      CIVL: The Concurrency Intermediate Verification Language
                               v1.1

------------------------------ Overview -------------------------------

CIVL is a framework encompassing... 

 * a programming language, CIVL-C, which adds to C a number of
   concurrency primitives, as well as the ability to define
   functions in any scope.  Together, these features make for
   a very expressive concurrent language that can faithfully
   represent programs using various APIs and parallel languages,
   such as MPI, OpenMP, Pthread, CUDA, and Chapel. CIVL-C also 
   provides a number of primitives supporting verification.
 * a model checker which uses symbolic execution to verify a
   number of safety properties of CIVL-C programs.   The model
   checker can also be used to verify that two CIVL-C programs
   are functionally equivalent.
 * a number of translators from various commonly-used languages
   and APIs to CIVL-C. (This part is still a work in progress.)

CIVL is developed by the Verified Software Laboratory at the
University of Delaware Department of Computer Science.
For more information, visit http://vsl.cis.udel.edu/civl

Developers:

Matthew B. Dwyer
John Edenhofner
Ziqing Luo
Andre Marianiello
Michael Rogers
Stephen F. Siegel
Manchun Zheng
Timothy K. Zirkel

------------------------------- License -------------------------------

CIVL is open source software distributed under the GNU
General Public License.  However, the libraries used by CIVL
(and incorporated into the complete distribution) use various
licenses.  See directory licenses for the license of each component.

-------------------------- Updates from v1.0 -------------------------

New features:
- new option -analyze_abs for analyzing the invocations of the 
  absolute value function abs of stdlib.h
- new option -showUnreached for displaying code that are never 
  executed/reached during model checking
(See examples in examples/analysis for more details.)

Bugs fixed: 
- bad format in the pretty printing of states
- incorrect modeling of static variables
- incorrect evaluation of some quantifier expressions
- exception thrown for $bundle_pack/unpack

   
------------------------- Binary Installation -------------------------

For most users, this will be the easiest way to install and
use CIVL.  Developers should instead follow the instructions for
"Source Installation" below.

1. Install at least one of the theorem provers below.
The more provers you install, the more precise CIVL analysis will
be.  Note that CIVL only requires the binary executable
version of each prover; you can ignore the libraries, various
API bindings, etc.   You just need to ensure that
each binary executable is in your PATH when you run
"civl config".   The currently supported provers are:
  
   - CVC3, http://www.cs.nyu.edu/acsys/cvc3/download.html
     download the latest, optimized build with static library
     and executable for your OS.  Place the executable file
     "cvc3" in your PATH.  You can discard everything else.
     Alternatively, on some linux systems, CVC3 can be installed
     using the package manager via "sudo apt-get install cvc3".
     This will place cvc3 in /usr/bin.
     
   - CVC4,  http://cvc4.cs.nyu.edu/downloads/
   
   - Z3, http://z3.codeplex.com/SourceControl/latest

2. Install a Java 7 SDK if you have not already.  Go to

  http://www.oracle.com/technetwork/java/javase/downloads/

for the latest from Oracle.  On linux, you can instead use
the package manager:

  sudo apt-get install openjdk-7-jdk

3. Download the CIVL distribution from http://vsl.cis.udel.edu/civl.

4. Unzip and untar the CIVL distribution file if this
does not happen automatically.  This should result in a
folder named CIVL-TAG, where TAG is some version ID string.
This folder contains the following:

 - README   : this file
 - bin      : containing one executable sh script called "civl"
 - lib      : containing civl-TAG.jar
 - doc      : containing the manual and the tutorial of CIVL
 - emacs    : CIVL-C emacs mode and its installation instructions
 - licenses : licenses for CIVL and included libraries
 - examples : some example CIVL programs

5.  You can move the CIVL folder wherever you want.
The JAR file in the lib directory is all you need to run CIVL.
You may also move this jar file wherever you want.   You 
run CIVL by typing a command that begins
"java -jar /path/to/civl-TAG.jar ...".  For convenience
you may instead use the shell script "civl" in bin,
which allows you to replace "java -jar /path/to/civl-TAG.jar"
with just "civl" on the command line.   Simply edit the civl script
to reflect the path to civl-TAG.jar and place the script 
somewhere in your PATH.   Alternatively, you can just define
an alias in your .profile, .bash_profile, or equivalent, such as

alias civl='java -jar /path/to/civl-TAG.jar'

In the following, we will assume that you have defined
a command "civl" in one these ways.

6. Type "civl config".  This should report that it found
the theorem provers you installed (and are in your PATH).
It should create a file called ".sarl" in your home directory
which you can also edit by hand.


------------------------- Source Installation -------------------------

We recommend using the Eclipse IDE for Java/EE developers.

0. Install theorem provers following the directions above.
Install Eclipse IDE for Java/EE developers if you have not already
done so.

1. Install an SVN plugin in Eclipse (such as Subversive) if you have
   not already.

2. Install prerequisite projects ABC, SARL and GMC. 
   Make sure that the three projects are put in the workspace
   directory where CIVL will be created.  Specifically:

    a. Install the symbolic algebra and reasoning library SARL.
	   In Eclipse, select New Project...from SVN, use the archive 
	   svn://vsl.cis.udel.edu/sarl. After entering that, open it 
	   up and select the "trunk". After checking out trunk, name 
	   the project "SARL". Then follow the instructions in the INSTALL 
	   file for Eclipse installation. Build the sarl.jar from within 
	   Eclipse by right-clicking (or ctrl-clicking) on the build.xml 
	   file and selecting Run As->Ant Build.
	   
    b. Install the C front-end ABC. In Eclipse, 
	   select New Project...from SVN, use the archive 
	   svn://vsl.cis.udel.edu/abc. After entering that, open it 
	   up and select the "trunk". After checking out trunk, name 
	   the project "ABC". Then follow the instructions in the INSTALL
	   file for Eclipse installation. Build the abc.jar from within
	   Eclipse by right-clicking (or ctrl-clicking on OS X) on the
	   build.xml file and selecting Run As->Ant Build.
	
    c. Install the generic model checking utilities package GMC.
	   In Eclipse, select New Project...from SVN, use the archive 
	   svn://vsl.cis.udel.edu/gmc. After entering that, open it 
	   up and select the "trunk". After checking out trunk, name 
	   the project "GMC". Build the gmc.jar from within Eclipse
	   by right-clicking (or ctrl-clicking) on the build.xml file and
	   selecting Run As->Ant Build.

3. From within Eclipse, select New Project...from SVN. The archive is
   svn://vsl.cis.udel.edu/civl.  After entering that, open it up and
   select the "trunk". (It is simplest to just check out the trunk for
   the Eclipse project.)

4. Check out the trunk, and create the project using the New Java
   Project Wizard as usual, naming it "CIVL". The .project, .classpath,
   and other Eclipse meta-data are already in the SVN archive,
   saving you a bunch of work.

5. If you already have the VSL dependencies library, you may
   skip this step. Otherwise, download the tgz archive of VSL
   dependencies from http://vsl.cis.udel.edu/lib/tools/vsl_depend
   Unzip the .tgz file and you will have the folder vsl.
   Move vsl to /opt.
   Note: you probably will need to use sudo for this.
   Also, if you don't already have a directory called /opt, 
   you will have to create it with "mkdir /opt".  Also, if you 
   don't want to use /opt for some reason, you can use any 
   directory you want; just modify the instructions below
   accordingly.

   Suppose that you put the .tgz file (or .tar file if your browser
   unzipped it automatically to a .tar file) in the directory DOWNLOAD.
   You can use the following commands:

   		$ cd DOWNLOAD
   		$ tar xzf YourTgzOrTarFile vsl
   		$ sudo mv vsl /opt

   (Leave out the "x" in the tar command if the file was already
   unzipped.) Now you can type "ls /opt/vsl", and the output
   should be

   		README.txt    lib        licenses    src

6. If default_build.properties matches the configuration of your system,
   then you can skip this step. Otherwise, you may need to create a file 
   build.properties in the directory containing build.xml.
   Copy and paste the content from any file under properties, edit each 
   entry with the path configured in your system. The newly created file
   build.properties will automatically be used by ant to to build the
   .jar file.

7. Navigate to Preferences -> Java -> Build Path -> ClassPath 
   Variables, and then select New to create a classpath variable VSL, 
   and specify its value to be /opt/vsl.

8. Do a clean build.  Everything should compile.  Generate the civl.jar
   by right-clicking (or ctrl-click on OS X) the build.xml file and
   Run As->Ant Build. 
   
9. Somewhere on your system, create a plain text file containing
   exactly the following two lines:
   
#!/bin/sh
java -jar /Path/To/Your/workspace/CIVL/civl.jar $@
 
   where "/Path/To/Your/workspace" is replaced with the path
   to your Eclipse workspace directory.  Name this file "civl",
   put it in your PATH, and make it executable (chmod ugo+x civl).
   Alternatively, you can define an alias in your .profile,
   .bash_profile, .bashrc, or equivalent:

alias civl='java -jar /Path/To/Your/workspace/CIVL/civl.jar'

10. From a terminal window, execute "civl config".  This should
    find the theorem provers in your PATH and create a file
    .sarl in your home directory.

11. In Eclipse, navigate to "Run->Run Configurations... Create a new
   JUnit configuration."
   Name it "CIVL Regression Tests". Select "Run all tests in the
   selected project..." and navigate to the folder "test/regress"
   in the CIVL project. The Test runner should be JUnit 4. Under the
   Arguments tab, type "-ea" (without the quotes) in the VM arguments
   area (to enable assertion checking).

12. An example of how to set up a single test from within Eclipse:
   create a new Run Configuration via the Run->Run
   Configurations... menu.  Create a new "Java Application"
   configuration.  Call it "CIVL barrier2".  The Project is CIVL.  The
   main class is edu.udel.cis.vsl.civl.CIVL.  Under the Arguments tab,
   set the Program arguments to 
   
       verify examples/concurrency/barrier2.cvl
   
   Modify the VM arguments as in the step above.  You should now be
   able to run the test by clicking "Run".
   

CIVL-C Syntax for Emacs
=======================
Version 0.8

Description
-----------

This small file adds syntax support for CIVL-C in Emacs.

CIVL-C is available for download from http://vsl.cis.udel.edu/civl/

This version conforms to CIVL-C v0.8

Prereqs
-------

1. Emacs >= 20
2. An interest in CIVL-C

Author
------

Name: William Killian

Contact: william.killian@gmail.com

## Installation

* Copy civl-syntax.el to ~/.emacs.d/lisp or another favorite location

* Include that path in your load path in .emacs

(add-to-list 'load-path "~/.emacs.d/lisp")

* Add the following lines to your ~/.emacs file

(require 'civl-syntax)
(civl-syntax)

* Enjoy!

The examples in this folder are for the purpose of testing 
for language features whose implementation is still in progress.
So it would be under expectation if there is exception when running
the examples in the folder.

This folder contains Fortran examples including:
  All examples in badExamples verified by CIVL will report a kind of violation.
  
  All examples in provesaExamples are provided by PROVESA organization, which
  is used to validate the correctness of the processing of Fortran program in 
  CIVL.

==============================================================================
                   __   __ ___________                 _                        
                   \ \ / //  ___| ___ \               | |                       
                    \ V / \ `--.| |_/ / ___ _ __   ___| |__                     
                    /   \  `--. \ ___ \/ _ \ '_ \ / __| '_ \                    
                   / /^\ \/\__/ / |_/ /  __/ | | | (__| | | |                   
                   \/   \/\____/\____/ \___|_| |_|\___|_| |_|                   

                                   Version 13

==============================================================================
Contact Information
==============================================================================

Organization:     Center for Exascale Simulation of Advanced Reactors (CESAR)
                  Argonne National Laboratory

Development Lead: John Tramm   <jtramm@anl.gov>
                  Ron Rahaman  <rahaman@anl.gov>
                  Amanda Lund  <alund@anl.gov>

==============================================================================
What is XSBench?
==============================================================================

XSBench is a mini-app representing a key computational kernel of the
Monte Carlo neutronics application OpenMC.

A full explanation of the theory and purpose of XSBench is provided in
docs/XSBench_Theory.pdf.

==============================================================================
Quick Start Guide
==============================================================================

Download----------------------------------------------------------------------

	For the most up-to-date version of XSBench, we recommend that you
	download from our git repository. This can be accomplished via
	cloning the repository from the command line, or by downloading a zip
	from our github page. Alternatively, you can download a tar file from
	the CESAR website directly.

	Git Repository Clone:
		
		Use the following command to clone XSBench to your machine:

		>$ git clone https://github.com/jtramm/XSBench.git

		Once cloned, you can update the code to the newest version
		using the following command (when in the XSBench directory):

		>$ git pull
	
	Git Zip Download:

		Simply use the "zip download" option on our webpage at:

		https://github.com/jtramm/XSBench
	
	CESAR Tar Download:

		A tar of the XSBench source code is available
		on the CESAR website at the following URL:
		
		https://cesar.mcs.anl.gov/content/software/neutronics

		Once downloaded, you can decompress XSBench using the following
		command on a linux or Mac OSX system:

		>$ tar -xvf XSBench-11.tar

		This will decompress the tar file into a directory called
		XSBench-11.

		To begin use of the XSBench code, you will have to navigate to
		the src directory:

		>$ cd XSBench-11/src

Compilation-------------------------------------------------------------------

	To compile XSBench with default settings, use the following
	command:

	>$ make

Running XSBench---------------------------------------------------------------

	To run XSBench with default settings, use the following command:

	>$ ./XSBench

	For non-default settings, XSBench supports the following command line
	options:	

	Usage: ./XSBench <options>
	Options include:
	  -t <threads>     Number of OpenMP threads to run
	  -s <size>        Size of H-M Benchmark to run (small, large, XL, XXL)
	  -g <gridpoints>  Number of gridpoints per nuclide
	  -l <lookups>     Number of Cross-section (XS) lookups
	Default (no arguments given) is equivalent to: -s large -l 15000000

	-t <threads>

		Sets the number of OpenMP threads to run. By default, XSBench
		will run with 1 thread per hardware core. If the architecture
		supports hyperthreading, multiple threads will be run per
		core.

		If running in MPI mode, this will be the number of threads
		per MPI rank.

	-s <size>
		
		Sets the size of the Hoogenboom-Martin reactor model. There
		are four options: 'small', 'large', 'XL', and 'XXL'. By default,
		the 'large' option is selected. 

		The H-M size corresponds to the number of nuclides present
		in the fuel region.  The small version has 34 fuel nuclides,
		whereas the large version has 321 fuel nuclides. This
		significantly slows down the runtime of the program as the
		data structures are much larger, and more lookups are required
		whenever a lookup occurs in a fuel material.  Note that the
		program defaults to "Large" if no specification is made.

		The additional size options, "XL" and "XXL", do not directly correspond
		to any particular physical model. They are similar to the H-M
		"large" option, except the number of gridpoints per nuclide
		has been increased greatly. This creates an extremely
		large energy grid data structure (XL: 120GB, XXL: 252GB), which is
		unlikely to fit on a single node, but is useful for experimentation
		purposes on novel architectures.

	-g <gridpoints>

		Sets the number of gridpoints per nuclide. By default, this
		value is set to 11,303. This corresponds to the average number
		of actual gridpoints per nuclide in the H-M Large model as run
		by OpenMC with the actual ACE ENDF cross-section data. 

		Note that this option will override the number of default grid
		-points as set by the '-s' option.

	-l <lookups>
		
		Sets the number of cross-section (XS) lookups to perform. By
		default, this value is set to 15,000,000. Users may want to
		increase this value if they wish to extend the runtime of
		XSBench, perhaps to produce more reliable performance counter
		data - as extending the run will decrease the percentage of
		runtime spent on initialization.

==============================================================================
Debugging, Optimization & Profiling
==============================================================================

There are also a number of switches that can be set in the makefile.

Here is a sample of the control panel at the top of the makefile:

COMPILER  = gnu
OPTIMIZE  = yes
DEBUG     = no
PROFILE   = no
MPI       = no
PAPI      = no
VEC_INFO  = no
VERIFY    = no
PAUSE     = no
BENCHMARK = no
BINARY_DUMP = no
BINARY_READ = no

-> Optimization enables the -O3 optimization flag.

-> Debugging enables the -g flag.

-> Profiling enables the -pg flag.

-> MPI enables MPI support in the code.

-> The PAPI flag is explained below.

-> VEC_INFO enables some additional information regarding the success or
   failure of the compiler's use of vectorization techniques during
   compilation.

-> VERIFY enables a verification mode, the details of which are explained below.

-> Benchmark mode tests all possible thread configurations on the given
   computer. I.e., if your computer supports 16 threads, XSBench will
   automatically do 1 <= nthreads <= 16 lookup loops

-> Binary dump mode writes a binary file containing a randomized data set
   of cross sections. This can be used in tandem with the binary read mode
   to skip generation of cross section data every time the program is run.

-> Binary read mode reads the binary file created by the binary dump mode
   as a (usually) much faster substitution for randomly generating XS
   data on-the-fly. This mode is particularly useful if running on
   simulators where walltime minimization is extremely critical for
   logistical reasons.

==============================================================================
MPI Support
==============================================================================

While XSBench is primarily used to investigate "on node parallelism" issues,
some systems provide power & performance statistics batched in multi-node
configurations. To accommodate this, XSBench provides an MPI mode which
runs the code on all MPI ranks simultaneously. There is no decomposition
across ranks of any kind, and all ranks accomplish the same work. There is
only one point of MPI communication (a reduce) at the end, which aggregates
the timing statistics and averages them across MPI ranks before printing them
out.

MPI support can be enabled with the makefile flag "MPI". If you are not using
the mpicc wrapper on your system, you may need to alter the makefile to
make use of your desired compiler.


==============================================================================
Verification Support
==============================================================================

XSBench has the ability to verify that consistent and correct results are
achieved. This mode is enabled by altering the "VERIFY" setting to 'yes' in
the makefile, i.e.:

VERIFY = yes

Once enabled, the code will generate a hash of the results and display it
with the other data once the code has completed executing. This hash can
then be verified against hashes that other versions or configurations of
the code generate. For instance, running XSBench with 4 threads vs 8 threads
(on a machine that supports that configuration) should generate the
same hash number. Changing the model / run parameters should NOT generate
the same hash number (i.e., increasing the number of lookups, number
of gridpoints, etc, will result in different hashes). 

Verification mode uses a RNG with a static seed. The randomized lookup
parameters are generated within a critical region. This ensures that the
same set of lookups are performed regardless of the number of threads
used. Then, after each lookup is completed, the lookup parameters and
the cross section vector are hashed together. This local hash is then
atomically added to a global running hash.

Note that the verification mode runs much slower, due to the use of
atomics within the threading loop. 

Below are the expected checksums for default runs of each size (-s):

small : 74966788162
large : 74994938929 

==============================================================================
PAPI Performance Counters
==============================================================================

PAPI performance counters is a performance counting library that can
offer information regarding the frequency of specific events (such as
memory loads, cache misses, branch prediction failures, etc) that occur
when the code is executed. XSBench supports use of these performance
counters, although it is left to the user to select the particular
performance counters and locations to instrument.

By default, PAPI is disabled.

To enable PAPI, set in the makefile:

PAPI = yes

Note that you may need to change the relevant library paths for papi to
work (as these are dependent on your machine).  The library path can be
specified in the makefile, and the header path is specified in the
XSBench_header.h file.

To select the performance counters you are interested in, open
the file papi.c and alter the events[] array to the events
you would like to count. 

==============================================================================
Binary File Support
==============================================================================

The flags:

BINARY_DUMP = no
BINARY_READ = no

Can be set to yes in order to write or read a binary file containing
a randomized XS data set (both nuclide grids and unionized grids). This
feature may be extremely useful for users running on simulators where
walltime minimization is critical for logistical purposes, or for users
who are doing many sequential runs.

Note that identical input parameters (problem size, etc) must be used
when reading and writing a binary file. No runtime checks are made
to validate that the file correctly corresponds to the selected input
parameters.

==============================================================================
Running on ANL BlueGene/Q (Vesta & Mira)
==============================================================================

Compilation is done using the included makefile, as follows:

>$ make MACHINE=bluegene

Note that the INFO macro in the XSbench_header.h file should be set to
0 when running on BG/Q to remove the run status portions of the output,
which cuts down on unnecessary file I/O, i.e.:

#define INFO 0

Also, note that you may need to add the following line to your .soft
file in order to use the mpicc compiler wrapper:

+mpiwrapper-gcc

Then, be sure to use the "resoft" command to update your software, i.e.,:

>$ resoft

When running in c16 mode, the maximum number of gridpoints per nuclide
is 900 (when running in "Large" mode). More points will cause the 1GB
memory limit to be broken.

A basic test run on 1 node can be achieved (assuming you have an allocation)
using the makefile and the following command:

>$ make bgqrun

Further information on queuing can be found at:

https://www.alcf.anl.gov/resource-guides/vesta-queuing

==============================================================================
Citing XSBench
==============================================================================

Papers citing the XSBench program in general should refer to:

J. R. Tramm, A. R. Siegel, T. Islam, and M. Schulz, “XSBench - The
Development and Verification of a Performance Abstraction for Monte
Carlo Reactor Analysis,” presented at PHYSOR 2014 - The Role
of Reactor Physics toward a Sustainable Future, Kyoto.

A PDF of this paper can be accessed directly at this link:

http://www.mcs.anl.gov/papers/P5064-0114.pdf

Bibtex Entry:

@inproceedings{Tramm:wy,
author = {Tramm, John R and Siegel, Andrew R and Islam, Tanzima and Schulz, Martin},
title = {{XSBench - The Development and Verification of a Performance Abstraction for Monte Carlo Reactor Analysis}},
booktitle = {PHYSOR 2014 - The Role of Reactor Physics toward a Sustainable Future},
address = {Kyoto}
}

==============================================================================

These are some MPI programs.  Our goal is to get civl to verify these 
exactly as they are, translating them automatically to CIVL-C.  

routines directory contains simple mpi examples which are mainly used
to test our implementation of mpi routines

dev directory contains mpi examples that are under development

seq directory contains sequential versions of the corresponding
mpi examples.

Here is some notes for comparing two diffusion1d programs(one in parallel and one in sequential) from FEVS.

Bugs of original MPI-C program( diffusion1d_par.c ):

1. Never try to free "u", which stores the final result, when quit by calling quit().

2. Never try to close the file, which provides input data, when quit by calling quit().

3. Malloc space to pointer "buf" inside the function "init()" twice without free the space 
   given by first time malloc.

4. Missing "fclose()" in function "init()".

5. Missing MPI_Finalize() when root process quits.

6. When root process call "quit()" before broadcasting parameters to
    other process,  other process will keep waiting for broadcasting forever.

Defects of CIVL:

1. CIVL cannot automatically handle system file closing work when the program quit before 
   reaching the end.

2. When comparing 2 programs, CIVL cannot recognize the file both of 2 programs are reading
   is same. Thus, CIVL will verify one path that one program quit because of failing on 
   reading file but the other doesn't fail on it.

3. "sprintf()" still not supported

4. CIVL pragma cannot support "if" statement.

Example 2:

This is a PETSc example that has been refactored.  This is motivated by some ideas we are exploring in automatic differentiation.  The verification task would be to confirm that all of the variants are equivalent.  They should all be real equivalent (in terms of the function computed -- some of the error checking and flop counting is not the same).  Some of them might even be Herbrand equivalent.

compare two variants:
        civl compare -impl ex2Driver.c ex2a.c -spec ex2Driver.c ex2d.c

compare all variants:
	make

This folder contains a sequential and a concurrent implementation of an
algorithm to find the maximum element in an array.

max.cvl: the driver
max_seq.cvl: the sequential implementation
max_par.cvl: the concurrent implementation (with data races)

CIVL finds that the two versions are not equivalent.

Two classic queue algorithm:

Two_lock Concurrent Queue: a "Two-Lock Concurrent Queue Algorithm", from Michael and Scott,
https://www.cs.rochester.edu/research/synchronization/pseudocode/queues.html.
Originally from "Simple, Fast, and Practical Non-Blocking and Blocking Concurrent Queue Algorithms", PODC96.

Non-Blocking Concurrent Queue Algorithm from Michael and Scott
https://www.cs.rochester.edu/research/synchronization/pseudocode/queues.html.
Originally from "Simple, Fast, and Practical Non-Blocking and Blocking Concurrent Queue Algorithms", PODC96.
The free in the algorithm (setFree method in Dequeue in this code) is meant to represent a function putting the node back on to a locally-maintained special-use free list and not the partner to malloc.
http://blog.shealevy.com/2015/04/23/use-after-free-bug-in-maged-m-michael-and-michael-l-scotts-non-blocking-concurrent-queue-algorithm/#up1

Result:

ID		result		#states		time (sec)	mem. (Mb)	note
										
0 division 	detected	2		0.87		268.44		
bad index	detected	3		0.74		268.44		
										
harmonic	equivalent	326		16.2		490.73		
resid		equivalent	39		1.97		268.44		
										
matmul		equivalent	1050		2.67		268.44		size < 5
matmul_bad	not equivalent	568		2.49		268.44		size < 5

matmul		equivalent	13018		4.26		268.44		size < 10
matmul_bad	not equivalent	4325		3.34		268.44		size < 10

matmul		equivalent	60942		20.78		268.44		size < 15
matmul_bad	not equivalent	14263		6.44		268.44		size < 15

matmul		equivalent	185271		242.01		322.96		size < 20
matmul_bad	not equivalent	24227		13.24		268.44		size < 20

matmul		equivalent	441865		2511.12		528.48		size < 25
matmul_bad	not equivalent	65013		62.59		268.44		size < 25

**SHTns is a high performance library for Spherical Harmonic Transform written in C,
aimed at numerical simulation (fluid flows, mhd, ...) in spherical geometries.**

Copyright (c) 2010-2014 Centre National de la Recherche Scientifique.
written by Nathanael Schaeffer (CNRS, ISTerre, Grenoble, France).
SHTns is distributed under the open source [CeCILL License](http://www.cecill.info/licences/Licence_CeCILL_V2.1-en.html)
(GPL compatible) located in the LICENSE file.

FEATURES:
---------

- **blazingly fast**.
- both **scalar and vector transforms**.
- backward and forward (synthesis and analysis) functions.
- flexible truncation (degree, order, azimuthal periodicity).
- spatial data can be stored in latitude-major or longitude-major arrays.
- various conventions (normalization and Condon-Shortley phase).
- can be used from **Fortran, c/c++, and Python** programs.
- a highly efficient Gauss algorithm working with Gauss nodes (based on
  Gauss-Legendre quadrature).
- support for SSE2, SSE3 and **AVX** vectorization, as well as Xeon Phi and
  Blue Gene/Q.
- **parallel transforms with OpenMP** (for Gauss grid only).
- an algorithm using DCT for regular nodes (generalized Fejer quadrature).
- synthesis (inverse transform) at any coordinate (not constrained to a grid).
- ability to choose the optimal spatial sizes for a given spectral truncation.
- **on-the-fly transforms** : saving memory and bandwidth, they are even faster
  on modern architectures.
- accurate up to spherical harmonic degree l=16383 (at least).
- rotation functions to rotate spherical harmonics (beta).
- special spectral operator functions that do not require a transform
  (multiply by cos(theta)...).
- scalar transforms for complex spatial fields.
- SHT at fixed m (without fft, aka Legendre transform - beta).


INSTALL:
--------

Briefly, the shell commands `./configure; make; make install` should
configure, build, and install this package. `./configure --help` will
list available options (among which `--enable-openmp` and `--enable-python`).
However, in order to get the best performance, it is highly recommended to
compile and install the FFTW library yourself, because many distributions
include a non-optimized FFTW library.

DOCUMENTATION:
--------------

- On-line doc is available: <http://users.isterre.fr/nschaeff/SHTns/>
- You can build it locally: Run `make docs` to generate documentation
  (requires doxygen). 
  Then browse the html documentation starting with `doc/html/index.html`
- A related research paper has been published:
  [Efficient Spherical Harmonic Transforms aimed at pseudo-spectral numerical simulations](http://dx.doi.org/10.1002/ggge.20071),
  also [available from arXiv](http://arxiv.org/abs/1202.6522).
- If you use SHTns for research work, please **cite this paper**:

        @article {shtns,
          author = {Schaeffer, Nathanael},
          title = {Efficient spherical harmonic transforms aimed at
          pseudospectral numerical simulations},
          journal = {Geochemistry, Geophysics, Geosystems},
          doi = {10.1002/ggge.20071},
          volume = {14}, number = {3}, pages = {751--758},
          year = {2013},
        }

CHANGE LOG:
-----------

* v2.6.3  (9 Mar 2015)
	- better default compilation flags for icc.
	- complex transforms added to Fortran API (thanks to Bertrand Putigny)

* v2.6.2  (30 Dec 2014)
	- fix regression: Schmidt normalized analysis failed since v2.6 in some cases.

* v2.6.1  (17 Dec 2014)
	- new functions in python interface to control console output.
	- fix: `spat_cplx_to_SH()` and `SH_to_spat_cplx()` were missing
	  a (-1)^m for m<0 [issue #16].
	- fix: segfault in `spat_to_SH_ml()` [issue #15].
	- fix a few compilation issues.

* v2.6  (24 Oct 2014)
	- support for IBM Blue Gene/Q (QPX) with [bgclang](http://trac.alcf.anl.gov/projects/llvm-bgq).
          Configure with `./configure --enable-many-core CC=bgclang`
	- new beta feature: SHT at fixed m (aka Legendre transform).
	- faster initialization with OpenMP.
	- fix: in python, a rare coredump now correctly raises an exception.
	- fix: a few compilation problems.

* v2.5  (13 Mar 2014)
	- new experimental support for Intel Xeon Phi (MIC) in native mode,
	  with contributions from Vincent Boulos (Bull). For good performance
	  icc 14 is required. Configure with `./configure --enable-mic CC=icc`
	- fftw3.h included for easier compilation.
	- fix: obey `OMP_NUM_THREADS` environement variable
	- fix: failure of fly analysis with some special (rare) sizes.
	- add missing `shtns_print_cfg()` to Fortran interface
	- new save/restore plan feature for bit-level reproducibility

* v2.4.1  (18 Sep 2013)
	- performance improvement: analysis with `SHT_PHI_CONTIGUOUS` is now
	  on par with synthesis (or better), even for large transforms.

* v2.4  (5 Aug 2013)
	- new scalar transforms for complex spatial fields: `SH_to_spat_cplx()`
	  and `spat_cplx_to_SH()`.
	- new `shtns_verbose()` function to control output during initialization.
	- better MKL support (including multi-thread). Warning: MKL's FFTW
	  interface is not thread safe, SHTns can't be called from multiple
	  threads if compiled with MKL.
	- fix compatibility with c++ std::complex.
	- new shallow water simulation example in examples/

* v2.3.1  (10 Apr 2013)
	- OpenMP library is now installed as `libshtns_omp.a`.
	- fix detection of OpenMP mutlithreaded FFTW.
	- new configure option `--enable-mkl` to use the FFT of the MKL
	  library instead of FFTW (lower performance expected).
	- `time_SHT` can be compiled on MacOSX and uses less memory.
	- new `SH_to_lat()` function.
	- a few other minor improvements and fixes.

* v2.3  (3 Oct 2012)
	- added `mi` member in `shtns_info` structure (ABI change).
	- added function to access the Gauss nodes.
	- added support for special operators in spectral space (multiplication
	  by cos(theta) and sin(theta).d/dtheta for instance).
	- shtns.h is now compatible with C++.
	- better python interface for rotations.
	- performance improvement for OpenMP code without `fftw3_omp`.
	- slightly faster `SH_to_point()` [5%] and `SHqst_to_point()` [20%].
	- bugfix: in some rare cases, OpenMP code freed unallocated memory.
	- bugfix: fixed python interface compilation with clang.

* v2.2.4  (25 Jun 2012)
	- the previous critical bugfix had not been applied to parallel OpenMP
	  transforms.

* v2.2.3  (24 Jun 2012)
	- critical bugfix: `SHtor_to_spat()` and `SHsph_to_spat()` gave wrong results
	  for mmax>0 with on-the-fly transoforms.
	- minor bugfix in Python interface.

* v2.2.2  (21 Jun 2012)
	- better Python interface: using `synth()` and `analys()` methods.
	- bugfix in build system: can now compile python extension without openmp.

* v2.2.1  (21 May 2012)
	- slightly faster parallel transforms.
	- better Python interface: decent error handling and keyword argument support.
	- changes to Python interface: grid defaults to `SHT_PHI_CONTIGUOUS`, 
	  `set_grid_auto()` removed.
	- bugfix: default compilation with FFTW 3.0 to avoid "bad Gauss points" error.
	- bugfix: correct alignement of gauss weights in 32 bit systems to avoid
	  segfaults.
	- new ./configure script for easier configuration and compilation.

* v2.2  (23 Apr 2012)
	- parallel transforms with OpenMP (for Gauss grid, significant benefit
	  for l>=127).

* v2.1  (8 Mar 2012)
	- support for huge spherical harmonic degree (tested up to l>43600).
	- speed improvements, especially for large transforms.
	- compilation with FFTW v3.0 or more is now possible through a 
	  configuration option (see `sht_config.h`)

* v2.0  (9 Feb 2012)
	- support for AVX instruction set (almost x2 speed-up on Sandy-Bridge
	  processors).
	- allow multiple transforms with different sizes, normalizations and
	  grids (C interface only).
	- changes to C interface : most functions now require a handle to identify
	  the transform. (Fortran interface unchanged)
	- transforms are accurate up to spherical harmonic degree l=2700 (at least).
	- lots of small improvements, speed-ups and a few bug fixes.
	- requires FFTW v3.3.
	- better Python interface using NumPy arrays (beta).
	- rotation functions to rotate spherical harmonics (beta).

* v1.5  (4 May 2011)
	- on-the-fly transforms which do not require huge matrices : save memory
	  and bandwidth, and can be faster on some architecture.
	- runtime selection of fastest algorithm, including on-the-fly transforms.
	- transforms are accurate up to spherical harmonic degree l=2045 (at least).
	- fix a bug that lead to wrong results for `SHtor_to_spat` and `SHsph_to_spat`.
	- a bunch of minor improvements, optimizations and fixes.

* v1.0  (9 June 2010)
	- initial release for C/C++ and Fortran under CeCILL licence (GPL compatible).
	- scalar and vector, forward and backward transforms.
	- support several normalization conventions.
	- transforms are accurate up to spherical harmonic degree l=1300 (at least).
	- flexible truncation and spatial sizes.
	- support spatial data stored in latitude-major or longitude-major arrays.
	- regular grid (with DCT acceleration) or Gauss grid (highly optimized).
	- SSE2 vectorization.
	- synthesis at any coordinate (not constrained to grid).
	- can choose the optimal spatial size for a given spectral truncation.
	- requires FFTW 3.0.

# DataRaceBench 1.3.2

DataRaceBench is a benchmark suite designed to systematically and
quantitatively evaluate the effectiveness of data race detection
tools. It includes a set of microbenchmarks with and without data
races. Parallelism is represented by OpenMP directives. OpenMP is a
popular parallel programming model for multi-threaded applications.

Note that some microbenchmarks use OpenMP 4.5 and 5.0 features. 
You may need a recent OpenMP compiler to compile them. 

DataRaceBench also comes with an evaluation script
(check-data-races.sh). The script can be used to evaluate the tools
Helgrind, Archer, Thread Sanitizer, and Intel Inspector. In addition a
parameterized test harness (scripts/test-harness.sh) is available
which allows to provide a number of different parameters for the
evaluation. The test harness is used by the evaluation script with
some pre-defined values.

## Quick Start

```
./check-data-races.sh

Usage: ./check-data-races.sh [--run] [--help] language

--help      : this option
--small     : compile and test all benchmarks using small parameters with Helgrind, ThreadSanitizer, Archer, Intel inspector.
--run       : compile and run all benchmarks with gcc (no evaluation)
--run-intel : compile and run all benchmarks with Intel compilers (no evaluation)
--helgrind  : compile and test all benchmarks with Helgrind
--tsan-clang: compile and test all benchmarks with clang ThreadSanitizer
--tsan-gcc  : compile and test all benchmarks with gcc ThreadSanitizer
--archer    : compile and test all benchmarks with Archer
--coderrect : compile and test all benchmarks with Coderrect Scanner
--inspector : compile and test all benchmarks with Intel Inspector
--romp      : compile and test all benchmarks with Romp
--customize : compile and test customized test list and tools
```

More information: [User Guide](https://github.com/LLNL/dataracebench/blob/master/user_guide.md)

## Latest Tool Evaluation Results
[Data race detection tool dashboard](https://github.com/LLNL/dataracebench/wiki/Tool-Evaluation-Dashboard)

## List of Benchmarks

[Benchmark labels and lists - C/C++](https://github.com/LLNL/dataracebench/blob/master/benchmarkList.md)

[Benchmark labels and lists - Fortran](https://github.com/LLNL/dataracebench/blob/master/benchmarkListFortran.md)

## Authors

DataRaceBench was created by Chunhua Liao, Pei-Hung Lin, Gaurav Verma, Yaying Shi, Joshua Asplund, Markus Schordan, and Ian Karlin.

## Release

DataRaceBench is released under a BSD license. For more details see
the file LICENSE.txt. The microbenchmarks marked 'Polyhedral' in above
table were generated as optimization variants of benchmarks from the
PolyOpt benchmark suite. For those benchmarks see the license file
LICENSE.OSU.txt.

`LLNL-CODE-732144`

## How to Cite DataRaceBench in a Publication

If you are referring to DataRaceBench in a publication, please cite the following paper:

* Chunhua Liao, Pei-Hung Lin, Joshua Asplund, Markus Schordan, Ian Karlin.
[DataRaceBench: A Benchmark Suite for Systematic Evaluation of Data Race Detection Tools (best paper finalist)](https://dl.acm.org/citation.cfm?doid=3126908.3126958).
Proceedings of the International Conference for High Performance Computing, Networking, Storage and Analysis, SC 2017, pp. 11:1-11:14, ISBN 978-1-4503-5114-0, Denver, CO, USA, November 12-17, 2017. [pdf](https://github.com/LLNL/dataracebench/blob/master/docs/DataRaceBench-SC17.pdf)

If you use DataRaceBench v.1.3.0 or later, please additionally cite the following paper:
* Gaurav Verma, Yaying Shi, Chunhua Liao, Barbara Chapman, and Yonghong Yan, Enhancing DataRaceBench for Evaluating DataRace Detection Tools, International Workshop on Software Correctness for HPC Applications (Correctness) SC20, 2020

Other papers
* Pei-Hung Lin, Chunhua Liao, Markus Schordan, Ian Karlin. [Exploring Regression of Data Race Detection Tools Using DataRaceBench](https://ieeexplore.ieee.org/abstract/document/8951036). 2019 IEEE/ACM 3rd International Workshop on Software Correctness for HPC Applications (Correctness), Denver, CO, USA, 2019, pp. 11-18. [pdf](https://github.com/LLNL/dataracebench/blob/master/docs/ExploringRegressionOfDataRaceDetectionTools-SC19.pdf), [Presentation](https://github.com/LLNL/dataracebench/blob/master/docs/2019-11-18-RegressionOfDataRaceTools-SC19.pdf)
* Chunhua Liao, Pei-Hung Lin, Markus Schordan and Ian Karlin, [A Semantics-Driven Approach to Improving DataRaceBench's OpenMP Standard Coverage](https://www.springerprofessional.de/en/a-semantics-driven-approach-to-improving-dataracebench-s-openmp-/16134302), IWOMP 2018: 14th International Workshop on OpenMP, Barcelona, Spain, September 26-28, 2018, [pdf](https://github.com/LLNL/dataracebench/blob/master/docs/Semantics-DrivenImprovingCoverage-IWOMP2018.pdf)
* Pei-Hung Lin, Chunhua Liao, Markus Schordan, Ian Karlin. [Runtime and Memory Evaluation of Data Race Detection Tools](https://link.springer.com/chapter/10.1007/978-3-030-03421-4_13). ISoLA (2) 2018: 179-196. [pdf](https://github.com/LLNL/dataracebench/blob/master/docs/2018-Runtime-Memory-Evaluation-DataRaceBench.pdf)

      program treeverseTest
      IMPLICIT NONE
      INTEGER nstp, nsnp, action,step
      LOGICAL TRV_NEXT_ACTION
      INTEGER nbadv, nbturn, nbpush, nblook, nbpop

      nbadv  = 0
      nbturn = 0
      nbpush = 0
      nblook = 0
      nbpop  = 0
      PRINT*,'Nb of time steps: '
      READ *,nstp
      PRINT*,'Nb of  snapshots: '
      READ *,nsnp
      PRINT*,'REVERSING ',nstp,' STEPS WITH ',nsnp,' SNAPSHOTS:'
      call TRV_INIT(nstp, nsnp, 1)
      DO WHILE (TRV_NEXT_ACTION(action,step))
         IF (action.eq.1) THEN
            WRITE(*,910) '[',action,'] PUSH SNAPSHOT    ',step
            nbpush = nbpush+1
         ELSE IF (action.eq.2) THEN
            WRITE(*,910) '[',action,'] LOOK SNAPSHOT    ',step
            nblook = nblook+1
         ELSE IF (action.eq.3) THEN
            WRITE(*,910) '[',action,'] POP SNAPSHOT     ',step
            nbpop = nbpop+1
         ELSE IF (action.eq.4) THEN
            WRITE(*,910) '[',action,'] ADVANCE ONE STEP ',step
            nbadv = nbadv+1
         ELSE IF (action.eq.5) THEN
            WRITE(*,910) '[',action,'] FIRST TURN       ',step
            nbturn = nbturn+1
         ELSE IF (action.eq.6) THEN
            WRITE(*,910) '[',action,'] TURN             ',step
            nbturn = nbturn+1
         ELSE
            WRITE(*,910) '[',action,'] ??               ',step
         ENDIF

c         IF (step.eq.8.and.action.eq.4) THEN
c            WRITE(*,*) '  =============> step 8: TRV_RESIZE() !!!'
c            CALL TRV_RESIZE()
c         ENDIF

      ENDDO
      WRITE(*,920) 'push:',nbpush,' look:',nblook,' pop:',nbpop,
     +     ' advance:',nbadv,' turn:',nbturn
 910  format(a1,i1,a19,i3)
 920  format(a5,i6,a6,i6,a5,i6,a9,i6,a6,i5)
      END

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Two-dimensional array computation:
!Only one loop is associated with omp taskloop.
!The inner loop's loop iteration variable will be shared if it is shared in the enclosing context.
!Data race pairs (we allow multiple ones to preserve the pattern):
!  Write_set = {j@36:20, j@36:30 (implicit step +1)}
!  Read_set = {j@36:22, j@36:24, j@37:35}
!  Any pair from Write_set vs. Write_set  and Write_set vs. Read_set is a data race pair.

!need to run with large thread number and large num of iterations.

module DRB095
    implicit none
    integer, dimension(:,:), allocatable :: a
end module

program DRB095_doall2_taskloop_orig_yes
    use omp_lib
    use DRB095
    implicit none

    integer :: len, i, j
    len = 100
    allocate (a(len,len))

    !$omp parallel
        !$omp single
            !$omp taskloop
            do i = 1, len
                do j = 1, len
                    a(i,j) = a(i,j)+1
                end do
            end do
            !$omp end taskloop
        !$omp end single
    !$omp end parallel

    print 100, a(50,50)
    100 format ('a(50,50) =',i3)

end program

      SUBROUTINE PLAN3 (IGEOM)
C-----------------------------------------------------------------------
C
C     Compute pressure and velocity using consistent approximation spaces.     
C     Operator splitting technique.
C
C-----------------------------------------------------------------------
      include 'SIZE'
      include 'INPUT'
      include 'EIGEN'
      include 'SOLN'
      include 'TSTEP'
C
      COMMON /SCRNS/  RESV1 (LX1,LY1,LZ1,LELV)
     $ ,              RESV2 (LX1,LY1,LZ1,LELV)
     $ ,              RESV3 (LX1,LY1,LZ1,LELV)
     $ ,              DV1   (LX1,LY1,LZ1,LELV)
     $ ,              DV2   (LX1,LY1,LZ1,LELV)
     $ ,              DV3   (LX1,LY1,LZ1,LELV)
      COMMON /SCRVH/  H1    (LX1,LY1,LZ1,LELV)
     $ ,              H2    (LX1,LY1,LZ1,LELV)
C
      IF (IGEOM.EQ.1) THEN
C
C        Old geometry
C
         CALL MAKEF
C
      ELSE
C
C        New geometry, new b.c.
C
         intype = -1
         call sethlm  (h1,h2,intype)
         call cresvif (resv1,resv2,resv3,h1,h2)

         call ophinv  (dv1,dv2,dv3,resv1,resv2,resv3,h1,h2,tolhv,nmxv)
         call opadd2  (vx,vy,vz,dv1,dv2,dv3)
c
         call incomprn(vx,vy,vz,pr)
C
      ENDIF
C
      RETURN
      END
C
      SUBROUTINE LAGPRES 
C--------------------------------------------------------------------
C
C     Keep old pressure values
C
C--------------------------------------------------------------------
      include 'SIZE'
      include 'SOLN'
      include 'TSTEP'

      common /cgeom/ igeom

      IF (NBDINP.EQ.3.and.igeom.le.2) THEN
         NTOT2 = lx2*ly2*lz2*NELV
         CALL COPY (PRLAG,PR,NTOT2)
      ENDIF
      RETURN
      END
C
      subroutine cresvif (resv1,resv2,resv3,h1,h2)
C---------------------------------------------------------------------
C
C     Compute startresidual/right-hand-side in the velocity solver
C
C---------------------------------------------------------------------
      include 'SIZE'
      include 'TOTAL'
      REAL           RESV1 (LX1,LY1,LZ1,1)
      REAL           RESV2 (LX1,LY1,LZ1,1)
      REAL           RESV3 (LX1,LY1,LZ1,1)
      REAL           H1    (LX1,LY1,LZ1,1)
      REAL           H2    (LX1,LY1,LZ1,1)
      COMMON /SCRUZ/ W1    (LX1,LY1,LZ1,LELV)
     $ ,             W2    (LX1,LY1,LZ1,LELV)
     $ ,             W3    (LX1,LY1,LZ1,LELV)

      common /cgeom/ igeom

      NTOT1 = lx1*ly1*lz1*NELV
      NTOT2 = lx2*ly2*lz2*NELV
      if (igeom.eq.2) CALL LAGVEL 
      CALL BCDIRVC (VX,VY,VZ,v1mask,v2mask,v3mask)
      CALL BCNEUTR
C
      call extrapp (pr,prlag)
      call opgradt (resv1,resv2,resv3,pr)
      CALL OPADD2  (RESV1,RESV2,RESV3,BFX,BFY,BFZ)
      CALL OPHX    (W1,W2,W3,VX,VY,VZ,H1,H2)
      CALL OPSUB2  (RESV1,RESV2,RESV3,W1,W2,W3)
C
      RETURN
      END
c-----------------------------------------------------------------------

program modulespec
  implicit none
!$CVL $input 
  integer :: inval
!$CVL $output
  integer :: outval
  integer :: n
!$CVL $assume(0 .LE. inval .AND. inval .LE. 10);
  n = 2
  outval = mod(inval, n)
end program modulespec

C==============================================================================
C
C     LIBRARY ROUTINES FOR SPECTRAL METHODS
C
C     March 1989
C
C     For questions, comments or suggestions, please contact:
C
C     Einar Malvin Ronquist
C     Room 3-243
C     Department of Mechanical Engineering
C     Massachusetts Institute of Technology
C     77 Massachusetts Avenue
C     Cambridge, MA 0299
C     U.S.A.
C
C------------------------------------------------------------------------------
C
C     ABBRIVIATIONS:
C
C     M   - Set of mesh points
C     Z   - Set of collocation/quadrature points
C     W   - Set of quadrature weights
C     H   - Lagrangian interpolant
C     D   - Derivative operator
C     I   - Interpolation operator
C     GL  - Gauss Legendre
C     GLL - Gauss-Lobatto Legendre
C     GJ  - Gauss Jacobi
C     GLJ - Gauss-Lobatto Jacobi
C
C
C     MAIN ROUTINES:
C
C     Points and weights:
C
C     ZWGL      Compute Gauss Legendre points and weights
C     ZWGLL     Compute Gauss-Lobatto Legendre points and weights
C     ZWGJ      Compute Gauss Jacobi points and weights (general)
C     ZWGLJ     Compute Gauss-Lobatto Jacobi points and weights (general)
C
C     Lagrangian interpolants:
C
C     HGL       Compute Gauss Legendre Lagrangian interpolant
C     HGLL      Compute Gauss-Lobatto Legendre Lagrangian interpolant
C     HGJ       Compute Gauss Jacobi Lagrangian interpolant (general)
C     HGLJ      Compute Gauss-Lobatto Jacobi Lagrangian interpolant (general)
C
C     Derivative operators:
C
C     DGLL      Compute Gauss-Lobatto Legendre derivative matrix
C     DGLLGL    Compute derivative matrix for a staggered mesh (GLL->GL)
C     DGJ       Compute Gauss Jacobi derivative matrix (general)
C     DGLJ      Compute Gauss-Lobatto Jacobi derivative matrix (general)
C     DGLJGJ    Compute derivative matrix for a staggered mesh (GLJ->GJ) (general)
C
C     Interpolation operators:
C
C     IGLM      Compute interpolation operator GL  -> M
C     IGLLM     Compute interpolation operator GLL -> M
C     IGJM      Compute interpolation operator GJ  -> M  (general)
C     IGLJM     Compute interpolation operator GLJ -> M  (general)
C
C     Other:
C
C     PNLEG     Compute Legendre polynomial of degree N
C     PNDLEG    Compute derivative of Legendre polynomial of degree N
C
C     Comments:
C
C     Note that many of the above routines exist in both single and
C     double precision. If the name of the single precision routine is
C     SUB, the double precision version is called SUBD. In most cases
C     all the "low-level" arithmetic is done in double precision, even
C     for the single precsion versions.
C
C     Useful references:
C
C [1] Gabor Szego: Orthogonal Polynomials, American Mathematical Society,
C     Providence, Rhode Island, 1939.
C [2] Abramowitz & Stegun: Handbook of Mathematical Functions,
C     Dover, New York, 1972.
C [3] Canuto, Hussaini, Quarteroni & Zang: Spectral Methods in Fluid
C     Dynamics, Springer-Verlag, 1988.
C
C
C==============================================================================
C
C--------------------------------------------------------------------
      SUBROUTINE ZWGL (Z,W,NP)
C--------------------------------------------------------------------
C
C     Generate NP Gauss Legendre points (Z) and weights (W)
C     associated with Jacobi polynomial P(N)(alpha=0,beta=0).
C     The polynomial degree N=NP-1.
C     Z and W are in single precision, but all the arithmetic
C     operations are done in double precision.
C
C--------------------------------------------------------------------
      REAL Z(1),W(1)
      ALPHA = 0.
      BETA  = 0.
      CALL ZWGJ (Z,W,NP,ALPHA,BETA)
      RETURN
      END
C
      SUBROUTINE ZWGLL (Z,W,NP)
C--------------------------------------------------------------------
C
C     Generate NP Gauss-Lobatto Legendre points (Z) and weights (W)
C     associated with Jacobi polynomial P(N)(alpha=0,beta=0).
C     The polynomial degree N=NP-1.
C     Z and W are in single precision, but all the arithmetic
C     operations are done in double precision.
C
C--------------------------------------------------------------------
      REAL Z(1),W(1)
      ALPHA = 0.
      BETA  = 0.
      CALL ZWGLJ (Z,W,NP,ALPHA,BETA)
      RETURN
      END
C
      SUBROUTINE ZWGJ (Z,W,NP,ALPHA,BETA)
C--------------------------------------------------------------------
C
C     Generate NP GAUSS JACOBI points (Z) and weights (W)
C     associated with Jacobi polynomial P(N)(alpha>-1,beta>-1).
C     The polynomial degree N=NP-1.
C     Single precision version.
C
C--------------------------------------------------------------------
      PARAMETER (NMAX=84)
      PARAMETER (lzd = NMAX)
      REAL*8  ZD(lzd),WD(lzd),APHAD,BETAD
      REAL Z(1),W(1),ALPHA,BETA
C
      NPMAX = lzd
      IF (NP.GT.NPMAX) THEN
         WRITE (6,*) 'Too large polynomial degree in ZWGJ'
         WRITE (6,*) 'Maximum polynomial degree is',NMAX
         WRITE (6,*) 'Here NP=',NP
         call exitt
      ENDIF
      ALPHAD = ALPHA
      BETAD  = BETA
      CALL ZWGJD (ZD,WD,NP,ALPHAD,BETAD)
      DO 100 I=1,NP
         Z(I) = ZD(I)
         W(I) = WD(I)
 100  CONTINUE
      RETURN
      END
C
      SUBROUTINE ZWGJD (Z,W,NP,ALPHA,BETA)
C--------------------------------------------------------------------
C
C     Generate NP GAUSS JACOBI points (Z) and weights (W)
C     associated with Jacobi polynomial P(N)(alpha>-1,beta>-1).
C     The polynomial degree N=NP-1.
C     Double precision version.
C
C--------------------------------------------------------------------
      IMPLICIT REAL*8  (A-H,O-Z)
      REAL*8  Z(1),W(1),ALPHA,BETA
C
      N     = NP-1
      DN    = ((N))
      ONE   = 1.
      TWO   = 2.
      APB   = ALPHA+BETA
C
      IF (NP.LE.0) THEN
         WRITE (6,*) 'ZWGJD: Minimum number of Gauss points is 1',np
         call exitt
      ENDIF
      IF ((ALPHA.LE.-ONE).OR.(BETA.LE.-ONE)) THEN
         WRITE (6,*) 'ZWGJD: Alpha and Beta must be greater than -1'
         call exitt
      ENDIF
C
      IF (NP.EQ.1) THEN
         Z(1) = (BETA-ALPHA)/(APB+TWO)
         W(1) = GAMMAF(ALPHA+ONE)*GAMMAF(BETA+ONE)/GAMMAF(APB+TWO)
     $          * TWO**(APB+ONE)
         RETURN
      ENDIF
C
      CALL JACG (Z,NP,ALPHA,BETA)
C
      NP1   = N+1
      NP2   = N+2
      DNP1  = ((NP1))
      DNP2  = ((NP2))
      FAC1  = DNP1+ALPHA+BETA+ONE
      FAC2  = FAC1+DNP1
      FAC3  = FAC2+ONE
      FNORM = PNORMJ(NP1,ALPHA,BETA)
      RCOEF = (FNORM*FAC2*FAC3)/(TWO*FAC1*DNP2)
      DO 100 I=1,NP
         CALL JACOBF (P,PD,PM1,PDM1,PM2,PDM2,NP2,ALPHA,BETA,Z(I))
         W(I) = -RCOEF/(P*PDM1)
 100  CONTINUE
      RETURN
      END
C
      SUBROUTINE ZWGLJ (Z,W,NP,ALPHA,BETA)
C--------------------------------------------------------------------
C
C     Generate NP GAUSS LOBATTO JACOBI points (Z) and weights (W)
C     associated with Jacobi polynomial P(N)(alpha>-1,beta>-1).
C     The polynomial degree N=NP-1.
C     Single precision version.
C
C--------------------------------------------------------------------
      PARAMETER (NMAX=84)
      PARAMETER (lzd = NMAX)
      REAL*8  ZD(lzd),WD(lzd),ALPHAD,BETAD
      REAL Z(1),W(1),ALPHA,BETA
C
      NPMAX = lzd
      IF (NP.GT.NPMAX) THEN
         WRITE (6,*) 'Too large polynomial degree in ZWGLJ'
         WRITE (6,*) 'Maximum polynomial degree is',NMAX
         WRITE (6,*) 'Here NP=',NP
         call exitt
      ENDIF
      ALPHAD = ALPHA
      BETAD  = BETA
      CALL ZWGLJD (ZD,WD,NP,ALPHAD,BETAD)
      DO 100 I=1,NP
         Z(I) = ZD(I)
         W(I) = WD(I)
 100  CONTINUE
      RETURN
      END
C
      SUBROUTINE ZWGLJD (Z,W,NP,ALPHA,BETA)
C--------------------------------------------------------------------
C
C     Generate NP GAUSS LOBATTO JACOBI points (Z) and weights (W)
C     associated with Jacobi polynomial P(N)(alpha>-1,beta>-1).
C     The polynomial degree N=NP-1.
C     Double precision version.
C
C--------------------------------------------------------------------
      IMPLICIT REAL*8  (A-H,O-Z)
      REAL*8  Z(NP),W(NP),ALPHA,BETA
C
      N     = NP-1
      NM1   = N-1
      ONE   = 1.
      TWO   = 2.
C
      IF (NP.LE.1) THEN
       WRITE (6,*) 'ZWGLJD: Minimum number of Gauss-Lobatto points is 2'
       WRITE (6,*) 'ZWGLJD: alpha,beta:',alpha,beta,np
       call exitt
      ENDIF
      IF ((ALPHA.LE.-ONE).OR.(BETA.LE.-ONE)) THEN
         WRITE (6,*) 'ZWGLJD: Alpha and Beta must be greater than -1'
         call exitt
      ENDIF
C
      IF (NM1.GT.0) THEN
         ALPG  = ALPHA+ONE
         BETG  = BETA+ONE
         CALL ZWGJD (Z(2),W(2),NM1,ALPG,BETG)
      ENDIF
      Z(1)  = -ONE
      Z(NP) =  ONE
      DO 100  I=2,NP-1
         W(I) = W(I)/(ONE-Z(I)**2)
 100  CONTINUE
      CALL JACOBF (P,PD,PM1,PDM1,PM2,PDM2,N,ALPHA,BETA,Z(1))
      W(1)  = ENDW1 (N,ALPHA,BETA)/(TWO*PD)
      CALL JACOBF (P,PD,PM1,PDM1,PM2,PDM2,N,ALPHA,BETA,Z(NP))
      W(NP) = ENDW2 (N,ALPHA,BETA)/(TWO*PD)
C
      RETURN
      END
C
      REAL*8  FUNCTION ENDW1 (N,ALPHA,BETA)
      IMPLICIT REAL*8  (A-H,O-Z)
      REAL*8  ALPHA,BETA
      ZERO  = 0.
      ONE   = 1.
      TWO   = 2.
      THREE = 3.
      FOUR  = 4.
      APB   = ALPHA+BETA
      IF (N.EQ.0) THEN
         ENDW1 = ZERO
         RETURN
      ENDIF
      F1   = GAMMAF(ALPHA+TWO)*GAMMAF(BETA+ONE)/GAMMAF(APB+THREE)
      F1   = F1*(APB+TWO)*TWO**(APB+TWO)/TWO
      IF (N.EQ.1) THEN
         ENDW1 = F1
         RETURN
      ENDIF
      FINT1 = GAMMAF(ALPHA+TWO)*GAMMAF(BETA+ONE)/GAMMAF(APB+THREE)
      FINT1 = FINT1*TWO**(APB+TWO)
      FINT2 = GAMMAF(ALPHA+TWO)*GAMMAF(BETA+TWO)/GAMMAF(APB+FOUR)
      FINT2 = FINT2*TWO**(APB+THREE)
      F2    = (-TWO*(BETA+TWO)*FINT1 + (APB+FOUR)*FINT2)
     $        * (APB+THREE)/FOUR
      IF (N.EQ.2) THEN
         ENDW1 = F2
         RETURN
      ENDIF
      DO 100 I=3,N
         DI   = ((I-1))
         ABN  = ALPHA+BETA+DI
         ABNN = ABN+DI
         A1   = -(TWO*(DI+ALPHA)*(DI+BETA))/(ABN*ABNN*(ABNN+ONE))
         A2   =  (TWO*(ALPHA-BETA))/(ABNN*(ABNN+TWO))
         A3   =  (TWO*(ABN+ONE))/((ABNN+TWO)*(ABNN+ONE))
         F3   =  -(A2*F2+A1*F1)/A3
         F1   = F2
         F2   = F3
 100  CONTINUE
      ENDW1  = F3
      RETURN
      END
C
      REAL*8  FUNCTION ENDW2 (N,ALPHA,BETA)
      IMPLICIT REAL*8  (A-H,O-Z)
      REAL*8  ALPHA,BETA
      ZERO  = 0.
      ONE   = 1.
      TWO   = 2.
      THREE = 3.
      FOUR  = 4.
      APB   = ALPHA+BETA
      IF (N.EQ.0) THEN
         ENDW2 = ZERO
         RETURN
      ENDIF
      F1   = GAMMAF(ALPHA+ONE)*GAMMAF(BETA+TWO)/GAMMAF(APB+THREE)
      F1   = F1*(APB+TWO)*TWO**(APB+TWO)/TWO
      IF (N.EQ.1) THEN
         ENDW2 = F1
         RETURN
      ENDIF
      FINT1 = GAMMAF(ALPHA+ONE)*GAMMAF(BETA+TWO)/GAMMAF(APB+THREE)
      FINT1 = FINT1*TWO**(APB+TWO)
      FINT2 = GAMMAF(ALPHA+TWO)*GAMMAF(BETA+TWO)/GAMMAF(APB+FOUR)
      FINT2 = FINT2*TWO**(APB+THREE)
      F2    = (TWO*(ALPHA+TWO)*FINT1 - (APB+FOUR)*FINT2)
     $        * (APB+THREE)/FOUR
      IF (N.EQ.2) THEN
         ENDW2 = F2
         RETURN
      ENDIF
      DO 100 I=3,N
         DI   = ((I-1))
         ABN  = ALPHA+BETA+DI
         ABNN = ABN+DI
         A1   =  -(TWO*(DI+ALPHA)*(DI+BETA))/(ABN*ABNN*(ABNN+ONE))
         A2   =  (TWO*(ALPHA-BETA))/(ABNN*(ABNN+TWO))
         A3   =  (TWO*(ABN+ONE))/((ABNN+TWO)*(ABNN+ONE))
         F3   =  -(A2*F2+A1*F1)/A3
         F1   = F2
         F2   = F3
 100  CONTINUE
      ENDW2  = F3
      RETURN
      END
C
      REAL*8  FUNCTION GAMMAF (X)
      IMPLICIT REAL*8  (A-H,O-Z)
      REAL*8  X
      ZERO = 0.0
      HALF = 0.5
      ONE  = 1.0
      TWO  = 2.0
      FOUR = 4.0
      PI   = FOUR*ATAN(ONE)
      GAMMAF = ONE
      IF (X.EQ.-HALF) GAMMAF = -TWO*SQRT(PI)
      IF (X.EQ. HALF) GAMMAF =  SQRT(PI)
      IF (X.EQ. ONE ) GAMMAF =  ONE
      IF (X.EQ. TWO ) GAMMAF =  ONE
      IF (X.EQ. 1.5  ) GAMMAF =  SQRT(PI)/2.
      IF (X.EQ. 2.5) GAMMAF =  1.5*SQRT(PI)/2.
      IF (X.EQ. 3.5) GAMMAF =  0.5*(2.5*(1.5*SQRT(PI)))
      IF (X.EQ. 3. ) GAMMAF =  2.
      IF (X.EQ. 4. ) GAMMAF = 6.
      IF (X.EQ. 5. ) GAMMAF = 24.
      IF (X.EQ. 6. ) GAMMAF = 120.
      RETURN
      END
C
      REAL*8  FUNCTION PNORMJ (N,ALPHA,BETA)
      IMPLICIT REAL*8  (A-H,O-Z)
      REAL*8  ALPHA,BETA
      ONE   = 1.
      TWO   = 2.
      DN    = ((N))
      CONST = ALPHA+BETA+ONE
      IF (N.LE.1) THEN
         PROD   = GAMMAF(DN+ALPHA)*GAMMAF(DN+BETA)
         PROD   = PROD/(GAMMAF(DN)*GAMMAF(DN+ALPHA+BETA))
         PNORMJ = PROD * TWO**CONST/(TWO*DN+CONST)
         RETURN
      ENDIF
      PROD  = GAMMAF(ALPHA+ONE)*GAMMAF(BETA+ONE)
      PROD  = PROD/(TWO*(ONE+CONST)*GAMMAF(CONST+ONE))
      PROD  = PROD*(ONE+ALPHA)*(TWO+ALPHA)
      PROD  = PROD*(ONE+BETA)*(TWO+BETA)
      DO 100 I=3,N
         DINDX = ((I))
         FRAC  = (DINDX+ALPHA)*(DINDX+BETA)/(DINDX*(DINDX+ALPHA+BETA))
         PROD  = PROD*FRAC
 100  CONTINUE
      PNORMJ = PROD * TWO**CONST/(TWO*DN+CONST)
      RETURN
      END
C
      SUBROUTINE JACG (XJAC,NP,ALPHA,BETA)
C--------------------------------------------------------------------
C
C     Compute NP Gauss points XJAC, which are the zeros of the
C     Jacobi polynomial J(NP) with parameters ALPHA and BETA.
C     ALPHA and BETA determines the specific type of Gauss points.
C     Examples:
C     ALPHA = BETA =  0.0  ->  Legendre points
C     ALPHA = BETA = -0.5  ->  Chebyshev points
C
C--------------------------------------------------------------------
      IMPLICIT REAL*8  (A-H,O-Z)
      REAL*8  XJAC(1)
      DATA KSTOP /10/
      DATA EPS/1.0e-12/
      N   = NP-1
      one = 1.
      DTH = 4.*ATAN(one)/(2.*((N))+2.)
      DO 40 J=1,NP
         IF (J.EQ.1) THEN
            X = COS((2.*(((J))-1.)+1.)*DTH)
         ELSE
            X1 = COS((2.*(((J))-1.)+1.)*DTH)
            X2 = XLAST
            X  = (X1+X2)/2.
         ENDIF
         DO 30 K=1,KSTOP
            CALL JACOBF (P,PD,PM1,PDM1,PM2,PDM2,NP,ALPHA,BETA,X)
            RECSUM = 0.
            JM = J-1
            DO 29 I=1,JM
               RECSUM = RECSUM+1./(X-XJAC(NP-I+1))
 29         CONTINUE
            DELX = -P/(PD-RECSUM*P)
            X    = X+DELX
            IF (ABS(DELX) .LT. EPS) GOTO 31
 30      CONTINUE
 31      CONTINUE
         XJAC(NP-J+1) = X
         XLAST        = X
 40   CONTINUE
      DO 200 I=1,NP
         XMIN = 2.
         DO 100 J=I,NP
            IF (XJAC(J).LT.XMIN) THEN
               XMIN = XJAC(J)
               JMIN = J
            ENDIF
 100     CONTINUE
         IF (JMIN.NE.I) THEN
            SWAP = XJAC(I)
            XJAC(I) = XJAC(JMIN)
            XJAC(JMIN) = SWAP
         ENDIF
 200  CONTINUE
      RETURN
      END
C
      SUBROUTINE JACOBF (POLY,PDER,POLYM1,PDERM1,POLYM2,PDERM2,
     $                   N,ALP,BET,X)
C--------------------------------------------------------------------
C
C     Computes the Jacobi polynomial (POLY) and its derivative (PDER)
C     of degree N at X.
C
C--------------------------------------------------------------------
      IMPLICIT REAL*8  (A-H,O-Z)
      APB  = ALP+BET
      POLY = 1.
      PDER = 0.
      IF (N .EQ. 0) RETURN
      POLYL = POLY
      PDERL = PDER
      POLY  = (ALP-BET+(APB+2.)*X)/2.
      PDER  = (APB+2.)/2.
      IF (N .EQ. 1) RETURN
      DO 20 K=2,N
         DK = ((K))
         A1 = 2.*DK*(DK+APB)*(2.*DK+APB-2.)
         A2 = (2.*DK+APB-1.)*(ALP**2-BET**2)
         B3 = (2.*DK+APB-2.)
         A3 = B3*(B3+1.)*(B3+2.)
         A4 = 2.*(DK+ALP-1.)*(DK+BET-1.)*(2.*DK+APB)
         POLYN  = ((A2+A3*X)*POLY-A4*POLYL)/A1
         PDERN  = ((A2+A3*X)*PDER-A4*PDERL+A3*POLY)/A1
         PSAVE  = POLYL
         PDSAVE = PDERL
         POLYL  = POLY
         POLY   = POLYN
         PDERL  = PDER
         PDER   = PDERN
 20   CONTINUE
      POLYM1 = POLYL
      PDERM1 = PDERL
      POLYM2 = PSAVE
      PDERM2 = PDSAVE
      RETURN
      END
C
      REAL FUNCTION HGJ (II,Z,ZGJ,NP,ALPHA,BETA)
C---------------------------------------------------------------------
C
C     Compute the value of the Lagrangian interpolant HGJ through
C     the NP Gauss Jacobi points ZGJ at the point Z.
C     Single precision version.
C
C---------------------------------------------------------------------
      PARAMETER (NMAX=84)
      PARAMETER (lzd = NMAX)
      REAL*8  ZD,ZGJD(lzd),HGJD,ALPHAD,BETAD
      REAL Z,ZGJ(1),ALPHA,BETA
      NPMAX = lzd
      IF (NP.GT.NPMAX) THEN
         WRITE (6,*) 'Too large polynomial degree in HGJ'
         WRITE (6,*) 'Maximum polynomial degree is',NMAX
         WRITE (6,*) 'Here NP=',NP
         call exitt
      ENDIF
      ZD = Z
      DO 100 I=1,NP
         ZGJD(I) = ZGJ(I)
 100  CONTINUE
      ALPHAD = ALPHA
      BETAD  = BETA
      HGJ    = HGJD (II,ZD,ZGJD,NP,ALPHAD,BETAD)
      RETURN
      END
C
      REAL*8  FUNCTION HGJD (II,Z,ZGJ,NP,ALPHA,BETA)
C---------------------------------------------------------------------
C
C     Compute the value of the Lagrangian interpolant HGJD through
C     the NZ Gauss-Lobatto Jacobi points ZGJ at the point Z.
C     Double precision version.
C
C---------------------------------------------------------------------
      IMPLICIT REAL*8  (A-H,O-Z)
      REAL*8  Z,ZGJ(1),ALPHA,BETA
      EPS = 1.e-5
      ONE = 1.
      ZI  = ZGJ(II)
      DZ  = Z-ZI
      IF (ABS(DZ).LT.EPS) THEN
         HGJD = ONE
         RETURN
      ENDIF
      CALL JACOBF (PZI,PDZI,PM1,PDM1,PM2,PDM2,NP,ALPHA,BETA,ZI)
      CALL JACOBF (PZ,PDZ,PM1,PDM1,PM2,PDM2,NP,ALPHA,BETA,Z)
      HGJD  = PZ/(PDZI*(Z-ZI))
      RETURN
      END
C
      REAL FUNCTION HGLJ (II,Z,ZGLJ,NP,ALPHA,BETA)
C---------------------------------------------------------------------
C
C     Compute the value of the Lagrangian interpolant HGLJ through
C     the NZ Gauss-Lobatto Jacobi points ZGLJ at the point Z.
C     Single precision version.
C
C---------------------------------------------------------------------
      PARAMETER (NMAX=84)
      PARAMETER (lzd = NMAX)
      REAL*8  ZD,ZGLJD(lzd),HGLJD,ALPHAD,BETAD
      REAL Z,ZGLJ(1),ALPHA,BETA
      NPMAX = lzd
      IF (NP.GT.NPMAX) THEN
         WRITE (6,*) 'Too large polynomial degree in HGLJ'
         WRITE (6,*) 'Maximum polynomial degree is',NMAX
         WRITE (6,*) 'Here NP=',NP
         call exitt
      ENDIF
      ZD = Z
      DO 100 I=1,NP
         ZGLJD(I) = ZGLJ(I)
 100  CONTINUE
      ALPHAD = ALPHA
      BETAD  = BETA
      HGLJ   = HGLJD (II,ZD,ZGLJD,NP,ALPHAD,BETAD)
      RETURN
      END
C
      REAL*8  FUNCTION HGLJD (I,Z,ZGLJ,NP,ALPHA,BETA)
C---------------------------------------------------------------------
C
C     Compute the value of the Lagrangian interpolant HGLJD through
C     the NZ Gauss-Lobatto Jacobi points ZJACL at the point Z.
C     Double precision version.
C
C---------------------------------------------------------------------
      IMPLICIT REAL*8  (A-H,O-Z)
      REAL*8  Z,ZGLJ(1),ALPHA,BETA
      EPS = 1.e-5
      ONE = 1.
      ZI  = ZGLJ(I)
      DZ  = Z-ZI
      IF (ABS(DZ).LT.EPS) THEN
         HGLJD = ONE
         RETURN
      ENDIF
      N      = NP-1
      DN     = ((N))
      EIGVAL = -DN*(DN+ALPHA+BETA+ONE)
      CALL JACOBF (PI,PDI,PM1,PDM1,PM2,PDM2,N,ALPHA,BETA,ZI)
      CONST  = EIGVAL*PI+ALPHA*(ONE+ZI)*PDI-BETA*(ONE-ZI)*PDI
      CALL JACOBF (P,PD,PM1,PDM1,PM2,PDM2,N,ALPHA,BETA,Z)
      HGLJD  = (ONE-Z**2)*PD/(CONST*(Z-ZI))
      RETURN
      END
C
      SUBROUTINE DGJ (D,DT,Z,NZ,lzd,ALPHA,BETA)
C-----------------------------------------------------------------
C
C     Compute the derivative matrix D and its transpose DT
C     associated with the Nth order Lagrangian interpolants
C     through the NZ Gauss Jacobi points Z.
C     Note: D and DT are square matrices.
C     Single precision version.
C
C-----------------------------------------------------------------
      PARAMETER (NMAX=84)
      PARAMETER (lzdD = NMAX)
      REAL*8  DD(lzdD,lzdD),DTD(lzdD,lzdD),ZD(lzdD),ALPHAD,BETAD
      REAL D(lzd,lzd),DT(lzd,lzd),Z(1),ALPHA,BETA
C
      IF (NZ.LE.0) THEN
         WRITE (6,*) 'DGJ: Minimum number of Gauss points is 1'
         call exitt
      ENDIF
      IF (NZ .GT. NMAX) THEN
         WRITE (6,*) 'Too large polynomial degree in DGJ'
         WRITE (6,*) 'Maximum polynomial degree is',NMAX
         WRITE (6,*) 'Here Nz=',Nz
         call exitt
      ENDIF
      IF ((ALPHA.LE.-1.).OR.(BETA.LE.-1.)) THEN
         WRITE (6,*) 'DGJ: Alpha and Beta must be greater than -1'
         call exitt
      ENDIF
      ALPHAD = ALPHA
      BETAD  = BETA
      DO 100 I=1,NZ
         ZD(I) = Z(I)
 100  CONTINUE
      CALL DGJD (DD,DTD,ZD,NZ,lzdD,ALPHAD,BETAD)
      DO 200 I=1,NZ
      DO 200 J=1,NZ
         D(I,J)  = DD(I,J)
         DT(I,J) = DTD(I,J)
 200  CONTINUE
      RETURN
      END
C
      SUBROUTINE DGJD (D,DT,Z,NZ,lzd,ALPHA,BETA)
C-----------------------------------------------------------------
C
C     Compute the derivative matrix D and its transpose DT
C     associated with the Nth order Lagrangian interpolants
C     through the NZ Gauss Jacobi points Z.
C     Note: D and DT are square matrices.
C     Double precision version.
C
C-----------------------------------------------------------------
      IMPLICIT REAL*8  (A-H,O-Z)
      REAL*8  D(lzd,lzd),DT(lzd,lzd),Z(1),ALPHA,BETA
      N    = NZ-1
      DN   = ((N))
      ONE  = 1.
      TWO  = 2.
C
      IF (NZ.LE.1) THEN
       WRITE (6,*) 'DGJD: Minimum number of Gauss-Lobatto points is 2'
       call exitt
      ENDIF
      IF ((ALPHA.LE.-ONE).OR.(BETA.LE.-ONE)) THEN
         WRITE (6,*) 'DGJD: Alpha and Beta must be greater than -1'
         call exitt
      ENDIF
C
      DO 200 I=1,NZ
      DO 200 J=1,NZ
         CALL JACOBF (PI,PDI,PM1,PDM1,PM2,PDM2,NZ,ALPHA,BETA,Z(I))
         CALL JACOBF (PJ,PDJ,PM1,PDM1,PM2,PDM2,NZ,ALPHA,BETA,Z(J))
         IF (I.NE.J) D(I,J) = PDI/(PDJ*(Z(I)-Z(J)))
         IF (I.EQ.J) D(I,J) = ((ALPHA+BETA+TWO)*Z(I)+ALPHA-BETA)/
     $                        (TWO*(ONE-Z(I)**2))
         DT(J,I) = D(I,J)
 200  CONTINUE
      RETURN
      END
C
      SUBROUTINE DGLJ (D,DT,Z,NZ,lzd,ALPHA,BETA)
C-----------------------------------------------------------------
C
C     Compute the derivative matrix D and its transpose DT
C     associated with the Nth order Lagrangian interpolants
C     through the NZ Gauss-Lobatto Jacobi points Z.
C     Note: D and DT are square matrices.
C     Single precision version.
C
C-----------------------------------------------------------------
      PARAMETER (NMAX=84)
      PARAMETER (lzdD = NMAX)
      REAL*8  DD(lzdD,lzdD),DTD(lzdD,lzdD),ZD(lzdD),ALPHAD,BETAD
      REAL D(lzd,lzd),DT(lzd,lzd),Z(1),ALPHA,BETA
C
      IF (NZ.LE.1) THEN
       WRITE (6,*) 'DGLJ: Minimum number of Gauss-Lobatto points is 2'
       call exitt
      ENDIF
      IF (NZ .GT. NMAX) THEN
         WRITE (6,*) 'Too large polynomial degree in DGLJ'
         WRITE (6,*) 'Maximum polynomial degree is',NMAX
         WRITE (6,*) 'Here NZ=',NZ
         call exitt
      ENDIF
      IF ((ALPHA.LE.-1.).OR.(BETA.LE.-1.)) THEN
         WRITE (6,*) 'DGLJ: Alpha and Beta must be greater than -1'
         call exitt
      ENDIF
      ALPHAD = ALPHA
      BETAD  = BETA
      DO 100 I=1,NZ
         ZD(I) = Z(I)
 100  CONTINUE
      CALL DGLJD (DD,DTD,ZD,NZ,lzdD,ALPHAD,BETAD)
      DO 200 I=1,NZ
      DO 200 J=1,NZ
         D(I,J)  = DD(I,J)
         DT(I,J) = DTD(I,J)
 200  CONTINUE
      RETURN
      END
C
      SUBROUTINE DGLJD (D,DT,Z,NZ,lzd,ALPHA,BETA)
C-----------------------------------------------------------------
C
C     Compute the derivative matrix D and its transpose DT
C     associated with the Nth order Lagrangian interpolants
C     through the NZ Gauss-Lobatto Jacobi points Z.
C     Note: D and DT are square matrices.
C     Double precision version.
C
C-----------------------------------------------------------------
      IMPLICIT REAL*8  (A-H,O-Z)
      REAL*8  D(lzd,lzd),DT(lzd,lzd),Z(1),ALPHA,BETA
      N    = NZ-1
      DN   = ((N))
      ONE  = 1.
      TWO  = 2.
      EIGVAL = -DN*(DN+ALPHA+BETA+ONE)
C
      IF (NZ.LE.1) THEN
       WRITE (6,*) 'DGLJD: Minimum number of Gauss-Lobatto points is 2'
       call exitt
      ENDIF
      IF ((ALPHA.LE.-ONE).OR.(BETA.LE.-ONE)) THEN
         WRITE (6,*) 'DGLJD: Alpha and Beta must be greater than -1'
         call exitt
      ENDIF
C
      DO 200 I=1,NZ
      DO 200 J=1,NZ
         CALL JACOBF (PI,PDI,PM1,PDM1,PM2,PDM2,N,ALPHA,BETA,Z(I))
         CALL JACOBF (PJ,PDJ,PM1,PDM1,PM2,PDM2,N,ALPHA,BETA,Z(J))
         CI = EIGVAL*PI-(BETA*(ONE-Z(I))-ALPHA*(ONE+Z(I)))*PDI
         CJ = EIGVAL*PJ-(BETA*(ONE-Z(J))-ALPHA*(ONE+Z(J)))*PDJ
         IF (I.NE.J) D(I,J) = CI/(CJ*(Z(I)-Z(J)))
         IF ((I.EQ.J).AND.(I.NE.1).AND.(I.NE.NZ))
     $   D(I,J) = (ALPHA*(ONE+Z(I))-BETA*(ONE-Z(I)))/
     $            (TWO*(ONE-Z(I)**2))
         IF ((I.EQ.J).AND.(I.EQ.1))
     $   D(I,J) =  (EIGVAL+ALPHA)/(TWO*(BETA+TWO))
         IF ((I.EQ.J).AND.(I.EQ.NZ))
     $   D(I,J) = -(EIGVAL+BETA)/(TWO*(ALPHA+TWO))
         DT(J,I) = D(I,J)
 200  CONTINUE
      RETURN
      END
C
      SUBROUTINE DGLL (D,DT,Z,NZ,lzd)
C-----------------------------------------------------------------
C
C     Compute the derivative matrix D and its transpose DT
C     associated with the Nth order Lagrangian interpolants
C     through the NZ Gauss-Lobatto Legendre points Z.
C     Note: D and DT are square matrices.
C
C-----------------------------------------------------------------
      PARAMETER (NMAX=84)
      REAL D(lzd,lzd),DT(lzd,lzd),Z(1)
      N  = NZ-1
      IF (NZ .GT. NMAX) THEN
         WRITE (6,*) 'Subroutine DGLL'
         WRITE (6,*) 'Maximum polynomial degree =',NMAX
         WRITE (6,*) 'Polynomial degree         =',NZ
      ENDIF
      IF (NZ .EQ. 1) THEN
         D(1,1) = 0.
         RETURN
      ENDIF
      FN = (N)
      d0 = FN*(FN+1.)/4.
      DO 200 I=1,NZ
      DO 200 J=1,NZ
         D(I,J) = 0.
         IF  (I.NE.J) D(I,J) = PNLEG(Z(I),N)/
     $                        (PNLEG(Z(J),N)*(Z(I)-Z(J)))
         IF ((I.EQ.J).AND.(I.EQ.1))  D(I,J) = -d0
         IF ((I.EQ.J).AND.(I.EQ.NZ)) D(I,J) =  d0
         DT(J,I) = D(I,J)
 200  CONTINUE
      RETURN
      END
C
      REAL FUNCTION HGLL (I,Z,ZGLL,NZ)
C---------------------------------------------------------------------
C
C     Compute the value of the Lagrangian interpolant L through
C     the NZ Gauss-Lobatto Legendre points ZGLL at the point Z.
C
C---------------------------------------------------------------------
      REAL ZGLL(1)
      EPS = 1.E-5
      DZ = Z - ZGLL(I)
      IF (ABS(DZ) .LT. EPS) THEN
         HGLL = 1.
         RETURN
      ENDIF
      N = NZ - 1
      ALFAN = (N)*((N)+1.)
      HGLL = - (1.-Z*Z)*PNDLEG(Z,N)/
     $         (ALFAN*PNLEG(ZGLL(I),N)*(Z-ZGLL(I)))
      RETURN
      END
C
      REAL FUNCTION HGL (I,Z,ZGL,NZ)
C---------------------------------------------------------------------
C
C     Compute the value of the Lagrangian interpolant HGL through
C     the NZ Gauss Legendre points ZGL at the point Z.
C
C---------------------------------------------------------------------
      REAL ZGL(1)
      EPS = 1.E-5
      DZ = Z - ZGL(I)
      IF (ABS(DZ) .LT. EPS) THEN
         HGL = 1.
         RETURN
      ENDIF
      N = NZ-1
      HGL = PNLEG(Z,NZ)/(PNDLEG(ZGL(I),NZ)*(Z-ZGL(I)))
      RETURN
      END
C
      REAL FUNCTION PNLEG (Z,N)
C---------------------------------------------------------------------
C
C     Compute the value of the Nth order Legendre polynomial at Z.
C     (Simpler than JACOBF)
C     Based on the recursion formula for the Legendre polynomials.
C
C---------------------------------------------------------------------
C
C     This next statement is to overcome the underflow bug in the i860.  
C     It can be removed at a later date.  11 Aug 1990   pff.
C
      IF(ABS(Z) .LT. 1.0E-25) Z = 0.0
C
      P1   = 1.
      IF (N.EQ.0) THEN
         PNLEG = P1
         RETURN
      ENDIF
      P2   = Z
      P3   = P2
      DO 10 K = 1, N-1
         FK  = (K)
         P3  = ((2.*FK+1.)*Z*P2 - FK*P1)/(FK+1.)
         P1  = P2
         P2  = P3
 10   CONTINUE
      PNLEG = P3
      if (n.eq.0) pnleg = 1.
      RETURN
      END
C
      REAL FUNCTION PNDLEG (Z,N)
C----------------------------------------------------------------------
C
C     Compute the derivative of the Nth order Legendre polynomial at Z.
C     (Simpler than JACOBF)
C     Based on the recursion formula for the Legendre polynomials.
C
C----------------------------------------------------------------------
      P1   = 1.
      P2   = Z
      P1D  = 0.
      P2D  = 1.
      P3D  = 1.
      DO 10 K = 1, N-1
         FK  = (K)
         P3  = ((2.*FK+1.)*Z*P2 - FK*P1)/(FK+1.)
         P3D = ((2.*FK+1.)*P2 + (2.*FK+1.)*Z*P2D - FK*P1D)/(FK+1.)
         P1  = P2
         P2  = P3
         P1D = P2D
         P2D = P3D
 10   CONTINUE
      PNDLEG = P3D
      IF (N.eq.0) pndleg = 0.
      RETURN
      END
C
      SUBROUTINE DGLLGL (D,DT,ZM1,ZM2,IM12,NZM1,NZM2,ND1,ND2)
C-----------------------------------------------------------------------
C
C     Compute the (one-dimensional) derivative matrix D and its
C     transpose DT associated with taking the derivative of a variable
C     expanded on a Gauss-Lobatto Legendre mesh (M1), and evaluate its
C     derivative on a Guass Legendre mesh (M2).
C     Need the one-dimensional interpolation operator IM12
C     (see subroutine IGLLGL).
C     Note: D and DT are rectangular matrices.
C
C-----------------------------------------------------------------------
      REAL D(ND2,ND1), DT(ND1,ND2), ZM1(ND1), ZM2(ND2), IM12(ND2,ND1)
      IF (NZM1.EQ.1) THEN
        D (1,1) = 0.
        DT(1,1) = 0.
        RETURN
      ENDIF
      EPS = 1.E-6
      NM1 = NZM1-1
      DO 10 IP = 1, NZM2
         DO 10 JQ = 1, NZM1
            ZP = ZM2(IP)
            ZQ = ZM1(JQ)
            IF ((ABS(ZP) .LT. EPS).AND.(ABS(ZQ) .LT. EPS)) THEN
                D(IP,JQ) = 0.
            ELSE
                D(IP,JQ) = (PNLEG(ZP,NM1)/PNLEG(ZQ,NM1)
     $                     -IM12(IP,JQ))/(ZP-ZQ)
            ENDIF
            DT(JQ,IP) = D(IP,JQ)
 10   CONTINUE
      RETURN
      END
C
      SUBROUTINE DGLJGJ (D,DT,ZGL,ZG,IGLG,NPGL,NPG,ND1,ND2,ALPHA,BETA)
C-----------------------------------------------------------------------
C
C     Compute the (one-dimensional) derivative matrix D and its
C     transpose DT associated with taking the derivative of a variable
C     expanded on a Gauss-Lobatto Jacobi mesh (M1), and evaluate its
C     derivative on a Guass Jacobi mesh (M2).
C     Need the one-dimensional interpolation operator IM12
C     (see subroutine IGLJGJ).
C     Note: D and DT are rectangular matrices.
C     Single precision version.
C
C-----------------------------------------------------------------------
      REAL D(ND2,ND1), DT(ND1,ND2), ZGL(ND1), ZG(ND2), IGLG(ND2,ND1)
      PARAMETER (NMAX=84)
      PARAMETER (NDD = NMAX)
      REAL*8  DD(NDD,NDD), DTD(NDD,NDD)
      REAL*8  ZGD(NDD), ZGLD(NDD), IGLGD(NDD,NDD)
      REAL*8  ALPHAD, BETAD
C
      IF (NPGL.LE.1) THEN
       WRITE(6,*) 'DGLJGJ: Minimum number of Gauss-Lobatto points is 2'
       call exitt
      ENDIF
      IF (NPGL.GT.NMAX) THEN
         WRITE(6,*) 'Polynomial degree too high in DGLJGJ'
         WRITE(6,*) 'Maximum polynomial degree is',NMAX
         WRITE(6,*) 'Here NPGL=',NPGL
         call exitt
      ENDIF
      IF ((ALPHA.LE.-1.).OR.(BETA.LE.-1.)) THEN
         WRITE(6,*) 'DGLJGJ: Alpha and Beta must be greater than -1'
         call exitt
      ENDIF
C
      ALPHAD = ALPHA
      BETAD  = BETA
      DO 100 I=1,NPG
         ZGD(I) = ZG(I)
         DO 100 J=1,NPGL
            IGLGD(I,J) = IGLG(I,J)
 100  CONTINUE
      DO 200 I=1,NPGL
         ZGLD(I) = ZGL(I)
 200  CONTINUE
      CALL DGLJGJD (DD,DTD,ZGLD,ZGD,IGLGD,NPGL,NPG,NDD,NDD,ALPHAD,BETAD)
      DO 300 I=1,NPG
      DO 300 J=1,NPGL
         D(I,J)  = DD(I,J)
         DT(J,I) = DTD(J,I)
 300  CONTINUE
      RETURN
      END
C
      SUBROUTINE DGLJGJD (D,DT,ZGL,ZG,IGLG,NPGL,NPG,ND1,ND2,ALPHA,BETA)
C-----------------------------------------------------------------------
C
C     Compute the (one-dimensional) derivative matrix D and its
C     transpose DT associated with taking the derivative of a variable
C     expanded on a Gauss-Lobatto Jacobi mesh (M1), and evaluate its
C     derivative on a Guass Jacobi mesh (M2).
C     Need the one-dimensional interpolation operator IM12
C     (see subroutine IGLJGJ).
C     Note: D and DT are rectangular matrices.
C     Double precision version.
C
C-----------------------------------------------------------------------
      IMPLICIT REAL*8  (A-H,O-Z)
      REAL*8  D(ND2,ND1), DT(ND1,ND2), ZGL(ND1), ZG(ND2)
      REAL*8  IGLG(ND2,ND1), ALPHA, BETA
C
      IF (NPGL.LE.1) THEN
       WRITE(6,*) 'DGLJGJD: Minimum number of Gauss-Lobatto points is 2'
       call exitt
      ENDIF
      IF ((ALPHA.LE.-1.).OR.(BETA.LE.-1.)) THEN
         WRITE(6,*) 'DGLJGJD: Alpha and Beta must be greater than -1'
         call exitt
      ENDIF
C
      EPS    = 1.e-6
      ONE    = 1.
      TWO    = 2.
      NGL    = NPGL-1
      DN     = ((NGL))
      EIGVAL = -DN*(DN+ALPHA+BETA+ONE)
C
      DO 100 I=1,NPG
      DO 100 J=1,NPGL
         DZ = ABS(ZG(I)-ZGL(J))
         IF (DZ.LT.EPS) THEN
            D(I,J) = (ALPHA*(ONE+ZG(I))-BETA*(ONE-ZG(I)))/
     $               (TWO*(ONE-ZG(I)**2))
         ELSE
            CALL JACOBF (PI,PDI,PM1,PDM1,PM2,PDM2,NGL,ALPHA,BETA,ZG(I))
            CALL JACOBF (PJ,PDJ,PM1,PDM1,PM2,PDM2,NGL,ALPHA,BETA,ZGL(J))
            FACI   = ALPHA*(ONE+ZG(I))-BETA*(ONE-ZG(I))
            FACJ   = ALPHA*(ONE+ZGL(J))-BETA*(ONE-ZGL(J))
            CONST  = EIGVAL*PJ+FACJ*PDJ
            D(I,J) = ((EIGVAL*PI+FACI*PDI)*(ZG(I)-ZGL(J))
     $               -(ONE-ZG(I)**2)*PDI)/(CONST*(ZG(I)-ZGL(J))**2)
         ENDIF
         DT(J,I) = D(I,J)
 100  CONTINUE
      RETURN
      END
C
      SUBROUTINE IGLM (I12,IT12,Z1,Z2,lz1,lz2,ND1,ND2)
C----------------------------------------------------------------------
C
C     Compute the one-dimensional interpolation operator (matrix) I12
C     ands its transpose IT12 for interpolating a variable from a
C     Gauss Legendre mesh (1) to a another mesh M (2).
C     Z1 : lz1 Gauss Legendre points.
C     Z2 : lz2 points on mesh M.
C
C--------------------------------------------------------------------
      REAL I12(ND2,ND1),IT12(ND1,ND2),Z1(ND1),Z2(ND2)
      IF (lz1 .EQ. 1) THEN
         I12 (1,1) = 1.
         IT12(1,1) = 1.
         RETURN
      ENDIF
      DO 10 I=1,lz2
         ZI = Z2(I)
         DO 10 J=1,lz1
            I12 (I,J) = HGL(J,ZI,Z1,lz1)
            IT12(J,I) = I12(I,J)
 10   CONTINUE
      RETURN
      END
c
      SUBROUTINE IGLLM (I12,IT12,Z1,Z2,lz1,lz2,ND1,ND2)
C----------------------------------------------------------------------
C
C     Compute the one-dimensional interpolation operator (matrix) I12
C     ands its transpose IT12 for interpolating a variable from a
C     Gauss-Lobatto Legendre mesh (1) to a another mesh M (2).
C     Z1 : lz1 Gauss-Lobatto Legendre points.
C     Z2 : lz2 points on mesh M.
C
C--------------------------------------------------------------------
      REAL I12(ND2,ND1),IT12(ND1,ND2),Z1(ND1),Z2(ND2)
      IF (lz1 .EQ. 1) THEN
         I12 (1,1) = 1.
         IT12(1,1) = 1.
         RETURN
      ENDIF
      DO 10 I=1,lz2
         ZI = Z2(I)
         DO 10 J=1,lz1
            I12 (I,J) = HGLL(J,ZI,Z1,lz1)
            IT12(J,I) = I12(I,J)
 10   CONTINUE
      RETURN
      END
C
      SUBROUTINE IGJM (I12,IT12,Z1,Z2,lz1,lz2,ND1,ND2,ALPHA,BETA)
C----------------------------------------------------------------------
C
C     Compute the one-dimensional interpolation operator (matrix) I12
C     ands its transpose IT12 for interpolating a variable from a
C     Gauss Jacobi mesh (1) to a another mesh M (2).
C     Z1 : lz1 Gauss Jacobi points.
C     Z2 : lz2 points on mesh M.
C     Single precision version.
C
C--------------------------------------------------------------------
      REAL I12(ND2,ND1),IT12(ND1,ND2),Z1(ND1),Z2(ND2)
      IF (lz1 .EQ. 1) THEN
         I12 (1,1) = 1.
         IT12(1,1) = 1.
         RETURN
      ENDIF
      DO 10 I=1,lz2
         ZI = Z2(I)
         DO 10 J=1,lz1
            I12 (I,J) = HGJ(J,ZI,Z1,lz1,ALPHA,BETA)
            IT12(J,I) = I12(I,J)
 10   CONTINUE
      RETURN
      END
c
      SUBROUTINE IGLJM (I12,IT12,Z1,Z2,lz1,lz2,ND1,ND2,ALPHA,BETA)
C----------------------------------------------------------------------
C
C     Compute the one-dimensional interpolation operator (matrix) I12
C     ands its transpose IT12 for interpolating a variable from a
C     Gauss-Lobatto Jacobi mesh (1) to a another mesh M (2).
C     Z1 : lz1 Gauss-Lobatto Jacobi points.
C     Z2 : lz2 points on mesh M.
C     Single precision version.
C
C--------------------------------------------------------------------
      REAL I12(ND2,ND1),IT12(ND1,ND2),Z1(ND1),Z2(ND2)
      IF (lz1 .EQ. 1) THEN
         I12 (1,1) = 1.
         IT12(1,1) = 1.
         RETURN
      ENDIF
      DO 10 I=1,lz2
         ZI = Z2(I)
         DO 10 J=1,lz1
            I12 (I,J) = HGLJ(J,ZI,Z1,lz1,ALPHA,BETA)
            IT12(J,I) = I12(I,J)
 10   CONTINUE
      RETURN
      END

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!The loop in this example cannot be parallelized.
!
!This pattern has two pair of dependencies:
!1. loop carried output dependence
! x = .. :
!
!2. loop carried true dependence due to:
!.. = x;
! x = ..;
!Data race pairs: we allow two pairs to preserve the original code pattern.
! 1. x@48 vs. x@49
! 2. x@49 vs. x@49


module globalArray
    implicit none
    integer, dimension(:), allocatable :: a
    contains
    subroutine useGlobalArray(len)
        integer :: len
        len = 100
        allocate (a(100))
    end subroutine useGlobalArray
end module globalArray

program DRB016_outputdep_orig_yes
    use omp_lib
    use globalArray

    implicit none

    integer len, i, x

    len = 100
    x = 10

    call useGlobalArray(len)

    !$omp parallel do
    do i = 1, len
        a(i) = x
        x = i
    end do
    !$omp end parallel do

    write(*,*) "x =",x
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

! argument pass-by-reference
! its data-sharing attribute is the same as its actual argument's. i and q are shared.
! Data race pair: q@15:5 vs. q@15:9

subroutine f1(q)
    implicit none
    integer :: q
    q = q+1
end subroutine f1

program DRB080_func_arg_orig_yes
    use omp_lib
    implicit none

    integer :: i

    i = 0

    !$omp parallel
    call f1(i)
    !$omp end parallel

    print*,"i = ",i
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!This example is based on one code snippet extracted from a paper:
!Ma etc. Symbolic Analysis of Concurrency Errors in OpenMP Programs, ICPP 2013
!
!Explicit barrier to counteract nowait. No data race pairs.


program DRB104_nowait_barrier_orig_no
    use omp_lib
    implicit none

    integer i, error, len, b
    integer, dimension(:), allocatable :: a

    len = 1000
    b = 5
    allocate (a(len))

    do i = 1, len
        a(i) = i
    end do

    !$omp parallel shared(b, error)
        !$omp do
        do i = 1, len
            a(i) = b+a(i)*5
        end do
        !$omp end do nowait
    !$omp end parallel

    !$omp barrier
    !$omp single
    error = a(9)+1
    !$omp end single

    print 100, error
    100 format ('error =',3i8)

    deallocate(a)
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!The -1 operation on numNodes2 is not protected, causing data race.
!Data race pair: numNodes2@32:13 vs. numNodes2@32:13

program DRB011_minusminus_orig_yes
    use omp_lib
    implicit none

    integer :: i, len, numNodes, numNodes2
    integer :: x(100)
    len = 100
    numNodes=len
    numNodes2=0

    do i = 1, len
        if (MOD(i,2) == 0) then
            x(i) = 5
        else
            x(i) = -5
        end if
    end do

    !$omp parallel do
    do i = numNodes, 1, -1
        if (x(i) <= 0) then
            numNodes2 = numNodes2-1
        end if
    end do
    !$omp end parallel do

    print*,"numNodes2 =", numNodes2
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!A linear expression is used as array subscription.
!Data race pair: a[2*i]@27:9 vs. a[i]@27:18

program DRB033_truedeplinear_orig_yes
    use omp_lib
    implicit none

    integer :: i, len
    integer, dimension(:), allocatable :: a

    len = 2000
    allocate (a(len))

    do i = 1, len
        a(i) = i
    end do

    !$omp parallel do
    do i = 1, 1000
        a(2*i) = a(i) + 1
    end do
    !$omp end parallel do

    print 100, a(1002)
    100 format ('a(1002) =',i3)

    deallocate(a)
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Data race pair: a[i]@24:9 vs. a[0]@24:16

program DRB039_truedepsingleelement_orig_yes
    use omp_lib
    implicit none

    integer :: len, i
    integer, dimension(:), allocatable :: a

    len = 1000
    allocate (a(len))

    a(1) = 2

    !$omp parallel do
    do i = 1, len
        a(i) = a(i)+a(1)
    end do
    !$omp end parallel do

    print 100, a(500)
    100 format ('a(500) =',i3)

    deallocate(a)
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!A variable is declared inside a function called within a parallel region.
!The variable should be shared if it uses static storage.
!
!Data race pair: q@19:7 vs. q@19:7

module global_foo
    use omp_lib
    implicit none
    contains
    subroutine foo()
      integer, save :: i
      i = i+1
      print*,i
    end subroutine foo
end module global_foo

program DRB082_declared_in_func_orig_yes
    use omp_lib
    use global_foo
    implicit none

    !$omp parallel
    call foo()
    !$omp end parallel
end program

c-----------------------------------------------------------------------
      subroutine aspect_ratios(ar)
c
c     7/6/96
c
c     This routine returns the aspect ratio of a 
c     conglomerate of a set of simplices defined by (tri,nt)
c
      include 'SIZE'
      include 'GEOM'
      include 'INPUT'
      include 'MASS'
c
      real ar(1)
      real xx(9)
c
      nxyz = lx1*ly1*lz1
c
      if (if3d) then
        do ie=1,nelv
          vol = vlsum(bm1(1,1,1,ie),nxyz)
          x0  = vlsc2(xm1(1,1,1,ie),bm1(1,1,1,ie),nxyz)/vol
          y0  = vlsc2(ym1(1,1,1,ie),bm1(1,1,1,ie),nxyz)/vol
          z0  = vlsc2(zm1(1,1,1,ie),bm1(1,1,1,ie),nxyz)/vol
c
          call rzero(xx,9)
          do i=1,nxyz
             x10 = xm1(i,1,1,ie) - x0
             y10 = ym1(i,1,1,ie) - y0
             z10 = zm1(i,1,1,ie) - z0
c
             xx(1) = xx(1) + bm1(i,1,1,ie)*x10*x10
             xx(2) = xx(2) + bm1(i,1,1,ie)*x10*y10
             xx(3) = xx(3) + bm1(i,1,1,ie)*x10*z10
             xx(4) = xx(4) + bm1(i,1,1,ie)*y10*x10
             xx(5) = xx(5) + bm1(i,1,1,ie)*y10*y10
             xx(6) = xx(6) + bm1(i,1,1,ie)*y10*z10
             xx(7) = xx(7) + bm1(i,1,1,ie)*z10*x10
             xx(8) = xx(8) + bm1(i,1,1,ie)*z10*y10
             xx(9) = xx(9) + bm1(i,1,1,ie)*z10*z10
          enddo
          vi = 1./vol
          call cmult(xx,vi,9)
c         call eig3(xx,eign,eig1)
          call eig2(xx,eign,eig1)
          ar(ie) = sqrt(eign/eig1)
        enddo
      else
        do ie=1,nelv
          vol = vlsum(bm1(1,1,1,ie),nxyz)
          x0  = vlsc2(xm1(1,1,1,ie),bm1(1,1,1,ie),nxyz)/vol
          y0  = vlsc2(ym1(1,1,1,ie),bm1(1,1,1,ie),nxyz)/vol
c
          call rzero(xx,4)
          do i=1,nxyz
             x10 = xm1(i,1,1,ie) - x0
             y10 = ym1(i,1,1,ie) - y0
             xx(1) = xx(1) + bm1(i,1,1,ie)*x10*x10
             xx(2) = xx(2) + bm1(i,1,1,ie)*x10*y10
             xx(3) = xx(3) + bm1(i,1,1,ie)*y10*x10
             xx(4) = xx(4) + bm1(i,1,1,ie)*y10*y10
          enddo
          vi = 1./vol
          call cmult(xx,vi,4)
          call eig2(xx,eign,eig1)
c         write(6,6) ie,vol,eign,eig1
c  6      format(i5,' veig:',1p3e16.6)
          ar(ie) = sqrt(eign/eig1)
        enddo
      endif
c
c     do ie=1,nelv
c        write(6,*) ar(ie),ie,' aspect'
c     enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine eig2(AA,eign,eig1)
c
c     return max and min eigenvalues of a 2x2 matrix
c
      real aa(2,2)
c
      a = aa(1,1)
      b = aa(1,2)
      c = aa(2,1)
      d = aa(2,2)
c
      qa = 1.
      qb = -(a+d)
      qc = (a*d - c*b)
      call quadratic_h(eign,eig1,qa,qb,qc)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine quadratic_h(x1,x2,a,b,c)
c
c     Stable routine for computation of real roots of quadratic
c
c     The "_h" denotes the hack below so we don't need to worry
c     about complex arithmetic in the near-double root case. pff 1/22/97
c
c     Upon return,  | x1 | >= | x2 |
c
      x1 = 0.
      x2 = 0.
c
      if (a.eq.0.) then
         if (b.eq.0) then
            write(6,10) x1,x2,a,b,c
            return
         endif
         x1 = -c/b
         write(6,11) x1,a,b,c
         return
      endif
c
      d = b*b - 4.*a*c
      if (d.lt.0) then
c        write(6,12) a,b,c,d
c        hack, for this application we'll assume d<0 by epsilon, and just set
         d = 0
      endif
      if (d.gt.0) d = sqrt(d)
c
      q = -0.5 * (b + b/abs(b) * d)
      x1 = q/a
      x2 = c/q
c
      if (abs(x2).gt.abs(x1)) then
         tmp = x2
         x2  = x1
         x1  = tmp
      endif
c
   10 format('ERROR: Both a & b zero in routine quadratic NO ROOTS.'
     $      ,1p5e12.4)
   11 format('ERROR: a = 0 in routine quadratic, only one root.'
     $      ,1p5e12.4)
   12 format('ERROR: negative discriminate in routine quadratic.'
     $      ,1p5e12.4)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine out_sem(iel)
c
      include 'SIZE'
      include 'INPUT'
      include 'GEOM'
c
c
      open(unit=33,file='v1')
      if (iel.eq.0) then
         do ie=1,nelv
            write(33,33) xm1(  1,  1,1,ie),ym1(  1,  1,1,ie)
            write(33,33) xm1(lx1,  1,1,ie),ym1(lx1,  1,1,ie)
            write(33,33) xm1(lx1,ly1,1,ie),ym1(lx1,ly1,1,ie)
            write(33,33) xm1(  1,ly1,1,ie),ym1(  1,ly1,1,ie)
         enddo
      else
         ie = iel
         write(33,33) xm1(  1,  1,1,ie),ym1(  1,  1,1,ie)
         write(33,33) xm1(lx1,  1,1,ie),ym1(lx1,  1,1,ie)
         write(33,33) xm1(lx1,ly1,1,ie),ym1(lx1,ly1,1,ie)
         write(33,33) xm1(  1,ly1,1,ie),ym1(  1,ly1,1,ie)
      endif
   33 format(f14.6)
      close(unit=33)
      return
      end
c-----------------------------------------------------------------------
      subroutine gradm11(ux,uy,uz,u,e)
c
c     Compute gradient of T -- mesh 1 to mesh 1 (vel. to vel.)
c
c     Single element case
c
      include 'SIZE'
      include 'DXYZ'
      include 'GEOM'
      include 'INPUT'
      include 'TSTEP'
c
      parameter (lxyz=lx1*ly1*lz1)
      real ux(lxyz),uy(lxyz),uz(lxyz),u(lxyz,1)
c
      common /ctmp1/ ur(lxyz),us(lxyz),ut(lxyz)
c
      integer e

c
      N = lx1-1
      if (if3d) then
         call local_grad3(ur,us,ut,u,N,e,dxm1,dxtm1)
         do i=1,lxyz
            ux(i) = jacmi(i,e)*(ur(i)*rxm1(i,1,1,e)
     $                        + us(i)*sxm1(i,1,1,e)
     $                        + ut(i)*txm1(i,1,1,e) )
            uy(i) = jacmi(i,e)*(ur(i)*rym1(i,1,1,e)
     $                        + us(i)*sym1(i,1,1,e)
     $                        + ut(i)*tym1(i,1,1,e) )
            uz(i) = jacmi(i,e)*(ur(i)*rzm1(i,1,1,e)
     $                        + us(i)*szm1(i,1,1,e)
     $                        + ut(i)*tzm1(i,1,1,e) )
         enddo
      else
         if (ifaxis) call setaxdy (ifrzer(e))
         call local_grad2(ur,us,u,N,e,dxm1,dytm1)
         do i=1,lxyz
            ux(i) =jacmi(i,e)*(ur(i)*rxm1(i,1,1,e)
     $                       + us(i)*sxm1(i,1,1,e) )
            uy(i) =jacmi(i,e)*(ur(i)*rym1(i,1,1,e)
     $                       + us(i)*sym1(i,1,1,e) )
         enddo
      endif
c
      return
      end
c-----------------------------------------------------------------------

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Two tasks without depend clause to protect data writes.
!i is shared for two tasks based on implicit data-sharing attribute rules.
!Data race pair: i@22 vs. i@25

program DRB027_taskdependmissing_orig_yes
    use omp_lib
    implicit none

    integer :: i
    i=0

    !$omp parallel
    !$omp single
    !$omp task
    i = 1
    !$omp end task
    !$omp task
    i = 2
    !$omp end task
    !$omp end single
    !$omp end parallel

    print 100, i
    100 format ("i=",i3)

end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!This example is extracted from a paper:
!Ma etc. Symbolic Analysis of Concurrency Errors in OpenMP Programs, ICPP 2013
!
!Some threads may finish the for loop early and execute errors = dt[10]+1
!while another thread may still be simultaneously executing
!the for worksharing region by writing to d[9], causing data races.
!
!Data race pair: a[i]@41:21 vs. a[10]@37:!7

program DRB013_nowait_orig_yes
    use omp_lib
    implicit none

    integer i, error, len, b
    integer, dimension (:), allocatable :: a

    b = 5
    len = 1000

    allocate (a(len))

    do i = 1, len
        a(i) = i
    end do

    !$omp parallel shared(b, error)
        !$omp parallel
            !$omp do
            do i = 1, len
                a(i) = b + a(i)*5
            end do
            !$omp end do nowait
            !$omp single
            error = a(10) + 1;
            !$omp end single
        !$omp end parallel
    !$omp end parallel

    print*,"error =",error

    deallocate(a)
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Example with loop-carried data dependence at the outer level loop.
!But the inner level loop can be parallelized.


program DRB053_inneronly1_orig_no
    use omp_lib
    implicit none

    integer :: i, j

    real, dimension(:,:), allocatable :: a
    allocate (a(20,20))

    do i = 1, 20
        do j = 1, 20
            a(i,j) = 0.0
        end do
    end do

    do i = 1, 19
    !$omp parallel do
        do j = 1, 20
            a(i,j) = a(i,j)+a(i+1,j)
        end do
    !$omp end parallel do
    end do

    deallocate(a)
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!A loop with loop-carried anti-dependence.
!Data race pair: a[i+1]@25:9 vs. a[i]@25:16

program DRB001_antidep1_orig_yes
use omp_lib
    implicit none
    integer :: i, len
    integer :: a(1000)

    len = 1000

    do i = 1, len
        a(i) = i
    end do

    !$omp parallel do
    do i = 1, len-1
        a(i) = a(i+1) + 1
    end do
    !$omp end parallel do

    print 100, a(500)
    100 format ('a(500)=',i3)
end program

      real function rans_komg_mut(ix,iy,iz,iel)
      include 'SIZE'
      include 'TSTEP'
      include 'RANS_KOMG'

      save ifldla
      data ifldla /ldimt1/ 

      if(ix*iy*iz*iel.eq.1 .and. ifield.le.ifldla) then
         if(nid.eq.0 .and. loglevel.gt.2) write(6,*) 'updating komg_mut'
         if(ifrans_komg_stndrd)      call rans_komg_stndrd_eddy
         if(ifrans_komg_lowRe)       call rans_komg_lowRe_eddy
         if(ifrans_komgSST_stndrd)   call rans_komgSST_stndrd_eddy
         if(ifrans_komgSST_lowRe)    call rans_komgSST_lowRe_eddy
         if(ifrans_komg_stndrd_noreg)call rans_komg_stndrd_eddy_noreg
      endif

      ifldla = ifield
      rans_komg_mut = mut(ix,iy,iz,iel)

      return
      end
c-----------------------------------------------------------------------
      real function rans_komg_mutsk(ix,iy,iz,iel)
      include 'SIZE'
      include 'TSTEP'
      include 'RANS_KOMG'

      rans_komg_mutsk = mutsk(ix,iy,iz,iel)

      return
      end
c-----------------------------------------------------------------------
      real function rans_komg_mutso(ix,iy,iz,iel)
      include 'SIZE'
      include 'TSTEP'
      include 'RANS_KOMG'

      rans_komg_mutso = mutso(ix,iy,iz,iel)

      return
      end
c-----------------------------------------------------------------------
      subroutine rans_komg_getCoeffs(coeffs_in)
      include 'SIZE'
      include 'TSTEP'
      include 'RANS_KOMG'

      real coeffs_in(1)

      do i=1,ncoeffs
         coeffs_in(i) = coeffs(i)
      enddo
      
      return
      end
c-----------------------------------------------------------------------
      real function rans_komg_kSrc(ix,iy,iz,iel)
      include 'SIZE'
      include 'TSTEP'
      include 'RANS_KOMG'

      logical ifevalsrc
      data ifevalsrc /.true./
      common /komgifsrc/ ifevalsrc

      if(ix*iy*iz*iel.eq.1 .and. ifevalsrc) then
         if(nid.eq.0 .and. loglevel.gt.2) write(6,*) 'updating komg_src'
         if(ifrans_komg_stndrd)      call rans_komg_stndrd_compute
         if(ifrans_komg_lowRe)       call rans_komg_lowRe_compute
         if(ifrans_komgSST_stndrd)   call rans_komgSST_stndrd_compute
         if(ifrans_komgSST_lowRe)    call rans_komgSST_lowRe_compute
         if(ifrans_komg_stndrd_noreg)call rans_komg_stndrd_compute_noreg
         ifevalsrc = .false.
      endif

      if(ifld_k.gt.ifld_omega) ifevalsrc = .true.
      rans_komg_kSrc = kSrc(ix,iy,iz,iel)

      return
      end
c-----------------------------------------------------------------------
      real function rans_komg_omgSrc(ix,iy,iz,iel)
      include 'SIZE'
      include 'TSTEP'
      include 'RANS_KOMG'

      logical ifevalsrc
      data ifevalsrc /.true./
      common /komgifsrc/ ifevalsrc

      if(ix*iy*iz*iel.eq.1 .and. ifevalsrc) then
         if(nid.eq.0 .and. loglevel.gt.2) write(6,*) 'updating komg_src'
         if(ifrans_komg_stndrd)      call rans_komg_stndrd_compute
         if(ifrans_komg_lowRe)       call rans_komg_lowRe_compute
         if(ifrans_komgSST_stndrd)   call rans_komgSST_stndrd_compute
         if(ifrans_komgSST_lowRe)    call rans_komgSST_lowRe_compute
         if(ifrans_komg_stndrd_noreg)call rans_komg_stndrd_compute_noreg
         ifevalsrc = .false.
      endif

      if(ifld_omega.gt.ifld_k) ifevalsrc = .true.
      rans_komg_omgSrc = omgSrc(ix,iy,iz,iel)

      return
      end
c-----------------------------------------------------------------------
      subroutine rans_komg_stndrd_compute
c
c     Compute RANS source terms and diffusivities on an 
c     element-by-element basis
c
      include 'SIZE'
      include 'TOTAL'
      include 'RANS_KOMG'

      parameter (lxyz=lx1*ly1*lz1)

      real           k_x(lxyz),k_y(lxyz),k_z(lxyz)
     $             , o_x(lxyz),o_y(lxyz),o_z(lxyz)
     $              ,omp_x(lxyz), omp_y(lxyz), omp_z(lxyz)

      real           tempv(lxyz), rhoalpk (lxyz)
     $              ,omwom(lxyz), rhoalpfr(lxyz)

      real           term1(lxyz), term2   (lxyz)
     $              ,term3(lxyz), term4   (lxyz)
     $              ,g    (lxyz), div     (lxyz)

      common /storesom/ St_mag2(lx1*ly1*lz1,lelv)
     $                , Om_mag2(lx1*ly1*lz1,lelv)
     $                , OiOjSk (lx1*ly1*lz1,lelv)
     $                , DivQ   (lx1*ly1*lz1,lelv)

      integer e
      real k,mu_t,nu_t,mu,nu, kv_min,omeg_max

      real mu_omeg(lxyz), mu_omegx(lxyz), mu_omegy(lxyz), mu_omegz(lxyz)
      real extra_src_omega(lxyz)

c Turbulent viscosity constants
        Pr_t         = coeffs( 1)
        sigma_k      = coeffs( 2)
        sigma_omega  = coeffs( 3)

c Low Reynolds number correction constants
        alpinf_str   = coeffs( 4)
        r_k          = coeffs( 5)
        beta_0       = coeffs( 6)
        alp0_str     = coeffs( 7)

c Dissipation of K constants
        betainf_str  = coeffs( 8)
        alp_inf      = coeffs( 9)
        r_b          = coeffs(10)
        akk          = coeffs(11)

c Production of omega constants
        alpha_0      = coeffs(12)
        r_w          = coeffs(13)

c Dissipation of omega constants
c         beta_0 = defined earlier	     

        kv_min       = coeffs(14)
        omeg_max     = coeffs(15)
        tiny         = coeffs(16)
c================================

      call comp_StOm (St_mag2, Om_mag2, OiOjSk, DivQ)

      nome_neg = 0
      nkey_neg = 0
      xome_neg = 0.
      xkey_neg = 0.

      do e=1,nelv

        call copy   (g,   St_mag2(1,e),       lxyz)
        call copy   (div, DivQ   (1,e),       lxyz)

        call gradm11(k_x,  k_y,  k_z,  t(1,1,1,1,ifld_k    -1),e)
        call gradm11(omp_x,omp_y,omp_z,t(1,1,1,1,ifld_omega-1),e)

c solve for omega_pert

c ---------------------
c        call check_omwall_behavior
c ---------------------
        do i=1,lxyz

          rho = param(1) ! vtrans(i,1,1,e,1)
          mu  = param(2) ! vdiff (i,1,1,e,1)
          nu  = mu/rho

c limits for k, omega

c solve for omega_pert
          omega   = t(i,1,1,e,ifld_omega-1) + f_omegb(i,1,1,e) ! Current k & omega values
          k       = t(i,1,1,e,ifld_k  -1)   ! from previous timestep

          iflim_omeg = 0 ! limit omega^{prime} 1 limit omega_total

          if    (iflim_omeg.eq.0) then
            if(t(i,1,1,e,ifld_omega-1).lt.0.0) then
c             write(*,*) 'Zero OMEG ', t(i,1,1,e,ifld_omega-1)
              xome_neg = min(xome_neg,t(i,1,1,e,ifld_omega-1))
              nome_neg = nome_neg + 1
c             write(*,*) 'Neg  OMEG ', nome_neg, xome_neg
              t(i,1,1,e,ifld_omega-1) =0.01*abs(t(i,1,1,e,ifld_omega-1))
              omega = t(i,1,1,e,ifld_omega-1) + f_omegb(i,1,1,e) ! Current k & omega values
            endif

            if(t(i,1,1,e,ifld_k-1).lt.0.0) then
c             write(*,*) 'Zero K    ', t(i,1,1,e,ifld_k-1)
              xkey_neg = min(xkey_neg,t(i,1,1,e,ifld_k-1))
              nkey_neg = nkey_neg + 1
c             write(*,*) 'Neg  KEY  ', nkey_neg, xkey_neg
              t(i,1,1,e,ifld_k-1) = 0.01*abs(t(i,1,1,e,ifld_k-1))
              k     = t(i,1,1,e,ifld_k  -1)   ! from previous timestep
            endif

          elseif(iflim_omeg.eq.1) then

            if(omega.lt.0.0) then
c             write(*,*) 'OMEG tot is neg', omega
              omega = 0.01*abs(omega)
            endif

            if(k.lt.0.0) then
c              write(*,*) 'K  is neg', k
               k = 0.01*abs(k)
            endif

          endif

          expn = -2.0 
          o_x(i)= omp_x(i)+expn * dfdx_omegb(i,1,1,e) *f_omegb(i,1,1,e)
          o_y(i)= omp_y(i)+expn * dfdy_omegb(i,1,1,e) *f_omegb(i,1,1,e)
          if(if3d) 
     $    o_z(i)= omp_z(i)+expn * dfdz_omegb(i,1,1,e) *f_omegb(i,1,1,e)
          omwom (i)= 1.0/(1.0+t(i,1,1,e,ifld_omega-1)/f_omegb(i,1,1,e))

c See equations from eqns_k_omega1.pdf from Eq. (3) onwards
c Eq.(1) and (2) in eqns_k_omega1.pdf are the governing equations
c no source terms Sk or S_w are added

          St_magn = sqrt(St_mag2(i,e))
          Om_magn = sqrt(Om_mag2(i,e))
          sum_xx  =      OiOjSk (i,e)

! calculate del k * del omega / omega

          if(if3d)then
            xk3= (k_x(i)*o_x(i) + k_y(i)*o_y(i) + k_z(i)*o_z(i))
     $                                         / (omega**3+tiny)
          else
            xk3= (k_x(i)*o_x(i) + k_y(i)*o_y(i))
     $                                         / (omega**3+tiny)
          endif

          alp_str = alpinf_str 
          mu_t    = rho * alp_str*k/(omega + tiny) ! should multiply these by rho!!!
          rhoalpk(i)= rho*alp_str*k

          factr = 1.0
          sigma_omega1 = 1.0/sigma_omega
          rhoalpfr(i) = expn * rho * alp_str * factr * omwom(i)
     $                                           * sigma_omega1

c nu_t is kinematic turbulent viscosity
c units of k = m2/s2, units of omega = 1/s, nu units = m2/s
c set limit for nu_t
c           nu_t    = max(tiny,nu_t)
c	    if(nu_t.gt.5000*mu)nu_t = 5000*mu

          betai_str = betainf_str

          if (xk3.le.0)then
            f_beta_str = 1.0
          else
            f_beta_str = (1.0 + 680.0*xk3*xk3)/(1.0 + 400.0*xk3*xk3)
          endif
          Y_k = rho * betai_str * f_beta_str * k * omega

c betai_str = beta_star in 12.5.15 for incompressible flow
 

          extra_prod = 0.
          if(iflomach) extra_prod = twothird*div(i)
          G_k0= mu_t*g(i) - ( rho*k + mu_t*div(i) )*extra_prod
          G_k = min(G_k0, 10.*Y_k)

c g(i) is S**2 in equation sheet

          kSrc  (i,1,1,e) = G_k - Y_k

c Compute production of omega
          alpha = (alp_inf/alp_str)

c          G_w = alpha*alp_str*rho*G_k/mu_t !g(i)
          G_w0 = alpha*alp_str*rho*(g(i)-(omega+div(i))*extra_prod)

c Compute dissipation of omega
          beta = beta_0
c no compressibility correction M < 0.25

          x_w = abs((sum_xx)/(betainf_str*omega + tiny)**3)
          f_b = 1.0
          if(if3d) f_b = (1.0 + 70.0*x_w)/(1.0 + 80.0*x_w)

          Y_w = rho*beta*f_b * omega * omega

          G_w = min(G_w0, 10.0*Y_w)
          omgSrc(i,1,1,e) = G_w - Y_w

          mut  (i,1,1,e)   = mu_t
          mutsk(i,1,1,e)   = mu_t / sigma_k
          mutso(i,1,1,e)   = mu_t / sigma_omega
        enddo

c solve for omega_pert

c add mut*delsqf
        sigma_omega1 = 1.0/sigma_omega
        call copy   (mu_omeg,rhoalpk,lxyz)
        call cmult  (mu_omeg,sigma_omega1,lxyz)
        call col4   (extra_src_omega,mu_omeg ,omwom
     $                                ,delsqf_omegb(1,1,1,e),lxyz)

c add mu*delsqf
        call copy   (tempv,delsqf_omegb(1,1,1,e),lxyz)
        call cmult  (tempv,mu,lxyz)
        call col2   (tempv,f_omegb(1,1,1,e),lxyz)
        call add2   (extra_src_omega, tempv,lxyz)

c Form (1/sigma_w) del_mut * del_omw
c  form 1: (del_yw/yw) del_k
        call col3   (term1,dfdx_omegb(1,1,1,e),k_x,lxyz)
        call addcol3(term1,dfdy_omegb(1,1,1,e),k_y,lxyz)
        if(if3d)
     $  call addcol3(term1,dfdz_omegb(1,1,1,e),k_z,lxyz)

c  form 2: 2(omw/om) (del_omw/yw)^2
        expm = -expn
        call col3   (term2,omwom,delfsq_omegb(1,1,1,e),   lxyz)
        call col2   (term2           ,t(1,1,1,e,ifld_k-1),lxyz)
        call cmult  (term2,expm,lxyz)
        call add3   (tempv, term1, term2, lxyz)

c  form 3: -(omw/om) k (del_yw/yw) \del_omp/omw
        call col3   (term3     ,omwom,t(1,1,1,e,ifld_k-1),lxyz)
        call invcol2(term3     ,f_omegb(1,1,1,e)         ,lxyz)
        call col3   (term4,  dfdx_omegb(1,1,1,e),omp_x,   lxyz)
        call addcol3(term4,  dfdy_omegb(1,1,1,e),omp_y,   lxyz)
        if(if3d)
     $  call addcol3(term4,  dfdz_omegb(1,1,1,e),omp_z,   lxyz)
        call subcol3(tempv, term3, term4, lxyz)

        call addcol3(extra_src_omega, rhoalpfr, tempv,    lxyz)

c add rho v * del_omw
        call col3   (tempv,dfdx_omegb(1,1,1,e),VX(1,1,1,e),lxyz)
        call addcol3(tempv,dfdy_omegb(1,1,1,e),VY(1,1,1,e),lxyz)
        if(if3d)
     $  call addcol3(tempv,dfdz_omegb(1,1,1,e),VZ(1,1,1,e),lxyz)
        call col2   (tempv,vtrans(1,1,1,e,1),lxyz)
        call admcol3(extra_src_omega,tempv,f_omegb(1,1,1,e),expm,lxyz)

        call add2   (omgSrc(1,1,1,e), extra_src_omega           ,lxyz)

      enddo

      if(loglevel.gt.2) then
        nome_neg =iglsum(nome_neg,1)
        nkey_neg =iglsum(nkey_neg,1)
        xome_neg = glmin(xome_neg,1)
        xkey_neg = glmin(xkey_neg,1)

        if(nid.eq.0 .and. nome_neg.gt.0) 
     $    write(*,*) 'Neg Omega ', nome_neg, xome_neg
        if(nid.eq.0 .and. nkey_neg.gt.0) 
     $    write(*,*) 'Neg TKE   ', nkey_neg, xkey_neg
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine rans_komg_lowRe_compute
c
c     Compute RANS source terms and diffusivities on an 
c     element-by-element basis
c
      include 'SIZE'
      include 'TOTAL'
      include 'RANS_KOMG'

      parameter (lxyz=lx1*ly1*lz1)

      real           k_x(lxyz),k_y(lxyz),k_z(lxyz)
     $             , o_x(lxyz),o_y(lxyz),o_z(lxyz)
     $              ,omp_x(lxyz), omp_y(lxyz), omp_z(lxyz)

      real           tempv(lxyz), rhoalpk (lxyz)
     $              ,omwom(lxyz), rhoalpfr(lxyz)

      real           term1(lxyz), term2   (lxyz)
     $              ,term3(lxyz), term4   (lxyz)
     $              ,g    (lxyz), div     (lxyz)

      common /storesom/ St_mag2(lx1*ly1*lz1,lelv)
     $                , Om_mag2(lx1*ly1*lz1,lelv)
     $                , OiOjSk (lx1*ly1*lz1,lelv)
     $                , DivQ   (lx1*ly1*lz1,lelv)

      integer e
      real k,mu_t,nu_t,mu,nu, kv_min,omeg_max

      real mu_omeg(lxyz), mu_omegx(lxyz), mu_omegy(lxyz), mu_omegz(lxyz)
      real extra_src_omega(lxyz)

c Turbulent viscosity constants
        Pr_t         = coeffs( 1)
        sigma_k      = coeffs( 2)
        sigma_omega  = coeffs( 3)

c Low Reynolds number correction constants
        alpinf_str   = coeffs( 4)
        r_k          = coeffs( 5)
        beta_0       = coeffs( 6)
        alp0_str     = coeffs( 7)

c Dissipation of K constants
        betainf_str  = coeffs( 8)
        alp_inf      = coeffs( 9)
        r_b          = coeffs(10)
        akk          = coeffs(11)

c Production of omega constants
        alpha_0      = coeffs(12)
        r_w          = coeffs(13)

c Dissipation of omega constants
c         beta_0 = defined earlier	     

        kv_min       = coeffs(14)
        omeg_max     = coeffs(15)
        tiny         = coeffs(16)
c================================

      call comp_StOm (St_mag2, Om_mag2, OiOjSk, DivQ)

      nome_neg = 0
      nkey_neg = 0
      xome_neg = 0.
      xkey_neg = 0.

      do e=1,nelv

        call copy   (g,   St_mag2(1,e),       lxyz)
        call copy   (div, DivQ   (1,e),       lxyz)

        call gradm11(k_x,  k_y,  k_z,  t(1,1,1,1,ifld_k    -1),e)
        call gradm11(omp_x,omp_y,omp_z,t(1,1,1,1,ifld_omega-1),e)

c solve for omega_pert

c ---------------------
c        call check_omwall_behavior
c ---------------------
        do i=1,lxyz

          rho = param(1) ! vtrans(i,1,1,e,1)
          mu  = param(2) ! vdiff (i,1,1,e,1)
          nu  = mu/rho

c limits for k, omega

c solve for omega_pert
          omega   = t(i,1,1,e,ifld_omega-1) + f_omegb(i,1,1,e) ! Current k & omega values
          k       = t(i,1,1,e,ifld_k  -1)   ! from previous timestep

          iflim_omeg = 0 ! limit omega^{prime} 1 limit omega_total

          if    (iflim_omeg.eq.0) then
            if(t(i,1,1,e,ifld_omega-1).lt.0.0) then
c             write(*,*) 'Zero OMEG ', t(i,1,1,e,ifld_omega-1)
              xome_neg = min(xome_neg,t(i,1,1,e,ifld_omega-1))
              nome_neg = nome_neg + 1
c             write(*,*) 'Neg  OMEG ', nome_neg, xome_neg
              t(i,1,1,e,ifld_omega-1) =0.01*abs(t(i,1,1,e,ifld_omega-1))
              omega = t(i,1,1,e,ifld_omega-1) + f_omegb(i,1,1,e) ! Current k & omega values
            endif

            if(t(i,1,1,e,ifld_k-1).lt.0.0) then
c             write(*,*) 'Zero K    ', t(i,1,1,e,ifld_k-1)
              xkey_neg = min(xkey_neg,t(i,1,1,e,ifld_k-1))
              nkey_neg = nkey_neg + 1
c             write(*,*) 'Neg  KEY  ', nkey_neg, xkey_neg
              t(i,1,1,e,ifld_k-1) = 0.01*abs(t(i,1,1,e,ifld_k-1))
              k     = t(i,1,1,e,ifld_k  -1)   ! from previous timestep
            endif

          elseif(iflim_omeg.eq.1) then

            if(omega.lt.0.0) then
              write(*,*) 'OMEG tot is neg', omega
              omega = 0.01*abs(omega)
            endif

            if(k.lt.0.0) then
               write(*,*) 'K  is neg', k
               k = 0.01*abs(k)
            endif

          endif

          expn = -2.0 
          o_x(i)= omp_x(i)+expn * dfdx_omegb(i,1,1,e) *f_omegb(i,1,1,e)
          o_y(i)= omp_y(i)+expn * dfdy_omegb(i,1,1,e) *f_omegb(i,1,1,e)
          if(if3d) 
     $    o_z(i)= omp_z(i)+expn * dfdz_omegb(i,1,1,e) *f_omegb(i,1,1,e)
          omwom (i)= 1.0/(1.0+t(i,1,1,e,ifld_omega-1)/f_omegb(i,1,1,e))

c See equations from eqns_k_omega1.pdf from Eq. (3) onwards
c Eq.(1) and (2) in eqns_k_omega1.pdf are the governing equations
c no source terms Sk or S_w are added

          St_magn = sqrt(St_mag2(i,e))
          Om_magn = sqrt(Om_mag2(i,e))
          sum_xx  =      OiOjSk (i,e)

! calculate del k * del omega / omega

          if(if3d)then
            xk3= (k_x(i)*o_x(i) + k_y(i)*o_y(i) + k_z(i)*o_z(i))
     $                                         / (omega**3+tiny)
          else
            xk3= (k_x(i)*o_x(i) + k_y(i)*o_y(i))
     $                                         / (omega**3+tiny)
          endif

          re_t    = rho * k /(mu * omega + tiny) 
          alp_str = alpinf_str * (alp0_str + (re_t/r_k))
     $                                         / (1.+(re_t/r_k)) 
          mu_t    = rho * alp_str*k/(omega + tiny) ! should multiply these by rho!!!
          rhoalpk(i)= rho*alp_str*k

          rtld = re_t / r_k
          funcr = (1.0 - alp0_str) / (alp0_str + rtld)/(1.0 + rtld)
          factr = (1.0 + rtld * funcr)
          sigma_omega1 = 1.0/sigma_omega
          rhoalpfr(i) = expn * rho * alp_str * factr * omwom(i)
     $                                           * sigma_omega1

c nu_t is kinematic turbulent viscosity
c units of k = m2/s2, units of omega = 1/s, nu units = m2/s
c set limit for nu_t
c           nu_t    = max(tiny,nu_t)
c	    if(nu_t.gt.5000*mu)nu_t = 5000*mu

          betai_str = betainf_str * (akk + (re_t/r_b)**4)
     $              / (1.0 + (re_t/r_b)**4)


          if (xk3.le.0)then
            f_beta_str = 1.0
          else
            f_beta_str = (1.0 + 680.0*xk3*xk3)/(1.0 + 400.0*xk3*xk3)
          endif
          Y_k = rho * betai_str * f_beta_str * k * omega

c betai_str = beta_star in 12.5.15 for incompressible flow
 
          extra_prod = 0.
          if(iflomach) extra_prod = twothird*div(i)
          G_k0= mu_t*g(i) - ( rho*k + mu_t*div(i) )*extra_prod
          G_k = min(G_k0, 10.*Y_k)

c g(i) is S**2 in equation sheet

          kSrc  (i,1,1,e) = G_k - Y_k

c Compute production of omega
          alpha = (alp_inf/alp_str) * 
     $          ((alpha_0 + (re_t/r_w))/(1.0 + (re_t/r_w)))

c          G_w = alpha*alp_str*rho*G_k/mu_t !g(i)
          G_w0 = alpha*alp_str*rho*(g(i)-(omega+div(i))*extra_prod)

c Compute dissipation of omega
          beta = beta_0
c no compressibility correction M < 0.25

          x_w = abs((sum_xx)/(betainf_str*omega + tiny)**3)
          f_b = 1.0
          if(if3d) f_b = (1.0 + 70.0*x_w)/(1.0 + 80.0*x_w)

          Y_w = rho*beta*f_b * omega * omega

          G_w = min(G_w0, 10.0*Y_w)
          omgSrc(i,1,1,e) = G_w - Y_w

          mut  (i,1,1,e)   = mu_t
          mutsk(i,1,1,e)   = mu_t / sigma_k
          mutso(i,1,1,e)   = mu_t / sigma_omega
        enddo

c solve for omega_pert

c add mut*delsqf
        sigma_omega1 = 1.0/sigma_omega
        call copy   (mu_omeg,rhoalpk,lxyz)
        call cmult  (mu_omeg,sigma_omega1,lxyz)
        call col4   (extra_src_omega,mu_omeg ,omwom
     $                                ,delsqf_omegb(1,1,1,e),lxyz)

c add mu*delsqf
        call copy   (tempv,delsqf_omegb(1,1,1,e),lxyz)
        call cmult  (tempv,mu,lxyz)
        call col2   (tempv,f_omegb(1,1,1,e),lxyz)
        call add2   (extra_src_omega, tempv,lxyz)

c Form (1/sigma_w) del_mut * del_omw
c  form 1: (del_yw/yw) del_k
        call col3   (term1,dfdx_omegb(1,1,1,e),k_x,lxyz)
        call addcol3(term1,dfdy_omegb(1,1,1,e),k_y,lxyz)
        if(if3d)
     $  call addcol3(term1,dfdz_omegb(1,1,1,e),k_z,lxyz)

c  form 2: 2(omw/om) (del_omw/yw)^2
        expm = -expn
        call col3   (term2,omwom,delfsq_omegb(1,1,1,e),   lxyz)
        call col2   (term2           ,t(1,1,1,e,ifld_k-1),lxyz)
        call cmult  (term2,expm,lxyz)
        call add3   (tempv, term1, term2, lxyz)

c  form 3: -(omw/om) k (del_yw/yw) \del_omp/omw
        call col3   (term3     ,omwom,t(1,1,1,e,ifld_k-1),lxyz)
        call invcol2(term3     ,f_omegb(1,1,1,e)         ,lxyz)
        call col3   (term4,  dfdx_omegb(1,1,1,e),omp_x,   lxyz)
        call addcol3(term4,  dfdy_omegb(1,1,1,e),omp_y,   lxyz)
        if(if3d)
     $  call addcol3(term4,  dfdz_omegb(1,1,1,e),omp_z,   lxyz)
        call subcol3(tempv, term3, term4, lxyz)

        call addcol3(extra_src_omega, rhoalpfr, tempv,    lxyz)

c add rho v * del_omw
        call col3   (tempv,dfdx_omegb(1,1,1,e),VX(1,1,1,e),lxyz)
        call addcol3(tempv,dfdy_omegb(1,1,1,e),VY(1,1,1,e),lxyz)
        if(if3d)
     $  call addcol3(tempv,dfdz_omegb(1,1,1,e),VZ(1,1,1,e),lxyz)
        call col2   (tempv,vtrans(1,1,1,e,1),lxyz)
        call admcol3(extra_src_omega,tempv,f_omegb(1,1,1,e),expm,lxyz)

        call add2   (omgSrc(1,1,1,e), extra_src_omega           ,lxyz)

      enddo

      if(loglevel.gt.2) then
        nome_neg =iglsum(nome_neg,1)
        nkey_neg =iglsum(nkey_neg,1)
        xome_neg = glmin(xome_neg,1)
        xkey_neg = glmin(xkey_neg,1)

        if(nid.eq.0 .and. nome_neg.gt.0)
     $    write(*,*) 'Neg Omega ', nome_neg, xome_neg
        if(nid.eq.0 .and. nkey_neg.gt.0)
     $    write(*,*) 'Neg TKE   ', nkey_neg, xkey_neg
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine rans_komgSST_stndrd_compute
c
c     Compute RANS source terms and diffusivities on an 
c     element-by-element basis
c
      include 'SIZE'
      include 'TOTAL'
      include 'RANS_KOMG'

      parameter (lxyz=lx1*ly1*lz1)

      real           k_x(lxyz),k_y(lxyz),k_z(lxyz)
     $             , o_x(lxyz),o_y(lxyz),o_z(lxyz)
     $              ,omp_x(lxyz), omp_y(lxyz), omp_z(lxyz)

      real           tempv(lxyz), rhoalpk (lxyz)
     $              ,omwom(lxyz), rhoalpfr(lxyz)

      real           term1(lxyz), term2   (lxyz)
     $              ,term3(lxyz), term4   (lxyz)
     $              ,g    (lxyz), div     (lxyz)

      common /storesom/ St_mag2(lx1*ly1*lz1,lelv)
     $                , Om_mag2(lx1*ly1*lz1,lelv)
     $                , OiOjSk (lx1*ly1*lz1,lelv)
     $                , DivQ   (lx1*ly1*lz1,lelv)

      integer e
      real k,mu_t,nu_t,mu,nu, kv_min,omeg_max

      real mu_omeg(lxyz), mu_omegx(lxyz), mu_omegy(lxyz), mu_omegz(lxyz)
      real extra_src_omega(lxyz)

c====turbulence constants==========

c Turbulent viscosity constants
        Pr_t         = coeffs( 1)
        sigk1        = coeffs( 2)
        sigom1       = coeffs( 3)

c Low Reynolds number correction constants
        alpinf_str   = coeffs( 4)
        r_k          = coeffs( 5)
        beta1        = coeffs( 6)
        alp0_str     = coeffs( 7)

c Dissipation of K constants
        beta_str     = coeffs( 8)
        gamma1       = coeffs( 9)
        r_b          = coeffs(10)
        akk          = coeffs(11)

c Production of omega constants
        alpha_0      = coeffs(12)
        r_w          = coeffs(13)

c Dissipation of omega constants
c         beta_0 = defined earlier	     

        kv_min       = coeffs(14)
        omeg_max     = coeffs(15)
        tiny         = coeffs(16)

c additional SST and k and epsilon constants
        alp1         = coeffs(17)
        beta2        = coeffs(18)
        sigk2        = coeffs(19)
        sigom2       = coeffs(20)
        gamma2       = coeffs(21)
c================================

      call comp_StOm (St_mag2, Om_mag2, OiOjSk, DivQ)

      nome_neg = 0
      nkey_neg = 0
      xome_neg = 0.
      xkey_neg = 0.

      do e=1,nelv

        call copy   (g,   St_mag2(1,e),       lxyz)
        call copy   (div, DivQ   (1,e),       lxyz)

        call gradm11(k_x,  k_y,  k_z,  t(1,1,1,1,ifld_k    -1),e)
        call gradm11(omp_x,omp_y,omp_z,t(1,1,1,1,ifld_omega-1),e)

c solve for omega_pert

c ---------------------
c        call check_omwall_behavior
c ---------------------
        do i=1,lxyz

          rho = param(1) ! vtrans(i,1,1,e,1)
          mu  = param(2) ! vdiff (i,1,1,e,1)
          nu  = mu/rho

c limits for k, omega

c solve for omega_pert
          omega   = t(i,1,1,e,ifld_omega-1) + f_omegb(i,1,1,e) ! Current k & omega values
          k       = t(i,1,1,e,ifld_k  -1)   ! from previous timestep

          iflim_omeg = 0 ! limit omega^{prime} 1 limit omega_total

          if    (iflim_omeg.eq.0) then
            if(t(i,1,1,e,ifld_omega-1).lt.0.0) then
c             write(*,*) 'Zero OMEG ', t(i,1,1,e,ifld_omega-1)
              xome_neg = min(xome_neg,t(i,1,1,e,ifld_omega-1))
              nome_neg = nome_neg + 1
c             write(*,*) 'Neg  OMEG ', nome_neg, xome_neg
              t(i,1,1,e,ifld_omega-1) =0.01*abs(t(i,1,1,e,ifld_omega-1))
              omega = t(i,1,1,e,ifld_omega-1) + f_omegb(i,1,1,e) ! Current k & omega values
            endif

            if(t(i,1,1,e,ifld_k-1).lt.0.0) then
c             write(*,*) 'Zero K    ', t(i,1,1,e,ifld_k-1)
              xkey_neg = min(xkey_neg,t(i,1,1,e,ifld_k-1))
              nkey_neg = nkey_neg + 1
c             write(*,*) 'Neg  KEY  ', nkey_neg, xkey_neg
              t(i,1,1,e,ifld_k-1) = 0.01*abs(t(i,1,1,e,ifld_k-1))
              k     = t(i,1,1,e,ifld_k  -1)   ! from previous timestep
            endif

          elseif(iflim_omeg.eq.1) then

            if(omega.lt.0.0) then
              write(*,*) 'OMEG tot is neg', omega
              omega = 0.01*abs(omega)
            endif

            if(k.lt.0.0) then
               write(*,*) 'K  is neg', k
               k = 0.01*abs(k)
            endif

          endif

          expn = -2.0 
          o_x(i)= omp_x(i)+expn * dfdx_omegb(i,1,1,e) *f_omegb(i,1,1,e)
          o_y(i)= omp_y(i)+expn * dfdy_omegb(i,1,1,e) *f_omegb(i,1,1,e)
          if(if3d) 
     $    o_z(i)= omp_z(i)+expn * dfdz_omegb(i,1,1,e) *f_omegb(i,1,1,e)
          omwom (i)= 1.0/(1.0+t(i,1,1,e,ifld_omega-1) /f_omegb(i,1,1,e))

c See equations from eqns_k_omega1.pdf from Eq. (3) onwards
c Eq.(1) and (2) in eqns_k_omega1.pdf are the governing equations
c no source terms Sk or S_w are added
c ----------

          St_magn = sqrt(St_mag2(i,e))
          Om_magn = sqrt(Om_mag2(i,e))

! calculate del k * del omega / omega

          if(if3d)then
            xk = (k_x(i)*o_x(i) + k_y(i)*o_y(i) + k_z(i)*o_z(i))
     $                                            / (omega+tiny)
          else
            xk = (k_x(i)*o_x(i) + k_y(i)*o_y(i))
     $                                            / (omega+tiny)
          endif

          rhoalpk(i)= rho*k
          rhoalpfr(i) = expn * rho * omwom(i) * sigom1

! calculate F2 based on arg2

          yw   = ywd  (i,1,1,e)
          ywm1 = ywdm1(i,1,1,e)
          ywm2 = ywm1*ywm1
          arg2_1 =      sqrt(abs(k)) * ywm1 / omega / beta_str
          arg2_2 =          500.0*nu * ywm2 / omega
          arg2   = max(2.0*arg2_1, arg2_2)
          Fun2   = tanh(arg2 * arg2)

! calculate F1 based on arg1

          argCD  =     2.0 * rho * sigom2 * xk
          CDkom  = max(argCD, 1.0e-10)
          arg1_1 = max(    arg2_1, arg2_2)
          arg1_2 =     4.0 * rho * sigom2 * k * ywm2 / CDkom
          arg1   = min(    arg1_1, arg1_2)
          Fun1   = tanh(arg1 * arg1 * arg1 * arg1)

! calculate mu_t 
          argn_1 = alp1*(omega + tiny)
          argn_2 = Fun2*St_magn ! this can also be Om_magn

          mu_t = 0.0
          denom = max(argn_1, argn_2)
          if(yw.ne.0) mu_t = rho * alp1 * k / denom 

! Compute Y_k = dissipation of k

          Y_k = rho * beta_str * k * omega

! Compute G_k = production of  k and limit it to 10*Y_k (the dissipation of k)

          extra_prod = 0.
          if(iflomach) extra_prod = twothird*div(i)
          G_k0= mu_t*g(i) - ( rho*k + mu_t*div(i) )*extra_prod
          G_k = min(G_k0, 10.*Y_k)

! Compute Source term for k 

          kSrc  (i,1,1,e) = G_k - Y_k

c Compute production of omega

          beta  = Fun1 * beta1  + (1.0 - Fun1) * beta2
          gamma = Fun1 * gamma1 + (1.0 - Fun1) * gamma2
          sigk  = Fun1 * sigk1  + (1.0 - Fun1) * sigk2
          sigom = Fun1 * sigom1 + (1.0 - Fun1) * sigom2

! Compute production of omega

          G_w0= rho * gamma * (g(i)-(div(i)+denom/alp1)*extra_prod)

! Compute dissipation of omega
 
          Y_w = rho * beta * omega * omega

          G_w = min(G_w0, 10.0*Y_w)

! Compute additional SST term for omega

          S_w = (1.0 - Fun1) * argCD

! Compute Source term for omega

          omgSrc(i,1,1,e) = G_w - Y_w + S_w
          mut  (i,1,1,e)   = mu_t
          mutsk(i,1,1,e)   = mu_t * sigk
          mutso(i,1,1,e)   = mu_t * sigom

        enddo

c solve for omega_pert

c add mut*delsqf
        call copy   (mu_omeg,rhoalpk,lxyz)
        call cmult  (mu_omeg,sigom1, lxyz)
        call col4   (extra_src_omega,mu_omeg ,omwom
     $                                ,delsqf_omegb(1,1,1,e),lxyz)

c add mu*delsqf
        call copy   (tempv,delsqf_omegb(1,1,1,e),lxyz)
        call cmult  (tempv,mu,lxyz)
        call col2   (tempv,f_omegb(1,1,1,e),lxyz)
        call add2   (extra_src_omega, tempv,lxyz)

c Form (1/sigma_w) del_mut * del_omw
c  form 1: (del_yw/yw) del_k
        call col3   (term1,dfdx_omegb(1,1,1,e),k_x,lxyz)
        call addcol3(term1,dfdy_omegb(1,1,1,e),k_y,lxyz)
        if(if3d)
     $  call addcol3(term1,dfdz_omegb(1,1,1,e),k_z,lxyz)

c  form 2: 2(omw/om) (del_omw/yw)^2
        expm = -expn
        call col3   (term2,omwom,delfsq_omegb(1,1,1,e),   lxyz)
        call col2   (term2           ,t(1,1,1,e,ifld_k-1),lxyz)
        call cmult  (term2,expm,lxyz)
        call add3   (tempv, term1, term2, lxyz)

c  form 3: -(omw/om) k (del_yw/yw) \del_omp/omw
        call col3   (term3     ,omwom,t(1,1,1,e,ifld_k-1),lxyz)
        call invcol2(term3     ,f_omegb(1,1,1,e)         ,lxyz)
        call col3   (term4,  dfdx_omegb(1,1,1,e),omp_x,   lxyz)
        call addcol3(term4,  dfdy_omegb(1,1,1,e),omp_y,   lxyz)
        if(if3d)
     $  call addcol3(term4,  dfdz_omegb(1,1,1,e),omp_z,   lxyz)
        call subcol3(tempv, term3, term4, lxyz)

        call addcol3(extra_src_omega, rhoalpfr, tempv,    lxyz)

c add rho v * del_omw
        call col3   (tempv,dfdx_omegb(1,1,1,e),VX(1,1,1,e),lxyz)
        call addcol3(tempv,dfdy_omegb(1,1,1,e),VY(1,1,1,e),lxyz)
        if(if3d)
     $  call addcol3(tempv,dfdz_omegb(1,1,1,e),VZ(1,1,1,e),lxyz)
        call col2   (tempv,vtrans(1,1,1,e,1),lxyz)
        call admcol3(extra_src_omega,tempv,f_omegb(1,1,1,e),expm,lxyz)

        call add2   (omgSrc(1,1,1,e), extra_src_omega           ,lxyz)

      enddo

      if(loglevel.gt.2) then
        nome_neg =iglsum(nome_neg,1)
        nkey_neg =iglsum(nkey_neg,1)
        xome_neg = glmin(xome_neg,1)
        xkey_neg = glmin(xkey_neg,1)

        if(nid.eq.0 .and. nome_neg.gt.0)
     $    write(*,*) 'Neg Omega ', nome_neg, xome_neg
        if(nid.eq.0 .and. nkey_neg.gt.0)
     $    write(*,*) 'Neg TKE   ', nkey_neg, xkey_neg
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine rans_komgSST_lowRe_compute
c
c     Compute RANS source terms and diffusivities on an 
c     element-by-element basis
c
      include 'SIZE'
      include 'TOTAL'
      include 'RANS_KOMG'

      parameter (lxyz=lx1*ly1*lz1)

      real           k_x(lxyz),k_y(lxyz),k_z(lxyz)
     $             , o_x(lxyz),o_y(lxyz),o_z(lxyz)
     $              ,omp_x(lxyz), omp_y(lxyz), omp_z(lxyz)

      real           tempv(lxyz), rhoalpk (lxyz)
     $              ,omwom(lxyz), rhoalpfr(lxyz)

      real           term1(lxyz), term2   (lxyz)
     $              ,term3(lxyz), term4   (lxyz)
     $              ,g    (lxyz), div     (lxyz)

      common /storesom/ St_mag2(lx1*ly1*lz1,lelv)
     $                , Om_mag2(lx1*ly1*lz1,lelv)
     $                , OiOjSk (lx1*ly1*lz1,lelv)
     $                , DivQ   (lx1*ly1*lz1,lelv)

      integer e
      real k,mu_t,nu_t,mu,nu, kv_min,omeg_max

      real mu_omeg(lxyz), mu_omegx(lxyz), mu_omegy(lxyz), mu_omegz(lxyz)
      real extra_src_omega(lxyz)

c====turbulence constants==========

c Turbulent viscosity constants
        Pr_t         = coeffs( 1)
        sigk1        = coeffs( 2)
        sigom1       = coeffs( 3)

c Low Reynolds number correction constants
        alpinf_str   = coeffs( 4)
        r_k          = coeffs( 5)
        beta1        = coeffs( 6)
        alp0_str     = coeffs( 7)

c Dissipation of K constants
        beta_str     = coeffs( 8)
        alp_inf      = coeffs( 9)
        r_b          = coeffs(10)
        akk          = coeffs(11)

c Production of omega constants
        alpha_0      = coeffs(12)
        r_w          = coeffs(13)

c Dissipation of omega constants
c         beta_0 = defined earlier	     

        kv_min       = coeffs(14)
        omeg_max     = coeffs(15)
        tiny         = coeffs(16)

c additional SST and k and epsilon constants
        alp1         = coeffs(17)
        beta2        = coeffs(18)
        sigk2        = coeffs(19)
        sigom2       = coeffs(20)
        gamma2       = coeffs(21)
c================================

      call comp_StOm (St_mag2, Om_mag2, OiOjSk, DivQ)

      nome_neg = 0
      nkey_neg = 0
      xome_neg = 0.
      xkey_neg = 0.

      do e=1,nelv

        call copy   (g,   St_mag2(1,e),       lxyz)
        call copy   (div, DivQ   (1,e),       lxyz)

        call gradm11(k_x,  k_y,  k_z,  t(1,1,1,1,ifld_k    -1),e)
        call gradm11(omp_x,omp_y,omp_z,t(1,1,1,1,ifld_omega-1),e)

c solve for omega_pert

c ---------------------
c        call check_omwall_behavior
c ---------------------
        do i=1,lxyz

          rho = param(1) ! vtrans(i,1,1,e,1)
          mu  = param(2) ! vdiff (i,1,1,e,1)
          nu  = mu/rho

c limits for k, omega

c solve for omega_pert
          omega   = t(i,1,1,e,ifld_omega-1) + f_omegb(i,1,1,e) ! Current k & omega values
          k       = t(i,1,1,e,ifld_k  -1)   ! from previous timestep

          iflim_omeg = 0 ! limit omega^{prime} 1 limit omega_total

          if    (iflim_omeg.eq.0) then
            if(t(i,1,1,e,ifld_omega-1).lt.0.0) then
c             write(*,*) 'Zero OMEG ', t(i,1,1,e,ifld_omega-1)
              xome_neg = min(xome_neg,t(i,1,1,e,ifld_omega-1))
              nome_neg = nome_neg + 1
c             write(*,*) 'Neg  OMEG ', nome_neg, xome_neg
              t(i,1,1,e,ifld_omega-1) =0.01*abs(t(i,1,1,e,ifld_omega-1))
              omega = t(i,1,1,e,ifld_omega-1) + f_omegb(i,1,1,e) ! Current k & omega values
            endif

            if(t(i,1,1,e,ifld_k-1).lt.0.0) then
c             write(*,*) 'Zero K    ', t(i,1,1,e,ifld_k-1)
              xkey_neg = min(xkey_neg,t(i,1,1,e,ifld_k-1))
              nkey_neg = nkey_neg + 1
c             write(*,*) 'Neg  KEY  ', nkey_neg, xkey_neg
              t(i,1,1,e,ifld_k-1) = 0.01*abs(t(i,1,1,e,ifld_k-1))
              k     = t(i,1,1,e,ifld_k  -1)   ! from previous timestep
            endif

          elseif(iflim_omeg.eq.1) then

            if(omega.lt.0.0) then
              write(*,*) 'OMEG tot is neg', omega
              omega = 0.01*abs(omega)
            endif

            if(k.lt.0.0) then
               write(*,*) 'K  is neg', k
               k = 0.01*abs(k)
            endif

          endif

          expn = -2.0 
          o_x(i)= omp_x(i)+expn * dfdx_omegb(i,1,1,e) *f_omegb(i,1,1,e)
          o_y(i)= omp_y(i)+expn * dfdy_omegb(i,1,1,e) *f_omegb(i,1,1,e)
          if(if3d) 
     $    o_z(i)= omp_z(i)+expn * dfdz_omegb(i,1,1,e) *f_omegb(i,1,1,e)
          omwom (i)= 1.0/(1.0+t(i,1,1,e,ifld_omega-1)/f_omegb(i,1,1,e))

c See equations from eqns_k_omega1.pdf from Eq. (3) onwards
c Eq.(1) and (2) in eqns_k_omega1.pdf are the governing equations
c no source terms Sk or S_w are added
c ----------

          St_magn = sqrt(St_mag2(i,e))
          Om_magn = sqrt(Om_mag2(i,e))
          sum_xx  =      OiOjSk (i,e)

! calculate del k * del omega / omega

          if(if3d)then
            xk = (k_x(i)*o_x(i) + k_y(i)*o_y(i) + k_z(i)*o_z(i))
     $                                            / (omega+tiny)
            xk3= (k_x(i)*o_x(i) + k_y(i)*o_y(i) + k_z(i)*o_z(i))
     $                                         / (omega**3+tiny)
          else
            xk = (k_x(i)*o_x(i) + k_y(i)*o_y(i))
     $                                            / (omega+tiny)
            xk3= (k_x(i)*o_x(i) + k_y(i)*o_y(i))
     $                                         / (omega**3+tiny)
          endif

c ------------ begin low Re part of k-omega -------------------

          re_t    = rho * k /(mu * omega + tiny) 
          alp_str = alpinf_str * (alp0_str + (re_t/r_k))
     $                                         / (1.+(re_t/r_k)) 
          rhoalpk(i)= rho*alp_str*k

          rtld = re_t / r_k
          funcr = (1.0 - alp0_str) / (alp0_str + rtld)/(1.0 + rtld)
          factr = (1.0 + rtld * funcr)
          rhoalpfr(i) = expn * rho * alp_str * factr * omwom(i) * sigom1

c nu_t is kinematic turbulent viscosity
c units of k = m2/s2, units of omega = 1/s, nu units = m2/s
c set limit for nu_t
c           nu_t    = max(tiny,nu_t)
c	    if(nu_t.gt.5000*mu)nu_t = 5000*mu

          betai_str = beta_str * (akk + (re_t/r_b)**4)
     $              / (1.0 + (re_t/r_b)**4)

          if (xk3.le.0)then
            f_beta_str = 1.0
          else
            f_beta_str = (1.0 + 680.0*xk3*xk3)/(1.0 + 400.0*xk3*xk3)
          endif

c Compute production of omega
          alpha = (alp_inf/alp_str) *
     $          ((alpha_0 + (re_t/r_w))/(1.0 + (re_t/r_w)))

          gammai = alpha*alp_str

c Compute dissipation of omega

          x_w = abs((sum_xx)/(beta_str*omega + tiny)**3)
          f_b = 1.0
          if(if3d) f_b = (1.0 + 70.0*x_w)/(1.0 + 80.0*x_w)
          betai= beta1 * f_b

c ------------ end   low Re part of k-omega -------------------

! calculate F2 based on arg2

          yw   = ywd  (i,1,1,e)
          ywm1 = ywdm1(i,1,1,e)
          ywm2 = ywm1*ywm1
          arg2_1 =      sqrt(abs(k)) * ywm1 / omega / beta_str
          arg2_2 =          500.0*nu * ywm2 / omega
          arg2   = max(2.0*arg2_1, arg2_2)
          Fun2   = tanh(arg2 * arg2)

! calculate F1 based on arg1

          argCD  =     2.0 * rho * sigom2 * xk
          CDkom  = max(argCD, 1.0e-10)
          arg1_1 = max(    arg2_1, arg2_2)
          arg1_2 =     4.0 * rho * sigom2 * k * ywm2 / CDkom
          arg1   = min(    arg1_1, arg1_2)
          Fun1   = tanh(arg1 * arg1 * arg1 * arg1)

! calculate mu_t 
          argn_1 = alp1*(omega + tiny) / alp_str
          argn_2 = Fun2*St_magn ! this can also be St_magn

          mu_t = 0.0
          denom = max(argn_1, argn_2)
          if(yw.ne.0) mu_t = rho * alp1 * k / denom 

! Compute Y_k = dissipation of k

c          Y_k = rho * beta_str * k * omega
          Y_k = rho * betai_str * f_beta_str * k * omega

! Compute G_k = production of  k and limit it to 10*Y_k (the dissipation of k)

          extra_prod = 0.
          if(iflomach) extra_prod = twothird*div(i)
          G_k0= mu_t*g(i) - ( rho*k + mu_t*div(i) )*extra_prod
          G_k = min(G_k0, 10.*Y_k)

! Compute Source term for k 

          kSrc  (i,1,1,e) = G_k - Y_k

c Compute production of omega

          beta  = Fun1 * betai  + (1.0 - Fun1) * beta2
          gamma = Fun1 * gammai + (1.0 - Fun1) * gamma2
          sigk  = Fun1 * sigk1  + (1.0 - Fun1) * sigk2
          sigom = Fun1 * sigom1 + (1.0 - Fun1) * sigom2

! Compute production of omega

          G_w0= rho * gamma * (g(i)-(div(i)+denom/alp1)*extra_prod)

! Compute dissipation of omega

          Y_w = rho * beta * omega * omega

          G_w = min(G_w0, 10.0*Y_w)

! Compute additional SST term for omega

          S_w = (1.0 - Fun1) * argCD

! Compute Source term for omega

          omgSrc(i,1,1,e) = G_w - Y_w + S_w
          mut  (i,1,1,e)   = mu_t
          mutsk(i,1,1,e)   = mu_t * sigk
          mutso(i,1,1,e)   = mu_t * sigom

        enddo

c solve for omega_pert

c add mut*delsqf
        call copy   (mu_omeg,rhoalpk,lxyz)
        call cmult  (mu_omeg,sigom1, lxyz)
        call col4   (extra_src_omega,mu_omeg ,omwom
     $                                ,delsqf_omegb(1,1,1,e),lxyz)

c add mu*delsqf
        call copy   (tempv,delsqf_omegb(1,1,1,e),lxyz)
        call cmult  (tempv,mu,lxyz)
        call col2   (tempv,f_omegb(1,1,1,e),lxyz)
        call add2   (extra_src_omega, tempv,lxyz)

c Form (1/sigma_w) del_mut * del_omw
c  form 1: (del_yw/yw) del_k
        call col3   (term1,dfdx_omegb(1,1,1,e),k_x,lxyz)
        call addcol3(term1,dfdy_omegb(1,1,1,e),k_y,lxyz)
        if(if3d)
     $  call addcol3(term1,dfdz_omegb(1,1,1,e),k_z,lxyz)

c  form 2: 2(omw/om) (del_omw/yw)^2
        expm = -expn
        call col3   (term2,omwom,delfsq_omegb(1,1,1,e),   lxyz)
        call col2   (term2           ,t(1,1,1,e,ifld_k-1),lxyz)
        call cmult  (term2,expm,lxyz)
        call add3   (tempv, term1, term2, lxyz)

c  form 3: -(omw/om) k (del_yw/yw) \del_omp/omw
        call col3   (term3     ,omwom,t(1,1,1,e,ifld_k-1),lxyz)
        call invcol2(term3     ,f_omegb(1,1,1,e)         ,lxyz)
        call col3   (term4,  dfdx_omegb(1,1,1,e),omp_x,   lxyz)
        call addcol3(term4,  dfdy_omegb(1,1,1,e),omp_y,   lxyz)
        if(if3d)
     $  call addcol3(term4,  dfdz_omegb(1,1,1,e),omp_z,   lxyz)
        call subcol3(tempv, term3, term4, lxyz)

        call addcol3(extra_src_omega, rhoalpfr, tempv,    lxyz)

c add rho v * del_omw
        call col3   (tempv,dfdx_omegb(1,1,1,e),VX(1,1,1,e),lxyz)
        call addcol3(tempv,dfdy_omegb(1,1,1,e),VY(1,1,1,e),lxyz)
        if(if3d)
     $  call addcol3(tempv,dfdz_omegb(1,1,1,e),VZ(1,1,1,e),lxyz)
        call col2   (tempv,vtrans(1,1,1,e,1),lxyz)
        call admcol3(extra_src_omega,tempv,f_omegb(1,1,1,e),expm,lxyz)

        call add2   (omgSrc(1,1,1,e), extra_src_omega           ,lxyz)

      enddo

      if(loglevel.gt.2) then
        nome_neg =iglsum(nome_neg,1)
        nkey_neg =iglsum(nkey_neg,1)
        xome_neg = glmin(xome_neg,1)
        xkey_neg = glmin(xkey_neg,1)

        if(nid.eq.0 .and. nome_neg.gt.0)
     $    write(*,*) 'Neg Omega ', nome_neg, xome_neg
        if(nid.eq.0 .and. nkey_neg.gt.0)
     $    write(*,*) 'Neg TKE   ', nkey_neg, xkey_neg
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine rans_komg_stndrd_compute_noreg
c
c     Compute RANS source terms and diffusivities on an 
c     element-by-element basis
c
      include 'SIZE'
      include 'TOTAL'
      include 'RANS_KOMG'

      parameter (lxyz=lx1*ly1*lz1)

      real           k_x(lxyz),k_y(lxyz),k_z(lxyz)
     $             , o_x(lxyz),o_y(lxyz),o_z(lxyz)
     $              ,omp_x(lxyz), omp_y(lxyz), omp_z(lxyz)

      real           tempv(lxyz), rhoalpk (lxyz)
     $              ,omwom(lxyz), rhoalpfr(lxyz)

      real           term1(lxyz), term2   (lxyz)
     $              ,term3(lxyz), term4   (lxyz)
     $              ,g    (lxyz), div     (lxyz)

      common /storesom/ St_mag2(lx1*ly1*lz1,lelv)
     $                , Om_mag2(lx1*ly1*lz1,lelv)
     $                , OiOjSk (lx1*ly1*lz1,lelv)
     $                , DivQ   (lx1*ly1*lz1,lelv)

      integer e
      real k,mu_t,nu_t,mu,nu, kv_min,omeg_max

      real mu_omeg(lxyz), mu_omegx(lxyz), mu_omegy(lxyz), mu_omegz(lxyz)
      real extra_src_omega(lxyz)

c Turbulent viscosity constants
        Pr_t         = coeffs( 1)
        sigma_k      = coeffs( 2)
        sigma_omega  = coeffs( 3)

c Low Reynolds number correction constants
        alpinf_str   = coeffs( 4)
        r_k          = coeffs( 5)
        beta_0       = coeffs( 6)
        alp0_str     = coeffs( 7)

c Dissipation of K constants
        betainf_str  = coeffs( 8)
        alp_inf      = coeffs( 9)
        r_b          = coeffs(10)
        akk          = coeffs(11)

c Production of omega constants
        alpha_0      = coeffs(12)
        r_w          = coeffs(13)

c Dissipation of omega constants
c         beta_0 = defined earlier	     

        kv_min       = coeffs(14)
        omeg_max     = coeffs(15)
        tiny         = coeffs(16)
c================================

      call comp_StOm (St_mag2, Om_mag2, OiOjSk, DivQ)

      nome_neg = 0
      nkey_neg = 0
      xome_neg = 0.
      xkey_neg = 0.

      do e=1,nelv

        call copy   (g,   St_mag2(1,e),       lxyz)
        call copy   (div, DivQ   (1,e),       lxyz)
c        call rzero  (div,                     lxyz)

        call gradm11(k_x,  k_y,  k_z,  t(1,1,1,1,ifld_k    -1),e)
        call gradm11(omp_x,omp_y,omp_z,t(1,1,1,1,ifld_omega-1),e)

c solve for omega_pert

c ---------------------
c        call check_omwall_behavior
c ---------------------
        do i=1,lxyz

          rho = param(1) ! vtrans(i,1,1,e,1)
          mu  = param(2) ! vdiff (i,1,1,e,1)
          nu  = mu/rho

c limits for k, omega

c solve for omega_pert
          omega   = t(i,1,1,e,ifld_omega-1) ! Current k & omega values
          k       = t(i,1,1,e,ifld_k  -1)   ! from previous timestep

          iflim_omeg = 0 ! limit omega^{prime} 1 limit omega_total

          if    (iflim_omeg.eq.0) then
            if(t(i,1,1,e,ifld_omega-1).lt.0.0) then
c             write(*,*) 'Zero OMEG ', t(i,1,1,e,ifld_omega-1)
              xome_neg = min(xome_neg,t(i,1,1,e,ifld_omega-1))
              nome_neg = nome_neg + 1
c             write(*,*) 'Neg  OMEG ', nome_neg, xome_neg
              t(i,1,1,e,ifld_omega-1) =0.01*abs(t(i,1,1,e,ifld_omega-1))
              omega = t(i,1,1,e,ifld_omega-1) ! Current k & omega values
            endif

            if(t(i,1,1,e,ifld_k-1).lt.0.0) then
c             write(*,*) 'Zero K    ', t(i,1,1,e,ifld_k-1)
              xkey_neg = min(xkey_neg,t(i,1,1,e,ifld_k-1))
              nkey_neg = nkey_neg + 1
c             write(*,*) 'Neg  KEY  ', nkey_neg, xkey_neg
              t(i,1,1,e,ifld_k-1) = 0.01*abs(t(i,1,1,e,ifld_k-1))
              k     = t(i,1,1,e,ifld_k  -1)   ! from previous timestep
            endif

          elseif(iflim_omeg.eq.1) then

            if(omega.lt.0.0) then
              write(*,*) 'OMEG tot is neg', omega
              omega = 0.01*abs(omega)
            endif

            if(k.lt.0.0) then
               write(*,*) 'K  is neg', k
               k = 0.01*abs(k)
            endif

          endif

          expn = -2.0 
          o_x(i)= omp_x(i)
          o_y(i)= omp_y(i)
          if(if3d) 
     $    o_z(i)= omp_z(i)

c See equations from eqns_k_omega1.pdf from Eq. (3) onwards
c Eq.(1) and (2) in eqns_k_omega1.pdf are the governing equations
c no source terms Sk or S_w are added

          if(St_mag2(i,e).lt.0.) write(*,*) '  St_mag2', i, e, St_mag2
          if(Om_mag2(i,e).lt.0.) write(*,*) '  Om_mag2', i, e, Om_mag2
          St_magn = sqrt(St_mag2(i,e))
          Om_magn = sqrt(Om_mag2(i,e))
          sum_xx  =      OiOjSk (i,e)
c         if(sum_xx .ne.0.) write(*,*) '  sum_xx ', i, e, sum_xx

! calculate del k * del omega / omega

          if(if3d)then
            xk3= (k_x(i)*o_x(i) + k_y(i)*o_y(i) + k_z(i)*o_z(i))
     $                                         / (omega**3+tiny)
          else
            xk3= (k_x(i)*o_x(i) + k_y(i)*o_y(i))
     $                                         / (omega**3+tiny)
          endif

          alp_str = alpinf_str 
          mu_t    = rho * alp_str*k/(omega + tiny) ! should multiply these by rho!!!

c nu_t is kinematic turbulent viscosity
c units of k = m2/s2, units of omega = 1/s, nu units = m2/s
c set limit for nu_t
c           nu_t    = max(tiny,nu_t)
c	    if(nu_t.gt.5000*mu)nu_t = 5000*mu

          betai_str = betainf_str

          if (xk3.le.0)then
            f_beta_str = 1.0
          else
            f_beta_str = (1.0 + 680.0*xk3*xk3)/(1.0 + 400.0*xk3*xk3)
          endif
          Y_k = rho * betai_str * f_beta_str * k * omega
 
c betai_str = beta_star in 12.5.15 for incompressible flow
 
          extra_prod = 0.
          if(iflomach) extra_prod = twothird*div(i)
          G_k0= mu_t*g(i) - ( rho*k + mu_t*div(i) )*extra_prod
          G_k = min(G_k0, 10.*Y_k)

c g(i) is S**2 in equation sheet

          kSrc  (i,1,1,e) = G_k - Y_k

c Compute production of omega
          alpha = (alp_inf/alp_str)

c          G_w0 = alpha*alp_str*rho*g(i)
          G_w0 = alpha*alp_str*rho*(g(i)-(omega+div(i))*extra_prod)

c Compute dissipation of omega
          beta = beta_0
c no compressibility correction M < 0.25

          x_w = abs((sum_xx)/(betainf_str*omega + tiny)**3)
          f_b = 1.0
          if(if3d) f_b = (1.0 + 70.0*x_w)/(1.0 + 80.0*x_w)

          Y_w = rho*beta*f_b * omega * omega

          G_w = min(G_w0, 10.0*Y_w)
          omgSrc(i,1,1,e) = G_w - Y_w

          mut  (i,1,1,e)   = mu_t
          mutsk(i,1,1,e)   = mu_t / sigma_k
          mutso(i,1,1,e)   = mu_t / sigma_omega
        enddo

      enddo

      if(loglevel.gt.2) then
        nome_neg =iglsum(nome_neg,1)
        nkey_neg =iglsum(nkey_neg,1)
        xome_neg = glmin(xome_neg,1)
        xkey_neg = glmin(xkey_neg,1)

        if(nid.eq.0 .and. nome_neg.gt.0)
     $    write(*,*) 'Neg Omega ', nome_neg, xome_neg
        if(nid.eq.0 .and. nkey_neg.gt.0)
     $    write(*,*) 'Neg TKE   ', nkey_neg, xkey_neg
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine rans_komg_init(ifld_k_in,ifld_omega_in,ifcoeffs
     $                       ,coeffs_in,wall_id,ywd_in,model_id)
c
c     Initialize values ifld_omega & ifld_k for RANS k-omega turbulence
c     modeling
c
      include 'SIZE'
      include 'TOTAL'
      include 'RANS_KOMG'

      real w1,w2,w3,w4,w5
      common /SCRNS/
     & w1(lx1*ly1*lz1*lelv)
     &,w2(lx1*ly1*lz1*lelv)
     &,w3(lx1*ly1*lz1*lelv)
     &,w4(lx1*ly1*lz1*lelv)
     &,w5(lx1*ly1*lz1*lelv)

      integer n,wall_id,ifld_mx
      real coeffs_in(1),ywd_in(1)
      logical ifcoeffs

      character*3 bcw
      character*36 mname(6)

      data mname
     &/'regularized standard k-omega        '
     &,'regularized low-Re k-omega          '
     &,'regularized standard k-omega SST    '
     &,'regularized low-Re k-omega SST      '
     &,'non-regularized standard k-omega    '
     &,'non-regularized standard k-omega SST'/

      n=nx1*ny1*nz1*nelv

      if(nid.eq.0) write(6,*) 'init RANS model'

      if(iflomach) then
        if(nid.eq.0) write(6,*)
     &          "ERROR: K-OMEGA NOT SUPPORTED WITH LOW MACH FORMULATION"
        call exitt
      endif

      ifrans_komg_stndrd       = .FALSE.
      ifrans_komg_lowRe        = .FALSE.
      ifrans_komgSST_stndrd    = .FALSE.
      ifrans_komgSST_lowRe     = .FALSE.
      ifrans_komg_stndrd_noreg = .FALSE.
      if(model_id .eq.0) ifrans_komg_stndrd          = .TRUE.
      if(model_id .eq.1) ifrans_komg_lowRe           = .TRUE.
      if(model_id .eq.2) ifrans_komgSST_stndrd       = .TRUE.
      if(model_id .eq.3) ifrans_komgSST_lowRe        = .TRUE.
      if(model_id .eq.4) ifrans_komg_stndrd_noreg    = .TRUE.

      if(nid.eq.0) write(*,'(a,a)') 
     &                      '  model: ',mname(model_id+1)
      ifld_k     = ifld_k_in
      ifld_omega = ifld_omega_in
      ifld_mx=max(ifld_k,ifld_omega)
      if (ifld_mx.gt.ldimt1) 
     $  call exitti('nflds gt ldimt+1, recompile with ldimt > ',
     $  ifld_mx+1)

! specify k-omega model coefficients

c      if(ncoeffs_in.lt.ncoeffs) 
c     $  call exitti('dim of user provided komg coeffs array 
c     $               should be >=$',ncoeffs)

      if(ifcoeffs) then
         do i=1,ncoeffs
            coeffs(i) =coeffs_in(i)
         enddo
      else
         if(ifrans_komg_stndrd .or. ifrans_komg_lowRe .or.
     $   ifrans_komg_stndrd_noreg)call rans_komg_set_defaultcoeffs
         if(ifrans_komgSST_stndrd .or. ifrans_komgSST_lowRe)
     $                            call rans_komgSST_set_defaultcoeffs
      endif

c solve for omega_pert
      if(wall_id.eq.0) then
        if(nid.eq.0) write(6,*) ' user supplied wall distance'
        call copy(ywd,ywd_in,n)
      else
        bcw    = 'W  '
        ifld   = 1
        if(nid.eq.0) write(6,*) 'BC for distance ',bcw
        if(wall_id.eq.1) call cheap_dist(ywd,ifld,bcw)
        if(wall_id.eq.2) call distf(ywd,ifld,bcw,w1,w2,w3,w4,w5)
        call copy(ywd_in,ywd,n)
      endif

      call rans_komg_omegabase

      if(nid.eq.0) write(6,*) 'done :: init RANS'

      return
      end
c-----------------------------------------------------------------------
      subroutine rans_komg_omegabase
c
c     Compute Omega base solution which diverges at walls
c
      include 'SIZE'
      include 'TOTAL'
      include 'RANS_KOMG'

      parameter (nprof_max = 10000)
      integer i,j,k,e
      real    nu

      real kv_min,omeg_max

      omeg_max   = coeffs(15)
      beta0      = coeffs(6)
      nu  = param(2)/param(1)
      ntot1 = nx1*ny1*nz1*nelv

      betainf_str = coeffs(11)
      yw_min = glmin(ywd,ntot1)

      Cfcon = 6.0 * nu / beta0 ! 2.0 * nu0 / betainf_str ! 
      expn  = -2.0

      call gradm1 (dfdx_omegb,dfdy_omegb,dfdz_omegb,   ywd)
      call opcolv (dfdx_omegb,dfdy_omegb,dfdz_omegb,   bm1)
      call opdssum(dfdx_omegb,dfdy_omegb,dfdz_omegb)
      call opcolv (dfdx_omegb,dfdy_omegb,dfdz_omegb,binvm1)

c     call gradm1 (dudx,      dudy      ,dudz,  dfdx_omegb)
c     call copy   (delsqf_omegb, dudx, ntot1)
c     call gradm1 (dudx,      dudy      ,dudz,  dfdy_omegb)
c     call add2   (delsqf_omegb, dudy, ntot1)
c     call gradm1 (dudx,      dudy      ,dudz,  dfdz_omegb)
c     call add2   (delsqf_omegb, dudz, ntot1)

      toll = 1.0e-08

c     call vdot3  (delfsq_omegb,dfdx_omegb,dfdy_omegb,dfdz_omegb 
c    $                         ,dfdx_omegb,dfdy_omegb,dfdz_omegb,ntot1)

      call rzero  (delsqf_omegb, ntot1)
      call rone   (delfsq_omegb, ntot1)

      do e = 1,nelv
      do k = 1,nz1
      do j = 1,ny1
      do i = 1,nx1

         ieg = lglel(e)
         yw   = ywd(i,j,k,e)       ! 1.0 - abs(y)
         ywmin=sqrt(Cfcon/omeg_max)
         if(yw.gt.ywmin) then
            ywm1 = 1.0 /yw
         else
           if(yw.ne.0) write(*,'(a,3G14.7,4I5)') 
     $                   'ywmin and yw ',ywmin,yw,omeg_max, i, j, k, ieg
            ywm1 = 1.0 /ywmin
         endif
         ywdm1(i,j,k,e) = ywm1
         ywm2 = ywm1*ywm1
         ywm3 = ywm2*ywm1
         ywm4 = ywm2*ywm2

         f_omegb     (i,j,k,e) =        Cfcon * ywm2
         delfpart              = expn * ywm1
         dfdx_omegb  (i,j,k,e) = dfdx_omegb(i,j,k,e)  * ywm1
         dfdy_omegb  (i,j,k,e) = dfdy_omegb(i,j,k,e)  * ywm1
         dfdz_omegb  (i,j,k,e) = dfdz_omegb(i,j,k,e)  * ywm1
         delsqfpart            = expn * (expn - 1.0)  * ywm2
         delsqf_omegb(i,j,k,e) =(delsqfpart  * delfsq_omegb(i,j,k,e)
     $                         + delfpart    * delsqf_omegb(i,j,k,e))
         delfsq_omegb(i,j,k,e) = delfsq_omegb(i,j,k,e)* ywm2

      enddo
      enddo
      enddo
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine rans_komg_set_defaultcoeffs
c
      include 'SIZE'
      include 'RANS_KOMG'

c ====various problem-specific turbulence constants
c omeg_max = value of omega on the walls
c kv_min = value of K on the walls
c Pr_t is the turbulent prandtl number

        vkappa = 0.41

c Turbulent viscosity constants
        Pr_t         = 0.85
        coeffs( 1)   = Pr_t
        sigma_k      = 2.0
        coeffs( 2)   = sigma_k
        sigma_omega  = 2.0
        coeffs( 3)   = sigma_omega

c Low Reynolds number correction constants

c Production of K constants
        alpinf_str   = 1.0
        coeffs( 4)   = alpinf_str
        r_k          = 6.0
        coeffs( 5)   = r_k
        beta_0       = 0.072 ! should be 0.075 for SST
        coeffs( 6)   = beta_0
        alp0_str     = beta_0/3.0
        coeffs( 7)   = alp0_str

c Dissipation of K constants
        betainf_str  = 0.09
        coeffs( 8)   = betainf_str
        alp_inf      = 0.52
c        alp_inf      = beta_0/betainf_str 
c     $               - vkappa**2/sqrt(betainf_str)/sigma_omega ! should be 0.52 for k-omega
        coeffs( 9)   = alp_inf
        r_b          = 8.0
        coeffs(10)   = r_b
        akk          = 4.0/15.0
        coeffs(11)   = akk

c Production of omega constants
        alpha_0      = 1.0/9.0
        coeffs(12)   = alpha_0
        r_w          = 2.95
        coeffs(13)   = r_w

c Dissipation of omega constants
c         beta_0 = defined earlier	     

        kv_min       = 0.0
        coeffs(14)   = kv_min
        omeg_max     = 2.0e8 ! 400.0 Lan
        coeffs(15)   = omeg_max
        tiny         = 1.0e-20
        coeffs(16)   = tiny

        return
        end
c-----------------------------------------------------------------------
      subroutine rans_komgSST_set_defaultcoeffs
c
      include 'SIZE'
      include 'RANS_KOMG'

c ====various problem-specific turbulence constants
c omeg_max = value of omega on the walls
c kv_min = value of K on the walls
c Pr_t is the turbulent prandtl number

        vkappa = 0.41

c Turbulent viscosity constants
        Pr_t         = 0.85
        coeffs( 1)   = Pr_t
        sigk1        = 0.5 ! should be 0.85 for SST
        coeffs( 2)   = sigk1
        sigom1       = 0.5
        coeffs( 3)   = sigom1

c Low Reynolds number correction constants

c Production of K constants
        alpinf_str   = 1.0
        coeffs( 4)   = alpinf_str
        r_k          = 6.0
        coeffs( 5)   = r_k
        beta_0       = 0.072 ! should be 0.075 for SST
        coeffs( 6)   = beta_0
        alp0_str     = beta_0/3.0
        coeffs( 7)   = alp0_str

c Dissipation of K constants
        betainf_str  = 0.09
        coeffs( 8)   = betainf_str
        alp_inf      = beta_0/betainf_str 
     $               - sigom1 * vkappa**2/sqrt(betainf_str) ! should be 0.52 for k-omega
c        alp_inf      = 0.52
        coeffs( 9)   = alp_inf
        r_b          = 8.0
        coeffs(10)   = r_b
        akk          = 4.0/15.0
        coeffs(11)   = akk

c Production of omega constants
        alpha_0      = 1.0/9.0
        coeffs(12)   = alpha_0
        r_w          = 2.95
        coeffs(13)   = r_w

c Dissipation of omega constants
c         beta_0 = defined earlier	     

        kv_min       = 0.0
        coeffs(14)   = kv_min
        omeg_max     = 2.0e8 ! 400.0 
        coeffs(15)   = omeg_max
        tiny         = 1.0e-20
        coeffs(16)   = tiny

c additional SST and k and epsilon constants
        alp1         = 0.31
        coeffs(17)   = alp1
        beta2        = 0.0828
        coeffs(18)   = beta2
        sigk2        = 1.0
        coeffs(19)   = sigk2
        sigom2       = 0.856
        coeffs(20)   = sigom2
        gamma2       = beta2/betainf_str 
     $               - sigom2 * vkappa**2/sqrt(betainf_str) ! should be 0.44 for k-epsilon
c        gamma2       = 0.44
        coeffs(21)   = gamma2

        return
        end
c-----------------------------------------------------------------------
      subroutine rans_komg_stndrd_eddy
c
c     Compute RANS source terms and diffusivities on an 
c     element-by-element basis
c
      include 'SIZE'
      include 'TOTAL'
      include 'RANS_KOMG'

      parameter (lxyz=lx1*ly1*lz1)

      integer e
      real k,mu_t,nu_t,mu,nu, kv_min,omeg_max

c Turbulent viscosity constants
        Pr_t         = coeffs( 1)
        sigma_k      = coeffs( 2)
        sigma_omega  = coeffs( 3)

c Low Reynolds number correction constants
        alpinf_str   = coeffs( 4)
        r_k          = coeffs( 5)
        beta_0       = coeffs( 6)
        alp0_str     = coeffs( 7)

c Dissipation of K constants
        betainf_str  = coeffs( 8)
        alp_inf      = coeffs( 9)
        r_b          = coeffs(10)
        akk          = coeffs(11)

c Production of omega constants
        alpha_0      = coeffs(12)
        r_w          = coeffs(13)

c Dissipation of omega constants
c         beta_0 = defined earlier	     

        kv_min       = coeffs(14)
        omeg_max     = coeffs(15)
        tiny         = coeffs(16)
c================================

      nome_neg = 0
      nkey_neg = 0
      xome_neg = 0.
      xkey_neg = 0.

      do e=1,nelv
        do i=1,lxyz

          rho = param(1) ! vtrans(i,1,1,e,1)
          mu  = param(2) ! vdiff (i,1,1,e,1)
          nu  = mu/rho

c limits for k, omega

c solve for omega_pert

          omega   = t(i,1,1,e,ifld_omega-1) + f_omegb(i,1,1,e) ! Current k & omega values
          k       = t(i,1,1,e,ifld_k  -1)   ! from previous timestep

          iflim_omeg = 0 ! limit omega^{prime} 1 limit omega_total

          if    (iflim_omeg.eq.0) then
            if(t(i,1,1,e,ifld_omega-1).lt.0.0) then
c             write(*,*) 'Zero OMEG ', t(i,1,1,e,ifld_omega-1)
              xome_neg = min(xome_neg,t(i,1,1,e,ifld_omega-1))
              nome_neg = nome_neg + 1
c             write(*,*) 'Neg  OMEG ', nome_neg, xome_neg
              t(i,1,1,e,ifld_omega-1) =0.01*abs(t(i,1,1,e,ifld_omega-1))
              omega = t(i,1,1,e,ifld_omega-1) + f_omegb(i,1,1,e) ! Current k & omega values
            endif

            if(t(i,1,1,e,ifld_k-1).lt.0.0) then
c             write(*,*) 'Zero K    ', t(i,1,1,e,ifld_k-1)
              xkey_neg = min(xkey_neg,t(i,1,1,e,ifld_k-1))
              nkey_neg = nkey_neg + 1
c             write(*,*) 'Neg  KEY  ', nkey_neg, xkey_neg
              t(i,1,1,e,ifld_k-1) = 0.01*abs(t(i,1,1,e,ifld_k-1))
              k     = t(i,1,1,e,ifld_k  -1)   ! from previous timestep
            endif

          elseif(iflim_omeg.eq.1) then

            if(omega.lt.0.0) then
              write(*,*) 'OMEG tot is neg', omega
              omega = 0.01*abs(omega)
            endif

            if(k.lt.0.0) then
               write(*,*) 'K  is neg', k
               k = 0.01*abs(k)
            endif

          endif

          alp_str = alpinf_str 
          mu_t    = rho * alp_str*k/(omega + tiny) ! should multiply these by rho!!!

          mut  (i,1,1,e)   = mu_t
          mutsk(i,1,1,e)   = mu_t / sigma_k
          mutso(i,1,1,e)   = mu_t / sigma_omega
        enddo

      enddo

      if(loglevel.gt.2) then
        nome_neg =iglsum(nome_neg,1)
        nkey_neg =iglsum(nkey_neg,1)
        xome_neg = glmin(xome_neg,1)
        xkey_neg = glmin(xkey_neg,1)

        if(nid.eq.0 .and. nome_neg.gt.0)
     $    write(*,*) 'Neg Omega ', nome_neg, xome_neg
        if(nid.eq.0 .and. nkey_neg.gt.0)
     $    write(*,*) 'Neg TKE   ', nkey_neg, xkey_neg
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine rans_komg_lowRe_eddy
c
c     Compute RANS source terms and diffusivities on an 
c     element-by-element basis
c
      include 'SIZE'
      include 'TOTAL'
      include 'RANS_KOMG'

      parameter (lxyz=lx1*ly1*lz1)

      integer e
      real k,mu_t,nu_t,mu,nu, kv_min,omeg_max

c Turbulent viscosity constants
        Pr_t         = coeffs( 1)
        sigma_k      = coeffs( 2)
        sigma_omega  = coeffs( 3)

c Low Reynolds number correction constants
        alpinf_str   = coeffs( 4)
        r_k          = coeffs( 5)
        beta_0       = coeffs( 6)
        alp0_str     = coeffs( 7)

c Dissipation of K constants
        betainf_str  = coeffs( 8)
        alp_inf      = coeffs( 9)
        r_b          = coeffs(10)
        akk          = coeffs(11)

c Production of omega constants
        alpha_0      = coeffs(12)
        r_w          = coeffs(13)

c Dissipation of omega constants
c         beta_0 = defined earlier	     

        kv_min       = coeffs(14)
        omeg_max     = coeffs(15)
        tiny         = coeffs(16)
c================================

      nome_neg = 0
      nkey_neg = 0
      xome_neg = 0.
      xkey_neg = 0.

      do e=1,nelv

        do i=1,lxyz

          rho = param(1) ! vtrans(i,1,1,e,1)
          mu  = param(2) ! vdiff (i,1,1,e,1)
          nu  = mu/rho

c limits for k, omega

c solve for omega_pert
          omega   = t(i,1,1,e,ifld_omega-1) + f_omegb(i,1,1,e) ! Current k & omega values
          k       = t(i,1,1,e,ifld_k  -1)   ! from previous timestep

          iflim_omeg = 0 ! limit omega^{prime} 1 limit omega_total

          if    (iflim_omeg.eq.0) then
            if(t(i,1,1,e,ifld_omega-1).lt.0.0) then
c             write(*,*) 'Zero OMEG ', t(i,1,1,e,ifld_omega-1)
              xome_neg = min(xome_neg,t(i,1,1,e,ifld_omega-1))
              nome_neg = nome_neg + 1
c             write(*,*) 'Neg  OMEG ', nome_neg, xome_neg
              t(i,1,1,e,ifld_omega-1) =0.01*abs(t(i,1,1,e,ifld_omega-1))
              omega = t(i,1,1,e,ifld_omega-1) + f_omegb(i,1,1,e) ! Current k & omega values
            endif

            if(t(i,1,1,e,ifld_k-1).lt.0.0) then
c             write(*,*) 'Zero K    ', t(i,1,1,e,ifld_k-1)
              xkey_neg = min(xkey_neg,t(i,1,1,e,ifld_k-1))
              nkey_neg = nkey_neg + 1
c             write(*,*) 'Neg  KEY  ', nkey_neg, xkey_neg
              t(i,1,1,e,ifld_k-1) = 0.01*abs(t(i,1,1,e,ifld_k-1))
              k     = t(i,1,1,e,ifld_k  -1)   ! from previous timestep
            endif

          elseif(iflim_omeg.eq.1) then

            if(omega.lt.0.0) then
              write(*,*) 'OMEG tot is neg', omega
              omega = 0.01*abs(omega)
            endif

            if(k.lt.0.0) then
               write(*,*) 'K  is neg', k
               k = 0.01*abs(k)
            endif

          endif

          re_t    = rho * k /(mu * omega + tiny) 
          alp_str = alpinf_str * (alp0_str + (re_t/r_k))
     $                                         / (1.+(re_t/r_k)) 
          mu_t    = rho * alp_str*k/(omega + tiny) ! should multiply these by rho!!!

          mut  (i,1,1,e)   = mu_t
          mutsk(i,1,1,e)   = mu_t / sigma_k
          mutso(i,1,1,e)   = mu_t / sigma_omega
        enddo

      enddo

      if(loglevel.gt.2) then
        nome_neg =iglsum(nome_neg,1)
        nkey_neg =iglsum(nkey_neg,1)
        xome_neg = glmin(xome_neg,1)
        xkey_neg = glmin(xkey_neg,1)

        if(nid.eq.0 .and. nome_neg.gt.0)
     $    write(*,*) 'Neg Omega ', nome_neg, xome_neg
        if(nid.eq.0 .and. nkey_neg.gt.0)
     $    write(*,*) 'Neg TKE   ', nkey_neg, xkey_neg
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine rans_komgSST_stndrd_eddy
c
c     Compute RANS source terms and diffusivities on an 
c     element-by-element basis
c
      include 'SIZE'
      include 'TOTAL'
      include 'RANS_KOMG'

      parameter (lxyz=lx1*ly1*lz1)

      real           k_x(lxyz),k_y(lxyz),k_z(lxyz)
     $             , o_x(lxyz),o_y(lxyz),o_z(lxyz)
     $              ,omp_x(lxyz), omp_y(lxyz), omp_z(lxyz)

      common /storesom/ St_mag2(lx1*ly1*lz1,lelv)
     $                , Om_mag2(lx1*ly1*lz1,lelv)
     $                , OiOjSk (lx1*ly1*lz1,lelv)
     $                , DivQ   (lx1*ly1*lz1,lelv)

      integer e
      real k,mu_t,nu_t,mu,nu, kv_min,omeg_max

c====turbulence constants==========

c Turbulent viscosity constants
        Pr_t         = coeffs( 1)
        sigk1        = coeffs( 2)
        sigom1       = coeffs( 3)

c Low Reynolds number correction constants
        alpinf_str   = coeffs( 4)
        r_k          = coeffs( 5)
        beta1        = coeffs( 6)
        alp0_str     = coeffs( 7)

c Dissipation of K constants
        beta_str     = coeffs( 8)
        gamma1       = coeffs( 9)
        r_b          = coeffs(10)
        akk          = coeffs(11)

c Production of omega constants
        alpha_0      = coeffs(12)
        r_w          = coeffs(13)

c Dissipation of omega constants
c         beta_0 = defined earlier	     

        kv_min       = coeffs(14)
        omeg_max     = coeffs(15)
        tiny         = coeffs(16)

c additional SST and k and epsilon constants
        alp1         = coeffs(17)
        beta2        = coeffs(18)
        sigk2        = coeffs(19)
        sigom2       = coeffs(20)
        gamma2       = coeffs(21)
c================================

      call comp_StOm (St_mag2, Om_mag2, OiOjSk, DivQ)

      nome_neg = 0
      nkey_neg = 0
      xome_neg = 0.
      xkey_neg = 0.

      do e=1,nelv

        call gradm11(k_x,  k_y,  k_z,  t(1,1,1,1,ifld_k    -1),e)
        call gradm11(omp_x,omp_y,omp_z,t(1,1,1,1,ifld_omega-1),e)

        do i=1,lxyz

          rho = param(1) ! vtrans(i,1,1,e,1)
          mu  = param(2) ! vdiff (i,1,1,e,1)
          nu  = mu/rho

c limits for k, omega

c solve for omega_pert
          omega   = t(i,1,1,e,ifld_omega-1) + f_omegb(i,1,1,e) ! Current k & omega values
          k       = t(i,1,1,e,ifld_k  -1)   ! from previous timestep

          iflim_omeg = 0 ! limit omega^{prime} 1 limit omega_total

          if    (iflim_omeg.eq.0) then
            if(t(i,1,1,e,ifld_omega-1).lt.0.0) then
c             write(*,*) 'Zero OMEG ', t(i,1,1,e,ifld_omega-1)
              xome_neg = min(xome_neg,t(i,1,1,e,ifld_omega-1))
              nome_neg = nome_neg + 1
c             write(*,*) 'Neg  OMEG ', nome_neg, xome_neg
              t(i,1,1,e,ifld_omega-1) =0.01*abs(t(i,1,1,e,ifld_omega-1))
              omega = t(i,1,1,e,ifld_omega-1) + f_omegb(i,1,1,e) ! Current k & omega values
            endif

            if(t(i,1,1,e,ifld_k-1).lt.0.0) then
c             write(*,*) 'Zero K    ', t(i,1,1,e,ifld_k-1)
              xkey_neg = min(xkey_neg,t(i,1,1,e,ifld_k-1))
              nkey_neg = nkey_neg + 1
c             write(*,*) 'Neg  KEY  ', nkey_neg, xkey_neg
              t(i,1,1,e,ifld_k-1) = 0.01*abs(t(i,1,1,e,ifld_k-1))
              k     = t(i,1,1,e,ifld_k  -1)   ! from previous timestep
            endif

          elseif(iflim_omeg.eq.1) then

            if(omega.lt.0.0) then
              write(*,*) 'OMEG tot is neg', omega
              omega = 0.01*abs(omega)
            endif

            if(k.lt.0.0) then
               write(*,*) 'K  is neg', k
               k = 0.01*abs(k)
            endif

          endif

          expn = -2.0
          o_x(i)= omp_x(i)+expn * dfdx_omegb(i,1,1,e) *f_omegb(i,1,1,e)
          o_y(i)= omp_y(i)+expn * dfdy_omegb(i,1,1,e) *f_omegb(i,1,1,e)
          if(if3d)
     $    o_z(i)= omp_z(i)+expn * dfdz_omegb(i,1,1,e) *f_omegb(i,1,1,e)

          St_magn = sqrt(St_mag2(i,e))
          Om_magn = sqrt(Om_mag2(i,e))

! calculate del k * del omega / omega

          if(if3d)then
            xk = (k_x(i)*o_x(i) + k_y(i)*o_y(i) + k_z(i)*o_z(i))
     $                                            / (omega+tiny)
          else
            xk = (k_x(i)*o_x(i) + k_y(i)*o_y(i))
     $                                            / (omega+tiny)
          endif

! calculate F2 based on arg2

          yw   = ywd  (i,1,1,e)
          ywm1 = ywdm1(i,1,1,e)
          ywm2 = ywm1*ywm1
          arg2_1 =      sqrt(abs(k)) * ywm1 / omega / beta_str
          arg2_2 =          500.0*nu * ywm2 / omega
          arg2   = max(2.0*arg2_1, arg2_2)
          Fun2   = tanh(arg2 * arg2)

! calculate F1 based on arg1

          argCD  =     2.0 * rho * sigom2 * xk
          CDkom  = max(argCD, 1.0e-10)
          arg1_1 = max(    arg2_1, arg2_2)
          arg1_2 =     4.0 * rho * sigom2 * k * ywm2 / CDkom
          arg1   = min(    arg1_1, arg1_2)
          Fun1   = tanh(arg1 * arg1 * arg1 * arg1)

! calculate mu_t 
          argn_1 = alp1*(omega + tiny)
          argn_2 = Fun2*St_magn ! this can also be St_magn

          mu_t = 0.0
          denom = max(argn_1, argn_2)
          if(yw.ne.0) mu_t = rho * alp1 * k / denom 

          sigk  = Fun1 * sigk1  + (1.0 - Fun1) * sigk2
          sigom = Fun1 * sigom1 + (1.0 - Fun1) * sigom2

          mut  (i,1,1,e)   = mu_t
          mutsk(i,1,1,e)   = mu_t * sigk
          mutso(i,1,1,e)   = mu_t * sigom

        enddo

      enddo

      if(loglevel.gt.2) then
        nome_neg =iglsum(nome_neg,1)
        nkey_neg =iglsum(nkey_neg,1)
        xome_neg = glmin(xome_neg,1)
        xkey_neg = glmin(xkey_neg,1)

        if(nid.eq.0 .and. nome_neg.gt.0)
     $    write(*,*) 'Neg Omega ', nome_neg, xome_neg
        if(nid.eq.0 .and. nkey_neg.gt.0)
     $    write(*,*) 'Neg TKE   ', nkey_neg, xkey_neg
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine rans_komgSST_lowRe_eddy
c
c     Compute RANS source terms and diffusivities on an 
c     element-by-element basis
c
      include 'SIZE'
      include 'TOTAL'
      include 'RANS_KOMG'

      parameter (lxyz=lx1*ly1*lz1)

      real           k_x(lxyz),k_y(lxyz),k_z(lxyz)
     $             , o_x(lxyz),o_y(lxyz),o_z(lxyz)
     $              ,omp_x(lxyz), omp_y(lxyz), omp_z(lxyz)

      common /storesom/ St_mag2(lx1*ly1*lz1,lelv)
     $                , Om_mag2(lx1*ly1*lz1,lelv)
     $                , OiOjSk (lx1*ly1*lz1,lelv)
     $                , DivQ   (lx1*ly1*lz1,lelv)

      integer e
      real k,mu_t,nu_t,mu,nu, kv_min,omeg_max

c====turbulence constants==========

c Turbulent viscosity constants
        Pr_t         = coeffs( 1)
        sigk1        = coeffs( 2)
        sigom1       = coeffs( 3)

c Low Reynolds number correction constants
        alpinf_str   = coeffs( 4)
        r_k          = coeffs( 5)
        beta1        = coeffs( 6)
        alp0_str     = coeffs( 7)

c Dissipation of K constants
        beta_str     = coeffs( 8)
        alp_inf      = coeffs( 9)
        r_b          = coeffs(10)
        akk          = coeffs(11)

c Production of omega constants
        alpha_0      = coeffs(12)
        r_w          = coeffs(13)

c Dissipation of omega constants
c         beta_0 = defined earlier	     

        kv_min       = coeffs(14)
        omeg_max     = coeffs(15)
        tiny         = coeffs(16)

c additional SST and k and epsilon constants
        alp1         = coeffs(17)
        beta2        = coeffs(18)
        sigk2        = coeffs(19)
        sigom2       = coeffs(20)
        gamma2       = coeffs(21)
c================================

      call comp_StOm (St_mag2, Om_mag2, OiOjSk, DivQ)

      nome_neg = 0
      nkey_neg = 0
      xome_neg = 0.
      xkey_neg = 0.

      do e=1,nelv

        call gradm11(k_x,  k_y,  k_z,  t(1,1,1,1,ifld_k    -1),e)
        call gradm11(omp_x,omp_y,omp_z,t(1,1,1,1,ifld_omega-1),e)

        do i=1,lxyz

          rho = param(1) ! vtrans(i,1,1,e,1)
          mu  = param(2) ! vdiff (i,1,1,e,1)
          nu  = mu/rho

c limits for k, omega

c solve for omega_pert
          omega   = t(i,1,1,e,ifld_omega-1) + f_omegb(i,1,1,e) ! Current k & omega values
          k       = t(i,1,1,e,ifld_k  -1)   ! from previous timestep

          iflim_omeg = 0 ! limit omega^{prime} 1 limit omega_total

          if    (iflim_omeg.eq.0) then
            if(t(i,1,1,e,ifld_omega-1).lt.0.0) then
c             write(*,*) 'Zero OMEG ', t(i,1,1,e,ifld_omega-1)
              xome_neg = min(xome_neg,t(i,1,1,e,ifld_omega-1))
              nome_neg = nome_neg + 1
c             write(*,*) 'Neg  OMEG ', nome_neg, xome_neg
              t(i,1,1,e,ifld_omega-1) =0.01*abs(t(i,1,1,e,ifld_omega-1))
              omega = t(i,1,1,e,ifld_omega-1) + f_omegb(i,1,1,e) ! Current k & omega values
            endif

            if(t(i,1,1,e,ifld_k-1).lt.0.0) then
c             write(*,*) 'Zero K    ', t(i,1,1,e,ifld_k-1)
              xkey_neg = min(xkey_neg,t(i,1,1,e,ifld_k-1))
              nkey_neg = nkey_neg + 1
c             write(*,*) 'Neg  KEY  ', nkey_neg, xkey_neg
              t(i,1,1,e,ifld_k-1) = 0.01*abs(t(i,1,1,e,ifld_k-1))
              k     = t(i,1,1,e,ifld_k  -1)   ! from previous timestep
            endif

          elseif(iflim_omeg.eq.1) then

            if(omega.lt.0.0) then
              write(*,*) 'OMEG tot is neg', omega
              omega = 0.01*abs(omega)
            endif

            if(k.lt.0.0) then
               write(*,*) 'K  is neg', k
               k = 0.01*abs(k)
            endif

          endif

          expn = -2.0
          o_x(i)= omp_x(i)+expn * dfdx_omegb(i,1,1,e) *f_omegb(i,1,1,e)
          o_y(i)= omp_y(i)+expn * dfdy_omegb(i,1,1,e) *f_omegb(i,1,1,e)
          if(if3d)
     $    o_z(i)= omp_z(i)+expn * dfdz_omegb(i,1,1,e) *f_omegb(i,1,1,e)

          St_magn = sqrt(St_mag2(i,e))
          Om_magn = sqrt(Om_mag2(i,e))

! calculate del k * del omega / omega

          if(if3d)then
            xk = (k_x(i)*o_x(i) + k_y(i)*o_y(i) + k_z(i)*o_z(i))
     $                                            / (omega+tiny)
          else
            xk = (k_x(i)*o_x(i) + k_y(i)*o_y(i))
     $                                            / (omega+tiny)
          endif

c ------------ begin low Re part of k-omega -------------------

          re_t    = rho * k /(mu * omega + tiny) 
          alp_str = alpinf_str * (alp0_str + (re_t/r_k))
     $                                         / (1.+(re_t/r_k)) 
c ------------ end   low Re part of k-omega -------------------

! calculate F2 based on arg2

          yw   = ywd  (i,1,1,e)
          ywm1 = ywdm1(i,1,1,e)
          ywm2 = ywm1*ywm1
          arg2_1 =      sqrt(abs(k)) * ywm1 / omega / beta_str
          arg2_2 =          500.0*nu * ywm2 / omega
          arg2   = max(2.0*arg2_1, arg2_2)
          Fun2   = tanh(arg2 * arg2)

! calculate F1 based on arg1

          argCD  =     2.0 * rho * sigom2 * xk
          CDkom  = max(argCD, 1.0e-10)
          arg1_1 = max(    arg2_1, arg2_2)
          arg1_2 =     4.0 * rho * sigom2 * k * ywm2 / CDkom
          arg1   = min(    arg1_1, arg1_2)
          Fun1   = tanh(arg1 * arg1 * arg1 * arg1)

! calculate mu_t 
          argn_1 = alp1*(omega + tiny) / alp_str
          argn_2 = Fun2*St_magn ! this can also be St_magn

          mu_t = 0.0
          denom = max(argn_1, argn_2)
          if(yw.ne.0) mu_t = rho * alp1 * k / denom 

          sigk  = Fun1 * sigk1  + (1.0 - Fun1) * sigk2
          sigom = Fun1 * sigom1 + (1.0 - Fun1) * sigom2

          mut  (i,1,1,e)   = mu_t
          mutsk(i,1,1,e)   = mu_t * sigk
          mutso(i,1,1,e)   = mu_t * sigom

        enddo

      enddo

      if(loglevel.gt.2) then
        nome_neg =iglsum(nome_neg,1)
        nkey_neg =iglsum(nkey_neg,1)
        xome_neg = glmin(xome_neg,1)
        xkey_neg = glmin(xkey_neg,1)

        if(nid.eq.0 .and. nome_neg.gt.0)
     $    write(*,*) 'Neg Omega ', nome_neg, xome_neg
        if(nid.eq.0 .and. nkey_neg.gt.0)
     $    write(*,*) 'Neg TKE   ', nkey_neg, xkey_neg
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine rans_komg_stndrd_eddy_noreg
c
c     Compute RANS source terms and diffusivities on an 
c     element-by-element basis
c
      include 'SIZE'
      include 'TOTAL'
      include 'RANS_KOMG'

      parameter (lxyz=lx1*ly1*lz1)

      integer e
      real k,mu_t,nu_t,mu,nu, kv_min,omeg_max

c Turbulent viscosity constants
        Pr_t         = coeffs( 1)
        sigma_k      = coeffs( 2)
        sigma_omega  = coeffs( 3)

c Low Reynolds number correction constants
        alpinf_str   = coeffs( 4)
        r_k          = coeffs( 5)
        beta_0       = coeffs( 6)
        alp0_str     = coeffs( 7)

c Dissipation of K constants
        betainf_str  = coeffs( 8)
        alp_inf      = coeffs( 9)
        r_b          = coeffs(10)
        akk          = coeffs(11)

c Production of omega constants
        alpha_0      = coeffs(12)
        r_w          = coeffs(13)

c Dissipation of omega constants
c         beta_0 = defined earlier	     

        kv_min       = coeffs(14)
        omeg_max     = coeffs(15)
        tiny         = coeffs(16)
c================================

      nome_neg = 0
      nkey_neg = 0
      xome_neg = 0.
      xkey_neg = 0.

      do e=1,nelv
        do i=1,lxyz

          rho = param(1) ! vtrans(i,1,1,e,1)
          mu  = param(2) ! vdiff (i,1,1,e,1)
          nu  = mu/rho

c limits for k, omega

c solve for omega_pert
          omega   = t(i,1,1,e,ifld_omega-1) ! Current k & omega values
          k       = t(i,1,1,e,ifld_k  -1)   ! from previous timestep

          iflim_omeg = 0 ! limit omega^{prime} 1 limit omega_total

          if    (iflim_omeg.eq.0) then
            if(t(i,1,1,e,ifld_omega-1).lt.0.0) then
c             write(*,*) 'Zero OMEG ', t(i,1,1,e,ifld_omega-1)
              xome_neg = min(xome_neg,t(i,1,1,e,ifld_omega-1))
              nome_neg = nome_neg + 1
c             write(*,*) 'Neg  OMEG ', nome_neg, xome_neg
              t(i,1,1,e,ifld_omega-1) =0.01*abs(t(i,1,1,e,ifld_omega-1))
              omega = t(i,1,1,e,ifld_omega-1) ! Current k & omega values
            endif

            if(t(i,1,1,e,ifld_k-1).lt.0.0) then
c             write(*,*) 'Zero K    ', t(i,1,1,e,ifld_k-1)
              xkey_neg = min(xkey_neg,t(i,1,1,e,ifld_k-1))
              nkey_neg = nkey_neg + 1
c             write(*,*) 'Neg  KEY  ', nkey_neg, xkey_neg
              t(i,1,1,e,ifld_k-1) = 0.01*abs(t(i,1,1,e,ifld_k-1))
              k     = t(i,1,1,e,ifld_k  -1)   ! from previous timestep
            endif

          elseif(iflim_omeg.eq.1) then

            if(omega.lt.0.0) then
              write(*,*) 'OMEG tot is neg', omega
              omega = 0.01*abs(omega)
            endif

            if(k.lt.0.0) then
               write(*,*) 'K  is neg', k
               k = 0.01*abs(k)
            endif

          endif

          alp_str = alpinf_str 
          mu_t    = rho * alp_str*k/(omega + tiny) ! should multiply these by rho!!!

          mut  (i,1,1,e)   = mu_t
          mutsk(i,1,1,e)   = mu_t / sigma_k
          mutso(i,1,1,e)   = mu_t / sigma_omega
        enddo

      enddo

      if(loglevel.gt.2) then
        nome_neg =iglsum(nome_neg,1)
        nkey_neg =iglsum(nkey_neg,1)
        xome_neg = glmin(xome_neg,1)
        xkey_neg = glmin(xkey_neg,1)

        if(nid.eq.0 .and. nome_neg.gt.0)
     $    write(*,*) 'Neg Omega ', nome_neg, xome_neg
        if(nid.eq.0 .and. nkey_neg.gt.0)
     $    write(*,*) 'Neg TKE   ', nkey_neg, xkey_neg
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine comp_StOm(St_mag2,Om_mag2,OiOjSk,DivQ)
c
c     Compute the square of the magnitude of the stress and rotation tensors
c     St_mag2=2Sij*Sij=S'ij*S'ij/2, S'ij=2Sij, Sij=(dui/dxj+duj/dxi)/2
c     Om_mag2=2Oij*Oij=O'ij*O'ij/2, O'ij=OSij, Oij=(dui/dxj-duj/dxi)/2
c
      include 'SIZE'
      include 'TOTAL'
c
      integer e

      parameter(lt  =lx1*ly1*lz1*lelv)
      parameter(lxyz=lx1*ly1*lz1)

      common /scruz/    sij  (lx1*ly1*lz1,6,lelv)
     $                , oij  (lx1*ly1*lz1,lelv,3)

      real              St_mag2(lx1*ly1*lz1,lelv)
     $                , Om_mag2(lx1*ly1*lz1,lelv)
     $                , OiOjSk (lx1*ly1*lz1,lelv)
     $                , DivQ   (lx1*ly1*lz1,lelv)

      logical iflmc, ifdss
c
      thqrt    = 0.75

      iflmc = .false.! to add lowmach correction to 2Sij (2Sij - 2Q/3*delta_ij) 
      ifdss = .true. ! to dssum sij and oij
      nij = 3
      if (if3d.or.ifaxis) nij=6

      if(nid.eq.0 .and. loglevel.gt.2) write(*,*) 'updating StOm '
      call comp_sij_oij     (sij, oij, nij, vx, vy, vz, iflmc, ifdss) ! S'ij=2Sij, O'ij=2Oij
      call comp_sij_oij_mag2(sij, oij, nij, St_mag2, Om_mag2, OiOjSk) ! St_mag2=2S^2=S'^2/2
c                                                                     ! Om_mag2=2O^2=O'^2/2
      do e = 1, nelv
         call add3   (DivQ(1,e), sij(1,1,e), sij(1,2,e), lxyz)
         if(if3d.or.ifaxis)
     $   call add2   (DivQ(1,e), sij(1,3,e),             lxyz)
         if(iflmc)     call cmult(DivQ(1,e), thqrt,      lxyz)
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine comp_sij_oij(sij,oij,nij,u,v,w,iflmc,ifdss)
c                                       du_i       du_j
c     Compute the stress tensor S_ij := ----   +   ----
c                                       du_j       du_i
c
      include 'SIZE'
      include 'TOTAL'
c
      integer e
      logical iflmc, ifdss
c
      parameter(lt  =lx1*ly1*lz1*lelv)
      parameter(lxyz=lx1*ly1*lz1)

      real sij(lx1*ly1*lz1,nij,lelv), oij(lx1*ly1*lz1,lelv,3)
      real u  (lx1*ly1*lz1,lelv)
      real v  (lx1*ly1*lz1,lelv)
      real w  (lx1*ly1*lz1,lelv)

      real ur(lxyz),us(lxyz),ut(lxyz)
     $    ,vr(lxyz),vs(lxyz),vt(lxyz)
     $    ,wr(lxyz),ws(lxyz),wt(lxyz)

      real j ! Inverse Jacobian

      n    = lx1-1      ! Polynomial degree
      nxyz = lx1*ly1*lz1

      if (if3d) then     ! 3D CASE
       do e=1,nelv
        call local_grad3(ur,us,ut,u,N,e,dxm1,dxtm1)
        call local_grad3(vr,vs,vt,v,N,e,dxm1,dxtm1)
        call local_grad3(wr,ws,wt,w,N,e,dxm1,dxtm1)

        do i=1,nxyz

         j = jacmi(i,e)

         sij(i,1,e) = j*  ! du/dx + du/dx
     $   2*(ur(i)*rxm1(i,1,1,e)+us(i)*sxm1(i,1,1,e)+ut(i)*txm1(i,1,1,e))

         sij(i,2,e) = j*  ! dv/dy + dv/dy
     $   2*(vr(i)*rym1(i,1,1,e)+vs(i)*sym1(i,1,1,e)+vt(i)*tym1(i,1,1,e))

         sij(i,3,e) = j*  ! dw/dz + dw/dz
     $   2*(wr(i)*rzm1(i,1,1,e)+ws(i)*szm1(i,1,1,e)+wt(i)*tzm1(i,1,1,e))

         sij(i,4,e) = j*  ! du/dy + dv/dx
     $   (ur(i)*rym1(i,1,1,e)+us(i)*sym1(i,1,1,e)+ut(i)*tym1(i,1,1,e) +
     $    vr(i)*rxm1(i,1,1,e)+vs(i)*sxm1(i,1,1,e)+vt(i)*txm1(i,1,1,e) )
         oij(i,e,3) = j*  ! dv/dx - du/dy
     $   (vr(i)*rxm1(i,1,1,e)+vs(i)*sxm1(i,1,1,e)+vt(i)*txm1(i,1,1,e) -
     $    ur(i)*rym1(i,1,1,e)+us(i)*sym1(i,1,1,e)+ut(i)*tym1(i,1,1,e) )

         sij(i,5,e) = j*  ! dv/dz + dw/dy
     $   (wr(i)*rym1(i,1,1,e)+ws(i)*sym1(i,1,1,e)+wt(i)*tym1(i,1,1,e) +
     $    vr(i)*rzm1(i,1,1,e)+vs(i)*szm1(i,1,1,e)+vt(i)*tzm1(i,1,1,e) )
         oij(i,e,1) = j*  ! dw/dy - dv/dz
     $   (wr(i)*rym1(i,1,1,e)+ws(i)*sym1(i,1,1,e)+wt(i)*tym1(i,1,1,e) -
     $    vr(i)*rzm1(i,1,1,e)+vs(i)*szm1(i,1,1,e)+vt(i)*tzm1(i,1,1,e) )

         sij(i,6,e) = j*  ! du/dz + dw/dx
     $   (ur(i)*rzm1(i,1,1,e)+us(i)*szm1(i,1,1,e)+ut(i)*tzm1(i,1,1,e) +
     $    wr(i)*rxm1(i,1,1,e)+ws(i)*sxm1(i,1,1,e)+wt(i)*txm1(i,1,1,e) )
         oij(i,e,2) = j*  ! du/dz - dw/dx
     $   (ur(i)*rzm1(i,1,1,e)+us(i)*szm1(i,1,1,e)+ut(i)*tzm1(i,1,1,e) -
     $    wr(i)*rxm1(i,1,1,e)+ws(i)*sxm1(i,1,1,e)+wt(i)*txm1(i,1,1,e) )


        enddo
       enddo

      elseif (ifaxis) then  ! AXISYMMETRIC CASE  

c
c        Notation:                       ( 2  x  Acheson, p. 353)
c                     Cylindrical
c            Nek5k    Coordinates
c
c              x          z
c              y          r
c              z          theta
c

         do e=1,nelv
            call setaxdy ( ifrzer(e) )  ! change dytm1 if on-axis
            call local_grad2(ur,us,u,N,e,dxm1,dytm1)
            call local_grad2(vr,vs,v,N,e,dxm1,dytm1)
            call local_grad2(wr,ws,w,N,e,dxm1,dytm1)

            do i=1,nxyz
               j = jacmi(i,e)
               r = ym1(i,1,1,e)                              ! Cyl. Coord:

               sij(i,1,e) = j*  ! du/dx + du/dx              ! e_zz
     $           2*(ur(i)*rxm1(i,1,1,e)+us(i)*sxm1(i,1,1,e))

               sij(i,2,e) = j*  ! dv/dy + dv/dy              ! e_rr
     $           2*(vr(i)*rym1(i,1,1,e)+vs(i)*sym1(i,1,1,e))

               if (r.gt.0) then                              ! e_@@
                  sij(i,3,e) = 2.*v(i,e)/r  ! v / r  ! corrected AT: factor of 2, 10/30/18
               else
                  sij(i,3,e) = j*  ! L'Hopital's rule: e_@@ = 2dv/dr
     $            2*(vr(i)*rym1(i,1,1,e)+vs(i)*sym1(i,1,1,e))
               endif

               sij(i,4,e) = j*  ! du/dy + dv/dx             ! e_zr
     $            ( ur(i)*rym1(i,1,1,e)+us(i)*sym1(i,1,1,e) +
     $              vr(i)*rxm1(i,1,1,e)+vs(i)*sxm1(i,1,1,e) )
               oij(i,e,3) = j*  ! dv/dx - du/dy
     $            ( vr(i)*rxm1(i,1,1,e)+vs(i)*sxm1(i,1,1,e) -
     $              ur(i)*rym1(i,1,1,e)+us(i)*sym1(i,1,1,e) )

               if (r.gt.0) then                             ! e_r@
                  sij(i,5,e) = j*  ! dw/dy 
     $              ( wr(i)*rym1(i,1,1,e)+ws(i)*sym1(i,1,1,e) )
     $              - w(i,e) / r
                  oij(i,e,1) = j*  ! dw/dy 
     $              ( wr(i)*rym1(i,1,1,e)+ws(i)*sym1(i,1,1,e) )
     $              + w(i,e) / r
               else
                  sij(i,5,e) = 0
                  oij(i,e,2) = j*  ! L'Hopital's rule: e_r@ = 2dw/dr
     $            2*(wr(i)*rym1(i,1,1,e)+ws(i)*sym1(i,1,1,e))
               endif

               sij(i,6,e) = j*  ! dw/dx                     ! e_@z
     $            ( wr(i)*rxm1(i,1,1,e)+ws(i)*sxm1(i,1,1,e) )
               oij(i,e,2) = j*  !-dw/dx
     $            (-wr(i)*rxm1(i,1,1,e)-ws(i)*sxm1(i,1,1,e) )

            enddo
         enddo

      else              ! 2D CASE

         do e=1,nelv
            call local_grad2(ur,us,u,N,e,dxm1,dxtm1)
            call local_grad2(vr,vs,v,N,e,dxm1,dxtm1)

            do i=1,nxyz
               j = jacmi(i,e)

               sij(i,1,e) = j*  ! du/dx + du/dx
     $           2*(ur(i)*rxm1(i,1,1,e)+us(i)*sxm1(i,1,1,e))
               oij(i,e,2) = 0.

               sij(i,2,e) = j*  ! dv/dy + dv/dy
     $           2*(vr(i)*rym1(i,1,1,e)+vs(i)*sym1(i,1,1,e))
               oij(i,e,3) = 0.

               sij(i,3,e) = j*  ! du/dy + dv/dx
     $           (ur(i)*rym1(i,1,1,e)+us(i)*sym1(i,1,1,e) +
     $            vr(i)*rxm1(i,1,1,e)+vs(i)*sxm1(i,1,1,e) )
               oij(i,e,1) = j*  ! dv/dx - du/dy
     $           (vr(i)*rxm1(i,1,1,e)+vs(i)*sxm1(i,1,1,e) -
     $            ur(i)*rym1(i,1,1,e)+us(i)*sym1(i,1,1,e) )

            enddo
         enddo
      endif

      if(iflomach .and. iflmc) then

        onethird = 1./3.
        if(if3d .or. ifaxis) then
          do e=1,nelv
            do i=1,nxyz
             trS = sij(i,1,e) + sij(i,2,e) + sij(i,3,e) ! 2(du/dx + dv/dy + dw/dz or v/r) in axisym
             sij(i,1,e) = sij(i,1,e) - onethird*trS     ! 2S - (2/3)Q = S'-(1/3)tr(S')
            enddo
          enddo
        else
          do e=1,nelv
            do i=1,nxyz
             trS = sij(i,1,e) + sij(i,2,e)              ! 2(du/dx + dv/dy)
             sij(i,1,e) = sij(i,1,e) - onethird*trS     ! 2S - (2/3)Q = S'-(1/3)tr(S')
            enddo
           enddo
        endif

      endif

      ifielt = ifield
      ifield = 1
      if(ifdss) call dssum_sij_oij(sij, oij, nij)
      ifield = ifielt

      return
      end
c-----------------------------------------------------------------------
      subroutine dssum_sij_oij(sij,oij,nij)
c
      include 'SIZE'
      include 'TOTAL'
c
      integer e
c
      parameter(lt  =lx1*ly1*lz1*lelv)
      parameter(lxyz=lx1*ly1*lz1)

      real sij(lx1*ly1*lz1,nij,lelv), oij(lx1*ly1*lz1,lelv,3)

      common /scrsij/  work1(lx1*ly1*lz1,lelv), work2(lx1*ly1*lz1,lelv)
     $                                        , work3(lx1*ly1*lz1,lelv)

      nxyz = lx1*ly1*lz1
      ntot = nxyz*nelv

      if (if3d .or. ifaxis) then
         call opcolv  (oij(1,1,1), oij(1,1,2), oij(1,1,3),   bm1)
         call opdssum (oij(1,1,1), oij(1,1,2), oij(1,1,3)       )
         call opcolv  (oij(1,1,1), oij(1,1,2), oij(1,1,3),binvm1)
         do e=1,nelv
            call copy (work1(1,e), sij(1,1,e),nxyz)
            call copy (work2(1,e), sij(1,2,e),nxyz)
            call copy (work3(1,e), sij(1,3,e),nxyz)
         enddo
         call opcolv  (work1, work2, work3,   bm1)
         call opdssum (work1, work2, work3       )
         call opcolv  (work1, work2, work3,binvm1)
         do e=1,nelv
            call copy (sij(1,1,e),work1(1,e), nxyz)
            call copy (sij(1,2,e),work2(1,e), nxyz)
            call copy (sij(1,3,e),work3(1,e), nxyz)
         enddo
         do e=1,nelv
            call copy (work1(1,e), sij(1,4,e),nxyz)
            call copy (work2(1,e), sij(1,5,e),nxyz)
            call copy (work3(1,e), sij(1,6,e),nxyz)
         enddo
         call opcolv  (work1, work2, work3,   bm1)
         call opdssum (work1, work2, work3       )
         call opcolv  (work1, work2, work3,binvm1)
         do e=1,nelv
            call copy (sij(1,4,e),work1(1,e), nxyz)
            call copy (sij(1,5,e),work2(1,e), nxyz)
            call copy (sij(1,6,e),work3(1,e), nxyz)
         enddo
      else
         call col2    (oij(1,1,1),bm1   ,ntot)
         call dssum   (oij(1,1,1),lx1,ly1,lz1)
         call col2    (oij(1,1,1),binvm1,ntot)
         do e=1,nelv
            call copy (work1(1,e), sij(1,1,e),nxyz)
            call copy (work2(1,e), sij(1,2,e),nxyz)
            call copy (work3(1,e), sij(1,3,e),nxyz)
         enddo
         call opcolv  (work1, work2, work3,   bm1)
         call opdssum (work1, work2, work3       )
         call opcolv  (work1, work2, work3,binvm1)
         do e=1,nelv
            call copy (sij(1,1,e),work1(1,e), nxyz)
            call copy (sij(1,2,e),work2(1,e), nxyz)
            call copy (sij(1,3,e),work3(1,e), nxyz)
         enddo
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine comp_sij_oij_mag2(sij,oij,nij,St_mag2,Om_mag2,OiOjSk)
c
c     Compute the square of the magnitude of the stress and rotation tensors
c     St_mag2=2Sij*Sij=S'ij*S'ij/2, S'ij=2Sij, Sij=(dui/dxj+duj/dxi)/2
c     Om_mag2=2Oij*Oij=O'ij*O'ij/2, O'ij=OSij, Oij=(dui/dxj-duj/dxi)/2
c
      include 'SIZE'
      include 'TOTAL'
c
      integer e
c
      parameter(lt  =lx1*ly1*lz1*lelv)
      parameter(lxyz=lx1*ly1*lz1)

      real sij(lx1*ly1*lz1,nij,lelv), oij(lx1*ly1*lz1,lelv,3)

      real              St_mag2(lx1*ly1*lz1,lelv)
     $                , Om_mag2(lx1*ly1*lz1,lelv)
     $                , OiOjSk (lx1*ly1*lz1,lelv)

      common /scrsij/  work1(lx1*ly1*lz1,lelv), work2(lx1*ly1*lz1,lelv)
     $                                        , work3(lx1*ly1*lz1,lelv)
      real tmp1(lxyz), tmp2(lxyz), tmp3(lxyz)

      nxyz    = lx1*ly1*lz1
      ntot    = nxyz*nelv
      two     = 2.
      onehalf = 0.5
      onethird= 1./3.
      oneeight= 1./8.
      beta    = onehalf-onethird

      if (if3d .or. ifaxis) then     ! 3D CASE or axisymmetric

       do e=1,nelv
          call    col3 (St_mag2(1,e), sij(1,1,e), sij(1,1,e),nxyz)
          call addcol3 (St_mag2(1,e), sij(1,2,e), sij(1,2,e),nxyz)
          call addcol3 (St_mag2(1,e), sij(1,3,e), sij(1,3,e),nxyz)
          call    col3 (work1  (1,e), sij(1,4,e), sij(1,4,e),nxyz)
          call addcol3 (work1  (1,e), sij(1,5,e), sij(1,5,e),nxyz)
          call addcol3 (work1  (1,e), sij(1,6,e), sij(1,6,e),nxyz)
          call  add2s2 (St_mag2(1,e), work1(1,e), two,       nxyz)
c
          call    col3 (work1  (1,e), oij(1,e,1), oij(1,e,1),nxyz)
          call    col3 (work2  (1,e), oij(1,e,2), oij(1,e,2),nxyz)
          call    col3 (work3  (1,e), oij(1,e,3), oij(1,e,3),nxyz)
          call    add4 (Om_mag2(1,e), work1(1,e), work2(1,e)
     $                                          , work3(1,e),nxyz)

          call    add3 (tmp1, work2(1,e), work3(1,e), nxyz)
          call    add3 (tmp2, work1(1,e), work3(1,e), nxyz)
          call    add3 (tmp3, work1(1,e), work2(1,e), nxyz)
          call    col3 (OiOjSk(1,e),tmp1, sij(1,1,e), nxyz)
          call addcol3 (OiOjSk(1,e),tmp2, sij(1,2,e), nxyz)
          call addcol3 (OiOjSk(1,e),tmp3, sij(1,3,e), nxyz)

          call    col4 (tmp1, oij(1,e,1), oij(1,e,2), sij(1,4,e), nxyz)
          call addcol4 (tmp1, oij(1,e,2), oij(1,e,3), sij(1,5,e), nxyz)
          call subcol4 (tmp1, oij(1,e,1), oij(1,e,3), sij(1,6,e), nxyz)
          call add2s2  (OiOjSk(1,e), tmp1, two,                   nxyz)

       enddo
           
      else              ! 2D CASE

       do e=1,nelv
          call    col3 (St_mag2(1,e), sij(1,1,e), sij(1,1,e),nxyz)
          call addcol3 (St_mag2(1,e), sij(1,2,e), sij(1,2,e),nxyz)
          call    col3 (work1  (1,e), sij(1,3,e), sij(1,3,e),nxyz)
          call  add2s2 (St_mag2(1,e), work1(1,e), two,       nxyz)
c
          call    col3 (Om_mag2(1,e), oij(1,e,1), oij(1,e,1),nxyz)
          call   rzero (OiOjSk (1,e),                        nxyz)
       enddo

      endif

      call  cmult (St_mag2, onehalf, ntot) ! St_mag2=2*Sij*Sij=S'ij*S'ij/2

      return
      end
c-----------------------------------------------------------------------

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!This example is derived from an example by Simone Atzeni, NVIDIA.
!
!Description: Race on variable init. The variable is written by the
!master thread and concurrently read by the others.
!
!Solution: master construct at line 23:24 does not have an implicit barrier better
!use single. Data Race Pair, init@24:9 and init@26:17.

program DRB124_master_orig_yes
    use omp_lib
    implicit none

    integer :: init, local

    !$omp parallel shared(init) private(local)
        !$omp master
        init = 10
        !$omp end master
        local = init
    !$omp end parallel

end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!*****************************************************************************
!
!  adi.F90: This file is part of the PolyBench/Fortran 1.0 test suite.
!
!  Contact: Louis-Noel Pouchet <pouchet@cse.ohio-state.edu>
!  Web address: http://polybench.sourceforge.net
!
!*****************************************************************************

!!No data race pairs.

! Include polybench common header.
#include "polybench/fpolybench.h"

! Include benchmark-specific header.
! Default data type is double, default size is 10x1024x1024.
#include "polybench/adi.h"

      program adi
      use omp_lib
      implicit none

      POLYBENCH_2D_ARRAY_DECL(x,DATA_TYPE,500, 500)
      POLYBENCH_2D_ARRAY_DECL(a,DATA_TYPE,500, 500)
      POLYBENCH_2D_ARRAY_DECL(b,DATA_TYPE,500, 500)
      polybench_declare_prevent_dce_vars
      polybench_declare_instruments

!     Allocation of Arrays
      POLYBENCH_ALLOC_2D_ARRAY(x, 500, 500)
      POLYBENCH_ALLOC_2D_ARRAY(a, 500, 500)
      POLYBENCH_ALLOC_2D_ARRAY(b, 500, 500)

!     Initialization
      call init_array(500, x, a, b)

!     Kernel Execution
      polybench_start_instruments

      call kernel_adi(10, 500, x, a, b)

      polybench_stop_instruments
      polybench_print_instruments

!     Prevent dead-code elimination. All live-out data must be printed
!     by the function call in argument.
      polybench_prevent_dce(print_array(500, x));

!     Deallocation of Arrays
      POLYBENCH_DEALLOC_ARRAY(x)
      POLYBENCH_DEALLOC_ARRAY(a)
      POLYBENCH_DEALLOC_ARRAY(b)

      contains

        subroutine init_array(n, x, a, b)
        implicit none

        DATA_TYPE, dimension(n, n) :: a
        DATA_TYPE, dimension(n, n) :: x
        DATA_TYPE, dimension(n, n) :: b
        integer :: n
        integer :: i, j, c1, c2

        if (n >= 1) then
            !$omp parallel do private(c2)
            do c1 = 1, n-1
              do c2 = 1, n-1
                x(c1,c2) = (DBLE(c1) * DBLE(c2+1) + 1.0D0) / DBLE(n)
                a(c1,c2) = (DBLE(c1) * DBLE(c2+2) + 2.0D0) / DBLE(n)
                b(c1,c2) = (DBLE(c1) * DBLE(c2+3) + 3.0D0) / DBLE(n)
              end do
            end do
            !$omp end parallel do
        end if
        end subroutine

!       DCE code. Must scan the entire live-out data.
!       Can be used also to check the correctness of the output.

        subroutine print_array(n, x)
        implicit none

        DATA_TYPE, dimension(n, n) :: x
        integer :: n
        integer :: i, j

        do i = 1, n
          do j = 1, n
            write(0, DATA_PRINTF_MODIFIER) x(i, j)
            if (mod((i * 500 + j), 20) == 0) then
              write(0, *)
            end if
          end do
        end do
        write(0, *)
        end subroutine

!       Main computational kernel. The whole function will be timed,
!       including the call and return.

        subroutine kernel_adi(tsteps, n, x, a, b)
        implicit none

        DATA_TYPE, dimension(n, n) :: a
        DATA_TYPE, dimension(n, n) :: x
        DATA_TYPE, dimension(n, n) :: b
        integer :: n, tsteps
        !integer :: i1, i2, t
        integer :: c0,c2,c8

        do c0 = 1, 10
            !$omp parallel do private (c8)
            do c2 = 1, 500
                do c8 = 2, 500
                    b(c2,c8) = b(c2,c8)-a(c2,c8)*a(c2,c8)/b(c2,c8-1)
                end do

                do c8 = 2, 500
                    x(c2,c8) = x(c2,c8)-x(c2,c8-1)*a(c2,c8)/b(c2,c8-1)
                end do

                do c8 = 1, 498
                    x(c2,500-c8) = (X(c2,500-c8) - X(c2,500-c8-1) * A(c2,500 - c8 - 1)) / B(c2,500 - 1 - c8)
                end do
            end do
            !$omp end parallel do

            !$omp parallel do
            do c2 = 1, 500
                x(c2,499) = x(c2,499)/b(c2,499)
            end do
            !$omp end parallel do

            !$omp parallel do private(c8)
            do c2 = 1, 500
                do c8 = 2, 500
                    b(c8,c2) = b(c8,c2)-a(c8,c2)*a(c8,c2)/b(c8-1,c2)
                end do

                do c8 = 2, 500
                    x(c8,c2) = x(c8,c2)-x(c8-1,c2)*a(c8,c2)/b(c8-1,c2)
                end do

                do c8 = 1, 498
                    X(500 - c8,c2) = (X(500 - c8,c2) - X(500 - c8 - 1,c2) * A(500 - 1 - c8,c2)) / B(500 - c8,c2)
                end do
            end do
            !$omp end parallel do

            !$omp parallel do
            do c2 = 1, 500
                x(500-1,c2) = x(499,c2)/b(499,c2)
            end do
            !$omp end parallel do
        end do

        end subroutine

      end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Example of writing to a file. No data race pairs.

program DRB049_fprintf_orig_no
    use omp_lib
    implicit none

    integer i, ret, len, stat
    integer :: a(1000)
    logical :: exist

    len = 1000

    do i = 1, len
        a(i) = i
    end do

    inquire(file="mytempfile.txt", exist=exist)

    if (exist) then
        open(6, file="mytempfile.txt", iostat=stat, status="old", position="append", action="write")
    else
        open(6, file="mytempfile.txt", iostat=stat, status="new", action="write")
    end if

    !$omp parallel do
    do i = 1, len
        write(6, *) a(i)
    end do
    !$omp end parallel do

    if (stat == 0) close(6, status='delete')

end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Test if atomic can be recognized properly. No data races.

program DRB108_atomic_orig_no
    use omp_lib
    implicit none

    integer a
    a = 0

    !$omp parallel
    !$omp atomic
    a = a+1
    !$omp end atomic
    !$omp end parallel

    print 100, a
    100 format ('a =',3i8)
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!This loop has loop-carried output-dependence due to x=... at line 44.
!The problem can be solved by using lastprivate(x) .
!Data race pair: x@44:9 vs. x@44:9

program DRB010_lastprivatemissing_var_yes
    use omp_lib
    implicit none

    integer :: i, len, argCount, allocStatus, rdErr, x, ix
    character(len=80), dimension(:), allocatable :: args
    len = 10000

    argCount = command_argument_count()
    if (argCount == 0) then
        write (*,'(a)') "No command line arguments provided."
    end if

    allocate(args(argCount), stat=allocStatus)
    if (allocStatus > 0) then
        write (*,'(a)') "Allocation error, program terminated."
        stop
    end if

    do ix = 1, argCount
        call get_command_argument(ix,args(ix))
    end do

    if (argCount >= 1) then
        read (args(1), '(i10)', iostat=rdErr) len
        if (rdErr /= 0 ) then
            write (*,'(a)') "Error, invalid integer value."
        end if
    end if

    !$omp parallel do private(i)
    do i = 0, len
        x = i
    end do
    !$omp end parallel do
    write(*,*) 'x =', x

    deallocate(args)
end program

C> @file intpdiff.f interpolation and differentiation routines not already provided
C> by nek5000
!--------------------------------------------------------------------
! JH061914 propose name change to intpdiff since that is what is in
!          here.
! JH081816 went to local_grad. redimensioned gradu. wish I could use
!          gradm11, but stride
!--------------------------------------------------------------------

      subroutine compute_gradients(e)
      include 'SIZE'
      include 'INPUT'
      include 'DXYZ'
      include 'GEOM'
      include 'SOLN'
      include 'CMTDATA'
      parameter (ldd=lxd*lyd*lzd)
      common /ctmp1/ ur(ldd),us(ldd),ut(ldd),ud(ldd),tu(ldd)

      integer eq,e

!     !  Compute d/dx, d/dy and d/dz of all the cons vars

      nxy1  = lx1*ly1
      nyz1  = ly1*lz1
      nxyz1 = lx1*ly1*lz1
      m0 = lx1-1

      do eq=1,toteq
         call invcol3(ud,u(1,1,1,eq,e),phig(1,1,1,e),nxyz1)

         if (if3d) then
            call local_grad3(ur,us,ut,ud,m0,1,dxm1,dxtm1)
            do i=1,nxyz1
               gradu(i,eq,1) = jacmi(i,e)*(rxm1(i,1,1,e)*ur(i)+
     >                                     sxm1(i,1,1,e)*us(i)+
     >                                     txm1(i,1,1,e)*ut(i))
            enddo
            do i=1,nxyz1
               gradu(i,eq,2) = jacmi(i,e)*(rym1(i,1,1,e)*ur(i)+
     >                                     sym1(i,1,1,e)*us(i)+
     >                                     tym1(i,1,1,e)*ut(i))
            enddo
            do i=1,nxyz1
               gradu(i,eq,3) = jacmi(i,e)*(rzm1(i,1,1,e)*ur(i)+
     >                                     szm1(i,1,1,e)*us(i)+
     >                                     tzm1(i,1,1,e)*ut(i))
            enddo

         else

            call local_grad2(ur,us   ,ud,m0,1,dxm1,dxtm1)
            do i=1,nxyz1
               gradu(i,eq,1) = jacmi(i,e)*(rxm1(i,1,1,e)*ur(i)+
     >                                     sxm1(i,1,1,e)*us(i))
            enddo
            do i=1,nxyz1
               gradu(i,eq,2) = jacmi(i,e)*(rym1(i,1,1,e)*ur(i)+
     >                                     sym1(i,1,1,e)*us(i))
            enddo

         endif

      enddo ! equation loop

      return
      end

!-----------------------------------------------------------------------

      subroutine set_dealias_face

!-----------------------------------------------------------------------
! JH111815 needed for face Jacobian and surface integrals
!-----------------------------------------------------------------------

      include 'SIZE'
      include 'INPUT' ! for if3d
      include 'GEOM'  ! for ifgeom
      include 'TSTEP' ! for istep
      include 'WZ'    ! for wxm1
      include 'DG'    ! for facewz

      integer ilstep
      save    ilstep
      data    ilstep /-1/

      if (.not.ifgeom.and.ilstep.gt.1) return  ! already computed
      if (ifgeom.and.ilstep.eq.istep)  return  ! already computed
      ilstep = istep

      call zwgl(zptf,wgtf,lxd)

      if (if3d) then
         k=0
         do j=1,ly1
         do i=1,lx1
            k=k+1
            wghtc(k)=wxm1(i)*wzm1(j)
         enddo
         enddo
         k=0
         do j=1,lyd
         do i=1,lxd
            k=k+1
            wghtf(k)=wgtf(i)*wgtf(j)
         enddo
         enddo
      else
         call copy(wghtc,wxm1,lx1)
         call copy(wghtf,wgtf,lxd)
      endif

      return
      end
!-----------------------------------------------------------------------

      subroutine set_alias_rx(istp)
! note that set_alias_rx will be called only when lxd = lx1
      include 'SIZE'
      include 'INPUT'
      include 'GEOM'
c     include 'TSTEP' ! for istep

      common /dealias1/ zd(lx1),wd(lx1)
      integer e

      integer ilsp
      save    ilsp
      data    ilsp /-1/

      if (.not.ifgeom.and.ilsp.gt.1) return  ! already computed
      if (ifgeom.and.ilsp.eq.istp)  return  ! already computed
      ilsp = istp
      nxyz = lx1*ly1*lz1
      call zwgll (zd,wd,lx1)  

      if (if3d)then
         do e=1,nelv

            call copy(rx(1,1,e),rxm1(1,1,1,e),nxyz) 
            call copy(rx(1,2,e),rym1(1,1,1,e),nxyz) 
            call copy(rx(1,3,e),rzm1(1,1,1,e),nxyz) 
            call copy(rx(1,4,e),sxm1(1,1,1,e),nxyz) 
            call copy(rx(1,5,e),sym1(1,1,1,e),nxyz) 
            call copy(rx(1,6,e),szm1(1,1,1,e),nxyz) 
            call copy(rx(1,7,e),txm1(1,1,1,e),nxyz) 
            call copy(rx(1,8,e),tym1(1,1,1,e),nxyz) 
            call copy(rx(1,9,e),tzm1(1,1,1,e),nxyz) 

            l = 0
            do k=1,lz1
            do j=1,ly1
            do i=1,lx1
               l = l+1
               w = wd(i)*wd(j)*wd(k)
               do ii=1,9
                  rx(l,ii,e) = w*rx(l,ii,e)
               enddo
            enddo
            enddo
            enddo
            enddo
      else

         do e=1,nelv

c           Interpolate z+ and z- into fine mesh, translate to r-s-t coords

            call copy(rx(1,1,e),rxm1(1,1,1,e),nxyz) 
            call copy(rx(1,2,e),rym1(1,1,1,e),nxyz) 
            call copy(rx(1,3,e),sxm1(1,1,1,e),nxyz) 
            call copy(rx(1,4,e),sym1(1,1,1,e),nxyz) 

            l = 0
            do j=1,ly1
            do i=1,lx1
               l = l+1
               w = wd(i)*wd(j)
               do ii=1,4
                  rx(l,ii,e) = w*rx(l,ii,e)
               enddo
            enddo
            enddo
         enddo

      endif

      return
      end

!-----------------------------------------------------------------------

      subroutine gradm11_t(grad,uxyz,csgn,e) ! grad is incremented, not overwritten
c     source: . gradm1, from navier5.f 
c             . gradm1, from navier5.f 
c     Compute divergence^T of ux,uy,uz -- mesh 1 to mesh 1 (vel. to vel.)
!     single element, but references jacmi and the metrics

      include 'SIZE'
      include 'DXYZ'
      include 'GEOM'
      include 'INPUT'

      parameter (lxyz=lx1*ly1*lz1)
      real grad(lxyz),uxyz(lxyz,ldim)

      common /ctmp1/ ur(lxyz),us(lxyz),ut(lxyz),ud(lxyz),tmp(lxyz)
      real ur,us,ut,tmp

      integer e

      nxyz = lx1*ly1*lz1
      call rzero(ud,nxyz)

      N = lx1-1
      if (if3d) then

         do i=1,lxyz
            ur(i) = jacmi(i,e)*(uxyz(i,1)*rxm1(i,1,1,e)
     >                        + uxyz(i,2)*rym1(i,1,1,e)
     >                        + uxyz(i,3)*rzm1(i,1,1,e) )
            us(i) = jacmi(i,e)*(uxyz(i,1)*sxm1(i,1,1,e)
     >                        + uxyz(i,2)*sym1(i,1,1,e)
     >                        + uxyz(i,3)*szm1(i,1,1,e) )
            ut(i) = jacmi(i,e)*(uxyz(i,1)*txm1(i,1,1,e)
     >                        + uxyz(i,2)*tym1(i,1,1,e)
     >                        + uxyz(i,3)*tzm1(i,1,1,e) )
         enddo
         call local_grad3_t(ud,ur,us,ut,N,1,dxm1,dxtm1,tmp)
      else
         do i=1,lxyz
            ur(i) =jacmi(i,e)*(uxyz(i,1)*rxm1(i,1,1,e)
     >                       + uxyz(i,2)*rym1(i,1,1,e) )
            us(i) =jacmi(i,e)*(uxyz(i,1)*sxm1(i,1,1,e)
     >                       + uxyz(i,2)*sym1(i,1,1,e) )
         enddo
         call local_grad2_t(ud,ur,us,N,1,dxm1,dxtm1,tmp)
      endif
      call cmult(ud,csgn,nxyz)
      call add2(grad,ud,nxyz)

      return
      end

!-----------------------------------------------------------------------

      subroutine gradm1_t(u,ux,uy,uz)
! JH082516 torn bleeding from Lu's dgf3.f. someday you are going to have
!          to vectorize cmt-nek properly.
c     source: . gradm1, from navier5.f 
c             . gradm1, from navier5.f 
c
c     Compute divergence of ux,uy,uz -- mesh 1 to mesh 1 (vel. to vel.)
c
      include 'SIZE'
      include 'DXYZ'
      include 'GEOM'
      include 'INPUT'
c
      parameter (lxyz=lx1*ly1*lz1)
      real ux(lxyz,*),uy(lxyz,*),uz(lxyz,*),u(lxyz,*)

      common /ctmp1/ ur(lxyz),us(lxyz),ut(lxyz),tmp(lxyz)
      real ur,us,ut,tmp

      integer e

      nxyz = lx1*ly1*lz1
      ntot = nxyz*nelt

      N = lx1-1
      do e=1,nelt
         if (if3d) then

            do i=1,lxyz
               ur(i) = jacmi(i,e)*(ux(i,e)*rxm1(i,1,1,e)
     $                           + uy(i,e)*rym1(i,1,1,e)
     $                           + uz(i,e)*rzm1(i,1,1,e) )
               us(i) = jacmi(i,e)*(ux(i,e)*sxm1(i,1,1,e)
     $                           + uy(i,e)*sym1(i,1,1,e)
     $                           + uz(i,e)*szm1(i,1,1,e) )
               ut(i) = jacmi(i,e)*(ux(i,e)*txm1(i,1,1,e)
     $                           + uy(i,e)*tym1(i,1,1,e)
     $                           + uz(i,e)*tzm1(i,1,1,e) )
            enddo
            call local_grad3_t(u,ur,us,ut,N,e,dxm1,dxtm1,tmp)
         else
            do i=1,lxyz
               ur(i) =jacmi(i,e)*(ux(i,e)*rxm1(i,1,1,e)
     $                          + uy(i,e)*rym1(i,1,1,e) )
               us(i) =jacmi(i,e)*(ux(i,e)*sxm1(i,1,1,e)
     $                          + uy(i,e)*sym1(i,1,1,e) )
            enddo
            call local_grad2_t(u,ur,us,N,e,dxm1,dxtm1,tmp)
         endif
      enddo
c
      return
      end

      subroutine print_results(name, class, n1, n2, n3, niter, 
     >               t, mops, optype, verified, npbversion, 
     >               compiletime, cs1, cs2, cs3, cs4, cs5, cs6, cs7)
      
      implicit none
      character name*(*)
      character class*1
      integer   n1, n2, n3, niter, j
      double precision t, mops
      character optype*24, size*15
      logical   verified
      character*(*) npbversion, compiletime, 
     >              cs1, cs2, cs3, cs4, cs5, cs6, cs7
      integer   num_threads, max_threads, i
c$    integer omp_get_num_threads, omp_get_max_threads
c$    external omp_get_num_threads, omp_get_max_threads


      max_threads = 1
c$    max_threads = omp_get_max_threads()

c     figure out number of threads used
      num_threads = 1
c$omp parallel shared(num_threads)
c$omp master
c$    num_threads = omp_get_num_threads()
c$omp end master
c$omp end parallel


         write (*, 2) name
 2       format(//, ' ', A, ' Benchmark Completed.')

         write (*, 3) Class
 3       format(' Class           = ', 12x, a12)

c   If this is not a grid-based problem (EP, FT, CG), then
c   we only print n1, which contains some measure of the
c   problem size. In that case, n2 and n3 are both zero.
c   Otherwise, we print the grid size n1xn2xn3

         if ((n2 .eq. 0) .and. (n3 .eq. 0)) then
            if (name(1:2) .eq. 'EP') then
               write(size, '(f15.0)' ) 2.d0**n1
               j = 15
               if (size(j:j) .eq. '.') j = j - 1
               write (*,42) size(1:j)
 42            format(' Size            = ',9x, a15)
            else
               write (*,44) n1
 44            format(' Size            = ',12x, i12)
            endif
         else
            write (*, 4) n1,n2,n3
 4          format(' Size            =  ',9x, i4,'x',i4,'x',i4)
         endif

         write (*, 5) niter
 5       format(' Iterations      = ', 12x, i12)
         
         write (*, 6) t
 6       format(' Time in seconds = ',12x, f12.2)

         write (*,7) num_threads
 7       format(' Total threads   = ', 12x, i12)
         
         write (*,8) max_threads
 8       format(' Avail threads   = ', 12x, i12)

         if (num_threads .ne. max_threads) write (*,88) 
 88      format(' Warning: Threads used differ from threads available')

         write (*,9) mops
 9       format(' Mop/s total     = ',12x, f12.2)

         write (*,10) mops/float( num_threads )
 10      format(' Mop/s/thread    = ', 12x, f12.2)        

         write(*, 11) optype
 11      format(' Operation type  = ', a24)

         if (verified) then 
            write(*,12) '  SUCCESSFUL'
         else
            write(*,12) 'UNSUCCESSFUL'
         endif
 12      format(' Verification    = ', 12x, a)

         write(*,13) npbversion
 13      format(' Version         = ', 12x, a12)

         write(*,14) compiletime
 14      format(' Compile date    = ', 12x, a12)


         write (*,121) cs1
 121     format(/, ' Compile options:', /, 
     >          '    F77          = ', A)

         write (*,122) cs2
 122     format('    FLINK        = ', A)

         write (*,123) cs3
 123     format('    F_LIB        = ', A)

         write (*,124) cs4
 124     format('    F_INC        = ', A)

         write (*,125) cs5
 125     format('    FFLAGS       = ', A)

         write (*,126) cs6
 126     format('    FLINKFLAGS   = ', A)

         write(*, 127) cs7
 127     format('    RAND         = ', A)
        
         write (*,130)
 130     format(//' Please send all errors/feedbacks to:'//
     >            ' NPB Development Team'/
     >            ' npb@nas.nasa.gov'//)
c 130     format(//' Please send the results of this run to:'//
c     >            ' NPB Development Team '/
c     >            ' Internet: npb@nas.nasa.gov'/
c     >            ' '/
c     >            ' If email is not available, send this to:'//
c     >            ' MS T27A-1'/
c     >            ' NASA Ames Research Center'/
c     >            ' Moffett Field, CA  94035-1000'//
c     >            ' Fax: 650-604-3957'//)


         return
         end

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!A file-scope variable used within a function called by a parallel region.
!Use threadprivate to avoid data races. No data race pairs.

module DRB085
    implicit none
    integer (kind=8) :: sum0, sum1
!$omp threadprivate(sum0)
contains
    subroutine foo(i)
        integer (kind=8) :: i
        sum0=sum0+i
    end subroutine
end module

program DRB085_threadprivate_orig_no
    use omp_lib
    use DRB085
    implicit none

    integer :: len
    integer (kind=8) :: i, sum
    len = 1000
    sum = 0

    !$omp parallel copyin(sum0)
        !$omp do
        do i = 1, len
            call foo(i)
        end do
        !$omp end do
        !$omp critical
        sum = sum+sum0
        !$omp end critical
    !$omp end parallel

    do i = 1, len
        sum1=sum1+i
    end do

    print*,'sum = ',sum,'sum1 =',sum1
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Test if the semantics of omp_get_thread_num() is correctly recognized.
!Thread with id 0 writes numThreads while other threads read it, causing data races.
!Data race pair: numThreads@22 vs. numThreads@24.


program DRB075_getthreadnum_orig_yes
    use omp_lib
    implicit none

    integer :: numThreads
    numThreads = 0

    !$omp parallel
    if ( omp_get_thread_num()==0 ) then
        numThreads = omp_get_num_threads();
    else
        print*,'numThreads =',numThreads
    end if
    !$omp endparallel
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!There is a loop-carried true dependence within the outer level loop.
!Data race pair: b[i][j]@31:13 vs. b[i-1][j-1]@31:22

program DRB031_truedepfirstdimension_orig_yes
    use omp_lib
    implicit none

    integer :: i, j, n, m
    real, dimension(:,:), allocatable :: b

    n = 1000
    m = 1000
    allocate (b(n,m))

    do i = 1, n
        do j = 1, m
            b(i,j) = 0.5
        end do
    end do

    !$omp parallel do private(j)
    do i = 2, n
        do j = 2, m
            b(i,j) = b(i-1, j-1)
        end do
    end do
    !$omp end parallel do

    print 100, b(500,500)
    100 format ('b(500,500) =',F10.6)

    deallocate(b)
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!A loop with loop-carried anti-dependence.
!Data race pair: a[i+1]@49:9 vs. a[i]@49:16

program DRB002_antidep1_var_yes
    use omp_lib
    implicit none
    integer :: i, len, argCount, allocStatus, rdErr, ix
    character(len=80), dimension(:), allocatable :: args
    integer, dimension (:), allocatable :: a
    len = 1000

    argCount = command_argument_count()
    if (argCount == 0) then
        write (*,'(a)') "No command line arguments provided."
    end if

    allocate(args(argCount), stat=allocStatus)
    if (allocStatus > 0) then
        write (*,'(a)') "Allocation error, program terminated."
        stop
    end if

    do ix = 1, argCount
        call get_command_argument(ix,args(ix))
    end do

    if (argCount >= 1) then
        read (args(1), '(i10)', iostat=rdErr) len
        if (rdErr /= 0 ) then
            write (*,'(a)') "Error, invalid integer value."
        end if
    end if

    allocate (a(len))

    do i = 1, len
        a(i) = i
    end do

    !$omp parallel do
    do i = 1, len-1
        a(i) = a(i+1)+1
    end do
    !$omp end parallel do

    deallocate(a)
    deallocate(args)

end program

C> @file face.f low-level initialization drivers. Eventually to be
C> superceded by nek5000 core DG handles and operators.
c-----------------------------------------------------------------------
      subroutine iface_vert_int8cmt(nx,ny,nz,fa,va,jz0,jz1,nel)
      include 'SIZE'
      integer*8 fa(nx*nz,2*ldim,nel),va(0:nx+1,0:ny+1,jz0:jz1,nel)
      integer e,f

      n = nx*nz*2*ldim*nel
      call izero8(fa,n)

      mx1 = nx+2
      my1 = ny+2
      mz1 = nz+2
      if (ldim.eq.2) mz1=1

      nface = 2*ldim
      do e=1,nel
      do f=1,nface
         call facind (kx1,kx2,ky1,ky2,kz1,kz2,nx,ny,nz,f)

         if     (f.eq.1) then ! EB notation
            ky1=ky1-1
            ky2=ky1
         elseif (f.eq.2) then
            kx1=kx1+1
            kx2=kx1
         elseif (f.eq.3) then
            ky1=ky1+1
            ky2=ky1
         elseif (f.eq.4) then
            kx1=kx1-1
            kx2=kx1
         elseif (f.eq.5) then
            kz1=kz1-1
            kz2=kz1
         elseif (f.eq.6) then
            kz1=kz1+1
            kz2=kz1
         endif

         i = 0
         do iz=kz1,kz2
         do iy=ky1,ky2
         do ix=kx1,kx2
            i = i+1
            fa(i,f,e)=va(ix,iy,iz,e)
         enddo
         enddo
         enddo
      enddo
      enddo

      return
      end 

!-----------------------------------------------------------------------

      subroutine setup_cmt_gs(dg_hndl,nx,ny,nz,nel,melg,vertex,gnv,gnf)

!     Global-to-local mapping for gs

      include 'SIZE'
      include 'TOTAL'

      integer   dg_hndl
      integer   vertex(*)

      integer*8 gnv(*),gnf(*),ngv

      common /nekmpi/ mid,mp,nekcomm,nekgroup,nekreal

      mx = nx+2
      call set_vert(gnv,ngv,mx,nel,vertex,.false.) ! lives in navier8.f

      mz0 = 1
      mz1 = 1
      if (if3d) mz0 = 0
      if (if3d) mz1 = nz+1
      call iface_vert_int8cmt(nx,ny,nz,gnf,gnv,mz0,mz1,nelt) 

      nf = nx*nz*2*ldim*nelt !total number of points on faces BETTA BE 4-byte!
      call fgslib_gs_setup(dg_hndl,gnf,nf,nekcomm,np)

      return
      end

!-----------------------------------------------------------------------

      subroutine setup_cmt_commo
      include 'SIZE'
      include 'TOTAL'
      include 'DG'

      parameter(lf=lx1*lz1*2*ldim*lelt)
      common /c_is1/ glo_num_face(lf)
     $             , glo_num_vol((lx1+2)*(ly1+2)*(lz1+2)*lelt)
      integer*8 glo_num_face,glo_num_vol,ngv

      call setup_cmt_gs(dg_hndl,lx1,ly1,lz1,nelt,nelgt,vertex,
     >                  glo_num_vol,glo_num_face)
      call cmt_set_fc_ptr(nelt,lx1,ly1,lz1,ndg_face,iface_flux)

      return
      end

!-----------------------------------------------------------------------

      subroutine cmt_set_fc_ptr(nel,nx,ny,nz,nface,iface)

!     Set up pointer to restrict u to faces ! NOTE: compact
! JH062314 Now 2D so we can strip faces by element and not necessarily
!          from the whole field

      include 'SIZE'
      include 'TOTAL'

      integer nx, ny, nz, nel
      integer nface,iface(nx*nz*2*ldim,*)
      integer e,f,ef

      call dsset(nx,ny,nz) ! set skpdat. lives in connect1.f

      nxyz = nx*ny*nz
      nxz  = nx*nz
      nfpe = 2*ldim
      nxzf = nx*nz*nfpe ! red'd mod to area, unx, etc.

      do e=1,nel
      do f=1,nfpe

         ef     = eface(f)
         js1    = skpdat(1,f)
         jf1    = skpdat(2,f)
         jskip1 = skpdat(3,f)
         js2    = skpdat(4,f)
         jf2    = skpdat(5,f)
         jskip2 = skpdat(6,f)

         i = 0
         do j2=js2,jf2,jskip2
         do j1=js1,jf1,jskip1

            i = i+1
            k = i+nxz*(ef-1)           ! face numbering
            iface(k,e) = j1+nx*(j2-1)  ! cell numbering

         enddo
         enddo

      enddo
      enddo
      nface = nxzf*nel

      return
      end

!-----------------------------------------------------------------------

      subroutine full2face_cmt(nel,nx,ny,nz,iface,faces,vols)

! JH062314 Store face data from nel full elements (volume data). Merely
!          selection for the time being (GLL grid), but if we need to
!          extrapolate to faces (say, from Gauss points), this is where
!          we'd do it.

      include 'SIZE'
      include 'TOTAL'

      integer  nel,nx,ny,nz
      integer  iface(nx*nz*2*ldim,1)
      real     faces(nx*nz   ,2*ldim,nel)
      real     vols (nx,ny,nz       ,1  )
      integer  e,i,j

      n= nx*nz*2*ldim
      do e=1,nel
      do j=1,n
         i=iface(j,e)
         faces(j,1,e) = vols(i,1,1,e)
      enddo
      enddo

      return
      end

!-----------------------------------------------------------------------

      subroutine add_face2full_cmt(nel,nx,ny,nz,iface,vols,faces)

      include 'SIZE'
      include 'TOTAL'

      integer   nel,nx,ny,nz
      integer   iface(nx*nz*2*ldim,*)
      real     faces(nx*nz   ,2*ldim,*  )
      real     vols (nx,ny,nz       ,nel)
      integer  ie,i,j

      n= nx*nz*2*ldim
      do ie=1,nel
      do j=1,n
         i=iface(j,ie)
         vols(i,1,1,ie) = vols(i,1,1,ie)+faces(j,1,ie)
      enddo
      enddo

      return
      end

      subroutine mxm(a,n1,b,n2,c,n3)
      real a(n1,3),b(3,n3),c(n1,n3)
      do j=1,n3
         do i=1,n1
            c(i,j) = a(i,1)*b(1,j) + a(i,2)*b(2,j) + a(i,3)*b(3,j)
         enddo
      enddo
      return
      end

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!To avoid data race, the initialization of the original list item "a" should complete before any
!update of a as a result of the reduction clause. This can be achieved by adding an explicit
!barrier after the assignment a=0@22:9, or by enclosing the assignment a=0@22:9 in a single directive
!or by initializing a@21:7 before the start of the parallel region. No data race pair


program DRB141_reduction_barrier_orig_no
    use omp_lib
    implicit none

    integer :: a, i

    !$omp parallel shared(a) private(i)
        !$omp master
        a = 0
        !$omp end master
        
        !$omp barrier        

        !$omp do reduction(+:a)
        do i = 1, 10
            a = a+i
        end do
        !$omp end do

        !$omp single
        print*, "Sum is ", A
        !$omp end single

    !$omp end parallel
end program

      program adbufferftest
      REAL*8 x,Y(10),px,PY(10)
      INTEGER*8 a,B(20),pa,PB(20)
      INTEGER pc1,pc2,pc3,pc4
      LOGICAL pb1,pb2,pb3
      CHARACTER CC1(3),PCC1(3),PCC2(2)
      INTEGER i,j,k
c
      x = -1.0
      do i=1,10
         Y(i) = i*1.1
      enddo
      a = -1
      do i=1,20
         B(i) = i
      enddo
      CC1(1)='a'
      CC1(2)='b'
      CC1(3)='c'      
c
      call showallstacks()

      call PUSHREAL8(x)
      call PUSHCHARACTERARRAY(CC1,2)
      call PUSHREAL8ARRAY(Y,10)
      call PUSHCONTROL1B(1)
      call PUSHBOOLEAN(.FALSE.)
      call PUSHCONTROL3B(4)
      call PUSHBOOLEAN(.TRUE.)
      call PUSHCONTROL1B(0)
      call PUSHCONTROL5B(14)

      call PUSHBOOLEAN(.TRUE.)
      call PUSHINTEGER8(a)
      call PUSHCHARACTERARRAY(CC1,3)
      call PUSHINTEGER8ARRAY(B,20)

      call showallstacks()

      call POPINTEGER8ARRAY(PB,20)
      print *,'B:',PB

      call LOOKCHARACTERARRAY(PCC1,3)
      print *,'l CC1:',PCC1
      call LOOKINTEGER8(pa)
      print *,'l -1:',pa
      call LOOKBOOLEAN(pb1)
      print *,'l true:',pb1
      call LOOKCONTROL5B(pc1)
      print *,'l 14?:',pc1
      call LOOKCONTROL1B(pc1)
      print *,'l  0?:',pc1
      call PUSHCONTROL5B(7)
      call PUSHCONTROL5B(8)
      call PUSHCONTROL5B(9)
      call PUSHCONTROL5B(10)
      call PUSHCONTROL5B(11)
      call PUSHCONTROL5B(12)
      call PUSHCONTROL5B(13)
      call PUSHCONTROL5B(14)
      call PUSHCONTROL5B(15)
      call PUSHCONTROL5B(16)
      call PUSHCONTROL5B(17)
      call PUSHCONTROL5B(18)
      call PUSHCONTROL5B(19)
      call PUSHCONTROL5B(20)
      call PUSHCONTROL5B(21)
      call PUSHCONTROL5B(22)
      call PUSHCONTROL5B(23)
      call PUSHCONTROL5B(24)
      call PUSHCONTROL5B(25)
      call PUSHCONTROL5B(26)
      call PUSHCONTROL5B(27)

      call PUSHCONTROL5B(28)

      call PRINTALLBUFFERS()

      call LOOKCONTROL5B(pc1)
      print *,'L 28?:',pc1
      call POPCONTROL5B(pc1)
      print *,'28?:',pc1

      call POPCONTROL5B(pc1)
      print *,'27?:',pc1
      call POPCONTROL5B(pc1)
      print *,'26?:',pc1
      call POPCONTROL5B(pc1)
      print *,'25?:',pc1
      call POPCONTROL5B(pc1)
      print *,'24?:',pc1
      call POPCONTROL5B(pc1)
      print *,'23?:',pc1
      call POPCONTROL5B(pc1)
      print *,'22?:',pc1
      call POPCONTROL5B(pc1)
      print *,'21?:',pc1
      call POPCONTROL5B(pc1)
      print *,'20?:',pc1
      call POPCONTROL5B(pc1)
      print *,'19?:',pc1
      call POPCONTROL5B(pc1)
      print *,'18?:',pc1
      call POPCONTROL5B(pc1)
      print *,'17?:',pc1
      call POPCONTROL5B(pc1)
      print *,'16?:',pc1
      call POPCONTROL5B(pc1)
      print *,'15?:',pc1
      call POPCONTROL5B(pc1)
      print *,'14?:',pc1
      call POPCONTROL5B(pc1)
      print *,'13?:',pc1
      call POPCONTROL5B(pc1)
      print *,'12?:',pc1
      call POPCONTROL5B(pc1)
      print *,'11?:',pc1
      call POPCONTROL5B(pc1)
      print *,'10?:',pc1
      call POPCONTROL5B(pc1)
      print *,' 9?:',pc1
      call POPCONTROL5B(pc1)
      print *,' 8?:',pc1
      call POPCONTROL5B(pc1)
      print *,' 7?:',pc1
      call POPCHARACTERARRAY(PCC1,3)
      print *,'CC1:',PCC1
      call POPINTEGER8(pa)
      print *,'-1:',pa
      call POPBOOLEAN(pb1)
      print *,'true:',pb1

      call LOOKCONTROL5B(pc1)
      print *,'L 14?:',pc1
      call LOOKCONTROL1B(pc1)
      print *,'L  0?:',pc1
      call LOOKBOOLEAN(pb1)
      print *,'L true:',pb1
      call LOOKCONTROL3B(pc1)
      print *,'L  4?:',pc1

      call POPCONTROL5B(pc1)
      print *,'14?:',pc1
      call POPCONTROL1B(pc1)
      print *,' 0?:',pc1
      call POPBOOLEAN(pb1)
      print *,'true:',pb1
      call POPCONTROL3B(pc1)
      print *,' 4?:',pc1
      call POPBOOLEAN(pb1)
      print *,'false:',pb1
      call POPCONTROL1B(pc1)
      print *,' 1?:',pc1
      call POPREAL8ARRAY(PY,10)
      print *,'y:',py
      call POPCHARACTERARRAY(PCC2,2)
      print *,'CC2:',PCC2
      call POPREAL8(px)
      print *,'-1.0:',px

      call showallstacks()

      END

      subroutine vprops 
C-----------------------------------------------------------------------
C
C     Set material properties
C
C     Material type: 0 for default  (PARAM and PCOND/PRHOCP)
C                    1 for constant props; 
C                    2 for fortran function;
C
C-----------------------------------------------------------------------
      include 'SIZE'
      include 'INPUT'
      include 'SOLN'
      include 'TSTEP'
      LOGICAL  IFKFLD,IFEFLD
C
      if (nio.eq.0.and.loglevel.gt.2)
     $   write(6,*) 'vprops', ifield

      NXYZ1 = lx1*ly1*lz1
      NEL   = NELFLD(IFIELD)
      NTOT1 = NXYZ1*NEL
C
      IF (ISTEP.EQ.0) THEN
C
C        First time around, set defaults
C
         ifvarp(ifield) = .false.
         if (iflomach) ifvarp(ifield) = .true.

         if (.not.ifvarp(ifield)) then ! check all groups
            do iel=1,nel
               igrp  = igroup(iel)
               itype = matype(igrp,ifield)
               if(itype.ne.0) ifvarp(ifield) = .true.
            enddo
         endif

         itest = 0                        ! test against all processors
         if (ifvarp(ifield)) itest = 1
         itest = iglmax(itest,1)
         if (itest.gt.0) ifvarp(ifield) = .true.

      endif         
C
C     Fill up property arrays every time step
      DO 1000 IEL=1,NEL
C
         IGRP=IGROUP(IEL)

         if (ifuservp) then
C
C           User specified fortran function   (pff 2/13/01)
            CALL NEKUVP (IEL)
            DIFMIN = VLMIN(VDIFF(1,1,1,IEL,IFIELD),NXYZ1)
            IF (DIFMIN .LE. 0.0) THEN
               WRITE (6,100) DIFMIN,IFIELD,IGRP
               CALL EXITT
            endif
C
         ELSE IF(MATYPE(IGRP,IFIELD).EQ.1)THEN
C
C           Constant property within groups of elements
C
            CDIFF  = CPGRP(IGRP,IFIELD,1)
            CTRANS = CPGRP(IGRP,IFIELD,2)
            CALL CFILL(VDIFF (1,1,1,IEL,IFIELD),CDIFF,NXYZ1)
            CALL CFILL(VTRANS(1,1,1,IEL,IFIELD),CTRANS,NXYZ1)
            IF (CDIFF.LE.0.0) THEN
               WRITE(6,100) CDIFF,IFIELD,IGRP
  100          FORMAT(2X,'ERROR:  Non-positive diffusivity ('
     $        ,G12.3,') specified for field',I2,', group',I2
     $        ,' element',I4,'.'
     $        ,/,'ABORTING in VPROPS',//)
               CALL EXITT
            endif
C
         ELSE IF(MATYPE(IGRP,IFIELD).EQ.2)THEN
C
C           User specified fortran function
C
            CALL NEKUVP (IEL)
C
            if(optlevel.le.2) then
              DIFMIN = VLMIN(VDIFF(1,1,1,IEL,IFIELD),NXYZ1)
              IF (DIFMIN .LE. 0.0) THEN
                 WRITE (6,100) DIFMIN,IFIELD,IGRP
                 CALL EXITT
              endif
            endif
C
         ELSE IF(MATYPE(IGRP,IFIELD).EQ.0)THEN
C
C           Default constant property
C
            CDIFF  = CPFLD(IFIELD,1)
            CTRANS = CPFLD(IFIELD,2)
c           write(6,*) 'vdiff:',ifield,cdiff,ctrans
            CALL CFILL(VDIFF (1,1,1,IEL,IFIELD),CDIFF,NXYZ1)
            CALL CFILL(VTRANS(1,1,1,IEL,IFIELD),CTRANS,NXYZ1)
            IF (CDIFF.LE.0.0) THEN
               WRITE(6,200) CDIFF,IFIELD
  200          FORMAT(2X,'ERROR:  Non-positive diffusivity ('
     $        ,G12.3,') specified for field',I2,'.',/
     $        ,'ABORTING in VPROPS',//)
               CALL EXITT
            endif
         endif
C
 1000 CONTINUE
C
      return
      end
C

C$Id: adBuffer.f 5257 2014-07-17 12:45:15Z vmp $

c PISTES D'AMELIORATIONS:
c  Attention aux IF qui peuvent couter cher.
c  On pourrait aussi bufferiser les bits avec N entiers,
c   (1 bit par entier), passer tout le paquet a C et laisser
c   C faire les jongleries de bitsets.
c  On pourrait aussi optimiser en -O3 les primitives de ADFirstAidKit
c  Regarder l'assembleur (option -S (et -o toto.s))
c  Pourchasser les divisions!

      BLOCK DATA LOOKINGORNOT
      LOGICAL looking
      COMMON /lookingfbuf/looking
      DATA looking/.FALSE./
      END

c======================== BITS ==========================:
      BLOCK DATA BITS
      INTEGER*4 adbitbuf, adbitlbuf
      INTEGER adbitibuf, adbitilbuf
      LOGICAL adbitinlbuf
      COMMON /adbitfbuf/adbitbuf,adbitlbuf,
     +       adbitibuf,adbitilbuf,adbitinlbuf
      DATA adbitbuf/0/
      DATA adbitlbuf/0/
      DATA adbitibuf/0/
      DATA adbitilbuf/-1/
      DATA adbitinlbuf/.FALSE./
      END

c [0,31] are the bit indices we can use in an INTEGER

      SUBROUTINE PUSHBIT(bit)
      LOGICAL bit
      INTEGER*4 adbitbuf, adbitlbuf
      INTEGER adbitibuf, adbitilbuf
      LOGICAL adbitinlbuf
      COMMON /adbitfbuf/adbitbuf,adbitlbuf,
     +       adbitibuf,adbitilbuf,adbitinlbuf
      LOGICAL looking
      COMMON /lookingfbuf/looking
c
      IF (adbitilbuf.ne.-1) THEN
         adbitilbuf = -1
         adbitinlbuf = .FALSE.
         looking = .FALSE.
      ENDIF
      IF (bit) THEN
         adbitbuf = IBSET(adbitbuf, adbitibuf)
      ELSE
         adbitbuf = IBCLR(adbitbuf, adbitibuf)
      ENDIF
      IF (adbitibuf.ge.31) THEN
         CALL PUSHINTEGER4(adbitbuf)
         adbitbuf = 0
         adbitibuf = 0
      ELSE
         adbitibuf = adbitibuf+1
      ENDIF
      END

      LOGICAL FUNCTION LOOKBIT()
      INTEGER*4 adbitbuf, adbitlbuf
      INTEGER adbitibuf, adbitilbuf
      LOGICAL adbitinlbuf
      COMMON /adbitfbuf/adbitbuf,adbitlbuf,
     +       adbitibuf,adbitilbuf,adbitinlbuf
      LOGICAL looking
      COMMON /lookingfbuf/looking
c
      IF (adbitilbuf.eq.-1) THEN
         adbitilbuf=adbitibuf
         adbitlbuf = adbitbuf
         IF (.not.looking) THEN
            CALL RESETADLOOKSTACK()
            looking = .TRUE.
         ENDIF
      ENDIF
      IF (adbitilbuf.le.0) THEN
         CALL LOOKINTEGER4(adbitlbuf)
         adbitilbuf = 31
      ELSE
         adbitilbuf = adbitilbuf-1
      ENDIF
      LOOKBIT = BTEST(adbitlbuf, adbitilbuf)
      END

      LOGICAL FUNCTION POPBIT()
      INTEGER*4 adbitbuf, adbitlbuf
      INTEGER adbitibuf, adbitilbuf
      LOGICAL adbitinlbuf
      COMMON /adbitfbuf/adbitbuf,adbitlbuf,
     +       adbitibuf,adbitilbuf,adbitinlbuf
      LOGICAL looking
      COMMON /lookingfbuf/looking
c
      IF (adbitilbuf.ne.-1) THEN
         adbitilbuf = -1
         adbitinlbuf = .FALSE.
         looking = .FALSE.
      ENDIF
      IF (adbitibuf.le.0) THEN
         CALL POPINTEGER4(adbitbuf)
         adbitibuf = 31
      ELSE
         adbitibuf = adbitibuf-1
      ENDIF
      POPBIT = BTEST(adbitbuf, adbitibuf)
      END

c====================== CONTROL =========================:

      SUBROUTINE PUSHCONTROL1B(cc)
      INTEGER cc
      CALL PUSHBIT(cc.ne.0)
      END

      SUBROUTINE POPCONTROL1B(cc)
      INTEGER cc
      LOGICAL POPBIT
      IF (POPBIT()) THEN
         cc = 1
      ELSE
         cc = 0
      ENDIF
      END

      SUBROUTINE LOOKCONTROL1B(cc)
      INTEGER cc
      LOGICAL LOOKBIT
      IF (LOOKBIT()) THEN
         cc = 1
      ELSE
         cc = 0
      ENDIF
      END

      SUBROUTINE PUSHCONTROL2B(cc)
      INTEGER cc
      CALL PUSHBIT(BTEST(cc,0))
      CALL PUSHBIT(BTEST(cc,1))
      END

      SUBROUTINE POPCONTROL2B(cc)
      INTEGER cc
      LOGICAL POPBIT
      IF (POPBIT()) THEN
         cc = 2
      ELSE
         cc = 0
      ENDIF
      IF (POPBIT()) cc = IBSET(cc,0)
      END

      SUBROUTINE LOOKCONTROL2B(cc)
      INTEGER cc
      LOGICAL LOOKBIT
      IF (LOOKBIT()) THEN
         cc = 2
      ELSE
         cc = 0
      ENDIF
      IF (LOOKBIT()) cc = IBSET(cc,0)
      END

      SUBROUTINE PUSHCONTROL3B(cc)
      INTEGER cc
      CALL PUSHBIT(BTEST(cc,0))
      CALL PUSHBIT(BTEST(cc,1))
      CALL PUSHBIT(BTEST(cc,2))
      END

      SUBROUTINE POPCONTROL3B(cc)
      INTEGER cc
      LOGICAL POPBIT
      IF (POPBIT()) THEN
         cc = 4
      ELSE
         cc = 0
      ENDIF
      IF (POPBIT()) cc = IBSET(cc,1)
      IF (POPBIT()) cc = IBSET(cc,0)
      END

      SUBROUTINE LOOKCONTROL3B(cc)
      INTEGER cc
      LOGICAL LOOKBIT
      IF (LOOKBIT()) THEN
         cc = 4
      ELSE
         cc = 0
      ENDIF
      IF (LOOKBIT()) cc = IBSET(cc,1)
      IF (LOOKBIT()) cc = IBSET(cc,0)
      END

      SUBROUTINE PUSHCONTROL4B(cc)
      INTEGER cc
      CALL PUSHBIT(BTEST(cc,0))
      CALL PUSHBIT(BTEST(cc,1))
      CALL PUSHBIT(BTEST(cc,2))
      CALL PUSHBIT(BTEST(cc,3))
      END

      SUBROUTINE POPCONTROL4B(cc)
      INTEGER cc
      LOGICAL POPBIT
      IF (POPBIT()) THEN
         cc = 8
      ELSE
         cc = 0
      ENDIF
      IF (POPBIT()) cc = IBSET(cc,2)
      IF (POPBIT()) cc = IBSET(cc,1)
      IF (POPBIT()) cc = IBSET(cc,0)
      END

      SUBROUTINE LOOKCONTROL4B(cc)
      INTEGER cc
      LOGICAL LOOKBIT
      IF (LOOKBIT()) THEN
         cc = 8
      ELSE
         cc = 0
      ENDIF
      IF (LOOKBIT()) cc = IBSET(cc,2)
      IF (LOOKBIT()) cc = IBSET(cc,1)
      IF (LOOKBIT()) cc = IBSET(cc,0)
      END

      SUBROUTINE PUSHCONTROL5B(cc)
      INTEGER cc
      CALL PUSHBIT(BTEST(cc,0))
      CALL PUSHBIT(BTEST(cc,1))
      CALL PUSHBIT(BTEST(cc,2))
      CALL PUSHBIT(BTEST(cc,3))
      CALL PUSHBIT(BTEST(cc,4))
      END

      SUBROUTINE POPCONTROL5B(cc)
      INTEGER cc
      LOGICAL POPBIT
      IF (POPBIT()) THEN
         cc = 16
      ELSE
         cc = 0
      ENDIF
      IF (POPBIT()) cc = IBSET(cc,3)
      IF (POPBIT()) cc = IBSET(cc,2)
      IF (POPBIT()) cc = IBSET(cc,1)
      IF (POPBIT()) cc = IBSET(cc,0)
      END

      SUBROUTINE LOOKCONTROL5B(cc)
      INTEGER cc
      LOGICAL LOOKBIT
      IF (LOOKBIT()) THEN
         cc = 16
      ELSE
         cc = 0
      ENDIF
      IF (LOOKBIT()) cc = IBSET(cc,3)
      IF (LOOKBIT()) cc = IBSET(cc,2)
      IF (LOOKBIT()) cc = IBSET(cc,1)
      IF (LOOKBIT()) cc = IBSET(cc,0)
      END

      SUBROUTINE PUSHCONTROL6B(cc)
      INTEGER cc
      CALL PUSHBIT(BTEST(cc,0))
      CALL PUSHBIT(BTEST(cc,1))
      CALL PUSHBIT(BTEST(cc,2))
      CALL PUSHBIT(BTEST(cc,3))
      CALL PUSHBIT(BTEST(cc,4))
      CALL PUSHBIT(BTEST(cc,5))
      END

      SUBROUTINE POPCONTROL6B(cc)
      INTEGER cc
      LOGICAL POPBIT
      IF (POPBIT()) THEN
         cc = 16
      ELSE
         cc = 0
      ENDIF
      IF (POPBIT()) cc = IBSET(cc,4)
      IF (POPBIT()) cc = IBSET(cc,3)
      IF (POPBIT()) cc = IBSET(cc,2)
      IF (POPBIT()) cc = IBSET(cc,1)
      IF (POPBIT()) cc = IBSET(cc,0)
      END

      SUBROUTINE LOOKCONTROL6B(cc)
      INTEGER cc
      LOGICAL LOOKBIT
      IF (LOOKBIT()) THEN
         cc = 16
      ELSE
         cc = 0
      ENDIF
      IF (LOOKBIT()) cc = IBSET(cc,4)
      IF (LOOKBIT()) cc = IBSET(cc,3)
      IF (LOOKBIT()) cc = IBSET(cc,2)
      IF (LOOKBIT()) cc = IBSET(cc,1)
      IF (LOOKBIT()) cc = IBSET(cc,0)
      END



      SUBROUTINE PUSHCONTROL9B(cc)
      INTEGER cc
      CALL PUSHBIT(BTEST(cc,0))
      CALL PUSHBIT(BTEST(cc,1))
      CALL PUSHBIT(BTEST(cc,2))
      CALL PUSHBIT(BTEST(cc,3))
      CALL PUSHBIT(BTEST(cc,4))
      CALL PUSHBIT(BTEST(cc,5))
      CALL PUSHBIT(BTEST(cc,6))
      CALL PUSHBIT(BTEST(cc,7))
      CALL PUSHBIT(BTEST(cc,8))
      CALL PUSHBIT(BTEST(cc,9))
      END

      SUBROUTINE POPCONTROL9B(cc)
      INTEGER cc
      LOGICAL POPBIT
      IF (POPBIT()) THEN
         cc = 16
      ELSE
         cc = 0
      ENDIF
      IF (POPBIT()) cc = IBSET(cc,7)
      IF (POPBIT()) cc = IBSET(cc,6)
      IF (POPBIT()) cc = IBSET(cc,5)
      IF (POPBIT()) cc = IBSET(cc,4)
      IF (POPBIT()) cc = IBSET(cc,3)
      IF (POPBIT()) cc = IBSET(cc,2)
      IF (POPBIT()) cc = IBSET(cc,1)
      IF (POPBIT()) cc = IBSET(cc,0)
      END

      SUBROUTINE LOOKCONTROL9B(cc)
      INTEGER cc
      LOGICAL LOOKBIT
      IF (LOOKBIT()) THEN
         cc = 16
      ELSE
         cc = 0
      ENDIF
      IF (LOOKBIT()) cc = IBSET(cc,7)
      IF (LOOKBIT()) cc = IBSET(cc,6)
      IF (LOOKBIT()) cc = IBSET(cc,5)
      IF (LOOKBIT()) cc = IBSET(cc,4)
      IF (LOOKBIT()) cc = IBSET(cc,3)
      IF (LOOKBIT()) cc = IBSET(cc,2)
      IF (LOOKBIT()) cc = IBSET(cc,1)
      IF (LOOKBIT()) cc = IBSET(cc,0)
      END

c======================= BOOLEANS =========================

      SUBROUTINE PUSHBOOLEAN(x)
      LOGICAL x
      CALL PUSHBIT(x)
      END

      SUBROUTINE LOOKBOOLEAN(x)
      LOGICAL x, LOOKBIT
      x = LOOKBIT()
      END

      SUBROUTINE POPBOOLEAN(x)
      LOGICAL x, POPBIT
      x = POPBIT()
      END

c===================== CHARACTERS =======================:
      BLOCK DATA CHARACTERS
      CHARACTER ads1buf(512), ads1lbuf(512)
      INTEGER ads1ibuf,ads1ilbuf
      LOGICAL ads1inlbuf
      COMMON /ads1fbuf/ads1buf,ads1lbuf,
     +       ads1ibuf,ads1ilbuf,ads1inlbuf
      DATA ads1ibuf/1/
      DATA ads1ilbuf/-1/
      DATA ads1inlbuf/.FALSE./
      END

      SUBROUTINE PUSHCHARACTER(x)
      CHARACTER x, ads1buf(512), ads1lbuf(512)
      INTEGER ads1ibuf,ads1ilbuf
      LOGICAL ads1inlbuf
      COMMON /ads1fbuf/ads1buf,ads1lbuf,
     +       ads1ibuf,ads1ilbuf,ads1inlbuf
      LOGICAL looking
      COMMON /lookingfbuf/looking
c
      CALL addftraffic(1)
      IF (ads1ilbuf.ne.-1) THEN
         ads1ilbuf = -1
         ads1inlbuf = .FALSE.
         looking = .FALSE.
      ENDIF
      IF (ads1ibuf.ge.512) THEN
         ads1buf(512) = x
         CALL PUSHCHARACTERARRAY(ads1buf, 512)
      CALL addftraffic(-512)
         ads1ibuf = 1
      ELSE
         ads1buf(ads1ibuf) = x
         ads1ibuf = ads1ibuf+1
      ENDIF
      END

      SUBROUTINE LOOKCHARACTER(x)
      CHARACTER x, ads1buf(512), ads1lbuf(512)
      INTEGER ads1ibuf,ads1ilbuf
      LOGICAL ads1inlbuf
      COMMON /ads1fbuf/ads1buf,ads1lbuf,
     +       ads1ibuf,ads1ilbuf,ads1inlbuf
      LOGICAL looking
      COMMON /lookingfbuf/looking
c
      IF (ads1ilbuf.eq.-1) THEN
         ads1ilbuf=ads1ibuf
         IF (.not.looking) THEN
            CALL RESETADLOOKSTACK()
            looking = .TRUE.
         ENDIF
      ENDIF
      IF (ads1ilbuf.le.1) THEN
         CALL LOOKCHARACTERARRAY(ads1lbuf, 512)
         ads1inlbuf = .TRUE.
         ads1ilbuf = 512
         x = ads1lbuf(512)
      ELSE
         ads1ilbuf = ads1ilbuf-1
         if (ads1inlbuf) THEN
            x = ads1lbuf(ads1ilbuf)
         ELSE
            x = ads1buf(ads1ilbuf)
         ENDIF
      ENDIF
      END

      SUBROUTINE POPCHARACTER(x)
      CHARACTER x, ads1buf(512), ads1lbuf(512)
      INTEGER ads1ibuf,ads1ilbuf
      LOGICAL ads1inlbuf
      COMMON /ads1fbuf/ads1buf,ads1lbuf,
     +       ads1ibuf,ads1ilbuf,ads1inlbuf
      LOGICAL looking
      COMMON /lookingfbuf/looking
c
      IF (ads1ilbuf.ne.-1) THEN
         ads1ilbuf = -1
         ads1inlbuf = .FALSE.
         looking = .FALSE.
      ENDIF
      IF (ads1ibuf.le.1) THEN
         CALL POPCHARACTERARRAY(ads1buf, 512)
         ads1ibuf = 512
         x = ads1buf(512)
      ELSE
         ads1ibuf = ads1ibuf-1
         x = ads1buf(ads1ibuf)
      ENDIF
      END

c======================= INTEGER*4 =========================:
      BLOCK DATA INTEGERS4
      INTEGER*4 adi4buf(512), adi4lbuf(512)
      INTEGER adi4ibuf,adi4ilbuf
      LOGICAL adi4inlbuf
      COMMON /adi4fbuf/adi4buf,adi4lbuf,
     +       adi4ibuf,adi4ilbuf,adi4inlbuf
      DATA adi4ibuf/1/
      DATA adi4ilbuf/-1/
      DATA adi4inlbuf/.FALSE./
      END

      SUBROUTINE PUSHINTEGER4(x)
      INTEGER*4 x, adi4buf(512), adi4lbuf(512)
      INTEGER adi4ibuf,adi4ilbuf
      LOGICAL adi4inlbuf
      COMMON /adi4fbuf/adi4buf,adi4lbuf,
     +       adi4ibuf,adi4ilbuf,adi4inlbuf
      LOGICAL looking
      COMMON /lookingfbuf/looking
c
      CALL addftraffic(4)
      IF (adi4ilbuf.ne.-1) THEN
         adi4ilbuf = -1
         adi4inlbuf = .FALSE.
         looking = .FALSE.
      ENDIF
      IF (adi4ibuf.ge.512) THEN
         adi4buf(512) = x
         CALL PUSHINTEGER4ARRAY(adi4buf, 512)
         CALL addftraffic(-2048)
         adi4ibuf = 1
      ELSE
         adi4buf(adi4ibuf) = x
         adi4ibuf = adi4ibuf+1
      ENDIF
      END

      SUBROUTINE LOOKINTEGER4(x)
      INTEGER*4 x, adi4buf(512), adi4lbuf(512)
      INTEGER adi4ibuf,adi4ilbuf
      LOGICAL adi4inlbuf
      COMMON /adi4fbuf/adi4buf,adi4lbuf,
     +       adi4ibuf,adi4ilbuf,adi4inlbuf
      LOGICAL looking
      COMMON /lookingfbuf/looking
c
      IF (adi4ilbuf.eq.-1) THEN
         adi4ilbuf=adi4ibuf
         IF (.not.looking) THEN
            CALL RESETADLOOKSTACK()
            looking = .TRUE.
         ENDIF
      ENDIF
      IF (adi4ilbuf.le.1) THEN
         CALL LOOKINTEGER4ARRAY(adi4lbuf, 512)
         adi4inlbuf = .TRUE.
         adi4ilbuf = 512
         x = adi4lbuf(512)
      ELSE
         adi4ilbuf = adi4ilbuf-1
         if (adi4inlbuf) THEN
            x = adi4lbuf(adi4ilbuf)
         ELSE
            x = adi4buf(adi4ilbuf)
         ENDIF
      ENDIF
      END

      SUBROUTINE POPINTEGER4(x)
      INTEGER*4 x, adi4buf(512), adi4lbuf(512)
      INTEGER adi4ibuf,adi4ilbuf
      LOGICAL adi4inlbuf
      COMMON /adi4fbuf/adi4buf,adi4lbuf,
     +       adi4ibuf,adi4ilbuf,adi4inlbuf
      LOGICAL looking
      COMMON /lookingfbuf/looking
c
      IF (adi4ilbuf.ne.-1) THEN
         adi4ilbuf = -1
         adi4inlbuf = .FALSE.
         looking = .FALSE.
      ENDIF
      IF (adi4ibuf.le.1) THEN
         CALL POPINTEGER4ARRAY(adi4buf, 512)
         adi4ibuf = 512
         x = adi4buf(512)
      ELSE
         adi4ibuf = adi4ibuf-1
         x = adi4buf(adi4ibuf)
      ENDIF
      END

c======================= INTEGER*8 =========================
      BLOCK DATA INTEGERS8
      INTEGER*8 adi8buf(512), adi8lbuf(512)
      INTEGER adi8ibuf,adi8ilbuf
      LOGICAL adi8inlbuf
      COMMON /adi8fbuf/adi8buf,adi8lbuf,
     +       adi8ibuf,adi8ilbuf,adi8inlbuf
      DATA adi8ibuf/1/
      DATA adi8ilbuf/-1/
      DATA adi8inlbuf/.FALSE./
      END

      SUBROUTINE PUSHINTEGER8(x)
      INTEGER*8 x, adi8buf(512), adi8lbuf(512)
      INTEGER adi8ibuf,adi8ilbuf
      LOGICAL adi8inlbuf
      COMMON /adi8fbuf/adi8buf,adi8lbuf,
     +       adi8ibuf,adi8ilbuf,adi8inlbuf
      LOGICAL looking
      COMMON /lookingfbuf/looking
c
      CALL addftraffic(8)
      IF (adi8ilbuf.ne.-1) THEN
         adi8ilbuf = -1
         adi8inlbuf = .FALSE.
         looking = .FALSE.
      ENDIF
      IF (adi8ibuf.ge.512) THEN
         adi8buf(512) = x
         CALL PUSHINTEGER8ARRAY(adi8buf, 512)
      CALL addftraffic(-4096)
         adi8ibuf = 1
      ELSE
         adi8buf(adi8ibuf) = x
         adi8ibuf = adi8ibuf+1
      ENDIF
      END

      SUBROUTINE LOOKINTEGER8(x)
      INTEGER*8 x, adi8buf(512), adi8lbuf(512)
      INTEGER adi8ibuf,adi8ilbuf
      LOGICAL adi8inlbuf
      COMMON /adi8fbuf/adi8buf,adi8lbuf,
     +       adi8ibuf,adi8ilbuf,adi8inlbuf
      LOGICAL looking
      COMMON /lookingfbuf/looking
c
      IF (adi8ilbuf.eq.-1) THEN
         adi8ilbuf=adi8ibuf
         IF (.not.looking) THEN
            CALL RESETADLOOKSTACK()
            looking = .TRUE.
         ENDIF
      ENDIF
      IF (adi8ilbuf.le.1) THEN
         CALL LOOKINTEGER8ARRAY(adi8lbuf, 512)
         adi8inlbuf = .TRUE.
         adi8ilbuf = 512
         x = adi8lbuf(512)
      ELSE
         adi8ilbuf = adi8ilbuf-1
         if (adi8inlbuf) THEN
            x = adi8lbuf(adi8ilbuf)
         ELSE
            x = adi8buf(adi8ilbuf)
         ENDIF
      ENDIF
      END

      SUBROUTINE POPINTEGER8(x)
      INTEGER*8 x, adi8buf(512), adi8lbuf(512)
      INTEGER adi8ibuf,adi8ilbuf
      LOGICAL adi8inlbuf
      COMMON /adi8fbuf/adi8buf,adi8lbuf,
     +       adi8ibuf,adi8ilbuf,adi8inlbuf
      LOGICAL looking
      COMMON /lookingfbuf/looking
c
      IF (adi8ilbuf.ne.-1) THEN
         adi8ilbuf = -1
         adi8inlbuf = .FALSE.
         looking = .FALSE.
      ENDIF
      IF (adi8ibuf.le.1) THEN
         CALL POPINTEGER8ARRAY(adi8buf, 512)
         adi8ibuf = 512
         x = adi8buf(512)
      ELSE
         adi8ibuf = adi8ibuf-1
         x = adi8buf(adi8ibuf)
      ENDIF
      END

c======================= REAL*4 =========================
      BLOCK DATA REALS4
      REAL*4 adr4buf(512), adr4lbuf(512)
      INTEGER adr4ibuf,adr4ilbuf
      LOGICAL adr4inlbuf
      COMMON /adr4fbuf/adr4buf,adr4lbuf,
     +       adr4ibuf,adr4ilbuf,adr4inlbuf
      DATA adr4ibuf/1/
      DATA adr4ilbuf/-1/
      DATA adr4inlbuf/.FALSE./
      END

      SUBROUTINE PUSHREAL4(x)
      REAL*4 x, adr4buf(512), adr4lbuf(512)
      INTEGER adr4ibuf,adr4ilbuf
      LOGICAL adr4inlbuf
      COMMON /adr4fbuf/adr4buf,adr4lbuf,
     +       adr4ibuf,adr4ilbuf,adr4inlbuf
      LOGICAL looking
      COMMON /lookingfbuf/looking
c
      CALL addftraffic(4)
      IF (adr4ilbuf.ne.-1) THEN
         adr4ilbuf = -1
         adr4inlbuf = .FALSE.
         looking = .FALSE.
      ENDIF
      IF (adr4ibuf.ge.512) THEN
         adr4buf(512) = x
         CALL PUSHREAL4ARRAY(adr4buf, 512)
      CALL addftraffic(-2048)
         adr4ibuf = 1
      ELSE
         adr4buf(adr4ibuf) = x
         adr4ibuf = adr4ibuf+1
      ENDIF
      END

      SUBROUTINE LOOKREAL4(x)
      REAL*4 x, adr4buf(512), adr4lbuf(512)
      INTEGER adr4ibuf,adr4ilbuf
      LOGICAL adr4inlbuf
      COMMON /adr4fbuf/adr4buf,adr4lbuf,
     +       adr4ibuf,adr4ilbuf,adr4inlbuf
      LOGICAL looking
      COMMON /lookingfbuf/looking
c
      IF (adr4ilbuf.eq.-1) THEN
         adr4ilbuf=adr4ibuf
         IF (.not.looking) THEN
            CALL RESETADLOOKSTACK()
            looking = .TRUE.
         ENDIF
      ENDIF
      IF (adr4ilbuf.le.1) THEN
         CALL LOOKREAL4ARRAY(adr4lbuf, 512)
         adr4inlbuf = .TRUE.
         adr4ilbuf = 512
         x = adr4lbuf(512)
      ELSE
         adr4ilbuf = adr4ilbuf-1
         if (adr4inlbuf) THEN
            x = adr4lbuf(adr4ilbuf)
         ELSE
            x = adr4buf(adr4ilbuf)
         ENDIF
      ENDIF
      END

      SUBROUTINE POPREAL4(x)
      REAL*4 x, adr4buf(512), adr4lbuf(512)
      INTEGER adr4ibuf,adr4ilbuf
      LOGICAL adr4inlbuf
      COMMON /adr4fbuf/adr4buf,adr4lbuf,
     +       adr4ibuf,adr4ilbuf,adr4inlbuf
      LOGICAL looking
      COMMON /lookingfbuf/looking
c
      IF (adr4ilbuf.ne.-1) THEN
         adr4ilbuf = -1
         adr4inlbuf = .FALSE.
         looking = .FALSE.
      ENDIF
      IF (adr4ibuf.le.1) THEN
         CALL POPREAL4ARRAY(adr4buf, 512)
         adr4ibuf = 512
         x = adr4buf(512)
      ELSE
         adr4ibuf = adr4ibuf-1
         x = adr4buf(adr4ibuf)
      ENDIF
      END

c======================= REAL*8 =========================
      BLOCK DATA REALS8
      REAL*8 adr8buf(512), adr8lbuf(512)
      INTEGER adr8ibuf,adr8ilbuf
      LOGICAL adr8inlbuf
      COMMON /adr8fbuf/adr8buf,adr8lbuf,
     +       adr8ibuf,adr8ilbuf,adr8inlbuf
      DATA adr8ibuf/1/
      DATA adr8ilbuf/-1/
      DATA adr8inlbuf/.FALSE./
      END

      SUBROUTINE PUSHREAL8(x)
      REAL*8 x, adr8buf(512), adr8lbuf(512)
      INTEGER adr8ibuf,adr8ilbuf
      LOGICAL adr8inlbuf
      COMMON /adr8fbuf/adr8buf,adr8lbuf,
     +       adr8ibuf,adr8ilbuf,adr8inlbuf
      LOGICAL looking
      COMMON /lookingfbuf/looking
c
      CALL addftraffic(8)
      IF (adr8ilbuf.ne.-1) THEN
         adr8ilbuf = -1
         adr8inlbuf = .FALSE.
         looking = .FALSE.
      ENDIF
      IF (adr8ibuf.ge.512) THEN
         adr8buf(512) = x
         CALL PUSHREAL8ARRAY(adr8buf, 512)
      CALL addftraffic(-4096)
         adr8ibuf = 1
      ELSE
         adr8buf(adr8ibuf) = x
         adr8ibuf = adr8ibuf+1
      ENDIF
      END

      SUBROUTINE LOOKREAL8(x)
      REAL*8 x, adr8buf(512), adr8lbuf(512)
      INTEGER adr8ibuf,adr8ilbuf
      LOGICAL adr8inlbuf
      COMMON /adr8fbuf/adr8buf,adr8lbuf,
     +       adr8ibuf,adr8ilbuf,adr8inlbuf
      LOGICAL looking
      COMMON /lookingfbuf/looking
c
      IF (adr8ilbuf.eq.-1) THEN
         adr8ilbuf=adr8ibuf
         IF (.not.looking) THEN
            CALL RESETADLOOKSTACK()
            looking = .TRUE.
         ENDIF
      ENDIF
      IF (adr8ilbuf.le.1) THEN
         CALL LOOKREAL8ARRAY(adr8lbuf, 512)
         adr8inlbuf = .TRUE.
         adr8ilbuf = 512
         x = adr8lbuf(512)
      ELSE
         adr8ilbuf = adr8ilbuf-1
         if (adr8inlbuf) THEN
            x = adr8lbuf(adr8ilbuf)
         ELSE
            x = adr8buf(adr8ilbuf)
         ENDIF
      ENDIF
      END

      SUBROUTINE POPREAL8(x)
      REAL*8 x, adr8buf(512), adr8lbuf(512)
      INTEGER adr8ibuf,adr8ilbuf
      LOGICAL adr8inlbuf
      COMMON /adr8fbuf/adr8buf,adr8lbuf,
     +       adr8ibuf,adr8ilbuf,adr8inlbuf
      LOGICAL looking
      COMMON /lookingfbuf/looking
c
      IF (adr8ilbuf.ne.-1) THEN
         adr8ilbuf = -1
         adr8inlbuf = .FALSE.
         looking = .FALSE.
      ENDIF
      IF (adr8ibuf.le.1) THEN
         CALL POPREAL8ARRAY(adr8buf, 512)
         adr8ibuf = 512
         x = adr8buf(512)
      ELSE
         adr8ibuf = adr8ibuf-1
         x = adr8buf(adr8ibuf)
      ENDIF
      END

c======================= COMPLEX*8 =========================
      BLOCK DATA COMPLEXS8
      COMPLEX*8 adc8buf(512), adc8lbuf(512)
      INTEGER adc8ibuf,adc8ilbuf
      LOGICAL adc8inlbuf
      COMMON /adc8fbuf/adc8buf,adc8lbuf,
     +       adc8ibuf,adc8ilbuf,adc8inlbuf
      DATA adc8ibuf/1/
      DATA adc8ilbuf/-1/
      DATA adc8inlbuf/.FALSE./
      END

      SUBROUTINE PUSHCOMPLEX8(x)
      COMPLEX*8 x, adc8buf(512), adc8lbuf(512)
      INTEGER adc8ibuf,adc8ilbuf
      LOGICAL adc8inlbuf
      COMMON /adc8fbuf/adc8buf,adc8lbuf,
     +       adc8ibuf,adc8ilbuf,adc8inlbuf
      LOGICAL looking
      COMMON /lookingfbuf/looking
c
      CALL addftraffic(8)
      IF (adc8ilbuf.ne.-1) THEN
         adc8ilbuf = -1
         adc8inlbuf = .FALSE.
         looking = .FALSE.
      ENDIF
      IF (adc8ibuf.ge.512) THEN
         adc8buf(512) = x
         CALL PUSHCOMPLEX8ARRAY(adc8buf, 512)
      CALL addftraffic(-4096)
         adc8ibuf = 1
      ELSE
         adc8buf(adc8ibuf) = x
         adc8ibuf = adc8ibuf+1
      ENDIF
      END

      SUBROUTINE LOOKCOMPLEX8(x)
      COMPLEX*8 x, adc8buf(512), adc8lbuf(512)
      INTEGER adc8ibuf,adc8ilbuf
      LOGICAL adc8inlbuf
      COMMON /adc8fbuf/adc8buf,adc8lbuf,
     +       adc8ibuf,adc8ilbuf,adc8inlbuf
      LOGICAL looking
      COMMON /lookingfbuf/looking
c
      IF (adc8ilbuf.eq.-1) THEN
         adc8ilbuf=adc8ibuf
         IF (.not.looking) THEN
            CALL RESETADLOOKSTACK()
            looking = .TRUE.
         ENDIF
      ENDIF
      IF (adc8ilbuf.le.1) THEN
         CALL LOOKCOMPLEX8ARRAY(adc8lbuf, 512)
         adc8inlbuf = .TRUE.
         adc8ilbuf = 512
         x = adc8lbuf(512)
      ELSE
         adc8ilbuf = adc8ilbuf-1
         if (adc8inlbuf) THEN
            x = adc8lbuf(adc8ilbuf)
         ELSE
            x = adc8buf(adc8ilbuf)
         ENDIF
      ENDIF
      END

      SUBROUTINE POPCOMPLEX8(x)
      COMPLEX*8 x, adc8buf(512), adc8lbuf(512)
      INTEGER adc8ibuf,adc8ilbuf
      LOGICAL adc8inlbuf
      COMMON /adc8fbuf/adc8buf,adc8lbuf,
     +       adc8ibuf,adc8ilbuf,adc8inlbuf
      LOGICAL looking
      COMMON /lookingfbuf/looking
c
      IF (adc8ilbuf.ne.-1) THEN
         adc8ilbuf = -1
         adc8inlbuf = .FALSE.
         looking = .FALSE.
      ENDIF
      IF (adc8ibuf.le.1) THEN
         CALL POPCOMPLEX8ARRAY(adc8buf, 512)
         adc8ibuf = 512
         x = adc8buf(512)
      ELSE
         adc8ibuf = adc8ibuf-1
         x = adc8buf(adc8ibuf)
      ENDIF
      END

c======================= COMPLEX*16 =========================
      BLOCK DATA COMPLEXS16
      COMPLEX*16 adc16buf(512), adc16lbuf(512)
      INTEGER adc16ibuf,adc16ilbuf
      LOGICAL adc16inlbuf
      COMMON /adc16fbuf/adc16buf,adc16lbuf,
     +       adc16ibuf,adc16ilbuf,adc16inlbuf
      DATA adc16ibuf/1/
      DATA adc16ilbuf/-1/
      DATA adc16inlbuf/.FALSE./
      END

      SUBROUTINE PUSHCOMPLEX16(x)
      COMPLEX*16 x, adc16buf(512), adc16lbuf(512)
      INTEGER adc16ibuf,adc16ilbuf
      LOGICAL adc16inlbuf
      COMMON /adc16fbuf/adc16buf,adc16lbuf,
     +       adc16ibuf,adc16ilbuf,adc16inlbuf
      LOGICAL looking
      COMMON /lookingfbuf/looking
c
      CALL addftraffic(16)
      IF (adc16ilbuf.ne.-1) THEN
         adc16ilbuf = -1
         adc16inlbuf = .FALSE.
         looking = .FALSE.
      ENDIF
      IF (adc16ibuf.ge.512) THEN
         adc16buf(512) = x
         CALL PUSHCOMPLEX16ARRAY(adc16buf, 512)
      CALL addftraffic(-8192)
         adc16ibuf = 1
      ELSE
         adc16buf(adc16ibuf) = x
         adc16ibuf = adc16ibuf+1
      ENDIF
      END

      SUBROUTINE LOOKCOMPLEX16(x)
      COMPLEX*16 x, adc16buf(512), adc16lbuf(512)
      INTEGER adc16ibuf,adc16ilbuf
      LOGICAL adc16inlbuf
      COMMON /adc16fbuf/adc16buf,adc16lbuf,
     +       adc16ibuf,adc16ilbuf,adc16inlbuf
      LOGICAL looking
      COMMON /lookingfbuf/looking
c
      IF (adc16ilbuf.eq.-1) THEN
         adc16ilbuf=adc16ibuf
         IF (.not.looking) THEN
            CALL RESETADLOOKSTACK()
            looking = .TRUE.
         ENDIF
      ENDIF
      IF (adc16ilbuf.le.1) THEN
         CALL LOOKCOMPLEX16ARRAY(adc16lbuf, 512)
         adc16inlbuf = .TRUE.
         adc16ilbuf = 512
         x = adc16lbuf(512)
      ELSE
         adc16ilbuf = adc16ilbuf-1
         if (adc16inlbuf) THEN
            x = adc16lbuf(adc16ilbuf)
         ELSE
            x = adc16buf(adc16ilbuf)
         ENDIF
      ENDIF
      END

      SUBROUTINE POPCOMPLEX16(x)
      COMPLEX*16 x, adc16buf(512), adc16lbuf(512)
      INTEGER adc16ibuf,adc16ilbuf
      LOGICAL adc16inlbuf
      COMMON /adc16fbuf/adc16buf,adc16lbuf,
     +       adc16ibuf,adc16ilbuf,adc16inlbuf
      LOGICAL looking
      COMMON /lookingfbuf/looking
c
      IF (adc16ilbuf.ne.-1) THEN
         adc16ilbuf = -1
         adc16inlbuf = .FALSE.
         looking = .FALSE.
      ENDIF
      IF (adc16ibuf.le.1) THEN
         CALL POPCOMPLEX16ARRAY(adc16buf, 512)
         adc16ibuf = 512
         x = adc16buf(512)
      ELSE
         adc16ibuf = adc16ibuf-1
         x = adc16buf(adc16ibuf)
      ENDIF
      END

C=========== MEASUREMENT OF PUSH/POP TRAFFIC ==========

      BLOCK DATA MEMTRAFFIC
      INTEGER*8 mmftraffic,mmftrafficM
      COMMON /mmcomtraffic/mmftraffic,mmftrafficM
      DATA mmftraffic/0/
      DATA mmftrafficM/0/
      END

      subroutine addftraffic(n)
      INTEGER n
      INTEGER*8 mmftraffic,mmftrafficM
      COMMON /mmcomtraffic/mmftraffic,mmftrafficM
c
      mmftraffic = mmftraffic+n
      if (mmftraffic.ge.1000000) then
 100     mmftraffic = mmftraffic-1000000
         mmftrafficM = mmftrafficM+1
         if (mmftraffic.ge.1000000) then
            goto 100
         else
            goto 300
         endif
      else if (mmftraffic.lt.0) then
 200     mmftraffic = mmftraffic+1000000
         mmftrafficM = mmftrafficM-1
         if (mmftraffic.lt.0) then
            goto 200
         else
            goto 300
         endif
      endif
 300  continue
      END

      SUBROUTINE PRINTTRAFFIC()
      INTEGER*8 mmftraffic,mmftrafficM
      COMMON /mmcomtraffic/mmftraffic,mmftrafficM
      CALL printctraffic()
      CALL printftrafficinc(mmftrafficM, 1000000, mmftraffic)
      CALL printtotaltraffic(mmftrafficM, 1000000, mmftraffic)
c       write (6,1001) ' F Traffic: ',mmftrafficM,' Mb and ',
c      +     (((mmftraffic*1000)/1024)*1000)/1024, ' millionths'
c 1001  format(a,i6,a,i6,a)
      END

C ============ PRINTING THE SIZE OF STACKS AND BUFFERS ==========

      SUBROUTINE PRINTBUFFERTOP()
      integer*4 SMALLSTACKSIZE
      integer*4 size

      size = SMALLSTACKSIZE()
      print *,'Buffer size:',size,' bytes i.e. ',size/1024.0,' Kbytes'
      END

      FUNCTION SMALLSTACKSIZE()
      CHARACTER ads1buf(512), ads1lbuf(512)
      INTEGER ads1ibuf,ads1ilbuf
      LOGICAL ads1inlbuf
      COMMON /ads1fbuf/ads1buf,ads1lbuf,
     +       ads1ibuf,ads1ilbuf,ads1inlbuf
c      LOGICAL adl4buf(512), adl4lbuf(512)
c      INTEGER adl4ibuf,adl4ilbuf
c      LOGICAL adl4inlbuf
c      COMMON /adl4fbuf/adl4buf,adl4lbuf,
c     +       adl4ibuf,adl4ilbuf,adl4inlbuf
      INTEGER*4 adi4buf(512), adi4lbuf(512)
      INTEGER adi4ibuf,adi4ilbuf
      LOGICAL adi4inlbuf
      COMMON /adi4fbuf/adi4buf,adi4lbuf,
     +       adi4ibuf,adi4ilbuf,adi4inlbuf
      INTEGER*8 adi8buf(512), adi8lbuf(512)
      INTEGER adi8ibuf,adi8ilbuf
      LOGICAL adi8inlbuf
      COMMON /adi8fbuf/adi8buf,adi8lbuf,
     +       adi8ibuf,adi8ilbuf,adi8inlbuf
c           INTEGER*16 adi16buf(512), adi16lbuf(512)
c           INTEGER adi16ibuf,adi16ilbuf
c           LOGICAL adi16inlbuf
c           COMMON /adi16fbuf/adi16buf,adi16lbuf,
c          +       adi16ibuf,adi16ilbuf,adi16inlbuf
      REAL*4 adr4buf(512), adr4lbuf(512)
      INTEGER adr4ibuf,adr4ilbuf
      LOGICAL adr4inlbuf
      COMMON /adr4fbuf/adr4buf,adr4lbuf,
     +       adr4ibuf,adr4ilbuf,adr4inlbuf
      REAL*8 adr8buf(512), adr8lbuf(512)
      INTEGER adr8ibuf,adr8ilbuf
      LOGICAL adr8inlbuf
      COMMON /adr8fbuf/adr8buf,adr8lbuf,
     +       adr8ibuf,adr8ilbuf,adr8inlbuf
c           REAL*16 adr16buf(512), adr16lbuf(512)
c           INTEGER adr16ibuf,adr16ilbuf
c           LOGICAL adr16inlbuf
c           COMMON /adr16fbuf/adr16buf,adr16lbuf,
c          +       adr16ibuf,adr16ilbuf,adr16inlbuf
c           REAL*32 x, adr32buf(512), adr32lbuf(512)
c           INTEGER adr32ibuf,adr32ilbuf
c           LOGICAL adr32inlbuf
c           COMMON /adr32fbuf/adr32buf,adr32lbuf,
c          +       adr32ibuf,adr32ilbuf,adr32inlbuf
c           COMPLEX*4 adc4buf(512), adc4lbuf(512)
c           INTEGER adc4ibuf,adc4ilbuf
c           LOGICAL adc4inlbuf
c           COMMON /adc4fbuf/adc4buf,adc4lbuf,
c          +       adc4ibuf,adc4ilbuf,adc4inlbuf
      COMPLEX*8 adc8buf(512), adc8lbuf(512)
      INTEGER adc8ibuf,adc8ilbuf
      LOGICAL adc8inlbuf
      COMMON /adc8fbuf/adc8buf,adc8lbuf,
     +       adc8ibuf,adc8ilbuf,adc8inlbuf
      COMPLEX*16 adc16buf(512), adc16lbuf(512)
      INTEGER adc16ibuf,adc16ilbuf
      LOGICAL adc16inlbuf
      COMMON /adc16fbuf/adc16buf,adc16lbuf,
     +       adc16ibuf,adc16ilbuf,adc16inlbuf
c           COMPLEX*32 adc32buf(512), adc32lbuf(512)
c           INTEGER adc32ibuf,adc32ilbuf
c           LOGICAL adc32inlbuf
c           COMMON /adc32fbuf/adc32buf,adc32lbuf,
c          +       adc32ibuf,adc32ilbuf,adc32inlbuf
      integer*4 smallstacksize
c     
      smallstacksize = 0
      smallstacksize = smallstacksize + (ads1ibuf-1)*1
c           smallstacksize = smallstacksize + (adl4ibuf-1)*4
      smallstacksize = smallstacksize + (adi4ibuf-1)*4
      smallstacksize = smallstacksize + (adi8ibuf-1)*8
c           smallstacksize = smallstacksize + (adi16ibuf-1)*16
      smallstacksize = smallstacksize + (adr4ibuf-1)*4
      smallstacksize = smallstacksize + (adr8ibuf-1)*8
c           smallstacksize = smallstacksize + (adr16ibuf-1)*16
c           smallstacksize = smallstacksize + (adr32ibuf-1)*32
c           smallstacksize = smallstacksize + (adc4ibuf-1)*4
      smallstacksize = smallstacksize + (adc8ibuf-1)*8
      smallstacksize = smallstacksize + (adc16ibuf-1)*16
c           smallstacksize = smallstacksize + (adc32ibuf-1)*32
c
      end

c Very complete display of the current size of the
c  push/look/pop local Fortran stacks and global C stack.
      SUBROUTINE PRINTALLBUFFERS()
      CHARACTER ads1buf(512), ads1lbuf(512)
      INTEGER ads1ibuf,ads1ilbuf
      LOGICAL ads1inlbuf
      COMMON /ads1fbuf/ads1buf,ads1lbuf,
     +       ads1ibuf,ads1ilbuf,ads1inlbuf
c      LOGICAL adl4buf(512), adl4lbuf(512)
c      INTEGER adl4ibuf,adl4ilbuf
c      LOGICAL adl4inlbuf
c      COMMON /adl4fbuf/adl4buf,adl4lbuf,
c     +       adl4ibuf,adl4ilbuf,adl4inlbuf
      INTEGER*4 adi4buf(512), adi4lbuf(512)
      INTEGER adi4ibuf,adi4ilbuf
      LOGICAL adi4inlbuf
      COMMON /adi4fbuf/adi4buf,adi4lbuf,
     +       adi4ibuf,adi4ilbuf,adi4inlbuf
      INTEGER*8 adi8buf(512), adi8lbuf(512)
      INTEGER adi8ibuf,adi8ilbuf
      LOGICAL adi8inlbuf
      COMMON /adi8fbuf/adi8buf,adi8lbuf,
     +       adi8ibuf,adi8ilbuf,adi8inlbuf
c           INTEGER*16 adi16buf(512), adi16lbuf(512)
c           INTEGER adi16ibuf,adi16ilbuf
c           LOGICAL adi16inlbuf
c           COMMON /adi16fbuf/adi16buf,adi16lbuf,
c          +       adi16ibuf,adi16ilbuf,adi16inlbuf
      REAL*4 adr4buf(512), adr4lbuf(512)
      INTEGER adr4ibuf,adr4ilbuf
      LOGICAL adr4inlbuf
      COMMON /adr4fbuf/adr4buf,adr4lbuf,
     +       adr4ibuf,adr4ilbuf,adr4inlbuf
      REAL*8 adr8buf(512), adr8lbuf(512)
      INTEGER adr8ibuf,adr8ilbuf
      LOGICAL adr8inlbuf
      COMMON /adr8fbuf/adr8buf,adr8lbuf,
     +       adr8ibuf,adr8ilbuf,adr8inlbuf
c           REAL*16 adr16buf(512), adr16lbuf(512)
c           INTEGER adr16ibuf,adr16ilbuf
c           LOGICAL adr16inlbuf
c           COMMON /adr16fbuf/adr16buf,adr16lbuf,
c          +       adr16ibuf,adr16ilbuf,adr16inlbuf
c           REAL*32 x, adr32buf(512), adr32lbuf(512)
c           INTEGER adr32ibuf,adr32ilbuf
c           LOGICAL adr32inlbuf
c           COMMON /adr32fbuf/adr32buf,adr32lbuf,
c          +       adr32ibuf,adr32ilbuf,adr32inlbuf
c           COMPLEX*4 adc4buf(512), adc4lbuf(512)
c           INTEGER adc4ibuf,adc4ilbuf
c           LOGICAL adc4inlbuf
c           COMMON /adc4fbuf/adc4buf,adc4lbuf,
c          +       adc4ibuf,adc4ilbuf,adc4inlbuf
      COMPLEX*8 adc8buf(512), adc8lbuf(512)
      INTEGER adc8ibuf,adc8ilbuf
      LOGICAL adc8inlbuf
      COMMON /adc8fbuf/adc8buf,adc8lbuf,
     +       adc8ibuf,adc8ilbuf,adc8inlbuf
      COMPLEX*16 adc16buf(512), adc16lbuf(512)
      INTEGER adc16ibuf,adc16ilbuf
      LOGICAL adc16inlbuf
      COMMON /adc16fbuf/adc16buf,adc16lbuf,
     +       adc16ibuf,adc16ilbuf,adc16inlbuf
c           COMPLEX*32 adc32buf(512), adc32lbuf(512)
c           INTEGER adc32ibuf,adc32ilbuf
c           LOGICAL adc32inlbuf
c           COMMON /adc32fbuf/adc32buf,adc32lbuf,
c          +       adc32ibuf,adc32ilbuf,adc32inlbuf
      integer*4 bsize,lookbsize
      integer*4 cblocks, csize, lookcblocks, lookcsize
c     
      call getbigcsizes(cblocks,csize,lookcblocks,lookcsize)
      write (6,'(a,i8,a,i5,a,i8,a,i5,a)')
     +     'MAIN C stack size :',cblocks,'B +',csize,
     +     ' bytes (looking:',lookcblocks,'B +',lookcsize,')'
      bsize = (ads1ibuf-1)*1
      lookbsize = -999
      if (ads1inlbuf.or.ads1ilbuf.gt.-1) lookbsize=(ads1ilbuf-1)*1
      write (6,'(a,i4,a,i4,a)') ' plus CHARs    :',bsize,
     +     ' bytes (looking:',lookbsize,')'
c           bsize = (adl4ibuf-1)*4
      bsize = (adi4ibuf-1)*4
      lookbsize = -999
      if (adi4inlbuf.or.adi4ilbuf.gt.-1) lookbsize=(adi4ilbuf-1)*4
      write (6,'(a,i4,a,i4,a)') ' plus INTs4    :',bsize,
     +     ' bytes (looking:',lookbsize,')'
      bsize = (adi8ibuf-1)*8
      lookbsize = -999
      if (adi8inlbuf.or.adi8ilbuf.gt.-1) lookbsize=(adi8ilbuf-1)*8
      write (6,'(a,i4,a,i4,a)') ' plus INTs8    :',bsize,
     +     ' bytes (looking:',lookbsize,')'
c           bsize = (adi16ibuf-1)*16
      bsize = (adr4ibuf-1)*4
      lookbsize = -999
      if (adr4inlbuf.or.adr4ilbuf.gt.-1) lookbsize=(adr4ilbuf-1)*4
      write (6,'(a,i4,a,i4,a)') ' plus REALs4   :',bsize,
     +     ' bytes (looking:',lookbsize,')'
      bsize = (adr8ibuf-1)*8
      lookbsize = -999
      if (adr8inlbuf.or.adr8ilbuf.gt.-1) lookbsize=(adr8ilbuf-1)*8
      write (6,'(a,i4,a,i4,a)') ' plus REALs8   :',bsize,
     +     ' bytes (looking:',lookbsize,')'
c      bsize = (adr16ibuf-1)*16
c      lookbsize = -999
c      if (adr16inlbuf.or.adr16ilbuf.gt.-1) lookbsize=(adr16ilbuf-1)*16
c      write (6,'(a,i4,a,i4,a)') ' plus REALs16  :',bsize,
c     +     ' bytes (looking:',lookbsize,')'
c           bsize = (adr32ibuf-1)*32
c           bsize = (adc4ibuf-1)*4
      bsize = (adc8ibuf-1)*8
      lookbsize = -999
      if (adc8inlbuf.or.adc8ilbuf.gt.-1) lookbsize=(adc8ilbuf-1)*8
      write (6,'(a,i4,a,i4,a)') ' plus CPLXs8   :',bsize,
     +     ' bytes (looking:',lookbsize,')'
      bsize = (adc16ibuf-1)*16
      lookbsize = -999
      if (adc16inlbuf.or.adc16ilbuf.gt.-1) lookbsize=(adc16ilbuf-1)*16
      write (6,'(a,i4,a,i4,a)') ' plus CPLXs16  :',bsize,
     +     ' bytes (looking:',lookbsize,')'
c           bsize = (adc32ibuf-1)*32
c
      end

C FOR INTERNAL DEBUGS ONLY:
      SUBROUTINE SHOWALLSTACKS()
      INTEGER*4 adbitbuf, adbitlbuf
      INTEGER adbitibuf, adbitilbuf
      LOGICAL adbitinlbuf
      COMMON /adbitfbuf/adbitbuf,adbitlbuf,
     +       adbitibuf,adbitilbuf,adbitinlbuf
      CHARACTER ads1buf(512), ads1lbuf(512)
      INTEGER ads1ibuf,ads1ilbuf
      LOGICAL ads1inlbuf
      COMMON /ads1fbuf/ads1buf,ads1lbuf,
     +       ads1ibuf,ads1ilbuf,ads1inlbuf
      INTEGER*4 adi4buf(512), adi4lbuf(512)
      INTEGER adi4ibuf,adi4ilbuf
      LOGICAL adi4inlbuf
      COMMON /adi4fbuf/adi4buf,adi4lbuf,
     +       adi4ibuf,adi4ilbuf,adi4inlbuf
      INTEGER*8 adi8buf(512), adi8lbuf(512)
      INTEGER adi8ibuf,adi8ilbuf
      LOGICAL adi8inlbuf
      COMMON /adi8fbuf/adi8buf,adi8lbuf,
     +       adi8ibuf,adi8ilbuf,adi8inlbuf
      REAL*4 adr4buf(512), adr4lbuf(512)
      INTEGER adr4ibuf,adr4ilbuf
      LOGICAL adr4inlbuf
      COMMON /adr4fbuf/adr4buf,adr4lbuf,
     +       adr4ibuf,adr4ilbuf,adr4inlbuf
      REAL*8 adr8buf(512), adr8lbuf(512)
      INTEGER adr8ibuf,adr8ilbuf
      LOGICAL adr8inlbuf
      COMMON /adr8fbuf/adr8buf,adr8lbuf,
     +       adr8ibuf,adr8ilbuf,adr8inlbuf
c           REAL*16 adr16buf(512), adr16lbuf(512)
c           INTEGER adr16ibuf,adr16ilbuf
c           LOGICAL adr16inlbuf
c           COMMON /adr16fbuf/adr16buf,adr16lbuf,
c          +       adr16ibuf,adr16ilbuf,adr16inlbuf
      COMPLEX*8 adc8buf(512), adc8lbuf(512)
      INTEGER adc8ibuf,adc8ilbuf
      LOGICAL adc8inlbuf
      COMMON /adc8fbuf/adc8buf,adc8lbuf,
     +       adc8ibuf,adc8ilbuf,adc8inlbuf
      COMPLEX*16 adc16buf(512), adc16lbuf(512)
      INTEGER adc16ibuf,adc16ilbuf
      LOGICAL adc16inlbuf
      COMMON /adc16fbuf/adc16buf,adc16lbuf,
     +       adc16ibuf,adc16ilbuf,adc16inlbuf
      INTEGER i
c
      write (6,1010) 'BIT STACK       : ',adbitbuf,'==',adbitbuf,
     +     ' (',adbitibuf,')'
1010  format(a,i20,a,z16,a,i2,a)
      write (6,1011) 'INTEGER*8 BUFFER[',adi8ibuf-1,']: ',
     +     (adi8buf(i),i=1,adi8ibuf-1)
      write (6,1011) 'INTEGER*4 BUFFER[',adi4ibuf-1,']: ',
     +     (adi4buf(i),i=1,adi4ibuf-1)
1011  format(a,i3,a,512(i40))
c      write (6,1012) 'REAL*16   BUFFER:[',adr16ibuf-1,']: ',
c     +     (adr16buf(i),i=1,adr16ibuf-1)
      write (6,1012) 'REAL*8    BUFFER:[',adr8ibuf-1, ']: ',
     +     (adr8buf(i),i=1,adr8ibuf-1)
      write (6,1012) 'REAL*4    BUFFER:[',adr4ibuf-1, ']: ',
     +     (adr4buf(i),i=1,adr4ibuf-1)
1012  format(a,i3,a,512(e8.2))
      call showrecentcstack()
c
      END

C========================================================
C PUSH* POP* SUBROUTINES FOR OTHER DATA TYPES
C Uncomment if these types are available on your compiler
C  and they are needed by the reverse differentiated code
C Don't forget to uncomment the corresponding lines in
C  subroutine PRINTBUFFERTOP, otherwise these types'
C  contribution to buffer occupation will not be seen.
C  (not very important anyway...)

c======================= INTEGER*16 =========================
c           BLOCK DATA INTEGERS16
c           INTEGER*16 adi16buf(512), adi16lbuf(512)
c           INTEGER adi16ibuf,adi16ilbuf
c           LOGICAL adi16inlbuf
c           COMMON /adi16fbuf/adi16buf,adi16lbuf,
c          +       adi16ibuf,adi16ilbuf,adi16inlbuf
c           DATA adi16ibuf/1/
c           DATA adi16ilbuf/-1/
c           DATA adi16inlbuf/.FALSE./
c           END
c     c
c           SUBROUTINE PUSHINTEGER16(x)
c           INTEGER*16 x, adi16buf(512), adi16lbuf(512)
c           INTEGER adi16ibuf,adi16ilbuf
c           LOGICAL adi16inlbuf
c           COMMON /adi16fbuf/adi16buf,adi16lbuf,
c          +       adi16ibuf,adi16ilbuf,adi16inlbuf
c           LOGICAL looking
c           COMMON /lookingfbuf/looking
c     c
c           CALL addftraffic(16)
c           IF (adi16ilbuf.ne.-1) THEN
c              adi16ilbuf = -1
c              adi16inlbuf = .FALSE.
c              looking = .FALSE.
c           ENDIF
c           IF (adi16ibuf.ge.512) THEN
c              adi16buf(512) = x
c              CALL PUSHINTEGER16ARRAY(adi16buf, 512)
c           CALL addftraffic(-8192)
c              adi16ibuf = 1
c           ELSE
c              adi16buf(adi16ibuf) = x
c              adi16ibuf = adi16ibuf+1
c           ENDIF
c           END
c     
c           SUBROUTINE LOOKINTEGER16(x)
c           INTEGER*16 x, adi16buf(512), adi16lbuf(512)
c           INTEGER adi16ibuf,adi16ilbuf
c           LOGICAL adi16inlbuf
c           COMMON /adi16fbuf/adi16buf,adi16lbuf,
c          +       adi16ibuf,adi16ilbuf,adi16inlbuf
c           LOGICAL looking
c           COMMON /lookingfbuf/looking
c     c
c           IF (adi16ilbuf.eq.-1) THEN
c              adi16ilbuf=adi16ibuf
c              IF (.not.looking) THEN
c                 CALL RESETADLOOKSTACK()
c                looking = .TRUE.
c              ENDIF
c           ENDIF
c           IF (adi16ilbuf.le.1) THEN
c              CALL LOOKINTEGER16ARRAY(adi16lbuf, 512)
c              adi16inlbuf = .TRUE.
c              adi16ilbuf = 512
c              x = adi16lbuf(512)
c           ELSE
c              adi16ilbuf = adi16ilbuf-1
c              if (adi16inlbuf) THEN
c                 x = adi16lbuf(adi16ilbuf)
c              ELSE
c                 x = adi16buf(adi16ilbuf)
c              ENDIF
c           ENDIF
c           END
c     
c           SUBROUTINE POPINTEGER16(x)
c           INTEGER*16 x, adi16buf(512), adi16lbuf(512)
c           INTEGER adi16ibuf,adi16ilbuf
c           LOGICAL adi16inlbuf
c           COMMON /adi16fbuf/adi16buf,adi16lbuf,
c          +       adi16ibuf,adi16ilbuf,adi16inlbuf
c           LOGICAL looking
c           COMMON /lookingfbuf/looking
c     c
c           IF (adi16ilbuf.ne.-1) THEN
c              adi16ilbuf = -1
c              adi16inlbuf = .FALSE.
c              looking = .FALSE.
c           ENDIF
c           IF (adi16ibuf.le.1) THEN
c              CALL POPINTEGER16ARRAY(adi16buf, 512)
c              adi16ibuf = 512
c              x = adi16buf(512)
c           ELSE
c              adi16ibuf = adi16ibuf-1
c              x = adi16buf(adi16ibuf)
c           ENDIF
c           END

c======================= REAL*16 =========================
c           BLOCK DATA REALS16
c           REAL*16 adr16buf(512), adr16lbuf(512)
c           INTEGER adr16ibuf,adr16ilbuf
c           LOGICAL adr16inlbuf
c           COMMON /adr16fbuf/adr16buf,adr16lbuf,
c          +       adr16ibuf,adr16ilbuf,adr16inlbuf
c           DATA adr16ibuf/1/
c           DATA adr16ilbuf/-1/
c           DATA adr16inlbuf/.FALSE./
c           END
c     
c           SUBROUTINE PUSHREAL16(x)
c           REAL*16 x, adr16buf(512), adr16lbuf(512)
c           INTEGER adr16ibuf,adr16ilbuf
c           LOGICAL adr16inlbuf
c           COMMON /adr16fbuf/adr16buf,adr16lbuf,
c          +       adr16ibuf,adr16ilbuf,adr16inlbuf
c           LOGICAL looking
c           COMMON /lookingfbuf/looking
c     c
c           CALL addftraffic(16)
c           IF (adr16ilbuf.ne.-1) THEN
c              adr16ilbuf = -1
c              adr16inlbuf = .FALSE.
c              looking = .FALSE.
c           ENDIF
c           IF (adr16ibuf.ge.512) THEN
c              adr16buf(512) = x
c              CALL PUSHREAL16ARRAY(adr16buf, 512)
c           CALL addftraffic(-8192)
c              adr16ibuf = 1
c           ELSE
c              adr16buf(adr16ibuf) = x
c              adr16ibuf = adr16ibuf+1
c           ENDIF
c           END
c     
c           SUBROUTINE LOOKREAL16(x)
c           REAL*16 x, adr16buf(512), adr16lbuf(512)
c           INTEGER adr16ibuf,adr16ilbuf
c           LOGICAL adr16inlbuf
c           COMMON /adr16fbuf/adr16buf,adr16lbuf,
c          +       adr16ibuf,adr16ilbuf,adr16inlbuf
c           LOGICAL looking
c           COMMON /lookingfbuf/looking
c     c
c           IF (adr16ilbuf.eq.-1) THEN
c              adr16ilbuf=adr16ibuf
c              IF (.not.looking) THEN
c                 CALL RESETADLOOKSTACK()
c                 looking = .TRUE.
c              ENDIF
c           ENDIF
c           IF (adr16ilbuf.le.1) THEN
c              CALL LOOKREAL16ARRAY(adr16lbuf, 512)
c              adr16inlbuf = .TRUE.
c              adr16ilbuf = 512
c              x = adr16lbuf(512)
c           ELSE
c              adr16ilbuf = adr16ilbuf-1
c              if (adr16inlbuf) THEN
c                 x = adr16lbuf(adr16ilbuf)
c              ELSE
c                 x = adr16buf(adr16ilbuf)
c              ENDIF
c           ENDIF
c           END
c     
c           SUBROUTINE POPREAL16(x)
c           REAL*16 x, adr16buf(512), adr16lbuf(512)
c           INTEGER adr16ibuf,adr16ilbuf
c           LOGICAL adr16inlbuf
c           COMMON /adr16fbuf/adr16buf,adr16lbuf,
c          +       adr16ibuf,adr16ilbuf,adr16inlbuf
c           LOGICAL looking
c           COMMON /lookingfbuf/looking
c     c
c           IF (adr16ilbuf.ne.-1) THEN
c              adr16ilbuf = -1
c              adr16inlbuf = .FALSE.
c              looking = .FALSE.
c           ENDIF
c           IF (adr16ibuf.le.1) THEN
c              CALL POPREAL16ARRAY(adr16buf, 512)
c              adr16ibuf = 512
c              x = adr16buf(512)
c           ELSE
c              adr16ibuf = adr16ibuf-1
c              x = adr16buf(adr16ibuf)
c           ENDIF
c           END

c======================= REAL*32 =========================
c           BLOCK DATA REALS32
c           REAL*32 adr32buf(512), adr32lbuf(512)
c           INTEGER adr32ibuf,adr32ilbuf
c           LOGICAL adr32inlbuf
c           COMMON /adr32fbuf/adr32buf,adr32lbuf,
c          +       adr32ibuf,adr32ilbuf,adr32inlbuf
c           DATA adr32ibuf/1/
c           DATA adr32ilbuf/-1/
c           DATA adr32inlbuf/.FALSE./
c           END
c     c
c           SUBROUTINE PUSHREAL32(x)
c           REAL*32 x, adr32buf(512), adr32lbuf(512)
c           INTEGER adr32ibuf,adr32ilbuf
c           LOGICAL adr32inlbuf
c           COMMON /adr32fbuf/adr32buf,adr32lbuf,
c          +       adr32ibuf,adr32ilbuf,adr32inlbuf
c           LOGICAL looking
c           COMMON /lookingfbuf/looking
c     c
c           CALL addftraffic(32)
c           IF (adr32ilbuf.ne.-1) THEN
c              adr32ilbuf = -1
c              adr32inlbuf = .FALSE.
c              looking = .FALSE.
c           ENDIF
c           IF (adr32ibuf.ge.512) THEN
c              adr32buf(512) = x
c              CALL PUSHREAL32ARRAY(adr32buf, 512)
c           CALL addftraffic(-16384)
c              adr32ibuf = 1
c           ELSE
c              adr32buf(adr32ibuf) = x
c              adr32ibuf = adr32ibuf+1
c           ENDIF
c           END
c     
c           SUBROUTINE LOOKREAL32(x)
c           REAL*32 x, adr32buf(512), adr32lbuf(512)
c           INTEGER adr32ibuf,adr32ilbuf
c           LOGICAL adr32inlbuf
c           COMMON /adr32fbuf/adr32buf,adr32lbuf,
c          +       adr32ibuf,adr32ilbuf,adr32inlbuf
c           LOGICAL looking
c           COMMON /lookingfbuf/looking
c     c
c           IF (adr32ilbuf.eq.-1) THEN
c              adr32ilbuf=adr32ibuf
c              IF (.not.looking) THEN
c                 CALL RESETADLOOKSTACK()
c                looking = .TRUE.
c              ENDIF
c           ENDIF
c           IF (adr32ilbuf.le.1) THEN
c              CALL LOOKREAL32ARRAY(adr32lbuf, 512)
c              adr32inlbuf = .TRUE.
c              adr32ilbuf = 512
c              x = adr32lbuf(512)
c           ELSE
c              adr32ilbuf = adr32ilbuf-1
c              if (adr32inlbuf) THEN
c                 x = adr32lbuf(adr32ilbuf)
c              ELSE
c                 x = adr32buf(adr32ilbuf)
c              ENDIF
c           ENDIF
c           END
c     
c           SUBROUTINE POPREAL32(x)
c           REAL*32 x, adr32buf(512), adr32lbuf(512)
c           INTEGER adr32ibuf,adr32ilbuf
c           LOGICAL adr32inlbuf
c           COMMON /adr32fbuf/adr32buf,adr32lbuf,
c          +       adr32ibuf,adr32ilbuf,adr32inlbuf
c           LOGICAL looking
c           COMMON /lookingfbuf/looking
c     c
c           IF (adr32ilbuf.ne.-1) THEN
c              adr32ilbuf = -1
c              adr32inlbuf = .FALSE.
c              looking = .FALSE.
c           ENDIF
c           IF (adr32ibuf.le.1) THEN
c              CALL POPREAL32ARRAY(adr32buf, 512)
c              adr32ibuf = 512
c              x = adr32buf(512)
c           ELSE
c              adr32ibuf = adr32ibuf-1
c              x = adr32buf(adr32ibuf)
c           ENDIF
c           END

c======================= COMPLEX*4 =========================
c           BLOCK DATA COMPLEXS4
c           COMPLEX*4 adc4buf(512), adc4lbuf(512)
c           INTEGER adc4ibuf,adc4ilbuf
c           LOGICAL adc4inlbuf
c           COMMON /adc4fbuf/adc4buf,adc4lbuf,
c          +       adc4ibuf,adc4ilbuf,adc4inlbuf
c           DATA adc4ibuf/1/
c           DATA adc4ilbuf/-1/
c           DATA adc4inlbuf/.FALSE./
c           END
c     c
c           SUBROUTINE PUSHCOMPLEX4(x)
c           COMPLEX*4 x, adc4buf(512), adc4lbuf(512)
c           INTEGER adc4ibuf,adc4ilbuf
c           LOGICAL adc4inlbuf
c           COMMON /adc4fbuf/adc4buf,adc4lbuf,
c          +       adc4ibuf,adc4ilbuf,adc4inlbuf
c           LOGICAL looking
c           COMMON /lookingfbuf/looking
c     c
c           CALL addftraffic(4)
c           IF (adc4ilbuf.ne.-1) THEN
c              adc4ilbuf = -1
c              adc4inlbuf = .FALSE.
c              looking = .FALSE.
c           ENDIF
c           IF (adc4ibuf.ge.512) THEN
c              adc4buf(512) = x
c              CALL PUSHCOMPLEX4ARRAY(adc4buf, 512)
c           CALL addftraffic(-2048)
c              adc4ibuf = 1
c           ELSE
c              adc4buf(adc4ibuf) = x
c              adc4ibuf = adc4ibuf+1
c           ENDIF
c           END
c     
c           SUBROUTINE LOOKCOMPLEX4(x)
c           COMPLEX*4 x, adc4buf(512), adc4lbuf(512)
c           INTEGER adc4ibuf,adc4ilbuf
c           LOGICAL adc4inlbuf
c           COMMON /adc4fbuf/adc4buf,adc4lbuf,
c          +       adc4ibuf,adc4ilbuf,adc4inlbuf
c           LOGICAL looking
c           COMMON /lookingfbuf/looking
c     c
c           IF (adc4ilbuf.eq.-1) THEN
c              adc4ilbuf=adc4ibuf
c              IF (.not.looking) THEN
c                 CALL RESETADLOOKSTACK()
c                looking = .TRUE.
c              ENDIF
c           ENDIF
c           IF (adc4ilbuf.le.1) THEN
c              CALL LOOKCOMPLEX4ARRAY(adc4lbuf, 512)
c              adc4inlbuf = .TRUE.
c              adc4ilbuf = 512
c              x = adc4lbuf(512)
c           ELSE
c              adc4ilbuf = adc4ilbuf-1
c              if (adc4inlbuf) THEN
c                 x = adc4lbuf(adc4ilbuf)
c              ELSE
c                 x = adc4buf(adc4ilbuf)
c              ENDIF
c           ENDIF
c           END
c     
c           SUBROUTINE POPCOMPLEX4(x)
c           COMPLEX*4 x, adc4buf(512), adc4lbuf(512)
c           INTEGER adc4ibuf,adc4ilbuf
c           LOGICAL adc4inlbuf
c           COMMON /adc4fbuf/adc4buf,adc4lbuf,
c          +       adc4ibuf,adc4ilbuf,adc4inlbuf
c           LOGICAL looking
c           COMMON /lookingfbuf/looking
c     c
c           IF (adc4ilbuf.ne.-1) THEN
c              adc4ilbuf = -1
c              adc4inlbuf = .FALSE.
c              looking = .FALSE.
c           ENDIF
c           IF (adc4ibuf.le.1) THEN
c              CALL POPCOMPLEX4ARRAY(adc4buf, 512)
c              adc4ibuf = 512
c              x = adc4buf(512)
c           ELSE
c              adc4ibuf = adc4ibuf-1
c              x = adc4buf(adc4ibuf)
c           ENDIF
c           END

c======================= COMPLEX*32 =========================
c           BLOCK DATA COMPLEXS32
c           COMPLEX*32 adc32buf(512), adc32lbuf(512)
c           INTEGER adc32ibuf,adc32ilbuf
c           LOGICAL adc32inlbuf
c           COMMON /adc32fbuf/adc32buf,adc32lbuf,
c          +       adc32ibuf,adc32ilbuf,adc32inlbuf
c           DATA adc32ibuf/1/
c           DATA adc32ilbuf/-1/
c           DATA adc32inlbuf/.FALSE./
c           END
c     c
c           SUBROUTINE PUSHCOMPLEX32(x)
c           COMPLEX*32 x, adc32buf(512), adc32lbuf(512)
c           INTEGER adc32ibuf,adc32ilbuf
c           LOGICAL adc32inlbuf
c           COMMON /adc32fbuf/adc32buf,adc32lbuf,
c          +       adc32ibuf,adc32ilbuf,adc32inlbuf
c           LOGICAL looking
c           COMMON /lookingfbuf/looking
c     c
c           CALL addftraffic(32)
c           IF (adc32ilbuf.ne.-1) THEN
c              adc32ilbuf = -1
c              adc32inlbuf = .FALSE.
c              looking = .FALSE.
c           ENDIF
c           IF (adc32ibuf.ge.512) THEN
c              adc32buf(512) = x
c              CALL PUSHCOMPLEX32ARRAY(adc32buf, 512)
c           CALL addftraffic(-16384)
c              adc32ibuf = 1
c           ELSE
c              adc32buf(adc32ibuf) = x
c              adc32ibuf = adc32ibuf+1
c           ENDIF
c           END
c     
c           SUBROUTINE LOOKCOMPLEX32(x)
c           COMPLEX*32 x, adc32buf(512), adc32lbuf(512)
c           INTEGER adc32ibuf,adc32ilbuf
c           LOGICAL adc32inlbuf
c           COMMON /adc32fbuf/adc32buf,adc32lbuf,
c          +       adc32ibuf,adc32ilbuf,adc32inlbuf
c           LOGICAL looking
c           COMMON /lookingfbuf/looking
c     c
c           IF (adc32ilbuf.eq.-1) THEN
c              adc32ilbuf=adc32ibuf
c              IF (.not.looking) THEN
c                 CALL RESETADLOOKSTACK()
c                looking = .TRUE.
c              ENDIF
c           ENDIF
c           IF (adc32ilbuf.le.1) THEN
c              CALL LOOKCOMPLEX32ARRAY(adc32lbuf, 512)
c              adc32inlbuf = .TRUE.
c              adc32ilbuf = 512
c              x = adc32lbuf(512)
c           ELSE
c              adc32ilbuf = adc32ilbuf-1
c              if (adc32inlbuf) THEN
c                 x = adc32lbuf(adc32ilbuf)
c              ELSE
c                 x = adc32buf(adc32ilbuf)
c              ENDIF
c           ENDIF
c           END
c     
c           SUBROUTINE POPCOMPLEX32(x)
c           COMPLEX*32 x, adc32buf(512), adc32lbuf(512)
c           INTEGER adc32ibuf,adc32ilbuf
c           LOGICAL adc32inlbuf
c           COMMON /adc32fbuf/adc32buf,adc32lbuf,
c          +       adc32ibuf,adc32ilbuf,adc32inlbuf
c           LOGICAL looking
c           COMMON /lookingfbuf/looking
c     c
c           IF (adc32ilbuf.ne.-1) THEN
c              adc32ilbuf = -1
c              adc32inlbuf = .FALSE.
c              looking = .FALSE.
c           ENDIF
c           IF (adc32ibuf.le.1) THEN
c              CALL POPCOMPLEX32ARRAY(adc32buf, 512)
c              adc32ibuf = 512
c              x = adc32buf(512)
c           ELSE
c              adc32ibuf = adc32ibuf-1
c              x = adc32buf(adc32ibuf)
c           ENDIF
c           END

C========================================================
C        HOW TO CREATE PUSH* POP* SUBROUTINES
C              YET FOR OTHER DATA TYPES
C ** Duplicate the commented program lines below
c ** In the duplicated subroutines, replace:
c            TTTT by the basic name of the type
c            z9   by the initial and size of the type
c                (integer:i real:r complex:c boolean:b character:s)
c            9    by the size of the type
c ** Uncomment the duplicated subroutines
C ** Don't forget to insert the corresponding lines in
C  subroutine PRINTBUFFERTOP, otherwise these types'
C  contribution to buffer occupation will not be seen.
C  (not very important anyway...)

c======================= TTTT*9 =========================
c           BLOCK DATA TTTTS9
c           TTTT*9 adz9buf(512), adz9lbuf(512)
c           INTEGER adz9ibuf,adz9ilbuf
c           LOGICAL adz9inlbuf
c           COMMON /adz9fbuf/adz9buf,adz9lbuf,
c          +       adz9ibuf,adz9ilbuf,adz9inlbuf
c           DATA adz9ibuf/1/
c           DATA adz9ilbuf/-1/
c           DATA adz9inlbuf/.FALSE./
c           END
c     c
c           SUBROUTINE PUSHTTTT9(x)
c           TTTT*9 x, adz9buf(512), adz9lbuf(512)
c           INTEGER adz9ibuf,adz9ilbuf
c           LOGICAL adz9inlbuf
c           COMMON /adz9fbuf/adz9buf,adz9lbuf,
c          +       adz9ibuf,adz9ilbuf,adz9inlbuf
c           LOGICAL looking
c           COMMON /lookingfbuf/looking
c     c
c           CALL addftraffic(9)
c           IF (adz9ilbuf.ne.-1) THEN
c              adz9ilbuf = -1
c              adz9inlbuf = .FALSE.
c              looking = .FALSE.
c           ENDIF
c           IF (adz9ibuf.ge.512) THEN
c              adz9buf(512) = x
c              CALL PUSHTTTT9ARRAY(adz9buf, 512)
c           CALL addftraffic(-9*512)
c              adz9ibuf = 1
c           ELSE
c              adz9buf(adz9ibuf) = x
c              adz9ibuf = adz9ibuf+1
c           ENDIF
c           END
c     
c           SUBROUTINE LOOKTTTT9(x)
c           TTTT*9 x, adz9buf(512), adz9lbuf(512)
c           INTEGER adz9ibuf,adz9ilbuf
c           LOGICAL adz9inlbuf
c           COMMON /adz9fbuf/adz9buf,adz9lbuf,
c          +       adz9ibuf,adz9ilbuf,adz9inlbuf
c           LOGICAL looking
c           COMMON /lookingfbuf/looking
c     c
c           IF (adz9ilbuf.eq.-1) THEN
c              adz9ilbuf=adz9ibuf
c              IF (.not.looking) THEN
c                 CALL RESETADLOOKSTACK()
c                looking = .TRUE.
c              ENDIF
c           ENDIF
c           IF (adz9ilbuf.le.1) THEN
c              CALL LOOKTTTT9ARRAY(adz9lbuf, 512)
c              adz9inlbuf = .TRUE.
c              adz9ilbuf = 512
c              x = adz9lbuf(512)
c           ELSE
c              adz9ilbuf = adz9ilbuf-1
c              if (adz9inlbuf) THEN
c                 x = adz9lbuf(adz9ilbuf)
c              ELSE
c                 x = adz9buf(adz9ilbuf)
c              ENDIF
c           ENDIF
c           END
c     
c           SUBROUTINE POPTTTT9(x)
c           TTTT*9 x, adz9buf(512), adz9lbuf(512)
c           INTEGER adz9ibuf,adz9ilbuf
c           LOGICAL adz9inlbuf
c           COMMON /adz9fbuf/adz9buf,adz9lbuf,
c          +       adz9ibuf,adz9ilbuf,adz9inlbuf
c           LOGICAL looking
c           COMMON /lookingfbuf/looking
c     c
c           IF (adz9ilbuf.ne.-1) THEN
c              adz9ilbuf = -1
c              adz9inlbuf = .FALSE.
c              looking = .FALSE.
c           ENDIF
c           IF (adz9ibuf.le.1) THEN
c              CALL POPTTTT9ARRAY(adz9buf, 512)
c              adz9ibuf = 512
c              x = adz9buf(512)
c           ELSE
c              adz9ibuf = adz9ibuf-1
c              x = adz9buf(adz9ibuf)
c           ENDIF
c           END

      double precision function randlc(x, a)

c---------------------------------------------------------------------
c
c   This routine returns a uniform pseudorandom double precision number in the
c   range (0, 1) by using the linear congruential generator
c
c   x_{k+1} = a x_k  (mod 2^46)
c
c   where 0 < x_k < 2^46 and 0 < a < 2^46.  This scheme generates 2^44 numbers
c   before repeating.  The argument A is the same as 'a' in the above formula,
c   and X is the same as x_0.  A and X must be odd double precision integers
c   in the range (1, 2^46).  The returned value RANDLC is normalized to be
c   between 0 and 1, i.e. RANDLC = 2^(-46) * x_1.  X is updated to contain
c   the new seed x_1, so that subsequent calls to RANDLC using the same
c   arguments will generate a continuous sequence.

      implicit none
      double precision x, a
      integer*8 Lx, La, a1, a2, x1, x2, xa
      double precision d2m46
      parameter(d2m46=0.5d0**46)

      Lx = x
      La = A
      a1 = ibits(La, 23, 23)
      a2 = ibits(La, 0, 23)
      x1 = ibits(Lx, 23, 23)
      x2 = ibits(Lx, 0, 23)
      xa = ishft(ibits(a1*x2+a2*x1, 0, 23), 23) + a2*x2
      Lx   = ibits(xa,0, 46)
      x    = dble(Lx)
      randlc = d2m46*x
      return
      end


c---------------------------------------------------------------------
c---------------------------------------------------------------------


      SUBROUTINE VRANLC (N, X, A, Y)
      implicit none
      integer n, i
      double precision x, a, y(*)
      integer*8 Lx, La, a1, a2, x1, x2, xa
      double precision d2m46
      parameter(d2m46=0.5d0**46)

      Lx = X
      La = A
      a1 = ibits(La, 23, 23)
      a2 = ibits(La, 0, 23)
      do i = 1, N
         x1 = ibits(Lx, 23, 23)
         x2 = ibits(Lx, 0, 23)
         xa = ishft(ibits(a1*x2+a2*x1, 0, 23), 23) + a2*x2
         Lx   = ibits(xa,0, 46)
         y(i) = d2m46*dble(Lx)
      end do
      x = dble(Lx)
      return
      end

C> @file drive1_cmt.f high-level driver for CMT-nek
C> \defgroup convhvol Volume integral for inviscid fluxes
C> \defgroup bcond Surface integrals due to boundary conditions
C> \defgroup diffhvol Volume integral for viscous fluxes
C> \defgroup vfjac Jacobians for viscous fluxes
C> \defgroup isurf Inviscid surface terms
C> \defgroup vsurf Viscous surface terms
C> \defgroup faceops utility functions for manipulating face data
C> Branch from subroutine nek_advance in core/drive1.f
C> Advance CMT-nek one time step within nek5000 time loop
      subroutine cmt_nek_advance
c     Solve the Euler equations

      include 'SIZE'
      include 'INPUT'
      include 'MASS'
      include 'TSTEP'
      include 'SOLN'
      include 'GEOM'
      include 'CTIMER'
      include 'CMTDATA'
      include 'CMTTIMERS'
      
      integer e,eq
      character*32 dumchars
      external AVeverywhere

      ftime_dum = dnekclock()
      nxyz1=lx1*ly1*lz1
      n = nxyz1*lelt*toteq
      nfldpart = ldim*npart

      if(istep.eq.1) then
         time4av=.true.
         call compute_mesh_h(meshh,xm1,ym1,zm1)
         call compute_grid_h(gridh,xm1,ym1,zm1)
         call cmt_ics
         if (ifrestart) then
            time_cmt=time
         else
            time_cmt=0.0 !time !0.0 ! until we can get settime to behave
         endif
         call cmt_flow_ics
         call init_cmt_timers
         dt=abs(param(12))
         call cmtchk ! need more ifdefs to use userchk
! JH080918 IC better be positive
         call compute_primitive_vars(1) ! get good mu
!! JH090518 Shock detector is not ready for prime time. Lean on EVM for
!!          sane default 
!!        call perssonperaire(t(1,1,1,1,5),vtrans(1,1,1,1,irho),scrent)
         call limiter
!!        call wavevisc(t(1,1,1,1,3))
!! JH082718 mask viscosity in t(:,3)
!!        call col2(t(1,1,1,1,3),t(1,1,1,1,5),nxyz*nelt)
!!        call max_to_trilin(t(1,1,1,1,3))
         call entropy_viscosity         ! for high diffno
!        call piecewiseAV(AVeverywhere)
         call compute_transport_props   ! at t=0

#ifdef LPM
      call spread_props_grid
#endif
      endif      
      call rzero(t,nxyz1*nelt*ldimt)

      nstage = 3
      do stage=1,nstage
         if (stage.eq.1) call copy(res3(1,1,1,1,1),U(1,1,1,1,1),n)

         rhst_dum = dnekclock()
         call compute_rhs_and_dt(AVeverywhere)
         rhst = rhst + dnekclock() - rhst_dum
c particle equations of motion are solved (also includes forcing)
c In future this subroutine may compute the back effect of particles
c on the fluid and suitably modify the residue computed by 
c compute_rhs_dt for the 5 conserved variables
!NTN         call usr_particles_solver
#ifdef LPM
        call lpm_usr_particles_solver
#endif
! JH111815 soon....
! JH082316 someday...maybe?
!        do eq=1,toteq
!           call fbinvert(res1(1,1,1,1,eq))
!        enddo

         do e=1,nelt
            do eq=1,toteq
            do i=1,nxyz1
c multiply u with bm1 as res has been multiplied by bm1 in compute_rhs
               u(i,1,1,eq,e) = bm1(i,1,1,e)*tcoef(1,stage)
     >                     *res3(i,1,1,eq,e)+bm1(i,1,1,e)*
     >                     tcoef(2,stage)*u(i,1,1,eq,e)-
     >                     tcoef(3,stage)*res1(i,1,1,e,eq)
c              u(i,1,1,eq,e) = bm1(i,1,1,e)*u(i,1,1,eq,e) - DT *
c    >                        (c1*res1(i,1,1,e,eq) + c2*res2(i,1,1,e,eq)
c    >                       + c3*res3(i,1,1,e,eq))
!-----------------------------------------------------------------------
! JH111815 in fact, I'd like to redo the time marching stuff above and
!          have an fbinvert call for res1
               u(i,1,1,eq,e) = u(i,1,1,eq,e)/bm1(i,1,1,e)
!-----------------------------------------------------------------------
            enddo
            enddo
         enddo ! nelt
!-----------------------------------------------------------------------
! JH080918 Now with solution limiters of Zhang & Shu (2010)
!                                    and   Lv & Ihme (2015) 
!          Also, FINALLY rewritten to consider solution at the
!          END OF RK STAGES AND END OF TIME STEP AS THE SOLUTION OF INTEREST
! JH081018 OK I can't do that for some reason. CHECK SOLN COMMONS BETWEEN
!          cmt_nek_advance and istep=istep+1
!-----------------------------------------------------------------------
!        call compute_primitive_vars(0)
!        call limiter
!        call compute_primitive_vars(1)

      enddo ! RK stage loop

!     time4av=.not.time4av

      ftime = ftime + dnekclock() - ftime_dum

!-----------------------------------------------------------------------
! JH081018 I/O really should go here, but I don't want to call limiter
!          and compute_primitive_variables needlessly.
!          For now, tuck all this stuff in compute_rhs_and_dt and query
!          iostep2 at stage==1.
!-----------------------------------------------------------------------
!     call copy(t(1,1,1,1,2),vtrans(1,1,1,1,irho),nxyz1*nelt)
!     if (mod(istep,iostep2).eq.0) then
!     if (mod(istep,iostep2).eq.0.or.istep.eq.1)then
!     if (mod(istep,iostep).eq.0.or.istep.eq.1)then
!        call out_fld_nek
! T2 S1 rho
! T3 S2 wave visc
! T4 S3 epsebdg
!        call cmtchk
!        call outpost2(vx,vy,vz,pr,t,ldimt,'CMT')
!        call mass_balance(if3d)
! dump out particle information. 
!        call usr_particles_io(istep)
!     end if

!     call print_cmt_timers ! NOT NOW

 101  format(4(2x,e18.9))
      return
      end

c-----------------------------------------------------------------------

C> Compute right-hand-side of the semidiscrete conservation law
C> Store it in res1
      subroutine compute_rhs_and_dt(shock_detector)
      include 'SIZE'
      include 'TOTAL'
      include 'DG'
      include 'CMTDATA'
      include 'CTIMER'

      integer lfq,heresize,hdsize
      parameter (lfq=lx1*lz1*2*ldim*lelt,
     >                   heresize=nqq*3*lfq,! guarantees transpose of Q+ fits
     >                   hdsize=toteq*3*lfq) ! might not need ldim
! not sure if viscous surface fluxes can live here yet
      common /CMTSURFLX/ flux(heresize),graduf(hdsize)
      real graduf

      integer e,eq
      real wkj(lx1+lxd)
      character*32  dumchars
      external shock_detector

      call compute_mesh_h(meshh,xm1,ym1,zm1)
      call compute_grid_h(gridh,xm1,ym1,zm1)

      if (lxd.gt.lx1) then
         call set_dealias_face
      else
         call set_alias_rx(istep)
      endif

!     call set_dealias_rx ! done in set_convect_cons,
! JH113015                ! now called from compute_primitive_variables

      call compute_primitive_vars(0)
!! JH090518 Shock detector is not ready for prime time. Lean on EVM for
!!          sane default 
!!     if (stage.eq.1)
!!    >call shock_detector(t(1,1,1,1,5),vtrans(1,1,1,1,irho),scrent)
!     if (1.eq.2) then
      call limiter
!     endif
      call compute_primitive_vars(1)

!     if (1==2) then
!     call piecewiseAV(shock_detector)
      call entropy_viscosity
      call compute_transport_props ! everything inside rk stage
!     endif
!     call smoothing(vdiff(1,1,1,1,imu)) ! still done in usr file
! you have GOT to figure out where phig goes!!!!

      nxyz = lx1*ly1*lz1
      if(stage.eq.1) then
!-----------------------------------------------------------------------
! JH081018 a whole bunch of this stuff should really be done AFTER the
!          RK loop at the END of the time step, but I lose custody
!          of commons in SOLN between cmt_nek_advance and the rest of
!          the time loop.
         call copy(t(1,1,1,1,2),vtrans(1,1,1,1,irho),nxyz*nelt)
         call cmtchk

!        if (mod(istep,iostep2).eq.0) then
         if (mod(istep,iostep2).eq.0.or.istep.eq.1)then
!        if (mod(istep,iostep).eq.0.or.istep.eq.1)then
            call out_fld_nek ! solution checkpoint for restart
! T2 S1 rho
! T3 S2 wave visc
! T4 S3 epsebdg
            call outpost2(vx,vy,vz,pr,t,ldimt,'CMT')
            call mass_balance(if3d)
! dump out particle information. 
#ifdef LPM
            call lpm_usr_particles_io(istep)
#endif
         end if
         call setdtcmt
         call set_tstep_coef
      endif

      ntot = lx1*ly1*lz1*lelt*toteq
      call rzero(res1,ntot)
      call rzero(flux,heresize)
      call rzero(graduf,hdsize)

!     !Total_eqs = 5 (we will set this up so that it can be a user 
!     !defined value. 5 will be its default value)
!     !eq = 1 -------- Mass balance
!     !eq = 2 -------- x  momentum 
!     !eq = 3 -------- y  momentum 
!     !eq = 4 -------- z  momentum 
!     !eq = 5 -------- Energy Equation 

C> Restrict via \f$\mathbf{E}\f$ to get primitive and conserved variables
C> on interior faces \f$\mathbf{U}^-\f$ and neighbor faces
C> \f$\mathbf{U}^+\f$; store in CMTSURFLX
      call fluxes_full_field

C> res1+=\f$\oint \mathbf{H}^{c\ast}\cdot\mathbf{n}dA\f$ on face points
      nstate=nqq
      nfq=lx1*lz1*2*ldim*nelt
      iwm =1
      iwp =iwm+nstate*nfq
      iflx=iwp+nstate*nfq
      do eq=1,toteq
         ieq=(eq-1)*ndg_face+iflx
         call surface_integral_full(res1(1,1,1,1,eq),flux(ieq))
      enddo
      dumchars='after_inviscid'
!     call dumpresidue(dumchars,999)

               !                   -
      iuj=iflx ! overwritten with U -{{U}}
!-----------------------------------------------------------------------
!                          /     1  T \
! JH082316 imqqtu computes | I - -QQ  | U for all 5 conserved variables
!                          \     2    /
! which I now make the following be'neon-billboarded assumption:
!***********************************************************************
! ASSUME CONSERVED VARS U1 THROUGH U5 ARE CONTIGUOUSLY STORED
! SEQUENTIALLY IN /CMTSURFLX/ i.e. that iu2=iu1+1, etc.
! CMTDATA BETTA REFLECT THIS!!!
!***********************************************************************
C> res1+=\f$\int_{\Gamma} \{\{\mathbf{A}^{\intercal}\nabla v\}\} \cdot \left[\mathbf{U}\right] dA\f$
!      if (1.eq.2) then
      ium=(iu1-1)*nfq+iwm
      iup=(iu1-1)*nfq+iwp
      call   imqqtu(flux(iuj),flux(ium),flux(iup))
      call   imqqtu_dirichlet(flux(iuj),flux(iwm),flux(iwp))
      call igtu_cmt(flux(iwm),flux(iuj),graduf) ! [[u]].{{gradv}}
      dumchars='after_igtu'
!     call dumpresidue(dumchars,999)
!      endif

C> res1+=\f$\int \left(\nabla v\right) \cdot \left(\mathbf{H}^c+\mathbf{H}^d\right)dV\f$ 
C> for each equation (inner), one element at a time (outer)
      do e=1,nelt
!-----------------------------------------------------------------------
! JH082216 Since the dawn of CMT-nek we have called this particular loop
!***********************************************************************
!*         "THE" ELEMENT LOOP                                          *
!***********************************************************************
!          since it does several operations, mostly for volume integrals,
!          for all equations, one element at a time. If we get memory
!          under control and GPUs really need to act on gigabytes all
!          at once, then this and its dependents can still have their
!          loop order flipped and things like totalh declared for
!          15 full fields or more.
!-----------------------------------------------------------------------
! Get user defined forcing from userf defined in usr file
         call cmtusrf(e)
         call compute_gradients(e) ! gradU
         do eq=1,toteq
            call convective_cmt(e,eq)        ! convh & totalh -> res1
!     if (1.eq.2) then
            call    viscous_cmt(e,eq) ! diffh -> half_iku_cmt -> res1
                                             !       |
                                             !       -> diffh2graduf
! Compute the forcing term in each of the 5 eqs
            call compute_forcing(e,eq)
!     endif
         enddo
      enddo
      dumchars='after_elm'
!     call dumpresidue(dumchars,999)

!      if (1.eq.2) then
C> res1+=\f$\int_{\Gamma} \{\{\mathbf{A}\nabla \mathbf{U}\}\} \cdot \left[v\right] dA\f$
      call igu_cmt(flux(iwp),graduf,flux(iwm))
      do eq=1,toteq
         ieq=(eq-1)*ndg_face+iwp
!Finally add viscous surface flux functions of derivatives to res1.
         call surface_integral_full(res1(1,1,1,1,eq),flux(ieq))
      enddo
!      endif
      dumchars='end_of_rhs'
!     call dumpresidue(dumchars,999)

      return
      end
!-----------------------------------------------------------------------
C> Compute coefficients for Runge-Kutta stages \cite{TVDRK}
      subroutine set_tstep_coef
      include 'SIZE'
      include 'TSTEP'
      include 'CMTDATA'

      tcoef(1,1) = 0.0
      tcoef(2,1) = 1.0 
      tcoef(3,1) = dt
      tcoef(1,2) = 3.0/4.0
      tcoef(2,2) = 1.0/4.0 
      tcoef(3,2) = dt/4.0 
      tcoef(1,3) = 1.0/3.0
      tcoef(2,3) = 2.0/3.0 
      tcoef(3,3) = dt*2.0/3.0 

      return
      end
!-----------------------------------------------------------------------

      subroutine cmt_flow_ics
      include 'SIZE'
      include 'CMTDATA'
      include 'SOLN'

      integer e
      nxyz1 = lx1*ly1*lz1
      n     = nxyz1*lelt*toteq
      if (ifrestart)then
         do e=1,nelt
            call copy(U(1,1,1,2,e),vx(1,1,1,e),nxyz1) 
            call copy(U(1,1,1,3,e),vy(1,1,1,e),nxyz1) 
            call copy(U(1,1,1,4,e),vz(1,1,1,e),nxyz1) 
            call copy(U(1,1,1,5,e),t(1,1,1,e,1),nxyz1) 
            call copy(U(1,1,1,1,e),pr(1,1,1,e),nxyz1) 
         enddo
         call copy(tlag(1,1,1,1,1,2),t(1,1,1,1,2),nxyz1*nelt) ! s_{n-1}
         call copy(tlag(1,1,1,1,2,1),t(1,1,1,1,3),nxyz1*nelt) ! s_n
      endif
      call rzero(res1,n)
!     call copy(res2,t(1,1,1,1,5),n) ! art visc hardcoding. old entropy resid
      call rzero(res2,n) ! Actually,...
      return
      end
!-----------------------------------------------------------------------

      subroutine print_cmt_timers
      include 'SIZE'
      include 'CMTTIMERS'
      include 'TSTEP'
      include 'PARALLEL'

c we need our own IO features. Until then we use the default nek routines
      if ((mod(istep,flio_freq).eq.0.and.istep.gt.0)
     $                               .or.istep.eq.nstep)then
         dmtime1 = ftime/istep
         dtime_ = glsum(dmtime1,1)
         if(nio.eq.0) write(6,*) 'fluid rhs compute time(Avg)  '
     $               ,dtime_/np
      endif
      return 
      end
!-----------------------------------------------------------------------

      subroutine init_cmt_timers
      include 'CMTTIMERS'

      rhst    = 0.00
      ftime   = 0.00

      return
      end
!-----------------------------------------------------------------------

c-----------------------------------------------------------------------
c
c    Stability limits:
c
c    AB3:    .7236                     w/safety (1.2):   .603
c
c    RK3:    1.73   (sqrt 3)           w/safety (1.2):   1.44
c
c    RK4:    2.828                     w/safety (1.2):   2.36
c
c    SEM Safety factor:  1.52 for N=3
c                     <  1.20 for N=16
c                     ~  1.16 for N=256
c
c-----------------------------------------------------------------------
      subroutine setup_convect(igeom)
      include 'SIZE'
      include 'TOTAL'
      logical ifnew

      common /cchar/ ct_vx(0:lorder+1) ! time for each slice in c_vx()

      common /scruz/ cx  (lx1*ly1*lz1*lelt)
     $ ,             cy  (lx1*ly1*lz1*lelt)
     $ ,             cz  (lx1*ly1*lz1*lelt)
     $ ,             hmsk(lx1*ly1*lz1*lelt)


      if (igeom.eq.1) return
      if (param(99).lt.0) return ! no dealiasing

      if (ifchar) then

         nelc = nelv
         if (ifmhd) nelc = max(nelv,nelfld(ifldmhd))
         if (ifmhd) call exitti('no characteristics for mhd yet$',istep)

         ifnew = .true.
         if (igeom.gt.2) ifnew = .false.

         if (ifgeom) then ! Moving mesh
            call opsub3(cx,cy,cz,vx,vy,vz,wx,wy,wz)
            call set_conv_char(ct_vx,c_vx,cx,cy,cz,nelc,time,ifnew)
c            call set_char_mask(hmsk,cx,cy,cz) ! mask for hyperbolic system 
         else
            call set_conv_char(ct_vx,c_vx,vx,vy,vz,nelc,time,ifnew)
c            call set_char_mask(hmsk,vx,vy,vz) ! mask for hyperbolic system 
         endif

         n=lx1*ly1*lz1*nelv
         call rone(hmsk,n)            ! TURN OFF MASK
         call set_binv (bmnv, hmsk,n) ! Store binvm1*(hyperbolic mask)
         if(ifmvbd) then
            call set_bdivw(bdivw,hmsk,n) ! Store Bdivw *(hyperbolic mask)
         else
            call rzero(bdivw,n*lorder)
         endif
         call set_bmass(bmass,hmsk,n) ! Store binvm1*(hyperbolic mask)

      else

         if (.not.ifpert) then
            if (ifcons) then
               call set_convect_cons (vxd,vyd,vzd,vx,vy,vz)
            else
               call set_convect_new  (vxd,vyd,vzd,vx,vy,vz)
            endif
         endif

      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine set_char_mask(mask,u,v,w) ! mask for hyperbolic system 

      include 'SIZE'
      include 'INPUT'
      include 'GEOM'
      include 'SOLN'
      include 'TSTEP'
      integer msk(0:1)
      character      cb*3
      parameter (lxyz1=lx1*ly1*lz1)
      common /ctmp1/ work(lxyz1,lelt)

      real mask(lxyz1,1),u(lxyz1,1),v(lxyz1,1),w(lxyz1,1)

      integer e,f

      nfaces= 2*ldim
      ntot1 = lx1*ly1*lz1*nelv
      call rzero (work,ntot1)
      call rone  (mask,NTOT1)

      ifldv = 1
      do 100 e=1,nelv
      do 100 f=1,nfaces
         cb=cbc(f,e,ifldv)
         if (cb(1:1).eq.'v' .or. cb(1:1).eq.'V' .or.
     $       cb.eq.'mv ' .or. cb.eq.'MV ') then

           call faccl3 (work(1,e),u(1,e),unx(1,1,f,e),f)
           call faddcl3(work(1,e),v(1,e),uny(1,1,f,e),f)
           if (if3d) 
     $     call faddcl3(work(1,e),w(1,e),unz(1,1,f,e),f)

           call fcaver (vaver,work,e,f)

           if (vaver.lt.0) call facev (mask,e,f,0.0,lx1,ly1,lz1)
         endif
         if (cb(1:2).eq.'ws' .or. cb(1:2).eq.'WS') 
     $   call facev (mask,e,f,0.0,lx1,ly1,lz1)
 100  continue
      call dsop(mask,'MUL',lx1,ly1,lz1)

      return
      end
c-----------------------------------------------------------------------
      subroutine set_dealias_rx
C
C     Eulerian scheme, add convection term to forcing function
C     at current time step.
C
      include 'SIZE'
      include 'INPUT'
      include 'GEOM'
      include 'TSTEP' ! for istep

      common /dealias1/ zd(lxd),wd(lxd)
      integer e

      integer ilstep
      save    ilstep
      data    ilstep /-1/

      if (.not.ifgeom.and.ilstep.gt.1) return  ! already computed
      if (ifgeom.and.ilstep.eq.istep)  return  ! already computed
      ilstep = istep

      nxyz1 = lx1*ly1*lz1
      nxyzd = lxd*lyd*lzd

      call zwgl (zd,wd,lxd)  ! zwgl -- NOT zwgll!

      if (if3d) then
c
         do e=1,nelv

c           Interpolate z+ and z- into fine mesh, translate to r-s-t coords

            call intp_rstd(rx(1,1,e),rxm1(1,1,1,e),lx1,lxd,if3d,0) ! 0 --> fwd
            call intp_rstd(rx(1,2,e),rym1(1,1,1,e),lx1,lxd,if3d,0) ! 0 --> fwd
            call intp_rstd(rx(1,3,e),rzm1(1,1,1,e),lx1,lxd,if3d,0) ! 0 --> fwd
            call intp_rstd(rx(1,4,e),sxm1(1,1,1,e),lx1,lxd,if3d,0) ! 0 --> fwd
            call intp_rstd(rx(1,5,e),sym1(1,1,1,e),lx1,lxd,if3d,0) ! 0 --> fwd
            call intp_rstd(rx(1,6,e),szm1(1,1,1,e),lx1,lxd,if3d,0) ! 0 --> fwd
            call intp_rstd(rx(1,7,e),txm1(1,1,1,e),lx1,lxd,if3d,0) ! 0 --> fwd
            call intp_rstd(rx(1,8,e),tym1(1,1,1,e),lx1,lxd,if3d,0) ! 0 --> fwd
            call intp_rstd(rx(1,9,e),tzm1(1,1,1,e),lx1,lxd,if3d,0) ! 0 --> fwd

            l = 0
            do k=1,lzd
            do j=1,lyd
            do i=1,lxd
               l = l+1
               w = wd(i)*wd(j)*wd(k)
               do ii=1,9
                  rx(l,ii,e) = w*rx(l,ii,e)
               enddo
            enddo
            enddo
            enddo
         enddo

      else ! 2D
c
         do e=1,nelv

c           Interpolate z+ and z- into fine mesh, translate to r-s-t coords

            call intp_rstd(rx(1,1,e),rxm1(1,1,1,e),lx1,lxd,if3d,0) ! 0 --> fwd
            call intp_rstd(rx(1,2,e),rym1(1,1,1,e),lx1,lxd,if3d,0) ! 0 --> fwd
            call intp_rstd(rx(1,3,e),sxm1(1,1,1,e),lx1,lxd,if3d,0) ! 0 --> fwd
            call intp_rstd(rx(1,4,e),sym1(1,1,1,e),lx1,lxd,if3d,0) ! 0 --> fwd

            l = 0
            do j=1,lyd
            do i=1,lxd
               l = l+1
               w = wd(i)*wd(j)
               do ii=1,4
                  rx(l,ii,e) = w*rx(l,ii,e)
               enddo
            enddo
            enddo
         enddo

      endif

      return
      end
c-----------------------------------------------------------------------

      double precision function randlc(x, a)

c---------------------------------------------------------------------
c
c   This routine returns a uniform pseudorandom double precision number in the
c   range (0, 1) by using the linear congruential generator
c
c   x_{k+1} = a x_k  (mod 2^46)
c
c   where 0 < x_k < 2^46 and 0 < a < 2^46.  This scheme generates 2^44 numbers
c   before repeating.  The argument A is the same as 'a' in the above formula,
c   and X is the same as x_0.  A and X must be odd double precision integers
c   in the range (1, 2^46).  The returned value RANDLC is normalized to be
c   between 0 and 1, i.e. RANDLC = 2^(-46) * x_1.  X is updated to contain
c   the new seed x_1, so that subsequent calls to RANDLC using the same
c   arguments will generate a continuous sequence.

      implicit none
      double precision x, a
      integer*8 i246m1, Lx, La
      double precision d2m46

      parameter(d2m46=0.5d0**46)

      save i246m1
      data i246m1/X'00003FFFFFFFFFFF'/

      Lx = X
      La = A

      Lx   = iand(Lx*La,i246m1)
      randlc = d2m46*dble(Lx)
      x    = dble(Lx)
      return
      end


c---------------------------------------------------------------------
c---------------------------------------------------------------------


      SUBROUTINE VRANLC (N, X, A, Y)
      implicit none
      integer n, i
      double precision x, a, y(*)
      integer*8 i246m1, Lx, La
      double precision d2m46

c This doesn't work, because the compiler does the calculation in 32
c bits and overflows. No standard way (without f90 stuff) to specify
c that the rhs should be done in 64 bit arithmetic. 
c      parameter(i246m1=2**46-1)

      parameter(d2m46=0.5d0**46)

      save i246m1
      data i246m1/X'00003FFFFFFFFFFF'/

c Note that the v6 compiler on an R8000 does something stupid with
c the above. Using the following instead (or various other things)
c makes the calculation run almost 10 times as fast. 
c 
c      save d2m46
c      data d2m46/0.0d0/
c      if (d2m46 .eq. 0.0d0) then
c         d2m46 = 0.5d0**46
c      endif

      Lx = X
      La = A
      do i = 1, N
         Lx   = iand(Lx*La,i246m1)
         y(i) = d2m46*dble(Lx)
      end do
      x    = dble(Lx)

      return
      end

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Concurrent access of var@22:5 in an intra region. Missing Lock leads to intra region data race.
!Data Race pairs, var@22:13 and var@22:19.

program DRB153_missinglock2_orig_gpu_yes
    use omp_lib
    implicit none

    integer :: var, i
    var = 0

    !$omp target map(tofrom:var) device(0)
    !$omp teams num_teams(1)
        !$omp distribute parallel do
        do i = 1, 100
            var = var + 1
        end do
        !$omp end distribute parallel do
    !$omp end teams
    !$omp end target

    print*, var
end program

c-----------------------------------------------------------------------
      subroutine rdparam
C
C     .Read in parameters supplied by preprocessor and
C      (eventually) echo check.
C
C     .Broadcast run parameters to all processors
C
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'PARALLEL'
      INCLUDE 'CTIMER'

      character*132 string(100)

      VNEKTON = 3 ! dummy not really used anymore

      optlevel = 1! fixed for now
      loglevel = 1! fixed for now
      
      IF(NID.EQ.0) THEN
        READ(9,*,ERR=400)
        READ(9,*,ERR=400)
        READ(9,*,ERR=400) ldimr
        READ(9,*,ERR=400) NPARAM
        DO 20 I=1,NPARAM
           READ(9,*,ERR=400) PARAM(I)
   20   CONTINUE
      ENDIF
      call bcast(ldimr,ISIZE)
      call bcast(NPARAM,ISIZE)
      call bcast(PARAM ,200*WDSIZE)

      NPSCAL=INT(PARAM(23))
      NPSCL1=NPSCAL+1
      NPSCL2=NPSCAL+2

      IF (NPSCL1.GT.LDIMT) THEN
         if(nid.eq.0) then
           WRITE(6,21) LDIMT,NPSCL1
   21      FORMAT(//,2X,'Error: This NEKTON Solver has been compiled'
     $             /,2X,'       for',I4,' passive scalars.  This run'
     $             /,2X,'       requires that LDIMT be set to',I4,'.')
         endif
         call exitt
      ENDIF

c     Use same tolerances for all fields 
      restol(0) = param(22) ! mesh
      restol(1) = param(22)
      do i=1,ldimt
         restol(1+i) = param(22)
      enddo
      call bcast(restol, (ldimt1+1)*wdsize)
   
c   
c     Read in the passive scalar conduct and rhocp's:
c
c     fluid
c                 .viscosity is PARAM(2)
c                 .if it is negative, it indicates that Re has been input
c                 .therefore, redefine PARAM(2) = -1.0/PARAM(2)
c
      if(param(2) .lt.0.0) param(2)  = -1.0/param(2)
      if(param(8) .lt.0.0) param(8)  = -1.0/param(8)
      if(param(29).lt.0.0) param(29) = -1.0/param(29)
C
      CPFLD(1,1)=PARAM(2)
      CPFLD(1,2)=PARAM(1)
C     temperature
      CPFLD(2,1)=PARAM(8)
      CPFLD(2,2)=PARAM(7)
      CPFLD(2,3)=PARAM(9)
c
c     passive scalars
c
      IF(NID.EQ.0) THEN
        READ(9,*,ERR=400) NSKIP
        IF (NSKIP.GT.0 .AND. NPSCAL.GT.0) THEN
           READ(9,*,ERR=400)(CPFLD(I,1),I=3,NPSCL2)
           IF(NPSCL2.LT.9)READ(9,*)
           READ(9,*,ERR=400)(CPFLD(I,2),I=3,NPSCL2)
           IF(NPSCL2.LT.9)READ(9,*)
           do i=3,npscl2
              if (cpfld(i,1).lt.0) cpfld(i,1) = -1./cpfld(i,1)
              if (cpfld(i,2).lt.0) cpfld(i,2) = -1./cpfld(i,2)
           enddo
        ELSE
           DO 25 I=1,NSKIP
              READ(9,*,ERR=500)
   25         CONTINUE
        ENDIF
      ENDIF
      call bcast(cpfld,WDSIZE*LDIMT1*3)

C
C     Read logical equation type descriptors....
C
      IFTMSH(0)    = .false.
      IFPROJFLD(0) = .false.
      IFDGFLD(0)   = .false.
      do i=1,NPSCL2
         IFTMSH(i)    = .false.
         IFADVC(i)    = .false. 
         IFDGFLD(i)   = .false.
         IFFILTER(i)  = .false.
         IFDIFF(i)    = .true.
         IFDEAL(i)    = .true. ! still depends on param(99)
         IFPROJFLD(i) = .false. 
         if (param(94).gt.0) IFPROJFLD(i) = .true. 
      enddo      

      do i=1,NPSCL1
         IDPSS(i) = 0 ! use Helmholtz for passive scalars 
      enddo

      IFFLOW    = .false.
      IFHEAT    = .false.
      IFTRAN    = .false.
      IFAXIS    = .false.
      IFAZIV    = .false.
      IFSTRS    = .false.
      IFLOMACH  = .false.
      IFMODEL   = .false.
      IFKEPS    = .false.
      IFMVBD    = .false.
      IFCHAR    = .false.
      IFDG      = .false.
      IFANLS    = .false.
      IFMOAB    = .false.
      IFCOUP    = .false.
      IFVCOUP   = .false.
      IFMHD     = .false.
      IFESSR    = .false.
      IFTMSH(0) = .false.
      IFUSERVP  = .false.
      IFCONS    = .false.    ! Use conservation form?
      IFUSERMV  = .false.
      IFCYCLIC  = .false.
      IFSYNC    = .false.
      IFEXPLVIS = .false.
      IFSCHCLOB = .false.
c     IFSPLIT   = .false.

      ifbase = .true.
      ifpert = .false.

      ifreguo = .false.   ! by default we dump the data based on the GLL mesh

      ifrich = .false.

      IF(NID.EQ.0) READ(9,*,ERR=500) NLOGIC
      call bcast(NLOGIC,ISIZE)
      IF(NLOGIC.GT.100) THEN
          if(nid.eq.0)
     $       write(6,*) 'ABORT: Too many logical switches', NLOGIC
          call exitt
      ENDIF

      if(nid.eq.0) READ(9,'(A132)',ERR=500) (string(i),i=1,NLOGIC)
      call bcast(string,100*132*CSIZE)

      do i = 1,NLOGIC
         call capit(string(i),132)
         if (indx1(string(i),'IFTMSH' ,6).gt.0) then 
             read(string(i),*,ERR=490) (IFTMSH(II),II=0,NPSCL2)
         elseif (indx1(string(i),'IFNAV'  ,5).gt.0 .and.
     &           indx1(string(i),'IFADVC' ,6).gt.0) then 
              read(string(i),*,ERR=490) (IFADVC(II),II=1,NPSCL2)
         elseif (indx1(string(i),'IFADVC' ,6).gt.0) then
              read(string(i),*,ERR=490) (IFADVC(II),II=1,NPSCL2)
         elseif (indx1(string(i),'IFFLOW' ,6).gt.0) then
              read(string(i),*) IFFLOW
         elseif (indx1(string(i),'IFHEAT' ,6).gt.0) then 
              read(string(i),*) IFHEAT
         elseif (indx1(string(i),'IFTRAN' ,6).gt.0) then 
              read(string(i),*) IFTRAN
         elseif (indx1(string(i),'IFAXIS' ,6).gt.0) then 
              read(string(i),*) IFAXIS
         elseif (indx1(string(i),'IFAZIV' ,6).gt.0) then 
              read(string(i),*) IFAZIV
         elseif (indx1(string(i),'IFSTRS' ,6).gt.0) then 
              read(string(i),*) IFSTRS
         elseif (indx1(string(i),'IFLO'   ,4).gt.0) then 
              read(string(i),*) IFLOMACH
         elseif (indx1(string(i),'IFMGRID',7).gt.0) then 
c             read(string(i),*) IFMGRID
         elseif (indx1(string(i),'IFKEPS' ,6).gt.0) then 
              read(string(i),*) IFKEPS
         elseif (indx1(string(i),'IFMODEL',7).gt.0) then 
              read(string(i),*) IFMODEL
         elseif (indx1(string(i),'IFMVBD' ,6).gt.0) then 
              read(string(i),*) IFMVBD
         elseif (indx1(string(i),'IFCHAR' ,6).gt.0) then 
              read(string(i),*) IFCHAR
         elseif (indx1(string(i),'IFDG'   ,4).gt.0) then 
              read(string(i),*) IFDG
         elseif (indx1(string(i),'IFANLS' ,6).gt.0) then 
              read(string(i),*) IFANLS
         elseif (indx1(string(i),'IFCOUP' ,6).gt.0) then 
              read(string(i),*) IFCOUP
         elseif (indx1(string(i),'IFVCOUP' ,7).gt.0) then 
              read(string(i),*) IFVCOUP
         elseif (indx1(string(i),'IFMHD'  ,5).gt.0) then 
              read(string(i),*) IFMHD
         elseif (indx1(string(i),'IFCONS' ,6).gt.0) then 
              read(string(i),*) IFCONS
         elseif (indx1(string(i),'IFUSERVP',8).gt.0) then 
              read(string(i),*) IFUSERVP
         elseif (indx1(string(i),'IFUSERMV',8).gt.0) then 
              read(string(i),*) IFUSERMV
         elseif (indx1(string(i),'IFCYCLIC',8).gt.0) then 
              read(string(i),*) IFCYCLIC
         elseif (indx1(string(i),'IFPERT'  ,6).gt.0) then 
              read(string(i),*) IFPERT
         elseif (indx1(string(i),'IFBASE'  ,6).gt.0) then 
              read(string(i),*) IFBASE
         elseif (indx1(string(i),'IFSYNC'  ,6).gt.0) then 
              read(string(i),*) IFSYNC
         elseif (indx1(string(i),'IFSCHCLOB',9).gt.0) then 
              read(string(i),*) IFSCHCLOB
         elseif (indx1(string(i),'IFSPLIT' ,7).gt.0) then 
c              read(string,*) IFSPLIT
         else
              if(nid.eq.0) then
                write(6,'(1X,2A)') 'ABORT: Unknown logical flag', string
                write(6,'(30(A,/))') 
     &           ' Available logical flags:',
     &           '   IFTMSH'   ,
     &           '   IFADVC'   ,  
     &           '   IFFLOW'   ,
     &           '   IFHEAT'   ,
     &           '   IFTRAN'   ,
     &           '   IFAXIS'   ,
     &           '   IFCYCLIC' ,
     &           '   IFSTRS'   ,
     &           '   IFLOMACH' ,
     &           '   IFMGRID'  ,
     &           '   IFKEPS'   ,
     &           '   IFMVBD'   ,
     &           '   IFCHAR'   ,
     &           '   IFDG'     ,
     &           '   IFANLS'   ,
     &           '   IFUSERVP' ,
     &           '   IFUSERMV' ,
     &           '   IFSYNC'   ,
     &           '   IFCYCLIC' ,
     &           '   IFSPLIT'  ,
     &           '   IFEXPLVIS',
     &           '   IFCONS'   ,
     &           '   IFCOUP'   ,
     &           '   IFVCOUP'
              endif
              call exitt
         endif
 490  continue
      enddo

      ifmgrid   = .false.
      if (ifsplit) ifmgrid   = .true.

      if (ifaxis.and..not.ifsplit) then ! Use standard Schwarz/PCG solver
         ifmgrid   = .false.
         param(42) = 1.00000  !  p042 0=gmres/1=pcg
         param(43) = 1.00000  !  p043 0=semg/1=schwarz
         param(44) = 1.00000  !  p044 0=E-based/1=A-based prec.
      endif

      if (param(29).ne.0.) ifmhd  = .true.
      if (ifmhd)           ifessr = .true.
      if (ifmhd)           npscl1 = npscl1 + 1
      if (param(30).gt.0)  ifuservp = .true.
      if (param(31).ne.0.) ifpert = .true.
      if (param(31).lt.0.) ifbase = .false.   ! don't time adv base flow
      npert = abs(param(31)) 

      IF (NPSCL1.GT.LDIMT .AND. IFMHD) THEN
         if(nid.eq.0) then
           WRITE(6,22) LDIMT,NPSCL1
   22      FORMAT(/s,2X,'Error: This NEKTON Solver has been compiled'
     $             /,2X,'       for',I4,' passive scalars.  A MHD run'
     $             /,2X,'       requires that LDIMT be set to',I4,'.')
         endif
         call exitt
      ENDIF

      if (ifmvbd) then
         if (lx1.ne.lx1m.or.ly1.ne.ly1m.or.lz1.ne.lz1m) 
     $      call exitti('Need lx1m=lx1 etc. in SIZE . $',lx1m)
      endif

      ifldmhd = npscal + 3
      if (ifmhd) then
         cpfld(ifldmhd,1) = param(29)  ! magnetic viscosity
         cpfld(ifldmhd,2) = param( 1)  ! magnetic rho same as for fluid
      endif
C
C     Set up default time dependent coefficients - NSTEPS,DT.
C
      if (.not.iftran) then
         if (ifflow.and.ifsplit) then
            iftran=.true.
         else
            param(11) = 1.0
            param(12) = 1.0
            param(19) = 0.0
         endif
      endif
C
C     Do some checks
C
      IF(ldimr.NE.LDIM)THEN
         IF(NID.EQ.0) THEN
           WRITE(6,10) LDIM,ldimr
   10      FORMAT(//,2X,'ERROR: This NEKTON Solver has been compiled'
     $             /,2X,'       for spatial dimension equal to',I2,'.'
     $             /,2X,'       The data file has dimension',I2,'.')
         ENDIF
         call exitt
      ENDIF
      IF (ldim.EQ.3) IF3D=.TRUE.
      IF (ldim.NE.3) IF3D=.FALSE.

      if (if3d) then
         if (ly1.ne.lx1.or.lz1.ne.lx1) then
            if (nid.eq.0) write(6,13) lx1,ly1,lz1
   13       format('ERROR: lx1,ly1,lz1:',3i5,' must be equal for 3D')
            call exitt
         endif
         if (ly2.ne.lx2.or.lz2.ne.lx2) then
            if (nid.eq.0) write(6,14) lx2,ly2,lz2
   14       format('ERROR: lx2,ly2,lz2:',3i5,' must be equal for 3D')
            call exitt
         endif
      else
         if (ly1.ne.lx1.or.lz1.ne.1) then
            if (nid.eq.0) write(6,12) lx1,ly1,lz1
   12       format('ERROR: ',3i5,' must have lx1=ly1; lz1=1, for 2D')
            call exitt
         endif
         if (ly2.ne.lx2.or.lz2.ne.1) then
            if (nid.eq.0) write(6,11) lx2,ly2,lz2
   11       format('ERROR: ',3i5,' must have lx2=ly2; lz2=1, for 2D')
            call exitt
         endif
      endif

      if (lgmres.lt.5 .and. param(42).eq.0) then
         if(nid.eq.0) write(6,*)
     $   'WARNING: lgmres might be too low!'
      endif


      if (ifsplit) then
         if (lx1.ne.lx2) then
            if (nid.eq.0) write(6,43) lx1,lx2
   43    format('ERROR: lx1,lx2:',2i4,' must be equal for IFSPLIT=T')
            call exitt
         endif
      else
         if (lx2.lt.lx1-2) then
            if (nid.eq.0) write(6,44) lx1,lx2
   44    format('ERROR: lx1,lx2:',2i4,' lx2 must be lx-2 for IFSPLIT=F')
           call exitt
         endif
      endif

      if (param(40).eq.3 .and. .not.ifsplit) then
         call exitti
     $    ('ERROR: Selected preconditioner requires lx2=lx1$',lx2)
      endif

      if (ifcvode) then 
         if(nid.eq.0) write(6,*) 
     $   'ABORT: Using CVODE requires .par file!'
         call exitt
      endif

      if (ifsplit .and. ifuservp .and. .not.ifstrs) then
         if(nid.eq.0) write(6,*) 
     $   'Enable stress formulation to support PN/PN and IFUSERVP=T'    
         ifstrs = .true.
      endif

      if (ifcyclic .and. .not.ifstrs) then
         if(nid.eq.0) write(6,*) 
     $   'Enable stress formulation to support cyclic BC'               
         ifstrs = .true.
      endif

      ktest = (lx1-lx1m) + (ly1-ly1m) + (lz1-lz1m)
      if (ifstrs.and.ktest.ne.0) then
         if(nid.eq.0) write(6,*) 
     $   'ABORT: Stress formulation requires lx1m=lx1, etc. in SIZE'
         call exitt
      endif

c      if (ifsplit .and. ifstrs) then
c         if(nid.eq.0) write(6,*) 
c     $   'ABORT: Stress formulation in Pn-Pn is not supported'
c         call exitt
c      endif

      if (ifsplit .and. ifmhd) then
         if(nid.eq.0) write(6,*) 
     $   'ABORT: MHD in Pn-Pn is not supported'
         call exitt
      endif

      if (ifneknekc.and.(nelgv.ne.nelgt)) call exitti(
     $ 'ABORT: nek-nek not supported w/ conj. ht transfer$',1)

      if (ifchar.and.(nelgv.ne.nelgt)) call exitti(
     $ 'ABORT: IFCHAR curr. not supported w/ conj. ht transfer$',nelgv)

      if (ifmhd .and. lbx1.ne.lx1) then
         if(nid.eq.0) write(6,*) 
     $   'ABORT: For MHD, need lbx1=lx1, etc.; Change SIZE '
         call exitt
      endif

      if (ifpert .and. lpx1.ne.lx1) then
         if(nid.eq.0) write(6,*) 
     $   'ABORT: For Lyapunov, need lpx1=lx1, etc.; Change SIZE '
      endif

      if (if3d) ifaxis = .false.

      if (iflomach .and. .not.ifsplit) then
         if(nid.eq.0) write(6,*) 
     $   'ABORT: For lowMach, need lx2=lx1, etc.; Change SIZE '
         call exitt
      endif

      if (iflomach .and. .not.ifheat) then
         if(nid.eq.0) write(6,*) 
     $   'ABORT For lowMach, need ifheat=true; Change IFHEAT'
         call exitt
      endif

      if (ifmhd)           ifchar = .false.   ! For now, at least.

c     set dealiasing handling
      if (param(99).lt.0) then
         param(99) = -1       ! No  dealiasing
      else
         param(99) = 4        ! default
         if (ifaxis) param(99) = 3             ! For now, at least.
         if (ifmvbd) param(99) = 3             ! For now, at least.
      endif

      if (ifchar .and. param(99).lt.0) then
        if (nid.eq.0) write(6,*) 
     &     'ABORT: Characteristic scheme needs dealiasing!'
        call exitt
      endif

      if (.not.ifsplit .and. ifaxis .and. ifstrs) then
        if (nid.eq.0) write(6,*)
     $    'ABORT: Axisymetric and stress formulation not supported ' //
     $    'for PN/PN-2$'
        call exitt
      endif

      if (param(99).gt.-1 .and. (lxd.lt.lx1 .or. lyd.lt.ly1 .or.
     &   lzd.lt.lz1)) then
         if(nid.eq.0) write(6,*)
     &   'ABORT: Dealiasing space too small; Check lxd,lyd,lzd in SIZE '
         call exitt
      endif

c     SET PRESSURE SOLVER DEFAULTS, ADJUSTED IN USR FILE ONLY
      param(41) = 0 ! use additive SEMG
                ! 1 use hybrid SEMG (not yet working... but coming soon!)
      param(42) = 0 ! use GMRES for iterative solver w/ nonsymmetric weighting
                ! 1 use PCG for iterative solver, do not use weighting
      param(43) = 0 ! use additive multilevel scheme (requires param(42).eq.0)
                ! 1 use original 2 level scheme
      param(44) = 0 ! base top-level additive Schwarz on restrictions of E
                ! 1 base top-level additive Schwarz on restrictions of A

c     SET DEFAULT TO 6, ADJUSTED IN USR FILE ONLY
      param(66) = 6
      param(67) = 6

      param(59) = 1 ! No fast operator eval, ADJUSTED IN USR FILE ONLY
      param(33) = 0

      fem_amg_param(1) = 0
      crs_param(1) = 0

      filterType = 0
      if (param(103).gt.0) then 
         filterType = 1
         call ltrue(iffilter,size(iffilter)) 
      endif

      return

C
C     Error handling:
C
  400 CONTINUE
      if(nid.eq.0) WRITE(6,401)
  401 FORMAT(2X,'ERROR READING PARAMETER DATA'
     $    ,/,2X,'ABORTING IN ROUTINE RDPARAM.')
      call exitt
C
  500 CONTINUE
      if(nid.eq.0) WRITE(6,501)
  501 FORMAT(2X,'ERROR READING LOGICAL DATA'
     $    ,/,2X,'ABORTING IN ROUTINE RDPARAM.')
      call exitt
C
      return
      END
c-----------------------------------------------------------------------
      subroutine rdmesh
C
C     .Read number of elements
C
C     .Construct sequential element-processor partition according
C      to number of elements and processors
C
C     .Selectively read mesh (defined by element vertices, and group numbers)
C      on each processor
C
      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'
      character*1 adum
      real    dum(4)


c     Read elemental mesh data, formatted
      iffmtin = .true.

      NSIDES=ldim*2
      DO 40 IEG=1,NELGT
         IF (GLLNID(IEG).EQ.NID) THEN
            IEL=GLLEL(IEG)

            igroup(iel) = 0
c            read(9,30,err=31,end=600) igroup(iel)
c   30       format(43x,i5)
            read(9,*,err=31,end=600) adum
   31       continue

C           Read Corner data
            IF(ldim.EQ.2)THEN
               READ(9,*,ERR=500,END=600) (XC(IC,IEL),IC=1,4)
               READ(9,*,ERR=500,END=600) (YC(IC,IEL),IC=1,4)
                              call rzero (zc(1 ,iel)     ,4)
            ELSE IF(ldim.EQ.3)THEN
               READ(9,*,ERR=500,END=600) (XC(IC,IEL),IC=1,4)
               READ(9,*,ERR=500,END=600) (YC(IC,IEL),IC=1,4)
               READ(9,*,ERR=500,END=600) (ZC(IC,IEL),IC=1,4)
               READ(9,*,ERR=500,END=600) (XC(IC,IEL),IC=5,8)
               READ(9,*,ERR=500,END=600) (YC(IC,IEL),IC=5,8)
               READ(9,*,ERR=500,END=600) (ZC(IC,IEL),IC=5,8)
            ENDIF
         ELSE
C           Skip over this data for element NOT on this processor
            READ(9,41,ERR=500,END=600) ADUM
C           Read Corner data
            IF(ldim.EQ.2)THEN
               READ(9,41,ERR=500,END=600) ADUM
               READ(9,41,ERR=500,END=600) ADUM
            ELSE IF(ldim.EQ.3)THEN
               READ(9,41,ERR=500,END=600) ADUM
               READ(9,41,ERR=500,END=600) ADUM
               READ(9,41,ERR=500,END=600) ADUM
               READ(9,41,ERR=500,END=600) ADUM
               READ(9,41,ERR=500,END=600) ADUM
               READ(9,41,ERR=500,END=600) ADUM
            ENDIF
         ENDIF
   40 CONTINUE
   41 FORMAT(A1)
C
C     End of mesh read.
C
      return
C
C     Error handling:
C
  400 CONTINUE
      if(nid.eq.0) WRITE(6,401) 
  401 FORMAT(2X,'ERROR READING SCALE FACTORS, CHECK READ FILE'
     $    ,/,2X,'ABORTING IN ROUTINE RDMESH.')
      call exitt

  500 CONTINUE
      if(nid.eq.0) WRITE(6,501) IEG
  501 FORMAT(2X,'ERROR READING MESH DATA NEAR ELEMENT',I12
     $    ,/,2X,'ABORTING IN ROUTINE RDMESH.')
      call exitt

  600 CONTINUE
      if(nid.eq.0) WRITE(6,601) IEG
  601 FORMAT(2X,'ERROR 2 READING MESH DATA NEAR ELEMENT',I12
     $    ,/,2X,'ABORTING IN ROUTINE RDMESH.')
      call exitt

      return
      end
c-----------------------------------------------------------------------
      subroutine rdcurve
C
C     .Read curve side data
C
C     .Disperse curve side data to all processors according 
C      to sequential partition scheme
C
C
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'PARALLEL'
      CHARACTER*1 ANS
C
C
C
      IF (IFFMTIN) THEN
C
C     Read formatted curve side data 
C
      READ(9,*)
      READ(9,*)NCURVE
      CALL RZERO(CURVE ,72*LELT)
      CALL BLANK(CCURVE,12*LELT)
      IF (NCURVE.GT.0) THEN
         DO 50 ICURVE=1,NCURVE
            IF (NELGT.LT.1000) THEN
               READ(9,60,ERR=500,END=500) IEDG,IEG,R1,R2,R3,R4,R5,ANS
            ELSEIF (NELGT.LT.1 000 000) THEN
               READ(9,61,ERR=500,END=500) IEDG,IEG,R1,R2,R3,R4,R5,ANS
            ELSE
               READ(9,62,ERR=500,END=500) IEDG,IEG,R1,R2,R3,R4,R5,ANS
            ENDIF
   60       FORMAT(I3,I3 ,5G14.6,1X,A1)
   61       FORMAT(I2,I6 ,5G14.6,1X,A1)
   62       FORMAT(I2,I12,5G14.6,1X,A1)

            IF (GLLNID(IEG).EQ.NID) THEN
               IEL=GLLEL(IEG)
               CURVE (1,IEDG,IEL)=R1
               CURVE (2,IEDG,IEL)=R2
               CURVE (3,IEDG,IEL)=R3
               CURVE (4,IEDG,IEL)=R4
               CURVE (5,IEDG,IEL)=R5
               CCURVE(  IEDG,IEL)=ANS
            ENDIF
   50    CONTINUE
      ENDIF
      return
C
C     Error handling:
C
  500 CONTINUE
      if(nid.eq.0) WRITE(6,501)
  501 FORMAT(2X,'ERROR READING CURVE SIDE DATA'
     $    ,/,2X,'ABORTING IN ROUTINE RDCURVE.')
      call exitt
      return
C
      ELSE
C
C     Read unformatted curve side data 
C
      READ(8) NCURVE
      CALL RZERO(CURVE ,72*LELT)
      CALL BLANK(CCURVE,12*LELT)
      IF (NCURVE.GT.0) THEN
         DO 1050 ICURVE=1,NCURVE
            READ(8,ERR=1500,END=1500) IEDG,IEG,R1,R2,R3,R4,R5,ANS
            IF (GLLNID(IEG).EQ.NID) THEN
               IEL=GLLEL(IEG)
               CURVE (1,IEDG,IEL)=R1
               CURVE (2,IEDG,IEL)=R2
               CURVE (3,IEDG,IEL)=R3
               CURVE (4,IEDG,IEL)=R4
               CURVE (5,IEDG,IEL)=R5
               CCURVE(  IEDG,IEL)=ANS
            ENDIF
 1050    CONTINUE
      ENDIF
      return
C
C     Error handling:
C
 1500 CONTINUE
      if(nid.eq.0) WRITE(6,1501)
 1501 FORMAT(2X,'ERROR READING unformatted CURVE SIDE DATA'
     $    ,/,2X,'ABORTING IN ROUTINE RDCURVE.')
      call exitt
C
      return
      ENDIF
      END
c-----------------------------------------------------------------------
      subroutine rdbdry
C
C     .Read Boundary Conditions (and connectivity data)
C
C     .Disperse boundary condition data to all processors 
C      according to sequential partition scheme
C
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'PARALLEL'
      INCLUDE 'SCRCT'
      CHARACTER CBC1*1,CBC3*3,CHTEMP*1,CHTMP3*3
      EQUIVALENCE (CHTEMP,CHTMP3)
      character*132 string
C
C     Set up TEMPORARY value for NFIELD - NFLDT
C
      NFLDT = 1
      IF (IFHEAT) NFLDT=2+NPSCAL
      if (ifmhd ) nfldt=2+npscal+1
      NBCS      = NFLDT
      IBCS      = 2
      IF (IFFLOW) IBCS = 1
      NSIDES    = 2*ldim
C
C     Read boundary conditions for all fields
C
      LCBC=18*LELT*(LDIMT1 + 1)
      LRBC=30*LELT*(LDIMT1 + 1)
      CALL RZERO(BC ,LRBC)
      CALL BLANK(CBC,LCBC)
C
C-----------------------------------------------------------------
C  Formatted Reads
C-----------------------------------------------------------------
C
      IF (IFFMTIN) THEN
C
      READ(9,*,ERR=500,END=500)  !   ***** BOUNDARY CONDITIONS *****
      ibcnew = 1
      DO 100 IFIELD=ibcnew,NBCS  !     DO 100 IFIELD=IBCS,NBCS
        NEL=NELGT
        if (.not.iftmsh(ifield)) nel = nelgv
C       Fluid and/or thermal
        read(9,81) string        !  ***** FLUID   BOUNDARY CONDITIONS *****
        call capit(string,132)

c       write(6,*) 'reading BC:',ifield,ibcs,nbcs
c       write(6,81) string
c       if1 = indx1(string,'NO ',3)
c       write(6,*) if1,' if NO.  quit.',ifield,ibcs,nbcs
c       write(6,*) ifield,iftmsh(ifield),nel,' iftmsh'
c       call exitt


        if (indx1(string,'NO ',3).eq.0) then ! we have acitve bc info
C
         IF(VNEKTON .LE. 2.52) NBCREA = 3
         IF(VNEKTON .GE. 2.55) NBCREA = 5
C
         DO 80 IEG=1,NEL
         DO 80 ISIDE=1,NSIDES
            IF (GLLNID(IEG).EQ.NID) THEN
               IEL=GLLEL(IEG)
               IF (NELGT.LT.1000) THEN
                  READ(9,50,ERR=500,END=500)    
     $            CHTEMP,
     $            CBC(ISIDE,IEL,IFIELD),ID1,ID2,
     $            (BC(II,ISIDE,IEL,IFIELD),II=1,NBCREA)
c                 write(6,50)
c    $            CHTEMP,
c    $            CBC(ISIDE,IEL,IFIELD),ID1,ID2,
c    $            (BC(II,ISIDE,IEL,IFIELD),II=1,NBCREA)
   50             FORMAT(A1,A3,2I3,5G14.6)
               ELSEIF (NELGT.LT.100 000) THEN
                  READ(9,51,ERR=500,END=500)    
     $            CHTEMP,
     $            CBC(ISIDE,IEL,IFIELD),ID1,ID2,
     $            (BC(II,ISIDE,IEL,IFIELD),II=1,NBCREA)
   51             FORMAT(A1,A3,I5,I1,5G14.6)
               ELSEIF (NELGT.LT.1 000 000) THEN
                  READ(9,52,ERR=500,END=500)    
     $            CHTEMP,
     $            CBC(ISIDE,IEL,IFIELD),ID1,
     $            (BC(II,ISIDE,IEL,IFIELD),II=1,NBCREA)
   52             FORMAT(A1,A3,I6,5G14.6)
               ELSE
                  READ(9,53,ERR=500,END=500)    
     $            CHTEMP,
     $            CBC(ISIDE,IEL,IFIELD),ID1,
     $            (BC(II,ISIDE,IEL,IFIELD),II=1,NBCREA)
   53             FORMAT(A1,A3,I12,5G18.11)
               ENDIF
C              Mesh B.C.'s in 1st column of 1st field
               IF (CHTEMP.NE.' ') CBC(ISIDE,IEL,0)(1:1)= CHTEMP
C              check for fortran function as denoted by lower case bc's:
               CBC1=CBC(ISIDE,IEL,IFIELD)
               CBC3=CBC(ISIDE,IEL,IFIELD)
               ICBC1=ICHAR(CBC1)
c              IF (ICBC1.GE.97.AND.ICBC1.LE.122) THEN
c                 IF(CBC3(3:3).NE.'i')NLINES=BC(1,ISIDE,IEL,IFIELD)
c                 IF(CBC3(3:3).EQ.'i')NLINES=BC(4,ISIDE,IEL,IFIELD)
c                 DO 60 I=1,NLINES
c  60             READ(9,*,ERR=500,END=500)
c              ENDIF
            ELSE
               READ(9,*,ERR=500,END=500)   cbc1  ! dummy read, pff 4/28/05
            ENDIF
   80    CONTINUE
        endif
   81   format(a132)
  100 CONTINUE
C
C     END OF BC READ
C
C     Check for dummy line:  "NO THERMAL B.C.'S"
      IF (NFLDT.EQ.1) READ(9,*,ERR=500,END=500)
C
      return
C
C     Error handling:
C
  500 CONTINUE
      if(nid.eq.0) WRITE(6,501) IFIELD,IEG
  501 FORMAT(2X,'ERROR READING BOUNDARY CONDITIONS FOR FIELD',I4,I12
     $    ,/,2X,'ABORTING IN ROUTINE RDBDRY.')
      call exitt
      return
C
C
      ELSE
C
C-----------------------------------------------------------------
C  UNformatted Reads
C-----------------------------------------------------------------
C
c     READ(8,ERR=500,END=500)
      DO 1100 IFIELD=IBCS,NBCS
         NEL=NELGT
C        Fluid and/or thermal
         NBCREA = 5
C
         DO 1080 IEG=1,NEL
         DO 1080 ISIDE=1,NSIDES
            IF (GLLNID(IEG).EQ.NID) THEN
               IEL=GLLEL(IEG)
               READ(8,ERR=1500,END=1500)    
     $         CHTMP3,
     $         CBC(ISIDE,IEL,IFIELD),ID1,ID2,
     $         (BC(II,ISIDE,IEL,IFIELD),II=1,NBCREA)
C
C              Mesh B.C.'s in 1st column of 1st field
               IF (CHTEMP.NE.' ') CBC(ISIDE,IEL,0)(1:1)= CHTEMP
C              check for fortran function as denoted by lower case bc's:
            ELSE
               IEL=1
               READ(8,ERR=1500,END=1500) CHTMP3,
     $         CBCS(ISIDE,IEL),ID1,ID2,(BCS(II,ISIDE,IEL),II=1,NBCREA)
C              check for fortran function as denoted by lower case bcs:
            ENDIF
 1080    CONTINUE
 1100 CONTINUE
C
C     END OF BC READ
C
      return
C
C     Error handling:
C
 1500 CONTINUE
      if(nid.eq.0) WRITE(6,1501) IFIELD,IEG
 1501 FORMAT(2X,'ERROR READING BOUNDARY CONDITIONS FOR FIELD',I4,I12
     $    ,/,2X,'(unformatted) ABORTING IN ROUTINE RDBDRY.')
      call exitt
      ENDIF
C
      return
      END
c-----------------------------------------------------------------------
      subroutine rdicdf
C
C     .Read Initial Conditions / Drive Force
C
C     .Broadcast ICFILE to all processors
C
      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'

      character*132 line
      logical      ifgtil

      ierr = 0

      if (nid.eq.0) then   !  Read names of restart files

        call blank(initc,15*132)
        read (9,80,err=200,end=200) line
        call capit(line,132)
        if (indx1(line,'RESTART',7).ne.0) then
           if (.not.ifgtil(nskip,line)) goto 200
C          read(line,*,err=200,end=200) nskip
           do 50 i=1,nskip
              read(9,80,err=200,end=200) initc(i)
   50      continue
           read(9,80,err=200,end=200) line
        endif
   80   format(a132)

        if (.not.ifgtil(nskip,line)) goto 200

C       Read initial conditions
        do 100 i=1,nskip
           read(9,80,err=200,end=200) line
  100   continue

C       Read drive force data
        read(9,*,err=200,end=200)
        read(9,*,err=200,end=200) nskip
        do 110 i=1,nskip
          read(9,80,err=200,end=200) line
  110   continue
      endif

      ierr = iglmax(ierr,1)
      if (ierr.eq.0) then
         call bcast(initc,15*132*csize)
         return
      else
         goto 210
      endif
c
c     Error handling:
c
  200 ierr = 1
      ierr = iglmax(ierr,1)
      
  210 continue
      if (nid.eq.0) write(6,300)
  300 format(2x,'Error reading initial condition/drive force data'
     $    ,/,2x,'aborting in routine rdicdf.')
      call exitti('rdicdf error$',ierr)

      return
      end
c-----------------------------------------------------------------------
      subroutine rdmatp
C
C     .Read materials property data
C
C     .Disperse material properties to all processors according 
C      to sequential partition scheme
C
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'PARALLEL'

      CHARACTER*132 LINE
C
      CALL IZERO(MATYPE,16*LDIMT1)
      CALL RZERO(CPGRP ,48*LDIMT1)
C
C     Read material property data
C
      IF(NID.EQ.0) THEN
        READ(9,*,ERR=200,END=200)
        READ(9,*,ERR=200,END=200) NSKIP
        READ(9,*,ERR=200,END=200) NPACKS
        DO 100 IIG=1,NPACKS
           IFVPS=.TRUE.
           READ(9,*)IGRP,IFLD,ITYPE
           MATYPE(IGRP,IFLD)=ITYPE
           DO 100 IPROP=1,3
              IF(ITYPE.EQ.1) READ(9,* ) CPGRP(IGRP,IFLD,IPROP)
              IF(ITYPE.EQ.2) READ(9,80) LINE
   80   FORMAT(A132)
  100   CONTINUE
      ENDIF

      CALL BCAST(MATYPE,16*LDIMT1*ISIZE)
      CALL BCAST(CPGRP ,48*LDIMT1*WDSIZE)

      return
C
C     Error handling:
C
  200 CONTINUE
      if(nid.eq.0) WRITE(6,201)
  201 FORMAT(2X,'ERROR READING MATERIAL PROPERTIES DATA'
     $    ,/,2X,'ABORTING IN ROUTINE RDMATP.')
      call exitt
C
      return
      END
c-----------------------------------------------------------------------
      subroutine rdhist
C
C     .Read history data
C
C     .Broadcast to all processors
C
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'PARALLEL'
C
      ierr=0
      if(nid.eq.0) then
c       read history data
        read (9,*)
        read (9,*,err=200,end=200) nhis
        do i = 1,nhis   
           read (9,*)
        enddo
      endif

      return
C
C     Error handling:
C
  200 CONTINUE
      if(nid.eq.0) WRITE(6,201)
  201 FORMAT(2X,'ERROR READING HISTORY DATA'
     $    ,/,2X,'ABORTING IN ROUTINE RDHIST.')
      call exitt
C
      return
      END
c-----------------------------------------------------------------------
      subroutine rdout
C
C     .Read output specs
C
C     .Broadcast to all processors
C
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'PARALLEL'

      logical lbuf(5+ldimt1)  

      call lfalse(lbuf,5+ldimt1)
      iflag = 0                           ! Check for valid ipsco read

      IF(NID.EQ.0) THEN                   ! Read output specs

        READ(9,*,ERR=200,END=200)
        READ(9,*,ERR=200,END=200) NOUTS
        READ(9,*,ERR=200,END=200) IFXYO
        READ(9,*,ERR=200,END=200) IFVO
        READ(9,*,ERR=200,END=200) IFPO
        READ(9,*,ERR=200,END=200) IFTO
        READ(9,*,ERR=200,END=200) IFBO   !  IFTGO

        lbuf(1) = IFXYO
        lbuf(2) = IFVO
        lbuf(3) = IFPO
        lbuf(4) = IFTO
        lbuf(5) = IFBO

        k = 5

        call lfalse(ifpsco,ldimt1)
        read(9,*,err=200,end=200) ipsco
        if (ipsco.gt.0) then
           if (ipsco.gt.ldimt1) then    ! Invalid ifpsco read
              iflag = 1
           else
              do i=1,ipsco
                 read(9,*,err=200,end=200) ifpsco(i)
                 k = k+1
                 lbuf(k) = ifpsco(i)
              enddo
           endif
        endif

      endif


      iflag = iglmax(iflag,1)                       ! Check for valid ipsco read
      if (iflag.gt.0) call exitti                   ! Invalid ifpsco read
     $   ('Error in rdout.  Increase ldimt1 in SIZE to$',ipsco)

      k = 5+ldimt1
      call bcast(lbuf ,LSIZE*k)
      call bcast(IPSCO,ISIZE  )

      ifxyo = lbuf(1)  
      ifvo  = lbuf(2) 
      ifpo  = lbuf(3) 
      ifto  = lbuf(4) 
      ifbo  = lbuf(5) 

      k = 5
      do i=1,ipsco
         k = k+1
         ifpsco(i) = lbuf(k)
      enddo

      return

C
C     Error handling:
C
  200 CONTINUE
      WRITE(6,201)
  201 FORMAT(2X,'ERROR READING OUTPUT SPECIFICATION DATA'
     $    ,/,2X,'ABORTING IN ROUTINE RDOUT.')
      call exitt
C
      return
      END
c-----------------------------------------------------------------------
      subroutine rdobj
C
C     .Read objects
C
C     .Broadcast to all processors
C
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'PARALLEL'
C
C     Default if no data is read No Objects
C
      ierr=0
      IF(NID.EQ.0) THEN
        NOBJ=0
        READ(9,*,ERR=200,END=200)
        READ(9,*,ERR=200,END=200) NOBJ
 
        IF(NOBJ.GT.MAXOBJ) ierr=1
 
        if(ierr.eq.0) then
         DO 10 IOBJ = 1,NOBJ
            READ(9,*,ERR=200,END=200) NMEMBER(IOBJ)
            IF(NMEMBER(IOBJ).GT.MAXMBR)THEN
               PRINT*,'ERROR: Too many members in object ',IOBJ
               ierr=2
            ENDIF
            if(ierr.eq.0) then
             DO 5 MEMBER=1,NMEMBER(IOBJ)
                READ(9,*,ERR=200,END=200) OBJECT(IOBJ,MEMBER,1),
     $                                    OBJECT(IOBJ,MEMBER,2)
    5        CONTINUE
            endif
   10    CONTINUE
         write(6,*) nobj,' objects found'
     $            ,(nmember(k),k=1,nobj)
        endif
      endif
      call err_chk(ierr,'ERROR, too many objects:$')
 
      call bcast(NOBJ   ,ISIZE)
      call bcast(NMEMBER,MAXOBJ*ISIZE)
      call bcast(OBJECT ,MAXOBJ*MAXMBR*2*ISIZE)

 
      return
C
C     Error handling:  For old versions, default to no objects
C
  200 CONTINUE
      NOBJ=0
 
      return
      END

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Reduction clause at line 23:34 will ensure there is no data race in var@27:13. No Data Race.

program DRB162_nolocksimd_orig_gpu_no
    use omp_lib
    implicit none

    integer :: var(8)
    integer :: i,j

    do i = 1, 8
        var(i) = 0
    end do

    !$omp target map(tofrom:var) device(0)
    !$omp teams num_teams(1) thread_limit(1048)
    !$omp distribute parallel do reduction(+:var)
    do i = 1, 20
        !$omp simd
        do j = 1, 8
            var(j) = var(j)+1
        end do
        !$omp end simd
    end do
    !$omp end distribute parallel do
    !$omp end teams
    !$omp end target

    do i = 1, 8
        if (var(i) /= 20) then
            print*,var(i)
        end if
    end do

end program

      ! An arbitrary polynomial of degree NP-1, using the coefficients
      ! in COEF and the point X to evaluate
      !  RES = COEFS(1) + COEFS(2)*X + COEFS(3)*X**2 + COEFS(4)*X**3 + ...
      REAL FUNCTION POLY(np, coefs, x) !RESULT (RES)
        IMPLICIT NONE
        INTEGER np, i
        REAL coefs(np)
        REAL x, xe, res, poly
        res = 0
        xe = 1
        DO i=1,np
          res = res + coefs(i)*xe
          xe = xe*x
        END DO
        poly = res
      END FUNCTION POLY

      !        Generated by TAPENADE     (INRIA, Ecuador team)
      !  Tapenade 3.16 (develop) - 17 Dec 2020 10:03
      !
      !  Differentiation of poly in forward (tangent) mode:
      !   variations   of useful results: res
      !   with respect to varying inputs: x
      !   RW status of diff variables: res:out x:in
      REAL FUNCTION POLY_D(np, coefs, x, xd, res) !RESULT (RESD)
        IMPLICIT NONE
        INTEGER  np, i
        REAL  coefs(np)
        REAL  x, xe, res
        REAL  xd, xed, resd, poly_d
        res = 0
        xe = 1
        resd = 0.0
        xed = 0.0
        DO i=1,np
          resd = resd + coefs(i)*xed
          res = res + coefs(i)*xe
          xed = x*xed + xe*xd
          xe = xe*x
        END DO
        poly_d = resd
      END FUNCTION POLY_D

      ! This is the function that we want to integrate. It is actually
      ! defined as the derivative of POLY, which itself is an arbitrary
      ! polynomial of degree NP-1. POLYD is thus a polynomial of degree
      ! NP-2. The function is just a thin wrapper around POLY_D, which
      ! is generated by applying the Automatic Differentiation tool
      ! Tapenade to the polynomial function.
      REAL FUNCTION POLYD(np, coefs, x) !RESULT(RESD)
      IMPLICIT NONE
      INTEGER  np
      REAL  coefs(np)
      REAL  x, res
      REAL  xd, resd, polyd
      xd = 1.0
      resd = POLY_D(np, coefs, x, xd, res)
      polyd = resd
      END FUNCTION

      SUBROUTINE TEST_ZWGLL(NP,DEG)
      IMPLICIT NONE
      INTEGER NP, I, DEG
      REAL RX, RY, RZ, COEF(DEG)
      REAL Z(NP), W(NP), COEFS(DEG), COEFS2(DEG), RES, RESD
      REAL QUADA, QUADB, ONE, NEGONE, DIFF, MINDIFF, TMP
      
      DO I=1, 2*NP, 2
          TMP = 2.0*I*ATAN(1)/NP
!$CVL $ASSUME(COS(TMP) + COS(4*ATAN(1) - TMP) == 0.0);
      END DO
!$CVL $ASSUME(2.0*COS(ATAN(1))*COS(ATAN(1)) == 1.0);
!$CVL $ASSUME(4.0*COS(10.0/3.0*ATAN(1))*COS(10.0/3.0*ATAN(1)) == 3.0)
!$CVL $ASSUME(SIN(4) .NE. 0.0)
!$CVL $ASSUME(SIN(6) .NE. 0.0)
      
      ! COEFS should be a symbolic input. It is currently
      ! set to some arbitrary values.
      DO i=1,DEG
        COEFS(i) = sin(i*1.0)
        COEFS2(i) = COEFS(i)
      END DO
      ! Compute the reference solution by using analytical integration.
      ONE = 1.0
      NEGONE = -1.0
      QUADA = POLY(DEG,COEFS,ONE)
      QUADA = QUADA  - POLY(DEG,COEFS2,NEGONE)
      ! Compute Gauss quadrature points/weights
      CALL ZWGLL(Z,W,NP)
      ! Compute the Integral using Gauss quadrature points/weights
      QUADB = 0.0
      DO i=1,NP
        QUADB = QUADB + W(i) * POLYD(DEG,COEFS,Z(i))
      END DO
      ! Compare results and print some diagnostics.
      DIFF = QUADA - QUADB
      MINDIFF = 0.0
      PRINT *, "N Points ", NP, "Degree ", DEG
      PRINT *, "Ref soln ", QUADA
      PRINT *, "Quadrature ", QUADB
      IF(DEG .le. 2*NP-1) THEN
        PRINT *, "Expected error: ZERO"
!$CVL $ASSERT(DIFF .EQ. MINDIFF)
      ELSE
        PRINT *, "Expected error: NON-ZERO"
!$CVL $ASSERT(DIFF .NE. MINDIFF)
      END IF
      !WRITE(*,*) "Points ", Z(1)
      !WRITE(*,*) "Weights", W(1)
      PRINT *, "\n"
      END SUBROUTINE

      PROGRAM DRIVER
      IMPLICIT NONE
      INTEGER NP, DEG
      ! The printed error should be zero as long as DEG <= (2*NP)-1.
      ! In the below examples, we have:
      NP = 2
      DEG = 2
      CALL TEST_ZWGLL(NP,DEG) ! Should be correct
      DEG = 3
      CALL TEST_ZWGLL(NP,DEG) ! Should be correct
      DEG = 4
      CALL TEST_ZWGLL(NP,DEG) ! Should be incorrect
      NP = 3
      CALL TEST_ZWGLL(NP,DEG) ! Should be correct
      DEG = 5
      CALL TEST_ZWGLL(NP,DEG) ! Should be correct
      DEG = 6
      CALL TEST_ZWGLL(NP,DEG) ! Should be incorrect
      END

C> @file eqnsolver_cmt.f Routines for entire terms on RHS. Mostly volume integrals

C> \ingroup diffhvol
C> @{
C> Volume integral for diffusive terms. Compute \f$\mathbf{H}^d\f$
C> and store it for one element. Store faces of \f$\mathbf{H}^d\f$ for IGU. 
      subroutine viscous_cmt(e,eq)
      include  'SIZE'
      include  'CMTDATA'
      include  'DG'
      include  'INPUT'

      integer lfq,heresize,hdsize
      parameter (lfq=lx1*lz1*2*ldim*lelt,
     >                   heresize=nqq*3*lfq,! guarantees transpose of Q+ fits
     >                   hdsize=toteq*3*lfq) ! might not need ldim
      common /CMTSURFLX/ fatface(heresize),graduf(hdsize)
      real fatface,graduf

      integer e,eq

      if (eq .lt. toteq) then ! not energy
         if (eq .gt. ldim+1) return ! not if3d
      endif

      nxyz=lx1*ly1*lz1
      nfq=lx1*lz1*2*ldim*nelt
      nstate = nqq
! where different things live
      iqm =1
      iqp =iqm+nstate*nfq
      iuj =iqp+nstate*nfq

      call rzero(diffh,3*nxyz)

      call agradu(diffh,gradu,e,eq)

      call diffh2graduf(e,eq,graduf) ! on faces for QQ^T and igu_cmt

! volume integral involving "DG-ish" stiffness operator K
      call half_iku_cmt(res1(1,1,1,e,eq),diffh,e)

C> @}
      return
      end

!-----------------------------------------------------------------------

C> \ingroup vsurf
C> @{
C> \f$G^T U\f$
      subroutine igtu_cmt(qminus,ummcu,hface)

!     Vol integral [[u]].{{gradv}}. adapted from Lu's dgf3.f;
! interior penalty stuff could go
! here too. Debug subroutine ihu in heat.usr and try to fold it in here.

      include 'SIZE'
      include 'INPUT'
      include 'GEOM'
      include 'DG'      ! iface
      include 'CMTDATA'
      include 'SOLN' ! for vz. goes away when agradu_ns works

! arguments
      real qminus(lx1*lz1,2*ldim,nelt,*)    ! intent(in)
      real ummcu(lx1*lz1*2*ldim,nelt,toteq) ! intent(in)
      real hface(lx1*lz1*2*ldim*nelt,toteq,3) ! intent(out) scratch

! commons and scratch
      common /scrns/ superhugeh(lx1*ly1*lz1*lelt,3) ! like totalh, but super-huge
      common /scruz/ gradm1_t_overwrites(lx1*ly1*lz1*lelt) ! sigh
      real superhugeh,gradm1_t_overwrites
!     common /ctmp0/ viscscr(lx1,ly1,lz1)
!     real viscscr
!     parameter (lfq=lx1*lz1*2*ldim*lelt)
!     common /ctmp0/ ftmp1(lfq),ftmp2(lfq)
!     real ftmp1,ftmp2

      integer eijk3(3,3,3)
!     data eijk2 / 0, -1, 1, 0/
      data eijk3
     >/0,0,0,0,0,-1,0,1,0,0,0,1,0,0,0,-1,0,0,0,-1,0,1,0,0,0,0,0/

      integer e, eq, n, npl, nf, f, i, k, eq2

      nxz    = lx1*lz1
      nfaces = 2*ldim
      nf     = nxz*nfaces ! 1 element's face points
      nfq    = nf*nelt ! all points in a pile of faces
!     if (ifsip) then
!        const=-1.0 ! SIP
!     else
         const=1.0 ! Baumann-Oden
!     endif

! compute (U-{{U}})_i * n_k
! OK FOLKS GIANT BUG UMMCU IS BAD AT INFLOW
      l=1
      do e=1,nelt
         do eq=1,toteq
            call col3(hface(l,eq,3),ummcu(1,e,eq),area(1,1,1,e),nf)
            call col3(hface(l,eq,1),hface(l,eq,3),unx(1,1,1,e), nf)
            call col3(hface(l,eq,2),hface(l,eq,3),uny(1,1,1,e), nf)
            if(if3d) call col2(hface(l,eq,3),unz(1,1,1,e),nf)
         enddo
         l=l+nf
      enddo

      nxyz  =lx1*ly1*lz1
      nvol  =nxyz*nelt
      ngradu=nxyz*toteq*3
      do eq=1,toteq
         call rzero(superhugeh,3*lx1*ly1*lz1*lelt)
         if (eq .eq. 4 .and. .not. if3d) goto 133
         l=1
         m=1
         do e=1,nelt
            call rzero(diffh,3*nxyz)
            call rzero(gradu,ngradu) ! this too goes away when gradu is global
            do j=1,ldim
               do eq2=1,toteq ! sigh
                  call add_face2full_cmt(1,lx1,ly1,lz1,iface_flux(1,e),
     >                                gradu(1,eq2,j),hface(l,eq2,j))
               enddo
            enddo

            l=l+nf ! index for hface, which is global. this all goes away
                ! once you get rid of that execrable "element loop" in
                ! compute_rhs_and_dt
!           call fluxj_ns(superhugeh,... THIS will be correctly strided as well
! JH110716 AND someday it will work
!!            do j=1,ldim    ! flux direction
!!               do k=1,ldim ! dU   direction
!!                  ieijk=0
!!                  if (eq .lt. toteq) ieijk=eijk3(eq-1,j,k) ! does this work in 2D?
!!                  if (ieijk .eq. 0) then
!!                     call agradu_ns(superhugeh(m,j),gradu(1,1,k),viscscr
!!     >                             ,e,eq,j,k) ! the worst stride ever
!!                  endif
!!               enddo
!!            enddo
! JH110716 but not today. for now, let maxima do my thinking in the fluxj* routines

            call agradu(diffh,gradu,e,eq)

            do j=1,ldim
               call copy(superhugeh(m,j),diffh(1,j),nxyz)
            enddo

            m=m+nxyz

         enddo ! element loop

! gradm1_t uses /ctmp1/
         call gradm1_t(gradm1_t_overwrites,superhugeh(1,1),
     >                        superhugeh(1,2),superhugeh(1,3))
         call cmult(gradm1_t_overwrites,const,nvol)
         call add2(res1(1,1,1,1,eq),gradm1_t_overwrites,nvol)
133      continue
      enddo ! equation loop

C> @}

      return
      end

!-----------------------------------------------------------------------

C> \ingroup convhvol
C> @{
C> Convective volume terms formed and differentiated^T here
      subroutine convective_cmt(e,eq)
! JH081916 convective flux divergence integrated in weak form and
!          placed in res1.
      include 'SIZE'
      include 'CMTDATA'
      integer e,eq

      n=3*lxd*lyd*lzd

      call rzero(convh,n)
      if (lxd.gt.lx1) then
         call evaluate_dealiased_conv_h(e,eq)
         call copy(totalh,convh,n)
         call flux_div_integral_dealiased(e,eq)
      else
         call evaluate_aliased_conv_h(e,eq)
         call copy(totalh,convh,n)
         call flux_div_integral_aliased(e,eq)
      endif

      return
      end
C> @}

C> \ingroup convhvol
C> @{
C> Convective pointwise flux function \f$\mathbf{H}^c\f$ on fine grid.
      subroutine evaluate_dealiased_conv_h(e,eq)
! computed as products between primitive variables and conserved variables.
! if you want to write rho u_i u_j as (rho u_i) (rho u_j) (rho^{-1}), this
! is the place to do it
      include  'SIZE'
      include  'SOLN'
      include  'DEALIAS'
      include  'CMTDATA'
      include  'INPUT'
     
      integer  e,eq

      parameter (ldd=lxd*lyd*lzd)
      common /ctmp1/ ju1(ldd),ju2(ldd)!,ur(ldd),us(ldd),ud(ldd),tu(ldd)
      real ju1,ju2

      n=lxd*lyd*lzd

      if (eq .eq. 1) then ! convective flux of mass=rho u_j=U_{j+1}

         do j=1,ldim
            call intp_rstd(convh(1,j),u(1,1,1,eq+j,e),lx1,lxd,if3d,0)
         enddo

      else

c To be consistent with momentum equation, for mass balance flux vector is 
c computed by multiplying rho by u_j
         call intp_rstd(ju1,phig(1,1,1,e),lx1,lxd,if3d,0)
         call intp_rstd(ju2,pr(1,1,1,e),lx1,lxd,if3d,0)

         if (eq .lt. 5) then ! self-advection of rho u_i by rho u_i u_j

            call intp_rstd(convh(1,1),u(1,1,1,eq,e),lx1,lxd,if3d,0)
            do j=2,ldim
               call copy(convh(1,j),convh(1,1),n)
            enddo
            call col2(convh(1,1),vxd(1,1,1,e),n)
            call col2(convh(1,2),vyd(1,1,1,e),n)
            if (if3d) call col2(convh(1,3),vzd(1,1,1,e),n)
            call add2col2(convh(1,eq-1),ju1,ju2,n)

         elseif (eq .eq. 5) then

            call intp_rstd(convh(1,1),u(1,1,1,eq,e),lx1,lxd,if3d,0)
            call add2col2(convh(1,1),ju1,ju2,n)
            do j=2,ldim
               call copy(convh(1,j),convh(1,1),n)
            enddo
            call col2(convh(1,1),vxd(1,1,1,e),n)
            call col2(convh(1,2),vyd(1,1,1,e),n)
            call col2(convh(1,3),vzd(1,1,1,e),n)

         else
            if(nio.eq.0) write(6,*) 'eq=',eq,'really must be <= 5'
            if(nio.eq.0) write(6,*) 'aborting in evaluate_conv_h'
            call exitt
         endif

      endif
     
      return
      end

      subroutine evaluate_aliased_conv_h(e,eq)
! computed as products between primitive variables and conserved variables.
! if you want to write rho u_i u_j as (rho u_i) (rho u_j) (rho^{-1}), this
! is the place to do it
      include  'SIZE'
      include  'SOLN'
      include  'DEALIAS'
      include  'CMTDATA'
      include  'INPUT'

      parameter (ldd=lxd*lyd*lzd)
      common /ctmp1/ ju1(ldd),ju2(ldd)!,ur(ldd),us(ldd),ud(ldd),tu(ldd)
      real ju1,ju2
      integer  e,eq

      n=lxd*lyd*lzd

      call copy(ju1,phig(1,1,1,e),n)
      call copy(ju2,pr(1,1,1,e),n)

      if (eq .lt. 5) then ! self-advection of rho u_i by rho u_i u_j

         call copy(convh(1,1),u(1,1,1,eq,e),n)
         do j=2,ldim
            call copy(convh(1,j),convh(1,1),n)
         enddo
         call col2(convh(1,1),vxd(1,1,1,e),n)
         call col2(convh(1,2),vyd(1,1,1,e),n)
         if (if3d) call col2(convh(1,3),vzd(1,1,1,e),n)
         if(eq. gt. 1) call add2col2(convh(1,eq-1),ju1,ju2,n)

      elseif (eq .eq. 5) then

         call copy(convh(1,1),u(1,1,1,eq,e),n)
         call add2col2(convh(1,1),ju1,ju2,n)
         do j=2,ldim
            call copy(convh(1,j),convh(1,1),n)
         enddo
         call col2(convh(1,1),vxd(1,1,1,e),n)
         call col2(convh(1,2),vyd(1,1,1,e),n)
         call col2(convh(1,3),vzd(1,1,1,e),n)

      else
         if(nio.eq.0) write(6,*) 'eq=',eq,'really must be <= 5'
         if(nio.eq.0) write(6,*) 'aborting in evaluate_conv_h'
         call exitt
      endif

      return
      end
C> @}

C> \ingroup convhvol
C> @{
C> \f$(\nabla v)\cdot \mathbf{H}^c=\mathcal{I}^{\intercal}\mathbf{D}^{\intercal}\cdots\f$ for equation eq, element e
      subroutine flux_div_integral_dealiased(e,eq)
      include  'SIZE'
      include  'INPUT'
      include  'GEOM'
      include  'MASS'
      include  'CMTDATA'

      integer  e,eq
      integer  dir
      parameter (ldd=lxd*lyd*lzd)
      parameter (ldg=lxd**3,lwkd=2*ldg)
      common /ctmp1/ ur(ldd),us(ldd),ut(ldd),ju(ldd),ud(ldd),tu(ldd)
      real ju
      common /dgrad/ d(ldg),dt(ldg),dg(ldg),dgt(ldg),jgl(ldg),jgt(ldg)
     $             , wkd(lwkd)
      real jgl,jgt

      nrstd=ldd
      nxyz=lx1*ly1*lz1
      call get_dgl_ptr(ip,lxd,lxd) ! fills dg, dgt
      mdm1=lxd-1

      call rzero(ur,nrstd)
      call rzero(us,nrstd)
      call rzero(ut,nrstd)
      call rzero(ud,nrstd)
      call rzero(tu,nrstd)

      j0=0
      do j=1,ldim
         j0=j0+1
         call add2col2(ur,totalh(1,j),rx(1,j0,e),nrstd)
      enddo
      do j=1,ldim
         j0=j0+1
         call add2col2(us,totalh(1,j),rx(1,j0,e),nrstd)
      enddo
      if (if3d) then
         do j=1,ldim
            j0=j0+1
            call add2col2(ut,totalh(1,j),rx(1,j0,e),nrstd)
         enddo
         call local_grad3_t(ud,ur,us,ut,mdm1,1,dg(ip),dgt(ip),wkd)
      else
         call local_grad2_t(ud,ur,us,   mdm1,1,dg(ip),dgt(ip),wkd)
      endif

      call intp_rstd(tu,ud,lx1,lxd,if3d,1)

! multiply the residue by mass matrix. Non diagonal B should still be
! one block per element
!     call col2(ud,bm1(1,1,1,e),nxyz)  ! res = B*res  --- B=mass matrix
!     call add2(res1(1,1,1,e,eq),tu,nxyz)
! weak?
      call sub2(res1(1,1,1,e,eq),tu,nxyz)

      return
      end

C> @}

      subroutine flux_div_integral_aliased(e,eq)
      include  'SIZE'
      include  'INPUT'
      include  'GEOM'
      include  'MASS'
      include  'CMTDATA'

      integer  e,eq
      integer  dir
      parameter (ldd=lxd*lyd*lzd)
      parameter (ldg=lxd**3,lwkd=2*ldg)
      common /ctmp1/ ur(ldd),us(ldd),ut(ldd),ju(ldd),ud(ldd),tu(ldd)
      real ju
      common /dgradl/ d(ldg),dt(ldg),dg(ldg),dgt(ldg),jgl(ldg),jgt(ldg)
     $             , wkd(lwkd)
      real jgl,jgt
      character*32 cname

      nrstd=ldd
      nxyz=lx1*ly1*lz1
      call get_dgll_ptr(ip,lxd,lxd) ! fills dg, dgt
      mdm1=lxd-1

      call rzero(ur,nrstd)
      call rzero(us,nrstd)
      call rzero(ut,nrstd)
      call rzero(ud,nrstd)
      call rzero(tu,nrstd)

      j0=0
      do j=1,ldim
         j0=j0+1
         call add2col2(ur,totalh(1,j),rx(1,j0,e),nrstd)
      enddo
      do j=1,ldim
         j0=j0+1
         call add2col2(us,totalh(1,j),rx(1,j0,e),nrstd)
      enddo
      if (if3d) then
         do j=1,ldim
            j0=j0+1
            call add2col2(ut,totalh(1,j),rx(1,j0,e),nrstd)
         enddo
         call local_grad3_t(ud,ur,us,ut,mdm1,1,d(ip),dt(ip),wkd)
      else
         call local_grad2_t(ud,ur,us,   mdm1,1,d(ip),dt(ip),wkd)
      endif

      call copy(tu,ud,nxyz)

! needs fleg or removal altogether. not good modularity
      call sub2(res1(1,1,1,e,eq),tu,nxyz)

      return
      end

!-----------------------------------------------------------------------
      subroutine compute_forcing(e,eq_num)
      include  'SIZE'
      include  'INPUT'
      include  'GEOM'
      include  'PARALLEL'
      include  'MASS'
      include  'SOLN'
      include  'CMTDATA'
      include  'DEALIAS'
      
      integer e,eq_num
      parameter (ldd=lxd*lyd*lzd)

      common /lpm_fix/ phigdum,phigvdum
      real phigdum(lx1,ly1,lz1,lelt,3),phigvdum(lx1,ly1,lz1,lelt)

      nxyz=lx1*ly1*lz1
      if(eq_num.ne.1.and.eq_num.ne.5)then


        if (eq_num.eq.4.and.ldim.eq.2)then

        else
#ifdef LPM
           call subcol3(res1(1,1,1,e,eq_num),phigdum(1,1,1,e,eq_num-1)
     >                  ,bm1(1,1,1,e),nxyz)
#endif
           call subcol3(res1(1,1,1,e,eq_num),usrf(1,1,1,eq_num)
     $                  ,bm1(1,1,1,e),nxyz) 
        endif
      elseif(eq_num.eq.5)then

#ifdef LPM
           call subcol3(res1(1,1,1,e,eq_num),phigvdum(1,1,1,e)
     >                  ,bm1(1,1,1,e),nxyz)
#endif
c          call subcol3(res1(1,1,1,e,eq_num),usrf(1,1,1,eq_num)
c    $                  ,bm1(1,1,1,e),nxyz) 

      endif
      return
      end
c-----------------------------------------------------------------------
      subroutine cmtusrf(e)
      include 'SIZE'
      include 'NEKUSE'
      include 'CMTDATA'
      include 'TSTEP'
      include 'PARALLEL'

      integer e,eg

      if(istep.eq.1)then
        n = lx1*ly1*lz1*5
        call rzero(usrf,n)
      endif
      eg = lglel(e)
      do k=1,lz1
         do j=1,ly1
            do i=1,lx1
               call NEKASGN(i,j,k,e)
               call userf(i,j,k,eg)
               rdum4 = 0.
#ifdef LPM
               call lpm_userf(I,J,K,e,rdum1,rdum2,rdum3,rdum4)
               FFX  = FFX + rdum1
               FFY  = FFY + rdum2
               FFZ  = FFZ + rdum3
#endif
               ! note fx,fy,fz multiply by density to stay 
               ! consistent with nek5000 units. Same for phig (cancels)
               usrf(i,j,k,2) = FFX*u(i,j,k,1,e)*phig(i,j,k,e)
               usrf(i,j,k,3) = FFY*u(i,j,k,1,e)*phig(i,j,k,e)
               usrf(i,j,k,4) = FFZ*u(i,j,k,1,e)*phig(i,j,k,e)
               usrf(i,j,k,5) = 0.0
c              usrf(i,j,k,5) = (U(i,j,k,2,e)*FFX + U(i,j,k,3,e)*FFY
c    &                       +  U(i,j,k,4,e)*FFZ)/ U(i,j,k,1,e)
            enddo
         enddo
      enddo

      return
      end 

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Data race on outLen due to ++ operation.
!Adding private (outLen) can avoid race condition. But it is wrong semantically.
!Data races on outLen also cause output[outLen++] to have data races.
!
!Data race pairs (we allow two pairs to preserve the original code pattern):
!1. outLen@34 vs. outLen@34
!2. output[]@33 vs. output[]@33

program DRB018_plusplus_orig_yes
    use omp_lib
    implicit none

    integer :: i, inLen, outLen
    integer :: input(1000)
    integer :: output(1000)

    inLen = 1000
    outLen = 1

    do i = 1, inLen
        input(i) = i
    end do

    !$omp parallel do
    do i = 1, inLen
        output(outLen) = input(i)
        outLen = outLen + 1
    end do
    !$omp end parallel do

    print 100, output(500)
    100 format ("output(500)=",i3)
end program

C> @file Dirichlet states for inflow boundary conditions
      subroutine inflow(nvar,f,e,facew,wbc)
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'CMTBCDATA'
      integer nvar,f,e
      real facew(lx1,lz1,2*ldim,nelt,nvar)
      real wbc(lx1,lz1,2*ldim,nelt,nvar)

! JH021717 compare
!     call inflow_rflu(nvar,f,e,facew,wbc)
      call inflow_inviscid(nvar,f,e,facew,wbc)

      return
      end

!--------------------------------------------------------------------

      subroutine inflow_rflu(nvar,f,e,facew,wbc)
!--------------------------------------------------------------------
! JH080118 CP IS ENERGY NOW
! DOESN'T WORK!!!
!--------------------------------------------------------------------
      include 'SIZE'
      include 'INPUT'
      include 'NEKUSE'
      include 'CMTDATA'
      include 'GEOM'
      include 'PARALLEL'
      include 'DG'
      include 'PERFECTGAS'

      integer f,e,fdim ! intent(in)
      integer i,bcOptType
      real facew(lx1*lz1,2*ldim,nelt,nvar) ! intent(in)
      real wbc  (lx1*lz1,2*ldim,nelt,nvar)   ! intent(out)
      real snx,sny,snz,rhou,rhov,rhow,pl,rhob,rhoub,rhovb,rhowb
     >     ,rhoeb, mach

      nxz=lx1*lz1
      nxzd=lxd*lzd
      fdim=ldim-1
      ieg=lglel(e)

      call facind(i0,i1,j0,j1,k0,k1,lx1,ly1,lz1,f)    
      l=0
      do iz=k0,k1
      do iy=j0,j1
      do ix=i0,i1
         call nekasgn(ix,iy,iz,e)
         call cmtasgn(ix,iy,iz,e)
         call userbc (ix,iy,iz,f,ieg) ! get molarmass asnd phi t0in p0in cp cv
c                                     !     ux,uy,uz
         l=l+1

         bcOptType=0
         snx  = unx(l,1,f,e)
         sny  = uny(l,1,f,e)

         rho  = facew(l,f,e,iu1)/facew(l,f,e,iph)
         rhou = facew(l,f,e,iu2)/facew(l,f,e,iph)
         rhov = facew(l,f,e,iu3)/facew(l,f,e,iph)
         rhow = facew(l,f,e,iu4)/facew(l,f,e,iph)
         rhoe = facew(l,f,e,iu5)/facew(l,f,e,iph)

         if (if3d) then
            mach = sqrt(ux**2+uy**2+uz**2)/asnd
            snz  = unz(l,1,f,e)
         else
            mach = sqrt(ux**2+uy**2)/asnd
            snz=0.0
         endif
         if (mach.lt.1.0) bcOptType=1

         call BcondInflowPerf(bcOptType,0,p0in,t0in,ux,uy,uz
     >                       ,mach,snx,sny,snz,cp
     >                       ,molarmass,rho,rhou,rhov,rhow,rhob,rhoub
     >                       ,rhovb,rhowb,rhoeb,pres,asnd,temp)
         
         wbc(l,f,e,irho) = rhob
         wbc(l,f,e,iux)  = ux
         wbc(l,f,e,iuy)  = uy
         wbc(l,f,e,iuz)  = uz
         wbc(l,f,e,isnd) = asnd ! overwritten by Bcond
         wbc(l,f,e,ipr)  = pres ! overwritten by Bcond
         wbc(l,f,e,ithm) = temp ! overwritten by Bcond
         wbc(l,f,e,icpf) = rho*cp
         wbc(l,f,e,icvf) = rho*cv
         wbc(l,f,e,iu1)  = rhob*phi
         wbc(l,f,e,iu2)  = rhoub*phi
         wbc(l,f,e,iu3)  = rhovb*phi
         wbc(l,f,e,iu4)  = rhowb*phi
         wbc(l,f,e,iu5)  = rhoeb*phi
      enddo
      enddo
      enddo

      return
      end

!--------------------------------------------------------------------

      subroutine inflow_inviscid(nvar,f,e,facew,wbc)
! JH021717 more conventional Dolejsi & Feistauer (2015),
!          Hartmann & Houston (2006) type boundary conditions
!          Emergency fallback if Holmes just doesn't play nice with DG
      include 'SIZE'
!     include 'TSTEP' ! diagnostics
      include 'INPUT'
      include 'NEKUSE'
      include 'CMTDATA'
      include 'GEOM'
      include 'PARALLEL'
      include 'DG'
      include 'PERFECTGAS'

      integer f,e,fdim ! intent(in)
      integer i
      real facew(lx1*lz1,2*ldim,nelt,nvar) ! intent(in)
      real wbc  (lx1*lz1,2*ldim,nelt,nvar)   ! intent(out)
      real snx,sny,snz,rhou,rhov,rhow,pl,rhob,rhoub,rhovb,rhowb
     >     ,rhoeb, mach

      nxz=lx1*lz1
      nxzd=lxd*lzd
      fdim=ldim-1
      ieg=lglel(e)

      call facind(i0,i1,j0,j1,k0,k1,lx1,ly1,lz1,f)    
      l=0
      do iz=k0,k1
      do iy=j0,j1
      do ix=i0,i1
         call nekasgn(ix,iy,iz,e)
         call cmtasgn(ix,iy,iz,e)
         call userbc (ix,iy,iz,f,ieg) ! get molarmass asnd phi t0in p0in cp cv
c                                     !     ux,uy,uz
         l=l+1
         wbc(l,f,e,irho) = rho  ! Dirichlet, userbc
         wbc(l,f,e,iux)  = ux   ! Dirichlet, userbc
         wbc(l,f,e,iuy)  = uy   ! Dirichlet, userbc
         wbc(l,f,e,iuz)  = uz   ! Dirichlet, userbc
         wbc(l,f,e,iph)  = phi  ! Dirichlet, userbc
         rhob   = rho*phi
         rhoub  = rho*ux*phi
         rhovb  = rho*uy*phi
         rhowb  = rho*uz*phi
         wbc(l,f,e,iu1)  = rhob
         wbc(l,f,e,iu2)  = rhoub
         wbc(l,f,e,iu3)  = rhovb
         wbc(l,f,e,iu4)  = rhowb

         if (if3d) then ! shouldn't this be normal Mach number?
            mach = sqrt(ux**2+uy**2+uz**2)/asnd
            snz  = unz(l,1,f,e)
         else
            mach = sqrt(ux**2+uy**2)/asnd
            snz=0.0
         endif

         snx  = unx(l,1,f,e)
         sny  = uny(l,1,f,e)

         if (mach.lt.1.0) then

            pres  = facew(l,f,e,ipr) ! extrapolated, overwritten
            temp = pres/rho/(cp-cv) ! definitely too perfect!
            wbc(l,f,e,ipr)  = pres
            wbc(l,f,e,isnd) = sqrt(cp/cv*pres/rho) ! too perfect?
            wbc(l,f,e,ithm) = temp      ! definitely too perfect!
!           wbc(l,f,e,icpf) = rho*cp ! NEED EOS WITH TEMP Dirichlet, userbc
            wbc(l,f,e,icpf) = e_internal
            wbc(l,f,e,icvf) = rho*cv ! NEED EOS WITH TEMP Dirichlet, userbc

         else ! supersonic inflow

            wbc(l,f,e,ipr)  = pres
            wbc(l,f,e,isnd) = asnd
            wbc(l,f,e,ithm) = temp
!           wbc(l,f,e,icpf) = rho*cp
            wbc(l,f,e,icpf) = e_internal
            wbc(l,f,e,icvf) = rho*cv

         endif

! find a smarter way of doing this. fold it into usr file if you must

         wbc(l,f,e,iu5)  = phi*rho*e_internal+0.5/rhob*(rhoub**2+rhovb**2+
     >                                               rhowb**2)

      enddo
      enddo
      enddo

      return
      end

!*********************************************************************
!* Illinois Open Source License                                      *
!*                                                                   *
!* University of Illinois/NCSA                                       * 
!* Open Source License                                               *
!*                                                                   *
!* Copyright@2008, University of Illinois.  All rights reserved.     *
!*                                                                   *
!*  Developed by:                                                    *
!*                                                                   *
!*     Center for Simulation of Advanced Rockets                     *
!*                                                                   *
!*     University of Illinois                                        *
!*                                                                   *
!*     www.csar.uiuc.edu                                             *
!*                                                                   *
!* Permission is hereby granted, free of charge, to any person       *
!* obtaining a copy of this software and associated documentation    *
!* files (the "Software"), to deal with the Software without         *
!* restriction, including without limitation the rights to use,      *
!* copy, modify, merge, publish, distribute, sublicense, and/or      *
!* sell copies of the Software, and to permit persons to whom the    *
!* Software is furnished to do so, subject to the following          *
!* conditions:                                                       *
!*                                                                   *
!*                                                                   *
!* @ Redistributions of source code must retain the above copyright  * 
!*   notice, this list of conditions and the following disclaimers.  *
!*                                                                   * 
!* @ Redistributions in binary form must reproduce the above         *
!*   copyright notice, this list of conditions and the following     *
!*   disclaimers in the documentation and/or other materials         *
!*   provided with the distribution.                                 *
!*                                                                   *
!* @ Neither the names of the Center for Simulation of Advanced      *
!*   Rockets, the University of Illinois, nor the names of its       *
!*   contributors may be used to endorse or promote products derived * 
!*   from this Software without specific prior written permission.   *
!*                                                                   *
!* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,   *
!* EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES   *
!* OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND          *
!* NONINFRINGEMENT.  IN NO EVENT SHALL THE CONTRIBUTORS OR           *
!* COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       * 
!* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   *
!* ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE    *
!* USE OR OTHER DEALINGS WITH THE SOFTWARE.                          *
!*********************************************************************
!* Please acknowledge The University of Illinois Center for          *
!* Simulation of Advanced Rockets in works and publications          *
!* resulting from this software or its derivatives.                  *
!*********************************************************************
!******************************************************************************
!
! Purpose: set inflow boundary condition for one cell.
!
! Description: The subsonic boundary condition is based on the extrapolation of 
!   the Riemann invariant from the interior field (Holmes, D.G.: Inviscid 2D 
!   Solutions on Unstructured, Adaptive Grids. VKI Lecture Series 1989-06, 1989). 
!   The supersonic inflow boundary condition computes the conservative variables
!   from given velocity components, density and pressure.
!
! Input: bcOptType  = boundary treatment: subsonic, supersonic, or mixed
!        bcOptFixed = whether _computed_ inflow angle should be fixed or not
!        ptot       = given total pressure
!        ttot       = given total temperature
!        sx/y/zn    = components of normalized face vector (outward facing)
!        cpgas      = specific heat at constant pressure (boundary cell)
!        mm         = molecular mass at boundary cell
!        rl         = given density
!        ru/v/wl    = given velocity components
!
! Output: rr      = density at boundary | velocity compts inout from userbc
!         ru/v/wr = density * velocity components at boundary
!         rer     = density * total internal energy at boundary
!         pr      = pressure at boundary
!
! Notes: 
!   1. This condition is valid only for thermally and calorically perfect  
!      gas.
!   2. Important to avoid division by MakeNonZero(sl) when computing eta 
!      because that computation can become undefined for reservoir inflow
!      conditions, i.e., for a vanishing velocity vector. 
!
!******************************************************************************
!
! $Id: BcondInflowPerf.F90,v 1.1.1.1 2014/05/05 21:47:47 tmish Exp $
!
! Copyright: (c) 2002-2004 by the University of Illinois
!
!******************************************************************************

      SUBROUTINE BcondInflowPerf(bcOptType,bcOptFixed,ptot,ttot,ur,vr,wr
     >                          ,mach,sxn,syn,szn,cpgas,mm,rl,rul
     >                          ,rvl,rwl,rr,rur,rvr,rwr,rer,pr,ar,tr)
      IMPLICIT NONE

      integer BCOPT_SUBSONIC, BCOPT_MIXED, BCOPT_FIXED_NO
! faked flags
      parameter (BCOPT_SUBSONIC = 1)
      parameter (BCOPT_MIXED = 2)
      parameter (BCOPT_FIXED_NO = 2)
      real  MixtPerf_C_Co2GUVW, MixtPerf_C_DGP, MixtPerf_C_GRT,
     >  MixtPerf_Co2_CGUVW, MixtPerf_C2_GRT,MixtPerf_D_PRT,
     >  MixtPerf_Eo_DGPUVW, MixtPerf_Eo_DGPVm, MixtPerf_G_CpR,
     >  MixtPerf_P_GMaPo, MixtPerf_P_GPoTTo, MixtPerf_Po_GPTTo,
     >  MixtPerf_Po_CGPUVW, MixtPerf_R_M, MixtPerf_T_CGR,
     >  MixtPerf_T_GMaTo,  MixtPerf_Vm_C2Co2G
      external  MixtPerf_C_Co2GUVW, MixtPerf_C_DGP, MixtPerf_C_GRT,
     >  MixtPerf_Co2_CGUVW, MixtPerf_C2_GRT,MixtPerf_D_PRT,
     >  MixtPerf_Eo_DGPUVW, MixtPerf_Eo_DGPVm, MixtPerf_G_CpR,
     >  MixtPerf_P_GMaPo, MixtPerf_P_GPoTTo, MixtPerf_Po_GPTTo,
     >  MixtPerf_Po_CGPUVW, MixtPerf_R_M, MixtPerf_T_CGR,
     >  MixtPerf_T_GMaTo,  MixtPerf_Vm_C2Co2G


! ... parameters
      INTEGER bcOptFixed,bcOptType!, INTENT(IN) ::
!          .      .     .                  .   .   .   from userbc
      REAL cpgas, mach, mm, sxn, syn, szn, ur, vr, wr,!, INTENT(IN) ::
     >                        ptot, rl, rul, rvl, rwl, ttot

      REAL rer, rr, rur, rvr, rwr, pr!, INTENT(OUT) ::

      REAL al, ar, a02, cp, disc, eta, g, gm1, igm1, ql, rgas, Rm,
     >            sl, sr, tr, ul,  vl,  wl

!******************************************************************************
! gas properties

      rgas = MixtPerf_R_M(mm)
      g    = MixtPerf_G_CpR(cpgas,rgas)

! subsonic or mixed -----------------------------------------------------------   

      IF ( bcOptType.eq.BCOPT_SUBSONIC.OR.bcOptType.eq.BCOPT_MIXED) THEN
         gm1  = g - 1.0
         igm1 = 1.0/gm1

         ul = rul/rl
         vl = rvl/rl
         wl = rwl/rl

         a02 = MixtPerf_C2_GRT(g,rgas,ttot)

         al = MixtPerf_C_Co2GUVW(a02,g,ul,vl,wl) ! make al consistent with a02
         ql = ul*sxn + vl*syn + wl*szn

! - subsonic

         IF ( ABS(ql) .lt. al ) THEN
            sl = SQRT(ul*ul + vl*vl + wl*wl)
         
            IF ( bcOptFixed .eq. BCOPT_FIXED_NO ) THEN 
               IF ( sl .gt. 1.0E-6 ) THEN ! Avoid ill-defined angle computation
                  eta = ql/sl        
               ELSE 
                  eta = -1.0
               END IF ! sl
            ELSE 
               eta = -1.0
            END IF ! bcOptFixed

            Rm   = al - 0.5*gm1*ql
            disc = 0.5*gm1*eta**2*
     >       (a02/(Rm*Rm)*(1.0 + 0.5*gm1*eta**2) - 1.0)     
        
            IF ( disc .lt. 0.0 ) THEN ! discriminant cannot be negative
               ar = SQRT(a02)
               tr = ttot
               pr = ptot
               sr = 0.0
            ELSE
               ar = Rm/(1.0 + 0.5*gm1*eta*eta)*(1.0+SQRT(disc))
               tr = MixtPerf_T_CGR(ar,g,rgas)
               pr = MixtPerf_P_GPoTTo(g,ptot,tr,ttot)
               sr = MixtPerf_Vm_C2Co2G(ar*ar,a02,g)
            END IF ! disc    
                     
            rr = MixtPerf_D_PRT( pr,rgas,tr )

            rer = rr*MixtPerf_Eo_DGPVm(rr,g,pr,sr)
            rur = rr*ur
            rvr = rr*vr
            rwr = rr*wr

! - supersonic

         ELSE
            IF ( bcOptType .eq. BCOPT_MIXED ) THEN
               pr = mixtPerf_P_GMaPo(g,mach,ptot)
               tr = mixtPerf_T_GMaTo(g,mach,ttot)
               rr = mixtPerf_D_PRT(pr,rgas,tr)
               ar = mixtPerf_C_GRT(g,rgas,tr)

               rer = rr*MixtPerf_Eo_DGPUVW(rr,g,pr,ur,vr,wr)
               rur = rr*ur
               rvr = rr*vr
               rwr = rr*wr
            END IF ! bcOptType
         END IF ! ql < al

! supersonic ------------------------------------------------------------------

      ELSE ! bcOptType .eq. BCOPT_SUPERSONIC
         pr = mixtPerf_P_GMaPo(g,mach,ptot)
         tr = mixtPerf_T_GMaTo(g,mach,ttot)
         rr = mixtPerf_D_PRT(pr,rgas,tr)
         ar = mixtPerf_C_GRT(g,rgas,tr)

         rer = rr*MixtPerf_Eo_DGPUVW(rr,g,pr,ur,vr,wr)
         rur = rr*ur
         rvr = rr*vr
         rwr = rr*wr
      END IF ! bcOptType

      return
      end

!******************************************************************************
!
! RCS Revision history:
!
! $Log: BcondInflowPerf.F90,v $
! Revision 1.1.1.1  2014/05/05 21:47:47  tmish
! Initial checkin for rocflu macro.
!
! Revision 1.3  2008/12/06 08:43:31  mtcampbe
! Updated license.
!
! Revision 1.2  2008/11/19 22:16:46  mtcampbe
! Added Illinois Open Source License/Copyright
!
! Revision 1.1  2007/04/09 18:48:32  haselbac
! Initial revision after split from RocfloMP
!
! Revision 1.1  2007/04/09 17:59:24  haselbac
! Initial revision after split from RocfloMP
!
! Revision 1.1  2004/12/01 16:47:56  haselbac
! Initial revision after changing case
!
! Revision 1.7  2004/01/29 22:52:36  haselbac
! Added bcOptFixed, fixed bug, clean-up
!
! Revision 1.6  2003/12/04 03:22:56  haselbac
! Fixed bug in formulation, added partial fix for eta
!
! Revision 1.5  2003/11/20 16:40:35  mdbrandy
! Backing out RocfluidMP changes from 11-17-03
!
! Revision 1.2  2002/06/22 00:49:50  jblazek
! Modified interfaces to BC routines.
!
! Revision 1.1  2002/06/10 21:19:34  haselbac
! Initial revision
!
!******************************************************************************

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Two-dimensional array computation:
!collapse(2) is used to associate two loops with omp for.
!The corresponding loop iteration variables are private. No data race pairs.


module DRB093
    implicit none
    integer, dimension(:,:), allocatable :: a
end module

program DRB093_doall2_collapse_orig_no
    use omp_lib
    use DRB093
    implicit none

    integer :: len, i, j
    len = 100

    allocate (a(len,len))

    !$omp parallel do collapse(2)
    do i = 1, len
        do j = 1, len
            a(i,j) = a(i,j)+1
        end do
    end do
    !$omp end parallel do
end program

c-----------------------------------------------------------------------
      subroutine uzawa_gmres(res,h1,h2,h2inv,intype,iter)

c     Solve the pressure equation by right-preconditioned 
c     GMRES iteration.
c     intype =  0  (steady)
c     intype =  1  (explicit)
c     intype = -1  (implicit)

      include 'SIZE'
      include 'TOTAL'
      include 'GMRES'
      common  /ctolpr/ divex
      common  /cprint/ ifprint
      logical          ifprint
      real             res  (lx2*ly2*lz2*lelv)
      real             h1   (lx1,ly1,lz1,lelv)
      real             h2   (lx1,ly1,lz1,lelv)
      real             h2inv(lx1,ly1,lz1,lelv)

      common /scrmg/    wp (lx2,ly2,lz2,lelv)

      common /ctmp0/   wk1(lgmres),wk2(lgmres)
      common /cgmres1/ y(lgmres)

      real alpha, l, temp
      integer j,m
c
      logical iflag
      save    iflag
      data    iflag /.false./
      real    norm_fac
      save    norm_fac
c
      real*8 etime1,dnekclock
c
      if(.not.iflag) then
         iflag=.true.
         call uzawa_gmres_split0(ml_gmres,mu_gmres,bm2,bm2inv,
     $                           lx2*ly2*lz2*nelv)
         norm_fac = 1./sqrt(volvm2)
      endif
c
      etime1 = dnekclock()
      etime_p = 0.
      divex = 0.
      iter  = 0
      m = lgmres
c
      call chktcg2(tolps,res,iconv)
      if (param(21).gt.0.and.tolps.gt.abs(param(21))) 
     $   tolps = abs(param(21))
c     if (param(21).lt.0) tolps = abs(param(21))
      if (istep.eq.0) tolps = 1.e-4
      tolpss = tolps
c
      ntot2  = lx2*ly2*lz2*nelv
c
      iconv = 0
      call rzero(x_gmres,ntot2)

      do while(iconv.eq.0.and.iter.lt.100)

         if(iter.eq.0) then
                                                        !      -1
            call col3(r_gmres,ml_gmres,res,ntot2)       ! r = L  res
c           call copy(r_gmres,res,ntot2)
         else
            !update residual
            call copy(r_gmres,res,ntot2)                      ! r = res
            call cdabdtp(w_gmres,x_gmres,h1,h2,h2inv,intype)  ! w = A x
            call add2s2(r_gmres,w_gmres,-1.,ntot2)            ! r = r - w
                                                              !      -1
            call col2(r_gmres,ml_gmres,ntot2)                 ! r = L   r
         endif
                                                            !            ______
         gamma_gmres(1) = sqrt(glsc2(r_gmres,r_gmres,ntot2))! gamma  = \/ (r,r) 
                                                            !      1
         if(iter.eq.0) then
            div0 = gamma_gmres(1)*norm_fac
            if (param(21).lt.0) tolpss=abs(param(21))*div0
         endif

         !check for lucky convergence
         rnorm = 0.
         if(gamma_gmres(1) .eq. 0.) goto 9000
         temp = 1./gamma_gmres(1)
         call cmult2(v_gmres(1,1),r_gmres,temp,ntot2)! v  = r / gamma
                                                     !  1            1
         do j=1,m
            iter = iter+1
                                                           !       -1
            call col3(w_gmres,mu_gmres,v_gmres(1,j),ntot2) ! w  = U   v
                                                           !           j
            
            etime2 = dnekclock()
            if(param(43).eq.1) then
               call uzprec(z_gmres(1,j),w_gmres,h1,h2,intype,wp)
            else                                        !       -1
               call hsmg_solve(z_gmres(1,j),w_gmres)    ! z  = M   w
c              call copy(z_gmres(1,j),w_gmres,ntot2)    ! z  = M   w
            endif     
            etime_p = etime_p + dnekclock()-etime2
     
            call cdabdtp(w_gmres,z_gmres(1,j),    ! w = A z
     $                   h1,h2,h2inv,intype)      !        j
     
                                                  !      -1
            call col2(w_gmres,ml_gmres,ntot2)     ! w = L   w

c           !modified Gram-Schmidt
c           do i=1,j
c              h_gmres(i,j)=glsc2(w_gmres,v_gmres(1,i),ntot2) ! h    = (w,v )
c                                                             !  i,j       i
c              call add2s2(w_gmres,v_gmres(1,i),-h_gmres(i,j),ntot2) ! w = w - h    v
c           enddo                                                    !          i,j  i


c           2-PASS GS, 1st pass:

            do i=1,j
               h_gmres(i,j)=vlsc2(w_gmres,v_gmres(1,i),ntot2) ! h    = (w,v )
            enddo                                             !  i,j       i

            call gop(h_gmres(1,j),wk1,'+  ',j)          ! sum over P procs

            do i=1,j
               call add2s2(w_gmres,v_gmres(1,i),-h_gmres(i,j),ntot2) ! w = w - h    v
            enddo                                                    !          i,j  i


c           2-PASS GS, 2nd pass:
c
c           do i=1,j
c              wk1(i)=vlsc2(w,v_gmres(1,i),ntot2) ! h    = (w,v )
c           enddo                                 !  i,j       i
c                                                 !
c           call gop(wk1,wk2,'+  ',j)             ! sum over P procs
c
c           do i=1,j
c              call add2s2(w,v_gmres(1,i),-wk1(i),ntot2) ! w = w - h    v
c              h(i,j) = h(i,j) + wk1(i)                  !          i,j  i
c           enddo


            !apply Givens rotations to new column
            do i=1,j-1
               temp = h_gmres(i,j)                   
               h_gmres(i  ,j)=  c_gmres(i)*temp 
     $                        + s_gmres(i)*h_gmres(i+1,j)  
               h_gmres(i+1,j)= -s_gmres(i)*temp 
     $                        + c_gmres(i)*h_gmres(i+1,j)
            enddo
                                                              !            ______
            alpha = sqrt(glsc2(w_gmres,w_gmres,ntot2))        ! alpha =  \/ (w,w)
            rnorm = 0.
            if(alpha.eq.0.) goto 900  !converged
            l = sqrt(h_gmres(j,j)*h_gmres(j,j)+alpha*alpha)
            temp = 1./l
            c_gmres(j) = h_gmres(j,j) * temp
            s_gmres(j) = alpha  * temp
            h_gmres(j,j) = l
            gamma_gmres(j+1) = -s_gmres(j) * gamma_gmres(j)
            gamma_gmres(j)   =  c_gmres(j) * gamma_gmres(j)

c            call outmat(h,m,j,' h    ',j)
            
            rnorm = abs(gamma_gmres(j+1))*norm_fac
            ratio = rnorm/div0
            if (ifprint.and.nio.eq.0) 
     $         write (6,66) iter,tolpss,rnorm,div0,ratio,istep
   66       format(i5,1p4e12.5,i8,' Divergence')

#ifndef FIXITER
            if (rnorm .lt. tolpss) goto 900  !converged
#else
            if (iter.gt.param(151)-1) goto 900
#endif
            if (j.eq.m) goto 1000 !not converged, restart

            temp = 1./alpha
            call cmult2(v_gmres(1,j+1),w_gmres,temp,ntot2) ! v    = w / alpha
                                                           !  j+1            
         enddo
  900    iconv = 1
 1000    continue
         !back substitution
         !     -1
         !c = H   gamma
         do k=j,1,-1
            temp = gamma_gmres(k)
            do i=j,k+1,-1
               temp = temp - h_gmres(k,i)*c_gmres(i)
            enddo
            c_gmres(k) = temp/h_gmres(k,k)
         enddo
         !sum up Arnoldi vectors
         do i=1,j
            call add2s2(x_gmres,z_gmres(1,i),c_gmres(i),ntot2) 
                       ! x = x + c  z
                       !          i  i
         enddo
c        if(iconv.eq.1) call dbg_write(x,lx2,ly2,lz2,nelv,'esol',3)
      enddo
 9000 continue
c
      divex = rnorm
c     iter = iter - 1
c
c     DIAGNOSTICS
c      call copy   (w,x,ntot2)
       call ortho  (w_gmres) ! Orthogonalize wrt null space, if present
c      call copy(r,res,ntot2) !r = res
c      call cdabdtp(r,w,h1,h2,h2inv,intype)  ! r = A w
c      do i=1,ntot2
c         r(i) = res(i) - r(i)               ! r = res - r
c      enddo
c      call uzawa_gmres_temp(r,bm2inv,ntot2)
c                                               !            ______
c      gamma(1) = sqrt(glsc2(r,r,ntot2)/volvm2) ! gamma  = \/ (r,r) 
c                                               !      1
c      print *, 'GMRES end resid:',gamma(1)
c     END DIAGNOSTICS
      call copy(res,x_gmres,ntot2)

      call ortho (res)  ! Orthogonalize wrt null space, if present

      etime1 = dnekclock()-etime1
      if (nio.eq.0) write(6,9999) istep,'  U-PRES gmres  ', 
     &                            iter,divex,div0,tolpss,etime_p,etime1
c     call flush_hack
 9999 format(i11,a,I6,1p5e13.4)

      return
      end

c-----------------------------------------------------------------------

      subroutine uzawa_gmres_split0(l,u,b,binv,n)
      integer n
      real l(n),u(n),b(n),binv(n)
      integer i
      do i=1,n
         l(i)=sqrt(binv(i))
         u(i)=sqrt(b(i))
         if(abs(u(i)*l(i)-1.0).gt.1e-13) print *, i, u(i)*l(i)
      enddo
      return
      end

c-----------------------------------------------------------------------
      subroutine uzawa_gmres_split(l,u,b,binv,n)
      integer n
      real l(n),u(n),b(n),binv(n)
      integer i
      do i=1,n
c        l(i)=sqrt(binv(i))
c        u(i)=sqrt(b(i))

c        u(i)=sqrt(b(i))
c        l(i)=1./u(i)

c        l(i)=sqrt(binv(i))
         l(i)=1.
         u(i)=1./l(i)


c        if(abs(u(i)*l(i)-1.0).gt.1e-13)write(6,*) i,u(i)*l(i),' gmr_sp'
      enddo
      return
      end

c-----------------------------------------------------------------------
      subroutine uzawa_gmres_temp(a,b,n)
      integer n
      real a(n),b(n)
      integer i
      do i=1,n
         a(i)=sqrt(b(i))*a(i)
      enddo
      return
      end
c-----------------------------------------------------------------------
      subroutine ax(w,x,h1,h2,n)
      include 'SIZE'
      include 'TOTAL'

c
c     w = A*x for pressure iteration
c

      integer n
      real w(n),x(n),h1(n),h2(n)

      imsh = 1
      isd  = 1
      call axhelm (w,x,h1,h2,imsh,isd)
      call dssum  (w,lx1,ly1,lz1)
      call col2   (w,pmask,n)

      return
      end
c-----------------------------------------------------------------------
      subroutine hmh_gmres(res,h1,h2,wt,iter)

c     Solve the Helmholtz equation by right-preconditioned 
c     GMRES iteration.

     
      include 'SIZE'
      include 'TOTAL'
      include 'FDMH1'
      include 'GMRES'
      common  /ctolpr/ divex
      common  /cprint/ ifprint
      logical          ifprint
      real             res  (lx1*ly1*lz1*lelv)
      real             h1   (lx1,ly1,lz1,lelv)
      real             h2   (lx1,ly1,lz1,lelv)
      real             wt   (lx1,ly1,lz1,lelv)

      common /scrcg/ d(lx1*ly1*lz1*lelv),wk(lx1*ly1*lz1*lelv)

      common /cgmres1/ y(lgmres)
      common /ctmp0/   wk1(lgmres),wk2(lgmres)
      real alpha, l, temp
      integer outer

      logical iflag,if_hyb
      save    iflag,if_hyb
c     data    iflag,if_hyb  /.false. , .true. /
      data    iflag,if_hyb  /.false. , .false. /
      real    norm_fac
      save    norm_fac

      real*8 etime1,dnekclock


      n = lx1*ly1*lz1*nelv

      etime1 = dnekclock()
      etime_p = 0.
      divex = 0.
      maxit = iter
      iter  = 0
      m     = lgmres

      if(.not.iflag) then
         iflag=.true.
         call uzawa_gmres_split(ml_gmres,mu_gmres,bm1,binvm1,
     $                          lx1*ly1*lz1*nelv)
         norm_fac = 1./sqrt(volvm1)
      endif

      if (param(100).ne.2) call set_fdm_prec_h1b(d,h1,h2,nelv)

      call chktcg1(tolps,res,h1,h2,pmask,vmult,1,1)
      if (param(21).gt.0.and.tolps.gt.abs(param(21))) 
     $   tolps = abs(param(21))
      if (istep.eq.0) tolps = 1.e-4
      tolpss = tolps
c
      iconv = 0
      call rzero(x_gmres,n)

      outer = 0
      do while (iconv.eq.0)

         outer = outer+1

         if(iter.eq.0) then                   !      -1
            call col3(r_gmres,ml_gmres,res,n) ! r = L  res
c           call copy(r,res,n)
         else
            !update residual
            call copy  (r_gmres,res,n)           ! r = res
            call ax    (w_gmres,x_gmres,h1,h2,n) ! w = A x
            call add2s2(r_gmres,w_gmres,-1.,n)   ! r = r - w
                                                 !      -1
            call col2(r_gmres,ml_gmres,n)        ! r = L   r
         endif
                                                            !            ______
         gamma_gmres(1) = sqrt(glsc3(r_gmres,r_gmres,wt,n)) ! gamma  = \/ (r,r) 
                                                            !      1
         if(iter.eq.0) then
            div0 = gamma_gmres(1)*norm_fac
            if (param(21).lt.0) tolpss=abs(param(21))*div0
         endif

         !check for lucky convergence
         rnorm = 0.
         if(gamma_gmres(1) .eq. 0.) goto 9000
         temp = 1./gamma_gmres(1)
         call cmult2(v_gmres(1,1),r_gmres,temp,n) ! v  = r / gamma
                                                  !  1            1
         do j=1,m
            iter = iter+1
                                                       !       -1
            call col3(w_gmres,mu_gmres,v_gmres(1,j),n) ! w  = U   v
                                                       !           j

c . . . . . Overlapping Schwarz + coarse-grid . . . . . . .

            etime2 = dnekclock()

c           if (outer.gt.2) if_hyb = .true.       ! Slow outer convergence
            if (ifmgrid) then
               if (param(40).ge.0 .and. param(40).le.2) then
                  call h1mg_solve(z_gmres(1,j),w_gmres,if_hyb) ! z  = M   w
               else if (param(40).eq.3) then
                  call fem_amg_solve(z_gmres(1,j),w_gmres)
               endif
            else                                            !  j
               kfldfdm = ldim+1
               if (param(100).eq.2) then
                   call h1_overlap_2 (z_gmres(1,j),w_gmres,pmask)
               else
                   call fdm_h1
     $               (z_gmres(1,j),w_gmres,d,pmask,vmult,nelv,
     $                ktype(1,1,kfldfdm),wk)
               endif
               call crs_solve_h1 (wk,w_gmres)        ! z  = M   w
               call add2         (z_gmres(1,j),wk,n) !  j        
            endif


            call ortho        (z_gmres(1,j)) ! Orthogonalize wrt null space, if present
            etime_p = etime_p + dnekclock()-etime2
c . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 

     
            call ax  (w_gmres,z_gmres(1,j),h1,h2,n) ! w = A z
                                                    !        j
     
                                                    !      -1
            call col2(w_gmres,ml_gmres,n)           ! w = L   w

c           !modified Gram-Schmidt

c           do i=1,j
c              h_gmres(i,j)=glsc3(w_gmres,v_gmres(1,i),wt,n) ! h    = (w,v )
c                                                            !  i,j       i

c              call add2s2(w_gmres,v_gmres(1,i),-h_gmres(i,j),n) ! w = w - h    v
c           enddo                                                !          i,j  i

c           2-PASS GS, 1st pass:

            do i=1,j
               h_gmres(i,j)=vlsc3(w_gmres,v_gmres(1,i),wt,n) ! h    = (w,v )
            enddo                                            !  i,j       i

            call gop(h_gmres(1,j),wk1,'+  ',j)          ! sum over P procs

            do i=1,j
               call add2s2(w_gmres,v_gmres(1,i),-h_gmres(i,j),n) ! w = w - h    v
            enddo                                                !          i,j  i


c           2-PASS GS, 2nd pass:
c
c           do i=1,j
c              wk1(i)=vlsc3(w_gmres,v_gmres(1,i),wt,n) ! h    = (w,v )
c           enddo                                      !  i,j       i
c                                                      !
c           call gop(wk1,wk2,'+  ',j)                  ! sum over P procs
c
c           do i=1,j
c              call add2s2(w_gmres,v_gmres(1,i),-wk1(i),n)    ! w = w - h    v
c              h_gmres(i,j) = h_gmres(i,j) + wk1(i)           !          i,j  i
c           enddo

            !apply Givens rotations to new column
            do i=1,j-1
               temp = h_gmres(i,j)                   
               h_gmres(i  ,j)=  c_gmres(i)*temp 
     $                        + s_gmres(i)*h_gmres(i+1,j)  
               h_gmres(i+1,j)= -s_gmres(i)*temp 
     $                        + c_gmres(i)*h_gmres(i+1,j)
            enddo
                                                      !            ______
            alpha = sqrt(glsc3(w_gmres,w_gmres,wt,n)) ! alpha =  \/ (w,w)
            rnorm = 0.
            if(alpha.eq.0.) goto 900  !converged
            l = sqrt(h_gmres(j,j)*h_gmres(j,j)+alpha*alpha)
            temp = 1./l
            c_gmres(j) = h_gmres(j,j) * temp
            s_gmres(j) = alpha  * temp
            h_gmres(j,j) = l
            gamma_gmres(j+1) = -s_gmres(j) * gamma_gmres(j)
            gamma_gmres(j)   =  c_gmres(j) * gamma_gmres(j)

            rnorm = abs(gamma_gmres(j+1))*norm_fac
            ratio = rnorm/div0
            if (ifprint.and.nio.eq.0) 
     $         write (6,66) iter,tolpss,rnorm,div0,ratio,istep
   66       format(i5,1p4e12.5,i8,' Divergence')

#ifndef FIXITER
            if (iter+1.gt.maxit) goto 900
            if (rnorm .lt. tolpss) goto 900  !converged
#else
            if (iter.gt.param(151)-1) goto 900
#endif
            if (j.eq.m) goto 1000 !not converged, restart

            temp = 1./alpha
            call cmult2(v_gmres(1,j+1),w_gmres,temp,n) ! v    = w / alpha
                                                       !  j+1            
         enddo
  900    iconv = 1
 1000    continue
         !back substitution
         !     -1
         !c = H   gamma
         do k=j,1,-1
            temp = gamma_gmres(k)
            do i=j,k+1,-1
               temp = temp - h_gmres(k,i)*c_gmres(i)
            enddo
            c_gmres(k) = temp/h_gmres(k,k)
         enddo
         !sum up Arnoldi vectors
         do i=1,j
            call add2s2(x_gmres,z_gmres(1,i),c_gmres(i),n) ! x = x + c  z
         enddo                                             !          i  i
c        if(iconv.eq.1) call dbg_write(x,lx1,ly1,lz1,nelv,'esol',3)
      enddo
 9000 continue

      divex = rnorm
      call copy(res,x_gmres,n)

      call ortho   (res) ! Orthogonalize wrt null space, if present

      etime1 = dnekclock()-etime1
      if (nio.eq.0) write(6,9999) istep,iter,divex,div0,tolpss,etime_p,
     &                            etime1,if_hyb
c     call flush_hack
 9999 format(4x,i7,'  PRES gmres ',4x,i5,1p5e13.4,1x,l4)

      if (outer.le.2) if_hyb = .false.

      return
      end
c-----------------------------------------------------------------------
      subroutine set_overlap2
c
c     Sets up the gather scatter and the SEM operators
c
      include 'SIZE'  
      include 'TOTAL' 
 
      common /c_is1/ glo_num(lxs*lys*lzs*lelv)  
      integer*8 glo_num
      common /ivrtx/ vertex ((2**ldim)*lelt)
      common /handle/ gsh_dd
      integer vertex,gsh_dd

      mz = ldim-2
      nx = lx1+2
      ny = ly1+2
      nz = lz1+2*mz
      call setupds_no_crn(gsh_dd,nx,ny,nz,nelv,nelgv,vertex,glo_num)
      call swap_lengths ! Set up Matrices for FDM
      call gen_fast_g

      return
      end
c-----------------------------------------------------------------------
      subroutine h1_overlap_2(u,v,mask)
c
c     Local overlapping Schwarz solves with overlap of 2
c
      include 'SIZE'
      include 'TOTAL'


      common /cwork1/ v1(lxs,lys,lzs,lelt)
      common /handle/ gsh_dd
      integer gsh_dd

      real u(lx1,lx1,lz1,1),v(1),mask(1)
      integer e

      n = lx1*ly1*lz1*nelfld(ifield)

      call dd_swap_vals(v1,v,gsh_dd)

      iz1 = 0
      if (if3d) iz1=1
      do ie=1,nelfld(ifield)
         do iz=1,lz1
         do iy=1,ly1
         do ix=1,lx1
            u(ix,iy,iz,ie) = v1(ix+1,iy+1,iz+iz1,ie)
         enddo
         enddo
         enddo
      enddo

      call dssum (u,lx1,ly1,lz1)
      call col2  (u,mask,n)


      return
      end
c-----------------------------------------------------------------------
      subroutine dd_swap_vals(v1,v0,gsh_dd)

      include 'SIZE'
      include 'TOTAL'

      common /work1/ w1(lxs,lys,lzs)           ! work arrarys for locals
     $              ,w2(lxs,lys,lzs)
      integer gsh_dd

      real v1(lxs,lys,lzs,lelt)
      real v0(lx1,ly1,lz1,lelt)

      integer e

      mz = ldim-2

      nx = lx1+2
      ny = ly1+2
      nz = lz1+2*mz

      n  = lx1*ly1*lz1*nelv
      m  = (lx1+2)*(ly1+2)*(lz1+2*mz)*nelv

      do e=1,nelv
         call rzero_g        (v1,e,nx,ny,nz)
         call fill_interior_g(v1,v0,e,lx1,lz1,mz,nelv)    ! v0      --> v1(int)
         call dface_ext_g    (v1,2,e,nx,nz)               ! v1(int) --> v1(face)
      enddo
c
c                 ~ ~T
c     This is the Q Q  part
c
      call fgslib_gs_op(gsh_dd,v1,1,1,0)  ! 1 ==> +         ! swap v1 & add vals

      do e =1,nelv
         call dface_add1si_g  (v1,-1.,2,e,nx,nz)
         call fastdm1_g       (v1(1,1,1,e),e,w1,w2)
         call s_face_to_int2_g(v1,-1.,2,e,nx,nz)
      enddo
c
c     Exchange/add elemental solutions
c
      call fgslib_gs_op              (gsh_dd,v1,1,1,0)
      do e =1,nelv
         call s_face_to_int2_g(v1,1.,2,e,nx,nz)
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine gen_fast_g
c
c     Generate fast diagonalization matrices for each element
c
      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'
      include 'SOLN'
      include 'WZ'

      parameter (lxss=lxs*lxs)
      common /fastg/  sr(lxss,2,lelv),ss(lxss,2,lelv),st(lxss,2,lelv)
     $             ,  df(lxs*lys*lzs,lelv)

      common /ctmpf/  lr(2*lx1+4),ls(2*lx1+4),lt(2*lx1+4)
     $              , llr(lelt),lls(lelt),llt(lelt)
     $              , lmr(lelt),lms(lelt),lmt(lelt)
     $              , lrr(lelt),lrs(lelt),lrt(lelt)
      real lr ,ls ,lt
      real llr,lls,llt
      real lmr,lms,lmt
      real lrr,lrs,lrt

      integer lbr,rbr,lbs,rbs,lbt,rbt
     

      call load_semhat_weighted   !   Fills the SEMHAT arrays
     

      ierr = 0
      do ie=1,nelv

         call get_fast_bc(lbr,rbr,lbs,rbs,lbt,rbt,ie,3,ierr)
c
c        Set up matrices for each element.
c
         call set_up_fast_1D_sem_g( sr(1,1,ie),lr,nr ,lbr,rbr
     $                      ,llr(ie),lmr(ie),lrr(ie),ie)
         call set_up_fast_1D_sem_g( ss(1,1,ie),ls,ns ,lbs,rbs
     $                      ,lls(ie),lms(ie),lrs(ie),ie)
         if (if3d) then
            call set_up_fast_1D_sem_g( st(1,1,ie),lt,nt ,lbt,rbt
     $                      ,llt(ie),lmt(ie),lrt(ie),ie)
         endif
c
c        Set up diagonal inverse
c
         if (if3d) then
            eps = 1.e-5 * (vlmax(lr(2),nr-2)
     $                  +  vlmax(ls(2),ns-2) + vlmax(lt(2),nt-2))
            l   = 1
            do k=1,nt
            do j=1,ns
            do i=1,nr
               diag = lr(i) + ls(j) + lt(k)
               if (diag.gt.eps) then
                  df(l,ie) = 1.0/diag
               else
c                 write(6,3) ie,'Reset Eig in gen fast:',i,j,k,l
c    $                         ,eps,diag,lr(i),ls(j),lt(k)
c   3             format(i6,1x,a21,4i5,1p5e12.4)
                  df(l,ie) = 0.0
               endif
               l = l+1
            enddo
            enddo
            enddo
         else
            eps = 1.e-5*(vlmax(lr(2),nr-2) + vlmax(ls(2),ns-2))
            l   = 1
            do j=1,ns
            do i=1,nr
               diag = lr(i) + ls(j)
               
               if (diag.gt.eps) then
                  df(l,ie) = 1.0/diag
                  
               else
c                 write(6,2) ie,'Reset Eig in gen fast:',i,j,l
c    $                         ,eps,diag,lr(i),ls(j)
c   2             format(i6,1x,a21,3i5,1p4e12.4)
                  df(l,ie) = 0.0
               endif
               l = l+1
            enddo
            enddo
         endif
c
c        Next element ....
c
      enddo
 
      return
      end
c-----------------------------------------------------------------------
      subroutine set_up_fast_1D_sem_g(s,lam,n,lbc,rbc,ll,lm,lr,ie)
      include 'SIZE'
      include 'SEMHAT'

      parameter (lr3=2*lxs*lxs)
      common /fast1dsem/ g(lr3),w(lr3)

      real g,w
      real s(1),lam(1),ll,lm,lr
      integer lbc,rbc

      integer bb0,bb1,eb0,eb1,n,n1
      logical l,r

      n=lx1-1
      !bcs on E are from normal vel component
      if(lbc.eq.2 .or. lbc.eq.3) then !wall,sym  - Neumann
         eb0=0
         bb0=0
      else !outflow,element                      - Dirichlet
         eb0=1
         bb0=1
      endif
      if(rbc.eq.2 .or. rbc.eq.3) then !wall,sym  - Neumann
         eb1=n
         bb1=n
      else !outflow,element                      - Dirichlet
         eb1=n-1
         bb1=n-1
      endif
      l = (lbc.eq.0)
      r = (rbc.eq.0)

c     calculate A tilde operator
      call set_up_fast_1D_sem_op_a(s,eb0,eb1,l,r,ll,lm,lr,ah)
c     calculate B tilde operator
      call set_up_fast_1D_sem_op_b(g,bb0,bb1,l,r,ll,lm,lr,bh)

      n=n+3
c     call outmat   (s,n,n,'  A   ',ie)
c     call outmat   (g,n,n,'  B   ',ie)
      call generalev(s,g,lam,n,w)
      if(.not.l) call row_zero(s,n,n,1)
      if(.not.r) call row_zero(s,n,n,n)
      call transpose(s(n*n+1),n,s,n) ! compute the transpose of s
c     call outmat   (s,n,n,'  S   ',ie)
c     call outmat   (s(n*n+1),n,n,'  St  ',1)
c     call exitt


      return
      end
c-----------------------------------------------------------------------
      subroutine set_up_fast_1D_sem_op_a(g,b0,b1,l
     $                                   ,r,ll,lm,lr,ah)
c            -1 T
c     G = J B  J
c
c     gives the inexact restriction of this matrix to
c     an element plus two node on either side
c
c     g - the output matrix
c     b0, b1 - the range for Bhat indices for the element
c              (enforces boundary conditions)
c     l, r - whether there is a left or right neighbor
c     ll,lm,lr - lengths of left, middle, and right elements
c     ah - hat matrix for A or B
c
c     result is inexact because:
c        neighbor's boundary condition at far end unknown
c        length of neighbor's neighbor unknown
c        (these contribs should be small for large N and
c         elements of nearly equal size)
c
      include 'SIZE'
      real g(0:lx1+1,0:lx1+1)
      real ah(0:lx1-1,0:lx1-1)
      real ll,lm,lr
      integer b0,b1
      logical l,r

      real bl,bm,br
      integer n

      n =lx1-1

c
c     compute the weight of A hat
c
      if (l) bl = 2. /ll
             bm = 2. /lm
      if (r) br = 2. /lr

      call rzero(g,(n+3)*(n+3))
      do j=1,n+1
         do i=1,n+1
            g(i,j) = ah(i-1,j-1)*bm
         enddo
      enddo

      if (l) then
         g(0,0) = g(0,0) + bl*ah(n-1,n-1)
         g(0,1) = g(0,1) + bl*ah(n-1,n  )
         g(1,0) = g(1,0) + bl*ah(n  ,n-1)
         g(1,1) = g(1,1) + bl*ah(n  ,n  )
      elseif (b0.eq.0) then          !Neumann BC
         g(0,0) = 1.
      else                           !Dirichlet BC
         g(0,0)     = 1.
         g(1,1)     = 1.
         do i=2,n+1
            g(i,1)  = 0.
            g(1,i)  = 0.
         enddo
      endif

      if (r) then
         g(n+1,n+1) = g(n+1,n+1) + br*ah(0,0)
         g(n+1,n+2) = g(n+1,n+2) + br*ah(0,1)
         g(n+2,n+1) = g(n+2,n+1) + br*ah(0,1)
         g(n+2,n+2) = g(n+2,n+2) + br*ah(1,1)
      elseif (b1.eq.n) then          !Neumann BC
         g(n+2,n+2)=1.
      else                           !Dirichlet BC
         g(n+2,n+2)   = 1.
         g(n+1,n+1)   = 1.
         do i=1,n
            g(i,n+1)  = 0.
            g(n+1,i)  = 0.
         enddo
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine set_up_fast_1D_sem_op_b(g,b0,b1,l
     $                                   ,r,ll,lm,lr,bh)
c            -1 T
c     G = J B  J
c
c     gives the inexact restriction of this matrix to
c     an element plus two node on either side
c
c     g - the output matrix
c     b0, b1 - the range for Bhat indices for the element
c              (enforces boundary conditions)
c     l, r - whether there is a left or right neighbor
c     ll,lm,lr - lengths of left, middle, and right elements
c     bh - hat matrix for  B
c
c     result is inexact because:
c        neighbor's boundary condition at far end unknown
c        length of neighbor's neighbor unknown
c        (these contribs should be small for large N and
c         elements of nearly equal size)
c
      include 'SIZE'
      real g(0:lx1+1,0:lx1+1)
      real bh(0:lx1-1)
      real ll,lm,lr
      integer b0,b1
      logical l,r

      real bl,bm,br
      integer n

      n =lx1-1
c
c     compute the weight of B hat
c
      if (l) bl = ll / 2.
             bm = lm / 2.
      if (r) br = lr / 2.

      call rzero(g,(n+3)*(n+3))
      do i=1,n+1
            g(i,i) = bh(i-1)*bm
      enddo

      if (l) then
         g(0,0) = g(0,0) + bl*bh(n-1)
         g(1,1) = g(1,1) + bl*bh(n  )
      elseif (b0.eq.0) then          !Neumann BC
         g(0,0) = 1.
      else                           !Dirichlet BC
         g(0,0)     = 1.
         g(1,1)     = 1.
         do i=2,n+1
            g(i,1)  = 0.
            g(1,i)  = 0.
         enddo
      endif

      if (r) then
         g(n+1,n+1) = g(n+1,n+1) + br*bh(0)
         g(n+2,n+2) = g(n+2,n+2) + br*bh(1)
      elseif (b1.eq.n) then          !Neumann BC
         g(n+2,n+2)=1.
      else                           !Dirichlet BC
         g(n+2,n+2)   = 1.
         g(n+1,n+1)   = 1.
         do i=1,n
            g(i,n+1)  = 0.
            g(n+1,i)  = 0.
         enddo
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine fill_interior_g(v1,v,e,nx,nz,iz1,nel)

      real v1(nx+2,nx+2,nz+2*iz1,nel) ! iz1=ldim-2
      real v (nx  ,nx  ,nz      ,nel)
      integer e

      ny = nx

      do iz=1,nz
      do iy=1,ny
      do ix=1,nx
         v1(ix+1,iy+1,iz+iz1,e) = v(ix,iy,iz,e)
      enddo
      enddo
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine dface_ext_g(x,t,e,nx,nz)
c     Extend interior to face of element

      include 'SIZE'
      include 'INPUT'
      real x(nx,nx,nz,1)
      integer e,t

      ny = nx

      if (if3d) then
        do iz=2,nz-1
        do ix=2,nx-1
            x(ix,1 ,iz,e) = x(ix, 1+t,iz,e)
            x(ix,ny,iz,e) = x(ix,ny-t,iz,e)
        enddo
        enddo
  
        do iz=2,nz-1
        do iy=2,ny-1
            x(1 ,iy,iz,e) = x( 1+t,iy,iz,e)
            x(nx,iy,iz,e) = x(nx-t,iy,iz,e)
        enddo
        enddo
  
        do iy=2,ny-1
        do ix=2,nx-1
            x(ix,iy,1 ,e) = x(ix,iy, 1+t,e)
            x(ix,iy,nz,e) = x(ix,iy,nz-t,e)
        enddo
        enddo
      else
         do ix=2,nx-1
            x(ix,1 ,1,e) = x(ix, 1+t,1,e)
            x(ix,ny,1,e) = x(ix,ny-t,1,e)
         enddo
         do iy=2,ny-1
            x(1 ,iy,1,e) = x( 1+t,iy,1,e)
            x(nx,iy,1,e) = x(nx-t,iy,1,e)
         enddo
      endif
      
      return
      end
c-----------------------------------------------------------------------
      subroutine dface_add1si_g(x,c,t,e,nx,nz)
c     Scale interior and add to face of element

      include 'SIZE'
      include 'INPUT'
      real x(nx,nx,nz,1)

      integer e,t

      ny = nx

      if (if3d) then

         do iz=2,nz-1
         do ix=2,nx-1
            x(ix,1 ,iz,e) = x(ix,1 ,iz,e) + c*x(ix, 1+t,iz,e)
            x(ix,ny,iz,e) = x(ix,ny,iz,e) + c*x(ix,ny-t,iz,e)
         enddo
         enddo

         do iz=2,nz-1
         do iy=2,ny-1
            x(1 ,iy,iz,e) = x(1 ,iy,iz,e) + c*x( 1+t,iy,iz,e)
            x(nx,iy,iz,e) = x(nx,iy,iz,e) + c*x(nx-t,iy,iz,e)
         enddo
         enddo

         do iy=2,ny-1
         do ix=2,nx-1
            x(ix,iy,1 ,e) = x(ix,iy,1 ,e) + c*x(ix,iy, 1+t,e)
            x(ix,iy,nz,e) = x(ix,iy,nz,e) + c*x(ix,iy,nz-t,e)
         enddo
         enddo

      else  ! 2D

         do ix=2,nx-1
            x(ix,1 ,1,e) = x(ix,1 ,1,e) + c*x(ix, 1+t,1,e)
            x(ix,ny,1,e) = x(ix,ny,1,e) + c*x(ix,ny-t,1,e)
         enddo
         do iy=2,ny-1
            x(1  ,iy,1,e) = x(1 ,iy,1,e) + c*x( 1+t,iy,1,e)
            x(nx ,iy,1,e) = x(nx,iy,1,e) + c*x(nx-t,iy,1,e)
         enddo

      endif
      
      return
      end
c-----------------------------------------------------------------------
      subroutine fastdm1_g(R,ie,w1,w2)
c
c     Fast diagonalization solver for FEM on mesh 1
c
      include 'SIZE'

      parameter (lxss=lxs*lxs)
      common /fastg/  sr(lxss,2,lelv),ss(lxss,2,lelv),st(lxss,2,lelv)
     $             ,  df(lxs*lys*lzs,lelv)

      parameter (lxyz = lxs*lys*lzs)

      real r(1),w1(1),w2(1)

      nx = lx1+2
c
c      T
c     S  r
      call tensr3 (w1,nx,r ,nx,sr(1,2,ie),ss(1,1,ie),st(1,1,ie),w2)
c
c
c      -1 T
c     D  S  r
c
      call col2   (w1,df(1,ie),lxyz)
c
c
c        -1 T
c     S D  S  r
c
      call tensr3 (r ,nx,w1,nx,sr(1,1,ie),ss(1,2,ie),st(1,2,ie),w2)

      return
      end
c-----------------------------------------------------------------------
      subroutine s_face_to_int2_g(x,c,t,e,nx,nz)
c
c     Scale face and add to interior of element
c
      include 'SIZE'
      include 'INPUT'
      real x(nx,nx,nz,1)
      integer t,e

      ny=nx


      if (if3d) then

         do iz=2,nz-1
         do ix=2,nx-1
            x(ix, 1+t,iz,e) = c*x(ix,1 ,iz,e) + x(ix, 1+t,iz,e)
            x(ix,ny-t,iz,e) = c*x(ix,ny,iz,e) + x(ix,ny-t,iz,e)
         enddo
         enddo

         do iz=2,nz-1
         do iy=2,ny-1
            x( 1+t,iy,iz,e) = c*x(1 ,iy,iz,e) + x( 1+t,iy,iz,e)
            x(nx-t,iy,iz,e) = c*x(nx,iy,iz,e) + x(nx-t,iy,iz,e)
         enddo
         enddo

         do iy=2,ny-1
         do ix=2,nx-1
            x(ix,iy, 1+t,e) = c*x(ix,iy,1 ,e) + x(ix,iy, 1+t,e)
            x(ix,iy,nz-t,e) = c*x(ix,iy,nz,e) + x(ix,iy,nz-t,e)
         enddo
         enddo

      else
c     2D
         do ix=2,nx-1
            x(ix, 1+t,1,e) = c*x(ix,1 ,1,e) + x(ix, 1+t,1,e)
            x(ix,ny-t,1,e) = c*x(ix,ny,1,e) + x(ix,ny-t,1,e)
         enddo
         do iy=2,ny-1
            x( 1+t,iy,1,e) = c*x(1 ,iy,1,e) + x( 1+t,iy,1,e)
            x(nx-t,iy,1,e) = c*x(nx,iy,1,e) + x(nx-t,iy,1,e)
         enddo
      endif
      
      return
      end
c-----------------------------------------------------------------------
      subroutine outfldr_g(x,txt10,nx,nz,ichk)
      INCLUDE 'SIZE'
      INCLUDE 'TSTEP'
      real x(nx,nx,nz,lelt)
      character*10 txt10

      integer idum,e
      save idum
      data idum /3/

      if (idum.lt.0) return

      ny = nx


      mtot = nx*ny*nz*nelv
      if (nx.gt.8.or.nelv.gt.16) return
      xmin = glmin(x,mtot)
      xmax = glmax(x,mtot)

      nell = nelt
      rnel = nell
      snel = sqrt(rnel)+.1
      ne   = snel
      ne1  = nell-ne+1
      k = 1
      do ie=1,1
         ne = 0
         write(6,116) txt10,k,ie,xmin,xmax,istep,time,nx
         do l=12,0,-4
            write(6,117)
            do j=ny,1,-1
              if (nx.eq.2) write(6,102) ((x(i,j,k,e+l),i=1,nx),e=1,4)
              if (nx.eq.3) write(6,103) ((x(i,j,k,e+l),i=1,nx),e=1,4)
              if (nx.eq.4) write(6,104) ((x(i,j,k,e+l),i=1,nx),e=1,4)
              if (nx.eq.5) write(6,105) ((x(i,j,k,e+l),i=1,nx),e=1,4)
              if (nx.eq.6) write(6,106) ((x(i,j,k,e+l),i=1,nx),e=1,4)
              if (nx.eq.7) write(6,107) ((x(i,j,k,e+l),i=1,nx),e=1,4)
              if (nx.eq.8) write(6,118) ((x(i,j,k,e+l),i=1,nx),e=1,4)
            enddo
         enddo
      enddo

  102 FORMAT(4(2f9.5,2x))
  103 FORMAT(4(3f9.5,2x))
  104 FORMAT(4(4f7.3,2x))
  105 FORMAT(5f9.5,10x,5f9.5)
  106 FORMAT(6f7.1,5x,6f7.1,5x,6f7.1,5x,6f7.1)
  107 FORMAT(7f8.4,5x,7f8.4)
  108 FORMAT(8f8.4,4x,8f8.4)
  118 FORMAT(8f12.9)

  116 FORMAT(  /,5X,'     ^              ',/,
     $    5X,'   Y |              ',/,
     $    5X,'     |              ',A10,/,
     $    5X,'     +---->         ','Plane = ',I2,'/',I2,2x,2e12.4,/,
     $    5X,'       X            ','Step  =',I9,f15.5,i2)
  117 FORMAT(' ')

      if (ichk.eq.1.and.idum.gt.0) call checkit(idum)
      return
      end
c-----------------------------------------------------------------------
      subroutine outfldi_g(x,txt10,nx,nz,ichk)
      INCLUDE 'SIZE'
      INCLUDE 'TSTEP'
      integer x(nx,nx,nz,lelt)
      character*10 txt10

      integer idum,e,xmin,xmax
      save idum
      data idum /3/

      if (idum.lt.0) return

      ny = nx


      mtot = nx*ny*nz*nelv
      if (nx.gt.8.or.nelv.gt.16) return
      xmin = iglmin(x,mtot)
      xmax = iglmax(x,mtot)

      nell = nelt
      rnel = nell
      snel = sqrt(rnel)+.1
      ne   = snel
      ne1  = nell-ne+1
      k = 1
      do ie=1,1
         ne = 0
         write(6,116) txt10,k,ie,xmin,xmax,istep,time,nx
         do l=12,0,-4
            write(6,117)
            do j=ny,1,-1
              if (nx.eq.2) write(6,102) ((x(i,j,k,e+l),i=1,nx),e=1,4)
              if (nx.eq.3) write(6,103) ((x(i,j,k,e+l),i=1,nx),e=1,4)
              if (nx.eq.4) write(6,104) ((x(i,j,k,e+l),i=1,nx),e=1,4)
              if (nx.eq.5) write(6,105) ((x(i,j,k,e+l),i=1,nx),e=1,4)
              if (nx.eq.6) write(6,106) ((x(i,j,k,e+l),i=1,nx),e=1,4)
              if (nx.eq.7) write(6,107) ((x(i,j,k,e+l),i=1,nx),e=1,4)
              if (nx.eq.8) write(6,118) ((x(i,j,k,e+l),i=1,nx),e=1,4)
            enddo
         enddo
      enddo

  102 FORMAT(4(2i9,2x))
  103 FORMAT(4(3i9,2x))
  104 FORMAT(4(4i7,2x))
  105 FORMAT(5i9,10x,5i9)
  106 FORMAT(6i7,5x,6i7,5x,6i7,5x,6i7)
  107 FORMAT(7i8,5x,7i8)
  108 FORMAT(8i8,4x,8i8)
  118 FORMAT(8i12)

  116 FORMAT(  /,5X,'     ^              ',/,
     $    5X,'   Y |              ',/,
     $    5X,'     |              ',A10,/,
     $    5X,'     +---->         ','Plane = ',I2,'/',I2,2x,2i12,/,
     $    5X,'       X            ','Step  =',I9,f15.5,i2)
  117 FORMAT(' ')

      if (ichk.eq.1.and.idum.gt.0) call checkit(idum)
      return
      end
c-----------------------------------------------------------------------
      subroutine setupds_no_crn(gs_h,nx,ny,nz,nel,melg,vertex,glo_num)
      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'
      include 'NONCON'
      integer   gs_h,vertex(1),e
      integer*8 ngv,glo_num(nx,ny,nz,nel)
      

      common /nekmpi/ mid,mp,nekcomm,nekgroup,nekreal

c     set up the global numbering
      call set_vert(glo_num,ngv,nx,nel,vertex,.false.)

c     zero out corners
      mz1 = max(1,nz-1)
      do e=1,nel
      do k=1,nz,mz1
      do j=1,ny,ny-1
      do i=1,nx,nx-1
         glo_num(i,j,k,e) = 0
      enddo
      enddo
      enddo
      enddo


      ntot = nx*ny*nz*nel

      t0 = dnekclock()
      call fgslib_gs_setup(gs_h,glo_num,ntot,nekcomm,mp) ! initialize gs code
      t1 = dnekclock()

      et = t1-t0

c     call gs_chkr(glo_num)

      if (nio.eq.0) then
         write(6,1) et,nx,nel,ntot,ngv,gs_h
    1    format('   gs_init time',1pe11.4,' seconds ',i3,4i10)
      endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine rzero_g(a,e,nx,ny,nz)

      real a(nx,ny,nz,1)
      integer e

      do  i=1,nx
      do  j=1,ny
      do  k=1,nz
          a(i,j,k,e) = 0.0
      enddo
      enddo
      enddo

      return
      END
c-----------------------------------------------------------------------

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Freshly allocated pointers do not alias to each other. No data race pairs.

module DRB066
    use omp_lib
    implicit none
contains
    subroutine setup(N)
        integer, value :: N
        integer :: i
        integer, parameter :: dp = kind(1.0d0)
        real(dp),dimension(:), pointer :: m_pdv_sum, m_nvol
        real(dp),dimension(:), allocatable, target :: tar1, tar2

        allocate (m_pdv_sum(N))
        allocate (m_nvol(N))
        allocate (tar1(N))
        allocate (tar2(N))

        m_pdv_sum => tar1
        m_nvol => tar2

        !$omp parallel do schedule(static)
        do i = 1, N
            tar1(i) = 0.0
            tar2(i) = i*2.5
        end do
        !$omp end parallel do

        !print*,tar1(N),tar2(N)
        if (associated(m_pdv_sum)) nullify(m_pdv_sum)
        if (associated(m_nvol)) nullify(m_nvol)
        deallocate(tar1,tar2)
    end subroutine
end module

program DRB066_pointernoaliasing_orig_no
    use omp_lib
    use DRB066
    implicit none

    integer :: N
    N = 1000

    call setup(N)

end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!The increment at line number 22 is critical for the variable
!var@22:13. Therefore, there is a possible Data Race pair var@22:13 and var@22:19.

program DRB144_atomiccritical_orig_gpu_yes
    use omp_lib
    implicit none

    integer :: var, i
    var = 0

    !$omp target map(tofrom:var) device(0)
    !$omp teams distribute parallel do
        do i = 1, 200
            !$omp critical
            var = var+1
            !$omp end critical
        end do
    !$omp end teams distribute parallel do
    !$omp end target

    print*,var
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!For the case of a variable which is not referenced within a construct:
!objects with dynamic storage duration should be shared.
!Putting it within a threadprivate directive may cause seg fault since
! threadprivate copies are not allocated!
!
!Dependence pair: *counter@22:9 vs. *counter@22:19


module DRB088
    implicit none
    integer, pointer :: counter

    contains
    subroutine foo()
        counter = counter+1
    end subroutine
end module
program DRB088_dynamic_storage_orig_yes
    use omp_lib
    use DRB088
    implicit none

    allocate(counter)

    counter = 0

    !$omp parallel
    call foo()
    !$omp end parallel

    print*,counter

    deallocate(counter)

end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Two-dimensional array computation:
!default(none) to enforce explictly list all variables in data-sharing attribute clauses
!default(shared) to cover another option. No data race pairs.


program DRB113_default_orig_no
    use omp_lib
    implicit none

    integer len,i,j
    integer, parameter :: dp = kind(1.0d0)
    real(dp), dimension(:,:), allocatable :: a,b

    len = 100

    allocate (a(len, len))
    allocate (b(len, len))

    !$omp parallel do default(none) shared(a) private(i,j)
    do i = 1, 100
        do j = 1, 100
            a(i,j) = a(i,j)+1
        end do
    end do
    !$omp end parallel do

    !$omp parallel do default(shared) private(i,j)
    do i = 1, 100
        do j = 1, 100
            b(i,j) = b(i,j)+1
        end do
    end do
    !$omp end parallel do

    print*,a(50,50),b(50,50)

    deallocate(a,b)
end program

c-----------------------------------------------------------------------
      subroutine setics
C-----------------------------------------------------------------------
C
C     Set initial conditions.
C
C-----------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'DEALIAS'
      INCLUDE 'INPUT'
      INCLUDE 'IXYZ'
      INCLUDE 'GEOM'
      INCLUDE 'SOLN'
      INCLUDE 'MASS'
      INCLUDE 'MVGEOM'
      INCLUDE 'PARALLEL'
      INCLUDE 'TSTEP'
 
      logical  iffort(  ldimt1,0:lpert)
     $       , ifrest(0:ldimt1,0:lpert)
     $       , ifprsl(  ldimt1,0:lpert)
 
      LOGICAL  IFANYP
      common /inelr/ nelrr
      common /ctmp1/ work(lx1,ly1,lz1,lelv)
     $ ,             ta1 (lx2,ly1,lz1)
     $ ,             ta2 (lx2,ly2,lz1)
      integer*8 ntotg,nn

      real psmax(ldimt)

      if(nio.eq.0) write(6,*) 'set initial conditions'


      nxyz2=lx2*ly2*lz2       ! Initialize all fields:
      ntot2=nxyz2*nelv
      nxyz1=lx1*ly1*lz1
      ntott=nelt*nxyz1
      ntotv=nelv*nxyz1
      ltott=lelt*nxyz1

      call rzero(vx,ntott)
      call rzero(vy,ntott)
      call rzero(vz,ntott)
      call rzero(pr,nxyz2*nelt)
      do 10 ifld=1,ldimt
         call rzero(t(1,1,1,1,ifld),ntott)
   10 continue

      jp = 0                  ! Set counter for perturbation analysis

      irst = param(46)        ! for lee's restart (rarely used)
      if (irst.gt.0)  call setup_convect(2)

c     If moving geometry then add a perturbation to the
c     mesh coordinates (see Subroutine INIGEOM)

      if (ifmvbd) call ptbgeom

C     Find out what type of i.c. is requested
C     Current options: 
C
C     (1) - User specified fortran function (default is zero i.c.)
C     (2) - Restart from file(s)
C     (3) - Activate pre-solver => steady diffusion / steady Stokes
C
C     If option (2) is requested, also return with the name of the
C     restart file(s) together with the associated dump number

      call slogic (iffort,ifrest,ifprsl,nfiles)

C      ***** TEMPERATURE AND PASSIVE SCALARS ******
C
C     Check if any pre-solv necessary for temperature/passive scalars

      IFANYP = .FALSE.
      DO 100 IFIELD=2,NFIELD
         IF (IFPRSL(IFIELD,jp)) THEN
            IF (NIO.EQ.0) WRITE(6,101) IFIELD
            IFANYP = .TRUE.
         ENDIF
  100 CONTINUE
  101 FORMAT(2X,'Using PRESOLVE option for field',I2,'.')

C     Fortran function initial conditions for temp/pass. scalars.
      maxfld = nfield
      if (ifmhd) maxfld = npscal+3

c     Always call nekuic (pff, 12/7/11)
      do ifield=1,maxfld
         if (nio.eq.0) write(6,*) 'nekuic (1) for ifld ', ifield
         call nekuic
      enddo

C     If any pre-solv, do pre-solv for all temperatur/passive scalar fields
      if (ifanyp) call prsolvt

      jp = 0 ! jp=0 --> base field, not perturbation field
      do 200 ifield=2,maxfld
         if (iffort(ifield,jp)) then
            if (nio.eq.0) write(6,*) 'call nekuic for ifld ', ifield
            call nekuic
         endif
 200  continue

      if (ifpert) then
         ifield=2
         do jp=1,npert
         if (nio.eq.0) write(6,*) 'nekuicP',ifield,jp,iffort(ifield,jp)
            if (iffort(ifield,jp)) call nekuic
         enddo
      endif
      jp = 0
     

      call nekgsync()
      call restart(nfiles) !  Check restart files
      call nekgsync()


C      ***** VELOCITY ******
C     (If restarting for V, we're done,
C     ...else, do pre-solv for fluid if requested.)

      ifield = 1
      if (ifprsl(ifield,jp)) call prsolvv


C     Fortran function initial conditions for velocity.
      ifield = 1
      if (iffort(ifield,jp)) then
         if (nio.eq.0) write(6,*) 'call nekuic for vel  '
         call nekuic
      endif
c
      if (ifpert) then
         ifield=1
         do jp=1,npert
            if (iffort(ifield,jp)) call nekuic
            if (nio.eq.0) write(6,*) 'ic vel pert:',iffort(1,jp),jp
         enddo
      endif
      jp = 0

      ntotv = lx1*ly1*lz1*nelv

C     Initial mesh velocities
      if (ifmvbd) call opcopy (wx,wy,wz,vx,vy,vz)
      if (ifmvbd.and..not.ifrest(0,jp)) call meshv (2)

C     If convection-diffusion of a passive scalar with a fixed velocity field,
C     make sure to fill up lagged arrays since this will not be done in
C     the time-stepping procedure (no flow calculation) (01/18/91 -EMR).

      if (.not.ifflow.and.ifheat) then
         ITEST=0
         DO 400 IFIELD=2,NFIELD
            IF (IFADVC(IFIELD)) ITEST=1
 400     CONTINUE
         IF (ITEST.EQ.1) THEN
            NBDMAX = 3
            NBDSAV = NBDINP
            NBDINP = NBDMAX
            DO 500 I=1,NBDMAX
               CALL LAGVEL
 500        CONTINUE
            NBDINP = NBDSAV
         ENDIF
      ENDIF
     
C     Ensure that all processors have the same time as node 0.
      if (nid.ne.0) time=0.0
      time=glsum(time,1)

      nxyz1=lx1*ly1*lz1
      ntott=nelt*nxyz1
      ntotv=nelv*nxyz1
      nn = nxyz1
      ntotg=nelgv*nn

      if (.not.ifdg) then
         ifield = 2
         if (ifflow) ifield = 1
         call rone(work,ntotv)
         ifield = 1
         call dssum  (work,lx1,ly1,lz1)
         call col2   (work,vmult,ntotv)
         rdif  = glsum(work,ntotv)
         rtotg = ntotg
         rdif  = (rdif-rtotg)/rtotg
         if (abs(rdif).gt.1e-14) then
            if(nid.eq.0)write(*,*)'ERROR: dssum test has failed!',rdif
            call exitt
         endif
      endif

      call projfld_c0 ! ensure fields are contiguous

C print min values
      xxmax = glmin(xm1,ntott)
      yymax = glmin(ym1,ntott)
      zzmax = glmin(zm1,ntott)

      vxmax = glmin(vx,ntotv)
      vymax = glmin(vy,ntotv)
      vzmax = glmin(vz,ntotv)
      prmax = glmin(pr,ntot2)

      ntot = nxyz1*nelfld(2)
      ttmax = glmin(t ,ntott)

      do i=1,ldimt-1
         ntot = nxyz1*nelfld(i+2)
         psmax(i) = glmin(T(1,1,1,1,i+1),ntot)
      enddo

      if (nio.eq.0) then
         write(6,19) xxmax,yymax,zzmax
   19    format(' xyz min  ',5g13.5)
      endif
      if (nio.eq.0) then
         write(6,20) vxmax,vymax,vzmax,prmax,ttmax
   20    format(' uvwpt min',5g13.5)
      endif
      if (ldimt-1.gt.0) then
         if (nio.eq.0) write(6,21) (psmax(i),i=1,LDIMT-1)
   21    format(' PS min   ',50g13.5)
      endif

c print max values
      xxmax = glmax(xm1,ntott)
      yymax = glmax(ym1,ntott)
      zzmax = glmax(zm1,ntott)

      vxmax = glmax(vx,ntotv)
      vymax = glmax(vy,ntotv)
      vzmax = glmax(vz,ntotv)
      prmax = glmax(pr,ntot2)

      ntot = nxyz1*nelfld(2)
      ttmax = glmax(t ,ntott)

      do i=1,ldimt-1
         ntot = nxyz1*nelfld(i+2)
         psmax(i) = glmax(T(1,1,1,1,i+1),ntot)
      enddo

      if (nio.eq.0) then
         write(6,16) xxmax,yymax,zzmax
   16    format(' xyz max  ',5g13.5)
      endif

      if (nio.eq.0) then
         write(6,17) vxmax,vymax,vzmax,prmax,ttmax
   17    format(' uvwpt max',5g13.5)
      endif

      if (ldimt-1.gt.0) then
         if (nio.eq.0)  then
            write(6,18) (psmax(i),i=1,ldimt-1)
   18       format(' PS max   ',50g13.5)
         endif
      endif

      if (iflomach .and. ifdp0dt) then
        if (p0th.le.0) call exitti('Invalid thermodynamic pressure!$',1)
        if (gamma0.lt.0) call exitti('Invalid gamma0!$',1)
      endif

      if (ifrest(0,jp)) then !  mesh has been read in.
         if (nio.eq.0) write(6,*) 'Restart: recompute geom. factors.'
         call geom_reset(1)  !  recompute geometric factors
      endif

      if(nio.eq.0) then
        write(6,*) 'done :: set initial conditions'
        write(6,*) ' '
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine slogic (iffort,ifrest,ifprsl,nfiles)
C---------------------------------------------------------------------
C
C     Set up logicals for initial conditions.
C
C---------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'RESTART'
c
      logical  iffort(  ldimt1,0:lpert)
     $       , ifrest(0:ldimt1,0:lpert)
     $       , ifprsl(  ldimt1,0:lpert)
c
      character*132 line,fname,cdum
      character*2  s2
      character*1  line1(132)
      equivalence (line1,line)
C
C     Default is user specified fortran function (=0 if not specified)
C
      nfldt = nfield
      if (ifmhd) nfldt = nfield+1

      do jp=0,npert
         ifrest(0,jp) = .false.
         do ifld=1,nfldt
            iffort(ifld,jp) = .true.
            ifrest(ifld,jp) = .false.
            ifprsl(ifld,jp) = .false.
         enddo
      enddo

      jp = 0
      nfiles=0

c     Check for Presolve options     

      DO 1000 ILINE=1,15 
         LINE=INITC(ILINE)
         CALL CAPIT(LINE,132)
         IF (INDX1(LINE,'PRESOLV',7).NE.0) THEN
C           found a presolve request
            CALL BLANK(INITC(ILINE),132)
            CALL LJUST(LINE)
            CALL CSPLIT(CDUM,LINE,' ',1)
C
            IF (LTRUNC(LINE,132).EQ.0) THEN
               IF (NIO.EQ.0) WRITE(6,700)
  700          FORMAT(/,2X,'Presolve options: ALL')
C              default - all fields are presolved.
               DO 800 IFIELD=1,nfldt
                  ifprsl(ifield,jp) = .true.
                  iffort(ifield,jp) = .false.
  800          CONTINUE
            ELSE
C           check line for arguments
C
               LL=LTRUNC(LINE,132)
               IF (NIO.EQ.0) WRITE(6,810) (LINE1(L),L=1,LL)
  810          FORMAT(/,2X,'Presolve options: ',132A1)
C
               IF (INDX_CUT(LINE,'U',1).NE.0) THEN
                  ifprsl(1,jp) = .true.
                  iffort(1,jp) = .false.
               ENDIF
C
               IF (INDX_CUT(LINE,'T',1).NE.0) THEN
                  ifprsl(2,jp) = .true.
                  iffort(2,jp) = .false.
               ENDIF
C
               DO 900 IFIELD=3,NPSCAL+2
                  IP=IFIELD-2
                  WRITE(S2,901) IP
                  IF (INDX_CUT(LINE,S2,2).NE.0) THEN
                     ifprsl(ifield,jp) = .true.
                     iffort(ifield,jp) = .false.
                  ENDIF
  900          CONTINUE
  901          FORMAT('P',I1)
            ENDIF
         ENDIF
 1000    CONTINUE
C
C     Check for restart options
C
      jp = 0
      DO 2000 ILINE=1,15
         if (ifpert) jp=iline-1
         LINE=INITC(ILINE)
         IF (LTRUNC(LINE,132).NE.0) THEN
C           found a filename
            NFILES=NFILES+1
            INITC(NFILES)=LINE
C
C            IF (NIO.EQ.0.AND.NFILES.EQ.1) WRITE(6,1010) LINE
            IF (NIO.EQ.0.) WRITE(6,1010) LINE
 1010       FORMAT(1X,'Checking restart options: ',A132)
c            IF (NID.EQ.0) WRITE(6,'(A132)') LINE
C
C           Parse restart options
 
            call sioflag(ndumps,fname,line)

            if (ifgetx) then
               ifrest(0,jp) = .true.
            endif
            if (ifgetu) then
               iffort(1,jp) = .false.
               ifprsl(1,jp) = .false.
               ifrest(1,jp) = .true.
            endif
            if (ifgett) then
               iffort(2,jp) = .false.
               ifprsl(2,jp) = .false.
               ifrest(2,jp) = .true.
            endif
            do 1900 ifield=3,nfldt
c              write(6,*) 'ifgetps:',(ifgtps(k),k=1,ldimt-1)
               if (ifgtps(ifield-2)) then
                  iffort(ifield,jp) = .false.
                  ifprsl(ifield,jp) = .false.
                  ifrest(ifield,jp) = .true.
               endif
 1900       continue
         endif
 2000 continue

      return
      end
c-----------------------------------------------------------------------
      subroutine restart(nfiles)
C----------------------------------------------------------------------
C
C     (1) Open restart file(s)
C     (2) Check previous spatial discretization 
C     (3) Map (K1,N1) => (K2,N2) if necessary
C
C     nfiles > 1 has several implications:
C
C     i.   For std. run, data is taken from last file in list, unless
C          explicitly specified in argument list of filename
C
C     ii.  For MHD and perturbation cases, 1st file is for U,P,T;
C          subsequent files are for B-field or perturbation fields
C
C
C----------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'TOTAL'
      INCLUDE 'RESTART'

      common /inelr/ nelrr

      PARAMETER (LXR=LX1+6)
      PARAMETER (LYR=LY1+6)
      PARAMETER (LZR=LZ1+6)
      PARAMETER (LXYZR=LXR*LYR*LZR)
      PARAMETER (LXYZT=LX1*LY1*LZ1*LELT)
      PARAMETER (LPSC9=LDIMT+9)

      common /scrcg/ pm1(lx1*ly1*lz1,lelv)
      COMMON /SCRNS/ SDUMP(LXYZT,7)
      integer mesg(40)

C     note, this usage of CTMP1 will be less than elsewhere if NELT ~> 9.
      COMMON /CTMP1/ TDUMP(LXYZR,LPSC9)
      real*4         tdump
c
      REAL SDMP2(LXYZT,LDIMT)

c     cdump comes in via PARALLEL (->TOTAL)

      character*30 excoder
      character*1  excoder1(30)
      equivalence (excoder,excoder1)


      character*132 fname
      character*1  fname1(132)
      equivalence (fname1,fname)

      integer       hnami (30)
      character*132 hname
      character*1   hname1(132)
      equivalence  (hname,hname1)
      equivalence  (hname,hnami )

      CHARACTER*132 header

C     Local logical flags to determine whether to copy data or not.
      logical ifok,iffmat
      integer iposx,iposz,iposu,iposw,iposp,ipost,ipsps(ldimt1)

      logical ifbytsw, if_byte_swap_test
      real*4   bytetest

c
      ifok=.false.
      ifbytsw = .false.

      if(nfiles.lt.1) return

      if(nio.eq.0) write(6,*) 'Reading checkpoint data '

c use new reader (only binary support)
      p67 = abs(param(67))
      if (p67.eq.6.0) then
         do ifile=1,nfiles
            call sioflag(ndumps,fname,initc(ifile))
            call mfi(fname,ifile)
         enddo
         call bcast(time,wdsize)! Sync time across processors
         return
      endif

c use old reader (for ASCII + old binary support)
      
      if (param(67).lt.1.0) then  ! zero only. should be abs.
         iffmat=.true.  ! ascii
      else
         iffmat=.false. ! binary
      endif

      do 6000 ifile=1,nfiles
        call sioflag(ndumps,fname,initc(ifile))
        ierr = 0
        if (nid.eq.0) then

          if (iffmat) then
            open (unit=91,file=fname,status='old',err=500)
          else
            len= ltrunc(fname,79)
            call izero (hnami,20)
            call chcopy(hname1,fname,len)
c           test for presence of file
            open (unit=91,file=hname
     $           ,form='unformatted',status='old',err=500)
            close(unit=91)
            call byte_open(hname,ierr)
            if(ierr.ne.0) goto 500
          ENDIF
          ifok = .true.
        endif

  500   continue
        call lbcast(ifok)
        if (.not.ifok) goto 5000
         
         ndumps = 1
C
C        Only NODE 0 reads from the disk.
C
         DO 1000 IDUMP=1,NDUMPS

            IF (NID.EQ.0) THEN
                ! read header
               if (iffmat) then
                 ierr = 2
                 if(mod(param(67),1.0).eq.0) then ! old header format
                   if(nelgt.lt.10000) then
                     read(91,91,err=10,end=10)
     $              neltr,nxr,nyr,nzr,rstime,istepr,(excoder1(i),i=1,30)
   91                format(4i4,1x,g13.4,i5,1x,30a1)
                     ierr=0
                   else
                     read(91,92,err=10,end=10)
     $              neltr,nxr,nyr,nzr,rstime,istepr,(excoder1(i),i=1,30)
   92                format(i10,3i4,1P1e18.9,i9,1x,30a1)
                     ierr=0
                   endif
                 else                          ! new head format
                   read(91,'(A132)',err=10,end=10) header
                   read(header,*)
     &                  neltr,nxr,nyr,nzr,rstime,istepr,excoder
                   ierr=0
                 endif
               else
                 if(mod(param(67),1.0).eq.0) then  ! old header format
                   call byte_read(hnami,20,ierr)
                   if(ierr.ne.0) goto 10
                   icase = 2
                   if (nelgt.lt.10000) icase = 1
                   ipass = 0
   93              continue  ! test each possible case  UGLY (7/31/07)
                   if(ipass.lt.2) then
                     ipass = ipass+1
                     if(icase.eq.1) then
                       read(hname,'(4i4,1x,g13.4,i5,1x,30a1)',
     $                     err=94,end=94) 
     $                     neltr,nxr,nyr,nzr,rstime,istepr,
     $                     (excoder1(i),i=1,30)
                       goto 95
                     else
                       read(hname,'(i10,3i4,1P1e18.9,i9,1x,30a1)',
     $                     err=94,end=94)
     $                     neltr,nxr,nyr,nzr,rstime,istepr,
     $                     (excoder1(i),i=1,30)
                       goto 95
                     endif
   94                icase = 3-icase  !  toggle: 2-->1  1-->2
                     goto 93
                   else
                     ierr=2
                     goto 10
                   endif
   95              continue
                 else                         ! new head format
                   call byte_read(header,20,ierr)
                   if(ierr.ne.0) goto 10
                   read(header,*)
     &             neltr,nxr,nyr,nzr,rstime,istepr,excoder
                 endif
                 call byte_read(bytetest,1,ierr)
c                call byte_read2(bytetest,1,ierr)
                 if(ierr.ne.0) goto 10
                 ifbytsw = if_byte_swap_test(bytetest,ierr)
                 if(ierr.ne.0) goto 10
               endif
               mesg(1) = neltr
               mesg(2) = nxr
               mesg(3) = nyr
               mesg(4) = nzr
               write(6,*)  'Read mode: ', param(67)
               write(6,333)'neltr,nxr,nyr,nzr: ', neltr,nxr,nyr,nzr
  333          format(A,i9,3i4)
               call chcopy(mesg(5),excoder1,20)
               len  = 14*isize
            endif
   10       call err_chk(ierr,'Error reading restart header. Abort.$')

            IF (IDUMP.EQ.1) THEN
               len  = 14*isize
               call bcast(mesg,len)
               neltr = mesg(1)
               nxr   = mesg(2)
               nyr   = mesg(3)
               nzr   = mesg(4)
               call   chcopy(excoder1,mesg(5),20)

               call lbcast(ifbytsw)

C              Bounds checking on mapped data.
               IF (NXR.GT.LXR) THEN
                  WRITE(6,20) NXR,lx1
   20             FORMAT(//,2X,
     $            'ABORT:  Attempt to map from',I3,
     $            ' to N=',I3,'.',/,2X,
     $            'NEK5000 currently supports mapping from N+6 or less.'
     $            ,/,2X,'Increase N or LXR in IC.FOR.')
                  CALL EXITT
               ENDIF
C
C              Figure out position of data in file "IFILE"
C
               NOUTS=0
               IPOSX=0
               IPOSY=0
               IPOSZ=0
               IPOSU=0
               IPOSV=0
               IPOSW=0
               IPOSP=0
               IPOST=0
               DO 40 I=1,NPSCAL
                  IPSPS(I)=0
   40          CONTINUE

               IPS = 0
               NPS = 0
               DO 50 I=1, 30
                  IF (excoder1(i).EQ.'X') THEN
                     NOUTS=NOUTS + 1
                     IPOSX=NOUTS
                     NOUTS=NOUTS+1
                     IPOSY=NOUTS
                     IF (IF3D) THEN
                        NOUTS=NOUTS + 1
                        IPOSZ=NOUTS
                     ENDIF
                  ENDIF
                  IF (excoder1(i).EQ.'U') THEN
                     NOUTS=NOUTS + 1
                     IPOSU=NOUTS
                     NOUTS=NOUTS+1
                     IPOSV=NOUTS
                     IF (IF3D) THEN
                        NOUTS=NOUTS + 1
                        IPOSW=NOUTS
                     ENDIF
                  ENDIF
                  IF (excoder1(i).EQ.'P') THEN
                     NOUTS=NOUTS + 1
                     IPOSP=NOUTS
                  ENDIF
                  IF (excoder1(i).EQ.'T') THEN
                     NOUTS=NOUTS + 1
                     IPOST=NOUTS
                  ENDIF
                  IF(mod(param(67),1.0).eq.0.0) THEN
                    i1 = i1_from_char(excoder1(i))
                    if (0.lt.i1.and.i1.lt.10) then
                       if (i1.le.ldimt1) then
                          nouts=nouts + 1
                          ipsps(i1)=nouts
                       else
                          if (nid.eq.0) write(6,2) i1,i,excoder1(i)
   2                      format(2i4,a1,' PROBLEM W/ RESTART DATA')
                       endif
                    endif
                  ELSE
                    IF(excoder1(i).EQ.'S') THEN
                       READ(excoder1(i+1),'(I1)') NPS1
                       READ(excoder1(i+2),'(I1)') NPS0
                       NPS=10*NPS1 + NPS0 
                       DO IS = 1, NPS
                         NOUTS=NOUTS + 1
                         IPSPS(IS)=NOUTS
                       ENDDO
                       GOTO 50
                    ENDIF
                  ENDIF
   50          CONTINUE
 
               IF (NPS.GT.(LDIMT-1)) THEN
                  IF (NID.EQ.0) THEN 
                    WRITE(*,'(A)') 
     &               'ERROR: restart file has a NSPCAL > LDIMT'
                    WRITE(*,'(A,I2)') 
     &               'Change LDIMT in SIZE'
                  ENDIF
                  CALL EXITT
               ENDIF

               lname=ltrunc(fname,132)
               if (nio.eq.0) write(6,61) (fname1(i),i=1,lname)
               if (nio.eq.0) write(6,62) 
     $             iposu,iposv,iposw,iposp,ipost,nps,nouts
   61          FORMAT(/,2X,'Restarting from file ',132A1)
   62          FORMAT(2X,'Columns for restart data U,V,W,P,T,S,N: ',7I4)

C              Make sure the requested data is present in this file....
               if (iposx.eq.0) ifgetx=.false.
               if (iposy.eq.0) ifgetx=.false.
               if (iposz.eq.0) ifgetz=.false.
               if (iposu.eq.0) ifgetu=.false.
               if (iposv.eq.0) ifgetu=.false.
               if (iposw.eq.0) ifgetw=.false.
               if (iposp.eq.0) ifgetp=.false.
               if (ipost.eq.0) ifgett=.false.
               do 65 i=1,npscal
                  if (ipsps(i).eq.0) ifgtps(i)=.false.
   65          continue

C              End of restart file header evaluation.

            ENDIF
C
C           Read the error estimators
C           not supported at the moment => just do dummy reading
C
            ifok = .false.
            IF(NID.EQ.0)THEN
               if (iffmat)
     &             READ(91,'(6G11.4)',END=15)(CDUMP,I=1,NELTR)
               ifok = .true.
            ENDIF
  15        continue
            call lbcast(ifok)
            if(.not.ifok) goto 1600
C
C           Read the current dump, double buffer so that we can
C           fit the data on a distributed memory machine,
C           and so we won't have to read the restart file twice
C           in case of an incomplete data file.
C
            NXYZR = NXR*NYR*NZR
C
C           Read the data
C
            nelrr = min(nelgt,neltr) ! # of elements to _really_read
                                     ! why not just neltr?
            do 200 ieg=1,nelrr
               ifok = .false.
               IF (NID.EQ.0) THEN
                 IF (MOD(IEG,10000).EQ.1) WRITE(6,*) 'Reading',IEG
                 IF (iffmat) THEN
                    READ(91,*,ERR=70,END=70)
     $              ((tdump(IXYZ,II),II=1,NOUTS),IXYZ=1,NXYZR)
                 ELSE
                    do ii=1,nouts
                       call byte_read(tdump(1,II),nxyzr,ierr)
                       if(ierr.ne.0) then
                          write(6,*) "Error reading xyz restart data"
                          goto 70
                       endif
                    enddo
                 ENDIF
                 IFOK=.TRUE.
               ENDIF
C
C              Notify other processors that we've read the data OK.
C
  70           continue
               call lbcast(ifok)
               IF (.NOT.IFOK) GOTO 1600
C
C              MAPDMP maps data from NXR to lx1
C              (and sends data to the appropriate processor.)
C
C              The buffer SDUMP is used so that if an incomplete dump
C              file is found (e.g. due to UNIX io buffering!), then
C              the previous read data stored in VX,VY,.., is not corrupted.
C
               IF (IFGETX) CALL MAPDMP
     $         (SDUMP(1,1),TDUMP(1,IPOSX),IEG,NXR,NYR,NZR,ifbytsw)
               IF (IFGETX) CALL MAPDMP
     $         (SDUMP(1,2),TDUMP(1,IPOSY),IEG,NXR,NYR,NZR,ifbytsw)
               IF (IFGETZ) CALL MAPDMP
     $         (SDUMP(1,3),TDUMP(1,IPOSZ),IEG,NXR,NYR,NZR,ifbytsw)
               IF (IFGETU) CALL MAPDMP
     $         (SDUMP(1,4),TDUMP(1,IPOSU),IEG,NXR,NYR,NZR,ifbytsw)
               IF (IFGETU) CALL MAPDMP
     $         (SDUMP(1,5),TDUMP(1,IPOSV),IEG,NXR,NYR,NZR,ifbytsw)
               IF (IFGETW) CALL MAPDMP
     $         (SDUMP(1,6),TDUMP(1,IPOSW),IEG,NXR,NYR,NZR,ifbytsw)
               IF (IFGETP) CALL MAPDMP
     $         (SDUMP(1,7),TDUMP(1,IPOSP),IEG,NXR,NYR,NZR,ifbytsw)
               if (ifgett) call mapdmp
     $         (SDMP2(1,1),TDUMP(1,IPOST),IEG,NXR,NYR,NZR,ifbytsw)

C              passive scalars
               do 100 ips=1,npscal
                  if (ifgtps(ips)) call mapdmp(sdmp2(1,ips+1)
     $               ,tdump(1,ipsps(ips)),ieg,nxr,nyr,nzr,IFBYTSW)
  100          continue
 
  200       continue
C
C           Successfully read a complete field, store it.
C
            nerr = 0              ! Count number of elements rec'd by nid
            do ieg=1,nelrr
               mid = gllnid(ieg)
               if (mid.eq.nid) nerr = nerr+1
            enddo

            nxyz2=lx2*ly2*lz2
            nxyz1=lx1*ly1*lz1
            ntott=nerr*nxyz1
            ntotv=nerr*nxyz1   ! Problem for differing Vel. and Temp. counts!
                               ! for now we read nelt dataset

            if (ifmhd.and.ifile.eq.2) then
               if (ifgetu) call copy(bx,sdump(1,4),ntott)
               if (ifgetu) call copy(by,sdump(1,5),ntott)
               if (ifgetw) call copy(bz,sdump(1,6),ntott)
               if (ifgetp) then
                 if (nio.eq.0) write(6,*) 'getting restart pressure'
                 if (ifsplit) then
                    call copy( pm,sdump(1,7),ntotv)
                 else
                  do iel=1,nelv
                    iiel = (iel-1)*nxyz1+1
                    call map12 (pm(1,1,1,iel),sdump(iiel,7),iel)
                  enddo
                 endif
               endif
               if (ifaxis.and.ifgett) 
     $            call copy(t(1,1,1,1,2),sdmp2(1,1),ntott)
            elseif (ifpert.and.ifile.ge.2) then
               j=ifile-1  ! pointer to perturbation field
               if (ifgetu) call copy(vxp(1,j),sdump(1,4),ntotv)
               if (ifgetu) call copy(vyp(1,j),sdump(1,5),ntotv)
               if (ifgetw) call copy(vzp(1,j),sdump(1,6),ntotv)
               if (ifgetp) then
                  if (nio.eq.0) write(6,*) 'getting restart pressure'
                  if (ifsplit) then
                     call copy(prp(1,j),sdump(1,7),ntotv)
                  else
                     do ie=1,nelv
                        ie1 = (ie-1)*nxyz1+1
                        ie2 = (ie-1)*nxyz2+1
                        call map12 (prp(ie2,j),sdump(ie1,7),ie)
                     enddo
                  endif
               endif
               if (ifgett) call copy(tp(1,1,j),sdmp2(1,1),ntott)
C              passive scalars
               do ips=1,NPSCAL
                  if (ifgtps(ips))
     $            call copy(tp(1,ips+1,j),sdmp2(1,ips+1),ntott)
               enddo

            else  ! Std. Case
               if (ifgetx) call copy(xm1,sdump(1,1),ntott)
               if (ifgetx) call copy(ym1,sdump(1,2),ntott)
               if (ifgetz) call copy(zm1,sdump(1,3),ntott)
               if (ifgetu) call copy(vx ,sdump(1,4),ntotv)
               if (ifgetu) call copy(vy ,sdump(1,5),ntotv)
               if (ifgetw) call copy(vz ,sdump(1,6),ntotv)
               if (ifgetp) call copy(pm1,sdump(1,7),ntotv)
               if (ifgett) call copy(t,sdmp2(1,1),ntott)
C              passive scalars
               do i=1,NPSCAL
                  if (ifgtps(i))
     $            call copy(t(1,1,1,1,i+1),sdmp2(1,i+1),ntott)
               enddo

               if (ifaxis) call axis_interp_ic(pm1)      ! Interpolate to axi mesh
               if (ifgetp) call map_pm1_to_pr(pm1,ifile) ! Interpolate pressure

               if (ifgtim) time=rstime
            endif

 1000    CONTINUE
         GOTO 1600
 
 1600    CONTINUE
C
         IF (IDUMP.EQ.1.AND.NID.EQ.0) THEN
            write(6,1700) fname
            write(6,1701) ieg,ixyz
            write(6,1702) 
     $            ((tdump(jxyz,ii),ii=1,nouts),jxyz=ixyz-1,ixyz)
 1700       FORMAT(5X,'WARNING:  No data read in for file ',A132)
 1701       FORMAT(5X,'Failed on  element',I4,',  point',I5,'.')
 1702       FORMAT(5X,'Last read dump:',/,5G15.7)
            write(6,*) nid,'call exitt 1702a',idump
            call exitt
         ELSEIF (IDUMP.EQ.1) THEN
            write(6,*) nid,'call exitt 1702b',idump
            call exitt
         ELSE
            IDUMP=IDUMP-1
            IF (NIO.EQ.0) WRITE(6,1800) IDUMP
 1800       FORMAT(2X,'Successfully read data from dump number',I3,'.')
         ENDIF
         if (iffmat) then
            if (nid.eq.0) close(unit=91)
         else
            ierr = 0
            if (nid.eq.0) call byte_close(ierr)
            call err_chk(ierr,'Error closing restart file in restart$')
         endif
         GOTO 6000

C        Can't open file...
 5000    CONTINUE
         if (nid.eq.0) write(6,5001) fname 
 5001    FORMAT(2X,'   *******   ERROR   *******    '
     $       ,/,2X,'   *******   ERROR   *******    '
     $       ,/,2X,'   Could not open restart file:'
     $       ,/,A132
     $      ,//,2X,'Quitting in routine RESTART.')
         CLOSE(UNIT=91)
         call exitt
 5002    CONTINUE
         IF (NIO.EQ.0) WRITE(6,5001) HNAME 
         call exitt
C
C
C     End of IFILE loop
 6000 CONTINUE
C
      return
      end
C
c-----------------------------------------------------------------------
      subroutine sioflag(ndumps,fname,rsopts)
C
C     Set IO flags according to Restart Options File, RSOPTS
C
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'RESTART'
      INCLUDE 'TSTEP'

      character*132 rsopts,fname
      character*2  s2
      logical ifgtrl

C     Scratch variables..
      logical ifdeft,ifanyc
      CHARACTER*132 RSOPT     ,LINE
      CHARACTER*1  RSOPT1(132),LINE1(132)
      EQUIVALENCE (RSOPT1,RSOPT)
      EQUIVALENCE (LINE1,LINE)
C
C     Parse filename
C
C        CSPLIT splits S1 into two parts, delimited by S2.  
C        S1 returns with 2nd part of S1.  CSPLIT returns 1st part.
C
      rsopt=rsopts
      call ljust(rsopt)
      call csplit(fname,rsopt,' ',1)
C     check fname for user supplied extension.
      if (indx1(fname,'.',1).eq.0) then
         len=ltrunc(fname,132)
         len1=len+1
         len4=len+4
         fname(len1:len4)='.fld'
      endif
C
C     Parse restart options
C
C     set default flags
C
      ifgetx=.false.
      ifgetz=.false.
      ifgetu=.false.
      ifgetw=.false.
      ifgetp=.false.
      ifgett=.false.
      do 100 i=1,ldimt-1
         ifgtps(i)=.false.
  100 continue
      ifgtim=.true.
      ndumps=0
C
C     Check for default case - just a filename given, no i/o options specified
C
      ifdeft=.true.
C
C     Parse file for i/o options and/or dump number
C
      CALL CAPIT(RSOPT,132)

      IF (LTRUNC(RSOPT,132).NE.0) THEN
C
C        Check for explicit specification of restart TIME.
C
         ITO=INDX_CUT(RSOPT,'TIME',4)
         IFGTIM=.TRUE.
         IF (ITO.NE.0) THEN
C           user has specified the time explicitly.
            IT1=INDX_CUT(RSOPT,'=',1)
            IT8=132-IT1
            CALL BLANK(LINE,132)
            CALL CHCOPY(LINE,RSOPT1(IT1),IT8)
            IF (IFGTRL(TTIME,LINE)) THEN
               IFGTIM=.FALSE.
               TIME=TTIME
            ENDIF
C           remove the user specified time from the RS options line.
            ITA=132-ITO+1
            CALL BLANK(RSOPT1(ITO),ITA)
            CALL LJUST(LINE)
            IT1=INDX1(LINE,' ',1)
            ITB=132-IT1+1
            CALL CHCOPY(RSOPT1(ITO),LINE1(IT1),ITB)
         ENDIF

C        Parse field specifications.

         IXO=INDX_CUT(RSOPT,'X',1)
         IF (IXO.NE.0) THEN
            ifdeft=.false.
            IFGETX=.TRUE.
            IF (IF3D) IFGETZ=.TRUE.
         ENDIF

         IVO=INDX_CUT(RSOPT,'U',1)
         IF (IVO.NE.0) THEN
            ifdeft=.false.
            IFGETU=.TRUE.
            IF (IF3D) IFGETW=.TRUE.
         ENDIF

         IPO=INDX_CUT(RSOPT,'P',1)
         IF (IPO.NE.0) THEN
            ifdeft=.false.
            IFGETP=.TRUE.
         ENDIF

         ITO=INDX_CUT(RSOPT,'T',1)
         IF (ITO.NE.0) THEN
            ifdeft=.false.
            ifgett=.true.
         ENDIF

         do 300 i=1,ldimt-1
            write (s2,301) i
            ipo=indx_cut(rsopt,s2,2)
            if (ipo.ne.0) then
               ifdeft=.false.
               ifgtps(i)=.true.
            endif
  300    continue
  301    format('S',i1)

C        Get number of dumps from remainder of user supplied line.
         if (ifgtrl(tdumps,rsopt)) ndumps=int(tdumps)
      endif

C     If no fields were explicitly specified, assume getting all fields. 
      if (ifdeft) then
         IFGETX=.TRUE.
         IF (IF3D) IFGETZ=.TRUE.
         IFANYC=.FALSE.
         DO 400 I=1,NFIELD
            IF (IFADVC(I)) IFANYC=.TRUE.
  400    CONTINUE
         IF (IFFLOW.OR.IFANYC) THEN
            IFGETU=.TRUE.
            IF (IF3D) IFGETW=.TRUE.
         ENDIF
         if (ifflow) ifgetp=.true.
         if (ifheat) ifgett=.true.
#ifdef CMTNEK
         ifgett=.true. ! CMT-nek still not compatible with IFHEAT
#endif
         do 410 i=1,ldimt-1
            ifgtps(i)=.TRUE.
  410    continue
      endif




      return
      END
c-----------------------------------------------------------------------
      subroutine mapdmp(sdump,tdump,ieg,nxr,nyr,nzr,if_byte_sw)
C----------------------------------------------------------------------
C
C----------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'PARALLEL'
C
      PARAMETER (LXYZ1=LX1*LY1*LZ1)
      PARAMETER (LXR=LX1+6)
      PARAMETER (LYR=LY1+6)
      PARAMETER (LZR=LZ1+6)
      PARAMETER (LXYZR=LXR*LYR*LZR)
C
      REAL   SDUMP(LXYZ1,LELT)
      REAL*4 TDUMP(LXYZR)
c
      logical if_byte_sw
c
      NXYZ=lx1*ly1*lz1
      NXYR=NXR*NYR*NZR
      ierr=0
C
C     Serial processor code:
C
      IF (NP.EQ.1) THEN

         IF (if_byte_sw) call byte_reverse(TDUMP,NXYR,ierr)
         if(ierr.ne.0) call exitti("Error in mapdmp")
         IF (NXR.EQ.lx1.AND.NYR.EQ.ly1.AND.NZR.EQ.lz1) THEN
            CALL COPY4r(SDUMP(1,IEG),TDUMP,NXYZ)
         ELSE
C           do the map    (assumes that NX=NY=NZ, or NX=NY, NZ=1)
            call mapab4r(sdump(1,ieg),tdump,nxr,1)
         ENDIF

      ELSE
C
C     Parallel code - send data to appropriate processor and map.
C
         JNID=GLLNID(IEG)
         MTYPE=3333+GLLEL(IEG)
         LEN=4*NXYR
         LE1=4
         IF (NID.EQ.0.AND.JNID.NE.0) THEN
c           hand-shake
            CALL CSEND(MTYPE,TDUMP,LE1,JNID,NULLPID)
            CALL CRECV2(MTYPE,dummy,LE1,JNID)
            CALL CSEND(MTYPE,TDUMP,LEN,JNID,NULLPID)
         ELSEIF (NID.NE.0.AND.JNID.EQ.NID) THEN
C           Receive data from node 0
            CALL CRECV2(MTYPE,dummy,LE1,0)
            CALL CSEND(MTYPE,TDUMP,LE1,0,NULLPID)
            CALL CRECV2(MTYPE,TDUMP,LEN,0)
         ENDIF
C
C        If the data is targeted for this processor, then map 
C        to appropriate element.
C
         IF (JNID.EQ.NID) THEN
            IE=GLLEL(IEG)
            IF (if_byte_sw) call byte_reverse(TDUMP,NXYR,ierr)
            IF (NXR.EQ.lx1.AND.NYR.EQ.ly1.AND.NZR.EQ.lz1) THEN
               CALL COPY4r(SDUMP(1,IE),TDUMP,NXYZ)
            ELSE
               call mapab4r(sdump(1,ie),tdump,nxr,1)
            ENDIF
         ENDIF
         call err_chk(ierr,'Error using byte_reverse in mapdmp.$')
C
C        End of parallel distribution/map routine.
C
      ENDIF
      return
      END
c-----------------------------------------------------------------------
      subroutine mapab(x,y,nxr,nel)
C---------------------------------------------------------------
C
C     Interpolate Y(NXR,NYR,NZR,NEL) to X(lx1,ly1,lz1,NEL)
C     (assumes that NXR=NYR=NZR, or NXR=NYR, NZR=1)
C---------------------------------------------------------------
C
      INCLUDE 'SIZE'
      INCLUDE 'IXYZ'
      INCLUDE 'WZ'
C
      PARAMETER (LXR=LX1+6)
      PARAMETER (LYR=LY1+6)
      PARAMETER (LZR=LZ1+6)
      PARAMETER (LXYZR=LXR*LYR*LZR)
      PARAMETER (LXYZ1=LX1*LY1*LZ1)
      DIMENSION X(lx1,ly1,lz1,NEL)
      DIMENSION Y(NXR,NXR,NXR,NEL)

      common /ctmp0/  xa(lxyzr)      ,xb(lx1,ly1,lzr) ,xc(lxyzr)
     $              , zgmr(lxr)      ,wgtr(lxr)
      common /ctmpab/ ires(lxr,lxr)  ,itres(lxr,lxr)
      real ires,itres

      INTEGER NOLD
      SAVE    NOLD
      DATA    NOLD /0/

C     Bounds checking on mapped data.
      if (nxr.gt.lxr) then
         if (nid.eq.0) write(6,20) nxr,lx1
   20    FORMAT(//,2X,
     $   'ABORT:  Attempt to map from',I3,
     $   ' to N=',I3,'.',/,2X,
     $   'NEK5000 currently supports mapping from N+6 or less.'
     $   ,/,2X,'Increase N')
         call exitt
      endif

      NZR = NXR
      IF(lz1.EQ.1) NZR=1
      NYZR = NXR*NZR
      NXY1 = lx1*ly1

      IF (NXR.NE.NOLD) THEN
         NOLD=NXR
         CALL ZWGLL   (ZGMR,WGTR,NXR)
         CALL IGLLM   (IRES,ITRES,ZGMR,ZGM1,NXR,lx1,NXR,lx1)      
         IF (NIO.EQ.0) WRITE(6,10) NXR,lx1
   10       FORMAT(2X,'Mapping restart data from Nold=',I2
     $               ,' to Nnew=',I2,'.')
      ENDIF
C
      DO 1000 IE=1,NEL
         CALL MXM (IRES,lx1,Y(1,1,1,IE),NXR,XA,NYZR)
         DO 100 IZ=1,NZR
            IZOFF = 1 + (IZ-1)*lx1*NXR
            CALL MXM (XA(IZOFF),lx1,ITRES,NXR,XB(1,1,IZ),ly1)
  100    CONTINUE
         IF (ldim.EQ.3) THEN
            CALL MXM (XB,NXY1,ITRES,NZR,X(1,1,1,IE),lz1)
         ELSE
            CALL COPY(X(1,1,1,IE),XB,NXY1)
         ENDIF
 1000 CONTINUE
C
      return
      END
c-----------------------------------------------------------------------
      subroutine mapab4R(x,y,nxr,nel)
C---------------------------------------------------------------
C
C     Interpolate Y(NXR,NYR,NZR,NEL) to X(lx1,ly1,lz1,NEL)
C     (assumes that NXR=NYR=NZR, or NXR=NYR, NZR=1)
c
c     Input:  real*4,  Output:  default precision
c
C---------------------------------------------------------------
C
      INCLUDE 'SIZE'
      INCLUDE 'IXYZ'
      INCLUDE 'WZ'
C
      PARAMETER (LXR=LX1+6)
      PARAMETER (LYR=LY1+6)
      PARAMETER (LZR=LZ1+6)
      PARAMETER (LXYZR=LXR*LYR*LZR)
      PARAMETER (LXYZ1=LX1*LY1*LZ1)
      REAL*4 X(lx1,ly1,lz1,NEL)
      REAL   Y(NXR,NXR,NXR,NEL)

      common /ctmp0/  xa(lxyzr)      ,xb(lx1,ly1,lzr) ,xc(lxyzr)
     $              , zgmr(lxr)      ,wgtr(lxr)
      common /ctmpa4/ ires(lxr,lxr)  ,itres(lxr,lxr)
      real ires,itres

      INTEGER NOLD
      SAVE    NOLD
      DATA    NOLD /0/

C     Bounds checking on mapped data.
      if (nxr.gt.lxr) then
         if (nid.eq.0) write(6,20) nxr,lx1
   20    FORMAT(//,2X,
     $   'ABORT:  Attempt to map from',I3,
     $   ' to N=',I3,'.',/,2X,
     $   'NEK5000 currently supports mapping from N+6 or less.'
     $   ,/,2X,'Increase N')
         call exitt
      endif

      NZR = NXR
      IF(lz1.EQ.1) NZR=1
      NYZR = NXR*NZR
      NXY1 = lx1*ly1
      nxyzr = nxr*nxr*nzr

      IF (NXR.NE.NOLD) THEN
         NOLD=NXR
         CALL ZWGLL   (ZGMR,WGTR,NXR)
         CALL IGLLM   (IRES,ITRES,ZGMR,ZGM1,NXR,lx1,NXR,lx1)      
         IF (NIO.EQ.0) WRITE(6,10) NXR,lx1
   10       FORMAT(2X,'Mapping restart data from Nold=',I2
     $               ,' to Nnew=',I2,'.')
      ENDIF
C
      DO 1000 IE=1,NEL
         call copy4r(xc,y(1,1,1,ie),nxyzr)
         CALL MXM (IRES,lx1,xc,NXR,XA,NYZR)
         DO 100 IZ=1,NZR
            IZOFF = 1 + (IZ-1)*lx1*NXR
            CALL MXM (XA(IZOFF),lx1,ITRES,NXR,XB(1,1,IZ),ly1)
  100    CONTINUE
         IF (ldim.EQ.3) THEN
            CALL MXM (XB,NXY1,ITRES,NZR,X(1,1,1,IE),lz1)
         ELSE
            CALL COPY(X(1,1,1,IE),XB,NXY1)
         ENDIF
 1000 CONTINUE
C
      return
      END
c-----------------------------------------------------------------------
      function i1_from_char(s1)
      character*1 s1

      character*10 n10
      save         n10
      data         n10 / '0123456789' /

      i1_from_char = indx2(n10,10,s1,1)-1

      return
      end
c-----------------------------------------------------------------------
      integer function indx2(s1,l1,s2,l2)
      character*132 s1,s2

      n1=l1-l2+1
      indx2=0
      if (n1.lt.1) return

      do i=1,n1
         i2=i+l2-1
         if (s1(i:i2).eq.s2(1:l2)) then
            indx2=i
            return
         endif
      enddo

      return
      end
c-----------------------------------------------------------------------
      INTEGER FUNCTION INDX1(S1,S2,L2)
      CHARACTER*132 S1,S2
C
      N1=132-L2+1
      INDX1=0
      IF (N1.LT.1) return
C
      DO 100 I=1,N1
         I2=I+L2-1
         IF (S1(I:I2).EQ.S2(1:L2)) THEN
            INDX1=I
            return
         ENDIF
  100 CONTINUE
C
      return
      END
c-----------------------------------------------------------------------
      INTEGER FUNCTION INDX_CUT(S1,S2,L2)
C
C     INDX_CUT is returned with the location of S2 in S1 (0 if not found)
C     S1     is returned with 1st occurance of S2 removed.
C
      CHARACTER*1 S1(132),S2(132)
C
      I1=INDX1(S1,S2,L2)
C
      IF (I1.NE.0) THEN
C
         N1=132-L2
         DO 100 I=I1,N1
            I2=I+L2
C           remove the 1st occurance of S2 from S1.
            S1(I)=S1(I2)
  100    CONTINUE
         N2=N1+1
         DO 200 I=N2,132
            S1(I)=' '
  200    CONTINUE
      ENDIF
C
      INDX_CUT=I1
      return
      END
c-----------------------------------------------------------------------
      subroutine csplit(s0,s1,s2,l0)
      CHARACTER*132 S0,S1,S2
C     split string S1 into two parts, delimited by S2.
C
      I2=INDX_CUT(S1,S2,L0)
      IF (I2.EQ.0) return
C
      I1=I2-1
      CALL BLANK(S0,132)
      S0(1:I1)=S1(1:I1)
      CALL LSHFT(S1,I2)
C
      return
      END
c-----------------------------------------------------------------------
      subroutine lshft(string,ipt)
C     shift string from IPT to the left
C     INPUT : "abcde......    test    "
C     OUTPUT: "e......    test        "     if ipt.eq.5
      CHARACTER*1 STRING(132)
C
      DO 20 J=1,133-IPT
         IJ=IPT+J-1
         STRING(J)=STRING(IJ)
   20 CONTINUE
      DO 30 J=134-IPT,132
         STRING(J)=' '
   30 CONTINUE
      return
      END
c-----------------------------------------------------------------------
      subroutine ljust(string)
C     left justify string
      CHARACTER*1 STRING(132)
C
      IF (STRING(1).NE.' ') return
C
      DO 100 I=2,132
C
         IF (STRING(I).NE.' ') THEN
            DO 20 J=1,133-I
               IJ=I+J-1
               STRING(J)=STRING(IJ)
   20       CONTINUE
            DO 30 J=134-I,132
               STRING(J)=' '
   30       CONTINUE
            return
         ENDIF
C
  100 CONTINUE
      return
      END
c-----------------------------------------------------------------------
      subroutine chknorm (ifzero)
C----------------------------------------------------------------------
C
C     Check if trivial user specified initial conditions
C
C----------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'TSTEP'
      LOGICAL IFZERO
C
      IFZERO = .TRUE.
C
      IF (IFFLOW) THEN
         IFIELD = 1
         IMESH  = 1
         CALL UNORM
         IF (VNRML8.GT.0.) IFZERO = .FALSE.
      ENDIF
      IF (IFHEAT) THEN
         DO 100 IFIELD=2,NFIELD
            IMESH = 1
            IF (IFTMSH(IFIELD)) IMESH = 2
            CALL UNORM
            IF (TNRML8(IFIELD).GT.0.) IFZERO = .FALSE.
 100     CONTINUE
      ENDIF
c
      return
      END
C
c-----------------------------------------------------------------------
      subroutine prsolvt
C----------------------------------------------------------------------
C
C     Use steady state solution as initial condition 
C     for temperatur/passive scalar
C
C----------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'TSTEP'
      LOGICAL  IFSAV1,IFSAV2(LDIMT1)
C
      IF (NIO.EQ.0) WRITE(6,*) ' '
      IF (NIO.EQ.0) WRITE(6,*) 'Conduction pre-solver activated'
C
C     Set logical IFTRAN to false (steady state)
C     Save logicals for convection
C     Turn convection off
C
      IFSAV1 = IFTRAN
      IFTRAN = .FALSE.
      DO 100 IFIELD=2,NFIELD
         IFSAV2(IFIELD) = IFADVC(IFIELD)
         IFADVC(IFIELD) = .FALSE.
 100  CONTINUE
C
      CALL SETPROP
      CALL SETSOLV
C
      IF(NIO.EQ.0)WRITE(6,*)'Steady conduction/passive scalar problem'
C
      DO 200 IGEOM=1,2
         CALL HEAT (IGEOM)
 200  CONTINUE
C
C     Set IFTRAN to true again
C     Turn convection on again
C
      IFTRAN = IFSAV1
      DO 300 IFIELD=2,NFIELD
         IFADVC(IFIELD) = IFSAV2(IFIELD)
 300  CONTINUE
C
      return
      END
C
c-----------------------------------------------------------------------
      subroutine prsolvv
C----------------------------------------------------------------------
C
C     Use steady Stokes solution as initial condition 
C     for flow problem
C
C----------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'SOLN'
      INCLUDE 'TSTEP'
      LOGICAL  IFSAV1,IFSAV2
C
      IF (NIO.EQ.0) WRITE(6,*) ' '
      IF (NIO.EQ.0) WRITE(6,*) 'Velocity pre-solver activated'
C
C     Initialize velocity to some non-trivial RHS to avoid FP trap in i860.
C
      IF (PARAM(60).NE.0.0) THEN
         SMALL=10.0E-10
         CALL CFILL(VX,SMALL,NTOTV)
         CALL CFILL(VY,SMALL,NTOTV)
         CALL CFILL(VZ,SMALL,NTOTV)
      ENDIF
C
C     Set logical IFTRAN to false (steady state)
C     Save logicals for convection
C     Turn convection off
C
      IF (IFSPLIT) THEN
        WRITE(6,10)
   10   FORMAT(
     $ /,2X,'ERROR: Steady Stokes Flow initial condition cannot'
     $,/,2X,'       be computed using the splitting formulation.'
     $,/,2X,'       Either compute using UZAWA, or remove PRESOLVE'
     $,/,2X,'       request for velocity.'
     $,/,2X
     $,/,2X,'       ABORTING IN PRSOLVV.')
        CALL EXITT
      ENDIF
C
      IFSAV1 = IFTRAN
      IFSAV2 = IFADVC(IFIELD)
      IFTRAN = .FALSE.
      IFADVC(IFIELD) = .FALSE.
C
      CALL SETPROP
      CALL SETSOLV
C
      IF (NIO.EQ.0) WRITE (6,*) 'Steady Stokes problem'
      DO 100 IGEOM=1,2
         IF (.NOT.IFSPLIT) CALL FLUID (IGEOM)
 100  CONTINUE
C
C     Set IFTRAN to true again
C     Turn convection on again
C
      IFTRAN = IFSAV1
      IFADVC(IFIELD) = IFSAV2
C
      return
      END
C
c-----------------------------------------------------------------------
      subroutine nekuic ! user specified fortran function (=0 if not specified)

      include 'SIZE'
      include 'INPUT'
      include 'SOLN'
      include 'TSTEP'
      include 'PARALLEL'
      include 'NEKUSE'

      integer e,eg

      nel   = nelfld(ifield)

      do e=1,nel
         eg = lglel(e)
         do 300 k=1,lz1
         do 300 j=1,ly1
         do 300 i=1,lx1
           call nekasgn (i,j,k,e)
           call useric  (i,j,k,eg)
           if (jp.eq.0) then
             if (ifield.eq.1) then
               vx(i,j,k,e) = ux
               vy(i,j,k,e) = uy
               vz(i,j,k,e) = uz
             elseif (ifield.eq.ifldmhd .and. ifmhd) then
               bx(i,j,k,e) = ux
               by(i,j,k,e) = uy
               bz(i,j,k,e) = uz
             else
               t(i,j,k,e,ifield-1) = temp
             endif
           else
             ijke = i+lx1*((j-1)+ly1*((k-1) + lz1*(e-1)))
             if (ifield.eq.1) then
               vxp(ijke,JP) = ux
               vyp(ijke,JP) = uy
               vzp(ijke,JP) = uz
             else
               tp(ijke,ifield-1,JP) = temp
             endif
           endif

 300     continue
      enddo

      return
      END
c-----------------------------------------------------------------------
      subroutine capit(lettrs,n)
C     Capitalizes string of length n
      CHARACTER LETTRS(N)
C
      DO 5 I=1,N
         INT=ICHAR(LETTRS(I))
         IF(INT.GE.97 .AND. INT.LE.122) THEN
            INT=INT-32
            LETTRS(I)=CHAR(INT)
         ENDIF
5     CONTINUE
      return
      END
c-----------------------------------------------------------------------
      LOGICAL FUNCTION IFGTRL(VALUE,LINE)
C
C     Read VALUE from LINE and set IFGTRL to .TRUE. if successful,
C                                  IFGTRL to .FALSE. otherwise.
C
C     This complicated function is necessary thanks to the Ardent,
C     which won't allow free formatted reads (*) from internal strings!
C
      CHARACTER*132 LINE
      CHARACTER*132 WORK
      CHARACTER*8  FMAT
C
C     Note that the format Fn.0 is appropriate for fields of type:
C          34   34.0  34.0e+00
C     The only difficulty would be with '34' but since we identify
C     the field width exactly, there is no problem.
C
      IFGTRL=.FALSE.
      VALUE=0.0
C
      WORK=LINE
      CALL LJUST(WORK)
      IFLDW=INDX1(WORK,' ',1)-1
C
      IF (IFLDW.GT.0) THEN
         WRITE(FMAT,10) IFLDW
   10    FORMAT('(F',I3.3,'.0)')
         READ(WORK,FMAT,ERR=100,END=100) TVAL
         VALUE=TVAL
         IFGTRL=.TRUE.
         return
      ENDIF
C
  100 CONTINUE
      return
      END
c-----------------------------------------------------------------------
      LOGICAL FUNCTION IFGTIL(IVALUE,LINE)
C
C     Read IVALUE from LINE and set IFGTIL to .TRUE. if successful,
C                                   IFGTIL to .FALSE. otherwise.
C
C     This complicated function is necessary thanks to the Ardent,
C     which won't allow free formatted reads (*) from internal strings!
C
      CHARACTER*132 LINE
      CHARACTER*132 WORK
      CHARACTER*8  FMAT
C
      IFGTIL=.FALSE.
      IVALUE=0
C
      WORK=LINE
      CALL LJUST(WORK)
      IFLDW=INDX1(WORK,' ',1)-1
C
      IF (IFLDW.GT.0) THEN
         WRITE(FMAT,10) IFLDW
   10    FORMAT('(F',I3.3,'.0)')
         READ(WORK,FMAT,ERR=100,END=100) TVAL
         IVALUE=INT(TVAL)
         IFGTIL=.TRUE.
         return
      ENDIF
C
  100 CONTINUE
      return
      END
c-----------------------------------------------------------------------
      subroutine perturb(tt,ifld,eps)
      include 'SIZE'
      include 'TOTAL'
c
      real tt(1)
      integer ifld

      ifield = ifld

      n = lx1*ly1*lz1*nelfld(ifield)
      call vcospf(tt,bm1,n)
      call cmult(tt,eps,n)
      call dssum(tt,lx1,ly1,lz1)

      return
      end
c-----------------------------------------------------------------------
      subroutine vcospf(x,y,n)
      real x(1),y(1)
      do i=1,n
         x(i) = cos(1000.*y(i))
      enddo
      return
      end
c-----------------------------------------------------------------------
      subroutine vbyte_swap(x,n)
      character*1 x(0:3,1),tmp0,tmp1
      character*1 in (0:3), out(0:3)
      real*4      in4     , out4
      equivalence (in ,in4 )
      equivalence (out,out4)
c
      do i=1,n
         do j=0,3
            in (j) = x(j,i)
         enddo
         tmp0   = x(0,i)
         tmp1   = x(1,i)
         x(0,i) = x(3,i)
         x(1,i) = x(2,i)
         x(2,i) = tmp1
         x(3,i) = tmp0
         do j=0,3
            out(j) = x(j,i)
         enddo
         write(6,*) 'swap:',i,in4,out4
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      logical function if_byte_swap_test(bytetest,ierr)
      include 'SIZE'
 
      real*4 bytetest,test2
      real*4 test_pattern
      save   test_pattern
 
      test_pattern = 6.54321
      eps          = 0.00020
      etest        = abs(test_pattern-bytetest)
      if_byte_swap_test = .true.
      if (etest.le.eps) if_byte_swap_test = .false.
 
      test2 = bytetest
      call byte_reverse(test2,1,ierr)
      if (nid.eq.0 .and. loglevel.gt.2) 
     $   write(6,*) 'byte swap:',if_byte_swap_test,bytetest,test2
      return
      end
c-----------------------------------------------------------------------
      subroutine geom_reset(icall)
C
C     Generate geometry data
C
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'GEOM'
      INCLUDE 'SOLN'
      INCLUDE 'TSTEP'
      include 'WZ'
c
      COMMON /scruz/ XM3 (LX1,LY1,LZ1,LELT)
     $ ,             YM3 (LX1,LY1,LZ1,LELT)
     $ ,             ZM3 (LX1,LY1,LZ1,LELT)
C
c
      if(nio.eq.0) write(6,*) 'regenerate geometry data',icall

      ntot = lx1*ly1*lz1*nelt
c
      if (lx3.eq.lx1) then
         call copy(xm3,xm1,ntot)
         call copy(ym3,ym1,ntot)
         call copy(zm3,zm1,ntot)
      else
         call map13_all(xm3,xm1)
         call map13_all(ym3,ym1)
         if (if3d) call map13_all(zm3,zm1)
      endif
c
      CALL GEOM1 (XM3,YM3,ZM3)
      CALL GEOM2
      CALL UPDMSYS (1)
      CALL VOLUME
      CALL SETINVM
      CALL SETDEF
      CALL SFASTAX
c
      do ie = 1,nelt
         ! x
         xc(1,ie) = XM1(1  ,1  ,1  ,ie)
         xc(2,ie) = XM1(lx1,1  ,1  ,ie)
         xc(3,ie) = XM1(lx1,ly1,1  ,ie)
         xc(4,ie) = XM1(1  ,ly1,1  ,ie)
         xc(5,ie) = XM1(1  ,1  ,lz1,ie)
         xc(6,ie) = XM1(lx1,1  ,lz1,ie)
         xc(7,ie) = XM1(lx1,ly1,lz1,ie)
         xc(8,ie) = XM1(1  ,ly1,lz1,ie)
         ! y
         yc(1,ie) = YM1(1  ,1  ,1  ,ie)
         yc(2,ie) = YM1(lx1,1  ,1  ,ie)
         yc(3,ie) = YM1(lx1,ly1,1  ,ie)
         yc(4,ie) = YM1(1  ,ly1,1  ,ie)
         yc(5,ie) = YM1(1  ,1  ,lz1,ie)
         yc(6,ie) = YM1(lx1,1  ,lz1,ie)
         yc(7,ie) = YM1(lx1,ly1,lz1,ie)
         yc(8,ie) = YM1(1  ,ly1,lz1,ie)
         ! z 
         zc(1,ie) = ZM1(1  ,1  ,1  ,ie)
         zc(2,ie) = ZM1(lx1,1  ,1  ,ie)
         zc(3,ie) = ZM1(lx1,ly1,1  ,ie)
         zc(4,ie) = ZM1(1  ,ly1,1  ,ie)
         zc(5,ie) = ZM1(1  ,1  ,lz1,ie)
         zc(6,ie) = ZM1(lx1,1  ,lz1,ie)
         zc(7,ie) = ZM1(lx1,ly1,lz1,ie)
         zc(8,ie) = ZM1(1  ,ly1,lz1,ie)
      enddo

      if(nio.eq.0) then
        write(6,*) 'done :: regenerate geometry data',icall
        write(6,*) ' '
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine dsavg(u)
c
c
      include 'SIZE'
      include 'TOTAL'
      real u(lx1,ly1,lz1,lelt)
c
c
c     Take direct stiffness avg of u
c
c
      ifieldo = ifield
      if (ifflow) then
         ifield = 1
         ntot = lx1*ly1*lz1*nelv
         call dssum(u,lx1,ly1,lz1)
         call col2 (u,vmult,ntot)
      else
         ifield = 2
         ntot = lx1*ly1*lz1*nelt
         call dssum(u,lx1,ly1,lz1)
         call col2 (u,tmult,ntot)
      endif
      ifield = ifieldo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine map13_all(x3,x1)
c
      include 'SIZE'
      include 'TOTAL'
c
      real x3(lx3,ly3,lz3,lelt)
      real x1(lx1,ly1,lz1,lelt)
c
      integer e
c
      do e=1,nelt
         call map13 (x3(1,1,1,e),x1(1,1,1,e),e)
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine mfi_gets(u,wk,lwk,iskip)

      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'
      include 'RESTART'


      real u(lx1*ly1*lz1,1)

      real*4 wk(2*lwk) ! message buffer
      parameter(lrbs=20*lx1*ly1*lz1*lelt)
      common /vrthov/ w2(lrbs) ! read buffer
      real*4 w2

      integer e,ei,eg,msg_id(lelt)
      logical iskip
      integer*8 i8tmp

      call nekgsync() ! clear outstanding message queues.

      nxyzr  = nxr*nyr*nzr  
      dnxyzr = nxyzr 
      len    = nxyzr*wdsizr  ! message length
      if (wdsizr.eq.8) nxyzr = 2*nxyzr

      ! check message buffer wk
      num_recv  = nxyzr*nelt
      num_avail = size(wk)
      call lim_chk(num_recv,num_avail,'     ','     ','mfi_gets a')

      ! setup read buffer
      if (nid.eq.pid0r) then
         i8tmp = int(nxyzr,8)*int(nelr,8)
         nread = i8tmp/int(lrbs,8)
         if (mod(i8tmp,int(lrbs,8)).ne.0) nread = nread + 1
         if(ifmpiio) nread = iglmax(nread,1) ! needed because of collective read
         nelrr = nelr/nread
      endif
      call bcast(nelrr,4)
      call lim_chk(nxyzr*nelrr,lrbs,'     ','     ','mfi_gets b')

      ! pre-post recieves
      if (np.gt.1) then
         l = 1
         do e=1,nelt
            msg_id(e) = irecv(e,wk(l),len)
            l = l+nxyzr
         enddo
      endif

      ierr = 0
      if (nid.eq.pid0r.and.np.gt.1) then ! only i/o nodes will read
         ! read blocks of size nelrr
         k = 0
         do i = 1,nread
            if(i.eq.nread) then ! clean-up 
              nelrr = nelr - (nread-1)*nelrr
              if(nelrr.lt.0) nelrr = 0
            endif
            
            if(ierr.eq.0) then
              if(ifmpiio) then
                call byte_read_mpi(w2,nxyzr*nelrr,-1,ifh_mbyte,ierr)
              else
                call byte_read (w2,nxyzr*nelrr,ierr)
              endif
            endif

            ! distribute data across target processors
            l = 1
            do e = k+1,k+nelrr
               jnid = gllnid(er(e))                ! where is er(e) now?
               jeln = gllel(er(e))
               if(ierr.ne.0) call rzero(w2(l),len)
               call csend(jeln,w2(l),len,jnid,0)  ! blocking send
               l = l+nxyzr
            enddo
            k  = k + nelrr
         enddo
      elseif (np.eq.1) then
         if(ifmpiio) then
           call byte_read_mpi(wk,nxyzr*nelr,-1,ifh_mbyte,ierr)
         else
           call byte_read(wk,nxyzr*nelr,ierr)
         endif
      endif

      if (iskip) then
         call nekgsync() ! clear outstanding message queues.
         goto 100     ! don't use the data
      endif

      nxyzr = nxr*nyr*nzr
      nxyzv = nxr*nyr*nzr
      nxyzw = nxr*nyr*nzr
      if (wdsizr.eq.8) nxyzw = 2*nxyzw

      l = 1
      do e=1,nelt
         if (np.gt.1) then
            call msgwait(msg_id(e))
            ei = e
         elseif(np.eq.1) then
            ei = er(e)
         endif
         if (if_byte_sw) then
            if(wdsizr.eq.8) then
              call byte_reverse8(wk(l),nxyzv*2,ierr)
            else
              call byte_reverse(wk(l),nxyzv,ierr)
            endif
         endif
         if (nxr.eq.lx1.and.nyr.eq.ly1.and.nzr.eq.lz1) then
            if (wdsizr.eq.4) then         ! COPY
               call copy4r(u(1,ei),wk(l        ),nxyzr)
            else
               call copy  (u(1,ei),wk(l        ),nxyzr)
            endif
         else                             ! INTERPOLATE
            if (wdsizr.eq.4) then
               call mapab4r(u(1,ei),wk(l        ),nxr,1)
            else
               call mapab  (u(1,ei),wk(l        ),nxr,1)
            endif
         endif
         l = l+nxyzw
      enddo


 100  call err_chk(ierr,'Error reading restart data,in gets.$')
      return
      end
c-----------------------------------------------------------------------
      subroutine mfi_getv(u,v,w,wk,lwk,iskip)

      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'
      include 'RESTART'

      real u(lx1*ly1*lz1,1),v(lx1*ly1*lz1,1),w(lx1*ly1*lz1,1)
      logical iskip

      real*4 wk(2*lwk) ! message buffer
      parameter(lrbs=20*lx1*ly1*lz1*lelt)
      common /vrthov/ w2(lrbs) ! read buffer
      real*4 w2

      integer e,ei,eg,msg_id(lelt)
      integer*8 i8tmp
 
      call nekgsync() ! clear outstanding message queues.

      nxyzr  = ldim*nxr*nyr*nzr
      len    = nxyzr*wdsizr             ! message length in bytes
      if (wdsizr.eq.8) nxyzr = 2*nxyzr

      ! check message buffer wk
      num_recv  = nxyzr*nelt 
      num_avail = size(wk)
      call lim_chk(num_recv,num_avail,'     ','     ','mfi_getv a')

      ! setup read buffer
      if(nid.eq.pid0r) then
         i8tmp = int(nxyzr,8)*int(nelr,8)
         nread = i8tmp/int(lrbs,8)
         if (mod(i8tmp,int(lrbs,8)).ne.0) nread = nread + 1
         if(ifmpiio) nread = iglmax(nread,1) ! needed because of collective read
         nelrr = nelr/nread
      endif
      call bcast(nelrr,4)
      call lim_chk(nxyzr*nelrr,lrbs,'     ','     ','mfi_getv b')

      ! pre-post recieves (one mesg per element)
      ! this assumes we never pre post more messages than supported
      if (np.gt.1) then
         l = 1
         do e=1,nelt
            msg_id(e) = irecv(e,wk(l),len)
            l = l+nxyzr
         enddo
      endif

      ierr = 0
      if (nid.eq.pid0r .and. np.gt.1) then ! only i/o nodes
         k = 0
         do i = 1,nread
            if(i.eq.nread) then ! clean-up 
              nelrr = nelr - (nread-1)*nelrr
              if(nelrr.lt.0) nelrr = 0
            endif

            if(ierr.eq.0) then
              if(ifmpiio) then 
                call byte_read_mpi(w2,nxyzr*nelrr,-1,ifh_mbyte,ierr)
              else
                call byte_read (w2,nxyzr*nelrr,ierr)
              endif
            endif

            ! redistribute data based on the current el-proc map
            l = 1
            do e = k+1,k+nelrr
               jnid = gllnid(er(e))                ! where is er(e) now?
               jeln = gllel(er(e))
               if(ierr.ne.0) call rzero(w2(l),len)
               call csend(jeln,w2(l),len,jnid,0)  ! blocking send
               l = l+nxyzr
            enddo
            k  = k + nelrr
         enddo
      elseif (np.eq.1) then
         if(ifmpiio) then 
           call byte_read_mpi(wk,nxyzr*nelr,-1,ifh_mbyte,ierr)
         else
           call byte_read(wk,nxyzr*nelr,ierr)
         endif
      endif

      if (iskip) then
         call nekgsync() ! clear outstanding message queues.
         goto 100     ! don't assign the data we just read
      endif

      nxyzr = nxr*nyr*nzr
      nxyzv = ldim*nxr*nyr*nzr
      nxyzw = nxr*nyr*nzr
      if (wdsizr.eq.8) nxyzw = 2*nxyzw

      l = 1
      do e=1,nelt
         if (np.gt.1) then
            call msgwait(msg_id(e))
            ei = e
         else if(np.eq.1) then
            ei = er(e) 
         endif
         if (if_byte_sw) then
            if(wdsizr.eq.8) then
               call byte_reverse8(wk(l),nxyzv*2,ierr)
            else
               call byte_reverse(wk(l),nxyzv,ierr)
            endif
         endif
         if (nxr.eq.lx1.and.nyr.eq.ly1.and.nzr.eq.lz1) then
            if (wdsizr.eq.4) then         ! COPY
               call copy4r(u(1,ei),wk(l        ),nxyzr)
               call copy4r(v(1,ei),wk(l+  nxyzw),nxyzr)
               if (if3d) 
     $         call copy4r(w(1,ei),wk(l+2*nxyzw),nxyzr)
            else
               call copy  (u(1,ei),wk(l        ),nxyzr)
               call copy  (v(1,ei),wk(l+  nxyzw),nxyzr)
               if (if3d) 
     $         call copy  (w(1,ei),wk(l+2*nxyzw),nxyzr)
            endif
         else                             ! INTERPOLATE
            if (wdsizr.eq.4) then
               call mapab4r(u(1,ei),wk(l        ),nxr,1)
               call mapab4r(v(1,ei),wk(l+  nxyzw),nxr,1)
               if (if3d) 
     $         call mapab4r(w(1,ei),wk(l+2*nxyzw),nxr,1)
            else
               call mapab  (u(1,ei),wk(l        ),nxr,1)
               call mapab  (v(1,ei),wk(l+  nxyzw),nxr,1)
               if (if3d) 
     $         call mapab  (w(1,ei),wk(l+2*nxyzw),nxr,1)
            endif
         endif
         l = l+ldim*nxyzw
      enddo

 100  call err_chk(ierr,'Error reading restart data, in getv.$')
      return
      end
c-----------------------------------------------------------------------
      subroutine mfi_parse_hdr(hdr,ierr)
      include 'SIZE'

      character*132 hdr

      if (indx2(hdr,132,'#std',4).eq.1) then
          call parse_std_hdr(hdr)
      else
         if (nio.eq.0) write(6,80) hdr
         if (nio.eq.0) write(6,80) 'NONSTD HDR, parse_hdr, abort.'
  80     format(a132)
         ierr = 1
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine parse_std_hdr(hdr)
      include 'SIZE'
      include 'INPUT'
      include 'SOLN'
      include 'PARALLEL'
      include 'RESTART'
      include 'TSTEP'

      character*132 hdr
      character*4 dummy
      logical if_press_mesh

      p0thr = -1
      if_press_mesh = .false.

      read(hdr,*,iostat=ierr) dummy
     $         ,  wdsizr,nxr,nyr,nzr,nelr,nelgr,timer,istpr
     $         ,  ifiler,nfiler
     $         ,  rdcode      ! 74+20=94
     $         ,  p0thr, if_press_mesh

      if (ierr.gt.0) then ! try again without pressure format flag
        read(hdr,*,iostat=ierr) dummy
     $         ,  wdsizr,nxr,nyr,nzr,nelr,nelgr,timer,istpr
     $         ,  ifiler,nfiler
     $         ,  rdcode      ! 74+20=94
     $         ,  p0thr
      endif

      if (ierr.gt.0) then ! try again without mean pressure
        read(hdr,*,err=99) dummy
     $         ,  wdsizr,nxr,nyr,nzr,nelr,nelgr,timer,istpr
     $         ,  ifiler,nfiler
     $         ,  rdcode      ! 74+20=94
      endif

c     set if_full_pres flag
      if_full_pres = .false.
      if (.not.ifsplit) if_full_pres = if_press_mesh

c      ifgtim  = .true.  ! always get time
      ifgetxr = .false.
      ifgetur = .false.
      ifgetpr = .false.
      ifgettr = .false.
      do k=1,ldimt-1
         ifgtpsr(k) = .false.
      enddo

      NPSR = 0
      NPS  = 0
      do i=1,10 
         if (rdcode1(i).eq.'X') ifgetxr = .true.
         if (rdcode1(i).eq.'U') ifgetur = .true.
         if (rdcode1(i).eq.'P') ifgetpr = .true.
         if (rdcode1(i).eq.'T') ifgettr = .true.
         if (rdcode1(i).eq.'S') then
            read(rdcode1(i+1),'(I1)') NPS1
            read(rdcode1(i+2),'(I1)') NPS0
            NPSR = 10*NPS1+NPS0
            NPS  = NPSR
            if(NPSR.gt.ldimt-1) NPS=ldimt-1
            do k=1,NPS
               ifgtpsr(k) = .true.
            enddo
            ! nothing will follow
            GOTO 50
         endif
      enddo

  50  if (NPS.lt.NPSR) then
         if (nid.eq.0) then 
           write(*,'(A,/,A)') 
     &      'WARNING: restart file has a NSPCAL > LDIMT',
     &      'read only part of the fld-data!'
         endif
      endif

      if (NPS.lt.NPSCAL) then
         if (nid.eq.0) then 
           write(*,'(A,/,A)') 
     &      'WARNING: NPSCAL read from restart file differs from ',
     &      'currently used NPSCAL!'
         endif
      endif

      p0th = 1 
      if (p0thr.gt.0) p0th = p0thr

      return

   99 continue   !  If we got here, then the May 2008 variant of std hdr
                 !  failed and we may have an older input file.

      call parse_std_hdr_2006(hdr,rdcode)  ! try the original header format

      return
      end
c-----------------------------------------------------------------------
      subroutine parse_std_hdr_2006(hdr,rlcode)
      include 'SIZE'
      include 'INPUT'
      include 'RESTART'

      character*132 hdr
      character*1 rlcode(20)

c                4  7  10  13   23    33    53    62     68     74
      read(hdr,1) wdsizr,nxr,nyr,nzr,nelr,nelgr,timer,istpr
     $         , ifiler,nfiler
     $         , (rlcode(k),k=1,20)                   ! 74+20=94
    1 format(4x,i2,3i3,2i10,e20.13,i9,2i6,20a1)

      if (nid.eq.0) write(6,*) 'WARNING: reading depreacted header!'

c     Assign read conditions, according to rdcode
c     NOTE: In the old hdr format: what you see in file is what you get.
c      ifgtim  = .true.  ! always get time
      ifgetxr = .false.
      ifgetur = .false.
      ifgetpr = .false.
      ifgettr = .false.
      do k=1,npscal
         ifgtpsr(k) = .false.
      enddo

      if (rlcode(1).eq.'X') ifgetxr = .true.
      if (rlcode(2).eq.'U') ifgetur = .true.
      if (rlcode(3).eq.'P') ifgetpr = .true.
      if (rlcode(4).eq.'T') ifgettr = .true.
      do k=1,npscal
         if (rlcode(4+k).ne.' ') ifgtpsr(k) = .true.
      enddo


      return
      end
c-----------------------------------------------------------------------
      subroutine mfi(fname_in,ifile)
c
c     (1) Open restart file(s)
c     (2) Check previous spatial discretization 
c     (3) Map (K1,N1) => (K2,N2) if necessary
c
c     nfiles > 1 has several implications:
c
c     i.   For std. run, data is taken from last file in list, unless
c          explicitly specified in argument list of filename
c
c     ii.  For MHD and perturbation cases, 1st file is for U,P,T;
c          subsequent files are for B-field or perturbation fields
c
c
      include 'SIZE'
      include 'TOTAL'
      include 'RESTART'
      character*132  hdr
      character*132  fname_in

      character*132  fname
      character*1    fnam1(132)
      equivalence   (fnam1,fname)

      character*1    frontc

      parameter (lwk = 7*lx1*ly1*lz1*lelt)
      common /scrns/ wk(lwk)
      common /scrcg/ pm1(lx1*ly1*lz1,lelv)
      integer e

      integer*8 offs0,offs,nbyte,stride,strideB,nxyzr8

      tiostart=dnekclock()

      ! add full path if required
      call blank(fname,132)
      call chcopy(frontc, fname_in, 1)
      if (frontc .ne. '/') then
        lenp = ltrunc(path,132)
        lenf = ltrunc(fname_in,132)
        call chcopy(fnam1(1),path,lenp)
        call chcopy(fnam1(lenp+1),fname_in,lenf)
      else
        lenf = ltrunc(fname_in,132)
        call chcopy(fnam1(1),fname_in,lenf)     
      endif

      call mfi_prepare(fname)       ! determine reader nodes +
                                    ! read hdr + element mapping 

      offs0   = iHeadersize + 4 + isize*nelgr
      nxyzr8  = nxr*nyr*nzr
      strideB = nelBr* nxyzr8*wdsizr
      stride  = nelgr* nxyzr8*wdsizr

      iofldsr = 0
      if (ifgetxr) then      ! if available
         offs = offs0 + ldim*strideB
         call byte_set_view(offs,ifh_mbyte)
         if (ifgetx) then
c            if(nid.eq.0) write(6,*) 'Reading mesh'
            call mfi_getv(xm1,ym1,zm1,wk,lwk,.false.)
         else                ! skip the data
            call mfi_getv(xm1,ym1,zm1,wk,lwk,.true.)
         endif
         iofldsr = iofldsr + ldim
      endif

      if (ifgetur) then
         offs = offs0 + iofldsr*stride + ldim*strideB
         call byte_set_view(offs,ifh_mbyte)
         if (ifgetu) then
            if (ifmhd.and.ifile.eq.2) then
c               if(nid.eq.0) write(6,*) 'Reading B field'
               call mfi_getv(bx,by,bz,wk,lwk,.false.)
            else
c               if(nid.eq.0) write(6,*) 'Reading velocity field'
               call mfi_getv(vx,vy,vz,wk,lwk,.false.)
            endif
         else
            call mfi_getv(vx,vy,vz,wk,lwk,.true.)
         endif
         iofldsr = iofldsr + ldim
      endif

      if (ifgetpr) then
         offs = offs0 + iofldsr*stride + strideB
         call byte_set_view(offs,ifh_mbyte)
         if (ifgetp) then
c           if(nid.eq.0) write(6,*) 'Reading pressure field'
            call mfi_gets(pm1,wk,lwk,.false.)
         else
            call mfi_gets(pm1,wk,lwk,.true.)
         endif
         iofldsr = iofldsr + 1
      endif

      if (ifgettr) then
         offs = offs0 + iofldsr*stride + strideB
         call byte_set_view(offs,ifh_mbyte)
         if (ifgett) then
c            if(nid.eq.0) write(6,*) 'Reading temperature field'
            call mfi_gets(t,wk,lwk,.false.)
         else
            call mfi_gets(t,wk,lwk,.true.)
         endif
         iofldsr = iofldsr + 1
      endif

      ierr = 0
      do k=1,ldimt-1
         if (ifgtpsr(k)) then
            offs = offs0 + iofldsr*stride + strideB
            call byte_set_view(offs,ifh_mbyte)
            if (ifgtps(k)) then
c               if(nid.eq.0) write(6,'(A,I2,A)') ' Reading ps',k,' field'
               call mfi_gets(t(1,1,1,1,k+1),wk,lwk,.false.)
            else
               call mfi_gets(t(1,1,1,1,k+1),wk,lwk,.true.)
            endif
            iofldsr = iofldsr + 1
         endif
      enddo
      nbyte = 0
      if(nid.eq.pid0r) nbyte = iofldsr*nelr*wdsizr*nxr*nyr*nzr

      if (ifgtim) time = timer

      if(ifmpiio) then
        if(nid.eq.pid0r) call byte_close_mpi(ifh_mbyte,ierr)
      else
        if(nid.eq.pid0r) call byte_close(ierr)
      endif
      call err_chk(ierr,'Error closing restart file, in mfi.$')
      tio = dnekclock()-tiostart

      dnbyte = nbyte
      nbyte = glsum(dnbyte,1)
      nbyte = nbyte + iHeaderSize + 4 + isize*nelgr

      if (tio.eq.0) tio=1
      if (nio.eq.0) write(6,7) istep,time,
     &             nbyte/tio/1024/1024/10,
     &             nfiler
    7 format(/,i9,1pe12.4,' done :: Read checkpoint data',/,
     &       30X,'avg data-throughput = ',f7.1,'MBps',/,
     &       30X,'io-nodes = ',i5,/)


      if (ifaxis) call axis_interp_ic(pm1)      ! Interpolate to axi mesh
      if (ifgetp) call map_pm1_to_pr(pm1,ifile) ! Interpolate pressure

      return
      end
c-----------------------------------------------------------------------
      subroutine addfid(fname,fid)
      include 'SIZE'
      include 'TSTEP'
      include 'INPUT'
      include 'RESTART'


      character*1 fname(132)
      integer fid

      character*8  eight,fmt,s8
      save         eight
      data         eight / "????????" /

      do ipass=1,2      ! 2nd pass, in case 1 file/directory
         do k=8,1,-1
            i1 = indx1(fname,eight,k)
            if (i1.ne.0) then ! found k??? string
               write(fmt,1) k,k
    1          format('(i',i1,'.',i1,')')
               write(s8,fmt) fid
               call chcopy(fname(i1),s8,k)
               goto 10
            endif
         enddo
   10    continue
      enddo
      
      return
      end
c-----------------------------------------------------------------------
      subroutine mfi_prepare(hname)  ! determine which nodes are readers
      character*132 hname

      include 'SIZE'
      include 'PARALLEL'
      include 'RESTART'
      include 'INPUT'

      integer stride
      character*132 hdr, hname_
      logical if_byte_swap_test
      real*4 bytetest

      integer*8 offs0,offs

      ierr = 0
      ! rank0 (i/o master) will do a pre-read to get some infos 
      ! we need to have in advance
      if (nid.eq.0) then
         call chcopy(hname_,hname,132)
         call addfid(hname_,0)
         call byte_open(hname_,ierr)

         if(ierr.ne.0) goto 101
         call blank     (hdr,iHeaderSize)
         call byte_read (hdr,iHeaderSize/4,ierr)
         if(ierr.ne.0) goto 101
         call byte_read (bytetest,1,ierr)
         if(ierr.ne.0) goto 101
         if_byte_sw = if_byte_swap_test(bytetest,ierr) ! determine endianess
         if(ierr.ne.0) goto 101
         call byte_close(ierr)
      endif

 101  continue
      call err_chk(ierr,'Error reading restart header in mfi_prepare$')

      call bcast(if_byte_sw,lsize) 
      call bcast(hdr,iHeaderSize)  
      call mfi_parse_hdr(hdr,ierr)

      ifmpiio = .false.
      if (nfiler.eq.1 .and. abs(param(67)).eq.6) ifmpiio = .true.
#ifdef NOMPIIO
      ifmpiio = .false.
#endif

      if(.not.ifmpiio) then

        stride = np / nfiler
        if (stride.lt.1) then
           write(6,*) nfiler,np,'  TOO MANY FILES, mfi_prepare'
           call exitt
        endif
 
        if (mod(nid,stride).eq.0) then ! i/o clients
           pid0r = nid
           pid1r = nid + stride
           fid0r = nid / stride
           call blank(hdr,iHeaderSize)

           call addfid(hname,fid0r)
           if(nid.eq.pid0r) write(6,*) '      FILE:',hname
           call byte_open(hname,ierr)

           if(ierr.ne.0) goto 102
           call byte_read (hdr, iHeaderSize/4,ierr)  
           if(ierr.ne.0) goto 102
           call byte_read (bytetest,1,ierr) 
           if(ierr.ne.0) goto 102
           call mfi_parse_hdr (hdr,ierr)    ! replace hdr with correct one 
           if (nelr.gt.lelr) then
              write(6,*) 'ERROR: increase lelr in SIZE to ', nelr 
              call exitt
           endif
           call byte_read (er,nelr,ierr)    ! get element mapping
           if(if_byte_sw) call byte_reverse(er,nelr,ierr)
        else
           pid0r = 0
           pid1r = 0
           fid0r = 0
        endif

      else

        pid0r  = nid
        pid1r  = nid
        offs0  = iHeaderSize + 4
        nfiler = np
 
        ! number of elements to read 
        nelr = nelgr/np
        do i = 0,mod(nelgr,np)-1
           if(i.eq.nid) nelr = nelr + 1
        enddo
        nelBr = igl_running_sum(nelr) - nelr 
        offs = offs0 + nelBr*isize

        call addfid(hname,fid0r)
        if(nio.eq.0) write(6,*) '      FILE:',hname
        call byte_open_mpi(hname,ifh_mbyte,.true.,ierr)

        if(ierr.ne.0) goto 102
        call byte_set_view(offs,ifh_mbyte)
        if (nelr.gt.lelr) then
           write(6,*) 'ERROR: increase lelr in SIZE to ', nelr 
           call exitt
        endif
        call byte_read_mpi(er,nelr,-1,ifh_mbyte,ierr)
        if(ierr.ne.0) goto 102
        if(if_byte_sw) call byte_reverse(er,nelr,ierr)

      endif

 102  continue
      call err_chk(ierr,'Error reading header/element map.$')

      return
      end
c-----------------------------------------------------------------------
      subroutine axis_interp_ic(pm1)

      include 'SIZE'
      include 'TOTAL'
      include 'RESTART'

      real pm1(lx1,ly1,lz1,lelv)

      common /ctmp0/ axism1 (lx1,ly1)
      integer e

      if (.not.ifaxis) return

      do e=1,nelv
         if (ifrzer(e)) then
           if (ifgetx) then
             call mxm   (xm1(1,1,1,e),lx1,iatlj1,ly1,axism1,ly1)
             call copy  (xm1(1,1,1,e),axism1,lx1*ly1)
             call mxm   (ym1(1,1,1,e),lx1,iatlj1,ly1,axism1,ly1)
             call copy  (ym1(1,1,1,e),axism1,lx1*ly1)
           endif
           if (ifgetu) then
             call mxm    (vx(1,1,1,e),lx1,iatlj1,ly1,axism1,ly1)
             call copy   (vx(1,1,1,e),axism1,lx1*ly1)
             call mxm    (vy(1,1,1,e),lx1,iatlj1,ly1,axism1,ly1)
             call copy   (vy(1,1,1,e),axism1,lx1*ly1)
           endif
           if (ifgetw) then
             call mxm    (vz(1,1,1,e),lx1,iatlj1,ly1,axism1,ly1)
             call copy   (vz(1,1,1,e),axism1,lx1*ly1)
           endif
           if (ifgetp) then
             call mxm    (pm1(1,1,1,e),lx1,iatlj1,ly1,axism1,ly1)
             call copy   (pm1(1,1,1,e),axism1,lx1*ly1)
           endif
           if (ifgett) then
             call mxm  (t (1,1,1,e,1),lx1,iatlj1,ly1,axism1,ly1)
             call copy (t (1,1,1,e,1),axism1,lx1*ly1)
           endif
           do ips=1,npscal
            is1 = ips + 1
            if (ifgtps(ips)) then
             call mxm (t(1,1,1,e,is1),lx1,iatlj1,ly1,axism1,ly1)
             call copy(t(1,1,1,e,is1),axism1,lx1*ly1)
            endif
           enddo
         endif
      enddo
   
      return
      end
c-----------------------------------------------------------------------
      subroutine map_pm1_to_pr(pm1,ifile)

      include 'SIZE'
      include 'TOTAL'
      include 'RESTART'

      real pm1(lx1*ly1*lz1,lelv)
      integer e

      nxyz2 = lx2*ly2*lz2

      if (ifmhd.and.ifile.eq.2) then
         do e=1,nelv
            if (if_full_pres) then
               call copy  (pm(1,1,1,e),pm1(1,e),nxyz2)
            else
               call map12 (pm(1,1,1,e),pm1(1,e),e)
            endif
         enddo
      elseif (ifsplit) then
         call copy (pr,pm1,lx1*ly1*lz1*nelv)
      else
         do e=1,nelv
            if (if_full_pres) then
               call copy  (pr(1,1,1,e),pm1(1,e),nxyz2)
            else
               call map12 (pr(1,1,1,e),pm1(1,e),e)
            endif
         enddo
      endif
   
      return
      end
c-----------------------------------------------------------------------
      subroutine full_restart(fnames,n_restart)
      include 'SIZE'
      include 'TOTAL'

      character *(*) fnames(*)

      ifile = istep+1  ! istep=0,1,...

      if (ifile.le.n_restart) then
         p67 = param(67)
         param(67) = 6.00
         call chcopy (initc,fnames(ifile),80)
         call bcast  (initc,80)
         call restart(1)
         call setprop
         param(67)=p67
      endif
   
      return
      end
c-----------------------------------------------------------------------
      subroutine projfld_c0()

      include 'SIZE'
      include 'TOTAL'

      nxyz1 = lx1*ly1*lz1
      ntott = nelt*nxyz1
      ntotv = nelv*nxyz1

      if(nid.eq.0 .and. loglevel.gt.2) write(6,*) 'projfld_c0'

c     if (ifflow.and..not.ifdg)  then  ! Current dg is for scalars only
      if (ifflow)  then
         ifield = 1
         call opdssum(vx,vy,vz)
         call opcolv (vx,vy,vz,vmult)
         if (ifsplit) call dsavg(pr)  ! continuous pressure
         if (ifvcor)  call ortho(pr)  ! remove any mean
      endif

c     if (ifmhd.and..not.ifdg) then   ! Current dg is for scalars only
      if (ifmhd) then
         ifield = ifldmhd
         call opdssum(bx,by,bz)
         call opcolv (bx,by,bz,vmult)
      endif

      if (ifheat.and..not.ifdg) then  ! Don't project if using DG
         ifield = 2
         call dssum(t ,lx1,ly1,lz1)
         call col2 (t ,tmult,ntott)
         do ifield=3,nfield
            if(gsh_fld(ifield).ge.0) then
              call dssum(t(1,1,1,1,ifield-1),lx1,ly1,lz1)
              if(iftmsh(ifield)) then
                call col2 (t(1,1,1,1,ifield-1),tmult,ntott)
              else
                call col2 (t(1,1,1,1,ifield-1),vmult,ntotv)
              endif
            endif
         enddo
      endif

c     if (ifpert.and..not.ifdg) then ! Still not DG
      if (ifpert) then
         do jp=1,npert
            ifield = 1
            call opdssum(vxp(1,jp),vyp(1,jp),vzp(1,jp))
            call opcolv (vxp(1,jp),vyp(1,jp),vzp(1,jp),vmult)

            if (.not.ifdg) then
               do ifield=2,nfield
                  call dssum(tp(1,ifield-1,jp),lx1,ly1,lz1)
                  if(iftmsh(ifield)) then
                     call col2 (tp(1,ifield-1,jp),tmult,ntott)
                  else
                     call col2 (tp(1,ifield-1,jp),vmult,ntotv)
                  endif
               enddo
            endif
         enddo
      endif
      jp = 0

      return
      end

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!One dimension array computation with a vectorization directive. No data race pairs.

program DRB070_simd1_orig_no
    use omp_lib
    implicit none

    integer :: len, i
    integer, dimension(:), allocatable :: a, b, c
    len = 100
    allocate (a(len))
    allocate (b(len))
    allocate (c(len))

    !$omp simd
    do i = 1, len
        a(i) = b(i) + c(i)
    end do
    !$omp end simd

    deallocate(a,b,c)
end program

c-----------------------------------------------------------------------
      subroutine lpm_comm_setup
      include 'SIZE'
      include 'TOTAL'
      include 'CTIMER'
#     include "LPM"

      common /nekmpi/ mid,mp,nekcomm,nekgroup,nekreal

      nmsh = lpm_rparam(3)

      call interp_setup(i_fp_hndl,0.0,nmsh,nelt)
      call fgslib_crystal_setup(i_cr_hndl,nekcomm,np)

      return
      end
c-----------------------------------------------------------------------
      subroutine lpm_comm_findpts
      include 'SIZE'
      include 'TOTAL'
#     include "LPM"

      common /intp_h/ ih_intp(2,1)

      ih_intp2 = ih_intp(2,i_fp_hndl)

      ix = 1
      iy = 2
      iz = 3

      call fgslib_findpts(ih_intp2           !   call fgslib_findpts( ihndl,
     $        , lpm_iprop (1 ,1),LPM_LIP        !   $        rcode,1,
     $        , lpm_iprop (3 ,1),LPM_LIP        !   &        proc,1,
     $        , lpm_iprop (2 ,1),LPM_LIP        !   &        elid,1,
     $        , lpm_rprop2(1 ,1),LPM_LRP2       !   &        rst,ndim,
     $        , lpm_rprop2(4 ,1),LPM_LRP2       !   &        dist,1,
     $        , lpm_y     (ix,1),LPM_LRS        !   &        pts(    1),1,
     $        , lpm_y     (iy,1),LPM_LRS        !   &        pts(  n+1),1,
     $        , lpm_y     (iz,1),LPM_LRS ,LPM_NPART) !   &   pts(2*n+1),1,n)

      do i=1,lpm_npart
         lpm_iprop(4,i) = lpm_iprop(3,i)
      enddo

      ! instead get which bin it is in
      do i=1,lpm_npart
         ! check if particles are greater or less than binb bounds....
         ! add below....

         ii    = floor((lpm_y(ix,i)-lpm_binb(1))/lpm_rdxgp) 
         jj    = floor((lpm_y(iy,i)-lpm_binb(3))/lpm_rdygp) 
         kk    = floor((lpm_y(iz,i)-lpm_binb(5))/lpm_rdzgp) 
         if (.not. if3d) kk = 0
         if (ii .eq. lpm_ndxgp) ii = lpm_ndxgp - 1
         if (jj .eq. lpm_ndygp) jj = lpm_ndygp - 1
         if (kk .eq. lpm_ndzgp) kk = lpm_ndzgp - 1
         ndum  = ii + lpm_ndxgp*jj + lpm_ndxgp*lpm_ndygp*kk
         nrank = modulo(ndum, np)

         lpm_iprop(8,i)  = ii
         lpm_iprop(9,i)  = jj
         lpm_iprop(10,i) = kk
         lpm_iprop(11,i) = ndum

         lpm_iprop(4,i)  = nrank ! where particle is actually moved
      enddo

      n = nid_glcount(lpm_iprop(4,1),LPM_LIP,lpm_npart)
      ierr = 0
      if (n.gt.LPM_LPART) ierr = 1 
      ierr = iglsum(ierr,1)
      if (ierr.gt.0) then
         nmax = iglmax(n,1)
         call exitti('LPM_LPART too small, require >$',nmax)
      endif

      return
      end
c-----------------------------------------------------------------------
      integer function nid_glcount(a,is,n)
c
c     returns global nid count in distributed integer array 
c
      include 'mpif.h'
      include 'SIZE'
      include 'PARALLEL'

      integer a(*)

      common /nekmpi/ nid_,np_,nekcomm,nekgroup,nekreal

      integer   disp_unit
      integer*8 wsize, tdisp
      data      tdisp /0/

      integer win, shared_counter
      save    win, shared_counter

      integer one
      parameter (one = 1)

      integer icalld
      data    icalld /0/
      save    icalld

#ifdef MPI
      if (icalld.eq.0) then
         disp_unit = ISIZE
         wsize     = disp_unit
         call MPI_win_create(shared_counter,
     $                       wsize,
     $                       disp_unit,
     $                       MPI_INFO_NULL,
     $                       nekcomm,win,ierr)
         icalld = 1
      endif

      shared_counter = 0

      call MPI_win_fence(MPI_MODE_NOPRECEDE,win,ierr)
      do i = 1,n
         call MPI_accumulate(one,1,MPI_INTEGER,a((i-1)*is+1),
     $                       tdisp,1,MPI_INTEGER,MPI_SUM,win,ierr)
      enddo
      call MPI_win_fence(MPI_MODE_NOSUCCEED,win,ierr)

      nid_glcount = shared_counter 
#else
      nid_glcount = n
#endif
 
      return
      end
c-----------------------------------------------------------------------
      subroutine lpm_comm_crystal
      include 'SIZE'
      include 'TOTAL'
      include 'CTIMER'
#     include "LPM"

      logical partl    
      integer lpm_ipmap1(1,LPM_LPART)
     >       ,lpm_ipmap2(1,LPM_LPART)
     >       ,lpm_ipmap3(1,LPM_LPART)
     >       ,lpm_ipmap4(1,LPM_LPART)

      parameter(lrf = LPM_LRS*4 + LPM_LRP + LPM_LRP2)
      real rwork(lrf,LPM_LPART)

      do i=1,lpm_npart
         ic = 1
         call copy(rwork(ic,i),lpm_y(1,i),LPM_LRS)
         ic = ic + LPM_LRS
         call copy(rwork(ic,i),lpm_y1((i-1)*LPM_LRS+1),LPM_LRS)
         ic = ic + LPM_LRS
         call copy(rwork(ic,i),lpm_ydot(1,i),LPM_LRS)
         ic = ic + LPM_LRS
         call copy(rwork(ic,i),lpm_ydotc(1,i),LPM_LRS)
         ic = ic + LPM_LRS
         call copy(rwork(ic,i),lpm_rprop(1,i),LPM_LRP)
         ic = ic + LPM_LRP
         call copy(rwork(ic,i),lpm_rprop2(1,i),LPM_LRP2)
      enddo

      j0 = 4 ! proc key
      call fgslib_crystal_tuple_transfer(i_cr_hndl,lpm_npart ,LPM_LPART
     $           ,lpm_iprop ,LPM_LIP,partl,0,rwork,lrf ,j0)

      do i=1,lpm_npart
         ic = 1
         call copy(lpm_y(1,i),rwork(ic,i),LPM_LRS)
         ic = ic + LPM_LRS
         call copy(lpm_y1((i-1)*LPM_LRS+1),rwork(ic,i),LPM_LRS)
         ic = ic + LPM_LRS
         call copy(lpm_ydot(1,i),rwork(ic,i),LPM_LRS)
         ic = ic + LPM_LRS
         call copy(lpm_ydotc(1,i),rwork(ic,i),LPM_LRS)
         ic = ic + LPM_LRS
         call copy(lpm_rprop(1,i),rwork(ic,i),LPM_LRP)
         ic = ic + LPM_LRP
         call copy(lpm_rprop2(1,i),rwork(ic,i),LPM_LRP2)
      enddo
        
      return
      end
c-----------------------------------------------------------------------
      subroutine lpm_comm_bin_setup
      include 'SIZE'
      include 'TOTAL'
#     include "LPM"

      integer  el_face_num(18),el_edge_num(36),el_corner_num(24),
     >                            nfacegp, nedgegp, ncornergp
      integer  ifac(3), icount(3)
      real     d2new(3)
      logical  partl

      real                      lpm_xerange(2,3,lpm_lbmax)
      common /lpm_elementrange/ lpm_xerange

c     face, edge, and corner number, x,y,z are all inline, so stride=3
      el_face_num = (/ -1,0,0, 1,0,0, 0,-1,0, 0,1,0, 0,0,-1, 0,0,1 /)
      el_edge_num = (/ -1,-1,0 , 1,-1,0, 1,1,0 , -1,1,0 ,
     >                  0,-1,-1, 1,0,-1, 0,1,-1, -1,0,-1,
     >                  0,-1,1 , 1,0,1 , 0,1,1 , -1,0,1  /)
      el_corner_num = (/
     >                 -1,-1,-1, 1,-1,-1, 1,1,-1, -1,1,-1,
     >                 -1,-1,1,  1,-1,1,  1,1,1,  -1,1,1 /)

      nfacegp   = 4  ! number of faces
      nedgegp   = 4  ! number of edges
      ncornergp = 0  ! number of corners

      if (if3d) then
         nfacegp   = 6  ! number of faces
         nedgegp   = 12 ! number of edges
         ncornergp = 8  ! number of corners
      endif

      ix = 1
      iy = 2
      iz = 3

      iperiodicx = int(lpm_rparam(8))
      iperiodicy = int(lpm_rparam(9))
      iperiodicz = int(lpm_rparam(10))

      ! compute binb
      xmin = 1E8
      ymin = 1E8
      zmin = 1E8
      xmax = 0.
      ymax = 0.
      zmax = 0.
      do i=1,lpm_npart
         rduml = lpm_y(ix,i) - lpm_d2chk(2)
         rdumr = lpm_y(ix,i) + lpm_d2chk(2)
         if (rduml .lt. xmin) xmin = rduml
         if (rdumr .gt. xmax) xmax = rdumr

         rduml = lpm_y(iy,i) - lpm_d2chk(2)
         rdumr = lpm_y(iy,i) + lpm_d2chk(2)
         if (rduml .lt. ymin) ymin = rduml
         if (rdumr .gt. ymax) ymax = rdumr

         rduml = lpm_y(iz,i) - lpm_d2chk(2)
         rdumr = lpm_y(iz,i) + lpm_d2chk(2)
         if (rduml .lt. zmin) zmin = rduml
         if (rdumr .gt. zmax) zmax = rdumr
      enddo

      lpm_binb(1) = glmin(xmin,1)
      lpm_binb(2) = glmax(xmax,1)
      lpm_binb(3) = glmin(ymin,1)
      lpm_binb(4) = glmax(ymax,1)
      lpm_binb(5) = 0.0
      lpm_binb(6) = 0.0
      if(if3d) lpm_binb(5) = glmin(zmin,1)
      if(if3d) lpm_binb(6) = glmax(zmax,1)

      lpm_binb(1) = max(lpm_binb(1),lpm_xdrange(1,1))
      lpm_binb(2) = min(lpm_binb(2),lpm_xdrange(2,1))
      lpm_binb(3) = max(lpm_binb(3),lpm_xdrange(1,2))
      lpm_binb(4) = min(lpm_binb(4),lpm_xdrange(2,2))
      if(if3d)lpm_binb(5) = max(lpm_binb(5),lpm_xdrange(1,3))
      if(if3d)lpm_binb(6) = min(lpm_binb(6),lpm_xdrange(2,3))

      if (iperiodicx .eq. 1) then
         lpm_binb(1) = lpm_xdrange(1,1)
         lpm_binb(2) = lpm_xdrange(2,1)
      endif
      if (iperiodicy .eq. 1) then
         lpm_binb(3) = lpm_xdrange(1,2)
         lpm_binb(4) = lpm_xdrange(2,2)
      endif
      if (iperiodicz .eq. 1 .and. if3d) then
         lpm_binb(5) = lpm_xdrange(1,3)
         lpm_binb(6) = lpm_xdrange(2,3)
      endif

      ifac(1) = 1
      ifac(2) = 1
      ifac(3) = 1
      icount(1) = 0
      icount(2) = 0
      icount(3) = 0
      d2new(1) = lpm_d2chk(2)
      d2new(2) = lpm_d2chk(2)
      d2new(3) = lpm_d2chk(2)

      lpm_ndxgp = floor( (lpm_binb(2) - lpm_binb(1))/d2new(1))
      lpm_ndygp = floor( (lpm_binb(4) - lpm_binb(3))/d2new(2))
      lpm_ndzgp = 1
      if (if3d) lpm_ndzgp = floor( (lpm_binb(6) - lpm_binb(5))/d2new(3))

c     if (lpm_ndxgp*lpm_ndygp*lpm_ndzgp .gt. np) then
      if (lpm_ndxgp*lpm_ndygp*lpm_ndzgp .gt. np .or. 
     >    int(lpm_rparam(4)) .eq. 1) then
         nmax = 1000
         d2chk_save = lpm_d2chk(2)
         
         do i=1,nmax
         do j=0,ndim-1
            iflg = 0
            ifac(j+1) = 1 + i
            d2new(j+1) = (lpm_binb(2+2*j) - lpm_binb(1+2*j))/ifac(j+1)
            nbb = ifac(1)*ifac(2)*ifac(3)
            if (int(lpm_rparam(4)) .eq. 0) then
               if(d2new(j+1) .lt. d2chk_save .or. nbb .gt. np) iflg = 1
            elseif (int(lpm_rparam(4)) .eq. 1) then
               if( nbb .gt. np ) iflg = 1
            endif
            if (iflg .eq. 1) then
               icount(j+1) = icount(j+1) + 1
               ifac(j+1) = ifac(j+1) - icount(j+1)
               d2new(j+1) = (lpm_binb(2+2*j) -lpm_binb(1+2*j))/ifac(j+1)
            endif
         enddo
            if (icount(1) .gt. 0) then
            if (icount(2) .gt. 0) then
            if (icount(3) .gt. 0) then
               exit
            endif
            endif
            endif
         enddo
      endif

! -------------------------------------------------------
c SETUP 3D BACKGROUND GRID PARAMETERS FOR GHOST PARTICLES
! -------------------------------------------------------
      ! how many spacings in each direction
      lpm_ndxgp = floor( (lpm_binb(2) - lpm_binb(1))/d2new(1))
      lpm_ndygp = floor( (lpm_binb(4) - lpm_binb(3))/d2new(2))
      lpm_ndzgp = 1
      if (if3d) lpm_ndzgp = floor( (lpm_binb(6) - lpm_binb(5))/d2new(3))

      ! grid spacing for that many spacings
      lpm_rdxgp = (lpm_binb(2) - lpm_binb(1))/real(lpm_ndxgp)
      lpm_rdygp = (lpm_binb(4) - lpm_binb(3))/real(lpm_ndygp)
      lpm_rdzgp = 1.
      if (if3d) lpm_rdzgp = (lpm_binb(6) - lpm_binb(5))/real(lpm_ndzgp)

      ninc = 2
      rxlbin = lpm_binb(1)
      rxrbin = lpm_binb(2)
      rylbin = lpm_binb(3)
      ryrbin = lpm_binb(4)
      rzlbin = lpm_binb(5)
      rzrbin = lpm_binb(6)
      if (iperiodicx .ne. 1) then
         rxlbin = rxlbin - ninc/2*lpm_rdxgp
         rxrbin = rxrbin + ninc/2*lpm_rdxgp
         rxlbin = max(rxlbin,lpm_xdrange(1,1))
         rxrbin = min(rxrbin,lpm_xdrange(2,1))
      endif
      if (iperiodicy .ne. 1) then
         rylbin = rylbin - ninc/2*lpm_rdygp
         ryrbin = ryrbin + ninc/2*lpm_rdygp
         rylbin = max(rylbin,lpm_xdrange(1,2))
         ryrbin = min(ryrbin,lpm_xdrange(2,2))
      endif
      if (iperiodicz .ne. 1) then
      if (if3d) then
         rzlbin = rzlbin - ninc/2*lpm_rdzgp
         rzrbin = rzrbin + ninc/2*lpm_rdzgp
         rzlbin = max(rzlbin,lpm_xdrange(1,3))
         rzrbin = min(rzrbin,lpm_xdrange(2,3))
      endif
      endif

      nbin_now = lpm_ndxgp*lpm_ndygp*lpm_ndzgp

      if (int(lpm_rparam(4)) .eq. 1) return ! only for projection

! see which bins are in which elements
      lpm_neltb = 0
      do ie=1,nelt
      do k=1,nz1
      do j=1,ny1
      do i=1,nx1
         rxval = xm1(i,j,k,ie) 
         ryval = ym1(i,j,k,ie) 
         rzval = 0.
         if(if3d) rzval = zm1(i,j,k,ie)

         if (rxval .gt. lpm_binb(2)) goto 1233
         if (rxval .lt. lpm_binb(1)) goto 1233
         if (ryval .gt. lpm_binb(4)) goto 1233
         if (ryval .lt. lpm_binb(3)) goto 1233
         if (if3d .and. rzval .gt. lpm_binb(6)) goto 1233
         if (if3d .and. rzval .lt. lpm_binb(5)) goto 1233

         ii    = floor((rxval-lpm_binb(1))/lpm_rdxgp) 
         jj    = floor((ryval-lpm_binb(3))/lpm_rdygp) 
         kk    = floor((rzval-lpm_binb(5))/lpm_rdzgp) 
         if (.not. if3d) kk = 0
         if (ii .eq. lpm_ndxgp) ii = lpm_ndxgp - 1
         if (jj .eq. lpm_ndygp) jj = lpm_ndygp - 1
         if (kk .eq. lpm_ndzgp) kk = lpm_ndzgp - 1
         ndum  = ii + lpm_ndxgp*jj + lpm_ndxgp*lpm_ndygp*kk
         nrank = modulo(ndum,np)

         lpm_neltb = lpm_neltb + 1
         if(lpm_neltb .gt. lpm_lbmax) then
           write(6,*) 'increase lbmax',nid,lpm_neltb,lpm_lbmax
           call exitt
         endif

         lpm_er_map(1,lpm_neltb) = ie
         lpm_er_map(2,lpm_neltb) = nid
         lpm_er_map(3,lpm_neltb) = ndum
         lpm_er_map(4,lpm_neltb) = nrank
         lpm_er_map(5,lpm_neltb) = nrank
         lpm_er_map(6,lpm_neltb) = nrank

         if (lpm_neltb .gt. 1) then
         do il=1,lpm_neltb-1
            if (lpm_er_map(1,il) .eq. ie) then
            if (lpm_er_map(4,il) .eq. nrank) then
               lpm_neltb = lpm_neltb - 1
               goto 1233
            endif
            endif
         enddo
         endif
 1233 continue
      enddo
      enddo
      enddo
      enddo

      nxyz = lx1*ly1*lz1
      do ie=1,lpm_neltb
         iee = lpm_er_map(1,ie)
         call copy(lpm_xm1b(1,1,1,1,ie), xm1(1,1,1,iee),nxyz)
         call copy(lpm_xm1b(1,1,1,2,ie), ym1(1,1,1,iee),nxyz)
         call copy(lpm_xm1b(1,1,1,3,ie), zm1(1,1,1,iee),nxyz)
      enddo

      lpm_neltbb = lpm_neltb

      do ie=1,lpm_neltbb
         call icopy(lpm_er_maps(1,ie),lpm_er_map(1,ie),LPM_LRMAX)
      enddo


      nl   = 0
      nii  = LPM_LRMAX
      njj  = 6
      nrr  = nxyz*3
      nkey = 3
      call fgslib_crystal_tuple_transfer(i_cr_hndl,lpm_neltb,lpm_lbmax
     >                  , lpm_er_map,nii,partl,nl,lpm_xm1b,nrr,njj)
      call fgslib_crystal_tuple_sort    (i_cr_hndl,lpm_neltb
     $              , lpm_er_map,nii,partl,nl,lpm_xm1b,nrr,nkey,1)


      do ie=1,lpm_neltb
      do k=1,nz1
      do j=1,ny1
      do i=1,nx1
         rxval = lpm_xm1b(i,j,k,1,ie)
         ryval = lpm_xm1b(i,j,k,2,ie)
         rzval = 0.
         if(if3d) rzval = lpm_xm1b(i,j,k,3,ie)
         
         ii    = floor((rxval-lpm_binb(1))/lpm_rdxgp) 
         jj    = floor((ryval-lpm_binb(3))/lpm_rdygp) 
         kk    = floor((rzval-lpm_binb(5))/lpm_rdzgp) 
         if (.not. if3d) kk = 0
         if (ii .eq. lpm_ndxgp) ii = lpm_ndxgp - 1
         if (jj .eq. lpm_ndygp) jj = lpm_ndygp - 1
         if (kk .eq. lpm_ndzgp) kk = lpm_ndzgp - 1
         ndum  = ii + lpm_ndxgp*jj + lpm_ndxgp*lpm_ndygp*kk

         lpm_modgp(i,j,k,ie,1) = ii
         lpm_modgp(i,j,k,ie,2) = jj
         lpm_modgp(i,j,k,ie,3) = kk
         lpm_modgp(i,j,k,ie,4) = ndum
   
      enddo
      enddo
      enddo
      enddo

      do ie=1,lpm_neltb
         lpm_xerange(1,1,ie) = vlmin(lpm_xm1b(1,1,1,1,ie),nxyz)
         lpm_xerange(2,1,ie) = vlmax(lpm_xm1b(1,1,1,1,ie),nxyz)
         lpm_xerange(1,2,ie) = vlmin(lpm_xm1b(1,1,1,2,ie),nxyz)
         lpm_xerange(2,2,ie) = vlmax(lpm_xm1b(1,1,1,2,ie),nxyz)
         lpm_xerange(1,3,ie) = vlmin(lpm_xm1b(1,1,1,3,ie),nxyz)
         lpm_xerange(2,3,ie) = vlmax(lpm_xm1b(1,1,1,3,ie),nxyz)

         ilow  = floor((lpm_xerange(1,1,ie) - lpm_binb(1))/lpm_rdxgp)
         ihigh = floor((lpm_xerange(2,1,ie) - lpm_binb(1))/lpm_rdxgp)
         jlow  = floor((lpm_xerange(1,2,ie) - lpm_binb(3))/lpm_rdygp)
         jhigh = floor((lpm_xerange(2,2,ie) - lpm_binb(3))/lpm_rdygp)
         klow  = floor((lpm_xerange(1,3,ie) - lpm_binb(5))/lpm_rdzgp)
         khigh = floor((lpm_xerange(2,3,ie) - lpm_binb(5))/lpm_rdzgp)
         if (.not. if3d) then
            klow = 0
            khigh = 0
         endif

         lpm_el_map(1,ie) = ilow  + lpm_ndxgp*jlow  
     >                            + lpm_ndxgp*lpm_ndygp*klow
         lpm_el_map(2,ie) = ihigh + lpm_ndxgp*jhigh 
     >                            + lpm_ndxgp*lpm_ndygp*khigh
         lpm_el_map(3,ie) = ilow
         lpm_el_map(4,ie) = ihigh
         lpm_el_map(5,ie) = jlow
         lpm_el_map(6,ie) = jhigh
         lpm_el_map(7,ie) = klow
         lpm_el_map(8,ie) = khigh
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine lpm_comm_ghost_create
      include 'SIZE'
      include 'TOTAL'
#     include "LPM"

      character*132 deathmessage
      real xdlen,ydlen,zdlen,rxdrng(3),rxnew(3)
      integer iadd(3),gpsave(27)
      real map(LPM_LRP_PRO)

      integer  el_face_num(18),el_edge_num(36),el_corner_num(24),
     >                            nfacegp, nedgegp, ncornergp

c     face, edge, and corner number, x,y,z are all inline, so stride=3
      el_face_num = (/ -1,0,0, 1,0,0, 0,-1,0, 0,1,0, 0,0,-1, 0,0,1 /)
      el_edge_num = (/ -1,-1,0 , 1,-1,0, 1,1,0 , -1,1,0 ,
     >                  0,-1,-1, 1,0,-1, 0,1,-1, -1,0,-1,
     >                  0,-1,1 , 1,0,1 , 0,1,1 , -1,0,1  /)
      el_corner_num = (/ -1,-1,-1, 1,-1,-1, 1,1,-1, -1,1,-1,
     >                   -1,-1,1,  1,-1,1,  1,1,1,  -1,1,1 /)

      nfacegp   = 4  ! number of faces
      nedgegp   = 4  ! number of edges
      ncornergp = 0  ! number of corners

      if (if3d) then
         nfacegp   = 6  ! number of faces
         nedgegp   = 12 ! number of edges
         ncornergp = 8  ! number of corners
      endif

      iperiodicx = int(lpm_rparam(8))
      iperiodicy = int(lpm_rparam(9))
      iperiodicz = int(lpm_rparam(10))

! ------------------------
c CREATING GHOST PARTICLES
! ------------------------
      jx    = 1
      jy    = 2
      jz    = 3
      jdp   = int(lpm_rparam(5))

      xdlen = lpm_binb(2) - lpm_binb(1)
      ydlen = lpm_binb(4) - lpm_binb(3)
      zdlen = -1.
      if (if3d) zdlen = lpm_binb(6) - lpm_binb(5)
      if (iperiodicx .ne. 1) xdlen = -1
      if (iperiodicy .ne. 1) ydlen = -1
      if (iperiodicz .ne. 1) zdlen = -1

      rxdrng(1) = xdlen
      rxdrng(2) = ydlen
      rxdrng(3) = zdlen

      lpm_npart_gp = 0

      rfac = 1.0

      do ip=1,lpm_npart

         call lpm_project_map(map,lpm_y(1,ip),lpm_ydot(1,ip)
     >                       ,lpm_ydotc(1,ip),lpm_rprop(1,ip))
         lpm_cp_map(1,ip) = lpm_y(jx,ip)      ! x coord
         lpm_cp_map(2,ip) = lpm_y(jy,ip)      ! y coord
         lpm_cp_map(3,ip) = lpm_y(jz,ip)      ! z coord
         lpm_cp_map(4,ip) = lpm_rprop(jdp,ip) ! filter non-dim scale
         do j=1,LPM_LRP_PRO
            lpm_cp_map(4+j,ip) = map(j)
         enddo

         rxval = lpm_cp_map(1,ip)
         ryval = lpm_cp_map(2,ip)
         rzval = 0.
         if(if3d) rzval = lpm_cp_map(3,ip)

         iip    = lpm_iprop(8,ip)
         jjp    = lpm_iprop(9,ip)
         kkp    = lpm_iprop(10,ip)

         rxl = lpm_binb(1) + lpm_rdxgp*iip
         rxr = rxl + lpm_rdxgp
         ryl = lpm_binb(3) + lpm_rdygp*jjp
         ryr = ryl + lpm_rdygp
         rzl = 0.0
         rzr = 0.0
         if (if3d) then
            rzl = lpm_binb(5) + lpm_rdzgp*kkp
            rzr = rzl + lpm_rdzgp
         endif

         isave = 0

         ! faces
         do ifc=1,nfacegp
            ist = (ifc-1)*3
            ii1 = iip + el_face_num(ist+1) 
            jj1 = jjp + el_face_num(ist+2)
            kk1 = kkp + el_face_num(ist+3)

            iig = ii1
            jjg = jj1
            kkg = kk1

            distchk = 0.0
            dist = 0.0
            if (ii1-iip .ne. 0) then
               distchk = distchk + (rfac*lpm_d2chk(2))**2
               if (ii1-iip .lt. 0) dist = dist +(rxval - rxl)**2
               if (ii1-iip .gt. 0) dist = dist +(rxval - rxr)**2
            endif
            if (jj1-jjp .ne. 0) then
               distchk = distchk + (rfac*lpm_d2chk(2))**2
               if (jj1-jjp .lt. 0) dist = dist +(ryval - ryl)**2
               if (jj1-jjp .gt. 0) dist = dist +(ryval - ryr)**2
            endif
            if (if3d) then
            if (kk1-kkp .ne. 0) then
               distchk = distchk + (rfac*lpm_d2chk(2))**2
               if (kk1-kkp .lt. 0) dist = dist +(rzval - rzl)**2
               if (kk1-kkp .gt. 0) dist = dist +(rzval - rzr)**2
            endif
            endif
            distchk = sqrt(distchk)
            dist = sqrt(dist)
            if (dist .gt. distchk) cycle

            iflgx = 0
            iflgy = 0
            iflgz = 0
            ! periodic if out of domain - add some ifsss
            if (iig .lt. 0 .or. iig .gt. lpm_ndxgp-1) then
               iflgx = 1
               iig =modulo(iig,lpm_ndxgp)
               if (iperiodicx .ne. 1) cycle
            endif
            if (jjg .lt. 0 .or. jjg .gt. lpm_ndygp-1) then
               iflgy = 1
               jjg =modulo(jjg,lpm_ndygp)
               if (iperiodicy .ne. 1) cycle
            endif
            if (kkg .lt. 0 .or. kkg .gt. lpm_ndzgp-1) then
               iflgz = 1  
               kkg =modulo(kkg,lpm_ndzgp)
               if (iperiodicz .ne. 1) cycle
            endif

            iflgsum = iflgx + iflgy + iflgz
            ndumn = iig + lpm_ndxgp*jjg + lpm_ndxgp*lpm_ndygp*kkg
            nrank = modulo(ndumn,np)

            if (nrank .eq. nid .and. iflgsum .eq. 0) cycle

            do i=1,isave
               if (gpsave(i) .eq. nrank .and. iflgsum .eq.0) goto 111
            enddo
            isave = isave + 1
            gpsave(isave) = nrank

            ibctype = iflgx+iflgy+iflgz
                 
            rxnew(1) = rxval
            rxnew(2) = ryval
            rxnew(3) = rzval
       
            iadd(1) = ii1
            iadd(2) = jj1
            iadd(3) = kk1

            call lpm_comm_check_periodic_gp(rxnew,rxdrng,iadd)
                 
            lpm_npart_gp = lpm_npart_gp + 1
            lpm_iprop_gp(1,lpm_npart_gp) = nrank
            lpm_iprop_gp(2,lpm_npart_gp) = iig
            lpm_iprop_gp(3,lpm_npart_gp) = jjg
            lpm_iprop_gp(4,lpm_npart_gp) = kkg
            lpm_iprop_gp(5,lpm_npart_gp) = ndumn

            lpm_rprop_gp(1,lpm_npart_gp) = rxnew(1)
            lpm_rprop_gp(2,lpm_npart_gp) = rxnew(2)
            lpm_rprop_gp(3,lpm_npart_gp) = rxnew(3)
            do k=4,LPM_LRP_GP
               lpm_rprop_gp(k,lpm_npart_gp) = lpm_cp_map(k,ip)
            enddo
  111 continue
         enddo

         ! edges
         do ifc=1,nedgegp
            ist = (ifc-1)*3
            ii1 = iip + el_edge_num(ist+1) 
            jj1 = jjp + el_edge_num(ist+2)
            kk1 = kkp + el_edge_num(ist+3)

            iig = ii1
            jjg = jj1
            kkg = kk1

            distchk = 0.0
            dist = 0.0
            if (ii1-iip .ne. 0) then
               distchk = distchk + (rfac*lpm_d2chk(2))**2
               if (ii1-iip .lt. 0) dist = dist +(rxval - rxl)**2
               if (ii1-iip .gt. 0) dist = dist +(rxval - rxr)**2
            endif
            if (jj1-jjp .ne. 0) then
               distchk = distchk + (rfac*lpm_d2chk(2))**2
               if (jj1-jjp .lt. 0) dist = dist +(ryval - ryl)**2
               if (jj1-jjp .gt. 0) dist = dist +(ryval - ryr)**2
            endif
            if (if3d) then
            if (kk1-kkp .ne. 0) then
               distchk = distchk + (rfac*lpm_d2chk(2))**2
               if (kk1-kkp .lt. 0) dist = dist +(rzval - rzl)**2
               if (kk1-kkp .gt. 0) dist = dist +(rzval - rzr)**2
            endif
            endif
            distchk = sqrt(distchk)
            dist = sqrt(dist)
            if (dist .gt. distchk) cycle

            iflgx = 0
            iflgy = 0
            iflgz = 0
            ! periodic if out of domain - add some ifsss
            if (iig .lt. 0 .or. iig .gt. lpm_ndxgp-1) then
               iflgx = 1
               iig =modulo(iig,lpm_ndxgp)
               if (iperiodicx .ne. 1) cycle
            endif
            if (jjg .lt. 0 .or. jjg .gt. lpm_ndygp-1) then
               iflgy = 1
               jjg =modulo(jjg,lpm_ndygp)
               if (iperiodicy .ne. 1) cycle
            endif
            if (kkg .lt. 0 .or. kkg .gt. lpm_ndzgp-1) then
               iflgz = 1  
               kkg =modulo(kkg,lpm_ndzgp)
               if (iperiodicz .ne. 1) cycle
            endif

            iflgsum = iflgx + iflgy + iflgz
            ndumn = iig + lpm_ndxgp*jjg + lpm_ndxgp*lpm_ndygp*kkg
            nrank = modulo(ndumn,np)

            if (nrank .eq. nid .and. iflgsum .eq. 0) cycle

            do i=1,isave
               if (gpsave(i) .eq. nrank .and. iflgsum .eq.0) goto 222
            enddo
            isave = isave + 1
            gpsave(isave) = nrank

            ibctype = iflgx+iflgy+iflgz
                 
            rxnew(1) = rxval
            rxnew(2) = ryval
            rxnew(3) = rzval
       
            iadd(1) = ii1
            iadd(2) = jj1
            iadd(3) = kk1

            call lpm_comm_check_periodic_gp(rxnew,rxdrng,iadd)
                 
            lpm_npart_gp = lpm_npart_gp + 1
            lpm_iprop_gp(1,lpm_npart_gp) = nrank
            lpm_iprop_gp(2,lpm_npart_gp) = iig
            lpm_iprop_gp(3,lpm_npart_gp) = jjg
            lpm_iprop_gp(4,lpm_npart_gp) = kkg
            lpm_iprop_gp(5,lpm_npart_gp) = ndumn

            lpm_rprop_gp(1,lpm_npart_gp) = rxnew(1)
            lpm_rprop_gp(2,lpm_npart_gp) = rxnew(2)
            lpm_rprop_gp(3,lpm_npart_gp) = rxnew(3)
            do k=4,LPM_LRP_GP
               lpm_rprop_gp(k,lpm_npart_gp) = lpm_cp_map(k,ip)
            enddo
  222 continue
         enddo

         ! corners
         do ifc=1,ncornergp
            ist = (ifc-1)*3
            ii1 = iip + el_corner_num(ist+1) 
            jj1 = jjp + el_corner_num(ist+2)
            kk1 = kkp + el_corner_num(ist+3)

            iig = ii1
            jjg = jj1
            kkg = kk1

            distchk = 0.0
            dist = 0.0
            if (ii1-iip .ne. 0) then
               distchk = distchk + (rfac*lpm_d2chk(2))**2
               if (ii1-iip .lt. 0) dist = dist +(rxval - rxl)**2
               if (ii1-iip .gt. 0) dist = dist +(rxval - rxr)**2
            endif
            if (jj1-jjp .ne. 0) then
               distchk = distchk + (rfac*lpm_d2chk(2))**2
               if (jj1-jjp .lt. 0) dist = dist +(ryval - ryl)**2
               if (jj1-jjp .gt. 0) dist = dist +(ryval - ryr)**2
            endif
            if (if3d) then
            if (kk1-kkp .ne. 0) then
               distchk = distchk + (rfac*lpm_d2chk(2))**2
               if (kk1-kkp .lt. 0) dist = dist +(rzval - rzl)**2
               if (kk1-kkp .gt. 0) dist = dist +(rzval - rzr)**2
            endif
            endif
            distchk = sqrt(distchk)
            dist = sqrt(dist)
            if (dist .gt. distchk) cycle

            iflgx = 0
            iflgy = 0
            iflgz = 0
            ! periodic if out of domain - add some ifsss
            if (iig .lt. 0 .or. iig .gt. lpm_ndxgp-1) then
               iflgx = 1
               iig =modulo(iig,lpm_ndxgp)
               if (iperiodicx .ne. 1) cycle
            endif
            if (jjg .lt. 0 .or. jjg .gt. lpm_ndygp-1) then
               iflgy = 1
               jjg =modulo(jjg,lpm_ndygp)
               if (iperiodicy .ne. 1) cycle
            endif
            if (kkg .lt. 0 .or. kkg .gt. lpm_ndzgp-1) then
               iflgz = 1  
               kkg =modulo(kkg,lpm_ndzgp)
               if (iperiodicz .ne. 1) cycle
            endif

            iflgsum = iflgx + iflgy + iflgz
            ndumn = iig + lpm_ndxgp*jjg + lpm_ndxgp*lpm_ndygp*kkg
            nrank = modulo(ndumn,np)

            if (nrank .eq. nid .and. iflgsum .eq. 0) cycle

            do i=1,isave
               if (gpsave(i) .eq. nrank .and. iflgsum .eq.0) goto 333
            enddo
            isave = isave + 1
            gpsave(isave) = nrank

            ibctype = iflgx+iflgy+iflgz
                 
            rxnew(1) = rxval
            rxnew(2) = ryval
            rxnew(3) = rzval
       
            iadd(1) = ii1
            iadd(2) = jj1
            iadd(3) = kk1

            call lpm_comm_check_periodic_gp(rxnew,rxdrng,iadd)
                 
            lpm_npart_gp = lpm_npart_gp + 1
            lpm_iprop_gp(1,lpm_npart_gp) = nrank
            lpm_iprop_gp(2,lpm_npart_gp) = iig
            lpm_iprop_gp(3,lpm_npart_gp) = jjg
            lpm_iprop_gp(4,lpm_npart_gp) = kkg
            lpm_iprop_gp(5,lpm_npart_gp) = ndumn

            lpm_rprop_gp(1,lpm_npart_gp) = rxnew(1)
            lpm_rprop_gp(2,lpm_npart_gp) = rxnew(2)
            lpm_rprop_gp(3,lpm_npart_gp) = rxnew(3)
            do k=4,LPM_LRP_GP
               lpm_rprop_gp(k,lpm_npart_gp) = lpm_cp_map(k,ip)
            enddo
  333 continue
         enddo

      enddo

      return
      end
c----------------------------------------------------------------------
      subroutine lpm_comm_check_periodic_gp(rxnew,rxdrng,iadd)
      include 'SIZE'
      include 'TOTAL'
#     include "LPM"

      real rxnew(3), rxdrng(3)
      integer iadd(3), irett(3), ntype, ntypel(7)

      xloc = rxnew(1)
      yloc = rxnew(2)
      zloc = rxnew(3)

      xdlen = rxdrng(1)
      ydlen = rxdrng(2)
      zdlen = rxdrng(3)

      ii = iadd(1)
      jj = iadd(2)
      kk = iadd(3)

      irett(1) = 0
      irett(2) = 0
      irett(3) = 0

      if (xdlen .gt. 0 ) then
      if (ii .ge. lpm_ndxgp) then
         xloc = xloc - xdlen
         irett(1) = 1
         goto 123
      endif
      endif
      if (xdlen .gt. 0 ) then
      if (ii .lt. 0) then
         xloc = xloc + xdlen
         irett(1) = 1
         goto 123
      endif
      endif

  123 continue    
      if (ydlen .gt. 0 ) then
      if (jj .ge. lpm_ndygp) then
         yloc = yloc - ydlen
         irett(2) = 1
         goto 124
      endif
      endif
      if (ydlen .gt. 0 ) then
      if (jj .lt. 0) then
         yloc = yloc + ydlen
         irett(2) = 1
         goto 124
      endif
      endif
  124 continue

      if (if3d) then
         if (zdlen .gt. 0 ) then
         if (kk .ge. lpm_ndzgp) then
            zloc = zloc - zdlen
            irett(3) = 1
            goto 125
         endif
         endif
         if (zdlen .gt. 0 ) then
         if (kk .lt. 0) then
            zloc = zloc + zdlen
            irett(3) = 1
            goto 125
         endif
         endif
      endif
  125 continue

      rxnew(1) = xloc
      rxnew(2) = yloc
      rxnew(3) = zloc

      return
      end
c----------------------------------------------------------------------
      subroutine lpm_comm_ghost_send
      include 'SIZE'
#     include "LPM"

      logical partl         

      ! send ghost particles
      call fgslib_crystal_tuple_transfer(i_cr_hndl
     >                                  ,lpm_npart_gp,LPM_LPART_GP
     >                                  ,lpm_iprop_gp,LPM_LIP_GP
     >                                  ,partl,0
     >                                  ,lpm_rprop_gp,LPM_LRP_GP
     >                                  ,1)

      return
      end
c----------------------------------------------------------------------

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!The workshare construct is only available in Fortran. The workshare spreads work across the threads 
!executing the parallel. There is an implicit barrier. No data race. 


program DRB170_workshare_orig_no
    use omp_lib
    implicit none
 
    integer :: AA, BB, CC, res
  
    BB = 1
    CC = 2

    !$omp parallel
        !$omp workshare
        AA = BB
        AA = AA+CC
        !$omp end workshare 
    
        !$omp workshare
        res = AA*2
        !$omp end workshare
    !$omp end parallel

    if (res /= 6) then 
        print*,res
    end if
end program

       PROGRAM MXMDRIVER

       INTEGER N = 4
       real A(N,N),B(N,N),C(N,N)
       INTEGER I,J

       DO J=1,N
         DO I=1,N
           A(I,J) = 1.0*(I+J)
           B(I,J) = 1.0*(I-J)
         ENDDO
       ENDDO

c       DO I=1,N
c         DO J=1,N
c           C(I,J) = 0.0
c           DO K=1,N
c             C(I,J) = C(I,J) + A(I,K)*B(K,J)
c           ENDDO
c         ENDDO
c       ENDDO

       call mxm44_0(A,N,B,N,C,N)

       DO J=1,N
         DO I=1,N
c           PRINT *,"C(",I,",",J,") = ",C(I,J)
         ENDDO
       ENDDO

       END 

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Depend clause at line 29 and 33 will ensure that there is no data race.

module DRB158
    integer :: a, i
    integer :: x(64), y(64)
end module

program DRB158_missingtaskbarrier_orig_gpu_no
    use omp_lib
    use DRB158
    implicit none

    do i = 1, 64
        x(i) = 0
        y(i) = 3
    end do

    a = 5

    !$omp target map(to:y,a) map(tofrom:x) device(0)
    do i = 1, 64
        !$omp task depend(inout:x(i))
        x(i) = a*x(i)
        !$omp end task

        !$omp task depend(inout:x(i))
        x(i) = x(i)+y(i)
        !$omp end task
    end do
    !$omp end target

    do i = 1, 64
        if (x(i) /= 3) then
            print*,x(i)
        end if
    end do

    !$omp taskwait

end program

      subroutine plan1 (igeom)
C-------------------------------------------------------------------------
C
C     Compute pressure and velocity using consistent approximation spaces.     
C
C-------------------------------------------------------------------------
      include 'SIZE'
      include 'INPUT'
      include 'EIGEN'
      include 'SOLN'
      include 'TSTEP'
C
      COMMON /SCRHI/ H2INV (LX1,LY1,LZ1,LELV)
      COMMON /SCRNS/ RESV1 (LX1,LY1,LZ1,LELV)
     $ ,             RESV2 (LX1,LY1,LZ1,LELV)
     $ ,             RESV3 (LX1,LY1,LZ1,LELV)
     $ ,             DV1   (LX1,LY1,LZ1,LELV)
     $ ,             DV2   (LX1,LY1,LZ1,LELV)
     $ ,             DV3   (LX1,LY1,LZ1,LELV)
     $ ,             WP    (LX2,LY2,LZ2,LELV)
      COMMON /SCRVH/ H1    (LX1,LY1,LZ1,LELV)
     $ ,             H2    (LX1,LY1,LZ1,LELV)
      REAL           G1    (LX1,LY1,LZ1,LELV)
      REAL           G2    (LX1,LY1,LZ1,LELV)
      REAL           G3    (LX1,LY1,LZ1,LELV)
      EQUIVALENCE   (G1,RESV1), (G2,RESV2), (G3,RESV3)
      LOGICAL        IFSTUZ
C
      IF (IGEOM.EQ.1) THEN
C
C        Old geometry
C
         CALL MAKEF
         CALL LAGVEL
C
      ELSE
C
C        New geometry
C
         CALL BCDIRVC (VX,VY,VZ,v1mask,v2mask,v3mask)
         IF (IFSTRS) CALL BCNEUTR
C
C        Check if steady state
C
         IFSTUZ = .FALSE.
         CALL CONVUZ (IFSTUZ)
C... no steady state
         IFSTUZ = .FALSE.
         IF (IFSTUZ) THEN
            IF (NIO.EQ.0) WRITE (6,*) 
     $      'Steady state reached in the fluid solver'
            return
         ENDIF
C
C        Uzawa decoupling: First, compute pressure.....
C
         ntot1  = lx1*ly1*lz1*nelv
         ntot2  = lx2*ly2*lz2*nelv
         intype = 0
         if (iftran) intype = -1
         call sethlm  (h1,h2,intype)
         if (iftran)  call invers2 (h2inv,h2,ntot1)
         call makeg   (   g1,g2,g3,h1,h2,intype)
         call crespuz (wp,g1,g2,g3,h1,h2,h2inv,intype)
         call uzawa   (wp,h1,h2,h2inv,intype,icg)
         if (icg.gt.0) call add2 (pr,wp,ntot2)

C        .... then, compute velocity:

         call cresvuz (resv1,resv2,resv3)
         call ophinv  (dv1,dv2,dv3,resv1,resv2,resv3,h1,h2,tolhv,nmxv)
         call opadd2  (vx,vy,vz,dv1,dv2,dv3)

      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine crespuz (respr,g1,g2,g3,h1,h2,h2inv,intype)

c     Compute start-residual/right-hand-side in the pressure equation

      include 'SIZE'
      include 'TOTAL'
      REAL           RESPR  (LX2,LY2,LZ2,LELV)
      REAL           G1     (LX1,LY1,LZ1,LELV)
      REAL           G2     (LX1,LY1,LZ1,LELV)
      REAL           G3     (LX1,LY1,LZ1,LELV)
      REAL           H1     (LX1,LY1,LZ1,LELV)
      REAL           H2     (LX1,LY1,LZ1,LELV)
      REAL           H2INV  (LX1,LY1,LZ1,LELV)
      COMMON /SCRUZ/ TA1    (LX1,LY1,LZ1,LELV)
     $ ,             TA2    (LX1,LY1,LZ1,LELV)
     $ ,             TA3    (LX1,LY1,LZ1,LELV)
      COMMON /SCRMG/ VBDRY1 (LX1,LY1,LZ1,LELV)
     $ ,             VBDRY2 (LX1,LY1,LZ1,LELV)
     $ ,             VBDRY3 (LX1,LY1,LZ1,LELV)

      if ((intype.eq.0).or.(intype.eq.-1)) then
         call ophinv (ta1,ta2,ta3,g1,g2,g3,h1,h2,tolhr,nmxp)
      else
         call opbinv (ta1,ta2,ta3,g1,g2,g3,h2inv)
      endif
      call opamask   (vbdry1,vbdry2,vbdry3)
      call opsub2    (ta1,ta2,ta3,vbdry1,vbdry2,vbdry3)
      call opdiv     (respr,ta1,ta2,ta3)
      call ortho     (respr)

      return
      end
c-----------------------------------------------------------------------
      subroutine cresvuz (resv1,resv2,resv3)

c     Compute the residual for the velocity - UZAWA SCHEME.

      include 'SIZE'
      include 'GEOM'
      include 'SOLN'
      REAL           RESV1 (LX1,LY1,LZ1,1)
      REAL           RESV2 (LX1,LY1,LZ1,1)
      REAL           RESV3 (LX1,LY1,LZ1,1)
      COMMON /SCRMG/ TA1   (LX1,LY1,LZ1,LELV)
     $ ,             TA2   (LX1,LY1,LZ1,LELV)
     $ ,             TA3   (LX1,LY1,LZ1,LELV)
      COMMON /SCREV/ H1    (LX1,LY1,LZ1,LELV)
     $ ,             H2    (LX1,LY1,LZ1,LELV)
C
      INLOC   = -1
      CALL SETHLM  (H1,H2,INLOC)
      CALL OPRZERO (RESV1,RESV2,RESV3)
      CALL OPGRADT (RESV1,RESV2,RESV3,PR)
      CALL OPADD2  (RESV1,RESV2,RESV3,BFX,BFY,BFZ)
      CALL OPHX    (TA1,TA2,TA3,VX,VY,VZ,H1,H2)
      CALL OPSUB2  (RESV1,RESV2,RESV3,TA1,TA2,TA3)
C
      return
      END
C
      subroutine makeg (out1,out2,out3,h1,h2,intype)
C----------------------------------------------------------------------
C
C     Compute inhomogeneities for the elliptic solver in the pressure
C     residual evaluation.
C     INTYPE =  0  steady state
C     INTYPE =  1  explicit, Euler forward
C     INTYPE = -1  implicit, Euler backward
C
C-----------------------------------------------------------------------
      include 'SIZE'
      include 'TOTAL'
      REAL           OUT1  (LX1,LY1,LZ1,LELV)
      REAL           OUT2  (LX1,LY1,LZ1,LELV)
      REAL           OUT3  (LX1,LY1,LZ1,LELV)
      REAL           H1    (LX1,LY1,LZ1,LELV)
      REAL           H2    (LX1,LY1,LZ1,LELV)
      COMMON /SCRMG/ TA1   (LX1,LY1,LZ1,LELV)
     $              ,TA2   (LX1,LY1,LZ1,LELV)
     $              ,TA3   (LX1,LY1,LZ1,LELV)
      COMMON /SCRUZ/ TB1   (LX1,LY1,LZ1,LELV)
     $              ,TB2   (LX1,LY1,LZ1,LELV)
     $              ,TB3   (LX1,LY1,LZ1,LELV)
     $              ,HZERO (LX1,LY1,LZ1,LELV)
C
      NTOT1 = lx1*ly1*lz1*NELV
C
      CALL OPGRADT (OUT1,OUT2,OUT3,PR)
      CALL OPCHSGN (OUT1,OUT2,OUT3)
C
      IF ((INTYPE.EQ.0.).OR.(INTYPE.EQ.-1)) THEN
C
C        Steady state or implicit scheme
C
         CALL OPAMASK (TB1,TB2,TB3)
         CALL OPHX    (TA1,TA2,TA3,TB1,TB2,TB3,H1,H2)
         CALL OPADD2  (OUT1,OUT2,OUT3,TA1,TA2,TA3)
         CALL OPSUB2  (OUT1,OUT2,OUT3,BFX,BFY,BFZ)
C
      ELSEIF (INTYPE.EQ.1) THEN
C
C        Explicit scheme
C
         CALL RZERO   (HZERO,NTOT1)
         CALL OPHX    (TA1,TA2,TA3,VX,VY,VZ,H1,HZERO)
         CALL OPADD2  (OUT1,OUT2,OUT3,TA1,TA2,TA3)
         CALL OPSUB2  (OUT1,OUT2,OUT3,BFX,BFY,BFZ)
C
      ENDIF
C
      return
      END

c-----------------------------------------------------------------------
      subroutine ctolspl (tolspl,respr)
C
C     Compute the pressure tolerance
C
      include 'SIZE'
      include 'MASS'
      include 'TSTEP'
      REAL           RESPR (LX2,LY2,LZ2,LELV)
      COMMON /SCRMG/ WORK  (LX1,LY1,LZ1,LELV)
C
      NTOT1 = lx1*ly1*lz1*NELV
      CALL INVCOL3 (WORK,RESPR,BM1,NTOT1)
      CALL COL2    (WORK,RESPR,NTOT1)
      RINIT  = SQRT (GLSUM (WORK,NTOT1)/VOLVM1)
      IF (TOLPDF.GT.0.) THEN
         TOLSPL = TOLPDF
         TOLMIN = TOLPDF
      ELSE
         TOLSPL = TOLPS/DT
         TOLMIN = RINIT*PRELAX
      ENDIF
      IF (TOLSPL.LT.TOLMIN) THEN
         TOLOLD = TOLSPL
         TOLSPL = TOLMIN
         IF (NIO.EQ.0) 
     $   WRITE (6,*) 'Relax the pressure tolerance ',TOLSPL,TOLOLD
      ENDIF
      return
      end
c------------------------------------------------------------------------
      subroutine ortho (respr)

C     Orthogonalize the residual in the pressure solver with respect 
C     to (1,1,...,1)T  (only if all Dirichlet b.c.).

      include 'SIZE'
      include 'GEOM'
      include 'INPUT'
      include 'PARALLEL'
      include 'SOLN'
      include 'TSTEP'
      real respr (lx2,ly2,lz2,lelv)
      integer*8 ntotg,nxyz2

      nxyz2 = lx2*ly2*lz2
      ntot  = nxyz2*nelv
      ntotg = nxyz2*nelgv

      if (ifield.eq.1) then
         if (ifvcor) then
            rlam  = glsum (respr,ntot)/ntotg
            call cadd (respr,-rlam,ntot)
         endif
       elseif (ifield.eq.ifldmhd) then
         if (ifbcor) then
            rlam = glsum (respr,ntot)/ntotg
            call cadd (respr,-rlam,ntot)
         endif
       else
         call exitti('ortho: unaccounted ifield = $',ifield)
      endif

      return
      end
c------------------------------------------------------------------------
      subroutine cdabdtp (ap,wp,h1,h2,h2inv,intype)

C     INTYPE= 0  Compute the matrix-vector product    DA(-1)DT*p
C     INTYPE= 1  Compute the matrix-vector product    D(B/DT)(-1)DT*p
C     INTYPE=-1  Compute the matrix-vector product    D(A+B/DT)(-1)DT*p

      include 'SIZE'
      include 'TOTAL'
      REAL           AP    (LX2,LY2,LZ2,1)
      REAL           WP    (LX2,LY2,LZ2,1)
      REAL           H1    (LX1,LY1,LZ1,1)
      REAL           H2    (LX1,LY1,LZ1,1)
      REAL           H2INV (LX1,LY1,LZ1,1)
C
      COMMON /SCRNS/ TA1 (LX1,LY1,LZ1,LELV)
     $ ,             TA2 (LX1,LY1,LZ1,LELV)
     $ ,             TA3 (LX1,LY1,LZ1,LELV)
     $ ,             TB1 (LX1,LY1,LZ1,LELV)
     $ ,             TB2 (LX1,LY1,LZ1,LELV)
     $ ,             TB3 (LX1,LY1,LZ1,LELV)

      call opgradt (ta1,ta2,ta3,wp)
      if ((intype.eq.0).or.(intype.eq.-1)) then
         tolhin=tolhs
         call ophinv (tb1,tb2,tb3,ta1,ta2,ta3,h1,h2,tolhin,nmxv)
      else
         if (ifanls) then
            dtbdi = dt/bd(1)   ! scale by dt*backwd-diff coefficient
            CALL OPBINV1(TB1,TB2,TB3,TA1,TA2,TA3,dtbdi)
         else
            CALL OPBINV (TB1,TB2,TB3,TA1,TA2,TA3,H2INV)
         endif
      endif
      call opdiv  (ap,tb1,tb2,tb3)

      return
      end
C
C-----------------------------------------------------------------------
      subroutine opgrad (out1,out2,out3,inp)
C---------------------------------------------------------------------
C
C     Compute OUTi = Di*INP, i=1,2,3. 
C     the gradient of the scalar field INP.
C     Note: OUTi is defined on the pressure mesh !!!
C
C---------------------------------------------------------------------
      include 'SIZE'
      include 'GEOM'
      include 'INPUT'

      REAL OUT1 (LX2,LY2,LZ2,1)
      REAL OUT2 (LX2,LY2,LZ2,1)
      REAL OUT3 (LX2,LY2,LZ2,1)
      REAL INP  (LX1,LY1,LZ1,1)

      iflg = 0

      if (ifsplit .and. .not.ifaxis) then
         call wgradm1(out1,out2,out3,inp,nelv) ! weak grad on FLUID mesh
         return
      endif

      NTOT2 = lx2*ly2*lz2*NELV
      CALL MULTD (OUT1,INP,RXM2,SXM2,TXM2,1,iflg)
      CALL MULTD (OUT2,INP,RYM2,SYM2,TYM2,2,iflg)
      IF (ldim.EQ.3) 
     $CALL MULTD (OUT3,INP,RZM2,SZM2,TZM2,3,iflg)
C
      return
      END
c-----------------------------------------------------------------------
      subroutine cdtp (dtx,x,rm2,sm2,tm2,isd)
C-------------------------------------------------------------
C
C     Compute DT*X (entire field)
C
C-------------------------------------------------------------
      include 'SIZE'
      include 'WZ'
      include 'DXYZ'
      include 'IXYZ'
      include 'GEOM'
      include 'MASS'
      include 'INPUT'
      include 'ESOLV'
C
      real dtx  (lx1*ly1*lz1,lelv)
      real x    (lx2*ly2*lz2,lelv)
      real rm2  (lx2*ly2*lz2,lelv)
      real sm2  (lx2*ly2*lz2,lelv)
      real tm2  (lx2*ly2*lz2,lelv)
C
      common /ctmp1/ wx  (lx1*ly1*lz1)
     $ ,             ta1 (lx1*ly1*lz1)
     $ ,             ta2 (lx1*ly1*lz1)
     $ ,             ta3 (lx1*ly1,lz1)

      REAL           DUAX(LX1)
c
      COMMON /FASTMD/ IFDFRM(LELT), IFFAST(LELT), IFH2, IFSOLV
      LOGICAL IFDFRM, IFFAST, IFH2, IFSOLV
      include 'CTIMER'

      integer e
C
#ifdef TIMER
      if (icalld.eq.0) tcdtp=0.0
      icalld=icalld+1
      ncdtp=icalld
      etime1=dnekclock()
#endif

      nxyz1 = lx1*ly1*lz1
      nxyz2 = lx2*ly2*lz2
      nyz2  = ly2*lz2
      nxy1  = lx1*ly1

      n1    = lx1*ly1
      n2    = lx1*ly2

      do e=1,nelv

C       Use the appropriate derivative- and interpolation operator in 
C       the y-direction (= radial direction if axisymmetric).
        if (ifaxis) then
         ly12   = ly1*ly2
         if (ifrzer(e)) then
            call copy (iym12,iam12,ly12)
            call copy (dym12,dam12,ly12)
            call copy (w3m2,w2am2,nxyz2)
         else
            call copy (iym12,icm12,ly12)
            call copy (dym12,dcm12,ly12)
            call copy (w3m2,w2cm2,nxyz2)
         endif
       endif
C
C      Collocate with weights
C
       if(ifsplit) then
         call col3 (wx,bm1(1,1,1,e),x(1,e),nxyz1)
         call invcol2(wx,jacm1(1,1,1,e),nxyz1)
       else
         if (.not.ifaxis) call col3 (wx,w3m2,x(1,e),nxyz2)
C
         if (ifaxis) then
            if (ifrzer(e)) then
                call col3    (wx,x(1,e),bm2(1,1,1,e),nxyz2)
                call invcol2 (wx,jacm2(1,1,1,e),nxyz2)
            else
                call col3    (wx,w3m2,x(1,e),nxyz2)
                call col2    (wx,ym2(1,1,1,e),nxyz2)
            endif
         endif
       endif
C
       if (ldim.eq.2) then
         if (.not.ifdfrm(e) .and. ifalgn(e)) then
C
            if (      ifrsxy(e).and.isd.eq.1  .or. 
     $           .not.ifrsxy(e).and.isd.eq.2) then
C
               call col3 (ta1,wx,rm2(1,e),nxyz2)
               call mxm  (dxtm12,lx1,ta1,lx2,ta2,nyz2)
               call mxm  (ta2,lx1,iym12,ly2,dtx(1,e),ly1)
            else
               call col3 (ta1,wx,sm2(1,e),nxyz2)
               call mxm  (ixtm12,lx1,ta1,lx2,ta2,nyz2)
               call mxm  (ta2,lx1,dym12,ly2,dtx(1,e),ly1)
            endif
         else
            call col3 (ta1,wx,rm2(1,e),nxyz2)
            call mxm  (dxtm12,lx1,ta1,lx2,ta2,nyz2)
            call mxm  (ta2,lx1,iym12,ly2,dtx(1,e),ly1)

            call col3 (ta1,wx,sm2(1,e),nxyz2)
            call mxm  (ixtm12,lx1,ta1,lx2,ta2,nyz2)
            call mxm  (ta2,lx1,dym12,ly2,ta1,ly1)

            call add2 (dtx(1,e),ta1,nxyz1)
         endif

       else
         if (ifsplit) then

            call col3 (ta1,wx,rm2(1,e),nxyz2)
            call mxm  (dxtm12,lx1,ta1,lx2,dtx(1,e),nyz2)
            call col3 (ta1,wx,sm2(1,e),nxyz2)
            i1 = 1
            i2 = 1
            do iz=1,lz2
               call mxm  (ta1(i2),lx1,dym12,ly2,ta2(i1),ly1)
               i1 = i1 + n1
               i2 = i2 + n2
            enddo
            call add2 (dtx(1,e),ta2,nxyz1)
            call col3 (ta1,wx,tm2(1,e),nxyz2)
            call mxm  (ta1,nxy1,dzm12,lz2,ta2,lz1)
            call add2 (dtx(1,e),ta2,nxyz1)

         else

            call col3 (ta1,wx,rm2(1,e),nxyz2)
            call mxm  (dxtm12,lx1,ta1,lx2,ta2,nyz2)
            i1 = 1
            i2 = 1
            do iz=1,lz2
               call mxm  (ta2(i2),lx1,iym12,ly2,ta1(i1),ly1)
               i1 = i1 + n1
               i2 = i2 + n2
            enddo
            call mxm  (ta1,nxy1,izm12,lz2,dtx(1,e),lz1)

            call col3 (ta1,wx,sm2(1,e),nxyz2)
            call mxm  (ixtm12,lx1,ta1,lx2,ta2,nyz2)
            i1 = 1
            i2 = 1
            do iz=1,lz2
               call mxm  (ta2(i2),lx1,dym12,ly2,ta1(i1),ly1)
               i1 = i1 + n1
               i2 = i2 + n2
            enddo
            call mxm  (ta1,nxy1,izm12,lz2,ta2,lz1)
            call add2 (dtx(1,e),ta2,nxyz1)

            call col3 (ta1,wx,tm2(1,e),nxyz2)
            call mxm  (ixtm12,lx1,ta1,lx2,ta2,nyz2)
            i1 = 1
            i2 = 1
            do iz=1,lz2
               call mxm  (ta2(i2),lx1,iym12,ly2,ta1(i1),ly1)
               i1 = i1 + n1
               i2 = i2 + n2
            enddo
            call mxm  (ta1,nxy1,dzm12,lz2,ta2,lz1)
            call add2 (dtx(1,e),ta2,nxyz1)

         endif

       endif         
C
C     If axisymmetric, add an extra diagonal term in the radial 
C     direction (only if solving the momentum equations and ISD=2)
C     NOTE: lz1=lz2=1
C
C
      if(ifsplit) then

       if (ifaxis.and.(isd.eq.4)) then
        call copy    (ta1,x(1,e),nxyz1)
        if (ifrzer(e)) THEN
           call rzero(ta1, lx1)
           call mxm  (x  (1,e),lx1,datm1,ly1,duax,1)
           call copy (ta1,duax,lx1)
        endif
        call col2    (ta1,baxm1(1,1,1,e),nxyz1)
        call add2    (dtx(1,e),ta1,nxyz1)
       endif

      else

       if (ifaxis.and.(isd.eq.2)) then
         call col3    (ta1,x(1,e),bm2(1,1,1,e),nxyz2)
         call invcol2 (ta1,ym2(1,1,1,e),nxyz2)
         call mxm     (ixtm12,lx1,ta1,lx2,ta2,ly2)
         call mxm     (ta2,lx1,iym12,ly2,ta1,ly1)
         call add2    (dtx(1,e),ta1,nxyz1)
       endif

      endif

      enddo
C
#ifdef TIMER
      tcdtp=tcdtp+(dnekclock()-etime1)
#endif
      return
      end
C
      subroutine multd (dx,x,rm2,sm2,tm2,isd,iflg)
C---------------------------------------------------------------------
C
C     Compute D*X
C     X    : input variable, defined on M1
C     DX   : output variable, defined on M2 (note: D is rectangular)   
C     RM2 : RXM2, RYM2 or RZM2
C     SM2 : SXM2, SYM2 or SZM2
C     TM2 : TXM2, TYM2 or TZM2
C     ISD : spatial direction (x=1,y=2,z=3)
C     IFLG: OPGRAD (iflg=0) or OPDIV (iflg=1)
C
C---------------------------------------------------------------------
      include 'SIZE'
      include 'WZ'
      include 'DXYZ'
      include 'IXYZ'
      include 'GEOM'
      include 'MASS'
      include 'INPUT'
      include 'ESOLV'

      real           dx   (lx2*ly2*lz2,lelv)
      real           x    (lx1*ly1*lz1,lelv)
      real           rm2  (lx2*ly2*lz2,lelv)
      real           sm2  (lx2*ly2*lz2,lelv)
      real           tm2  (lx2*ly2*lz2,lelv)

      common /ctmp1/ ta1 (lx1*ly1*lz1)
     $ ,             ta2 (lx1*ly1*lz1)
     $ ,             ta3 (lx1*ly1*lz1)

      real           duax(lx1)

      common /fastmd/ ifdfrm(lelt), iffast(lelt), ifh2, ifsolv
      logical ifdfrm, iffast, ifh2, ifsolv
      include 'CTIMER'

      integer e
C
#ifdef TIMER
      if (icalld.eq.0) tmltd=0.0
      icalld=icalld+1
      nmltd=icalld
      etime1=dnekclock()
#endif

      nyz1  = ly1*lz1
      nxy2  = lx2*ly2
      nxyz1 = lx1*ly1*lz1
      nxyz2 = lx2*ly2*lz2

      n1    = lx2*ly1
      n2    = lx2*ly2

      do e=1,nelv

c        Use the appropriate derivative- and interpolation operator in 
c        the y-direction (= radial direction if axisymmetric).
         if (ifaxis) then
            ly12   = ly1*ly2
            if (ifrzer(e)) then
               call copy (iytm12,iatm12,ly12)
               call copy (dytm12,datm12,ly12)
               call copy (w3m2,w2am2,nxyz2)
            else
               call copy (iytm12,ictm12,ly12)
               call copy (dytm12,dctm12,ly12)
               call copy (w3m2,w2cm2,nxyz2)
            endif
         endif

         if (ldim.eq.2) then
            if (.not.ifdfrm(e) .and. ifalgn(e)) then
c
               if (      ifrsxy(e).and.isd.eq.1  .or. 
     $              .not.ifrsxy(e).and.isd.eq.2) then
                  call mxm     (dxm12,lx2,x(1,e),lx1,ta1,nyz1)
                  call mxm     (ta1,lx2,iytm12,ly1,dx(1,e),ly2)
                  call col2    (dx(1,e),rm2(1,e),nxyz2)
               else
                  call mxm     (ixm12,lx2,x(1,e),lx1,ta1,nyz1)
                  call mxm     (ta1,lx2,dytm12,ly1,dx(1,e),ly2)
                  call col2    (dx(1,e),sm2(1,e),nxyz2)
               endif
            else
               call mxm     (dxm12,lx2,x(1,e),lx1,ta1,nyz1)
               call mxm     (ta1,lx2,iytm12,ly1,dx(1,e),ly2)
               call col2    (dx(1,e),rm2(1,e),nxyz2)
               call mxm     (ixm12,lx2,x(1,e),lx1,ta1,nyz1)
               call mxm     (ta1,lx2,dytm12,ly1,ta3,ly2)
               call addcol3 (dx(1,e),ta3,sm2(1,e),nxyz2)
            endif

         else  ! 3D

c           if (ifsplit) then
c
c             call mxm  (dxm12,lx2,x(1,e),lx1,dx(1,e),nyz1)
c             call col2 (dx(1,e),rm2(1,e),nxyz2)
c             i1=1
c             i2=1
c             do iz=1,lz1
c                call mxm (x(1,e),lx2,dytm12,ly1,ta1(i2),ly2)
c                i1=i1+n1
c                i2=i2+n2
c             enddo
c             call addcol3 (dx(1,e),ta1,sm2(1,e),nxyz2)
c             call mxm (x(1,e),nxy2,dztm12,lz1,ta1,lz2)
c             call addcol3 (dx(1,e),ta1,tm2(1,e),nxyz2)

c           else ! PN - PN-2

             call mxm (dxm12,lx2,x(1,e),lx1,ta1,nyz1)
             i1=1
             i2=1
             do iz=1,lz1
               call mxm (ta1(i1),lx2,iytm12,ly1,ta2(i2),ly2)
               i1=i1+n1
               i2=i2+n2
             enddo
             call mxm  (ta2,nxy2,iztm12,lz1,dx(1,e),lz2)
             call col2 (dx(1,e),rm2(1,e),nxyz2)

             call mxm  (ixm12,lx2,x(1,e),lx1,ta3,nyz1) ! reuse ta3 below
             i1=1
             i2=1
             do iz=1,lz1
               call mxm (ta3(i1),lx2,dytm12,ly1,ta2(i2),ly2)
               i1=i1+n1
               i2=i2+n2
             enddo
             call mxm     (ta2,nxy2,iztm12,lz1,ta1,lz2)
             call addcol3 (dx(1,e),ta1,sm2(1,e),nxyz2)

c            call mxm (ixm12,lx2,x(1,e),lx1,ta1,nyz1) ! reuse ta3 from above
             i1=1
             i2=1
             do iz=1,lz1
               call mxm (ta3(i1),lx2,iytm12,ly1,ta2(i2),ly2)
               i1=i1+n1
               i2=i2+n2
             enddo
             call mxm (ta2,nxy2,dztm12,lz1,ta3,lz2)
             call addcol3 (dx(1,e),ta3,tm2(1,e),nxyz2)
c           endif
         endif
C
C        Collocate with the weights on the pressure mesh


       if(ifsplit) then
         call col2   (dx(1,e),bm1(1,1,1,e),nxyz1)
         call invcol2(dx(1,e),jacm1(1,1,1,e),nxyz1)
       else
         if (.not.ifaxis) call col2 (dx(1,e),w3m2,nxyz2)
         if (ifaxis) then
             if (ifrzer(e)) then
                 call col2    (dx(1,e),bm2(1,1,1,e),nxyz2)
                 call invcol2 (dx(1,e),jacm2(1,1,1,e),nxyz2)
             else
                 call col2    (dx(1,e),w3m2,nxyz2)
                 call col2    (dx(1,e),ym2(1,1,1,e),nxyz2)
             endif
         endif
       endif

c        If axisymmetric, add an extra diagonal term in the radial 
c        direction (ISD=2).
c        NOTE: lz1=lz2=1

      if(ifsplit) then

       if (ifaxis.and.(isd.eq.2).and.iflg.eq.1) then
        call copy    (ta3,x(1,e),nxyz1)
        if (ifrzer(e)) then
           call rzero(ta3, lx1)
           call mxm  (x(1,e),lx1,datm1,ly1,duax,1)
           call copy (ta3,duax,lx1)
        endif
        call col2    (ta3,baxm1(1,1,1,e),nxyz1)
        call add2    (dx(1,e),ta3,nxyz2)
       endif

      else

       if (ifaxis.and.(isd.eq.2)) then
            call mxm     (ixm12,lx2,x(1,e),lx1,ta1,ly1)
            call mxm     (ta1,lx2,iytm12,ly1,ta2,ly2)
            call col3    (ta3,bm2(1,1,1,e),ta2,nxyz2)
            call invcol2 (ta3,ym2(1,1,1,e),nxyz2)
            call add2    (dx(1,e),ta3,nxyz2)
       endif

      endif
C
      enddo
C
#ifdef TIMER
      tmltd=tmltd+(dnekclock()-etime1)
#endif
      return
      END
c-----------------------------------------------------------------------
      subroutine ophx (out1,out2,out3,inp1,inp2,inp3,h1,h2)
C----------------------------------------------------------------------
C
C     OUT = (H1*A+H2*B) * INP  
C
C----------------------------------------------------------------------
      include 'SIZE'
      include 'INPUT'
      include 'SOLN'
      REAL OUT1 (LX1,LY1,LZ1,1)
      REAL OUT2 (LX1,LY1,LZ1,1)
      REAL OUT3 (LX1,LY1,LZ1,1)
      REAL INP1 (LX1,LY1,LZ1,1)
      REAL INP2 (LX1,LY1,LZ1,1)
      REAL INP3 (LX1,LY1,LZ1,1)
      REAL H1   (LX1,LY1,LZ1,1)
      REAL H2   (LX1,LY1,LZ1,1)
C
      IMESH = 1
C
      IF (IFSTRS) THEN
         MATMOD = 0
         CALL AXHMSF (OUT1,OUT2,OUT3,INP1,INP2,INP3,H1,H2,MATMOD)
      ELSE
         CALL AXHELM (OUT1,INP1,H1,H2,IMESH,1)
         CALL AXHELM (OUT2,INP2,H1,H2,IMESH,2)
         IF (ldim.EQ.3)
     $   CALL AXHELM (OUT3,INP3,H1,H2,IMESH,3)
      ENDIF
C
      return
      END
c-----------------------------------------------------------------------
      subroutine opbinv (out1,out2,out3,inp1,inp2,inp3,h2inv)
C--------------------------------------------------------------------
C
C     Compute OUT = (H2*B)-1 * INP   (explicit)
C
C--------------------------------------------------------------------
      include 'SIZE'
      include 'INPUT'
      include 'MASS'
      include 'SOLN'
C
      REAL OUT1  (1)
      REAL OUT2  (1)
      REAL OUT3  (1)
      REAL INP1  (1)
      REAL INP2  (1)
      REAL INP3  (1)
      REAL H2INV (1)
C

      include 'OPCTR'
C
#ifdef TIMER
      if (isclld.eq.0) then
          isclld=1
          nrout=nrout+1
          myrout=nrout
          rname(myrout) = 'opbinv'
      endif
#endif
C
      call opmask  (inp1,inp2,inp3)
      call opdssum (inp1,inp2,inp3)
C
      NTOT=lx1*ly1*lz1*NELV
C
#ifdef TIMER
      isbcnt = ntot*(1+ldim)
      dct(myrout) = dct(myrout) + (isbcnt)
      ncall(myrout) = ncall(myrout) + 1
      dcount      =      dcount + (isbcnt)
#endif

      call invcol3 (out1,bm1,h2inv,ntot)  ! this is expensive and should
      call dssum   (out1,lx1,ly1,lz1)     ! be changed (pff, 3/18/09)
      if (if3d) then
         do i=1,ntot
            tmp = 1./out1(i)
            out1(i)=inp1(i)*tmp
            out2(i)=inp2(i)*tmp
            out3(i)=inp3(i)*tmp
         enddo
      else
         do i=1,ntot
            tmp = 1./out1(i)
            out1(i)=inp1(i)*tmp
            out2(i)=inp2(i)*tmp
         enddo
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine opbinv1(out1,out2,out3,inp1,inp2,inp3,SCALE)
C--------------------------------------------------------------------
C
C     Compute OUT = (B)-1 * INP   (explicit)
C
C--------------------------------------------------------------------
      include 'SIZE'
      include 'INPUT'
      include 'MASS'
      include 'SOLN'
C
      REAL OUT1  (1)
      REAL OUT2  (1)
      REAL OUT3  (1)
      REAL INP1  (1)
      REAL INP2  (1)
      REAL INP3  (1)
C

      include 'OPCTR'
C
#ifdef TIMER
      if (isclld.eq.0) then
          isclld=1
          nrout=nrout+1
          myrout=nrout
          rname(myrout) = 'opbnv1'
      endif
#endif
C
      CALL OPMASK  (INP1,INP2,INP3)
      CALL OPDSSUM (INP1,INP2,INP3)
C
      NTOT=lx1*ly1*lz1*NELV
C
#ifdef TIMER
      isbcnt = ntot*(1+ldim)
      dct(myrout) = dct(myrout) + (isbcnt)
      ncall(myrout) = ncall(myrout) + 1
      dcount      =      dcount + (isbcnt)
#endif
C
      IF (IF3D) THEN
         DO 100 I=1,NTOT
            TMP    =BINVM1(I,1,1,1)*scale
            OUT1(I)=INP1(I)*TMP
            OUT2(I)=INP2(I)*TMP
            OUT3(I)=INP3(I)*TMP
  100    CONTINUE
      ELSE
         DO 200 I=1,NTOT
            TMP    =BINVM1(I,1,1,1)*scale
            OUT1(I)=INP1(I)*TMP
            OUT2(I)=INP2(I)*TMP
  200    CONTINUE
      ENDIF
C
      return
      END
C-----------------------------------------------------------------------
      subroutine uzprec (rpcg,rcg,h1m1,h2m1,intype,wp)
C--------------------------------------------------------------------
C
C     Uzawa preconditioner
C
C--------------------------------------------------------------------
      include 'SIZE'
      include 'GEOM'
      include 'INPUT'
      include 'MASS'
      include 'TSTEP'
      include 'PARALLEL'
c
      REAL           RPCG (LX2,LY2,LZ2,LELV)
      REAL           RCG  (LX2,LY2,LZ2,LELV)
      REAL           WP   (LX2,LY2,LZ2,LELV)
      REAL           H1M1 (LX1,LY1,LZ1,LELV)
      REAL           H2M1 (LX1,LY1,LZ1,LELV)
      COMMON /SCRCH/ H1M2 (LX2,LY2,LZ2,LELV)
     $ ,             H2M2 (LX2,LY2,LZ2,LELV)
C
      integer kstep
      save    kstep
      data    kstep/-1/
c
      integer*8 ntotg,nxyz2
c
      NTOT2 = lx2*ly2*lz2*NELV
      if (istep.ne.kstep .and. .not.ifanls) then
         kstep=istep
         DO 100 IE=1,NELV
            CALL MAP12 (H1M2(1,1,1,IE),H1M1(1,1,1,IE),IE)
            CALL MAP12 (H2M2(1,1,1,IE),H2M1(1,1,1,IE),IE)
 100     CONTINUE
      endif
C
      IF (INTYPE.EQ.0) THEN
         CALL COL3        (WP,RCG,H1M2,NTOT2)
         CALL COL3        (RPCG,WP,BM2INV,NTOT2)
      ELSEIF (INTYPE.EQ.-1) THEN
         CALL EPREC       (WP,RCG)
         CALL COL2        (WP,H2M2,NTOT2)
         CALL COL3        (RPCG,RCG,BM2INV,NTOT2)
         CALL COL2        (RPCG,H1M2,NTOT2)
         CALL ADD2        (RPCG,WP,NTOT2)
      ELSEIF (INTYPE.EQ.1) THEN
         if (ifanls) then
            CALL EPREC2      (RPCG,RCG)
            DTBD = BD(1)/DT
            CALL cmult       (RPCG,DTBD,ntot2)
         else
            CALL EPREC2      (RPCG,RCG)
c           CALL COL2        (RPCG,H2M2,NTOT2)
         endif
      ELSE
         CALL COPY        (RPCG,RCG,NTOT2)
      ENDIF

      call ortho (rpcg)

      return
      end
C
      subroutine eprec (z2,r2)
C----------------------------------------------------------------
C
C     Precondition the explicit pressure operator (E) with
C     a Neumann type (H1) Laplace operator: JT*A*J.
C     Invert A by conjugate gradient iteration or multigrid.
C
C     NOTE: SCRNS is used.
C
C----------------------------------------------------------------
      include 'SIZE'
      include 'INPUT'
      include 'GEOM'
      include 'SOLN'
      include 'MASS'
      include 'PARALLEL'
      include 'TSTEP'
      REAL           Z2   (LX2,LY2,LZ2,LELV)
      REAL           R2   (LX2,LY2,LZ2,LELV)
      COMMON /SCRNS/ MASK (LX1,LY1,LZ1,LELV)
     $              ,R1   (LX1,LY1,LZ1,LELV)
     $              ,X1   (LX1,LY1,LZ1,LELV)
     $              ,W2   (LX2,LY2,LZ2,LELV)
     $              ,H1   (LX1,LY1,LZ1,LELV)
     $              ,H2   (LX1,LY1,LZ1,LELV)
      REAL    MASK
      COMMON /CPRINT/ IFPRINT, IFHZPC
      LOGICAL         IFPRINT, IFHZPC
      integer*8 ntotg,nxyz
 
      nxyz   = lx1*ly1*lz1
      ntotg  = nxyz*nelgv
      ntot1  = nxyz*nelv
      ntot2  = lx2*ly2*lz2*nelv
      nfaces = 2*ldim
C
C     Set the tolerance for the preconditioner
C
      CALL COL3 (W2,R2,BM2INV,NTOT2)
      RINIT  = SQRT(GLSC2(W2,R2,NTOT2)/VOLVM2)
      EPS    = 0.02
      TOL    = EPS*RINIT
c     if (param(91).gt.0) tol=param(91)*rinit
c     if (param(91).lt.0) tol=-param(91)
C
      DO 100 IEL=1,NELV
         CALL MAP21E (R1(1,1,1,IEL),R2(1,1,1,IEL),IEL)
 100  CONTINUE
C
      if (ifvcor) then
         otr1 = glsum (r1,ntot1)
         call rone  (x1,ntot1)
         c2   = -otr1/ntotg
         call add2s2 (r1,x1,c2,ntot1)
C
         OTR1 = GLSUM (R1,NTOT1)
         TOLMIN = 10.*ABS(OTR1)
         IF (TOL .LT. TOLMIN) THEN
             if (nid.eq.0) 
     $       write(6,*) 'Resetting tol in EPREC:(old,new)',tol,tolmin
             TOL = TOLMIN
         ENDIF
      ENDIF
C
      CALL RONE    (H1,NTOT1)
      CALL RZERO   (H2,NTOT1)
      IFHZPC = .TRUE.
      CALL HMHOLTZ ('PREC',X1,R1,H1,H2,PMASK,VMULT,IMESH,TOL,NMXP,1)
      IFHZPC = .FALSE.
C
      DO 200 IEL=1,NELV
         CALL MAP12 (Z2(1,1,1,IEL),X1(1,1,1,IEL),IEL)
 200  CONTINUE
C
      return
      END
C
      subroutine convprn (iconv,rbnorm,rrpt,res,z,tol)
C-----------------------------------------------------------------
C                                               T
C     Convergence test for the pressure step;  r z
C
C-----------------------------------------------------------------
      include 'SIZE'
      include 'MASS'
      REAL           RES  (1)
      REAL           Z    (1)
      REAL           wrk1(2),wrk2(2)
c
      ntot2   = lx2*ly2*lz2*nelv
      wrk1(1) = vlsc21 (res,bm2inv,ntot2)  !  res*bm2inv*res
      wrk1(2) = vlsc2  (res,z     ,ntot2)  !  res*z
      call gop(wrk1,wrk2,'+  ',2)
      rbnorm  = sqrt(wrk1(1)/volvm2)
      rrpt    = wrk1(2)
c
c     CALL CONVPR (RCG,tolpss,ICONV,RNORM)
c     RRP1 = GLSC2 (RPCG,RCG,NTOT2)
c     RBNORM = SQRT (GLSC2 (BM2,TB,NTOT2)/VOLVM2)
c
      ICONV  = 0
      IF (RBNORM.LT.TOL) ICONV=1
      return
      END
C
      subroutine convpr (res,tol,iconv,rbnorm)
C-----------------------------------------------------------------
C
C     Convergence test for the pressure step
C
C-----------------------------------------------------------------
      include 'SIZE'
      include 'MASS'
      REAL           RES  (LX2,LY2,LZ2,LELV)
      COMMON /SCRMG/ TA   (LX2,LY2,LZ2,LELV)
     $ ,             TB   (LX2,LY2,LZ2,LELV)
C
      RBNORM = 0.
      NTOT2  = lx2*ly2*lz2*NELV
      CALL COL3     (TA,RES,BM2INV,NTOT2)
      CALL COL3     (TB,TA,TA,NTOT2)
      RBNORM = SQRT (GLSC2 (BM2,TB,NTOT2)/VOLVM2)
c
      ICONV  = 0
      IF (RBNORM.LT.TOL) ICONV=1
      return
      END
C
      subroutine chktcg2 (tol,res,iconv)
C-------------------------------------------------------------------
C
C     Check that the tolerances are not too small for the CG-solver.
C     Important when calling the CG-solver (Gauss  mesh) with
C     all Dirichlet velocity b.c. (zero Neumann for the pressure).
C
C-------------------------------------------------------------------
      include 'SIZE'
      include 'GEOM'
      include 'INPUT'
      include 'MASS'
      include 'TSTEP'
      REAL           RES (LX2,LY2,LZ2,LELV)
      COMMON /CTMP0/ TA  (LX2,LY2,LZ2,LELV)
     $ ,             TB  (LX2,LY2,LZ2,LELV)
      COMMON /CPRINT/ IFPRINT
      LOGICAL         IFPRINT
C
      ICONV = 0
C
C     Single or double precision???
C
      DELTA = 1.E-9
      X     = 1.+DELTA
      Y     = 1.
      DIFF  = ABS(X-Y)
      IF (DIFF.EQ.0.) EPS = 1.E-5
      IF (DIFF.GT.0.) EPS = 1.E-10
C
C     Relaxed pressure iteration; maximum decrease in the residual (ER)
C
      IF (PRELAX.NE.0.) EPS = PRELAX
C
      NTOT2 = lx2*ly2*lz2*NELV
      CALL COL3     (TA,RES,BM2INV,NTOT2)
      CALL COL3     (TB,TA,TA,NTOT2)
      CALL COL2     (TB,BM2,NTOT2)
      RINIT = SQRT( GLSUM (TB,NTOT2)/VOLVM2 )
      IF (RINIT.LT.TOL) THEN
         ICONV = 1
         return
      ENDIF
      IF (TOLPDF.GT.0.) THEN
         RMIN = TOLPDF
      ELSE
         RMIN  = EPS*RINIT
      ENDIF
      IF (TOL.LT.RMIN) THEN
         TOLOLD = TOL
         TOL = RMIN
         IF (NIO.EQ.0 .AND. IFPRINT) WRITE (6,*)
     $   'New CG2-tolerance (RINIT*10-5/10-10) = ',TOL,TOLOLD
      ENDIF
      IF (IFVCOR) THEN
         OTR = GLSUM (RES,NTOT2)
         TOLMIN = ABS(OTR)*100.
         IF (TOL .LT. TOLMIN) THEN
             TOLOLD = TOL
             TOL = TOLMIN
             IF (NIO.EQ.0 .AND. IFPRINT)
     $       WRITE (6,*) 'New CG2-tolerance (OTR) = ',TOLMIN,TOLOLD
         ENDIF
      ENDIF
      return
      END
C
      subroutine dudxyz (du,u,rm1,sm1,tm1,jm1,imsh,isd)
C--------------------------------------------------------------
C
C     DU   - dU/dx or dU/dy or dU/dz
C     U    - a field variable defined on mesh 1
C     RM1  - dr/dx or dr/dy or dr/dz  
C     SM1  - ds/dx or ds/dy or ds/dz
C     TM1  - dt/dx or dt/dy or dt/dz
C     JM1  - the Jacobian   
C     IMESH - topology: velocity (1) or temperature (2) mesh
C
C--------------------------------------------------------------
      include 'SIZE'
      include 'DXYZ'
      include 'GEOM'
      include 'INPUT'
      include 'TSTEP'
C
      REAL  DU  (LX1,LY1,LZ1,1)
      REAL  U   (LX1,LY1,LZ1,1)
      REAL  RM1 (LX1,LY1,LZ1,1)
      REAL  SM1 (LX1,LY1,LZ1,1)
      REAL  TM1 (LX1,LY1,LZ1,1)
      REAL  JM1 (LX1,LY1,LZ1,1)
C
      COMMON /FASTMD/ IFDFRM(LELT), IFFAST(LELT), IFH2, IFSOLV
      LOGICAL IFDFRM, IFFAST, IFH2, IFSOLV
C
      REAL  DRST(LX1,LY1,LZ1)
C
      IF (imsh.EQ.1) NEL = NELV
      IF (imsh.EQ.2) NEL = NELT
      NXY1  = lx1*ly1
      NYZ1  = ly1*lz1
      NXYZ1 = lx1*ly1*lz1
      NTOT  = NXYZ1*NEL

      DO 1000 IEL=1,NEL
C
      IF (IFAXIS) CALL SETAXDY (IFRZER(IEL) )
C
      IF (ldim.EQ.2) THEN
            CALL MXM     (DXM1,lx1,U(1,1,1,IEL),lx1,DU(1,1,1,IEL),NYZ1)
            CALL COL2    (DU(1,1,1,IEL),RM1(1,1,1,IEL),NXYZ1)
            CALL MXM     (U(1,1,1,IEL),lx1,DYTM1,ly1,DRST,ly1)
            CALL ADDCOL3 (DU(1,1,1,IEL),DRST,SM1(1,1,1,IEL),NXYZ1)
      ELSE
            CALL MXM   (DXM1,lx1,U(1,1,1,IEL),lx1,DU(1,1,1,IEL),NYZ1)
            CALL COL2  (DU(1,1,1,IEL),RM1(1,1,1,IEL),NXYZ1)
            DO 20 IZ=1,lz1
               CALL MXM  (U(1,1,IZ,IEL),lx1,DYTM1,ly1,DRST(1,1,IZ),ly1)
 20         CONTINUE
            CALL ADDCOL3 (DU(1,1,1,IEL),DRST,SM1(1,1,1,IEL),NXYZ1)
            CALL MXM     (U(1,1,1,IEL),NXY1,DZTM1,lz1,DRST,lz1)
            CALL ADDCOL3 (DU(1,1,1,IEL),DRST,TM1(1,1,1,IEL),NXYZ1)
      ENDIF
C
 1000 CONTINUE
C
c     CALL INVCOL2 (DU,JM1,NTOT)
      CALL COL2 (DU,JACMI,NTOT)
C
      return
      END
C
      subroutine convopo (conv,fi)
C--------------------------------------------------------------------
C
C     Compute the convective term CONV for a passive scalar field FI
C     using the skew-symmetric formulation.
C     The field variable FI is defined on mesh M1 (GLL) and
C     the velocity field is assumed given.
C
C     IMPORTANT NOTE: Use the scratch-arrays carefully!!!!!
C
C     The common-block SCRNS is used in CONV1 and CONV2.
C     The common-blocks CTMP0 and CTMP1 are also used as scratch-arrays
C     since there is no direct stiffness summation or Helmholtz-solves. 
C
C--------------------------------------------------------------------
      include 'SIZE'
      include 'TOTAL'
C
C     Use the common blocks CTMP0 and CTMP1 as work space.
C
      COMMON /SCRCH/  CMASK1 (LX1,LY1,LZ1,LELV)
     $ ,              CMASK2 (LX1,LY1,LZ1,LELV)
      COMMON /CTMP1/  MFI    (LX1,LY1,LZ1,LELV)
     $ ,              DMFI   (LX1,LY1,LZ1,LELV)
     $ ,              MDMFI  (LX1,LY1,LZ1,LELV)
      REAL   MFI,DMFI,MDMFI
C
C     Arrays in parameter list
C
      REAL    CONV (LX1,LY1,LZ1,1) 
      REAL    FI   (LX1,LY1,LZ1,1)
C
C
      NXYZ1 = lx1*ly1*lz1
      NTOT1 = lx1*ly1*lz1*NELV
      NTOTZ = lx1*ly1*lz1*NELT
C
      CALL RZERO  (CONV,NTOTZ)
C
      IF (PARAM(86).EQ.0.0) THEN
C        Always use the convective form !!! (ER)
         CALL CONV1 (CONV,FI)
      ELSE
C        Use skew-symmetric form
C
C        Generate operator mask arrays CMASK1 and CMASK2
C
         CALL CMASK  (CMASK1,CMASK2)
C
         CALL COL3   (MFI,FI,CMASK1,NTOT1)
         CALL CONV1  (DMFI,MFI)
         CALL COL3   (MDMFI,DMFI,CMASK1,NTOT1)
         CALL ADD2S2 (CONV,MDMFI,0.5,NTOT1)
C
         CALL COL3   (MDMFI,DMFI,CMASK2,NTOT1)
         CALL ADD2   (CONV,MDMFI,NTOT1)      
C
         CALL CONV2  (DMFI,MFI)
         CALL COL3   (MDMFI,DMFI,CMASK1,NTOT1)
         CALL ADD2S2 (CONV,MDMFI,-0.5,NTOT1)
C
         CALL COL3   (MFI,FI,CMASK2,NTOT1)
         CALL CONV1  (DMFI,MFI)
         CALL COL3   (MDMFI,DMFI,CMASK2,NTOT1)
         CALL ADD2S2 (CONV,MDMFI,0.5,NTOT1)
C
         CALL CONV2  (DMFI,MFI)
         CALL COL3   (MDMFI,DMFI,CMASK1,NTOT1)
         CALL ADD2S2 (CONV,MDMFI,-1.,NTOT1)
C
         CALL COL3   (MDMFI,DMFI,CMASK2,NTOT1)
         CALL ADD2S2 (CONV,MDMFI,0.5,NTOT1)      
      ENDIF
C
      return
      END
c-----------------------------------------------------------------------
      subroutine conv2 (dtfi,fi)
C--------------------------------------------------------------------
C
C     Compute DT*FI (part of the convection operator)
C
C--------------------------------------------------------------------
      include 'SIZE'
      include 'TOTAL'
      REAL           DTFI (LX1,LY1,LZ1,1) 
      REAL           FI   (LX1,LY1,LZ1,1)
      COMMON /SCRNS/ TA1  (LX1,LY1,LZ1,LELV)
     $ ,             TA2  (LX1,LY1,LZ1,LELV)
     $ ,             TA3  (LX1,LY1,LZ1,LELV)
     $ ,             TB1  (LX1,LY1,LZ1,LELV)
     $ ,             TB2  (LX1,LY1,LZ1,LELV)
     $ ,             TB3  (LX1,LY1,LZ1,LELV)
C
      NXY1  = lx1*ly1
      NYZ1  = ly1*lz1
      NXYZ1 = lx1*ly1*lz1
      NTOT1 = lx1*ly1*lz1*NELV
C
      CALL RZERO(DTFI,NTOT1)
C
      IF (ldim .EQ. 2) THEN
C
C     2-dimensional case
C
      CALL COL4 (TA1,RXM1,VX,FI,NTOT1)
      CALL COL4 (TA2,RYM1,VY,FI,NTOT1)
      CALL ADD2 (TA1,TA2,NTOT1)
      DO 200 IEL=1,NELV
         CALL COL2    (TA1(1,1,1,IEL),W3M1,NXYZ1)
         CALL MXM     (DXTM1,lx1,TA1(1,1,1,IEL),lx1,TB1(1,1,1,IEL),ly1)
 200  CONTINUE
      CALL COPY(DTFI,TB1,NTOT1)
C
      CALL COL4 (TA1,SXM1,VX,FI,NTOT1)
      CALL COL4 (TA2,SYM1,VY,FI,NTOT1)
      CALL ADD2 (TA1,TA2,NTOT1)
      DO 300 IEL=1,NELV
         CALL COL2    (TA1(1,1,1,IEL),W3M1,NXYZ1)
         CALL MXM     (TA1(1,1,1,IEL),lx1,DYM1,ly1,TB1(1,1,1,IEL),ly1)
 300  CONTINUE
      CALL ADD2    (DTFI,TB1,NTOT1)
      CALL INVCOL2 (DTFI,BM1,NTOT1)
C
      ELSE
C
C     3-dimensional case
C      
      CALL COL4 (TA1,RXM1,VX,FI,NTOT1)
      CALL COL4 (TA2,RYM1,VY,FI,NTOT1)
      CALL COL4 (TA3,RZM1,VZ,FI,NTOT1)
      CALL ADD2 (TA1,TA2,NTOT1)
      CALL ADD2 (TA1,TA3,NTOT1)
      DO 600 IEL=1,NELV
         CALL COL2    (TA1(1,1,1,IEL),W3M1,NXYZ1)
         CALL MXM     (DXTM1,lx1,TA1(1,1,1,IEL),lx1,TB1(1,1,1,IEL),NYZ1)
 600  CONTINUE
      CALL COPY(DTFI,TB1,NTOT1)
C
      CALL COL4 (TA1,SXM1,VX,FI,NTOT1)
      CALL COL4 (TA2,SYM1,VY,FI,NTOT1)
      CALL COL4 (TA3,SZM1,VZ,FI,NTOT1)
      CALL ADD2 (TA1,TA2,NTOT1)
      CALL ADD2 (TA1,TA3,NTOT1)
      DO 700 IEL=1,NELV
         CALL COL2    (TA1(1,1,1,IEL),W3M1,NXYZ1)
         DO 710 IZ=1,lz1
            CALL MXM (TA1(1,1,IZ,IEL),lx1,DYM1,ly1,TB1(1,1,IZ,IEL),ly1)
 710     CONTINUE
 700  CONTINUE
      CALL ADD2    (DTFI,TB1,NTOT1)
C
      CALL COL4 (TA1,TXM1,VX,FI,NTOT1)
      CALL COL4 (TA2,TYM1,VY,FI,NTOT1)
      CALL COL4 (TA3,TZM1,VZ,FI,NTOT1)
      CALL ADD2 (TA1,TA2,NTOT1)
      CALL ADD2 (TA1,TA3,NTOT1)
      DO 800 IEL=1,NELV
         CALL COL2    (TA1(1,1,1,IEL),W3M1,NXYZ1)
         CALL MXM     (TA1(1,1,1,IEL),NXY1,DZM1,lz1,TB1(1,1,1,IEL),lz1)
 800  CONTINUE
      CALL ADD2    (DTFI,TB1,NTOT1)
      CALL INVCOL2 (DTFI,BM1,NTOT1)
C
      ENDIF
C
      return
      END
C
      subroutine cmask (cmask1,cmask2)
C---------------------------------------------------------------
C
C     Generate maskarrays for the convection operator
C
C       CMASK1   =  1.0 in the interior
C                =  0.0 at outflow
C       CMASK2   =  0.0 in the interior
C                =  1.0 at outflow
C
C---------------------------------------------------------------
      include 'SIZE'
      include 'INPUT'
      include 'TSTEP'
C
      REAL CMASK1 (LX1,LY1,LZ1,LELV)
      REAL CMASK2 (LX1,LY1,LZ1,LELV)
C
      CHARACTER CB*1
C
      NTOT1  = lx1*ly1*lz1*NELV
      NFACES = 2*ldim
      CALL CFILL (CMASK1,1.,NTOT1)
      CALL CFILL (CMASK2,0.,NTOT1)
      DO 100 IEL=1,NELV
      DO 100 IFACE=1,NFACES
         CB = CBC (IFACE,IEL,IFIELD)
         IF (CB.EQ.'O' .OR. CB.EQ.'o') THEN
            CALL FACEV (CMASK1,IEL,IFACE,0.,lx1,ly1,lz1)
            CALL FACEV (CMASK2,IEL,IFACE,1.,lx1,ly1,lz1)
         ENDIF
 100  CONTINUE
      return
      END
C
      subroutine makef
C---------------------------------------------------------------------
C
C     Compute and add: (1) user specified forcing function (FX,FY,FZ)
C                      (2) driving force due to natural convection
C                      (3) convection term
C
C     !! NOTE: Do not change the arrays BFX, BFY, BFZ until the
C              current time step is completed.
C
C----------------------------------------------------------------------
      include 'SIZE'
      include 'SOLN'
      include 'MASS'
      include 'INPUT'
      include 'TSTEP'
      include 'CTIMER'
      include 'MVGEOM'

      etime1 = dnekclock()
                                                call makeuf
      if (filterType.eq.2)                      call make_hpf
      if (ifexplvis.and.ifsplit)                call makevis
      if (ifnav .and..not.ifchar)               call advab
      if (ifmvbd.and..not.ifchar)               call admeshv
      if (iftran)                               call makeabf
      if ((iftran.and..not.ifchar).or.
     $    (iftran.and..not.ifnav.and.ifchar))   call makebdf
      if (ifnav.and.ifchar)                     call advchar

c     Adding this call allows prescribed pressure bc for PnPn-2
c     if (.not.ifsplit.and..not.ifstrs)         call bcneutr
      
      tmakf=tmakf+(dnekclock()-etime1)

      return
      end
c
      subroutine makeuf
C---------------------------------------------------------------------
C
C     Compute and add: (1) user specified forcing function (FX,FY,FZ)
C
C----------------------------------------------------------------------
      include 'SIZE'
      include 'SOLN'
      include 'MASS'
      include 'TSTEP'
C
      TIME = TIME-DT
      CALL NEKUF   (BFX,BFY,BFZ)
      CALL OPCOLV  (BFX,BFY,BFZ,BM1)
      TIME = TIME+DT
C
      return
      END
C
      subroutine nekuf (f1,f2,f3)
      include 'SIZE'
      include 'PARALLEL'
      include 'NEKUSE'
      include 'CTIMER'

      REAL F1 (LX1,LY1,LZ1,LELV)
      REAL F2 (LX1,LY1,LZ1,LELV)
      REAL F3 (LX1,LY1,LZ1,LELV)

#ifdef TIMER
      etime1=dnekclock_sync()
#endif

      CALL OPRZERO (F1,F2,F3)
      DO 100 IEL=1,NELV
         ielg = lglel(iel)
         DO 100 K=1,lz1
         DO 100 J=1,ly1
         DO 100 I=1,lx1
            if (optlevel.le.2) CALL NEKASGN (I,J,K,IEL)
            CALL USERF   (I,J,K,IELG)
            F1(I,J,K,IEL) = FFX
            F2(I,J,K,IEL) = FFY
            F3(I,J,K,IEL) = FFZ
 100  CONTINUE

#ifdef TIMER
      tusfq=tusfq+(dnekclock()-etime1)
#endif

      return
      END
C
      subroutine advab
C---------------------------------------------------------------
C
C     Eulerian scheme, add convection term to forcing function 
C     at current time step.
C
C---------------------------------------------------------------
      include 'SIZE'
      include 'SOLN'
      include 'MASS'
      include 'TSTEP'
C
      COMMON /SCRUZ/ TA1 (LX1,LY1,LZ1,LELV)
     $ ,             TA2 (LX1,LY1,LZ1,LELV)
     $ ,             TA3 (LX1,LY1,LZ1,LELV)
C
      NTOT1 = lx1*ly1*lz1*NELV
      CALL CONVOP  (TA1,VX)
      CALL CONVOP  (TA2,VY)
      CALL SUBCOL3 (BFX,BM1,TA1,NTOT1)
      CALL SUBCOL3 (BFY,BM1,TA2,NTOT1)
      IF (ldim.EQ.2) THEN
         CALL RZERO (TA3,NTOT1)
      ELSE
         CALL CONVOP  (TA3,VZ)
         CALL SUBCOL3 (BFZ,BM1,TA3,NTOT1)
      ENDIF
C

      return
      END
c-----------------------------------------------------------------------
      subroutine makebdf
C
C     Add contributions to F from lagged BD terms.
C
      include 'SIZE'
      include 'SOLN'
      include 'MASS'
      include 'GEOM'
      include 'INPUT'
      include 'TSTEP'
C
      COMMON /SCRNS/ TA1(LX1,LY1,LZ1,LELV)
     $ ,             TA2(LX1,LY1,LZ1,LELV)
     $ ,             TA3(LX1,LY1,LZ1,LELV)
     $ ,             TB1(LX1,LY1,LZ1,LELV)
     $ ,             TB2(LX1,LY1,LZ1,LELV)
     $ ,             TB3(LX1,LY1,LZ1,LELV)
     $ ,             H2 (LX1,LY1,LZ1,LELV)
C
      NTOT1 = lx1*ly1*lz1*NELV
      CONST = 1./DT

      if(iflomach) then
        call cfill(h2,CONST,ntot1)
      else
        call cmult2(h2,vtrans(1,1,1,1,ifield),const,ntot1)
      endif

      CALL OPCOLV3c (TB1,TB2,TB3,VX,VY,VZ,BM1,bd(2))
C
      DO 100 ILAG=2,NBD
         IF (IFGEOM) THEN
            CALL OPCOLV3c(TA1,TA2,TA3,VXLAG (1,1,1,1,ILAG-1),
     $                                VYLAG (1,1,1,1,ILAG-1),
     $                                VZLAG (1,1,1,1,ILAG-1),
     $                                BM1LAG(1,1,1,1,ILAG-1),bd(ilag+1))
         ELSE
            CALL OPCOLV3c(TA1,TA2,TA3,VXLAG (1,1,1,1,ILAG-1),
     $                                VYLAG (1,1,1,1,ILAG-1),
     $                                VZLAG (1,1,1,1,ILAG-1),
     $                                BM1                   ,bd(ilag+1))
         ENDIF
         CALL OPADD2  (TB1,TB2,TB3,TA1,TA2,TA3)
 100  CONTINUE
      CALL OPADD2col (BFX,BFY,BFZ,TB1,TB2,TB3,h2)
C
      return
      END
c-----------------------------------------------------------------------
      subroutine makeabf
C-----------------------------------------------------------------------
C
C     Sum up contributions to kth order extrapolation scheme.
C
C-----------------------------------------------------------------------
      include 'SIZE'
      include 'INPUT'
      include 'SOLN'
      include 'TSTEP'
C
      COMMON /SCRUZ/ TA1 (LX1,LY1,LZ1,LELV)
     $ ,             TA2 (LX1,LY1,LZ1,LELV)
     $ ,             TA3 (LX1,LY1,LZ1,LELV)
C
      NTOT1 = lx1*ly1*lz1*NELV
C
      AB0 = AB(1)
      AB1 = AB(2)
      AB2 = AB(3)
      CALL ADD3S2 (TA1,ABX1,ABX2,AB1,AB2,NTOT1)
      CALL ADD3S2 (TA2,ABY1,ABY2,AB1,AB2,NTOT1)
      CALL COPY   (ABX2,ABX1,NTOT1)
      CALL COPY   (ABY2,ABY1,NTOT1)
      CALL COPY   (ABX1,BFX,NTOT1)
      CALL COPY   (ABY1,BFY,NTOT1)
      CALL ADD2S1 (BFX,TA1,AB0,NTOT1)
      CALL ADD2S1 (BFY,TA2,AB0,NTOT1)
      if(.not.iflomach) CALL COL2   (BFX,VTRANS,NTOT1)          ! multiply by density
      if(.not.iflomach) CALL COL2   (BFY,VTRANS,NTOT1)
      IF (ldim.EQ.3) THEN
         CALL ADD3S2 (TA3,ABZ1,ABZ2,AB1,AB2,NTOT1)
         CALL COPY   (ABZ2,ABZ1,NTOT1)
         CALL COPY   (ABZ1,BFZ,NTOT1)
         CALL ADD2S1 (BFZ,TA3,AB0,NTOT1)
         if(.not.iflomach) CALL COL2   (BFZ,VTRANS,NTOT1)
      ENDIF
C
      return
      END
C
c-----------------------------------------------------------------------
      subroutine setab3 (ab0,ab1,ab2)
C
C     Set coefficients for 3rd order Adams-Bashforth scheme
C     (variable time step).
C
      include 'SIZE'
      include 'TSTEP'
C
      IF (ISTEP.LE.2) THEN
         AB0 = 1.
         AB1 = 0.
         AB2 = 0.
      ELSE
         DT0 = DTLAG(1)
         DT1 = DTLAG(2)
         DT2 = DTLAG(3)
         AB2  = (DT0/DT2)*((DT0/3.+DT1/2.)/(DT1+DT2))
         AB1  = -(DT0/DT1)*(0.5+(DT0/3.+DT1/2.)/DT2)
         AB0  = 1.-AB1-AB2 
      ENDIF
      return
      END
C
      subroutine setabbd (ab,dtlag,nab,nbd)
C-----------------------------------------------------------------------
C
C     Compute Adams-Bashforth coefficients (order NAB, less or equal to 3)
C     
C     NBD .EQ. 1
C     Standard Adams-Bashforth coefficients 
C
C     NBD .GT. 1
C     Modified Adams-Bashforth coefficients to be used in con-
C     junction with Backward Differentiation schemes (order NBD)
C
C-----------------------------------------------------------------------
      REAL AB(NAB),DTLAG(NAB)
C
      DT0 = DTLAG(1)
      DT1 = DTLAG(2)
      DT2 = DTLAG(3)
C
      IF ( NAB.EQ.1 ) THEN
C
          AB(1) = 1.0
C
      ELSEIF ( NAB.EQ.2 ) THEN
C
          DTA =  DT0/DT1
C
          IF ( NBD.EQ.1 ) THEN
C
          AB(2) = -0.5*DTA
          AB(1) =  1.0 - AB(2)
C
          ELSEIF ( NBD.EQ.2 ) THEN
C
          AB(2) = -DTA
          AB(1) =  1.0 - AB(2)
C
          ENDIF
C
      ELSEIF ( NAB.EQ.3 ) THEN
C
          DTS =  DT1 + DT2
          DTA =  DT0 / DT1
          DTB =  DT1 / DT2
          DTC =  DT0 / DT2
          DTD =  DTS / DT1
          DTE =  DT0 / DTS
C
          IF ( NBD.EQ.1 ) THEN
C
          AB(3) =  DTE*( 0.5*DTB + DTC/3. )
          AB(2) = -0.5*DTA - AB(3)*DTD
          AB(1) =  1.0 - AB(2) - AB(3)
C
          ELSEIF ( NBD.EQ.2 ) THEN
C
          AB(3) =  2./3.*DTC*(1./DTD + DTE)
          AB(2) = -DTA - AB(3)*DTD
          AB(1) =  1.0 - AB(2) - AB(3)
C
          ELSEIF ( NBD.EQ.3 ) THEN
C
          AB(3) =  DTE*(DTB + DTC)
          AB(2) = -DTA*(1.0 + DTB + DTC)
          AB(1) =  1.0 - AB(2) - AB(3)
C
          ENDIF
C
      ENDIF
C
      return
      END
C
      subroutine setbd (bd,dtbd,nbd)
C-----------------------------------------------------------------------
C
C     Compute bacward-differentiation coefficients of order NBD
C
C-----------------------------------------------------------------------
      PARAMETER (ldim = 10)
      REAL BDMAT(ldim,ldim),BDRHS(ldim)
      INTEGER IR(ldim),IC(ldim)
      REAL BD(1),DTBD(1)
C
      IF (NBD.EQ.1) THEN
         BD(1) = 1.
         BDF   = 1.
      ELSEIF (NBD.GE.2) THEN
         NSYS = NBD+1
         CALL BDSYS (BDMAT,BDRHS,DTBD,NBD,ldim)
         CALL LU    (BDMAT,NSYS,ldim,IR,IC)
         CALL SOLVE (BDRHS,BDMAT,1,NSYS,ldim,IR,IC)
         DO 30 I=1,NBD
            BD(I) = BDRHS(I)
 30      CONTINUE
         BDF = BDRHS(NBD+1)
      ENDIF
C
C     Normalize
C
      DO 100 IBD=NBD,1,-1
         BD(IBD+1) = BD(IBD)
 100  CONTINUE
      BD(1) = 1.
      DO 200 IBD=1,NBD+1
         BD(IBD) = BD(IBD)/BDF
 200  CONTINUE
c     write(6,1) (bd(k),k=1,nbd+1)
c   1 format('bd:',1p8e13.5)
C
      return
      END
C
      subroutine bdsys (a,b,dt,nbd,ldim)
      REAL A(ldim,9),B(9),DT(9)
      CALL RZERO (A,ldim**2)
      N = NBD+1
      DO 10 J=1,NBD
         A(1,J) = 1.
 10   CONTINUE
      A(1,NBD+1) = 0.
      B(1) = 1.
      DO 20 J=1,NBD
         SUMDT = 0.
         DO 25 K=1,J
            SUMDT = SUMDT+DT(K)
 25      CONTINUE
         A(2,J) = SUMDT
 20   CONTINUE
      A(2,NBD+1) = -DT(1)
      B(2) = 0.
      DO 40 I=3,NBD+1
      DO 30 J=1,NBD
         SUMDT = 0.
         DO 35 K=1,J
            SUMDT = SUMDT+DT(K)
 35      CONTINUE
         A(I,J) = SUMDT**(I-1)
 30   CONTINUE
      A(I,NBD+1) = 0.
      B(I) = 0.
 40   CONTINUE
      return
      END
C
      subroutine tauinit (tau,ilag)
C-------------------------------------------------------------------
C
C     Set initial time for subintegration 
C
C-------------------------------------------------------------------
      include 'SIZE'
      include 'TSTEP'
      TAU   = 0.
      DO 10 I=NBD,ILAG+1,-1
         TAU = TAU+DTLAG(I)
 10   CONTINUE
      return
      END
C
      subroutine velinit (vel1,vel2,vel3,ilag)
C-------------------------------------------------------------------
C
C     Set initial conditions for subintegration
C
C-------------------------------------------------------------------
      include 'SIZE'
      include 'SOLN'
      REAL VEL1 (LX1,LY1,LZ1,LELV)
      REAL VEL2 (LX1,LY1,LZ1,LELV)
      REAL VEL3 (LX1,LY1,LZ1,LELV)
      IF (ILAG.EQ.1) THEN
         CALL OPCOPY (VEL1,VEL2,VEL3,VX,VY,VZ)
      ELSE
         CALL OPCOPY (VEL1,VEL2,VEL3,VXLAG(1,1,1,1,ILAG-1)
     $                              ,VYLAG(1,1,1,1,ILAG-1)
     $                              ,VZLAG(1,1,1,1,ILAG-1) )
      ENDIF
      return
      END
C
      subroutine velconv (vxn,vyn,vzn,tau)
C--------------------------------------------------------------------
C
C     Compute convecting velocity field (linearization)
C
C--------------------------------------------------------------------
      include 'SIZE'
      include 'SOLN'
      include 'TSTEP'
      REAL VXN (LX1,LY1,LZ1,LELV)
      REAL VYN (LX1,LY1,LZ1,LELV)
      REAL VZN (LX1,LY1,LZ1,LELV)
      CALL VELCHAR (VX,VXN,VXLAG,NBD,TAU,DTLAG)
      CALL VELCHAR (VY,VYN,VYLAG,NBD,TAU,DTLAG)
      IF (ldim.EQ.3) 
     $CALL VELCHAR (VZ,VZN,VZLAG,NBD,TAU,DTLAG)
      return
      END
C
      subroutine frkconv (y,x,mask)
C--------------------------------------------------------------------
C
C     Evaluate right-hand-side for Runge-Kutta scheme in the case of
C     pure convection.
C
C--------------------------------------------------------------------
      include 'SIZE'
      include 'MASS'
      include 'TSTEP'
      REAL Y    (LX1,LY1,LZ1,1)
      REAL X    (LX1,LY1,LZ1,1)
      REAL MASK (LX1,LY1,LZ1,1)
C
      IF (IMESH.EQ.1) NEL=NELV
      IF (IMESH.EQ.2) NEL=NELT
      NTOT1 = lx1*ly1*lz1*NEL
      CALL CONVOP (Y,X)
      CALL COL2   (Y,BM1,NTOT1)
      CALL DSSUM  (Y,lx1,ly1,lz1)
      IF (IMESH.EQ.1) CALL COL2 (Y,BINVM1,NTOT1)
      IF (IMESH.EQ.2) CALL COL2 (Y,BINTM1,NTOT1)
      CALL COL2   (Y,MASK,NTOT1)
C
      return
      END
C
      subroutine velchar (vel,vn,vlag,nbd,tau,dtbd)
C-----------------------------------------------------------------------
C
C     Compute linearized velocity field.
C
C-----------------------------------------------------------------------
      include 'SIZE'
      REAL VEL  (LX1,LY1,LZ1,LELV)
      REAL VN   (LX1,LY1,LZ1,LELV)
      REAL VLAG (LX1,LY1,LZ1,LELV,9)
      REAL DTBD (NBD)
C
      NTOT1 = lx1*ly1*lz1*NELV
      IF (NBD.EQ.1) THEN
         CALL COPY (VEL,VN,NTOT1)
         return
      ELSEIF (NBD.EQ.2) THEN
         C1 = TAU/DTBD(2)
         C2 = 1.-C1
         CALL ADD3S2 (VEL,VN,VLAG,C1,C2,NTOT1)
      ELSEIF (NBD.EQ.3) THEN
         F1 = TAU**2-DTBD(3)*TAU
         F2 = TAU**2-(DTBD(2)+DTBD(3))*TAU
         F3 = DTBD(2)*DTBD(3)
         F4 = DTBD(2)*(DTBD(2)+DTBD(3))
         R1 = F2/F3
         R2 = F1/F4
         C1 = R2
         C2 = -R1
         C3 = 1+R1-R2
         CALL ADD3S2 (VEL,VLAG(1,1,1,1,1),VLAG(1,1,1,1,2),C2,C3,NTOT1)
         CALL ADD2S2 (VEL,VN,C1,NTOT1)
      ELSE
         WRITE (6,*) 'Need higher order expansion in VELCHAR'
         call exitt
      ENDIF
C
      return
      END
C
      subroutine lagvel
C-----------------------------------------------------------------------
C
C     Keep old velocity field(s) 
C
C-----------------------------------------------------------------------
      include 'SIZE'
      include 'INPUT'
      include 'SOLN'
      include 'TSTEP'
C
      NTOT1 = lx1*ly1*lz1*NELV
C
c      DO 100 ILAG=NBDINP-1,2,-1
      DO 100 ILAG=3-1,2,-1
         CALL COPY (VXLAG (1,1,1,1,ILAG),VXLAG (1,1,1,1,ILAG-1),NTOT1)
         CALL COPY (VYLAG (1,1,1,1,ILAG),VYLAG (1,1,1,1,ILAG-1),NTOT1)
         IF (ldim.EQ.3)
     $   CALL COPY (VZLAG (1,1,1,1,ILAG),VZLAG (1,1,1,1,ILAG-1),NTOT1)
 100  CONTINUE
C
      CALL OPCOPY (VXLAG,VYLAG,VZLAG,VX,VY,VZ)
C
      return
      END
C
      subroutine hypmsk3 (hv1msk,hv2msk,hv3msk)
C---------------------------------------------------------------------
C
C     Generate mask-array for the hyperbolic system (velocity).
C
C---------------------------------------------------------------------
      include 'SIZE'
      include 'INPUT'
      include 'GEOM'
      include 'SOLN'
      include 'TSTEP'
      REAL           HV1MSK (LX1,LY1,LZ1,1)
      REAL           HV2MSK (LX1,LY1,LZ1,1)
      REAL           HV3MSK (LX1,LY1,LZ1,1)
      CHARACTER      CB*3
      PARAMETER (LXYZ1=LX1*LY1*LZ1)
      COMMON /CTMP1/ WORK   (LXYZ1,LELT)
C
      NFACES= 2*ldim
      NTOT1 = lx1*ly1*lz1*NELV
      CALL RZERO (WORK  ,NTOT1)
      CALL RONE  (HV1MSK,NTOT1)
C
      IF (IFIELD.EQ.1) THEN
      DO 100 IE=1,NELV
      DO 100 IFACE=1,NFACES
         CB=CBC(IFACE,IE,IFIELD)
         IF (CB(1:1).EQ.'V' .OR. CB(1:1).EQ.'v') THEN
           CALL FACCL3 (WORK(1,IE),VX(1,1,1,IE),UNX(1,1,IFACE,IE),IFACE)
           CALL FADDCL3(WORK(1,IE),VY(1,1,1,IE),UNY(1,1,IFACE,IE),IFACE)
           IF (IF3D) 
     $     CALL FADDCL3(WORK(1,IE),VZ(1,1,1,IE),UNZ(1,1,IFACE,IE),IFACE)
           CALL FCAVER (VAVER,WORK,IE,IFACE)
C
           IF (VAVER.LT.0.) CALL FACEV (HV1MSK,IE,IFACE,0.0,lx1,ly1,lz1)
         ENDIF
         IF (CB(1:2).EQ.'WS' .OR. CB(1:2).EQ.'ws') 
     $   CALL FACEV (HV1MSK,IE,IFACE,0.0,lx1,ly1,lz1)
 100   CONTINUE
      ENDIF
C
      CALL COPY (HV2MSK,HV1MSK,NTOT1)
      CALL COPY (HV3MSK,HV1MSK,NTOT1)
C
      return
      END
C
      subroutine setordbd
C----------------------------------------------------------------------
C
C     Set up parameters for backward differentiation scheme.
C
C----------------------------------------------------------------------
      include 'SIZE'
      include 'INPUT'
      include 'TSTEP'
C
c     IF (IFSPLIT .OR. NBDINP.EQ.0) THEN     undid hardwire, 3/6/92 pff
      IF ( NBDINP.LT.1) THEN
          NBD = 1
      ELSE
         IF ((ISTEP.EQ.0).OR.(ISTEP.EQ.1))        NBD = 1
         IF ((ISTEP.GT.1).AND.(ISTEP.LE.NBDINP))  NBD = ISTEP
         IF (ISTEP.GT.NBDINP)                     NBD = NBDINP
      ENDIF
C
      return
      END
C
c-----------------------------------------------------------------------
      subroutine normsc (h1,semi,l2,linf,x,imesh)
C---------------------------------------------------------------
C
C     Compute error norms of a (scalar) field variable X 
C     defined on mesh 1 or mesh 2.
C     The error norms are normalized with respect to the volume
C     (except for Linf).
C
C---------------------------------------------------------------
      include 'SIZE'
      include 'MASS'
C
      REAL           X  (LX1,LY1,LZ1,1)
      COMMON /SCRNRM/ Y  (LX1,LY1,LZ1,LELT)
     $               ,TA1(LX1,LY1,LZ1,LELT)
     $               ,TA2(LX1,LY1,LZ1,LELT)
      REAL H1,SEMI,L2,LINF
      REAL LENGTH
C
      IF (IMESH.EQ.1) THEN
         NEL = NELV
         VOL = VOLVM1
      ELSEIF (IMESH.EQ.2) THEN
         NEL = NELT
         VOL = VOLTM1
      ENDIF
      LENGTH = VOL**(1./(ldim))
      NXYZ1  = lx1*ly1*lz1
      NTOT1  = NXYZ1*NEL
C
      H1     = 0.
      SEMI   = 0.
      L2     = 0.
      LINF   = 0.
C
      LINF = GLAMAX (X,NTOT1)
C
      CALL COL3   (TA1,X,X,NTOT1)
      CALL COL2   (TA1,BM1,NTOT1)
      L2   = GLSUM  (TA1,NTOT1)
      IF (L2.LT.0.0) L2 = 0.
C
      CALL RONE   (TA1,NTOT1)
      CALL RZERO  (TA2,NTOT1)
      CALL AXHELM (Y,X,TA1,TA2,IMESH,1)
      CALL COL3   (TA1,Y,X,NTOT1)
      SEMI = GLSUM  (TA1,NTOT1)
      IF (SEMI.LT.0.0) SEMI = 0.
C
      H1   = SQRT((SEMI*LENGTH**2+L2)/VOL)
      SEMI = SQRT(SEMI/VOL)
      L2   = SQRT(L2/VOL)
      IF (H1.LT.0.) H1 = 0.
C
      return
      END
C
      subroutine normvc (h1,semi,l2,linf,x1,x2,x3)
C---------------------------------------------------------------
C
C     Compute error norms of a (vector) field variable (X1,X2,X3)
C     defined on mesh 1 (velocity mesh only !)
C     The error norms are normalized with respect to the volume
C     (except for Linf).
C
C---------------------------------------------------------------
      include 'SIZE'
      include 'MASS'
C
      REAL           X1 (LX1,LY1,LZ1,1)
      REAL           X2 (LX1,LY1,LZ1,1)
      REAL           X3 (LX1,LY1,LZ1,1)
      COMMON /SCRMG/ Y1 (LX1,LY1,LZ1,LELT)
     $              ,Y2 (LX1,LY1,LZ1,LELT)
     $              ,Y3 (LX1,LY1,LZ1,LELT)
     $              ,TA1(LX1,LY1,LZ1,LELT)
      COMMON /SCRCH/ TA2(LX1,LY1,LZ1,LELT)
      REAL H1,SEMI,L2,LINF
      REAL LENGTH
C
      IMESH  = 1
      NEL    = NELV
      VOL    = VOLVM1
      LENGTH = VOL**(1./(ldim))
      NXYZ1  = lx1*ly1*lz1
      NTOT1  = NXYZ1*NEL
C
      H1     = 0.
      SEMI   = 0.
      L2     = 0.
      LINF   = 0.
C
      CALL COL3 (TA1,X1,X1,NTOT1)
      CALL COL3 (TA2,X2,X2,NTOT1)
      CALL ADD2 (TA1,TA2,NTOT1)
      IF (ldim.EQ.3) THEN
      CALL COL3 (TA2,X3,X3,NTOT1)
      CALL ADD2 (TA1,TA2,NTOT1)
      ENDIF
      LINF = GLAMAX (TA1,NTOT1)
      LINF = SQRT( LINF )
C
      CALL COL3 (TA1,X1,X1,NTOT1)
      CALL COL3 (TA2,X2,X2,NTOT1)
      CALL ADD2 (TA1,TA2,NTOT1)
      IF (ldim.EQ.3) THEN
      CALL COL3 (TA2,X3,X3,NTOT1)
      CALL ADD2 (TA1,TA2,NTOT1)
      ENDIF
      CALL COL2 (TA1,BM1,NTOT1)
      L2 = GLSUM  (TA1,NTOT1)
      IF (L2.LT.0.0) L2 = 0.
C
      CALL RONE  (TA1,NTOT1)
      CALL RZERO (TA2,NTOT1)
      CALL OPHX  (Y1,Y2,Y3,X1,X2,X3,TA1,TA2)
      CALL COL3  (TA1,Y1,X1,NTOT1)
      CALL COL3  (TA2,Y2,X2,NTOT1)
      CALL ADD2  (TA1,TA2,NTOT1)
      IF (ldim.EQ.3) THEN
      CALL COL3  (TA2,Y3,X3,NTOT1)
      CALL ADD2  (TA1,TA2,NTOT1)
      ENDIF
      SEMI = GLSUM (TA1,NTOT1)
      IF (SEMI.LT.0.0) SEMI = 0.
C
      H1   = SQRT((SEMI*LENGTH**2+L2)/VOL)
      SEMI = SQRT(SEMI/VOL)
      L2   = SQRT(L2  /VOL)
      IF (H1.LT.0.) H1 = 0.
C
      return
      END
C
      subroutine genwp (wp,wm2,p)
C------------------------------------------------------------------
C
C     Collocate the weights on mesh M2 with the pressure or the
C     search direction in the cg-iteration.
C
C-----------------------------------------------------------------
      include 'SIZE'
C
      REAL   WP  (LX2,LY2,LZ2,LELV)
      REAL   P   (LX2,LY2,LZ2,LELV)
      REAL   WM2 (LX2,LY2,LZ2)
C
      NXYZ2 = lx2*ly2*lz2
      DO 100 IEL=1,NELV
         CALL COL3 (WP(1,1,1,IEL),WM2(1,1,1),P(1,1,1,IEL),NXYZ2)
 100  CONTINUE
      return
      END
C
      subroutine convuz (ifstuz)
C--------------------------------------------------------------------
C
C     Check convergence for the coupled form.
C     Consistent approximation spaces.
C
C--------------------------------------------------------------------
      include 'SIZE'
      include 'TOTAL'
      LOGICAL        IFSTUZ
      COMMON /SCRNS/ RESV1 (LX1,LY1,LZ1,LELV)
     $ ,             RESV2 (LX1,LY1,LZ1,LELV)
     $ ,             RESV3 (LX1,LY1,LZ1,LELV)
     $ ,             RESP  (LX2,LY2,LZ2,LELV)
     $ ,             TA1   (LX1,LY1,LZ1,LELV)
     $ ,             TA2   (LX1,LY1,LZ1,LELV)
     $ ,             TA3   (LX1,LY1,LZ1,LELV) 
      COMMON /SCRMG/ TB1   (LX1,LY1,LZ1,LELV)
     $ ,             TB2   (LX1,LY1,LZ1,LELV)
     $ ,             TB3   (LX1,LY1,LZ1,LELV)
     $ ,             WP    (LX2,LY2,LZ2,LELV)
      COMMON /SCRVH/ H1    (LX1,LY1,LZ1,LELV)
     $ ,             H2    (LX1,LY1,LZ1,LELV)
C
      IFSTUZ = .TRUE.
      TCRITV = TOLHV*1.5
      TCRITP = TOLPS*1.5
      NTOT1  = lx1*ly1*lz1*NELV
      NTOT2  = lx2*ly2*lz2*NELV
      INTYPE = 0
      CALL SETHLM (H1,H2,INTYPE)
C
C     Momentum
C
      CALL OPCOPY  (RESV1,RESV2,RESV3,BFX,BFY,BFZ)
      CALL OPGRADT (TA1,TA2,TA3,PR)
      CALL OPHX    (TB1,TB2,TB3,VX,VY,VZ,H1,H2)
      CALL OPADD2  (RESV1,RESV2,RESV3,TA1,TA2,TA3)
      CALL OPSUB2  (RESV1,RESV2,RESV3,TB1,TB2,TB3)
      CALL OPMASK  (RESV1,RESV2,RESV3)
      CALL OPDSSUM (RESV1,RESV2,RESV3)
      CALL OPCOLV3 (TA1,TA2,TA3,RESV1 ,RESV2 ,RESV3,BINVM1)
      RV1 = SQRT(GLSC3(TA1,RESV1,VMULT,NTOT1)/VOLVM1)
      RV2 = SQRT(GLSC3(TA2,RESV2,VMULT,NTOT1)/VOLVM1)
      IF (RV1 .GT. TCRITV) IFSTUZ = .FALSE.
      IF (RV2 .GT. TCRITV) IFSTUZ = .FALSE.
      IF (ldim.EQ.3) THEN
         RV3 = SQRT(GLSC3(TA3,RESV3,VMULT,NTOT1)/VOLVM1)
         IF (RV3 .GT. TCRITV) IFSTUZ = .FALSE.
      ENDIF
C
C     Continuity
C
      CALL OPDIV (RESP,VX,VY,VZ)
      CALL COL3  (WP,RESP,BM2INV,NTOT2)
      RP = SQRT  (GLSC2(WP,RESP,NTOT2)/VOLVM2)
      IF (RP .GT. TCRITP) IFSTUZ = .FALSE.
C
      return
      END
C
      subroutine convsp (ifstsp)
      LOGICAL IFSTSP
      IFSTSP = .FALSE.
      return
      END
C
      subroutine antimsk (y,x,xmask,n)
C------------------------------------------------------------------
C
C     Return Dirichlet boundary values of X in the array Y
C
C-------------------------------------------------------------------
      REAL  Y(1),X(1),XMASK(1)
      include 'OPCTR'
C
#ifdef TIMER
      if (isclld.eq.0) then
          isclld=1
          nrout=nrout+1
          myrout=nrout
          rname(myrout) = 'antmsk'
      endif
      isbcnt = 2*n
      dct(myrout) = dct(myrout) + (isbcnt)
      ncall(myrout) = ncall(myrout) + 1
      dcount      =      dcount + (isbcnt)
#endif
C
      DO 100 I=1,N
         Y(I) = X(I)*(1.-XMASK(I))
 100  CONTINUE
      return
      END
C
      subroutine opamask (vbdry1,vbdry2,vbdry3) 
C----------------------------------------------------------------------
C
C     Antimask the velocity arrays. 
C
C----------------------------------------------------------------------
      include 'SIZE'
      include 'INPUT'
      include 'SOLN'
      include 'TSTEP'
      REAL VBDRY1 (LX1,LY1,LZ1,1)
      REAL VBDRY2 (LX1,LY1,LZ1,1)
      REAL VBDRY3 (LX1,LY1,LZ1,1)
C
      NTOT1 = lx1*ly1*lz1*NELV
C
      IF (IFSTRS) THEN
         if (ifield.eq.ifldmhd) then
            CALL AMASK (VBDRY1,VBDRY2,VBDRY3,BX,BY,BZ,NELV)
         else
            CALL AMASK (VBDRY1,VBDRY2,VBDRY3,VX,VY,VZ,NELV)
         endif
      ELSE
         if (ifield.eq.ifldmhd) then
            CALL ANTIMSK (VBDRY1,BX,B1MASK,NTOT1)
            CALL ANTIMSK (VBDRY2,BY,B2MASK,NTOT1)
            IF (ldim.EQ.3) 
     $      CALL ANTIMSK (VBDRY3,BZ,B3MASK,NTOT1)
         else
            CALL ANTIMSK (VBDRY1,VX,V1MASK,NTOT1)
            CALL ANTIMSK (VBDRY2,VY,V2MASK,NTOT1)
            IF (ldim.EQ.3) 
     $      CALL ANTIMSK (VBDRY3,VZ,V3MASK,NTOT1)
         endif
      ENDIF
C
      return
      END
C
      subroutine opmask (res1,res2,res3)
C----------------------------------------------------------------------
C
C     Mask the residual arrays. 
C
C----------------------------------------------------------------------
      include 'SIZE'
      include 'INPUT'
      include 'SOLN'
      include 'TSTEP'
      REAL RES1(1),RES2(1),RES3(1)
C
      NTOT1 = lx1*ly1*lz1*NELV
C
c     sv=glsum(v3mask,ntot1)
c     sb=glsum(b3mask,ntot1)
c     write(6,*) istep,' ifld:',ifield,intype,sv,sb
      IF (IFSTRS) THEN
         CALL RMASK (RES1,RES2,RES3,NELV)
      ELSE
         if (ifield.eq.ifldmhd) then
            CALL COL2 (RES1,B1MASK,NTOT1)
            CALL COL2 (RES2,B2MASK,NTOT1)
            IF (ldim.EQ.3)
     $      CALL COL2 (RES3,B3MASK,NTOT1)
         else
            CALL COL2 (RES1,V1MASK,NTOT1)
            CALL COL2 (RES2,V2MASK,NTOT1)
            IF (ldim.EQ.3)
     $      CALL COL2 (RES3,V3MASK,NTOT1)
         endif
      ENDIF
C
      return
      END
C
      subroutine opadd2 (a1,a2,a3,b1,b2,b3)
      include 'SIZE'
      REAL A1(1),A2(1),A3(1),B1(1),B2(1),B3(1)
      NTOT1=lx1*ly1*lz1*NELV
      CALL ADD2(A1,B1,NTOT1)
      CALL ADD2(A2,B2,NTOT1)
      IF(ldim.EQ.3)CALL ADD2(A3,B3,NTOT1)
      return
      END
C
      subroutine opsub2 (a1,a2,a3,b1,b2,b3)
      include 'SIZE'
      REAL A1(1),A2(1),A3(1),B1(1),B2(1),B3(1)
      NTOT1=lx1*ly1*lz1*NELV
      CALL SUB2(A1,B1,NTOT1)
      CALL SUB2(A2,B2,NTOT1)
      IF(ldim.EQ.3)CALL SUB2(A3,B3,NTOT1)
      return
      END
C
      subroutine opsub3 (a1,a2,a3,b1,b2,b3,c1,c2,c3)
      include 'SIZE'
      REAL A1(1),A2(1),A3(1),B1(1),B2(1),B3(1),C1(1),C2(1),C3(1)
      NTOT1=lx1*ly1*lz1*NELV
      CALL SUB3(A1,B1,C1,NTOT1)
      CALL SUB3(A2,B2,C2,NTOT1)
      IF(ldim.EQ.3)CALL SUB3(A3,B3,C3,NTOT1)
      return
      END
C
      subroutine opcolv3(a1,a2,a3,b1,b2,b3,c)
      include 'SIZE'
      REAL A1(1),A2(1),A3(1)
      REAL B1(1),B2(1),B3(1)
      REAL C (1)
      include 'OPCTR'
C
      NTOT1=lx1*ly1*lz1*NELV

#ifdef TIMER
      if (isclld.eq.0) then
          isclld=1
          nrout=nrout+1
          myrout=nrout
          rname(myrout) = 'opcolv'
      endif
C
      isbcnt = ntot1*ldim
      dct(myrout) = dct(myrout) + (isbcnt)
      ncall(myrout) = ncall(myrout) + 1
      dcount      =      dcount + (isbcnt)
#endif
C
      IF (ldim.EQ.3) THEN
         DO 100 I=1,NTOT1
            A1(I)=B1(I)*C(I)
            A2(I)=B2(I)*C(I)
            A3(I)=B3(I)*C(I)
  100    CONTINUE
      ELSE
         DO 200 I=1,NTOT1
            A1(I)=B1(I)*C(I)
            A2(I)=B2(I)*C(I)
  200    CONTINUE
      ENDIF
      return
      END
C
      subroutine opcolv (a1,a2,a3,c)
      include 'SIZE'
      REAL A1(1),A2(1),A3(1),C(1)
      include 'OPCTR'
C
      NTOT1=lx1*ly1*lz1*NELV

#ifdef TIMER
      if (isclld.eq.0) then
          isclld=1
          nrout=nrout+1
          myrout=nrout
          rname(myrout) = 'opcolv'
      endif
C
      isbcnt = ntot1*ldim
      dct(myrout) = dct(myrout) + (isbcnt)
      ncall(myrout) = ncall(myrout) + 1
      dcount      =      dcount + (isbcnt)
#endif
C
      IF (ldim.EQ.3) THEN
         DO 100 I=1,NTOT1
            A1(I)=A1(I)*C(I)
            A2(I)=A2(I)*C(I)
            A3(I)=A3(I)*C(I)
  100    CONTINUE
      ELSE
         DO 200 I=1,NTOT1
            A1(I)=A1(I)*C(I)
            A2(I)=A2(I)*C(I)
  200    CONTINUE
      ENDIF
      return
      END
C
      subroutine opcol2 (a1,a2,a3,b1,b2,b3)
      include 'SIZE'
      REAL A1(1),A2(1),A3(1),B1(1),B2(1),B3(1)
      NTOT1=lx1*ly1*lz1*NELV
      CALL COL2(A1,B1,NTOT1)
      CALL COL2(A2,B2,NTOT1)
      IF(ldim.EQ.3)CALL COL2(A3,B3,NTOT1)
      return
      END
C
      subroutine opchsgn (a,b,c)
      include 'SIZE'
      REAL A(1),B(1),C(1)
      NTOT1=lx1*ly1*lz1*NELV
      CALL CHSIGN(A,NTOT1)
      CALL CHSIGN(B,NTOT1)
      IF(ldim.EQ.3)CALL CHSIGN(C,NTOT1)
      return
      END
c
      subroutine opcopy (a1,a2,a3,b1,b2,b3)
      include 'SIZE'
      REAL A1(1),A2(1),A3(1),B1(1),B2(1),B3(1)
      NTOT1=lx1*ly1*lz1*NELV
      CALL COPY(A1,B1,NTOT1)
      CALL COPY(A2,B2,NTOT1)
      IF(ldim.EQ.3)CALL COPY(A3,B3,NTOT1)
      return
      END

c-----------------------------------------------------------------------
      subroutine rotate_cyc(r1,r2,r3,idir)

      include 'SIZE'
      include 'GEOM'
      include 'INPUT'
      include 'PARALLEL'
      include 'TSTEP'

      real r1(lx1,ly1,lz1,1)
     $   , r2(lx1,ly1,lz1,1)
     $   , r3(lx1,ly1,lz1,1)

      integer e,f
      logical ifxy
      real length
 
c     (1) Face n-t transformation


      nface = 2*ldim
      do e=1,nelfld(ifield)
      do f=1,nface

         if(cbc(f,e,ifield) .eq. 'P  '.or.cbc(f,e,ifield).eq.'p  ')then

            call facind2 (js1,jf1,jskip1,js2,jf2,jskip2,f)
            if (idir.eq.1) then
              k=0
              do j2=js2,jf2,jskip2
              do j1=js1,jf1,jskip1
               k=k+1

               dotprod = unx(k,1,f,e)*ym1(j1,j2,1,e)
     $                  -uny(k,1,f,e)*xm1(j1,j2,1,e)
     
               ifxy = .true.
      
               length = unx(k,1,f,e)*unx(k,1,f,e) 
     $               + uny(k,1,f,e)*uny(k,1,f,e)
               length = sqrt(length)

               cost =  unx(k,1,f,e)/length
               sint =  uny(k,1,f,e)/length
               
               rnor = ( r1(j1,j2,1,e)*cost + r2(j1,j2,1,e)*sint )
               rtn1 = (-r1(j1,j2,1,e)*sint + r2(j1,j2,1,e)*cost )

               if (ifxy.and.dotprod .ge. 0.0) then 
                  r1(j1,j2,1,e) = rnor
                  r2(j1,j2,1,e) = rtn1
               elseif (ifxy) then
                  r1(j1,j2,1,e) =-rnor
                  r2(j1,j2,1,e) =-rtn1
               endif
              enddo
              enddo

            else    ! reverse rotate

              k=0
              do j2=js2,jf2,jskip2
              do j1=js1,jf1,jskip1
               k=k+1

               dotprod = unx(k,1,f,e)*ym1(j1,j2,1,e)
     $                  -uny(k,1,f,e)*xm1(j1,j2,1,e)
               ifxy = .true.
               
               length = unx(k,1,f,e)*unx(k,1,f,e) 
     $               + uny(k,1,f,e)*uny(k,1,f,e)
               length = sqrt(length)
               
               cost =  unx(k,1,f,e)/length
               sint =  uny(k,1,f,e)/length
               
               rnor = ( r1(j1,j2,1,e)*cost - r2(j1,j2,1,e)*sint )
               rtn1 = ( r1(j1,j2,1,e)*sint + r2(j1,j2,1,e)*cost )

               if(ifxy.and.dotprod .ge. 0.0) then 
                  r1(j1,j2,1,e) = rnor
                  r2(j1,j2,1,e) = rtn1
               elseif (ifxy) then
                  r1(j1,j2,1,e) =-rnor
                  r2(j1,j2,1,e) =-rtn1
               endif
              enddo
              enddo
            endif

         endif

      enddo
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine opdssum (a,b,c)! NOTE: opdssum works on FLUID/MHD arrays only!

      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'
      include 'TSTEP'
      include 'GEOM'

      real a(1),b(1),c(1)

      if (ifcyclic) then
         call rotate_cyc  (a,b,c,1)
         call vec_dssum   (a,b,c,lx1,ly1,lz1)
         call rotate_cyc  (a,b,c,0)
      else
         call vec_dssum   (a,b,c,lx1,ly1,lz1)
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine opdsop (a,b,c,op)! opdsop works on FLUID/MHD arrays only!

      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'
      include 'TSTEP'
      include 'GEOM'

      real a(1),b(1),c(1)
      character*3 op

      if (ifcyclic) then

         if (op.eq.'*  ' .or. op.eq.'mul' .or. op.eq.'MUL') then
            call vec_dsop    (a,b,c,lx1,ly1,lz1,op)
         else
            call rotate_cyc  (a,b,c,1)
            call vec_dsop    (a,b,c,lx1,ly1,lz1,op)
            call rotate_cyc  (a,b,c,0)
         endif

      else

         call vec_dsop    (a,b,c,lx1,ly1,lz1,op)

      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine opicol2 (a1,a2,a3,b1,b2,b3)
      include 'SIZE'
      REAL A1(1),A2(1),A3(1),B1(1),B2(1),B3(1)
      NTOT1=lx1*ly1*lz1*NELV
      CALL INVCOL2(A1,B1,NTOT1)
      CALL INVCOL2(A2,B2,NTOT1)
      IF(ldim.EQ.3)CALL INVCOL2(A3,B3,NTOT1)
      return
      END
C
      subroutine oprzero (a,b,c)
      include 'SIZE'
      REAL A(1),B(1),C(1)
      NTOT1=lx1*ly1*lz1*NELV
      CALL RZERO(A,NTOT1)
      CALL RZERO(B,NTOT1)
      IF(ldim.EQ.3) CALL RZERO(C,NTOT1)
      return
      END
C
      subroutine oprone (a,b,c)
      include 'SIZE'
      REAL A(1),B(1),C(1)
      NTOT1=lx1*ly1*lz1*NELV
      CALL RONE(A,NTOT1)
      CALL RONE(B,NTOT1)
      IF(ldim.EQ.3) CALL RONE(C,NTOT1)
      return
      END
C
      subroutine opcmult (a,b,c,const)
      include 'SIZE'
      REAL A(1),B(1),C(1)
      NTOT1=lx1*ly1*lz1*NELV
      CALL CMULT(A,CONST,NTOT1)
      CALL CMULT(B,CONST,NTOT1)
      IF(ldim.EQ.3) CALL CMULT(C,CONST,NTOT1)
      return
      END
c-----------------------------------------------------------------------
      subroutine opcolv2c(a1,a2,a3,b1,b2,c)
      include 'SIZE'
      REAL A1(1),A2(1),A3(1)
      REAL B1(1),B2(1)
      include 'OPCTR'
C
      NTOT1=lx1*ly1*lz1*NELV

#ifdef TIMER
      if (isclld.eq.0) then
          isclld=1
          nrout=nrout+1
          myrout=nrout
          rname(myrout) = 'opcv2c'
      endif
C
      isbcnt = ntot1*(ldim+2)
      dct(myrout) = dct(myrout) + (isbcnt)
      ncall(myrout) = ncall(myrout) + 1
      dcount      =      dcount + (isbcnt)
#endif
C
      IF (ldim.EQ.3) THEN
         DO 100 I=1,NTOT1
            tmp = c*b1(i)*b2(i)
            A1(I)=A1(I)*tmp
            A2(I)=A2(I)*tmp
            A3(I)=A3(I)*tmp
  100    CONTINUE
      ELSE
         DO 200 I=1,NTOT1
            tmp = c*b1(i)*b2(i)
            A1(I)=A1(I)*tmp
            A2(I)=A2(I)*tmp
  200    CONTINUE
      ENDIF
      return
      END
c-----------------------------------------------------------------------
      subroutine opcolv2(a1,a2,a3,b1,b2)
      include 'SIZE'
      REAL A1(1),A2(1),A3(1)
      REAL B1(1),B2(1)
      include 'OPCTR'
C
      NTOT1=lx1*ly1*lz1*NELV

#ifdef TIMER
      if (isclld.eq.0) then
          isclld=1
          nrout=nrout+1
          myrout=nrout
          rname(myrout) = 'opclv2'
      endif
C
      isbcnt = ntot1*(ldim+1)
      dct(myrout) = dct(myrout) + (isbcnt)
      ncall(myrout) = ncall(myrout) + 1
      dcount      =      dcount + (isbcnt)
#endif
C
      IF (ldim.EQ.3) THEN
         DO 100 I=1,NTOT1
            tmp = b1(i)*b2(i)
            A1(I)=A1(I)*tmp
            A2(I)=A2(I)*tmp
            A3(I)=A3(I)*tmp
  100    CONTINUE
      ELSE
         DO 200 I=1,NTOT1
            tmp = b1(i)*b2(i)
            A1(I)=A1(I)*tmp
            A2(I)=A2(I)*tmp
  200    CONTINUE
      ENDIF
      return
      END
c-----------------------------------------------------------------------
      subroutine opadd2col(a1,a2,a3,b1,b2,b3,c)
      include 'SIZE'
      REAL A1(1),A2(1),A3(1)
      REAL B1(1),B2(1),B3(1),C(1)
      include 'OPCTR'
C
      NTOT1=lx1*ly1*lz1*NELV

#ifdef TIMER
      if (isclld.eq.0) then
          isclld=1
          nrout=nrout+1
          myrout=nrout
          rname(myrout) = 'opa2cl'
      endif
C
      isbcnt = ntot1*(ldim*2)
      dct(myrout) = dct(myrout) + (isbcnt)
      ncall(myrout) = ncall(myrout) + 1
      dcount      =      dcount + (isbcnt)
#endif
C
      IF (ldim.EQ.3) THEN
         DO 100 I=1,NTOT1
            A1(I)=A1(I)+b1(i)*c(i)
            A2(I)=A2(I)+b2(i)*c(i)
            A3(I)=A3(I)+b3(i)*c(i)
  100    CONTINUE
      ELSE
         DO 200 I=1,NTOT1
            A1(I)=A1(I)+b1(i)*c(i)
            A2(I)=A2(I)+b2(i)*c(i)
  200    CONTINUE
      ENDIF
      return
      END
c-----------------------------------------------------------------------
      subroutine opcolv3c(a1,a2,a3,b1,b2,b3,c,d)
      include 'SIZE'
      REAL A1(1),A2(1),A3(1)
      REAL B1(1),B2(1),B3(1)
      REAL C (1)
      include 'OPCTR'
C
      NTOT1=lx1*ly1*lz1*NELV

#ifdef TIMER
      if (isclld.eq.0) then
          isclld=1
          nrout=nrout+1
          myrout=nrout
          rname(myrout) = 'opcv3c'
      endif
C
      isbcnt = ntot1*ldim*2
      dct(myrout) = dct(myrout) + (isbcnt)
      ncall(myrout) = ncall(myrout) + 1
      dcount      =      dcount + (isbcnt)
#endif
C
      IF (ldim.EQ.3) THEN
         DO 100 I=1,NTOT1
            A1(I)=B1(I)*C(I)*d
            A2(I)=B2(I)*C(I)*d
            A3(I)=B3(I)*C(I)*d
  100    CONTINUE
      ELSE
         DO 200 I=1,NTOT1
            A1(I)=B1(I)*C(I)*d
            A2(I)=B2(I)*C(I)*d
  200    CONTINUE
      ENDIF
      return
      END
c-----------------------------------------------------------------------
C
      subroutine uzawa (rcg,h1,h2,h2inv,intype,iter)
C-----------------------------------------------------------------------
C
C     Solve the pressure equation by (nested) preconditioned 
C     conjugate gradient iteration.
C     INTYPE =  0  (steady)
C     INTYPE =  1  (explicit)
C     INTYPE = -1  (implicit)
C
C-----------------------------------------------------------------------
      include 'SIZE'
      include 'TOTAL'
      COMMON  /CTOLPR/ DIVEX
      COMMON  /CPRINT/ IFPRINT
      LOGICAL          IFPRINT
      REAL             RCG  (LX2,LY2,LZ2,LELV)
      REAL             H1   (LX1,LY1,LZ1,LELV)
      REAL             H2   (LX1,LY1,LZ1,LELV)
      REAL             H2INV(LX1,LY1,LZ1,LELV)
      COMMON /SCRUZ/   WP   (LX2,LY2,LZ2,LELV)
     $ ,               XCG  (LX2,LY2,LZ2,LELV)
     $ ,               PCG  (LX2,LY2,LZ2,LELV) 
     $ ,               RPCG (LX2,LY2,LZ2,LELV)
 
      real*8 etime1,dnekclock
      integer*8 ntotg,nxyz2


      etime1 = dnekclock()
      DIVEX = 0.
      ITER  = 0
c
      CALL CHKTCG2 (TOLPS,RCG,ICONV)
      if (param(21).gt.0.and.tolps.gt.abs(param(21))) 
     $   TOLPS = abs(param(21))
C
c      IF (ICONV.EQ.1) THEN
c         IF (NID.EQ.0) WRITE(6,9999) ITER,DIVEX,TOLPS
c         return
c      ENDIF

      nxyz2 = lx2*ly2*lz2
      ntot2 = nxyz2*nelv
      ntotg = nxyz2*nelgv

      CALL UZPREC  (RPCG,RCG,H1,H2,INTYPE,WP)
      RRP1 = GLSC2 (RPCG,RCG,NTOT2)
      CALL COPY    (PCG,RPCG,NTOT2)
      CALL RZERO   (XCG,NTOT2)
      if (rrp1.eq.0) return
      BETA = 0.
      div0=0.
C
      tolpss = tolps
      DO 1000 ITER=1,NMXP
C
C        CALL CONVPR  (RCG,tolpss,ICONV,RNORM)
         call convprn (iconv,rnorm,rrp1,rcg,rpcg,tolpss)

         if (iter.eq.1)      div0   = rnorm
         if (param(21).lt.0) tolpss = abs(param(21))*div0

         ratio = rnorm/div0
         IF (IFPRINT.AND.NIO.EQ.0) 
     $   WRITE (6,66) iter,tolpss,rnorm,div0,ratio,istep
   66    format(i5,1p4e12.5,i8,' Divergence')
c
         IF (ICONV.EQ.1.and.iter.gt.1) GOTO 9000
c        IF (ICONV.EQ.1.and.(iter.gt.1.or.istep.le.2)) GOTO 9000
c        IF (ICONV.EQ.1) GOTO 9000
c        if (ratio.le.1.e-5) goto 9000


         IF (ITER .NE. 1) THEN
            BETA = RRP1/RRP2
            CALL ADD2S1 (PCG,RPCG,BETA,NTOT2)
         ENDIF

         CALL CDABDTP  (WP,PCG,H1,H2,H2INV,INTYPE)
         PAP   = GLSC2 (PCG,WP,NTOT2)

         IF (PAP.NE.0.) THEN
            ALPHA = RRP1/PAP
         ELSE
            pcgmx = glamax(pcg,ntot2)
            wp_mx = glamax(wp ,ntot2)
            ntot1 = lx1*ly1*lz1*nelv
            h1_mx = glamax(h1 ,ntot1)
            h2_mx = glamax(h2 ,ntot1)
            if (nid.eq.0) write(6,*) 'ERROR: pap=0 in uzawa.'
     $      ,iter,pcgmx,wp_mx,h1_mx,h2_mx
            call exitt
         ENDIF
         CALL ADD2S2 (XCG,PCG,ALPHA,NTOT2)
         CALL ADD2S2 (RCG,WP,-ALPHA,NTOT2)

         if (iter.eq.-1) then
            call convprn (iconv,rnrm1,rrpx,rcg,rpcg,tolpss)
            if (iconv.eq.1) then
               rnorm = rnrm1
               ratio = rnrm1/div0
               if (nio.eq.0) 
     $         write (6,66) iter,tolpss,rnrm1,div0,ratio,istep
               goto 9000
            endif
         endif

         call ortho(rcg)

         RRP2 = RRP1
         CALL UZPREC  (RPCG,RCG,H1,H2,INTYPE,WP)
c        RRP1 = GLSC2 (RPCG,RCG,NTOT2)

 1000 CONTINUE
      if (nid.eq.0) WRITE (6,3001) ITER,RNORM,tolpss
c     if (istep.gt.20) CALL EMERXIT
 3001 FORMAT(I6,' **ERROR**: Failed to converge in UZAWA:',6E13.4)
 9000 CONTINUE

      divex = rnorm
      iter  = iter-1

      if (iter.gt.0) call copy (rcg,xcg,ntot2)
      call ortho(rcg)

      etime1 = dnekclock()-etime1
      IF (NIO.EQ.0) WRITE(6,9999) ISTEP, '  U-Press std. ',
     &                            ITER,DIVEX,div0,tolpss,etime1
 9999 FORMAT(I11,a,I7,1p4E13.4)
19999 FORMAT(I11,'  U-Press 1.e-5: ',I7,1p4E13.4)
C
C
      return
      END
c-----------------------------------------------------------------------
      subroutine mapw(md,nd,m1,n1,mflg)
c
c     Interpolate from mesh "1" to "d" if mflg = 1
c
      include 'SIZE'
      include 'DEALIAS'
c
      real w(lxd*lxd*lx1)
      real md(lxd,lyd,lzd,lelv),m1(lx1,ly1,lz1,lelv)
c
      integer icalld
      save icalld
      data icalld /0/
c
      if (icalld .eq. 0) then
         call setmap(n1,nd)
         icalld = icalld + 1
      endif
c
      if (mflg .eq.1) then
         do ie = 1,nelv
            call specmp(md(1,1,1,ie),nd,m1(1,1,1,ie),n1,im1d,im1dt,w)
         enddo
      else
         do ie = 1,nelv
            call specmp(m1(1,1,1,ie),n1,md(1,1,1,ie),nd,imd1,imd1t,w)
         enddo
      endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine mapwp(md,nd,m1,n1,mflg)
c
c     Project from "d" to 1
c
      include 'SIZE'
      include 'DEALIAS'
c
      real w(lxd*lxd*lx1)
      real md(lxd,lyd,lzd,lelv),m1(lx1,ly1,lz1,lelv)
c
      integer icalld
      save icalld
      data icalld /0/
c
      if (icalld .eq. 0) then
          call setproj(n1,nd)
          icalld = icalld + 1
      endif
c
      do ie = 1,nelv
        call specmp(m1(1,1,1,ie),n1,md(1,1,1,ie),nd,pmd1,pmd1t,w)
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine specmp(b,nb,a,na,ba,ab,w)
C
C     -  Spectral interpolation from A to B via tensor products
C     -  scratch arrays: w(na*na*nb)
C
C
      include 'SIZE'
      include 'INPUT'
      real b(nb,nb,nb),a(na,na,na)
      real w(1)
C
C
      if (if3d) then
         nab = na*nb
         nbb = nb*nb
         call mxm(ba,nb,a,na,b,na*na)
         k=1
         l=1
         do iz=1,na
            call mxm(b(k,1,1),nb,ab,na,w(l),nb)
            k=k+nab
            l=l+nbb
         enddo
         call mxm(w,nbb,ab,na,b,nb)
      else
         call mxm(ba,nb,a,na,w,na)
         call mxm(w,nb,ab,na,b,nb)
      endif
      return
      end
c-----------------------------------------------------------------------
      subroutine setmap(n1,nd)
c
      include 'SIZE'
      include 'DEALIAS'
c
      parameter(lx=80)
      real z1(lx),zd(lx),w(lx)
c
      if (n1.gt.lx.or.nd.gt.lx) then
         write(6,*)'ERROR: increase lx in setmap to max:',n1,nd
         call exitt
      endif
c
      call zwgll(z1,w,n1)
      call zwgll(zd,w,nd)
      call igllm(im1d,im1dt,z1,zd,n1,nd,n1,nd)
      call igllm(imd1,imd1t,zd,z1,nd,n1,nd,n1)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine set_PND(P,LkD,LkNt,N,D)
c
      integer N,D
      real    P(N,D),LkD(0:N-1,D),LkNt(N,0:N-1)
c
      parameter(lx=80)
      real zN(lx),zD(lx),w(lx)
c
c     Compute Lagrangian interpolant points
c
      call zwgll(zN,w,N)
      call zwgll(zD,w,D)
c
c
c                 D           D
c     Compute L (x )  and L (x )
c              k  i        k  j
c
      do k=0,N-1
c
         do j=1,D
            LkD (k,j) = pnleg(zD(j),k)
         enddo
c
         do j=1,N
            LkNt(j,k) = pnleg(zN(j),k)
         enddo
c
      enddo
c
c     Find scale factors to normalize the first N-1 Legendre polynomials
c     such that  (L_i,L_j) = delta_ij
c
      do k=0,N-1
         s = 0
         do j=1,D
            s = s + LkD(k,j)*LkD(k,j)*w(j)
         enddo
         s = 1./sqrt(s)
c
c        Normalize polynomials
c
         do j=1,D
            LkD (k,j) = s * LkD (k,j)
         enddo
c
         do j=1,N
            LkNt(j,k) = s * LkNt(j,k)
         enddo
c
      enddo
c
c     Scale columns of LkD by w_j
c
      do j=1,D
         do k=0,N-1
            LkD(k,j) = LkD(k,j)*w(j)
         enddo
      enddo
c
c     Compute P = LkNt * LkD
c
      call mxm(LkNt,N,LkD,N,P,D)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine convop(conv,fi)
C
C     Compute the convective term CONV for a passive scalar field FI
C     using the skew-symmetric formulation.
C     The field variable FI is defined on mesh M1 (GLL) and
C     the velocity field is assumed given.
C
C     IMPORTANT NOTE: Use the scratch-arrays carefully!!!!!
C
C     The common-block SCRNS is used in CONV1 and CONV2.
C     The common-blocks CTMP0 and CTMP1 are also used as scratch-arrays
C     since there is no direct stiffness summation or Helmholtz-solves. 
C
      include 'SIZE'
      include 'TOTAL'
      include 'CTIMER'
C
C     Use the common blocks CTMP0 and CTMP1 as work space.
C
      COMMON /SCRCH/  CMASK1 (LX1,LY1,LZ1,LELV)
     $ ,              CMASK2 (LX1,LY1,LZ1,LELV)
      COMMON /CTMP1/  MFI    (LX1,LY1,LZ1,LELV)
     $ ,              DMFI   (LX1,LY1,LZ1,LELV)
     $ ,              MDMFI  (LX1,LY1,LZ1,LELV)
      REAL   MFI,DMFI,MDMFI
C
C     Arrays in parameter list
C
      REAL    CONV (LX1,LY1,LZ1,1) 
      REAL    FI   (LX1,LY1,LZ1,1)

      if (nio.eq.0.and.loglevel.gt.2)
     $   write(6,*) 'convop', ifield, ifdeal(ifield)

#ifdef TIMER
      if (icalld.eq.0) tadvc=0.0
      icalld=icalld+1
      nadvc=icalld
      etime1=dnekclock()
#endif
 
      nxyz1 = lx1*ly1*lz1
      ntot1 = lx1*ly1*lz1*nelv
      ntotz = lx1*ly1*lz1*nelfld(ifield)
      ntott = lx1*ly1*lz1*nelt
 
      call rzero  (conv,ntott)
 
      if (ifdgfld(ifield)) then
         call convect_dg (conv,fi,.false.,vxd,vyd,vzd,.true.)
         goto 100
      elseif (param(86).ne.0.0) then  ! skew-symmetric form
         call convopo(conv,fi)
         goto 100
      endif

      if (.not. ifdeal(ifield)) then
         call conv1 (conv,fi)
      elseif (param(99).eq.2.or.param(99).eq.3) then  
         call conv1d(conv,fi)
      elseif (param(99).eq.4) then
         if (ifpert) then
           call convect_new (conv,fi,.false.,vx,vy,vz,.false.)
         else
           call convect_new (conv,fi,.false.,vxd,vyd,vzd,.true.)
         endif
         call invcol2     (conv,bm1,ntot1)  ! local mass inverse
      elseif (param(99).eq.5) then
         call convect_cons(conv,fi,.false.,vx,vy,vz,.false.)
         call invcol2     (conv,bm1,ntot1)  ! local mass inverse
      else
         call conv1 (conv,fi)
      endif

 100  continue

#ifdef TIMER
      tadvc=tadvc+(dnekclock()-etime1)
#endif

      return
      END
c-----------------------------------------------------------------------
      subroutine conv1d (dfi,fi)
C--------------------------------------------------------------------
C
C     Compute D*FI (part of the convection operator)
C     De-aliased version 3/11/97
C
C--------------------------------------------------------------------
      include 'SIZE'
      include 'TOTAL'
      REAL           DFI (LX1,LY1,LZ1,1) 
      REAL           FI  (LX1,LY1,LZ1,1) 
c
      COMMON /CTMP0/ TA1  (LX1,LY1,LZ1,LELV)
     $             , DFID (LXD,LYD,LZD,LELV) 
     $             , TA1D (LXD,LYD,LZD,lelv) 
C
      integer icalld
      save icalld
      data icalld /0/
c
      NTOTD = lxd*lyd*lzd*NELV
c
c
c     interpolate ta1 and vx onto larger mesh
c
      CALL DUDXYZ (TA1,FI,RXM1,SXM1,TXM1,JACM1,IMESH,1)
      call mapw   (ta1d,lxd,ta1,lx1,1)
      call mapw   (vxd ,lxd,vx ,lx1,1)
      CALL COL3   (DFID,TA1D,VXD,NTOTD)
c
c
c     interpolate ta1 and vy onto larger mesh
c
      CALL DUDXYZ  (TA1,FI,RYM1,SYM1,TYM1,JACM1,IMESH,2)
      call mapw    (ta1d,lxd,ta1,lx1,1)
      call mapw    (vyd ,lxd,vy ,lx1,1)
      CALL ADDCOL3 (DFID,TA1D,VYD,NTOTD)
c
      IF (if3d) THEN
c
c        interpolate ta1 and vy onto larger mesh
c
         CALL DUDXYZ  (TA1,FI,RZM1,SZM1,TZM1,JACM1,IMESH,3)
         call mapw    (ta1d,lxd,ta1,lx1,1)
         call mapw    (vzd ,lxd,vz ,lx1,1)
         CALL ADDCOL3 (DFID,TA1D,VZD,NTOTD)
c
      ENDIF
c
c     Now, *project* DFID onto mesh 1 using L2 projection
c
      call mapwp(dfid,lxd,dfi,lx1,-1)
      return
      END
C------------------------------------------------------------------------
      subroutine conv1(du,u)  ! used to be conv1n
c
      include 'SIZE'
      include 'DXYZ'
      include 'INPUT'
      include 'GEOM'
      include 'SOLN'
      include 'TSTEP'
c
      real  du  (lx1*ly1*lz1,1)
      real  u   (lx1,ly1,lz1,1)
c
      common /fastmd/ ifdfrm(lelt), iffast(lelt), ifh2, ifsolv
      logical ifdfrm, iffast, ifh2, ifsolv
C
C     Store the inverse jacobian to speed this operation up
C
      common /ctmp0/ dudr(lx1,ly1,lz1)
     $             , duds(lx1,ly1,lz1)
     $             , dudt(lx1,ly1,lz1)

      nel = nelv
      if (imesh.eq.2) nel = nelt
      nxy1  = lx1*ly1
      nyz1  = ly1*lz1
      nxyz1 = lx1*ly1*lz1
      ntot  = nxyz1*nel
C
C     Compute vel.grad(u)
C
      do ie=1,nel
C
        if (if3d) then
c
           call mxm   (dxm1,lx1,u(1,1,1,ie),lx1,dudr,nyz1)
           do iz=1,lz1
             call mxm (u(1,1,iz,ie),lx1,dytm1,ly1,duds(1,1,iz),ly1)
           enddo
           call mxm   (u(1,1,1,ie),nxy1,dztm1,lz1,dudt,lz1)
c
           do i=1,nxyz1
              du(i,ie) = jacmi(i,ie)*(
     $                     vx(i,1,1,ie)*(
     $                          rxm1(i,1,1,ie)*dudr(i,1,1)
     $                        + sxm1(i,1,1,ie)*duds(i,1,1)
     $                        + txm1(i,1,1,ie)*dudt(i,1,1) )
     $                   + vy(i,1,1,ie)*(
     $                          rym1(i,1,1,ie)*dudr(i,1,1)
     $                        + sym1(i,1,1,ie)*duds(i,1,1)
     $                        + tym1(i,1,1,ie)*dudt(i,1,1) )
     $                   + vz(i,1,1,ie)*(
     $                          rzm1(i,1,1,ie)*dudr(i,1,1)
     $                        + szm1(i,1,1,ie)*duds(i,1,1)
     $                        + tzm1(i,1,1,ie)*dudt(i,1,1) ) )
           enddo
c
         else
c
c           2D
            call mxm (dxm1,lx1,u(1,1,1,ie),lx1,dudr,nyz1)
            call mxm (u(1,1,1,ie),lx1,dytm1,ly1,duds,ly1)
            do i=1,nxyz1
               du(i,ie) = jacmi(i,ie)*(
     $                      vx(i,1,1,ie)*(
     $                           rxm1(i,1,1,ie)*dudr(i,1,1)
     $                         + sxm1(i,1,1,ie)*duds(i,1,1) )
     $                    + vy(i,1,1,ie)*(
     $                           rym1(i,1,1,ie)*dudr(i,1,1)
     $                         + sym1(i,1,1,ie)*duds(i,1,1) ) )
            enddo
          endif

       enddo
c
       return
       end
c-----------------------------------------------------------------------
      subroutine conv1no(du,u)
c
      include 'SIZE'
      include 'DXYZ'
      include 'INPUT'
      include 'GEOM'
      include 'SOLN'
      include 'TSTEP'
c
      real  du  (lx1*ly1*lz1,1)
      real  u   (lx1,ly1,lz1,1)
c
      common /fastmd/ ifdfrm(lelt), iffast(lelt), ifh2, ifsolv
      logical ifdfrm, iffast, ifh2, ifsolv
C
C     Store the inverse jacobian to speed this operation up
C
C
      common /ctmp0/ dudr(lx1,ly1,lz1)
     $             , duds(lx1,ly1,lz1)
     $             , dudt(lx1,ly1,lz1)
C
      nel = nelv
      if (imesh.eq.2) nel = nelt
      nxy1  = lx1*ly1
      nyz1  = ly1*lz1
      nxyz1 = lx1*ly1*lz1
      ntot  = nxyz1*nel
C
C     Compute vel.grad(u)
C
      do ie=1,nel
C
        if (if3d) then
c
           call mxm   (dxm1,lx1,u(1,1,1,ie),lx1,dudr,nyz1)
           do iz=1,lz1
             call mxm (u(1,1,iz,ie),lx1,dytm1,ly1,duds(1,1,iz),ly1)
           enddo
           call mxm   (u(1,1,1,ie),nxy1,dztm1,lz1,dudt,lz1)
c
           do i=1,nxyz1
              du(i,ie) = jacmi(i,ie)*(
     $                     vx(i,1,1,ie)*(
     $                          rxm1(i,1,1,ie)*dudr(i,1,1)
     $                        + sxm1(i,1,1,ie)*duds(i,1,1)
     $                        + txm1(i,1,1,ie)*dudt(i,1,1) )
     $                   + vy(i,1,1,ie)*(
     $                          rym1(i,1,1,ie)*dudr(i,1,1)
     $                        + sym1(i,1,1,ie)*duds(i,1,1)
     $                        + tym1(i,1,1,ie)*dudt(i,1,1) )
     $                   + vz(i,1,1,ie)*(
     $                          rzm1(i,1,1,ie)*dudr(i,1,1)
     $                        + szm1(i,1,1,ie)*duds(i,1,1)
     $                        + tzm1(i,1,1,ie)*dudt(i,1,1) ) )
           enddo
c
         else
c
c           2D
            call mxm (dxm1,lx1,u(1,1,1,ie),lx1,dudr,nyz1)
            call mxm (u(1,1,1,ie),lx1,dytm1,ly1,duds,ly1)
            do i=1,nxyz1
               du(i,ie) = jacmi(i,ie)*(
     $                      vx(i,1,1,ie)*(
     $                           rxm1(i,1,1,ie)*dudr(i,1,1)
     $                         + sxm1(i,1,1,ie)*duds(i,1,1) )
     $                    + vy(i,1,1,ie)*(
     $                           rym1(i,1,1,ie)*dudr(i,1,1)
     $                         + sym1(i,1,1,ie)*duds(i,1,1) ) )
            enddo
          endif

       enddo
c
       return
       end
c-----------------------------------------------------------------------
      subroutine conv1rk(du,dv,dw,u,v,w)
c
      include 'SIZE'
      include 'DXYZ'
      include 'INPUT'
      include 'GEOM'
      include 'SOLN'
      include 'TSTEP'
c
      real  du(lx1*ly1*lz1,1),dv(lx1*ly1*lz1,1),dw(lx1*ly1*lz1,1)
      real  u (lx1,ly1,lz1,1),v (lx1,ly1,lz1,1),w (lx1,ly1,lz1,1)
c
      common /fastmd/ ifdfrm(lelt), iffast(lelt), ifh2, ifsolv
      logical ifdfrm, iffast, ifh2, ifsolv
C
      common /ctmp0/ duds(lx1,ly1,lz1)
     $             , dvds(lx1,ly1,lz1)
     $             , dwds(lx1,ly1,lz1)
C
      nel = nelv
      if (imesh.eq.2) nel = nelt
      nxy1  = lx1*ly1
      nyz1  = ly1*lz1
      nxyz1 = lx1*ly1*lz1
C
C     Compute vel.grad(u)
C
      do ie=1,nel
C
         if (if3d) then
            call mxm   (dxm1,lx1,u(1,1,1,ie),lx1,du(1,ie),nyz1)
            call mxm   (dxm1,lx1,v(1,1,1,ie),lx1,dv(1,ie),nyz1)
            call mxm   (dxm1,lx1,w(1,1,1,ie),lx1,dw(1,ie),nyz1)
            do i=1,nxyz1
               du(i,ie) = du(i,ie)*vx(i,1,1,ie)
               dv(i,ie) = dv(i,ie)*vx(i,1,1,ie)
               dw(i,ie) = dw(i,ie)*vx(i,1,1,ie)
            enddo
c
            do iz=1,lz1
              call mxm (u(1,1,iz,ie),lx1,dytm1,ly1,duds(1,1,iz),ly1)
            enddo
            do iz=1,lz1
              call mxm (v(1,1,iz,ie),lx1,dytm1,ly1,dvds(1,1,iz),ly1)
            enddo
            do iz=1,lz1
              call mxm (w(1,1,iz,ie),lx1,dytm1,ly1,dwds(1,1,iz),ly1)
            enddo
            do i=1,nxyz1
               du(i,ie) = du(i,ie) + duds(i,1,1)*vy(i,1,1,ie)
               dv(i,ie) = dv(i,ie) + dvds(i,1,1)*vy(i,1,1,ie)
               dw(i,ie) = dw(i,ie) + dwds(i,1,1)*vy(i,1,1,ie)
            enddo
c
            call mxm   (u(1,1,1,ie),nxy1,dztm1,lz1,duds,lz1)
            call mxm   (v(1,1,1,ie),nxy1,dztm1,lz1,dvds,lz1)
            call mxm   (w(1,1,1,ie),nxy1,dztm1,lz1,dwds,lz1)
            do i=1,nxyz1
               du(i,ie) = du(i,ie) + duds(i,1,1)*vz(i,1,1,ie)
               dv(i,ie) = dv(i,ie) + dvds(i,1,1)*vz(i,1,1,ie)
               dw(i,ie) = dw(i,ie) + dwds(i,1,1)*vz(i,1,1,ie)
            enddo
         else
c           2D
            call mxm   (dxm1,lx1,u(1,1,1,ie),lx1,du(1,ie),nyz1)
            call mxm   (dxm1,lx1,v(1,1,1,ie),lx1,dv(1,ie),nyz1)
            do i=1,nxyz1
               du(i,ie) = du(i,ie)*vx(i,1,1,ie)
               dv(i,ie) = dv(i,ie)*vx(i,1,1,ie)
            enddo
c
            call mxm (u(1,1,1,ie),lx1,dytm1,ly1,duds,ly1)
            call mxm (v(1,1,1,ie),lx1,dytm1,ly1,dvds,ly1)
            do i=1,nxyz1
               du(i,ie) = du(i,ie) + duds(i,1,1)*vy(i,1,1,ie)
               dv(i,ie) = dv(i,ie) + dvds(i,1,1)*vy(i,1,1,ie)
            enddo
c
         endif
c
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine velconvv(vxn,vyn,vzn,tau)
c
c     Compute convecting velocity field (linearization)
c
      include 'SIZE'
      include 'GEOM'
      include 'MASS'
      include 'SOLN'
      include 'TSTEP'
      real vxn(1),vyn(1),vzn(1)
c
      include 'OPCTR'

c     Operation count
#ifdef TIMER
      integer opct
      if (isclld.eq.0) then
          isclld=1
          nrout=nrout+1
          myrout=nrout
          rname(myrout) = 'velcvv'
      endif
      ncall(myrout) = ncall(myrout) + 1
      opct = 0
#endif

      call velchar (vx,vxn,vxlag,nbd,tau,dtlag)
      call velchar (vy,vyn,vylag,nbd,tau,dtlag)
      if (ldim.eq.3) 
     $call velchar (vz,vzn,vzlag,nbd,tau,dtlag)
c
      ntot = lx1*ly1*lz1*nelv
      if (ldim.eq.3) then
         do i=1,ntot
c
            tx = vx(i,1,1,1)*bm1(i,1,1,1)*jacmi(i,1)
            ty = vy(i,1,1,1)*bm1(i,1,1,1)*jacmi(i,1)
            tz = vz(i,1,1,1)*bm1(i,1,1,1)*jacmi(i,1)
c
            vx(i,1,1,1) = tx*rxm1(i,1,1,1)
     $                  + ty*rym1(i,1,1,1)
     $                  + tz*rzm1(i,1,1,1)
            vy(i,1,1,1) = tx*sxm1(i,1,1,1)
     $                  + ty*sym1(i,1,1,1)
     $                  + tz*szm1(i,1,1,1)
            vz(i,1,1,1) = tx*txm1(i,1,1,1)
     $                  + ty*tym1(i,1,1,1)
     $                  + tz*tzm1(i,1,1,1)
         enddo
      else
         do i=1,ntot
c
            tx = vx(i,1,1,1)*bm1(i,1,1,1)*jacmi(i,1)
            ty = vy(i,1,1,1)*bm1(i,1,1,1)*jacmi(i,1)
c
            vx(i,1,1,1) = tx*rxm1(i,1,1,1)
     $                  + ty*rym1(i,1,1,1)
            vy(i,1,1,1) = tx*sxm1(i,1,1,1)
     $                  + ty*sym1(i,1,1,1)
         enddo
      endif
c
#ifdef TIMER
      if (ldim.eq.3) then
         opct = ntot*21
      else
         opct = ntot*10
      endif
      dct(myrout) = dct(myrout) + opct
      dcount      =      dcount + opct
#endif
C
c
      return
      end
c-----------------------------------------------------------------------
      subroutine frkconvv (du,dv,dw,u,v,w,mu)
c
      include 'SIZE'
      include 'DXYZ'
      include 'INPUT'
      include 'GEOM'
      include 'SOLN'
      include 'MASS'
      include 'TSTEP'
c
      real  du(1),dv(1),dw(1)
      real  u (1),v (1),w (1)
      integer mu(0:1)
c
      include 'OPCTR'
c
c     Operation count
c
#ifdef TIMER
      integer opct
      if (isclld.eq.0) then
          isclld=1
          nrout=nrout+1
          myrout=nrout
          rname(myrout) = 'frkcvv'
      endif
      ncall(myrout) = ncall(myrout) + 1
#endif
c
c
c     Evaluate right-hand-side for Runge-Kutta scheme in the case of
c     pure convection.
c
      ntot = lx1*ly1*lz1*nelv
      call conv1rk   (du,dv,dw,u,v,w)
      CALL OPDSSUM   (du,dv,dw)
c
      if (ldim.eq.3) then
         do i=1,ntot
            du(i) = du(i)*binvm1(i,1,1,1)
            dv(i) = dv(i)*binvm1(i,1,1,1)
            dw(i) = dw(i)*binvm1(i,1,1,1)
         enddo
      else
         do i=1,ntot
            du(i) = du(i)*binvm1(i,1,1,1)
            dv(i) = dv(i)*binvm1(i,1,1,1)
         enddo
      endif
c
c     Mask
c
      nu = mu(0)
      if (ldim.eq.3) then
         do i=1,nu
            du(mu(i)) = 0.
            dv(mu(i)) = 0.
            dw(mu(i)) = 0.
         enddo
      else
         do i=1,nu
            du(mu(i)) = 0.
            dv(mu(i)) = 0.
         enddo
      endif
c
#ifdef TIMER
      opct = ldim*ntot
      dct(myrout) = dct(myrout) + opct
      dcount      =      dcount + opct
#endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine conv1rk2(du,dv,dw,u,v,w,cu,cv,cw,beta,wk)
c
      include 'SIZE'
      include 'DXYZ'
      include 'INPUT'
      include 'GEOM'
      include 'SOLN'
      include 'TSTEP'
c
      real  du(lx1*ly1*lz1,1),dv(lx1*ly1*lz1,1),dw(lx1*ly1*lz1,1)
      real  u (lx1,ly1,lz1,1),v (lx1,ly1,lz1,1),w (lx1,ly1,lz1,1)
      real  cu(lx1,ly1,lz1,1),cv(lx1,ly1,lz1,1),cw(lx1,ly1,lz1,1)
      real  wk(lx1,ly1,lz1,3)
c
      common /ctmp0/ duds(lx1,ly1,lz1)
     $             , dvds(lx1,ly1,lz1)
     $             , dwds(lx1,ly1,lz1)
C
      include 'OPCTR'
c
c     Operation count
c
#ifdef TIMER
      integer opct
      if (isclld.eq.0) then
          isclld=1
          nrout=nrout+1
          myrout=nrout
          rname(myrout) = 'cv1rk2'
      endif
      ncall(myrout) = ncall(myrout) + 1
      opct = 0
#endif
c
      nel = nelv
      if (imesh.eq.2) nel = nelt
      nxy1  = lx1*ly1
      nyz1  = ly1*lz1
      nxyz1 = lx1*ly1*lz1
      ntot  = nxyz1*nel
C
C     Compute vel.grad(u)
C
      do ie=1,nel
C
         if (if3d) then
            do i=1,nxyz1
               wk(i,1,1,1)=u(i,1,1,ie)+beta*cu(i,1,1,ie)
               wk(i,1,1,2)=v(i,1,1,ie)+beta*cv(i,1,1,ie)
               wk(i,1,1,3)=w(i,1,1,ie)+beta*cw(i,1,1,ie)
            enddo
c
            call mxm   (dxm1,lx1,wk(1,1,1,1),lx1,du(1,ie),nyz1)
            call mxm   (dxm1,lx1,wk(1,1,1,2),lx1,dv(1,ie),nyz1)
            call mxm   (dxm1,lx1,wk(1,1,1,3),lx1,dw(1,ie),nyz1)
            do i=1,nxyz1
               du(i,ie) = du(i,ie)*vx(i,1,1,ie)
               dv(i,ie) = dv(i,ie)*vx(i,1,1,ie)
               dw(i,ie) = dw(i,ie)*vx(i,1,1,ie)
            enddo
c
            do iz=1,lz1
              call mxm (wk(1,1,iz,1),lx1,dytm1,ly1,duds(1,1,iz),ly1)
            enddo
            do iz=1,lz1
              call mxm (wk(1,1,iz,2),lx1,dytm1,ly1,dvds(1,1,iz),ly1)
            enddo
            do iz=1,lz1
              call mxm (wk(1,1,iz,3),lx1,dytm1,ly1,dwds(1,1,iz),ly1)
            enddo
            do i=1,nxyz1
               du(i,ie) = du(i,ie) + duds(i,1,1)*vy(i,1,1,ie)
               dv(i,ie) = dv(i,ie) + dvds(i,1,1)*vy(i,1,1,ie)
               dw(i,ie) = dw(i,ie) + dwds(i,1,1)*vy(i,1,1,ie)
            enddo
c
            call mxm   (wk(1,1,1,1),nxy1,dztm1,lz1,duds,lz1)
            call mxm   (wk(1,1,1,2),nxy1,dztm1,lz1,dvds,lz1)
            call mxm   (wk(1,1,1,3),nxy1,dztm1,lz1,dwds,lz1)
            do i=1,nxyz1
               du(i,ie) = du(i,ie) + duds(i,1,1)*vz(i,1,1,ie)
               dv(i,ie) = dv(i,ie) + dvds(i,1,1)*vz(i,1,1,ie)
               dw(i,ie) = dw(i,ie) + dwds(i,1,1)*vz(i,1,1,ie)
            enddo
         else
c           2D
            do i=1,nxyz1
               wk(i,1,1,1)=u(i,1,1,ie)+beta*cu(i,1,1,ie)
               wk(i,1,1,2)=v(i,1,1,ie)+beta*cv(i,1,1,ie)
            enddo
c
            call mxm   (dxm1,lx1,wk(1,1,1,1),lx1,du(1,ie),nyz1)
            call mxm   (dxm1,lx1,wk(1,1,1,2),lx1,dv(1,ie),nyz1)
            do i=1,nxyz1
               du(i,ie) = du(i,ie)*vx(i,1,1,ie)
               dv(i,ie) = dv(i,ie)*vx(i,1,1,ie)
            enddo
c
            call mxm (wk(1,1,1,1),lx1,dytm1,ly1,duds,ly1)
            call mxm (wk(1,1,1,2),lx1,dytm1,ly1,dvds,ly1)
            do i=1,nxyz1
               du(i,ie) = du(i,ie) + duds(i,1,1)*vy(i,1,1,ie)
               dv(i,ie) = dv(i,ie) + dvds(i,1,1)*vy(i,1,1,ie)
            enddo
         endif
c
      enddo
c
#ifdef TIMER
      if (if3d) then
         opct = 21*ntot
      else
         opct = 10*ntot
      endif
c
      dct(myrout) = dct(myrout) + opct
      dcount      =      dcount + opct
#endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine frkconvv2(du,dv,dw,u,v,w,cu,cv,cw,beta,mu,wk)
c
      include 'SIZE'
      include 'DXYZ'
      include 'INPUT'
      include 'GEOM'
      include 'SOLN'
      include 'MASS'
      include 'TSTEP'
c
      real  du(1),dv(1),dw(1)
      real  u (1),v (1),w (1)
      real  cu(1),cv(1),cw(1)
      real  wk(lx1*ly1*lz1,3)
      integer mu(0:1)
c
      include 'OPCTR'
c
c     Operation count
c
#ifdef TIMER
      integer opct
      if (isclld.eq.0) then
          isclld=1
          nrout=nrout+1
          myrout=nrout
          rname(myrout) = 'frkcv2'
      endif
      ncall(myrout) = ncall(myrout) + 1
#endif
c
c
c     Evaluate right-hand-side for Runge-Kutta scheme in the case of
c     pure convection.
c
C
      ntot = lx1*ly1*lz1*nelv
      call conv1rk2  (du,dv,dw,u,v,w,cu,cv,cw,beta,wk)
      CALL OPDSSUM   (du,dv,dw)
c
      if (ldim.eq.3) then
         do i=1,ntot
            du(i) = du(i)*binvm1(i,1,1,1)
            dv(i) = dv(i)*binvm1(i,1,1,1)
            dw(i) = dw(i)*binvm1(i,1,1,1)
         enddo
      else
         do i=1,ntot
            du(i) = du(i)*binvm1(i,1,1,1)
            dv(i) = dv(i)*binvm1(i,1,1,1)
         enddo
      endif
c
c     Mask
c
      nu = mu(0)
      if (ldim.eq.3) then
         do i=1,nu
            du(mu(i)) = 0.
            dv(mu(i)) = 0.
            dw(mu(i)) = 0.
         enddo
      else
         do i=1,nu
            du(mu(i)) = 0.
            dv(mu(i)) = 0.
         enddo
      endif
c
#ifdef TIMER
      opct = ldim*ntot
      dct(myrout) = dct(myrout) + opct
      dcount      =      dcount + opct
#endif
C
      return
      end
c-----------------------------------------------------------------------
      subroutine hypmsk3v(msk,mask)
C---------------------------------------------------------------------
C
C     Generate mask-array for the hyperbolic system (velocity).
C
C---------------------------------------------------------------------
      include 'SIZE'
      include 'INPUT'
      include 'GEOM'
      include 'SOLN'
      include 'TSTEP'
      integer msk(0:1)
      CHARACTER      CB*3
      PARAMETER (LXYZ1=LX1*LY1*LZ1)
      COMMON /CTMP1/ WORK(LXYZ1,LELT)
      real mask(lxyz1,lelt)
C
      NFACES= 2*ldim
      NTOT1 = lx1*ly1*lz1*NELV
      CALL RZERO (WORK  ,NTOT1)
      CALL RONE  (mask,NTOT1)
C
      IF (IFIELD.EQ.1) THEN
      DO 100 IE=1,NELV
      DO 100 IFACE=1,NFACES
         CB=CBC(IFACE,IE,IFIELD)
         IF (CB(1:1).EQ.'V' .OR. CB(1:1).EQ.'v') THEN
           CALL FACCL3 (WORK(1,IE),VX(1,1,1,IE),UNX(1,1,IFACE,IE),IFACE)
           CALL FADDCL3(WORK(1,IE),VY(1,1,1,IE),UNY(1,1,IFACE,IE),IFACE)
           IF (IF3D) 
     $     CALL FADDCL3(WORK(1,IE),VZ(1,1,1,IE),UNZ(1,1,IFACE,IE),IFACE)
           CALL FCAVER (VAVER,WORK,IE,IFACE)
C
           IF (VAVER.LT.0.) CALL FACEV (mask,IE,IFACE,0.0,lx1,ly1,lz1)
         ENDIF
         IF (CB(1:2).EQ.'WS' .OR. CB(1:2).EQ.'ws') 
     $   CALL FACEV (mask,IE,IFACE,0.0,lx1,ly1,lz1)
 100   CONTINUE
      ENDIF
C
      nm = 0
      ntot = lx1*ly1*lz1*nelv
      do i=1,ntot
         if (mask(i,1).eq.0) then
            nm = nm+1
            msk(nm) = i
         endif
      enddo
      msk(0) = nm
C
      return
      END
c-----------------------------------------------------------------------
      subroutine ophyprk (vel1,vel2,vel3,ilag)
C---------------------------------------------------------------------------
C
C     Convection of all velocity components.
C     Runge-Kutta scheme.
C
C--------------------------------------------------------------------------
      include 'SIZE'
      include 'MASS'
      include 'SOLN'
      include 'TSTEP'
C
      REAL           VEL1  (LX1,LY1,LZ1,1)
      REAL           VEL2  (LX1,LY1,LZ1,1)
      REAL           VEL3  (LX1,LY1,LZ1,1)
      COMMON /SCRNS/ VXN   (LX1,LY1,LZ1,LELV)
     $ ,             VYN   (LX1,LY1,LZ1,LELV)
     $ ,             VZN   (LX1,LY1,LZ1,LELV)
     $ ,             HV1MSK(LX1,LY1,LZ1,LELV)
     $ ,             HV2MSK(LX1,LY1,LZ1,LELV)
     $ ,             HV3MSK(LX1,LY1,LZ1,LELV)
     $ ,             WORK  (LX1,LY1,LZ1,LELV)
      COMMON /CTMP1/ RKX1  (LX1,LY1,LZ1,LELV)
     $ ,             RKX2  (LX1,LY1,LZ1,LELV)
     $ ,             RKX3  (LX1,LY1,LZ1,LELV)
     $ ,             RKX4  (LX1,LY1,LZ1,LELV)
      COMMON /SCRMG/ RKY1  (LX1,LY1,LZ1,LELV)
     $ ,             RKY2  (LX1,LY1,LZ1,LELV)
     $ ,             RKY3  (LX1,LY1,LZ1,LELV)
     $ ,             RKY4  (LX1,LY1,LZ1,LELV)
      COMMON /SCREV/ RKZ1  (LX1,LY1,LZ1,LELV)
     $ ,             RKZ2  (LX1,LY1,LZ1,LELV)
      COMMON /SCRCH/ RKZ3  (LX1,LY1,LZ1,LELV)
     $ ,             RKZ4  (LX1,LY1,LZ1,LELV)
C
      NTOT1 = lx1*ly1*lz1*NELV
C
      CALL OPCOPY  (VXN,VYN,VZN,VX,VY,VZ)
      CALL HYPMSK3 (HV1MSK,HV2MSK,HV3MSK)
      CALL TAUINIT (TAU,ILAG)
      CALL VELINIT (VEL1,VEL2,VEL3,ILAG)
      CALL VELCONV (VXN,VYN,VZN,TAU)
C
      DO 1000 JLAG=ILAG,1,-1
C
         DTAU   = DTLAG(JLAG)/(NTAUBD)
         DTHALF = DTAU/2.
         CRK1   = DTAU/6.
         CRK2   = DTAU/3.
C
         DO 900 ITAU=1,NTAUBD
C
C           Stage 1.
C
            CALL FRKCONV (RKX1,VEL1,HV1MSK)
            CALL FRKCONV (RKY1,VEL2,HV2MSK)
            IF (ldim.EQ.3) 
     $      CALL FRKCONV (RKZ1,VEL3,HV3MSK)
C
C
C           Stage 2.
C
            TAU = TAU + DTHALF
            CALL VELCONV (VXN,VYN,VZN,TAU)
C
            CALL COPY    (WORK,VEL1,NTOT1)
            CALL ADD2S2  (WORK,RKX1,-DTHALF,NTOT1)
            CALL FRKCONV (RKX2,WORK,HV1MSK)
C
            CALL COPY    (WORK,VEL2,NTOT1)
            CALL ADD2S2  (WORK,RKY1,-DTHALF,NTOT1)
            CALL FRKCONV (RKY2,WORK,HV2MSK)
C
            IF (ldim.EQ.3) THEN
               CALL COPY    (WORK,VEL3,NTOT1)
               CALL ADD2S2  (WORK,RKZ1,-DTHALF,NTOT1)
               CALL FRKCONV (RKZ2,WORK,HV3MSK)
            ENDIF
C
C
C           Stage 3.
C
            CALL COPY    (WORK,VEL1,NTOT1)
            CALL ADD2S2  (WORK,RKX2,-DTHALF,NTOT1)
            CALL FRKCONV (RKX3,WORK,HV1MSK)

            CALL COPY    (WORK,VEL2,NTOT1)
            CALL ADD2S2  (WORK,RKY2,-DTHALF,NTOT1)
            CALL FRKCONV (RKY3,WORK,HV2MSK)
C
            IF (ldim.EQ.3) THEN
               CALL COPY    (WORK,VEL3,NTOT1)
               CALL ADD2S2  (WORK,RKZ2,-DTHALF,NTOT1)
               CALL FRKCONV (RKZ3,WORK,HV3MSK)
            ENDIF
C
C
C           Stage 4.
C
            TAU = TAU + DTHALF
            CALL VELCONV (VXN,VYN,VZN,TAU)
C
            CALL COPY    (WORK,VEL1,NTOT1)
            CALL ADD2S2  (WORK,RKX3,-DTAU,NTOT1)
            CALL FRKCONV (RKX4,WORK,HV1MSK)

            CALL COPY    (WORK,VEL2,NTOT1)
            CALL ADD2S2  (WORK,RKY3,-DTAU,NTOT1)
            CALL FRKCONV (RKY4,WORK,HV2MSK)
C
            IF (ldim.EQ.3) THEN
               CALL COPY    (WORK,VEL3,NTOT1)
               CALL ADD2S2  (WORK,RKZ3,-DTAU,NTOT1)
               CALL FRKCONV (RKZ4,WORK,HV3MSK)
            ENDIF
C
C
C           Sum up contributions from 4 stages.
C
            CALL ADD2S2  (VEL1,RKX1,-CRK1,NTOT1)
            CALL ADD2S2  (VEL1,RKX2,-CRK2,NTOT1)
            CALL ADD2S2  (VEL1,RKX3,-CRK2,NTOT1)
            CALL ADD2S2  (VEL1,RKX4,-CRK1,NTOT1)
C
            CALL ADD2S2  (VEL2,RKY1,-CRK1,NTOT1)
            CALL ADD2S2  (VEL2,RKY2,-CRK2,NTOT1)
            CALL ADD2S2  (VEL2,RKY3,-CRK2,NTOT1)
            CALL ADD2S2  (VEL2,RKY4,-CRK1,NTOT1)
C
            IF (ldim.EQ.3) THEN
               CALL ADD2S2  (VEL3,RKZ1,-CRK1,NTOT1)
               CALL ADD2S2  (VEL3,RKZ2,-CRK2,NTOT1)
               CALL ADD2S2  (VEL3,RKZ3,-CRK2,NTOT1)
               CALL ADD2S2  (VEL3,RKZ4,-CRK1,NTOT1)
            ENDIF
C
  900    CONTINUE
 1000 CONTINUE
C
      CALL OPCOPY (VX,VY,VZ,VXN,VYN,VZN)
C
      return
      END
c-----------------------------------------------------------------------
      subroutine opdiv(outfld,inpx,inpy,inpz)
C---------------------------------------------------------------------
C
C     Compute OUTFLD = SUMi Di*INPi, 
C     the divergence of the vector field (INPX,INPY,INPZ)
C
C---------------------------------------------------------------------
      include 'SIZE'
      include 'GEOM'
      real outfld (lx2,ly2,lz2,1)
      real inpx   (lx1,ly1,lz1,1)
      real inpy   (lx1,ly1,lz1,1)
      real inpz   (lx1,ly1,lz1,1)
      common /ctmp0/ work (lx2,ly2,lz2,lelv)
C
      iflg = 1

      ntot2 = lx2*ly2*lz2*nelv
      call multd (work,inpx,rxm2,sxm2,txm2,1,iflg)
      call copy  (outfld,work,ntot2)
      call multd (work,inpy,rym2,sym2,tym2,2,iflg)
      call add2  (outfld,work,ntot2)
      if (ldim.eq.3) then
         call multd (work,inpz,rzm2,szm2,tzm2,3,iflg)
         call add2  (outfld,work,ntot2)
      endif
C
      return
      end
C
c-----------------------------------------------------------------------
      subroutine opgradt(outx,outy,outz,inpfld)
C------------------------------------------------------------------------
C
C     Compute DTx, DTy, DTz of an input field INPFLD 
C
C-----------------------------------------------------------------------
      include 'SIZE'
      include 'TOTAL'
      real outx   (lx1,ly1,lz1,1)
      real outy   (lx1,ly1,lz1,1)
      real outz   (lx1,ly1,lz1,1)
      real inpfld (lx2,ly2,lz2,1)
C
      call cdtp (outx,inpfld,rxm2,sxm2,txm2,1)
      call cdtp (outy,inpfld,rym2,sym2,tym2,2)
      if (ldim.eq.3) 
     $   call cdtp (outz,inpfld,rzm2,szm2,tzm2,3)
C
      return
      end
c-----------------------------------------------------------------------
      subroutine setproj(n1,nd)
c
      include 'SIZE'
      include 'DEALIAS'
      include 'INPUT'
c
      parameter(lx=80)
      real LkN(lx,lx),LkD(lx,lx),LkNt(lx,lx)
c
      if (n1.gt.lx.or.nd.gt.lx) then
         write(6,*)'ERROR: increase lx in setmap to max:',n1,nd
         call exitt
      endif
c
c
      if (param(99).eq.2) then
         call set_PND  (PmD1 ,LkD,LkNt,n1,nd)
      elseif (param(99).eq.3) then
         call set_PNDoi(PmD1 ,LkD,LkNt,n1,nd)
      endif
      call transpose(PmD1t,nd,PmD1,n1)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine set_PNDoi(Pt,P,LkNt,N,D)

      include 'SIZE'   ! for write stmt

c
c     Set up operators for overintegration and interpolation
c
      integer N,D
      real    Pt(N,D),P(D,N),LkNt(N,0:N-1)
c
      parameter(lx=80)
      real zN(lx),zD(lx),wN(lx),wD(lx)
c
c     Compute Lagrangian interpolant points
c
      call zwgll(zN,wN,N)
      call zwgll(zD,wD,D)
c
      if (nio.eq.0) write(6,*) 'dealias, pndoi:',N,D
      call IGLLM (P,Pt,ZN,ZD,N,D,N,D)
c
      do j=1,D
      do i=1,N
         Pt(i,j) = wD(j)*Pt(i,j)/wN(i)
      enddo
      enddo
      return
      end
c-----------------------------------------------------------------------
      subroutine wgradm1(ux,uy,uz,u,nel) ! weak form of grad 
c
c     Compute gradient of T -- mesh 1 to mesh 1 (vel. to vel.)
c
      include 'SIZE'
      include 'DXYZ'
      include 'GEOM'
      include 'INPUT'
      include 'TSTEP'
      include 'WZ'
c
      parameter (lxyz=lx1*ly1*lz1)
      real ux(lxyz,1),uy(lxyz,1),uz(lxyz,1),u(lxyz,1)
c
      common /ctmp1/ ur(lxyz),us(lxyz),ut(lxyz)

      integer e

      N = lx1-1
      do e=1,nel
         if (if3d) then
            call local_grad3(ur,us,ut,u,N,e,dxm1,dxtm1)
            do i=1,lxyz
               ux(i,e) = w3m1(i,1,1)*(ur(i)*rxm1(i,1,1,e)
     $                              + us(i)*sxm1(i,1,1,e)
     $                              + ut(i)*txm1(i,1,1,e) )
               uy(i,e) = w3m1(i,1,1)*(ur(i)*rym1(i,1,1,e)
     $                              + us(i)*sym1(i,1,1,e)
     $                              + ut(i)*tym1(i,1,1,e) )
               uz(i,e) = w3m1(i,1,1)*(ur(i)*rzm1(i,1,1,e)
     $                              + us(i)*szm1(i,1,1,e)
     $                              + ut(i)*tzm1(i,1,1,e) )
            enddo
         else

            if (ifaxis) then
               call setaxdy (ifrzer(e))  ! reset dytm1
               call setaxw1 (ifrzer(e))  ! reset w3m1
            endif

            call local_grad2(ur,us,u,N,e,dxm1,dytm1)

            do i=1,lxyz
               ux(i,e) =w3m1(i,1,1)*(ur(i)*rxm1(i,1,1,e)
     $                             + us(i)*sxm1(i,1,1,e) )
               uy(i,e) =w3m1(i,1,1)*(ur(i)*rym1(i,1,1,e)
     $                             + us(i)*sym1(i,1,1,e) )
            enddo
         endif

      enddo
c
      return
      end
c-----------------------------------------------------------------------
      SUBROUTINE MAKEVIS
C----------------------------------------------------------------------
C
C     construct viscous term:
c
c     DEL*[mue*(DEL V + (DEL V)^T - 2/3*DEL*V *I)]
c                 =  
c     2*DEL*[mue*(S - 1/3*QTL*I)]
c
c     where mue is the viscosity, S the strain rate tensor,
c     tr(S) the trace of S and I the indentitiy matrix. 
c
c     NOTE: for now only for incompressible flows
c           In the compressible case we need to compute S using 
c           a kth-order extrapolation scheme because we cannot 
c           use the existing MAKEABF extrapolater and we need
c           to use mue/QTL from the thermo-chemical subsystem.
c           CAUTION: we cannot use BFX,BFY,BFZ anymore. Some 
c                    extra handling in plan4 is needed to add the
c                    viscous term to the RHS!   
 
C----------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'SOLN'
      INCLUDE 'MASS'
      INCLUDE 'TSTEP'
C
      COMMON /SCRUZ/ W1 (LX1,LY1,LZ1,LELV)
     $ ,             W2 (LX1,LY1,LZ1,LELV)
     $ ,             W3 (LX1,LY1,LZ1,LELV)
C
      COMMON /SCRNS/ SXZ(LX1,LY1,LZ1,LELT)
     $             , SYZ(LX1,LY1,LZ1,LELT)
     $             , SXX(LX1,LY1,LZ1,LELT)
     $             , SXY(LX1,LY1,LZ1,LELT)
     $             , SYY(LX1,LY1,LZ1,LELT)
     $             , SZZ(LX1,LY1,LZ1,LELT)

      REAL fac
C----------------------------------------------------------------------

      NTOT = lx1*ly1*lz1*NELV

      ! CONSTRUCT strain rate tensor S (SXX, ..., SZZ)
      ! CALL MAKEABS
      CALL COMP_SIEJ(VX,VY,VZ) 

      ! substract trace of S
c      CALL ADD4  (W1,SXX,SYY,SZZ,NTOT)
      CALL COPY  (W1,QTL,ntot)  
      fac = -1./3. 
      CALL CMULT (W1,fac,NTOT)
      CALL ADD2  (SXX,W1,NTOT)
      CALL ADD2  (SYY,W1,NTOT)
      CALL ADD2  (SZZ,W1,NTOT)

      CALL OPCOLV(SXX,SYY,SZZ,VDIFF_E)
      CALL OPCOLV(SXY,SXZ,SYZ,VDIFF_E)

      ! not sure if that is really needed
      CALL OPCOLV (SXX,SYY,SZZ,BM1)
      CALL OPCOLV (SXY,SXZ,SYZ,BM1)
      CALL OPDSSUM(SXX,SYY,SZZ)
      CALL OPDSSUM(SXY,SXZ,SYZ)
      CALL OPCOLV (SXX,SYY,SZZ,BINVM1)
      CALL OPCOLV (SXY,SXZ,SYZ,BINVM1)

      CALL RONE(W2,NTOT)
      fac = 2.0
      CALL CMULT  (W2,fac,NTOT)
      
c add to RHS (BFX,BFY,BFZ)
      CALL OPDIV (W1,SXX,SXY,SXZ)
      CALL COL2  (W1,W2,NTOT)
      CALL ADD2  (BFX,W1,NTOT)
      
      CALL OPDIV (W1,SXY,SYY,SYZ)
      CALL COL2  (W1,W2,NTOT)
      CALL ADD2  (BFY,W1,NTOT)

      IF (ldim.EQ.3) THEN
        CALL OPDIV (W1,SXZ,SYZ,SZZ)
        CALL COL2  (W1,W2,NTOT)
        CALL ADD2  (BFZ,W1,NTOT)
      ENDIF


      RETURN
      END
c-----------------------------------------------------------------------

      SUBROUTINE COMP_SIEJ (U1,U2,U3)
C
C     Compute strainrates
C
C     CAUTION : CB SCRNS is used for data change
C
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'GEOM'

      COMMON /SCRNS/ EXZ(LX1,LY1,LZ1,LELT)
     $             , EYZ(LX1,LY1,LZ1,LELT)
     $             , EXX(LX1,LY1,LZ1,LELT)
     $             , EXY(LX1,LY1,LZ1,LELT)
     $             , EYY(LX1,LY1,LZ1,LELT)
     $             , EZZ(LX1,LY1,LZ1,LELT)

C
      DIMENSION U1(LX1,LY1,LZ1,1)
     $        , U2(LX1,LY1,LZ1,1)
     $        , U3(LX1,LY1,LZ1,1)


      NEL = NELV
      NTOT1 = lx1*ly1*lz1*NEL

      CALL RZERO3 (EXX,EYY,EZZ,NTOT1)
      CALL RZERO3 (EXY,EXZ,EYZ,NTOT1)
C
      CALL UXYZ  (U1,EXX,EXY,EXZ,NEL)
      CALL UXYZ  (U2,EXY,EYY,EYZ,NEL)
      IF (ldim.EQ.3) CALL UXYZ   (U3,EXZ,EYZ,EZZ,NEL)
C
      CALL COL2 (EXX,JACMi,NTOT1)
      CALL COL2 (EXY,JACMi,NTOT1)
      CALL COL2 (EYY,JACMi,NTOT1)
C
      IF (IFAXIS) CALL AXIEZZ (U2,EYY,EZZ,NEL)
C
      IF (ldim.EQ.3) THEN
         CALL COL2 (EXZ,JACMi,NTOT1)
         CALL COL2 (EYZ,JACMi,NTOT1)
         CALL COL2 (EZZ,JACMi,NTOT1)
      ENDIF
C
      fac = 0.5
      CALL CMULT (EXY,fac,NTOT1) 
      CALL CMULT (EXZ,fac,NTOT1)  
      CALL CMULT (EYZ,fac,NTOT1) 

      RETURN
      END
c-----------------------------------------------------------------------
      subroutine wlaplacian(out,a,diff,ifld)
c
c     compute weak form of the laplacian operator including the boundary
c     contribution
c
      include 'SIZE'
      include 'TOTAL'

      real out(1),a(1),diff(1)
      real wrk(lx1,ly1,lz1,lelt)
      real h2(lx1,ly1,lz1,lelt)

      ntot = lx1*ly1*lz1*nelfld(ifld)
      if (.not.iftmsh(ifld)) imesh = 1
      if (     iftmsh(ifld)) imesh = 2

      call rzero(h2,ntot)

      ifield_ = ifield
      ifield = ifld

      call bcneusc(out,1)
      call axhelm(wrk,a,diff,h2,imesh,1)
      call sub2 (out,wrk,ntot)  
 
      ifield = ifield_ 

      return
      end
c-----------------------------------------------------------------------
      subroutine explstrs ! Explicit stress tensor w/ variable viscosity

      include 'SIZE'
      include 'TOTAL'

      common /scruz/ u(lx1*ly1*lz1),v(lx1*ly1*lz1),w(lx1*ly1*lz1)

      integer e

      nxyz = lx1*ly1*lz1


      do e=1,nelv

        call expl_strs_e(u,v,w,vx(1,1,1,e),vy(1,1,1,e),vz(1,1,1,e),e)

        do i=1,nxyz
           bfx(i,1,1,e) = bfx(i,1,1,e) - u(i)
           bfy(i,1,1,e) = bfy(i,1,1,e) - v(i)
           bfz(i,1,1,e) = bfz(i,1,1,e) - w(i)
        enddo

      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine expl_strs(w1,w2,w3,u1,u2,u3)
      include 'SIZE'
      include 'TOTAL'

      real w1(1),w2(1),w3(1),u1(1),u2(1),u3(1)

      integer e

      nxyz = lx1*ly1*lz1
      k = 1
      do e=1,nelv

         call expl_strs_e(w1(k),w2(k),w3(k),u1(k),u2(k),u3(k),e)
         k = k+nxyz

      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine expl_strs_e(w1,w2,w3,u1,u2,u3,e)
      include 'SIZE'
      include 'INPUT'  ! if3d
      include 'SOLN'   ! nu_star

      real w1(1),w2(1),w3(1),u1(1),u2(1),u3(1)
      integer e

      integer icalld
      save    icalld
      data    icalld /0/

      if (nio.eq.0.and.icalld.eq.0) write(6,*) 'nu_star:',nu_star
      icalld=1

      if (if3d) then
         call expl_strs_e_3d (w1,w2,w3,u1,u2,u3,e)
      else
         call expl_strs_e_2d (w1,w2,u1,u2,e)
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine expl_strs_e_3d(w1,w2,w3,u1,u2,u3,e)

c     Evaluate, for element e,
c     
c     /dvi\T  /     dui       duj \
c     |---|   | dnu ---  + nu --- |    (no boundary terms at present)
c     \dxj/   \     dxj       dxi /


      real w1(1),w2(1),w3(1),u1(1),u2(1),u3(1)
      integer e

      include 'SIZE'
      include 'GEOM'    ! jacmi,rxm1, etc.
      include 'INPUT'   ! if3d
      include 'MASS'    ! bm1
      include 'SOLN'    ! vtrans,vdiff,nu_star
      include 'TSTEP'   ! dt
      include 'WZ'      ! w3m1

      real nu

      parameter (lxyz=lx1*ly1*lz1)
      common /ctmp1/ ur(lxyz),us(lxyz),ut(lxyz)
     $             , vr(lxyz),vs(lxyz),vt(lxyz)
     $             , wr(lxyz),ws(lxyz),wt(lxyz)

      call gradl_rst(ur,us,ut,u1,lx1,if3d) ! Grad on GLL
      call gradl_rst(vr,vs,vt,u2,lx1,if3d)
      call gradl_rst(wr,ws,wt,u3,lx1,if3d)

      do i=1,lxyz

         nu  = vdiff(i,1,1,e,1)
         dnu = nu - nu_star  ! nu_star is the constant implicit part

c        uij := jac*( du_i / dx_j )

         u11=ur(i)*rxm1(i,1,1,e)+us(i)*sxm1(i,1,1,e)+ut(i)*txm1(i,1,1,e)
         u21=vr(i)*rxm1(i,1,1,e)+vs(i)*sxm1(i,1,1,e)+vt(i)*txm1(i,1,1,e)
         u31=wr(i)*rxm1(i,1,1,e)+ws(i)*sxm1(i,1,1,e)+wt(i)*txm1(i,1,1,e)
         u12=ur(i)*rym1(i,1,1,e)+us(i)*sym1(i,1,1,e)+ut(i)*tym1(i,1,1,e)
         u22=vr(i)*rym1(i,1,1,e)+vs(i)*sym1(i,1,1,e)+vt(i)*tym1(i,1,1,e)
         u32=wr(i)*rym1(i,1,1,e)+ws(i)*sym1(i,1,1,e)+wt(i)*tym1(i,1,1,e)
         u13=ur(i)*rzm1(i,1,1,e)+us(i)*szm1(i,1,1,e)+ut(i)*tzm1(i,1,1,e)
         u23=vr(i)*rzm1(i,1,1,e)+vs(i)*szm1(i,1,1,e)+vt(i)*tzm1(i,1,1,e)
         u33=wr(i)*rzm1(i,1,1,e)+ws(i)*szm1(i,1,1,e)+wt(i)*tzm1(i,1,1,e)

         w11 = dnu*u11 + nu*u11
         w12 = dnu*u12 + nu*u21
         w13 = dnu*u13 + nu*u31
         w21 = dnu*u21 + nu*u12
         w22 = dnu*u22 + nu*u22
         w23 = dnu*u23 + nu*u32
         w31 = dnu*u31 + nu*u13
         w32 = dnu*u32 + nu*u23
         w33 = dnu*u33 + nu*u33

         w   = w3m1(i,1,1)*jacmi(i,e)  ! note, ry has jac in it.

         ur(i)=(w11*rxm1(i,1,1,e)+w12*rym1(i,1,1,e)+w13*rzm1(i,1,1,e))*w
         us(i)=(w11*sxm1(i,1,1,e)+w12*sym1(i,1,1,e)+w13*szm1(i,1,1,e))*w
         ut(i)=(w11*txm1(i,1,1,e)+w12*tym1(i,1,1,e)+w13*tzm1(i,1,1,e))*w
         vr(i)=(w21*rxm1(i,1,1,e)+w22*rym1(i,1,1,e)+w23*rzm1(i,1,1,e))*w
         vs(i)=(w21*sxm1(i,1,1,e)+w22*sym1(i,1,1,e)+w23*szm1(i,1,1,e))*w
         vt(i)=(w21*txm1(i,1,1,e)+w22*tym1(i,1,1,e)+w23*tzm1(i,1,1,e))*w
         wr(i)=(w31*rxm1(i,1,1,e)+w32*rym1(i,1,1,e)+w33*rzm1(i,1,1,e))*w
         ws(i)=(w31*sxm1(i,1,1,e)+w32*sym1(i,1,1,e)+w33*szm1(i,1,1,e))*w
         wt(i)=(w31*txm1(i,1,1,e)+w32*tym1(i,1,1,e)+w33*tzm1(i,1,1,e))*w

      enddo

      call gradl_rst_t(w1,ur,us,ut,lx1,if3d)
      call gradl_rst_t(w2,vr,vs,vt,lx1,if3d)
      call gradl_rst_t(w3,wr,ws,wt,lx1,if3d)

      return
      end
c-----------------------------------------------------------------------
      subroutine expl_strs_e_2d(w1,w2,u1,u2,e)

c
c     Evaluate, for element e,
c     
c     /dvi\T  /     dui       duj \
c     |---|   | dnu ---  + nu --- |    (no boundary terms at present)
c     \dxj/   \     dxj       dxi /
c


      real w1(1),w2(1),u1(1),u2(1)
      integer e

      include 'SIZE'
      include 'GEOM'    ! jacmi,rxm1, etc.
      include 'INPUT'   ! if3d
      include 'MASS'    ! bm1
      include 'SOLN'    ! vtrans,vdiff,nu_star
      include 'TSTEP'   ! dt
      include 'WZ'      ! w3m1

      real nu

      parameter (lxyz=lx1*ly1*lz1)
      common /ctmp1/ ur(lxyz),us(lxyz),ut(lxyz)
     $             , vr(lxyz),vs(lxyz),vt(lxyz)
     $             , wr(lxyz),ws(lxyz),wt(lxyz)

      call gradl_rst(ur,us,ut,u1,lx1,if3d) ! Grad on GLL
      call gradl_rst(vr,vs,vt,u2,lx1,if3d)

      do i=1,lxyz

         nu  = vdiff(i,1,1,e,1)
         dnu = nu - nu_star  ! nu_star is the constant implicit part

c        uij := jac*( du_i / dx_j )

         u11=ur(i)*rxm1(i,1,1,e)+us(i)*sxm1(i,1,1,e)
         u21=vr(i)*rxm1(i,1,1,e)+vs(i)*sxm1(i,1,1,e)
         u12=ur(i)*rym1(i,1,1,e)+us(i)*sym1(i,1,1,e)
         u22=vr(i)*rym1(i,1,1,e)+vs(i)*sym1(i,1,1,e)

         w11 = dnu*u11 + nu*u11
         w12 = dnu*u12 + nu*u21
         w21 = dnu*u21 + nu*u12
         w22 = dnu*u22 + nu*u22

         w   = w3m1(i,1,1)*jacmi(i,e)  ! note, ry has jac in it.

         ur(i)=(w11*rxm1(i,1,1,e)+w12*rym1(i,1,1,e))*w
         us(i)=(w11*sxm1(i,1,1,e)+w12*sym1(i,1,1,e))*w
         vr(i)=(w21*rxm1(i,1,1,e)+w22*rym1(i,1,1,e))*w
         vs(i)=(w21*sxm1(i,1,1,e)+w22*sym1(i,1,1,e))*w

      enddo

      call gradl_rst_t(w1,ur,us,ut,lx1,if3d)
      call gradl_rst_t(w2,vr,vs,vt,lx1,if3d)

      return
      end
c-----------------------------------------------------------------------
      subroutine gradl_rst_t(u,ur,us,ut,md,if3d)  ! GLL grad-transpose
c
c     Thus routine originally from fsi file: u5.usr (May 2010)
c
c
      include 'SIZE'
      include 'DXYZ'

      real    u(1),ur(1),us(1),ut(1)
      logical if3d

c     dgradl holds GLL-based derivative / interpolation operators

      parameter (ldg=lxd**3,lwkd=2*ldg)
      common /dgradl/ d(ldg),dt(ldg),dg(ldg),dgt(ldg),jgl(ldg),jgt(ldg)
     $             , wkd(lwkd)
      real jgl,jgt

      m0 = md-1
      call get_dgll_ptr (ip,md,md)
      if (if3d) then
         call local_grad3_t(u,ur,us,ut,m0,1,d(ip),dt(ip),wkd)
      else
         call local_grad2_t(u,ur,us   ,m0,1,d(ip),dt(ip),wkd)
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine gradl_rst(ur,us,ut,u,md,if3d)  ! GLL-based gradient
c
      include 'SIZE'
      include 'DXYZ'

      real    ur(1),us(1),ut(1),u(1)
      logical if3d

c     dgradl holds GLL-based derivative / interpolation operators

      parameter (ldg=lxd**3,lwkd=4*lxd*lxd)
      common /dgradl/ d(ldg),dt(ldg),dg(ldg),dgt(ldg),jgl(ldg),jgt(ldg)
     $             , wkd(lwkd)
      real jgl,jgt

      m0 = md-1
      call get_dgll_ptr (ip,md,md)
      if (if3d) then
         call local_grad3(ur,us,ut,u,m0,1,d(ip),dt(ip))
      else
         call local_grad2(ur,us   ,u,m0,1,d(ip),dt(ip))
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine local_grad3_t(u,ur,us,ut,N,e,D,Dt,w)
c     Output: ur,us,ut         Input:u,N,e,D,Dt
      real u (0:N,0:N,0:N,1)
      real ur(0:N,0:N,0:N),us(0:N,0:N,0:N),ut(0:N,0:N,0:N)
      real D (0:N,0:N),Dt(0:N,0:N)
      real w (0:N,0:N,0:N)
      integer e

      m1 = N+1
      m2 = m1*m1
      m3 = m1*m1*m1

      call mxm(Dt,m1,ur,m1,u(0,0,0,e),m2)

      do k=0,N
         call mxm(us(0,0,k),m1,D ,m1,w(0,0,k),m1)
      enddo
      call add2(u(0,0,0,e),w,m3)

      call mxm(ut,m2,D ,m1,w,m1)
      call add2(u(0,0,0,e),w,m3)

      return
      end
c-----------------------------------------------------------------------
      subroutine local_grad2_t(u,ur,us,N,e,D,Dt,w)
c     Output: ur,us         Input:u,N,e,D,Dt
      real u (0:N,0:N,1)
      real ur(0:N,0:N),us(0:N,0:N)
      real D (0:N,0:N),Dt(0:N,0:N)
      real w (0:N,0:N)
      integer e

      m1 = N+1
      m2 = m1*m1

      call mxm(Dt,m1,ur,m1,u(0,0,e),m1)
      call mxm(us,m1,D ,m1,w         ,m1)
      call add2(u(0,0,e),w,m2)

      return
      end
c-----------------------------------------------------------------------
      subroutine get_dgll_ptr (ip,mx,md)
c
c     Get pointer to GLL-GLL interpolation dgl() for pair (mx,md)
c
      include 'SIZE'

c     dgradl holds GLL-based derivative / interpolation operators

      parameter (ldg=lxd**3,lwkd=4*lxd*lxd)
      common /dgradl/ d(ldg),dt(ldg),dg(ldg),dgt(ldg),jgl(ldg),jgt(ldg)
     $             , wkd(lwkd)
      real jgl,jgt
 
c     Pointers into GLL-based derivative / interpolation operators

      parameter (ld=2*lxd)
      common /jgradl/ pd    (0:ld*ld)
     $              , pdg   (0:ld*ld)
     $              , pjgl  (0:ld*ld)
      integer pd , pdg , pjgl

      ij = md + ld*(mx-1)
      ip = pdg (ij)

      if (ip.eq.0) then

         nstore   = pdg (0)
         pdg (ij) = nstore+1
         nstore   = nstore + md*mx
         pdg (0)  = nstore
         ip       = pdg (ij)

        if (nid.eq.985) write(6,*) nstore,ldg,ij,md,mx,ip,' NSTOR'
c
         nwrkd = mx + md
         call lim_chk(nstore,ldg ,'dg   ','ldg  ','get_dgl_pt')
         call lim_chk(nwrkd ,lwkd,'wkd  ','lwkd ','get_dgl_pt')
c
         call gen_dgll(d (ip),dt(ip),md,mx,wkd)
      endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine gen_dgll(dgl,dgt,mp,np,w)
c
c     Generate derivative from np GL points onto mp GL points
c
c        dgl  = derivative matrix, mapping from velocity nodes to pressure
c        dgt  = transpose of derivative matrix
c        w    = work array of size (3*np+mp)
c
c        np   = number of points on GLL grid
c        mp   = number of points on GL  grid
c
c
c
      real dgl(mp,np),dgt(np*mp),w(1)
c
c
      iz = 1
      id = iz + np
c
      call zwgll (w(iz),dgt,np)  ! GL points
      call zwgll (w(id),dgt,mp)  ! GL points
c
      ndgt = 2*np
      ldgt = mp*np
      call lim_chk(ndgt,ldgt,'ldgt ','dgt  ','gen_dgl   ')
c
      n  = np-1
      do i=1,mp
         call fd_weights_full(w(id+i-1),w(iz),n,1,dgt) ! 1=1st deriv.
         do j=1,np
            dgl(i,j) = dgt(np+j)                       ! Derivative matrix
         enddo
      enddo
c
      call transpose(dgt,np,dgl,mp)
c
      return
      end
c-----------------------------------------------------------------------

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Though we have used critical directive to ensure that additions across teams are not overlapped.
!Critical only synchronizes within a team. There is a data race pair.
!Data Race pairs, var@24:9 and var@24:15


program DRB148_critical1_orig_gpu_yes
    use omp_lib
    implicit none

    integer :: var, i
    var = 0

    !$omp target map(tofrom:var) device(0)
    !$omp teams distribute parallel do
    do i = 1, 100
        !$omp critical(addlock)
        var = var+1
        !$omp end critical(addlock)
    end do
    !$omp end teams distribute parallel do
    !$omp end target

    print*,var
end program

program powspec
  implicit none
!$CVL $input 
  integer :: inval0, inval1
!$CVL $output
  integer :: outval
  integer :: i, res
!$CVL $assume(0.0 .LE. inval0 .AND. inval0 .LE. 10.0);
!$CVL $assume(1.0 .LE. inval1 .AND. inval1 .LE. 3.0);
  res = inval0
  do i=1,inval1-1
    res = res + inval0
  end do
  outval = res
end program powspec

c-----------------------------------------------------------------------
      subroutine setup_topo
C
C     Parallel compatible routine to find 
C     connectivity of element structure.
C
C     On Processor 0:
C
C     .Verify right-handedness of elements.
C     .Verify element-to-element reciprocity of BC's
C     .Verify correlation between E-E BC's and physical coincidence
C     .Set rotations
C     .Determine multiplicity
C     .Set up direct stiffness summation arrays.
C
C     All Processors:
C
C     .Disperse/Receive BC and MULT temporary data read from preprocessor.
C
C
      include 'SIZE'
      include 'TOTAL'
      include 'NONCON'
      include 'SCRCT'
c
      common /nekmpi/ nidd,npp,nekcomm,nekgroup,nekreal
c      
      COMMON /SCRUZ/ XM3 (LX3,LY3,LZ3,LELT)
     $ ,             YM3 (LX3,LY3,LZ3,LELT)
     $ ,             ZM3 (LX3,LY3,LZ3,LELT)
C
      common /c_is1/ glo_num(1*lx1*ly1*lz1*lelv)
      integer*8 glo_num
      common /ivrtx/ vertex ((2**ldim)*lelt)
      integer vertex

      if(nio.eq.0) write(6,*) 'setup mesh topology'
C
C     Initialize key arrays for Direct Stiffness SUM.
C
      NXL=3
      NYL=3
      NZL=1+2*(ldim-2)

      call initds
      call dsset (nxl,nyl,nzl)
      call setedge
C
C=================================================
C     Establish (global) domain topology
C=================================================
C
C     .Generate topologically correct mesh data.
C     .Set up element centers, face centers, etc. 
C     .Check  right handedness of elements.
C     .Check  element boundary conditions.
C     .Establish Element-Element rotations
C     .Construct the element to processor map and

      call genxyzl
      call setside
      call verify

      CALL SETCDOF 
      IF (IFAXIS            ) CALL SETRZER
      IF (IFMVBD            ) CALL CBCMESH
      CALL CHKAXCB
C
C========================================================================
C     Set up element-processor mapping and establish global numbering
C========================================================================
C
      mfield=2
      if (ifflow) mfield=1
      if (ifmvbd) mfield=0

      ncrnr = 2**ldim

      if (nelgv.eq.nelgt) then
         call get_vert
         call setupds(gsh_fld(1),lx1,ly1,lz1,nelv,nelgv,vertex,glo_num)
         gsh_fld(2)=gsh_fld(1)

         if(nid.eq.0) write(6,*) ''
         call printPartStat(glo_num,nelt,lx1*ly1*lz1,nekcomm)
         if(nid.eq.0) write(6,*) ''

c        call gs_counter(glo_num,gsh_fld(1))

      else

c
c        For conjugate heat transfer, it is assumed that fluid
c        elements are listed both globally and locally with lower
c        element numbers than the solid elements.
c
c        We currently assume that there is at least one fluid elem.
c        per processor.
c

         call get_vert
c        call outmati(vertex,4,nelv,'vrtx V')
         call setupds(gsh_fld(1),lx1,ly1,lz1,nelv,nelgv,vertex,glo_num)

c        call get_vert  (vertex, ncrnr, nelgt, '.mp2')  !  LATER !
c        call outmati(vertex,4,nelt,'vrtx T')
         call setupds(gsh_fld(2),lx1,ly1,lz1,nelt,nelgt,vertex,glo_num)

c
c        Feb 20, 2012:  It appears that we do not need this restriction: (pff)
c
c        check if there is a least one fluid element on each processor
c        do iel = 1,nelt
c           ieg = lglel(iel)
c           if (ieg.le.nelgv) goto 101 
c        enddo
c        if(nio.eq.0) write(6,*) 
c    &     'ERROR: each domain must contain at least one fluid element!'
c        call exitt
c 101   continue

      endif


c     if (ifmvbd) call setup_mesh_dssum ! Set up dssum for mesh

C========================================================================
C     Set up multiplicity and direct stiffness arrays for each IFIELD
C========================================================================

      ntotv = lx1*ly1*lz1*nelv
      ntott = lx1*ly1*lz1*nelt

      if (ifflow) then
         ifield = 1
         call rone    (vmult,ntotv)
         call dssum   (vmult,lx1,ly1,lz1)
         vmltmax=glmax(vmult,ntotv)
         ivmltmax=vmltmax
         if (nio.eq.0) write(6,*) 'max multiplicity ', ivmltmax
         call invcol1 (vmult,ntotv)
      endif
      if (ifheat) then
         ifield = 2
         call rone    (tmult,ntott)
         call dssum   (tmult,lx1,ly1,lz1)
         call invcol1 (tmult,ntott)
      endif
      if (.not.ifflow) call copy(vmult,tmult,ntott)
      if (ifmvbd)  call copy (wmult,vmult,ntott)
      do ifield=3,nfield                  ! Additional pass. scalrs.
         if (nelg(ifield).eq.nelgv) then
            gsh_fld(ifield) = gsh_fld(1)
            call copy (tmult(1,1,1,1,ifield-1),vmult,ntotv)
         else
            gsh_fld(ifield) = gsh_fld(2)
            call copy (tmult(1,1,1,1,ifield-1),tmult,ntott)
         endif
      enddo

      ifgsh_fld_same = .true.
      do ifield=2,nfield
         if (gsh_fld(ifield).ne.gsh_fld(1)) then
            ifgsh_fld_same = .false.
            goto 100
         endif
      enddo
 100  continue

      if(nio.eq.0) then
        write(6,*) 'done :: setup mesh topology'
        write(6,*) ' '
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine initds
C
C          -- Direct Stiffness Initialization Routine --
C
C     Set up required data for packing data on faces of spectral cubes.
C
      INCLUDE 'SIZE'
      INCLUDE 'TOPOL'
C
C     Nominal ordering for direct stiffness summation of faces
C
      J=0
      DO 5 IDIM=1,ldim
      DO 5 IFACE=1,2
        J=J+1
         NOMLIS(IFACE,IDIM)=J
    5 CONTINUE
C
C     Assign Ed's numbering scheme to PF's scheme.
C
      EFACE(1)=4
      EFACE(2)=2
      EFACE(3)=1
      EFACE(4)=3
      EFACE(5)=5
      EFACE(6)=6
C
C     Assign inverse of Ed's numbering scheme to PF's scheme.
C
      EFACE1(1)=3
      EFACE1(2)=2
      EFACE1(3)=4
      EFACE1(4)=1
      EFACE1(5)=5
      EFACE1(6)=6
C
C     Assign group designation to each face to determine ordering of indices.
C
      GROUP(1)=0
      GROUP(2)=1
      GROUP(3)=1
      GROUP(4)=0
      GROUP(5)=0
      GROUP(6)=1
C
      RETURN
      END
c-----------------------------------------------------------------------
      subroutine setedge
C
C     .Initialize EDGE arrays for face and edge specific tasks.
C
C     .NOTE: Sevaral arrays in common are initialized via 
C            BLOCKDATA EDGEC
C
C     Computed arrays: 
C
C     IEDGE  -  Minimal list of wire frame nodes.
C               Used to search for all physical
C               coincidences.
C
C
C     IEDGEF - .Ordered list of wire frame nodes 
C               associated with faces 1 through 6.
C              .Each of 4 sides of square frame stored 
C               individually so that rotations are 
C               readily handled.
C              .Two types of node orderings stored -
C               (0) is clockwise marching
C               (1) is counter-clockwise marching 
C                   for image face.
C                               
C
C     IFACE         - indicates the face number.  Two notations
C                     are currently in use:
C
C                     i) Preprocessor notation:
C                
C                                       +--------+     ^ S
C                                      /        /|     |
C                                     /    3   / |     |
C                               4--> /        /  |     |
C                                   +--------+ 2 +     +----> R
C                                   |        |  /     /
C                                   |    6   | /     /
C                                   |        |/     /
C                                   +--------+     T
C                                       1
C
C                    ii) Symmetric notation:
C                     
C                                       +--------+     ^ S
C                                      /        /|     |
C                                     /    4   / |     |
C                               1--> /        /  |     |
C                                   +--------+ 2 +     +----> R
C                                   |        |  /     /
C                                   |    6   | /     /
C                                   |        |/     /
C                                   +--------+     T
C                                       3
C
C     EFACE(IFACE)  -   Given face number IFACE in symmetric notation, 
C                       returns preprocessor notation face number.
C
C     EFACE1(IFACE) -   Given face number IFACE in preprocessor notation, 
C                       returns symmetric notation face number.
C
C  The following variables all take the symmetric 
C  notation of IFACE as arguments:
C
C     ICFACE(i,IFACE) -   Gives the 4 vertices which reside on face IFACE
C                         as depicted below, e.g. ICFACE(i,2)=2,4,6,8.
C
C                        3+-----+4    ^ Y
C                        /  2  /|     |
C     Edge 1 extends    /     / |     |
C       from vertex   7+-----+8 +2    +----> X
C       1 to 2.        |  4  | /     /
C                      |     |/     /
C                     5+-----+6    Z
C                         3
C
C     IEDGFC(i,IFACE) -   Gives the 4 edges which border the face IFACE
C                         Edge numbering is as follows:
C                            Edge = 1,2,3,4     run in +r direction
C                            Edge = 5,6,7,8     run in +s direction
C                            Edge = 9,10,11,12  run in +t direction
C
C                         Ordering of each edge is such that a monotonically
C                         increasing sequence of vertices is associated with
C                         the start point of a corresponding set of 
C                         monotonically increasing edge numbers, e.g.,
C
C     ICEDG(i,IEDGE)  -   Gives 3 variables for determining the stride along
C                         a given edge, IEDGE;  i=1 gives the starting vertex
C                                               i=2 gives the stopping vertex
C                                               i=3 gives the stride size.
C
      INCLUDE 'SIZE'
      INCLUDE 'TOPOL'
C
      COMMON /CTMP0/ ITMP(3,3,3)
      INTEGER ORDER
C
      NXL=3
      NYL=3
      NZL=1+2*(ldim-2)
      NXY   =NXL*NYL
      NXYZ  =NXL*NYL*NZL
      NFACES=2*ldim
C
C----------------------------------------------------------------------
C     Set up edge arrays (temporary - required only for defining DS)
C----------------------------------------------------------------------
C
C     Fill corners - 1 through 8.
C
      I3D=1
      IF (ldim.EQ.2) I3D=0
C
      I=0
      DO 10 I3=0,I3D
         IZ=1+(NZL-1)*I3
         DO 10 I2=0,1
            IY=1+(NYL-1)*I2
            DO 10 I1=0,1
               IX=1+(NXL-1)*I1
               I=I+1
               IEDGE(I)=IX+NXL*(IY-1)+NXY*(IZ-1)
   10 CONTINUE
C
C     Fill X-direction edges.
C
      DO 20 I3=0,I3D
         IZ=1+(NZL-1)*I3
         DO 20 I2=0,1
            IY=1+(NYL-1)*I2
            DO 20 IX=2,NXL-1
               I=I+1
               IEDGE(I)=IX+NXL*(IY-1)+NXY*(IZ-1)
   20 CONTINUE
C
C     Fill Y-direction edges.
C
      DO 30 I3=0,I3D
         IZ=1+(NZL-1)*I3
         DO 30 I1=0,1
            IX=1+(NXL-1)*I1
            DO 30 IY=2,NYL-1
               I=I+1
               IEDGE(I)=IX+NXL*(IY-1)+NXY*(IZ-1)
   30 CONTINUE
C
C     Fill Z-direction edges.
C
      IF (ldim.EQ.3) THEN
         DO 40 I2=0,1
            IY=1+(NYL-1)*I2
            DO 40 I1=0,1
               IX=1+(NXL-1)*I1
               DO 40 IZ=2,NZL-1
                  I=I+1
                  IEDGE(I)=IX+NXL*(IY-1)+NXY*(IZ-1)
   40    CONTINUE
      ENDIF
C
      CALL IZERO(INVEDG,27)
      DO 44 II=1,20
         IX=IEDGE(II)
         INVEDG(IX)=II
   44 CONTINUE
C
C
C     GENERAL FACE, GENERAL ROTATION EDGE NUMBERS.
C
      IF (ldim.EQ.3) THEN
C
C        Pack 3-D edge numbering:
C   
C        Fill temporary array with local index numbers:
C
         DO 50 IX=1,NXYZ
            ITMP(IX,1,1)=IX
   50    CONTINUE
C
C        Two sets are required, the base cube and the image cube 
C        which is being summed with it.
C
         DO 1000 IMAGE=0,1
C
C        Pack edges for each face, no rotation.
C
         DO 500 IFACE=1,NFACES
            JS1    = SKPDAT(1,IFACE)
            JF1    = SKPDAT(2,IFACE)
            JSKIP1 = SKPDAT(3,IFACE)
            JS2    = SKPDAT(4,IFACE)
            JF2    = SKPDAT(5,IFACE)
            JSKIP2 = SKPDAT(6,IFACE)
C
C           Choose proper indexing order according to face type and image.
C
            ORDER = (-1)**(GROUP(IFACE)+IMAGE)
            IF (ORDER.EQ.1) THEN
C
C              Forward ordering:
C
C            +-------------+    ^ v1
C            | --------->| |    |
C            | ^    2    | |    +-->
C            | |         | |      v2
C            | |1       3| |
C            | |    4    V |
C            | |<--------- |
C            F-------------I     F is fiducial node.
C
C                                I is location of fiducial node for
C                                     image face.
C
C           Load edge 1:
C
            J=0
            J2=JS2
            DO 100 J1=JS1,JF1-JSKIP1,JSKIP1
               J=J+1
               IEDGEF(J,1,IFACE,IMAGE)=ITMP(J1,J2,1)
  100       CONTINUE
C
C           Load edge 2:
C
            J=0
            J1=JF1
            DO 200 J2=JS2,JF2-JSKIP2,JSKIP2
               J=J+1
               IEDGEF(J,2,IFACE,IMAGE)=ITMP(J1,J2,1)
  200       CONTINUE
C
C
C           Load edge 3:
C
            J=0
            J2=JF2
            DO 300 J1=JF1,JS1+JSKIP1,-JSKIP1
               J=J+1
               IEDGEF(J,3,IFACE,IMAGE)=ITMP(J1,J2,1)
  300       CONTINUE
C
C           Load edge 4:
C
            J=0
            J1=JS1
            DO 400 J2=JF2,JS2+JSKIP2,-JSKIP2
               J=J+1
               IEDGEF(J,4,IFACE,IMAGE)=ITMP(J1,J2,1)
  400       CONTINUE
C
            ELSE
C
C           Reverse ordering:
C
C            +-------------+
C            | |<--------- |       ^ v2
C            | |    2    ^ |       |
C            | |         | |    <--+
C            | |3       1| |     v1
C            | V    4    | |
C            | --------->| |
C            I-------------F     F is fiducial node.
C
C                                I is location of fiducial node for
C                                     image face.
C
C           Load edge 1:
C   
            J=0
            J1=JS1
            DO 105 J2=JS2,JF2-JSKIP2,JSKIP2
               J=J+1
               IEDGEF(J,1,IFACE,IMAGE)=ITMP(J1,J2,1)
  105       CONTINUE
C
C           Load edge 2:
C
            J=0
            J2=JF2
            DO 205 J1=JS1,JF1-JSKIP1,JSKIP1
               J=J+1
               IEDGEF(J,2,IFACE,IMAGE)=ITMP(J1,J2,1)
  205       CONTINUE
C
C           Load edge 3:
C
            J=0
            J1=JF1
            DO 305 J2=JF2,JS2+JSKIP2,-JSKIP2
                J=J+1
               IEDGEF(J,3,IFACE,IMAGE)=ITMP(J1,J2,1)
  305       CONTINUE
C
C           Load edge 4:
C
            J=0
            J2=JS2
            DO 405 J1=JF1,JS1+JSKIP1,-JSKIP1
               J=J+1
              IEDGEF(J,4,IFACE,IMAGE)=ITMP(J1,J2,1)
  405       CONTINUE
            ENDIF
C
  500    CONTINUE
 1000    CONTINUE
      ELSE
C
C        Load edge information for 2-D case
C
         IEDGEF(1,1,1,0) = NXY - NXL + 1
         IEDGEF(1,2,1,0) = 1
         IEDGEF(1,1,2,0) = NXL
         IEDGEF(1,2,2,0) = NXY
         IEDGEF(1,1,3,0) = 1
         IEDGEF(1,2,3,0) = NXL
         IEDGEF(1,1,4,0) = NXY
         IEDGEF(1,2,4,0) = NXY - NXL + 1
C
         IEDGEF(1,1,1,1) = 1
         IEDGEF(1,2,1,1) = NXY - NXL + 1
         IEDGEF(1,1,2,1) = NXY
         IEDGEF(1,2,2,1) = NXL
         IEDGEF(1,1,3,1) = NXL
         IEDGEF(1,2,3,1) = 1
         IEDGEF(1,1,4,1) = NXY - NXL + 1
         IEDGEF(1,2,4,1) = NXY
      ENDIF
C
      RETURN
      END
c-----------------------------------------------------------------------
      subroutine dsset(nx,ny,nz)
C
C     Set up arrays IXCN,ESKIP,SKPDAT,NEDG,NOFFST for new NX,NY,NZ
C
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'TOPOL'
      INTEGER NXO,NYO,NZO
      SAVE    NXO,NYO,NZO
      DATA    NXO,NYO,NZO /3*0/
C
C     Check if element surface counters are already set from last call...
C
      IF (NXO.EQ.NX.AND.NYO.EQ.NY.AND.NZO.EQ.NZ) RETURN
C
C     else, proceed....
C
      NXO = NX
      NYO = NY
      NZO = NZ
C
C     Establish corner to elemental node number mappings
C
      IC=0
      DO 10 ICZ=0,1
      DO 10 ICY=0,1
      DO 10 ICX=0,1
C       Supress vectorization to 
c        IF(ICX.EQ.0)DUMMY=0        
c        IF(ICX.EQ.1)DUMMY=1
c        DUMMY2=DUMMY2+DUMMY
        IC=IC+1
        IXCN(IC)= 1 + (NX-1)*ICX + NX*(NY-1)*ICY + NX*NY*(NZ-1)*ICZ
   10   CONTINUE
C
C     Assign indices for direct stiffness summation of arbitrary faces.
C
C
C     Y-Z Planes (Faces 1 and 2)
C
      SKPDAT(1,1)=1
      SKPDAT(2,1)=NX*(NY-1)+1
      SKPDAT(3,1)=NX
      SKPDAT(4,1)=1
      SKPDAT(5,1)=NY*(NZ-1)+1
      SKPDAT(6,1)=NY
C
      SKPDAT(1,2)=1             + (NX-1)
      SKPDAT(2,2)=NX*(NY-1)+1   + (NX-1)
      SKPDAT(3,2)=NX
      SKPDAT(4,2)=1
      SKPDAT(5,2)=NY*(NZ-1)+1
      SKPDAT(6,2)=NY
C
C     X-Z Planes (Faces 3 and 4)
C
      SKPDAT(1,3)=1
      SKPDAT(2,3)=NX
      SKPDAT(3,3)=1
      SKPDAT(4,3)=1
      SKPDAT(5,3)=NY*(NZ-1)+1
      SKPDAT(6,3)=NY
C
      SKPDAT(1,4)=1           + NX*(NY-1)
      SKPDAT(2,4)=NX          + NX*(NY-1)
      SKPDAT(3,4)=1
      SKPDAT(4,4)=1
      SKPDAT(5,4)=NY*(NZ-1)+1
      SKPDAT(6,4)=NY
C
C     X-Y Planes (Faces 5 and 6)
C
      SKPDAT(1,5)=1
      SKPDAT(2,5)=NX
      SKPDAT(3,5)=1
      SKPDAT(4,5)=1
      SKPDAT(5,5)=NY
      SKPDAT(6,5)=1
C
      SKPDAT(1,6)=1           + NX*NY*(NZ-1)
      SKPDAT(2,6)=NX          + NX*NY*(NZ-1)
      SKPDAT(3,6)=1
      SKPDAT(4,6)=1
      SKPDAT(5,6)=NY
      SKPDAT(6,6)=1
C
C     Set up skip indices for each of the 12 edges 
C
C         Note that NXY = NX*NY even for 2-D since
C         this branch does not apply to the 2D case anyway.
C
C     ESKIP(*,1) = start location
C     ESKIP(*,2) = end 
C     ESKIP(*,3) = stride
C
      NXY=NX*NY
      ESKIP( 1,1) = IXCN(1) + 1
      ESKIP( 1,2) = IXCN(2) - 1
      ESKIP( 1,3) = 1
      ESKIP( 2,1) = IXCN(3) + 1
      ESKIP( 2,2) = IXCN(4) - 1
      ESKIP( 2,3) = 1
      ESKIP( 3,1) = IXCN(5) + 1
      ESKIP( 3,2) = IXCN(6) - 1
      ESKIP( 3,3) = 1
      ESKIP( 4,1) = IXCN(7) + 1
      ESKIP( 4,2) = IXCN(8) - 1
      ESKIP( 4,3) = 1
      ESKIP( 5,1) = IXCN(1) + NX
      ESKIP( 5,2) = IXCN(3) - NX
      ESKIP( 5,3) = NX
      ESKIP( 6,1) = IXCN(2) + NX
      ESKIP( 6,2) = IXCN(4) - NX
      ESKIP( 6,3) = NX
      ESKIP( 7,1) = IXCN(5) + NX
      ESKIP( 7,2) = IXCN(7) - NX
      ESKIP( 7,3) = NX
      ESKIP( 8,1) = IXCN(6) + NX
      ESKIP( 8,2) = IXCN(8) - NX
      ESKIP( 8,3) = NX
      ESKIP( 9,1) = IXCN(1) + NXY
      ESKIP( 9,2) = IXCN(5) - NXY
      ESKIP( 9,3) = NXY
      ESKIP(10,1) = IXCN(2) + NXY
      ESKIP(10,2) = IXCN(6) - NXY
      ESKIP(10,3) = NXY
      ESKIP(11,1) = IXCN(3) + NXY
      ESKIP(11,2) = IXCN(7) - NXY
      ESKIP(11,3) = NXY
      ESKIP(12,1) = IXCN(4) + NXY
      ESKIP(12,2) = IXCN(8) - NXY
      ESKIP(12,3) = NXY
C
C     Load reverse direction edge arrays for reverse mappings...
C
      DO 20 IED=1,12
      IEDM=-IED
      ESKIP(IEDM,1) =  ESKIP(IED,2)
      ESKIP(IEDM,2) =  ESKIP(IED,1)
      ESKIP(IEDM,3) = -ESKIP(IED,3)
   20 CONTINUE
C
C     Compute offset for global edge vector given current element
C     dimensions.....
C
C     NGSPED(ITE,ICMP) = number of global (ie, distinct) special edges
C                        of type ITE (1,2, or 3)  for field ICMP.
C
C                        ITE = 1 implies an "X" edge
C                        ITE = 2 implies an "Y" edge
C                        ITE = 3 implies an "Z" edge
C
C     Set up number of nodes along each of the 3 types of edges
C     (endpoints excluded).
C
      NEDG(1)=NX-2
      NEDG(2)=NY-2
      NEDG(3)=NZ-2
C
C
      RETURN
      END
c-----------------------------------------------------------------------
      subroutine genxyzl
C
C     Generate xyz coordinates 
C
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'SCRCT'
      COMMON /CTMP0/ XCB(2,2,2),YCB(2,2,2),ZCB(2,2,2),H(3,3,2),INDX(8)
C
      NXL=3
      NYL=3
      NZL=1+2*(ldim-2)
      NTOT3=NXL*NYL*NZL*NELT
C
C   Preprocessor Corner notation:      Symmetric Corner notation:
C                
C           4+-----+3    ^ s                    3+-----+4    ^ s        
C           /     /|     |                      /     /|     |          
C          /     / |     |                     /     / |     |          
C        8+-----+7 +2    +----> r            7+-----+8 +2    +----> r   
C         |     | /     /                     |     | /     /           
C         |     |/     /                      |     |/     /            
C        5+-----+6    t                      5+-----+6    t             
C
      DO 10 IX=1,NXL
         H(IX,1,1)=0.5*FLOAT(3-IX)
         H(IX,1,2)=0.5*FLOAT(IX-1)
   10 CONTINUE
      DO 20 IY=1,NYL
         H(IY,2,1)=0.5*FLOAT(3-IY)
         H(IY,2,2)=0.5*FLOAT(IY-1)
   20 CONTINUE
      DO 30 IZ=1,NZL
         H(IZ,3,1)=0.5*FLOAT(3-IZ)
         H(IZ,3,2)=0.5*FLOAT(IZ-1)
   30 CONTINUE
C
      INDX(1)=1
      INDX(2)=2
      INDX(3)=4
      INDX(4)=3
      INDX(5)=5
      INDX(6)=6
      INDX(7)=8
      INDX(8)=7
C
      CALL RZERO(XML,NTOT3)
      CALL RZERO(YML,NTOT3)
      CALL RZERO(ZML,NTOT3)
      CALL RZERO(XCB,8)
      CALL RZERO(YCB,8)
      CALL RZERO(ZCB,8)
C
      DO 5000 IE=1,NELT
C
         ldim2 = 2**ldim
         DO 50 IX=1,ldim2
            I=INDX(IX)
            XCB(IX,1,1)=XC(I,IE)
            YCB(IX,1,1)=YC(I,IE)
            ZCB(IX,1,1)=ZC(I,IE)
   50    CONTINUE
C
C        Map R-S-T space into physical X-Y-Z space.
C
         DO 100 IZT=1,ldim-1
         DO 100 IYT=1,2
         DO 100 IXT=1,2
C
         DO 100 IZ=1,NZL
         DO 100 IY=1,NYL
         DO 100 IX=1,NXL
            XML(IX,IY,IZ,IE)=XML(IX,IY,IZ,IE)+
     $        H(IX,1,IXT)*H(IY,2,IYT)*H(IZ,3,IZT)*XCB(IXT,IYT,IZT)
            YML(IX,IY,IZ,IE)=YML(IX,IY,IZ,IE)+
     $        H(IX,1,IXT)*H(IY,2,IYT)*H(IZ,3,IZT)*YCB(IXT,IYT,IZT)
            ZML(IX,IY,IZ,IE)=ZML(IX,IY,IZ,IE)+
     $        H(IX,1,IXT)*H(IY,2,IYT)*H(IZ,3,IZT)*ZCB(IXT,IYT,IZT)
  100    CONTINUE
C
 5000 CONTINUE
      RETURN
      END
c-----------------------------------------------------------------------
      subroutine verify
C
C     .Verify right-handedness of elements.
C     .Verify element-to-element reciprocity of BC's
C     .Verify correlation between E-E BC's and physical coincidence
C
      include 'SIZE'
      include 'PARALLEL'
      include 'INPUT'
      include 'SCRCT'
 
      call verrhe

      return
      end
c-----------------------------------------------------------------------
      subroutine setside
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'TOPOL'
      INCLUDE 'SCRCT'
C
C     SIDE(i,IFACE,IE) -  Physical (xyz) location of element side midpoint.
C                         i=1,2,3 gives x,y,z value, respectively.
C                         i=4  gives average dimension of face for setting
C                              tolerances.
C
      INDX(1)=1
      INDX(2)=2
      INDX(3)=4
      INDX(4)=3
      INDX(5)=5
      INDX(6)=6
      INDX(7)=8
      INDX(8)=7
C
C     Flip vertex array structure
C
c     write(6,*) nelv,nelt,if3d
      call rzero(xyz,24*nelt)
      if (if3d) then
         do ie=1,nelt
         do j=1,8
            ivtx = indx(j)
            xyz(1,ivtx,ie) = xc(j,ie)
            xyz(2,ivtx,ie) = yc(j,ie)
            xyz(3,ivtx,ie) = zc(j,ie)
c           write(6,1) ie,j,ivtx,xc(j,ie),yc(j,ie),zc(j,ie),' xcz'
c           write(6,1) ie,j,ivtx,(xyz(k,ivtx,ie),k=1,3),' vtx'
c   1       format(3i5,1p3e12.4,a4)
         enddo
         enddo
      else
         do ie=1,nelt
         do j=1,4
            ivtx = indx(j)
            xyz(1,ivtx,ie) = xc(j,ie)
            xyz(2,ivtx,ie) = yc(j,ie)
            xyz(3,ivtx,ie) = 0.0
         enddo
         enddo
      endif
C
C     Compute location of center and "diameter" of each element side.
C
      NFACES=ldim*2
      NCRNR =2**(ldim-1)
      CALL RZERO(SIDE,24*NELT)
      DO 500 ICRN=1,NCRNR
      DO 500 IFAC=1,NFACES
         IVTX = ICFACE(ICRN,IFAC)
         ICR1 = NCRNR+(ICRN-1)
         ICR1 = MOD1(ICR1,NCRNR)
         IVT1 = ICFACE(ICR1,IFAC)
         DO 400 IE=1,NELT
            DO 300 IDIM=1,ldim
               SIDE(IDIM,IFAC,IE)=SIDE(IDIM,IFAC,IE)+XYZ(IDIM,IVTX,IE)
               SIDE(   4,IFAC,IE)=SIDE(   4,IFAC,IE)+
     $                     ( XYZ(IDIM,IVTX,IE)-XYZ(IDIM,IVT1,IE) )**2
  300       CONTINUE
            SIDE(4,IFAC,IE)=SQRT( SIDE(4,IFAC,IE) )
  400    CONTINUE
  500 CONTINUE
      AVWGHT=1.0/FLOAT(NCRNR)
      CALL CMULT(SIDE,AVWGHT,24*NELT)
C
c     call exitt
      RETURN
      END
c-----------------------------------------------------------------------
      subroutine verrhe
C
C     8 Mar 1989 21:58:26   PFF
C     Verify right-handedness of given elements. 
C
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'PARALLEL'
      INCLUDE 'SCRCT'
      INCLUDE 'TOPOL'
      LOGICAL IFYES,IFCSTT
C
      IFCSTT=.TRUE.
      IF (.NOT.IF3D) THEN
      DO 1000 IE=1,NELT
C
C        CRSS2D(A,B,O) = (A-O) X (B-O)
C
         C1=CRSS2D(XYZ(1,2,IE),XYZ(1,3,IE),XYZ(1,1,IE))
         C2=CRSS2D(XYZ(1,4,IE),XYZ(1,1,IE),XYZ(1,2,IE))
         C3=CRSS2D(XYZ(1,1,IE),XYZ(1,4,IE),XYZ(1,3,IE))
         C4=CRSS2D(XYZ(1,3,IE),XYZ(1,2,IE),XYZ(1,4,IE))
C
         IF (C1.LE.0.0.OR.C2.LE.0.0.OR.
     $       C3.LE.0.0.OR.C4.LE.0.0 ) THEN
C
            ieg=lglel(ie)
            WRITE(6,800) IEG,C1,C2,C3,C4
            call exitt
  800       FORMAT(/,2X,'WARNINGa: Detected non-right-handed element.',
     $      /,2X,'Number',I8,'  C1-4:',4E12.4)
            IFCSTT=.FALSE.
C           CALL QUERY(IFYES,'Proceed                                 ')
C           IF (.NOT.IFYES) GOTO 9000
         ENDIF
 1000 CONTINUE
C
C     Else 3-D:
C
      ELSE      
      DO 2000 IE=1,NELT
C
C        VOLUM0(A,B,C,O) = (A-O)X(B-O).(C-O)
C
         V1= VOLUM0(XYZ(1,2,IE),XYZ(1,3,IE),XYZ(1,5,IE),XYZ(1,1,IE))
         V2= VOLUM0(XYZ(1,4,IE),XYZ(1,1,IE),XYZ(1,6,IE),XYZ(1,2,IE))
         V3= VOLUM0(XYZ(1,1,IE),XYZ(1,4,IE),XYZ(1,7,IE),XYZ(1,3,IE))
         V4= VOLUM0(XYZ(1,3,IE),XYZ(1,2,IE),XYZ(1,8,IE),XYZ(1,4,IE))
         V5=-VOLUM0(XYZ(1,6,IE),XYZ(1,7,IE),XYZ(1,1,IE),XYZ(1,5,IE))
         V6=-VOLUM0(XYZ(1,8,IE),XYZ(1,5,IE),XYZ(1,2,IE),XYZ(1,6,IE))
         V7=-VOLUM0(XYZ(1,5,IE),XYZ(1,8,IE),XYZ(1,3,IE),XYZ(1,7,IE))
         V8=-VOLUM0(XYZ(1,7,IE),XYZ(1,6,IE),XYZ(1,4,IE),XYZ(1,8,IE))
C
         IF (V1.LE.0.0.OR.V2.LE.0.0.OR.
     $       V3.LE.0.0.OR.V4.LE.0.0.OR.
     $       V5.LE.0.0.OR.V6.LE.0.0.OR.
     $       V7.LE.0.0.OR.V8.LE.0.0    ) THEN
C
            ieg=lglel(ie)
            WRITE(6,1800) IEG,V1,V2,V3,V4,V5,V6,V7,V8
            call exitt
 1800       FORMAT(/,2X,'WARNINGb: Detected non-right-handed element.',
     $      /,2X,'Number',I8,'  V1-8:',4E12.4
     $      /,2X,'      ',4X,'       ',4E12.4)
            IFCSTT=.FALSE.
         ENDIF
 2000 CONTINUE
      ENDIF
C
 9000 CONTINUE
C
C     Print out results from right-handed check
C
      IF (.NOT.IFCSTT) WRITE(6,2001)
C
C     Check consistency accross all processors.
C
      CALL GLLOG(IFCSTT,.FALSE.)
C
      IF (.NOT.IFCSTT) THEN
         IF (NID.EQ.0) WRITE(6,2003) NELGT
         call exitt
      ELSE
         IF (NIO.EQ.0) WRITE(6,2002) NELGT
      ENDIF
C
 2001 FORMAT(//,'  Elemental geometry not right-handed, ABORTING'
     $      ,' in routine VERRHE.')
 2002 FORMAT('   Right-handed check complete for',I12,' elements. OK.')
 2003 FORMAT('   Right-handed check failed for',I12,' elements.'
     $      ,'   Exiting in routine VERRHE.')
      RETURN
      END
c-----------------------------------------------------------------------
      FUNCTION VOLUM0(P1,P2,P3,P0)
C
C                           3
C     Given four points in R , (P1,P2,P3,P0), VOLUM0 returns
C     the volume enclosed by the parallelagram defined by the
C     vectors { (P1-P0),(P2-P0),(P3-P0) }.  This routine has
C     the nice feature that if the 3 vectors so defined are
C     not right-handed then the volume returned is negative.
C
      REAL P1(3),P2(3),P3(3),P0(3)
C
         U1=P1(1)-P0(1)
         U2=P1(2)-P0(2)
         U3=P1(3)-P0(3)
C
         V1=P2(1)-P0(1)
         V2=P2(2)-P0(2)
         V3=P2(3)-P0(3)
C
         W1=P3(1)-P0(1)
         W2=P3(2)-P0(2)
         W3=P3(3)-P0(3)
C
         CROSS1 = U2*V3-U3*V2
         CROSS2 = U3*V1-U1*V3
         CROSS3 = U1*V2-U2*V1
C
         VOLUM0  = W1*CROSS1 + W2*CROSS2 + W3*CROSS3
         
      RETURN
      END
c-----------------------------------------------------------------------
      FUNCTION CRSS2D(XY1,XY2,XY0)
      REAL XY1(2),XY2(2),XY0(2)
C
         V1X=XY1(1)-XY0(1)
         V2X=XY2(1)-XY0(1)
         V1Y=XY1(2)-XY0(2)
         V2Y=XY2(2)-XY0(2)
         CRSS2D = V1X*V2Y - V1Y*V2X
C
      RETURN
      END
c-----------------------------------------------------------------------
      subroutine facind (kx1,kx2,ky1,ky2,kz1,kz2,nx,ny,nz,iface)
c      ifcase in preprocessor notation
       KX1=1
       KY1=1
       KZ1=1
       KX2=NX
       KY2=NY
       KZ2=NZ
       IF (IFACE.EQ.1) KY2=1
       IF (IFACE.EQ.2) KX1=NX
       IF (IFACE.EQ.3) KY1=NY
       IF (IFACE.EQ.4) KX2=1
       IF (IFACE.EQ.5) KZ2=1
       IF (IFACE.EQ.6) KZ1=NZ
      return
      end
c-----------------------------------------------------------------------
      subroutine facindr (kx1,kx2,ky1,ky2,kz1,kz2,nx,ny,nz,iface)

c     restricted index set, iface in preprocessor notation

      kx1=2
      ky1=2
      kz1=2
      kx2=nx-1
      ky2=ny-1
      kz2=nz-1

      if (iface.eq.1) ky1=1
      if (iface.eq.1) ky2=1

      if (iface.eq.2) kx1=nx
      if (iface.eq.2) kx2=nx

      if (iface.eq.3) ky1=ny
      if (iface.eq.3) ky2=ny

      if (iface.eq.4) kx1=1
      if (iface.eq.4) kx2=1

      if (iface.eq.5) kz1=1
      if (iface.eq.5) kz2=1

      if (iface.eq.6) kz1=nz
      if (iface.eq.6) kz2=nz

      return
      end
c-----------------------------------------------------------------------
      subroutine facev(a,ie,iface,val,nx,ny,nz)
C
C     Assign the value VAL to face(IFACE,IE) of array A.
C     IFACE is the input in the pre-processor ordering scheme.
C
      INCLUDE 'SIZE'
      DIMENSION A(NX,NY,NZ,LELT)
      CALL FACIND (KX1,KX2,KY1,KY2,KZ1,KZ2,NX,NY,NZ,IFACE)
      DO 100 IZ=KZ1,KZ2
      DO 100 IY=KY1,KY2
      DO 100 IX=KX1,KX2
         A(IX,IY,IZ,IE)=VAL
  100 CONTINUE
      RETURN
      END
c-----------------------------------------------------------------------
      subroutine ifacev(a,ie,iface,val,nx,ny,nz)
C
C     Assign the value VAL to face(IFACE,IE) of array A.
C     IFACE is the input in the pre-processor ordering scheme.
C
      include 'SIZE'
      integer a(nx,ny,nz,lelt),val
      call facind (kx1,kx2,ky1,ky2,kz1,kz2,nx,ny,nz,iface)
      do 100 iz=kz1,kz2
      do 100 iy=ky1,ky2
      do 100 ix=kx1,kx2
         a(ix,iy,iz,ie)=val
  100 continue
      return
      end
c-----------------------------------------------------------------------
      subroutine facec(a,b,ie,iface,nx,ny,nz,nel)
C
C     Copy the face (IFACE) of B to A.
C     IFACE is the input in the pre-processor ordering scheme.
C
      DIMENSION A(NX,NY,NZ,NEL)
      DIMENSION B(NX,NY,NZ,NEL)
      CALL FACIND (KX1,KX2,KY1,KY2,KZ1,KZ2,NX,NY,NZ,IFACE)
      DO 100 IZ=KZ1,KZ2
      DO 100 IY=KY1,KY2
      DO 100 IX=KX1,KX2
         A(IX,IY,IZ,IE)=B(IX,IY,IZ,IE)
  100 CONTINUE
      RETURN
      END
c-----------------------------------------------------------------------
      subroutine combin2(glnm1,glnm2,nglob)
c
      write(6,*) 'Hey, who called combin2???  ABORT'
      call exitt
c
      return
      end
c-----------------------------------------------------------------------
      subroutine outfldio (x,txt10)
      INCLUDE 'SIZE'
      integer x(lx1,ly1,lz1,lelt)
      character*10 txt10
C
      do ie=1,nelv,2
         do iz=1,lz1,1
            if (iz.eq.1) write(6,106) txt10,iz,ie
            if (iz.gt.1) write(6,107) 
            i1 = ie+1
            do j=ly1,1,-1
               write(6,105) (x(i,j,iz,ie),i=1,lx1)
     $                    , (x(i,j,iz,i1),i=1,lx1)
            enddo
         enddo
      enddo
C
  107 FORMAT(' ')
  105 FORMAT(4i6,20x,4i6)
  106 FORMAT(  /,5X,'     ^              ',/,
     $           5X,'   Y |              ',/,
     $           5X,'     |              ',A10,/,
     $           5X,'     +---->         ','Plane = ',I2,'/',I2,/,
     $           5X,'       X            ')
C
      return
      end
c-----------------------------------------------------------------------
      subroutine outfldi (x,txt10)
      INCLUDE 'SIZE'
      integer x(lx1,ly1,lz1,lelt)
      character*10 txt10
c
      character*6 s(20,20)
c
      if (lx1.ne.4 .or. nelv.gt.3) return
c
      write(6,106) txt10,ie,ie
  106 FORMAT(  /,5X,'     ^              ',/,
     $           5X,'   Y |              ',/,
     $           5X,'     |              ',A10,/,
     $           5X,'     +---->         ','elem. = ',I2,'/',I2,/,
     $           5X,'       X            ')
C
C
      call blank(s,6*20*20)
      do ie=1,3
         if (ie.eq.1) then
            jstart  = 1
            istart  = 1
            istride = 3
         else
            jstart  = 2 + lx1
            istart  = 1
            istride = 1
            if (ie.eq.2) istart = 7
         endif
c
         i=istart
         do iy=ly1,1,-1
            j=jstart
            do ix=1,lx1
               write(s(i,j),6) x(ix,iy,1,ie)
               j=j+1
            enddo
            i=i+istride
         enddo
    6    format(20i6)
      enddo
c
      do i=1,10
         write(6,7) (s(i,l),l=1,j-1)
      enddo
    7 format(20a6)
c
      write(6,*)
      return
      end
c-----------------------------------------------------------------------
      subroutine outfldr (x,txt10)
      INCLUDE 'SIZE'
      real x(lx1,ly1,lz1,lelt)
      character*10 txt10
c
      character*6 s(20,20)
c
      if (lx1.ne.4 .or. nelv.gt.3) return
      write(6,106) txt10,ie,ie
  106 FORMAT(  /,5X,'     ^              ',/,
     $           5X,'   Y |              ',/,
     $           5X,'     |              ',A10,/,
     $           5X,'     +---->         ','elem. = ',I2,'/',I2,/,
     $           5X,'       X            ')
      call blank(s,6*20*20)
C
C
      do ie=1,3
         if (ie.eq.1) then
            jstart  = 1
            istart  = 1
            istride = 3
         else
            jstart  = 2 + lx1
            istart  = 1
            istride = 1
            if (ie.eq.2) istart = 7
         endif
c
         i=istart
         do iy=ly1,1,-1
            j=jstart
            do ix=1,lx1
               write(s(i,j),6) x(ix,iy,1,ie)
               j=j+1
            enddo
            i=i+istride
         enddo
    6    format(f6.2)
      enddo
c
      do i=1,10
         write(6,7) (s(i,l),l=1,j-1)
      enddo
    7 format(20a6)
c
      write(6,*)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine checkit(idum)
      write(6,*) 'continue?'
      read (5,*) idum
      return
      end
c-----------------------------------------------------------------------
      subroutine outfldro (x,txt10,ichk)
      INCLUDE 'SIZE'
      INCLUDE 'TSTEP'
      real x(lx1,ly1,lz1,lelt)
      character*10 txt10
c
      integer idum,e
      save idum
      data idum /3/
      if (idum.lt.0) return
c
C
      mtot = lx1*ly1*lz1*nelv
      if (lx1.gt.8.or.nelv.gt.16) return
      xmin = glmin(x,mtot)
      xmax = glmax(x,mtot)

      do ie=1,1
         ne = 1
         do k=1,1
            write(6,116) txt10,k,ie,xmin,xmax,istep,time
            write(6,117) 
            do j=ly1,1,-1
              if (lx1.eq.2) write(6,102) ((x(i,j,k,e+1),i=1,lx1),e=0,ne)
              if (lx1.eq.3) write(6,103) ((x(i,j,k,e+1),i=1,lx1),e=0,ne)
              if (lx1.eq.4) write(6,104) ((x(i,j,k,e+1),i=1,lx1),e=0,ne)
              if (lx1.eq.5) write(6,105) ((x(i,j,k,e+1),i=1,lx1),e=0,ne)
              if (lx1.eq.6) write(6,106) ((x(i,j,k,e+1),i=1,lx1),e=0,ne)
              if (lx1.eq.7) write(6,107) ((x(i,j,k,e+1),i=1,lx1),e=0,ne)
              if (lx1.eq.8) write(6,118) ((x(i,j,k,e+1),i=1,lx1),e=0,ne)
            enddo
         enddo
      enddo

  102 FORMAT(4(2f9.5,2x))
  103 FORMAT(4(3f9.5,2x))
  104 FORMAT(4(4f7.3,2x))
  105 FORMAT(5f9.5,10x,5f9.5)
  106 FORMAT(6f9.5,5x,6f9.5)
  107 FORMAT(7f8.4,5x,7f8.4)
  108 FORMAT(8f8.4,4x,8f8.4)
  118 FORMAT(8f12.9)
c
  116 FORMAT(  /,5X,'     ^              ',/,
     $    5X,'   Y |              ',/,
     $    5X,'     |              ',A10,/,
     $    5X,'     +---->         ','Plane = ',I2,'/',I2,2x,2e12.4,/,
     $    5X,'       X            ','Step  =',I9,f15.5)
  117 FORMAT(' ')
c
      if (ichk.eq.1.and.idum.gt.0) call checkit(idum)
      return
      end
c-----------------------------------------------------------------------
      subroutine outfldrv (x,txt10,ichk) ! writes to unit=40+ifield
      INCLUDE 'SIZE'
      INCLUDE 'TSTEP'
      real x(lx1,ly1,lz1,lelt)
      character*10 txt10
c
      integer idum,e
      save idum
      data idum /3/
      if (idum.lt.0) return
      m = 40 + ifield
c
C
      mtot = lx1*ly1*lz1*nelv
      if (lx1.gt.7.or.nelv.gt.16) return
      xmin = glmin(x,mtot)
      xmax = glmax(x,mtot)
c
      rnel = nelv
      snel = sqrt(rnel)+.1
      ne   = snel
      ne1  = nelv-ne+1
      do ie=ne1,1,-ne
         l=ie-1
         do k=1,1
            if (ie.eq.ne1) write(m,116) txt10,k,ie,xmin,xmax,istep,time
            write(m,117) 
            do j=ly1,1,-1
              if (lx1.eq.2) write(m,102) ((x(i,j,k,e+l),i=1,lx1),e=1,ne)
              if (lx1.eq.3) write(m,103) ((x(i,j,k,e+l),i=1,lx1),e=1,ne)
              if (lx1.eq.4) write(m,104) ((x(i,j,k,e+l),i=1,lx1),e=1,ne)
              if (lx1.eq.5) write(m,105) ((x(i,j,k,e+l),i=1,lx1),e=1,ne)
              if (lx1.eq.6) write(m,106) ((x(i,j,k,e+l),i=1,lx1),e=1,ne)
              if (lx1.eq.7) write(m,107) ((x(i,j,k,e+l),i=1,lx1),e=1,ne)
              if (lx1.eq.8) write(m,108) ((x(i,j,k,e+l),i=1,lx1),e=1,ne)
            enddo
         enddo
      enddo

C
  102 FORMAT(4(2f9.5,2x))
  103 FORMAT(4(3f9.5,2x))
  104 FORMAT(4(4f7.3,2x))
  105 FORMAT(5f9.5,10x,5f9.5)
  106 FORMAT(6f9.5,5x,6f9.5)
  107 FORMAT(7f8.4,5x,7f8.4)
  108 FORMAT(8f8.4,4x,8f8.4)
c
  116 FORMAT(  /,5X,'     ^              ',/,
     $    5X,'   Y |              ',/,
     $    5X,'     |              ',A10,/,
     $    5X,'     +---->         ','Plane = ',I2,'/',I2,2x,2e12.4,/,
     $    5X,'       X            ','Step  =',I9,f15.5)
  117 FORMAT(' ')
c
      if (ichk.eq.1.and.idum.gt.0) call checkit(idum)
      return
      end
c-----------------------------------------------------------------------
      subroutine outfldrv0 (x,txt10,ichk)
      INCLUDE 'SIZE'
      INCLUDE 'TSTEP'
      real x(lx1,ly1,lz1,lelt)
      character*10 txt10
c
      integer idum,e
      save idum
      data idum /3/
      if (idum.lt.0) return
c
C
      mtot = lx1*ly1*lz1*nelv
      if (lx1.gt.7.or.nelv.gt.16) return
      xmin = glmin(x,mtot)
      xmax = glmax(x,mtot)
c
      rnel = nelv
      snel = sqrt(rnel)+.1
      ne   = snel
      ne1  = nelv-ne+1
      do ie=ne1,1,-ne
         l=ie-1
         do k=1,1
            if (ie.eq.ne1) write(6,116) txt10,k,ie,xmin,xmax,istep,time
            write(6,117) 
            do j=ly1,1,-1
              if (lx1.eq.2) write(6,102) ((x(i,j,k,e+l),i=1,lx1),e=1,ne)
              if (lx1.eq.3) write(6,103) ((x(i,j,k,e+l),i=1,lx1),e=1,ne)
              if (lx1.eq.4) write(6,104) ((x(i,j,k,e+l),i=1,lx1),e=1,ne)
              if (lx1.eq.5) write(6,105) ((x(i,j,k,e+l),i=1,lx1),e=1,ne)
              if (lx1.eq.6) write(6,106) ((x(i,j,k,e+l),i=1,lx1),e=1,ne)
              if (lx1.eq.7) write(6,107) ((x(i,j,k,e+l),i=1,lx1),e=1,ne)
              if (lx1.eq.8) write(6,108) ((x(i,j,k,e+l),i=1,lx1),e=1,ne)
            enddo
         enddo
      enddo

C
  102 FORMAT(4(2f9.5,2x))
  103 FORMAT(4(3f9.5,2x))
  104 FORMAT(4(4f7.3,2x))
  105 FORMAT(5f9.5,10x,5f9.5)
  106 FORMAT(6f9.5,5x,6f9.5)
  107 FORMAT(7f8.4,5x,7f8.4)
  108 FORMAT(8f8.4,4x,8f8.4)
c
  116 FORMAT(  /,5X,'     ^              ',/,
     $    5X,'   Y |              ',/,
     $    5X,'     |              ',A10,/,
     $    5X,'     +---->         ','Plane = ',I2,'/',I2,2x,2e12.4,/,
     $    5X,'       X            ','Step  =',I9,f15.5)
  117 FORMAT(' ')
c
      if (ichk.eq.1.and.idum.gt.0) call checkit(idum)
      return
      end
c-----------------------------------------------------------------------
      subroutine outfldrp0 (x,txt10,ichk)
      INCLUDE 'SIZE'
      INCLUDE 'TSTEP'
      real x(lx2,ly2,lz2,lelt)
      character*10 txt10
c
      integer idum,e
      save idum
      data idum /3/
      if (idum.lt.0) return
c
C
      mtot = lx2*ly2*lz2*nelv
      if (lx2.gt.7.or.nelv.gt.16) return
      xmin = glmin(x,mtot)
      xmax = glmax(x,mtot)
c
      rnel = nelv
      snel = sqrt(rnel)+.1
      ne   = snel
      ne1  = nelv-ne+1
      do ie=ne1,1,-ne
         l=ie-1
         do k=1,1
            if (ie.eq.ne1) write(6,116) txt10,k,ie,xmin,xmax,istep,time
            write(6,117) 
            do j=ly2,1,-1
              if (lx2.eq.2) write(6,102) ((x(i,j,k,e+l),i=1,lx2),e=1,ne)
              if (lx2.eq.3) write(6,103) ((x(i,j,k,e+l),i=1,lx2),e=1,ne)
              if (lx2.eq.4) write(6,104) ((x(i,j,k,e+l),i=1,lx2),e=1,ne)
              if (lx2.eq.5) write(6,105) ((x(i,j,k,e+l),i=1,lx2),e=1,ne)
              if (lx2.eq.6) write(6,106) ((x(i,j,k,e+l),i=1,lx2),e=1,ne)
              if (lx2.eq.7) write(6,107) ((x(i,j,k,e+l),i=1,lx2),e=1,ne)
              if (lx2.eq.8) write(6,108) ((x(i,j,k,e+l),i=1,lx2),e=1,ne)
            enddo
         enddo
      enddo

C
  102 FORMAT(4(2f9.5,2x))
  103 FORMAT(4(3f9.5,2x))
  104 FORMAT(4(4f7.3,2x))
  105 FORMAT(5f9.5,10x,5f9.5)
  106 FORMAT(6f9.5,5x,6f9.5)
  107 FORMAT(7f8.4,5x,7f8.4)
  108 FORMAT(8f8.4,4x,8f8.4)
c
  116 FORMAT(  /,5X,'     ^              ',/,
     $    5X,'   Y |              ',/,
     $    5X,'     |              ',A10,/,
     $    5X,'     +---->         ','Plane = ',I2,'/',I2,2x,2e12.4,/,
     $    5X,'       X            ','Step  =',I9,f15.5)
  117 FORMAT(' ')
c
      if (ichk.eq.1.and.idum.gt.0) call checkit(idum)
      return
      end
c-----------------------------------------------------------------------
      subroutine outfldrp (x,txt10,ichk) ! writes out into unit = 40+ifield 
      INCLUDE 'SIZE'
      INCLUDE 'TSTEP'
      real x(lx2,ly2,lz2,lelt)
      character*10 txt10
c
      integer idum,e
      save    idum
      data    idum /3/
      if (idum.lt.0)   return
      m = 40 + ifield             ! unit #
c
c
C
      mtot = lx2*ly2*lz2*nelv
      if (lx2.gt.7.or.nelv.gt.16) return
      xmin = glmin(x,mtot)
      xmax = glmax(x,mtot)
c
      rnel = nelv
      snel = sqrt(rnel)+.1
      ne   = snel
      ne1  = nelv-ne+1
      do ie=ne1,1,-ne
         l=ie-1
         do k=1,1
            if (ie.eq.ne1) write(m,116) txt10,k,ie,xmin,xmax,istep,time
            write(6,117) 
            do j=ly2,1,-1
              if (lx2.eq.2) write(m,102) ((x(i,j,k,e+l),i=1,lx2),e=1,ne)
              if (lx2.eq.3) write(m,103) ((x(i,j,k,e+l),i=1,lx2),e=1,ne)
              if (lx2.eq.4) write(m,104) ((x(i,j,k,e+l),i=1,lx2),e=1,ne)
              if (lx2.eq.5) write(m,105) ((x(i,j,k,e+l),i=1,lx2),e=1,ne)
              if (lx2.eq.6) write(m,106) ((x(i,j,k,e+l),i=1,lx2),e=1,ne)
              if (lx2.eq.7) write(m,107) ((x(i,j,k,e+l),i=1,lx2),e=1,ne)
              if (lx2.eq.8) write(m,108) ((x(i,j,k,e+l),i=1,lx2),e=1,ne)
            enddo
         enddo
      enddo

C
  102 FORMAT(4(2f9.5,2x))
  103 FORMAT(4(3f9.5,2x))
  104 FORMAT(4(4f7.3,2x))
  105 FORMAT(5f9.5,10x,5f9.5)
  106 FORMAT(6f9.5,5x,6f9.5)
  107 FORMAT(7f8.4,5x,7f8.4)
  108 FORMAT(8f8.4,4x,8f8.4)
c
  116 FORMAT(  /,5X,'     ^              ',/,
     $    5X,'   Y |              ',/,
     $    5X,'     |              ',A10,/,
     $    5X,'     +---->         ','Plane = ',I2,'/',I2,2x,2e12.4,/,
     $    5X,'       X            ','Step  =',I9,f15.5)
  117 FORMAT(' ')
c
      if (ichk.eq.1.and.idum.gt.0) call checkit(idum)
      return
      end
c-----------------------------------------------------------------------
      subroutine outmatp(a,m,n,name6,ie)
      include 'SIZE'
      include 'PARALLEL'
      real a(m,n)
      character*6 name6
c
      if (nelv.gt.1) return
      do jid=0,np-1
        imax = iglmax(jid,1)
        if (jid.eq.nid) then
           write(6,*) 
           write(6,*) nid,ie,' matrix: ',name6,m,n
           n12 = min(n,12)
           do i=1,m
              write(6,6) ie,name6,(a(i,j),j=1,n12)
           enddo
    6      format(i3,1x,a6,12f9.5)
           write(6,*) 
           call flush_io()
         endif
        imax = iglmax(jid,1)
      enddo
      return
      end
c-----------------------------------------------------------------------
      subroutine gs_chkr(glo_num)
      include 'SIZE'
      include 'TOTAL'

      integer glo_num(lx1,ly1,lz1,lelt)
      integer e,eg

      do ipass = 1,2
         iquick = 0
         if (nid.eq.0) iquick=glo_num(ipass,1,1,1)
         iquick = iglmax(iquick,1)

         do e=1,nelv
         do k=1,lz1
         do j=1,ly1
         do i=1,lx1
           if (glo_num(i,j,k,e).eq.iquick) then
            eg = lglel(e)
            write(6,1) nid,i,j,k,e,eg,iquick,ipass
     $      ,xm1(i,j,k,e),ym1(i,j,k,e),zm1(i,j,k,e)
  1         format(i12,3i4,2i12,i12,i2,1p3e12.4,' iquick')
          endif
         enddo
         enddo
         enddo
         enddo
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine setup_mesh_dssum ! Set up dssum for mesh

      include 'SIZE'
      include 'TOTAL'
      include 'NONCON'

      common /c_is1/ glo_num(1*lx1*ly1*lz1*lelv)
      integer*8 glo_num
      common /ivrtx/ vertex ((2**ldim)*lelt)
      integer vertex

      parameter(lxyz=lx1*ly1*lz1)
      common /scrns/ enum(lxyz,lelt)
     $             ,  rnx(lxyz,lelt) , rny(lxyz,lelt) , rnz(lxyz,lelt)
     $             ,  tnx(lxyz,lelt) , tny(lxyz,lelt) , tnz(lxyz,lelt)
      common /scruz/  snx(lxz) , sny(lxz) , snz(lxz) ,  efc(lxz)
      common /scrsf/  jvrtex((2**ldim),lelt)

      integer e,f,eg


      gsh_fld(0)=gsh_fld(1)
      if (iftmsh(0)) gsh_fld(0)=gsh_fld(2)

      ifield = 0
      nel    = nelfld(0)
      nxyz   = lx1*ly1*lz1
      nxz    = lx1*lz1
      n      = nel*nxyz
      nface  = 2*ldim


      iflag=0
      do e=1,nel
      do f=1,nface
         if (cbc(f,e,1).eq.'msi'.or.cbc(f,e,1).eq.'MSI') iflag=1
      enddo
      enddo
      iflag = iglmax(iflag,1)
      if (iflag.eq.0) return


c     We need to differentiate elements according to unit normal on msi face.

c     NOTE that this code assumes we do not have two adjacent faces on a given
c     element that both have cbc = msi!

      call rzero(rnx,n)
      call rzero(rny,n)
      call rzero(rnz,n)
      call rzero(tnx,n)
      call rzero(tny,n)
      call rzero(tnz,n)

      do e=1,nel
         re = lglel(e)
         call cfill(enum(1,e),re,nxyz)
      enddo

      call dsop(enum,'min')


      do e=1,nel
         eg = lglel(e)
         do f=1,nface
           if (cbc(f,e,1).eq.'msi'.or.cbc(f,e,1).eq.'MSI') then
             call facexs (efc,enum(1,e),f,0) ! enum-->efc
             do i=1,nxz
               jg = efc(i)+0.1
               if (jg.eq.eg) then         ! this is the controlling face
                  snx(i) = unx(i,1,f,e)
                  sny(i) = uny(i,1,f,e)
                  snz(i) = unz(i,1,f,e)
               endif
             enddo
             call facexv (snx,sny,snz,rnx(1,e),rny(1,e),rnz(1,e),f,1) ! s-->r
             call facexv (unx(1,1,f,e),uny(1,1,f,e),unz(1,1,f,e) ! Control
     $                   ,tnx(1,e),tny(1,e),tnz(1,e),f,1)        ! u-->r
           endif
         enddo
      enddo

      call opdssum(rnx,rny,rnz)

      nv = nel*(2**ldim)
      call icopy(jvrtex,vertex,nv)  ! Save vertex
      mvertx=iglmax(jvrtex,nv)


c     Now, check to see if normal is aligned with incoming normal

      nsx=lx1-1
      nsy=ly1-1
      nsz=max(1,lz1-1)

      do e=1,nel
         l=0
         do k=1,lz1,nsz
         do j=1,ly1,nsy
         do i=1,lx1,nsx
            l=l+1
            m=i + lx1*(j-1) + lx1*ly1*(k-1)
            dot = tnx(m,e)*rnx(m,e)+tny(m,e)*rny(m,e)+tnz(m,e)*rnz(m,e)
            if (dot.lt.-.5) jvrtex(l,e)=jvrtex(l,e)+mvertx
         enddo
         enddo
         enddo
      enddo


      call setupds(gsh_fld(0),lx1,ly1,lz1,nelv,nelgv,jvrtex,glo_num)

      return
      end
c-----------------------------------------------------------------------
      subroutine outfldnx(x,txt10,nx,ny)
      include 'SIZE'
      real x(nx,ny,4)
      character*10 txt10
      integer e,g

      write(6,106) txt10,nel,nx
  106 FORMAT(  /,5X,'     ^              ',/,
     $           5X,'   Y |              ',/,
     $           5X,'     |              ',A10,/,
     $           5X,'     +---->         ','elem. = ',I2,'/',I2,/,
     $           5X,'       X            ')

      do e=3,1,-2
         g=e+1
         i=istart
         do j=ny,1,-1
            if (nx.eq.3) write(6,3) (x(i,j,e),i=1,nx),(x(i,j,g),i=1,nx)
            if (nx.eq.4) write(6,4) (x(i,j,e),i=1,nx),(x(i,j,g),i=1,nx)
            if (nx.eq.5) write(6,5) (x(i,j,e),i=1,nx),(x(i,j,g),i=1,nx)
            if (nx.eq.6) write(6,6) (x(i,j,e),i=1,nx),(x(i,j,g),i=1,nx)
            if (nx.eq.7) write(6,7) (x(i,j,e),i=1,nx),(x(i,j,g),i=1,nx)
   3        format(3f8.4,3x,3f8.4)
   4        format(4f8.4,3x,4f8.4)
   5        format(5f8.4,3x,5f8.4)
   6        format(6f8.4,3x,6f8.4)
   7        format(7f8.4,3x,7f8.4)
         enddo
         write(6,*)
      enddo
      write(6,*)

      return
      end
c-----------------------------------------------------------------------

subroutine Eos_getData(range,vecLen,solnData,gridDataStruct,eosData,massFrac, eosMask)

  use Eos_data, ONLY: eos_eintSwitch, eos_smalle, eos_mapLookup
  use Driver_interface, ONLY : Driver_abortFlash
  use Eos_interface, ONLY : Eos_getData_loop1
  implicit none
  
#include "Eos.h"
#include "Eos_map.h"
#include "constants.h"
#include "Flash.h"
  
  integer, intent(in) :: vecLen, gridDataStruct
  integer, dimension(LOW:HIGH,MDIM), intent(in) :: range
  real, dimension(EOS_NUM*vecLen),intent(INOUT) :: eosData
  real,dimension(:),optional,intent(OUT) :: massFrac
  logical, optional, INTENT(INOUT),dimension(EOS_VARS+1:) :: eosMask     
  real, pointer:: solnData(:,:,:,:)


  integer :: i,j,k,n,m,pres,dens,gamc,temp,abar,zbar,eint,ekin,entr
  integer :: pres_map,dens_map,gamc_map,game_map,temp_map,entr_map
  integer :: eint_map,ener_map, velx_map, vely_map, velz_map, sumy_map, ye_map
  integer :: ib,ie,jb,je,kb,ke
  real :: kineticEnergy, internalEnergy
!! ---------------------------------------------------------------------------------
! Test calling arguments

! Initializations:   grab the solution data from UNK and determine
!   the length of the data being operated upon
  
  ib=range(LOW,IAXIS)
  jb=range(LOW,JAXIS)
  kb=range(LOW,KAXIS)
  ie=range(HIGH,IAXIS)
  je=range(HIGH,JAXIS)
  ke=range(HIGH,KAXIS)
!!$  select case(axis)
!!$  case(IAXIS)
!!$     ie=ie+vecLen-1
!!$  case(JAXIS)
!!$     je=je+vecLen-1
!!$  case(KAXIS)
!!$     ke=ke+vecLen-1
!!$  end select
! These integers are indexes into the location in eosData just before the storage area for the appropriate variable.
  pres = (EOS_PRES-1)*vecLen
  dens = (EOS_DENS-1)*vecLen
  temp = (EOS_TEMP-1)*vecLen
  gamc = (EOS_GAMC-1)*vecLen
  eint = (EOS_EINT-1)*vecLen
  ekin = (EOS_EKIN-1)*vecLen
  abar = (EOS_ABAR-1)*vecLen
  zbar = (EOS_ZBAR-1)*vecLen
  entr = (EOS_ENTR-1)*vecLen

  pres_map = eos_mapLookup(EOSMAP_PRES,EOS_IN,gridDataStruct)
  dens_map = eos_mapLookup(EOSMAP_DENS,EOS_IN,gridDataStruct)
  temp_map = eos_mapLookup(EOSMAP_TEMP,EOS_IN,gridDataStruct)
  gamc_map = eos_mapLookup(EOSMAP_GAMC,EOS_IN,gridDataStruct)
  game_map = eos_mapLookup(EOSMAP_GAME,EOS_IN,gridDataStruct)
  eint_map = eos_mapLookup(EOSMAP_EINT,EOS_IN,gridDataStruct)
  ener_map = eos_mapLookup(EOSMAP_ENER,EOS_IN,gridDataStruct)
  velx_map = eos_mapLookup(EOSMAP_VELX,EOS_IN,gridDataStruct)
  vely_map = eos_mapLookup(EOSMAP_VELY,EOS_IN,gridDataStruct)
  velz_map = eos_mapLookup(EOSMAP_VELZ,EOS_IN,gridDataStruct)
  sumy_map = eos_mapLookup(EOSMAP_SUMY,EOS_IN,gridDataStruct)
  ye_map   = eos_mapLookup(EOSMAP_YE,  EOS_IN,gridDataStruct)
  entr_map = eos_mapLookup(EOSMAP_ENTR,EOS_IN,gridDataStruct)

  if(gridDataStruct == SCRATCH) then
     call Driver_abortFlash("Eos_getData : the use of SCRATCH is deprecated")
  end if

  if(present(massFrac)) then
     m=1
     do k = kb,ke
        do j = jb,je
           do i = ib,ie
              do n = SPECIES_BEGIN,SPECIES_END
                 massFrac(m) = solnData(n,i,j,k)
                 m=m+1
              end do
           end do
        end do
     end do
  end if

  n = 0
  !! DEV: If / when we add a ptr dummy argument for passing in an offset, this will be n = ptr
  do k = kb,ke
     do j = jb,je
        do i = ib,ie
           call Eos_getData_loop1(vecLen, eosData, solnData, i,j,k,n, pres_map,dens_map,gamc_map,&
                    game_map,temp_map,entr_map,eint_map,ener_map, velx_map, vely_map, velz_map, &
                    sumy_map, ye_map, pres,dens,gamc,temp,abar,zbar,eint,ekin,entr)
        end do
     end do
  end do
  
  return
end subroutine Eos_getData 

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Array initialization using assignments. No data race pairs.

module DRB067
    use omp_lib
    implicit none
contains
    subroutine foo(newSxx, newSyy, len)
        integer, value :: len
        integer :: i
        integer, parameter :: dp = kind(1.0d0)
        real(dp),dimension(:), pointer :: newSxx, newSyy
        real(dp),dimension(len), target :: tar1, tar2

        allocate (newSxx(len))
        allocate (newSyy(len))

        newSxx => tar1
        newSyy => tar2

        !$omp parallel do private (i) firstprivate (len)
        do i = 1, len
            tar1(i) = 0.0
            tar2(i) = 0.0
        end do
        !$omp end parallel do

        print*,tar1(len),tar2(len)
        
        if(associated(newSxx))nullify(newSxx)
        if(associated(newSyy))nullify(newSyy)

    end subroutine
end module
program DRB067_restrictpointer1_orig_no
    use omp_lib
    use DRB067
    implicit none

    integer :: len = 1000
    integer, parameter :: dp = kind(1.0d0)
    real(dp),dimension(:), pointer :: newSxx, newSyy

    allocate (newSxx(len))
    allocate (newSyy(len))

    call foo(newSxx, newSyy, len)

    if(associated(newSxx))nullify(newSxx)
    if(associated(newSyy))nullify(newSyy)
end program

c-----------------------------------------------------------------------
c
      subroutine set_vert(glo_num,ngv,nx,nel,vertex,ifcenter)
c
c     Given global array, vertex, pointing to hex vertices, set up
c     a new array of global pointers for an nx^ldim set of elements.
c
      include 'SIZE'
      include 'INPUT'
c
      integer*8 glo_num(1),ngv
      integer vertex(1),nx
      logical ifcenter

      if (if3d) then
         call setvert3d(glo_num,ngv,nx,nel,vertex,ifcenter)
      else
         call setvert2d(glo_num,ngv,nx,nel,vertex,ifcenter)
      endif

c     Check for single-element periodicity 'p' bc
      nz = 1
      if (if3d) nz = nx
      call check_p_bc(glo_num,nx,nx,nz,nel)

      if(nio.eq.0 .and. loglevel.gt.2) 
     $  write(6,*) 'call usrsetvert'
      call usrsetvert(glo_num,nel,nx,nx,nz)
      if(nio.eq.0 .and. loglevel.gt.2) 
     $  write(6,'(A,/)') ' done :: usrsetvert'

      return
      end
c
c-----------------------------------------------------------------------
c
      subroutine crs_solve_l2(uf,vf)
c
c     Given an input vector v, this generates the H1 coarse-grid solution
c
      include 'SIZE'
      include 'DOMAIN'
      include 'ESOLV'
      include 'GEOM'
      include 'PARALLEL'
      include 'SOLN'
      include 'INPUT'
      include 'TSTEP'
      real uf(1),vf(1)
      common /scrpre/ uc(lcr*lelt),w(2*lx1*ly1*lz1)

      call map_f_to_c_l2_bilin(uf,vf,w)
      call fgslib_crs_solve(xxth(ifield),uc,uf)
      call map_c_to_f_l2_bilin(uf,uc,w)

      return
      end
c
c-----------------------------------------------------------------------
c      subroutine test_h1_crs
c      include 'SIZE'
c      include 'DOMAIN'
c      common /scrxxt/ x(lcr*lelv),b(lcr*lelv)
c      common /nekmpi/ mid,mp,nekcomm,nekgroup,nekreal
c      real x,b
c      ntot=nelv*nxyz_c
c      do i=1,12
c         call rzero(b,ntot)
c         if(mp.eq.1) then
c            b(i)=1
c         else if(mid.eq.0) then
c            if(i.gt.8) b(i-8)=1
c         else
c            if(i.le.8) b(i)=1
c         endif
c         call hsmg_coarse_solve(x,b)
c         print *, 'Column ',i,':',(x(j),j=1,ntot)
c      enddo
c      return
c      end
c-----------------------------------------------------------------------
c
      subroutine set_up_h1_crs

      include 'SIZE'
      include 'GEOM'
      include 'DOMAIN'
      include 'INPUT'
      include 'PARALLEL'
      include 'TSTEP'
      common /nekmpi/ mid,mp,nekcomm,nekgroup,nekreal

      common /ivrtx/ vertex ((2**ldim)*lelt)
      integer vertex

      integer gs_handle
      integer null_space,e

      character*3 cb
      common /scrxxt/ cmlt(lcr,lelv),mask(lcr,lelv)
      common /scrxxti/ ia(lcr,lcr,lelv), ja(lcr,lcr,lelv)
      real mask
      integer ia,ja
      real z

      integer key(2),aa(2)
      common /scrch/ iwork(2,lx1*ly1*lz1*lelv)
      common /scrns/ w(7*lx1*ly1*lz1*lelv)
      common /vptsol/ a(27*lx1*ly1*lz1*lelv)
      integer w
      real wr(1)
      equivalence (wr,w)

      common /scrvhx/ h1(lx1*ly1*lz1*lelv),h2(lx1*ly1*lz1*lelv)
      common /scrmgx/ w1(lx1*ly1*lz1*lelv),w2(lx1*ly1*lz1*lelv)

      integer*8 ngv
      character*132 amgfile_c
      character*1   fname1(132)
      equivalence  (fname1,amgfile_c)
      integer nnamg

      t0 = dnekclock()

c     nxc is order of coarse grid space + 1, nxc=2, linear, 3=quad,etc.
c     nxc=param(82)
c     if (nxc.gt.lxc) then
c        nxc=lxc
c        write(6,*) 'WARNING :: coarse grid space too large',nxc,lxc 
c     endif
c     if (nxc.lt.2) nxc=2

      nxc     = 2
      nx_crs  = nxc

      if(nio.eq.0) write(6,*) 'setup h1 coarse grid, nx_crs=', nx_crs

      ncr     = nxc**ldim
      nxyz_c  = ncr
c
c     Set SEM_to_GLOB
c
      call get_vertex
      call set_vert(se_to_gcrs,ngv,nxc,nelv,vertex,.true.)

c     Set mask
      z=0
      ntot=nelv*nxyz_c
      nzc=1
      if (if3d) nzc=nxc
      call rone(mask,ntot)
      call rone(cmlt,ntot)
      nfaces=2*ldim
c     ifield=1			!c? avo: set in set_overlap through 'TSTEP'?

      if (ifield.eq.1) then
         do ie=1,nelv
         do iface=1,nfaces
            cb=cbc(iface,ie,ifield)
            if (cb.eq.'o  '  .or.  cb.eq.'on '  .or. 
     $          cb.eq.'O  '  .or.  cb.eq.'ON '  .or.  cb.eq.'MM '  .or.
     $          cb.eq.'mm '  .or.  cb.eq.'ms '  .or.  cb.eq.'MS ')
     $           call facev(mask,ie,iface,z,nxc,nxc,nzc) ! 'S* ' & 's* ' ?avo?
         enddo
         enddo
      elseif (ifield.eq.ifldmhd) then   ! no ifmhd ?avo?
         do ie=1,nelv
         do iface=1,nfaces
            cb=cbc(iface,ie,ifield)
            if (cb.eq.'ndd'  .or.  cb.eq.'dnd'  .or.  cb.eq.'ddn')
     $          call facev(mask,ie,iface,z,nxc,nxc,nzc)
         enddo
         enddo
      endif

c     Set global index of dirichlet nodes to zero; xxt will ignore them

      call fgslib_gs_setup(gs_handle,se_to_gcrs,ntot,nekcomm,mp)
      call fgslib_gs_op   (gs_handle,mask,1,2,0)  !  "*"
      call fgslib_gs_op   (gs_handle,cmlt,1,1,0)  !  "+"
      call fgslib_gs_free (gs_handle)
      call set_jl_crs_mask(ntot,mask,se_to_gcrs)

      call invcol1(cmlt,ntot)

c     Setup local SEM-based Neumann operators (for now, just full...)

c      if (param(51).eq.1) then     ! old coarse grid
c         nxyz1=lx1*ly1*lz1
c         lda = 27*nxyz1*lelt
c         ldw =  7*nxyz1*lelt
c         call get_local_crs(a,lda,nxc,h1,h2,w,ldw)
c      else
c        NOTE: a(),h1,...,w2() must all be large enough
         n = lx1*ly1*lz1*nelv
         call rone (h1,n)
         call rzero(h2,n)
         call get_local_crs_galerkin(a,ncr,nxc,h1,h2,w1,w2)
c      endif

      call set_mat_ij(ia,ja,ncr,nelv)
      null_space=0
      if (ifield.eq.1) then
         if (ifvcor)  null_space=1
      elseif (ifield.eq.ifldmhd) then
         if (ifbcor)  null_space=1
      endif

      nz=ncr*ncr*nelv
      isolver = param(40)

      call blank(fname1,132)
      lamgn = ltrunc(amgfile,len(amgfile))
      call chcopy(fname1,amgfile,lamgn)
      call chcopy(fname1(lamgn+1),char(0),1)

      ierr = 0
      call fgslib_crs_setup(xxth(ifield),isolver,nekcomm,mp,ntot,
     $     se_to_gcrs,nz,ia,ja,a, null_space, crs_param, 
     $     amgfile_c,ierr)
      ierr = iglmax(ierr,1)
      if (ifneknek) ierr = iglmax_ms(ierr,1)
      if (ierr.eq.1) then
         call exitt
      endif

      t0 = dnekclock()-t0
      if (nio.eq.0) then
         write(6,*) 'done :: setup h1 coarse grid ',t0, ' sec'
         write(6,*) ' '
      endif

      return
      end
c
c-----------------------------------------------------------------------
      subroutine set_jl_crs_mask(n, mask, se_to_gcrs)
      real mask(1)
      integer*8 se_to_gcrs(1)
      do i=1,n
         if(mask(i).lt.0.1) se_to_gcrs(i)=0
      enddo
      return
      end
c-----------------------------------------------------------------------
      subroutine set_mat_ij(ia,ja,n,ne)
      integer n,ne
      integer ia(n,n,ne), ja(n,n,ne)
c
      integer i,j,ie
      do ie=1,ne
      do j=1,n
      do i=1,n
         ia(i,j,ie)=(ie-1)*n+i-1
         ja(i,j,ie)=(ie-1)*n+j-1
      enddo
      enddo
      enddo
      return
      end
c-----------------------------------------------------------------------
      subroutine irank_vec(ind,nn,a,m,n,key,nkey,aa)
c
c     Compute rank of each unique entry a(1,i) 
c
c     Output:   ind(i)  i=1,...,n    (global) rank of entry a(*,i)
c               nn  = max(rank)
c               a(j,i) is destroyed
c
c     Input:    a(j,i) j=1,...,m;  i=1,...,n  
c               m      :   leading dim. of v  (ldv must be .ge. m)
c               key    :   sort key
c               nkey   :   
c
c     Although not mandatory, this ranking procedure is probably
c     most effectively employed when the keys are pre-sorted. Thus,
c     the option is provided to sort vi() prior to the ranking.
c
c
      integer ind(n),a(m,n)
      integer key(nkey),aa(m)
      logical iftuple_ianeb,a_ne_b
c
      if (m.eq.1) then
c
         write(6,*) 
     $        'WARNING: For single key, not clear that rank is unique!'
         call irank(a,ind,n)
         return
      endif
c
c
      nk = min(nkey,m)
      call ituple_sort(a,m,n,key,nk,ind,aa)
c
c     Find unique a's
c
      nn=1
c
      call icopy(aa,a,m)
      a(1,1) = nn
      a(2,1)=ind(1)
c
      do i=2,n
         a_ne_b = iftuple_ianeb(aa,a(1,i),key,nk)
         if (a_ne_b) then
            call icopy(aa,a(1,i),m)
            nn = nn+1
         endif
         a(1,i) = nn
         a(2,i) = ind(i)
      enddo
c
c     Set ind() to rank
c
      do i=1,n
         iold=a(2,i)
         ind(iold) = a(1,i)
      enddo
c
      return
      end
c
c-----------------------------------------------------------------------
c
      subroutine ituple_sort(a,lda,n,key,nkey,ind,aa)
C
C     Use Heap Sort (p 231 Num. Rec., 1st Ed.)
C
      integer a(lda,n),aa(lda)
      integer ind(1),key(nkey)
      logical iftuple_ialtb
C
      dO 10 j=1,n
         ind(j)=j
   10 continue
C
      if (n.le.1) return
      L=n/2+1
      ir=n
  100 continue
         if (l.gt.1) then
            l=l-1
c           aa  = a  (l)
            call icopy(aa,a(1,l),lda)
            ii  = ind(l)
         else
c           aa =   a(ir)
            call icopy(aa,a(1,ir),lda)
            ii = ind(ir)
c           a(ir) =   a( 1)
            call icopy(a(1,ir),a(1,1),lda)
            ind(ir) = ind( 1)
            ir=ir-1
            if (ir.eq.1) then
c              a(1) = aa
               call icopy(a(1,1),aa,lda)
               ind(1) = ii
               return
            endif
         endif
         i=l
         j=l+l
  200    continue
         if (j.le.ir) then
            if (j.lt.ir) then
               if (iftuple_ialtb(a(1,j),a(1,j+1),key,nkey)) j=j+1
            endif
            if (iftuple_ialtb(aa,a(1,j),key,nkey)) then
c              a(i) = a(j)
               call icopy(a(1,i),a(1,j),lda)
               ind(i) = ind(j)
               i=j
               j=j+j
            else
               j=ir+1
            endif
         GOTO 200
         endif
c        a(i) = aa
         call icopy(a(1,i),aa,lda)
         ind(i) = ii
      GOTO 100
      end
c
c-----------------------------------------------------------------------
c
      subroutine tuple_sort(a,lda,n,key,nkey,ind,aa)
C
C     Use Heap Sort (p 231 Num. Rec., 1st Ed.)
C
      real a(lda,n),aa(lda)
      integer ind(1),key(nkey)
      logical iftuple_altb
C
      dO 10 j=1,n
         ind(j)=j
   10 continue
C
      if (n.le.1) return
      L=n/2+1
      ir=n
  100 continue
         if (l.gt.1) then
            l=l-1
c           aa  = a  (l)
            call copy(aa,a(1,l),lda)
            ii  = ind(l)
         else
c           aa =   a(ir)
            call copy(aa,a(1,ir),lda)
            ii = ind(ir)
c           a(ir) =   a( 1)
            call copy(a(1,ir),a(1,1),lda)
            ind(ir) = ind( 1)
            ir=ir-1
            if (ir.eq.1) then
c              a(1) = aa
               call copy(a(1,1),aa,lda)
               ind(1) = ii
               return
            endif
         endif
         i=l
         j=l+l
  200    continue
         if (j.le.ir) then
            if (j.lt.ir) then
c              if ( a(j).lt.a(j+1) ) j=j+1
               if (iftuple_altb(a(1,j),a(1,j+1),key,nkey)) j=j+1
            endif
c           if (aa.lt.a(j)) then
            if (iftuple_altb(aa,a(1,j),key,nkey)) then
c              a(i) = a(j)
               call copy(a(1,i),a(1,j),lda)
               ind(i) = ind(j)
               i=j
               j=j+j
            else
               j=ir+1
            endif
         GOTO 200
         endif
c        a(i) = aa
         call copy(a(1,i),aa,lda)
         ind(i) = ii
      GOTO 100
      end
c
c-----------------------------------------------------------------------
c
      logical function iftuple_ialtb(a,b,key,nkey)
      integer a(1),b(1)
      integer key(nkey)
c
      do i=1,nkey
         k=key(i)
         if (a(k).lt.b(k)) then
            iftuple_ialtb = .true.
            return
         elseif (a(k).gt.b(k)) then
            iftuple_ialtb = .false.
            return
         endif
      enddo
      iftuple_ialtb = .false.
      return
      end
c
c-----------------------------------------------------------------------
c
      logical function iftuple_altb(a,b,key,nkey)
      real a(1),b(1)
      integer key(nkey)
c
      do i=1,nkey
         k=key(i)
         if (a(k).lt.b(k)) then
            iftuple_altb = .true.
            return
         elseif (a(k).gt.b(k)) then
            iftuple_altb = .false.
            return
         endif
      enddo
      iftuple_altb = .false.
      return
      end
c
c-----------------------------------------------------------------------
c
      logical function iftuple_ianeb(a,b,key,nkey)
      integer a(1),b(1)
      integer key(nkey)
c
      do i=1,nkey
         k=key(i)
         if (a(k).ne.b(k)) then
            iftuple_ianeb = .true.
            return
         endif
      enddo
      iftuple_ianeb = .false.
      return
      end
c
c-----------------------------------------------------------------------
c
      subroutine get_local_crs(a,lda,nxc,h1,h2,w,ldw)
c
c     This routine generates Nelv submatrices of order nxc^ldim.
c
      include 'SIZE'
      include 'GEOM'
      include 'INPUT'
      include 'TSTEP'
      include 'DOMAIN'
      include 'PARALLEL'
c
c
c     Generate local triangular matrix
c
      real   a(1),h1(1),h2(1),w(ldw)
c
      parameter (lcrd=lx1**ldim)
      common /ctmp1/ x(lcrd),y(lcrd),z(lcrd)
c
c
      ncrs_loc = nxc**ldim
      n2       = ncrs_loc*ncrs_loc
c
c     Required storage for a:
      nda = n2*nelv
      if (nda.gt.lda) then
         write(6,*)nid,'ERROR: increase storage get_local_crs:',nda,lda
         call exitt
      endif
c
c
      l = 1
      do ie=1,nelv
c
         call map_m_to_n(x,nxc,xm1(1,1,1,ie),lx1,if3d,w,ldw)
         call map_m_to_n(y,nxc,ym1(1,1,1,ie),lx1,if3d,w,ldw)
         if (if3d) call map_m_to_n(z,nxc,zm1(1,1,1,ie),lx1,if3d,w,ldw)
c.later. call map_m_to_n(hl1,nxc,h1(1,1,1,ie),lx1,if3d,w,ldw)
c.later. call map_m_to_n(hl2,nxc,h2(1,1,1,ie),lx1,if3d,w,ldw)
c
         call a_crs_enriched(a(l),h1,h2,x,y,z,nxc,if3d,ie)
         l=l+n2
c
      enddo
c
      return
      end
c
c-----------------------------------------------------------------------
c
      subroutine a_crs_enriched(a,h1,h2,x1,y1,z1,nxc,if3d,ie)
c
c     This sets up a matrix for a single array of tensor-product
c     gridpoints (e.g., an array defined by SEM-GLL vertices)
c
c         For example, suppose ldim=3.
c
c         Then, there would be ncrs_loc := nxc^3 dofs for this matrix,
c
c         and the matrix size would be (ncrs_loc x ncrs_loc).
c
c
c
      include 'SIZE'
c
      real a(1),h1(1),h2(1)
      real x1(nxc,nxc,1),y1(nxc,nxc,1),z1(nxc,nxc,1)
      logical if3d
c
      parameter (ldm2=2**ldim)
      real a_loc(ldm2,ldm2)
      real x(8),y(8),z(8)
c
      ncrs_loc = nxc**ldim
      n2       = ncrs_loc*ncrs_loc
      call rzero(a,n2)
c
      nyc=nxc
      nzc=2
      if (if3d) nzc=nxc
      nz =0
      if (if3d) nz=1
c
c     Here, we march across sub-cubes
c
      do kz=1,nzc-1
      do ky=1,nyc-1
      do kx=1,nxc-1
         k = 0
         do iz=0,nz
         do iy=0,1
         do ix=0,1
            k = k+1
            x(k) = x1(kx+ix,ky+iy,kz+iz)
            y(k) = y1(kx+ix,ky+iy,kz+iz)
            z(k) = z1(kx+ix,ky+iy,kz+iz)
         enddo
         enddo
         enddo
         if (if3d) then
            call a_crs_3d(a_loc,h1,h2,x,y,z,ie)
         else
            call a_crs_2d(a_loc,h1,h2,x,y,ie)
         endif
c        call outmat(a_loc,ldm2,ldm2,'A_loc ',ie)
c
c        Assemble:
c
         j = 0
         do jz=0,nz
         do jy=0,1
         do jx=0,1
            j = j+1
            ja = (kx+jx) + nxc*(ky+jy-1) + nxc*nyc*(kz+jz-1)
c
            i = 0
            do iz=0,nz
            do iy=0,1
            do ix=0,1
               i   = i+1
               ia  = (kx+ix) + nxc*(ky+iy-1) + nxc*nyc*(kz+iz-1)
c
               ija = ia + ncrs_loc*(ja-1)
               a(ija) = a(ija) + a_loc(i,j)
c
            enddo
            enddo
            enddo
c
         enddo
         enddo
         enddo
      enddo
      enddo
      enddo
c
      return
      end
c
c-----------------------------------------------------------------------
c
      subroutine a_crs_3d(a,h1,h2,xc,yc,zc,ie)
c
c     Generate stiffness matrix for 3D coarse grid problem.
c     
c     This is done by using two tetrahedrizations of each
c     hexahedral subdomain (element) such that each of the
c     6 panels (faces) on the sides of an element has a big X.
c
c
      real a(0:7,0:7),h1(0:7),h2(0:7)
      real xc(0:7),yc(0:7),zc(0:7)
c
      real a_loc(4,4)
      real xt(4),yt(4),zt(4)
c
      integer vertex(4,5,2)
      save    vertex
      data    vertex / 000 ,  001 , 010 , 100
     $               , 000 ,  001 , 011 , 101 
     $               , 011 ,  010 , 000 , 110 
     $               , 011 ,  010 , 001 , 111 
     $               , 000 ,  110 , 101 , 011
c
     $               , 101 ,  100 , 110 , 000
     $               , 101 ,  100 , 111 , 001 
     $               , 110 ,  111 , 100 , 010 
     $               , 110 ,  111 , 101 , 011 
     $               , 111 ,  001 , 100 , 010  /
c
      integer icalld
      save    icalld
      data    icalld/0/
c
      if (icalld.eq.0) then
         do i=1,40
            call bindec(vertex(i,1,1))
         enddo
      endif
      icalld=icalld+1
c
      call rzero(a,64)
      do k=1,10
         do iv=1,4
            xt(iv) = xc(vertex(iv,k,1))
            yt(iv) = yc(vertex(iv,k,1))
            zt(iv) = zc(vertex(iv,k,1))
         enddo
         call get_local_A_tet(a_loc,xt,yt,zt,k,ie)
         do j=1,4
            jj = vertex(j,k,1)
            do i=1,4
               ii = vertex(i,k,1)
               a(ii,jj) = a(ii,jj) + 0.5*a_loc(i,j)
            enddo
         enddo
      enddo
      return
      end
c
c-----------------------------------------------------------------------
c
      subroutine bindec(bin_in)
      integer bin_in,d,b,b2
c
      keep  = bin_in
      d  = bin_in
      b2 = 1
      b  = 0
      do l=1,12
         b  = b + b2*mod(d,10)
         d  = d/10
         b2 = b2*2
         if (d.eq.0) goto 1
      enddo
    1 continue
      bin_in = b
      return
      end
c
c-----------------------------------------------------------------------
      subroutine get_local_A_tet(a,x,y,z,kt,ie)
c
c     Generate local tetrahedral matrix
c
c
      real a(4,4), g(4,4)
      real x(4),y(4),z(4)
c
   11 continue
      x23 = x(2) - x(3)
      y23 = y(2) - y(3)
      z23 = z(2) - z(3)
      x34 = x(3) - x(4)
      y34 = y(3) - y(4)
      z34 = z(3) - z(4)
      x41 = x(4) - x(1)
      y41 = y(4) - y(1)
      z41 = z(4) - z(1)
      x12 = x(1) - x(2)
      y12 = y(1) - y(2)
      z12 = z(1) - z(2)
c
      xy234 = x34*y23 - x23*y34
      xy341 = x34*y41 - x41*y34
      xy412 = x12*y41 - x41*y12
      xy123 = x12*y23 - x23*y12
      xz234 = x23*z34 - x34*z23
      xz341 = x41*z34 - x34*z41
      xz412 = x41*z12 - x12*z41
      xz123 = x23*z12 - x12*z23
      yz234 = y34*z23 - y23*z34
      yz341 = y34*z41 - y41*z34
      yz412 = y12*z41 - y41*z12
      yz123 = y12*z23 - y23*z12
c
      g(1,1) = -(x(2)*yz234 + y(2)*xz234 + z(2)*xy234)
      g(2,1) = -(x(3)*yz341 + y(3)*xz341 + z(3)*xy341)
      g(3,1) = -(x(4)*yz412 + y(4)*xz412 + z(4)*xy412)
      g(4,1) = -(x(1)*yz123 + y(1)*xz123 + z(1)*xy123)
      g(1,2) = yz234
      g(2,2) = yz341
      g(3,2) = yz412
      g(4,2) = yz123
      g(1,3) = xz234
      g(2,3) = xz341
      g(3,3) = xz412
      g(4,3) = xz123
      g(1,4) = xy234
      g(2,4) = xy341
      g(3,4) = xy412
      g(4,4) = xy123
c
c        vol36 = 1/(36*volume) = 1/(6*determinant)
c
      det = x(1)*yz234 + x(2)*yz341 + x(3)*yz412 + x(4)*yz123
      vol36 = 1.0/(6.0*det)
      if (vol36.lt.0) then
         write(6,*) 'Error: tetrahedron not right-handed',ie
         write(6,1) 'x',(x(k),k=1,4)
         write(6,1) 'y',(y(k),k=1,4)
         write(6,1) 'z',(z(k),k=1,4)
 1       format(a1,1p4e15.5)

c        call exitt                 ! Option 1

         xx = x(1)                  ! Option 2
         x(1) = x(2)                !  -- this is the option that 
         x(2) = xx                  !     actually works. 11/25/07

         xx = y(1)
         y(1) = y(2)
         y(2) = xx

         xx = z(1)
         z(1) = z(2)
         z(2) = xx

         goto 11

c        call rzero(a,16)           ! Option 3
c        return

c        vol36 = abs(vol36)         ! Option 4

      endif
c
      do j=1,4
         do i=1,4
            a(i,j)=vol36*(g(i,2)*g(j,2)+g(i,3)*g(j,3)+g(i,4)*g(j,4))
         enddo
      enddo
c
      return
      end
c
c-----------------------------------------------------------------------
c
      subroutine a_crs_2d(a,h1,h2,x,y,ie)
c
      include 'SIZE'
      include 'GEOM'
      include 'INPUT'
      include 'TSTEP'
      include 'DOMAIN'
      include 'PARALLEL'
c
c     Generate local triangle-based stiffnes matrix for quad
c
      real a(4,4),h1(1),h2(1)
      real x(1),y(1)
c
c     Triangle to Square pointers
c
      integer elem(3,2)
      save    elem
      data    elem / 1,2,4  ,  1,4,3 /
c
      real a_loc(3,3)
c
c
      call rzero(a,16)
c
      do i=1,2
         j1 = elem(1,i)
         j2 = elem(2,i)
         j3 = elem(3,i)
         x1=x(j1)
         y1=y(j1)
         x2=x(j2)
         y2=y(j2)
         x3=x(j3)
         y3=y(j3)
c
         y23=y2-y3
         y31=y3-y1
         y12=y1-y2
c
         x32=x3-x2
         x13=x1-x3
         x21=x2-x1
c
c        area4 = 1/(4*area)
         area4 = 0.50/(x21*y31 - y12*x13)
c
         a_loc(1, 1) = area4*( y23*y23+x32*x32 )
         a_loc(1, 2) = area4*( y23*y31+x32*x13 )
         a_loc(1, 3) = area4*( y23*y12+x32*x21 )
c
         a_loc(2, 1) = area4*( y31*y23+x13*x32 )
         a_loc(2, 2) = area4*( y31*y31+x13*x13 )
         a_loc(2, 3) = area4*( y31*y12+x13*x21 )
c
         a_loc(3, 1) = area4*( y12*y23+x21*x32 )
         a_loc(3, 2) = area4*( y12*y31+x21*x13 )
         a_loc(3, 3) = area4*( y12*y12+x21*x21 )
c
c        Store in "4 x 4" format
c
         do il=1,3
            iv = elem(il,i)
            do jl=1,3
               jv = elem(jl,i)
               a(iv,jv) = a(iv,jv) + a_loc(il,jl)
            enddo
         enddo
      enddo
c
      return
      end
c
c-----------------------------------------------------------------------
c
      subroutine map_m_to_n(a,na,b,nb,if3d,w,ldw)
c
c     Input:   b
c     Output:  a
c
      real a(1),b(1),w(1)
      logical if3d
c
      parameter(lx=50)
      real za(lx),zb(lx)
c
      real iba(lx*lx),ibat(lx*lx)
      save iba,ibat
c
      integer nao,nbo
      save    nao,nbo
      data    nao,nbo  / -9, -9/
c
      if (na.gt.lx.or.nb.gt.lx) then
         write(6,*)'ERROR: increase lx in map_m_to_n to max:',na,nb
         call exitt
      endif
c
      if (na.ne.nao  .or.   nb.ne.nbo) then
         nao = na
         nbo = nb
         call zwgll(za,w,na)
         call zwgll(zb,w,nb)
         call igllm(iba,ibat,zb,za,nb,na,nb,na)
      endif
c
      call specmpn(a,na,b,nb,iba,ibat,if3d,w,ldw)
c
      return
      end
c
c-----------------------------------------------------------------------
c
      subroutine specmpn(b,nb,a,na,ba,ab,if3d,w,ldw)
C
C     -  Spectral interpolation from A to B via tensor products
C     -  scratch arrays: w(na*na*nb + nb*nb*na)
C
C     5/3/00  -- this routine replaces specmp in navier1.f, which
c                has a potential memory problem
C
C
      logical if3d
c
      real b(nb,nb,nb),a(na,na,na)
      real w(ldw)
c
      ltest = na*nb
      if (if3d) ltest = na*na*nb + nb*na*na
      if (ldw.lt.ltest) then
         write(6,*) 'ERROR specmp:',ldw,ltest,if3d
         call exitt
      endif
c
      if (if3d) then
         nab = na*nb
         nbb = nb*nb
         call mxm(ba,nb,a,na,w,na*na)
         k=1
         l=na*na*nb + 1
         do iz=1,na
            call mxm(w(k),nb,ab,na,w(l),nb)
            k=k+nab
            l=l+nbb
         enddo
         l=na*na*nb + 1
         call mxm(w(l),nbb,ab,na,b,nb)
      else
         call mxm(ba,nb,a,na,w,na)
         call mxm(w,nb,ab,na,b,nb)
      endif
      return
      end
c
c-----------------------------------------------------------------------
c
      subroutine irank(A,IND,N)
C
C     Use Heap Sort (p 233 Num. Rec.), 5/26/93 pff.
C
      integer A(1),IND(1)
C
      if (n.le.1) return
      DO 10 J=1,N
         IND(j)=j
   10 continue
C
      if (n.eq.1) return
      L=n/2+1
      ir=n
  100 continue
         IF (l.gt.1) THEN
            l=l-1
            indx=ind(l)
            q=a(indx)
         ELSE
            indx=ind(ir)
            q=a(indx)
            ind(ir)=ind(1)
            ir=ir-1
            if (ir.eq.1) then
               ind(1)=indx
               return
            endif
         ENDIF
         i=l
         j=l+l
  200    continue
         IF (J.le.IR) THEN
            IF (J.lt.IR) THEN
               IF ( A(IND(j)).lt.A(IND(j+1)) ) j=j+1
            ENDIF
            IF (q.lt.A(IND(j))) THEN
               IND(I)=IND(J)
               I=J
               J=J+J
            ELSE
               J=IR+1
            ENDIF
         GOTO 200
         ENDIF
         IND(I)=INDX
      GOTO 100
      END
c-----------------------------------------------------------------------
      subroutine iranku(r,input,n,w,ind)
c
c     Return the rank of each input value, and the maximum rank.
c
c     OUTPUT:    r(k) = rank of each entry,  k=1,..,n
c                maxr = max( r )
c                w(i) = sorted & compressed list of input values
c
      integer r(1),input(1),ind(1),w(1)
c
      call icopy(r,input,n)
      call isort(r,ind,n)
c
      maxr  = 1
      rlast = r(1) 
      do i=1,n
c        Bump rank only when r_i changes
         if (r(i).ne.rlast) then
            rlast = r(i)
            maxr  = maxr + 1
         endif
         r(i) = maxr
      enddo
      call iunswap(r,ind,n,w)
c
      return
      end
c
c-----------------------------------------------------------------------
c
      subroutine ifacev_redef(a,ie,iface,val,nx,ny,nz)
C
C     Assign the value VAL to face(IFACE,IE) of array A.
C     IFACE is the input in the pre-processor ordering scheme.
C
      include 'SIZE'
      integer a(nx,ny,nz,lelt),val
      call facind (kx1,kx2,ky1,ky2,kz1,kz2,nx,ny,nz,iface)
      do 100 iz=kz1,kz2
      do 100 iy=ky1,ky2
      do 100 ix=kx1,kx2
         a(ix,iy,iz,ie)=val
  100 continue
      return
      end
c
c-----------------------------------------------------------------------
      subroutine map_c_to_f_l2_bilin(uf,uc,w)
c
c     H1 Iterpolation operator:  linear --> spectral GLL mesh
c
      include 'SIZE'
      include 'DOMAIN'
      include 'INPUT'
c
      parameter (lxyz = lx2*ly2*lz2)
      real uc(nxyz_c,lelt),uf(lxyz,lelt),w(1)

      ltot22 = 2*lx2*ly2*lz2
      nx_crs = 2   ! bilinear only

      do ie=1,nelv
         call maph1_to_l2(uf(1,ie),lx2,uc(1,ie),nx_crs,if3d,w,ltot22)
      enddo
c
      return
      end
c
c-----------------------------------------------------------------------
c
      subroutine map_f_to_c_l2_bilin(uc,uf,w)

c     TRANSPOSE of L2 Iterpolation operator:                    T
c                                 (linear --> spectral GLL mesh)

      include 'SIZE'
      include 'DOMAIN'
      include 'INPUT'

      parameter (lxyz = lx2*ly2*lz2)
      real uc(nxyz_c,lelt),uf(lxyz,lelt),w(1)

      ltot22 = 2*lx2*ly2*lz2
      nx_crs = 2   ! bilinear only

      do ie=1,nelv
         call maph1_to_l2t(uc(1,ie),nx_crs,uf(1,ie),lx2,if3d,w,ltot22)
      enddo
c
      return
      end
c
c-----------------------------------------------------------------------
c
      subroutine maph1_to_l2(a,na,b,nb,if3d,w,ldw)
c
c     Input:   b
c     Output:  a
c
      real a(1),b(1),w(1)
      logical if3d
c
      parameter(lx=50)
      real za(lx),zb(lx)
c
      real iba(lx*lx),ibat(lx*lx)
      save iba,ibat
c
      integer nao,nbo
      save    nao,nbo
      data    nao,nbo  / -9, -9/
c
c
      if (na.gt.lx.or.nb.gt.lx) then
         write(6,*)'ERROR: increase lx in maph1_to_l2 to max:',na,nb
         call exitt
      endif
c
      if (na.ne.nao  .or.   nb.ne.nbo) then
         nao = na
         nbo = nb
         call zwgl (za,w,na)
         call zwgll(zb,w,nb)
         call igllm(iba,ibat,zb,za,nb,na,nb,na)
      endif
c
      call specmpn(a,na,b,nb,iba,ibat,if3d,w,ldw)
c
      return
      end
c
c-----------------------------------------------------------------------
c
      subroutine maph1_to_l2t(b,nb,a,na,if3d,w,ldw)
c
c     Input:   a
c     Output:  b
c
      real a(1),b(1),w(1)
      logical if3d
c
      parameter(lx=50)
      real za(lx),zb(lx)
c
      real iba(lx*lx),ibat(lx*lx)
      save iba,ibat
c
      integer nao,nbo
      save    nao,nbo
      data    nao,nbo  / -9, -9/
c
c
      if (na.gt.lx.or.nb.gt.lx) then
         write(6,*)'ERROR: increase lx in maph1_to_l2 to max:',na,nb
         call exitt
      endif
c
      if (na.ne.nao  .or.   nb.ne.nbo) then
         nao = na
         nbo = nb
         call zwgl (za,w,na)
         call zwgll(zb,w,nb)
         call igllm(iba,ibat,zb,za,nb,na,nb,na)
      endif
c
      call specmpn(b,nb,a,na,ibat,iba,if3d,w,ldw)
c
      return
      end
c
c-----------------------------------------------------------------------
      subroutine irank_vec_tally(ind,nn,a,m,n,key,nkey,key2,aa)
c
c     Compute rank of each unique entry a(1,i) 
c
c     Output:   ind(i)  i=1,...,n    (global) rank of entry a(*,i)
c               nn  = max(rank)
c               a(j,i) is destroyed
c               a(1,i) tally of preceding structure values
c
c     Input:    a(j,i) j=1,...,m;  i=1,...,n  
c               m      :   leading dim. of v  (ldv must be .ge. m)
c               key    :   sort key
c               nkey   :   
c
c     Although not mandatory, this ranking procedure is probably
c     most effectively employed when the keys are pre-sorted. Thus,
c     the option is provided to sort vi() prior to the ranking.
c
c
      integer ind(n),a(m,n)
      integer key(nkey),key2(0:3),aa(m)
      logical iftuple_ianeb,a_ne_b
c
c
      nk = min(nkey,m)
      call ituple_sort(a,m,n,key,nk,ind,aa)
c     do i=1,n
c        write(6,*) i,' sort:',(a(k,i),k=1,3)
c     enddo
c
c
c     Find unique a's
c
      call icopy(aa,a,m)
      nn=1
      mm=0
c
      a(1,1) = nn
      a(2,1)=ind(1)
      a(3,1)=mm
c
      do i=2,n
         a_ne_b = iftuple_ianeb(aa,a(1,i),key,nk)
         if (a_ne_b) then              ! new structure
            ms = aa(3)                 ! structure type
            if (aa(2).eq.0) ms = aa(2) ! structure type
            mm = mm+key2(ms)           ! n dofs
            call icopy(aa,a(1,i),m)
            nn = nn+1
         endif
         a(1,i) = nn
         a(2,i) = ind(i)
         a(3,i) = mm
      enddo
      ms = aa(3)
      if (aa(2).eq.0) ms = aa(2) ! structure type
      nn = mm+key2(ms)
c
c     Set ind() to rank
c
      do i=1,n
         iold=a(2,i)
         ind(iold) = a(1,i)
      enddo
c
c     Set a1() to number of preceding dofs
c
      do i=1,n
         iold=a(2,i)
         a(1,iold) = a(3,i)
      enddo
c
      return
      end
c
c-----------------------------------------------------------------------
c
      subroutine out_se1(se2crs,nx,name)
c
      include 'SIZE'
      integer se2crs(nx,nx,1)
      character*4 name
c
      write(6,*) 
      write(6,*) 'out_se',nx,name
      do ie=nelv-1,1,-2
         write(6,*)
         do j=nx,1,-1
            if(nx.eq.4) then
               write(6,4) name,((se2crs(i,j,k+ie),i=1,nx),k=0,1)
            elseif(nx.eq.3) then
               write(6,3) name,((se2crs(i,j,k+ie),i=1,nx),k=0,1)
            else
               write(6,2) name,((se2crs(i,j,k+ie),i=1,nx),k=0,1)
            endif
         enddo
      enddo
c
    4 format(a4,5x,2(4i5,3x))
    3 format(a4,5x,2(3i5,3x))
    2 format(a4,5x,2(2i5,3x))
c
      return
      end
c
c-----------------------------------------------------------------------
c
      subroutine out_se0(se2crs,nx,nel,name)
c
      include 'SIZE'
      integer se2crs(nx,nx,1)
      character*4 name
c
      write(6,*) 
      write(6,*) 'out_se',nx,name,nel
      do ie=nel-3,1,-4
         write(6,*)
         do j=nx,1,-1
            if(nx.eq.4) then
               write(6,4) name,((se2crs(i,j,k+ie),i=1,nx),k=0,3)
            elseif(nx.eq.3) then
               write(6,3) name,((se2crs(i,j,k+ie),i=1,nx),k=0,3)
            else
               write(6,2) name,((se2crs(i,j,k+ie),i=1,nx),k=0,3)
            endif
         enddo
      enddo
c
    4 format(a4,5x,4(4i5,3x))
    3 format(a4,5x,4(3i5,3x))
    2 format(a4,5x,4(2i5,3x))
c
      return
      end
c
c-----------------------------------------------------------------------
c
      subroutine crs_solve_h1(uf,vf)
c
c     Given an input vector v, this generates the H1 coarse-grid solution
c
      include 'SIZE'
      include 'DOMAIN'
      include 'INPUT'
      include 'GEOM'
      include 'SOLN'
      include 'PARALLEL'
      include 'CTIMER'
      include 'TSTEP'

      real uf(1),vf(1)
      common /scrpre/ uc(lcr*lelt)
      common /scrpr2/ vc(lcr*lelt)
      common /scrxxt/ cmlt(lcr,lelv),mask(lcr,lelv)

      integer icalld1
      save    icalld1
      data    icalld1 /0/

      
      if (icalld1.eq.0) then ! timer info
         ncrsl=0
         tcrsl=0.0
         icalld1=1
      endif
      ncrsl  = ncrsl  + 1

      ntot = nelv*lx1*ly1*lz1
      call col3(uf,vf,vmult,ntot)

      call map_f_to_c_h1_bilin(vc,uf)   ! additive Schwarz

#ifdef TIMER
      etime1=dnekclock()
#endif
      call fgslib_crs_solve(xxth(ifield),uc,vc)
#ifdef TIMER
      tcrsl=tcrsl+dnekclock()-etime1
#endif

      call map_c_to_f_h1_bilin(uf,uc)


      return
      end
c-----------------------------------------------------------------------
      subroutine set_h1_basis_bilin
c
      include 'SIZE'
      include 'DOMAIN'
      include 'WZ'
c
      do ix=1,lx1
         h1_basis(ix) = 0.5*(1.0-zgm1(ix,1))
         h1_basis(ix+lx1) = 0.5*(1.0+zgm1(ix,1))
      enddo
      call transpose(h1_basist,2,h1_basis,lx1)
c
      return
      end
c
c-----------------------------------------------------------------------
c
      subroutine map_c_to_f_h1_bilin(uf,uc)
c
c     H1 Iterpolation operator:  linear --> spectral GLL mesh
c
      include 'SIZE'
      include 'INPUT'
      include 'DOMAIN'
c
      parameter (lxyz = lx1*ly1*lz1)
      real uc(2,2,ldim-1,lelt),uf(lxyz,lelt)
      parameter (l2 = ldim-1)
      common /ctmp0/ w(lx1,lx1,2),v(lx1,2,l2,lelt)
c
      integer icalld
      save    icalld
      data    icalld/0/
      if (icalld.eq.0) then
         icalld=icalld+1
         call set_h1_basis_bilin
      endif
c
c
      n2 = 2
      if (if3d) then
c
         n31 = n2*n2*nelv
         n13 = lx1*lx1
c
         call mxm(h1_basis,lx1,uc,n2,v,n31)
         do ie=1,nelv
            do iz=1,n2
               call mxm(v(1,1,iz,ie),lx1,h1_basist,n2,w(1,1,iz),lx1)
            enddo
            call mxm(w,n13,h1_basist,n2,uf(1,ie),lx1)
         enddo
c
      else
c
         n31 = 2*nelv
         call mxm(h1_basis,lx1,uc,n2,v,n31)
         do ie=1,nelv
            call mxm(v(1,1,1,ie),lx1,h1_basist,n2,uf(1,ie),lx1)
         enddo
      endif
      return
      end
c
c-----------------------------------------------------------------------
c
      subroutine map_f_to_c_h1_bilin(uc,uf)
c
c     TRANSPOSE of H1 Iterpolation operator:                    T
c                                 (linear --> spectral GLL mesh)
c
      include 'SIZE'
      include 'DOMAIN'
      include 'INPUT'
c
      parameter (lxyz = lx1*ly1*lz1)
      real uc(lcr,lelt),uf(lx1,ly1,lz1,lelt)
      common /ctmp0/ w(2,2,lx1),v(2,ly1,lz1,lelt)
c
      integer icalld
      save    icalld
      data    icalld/0/
      if (icalld.eq.0) then
         icalld=icalld+1
         call set_h1_basis_bilin
      endif
c
      n2 = 2
      if (if3d) then
         n31 = ly1*lz1*nelv
         n13 = n2*n2
         call mxm(h1_basist,n2,uf,lx1,v,n31)
         do ie=1,nelv
            do iz=1,lz1
               call mxm(v(1,1,iz,ie),n2,h1_basis,lx1,w(1,1,iz),n2)
            enddo
            call mxm(w,n13,h1_basis,lx1,uc(1,ie),n2)
         enddo
      else
         n31 = ly1*nelv
         call mxm(h1_basist,n2,uf,lx1,v,n31)
         do ie=1,nelv
               call mxm(v(1,1,1,ie),n2,h1_basis,lx1,uc(1,ie),n2)
         enddo
      endif
 
      return
      end
c-----------------------------------------------------------------------
      subroutine get_local_crs_galerkin(a,ncl,nxc,h1,h2,w1,w2)

c     This routine generates Nelv submatrices of order ncl using
c     Galerkin projection

      include 'SIZE'

      real    a(ncl,ncl,1),h1(1),h2(1)
      real    w1(lx1*ly1*lz1,nelv),w2(lx1*ly1*lz1,nelv)

      parameter (lcrd=lx1**ldim)
      common /ctmp1z/ b(lcrd,8)

      integer e

      do j=1,ncl
         call gen_crs_basis(b(1,j),j) ! bi- or tri-linear interpolant
      enddo

      isd  = 1
      imsh = 1

      nxyz = lx1*ly1*lz1
      do j = 1,ncl
         do e = 1,nelv
            call copy(w1(1,e),b(1,j),nxyz)
         enddo

         call axhelm (w2,w1,h1,h2,imsh,isd)        ! A^e * bj

         do e = 1,nelv
         do i = 1,ncl
            a(i,j,e) = vlsc2(b(1,i),w2(1,e),nxyz)  ! bi^T * A^e * bj
         enddo
         enddo

      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine gen_crs_basis(b,j) ! bi- tri-linear

      include 'SIZE'
      real b(lx1,ly1,lz1)

      real z0(lx1),z1(lx1)
      real zr(lx1),zs(lx1),zt(lx1)

      integer p,q,r

      call zwgll(zr,zs,lx1)

      do i=1,lx1
         z0(i) = .5*(1-zr(i))  ! 1-->0
         z1(i) = .5*(1+zr(i))  ! 0-->1
      enddo

      call copy(zr,z0,lx1)
      call copy(zs,z0,lx1)
      call copy(zt,z0,lx1)

      if (mod(j,2).eq.0)                        call copy(zr,z1,lx1)
      if (j.eq.3.or.j.eq.4.or.j.eq.7.or.j.eq.8) call copy(zs,z1,lx1)
      if (j.gt.4)                               call copy(zt,z1,lx1)

      if (ldim.eq.3) then
         do r=1,lx1
         do q=1,lx1
         do p=1,lx1
            b(p,q,r) = zr(p)*zs(q)*zt(r)
         enddo
         enddo
         enddo
      else
         do q=1,lx1
         do p=1,lx1
            b(p,q,1) = zr(p)*zs(q)
         enddo
         enddo
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine gen_crs_basis2(b,j) ! bi- tri-quadratic

      include 'SIZE'
      real b(lx1,ly1,lz1)

      real z0(lx1),z1(lx1),z2(lx1)
      real zr(lx1),zs(lx1),zt(lx1)

      integer p,q,r

      call zwgll(zr,zs,lx1)

      do i=1,lx1
         z0(i) = .5*(zr(i)-1)*zr(i)  ! 1-->0   ! Lagrangian, ordered
         z1(i) = 4.*(1+zr(i))*(1-zr(i))        ! lexicographically
         z2(i) = .5*(zr(i)+1)*zr(i)  ! 0-->1   !
      enddo

      call copy(zr,z0,lx1)
      call copy(zs,z0,lx1)
      call copy(zt,z0,lx1)

      if (mod(j,2).eq.0)                        call copy(zr,z1,lx1)
      if (j.eq.3.or.j.eq.4.or.j.eq.7.or.j.eq.8) call copy(zs,z1,lx1)
      if (j.gt.4)                               call copy(zt,z1,lx1)

      if (ldim.eq.3) then
         do r=1,lx1
         do q=1,lx1
         do p=1,lx1
            b(p,q,r) = zr(p)*zs(q)*zt(r)
         enddo
         enddo
         enddo
      else
         do q=1,lx1
         do p=1,lx1
            b(p,q,1) = zr(p)*zs(q)
         enddo
         enddo
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine get_vertex
      include 'SIZE'
      include 'TOTAL'

      common /ivrtx/ vertex ((2**ldim)*lelt)
      integer vertex

      call get_vert

      return
      end
c-----------------------------------------------------------------------
c-----------------------------------------------------------------------
      subroutine irank_vecn(ind,nn,a,m,n,key,nkey,aa)
c
c     Compute rank of each unique entry a(1,i) 
c
c     Output:   ind(i)  i=1,...,n    (global) rank of entry a(*,i)
c               nn  = max(rank)
c               a(j,i) is permuted
c
c     Input:    a(j,i) j=1,...,m;  i=1,...,n  
c               m      :   leading dim. of v  (ldv must be .ge. m)
c               key    :   sort key
c               nkey   :   
c
c     Although not mandatory, this ranking procedure is probably
c     most effectively employed when the keys are pre-sorted. Thus,
c     the option is provided to sort vi() prior to the ranking.
c
c
      integer ind(n),a(m,n)
      integer key(nkey),aa(m)
      logical iftuple_ianeb,a_ne_b

      nk = min(nkey,m)
      call ituple_sort(a,m,n,key,nk,ind,aa)

c     Find unique a's
      call icopy(aa,a,m)
      nn     = 1
      ind(1) = nn
c
      do i=2,n
         a_ne_b = iftuple_ianeb(aa,a(1,i),key,nk)
         if (a_ne_b) then
            call icopy(aa,a(1,i),m)
            nn = nn+1
         endif
         ind(i) = nn ! set ind() to rank
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine gbtuple_rank(tuple,m,n,nmax,cr_h,nid,np,ind)
c
c     Return a unique rank for each matched tuple set. Global.  Balanced.
c
c     tuple is destroyed.
c
c     By "balanced" we mean that none of the tuple entries is likely to
c     be much more uniquely populated than any other, so that any of
c     the tuples can serve as an initial (parallel) sort key
c
c     First two slots in tuple(:,i) assumed empty
c
      integer ind(nmax),tuple(m,nmax),cr_h

      parameter (mmax=40)
      integer key(mmax),wtuple(mmax)

      if (m.gt.mmax) then
         write(6,*) nid,m,mmax,' gbtuple_rank fail'
         call exitt
      endif

      do i=1,n
         tuple(1,i) = mod(tuple(3,i),np) ! destination processor
         tuple(2,i) = i                  ! return location
      enddo

      ni= n
      ky=1  ! Assumes crystal_new already called
      call fgslib_crystal_ituple_transfer(cr_h, tuple,m,ni,nmax, ky)

      nimx = iglmax(ni,1)
      if (ni.gt.nmax)   write(6,*) ni,nmax,n,'cr_xfer problem, A'
      if (nimx.gt.nmax) call exitt

      nkey = m-2
      do k=1,nkey
         key(k) = k+2
      enddo

      call irank_vecn(ind,nu,tuple,m,ni,key,nkey,wtuple)! tuple re-ordered,
                                                        ! but contents same

      nu_tot   = igl_running_sum(nu) ! running sum over P processors
      nu_prior = nu_tot - nu

      do i=1,ni
         tuple(3,i) = ind(i) + nu_prior  ! global ranking
      enddo

      call fgslib_crystal_ituple_transfer(cr_h, tuple,m,ni,nmax, ky)

      nk = 1  ! restore to original order, local rank: 2; global: 3
      ky = 2
      call ituple_sort(tuple,m,n,ky,nk,ind,wtuple)


      return
      end
c-----------------------------------------------------------------------
      subroutine setvert3d(glo_num,ngv,nx,nel,vertex,ifcenter)
c
c     setup unique ids for dssum  
c     note:
c     total number of unique vertices, edges and faces has to be smaller 
c     than 2**31 (integer-4 limit).
c     if nelgt < 2**31/12 we're ok for sure (independent of N)! 
c
      include 'SIZE'
      include 'CTIMER'
      include 'PARALLEL'
      include 'TOPOL'
      include 'GEOM'

      integer*8 glo_num(1),ngv
      integer vertex(0:1,0:1,0:1,1),nx
      logical ifcenter

      integer  edge(0:1,0:1,0:1,3,lelt),enum(12,lelt),fnum(6,lelt)
      common  /scrmg/ edge,enum,fnum

      parameter (nsafe=8)  ! OFTEN, nsafe=2 suffices
      integer etuple(4,12*lelt*nsafe),ftuple(5,6,lelt*nsafe)
      integer ind(12*lelt*nsafe)
      common  /scrns/ ind,etuple
      equivalence  (etuple,ftuple)

      integer gvf(4),facet(4),aa(3),key(3),e
      logical ifij
      
      integer*8 igv,ig0
      integer*8 ngvv,ngve,ngvs,ngvi,ngvm
      integer*8 n_on_edge,n_on_face,n_in_interior
      integer*8 i8glmax
c
      ny   = nx
      nz   = nx
      nxyz = nx*ny*nz
c
      key(1)=1
      key(2)=2
      key(3)=3
c
c     Assign hypercube ordering of vertices
c     -------------------------------------
c
c     Count number of unique vertices
      nlv  = 2**ldim
      ngvv = iglmax(vertex,nlv*nel)
c
      do e=1,nel
         do k=0,1
         do j=0,1
         do i=0,1
c           Local to global node number (vertex)
            il  = 1 + (nx-1)*i + nx*(nx-1)*j + nx*nx*(nx-1)*k
            ile = il + nx*ny*nz*(e-1)
            glo_num(ile)   = vertex(i,j,k,e)
         enddo
         enddo
         enddo
      enddo
      ngv  = ngvv
c
      if (nx.eq.2) return
c
c     Assign global vertex numbers to SEM nodes on each edge
c     ------------------------------------------------------
c
c     Assign edge labels by bounding vertices.  
      do e=1,nel
         do k=0,1
         do j=0,1
         do i=0,1
            edge(i,j,k,1,e) = vertex(i,j,k,e)  ! r-edge
            edge(j,i,k,2,e) = vertex(i,j,k,e)  ! s-edge
            edge(k,i,j,3,e) = vertex(i,j,k,e)  ! t-edge
         enddo
         enddo
         enddo
      enddo
c
c     Sort edges by bounding vertices.
      do i=0,12*nel-1
         if (edge(0,i,0,1,1).gt.edge(1,i,0,1,1)) then
            kswap = edge(0,i,0,1,1)
            edge(0,i,0,1,1) = edge(1,i,0,1,1)
            edge(1,i,0,1,1) = kswap
         endif
         etuple(3,i+1) = edge(0,i,0,1,1)
         etuple(4,i+1) = edge(1,i,0,1,1)
      enddo
c
c     Assign a number (rank) to each unique edge
      m    = 4
      n    = 12*nel
      nmax = 12*lelt*nsafe  ! nsafe for crystal router factor of safety
      call gbtuple_rank(etuple,m,n,nmax,cr_h,nid,np,ind)
      do i=1,12*nel
         enum(i,1) = etuple(3,i)
      enddo
      n_unique_edges = iglmax(enum,12*nel)
c
      n_on_edge = nx-2
      ngve      = n_unique_edges*n_on_edge
      do e=1,nel
         iedg_loc = 0
c
c        Edges 1-4
         do k=0,1
         do j=0,1
            igv = ngv + n_on_edge*(enum(iedg_loc+1,e)-1)
            i0  = nx*(nx-1)*j + nx*nx*(nx-1)*k
            i0e = i0 + nxyz*(e-1)
            if (glo_num(i0e+1).lt.glo_num(i0e+nx)) then
               do i=2,nx-1                                   ! std forward case
                  glo_num(i0e+i) = igv + i-1
               enddo
            else
               do i=2,nx-1                                   ! backward case
                  glo_num(i0e+i) = igv + 1 + n_on_edge-(i-1)
               enddo
            endif
            iedg_loc = iedg_loc + 1
         enddo
         enddo
c
c        Edges 5-8
         do k=0,1
         do i=0,1
            igv = ngv + n_on_edge*(enum(iedg_loc+1,e)-1)
            i0  = 1+(nx-1)*i + nx*nx*(nx-1)*k
            i0e = i0 + nxyz*(e-1)
            if (glo_num(i0e).lt.glo_num(i0e+nx*(nx-1))) then
               do j=2,nx-1                                   ! std forward case
                  glo_num(i0e+(j-1)*nx) = igv + j-1
               enddo
            else
               do j=2,nx-1                                   ! backward case
                  glo_num(i0e+(j-1)*nx) = igv + 1 + n_on_edge-(j-1)
               enddo
            endif
            iedg_loc = iedg_loc + 1
         enddo
         enddo
c
c        Edges 9-12
         do j=0,1
         do i=0,1
            igv = ngv + n_on_edge*(enum(iedg_loc+1,e)-1)
            i0  = 1 + (nx-1)*i + nx*(nx-1)*j
            i0e = i0 + nxyz*(e-1)
            if (glo_num(i0e).lt.glo_num(i0e+nx*nx*(nx-1))) then
               do k=2,nx-1                                   ! std forward case
                  glo_num(i0e+(k-1)*nx*nx) = igv + k-1
               enddo
            else
               do k=2,nx-1                                   ! backward case
                  glo_num(i0e+(k-1)*nx*nx) = igv + 1 + n_on_edge-(k-1)
               enddo
            endif
            iedg_loc = iedg_loc + 1
         enddo
         enddo
      enddo
      ngv   = ngv + ngve
c
c     Asign global node numbers on the interior of each face
c     ------------------------------------------------------ 
c
c     Assign faces by 3-tuples 
c
c     (The following variables all take the symmetric 
c     notation of IFACE as arguments:)
c
c     ICFACE(i,IFACE) -   Gives the 4 vertices which reside on face IFACE
c                         as depicted below, e.g. ICFACE(i,2)=2,4,6,8.
c
c                        3+-----+4    ^ Y
c                        /  2  /|     |
c     Edge 1 extends    /     / |     |
c       from vertex   7+-----+8 +2    +----> X
c       1 to 2.        |  4  | /     /
c                      |     |/     /
c                     5+-----+6    Z
c                         3
c
      nfaces=ldim*2
      ncrnr =2**(ldim-1)
      do e=1,nel
         do ifac=1,nfaces
            do icrn=1,ncrnr
               i                  = icface(icrn,ifac)-1
               facet(icrn)        = vertex(i,0,0,e)
            enddo
            call isort(facet,ind,ncrnr)
            call icopy(ftuple(3,ifac,e),facet,ncrnr-1)
         enddo
      enddo

c     Assign a number (rank) to each unique face
      m    = 5
      n    = 6*nel
      nmax = 6*lelt*nsafe  ! nsafe for crystal router factor of safety
      call gbtuple_rank(ftuple,m,n,nmax,cr_h,nid,np,ind)
      do i=1,6*nel
         fnum(i,1) = ftuple(3,i,1)
      enddo
      n_unique_faces = iglmax(fnum,6*nel)
c
      call dsset (nx,ny,nz)
      do e=1,nel
       do iface=1,nfaces
         i0 = skpdat(1,iface)
         i1 = skpdat(2,iface)
         is = skpdat(3,iface)
         j0 = skpdat(4,iface)
         j1 = skpdat(5,iface)
         js = skpdat(6,iface)
c
c        On each face, count from minimum global vertex number,
c        towards smallest adjacent vertex number.  e.g., suppose
c        the face is defined by the following global vertex numbers:
c
c
c                    11+--------+81
c                      |c      d|
c                      |        |
c                      |        |
c                      |a      b|
c                    15+--------+62
c                          
c        We would count from c-->a, then towards d.
c
         gvf(1) = glo_num(i0+nx*(j0-1)+nxyz*(e-1))
         gvf(2) = glo_num(i1+nx*(j0-1)+nxyz*(e-1))
         gvf(3) = glo_num(i0+nx*(j1-1)+nxyz*(e-1))
         gvf(4) = glo_num(i1+nx*(j1-1)+nxyz*(e-1))
c
         call irank(gvf,ind,4)
c
c        ind(1) tells which element of gvf() is smallest.
c
         ifij = .false.
         if (ind(1).eq.1) then
            idir =  1
            jdir =  1
            if (gvf(2).lt.gvf(3)) ifij = .true.
         elseif (ind(1).eq.2) then
            idir = -1
            jdir =  1
            if (gvf(1).lt.gvf(4)) ifij = .true.
         elseif (ind(1).eq.3) then
            idir =  1
            jdir = -1
            if (gvf(4).lt.gvf(1)) ifij = .true.
         elseif (ind(1).eq.4) then
            idir = -1
            jdir = -1
            if (gvf(3).lt.gvf(2)) ifij = .true.
         endif
c
         if (idir.lt.0) then
            it=i0
            i0=i1
            i1=it
            is=-is
         endif
c
         if (jdir.lt.0) then
            jt=j0
            j0=j1
            j1=jt
            js=-js
         endif
c
         nxx = nx*nx
         n_on_face = (nx-2)*(ny-2)
         ngvs  = n_unique_faces*n_on_face
         ig0 = ngv + n_on_face*(fnum(iface,e)-1)
         if (ifij) then
            k=0
            l=0
            do j=j0,j1,js
            do i=i0,i1,is
               k=k+1
c              this is a serious kludge to stay on the face interior
               if (k.gt.nx.and.k.lt.nxx-nx .and.
     $            mod(k,nx).ne.1.and.mod(k,nx).ne.0) then
c                 interior
                  l = l+1
                  glo_num(i+nx*(j-1)+nxyz*(e-1)) = l + ig0
               endif
            enddo
            enddo
         else
            k=0
            l=0
            do i=i0,i1,is
            do j=j0,j1,js
               k=k+1
c              this is a serious kludge to stay on the face interior
               if (k.gt.nx.and.k.lt.nxx-nx .and.
     $            mod(k,nx).ne.1.and.mod(k,nx).ne.0) then
c                 interior
                  l = l+1
                  glo_num(i+nx*(j-1)+nxyz*(e-1)) = l + ig0
               endif
            enddo
            enddo
         endif
       enddo
      enddo
      ngv   = ngv + ngvs
c
c     Finally,  number interiors (only ifcenter=.true.)
c     -------------------------------------------------
c
      n_in_interior = (nx-2)*(ny-2)*(nz-2)
      ngvi = n_in_interior*nelgt
      if (ifcenter) then
         do e=1,nel
            ig0 = ngv + n_in_interior*(lglel(e)-1)
            l = 0
            do k=2,nz-1
            do j=2,ny-1
            do i=2,nx-1
               l = l+1
               glo_num(i+nx*(j-1)+nx*ny*(k-1)+nxyz*(e-1)) = ig0+l
            enddo
            enddo
            enddo
         enddo
         ngv = ngv + ngvi
      else
         do e=1,nel
            l = 0
            do k=2,nz-1
            do j=2,ny-1
            do i=2,nx-1
               l = l+1
               glo_num(i+nx*(j-1)+nx*ny*(k-1)+nxyz*(e-1)) = 0
            enddo
            enddo
            enddo
         enddo
      endif
c
c     Quick check on maximum #dofs:
      m    = nxyz*nelt
      ngvm = i8glmax(glo_num,m)
      ngvv = ngvv + ngve + ngvs  ! number of unique ids w/o interior 
      ngvi = ngvi + ngvv         ! total number of unique ids 
      if (nio.eq.0) write(6,1) nx,ngvv,ngvi,ngv,ngvm
    1 format('   setvert3d:',i4,4i12)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine setvert2d(glo_num,ngv,nx,nel,vertex,ifcenter)
c
c     setup unique ids for dssum  
c
      include 'SIZE'
      include 'CTIMER'
      include 'PARALLEL'
      include 'TOPOL'
      include 'GEOM'

      integer*8 glo_num(1),ngv
      integer vertex(0:1,0:1,1),nx
      logical ifcenter

      integer  edge(0:1,0:1,2,lelt),enum(4,lelt)
      common  /scrmg/ edge,enum

      parameter (nsafe=8)  ! OFTEN, nsafe=2 suffices
      integer etuple(4,4*lelt*nsafe),ind(4*lelt*nsafe)
      common  /scrns/ ind,etuple

      integer gvf(4),aa(3),key(3),e,eg
      logical ifij

      integer*8 igv,ig0
      integer*8 ngvv,ngve,ngvs,ngvi,ngvm
      integer*8 n_on_edge,n_on_face,n_in_interior
      integer*8 i8glmax
c
c
c     memory check...
c
      ny   = nx
      nz   = 1
      nxyz = nx*ny*nz
c
      key(1)=1
      key(2)=2
      key(3)=3
c
c     Count number of unique vertices
      nlv  = 2**ldim
      ngvv = iglmax(vertex,nlv*nel)
      ngv  = ngvv
c
c     Assign hypercube ordering of vertices.
      do e=1,nel
         do j=0,1
         do i=0,1
c           Local to global node number (vertex)
            il  = 1 + (nx-1)*i + nx*(nx-1)*j
            ile = il + nx*ny*(e-1)
            glo_num(ile)   = vertex(i,j,e)
         enddo
         enddo
      enddo
      if (nx.eq.2) return
c
c     Assign edge labels by bounding vertices.  
      do e=1,nel
         do j=0,1
         do i=0,1
            edge(i,j,1,e) = vertex(i,j,e)  ! r-edge
            edge(j,i,2,e) = vertex(i,j,e)  ! s-edge
         enddo
         enddo
      enddo

c     Sort edges by bounding vertices.
      do i=0,4*nel-1
         if (edge(0,i,1,1).gt.edge(1,i,1,1)) then
            kswap = edge(0,i,1,1)
            edge(0,i,1,1) = edge(1,i,1,1)
            edge(1,i,1,1) = kswap
         endif
         etuple(3,i+1) = edge(0,i,1,1)
         etuple(4,i+1) = edge(1,i,1,1)
      enddo

c     Assign a number (rank) to each unique edge
      m    = 4
      n    = 4*nel
      nmax = 4*lelt*nsafe  ! nsafe for crystal router factor of safety

      call gbtuple_rank(etuple,m,n,nmax,cr_h,nid,np,ind)
      do i=1,4*nel
         enum(i,1) = etuple(3,i)
      enddo
      n_unique_edges = iglmax(enum,4*nel)

c= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
c     Assign global vertex numbers to SEM nodes on each edge
      n_on_edge = nx-2
      do e=1,nel

         iedg_loc = 0

c        Edges 1-2
         do j=0,1
            igv = ngv + n_on_edge*(enum(iedg_loc+1,e)-1)
            i0  = nx*(nx-1)*j
            i0e = i0 + nxyz*(e-1)
            if (glo_num(i0e+1).lt.glo_num(i0e+nx)) then
               do i=2,nx-1                                   ! std forward case
                  glo_num(i0e+i) = igv + i-1
               enddo
            else
               do i=2,nx-1                                   ! backward case
                  glo_num(i0e+i) = igv + 1 + n_on_edge-(i-1)
               enddo
            endif
            iedg_loc = iedg_loc + 1
         enddo
c
c        Edges 3-4
         do i=0,1
            igv = ngv + n_on_edge*(enum(iedg_loc+1,e)-1)
            i0  = 1+(nx-1)*i
            i0e = i0 + nxyz*(e-1)
            if (glo_num(i0e).lt.glo_num(i0e+nx*(nx-1))) then
               do j=2,nx-1                                   ! std forward case
                  glo_num(i0e+(j-1)*nx) = igv + j-1
               enddo
            else
               do j=2,nx-1                                   ! backward case
                  glo_num(i0e+(j-1)*nx) = igv + 1 + n_on_edge-(j-1)
               enddo
            endif
            iedg_loc = iedg_loc + 1
         enddo
      enddo
 
      ngve = n_unique_edges*n_on_edge
      ngv  = ngv + ngve    
c
c     Finally,  number interiors  
c
      n_in_interior = (nx-2)*(ny-2)
      ngvi          = n_in_interior*nelgt
      if (ifcenter) then
         do e=1,nel
            ig0 = ngv + n_in_interior*(lglel(e)-1)
            l = 0
            do j=2,ny-1
            do i=2,nx-1
               l = l+1
               glo_num(i+nx*(j-1)+nxyz*(e-1)) = ig0+l
            enddo
            enddo
         enddo
         ngv = ngv + ngvi
      else
         do e=1,nel
            l = 0
            do j=2,ny-1
            do i=2,nx-1
               l = l+1
               glo_num(i+nx*(j-1)+nxyz*(e-1)) = 0
            enddo
            enddo
         enddo
      endif

c
c     Quick check on maximum #dofs:
      m    = nxyz*nelt
      ngvm = i8glmax(glo_num,m)
      ngvv = ngvv + ngve         ! number of unique ids w/o interior 
      ngvi = ngvi + ngvv         ! total number of unique ids 
      if (nio.eq.0) write(6,1) nx,ngvv,ngvi,ngv,ngvm
    1 format('   setvert2d:',i4,4i12)
c
      return
      end
c-----------------------------------------------------------------------
c
      subroutine map_to_crs(a,na,b,nb,if3d,w,ldw)
c
c     Input:   b
c     Output:  a
c
      real a(1),b(1),w(1)
      logical if3d
c
      parameter(lx=40)
      real za(lx),zb(lx)
c
      real iba(lx*lx),ibat(lx*lx)
      save iba,ibat
c
      integer nao,nbo
      save    nao,nbo
      data    nao,nbo  / -9, -9/
c
      if (na.gt.lx.or.nb.gt.lx) then
         write(6,*)'ERROR: increase lx in map_to_crs to max:',na,nb
         call exitt
      endif
c
      if (na.ne.nao  .or.   nb.ne.nbo) then
         nao = na
         nbo = nb
         call zwgll(za,w,na)
         call zwgll(zb,w,nb)
         call igllm(iba,ibat,zb,za,nb,na,nb,na)
      endif
c
      call specmpn(a,na,b,nb,iba,ibat,if3d,w,ldw)

      return
      end
c-----------------------------------------------------------------------
      subroutine check_p_bc(glo_num,nx,ny,nz,nel)

      include 'SIZE'
      include 'TOTAL'

      integer*8 glo_num(nx,ny,nz,nel)
      integer*8 gmn

      integer e,f,fo,ef,efo
      integer eface0(6)
      save    eface0
      data    eface0 / 4,2,1,3,5,6 /

      ifld = 2
      if (ifflow) ifld = 1

      nface=2*ldim
      do e=1,nelt
      do f=1,nface,2
         fo  = f+1
         ef  = eface0(f)
         efo = eface0(fo)
         if (cbc(ef,e,ifld).eq.'p  '.and.cbc(efo,e,ifld).eq.'p  ') then
            if (f.eq.1) then  ! r=-/+1
               do k=1,nz
               do j=1,ny
                  gmn = min(glo_num(1,j,k,e),glo_num(nx,j,k,e))
                  glo_num(1 ,j,k,e) = gmn
                  glo_num(nx,j,k,e) = gmn
               enddo
               enddo
            elseif (f.eq.3) then  ! s=-/+1
               do k=1,nz
               do i=1,nx
                  gmn = min(glo_num(i,1,k,e),glo_num(i,ny,k,e))
                  glo_num(i,1 ,k,e) = gmn
                  glo_num(i,ny,k,e) = gmn
               enddo
               enddo
            else
               do j=1,ny
               do i=1,nx
                  gmn = min(glo_num(i,j,1,e),glo_num(i,j,nz,e))
                  glo_num(i,j,1 ,e) = gmn
                  glo_num(i,j,nz,e) = gmn
               enddo
               enddo
            endif
         endif
      enddo
      enddo

      return
      end
c-----------------------------------------------------------------------

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!* This is a program based on a test contributed by Yizi Gu@Rice Univ.
! * Classic Fibonacci calculation using task but missing taskwait.
! * Data races pairs: i@29:13 vs i@34:17
! *                   j@32:13 vs j@34:19

!check on the unsgined part

module DRB106
    implicit none
    integer (kind=4) input

contains
    recursive function fib(n) result(r)
        use omp_lib
        implicit none
        integer (kind=4) :: n, i, j, r

        if (n<2) then
            r = n
        else
            !$omp task shared(i)
            i = fib(n-1)
            !$omp end task
            !$omp task shared(j)
            j = fib(n-2)
            !$omp end task
            r = i+j
        end if
        !$omp taskwait
    end function
end module

program DRB106_taskwaitmissing_orig_yes
    use omp_lib
    use DRB106
    implicit none

    integer :: result
    input = 30

    !$omp parallel
    !$omp single
    result = fib(input)
    !$omp end single
    !$omp end parallel

    print*,'Fib for ',input,' =',result

end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!A loop with loop-carried anti-dependence.
!Data race pair: a[i+1]@36:9 vs. a[i]@36:16

!!- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -!!
!! NOTE by WenhaoWu (wuwenhao@udel.edu)                                  !!
!! This example is modified so that the bound can be adjusted            !!
!! by defining 'N' and if it is not defined then the bound value         !!
!! in the original example is used as the default value of 'N'           !!
!!- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -	- -	-!!

#ifndef N
#define N 10
#endif 

program DRB001_antidep1_orig_yes
use omp_lib
    implicit none
    integer :: i, len
    integer :: a(N)

    len = N

    do i = 1, len
        a(i) = i
    end do

    !$omp parallel do
    do i = 1, len-1
        a(i) = a(i+1) + 1
    end do
    !$omp end parallel do

    100 format ('a(N/2)=',i3)
    print 100, a(N/2)
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!use of omp target + teams + distribute + parallel for. No data race pairs.

program DRB097_target_teams_distribute_orig_no
    use omp_lib
    use ISO_C_Binding
    implicit none
    integer, parameter :: dp = kind(1.0d0)
    integer, parameter :: double_kind = c_double
    integer (kind=8) :: i, i2, len, l_limit, tmp
    real(dp) :: sum, sum2
    real(dp), dimension(:), allocatable :: a, b

    len = 2560
    sum = real(0.0,dp)
    sum2 = real(0.0,dp)

    allocate (a(len))
    allocate (b(len))

    do i = 1, len
        a(i) = real(i,dp)/real(2.0,dp)
        b(i) = real(i,dp)/real(3.0,dp)
    end do

    !$omp target map(to: a(0:len), b(0:len)) map(tofrom: sum)
    !$omp teams num_teams(10) thread_limit(256) reduction (+:sum)
    !$omp distribute
        do i2 = 1, len, 256
            !$omp parallel do reduction (+:sum)
            do i = i2+1, merge(i2+256,len,i2+256<len)
                sum = sum+a(i)*b(i)
            end do
            !$omp end parallel do
        end do
    !$omp end distribute
    !$omp end teams
    !$omp end target

    !$omp parallel do reduction (+:sum2)
    do i = 1, len
        sum2 = sum2+a(i)*b(i)
    end do
    !$omp end parallel do

    print*,'sum =',int(sum),'; sum2 =',int(sum2)

    deallocate(a,b)
end program

C> @file diffusive_cmt.f routines for diffusive fluxes.
C> Some surface. Some volume. All pain. Jacobians and other factorizations.

C> \ingroup vsurf
C> @{
C> ummcu = \f$\mathbf{U}^--\{\{\mathbf{U}\}\}\f$
      subroutine imqqtu(ummcu,uminus,uplus)
! Computes (I-0.5*QQT)U for all five conserved variables.
! See call in compute_rhs_and_dt for important documentation
!                                     -
! Spoiler: for SEM this comes out to U -{{U}}, which when
!          spoken is "UMinus Minus the Central flux of U" which I
!          then abbreviate as ummcu
      include 'SIZE'

      real ummcu (lx1*lz1*2*ldim*nelt,toteq) ! intent(out)
      real uminus(lx1*lz1*2*ldim*nelt,toteq) ! intent(in)
      real uplus (lx1*lz1*2*ldim*nelt,toteq) ! intent(in)
      integer ivar

      nf = lx1*lz1*2*ldim*nelt
      const=-0.5

! U-{{U}} on interior faces. first just do it on all faces.
      do ivar=1,toteq
         call add3(ummcu(1,ivar),uminus(1,ivar),uplus(1,ivar),nf)
         call cmult(ummcu(1,ivar),const,nf)        !         -
         call add2(ummcu(1,ivar),uminus(1,ivar),nf)!ummcu = U -{{U}}
      enddo

C> @}
      return
      end

!-----------------------------------------------------------------------

C> \ingroup bcond
C> @{
C> umubc = \f$\mathbf{U}^--\mathbf{U}^D\f$
      subroutine imqqtu_dirichlet(umubc,wminus,wplus)
! v+ undefined on boundary faces, so (I-0.5QQ^T) degenerates to 
! [[U]] with respect to the Dirichlet boundary state
      include 'SIZE'
      include 'INPUT' ! do we need this?
      include 'TSTEP' ! for ifield
      include 'CMTDATA'
      real umubc (lx1*lz1,2*ldim,nelt,toteq) ! intent(out)
      real wminus(lx1*lz1,2*ldim,nelt,nqq),
     >     wplus (lx1*lz1,2*ldim,nelt,nqq)
      real nTol
      integer e,f
      character*132 deathmessage
      common /nekcb/ cb
      character*3 cb

      nTol = 1.0E-14

      nxz = lx1*lz1
      nface=2*ldim
      ifield= 1 ! You need to figure out the best way of dealing with
                ! this variable

      do e=1,nelt
      do f=1,nface

         cb=cbc(f,e,ifield)
         if (cb.ne.'E  '.and.cb.ne.'P  ') then ! cbc bndy. this routine
                                               ! had better not touch any
                                               ! interior face
! JH031315 flux added to argument list. BC routines preserve wminus for
!          obvious reasons and fill wplus with good stuff for everybody:
!          imposed states for Dirichlet conditions, and important things
!          for viscous numerical fluxes.
! JH060215 added SYM bc. Just use it as a slip wall hopefully.
! JH111416 This may look like lazy duplication, but there is a good chance
!          that this may replace/consolidate BC calls in InviscidFlus.
!          basically, nothing in wplus is trustworthy, so we are going to
!          recompute and overwrite iu1 through iu5 in wplus with stuff we
!          do trust (UBC, to be exact).
!           if (cb.eq.'v  ' .or. cb .eq. 'V  ') then
!             call inflow2(nqq,f,e,wminus,wplus)
            if (cb .eq. 'W  ' .or. cb .eq.'I  ')then
              call wallbc2(nqq,f,e,wminus,wplus)
            endif

!  -
! U - UBC
            do ivar=1,toteq
               call sub3(umubc(1,f,e,ivar),wminus(1,f,e,iu1+ivar-1),
     >                                      wplus(1,f,e,iu1+ivar-1),nxz)
            enddo

         endif 
      enddo
      enddo

C> @}
      return
      end

!-----------------------------------------------------------------------

C> \ingroup vfjac
C> @{
C> flux = \f$\mathscr{A}\f$ dU = \f$\left(\mathscr{A}^{\mbox{NS}}+\mathscr{A}^{\mbox{EVM}}\right) \f$dU 
      subroutine agradu(flux,du,e,eq)
      include 'SIZE'
      include 'CMTDATA'
!JH122716 Apply viscous flux jacobian \mathscr{A} to a notional gradient
!         of the unknowns U (gradU in viscous_cmt and iku, U-{{U}} and
!         U-U_D in igtu_cmt, [U] in ihu (CHECK LI'S NOTES AGAIN))
! Yes, I know theoretically that EVM and NSE have different diffusive
! fluxes for different physical reasons. But I am combining them because
! 1. s_{ij} is shared by both and cuts down on code redundancy
! 2. we may wish to run EVM AND NSE together (I know this is frowned upon)

! but let's consider the normal use case of either NSE OR EVM
! Compressible Navier-Stokes      |
! mu=mu(T)                        |
! lambda=-2/3mu                   |
! nu_s=0                          |
! kappa=kappa(T)                  |  All of this 
!                                 |  should be done in
! Entropy visosity method (EVM)   |  uservp. very error-prone
! mu=mu_s(R_s,|u|+c,h)            |  requires deliberate user attention
! lambda=0 for EVM                |
! nu_s=nu_s(mu_s)                 |
! kappa=0                         |
! I need a flag, ifevm, for controlling calls (entropy_residual
! and longitudinal viscous fluxes, mostly due to grad rho) SOMEDAY
!-----------------------------------------------------------------------
! constructive feedback is always welcome
! flux is zero on entry
!-----------------------------------------------------------------------
      integer e, eq
      real flux(lx1*ly1*lz1,ldim),du(lx1*ly1*lz1,toteq,ldim)

C> \f$\tau_{ij}\f$ and \f$u_j \tau_{ij}\f$.  \f$\lambda=0\f$ and \f$\kappa=0\f$
C> for EVM
      call fluxj_ns (flux,du,e,eq)
C> \f$\nu_s \nabla \rho\f$, \f$\nu_s \left(\nabla \rho \right) \otimes \mathbf{u}\f$
C> and \f$\nu_s \nabla \left(\rho e\right)\f$.  \f$\nu_s=0\f$ for Navier-Stokes
      call fluxj_evm(flux,du,e,eq)

! no idea where phi goes. put it out front
c     call col2(flux,phig(1,1,1,e),lx1*ly1*lz1)

C> @}
      return
      end

!-----------------------------------------------------------------------

C> \f$ \tau_{ij}=2 \mu\sigma_{ij} + \lambda \Delta \delta_{ij}\f$
C> Navier-Stokes, so no mass diffusion. uservp provides properties.
C> Implemented via maxima-generated code
      subroutine fluxj_ns(flux,gradu,e,eq)
! viscous flux jacobian for compressible Navier-Stokes equations (NS)
! SOLN and CMTDATA are indexed, assuming vdiff has been filled by uservp
! somehow. In serious need of debugging and replacement.
      include 'SIZE'
      include 'INPUT'! TRIAGE?
      include 'SOLN' ! TRIAGE?

      parameter (ldd=lx1*ly1*lz1)
      common /ctmp1/ viscscr(lx1,ly1,lz1)
      real viscscr

      integer e,eq
      real flux(lx1*ly1*lz1,ldim),gradu(lx1*ly1*lz1,toteq,ldim)
      integer eijk3(3,3,3)
!     data eijk2 / 0, -1, 1, 0/
      data eijk3
     >/0,0,0,0,0,-1,0,1,0,0,0,1,0,0,0,-1,0,0,0,-1,0,1,0,0,0,0,0/

      n=lx1*ly1*lz1

! This is a disaster that I might want to program less cleverly
      if (eq .lt. toteq) then ! TRIAGE. CAN'T GET AGRADU_NS to WORK
                              ! for ENERGY EQUATION. MAXIMA ROUTINES
                              ! BELOW
!!      do j=1,ldim
!!         do k=1,ldim
!!            ieijk=0
!!!           if (eq .lt. toteq .and. eq .gt. 1) ieijk=eijk3(eq-1,j,k) ! does this work in 2D?
!!            if (eq.gt.1)ieijk=eijk3(eq-1,j,k) ! does this work in 2D?
!!
!!            if (ieijk .eq. 0) then
!!              call agradu_ns(flux(1,j),gradu(1,1,k),viscscr,e,
!!     >                           eq,j,k)
!!            endif
!!         enddo
!!      enddo
! JH110716 Maxima routines added for every viscous flux.
!          agradu_ns has failed all verification checks for homentropic vortex
!          initialization.
!          start over
        if (eq.eq.2) then
           call A21kldUldxk(flux(1,1),gradu,e)
           call A22kldUldxk(flux(1,2),gradu,e)
           call A23kldUldxk(flux(1,3),gradu,e)
        elseif (eq.eq.3) then
           call A31kldUldxk(flux(1,1),gradu,e)
           call A32kldUldxk(flux(1,2),gradu,e)
           call A33kldUldxk(flux(1,3),gradu,e)
        elseif (eq.eq.4) then
           call A41kldUldxk(flux(1,1),gradu,e)
           call A42kldUldxk(flux(1,2),gradu,e)
           call A43kldUldxk(flux(1,3),gradu,e)
        endif

      else ! Energy equation courtesy of thoroughly-checked maxima
           ! until I can get agradu_ns working correctly
         if (if3d) then
            call a53kldUldxk(flux(1,3),gradu,e)
         else
            call rzero(gradu(1,1,3),lx1*ly1*lz1*toteq)
            call rzero(vz(1,1,1,e),lx1*ly1*lz1)
         endif
         call a51kldUldxk(flux(1,1),gradu,e)
         call a52kldUldxk(flux(1,2),gradu,e)
      endif

      return
      end

!-----------------------------------------------------------------------
!     subroutine agradu_ns(gijklu,dut,visco,e,eq,jflux,kdir) ! in junkyard...
!-----------------------------------------------------------------------

C> viscous flux jacobian for entropy viscosity Euler regularization of
C> Guermond and Popov (2014) SIAM JAM 74(2) that do NOT overlap with
C> the compressible Navier-Stokes equations (NS).
      subroutine fluxj_evm(flux,du,e,eq)
! SOLN and CMTDATA are indexed, assuming vdiff has been filled by uservp
! somehow. In serious need of debugging and replacement.
      include 'SIZE'
      include 'PARALLEL'
      include 'INPUT'! TRIAGE?
      include 'SOLN' ! TRIAGE?
      include 'CMTDATA'

      parameter (ldd=lx1*ly1*lz1)
      common /ctmp1/ viscscr(lx1,ly1,lz1) ! I'ma keep this
      real viscscr

      integer e,eq,eq2
      real flux(lx1*ly1*lz1,ldim),du(lx1*ly1*lz1,toteq,ldim)

      n=lx1*ly1*lz1

! diffusion due to grad rho
      if (eq .eq. 1) then
         do j=1,ldim ! flux+= viscscr*nu_s*grad (rho)
            call addcol3(flux(1,j),vdiff(1,1,1,e,inus),du(1,1,j),n)
         enddo
      else
         if (eq.lt.toteq) then
            call copy(viscscr,du(1,1,eq-1),n)
            call col2(viscscr,vdiff(1,1,1,e,inus),n)
            call addcol3(flux(1,1),viscscr,vx(1,1,1,e),n)
            call addcol3(flux(1,2),viscscr,vy(1,1,1,e),n)
            if (if3d) call addcol3(flux(1,3),viscscr,vz(1,1,1,e),n)

         else ! energy equation

            if(if3d) then ! mass diffusion term
               call vdot3(viscscr,vx(1,1,1,e),vy(1,1,1,e),vz(1,1,1,e),
     >                            vx(1,1,1,e),vy(1,1,1,e),vz(1,1,1,e),n)
            else
               call vdot2(viscscr,vx(1,1,1,e),vy(1,1,1,e),
     >                            vx(1,1,1,e),vy(1,1,1,e),n)
            endif
            call col2(viscscr,vdiff(1,1,1,e,inus),n)
            do j=1,ldim
               call addcol3(flux(1,j),du(1,1,j),viscscr,n)
            enddo

            do j=1,ldim
               do eq2=2,ldim+1
                  call col4(viscscr,du(1,eq2,j),u(1,1,1,eq2,e),
     >                           vdiff(1,1,1,e,inus),n)
                  call invcol2(viscscr,vtrans(1,1,1,e,irho),n) ! scr=nu_s*U/rho
                  call sub2(flux(1,j),viscscr,n)
               enddo
               call addcol3(flux(1,j),du(1,toteq,j),vdiff(1,1,1,e,inus),
     >                      n)
            enddo
         endif ! eq<toteq?

      endif ! eq==1?

      return
      end

!-----------------------------------------------------------------------

      subroutine half_iku_cmt(res,diffh,e)
      include 'SIZE'
      include 'MASS'
! diffh has D AgradU. half_iku_cmt applies D^T BM1 to it and increments
! the residual res with the result
      integer e ! lopsided. routine for one element must reference bm1
      real res(lx1,ly1,lz1),diffh(lx1*ly1*lz1,ldim)

      n=lx1*ly1*lz1

      do j=1,ldim
         call col2(diffh(1,j),bm1(1,1,1,e),n)
!        call col2(diffh(1,j),phig(1,1,1,e),n) ! still no idea where phi goes
      enddo

!     const=-1.0 ! I0
      const=1.0  ! *-1 in time march
      call gradm11_t(res,diffh,const,e)

      return
      end

!-----------------------------------------------------------------------

      subroutine compute_transport_props
! get vdiff props
! viscosity in imu
! second viscosity in ilam; second viscosity is usually -2/3mu
! but we refuse to assume Stokes' hypothesis for the user
! second viscosity=0 in the EVM for Euler gas dynamics
! thermal conductivity in iknd;
! mass diffusivity for EVM in inus
! via nekasgn
      include 'SIZE'
      include 'PARALLEL'
      include 'NEKUSE'
      include 'SOLN'
      include 'CMTDATA'

      integer   e

      do e=1,nelt
         ieg=lglel(e)
         do k=1,lz1
         do j=1,ly1
         do i=1,lx1
            call nekasgn(i,j,k,e)
            call cmtasgn(i,j,k,e)
            call uservp(i,j,k,ieg)
            vdiff(i,j,k,e,imu)  = mu   ! NEKUSE
            vdiff(i,j,k,e,ilam) = lambda!NEKUSE
            vdiff(i,j,k,e,iknd) = udiff! NEKUSE
            vdiff(i,j,k,e,inus) = nu_s ! CMTDATA
         enddo
         enddo
         enddo
      enddo

      return
      end

!-----------------------------------------------------------------------
! TRIAGE BELOW UNTIL I CAN FIX AGRADU_NS
!-----------------------------------------------------------------------
      subroutine a51kldUldxk(flux,dU,ie)
      include 'SIZE'
      include 'SOLN'
      include 'CMTDATA' ! gradu lurks
      real K,E,kmcvmu,lambdamu
      real dU(lx1*ly1*lz1,toteq,3)
      real flux(lx1*ly1*lz1)
      npt=lx1*ly1*lz1
      do i=1,npt
         dU1x=dU(i,1,1)
         dU2x=dU(i,2,1)
         dU3x=dU(i,3,1)
         dU4x=dU(i,4,1)
         dU5x=dU(i,5,1)
         dU1y=dU(i,1,2)
         dU2y=dU(i,2,2)
         dU3y=dU(i,3,2)
         dU4y=dU(i,4,2)
         dU5y=dU(i,5,2)
         dU1z=dU(i,1,3)
         dU2z=dU(i,2,3)
         dU3z=dU(i,3,3)
         dU4z=dU(i,4,3)
         dU5z=dU(i,5,3)
         rho   =vtrans(i,1,1,ie,irho)
         cv    =vtrans(i,1,1,ie,icv)/rho
         lambda=vdiff(i,1,1,ie,ilam)
         mu    =vdiff(i,1,1,ie,imu)
         K     =vdiff(i,1,1,ie,iknd)
         u1    =vx(i,1,1,ie)
         u2    =vy(i,1,1,ie)
         u3    =vz(i,1,1,ie)
         E     =U(i,1,1,toteq,ie)/rho
         lambdamu=lambda+mu
         kmcvmu=K-cv*mu
         flux(i)=
     >(K*dU5x+cv*lambda*u1*dU4z-kmcvmu*u3*dU4x+cv*lambda*u1*dU3y
     1   -kmcvmu*u2*dU3x+cv*mu*u3*dU2z+cv*mu*u2*dU2y+(cv*lambda-
     2   K+2*cv*mu)*u1*dU2x-cv*lambdamu*u1*u3*dU1z-cv*lambdamu
     3   *u1*u2*dU1y+(K*u3**2-cv*mu*u3**2+K*u2**2-cv*mu*u2**2-cv*la
     4   mbda*u1**2+K*u1**2-2*cv*mu*u1**2-E*K)*dU1x)/(cv*rho)
      enddo
      return
      end

      subroutine a52kldUldxk(flux,dU,ie)
      include 'SIZE'
      include 'SOLN'
      include 'CMTDATA' ! gradu lurks
      real K,E,kmcvmu,lambdamu
      real dU(lx1*ly1*lz1,toteq,3)
      real flux(lx1*ly1*lz1)
      npt=lx1*ly1*lz1
      do i=1,npt
         dU1x=dU(i,1,1)
         dU2x=dU(i,2,1)
         dU3x=dU(i,3,1)
         dU4x=dU(i,4,1)
         dU5x=dU(i,5,1)
         dU1y=dU(i,1,2)
         dU2y=dU(i,2,2)
         dU3y=dU(i,3,2)
         dU4y=dU(i,4,2)
         dU5y=dU(i,5,2)
         dU1z=dU(i,1,3)
         dU2z=dU(i,2,3)
         dU3z=dU(i,3,3)
         dU4z=dU(i,4,3)
         dU5z=dU(i,5,3)
         rho   =vtrans(i,1,1,ie,irho)
         cv    =vtrans(i,1,1,ie,icv)/rho
         lambda=vdiff(i,1,1,ie,ilam)
         mu    =vdiff(i,1,1,ie,imu)
         K     =vdiff(i,1,1,ie,iknd)
         u1    =vx(i,1,1,ie)
         u2    =vy(i,1,1,ie)
         u3    =vz(i,1,1,ie)
         E     =U(i,1,1,toteq,ie)/rho
         lambdamu=lambda+mu
         kmcvmu=K-cv*mu
         flux(i)=
     >(K*dU5y+cv*lambda*u2*dU4z-kmcvmu*u3*dU4y+cv*mu*u3*dU3z+(cv
     1   *lambda-K+2*cv*mu)*u2*dU3y+cv*mu*u1*dU3x-kmcvmu*u1*dU2y+
     2   cv*lambda*u2*dU2x-cv*lambdamu*u2*u3*dU1z+(K*u3**2-cv*mu
     3   *u3**2-cv*lambda*u2**2+K*u2**2-2*cv*mu*u2**2+K*u1**2-cv*mu*
     4   u1**2-E*K)*dU1y-cv*lambdamu*u1*u2*dU1x)/(cv*rho)
      enddo
      return
      end
      subroutine a53kldUldxk(flux,dU,ie)
      include 'SIZE'
      include 'SOLN'
      include 'CMTDATA' ! gradu lurks
      real K,E,kmcvmu,lambdamu
      real dU(lx1*ly1*lz1,toteq,3)
      real flux(lx1*ly1*lz1)
      npt=lx1*ly1*lz1
      do i=1,npt
         dU1x=dU(i,1,1)
         dU2x=dU(i,2,1)
         dU3x=dU(i,3,1)
         dU4x=dU(i,4,1)
         dU5x=dU(i,5,1)
         dU1y=dU(i,1,2)
         dU2y=dU(i,2,2)
         dU3y=dU(i,3,2)
         dU4y=dU(i,4,2)
         dU5y=dU(i,5,2)
         dU1z=dU(i,1,3)
         dU2z=dU(i,2,3)
         dU3z=dU(i,3,3)
         dU4z=dU(i,4,3)
         dU5z=dU(i,5,3)
         rho   =vtrans(i,1,1,ie,irho)
         cv    =vtrans(i,1,1,ie,icv)/rho
         lambda=vdiff(i,1,1,ie,ilam)
         mu    =vdiff(i,1,1,ie,imu)
         K     =vdiff(i,1,1,ie,iknd)
         u1    =vx(i,1,1,ie)
         u2    =vy(i,1,1,ie)
         u3    =vz(i,1,1,ie)
         E     =U(i,1,1,toteq,ie)/rho
         lambdamu=lambda+mu
         kmcvmu=K-cv*mu
         flux(i)=
     >(K*(dU5z-E*dU1z)+cv*u3*(lambda*dU4z+2*mu*dU4z+lambda*dU3y+lambda
     1   *dU2x)-K*u3*dU4z+cv*mu*u2*(dU4y+dU3z)+cv*mu*u1*(dU4x+dU2z)-
     2   K*u2*dU3z-K*u1*dU2z-cv*(lambda+2*mu)*u3**2*dU1z+K*u3**2*dU1z+
     3   K*u2**2*dU1z-cv*mu*u2**2*dU1z+K*u1**2*dU1z-cv*mu*u1**2*dU1z-c
     4   v*(lambda+mu)*u2*u3*dU1y-cv*(lambda+mu)*u1*u3*dU1x)/(cv*rho)
      enddo
      return
      end

      subroutine A21kldUldxk(flux,dU,ie)
      include 'SIZE'
      include 'SOLN'
      include 'CMTDATA' ! gradu lurks
      real K,E,kmcvmu,lambdamu
      real dU(lx1*ly1*lz1,toteq,3)
      real flux(lx1*ly1*lz1)
      npt=lx1*ly1*lz1
      do i=1,npt
         dU1x=dU(i,1,1)
         dU2x=dU(i,2,1)
         dU1y=dU(i,1,2)
         dU3y=dU(i,3,2)
         dU1z=dU(i,1,3)
         dU4z=dU(i,4,3)
         rho   =vtrans(i,1,1,ie,irho)
         lambda=vdiff(i,1,1,ie,ilam)
         mu    =vdiff(i,1,1,ie,imu)
         u1    =vx(i,1,1,ie)
         u2    =vy(i,1,1,ie)
         u3    =vz(i,1,1,ie)
         lambdamu=lambda+2.0*mu
         flux(i)=
     >(lambda*(dU4z+dU3y-u3*dU1z-u2*dU1y)+lambdamu*(dU2x-u1*dU1x))/rho
      enddo
      return
      end
      subroutine A22kldUldxk(flux,dU,ie)
      include 'SIZE'
      include 'SOLN'
      include 'CMTDATA' ! gradu lurks
      real K,E,kmcvmu,lambdamu
      real dU(lx1*ly1*lz1,toteq,3)
      real flux(lx1*ly1*lz1)
      npt=lx1*ly1*lz1
      do i=1,npt
         dU1x=dU(i,1,1)
         dU3x=dU(i,3,1)
         dU1y=dU(i,1,2)
         dU2y=dU(i,2,2)
         rho   =vtrans(i,1,1,ie,irho)
         mu    =vdiff(i,1,1,ie,imu)
         u1    =vx(i,1,1,ie)
         u2    =vy(i,1,1,ie)
         flux(i)=mu*(dU3x+dU2y-u1*dU1y-u2*dU1x)/rho
      enddo
      return
      end
      subroutine A23kldUldxk(flux,dU,ie)
      include 'SIZE'
      include 'SOLN'
      include 'CMTDATA' ! gradu lurks
      real K,E,kmcvmu,lambdamu
      real dU(lx1*ly1*lz1,toteq,3)
      real flux(lx1*ly1*lz1)
      npt=lx1*ly1*lz1
      do i=1,npt
         dU1x=dU(i,1,1)
         dU4x=dU(i,4,1)
         dU1z=dU(i,1,3)
         dU2z=dU(i,2,3)
         rho   =vtrans(i,1,1,ie,irho)
         mu    =vdiff(i,1,1,ie,imu)
         u1    =vx(i,1,1,ie)
         u3    =vz(i,1,1,ie)
         flux(i)=mu*(dU4x+dU2z-u1*dU1z-u3*dU1x)/rho
      enddo
      return
      end

      subroutine A31kldUldxk(flux,dU,ie)
      include 'SIZE'
      include 'SOLN'
      include 'CMTDATA' ! gradu lurks
      real K,E,kmcvmu,lambdamu
      real dU(lx1*ly1*lz1,toteq,3)
      real flux(lx1*ly1*lz1)
      npt=lx1*ly1*lz1
      do i=1,npt
         dU1x=dU(i,1,1)
         dU3x=dU(i,3,1)
         dU1y=dU(i,1,2)
         dU2y=dU(i,2,2)
         rho   =vtrans(i,1,1,ie,irho)
         mu    =vdiff(i,1,1,ie,imu)
         u1    =vx(i,1,1,ie)
         u2    =vy(i,1,1,ie)
         flux(i)=mu*(dU3x+dU2y-u1*dU1y-u2*dU1x)/rho
      enddo
      return
      end
      subroutine A32kldUldxk(flux,dU,ie)
      include 'SIZE'
      include 'SOLN'
      include 'CMTDATA' ! gradu lurks
      real K,E,kmcvmu,lambdamu
      real dU(lx1*ly1*lz1,toteq,3)
      real flux(lx1*ly1*lz1)
      npt=lx1*ly1*lz1
      do i=1,npt
         dU1x=dU(i,1,1)
         dU2x=dU(i,2,1)
         dU1y=dU(i,1,2)
         dU3y=dU(i,3,2)
         dU1z=dU(i,1,3)
         dU4z=dU(i,4,3)
         rho   =vtrans(i,1,1,ie,irho)
         lambda=vdiff(i,1,1,ie,ilam)
         mu    =vdiff(i,1,1,ie,imu)
         u1    =vx(i,1,1,ie)
         u2    =vy(i,1,1,ie)
         u3    =vz(i,1,1,ie)
         lambdamu=lambda+2.0*mu
         flux(i)=(lambda*(dU4z+dU2x-u3*dU1z-u1*dU1x)+
     >   lambdamu*(dU3y-u2*dU1y))/rho
      enddo
      return
      end
      subroutine A33kldUldxk(flux,dU,ie)
      include 'SIZE'
      include 'SOLN'
      include 'CMTDATA' ! gradu lurks
      real K,E,kmcvmu,lambdamu
      real dU(lx1*ly1*lz1,toteq,3)
      real flux(lx1*ly1*lz1)
      npt=lx1*ly1*lz1
      do i=1,npt
         dU1y=dU(i,1,2)
         dU4y=dU(i,4,2)
         dU1z=dU(i,1,3)
         dU3z=dU(i,3,3)
         rho   =vtrans(i,1,1,ie,irho)
         mu    =vdiff(i,1,1,ie,imu)
         u2    =vy(i,1,1,ie)
         u3    =vz(i,1,1,ie)
         flux(i)=mu*(dU4y+dU3z-u2*dU1z-u3*dU1y)/rho
      enddo
      return
      end

      subroutine A41kldUldxk(flux,dU,ie)
      include 'SIZE'
      include 'SOLN'
      include 'CMTDATA' ! gradu lurks
      real K,E,kmcvmu,lambdamu
      real dU(lx1*ly1*lz1,toteq,3)
      real flux(lx1*ly1*lz1)
      npt=lx1*ly1*lz1
      do i=1,npt
         dU1x=dU(i,1,1)
         dU4x=dU(i,4,1)
         dU1z=dU(i,1,3)
         dU2z=dU(i,2,3)
         rho   =vtrans(i,1,1,ie,irho)
         mu    =vdiff(i,1,1,ie,imu)
         u1    =vx(i,1,1,ie)
         u3    =vz(i,1,1,ie)
         flux(i)=mu*(dU4x+dU2z-u1*dU1z-u3*dU1x)/rho
      enddo
      return
      end
      subroutine A42kldUldxk(flux,dU,ie)
      include 'SIZE'
      include 'SOLN'
      include 'CMTDATA' ! gradu lurks
      real K,E,kmcvmu,lambdamu
      real dU(lx1*ly1*lz1,toteq,3)
      real flux(lx1*ly1*lz1)
      npt=lx1*ly1*lz1
      do i=1,npt
         dU1y=dU(i,1,2)
         dU4y=dU(i,4,2)
         dU1z=dU(i,1,3)
         dU3z=dU(i,3,3)
         rho   =vtrans(i,1,1,ie,irho)
         mu    =vdiff(i,1,1,ie,imu)
         u2    =vy(i,1,1,ie)
         u3    =vz(i,1,1,ie)
         flux(i)=mu*(dU4y+dU3z-u2*dU1z-u3*dU1y)/rho
      enddo
      return
      end
      subroutine A43kldUldxk(flux,dU,ie)
      include 'SIZE'
      include 'SOLN'
      include 'CMTDATA' ! gradu lurks
      real K,E,kmcvmu,lambdamu
      real dU(lx1*ly1*lz1,toteq,3)
      real flux(lx1*ly1*lz1)
      npt=lx1*ly1*lz1
      do i=1,npt
         dU1x=dU(i,1,1)
         dU2x=dU(i,2,1)
         dU1y=dU(i,1,2)
         dU3y=dU(i,3,2)
         dU1z=dU(i,1,3)
         dU4z=dU(i,4,3)
         rho   =vtrans(i,1,1,ie,irho)
         lambda=vdiff(i,1,1,ie,ilam)
         mu    =vdiff(i,1,1,ie,imu)
         u1    =vx(i,1,1,ie)
         u2    =vy(i,1,1,ie)
         u3    =vz(i,1,1,ie)
         lambdamu=lambda+2.0*mu
         flux(i)=(lambda*(dU3y+dU2x-u2*dU1y-u1*dU1x)+
     >lambdamu*(dU4z-u3*dU1z))/rho
      enddo
      return
      end

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Concurrent access on same variable var@23 and var@25 leads to the race condition if two different
!locks are used. This is the reason here we have used the atomic directive to ensure that addition
!and subtraction are not interleaved. No data race pairs.

program DRB147_critical1_orig_gpu_no
    use omp_lib
    implicit none

    integer :: var, i
    var = 0

    !$omp target map(tofrom:var) device(0)
    !$omp teams distribute parallel do
        do i = 0, 100
            !$omp atomic
            var = var+1
            !$omp atomic
            var = var-2
        end do
    !$omp end teams distribute parallel do
    !$omp end target

    print*, var
end program

c=======================================================================
      subroutine hmholtz(name,u,rhs,h1,h2,mask,mult,imsh,tli,maxit,isd)
      include 'SIZE'
      include 'TOTAL'
      include 'FDMH1'
      include 'CTIMER'

      CHARACTER      NAME*4
      REAL           U    (LX1,LY1,LZ1,1)
      REAL           RHS  (LX1,LY1,LZ1,1)
      REAL           H1   (LX1,LY1,LZ1,1)
      REAL           H2   (LX1,LY1,LZ1,1)
      REAL           MASK (LX1,LY1,LZ1,1)
      REAL           MULT (LX1,LY1,LZ1,1)

      logical iffdm
      character*3 nam3

      tol = abs(tli)

      iffdm = .false.
      if (ifsplit) iffdm = .true.
      if (icalld.eq.0.and.iffdm) call set_fdm_prec_h1A
      icalld = icalld+1

#ifdef TIMER
      if (name.ne.'PRES') then
        nhmhz = nhmhz + 1
        etime1 = dnekclock()
      endif
#endif

      ntot = lx1*ly1*lz1*nelfld(ifield)
      if (imsh.eq.1) ntot = lx1*ly1*lz1*nelv
      if (imsh.eq.2) ntot = lx1*ly1*lz1*nelt

C     Determine which field is being computed for FDM based preconditioner bc's
c
      call chcopy(nam3,name,3)
c
                          kfldfdm = -1
c     if (nam3.eq.'TEM' ) kfldfdm =  0
c     if (name.eq.'TEM1') kfldfdm =  0  ! hardcode for temp only, for mpaul
c     if (name.eq.'VELX') kfldfdm =  1
c     if (name.eq.'VELY') kfldfdm =  2
c     if (name.eq.'VELZ') kfldfdm =  3
      if (name.eq.'PRES') kfldfdm =  ldim+1
c     if (.not.iffdm) kfldfdm=-1
C
      call dssum   (rhs,lx1,ly1,lz1)
      call col2    (rhs,mask,ntot)
c      if (nio.eq.0.and.istep.le.10) 
c     $    write(6,*) param(22),' p22 ',istep,imsh
      if (param(22).eq.0.or.istep.le.10)
     $    call chktcg1 (tol,rhs,h1,h2,mask,mult,imsh,isd)

      if (tli.lt.0) tol=tli ! caller-specified relative tolerance

      if (imsh.eq.1) call cggo
     $   (u,rhs,h1,h2,mask,mult,imsh,tol,maxit,isd,binvm1,name)
      if (imsh.eq.2) call cggo
     $   (u,rhs,h1,h2,mask,mult,imsh,tol,maxit,isd,bintm1,name)

#ifdef TIMER
      if (name.ne.'PRES') thmhz=thmhz+(dnekclock()-etime1)
#endif

      return
      END
C
c=======================================================================
      subroutine axhelm (au,u,helm1,helm2,imesh,isd)
C------------------------------------------------------------------
C
C     Compute the (Helmholtz) matrix-vector product,
C     AU = helm1*[A]u + helm2*[B]u, for NEL elements.
C
C------------------------------------------------------------------
      include 'SIZE'
      include 'WZ'
      include 'DXYZ'
      include 'GEOM'
      include 'MASS'
      include 'INPUT'
      include 'PARALLEL'
      include 'CTIMER'
C
      COMMON /FASTAX/ WDDX(LX1,LX1),WDDYT(LY1,LY1),WDDZT(LZ1,LZ1)
      COMMON /FASTMD/ IFDFRM(LELT), IFFAST(LELT), IFH2, IFSOLV
      LOGICAL IFDFRM, IFFAST, IFH2, IFSOLV
C
      REAL           AU    (LX1,LY1,LZ1,1)
     $ ,             U     (LX1,LY1,LZ1,1)
     $ ,             HELM1 (LX1,LY1,LZ1,1)
     $ ,             HELM2 (LX1,LY1,LZ1,1)
      COMMON /CTMP1/ DUDR  (LX1,LY1,LZ1)
     $ ,             DUDS  (LX1,LY1,LZ1)
     $ ,             DUDT  (LX1,LY1,LZ1)
     $ ,             TMP1  (LX1,LY1,LZ1)
     $ ,             TMP2  (LX1,LY1,LZ1)
     $ ,             TMP3  (LX1,LY1,LZ1)

      REAL           TM1   (LX1,LY1,LZ1)
      REAL           TM2   (LX1,LY1,LZ1)
      REAL           TM3   (LX1,LY1,LZ1)
      REAL           DUAX  (LX1)
      REAL           YSM1  (LX1)
      EQUIVALENCE    (DUDR,TM1),(DUDS,TM2),(DUDT,TM3)

      integer e

      naxhm = naxhm + 1
      etime1 = dnekclock()

      nel=nelt
      if (imesh.eq.1) nel=nelv

      NXY=lx1*ly1
      NYZ=ly1*lz1
      NXZ=lx1*lz1
      NXYZ=lx1*ly1*lz1
      NTOT=NXYZ*NEL

      IF (.NOT.IFSOLV) CALL SETFAST(HELM1,HELM2,IMESH)
      CALL RZERO (AU,NTOT)

      do 100 e=1,nel
C
        if (ifaxis) call setaxdy ( ifrzer(e) )
C
        IF (ldim.EQ.2) THEN
C
C       2-d case ...............
C
           if (iffast(e)) then
C
C          Fast 2-d mode: constant properties and undeformed element
C
           h1 = helm1(1,1,1,e)
           call mxm   (wddx,lx1,u(1,1,1,e),lx1,tm1,nyz)
           call mxm   (u(1,1,1,e),lx1,wddyt,ly1,tm2,ly1)
           call col2  (tm1,g4m1(1,1,1,e),nxyz)
           call col2  (tm2,g5m1(1,1,1,e),nxyz)
           call add3  (au(1,1,1,e),tm1,tm2,nxyz)
           call cmult (au(1,1,1,e),h1,nxyz)
C
           else
C
C
           call mxm  (dxm1,lx1,u(1,1,1,e),lx1,dudr,nyz)
           call mxm  (u(1,1,1,e),lx1,dytm1,ly1,duds,ly1)
           call col3 (tmp1,dudr,g1m1(1,1,1,e),nxyz)
           call col3 (tmp2,duds,g2m1(1,1,1,e),nxyz)
           if (ifdfrm(e)) then
              call addcol3 (tmp1,duds,g4m1(1,1,1,e),nxyz)
              call addcol3 (tmp2,dudr,g4m1(1,1,1,e),nxyz)
           endif
           call col2 (tmp1,helm1(1,1,1,e),nxyz)
           call col2 (tmp2,helm1(1,1,1,e),nxyz)
           call mxm  (dxtm1,lx1,tmp1,lx1,tm1,nyz)
           call mxm  (tmp2,lx1,dym1,ly1,tm2,ly1)
           call add2 (au(1,1,1,e),tm1,nxyz)
           call add2 (au(1,1,1,e),tm2,nxyz)

        endif
C
        else
C
C       3-d case ...............
C
           if (iffast(e)) then
C
C          Fast 3-d mode: constant properties and undeformed element
C
           h1 = helm1(1,1,1,e)
           call mxm   (wddx,lx1,u(1,1,1,e),lx1,tm1,nyz)
           do 5 iz=1,lz1
           call mxm   (u(1,1,iz,e),lx1,wddyt,ly1,tm2(1,1,iz),ly1)
 5         continue
           call mxm   (u(1,1,1,e),nxy,wddzt,lz1,tm3,lz1)
           call col2  (tm1,g4m1(1,1,1,e),nxyz)
           call col2  (tm2,g5m1(1,1,1,e),nxyz)
           call col2  (tm3,g6m1(1,1,1,e),nxyz)
           call add3  (au(1,1,1,e),tm1,tm2,nxyz)
           call add2  (au(1,1,1,e),tm3,nxyz)
           call cmult (au(1,1,1,e),h1,nxyz)
C
           else
C
C
           call mxm(dxm1,lx1,u(1,1,1,e),lx1,dudr,nyz)
           do 10 iz=1,lz1
              call mxm(u(1,1,iz,e),lx1,dytm1,ly1,duds(1,1,iz),ly1)
   10      continue
           call mxm     (u(1,1,1,e),nxy,dztm1,lz1,dudt,lz1)
           call col3    (tmp1,dudr,g1m1(1,1,1,e),nxyz)
           call col3    (tmp2,duds,g2m1(1,1,1,e),nxyz)
           call col3    (tmp3,dudt,g3m1(1,1,1,e),nxyz)
           if (ifdfrm(e)) then
              call addcol3 (tmp1,duds,g4m1(1,1,1,e),nxyz)
              call addcol3 (tmp1,dudt,g5m1(1,1,1,e),nxyz)
              call addcol3 (tmp2,dudr,g4m1(1,1,1,e),nxyz)
              call addcol3 (tmp2,dudt,g6m1(1,1,1,e),nxyz)
              call addcol3 (tmp3,dudr,g5m1(1,1,1,e),nxyz)
              call addcol3 (tmp3,duds,g6m1(1,1,1,e),nxyz)
           endif
           call col2 (tmp1,helm1(1,1,1,e),nxyz)
           call col2 (tmp2,helm1(1,1,1,e),nxyz)
           call col2 (tmp3,helm1(1,1,1,e),nxyz)
           call mxm  (dxtm1,lx1,tmp1,lx1,tm1,nyz)
           do 20 iz=1,lz1
              call mxm(tmp2(1,1,iz),lx1,dym1,ly1,tm2(1,1,iz),ly1)
   20      continue
           call mxm  (tmp3,nxy,dzm1,lz1,tm3,lz1)
           call add2 (au(1,1,1,e),tm1,nxyz)
           call add2 (au(1,1,1,e),tm2,nxyz)
           call add2 (au(1,1,1,e),tm3,nxyz)
C
           endif
c
        endif
C
 100  continue
C
      if (ifh2) call addcol4 (au,helm2,bm1,u,ntot)
C
C     If axisymmetric, add a diagonal term in the radial direction (ISD=2)
C
      if (ifaxis.and.(isd.eq.2)) then
         do 200 e=1,nel
C
            if (ifrzer(e)) then
               call mxm(u  (1,1,1,e),lx1,datm1,ly1,duax,1)
               call mxm(ym1(1,1,1,e),lx1,datm1,ly1,ysm1,1)
            endif
c
            do 190 j=1,ly1
            do 190 i=1,lx1
C               if (ym1(i,j,1,e).ne.0.) then
                  if (ifrzer(e)) then
                     term1 = 0.0
                     if(j.ne.1) 
     $             term1 = bm1(i,j,1,e)*u(i,j,1,e)/ym1(i,j,1,e)**2
                     term2 =  wxm1(i)*wam1(1)*dam1(1,j)*duax(i)
     $                       *jacm1(i,1,1,e)/ysm1(i)
                  else
                   term1 = bm1(i,j,1,e)*u(i,j,1,e)/ym1(i,j,1,e)**2
                     term2 = 0.
                  endif
                  au(i,j,1,e) = au(i,j,1,e)
     $                          + helm1(i,j,1,e)*(term1+term2)
C               endif
  190       continue
  200    continue
      endif

      taxhm=taxhm+(dnekclock()-etime1)
      return
      end
C
c=======================================================================
      subroutine setfast (helm1,helm2,imesh)
C-------------------------------------------------------------------
C
C     Set logicals for fast evaluation of A*x
C
C-------------------------------------------------------------------
      include 'SIZE'
      include 'INPUT'
      COMMON /FASTMD/ IFDFRM(LELT), IFFAST(LELT), IFH2, IFSOLV
      LOGICAL IFDFRM, IFFAST, IFH2, IFSOLV
      REAL HELM1(lx1,ly1,lz1,1), HELM2(lx1,ly1,lz1,1)
C
      IF (IMESH.EQ.1) NEL=NELV
      IF (IMESH.EQ.2) NEL=NELT
      NXYZ = lx1*ly1*lz1
      NTOT = NXYZ*NEL
C
      DELTA = 1.E-9
      X    = 1.+DELTA
      Y    = 1.
      DIFF = ABS(X-Y)
      IF (DIFF.EQ.0.0) EPSM = 1.E-6
      IF (DIFF.GT.0.0) EPSM = 1.E-13
C
      DO 100 ie=1,NEL
         IFFAST(ie) = .FALSE.
         IF (IFDFRM(ie).OR.IFAXIS) THEN
            IFFAST(ie) = .FALSE.
         ELSE
           H1MIN  = VLMIN(HELM1(1,1,1,ie),NXYZ)
           H1MAX  = VLMAX(HELM1(1,1,1,ie),NXYZ)
           den    = abs(h1max)+abs(h1min)
           if (den.gt.0) then
              TESTH1 = ABS((H1MAX-H1MIN)/(H1MAX+H1MIN))
              IF (TESTH1.LT.EPSM) IFFAST(ie) = .TRUE.
           else
              iffast(ie) = .true.
           endif
         ENDIF
 100  CONTINUE
c
      IFH2   = .FALSE.
      TESTH2 =  VLAMAX(HELM2,NTOT)
      IF (TESTH2.GT.0.) IFH2 = .TRUE.
      return
      END
C
c=======================================================================
      subroutine sfastax
C----------------------------------------------------------------------
C
C     For undeformed elements, set up appropriate elemental matrices
C     and geometric factors for fast evaluation of Ax.
C
C----------------------------------------------------------------------
      include 'SIZE'
      include 'WZ'
      include 'DXYZ'
      include 'GEOM'
      COMMON /FASTAX/ WDDX(LX1,LY1),WDDYT(LY1,LY1),WDDZT(LZ1,LZ1)
      COMMON /FASTMD/ IFDFRM(LELT), IFFAST(LELT), IFH2, IFSOLV
      LOGICAL IFDFRM, IFFAST, IFH2, IFSOLV
      LOGICAL IFIRST
      SAVE    IFIRST
      DATA    IFIRST /.TRUE./
C
      NXX=lx1*lx1
      IF (IFIRST) THEN
         CALL RZERO(WDDX,NXX)
         DO 100 I=1,lx1
         DO 100 J=1,lx1
         DO 100 IP=1,lx1
            WDDX(I,J) = WDDX(I,J) + WXM1(IP)*DXM1(IP,I)*DXM1(IP,J)
  100    CONTINUE
         NYY=ly1*ly1
         CALL RZERO(WDDYT,NYY)
         DO 200 I=1,ly1
         DO 200 J=1,ly1
         DO 200 IP=1,ly1
            WDDYT(J,I) = WDDYT(J,I) + WYM1(IP)*DYM1(IP,I)*DYM1(IP,J)
  200    CONTINUE
         NZZ=lz1*lz1
         CALL RZERO(WDDZT,NZZ)
         DO 300 I=1,lz1
         DO 300 J=1,lz1
         DO 300 IP=1,lz1
            WDDZT(J,I) = WDDZT(J,I) + WZM1(IP)*DZM1(IP,I)*DZM1(IP,J)
  300    CONTINUE
         IFIRST=.FALSE.
      ENDIF
C
      IF (ldim.EQ.3) THEN
         DO 1001 IE=1,NELT
            IF (.NOT.IFDFRM(IE)) THEN
               DO 1000 IZ=1,lz1
               DO 1000 IY=1,ly1
               DO 1000 IX=1,lx1
                  G4M1(IX,IY,IZ,IE)=G1M1(IX,IY,IZ,IE)/WXM1(IX)
                  G5M1(IX,IY,IZ,IE)=G2M1(IX,IY,IZ,IE)/WYM1(IY)
                  G6M1(IX,IY,IZ,IE)=G3M1(IX,IY,IZ,IE)/WZM1(IZ)
 1000          CONTINUE
            ENDIF
 1001    CONTINUE
      ELSE
         DO 2001 IE=1,NELT
            IF (.NOT.IFDFRM(IE)) THEN
               DO 2000 IY=1,ly1
               DO 2000 IX=1,lx1
                  G4M1(IX,IY,1,IE)=G1M1(IX,IY,1,IE)/WXM1(IX)
                  G5M1(IX,IY,1,IE)=G2M1(IX,IY,1,IE)/WYM1(IY)
 2000          CONTINUE
            ENDIF
 2001    CONTINUE
      ENDIF
      return
      END
C
c=======================================================================
      subroutine setprec (dpcm1,helm1,helm2,imsh,isd)
C-------------------------------------------------------------------
C
C     Generate diagonal preconditioner for the Helmholtz operator.
C
C-------------------------------------------------------------------
      include 'SIZE'
      include 'WZ'
      include 'DXYZ'
      include 'GEOM'
      include 'INPUT'
      include 'TSTEP'
      include 'MASS'
      REAL            DPCM1 (LX1,LY1,LZ1,1)
      COMMON /FASTMD/ IFDFRM(LELT), IFFAST(LELT), IFH2, IFSOLV
      LOGICAL IFDFRM, IFFAST, IFH2, IFSOLV
      REAL            HELM1(lx1,ly1,lz1,1), HELM2(lx1,ly1,lz1,1)
      REAL YSM1(LY1)

      nel=nelt
      if (imsh.eq.1) nel=nelv

      ntot = nel*lx1*ly1*lz1

c     The following lines provide a convenient debugging option
c     call rone(dpcm1,ntot)
c     if (ifield.eq.1) call copy(dpcm1,binvm1,ntot)
c     if (ifield.eq.2) call copy(dpcm1,bintm1,ntot)
c     return

      CALL RZERO(DPCM1,NTOT)
      DO 1000 IE=1,NEL

        IF (IFAXIS) CALL SETAXDY ( IFRZER(IE) )

        DO 320 IQ=1,lx1
        DO 320 IZ=1,lz1
        DO 320 IY=1,ly1
        DO 320 IX=1,lx1
           DPCM1(IX,IY,IZ,IE) = DPCM1(IX,IY,IZ,IE) + 
     $                          G1M1(IQ,IY,IZ,IE) * DXTM1(IX,IQ)**2
  320   CONTINUE
        DO 340 IQ=1,ly1
        DO 340 IZ=1,lz1
        DO 340 IY=1,ly1
        DO 340 IX=1,lx1
           DPCM1(IX,IY,IZ,IE) = DPCM1(IX,IY,IZ,IE) + 
     $                          G2M1(IX,IQ,IZ,IE) * DYTM1(IY,IQ)**2
  340   CONTINUE
        IF (LDIM.EQ.3) THEN
           DO 360 IQ=1,lz1
           DO 360 IZ=1,lz1
           DO 360 IY=1,ly1
           DO 360 IX=1,lx1
              DPCM1(IX,IY,IZ,IE) = DPCM1(IX,IY,IZ,IE) + 
     $                             G3M1(IX,IY,IQ,IE) * DZTM1(IZ,IQ)**2
  360      CONTINUE
C
C          Add cross terms if element is deformed.
C
           IF (IFDFRM(IE)) THEN
              DO 600 IY=1,ly1,ly1-1
              DO 600 IZ=1,lz1,max(1,lz1-1)
              DPCM1(1,IY,IZ,IE) = DPCM1(1,IY,IZ,IE)
     $            + G4M1(1,IY,IZ,IE) * DXTM1(1,1)*DYTM1(IY,IY)
     $            + G5M1(1,IY,IZ,IE) * DXTM1(1,1)*DZTM1(IZ,IZ)
              DPCM1(lx1,IY,IZ,IE) = DPCM1(lx1,IY,IZ,IE)
     $            + G4M1(lx1,IY,IZ,IE) * DXTM1(lx1,lx1)*DYTM1(IY,IY)
     $            + G5M1(lx1,IY,IZ,IE) * DXTM1(lx1,lx1)*DZTM1(IZ,IZ)
  600         CONTINUE
              DO 700 IX=1,lx1,lx1-1
              DO 700 IZ=1,lz1,max(1,lz1-1)
                 DPCM1(IX,1,IZ,IE) = DPCM1(IX,1,IZ,IE)
     $            + G4M1(IX,1,IZ,IE) * DYTM1(1,1)*DXTM1(IX,IX)
     $            + G6M1(IX,1,IZ,IE) * DYTM1(1,1)*DZTM1(IZ,IZ)
                 DPCM1(IX,ly1,IZ,IE) = DPCM1(IX,ly1,IZ,IE)
     $            + G4M1(IX,ly1,IZ,IE) * DYTM1(ly1,ly1)*DXTM1(IX,IX)
     $            + G6M1(IX,ly1,IZ,IE) * DYTM1(ly1,ly1)*DZTM1(IZ,IZ)
  700         CONTINUE
              DO 800 IX=1,lx1,lx1-1
              DO 800 IY=1,ly1,ly1-1
                 DPCM1(IX,IY,1,IE) = DPCM1(IX,IY,1,IE)
     $                + G5M1(IX,IY,1,IE) * DZTM1(1,1)*DXTM1(IX,IX)
     $                + G6M1(IX,IY,1,IE) * DZTM1(1,1)*DYTM1(IY,IY)
                 DPCM1(IX,IY,lz1,IE) = DPCM1(IX,IY,lz1,IE)
     $                + G5M1(IX,IY,lz1,IE) * DZTM1(lz1,lz1)*DXTM1(IX,IX)
     $                + G6M1(IX,IY,lz1,IE) * DZTM1(lz1,lz1)*DYTM1(IY,IY)
  800         CONTINUE
           ENDIF

        ELSE  ! 2D

           IZ=1
           IF (IFDFRM(IE)) THEN
              DO 602 IY=1,ly1,ly1-1
                 DPCM1(1,IY,IZ,IE) = DPCM1(1,IY,IZ,IE)
     $                + G4M1(1,IY,IZ,IE) * DXTM1(1,1)*DYTM1(IY,IY)
                 DPCM1(lx1,IY,IZ,IE) = DPCM1(lx1,IY,IZ,IE)
     $                + G4M1(lx1,IY,IZ,IE) * DXTM1(lx1,lx1)*DYTM1(IY,IY)
  602         CONTINUE
              DO 702 IX=1,lx1,lx1-1
                 DPCM1(IX,1,IZ,IE) = DPCM1(IX,1,IZ,IE)
     $                + G4M1(IX,1,IZ,IE) * DYTM1(1,1)*DXTM1(IX,IX)
                 DPCM1(IX,ly1,IZ,IE) = DPCM1(IX,ly1,IZ,IE)
     $                + G4M1(IX,ly1,IZ,IE) * DYTM1(ly1,ly1)*DXTM1(IX,IX)
  702         CONTINUE
           ENDIF

        ENDIF
 1000 CONTINUE
C
      CALL COL2    (DPCM1,HELM1,NTOT)
      CALL ADDCOL3 (DPCM1,HELM2,BM1,NTOT)
C
C     If axisymmetric, add a diagonal term in the radial direction (ISD=2)
C
      IF (IFAXIS.AND.(ISD.EQ.2)) THEN
         DO 1200 IEL=1,NEL
C
            IF (IFRZER(IEL)) THEN
               CALL MXM(YM1(1,1,1,IEL),lx1,DATM1,ly1,YSM1,1)
            ENDIF
C
            DO 1190 J=1,ly1
            DO 1190 I=1,lx1
               IF (YM1(I,J,1,IEL).NE.0.) THEN
                  TERM1 = BM1(I,J,1,IEL)/YM1(I,J,1,IEL)**2
                  IF (IFRZER(IEL)) THEN
                     TERM2 =  WXM1(I)*WAM1(1)*DAM1(1,J)
     $                       *JACM1(I,1,1,IEL)/YSM1(I)
                  ELSE
                     TERM2 = 0.
                  ENDIF
                  DPCM1(I,J,1,IEL) = DPCM1(I,J,1,IEL)
     $                             + HELM1(I,J,1,IEL)*(TERM1+TERM2)
               ENDIF
 1190       CONTINUE
 1200    CONTINUE
      ENDIF
C
      CALL DSSUM (DPCM1,lx1,ly1,lz1)
      CALL INVCOL1 (DPCM1,NTOT)
C
      return
      END
C
c=======================================================================
      subroutine chktcg1 (tol,res,h1,h2,mask,mult,imesh,isd)
C-------------------------------------------------------------------
C
C     Check that the tolerances are not too small for the CG-solver.
C     Important when calling the CG-solver (Gauss-Lobatto mesh) with
C     zero Neumann b.c.
C
C-------------------------------------------------------------------
      include 'SIZE'
      include 'INPUT'
      include 'MASS'
      include 'EIGEN'
      COMMON  /CPRINT/ IFPRINT
      LOGICAL          IFPRINT
      COMMON /CTMP0/ W1   (LX1,LY1,LZ1,LELT)
     $ ,             W2   (LX1,LY1,LZ1,LELT)
      REAL RES  (LX1,LY1,LZ1,1)
      REAL H1   (LX1,LY1,LZ1,1)
      REAL H2   (LX1,LY1,LZ1,1)
      REAL MULT (LX1,LY1,LZ1,1)
      REAL MASK (LX1,LY1,LZ1,1)
C
      IF (EIGAA.NE.0.) THEN
         ACONDNO = EIGGA/EIGAA
      ELSE
         ACONDNO = 10.
      ENDIF
C
C     Single or double precision???
C
      DELTA = 1.E-9
      X     = 1.+DELTA
      Y     = 1.
      DIFF  = ABS(X-Y)
      IF (DIFF.EQ.0.) EPS = 1.E-6
      IF (DIFF.GT.0.) EPS = 1.E-13
C
      IF (IMESH.EQ.1) THEN
          NL  = NELV
          VOL = VOLVM1
      ELSEIF (IMESH.EQ.2) THEN
          NL  = NELT
          VOL = VOLTM1
      ENDIF
      NTOT1 = lx1*ly1*lz1*NL
      CALL COPY (W1,RES,NTOT1)
C
      IF (IMESH.EQ.1) THEN
         CALL COL3 (W2,BINVM1,W1,NTOT1)
         RINIT  = SQRT(GLSC3 (W2,W1,MULT,NTOT1)/VOLVM1)
      ELSE
         CALL COL3 (W2,BINTM1,W1,NTOT1)
         RINIT  = SQRT(GLSC3 (W2,W1,MULT,NTOT1)/VOLTM1)
      ENDIF
      RMIN   = EPS*RINIT
      IF (TOL.LT.RMIN) THEN
         IF (NIO.EQ.0.AND.IFPRINT)
     $   WRITE (6,*) 'New CG1-tolerance (RINIT*epsm) = ',RMIN,TOL
         TOL = RMIN
      ENDIF
C
      CALL RONE (W1,NTOT1)
      BCNEU1 = GLSC3(W1,MASK,MULT,NTOT1)
      BCNEU2 = GLSC3(W1,W1  ,MULT,NTOT1)
      BCTEST = ABS(BCNEU1-BCNEU2)
C
      CALL AXHELM (W2,W1,H1,H2,IMESH,ISD)
      CALL COL2   (W2,W2,NTOT1)
      CALL COL2   (W2,BM1,NTOT1)
      BCROB  = SQRT(GLSUM(W2,NTOT1)/VOL)
C
      IF ((BCTEST .LT. .1).AND.(BCROB.LT.(EPS*ACONDNO))) THEN
C         OTR = GLSC3 (W1,RES,MULT,NTOT1)
         TOLMIN = RINIT*EPS*10.
         IF (TOL .LT. TOLMIN) THEN
             TOL = TOLMIN
             IF (NIO.EQ.0.AND.IFPRINT)
     $       WRITE(6,*) 'New CG1-tolerance (Neumann) = ',TOLMIN
         ENDIF
      ENDIF
C
      return
      end
c=======================================================================
      subroutine cggo(x,f,h1,h2,mask,mult,imsh,tin,maxit,isd,binv,name)
C-------------------------------------------------------------------------
C
C     Solve the Helmholtz equation, H*U = RHS,
C     using preconditioned conjugate gradient iteration.
C     Preconditioner: diag(H).
C
C------------------------------------------------------------------------
      include 'SIZE'
      include 'TOTAL'
      include 'FDMH1'
 
      COMMON  /CPRINT/ IFPRINT, IFHZPC
      LOGICAL          IFPRINT, IFHZPC
 
      common /fastmd/ ifdfrm(lelt), iffast(lelt), ifh2, ifsolv
      logical ifdfrm, iffast, ifh2, ifsolv

      logical ifmcor,ifprint_hmh
 
      real x(1),f(1),h1(1),h2(1),mask(1),mult(1),binv(1)
      parameter        (lg=lx1*ly1*lz1*lelt)
      COMMON /SCRCG/ d (lg) , scalar(2)
      common /SCRMG/ r (lg) , w (lg) , p (lg) , z (lg)
c
      parameter (maxcg=900)
      common /tdarray/ diagt(maxcg),upper(maxcg)
      common /iterhm/ niterhm
      character*4 name
c
      if (ifsplit.and.name.eq.'PRES') then
         if (param(42).eq.0) then
           n = lx1*ly1*lz1*nelv
           call copy      (x,f,n)
           iter = maxit
           call hmh_gmres (x,h1,h2,mult,iter)
           niterhm = iter
           return
         elseif(param(42).eq.2) then 
           n = lx1*ly1*lz1*nelv
           call copy       (x,f,n)
           iter = maxit
           call hmh_flex_cg(x,h1,h2,mult,iter)
           niterhm = iter
           return
         endif
      endif

c **  zero out stuff for Lanczos eigenvalue estimator
      call rzero(diagt,maxcg)
      call rzero(upper,maxcg)
      rho = 0.00
C
C     Initialization
C
      NXYZ   = lx1*ly1*lz1
      NEL    = NELV
      VOL    = VOLVM1
      IF (IMSH.EQ.2) NEL=NELT
      IF (IMSH.EQ.2) VOL=VOLTM1
      n      = NEL*NXYZ

      tol=abs(tin)

c     overrule input tolerance
      if (restol(ifield).ne.0) tol=restol(ifield)
      if (name.eq.'PRES'.and.param(21).ne.0) tol=abs(param(21))

      if (tin.lt.0) tol=abs(tin)
      niter = min(maxit,maxcg)

      if (.not.ifsolv) then
         call setfast(h1,h2,imsh)
         ifsolv = .true.
      endif
C
C     Set up diag preconditioner.
C
      if (kfldfdm.lt.0) then
         call setprec(D,h1,h2,imsh,isd)
      elseif(param(100).ne.2) then
         call set_fdm_prec_h1b(d,h1,h2,nel)
      endif

      call copy (r,f,n)
      call rzero(x,n)
      call rzero(p,n)

      fmax = glamax(f,n)
      if (fmax.eq.0.0) return

c     Check for non-trivial null-space

      ifmcor = .false.
      h2max = glmax(h2  ,n)
      skmin = glmin(mask,n)
      if (skmin.gt.0.and.h2max.eq.0) ifmcor = .true.
C
      if (name.eq.'PRES') then
c        call ortho (r)           ! Commented out March 15, 2011,pff
      elseif (ifmcor) then

         smean = -1./glsum(bm1,n) ! Modified 5/4/12 pff
         rmean = smean*glsc2(r,mult,n)
         call copy(x,bm1,n)
         call dssum(x,lx1,ly1,lz1)
         call add2s2(r,x,rmean,n)
         call rzero(x,n)
      endif
C
      krylov = 0
      rtz1=1.0
      niterhm = 0

      do iter=1,niter
C
         if (kfldfdm.lt.0) then  ! Jacobi Preconditioner
c           call copy(z,r,n)
            call col3(z,r,d,n)
         else                                       ! Schwarz Preconditioner
            if (name.eq.'PRES'.and.param(100).eq.2) then
               call h1_overlap_2(z,r,mask)
               call crs_solve_h1 (w,r)  ! Currently, crs grd only for P
               call add2         (z,w,n)
            else   
               call fdm_h1(z,r,d,mask,mult,nel,ktype(1,1,kfldfdm),w)
               if (name.eq.'PRES') then 
                 call crs_solve_h1 (w,r)  ! Currently, crs grd only for P
                 call add2         (z,w,n)
               endif
            endif
         endif
c
         if (name.eq.'PRES') then
            call ortho (z)
         elseif (ifmcor) then
            rmean = smean*glsc2(z,bm1,n)
            call cadd(z,rmean,n)
         endif
c        write(6,*) rmean,ifmcor,' ifmcor'
c
         rtz2=rtz1
         scalar(1)=vlsc3 (z,r,mult,n)
         if(param(18).eq.1) then
           scalar(2)=vlsc3(r,r,mult,n)
         else 
          scalar(2)=vlsc32(r,mult,binv,n)
         endif
         call gop(scalar,w,'+  ',2)
         rtz1=scalar(1)
         rbn2=sqrt(scalar(2)/vol)
         if (iter.eq.1) rbn0 = rbn2
         if (param(22).lt.0) tol=abs(param(22))*rbn0
         if (tin.lt.0)       tol=abs(tin)*rbn0

         ifprint_hmh = .false.
         if (nio.eq.0.and.ifprint.and.param(74).ne.0) ifprint_hmh=.true.
         if (nio.eq.0.and.istep.eq.1)                 ifprint_hmh=.true.

         if (ifprint_hmh)
     &      write(6,3002) istep,'  Hmholtz ' // name,
     &                    iter,rbn2,h1(1),tol,h2(1),ifmcor


c        Always take at least one iteration   (for projection) pff 11/23/98
#ifndef FIXITER
         IF (rbn2.LE.TOL.and.(iter.gt.1 .or. istep.le.5)) THEN
#else
         iter_max = param(150)
         if (name.eq.'PRES') iter_max = param(151)
         if (iter.gt.iter_max) then
#endif
c        IF (rbn2.LE.TOL) THEN
            NITER = ITER-1
c           IF(NID.EQ.0.AND.((.NOT.IFHZPC).OR.IFPRINT))
            if (nio.eq.0)
     &         write(6,3000) istep,'  Hmholtz ' // name,
     &                       niter,rbn2,rbn0,tol
            goto 9999
         ENDIF
c
         beta = rtz1/rtz2
         if (iter.eq.1) beta=0.0
         call add2s1 (p,z,beta,n)
         call axhelm (w,p,h1,h2,imsh,isd)
         call dssum  (w,lx1,ly1,lz1)
         call col2   (w,mask,n)
c
         rho0 = rho
         rho  = glsc3(w,p,mult,n)
         alpha=rtz1/rho
         alphm=-alpha
         call add2s2(x,p ,alpha,n)
         call add2s2(r,w ,alphm,n)
c
c        Generate tridiagonal matrix for Lanczos scheme
         if (iter.eq.1) then
            krylov = krylov+1
            diagt(iter) = rho/rtz1
         elseif (iter.le.maxcg) then
            krylov = krylov+1
            diagt(iter)    = (beta**2 * rho0 + rho ) / rtz1
            upper(iter-1)  = -beta * rho0 / sqrt(rtz2 * rtz1)
         endif
 1000 enddo
      niter = iter-1
c
      if (nio.eq.0) write (6,3001) istep, '  Error Hmholtz ' // name,
     &                             niter,rbn2,rbn0,tol


 3000 format(i11,a,1x,I7,1p4E13.4)
 3001 format(i11,a,1x,I7,1p4E13.4)
 3002 format(i11,a,1x,I7,1p4E13.4,l4)
 9999 continue
      niterhm = niter
      ifsolv = .false.
c
c
c     Call eigenvalue routine for Lanczos scheme:
c          two work arrays are req'd if you want to save "diag & upper"
c
c     if (iter.ge.3) then
c        niter = iter-1
c        call calc (diagt,upper,w,z,krylov,dmax,dmin)
c        cond = dmax/dmin
c        if (nid.eq.0) write(6,6) istep,cond,dmin,dmax,' lambda'
c     endif
c   6 format(i9,1p3e12.4,4x,a7)
c
c     if (n.gt.0) write(6,*) 'quit in cggo'
c     if (n.gt.0) call exitt
c     call exitt
      return
      end
c=======================================================================
      function vlsc32(r,b,m,n)
      real r(1),b(1),m(1)
      s = 0.
      do i=1,n
         s = s + b(i)*m(i)*r(i)*r(i)
      enddo
      vlsc32 = s
      return
      end
c=======================================================================
      subroutine calc (diag,upper,d,e,n,dmax,dmin)
c
      dimension diag(n),upper(n)
      dimension d(n),e(n)
c
      call copy (d,diag ,n)
      call copy (e,upper,n)
c
      do 15 l=1,n
         iter = 0
c
 1       do 12 m=l,n-1
            dd = abs( d(m) ) + abs( d(m+1) )
            if ( abs(e(m)) + dd .eq. dd ) goto 2
 12      continue
c
         m = n
 2       if ( m .ne. l ) then
c
            if ( iter .eq. 30 ) then
               write (6,*) 'too many iterations'
               return
            endif
c
         iter = iter + 1
         g = ( d(l+1) - d(l) ) / ( 2.0 * e(l) )
         r = sqrt( g**2 + 1.0 )
c
c sign is defined as a(2) * abs( a(1) )
c
         g = d(m) - d(l) + e(l)/(g+sign(r,g))
         s = 1.0
         c = 1.0
         p = 0.0
c
         do 14 i = m-1,l,-1
            f = s * e(i)
            b = c * e(i)
            if ( abs(f) .ge. abs(g) ) then
               c = g/f
               r = sqrt( c**2 + 1.0 )
               e(i+1) = f*r
               s = 1.0/r
               c = c*s
            else
               s = f/g
               r = sqrt( s**2 + 1.0 )
               e(i+1) = g*r
               c = 1.0 / r
               s = s * c
            endif
c
            g = d(i+1) - p
            r = ( d(i) - g ) * s + 2.0 * c * b
            p = s * r
            d(i+1) = g + p
            g = c*r - b
 14      continue
c
         d(l) = d(l) - p
         e(l) = g
         e(m) = 0.0
         goto 1
c
         endif
c
 15   continue
c
      dmax = 0.0
      dmin = d(1)
c
      do 40 i = 1 , n
        dmax = abs( max( d(i) , dmax ) )
        dmin = abs( min( d(i) , dmin ) )
 40   continue
c
      return
      end
c-----------------------------------------------------------------------
      subroutine fdm_h1(z,r,d,mask,mult,nel,kt,rr)
      include 'SIZE'
      include 'TOTAL'
c
      common /ctmp0/ w(lx1,ly1,lz1)
c
      include 'FDMH1'
c
c     Overlapping Schwarz, FDM based
c
      real z(lx1,ly1,lz1,1)
      real r(lx1,ly1,lz1,1)
      real d(lx1,ly1,lz1,1)
      real mask(lx1,ly1,lz1,1)
      real mult(lx1,ly1,lz1,1)
      real rr(lx1,ly1,lz1,1)
c
      integer kt(lelt,3)
c
      integer icalld
      save    icalld
      data    icalld /0/
c
      n1 = lx1
      n2 = lx1*lx1
      n3 = lx1*lx1*lx1
      ntot = lx1*ly1*lz1*nel
c
      if (ifbhalf) then
         call col3(rr,r,bhalf,ntot)
      else
         call copy(rr,r,ntot)
c        call col2(rr,mult,ntot)
      endif
c      if (nid.eq.0.and.icalld.eq.0) write(6,*) 'In fdm_h1',nel
      icalld = icalld+1
c
c
      do ie=1,nel
         if (if3d) then
c           Transfer to wave space:  
            call mxm(fdst(1,kt(ie,1)),n1,rr(1,1,1,ie),n1,w,n2)
            do iz=1,n1
              call mxm(w(1,1,iz),n1,fds (1,kt(ie,2)),n1,z(1,1,iz,ie),n1)
            enddo
            call mxm(z(1,1,1,ie),n2,fds (1,kt(ie,3)),n1,w,n1)
c
c           fdsolve:
c
            call col2(w,d(1,1,1,ie),n3)
c
c           Transfer to physical space:  
c
            call mxm(w,n2,fdst(1,kt(ie,3)),n1,z(1,1,1,ie),n1)
            do iz=1,n1
              call mxm(z(1,1,iz,ie),n1,fdst(1,kt(ie,2)),n1,w(1,1,iz),n1)
            enddo
            call mxm(fds (1,kt(ie,1)),n1,w,n1,z(1,1,1,ie),n2)
c
         else
c           Transfer to wave space:  
            call mxm(fdst(1,kt(ie,1)),n1,rr(1,1,1,ie),n1,w,n1)
            call mxm(w,n1,fds (1,kt(ie,2)),n1,z(1,1,1,ie),n1)
c
c           fdsolve:
c
            call col2(z(1,1,1,ie),d(1,1,1,ie),n2)
c
c           Transfer to physical space:  
c
            call mxm(z(1,1,1,ie),n1,fdst(1,kt(ie,2)),n1,w,n1)
            call mxm(fds (1,kt(ie,1)),n1,w,n1,z(1,1,1,ie),n1)
c
         endif
      enddo
c
c     call copy(vx,rr,ntot)
c     call copy(vy,z,ntot)
c     call prepost(.true.)
c     write(6,*) 'quit in fdm'
c     call exitt
c
      if (ifbhalf) call col2(z,bhalf,ntot)
c
c     call col2 (z,mult,ntot)
      call dssum(z,lx1,ly1,lz1)
      call col2 (z,mask,ntot)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine set_fdm_prec_h1A_gen
c
      include 'SIZE'
      include 'DXYZ'
      include 'INPUT'
      include 'MASS'
      include 'WZ'
c
      include 'FDMH1'
c
      COMMON /CTMP0/ W(LX1,LX1),aa(lx1,lx1),bb(lx1,lx1)
c
      integer left,right
c
c     Set up generic operators for fdm applied to H1 operator (Helmholtz)
c
c     3 cases:   E (or P),   "D"  or "N"  for E-E bc, Dirichlet, or Neuamann.
c
c     Since there are 2 endpoints, there are a total of 9 types.
c
c
      n  = lx1
      n2 = lx1*lx1
c
      delta = abs( zgm1(2,1) - zgm1(1,1) )
      bbh   = 0.5*delta
      aah   = 1./delta
c
      l = 0
      do right = 1,3
      do left  = 1,3
         l = l+1
c
         call rzero(bb,n2)
         do i=1,lx1
            bb(i,i) = wxm1(i)
         enddo
c
c        A = D^T B D
c
         call mxm(BB,n,Dxm1 ,n,w,n)
         call mxm(Dxtm1,n,w,n,AA,n)
         if (left.eq.1) then
c           Internal
            bb(1,1) = bb(1,1) + bbh
            aa(1,1) = aa(1,1) + aah
         elseif (left.eq.2) then
c           Dirichlet
            bb(1,1) = 1.
            do i=1,n
               aa(i,1) = 0.
               aa(1,i) = 0.
            enddo
            aa(1,1) = 1.
         endif
c
         if (right.eq.1) then
c           Internal
            bb(n,n) = bb(n,n) + bbh
            aa(n,n) = aa(n,n) + aah
         elseif (right.eq.2) then
c           Dirichlet
            bb(n,n) = 1.
            do i=1,n
               aa(i,n) = 0.
               aa(n,i) = 0.
            enddo
            aa(n,n) = 1.
         endif
c
c        Scale out mass matrix, so we can precondition w/ binvhf.
c
c        ifbhalf = .true.

         ifbhalf = .false.
         if (ifbhalf) call rescale_abhalf (aa,bb,w,n)
c
c        Now, compute eigenvectors/eigenvalues
c
         call generalev(aa,bb,dd(1,l),n,w)
         call copy(fds(1,l),aa,n*n)
         call transpose(fdst(1,l),n,fds(1,l),n)
c
      enddo
      enddo
      ntot = lx1*ly1*lz1*nelv
      if (ifbhalf) call copy (bhalf,binvm1,ntot)
      if (ifbhalf) call vsqrt(bhalf,ntot)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine set_fdm_prec_h1A_els
c
      include 'SIZE'
      include 'DXYZ'
      include 'FDMH1'
      include 'GEOM'
      include 'INPUT'
      include 'SOLN'
      include 'TOPOL'
      include 'WZ'
c
      COMMON /CTMP0/ W(LX1,LX1),aa(lx1,lx1),bb(lx1,lx1)
     $             , mask(lx1,ly1,lz1,lelt)
      real mask
      character*3 cb
c
c
c     Set up element specific information
c
c     3 cases:   E (or P),   "D"  or "N"  for E-E bc, Dirichlet, or Neuamann.
c
c     Since there are 2 endpoints, there are a total of 9 types.
c
c
      ntot = lx1*ly1*lz1*nelt
      kf0 = 1
      kf1 = 0
      if (ifheat)  kf0 = 0
      if (ifflow)  kf1 = ldim
      if (ifsplit) kf1 = ldim+1
      do kfld=kf0,kf1
         ifld = 1
         if (kfld.eq.0) ifld = 2
c
         if (kfld.eq.0)      call copy(mask, tmask,ntot)
         if (kfld.eq.1)      call copy(mask,v1mask,ntot)
         if (kfld.eq.2)      call copy(mask,v2mask,ntot)
         if (kfld.eq.3)      call copy(mask,v3mask,ntot)
         if (kfld.eq.ldim+1) call copy(mask, pmask,ntot)
c
         do ie=1,nelv
            do ifacedim = 1,ldim
c
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c              Mask pointers
c
               ii = 2
               jj = 2
               kk = 2
c
               if (ifacedim.eq.1) ii = 1
               if (ifacedim.eq.2) jj = 1
               if (ifacedim.eq.3) kk = 1
               k1 = ii+lx1*(jj-1)
               if (if3d) k1 = ii+lx1*(jj-1) + lx1*lx1*(kk-1)
c
               if (ifacedim.eq.1) ii = lx1
               if (ifacedim.eq.2) jj = lx1
               if (ifacedim.eq.3) kk = lx1
               k2 = ii+lx1*(jj-1)
               if (if3d) k2 = ii+lx1*(jj-1) + lx1*lx1*(kk-1)
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c
               iface = 2*ifacedim-1
               jface = iface+1
c
c              Convert to preproc   :(
               iface = eface(iface)
               jface = eface(jface)
c
c              "left" bc
c
               cb = cbc(iface,ie,ifld)
               if (cb.eq.'E  '.or.cb.eq.'P  '.or.cb.eq.'p  ') then
c                 Internal
                  ic1 = 1
               elseif (mask(k1,1,1,ie).eq.0) then
c                 Dirichlet
                  ic1 = 2
               else
c                 Neumann
                  ic1 = 3
               endif
c              write(6,*) ie,iface,'cbl: ',cb,ic1,k1,mask(k1,1,1,ie)
c
c              "right" bc
c
               cb = cbc(jface,ie,ifld)
               if (cb.eq.'E  '.or.cb.eq.'P  '.or.cb.eq.'p  ') then
c                 Internal
                  jc1 = 1
               elseif (mask(k2,1,1,ie).eq.0) then
c                 Dirichlet
                  jc1 = 2
               else
c                 Neumann
                  jc1 = 3
               endif
c              write(6,*) ie,jface,'cbr: ',cb,jc1,k2,mask(k2,1,1,ie)
c
               ijc = ic1 + 3*(jc1-1)
               ktype(ie,ifacedim,kfld) = ijc
c
            enddo
         enddo
      enddo
c
c     Boundary condition issues resolved... now resolve length scales
c
c
c
      do ie = 1,nelt
      do idim=1,ldim
         k1 = 1
         k2 = lz1
         if (idim.eq.3.or.ldim.eq.2) k2=1
         j1 = 1
         j2 = ly1
         if (idim.eq.2) j2=1
         i1 = 1
         i2 = lx1
         if (idim.eq.1) i2=1
c
c        l -- face 1,  l+jump = face 2
c
         jump = (lx1-1)*lx1**(idim-1)
         l    = 0
         dlm  = 0
         wgt  = 0
         do k=k1,k2
         do j=j1,j2
         do i=i1,i2
            l = l+1
            dl2 = (xm1(i+jump,j,k,ie)-xm1(i,j,k,ie))**2
     $          + (ym1(i+jump,j,k,ie)-ym1(i,j,k,ie))**2
     $          + (zm1(i+jump,j,k,ie)-zm1(i,j,k,ie))**2
            dlm = dlm + dl2*wxm1(i)*wxm1(j)*wxm1(k)
            wgt = wgt + wxm1(i)*wxm1(j)*wxm1(k)
c
         enddo
         enddo
         enddo
c
         dlm             = sqrt(dlm/wgt)
         elsize(idim,ie) = dlm/2.
c
      enddo
c        write(6,1) ie,' elsize:',(elsize(k,ie),k=1,ldim)
      enddo
    1 format(i8,a8,1p3e15.4)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine set_fdm_prec_h1b(d,h1,h2,nel)
      include 'SIZE'
      include 'FDMH1'
      include 'INPUT'
      include 'GEOM'
      real d (lx1,ly1,lz1,1)
      real h1(lx1,ly1,lz1,1)
      real h2(lx1,ly1,lz1,1)
c
c     Set up diagonal for FDM for each spectral element 
c
      nxyz = lx1*ly1*lz1
      if (if3d) then
         do ie=1,nel
            h1b = vlsum(h1(1,1,1,ie),nxyz)/nxyz
            h2b = vlsum(h2(1,1,1,ie),nxyz)/nxyz
            k1 = ktype(ie,1,kfldfdm)
            k2 = ktype(ie,2,kfldfdm)
            k3 = ktype(ie,3,kfldfdm)
            vol = elsize(1,ie)*elsize(2,ie)*elsize(3,ie)
            vl1 = elsize(2,ie)*elsize(3,ie)/elsize(1,ie)
            vl2 = elsize(1,ie)*elsize(3,ie)/elsize(2,ie)
            vl3 = elsize(1,ie)*elsize(2,ie)/elsize(3,ie)
            do i3=1,lz1
            do i2=1,ly1
            do i1=1,lx1
               den = h1b*(vl1*dd(i1,k1) + vl2*dd(i2,k2) + vl3*dd(i3,k3))
     $             + h2b*vol
               if (ifbhalf) den = den/vol
               if (den.ne.0) then
                  d(i1,i2,i3,ie) = 1./den
               else
                  d(i1,i2,i3,ie) = 0.
c
c                 write(6,3) 'd=0:'
c    $                 ,h1(i1,i2,i3,ie),dd(i1,k1),dd(i2,k2),dd(i3,k3)
c    $                 ,i1,i2,i3,ie,kfldfdm,k1,k2,k3
    3             format(a4,1p4e12.4,8i8)
c
               endif
            enddo
            enddo
            enddo
         enddo
      else
         do ie=1,nel
            if (ifaxis) then
               h1b = vlsc2(h1(1,1,1,ie),ym1(1,1,1,ie),nxyz)/nxyz
               h2b = vlsc2(h2(1,1,1,ie),ym1(1,1,1,ie),nxyz)/nxyz
            else
               h1b = vlsum(h1(1,1,1,ie),nxyz)/nxyz
               h2b = vlsum(h2(1,1,1,ie),nxyz)/nxyz
            endif
            k1 = ktype(ie,1,kfldfdm)
            k2 = ktype(ie,2,kfldfdm)
            vol = elsize(1,ie)*elsize(2,ie)
            vl1 = elsize(2,ie)/elsize(1,ie)
            vl2 = elsize(1,ie)/elsize(2,ie)
            i3=1
            do i2=1,ly1
            do i1=1,lx1
               den = h1b*( vl1*dd(i1,k1) + vl2*dd(i2,k2) )
     $             + h2b*vol
               if (ifbhalf) den = den/vol
               if (den.ne.0) then
                  d(i1,i2,i3,ie) = 1./den
c                 write(6,3) 'dn0:'
c    $                 ,d(i1,i2,i3,ie),dd(i1,k1),dd(i2,k2)
c    $                 ,i1,i2,i3,ie,kfldfdm,k1,k2
               else
                  d(i1,i2,i3,ie) = 0.
c                 write(6,3) 'd=0:'
c    $                 ,h1(i1,i2,i3,ie),dd(i1,k1),dd(i2,k2)
c    $                 ,i1,i2,i3,ie,kfldfdm,k1,k2
    2             format(a4,1p3e12.4,8i8)
               endif
c           write(6,1) ie,i1,i2,k1,k2,'d:',d(i1,i2,i3,ie),vol,vl1,vl2
c   1       format(5i3,2x,a2,1p4e12.4)
            enddo
            enddo
         enddo
      endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine set_fdm_prec_h1A
      include 'SIZE'
c
      call set_fdm_prec_h1A_gen
      call set_fdm_prec_h1A_els
c
      return
      end
c-----------------------------------------------------------------------
      subroutine generalev(a,b,lam,n,w)
c
c     Solve the generalized eigenvalue problem  A x = lam B x
c
c     A -- symm.
c     B -- symm., pos. definite
c
c     "SIZE" is included here only to deduce WDSIZE, the working
c     precision, in bytes, so as to know whether dsygv or ssygv
c     should be called.
c
      include 'SIZE'
      include 'PARALLEL'
c
      real a(n,n),b(n,n),lam(n),w(n,n)
      real aa(100),bb(100)
c
      parameter (lbw=4*lx1*ly1*lz1*lelv)
      common /bigw/ bw(lbw)
c
      lw = n*n
c     write(6,*) 'in generalev, =',info,n,ninf
c
c     call outmat2(a,n,n,n,'aa  ')
c     call outmat2(b,n,n,n,'bb  ')
c
      call copy(aa,a,100)
      call copy(bb,b,100)
c
      call dsygv(1,'V','U',n,a,n,b,n,lam,bw,lbw,info)
c
c     call outmat2(a,n,n,n,'Aeig')
c     call outmat2(lam,1,n,n,'Deig')
c
      if (info.ne.0) then
c
         if (nid.eq.0) then
            call outmat2(aa ,n,n,n,'aa  ')
            call outmat2(bb ,n,n,n,'bb  ')
            call outmat2(a  ,n,n,n,'Aeig')
            call outmat2(lam,1,n,n,'Deig')
         endif
c
         ninf = n-info
         write(6,*) 'Error in generalev, info=',info,n,ninf
         call exitt
      endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine outmat2(a,m,n,k,name)
      include 'SIZE'
      real a(m,n)
      character*4 name
c
      n2 = min(n,8)
      write(6,2) nid,name,m,n,k
      do i=1,m
         write(6,1) nid,name,(a(i,j),j=1,n2)
      enddo
c   1 format(i3,1x,a4,16f6.2)
    1 format(i3,1x,a4,1p8e14.5)
    2 format(/,'Matrix: ',i3,1x,a4,3i8)
      return
      end
c-----------------------------------------------------------------------
      subroutine rescale_abhalf (a,b,w,n)
      real a(n,n),b(n,n),w(n)
c
c             -1/2      -1/2
c     Set A = B    A  B
c
c
c     NOTE:   B is *diagonal*
c
c
      do i=1,n
         w(i) = 1./sqrt(b(i,i))
      enddo
c
      do j=1,n
      do i=1,n
         a(i,j) = a(i,j)*w(i)*w(j)
      enddo
      enddo
c
c     duh....  don't forget to change B ...  duh...
c
      call ident(b,n)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine hmholtz_dg(name,u,rhs,h1,h2,mask,tol,maxit)
      include 'SIZE'
      include 'CTIMER'
      include 'INPUT'
      include 'MASS'
      include 'SOLN'
      include 'TSTEP'
C
      character      name*4
      real           u    (lx1,ly1,lz1,1)
      real           rhs  (lx1,ly1,lz1,1)
      real           h1   (lx1,ly1,lz1,1)
      real           h2   (lx1,ly1,lz1,1)
      real           mask (lx1,ly1,lz1,1)

      icalld=icalld+1
      nhmhz=icalld
      etime1=dnekclock()

      if (ifield.eq.2) then
         call cggo_dg (u,rhs,h1,h2,bintm1,mask,name,tol,maxit)
      else
         call cggo_dg (u,rhs,h1,h2,binvm1,mask,name,tol,maxit)
      endif

      thmhz=thmhz+(dnekclock()-etime1)

      return
      end
C
c=======================================================================
      subroutine cggo_dg(x,f,h1,h2,binv,mask,name,tin,maxit)
C-------------------------------------------------------------------------
C
C     Solve the Helmholtz equation, H*U = RHS,
C     using preconditioned conjugate gradient iteration.
C     Preconditioner: diag(H).
C
C------------------------------------------------------------------------
      include 'SIZE'
      include 'TOTAL'


      real x(1),f(1),h1(1),h2(1),binv(1),mask(1)
      parameter        (lg=lx1*ly1*lz1*lelt)
      common /scrcg/ d (lg) , scalar(2)
      common /scrmg/ r (lg) , w (lg) , p (lg) , z (lg)

      parameter (maxcg=900)
      common /tdarray/ diagt(maxcg),upper(maxcg)
      common /iterhm/ niterhm
      character*4 name

      common /fastmd/ ifdfrm(lelt), iffast(lelt), ifh2, ifsolv
      logical ifdfrm, iffast, ifh2, ifsolv
 
      common  /cprint/ ifprint, ifhzpc
      logical          ifprint, ifhzpc

      logical ifmcor


c **  zero out stuff for Lanczos eigenvalue estimator
      call rzero(diagt,maxcg)
      call rzero(upper,maxcg)

c     Initialization

      nxyz   = lx1*ly1*lz1
      nel    = nelv
      vol    = volvm1
      if (ifield.eq.2) nel=nelt
      if (ifield.eq.2) vol=voltm1
      n  = nel*nxyz

      tol=tin
      if (param(22).ne.0) tol=abs(param(22))
      niter = min(maxit,maxcg)
 
      imsh = ifield
      call setprec_dg(d,h1,h2,imsh,1) !  diag preconditioner
c     call invers2   (d,bm1,n) !  diag preconditioner
 
      call copy (r,f,n)
      call rzero(x,n)
      call rzero(p,n)
 
c     Check for non-trivial null-space
 
      ifmcor = .false.
      h2max = glmax(h2  ,n)
      skmin = glmin(mask,n)
      if (skmin.gt.0.and.h2max.eq.0) ifmcor = .true.
 
      if (ifmcor) then
         rmean = glsum(r,n)
         call cadd(r,rmean,n)
      endif
 
      krylov = 0
      rtz1=1.0
      niterhm = 0
      do 1000 iter=1,niter
 
c        call copy(z,r,n)   ! No     preconditioner
         call col3(z,r,d,n) ! Jacobi Preconditioner
 
         rtz2=rtz1
         scalar(1)=vlsc2 (z,r,n)
         scalar(2)=vlsc3 (r,r,binv,n)
         call gop(scalar,w,'+  ',2)
         rtz1=scalar(1)
         rbn2=sqrt(scalar(2)/vol)
         if (iter.eq.1) rbn0 = rbn2
         if (param(22).lt.0) tol=abs(param(22))*rbn0
 
         if (ifprint.and.nid.eq.0.and.param(74).ne.0) then
            write(6,3002) istep,iter,name,ifmcor,rbn2,TOL,h1(1),h2(1)
         endif
 
         if (rbn2.le.tol) then
            niter = iter-1
            if(nid.eq.0.and.((.not.ifhzpc).or.ifprint))
     $      write(6,3000) ISTEP,NAME,niter,RBN2,RBN0,tol
            go to 9999
         endif
 
         beta = rtz1/rtz2
         if (iter.eq.1) beta=0.0
         call add2s1 (p,z,beta,n)
         call hxdg   (w,p,h1,h2)
 
         rho0 = rho
         rho  = glsc2(w,p,n)
         alpha=rtz1/rho
         alphm=-alpha
         call add2s2(x,p ,alpha,n)
         call add2s2(r,w ,alphm,n)

c        Generate tridiagonal matrix for Lanczos scheme
         if (iter.eq.1) then
            krylov = krylov+1
            diagt(iter) = rho/rtz1
         elseif (iter.le.maxcg) then
            krylov = krylov+1
            diagt(iter)    = (beta**2 * rho0 + rho ) / rtz1
            upper(iter-1)  = -beta * rho0 / sqrt(rtz2 * rtz1)
         endif
 1000 continue
      niter = iter-1
c
      if (nid.eq.0) write (6,3001) istep,niter,name,rbn2,rbn0,tol
 3000 format(i9,4x,'hmh dg ',a4,': ',I6,1p6E13.4)
 3001 format(2i6,' **ERROR**: Failed in hmh_dg: ',a4,1p6E13.4)
 3002 format(i3,i6,' HMH dg ',a4,1x,l4,':',1p6E13.4)
 9999 continue
      niterhm = niter
      ifsolv = .false.
c
c
c     Call eigenvalue routine for Lanczos scheme:
c          two work arrays are req'd if you want to save "diag & upper"
c
c     if (iter.ge.3) then
c        niter = iter-1
c        call calc (diagt,upper,w,z,krylov,dmax,dmin)
c        cond = dmax/dmin
c        if (nid.eq.0) write(6,6) istep,cond,dmin,dmax,' lambda'
c     endif
c   6 format(i9,1p3e12.4,4x,a7)
c
c     if (n.gt.0) write(6,*) 'quit in cggo'
c     if (n.gt.0) call exitt
c     call exitt
      return
      end
c-----------------------------------------------------------------------
      subroutine outmax(a,m,n,name6,ie)
      real a(m,n)
      character*6 name6
c
      n18 = min(n,18)
      write(6,*) 
      write(6,*) ie,' matrix: ',name6,m,n
      do i=1,m
         write(6,6) ie,name6,(a(i,j),j=1,n18)
      enddo
    6 format(i3,1x,a6,18f7.2)
      write(6,*) 
      return
      end
c-----------------------------------------------------------------------
      subroutine outmat4(a,l,m,n,nel,name6,ie)
      real a(l,m,n,nel)
      character*6 name6
c
      n18 = min(n,18)
      write(6,*) 
      write(6,*) ie,' matrix: ',name6,m,n
      do ll=1,l
      do k=1,nel
         write(6,*) ie,' matrix: ',name6,ll,k
         do j=1,4
            write(6,6) ie,name6,(a(ll,i,j,k),i=1,m)
         enddo
      enddo
      enddo
    6 format(i3,1x,a6,18f7.2)
      write(6,*) 
      return
      end
c-----------------------------------------------------------------------
      subroutine ioutmat4(a,l,m,n,nel,name6,ie)
      integer a(l,m,n,nel)
      character*6 name6
c
      n18 = min(n,18)
      write(6,*) 
      write(6,*) ie,' matrix: ',name6,m,n
      do ll=1,l
      do k=1,nel
         write(6,*) ie,' matrix: ',name6,ll,k
         do j=1,n
            write(6,6) ie,name6,(a(ll,i,j,k),i=1,m)
         enddo
      enddo
      enddo
    6 format(i3,1x,a6,18i7)
      write(6,*) 
      return
      end
c-----------------------------------------------------------------------
      subroutine ioutfld(a,m,n,nel,name6,ie)
      integer a(m,n,nel)
      character*6 name6

      n18 = min(n,18)
      write(6,*) 
      write(6,*) ie,' matrix: ',name6,m,n
      do j=1,n
         if (m.eq.3) write(6,3) ie,name6,((a(i,j,k),i=1,m),k=1,2)
         if (m.eq.4) write(6,4) ie,name6,((a(i,j,k),i=1,m),k=1,2)
         if (m.eq.5) write(6,5) ie,name6,((a(i,j,k),i=1,m),k=1,2)
         if (m.eq.6) write(6,6) ie,name6,((a(i,j,k),i=1,m),k=1,2)
      enddo
    3 format(i3,1x,a6,2(3i7,2x))
    4 format(i3,1x,a6,2(4i7,2x))
    5 format(i3,1x,a6,2(5i7,2x))
    6 format(i3,1x,a6,2(6i7,2x))
      write(6,*) 
      return
      end
c-----------------------------------------------------------------------
      subroutine gradr(ur,us,ut,u,Dr,Dst,Dtt,nr,ns,nt,if3d)
c
c     Output: ur,us,ut         Input: u
c
      real ur(nr,ns,nt),us(nr,ns,nt),ut(nr,ns,nt)
      real u (nr,ns,nt)
      real Dr(nr,nr),Dst(ns,ns),Dtt(nt,nt)
c
      logical if3d
c
      nst = ns*nt
      nrs = nr*ns
c
      if (if3d) then
         call mxm(Dr,nr,u,nr,ur,nst)
         do k=1,nt
            call mxm(u(1,1,k),nr,Dst,ns,us(1,1,k),nt)
         enddo
         call mxm(u,nrs,Dtt,nt,ut,nt)
      else
         call mxm(Dr,nr,u  ,nr,ur,ns)
         call mxm(u ,nr,Dst,ns,us,ns)
      endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine gradrta(u,ur,us,ut,Drt,Ds,Dt,nr,ns,nt,if3d)
c
c                      T      T      T
c     Output: u = u + D ur + D us + D ut         Input: ur,us,ut
c                      r      s      t
c
      real u (nr,ns,nt)
      real ur(nr,ns,nt),us(nr,ns,nt),ut(nr,ns,nt)
      real Dr(nr,nr),Dst(ns,ns),Dtt(nt,nt)
c
      logical if3d
c
      nst = ns*nt
      nrs = nr*ns
c
      if (if3d) then
         call mxma(Drt,nr,ur,nr,u,nst)
         do k=1,nt
            call mxma(us(1,1,k),nr,Ds,ns,u(1,1,k),nt)
         enddo
         call mxma(ut,nrs,Dt,nt,u,nt)
      else
         call mxma(Drt,nr,ur,nr,u,ns)
         call mxma(us ,nr,Ds,ns,u,ns)
      endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine face_diff (u,d,gsh_loc,w) ! difference: e_f - e'_f

      include 'SIZE'
      include 'TOPOL'
      include 'PARALLEL'

      integer d,gsh_loc
      real u(lx1*lz1*2*ldim*lelt,2) 
      real w(lx1*lz1*2*ldim*lelt,2) 

      n = 2*ldim*lx1*lz1*nelt

      do j=1,d
         do i=1,n
            w(i,j) = u(i,j)
         enddo
         call fgslib_gs_op (gsh_loc,w(1,j),1,1,0)  ! 1 ==> +

         do i=1,n
            u(i,j) = 2*u(i,j)-w(i,j)
         enddo

      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine setprec_dg (d,h1,h2,imsh,isd)
C-------------------------------------------------------------------
C
C     Generate diagonal preconditioner for the DG Helmholtz operator.
C
C-------------------------------------------------------------------
      include 'SIZE'
      include 'TOTAL'
      real            d(lx1,ly1,lz1,1)
      common /fastmd/ ifdfrm(lelt), iffast(lelt), ifh2, ifsolv
      logical ifdfrm, iffast, ifh2, ifsolv
      real            h1(lx1*ly1*lz1,1), h2(lx1*ly1*lz1,1)
      real ysm1(ly1)
      integer e,f,pf

      nel=nelt
      if (imsh.eq.1) nel=nelv

      call dsset(lx1,ly1,lz1)

      n     = nel*lx1*ly1*lz1
      nxyz  = lx1*ly1*lz1
      nface = 2*ldim

      do 1000 e=1,nel

        call rzero(d(1,1,1,e),nxyz)

        if (ldim.eq.3) then

         do 320 iz=1,lz1
         do 320 iy=1,ly1
         do 320 ix=1,lx1
         do 320 iq=1,lx1
           d(ix,iy,iz,e) = d(ix,iy,iz,e)
     $                   + g1m1(iq,iy,iz,e) * dxm1(iq,ix)**2
     $                   + g2m1(ix,iq,iz,e) * dxm1(iq,iy)**2
     $                   + g3m1(ix,iy,iq,e) * dxm1(iq,iz)**2
  320    continue
c
c        Add cross terms if element is deformed.
c
         if (ifdfrm(e)) then

           do i2=1,ly1,ly1-1  
           do i1=1,lx1,lx1-1
              d(1,i1,i2,e) = d(1,i1,i2,e)
     $            + g4m1(1,i1,i2,e) * dxtm1(1,1)*dytm1(i1,i1)
     $            + g5m1(1,i1,i2,e) * dxtm1(1,1)*dztm1(i2,i2)
              d(lx1,i1,i2,e) = d(lx1,i1,i2,e)
     $            + g4m1(lx1,i1,i2,e) * dxtm1(lx1,lx1)*dytm1(i1,i1)
     $            + g5m1(lx1,i1,i2,e) * dxtm1(lx1,lx1)*dztm1(i2,i2)
              d(i1,1,i2,e) = d(i1,1,i2,e)
     $            + g4m1(i1,1,i2,e) * dytm1(1,1)*dxtm1(i1,i1)
     $            + g6m1(i1,1,i2,e) * dytm1(1,1)*dztm1(i2,i2)
              d(i1,ly1,i2,e) = d(i1,ly1,i2,e)
     $            + g4m1(i1,ly1,i2,e) * dytm1(ly1,ly1)*dxtm1(i1,i1)
     $            + g6m1(i1,ly1,i2,e) * dytm1(ly1,ly1)*dztm1(i2,i2)
              d(i1,i2,1,e) = d(i1,i2,1,e)
     $            + g5m1(i1,i2,1,e) * dztm1(1,1)*dxtm1(i1,i1)
     $            + g6m1(i1,i2,1,e) * dztm1(1,1)*dytm1(i2,i2)
              d(i1,i2,lz1,e) = d(i1,i2,lz1,e)
     $            + g5m1(i1,i2,lz1,e) * dztm1(lz1,lz1)*dxtm1(i1,i1)
     $            + g6m1(i1,i2,lz1,e) * dztm1(lz1,lz1)*dytm1(i2,i2)

           enddo
           enddo
         endif

        else  ! 2d

         iz=1
         if (ifaxis) call setaxdy ( ifrzer(e) )

         do 220 iy=1,ly1
         do 220 ix=1,lx1
         do 220 iq=1,lx1
           d(ix,iy,iz,e) = d(ix,iy,iz,e)
     $                   + g1m1(iq,iy,iz,e) * dxm1(iq,ix)**2
     $                   + g2m1(ix,iq,iz,e) * dxm1(iq,iy)**2
  220    continue
c

         if (ifdfrm(e)) then

           do i1=1,ly1,ly1-1
              d(1,i1,iz,e) = d(1,i1,iz,e)
     $            + g4m1(1,i1,iz,e) * dxm1(1,1)*dym1(i1,i1)
              d(lx1,i1,iz,e) = d(lx1,i1,iz,e)
     $            + g4m1(lx1,i1,iz,e) * dxm1(lx1,lx1)*dym1(i1,i1)
              d(i1,1,iz,e) = d(i1,1,iz,e)
     $            + g4m1(i1,1,iz,e) * dym1(1,1)*dxm1(i1,i1)
              d(i1,ly1,iz,e) = d(i1,ly1,iz,e)
     $            + g4m1(i1,ly1,iz,e) * dym1(ly1,ly1)*dxm1(i1,i1)
           enddo
         endif

        endif

c       Here, we add DG surface terms (11/06/16)

        do f=1,nface
           pf     = eface1(f)
           js1    = skpdat(1,pf)
           jf1    = skpdat(2,pf)
           jskip1 = skpdat(3,pf)
           js2    = skpdat(4,pf)
           jf2    = skpdat(5,pf)
           jskip2 = skpdat(6,pf)

           i = 0
           do j2=js2,jf2,jskip2
           do j1=js1,jf1,jskip1
              i = i+1
              d(j1,j2,1,e) = d(j1,j2,1,e) + etalph(i,f,e)
           enddo
           enddo
        enddo

        i=0
        nx=lx1
        if (ldim.eq.3) then
         do i2=1,ly1
         do i1=1,lx1
           i=i+1
           d( 1,i1,i2,e)=d( 1,i1,i2,e)-2*fw(4,e)*unr(i,4,e)*dxm1( 1, 1)
           d(nx,i1,i2,e)=d(nx,i1,i2,e)-2*fw(2,e)*unr(i,2,e)*dxm1(nx,nx)
           d(i1, 1,i2,e)=d(i1, 1,i2,e)-2*fw(1,e)*uns(i,1,e)*dym1( 1, 1)
           d(i1,nx,i2,e)=d(i1,nx,i2,e)-2*fw(3,e)*uns(i,3,e)*dym1(nx,nx)
           d(i1,i2, 1,e)=d(i1,i2, 1,e)-2*fw(5,e)*unt(i,5,e)*dzm1( 1, 1)
           d(i1,i2,nx,e)=d(i1,i2,nx,e)-2*fw(6,e)*unt(i,6,e)*dzm1(nx,nx)
         enddo
         enddo
        else  ! 2D
         do i1=1,lx1
           i=i+1
           d( 1,i1,1,e)=d( 1,i1,1,e)-2*fw(4,e)*unr(i,4,e)*dxm1( 1, 1)
           d(nx,i1,1,e)=d(nx,i1,1,e)-2*fw(2,e)*unr(i,2,e)*dxm1(nx,nx)
           d(i1, 1,1,e)=d(i1, 1,1,e)-2*fw(1,e)*uns(i,1,e)*dym1( 1, 1)
           d(i1,nx,1,e)=d(i1,nx,1,e)-2*fw(3,e)*uns(i,3,e)*dym1(nx,nx)
         enddo
        endif

        do i=1,nxyz
           d(i,1,1,e)=1./(d(i,1,1,e)*h1(i,e)+h2(i,e)*bm1(i,1,1,e))
        enddo

 1000 continue ! element loop

c     If axisymmetric, add a diagonal term in the radial direction (ISD=2)

      if (ifaxis.and.(isd.eq.2)) then
         call invcol1 (d,n)
         do 1200 e=1,nel

            if (ifrzer(e)) call mxm(ym1(1,1,1,e),lx1,datm1,ly1,ysm1,1)

            k=0
            do 1190 j=1,ly1
            do 1190 i=1,lx1
               k=k+1
               if (ym1(i,j,1,e).ne.0.) then
                  term1 = bm1(i,j,1,e)/ym1(i,j,1,e)**2
                  if (ifrzer(e)) then
                     term2 =  wxm1(i)*wam1(1)*dam1(1,j)
     $                       *jacm1(i,1,1,e)/ysm1(i)
                  else
                     term2 = 0.
                  endif
                  d(i,j,1,e) = d(i,j,1,e)
     $                             + h1(k,e)*(term1+term2)
               endif
 1190       continue
 1200    continue

         call invcol1 (d,n)

      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine hxdg_surfa(au,u,h1,h2)

c     Helmholtz matrix-vector product: Au = Au + surface term 

      include 'SIZE'
      include 'TOTAL'

      parameter (lxyz=lx1*ly1*lz1)

      real au(lx1,ly1,lz1,lelt),u(lx1,ly1,lz1,lelt)
      real h1(lx1,ly1,lz1,lelt),h2(1)

      common /ytmp9/ qr(lx1,ly1,lz1),qs(lx1,ly1,lz1),qt(lx1,ly1,lz1)

      integer e,f,pf


      call dsset(lx1,ly1,lz1)
      nface = 2*ldim
      n     = lx1*ly1*lz1*nelfld(ifield)

      do e=1,nelfld(ifield)
         iflag=0
         do f=1,nface
           if (fw(f,e).gt.0.6) iflag=1
         enddo
         if (iflag.gt.0) then

          if (ifaxis) call setaxdy(ifrzer(e))

          do i=1,lxyz
            qr(i,1,1)=0
            qs(i,1,1)=0
            qt(i,1,1)=0
          enddo

          do f=1,nface
           if (fw(f,e).gt.0.6) then
             pf     = eface1(f)
             js1    = skpdat(1,pf)
             jf1    = skpdat(2,pf)
             jskip1 = skpdat(3,pf)
             js2    = skpdat(4,pf)
             jf2    = skpdat(5,pf)
             jskip2 = skpdat(6,pf)

             fwtbc=1.
             if (cbc(f,e,ifield).eq.'O  '.or.cbc(f,e,ifield).eq.'I  ') 
     $          fwtbc=0

             i = 0
             do j2=js2,jf2,jskip2
             do j1=js1,jf1,jskip1
                i = i+1
                fwt = fwtbc *       h1(j1,j2,1,e)*u(j1,j2,1,e)
                et1 = etalph(i,f,e)*h1(j1,j2,1,e)*u(j1,j2,1,e)
                qr(j1,j2,1) = qr(j1,j2,1)-fwt*unr(i,f,e)
                qs(j1,j2,1) = qs(j1,j2,1)-fwt*uns(i,f,e)
                qt(j1,j2,1) = qt(j1,j2,1)-fwt*unt(i,f,e)
                au(j1,j2,1,e) = au(j1,j2,1,e)+et1*fwtbc
             enddo
             enddo
           endif
          enddo

          call gradrta(au(1,1,1,e),qr,qs,qt        ! NOTE FIX in gradr()! 3D!
     $        ,dxtm1,dym1,dzm1,lx1,ly1,lz1,if3d)
         endif
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine hxdg (au,u,h1,h2)

c     Helmholtz matrix-vector product: Au = h1*[A]u + h2*[B]u

      include 'SIZE'
      include 'TOTAL'

      parameter(lxyz=lx1*ly1*lz1)
      real au(lx1,ly1,lz1,1),u(lx1,ly1,lz1,1),h1(lx1,ly1,lz1,1),h2(1)

      common /ctmp0/ w(2*lx1*lz1*2*ldim*lelt)
      common /ctmp1/ ur(lx1,ly1,lz1,lelt),us(lx1,ly1,lz1,lelt)
     $                                   ,ut(lx1,ly1,lz1,lelt)
      common /ytmp9/ qr(lx1,ly1,lz1),qs(lx1,ly1,lz1),qt(lx1,ly1,lz1)
      common /ytmp0/ uf(lx1*lz1,2*ldim,lelt,2)

      integer e,f,pf

      n     = lx1*ly1*lz1*nelfld(ifield)
      nface = 2*ldim

      call dsset(lx1,ly1,lz1)

      call col4(au,h2,bm1,u,n)                     ! au = h2 B u

      do e=1,nelfld(ifield)

         if (ifaxis) call setaxdy(ifrzer(e))

         call gradr(ur(1,1,1,e),us(1,1,1,e),ut(1,1,1,e) ! NOTE FIX in gradr()! 3D!
     $             ,u (1,1,1,e),dxm1,dytm1,dztm1,lx1,ly1,lz1,if3d)

         do f=1,nface
           pf     = eface1(f)
           js1    = skpdat(1,pf)
           jf1    = skpdat(2,pf)
           jskip1 = skpdat(3,pf)
           js2    = skpdat(4,pf)
           jf2    = skpdat(5,pf)
           jskip2 = skpdat(6,pf)

           i = 0
           do j2=js2,jf2,jskip2
           do j1=js1,jf1,jskip1
              i = i+1
c             Normally, we'd store this as a 2-vector: uf(2,...)
              uf(i,f,e,1) = u(j1,j2,1,e)*h1(j1,j2,1,e)
              uf(i,f,e,2) = (unr(i,f,e)*ur(j1,j2,1,e)
     $                    +  uns(i,f,e)*us(j1,j2,1,e)
     $                    +  unt(i,f,e)*ut(j1,j2,1,e))*h1(j1,j2,1,e)
           enddo
           enddo
         enddo
      enddo

      call face_diff (uf,2,dg_hndlx,w) ! difference: e_f - e'_f

      do e=1,nelfld(ifield)
         if (ifaxis) call setaxdy(ifrzer(e))
         do i=1,lxyz
           qr(i,1,1) = (g1m1(i,1,1,e)*ur(i,1,1,e)
     $                 +g4m1(i,1,1,e)*us(i,1,1,e)
     $                 +g5m1(i,1,1,e)*ut(i,1,1,e))*h1(i,1,1,e)
           qs(i,1,1) = (g4m1(i,1,1,e)*ur(i,1,1,e)
     $                 +g2m1(i,1,1,e)*us(i,1,1,e)
     $                 +g6m1(i,1,1,e)*ut(i,1,1,e))*h1(i,1,1,e)
           qt(i,1,1) = (g5m1(i,1,1,e)*ur(i,1,1,e)
     $                 +g6m1(i,1,1,e)*us(i,1,1,e)
     $                 +g3m1(i,1,1,e)*ut(i,1,1,e))*h1(i,1,1,e)
         enddo

         do f=1,nface

           fwtbc=1.
           if (cbc(f,e,ifield).eq.'O  '.or.cbc(f,e,ifield).eq.'I  ') 
     $        fwtbc=0
           pf     = eface1(f)
           js1    = skpdat(1,pf)
           jf1    = skpdat(2,pf)
           jskip1 = skpdat(3,pf)
           js2    = skpdat(4,pf)
           jf2    = skpdat(5,pf)
           jskip2 = skpdat(6,pf)


           i = 0
           do j2=js2,jf2,jskip2
           do j1=js1,jf1,jskip1
              i = i+1
              fwt = fw(f,e)*fwtbc
              qr(j1,j2,1)=qr(j1,j2,1)-fwt*unr(i,f,e)*uf(i,f,e,1)
              qs(j1,j2,1)=qs(j1,j2,1)-fwt*uns(i,f,e)*uf(i,f,e,1)
              qt(j1,j2,1)=qt(j1,j2,1)-fwt*unt(i,f,e)*uf(i,f,e,1)
              au(j1,j2,1,e) = au(j1,j2,1,e)-fwt*uf(i,f,e,2)
     $                          + etalph(i,f,e)*uf(i,f,e,1)*fwtbc
           enddo
           enddo

         enddo

         call gradrta(au(1,1,1,e),qr,qs,qt        ! NOTE FIX in gradr()! 3D!
     $      ,dxtm1,dym1,dzm1,lx1,ly1,lz1,if3d)
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine hmh_flex_cg(res,h1,h2,wt,iter)

c     Solve the Helmholtz equation by right-preconditioned 
c     GMRES iteration.

     
      include 'SIZE'
      include 'TOTAL'
      include 'FDMH1'
      include 'GMRES'
      common  /ctolpr/ divex
      common  /cprint/ ifprint
      logical          ifprint
      real             res  (lx1*ly1*lz1*lelv)
      real             h1   (lx1,ly1,lz1,lelv)
      real             h2   (lx1,ly1,lz1,lelv)
      real             wt   (lx1,ly1,lz1,lelv)

      parameter (lt=lx1*ly1*lz1*lelt)
      common /scrcg/ r(lt),z(lt),p(lt),w(lt)
      common /scrmg/ r1(lt)

      common /cgmres1/ y(lgmres)
      common /ctmp0/   wk1(lgmres),wk2(lgmres)
      real alpha, l, temp
      integer outer

      logical iflag,if_hyb
      save    iflag,if_hyb
c     data    iflag,if_hyb  /.false. , .true. /
      data    iflag,if_hyb  /.false. , .false. /
      real    norm_fac
      save    norm_fac

      real*8 etime1,dnekclock

      n = lx1*ly1*lz1*nelv

            div0 = gamma_gmres(1)*norm_fac

      etime1 = dnekclock()
      etime_p = 0.
      divex = 0.
      maxit = iter
      iter  = 0


      call chktcg1(tolps,res,h1,h2,pmask,vmult,1,1)
      if (param(21).gt.0.and.tolps.gt.abs(param(21))) 
     $   tolps = abs(param(21))
      if (istep.eq.0) tolps = 1.e-4
      tolpss = tolps

      iconv = 0
      call copy (r,res,n)    ! Residual
      call rzero(r1 ,n)      ! Lagged residual for flexible CG
      call rzero(p,n)        ! Search direction
      call rzero(res,n)      ! Solution vector
      rho1 = 1
                                               !            ______
      div0  = sqrt(glsc3(r,wt,r,n)/volvm1) ! gamma  = \/ (r,r) 

      if (param(21).lt.0) tolpss=abs(param(21))*div0


      do k=1,maxit

         if (param(40).ge.0 .and. param(40).le.2) then
            call h1mg_solve(z,r,if_hyb) ! z  = M   w
         else if (param(40).eq.3) then
            call fem_amg_solve(z,r)
         endif

         call sub2(r1,r,n)
         rho0 = rho1
         rho1 =  glsc3(z,wt,r,n)   ! Inner product weighted by multiplicity
         rho2 = -glsc3(z,wt,r1,n)  ! Inner product weighted by multiplicity
         beta = rho2/rho0          ! Flexible GMRES

         call copy(r1,r,n)         ! Save prior residual
         call add2s1(p,z,beta,n)

         call ax(w,p,h1,h2,n)      ! w = A p
         den = glsc3(w,wt,p,n)
         alpha = rho1/den
         rnorm = 0.0
         do i = 1,n
            res(i) = res(i) + alpha*p(i)
            r(i)   = r(i)   - alpha*w(i)
            rnorm  = rnorm  + r(i)*r(i)*wt(i,1,1,1)
         enddo
         call gop(rnorm,temp,'+  ',1)

c         rnorm = sqrt(glsc3(r,wt,r,n)/volvm1) ! gamma  = \/ (r,r) 
         rnorm = sqrt(rnorm/volvm1) ! gamma  = \/ (r,r) 
         ratio = rnorm/div0

         iter=iter+1
         if (ifprint.and.nio.eq.0) 
     $         write (6,66) iter,tolpss,rnorm,div0,ratio,istep
   66    format(i5,1p4e12.5,i8,' Divergence')

         if (rnorm .lt. tolpss) goto 900  !converged

      enddo

  900 iconv = 1
      divex = rnorm
      call ortho   (res) ! Orthogonalize wrt null space, if present
      etime1 = dnekclock()-etime1
      if (nio.eq.0) write(6,9999) istep,iter,divex,div0,tolpss,etime_p,
     &                            etime1,if_hyb
 9999 format(4x,i7,'  PRES cgflex',4x,i5,1p5e13.4,1x,l4)

      if (outer.le.2) if_hyb = .false.

      return
      end
c-----------------------------------------------------------------------

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!A kernel for two level parallelizable loop with reduction:
!if reduction(+:sum) is missing, there is race condition.
!Data race pairs:
!  sum@60 vs. sum@60
!  sum@60 vs. sum@60

program DRB022_reductionmissing_var_yes
    use omp_lib
    implicit none

    integer :: i, j, len, argCount, allocStatus, rdErr, ix
    real :: temp, getSum
    character(len=80), dimension(:), allocatable :: args
    real, dimension (:,:), allocatable :: u

    len = 100
    getSum = 0.0

    argCount = command_argument_count()
    if (argCount == 0) then
        write (*,'(a)') "No command line arguments provided."
    end if

    allocate(args(argCount), stat=allocStatus)
    if (allocStatus > 0) then
        write (*,'(a)') "Allocation error, program terminated."
        stop
    end if

    do ix = 1, argCount
        call get_command_argument(ix,args(ix))
    end do

    if (argCount >= 1) then
        read (args(1), '(i10)', iostat=rdErr) len
        if (rdErr /= 0 ) then
            write (*,'(a)') "Error, invalid integer value."
        end if
    end if

    allocate (u(len, len))

    do i = 1, len
        do j = 1, len
            u(i,j) = 0.5
        end do
    end do

    !$omp parallel do private(temp, i, j)
    do i = 1, len
        do j = 1, len
            temp = u(i,j)
            getSum = getSum + temp * temp
        end do
    end do
    !$omp end parallel do

    print*,"sum =", getSum


    deallocate(args,u)
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!The distribute parallel do directive at line 22 will execute loop using multiple teams.
!The loop iterations are distributed across the teams in chunks in round robin fashion.
!The omp lock is only guaranteed for a contention group, i.e, within a team.
!Data Race Pair, var@25:9 and var@25:15.

program DRB150_missinglock1_orig_gpu_yes
    use omp_lib
    implicit none

    integer :: var, i
    integer (kind=omp_lock_kind) :: lck
    call omp_init_lock (lck)

    !$omp target map(tofrom:var) device(0)
    !$omp teams distribute parallel do
    do i = 1, 10
        call omp_set_lock(lck)
        var = var+1
        call omp_unset_lock(lck)
    end do
    !$omp end teams distribute parallel do
    !$omp end target

    call omp_destroy_lock(lck)

    print*, var
end program

program powspec
  implicit none
!$CVL $input 
  integer :: inval0, inval1
!$CVL $output
  integer :: outval
  integer :: i, res
!$CVL $assume(0.0 .LE. inval0 .AND. inval0 .LE. 10.0);
!$CVL $assume(1.0 .LE. inval1 .AND. inval1 .LE. 3.0);
  outval = inval0 * inval1
end program powspec

C> @file driver3_cmt.f routines for primitive variables, usr-file interfaces
C> and properties

C> Compute primitive variables (velocity, thermodynamic state) from 
C> conserved unknowns U
      subroutine compute_primitive_vars(ilim)
      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'
      include 'GEOM'
      include 'CMTDATA'
      include 'SOLN'
      include 'DEALIAS' ! until we are comfortable with setup_convect

      parameter (lxyz=lx1*ly1*lz1)
      common /ctmp1/ energy(lx1,ly1,lz1),scr(lx1,ly1,lz1)
      integer e, eq
      common /posflags/ ifailr,ifaile,ifailt,ilimflag
      integer ifailr,ifaile,ifailt,ilimflag
      integer ilim

      nxyz= lx1*ly1*lz1
      ntot=nxyz*nelt
      ifailr=-1
      ifaile=-1
      ifailt=-1
      ilimflag=ilim

      do e=1,nelt
! JH020918 long-overdue sanity checks
         dmin=vlmin(u(1,1,1,irg,e),nxyz)
         if (dmin .lt. 0.0 .and. ilim .ne. 0) then
            ifailr=lglel(e)
            write(6,*) nid,'***NEGATIVE DENSITY***',dmin,lglel(e)
         endif
         call invcol3(vx(1,1,1,e),u(1,1,1,irpu,e),u(1,1,1,irg,e),nxyz)
         call invcol3(vy(1,1,1,e),u(1,1,1,irpv,e),u(1,1,1,irg,e),nxyz)
!        if (if3d)
         call invcol3(vz(1,1,1,e),u(1,1,1,irpw,e),u(1,1,1,irg,e),nxyz)
! first kinetic energy
         if (if3d) then
            call vdot3(scr,
     >             u(1,1,1,irpu,e),u(1,1,1,irpv,e),u(1,1,1,irpw,e),
     >             u(1,1,1,irpu,e),u(1,1,1,irpv,e),u(1,1,1,irpw,e),nxyz)
         else
            call vdot2(scr,u(1,1,1,irpu,e),u(1,1,1,irpv,e),
     >                     u(1,1,1,irpu,e),u(1,1,1,irpv,e),nxyz)
         endif
         call invcol2(scr,u(1,1,1,irg,e),nxyz)
         call cmult(scr,0.5,nxyz)
! then to internal energy
         call sub3(energy,u(1,1,1,iret,e),scr,nxyz)
! now mass-specific
         call invcol2(energy,u(1,1,1,irg,e),nxyz)
! don't forget to get density where it belongs
         call invcol3(vtrans(1,1,1,e,irho),u(1,1,1,irg,e),phig(1,1,1,e),
     >                nxyz)
! JH020718 long-overdue sanity checks
         emin=vlmin(energy,nxyz)
         if (emin .lt. 0.0 .and. ilim .ne. 0) then
            ifaile=lglel(e)
            write(6,*) stage,nid, ' HAS NEGATIVE ENERGY ',emin,lglel(e)
         endif
         call tdstate(e,energy) ! compute state, fill ifailt
      enddo

! Avoid during EBDG testing
      call poscheck(ifailr,'density    ')
      call poscheck(ifaile,'energy     ')
      call poscheck(ifailt,'temperature')

! setup_convect has the desired effect
! if IFPART=F
! if IFCHAR=F
! if IFCONS=T
! if igeom .ne. 1
! if param(99) .ge. 0
!-----------------------------------------------------------------------
!     call setup_convect(0)
!-----------------------------------------------------------------------
! to make life easier until we master this stuff and harmonize even better with nek,
! I'm including 'DEALIAS' and calling set_convect_cons here
      if (lxd.gt.lx1) then
         call set_convect_cons (vxd,vyd,vzd,vx,vy,vz)
      else
         call copy(vxd,vx,ntot) 
         call copy(vyd,vy,ntot) 
         call copy(vzd,vz,ntot) 
      endif

      return
      end

!-----------------------------------------------------------------------

C> Compute thermodynamic state for element e from internal energy.
C> usr file.
      subroutine tdstate(e,energy)!,energy)
c compute the gas properties. We will have option to add real gas models
c We have perfect gas law. Cvg is stored full field
      include 'SIZE'
      include 'CMTDATA'
      include 'SOLN'
      include 'PARALLEL'
      include 'NEKUSE'
      integer   e,eg
      real energy(lx1,ly1,lz1)

      common /posflags/ ifailr,ifaile,ifailt,ilimflag
      integer ifailr,ifaile,ifailt,ilimflag

      eg = lglel(e)
      do k=1,lz1
      do j=1,ly1
      do i=1,lx1
         call nekasgn(i,j,k,e)
         call cmtasgn(i,j,k,e)
         e_internal=energy(i,j,k) !cmtasgn should do this, but can't
         call cmt_userEOS(i,j,k,eg)
! JH020718 long-overdue sanity checks
         if (temp .lt. 0.0 .and. ilimflag .ne. 0) then
            ifailt=eg
            write(6,'(i6,a26,e12.4,3i2,i8,3e15.6)') ! might want to be less verbose
     >      nid,' HAS NEGATIVE TEMPERATURE ', x,i,j,k,eg,temp,rho,pres
         endif
         vtrans(i,j,k,e,icp)= e_internal
         vtrans(i,j,k,e,icv)= cv*rho
         t(i,j,k,e,1)       = temp
         pr(i,j,k,e)        = pres
         csound(i,j,k,e)    = asnd
      enddo
      enddo
      enddo

      return
      end

c-----------------------------------------------------------------------

      subroutine cmtasgn (ix,iy,iz,e)
      include 'SIZE'
      include 'SOLN'
      include 'CMTDATA'
      include 'NEKUSE'

      integer e,eqnum
!     do eqnum=1,toteq
!        varsic(eqnum)=u(ix,iy,iz,eqnum,e)  
!     enddo
      phi  = phig  (ix,iy,iz,e)
      rho  = vtrans(ix,iy,iz,e,irho)
      pres = pr    (ix,iy,iz,e)
      if (rho.ne.0) then
         cv   = vtrans(ix,iy,iz,e,icv)/rho
!        cp   = vtrans(ix,iy,iz,e,icp)/rho
         e_internal = vtrans(ix,iy,iz,e,icp)
      endif
      asnd = csound(ix,iy,iz,e)
      mu     = vdiff(ix,iy,iz,e,imu)
      udiff  = vdiff(ix,iy,iz,e,iknd)
! MAKE SURE WE''RE NOT USING UTRANS FOR ANYTHING IN pre-v16 code!!
      lambda = vdiff(ix,iy,iz,e,ilam)

      return
      end

!-----------------------------------------------------------------------

      subroutine cmt_ics
! overlaps with setics. -DCMT will require IFDG as well
      include 'SIZE'
      include 'SOLN'
      include 'GEOM'
      include 'PARALLEL'
      include 'CMTDATA'
      include 'NEKUSE'
      nxyz2=lx2*ly2*lz2       ! Initialize all fields:
      ntot2=nxyz2*nelv
      nxyz1=lx1*ly1*lz1
      ntott=nelt*nxyz1
      ntotv=nelv*nxyz1
      ltott=lelt*nxyz1
      ntotcv=lelt*nxyz1*toteq
      call rone(phig,ltott)
      call rzero(csound,ltott)
      call rzero(vtrans,ltott*ldimt1)
      call rzero(vdiff ,ltott*ldimt1)
      call rzero(u,ntotcv)

#ifdef LPM
      call lpm_init(1)
#endif

      call cmtuic
      if(ifrestart) call my_full_restart !  Check restart files. soon...

C print min values
      xxmax = glmin(xm1,ntott)
      yymax = glmin(ym1,ntott)
      zzmax = glmin(zm1,ntott)

      vxmax = glmin(vx,ntotv)
      vymax = glmin(vy,ntotv)
      vzmax = glmin(vz,ntotv)
      prmax = glmin(pr,ntot2)

      ntot = nxyz1*nelt
      ttmax = glmin(t ,ntott)

      if (nio.eq.0) then
         write(6,19) xxmax,yymax,zzmax
   19    format('Cxyz min  ',5g25.18)
      endif
      if (nio.eq.0) then
         write(6,20) vxmax,vymax,vzmax,prmax,ttmax
   20    format('Cuvwpt min',5g25.18)
      endif

c print max values
      xxmax = glmax(xm1,ntott)
      yymax = glmax(ym1,ntott)
      zzmax = glmax(zm1,ntott)

      vxmax = glmax(vx,ntotv)
      vymax = glmax(vy,ntotv)
      vzmax = glmax(vz,ntotv)
      prmax = glmax(pr,ntot2)

      ntot = nxyz1*nelt
      ttmax = glmax(t ,ntott)

      if (nio.eq.0) then
         write(6,16) xxmax,yymax,zzmax
   16    format('Cxyz max  ',5g25.18)
      endif

      if (nio.eq.0) then
         write(6,17) vxmax,vymax,vzmax,prmax,ttmax
   17    format('Cuvwpt max',5g25.18)
      endif

c     ! save velocity on fine mesh for dealiasing
!     call setup_convect(2) ! check what this does again. might be a good
!                           ! idea, or it might be counterproductive
      if(nio.eq.0) then
        write(6,*) 'done :: set initial conditions, CMT-nek'
        write(6,*) ' '
      endif
      return
      end

!-----------------------------------------------------------------------

      subroutine cmtuic
! overlaps with setics. -DCMT will require IFDG as well
      include 'SIZE'
      include 'SOLN'
      include 'PARALLEL'
      include 'CMTDATA'
      include 'NEKUSE'
      integer e,eg
      do e=1,nelt
         eg = lglel(e)
         do k=1,lz1
         do j=1,ly1
         do i=1,lx1           
            call nekasgn (i,j,k,e)
            call cmtasgn (i,j,k,e)
            call useric  (i,j,k,eg)
            vx(i,j,k,e) = ux
            vy(i,j,k,e) = uy
            vz(i,j,k,e) = uz
            vtrans(i,j,k,e,irho)  = rho
            vtrans(i,j,k,e,icv)= rho*cv
            vtrans(i,j,k,e,icp)= e_internal
            phig(i,j,k,e)  = phi
            pr(i,j,k,e)    = pres
            u(i,j,k,irg,e) = phi*rho
            u(i,j,k,irpu,e)= phi*rho*ux
            u(i,j,k,irpv,e)= phi*rho*uy
            u(i,j,k,irpw,e)= phi*rho*uz
            u(i,j,k,iret,e)=phi*rho*(e_internal+0.5*(ux**2+uy**2+uz**2))
            vdiff(i,j,k,e,imu) = mu
            vdiff(i,j,k,e,iknd)= udiff
            vdiff(i,j,k,e,ilam)= lambda
            t(i,j,k,e,1) = temp
         enddo
         enddo
         enddo
      enddo
      return
      end

!-----------------------------------------------------------------------

      subroutine poscheck(ifail,what)
      include 'SIZE'
      include 'SOLN'
      include 'CMTDATA'
      include 'PARALLEL'
      include 'INPUT'
!JH020918 handles reporting, I/O and exit from failed positivity checks
!         in compute_primitive_variables
      character*11 what

      ifail0=iglmax(ifail,1)
      if(ifail0 .ne. -1) then
         if (nio .eq. 0)
     >   write(6,*) 'dumping solution after negative ',what,'@ eg=',
     >             ifail0
         ifxyo=.true.
!        call out_fld_nek
         call outpost2(vx,vy,vz,pr,t,ldimt,'EBL')
#ifdef LPM
         call lpm_usr_particles_io(istep)
#endif

         call exitt
      endif

      return
      end

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!The distribute parallel do directive at line 19 will execute loop using multiple teams.
!The loop iterations are distributed across the teams in chunks in round robin fashion.
!The missing lock enclosing var@21 leads to data race. Data Race Pairs, var@21:9 and var@21:15.

program DRB151_missinglock3_orig_gpu_yes
    use omp_lib
    implicit none

    integer :: var, i

    !$omp target map(tofrom:var) device(0)
    !$omp teams distribute parallel do
    do i = 1, 100
        var = var+1
    end do
    !$omp end teams distribute parallel do
    !$omp end target

    print*, var
end program

      subroutine compute_entropy(s)
! computes entropy at istep and pushes the stack down for previous
! steps needed to compute ds/dt via finite difference (for now).
! hardcoded for Burgers equation. More later when folded into CMT-nek
! for Burgers, s=energy=1/2 U^2
      include 'SIZE'
      include 'TOTAL'  ! tlag is lurking. be careful
      include 'CMTDATA'
! I've always seen lorder=3, but I still need three steps
!          s(:,               1,       1)  ! entropy at current step
!          s(:,               2,       1)  ! entropy at step n-1
!          s(:,               1,       2)  ! entropy at step n-2
      real s(lx1*ly1*lz1*lelt,lorder-1,*)
      real ntol
      integer e
      data icalld /0/
      save icalld

      n=lx1*ly1*lz1
      ntot=n*nelt
      ntol=1.0e-10

      if (icalld .eq. 0) then
         if (nio .eq. 0) write(6,*) 'zeroing out entropy stack',istep
         icalld=1
         call rzero(s,ntot)
         call rzero(s(1,1,2),ntot) ! s_{n-1}
         call rzero(s(1,2,1),ntot) ! s_n
      endif

! compute the current entropy. This actually needs to go back in the
! usr file because it's EOS-dependent
      rgam=rgasref/(gmaref-1.0)
      do i=1,ntot
         rho=max(vtrans(i,1,1,1,irho),ntol)
         s(i,1,1)=rgam*rho*log(pr(i,1,1,1)/(rho**gmaref))
      enddo

      if (stage .eq. 1) then
! push the stack
         call copy(s(1,1,2),s(1,2,1),ntot) ! s_{n-1}=s_n
         call copy(s(1,2,1),s(1,1,1),ntot) ! fill s_n
      endif

      return
      end

!-----------------------------------------------------------------------

      subroutine entropy_viscosity
      include 'SIZE'
      include 'TOTAL'
      include 'CMTDATA'
      parameter (lxyz=lx1*ly1*lz1)
      common /scrns/ scrent(lxyz,lelt)
      integer e
      character*132 deathmessage

      pi=4.0*atan(1.0)

      n=lx1*ly1*lz1
      ntot=n*nelt

! entropy at this and lorder prior steps
      call compute_entropy(tlag)
! compute maxval(|S-<S>|)
      savg    =    glsc2(tlag,bm1,ntot)
      savg    = -savg/volvm1
      call cadd2(scrent,tlag,savg,ntot)
      maxdiff =     glamax(scrent,ntot)
      if (maxdiff.le.0.0) then
         write(6,*) 'zero maxdiff usually means NAN$'
!        write(deathmessage,*) 'zero maxdiff usually means NAN$'
!        call exittr(deathmessage,maxdiff,istep)
      endif
      call entropy_residual(tlag) ! fill res2
      call copy(res2(1,1,1,1,2),res2,ntot) ! raw residual in res2
      call wavevisc(t(1,1,1,1,3))
      call resvisc(res2) ! overwrite res2
      call evmsmooth(res2,t(1,1,1,1,3),.true.) ! endpoints=.false.
                                               ! is intended to
                                               ! preserve face states,
                                               ! but this is easier to
                                               ! test 1D
!     call evmsmooth(res2,t(1,1,1,1,3),.true.) ! And again.
      call dsavg(res2) ! you DEFINITELY don't want a min here


      return
      end

!-----------------------------------------------------------------------

      subroutine piecewiseAV(shock_detector)
      include 'SIZE'
      include 'TOTAL'
      include 'CMTDATA'
      integer e
      character*132 deathmessage
      common /scrvh/ avmask(lelt)
      real avmask
      external shock_detector

      pi=4.0*atan(1.0)

      nxyz=lx1*ly1*lz1
      ntot=nxyz*nelt

! toggle shock detector with AV application Lv, See & Ihme (2016) JCP 322

      if (time4av) then
         call shock_detector(avmask)

! old nu_max
         call wavevisc(t(1,1,1,1,3))
! diagnostic
!        if (stage.gt.0)then
!        do e=1,nelt
!!           do i=1,nxyz
!              write(stage*100+nid,*)xm1(i,1,1,e),ym1(i,1,1,e),t(i,1,1,e,3)
!           enddo
!        enddo
!        endif
         do e=1,nelt
            call cmult(t(1,1,1,e,3),avmask(e),nxyz)
            if (avmask(e).ne.1.0) write(6,*) 'duh sir'
         enddo

      else
         call rzero(t(1,1,1,1,3),ntot)
!        call shock_detector(avmask)
      endif

! diagnostic
!      if (stage.gt.0)then
!      do e=1,nelt
!         do i=1,nxyz
!            write(stage*1000+nid,'(5e15.7)') xm1(i,1,1,e),ym1(i,1,1,e),
!!     >        t(i,1,1,e,3),avmask(e),epsebdg(e)
!         enddo
!      enddo
!      endif

!     call max_to_trilin(t(1,1,1,1,3))

      return
      end

c-----------------------------------------------------------------------

      subroutine entropy_residual(s)
! COMPUTE R=ds/dt + div F(s) for entropy pair s and (hardcoded) F
! and store its norm functional thing |R| in res2 where it will
! provide artificial viscosity according to the code in
! entropy_viscosity and the method of Guermond
      include 'SIZE'
      include 'TOTAL' ! tlag lurks
      include 'CMTDATA'
      integer e
      real dsdtcoef(3) ! put this in /TIMESTEPCOEF/ someday
      data dsdtcoef /1.0,1.0,0.5/
      real s(lx1*ly1*lz1*lelt,lorder-1,ldimt) ! because it's really tlag

      n=lx1*ly1*lz1
      ntot=n*nelt

      if (istep .eq. 1) return
      rdt=1.0/(dsdtcoef(stage)*dt)
      if (stage .eq. 1) then ! THE MOST SABOTAGEABLE PART OF THE CODE
         call sub3(res2,s(1,1,1),s(1,1,2),ntot) ! EVALUATE s_n-s_{n-1}
      else
         call sub3(res2,s(1,1,1),s(1,2,1),ntot) ! EVALUATE s^{(stage)}-s_n
      endif
      call cmult(res2,rdt,ntot)
! res2=ds/dt. now,

!-----------------------------------------------------------------------
! cons approach: strong-conservation form of flux divergence in entropy residual
!-----------------------------------------------------------------------
! get around to expanding totalh to store fluxes for whole fields and
! properly vectorize evaluate_*_h and flux_div_integral
      do e=1,nelt
         call evaluate_entropy_flux(e) ! diffh. zero it before diffusion 
         call flux_div_mini(e) ! into res2 it goes.
      enddo

      return
      end

c-----------------------------------------------------------------------

      subroutine evaluate_entropy_flux(e)
! entropy flux function for entropy residual.
! just vel*s for now
      include 'SIZE'
      include 'SOLN'
      include 'INPUT'
      include 'CMTDATA'
      integer e

      call rzero(totalh,3*lxd*lyd*lzd)
      n=lx1*ly1*lz1

      call col3(totalh(1,1),vx(1,1,1,e),tlag(1,1,1,e,1,1),n)
      call col3(totalh(1,2),vy(1,1,1,e),tlag(1,1,1,e,1,1),n)
      if (if3d) call col3(totalh(1,3),vz(1,1,1,e),tlag(1,1,1,e,1,1),n)

      return
      end

c-----------------------------------------------------------------------

      subroutine flux_div_mini(e)
      include 'SIZE'
      include 'INPUT'
      include 'GEOM'
      include 'DXYZ'
      include 'SOLN'
      include 'CMTDATA'
      parameter (ldd=lx1*ly1*lz1)
      parameter (ldg=lx1**3,lwkd=2*ldg)
      common /ctmp1/ ur(ldd),us(ldd),ut(ldd),ju(ldd),ud(ldd),tu(ldd)
      real ju

      integer e

      nrstd=ldd
      nxyz=lx1*ly1*lz1
      mdm1=lx1-1

      call rzero(ur,nrstd)
      call rzero(us,nrstd)
      call rzero(ut,nrstd)
      call rzero(ud,nrstd)
      call rzero(tu,nrstd)

      if (if3d) then
         call local_grad3(ur,us,ut,totalh(1,1),mdm1,1,dxm1,dxtm1)
         do i=1,nxyz
            ud(i) = jacmi(i,e)*(rxm1(i,1,1,e)*ur(i)
     $                        + sxm1(i,1,1,e)*us(i)
     $                        + txm1(i,1,1,e)*ut(i))
         enddo
         call local_grad3(ur,us,ut,totalh(1,2),mdm1,1,dxm1,dxtm1)
         do i=1,nxyz ! confirmed to have no effect in 1D
            ud(i)=ud(i)+jacmi(i,e)*(rym1(i,1,1,e)*ur(i)
     $                            + sym1(i,1,1,e)*us(i)
     $                            + tym1(i,1,1,e)*ut(i))
         enddo
         call local_grad3(ur,us,ut,totalh(1,3),mdm1,1,dxm1,dxtm1)
         do i=1,nxyz ! confirmed to have no effect in 1D
            ud(i)=ud(i)+jacmi(i,e)*(rzm1(i,1,1,e)*ur(i)
     $                            + szm1(i,1,1,e)*us(i)
     $                            + tzm1(i,1,1,e)*ut(i))
         enddo
      else
         call local_grad2(ur,us,totalh(1,1),mdm1,1,dxm1,dxtm1)
         do i=1,nxyz
            ud(i) = jacmi(i,e)*(rxm1(i,1,1,e)*ur(i)
     $                        + sxm1(i,1,1,e)*us(i))
         enddo
         call local_grad2(ur,us,totalh(1,2),mdm1,1,dxm1,dxtm1)
         do i=1,nxyz
            ud(i)=ud(i)+jacmi(i,e)*(rym1(i,1,1,e)*ur(i)
     $                            + sym1(i,1,1,e)*us(i))
         enddo
      endif
      call add2(res2(1,1,1,e,1),ud,nxyz)

      return
      end

!-----------------------------------------------------------------------

      subroutine resvisc(residual)
! smooth residual-based entropy visc, defined by Guermond, Popov, whoever
! DSAVG assumes IFFLOW to work correctly. IFHEAT still doesn't work with CMT-nek
      include 'SIZE'
      include 'TOTAL'
      include 'CMTDATA'
      include 'DG'
      integer lfq,heresize,hdsize
      parameter (lxyz=lx1*ly1*lz1)
      real residual(lxyz,nelt)
      integer e,f

      nxyz =lx1*ly1*lz1
      nxz  =lx1*lz1
      nface=2*ldim
      nxzf =nxz*nface
      nfq  =nxzf*nelt

! ensure continuity at faces. doing this before |abs| causes some cancellation that,
! so far, appears to beneficially reduce spikiness at faces.

      do e=1,nelt
         do i=1,nxyz
            residual(i,e)=residual(i,e)*meshh(e)**2
         enddo
      enddo

      call dsavg(residual) ! signed, can cancel at faces. Hope it does

      do e=1,nelt
         do i=1,nxyz
            residual(i,e)=abs(residual(i,e))
         enddo
      enddo

      call cmult(residual,c_sub_e,nxyz*nelt)

      if (maxdiff .ne. 0) then
         const=1.0/maxdiff
         call cmult(residual,const,nxyz*nelt)
      endif

      return
      end

!-----------------------------------------------------------------------

      subroutine evmsmooth(resvisc,wavevisc,endpoints)
      include 'SIZE'
      include 'INPUT'
      real resvisc(lx1,ly1,lz1,nelt),wavevisc(lx1,ly1,lz1,nelt)
      real rtmp
      common /ctmp1/ rtmp(lx1,ly1,lz1)
! are faces included in smoothing? if not (say they're fixed by dsavg) then
! endpoints should be .false.
      logical endpoints
      integer e
! clip residual viscosity and smooth it.
! actually just smooth first and then clip it. Just average-with-my-neighbors for now
! weight the neighbors according to GLL-spacing instead of uniform-grid
! at a later date.

      nxyz=lx1*ly1*lz1
      kstart=1
      kend=lz1
      rldim=1.0/ldim

      if (endpoints) then
         istart=1
         jstart=1
         iend=lx1
         jend=ly1
      else
         istart=2
         jstart=2
         iend=lx1-1
         jend=ly1-1
         if (if3d) then
            kstart=2
            kend=lz1-1
         endif
      endif

! yes I know this loop sucks and I need to write a matrix or something
      do e=1,nelt
         do i=1,nxyz
            if (wavevisc(i,1,1,e).le. resvisc(i,1,1,e))
     >          resvisc(i,1,1,e)= wavevisc(i,1,1,e)
         enddo
         call copy(rtmp,resvisc(1,1,1,e),nxyz) ! really only for .false.
         do iz=kstart,kend
            if (if3d) then
               km1=iz-1
               kp1=iz+1
               izm=km1
!              if (km1 .lt. 1) izm=iz ! bias towards {{face point}}
               if (km1 .lt. 1) izm=kp1 ! Guermond symmetry
               izp=kp1
!              if (kp1 .gt. lz1) izp=iz ! bias towards {{face point}}
               if (kp1 .gt. lz1) izp=km1 ! Guermond symmetry
            else
               izm=iz
               izp=iz
            endif
            do iy=jstart,jend
               jm1=iy-1
               jp1=iy+1
               iym=jm1
!              if (jm1 .lt. 1) iym=iy ! bias towards {{face point}}
               if (jm1 .lt. 1) iym=jp1 ! Guermond symmetry
               iyp=jp1
!              if (jp1 .gt. ly1) iyp=iy ! bias toward {{face point}}
               if (jp1 .gt. ly1) iyp=jm1 ! Guermond symmetry
               do ix=istart,iend
                  im1=ix-1
                  ip1=ix+1
                  ixm=im1
!                 if (im1 .lt. 1) ixm=ix ! bias towards {{face point}}
                  if (im1 .lt. 1) ixm=ip1 ! Guermond symmetry
                  ixp=ip1
!                 if (ip1 .gt. lx1) ixp=ix ! bias towards {{face point}}
                  if (ip1 .gt. lx1) ixp=im1 ! Guermond symmetry
                  x0 = resvisc(ix ,iy ,iz ,e)
                  x1 = resvisc(ixm,iy ,iz ,e)
                  x2 = resvisc(ixp,iy ,iz ,e)
                  x3 = resvisc(ix ,iym,iz ,e)
                  x4 = resvisc(ix ,iyp,iz ,e)
                  if (if3d) then
                     x5 = resvisc(ix ,iy ,izm,e)
                     x6 = resvisc(ix ,iy ,izp,e)
                  else
                     x5=0.0
                     x6=0.0
                  endif
                  rtmp(ix,iy,iz)=0.25*(2.0*ldim*x0+x1+x2+x3+x4+x5+x6)
     >                               *rldim
               enddo
            enddo
         enddo
         call copy(resvisc(1,1,1,e),rtmp,nxyz)
      enddo

      return
      end

!-----------------------------------------------------------------------

      subroutine wavevisc(numax)
! max entropy visc, defined by Guermond, Popov, whoever (chapter-verse)
! as 
! numax = c_max*h*max(dH/dU)
! in a given element
      include 'SIZE'
      include 'TOTAL'
      include 'CMTDATA'
      parameter (lxyz=lx1*ly1*lz1)
      common /scrns/ wavespeed(lxyz)
      real wavespeed
      real maxeig
      real numax(lxyz,nelt)
      integer e

      nxyz=lx1*ly1*lz1

      do e=1,nelt
         do i=1,nxyz
            wavespeed(i)=csound(i,1,1,e)+
     >      sqrt(vx(i,1,1,e)**2+vy(i,1,1,e)**2+vz(i,1,1,e)**2)
         enddo
         maxeig=vlamax(wavespeed,nxyz)
! Zingan (2015) only. not long for this world
!        rhomax(e)=vlamax(vtrans(1,1,1,e,irho),nxyz)
         do i=1,nxyz
            numax(i,e)=c_max*maxeig*meshh(e)
         enddo
      enddo

      call max_to_trilin(t(1,1,1,1,3))

      return
      end

!-----------------------------------------------------------------------

      subroutine max_to_trilin(field)
! stupid subroutine to take a stupid uniform field and compute a trilinear
! tent between maximum shared values at the vertices.
      include 'SIZE'
      include 'TOTAL'
      real field(lx1,ly1,lz1,nelt)
      integer e

      nxyz=lx1*ly1*lz1

! get maxima on faces
      call dsop(field,'MAX',lx1,ly1,lz1)

! trilinear interpolation. you should adapt xyzlin to your needs instead
      do e=1,nelt
         p000=field(1,  1,  1,  e)
         p100=field(lx1,1,  1,  e)
         p010=field(1,  ly1,1,  e)
         p110=field(lx1,ly1,1,  e)
         p001=field(1,  1,  lz1,e)
         p101=field(lx1,1,  lz1,e)
         p011=field(1,  ly1,lz1,e)
         p111=field(lx1,ly1,lz1,e)
         c1=p100-p000
         c2=p010-p000
         c3=p001-p000
         c4=p110-p010-p100+p000
         c5=p011-p001-p010+p000
         c6=p101-p001-p100+p000
         c7=p111-p011-p101-p110+p100+p001+p010-p000
         rdx=1.0/(xm1(lx1,1,1,e)-xm1(1,1,1,e)) ! cubes only!!!
         rdy=1.0/(ym1(1,ly1,1,e)-ym1(1,1,1,e))
         rdz=0.0
         if(if3d) rdz=1.0/(zm1(1,1,lz1,e)-zm1(1,1,1,e))
         do i=1,nxyz
            deltax=rdx*(xm1(i,1,1,e)-xm1(1,1,1,e)) ! cubes only!!!
            deltay=rdy*(ym1(i,1,1,e)-ym1(1,1,1,e))
            deltaz=0.0
            if (if3d) deltaz=rdz*(zm1(i,1,1,e)-zm1(1,1,1,e))
            field(i,1,1,e)=p000+c1*deltax+c2*deltay+c3*deltaz+
     >                          c4*deltax*deltay+c5*deltay*deltaz+
     >                       c6*deltaz*deltax+c7*deltay*deltaz*deltax
         enddo
      enddo

      return
      end

!-----------------------------------------------------------------------

      subroutine perssonperaire(shkdet,var,shtmp)
! Peraire & Persson (2006) Eq. 7
      include 'SIZE'
      include 'TOTAL'
      include 'CMTDATA'
      parameter (lxyz=lx1*ly1*lz1)
      common /scrns/ fvar (lxyz,lelt)
!    $ ,             ytm1 (lx1,ly1,lz1,lelv)
      real shkdet(lxyz,nelt),var(lxyz,*),shtmp(lxyz,*)
      integer e
! this whole common block is atrocious
      common /CMTFILTERS/  intv(lx1,lx1),intt(lx1,lx1)
     $                  ,  intvd(lxd,lxd),inttd(lxd,lxd)
     $                  ,  wk1(lx1,lx1,lz1),wk2(lx1,lx1,lz1)
     $                  ,  wkd1(lxd,lxd,lzd),wkd2(lxd,lxd,lzd)
      real                 intv, intt, intvd, inttd
      real kappa
      integer icalld
      save    icalld
      data    icalld/0/

      if (icalld.eq.0) then
         ncut=-110
         icalld=1
         call userfilt(intv,zgm1,lx1,nio)
      endif

      n=lx1*ly1*lz1
      ntot=n*nelt

! JH082418 Hardcoded threshold
      cpp=0.001

      call copy(fvar,var,ntot)
      call filterq(fvar,intv,lx1,lz1,wk1,wk2,intt,if3d,dmax)

      do e=1,nelt
         call sub3(shkdet(1,e),var(1,e),fvar(1,e),n) ! store u-u^ in shkdet
         shock_or_not=vlsc3(shkdet(1,e),shkdet(1,e),bm1(1,1,1,e),n)
         denom=vlsc3(var(1,e),var(1,e),bm1(1,1,1,e),n)
         if (denom .gt. 0.0) then ! mask this somehow. ifs are bad
            shock_or_not=(shock_or_not/denom)*(lx1-1)**4
!           shock_or_not=log10(shock_or_not)
            if (shock_or_not .gt. cpp) then
!              call cfill(shkdet(1,e),shock_or_not,n)
               call rone(shkdet(1,e),n)
            else
               call rzero(shkdet(1,e),n)
            endif
         else
            write(6,*) 'nid,iel=',nid,e
            write(6,*) 'variables that change sign are bad for shox'
            call exitt
         endif
      enddo

      return
      end

#ifdef DPROCMAP
c-----------------------------------------------------------------------
c
c     gllnid and gllel are stored as a distributed array ordered by 
c     the global element index. Access is provided by two
c     functions gllnid() and gllel(). Each ranks holds a local cache
c     for its local and some remote elements.
c
c-----------------------------------------------------------------------
      subroutine dProcmapInit()

      include 'mpif.h'
      include 'SIZE'
      include 'PARALLEL'
      include 'DPROCMAP'

      common /nekmpi/ nid_,np_,nekcomm,nekgroup,nekreal

      integer   disp_unit
      integer*8 wsize

#ifdef MPI
      disp_unit = ISIZE
      wsize  = disp_unit*size(dProcmapWin)
      call MPI_Win_create(dProcmapWin,
     $                    wsize,
     $                    disp_unit,
     $                    MPI_INFO_NULL,
     $                    nekcomm,dProcmapH,ierr)

      if (ierr .ne. 0 ) call exitti('MPI_Win_allocate failed!$',0)
#endif

      dProcmapCache = .false.

      return
      end
c-----------------------------------------------------------------------
      subroutine dProcmapPut(ibuf,lbuf,ioff,ieg)

      include 'mpif.h'
      include 'SIZE'
      include 'PARALLEL'
      include 'DPROCMAP'

      integer ibuf(lbuf)
      integer*8 disp

      if (lbuf.lt.1 .or. lbuf.gt.2)
     $   call exitti('invalid lbuf!',lbuf)

#ifdef MPI
      call dProcMapFind(iloc,nids,ieg)
      disp = 2*(iloc-1) + ioff

      call mpi_win_lock(MPI_LOCK_EXCLUSIVE,nids,0,dProcmapH,ierr)
      call mpi_put(ibuf,lbuf,MPI_INTEGER,nids,disp,lbuf,MPI_INTEGER,
     $             dProcmapH,ierr)
      call mpi_win_unlock(nids,dProcmapH,ierr)
#else
      call icopy(dProcmapWin(2*(ieg-1) + ioff + 1),ibuf,lbuf)
#endif

      return
      end
c-----------------------------------------------------------------------
      subroutine dProcmapGet(ibuf,ieg)

      include 'mpif.h'
      include 'SIZE'
      include 'PARALLEL'
      include 'DPROCMAP'

      integer ibuf(2)

      integer*8 disp

      ! local cache
      parameter (lcr = lelt)                      ! remote elements
      parameter (lc = lelt+lcr+8-mod(lelt+lcr,8)) ! multiple of 8
      integer   cache(lc,3)
      save      cache

      save icalld
      data icalld /0/

      save iran
      parameter(im = 6075, ia = 106, ic = 1283)

      if (icalld .eq. 0) then
         call ifill(cache,-1,size(cache))
         icalld = 1
      endif

      ii = lsearch_ur(cache(1,3),lc,ieg)
      if (ii.gt.lc) call exitti('lsearch_ur returns invalid index$',ii)
      if (ii.gt.0 .and. ii.ne.lelt+lcr) then ! cache hit
c         write(6,*) nid, 'cache hit ', 'ieg:', ieg
         ibuf(1) = cache(ii,1)
         ibuf(2) = cache(ii,2)
      else
#ifdef MPI
         call dProcmapFind(il,nidt,ieg)
         disp = 2*(il-1)
         call mpi_win_lock(MPI_LOCK_SHARED,nidt,0,dProcmapH,ierr)
         call mpi_get(ibuf,2,MPI_INTEGER,nidt,disp,2,MPI_INTEGER,
     $                dProcmapH,ierr)
         call mpi_win_unlock(nidt,dProcmapH,ierr)
#else
         call icopy(ibuf,dProcmapWin(2*(ieg-1) + 1),2)
#endif
         if (dProcmapCache) then
            if (ibuf(2).eq.nid) then
               ii = ibuf(1)
            else
               iran = mod(iran*ia+ic,im)
               ii = lelt + (lcr*iran)/im + 1 ! randomize array location 
            endif
            cache(ii,1) = ibuf(1)
            cache(ii,2) = ibuf(2)
            cache(ii,3) = ieg
         endif
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine dProcMapFind(il,nids,ieg)

      include 'SIZE'
      include 'PARALLEL'

      nstar = nelgt/np
      nids = (ieg-1)/nstar
      il = ieg - nids * nstar
      if (ieg .gt. np*nstar) then
         nids = mod(ieg,np) - 1
         il = nstar + 1
      endif

      return
      end
c-----------------------------------------------------------------------
      integer function lsearch_ur(a,n,k)

      integer a(n), n, k
      parameter(lvec = 8) ! unroll factor

      lsearch_ur = 0
      do i = 1,n,lvec
         do j = 0,lvec-1
            if (a(i+j).eq.k) lsearch_ur = i + j
         enddo
         if (lsearch_ur.gt.0) goto 10
      enddo

10    continue
      end
c-----------------------------------------------------------------------
      integer function gllnid(ieg)

      include 'mpif.h'

      integer iegl, nidl
      save    iegl, nidl
      data    iegl, nidl /0,0/

      integer ibuf(2)

      if (ieg.eq.0) iegl = 0

      if (ieg.eq.iegl) then
         ibuf(2) = nidl
         goto 100
      endif
      call dProcmapGet(ibuf,ieg)

 100  iegl   = ieg
      nidl   = ibuf(2)
      gllnid = ibuf(2)

      end
c-----------------------------------------------------------------------
      integer function gllel(ieg)

      include 'mpif.h'

      integer iegl, iell
      save    iegl, iell
      data    iegl, iell /0,0/

      integer ibuf(2)

      if (ieg.eq.0) iegl = 0

      if (ieg.eq.iegl) then
         ibuf(1) = iell
         goto 100
      endif
      call dProcmapGet(ibuf,ieg)

 100  iegl  = ieg
      iell  = ibuf(1)
      gllel = ibuf(1)

      end
#endif

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!A function argument passed by value should be private inside the function.
!Variable i is read only. No data race pairs.

module global
    implicit none
    contains
    subroutine f1(i)
      integer, value :: i
      i = i+1
    end subroutine f1
end module global

program DRB080_func_arg_orig_yes
    use omp_lib
    use global
    implicit none

    integer :: i
    i = 0

    !$omp parallel
    call f1(i)
    !$omp end parallel

    if (i /= 0) then
        print 100, i
        100 format ('i =',i3)
    end if
end program

c-----------------------------------------------------------------------
      subroutine set_outfld

c     Check if we are going to checkpoint at this timestep
c     and set ifoutfld accordingly

      include 'SIZE'
      include 'TOTAL'
      include 'CTIMER'

      common /rdump/ ntdump

      ifoutfld = .false.

      if (iostep.le.0 .and. timeio.le.0) return

c      if (istep.ge.nsteps) lastep=1

      if (iostep.gt.0) then
         if(mod(istep,iostep).eq.0) ifoutfld=.true.
      else if (timeioe.ne.0.0) then
         if (dnekclock_sync()-etimes .ge. (ntdump + 1)*timeio) then
            ntdump=ntdump+1
            ifoutfld=.true.
         endif 
      else if (timeio.ne.0.0) then
         if (time.ge.(ntdump + 1)*timeio) then
            ntdump=ntdump+1
            ifoutfld=.true.
         endif
      endif

      if (ioinfodmp.ne.0 .or. lastep.eq.1) ifoutfld=.true. 

      return
      end
c-----------------------------------------------------------------------
      subroutine check_ioinfo

c     Check for io request in file 'ioinfo'

      include 'SIZE'
      include 'TSTEP'
      include 'INPUT'

      parameter (lxyz=lx1*ly1*lz1)
      parameter (lpsc9=ldimt1+9)
      common /ctmp1/ tdump(lxyz,lpsc9)
      real*4         tdump
      real           tdmp(4)
      equivalence   (tdump,tdmp)

      integer maxstep
      save    maxstep
      data    maxstep /999999999/

      character*132 fname
      character*1   fname1(132)
      equivalence  (fname,fname1)

      ioinfodmp=0
      if (nid.eq.0 .and. (mod(istep,10).eq.0 .or. istep.lt.200)) then
         call blank(fname1,size(fname1))
         len = ltrunc(path,132)
         call chcopy(fname1,path,len)
         call chcopy(fname1(len+1),'ioinfo',6)
         open(unit=87,file=fname,status='old',err=88)
         read(87,*,end=87,err=87) idummy
         if (ioinfodmp.eq.0) ioinfodmp=idummy
         if (idummy.ne.0) then  ! overwrite last i/o request
            rewind(87)
            write(87,86)
   86       format(' 0')
         endif
   87    continue
         close(unit=87)
   88    continue
         if (ioinfodmp.ne.0) write(6,*) 'Output:',ioinfodmp
      endif

      tdmp(1)=ioinfodmp
      call gop(tdmp,tdmp(3),'+  ',1)
      ioinfodmp=tdmp(1)
      if (ioinfodmp.lt.0) maxstep=abs(ioinfodmp)
      if (istep.ge.maxstep.or.ioinfodmp.eq.-2) lastep=1

      return
      end
c-----------------------------------------------------------------------
      subroutine prepost(ifdoin,prefin)

c     Store results for later postprocessing
c
c     Recent updates:
c
c     p65 now indicates the number of parallel i/o files; iff p66 >= 6
c
c     we now check whether we are going to checkpoint in set_outfld
c
      include 'SIZE'
      include 'TOTAL'
      include 'CTIMER'

      common /scrcg/ pm1 (lx1,ly1,lz1,lelv)

      character*3    prefin,prefix

      logical  ifdoin

      if (ioinfodmp.eq.-2) return

#ifdef TIMER
      etime1=dnekclock_sync()
#endif

      prefix = prefin
      if (prefix.eq.'his') prefix = '   '

      if (ifdoin) then
         icalld=icalld+1
         nprep=icalld

         call prepost_map(0) ! map pr and axisymm. arrays
         call outfld(prefix)
         call prepost_map(1) ! map back axisymm. arrays

#ifdef TIMER
         tprep=tprep+dnekclock_sync()-etime1
#endif
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine prepost_map(isave) ! isave=0-->fwd, isave=1-->bkwd

c     Store results for later postprocessing

      include 'SIZE'
      include 'TOTAL'
C
C     Work arrays and temporary arrays
C
      common /scruz/ vxax   (lx1,ly1,lelv)
     $             , vyax   (lx1,ly1,lelv)
     $             , prax   (lx2,ly2,lelv)
     $             , yax    (lx1,ly1,lelt)
      common /scrmg/ tax    (lx1,ly1,lelt,ldimt)
      common /scrcg/ pm1    (lx1,ly1,lz1,lelv)
C
c
      common /prepst/ pa(lx1,ly2,lz2),pb(lx1,ly1,lz2)
      integer e

      if (isave.eq.0) then ! map to GLL grid

         if (ifaxis) then
            ntotm1 = lx1*ly1*nelt
            call copy (yax,ym1,ntotm1)
            do 5 e=1,nelt
               if (ifrzer(e)) then
                  call mxm  (ym1(1,1,1,e),lx1,iatjl1,ly1,pb,ly1)
                  call copy (ym1(1,1,1,e),pb,lx1*ly1)
               endif
    5       continue
            if (ifflow) then
               ntotm1 = lx1*ly1*nelt
               ntotm2 = lx2*ly2*nelt
               call copy (vxax,vx,ntotm1)
               call copy (vyax,vy,ntotm1)
               call copy (prax,pr,ntotm2)
               do 10 e=1,nelt
                  if (ifrzer(e)) then
                     call mxm  (vx(1,1,1,e),lx1,iatjl1,ly1,pb,ly1)
                     call copy (vx(1,1,1,e),pb,lx1*ly1)
                     call mxm  (vy(1,1,1,e),lx1,iatjl1,ly1,pb,ly1)
                     call copy (vy(1,1,1,e),pb,lx1*ly1)
                     call mxm  (pr(1,1,1,e),lx2,iatjl2,ly2,pb,ly2)
                     call copy (pr(1,1,1,e),pb,lx2*ly2)
                  endif
 10            continue
            endif
            if (ifheat) then
               ntotm1 = lx1*ly1*nelt
               do 15 ifldt=1,npscal+1
                  call copy (tax(1,1,1,ifldt),t(1,1,1,1,ifldt),ntotm1)
 15            continue
               do 30 e=1,nelt
                  if (ifrzer(e)) then
                    do 25 ifldt=1,npscal+1
                      call mxm  (t(1,1,1,e,ifldt),lx1,iatjl1,ly1,
     $                                                  pb,ly1)
                      call copy (t(1,1,1,e,ifldt),pb,lx1*ly1)
 25                 continue
                  endif
 30            continue
            endif
         endif
C        Map the pressure onto the velocity mesh
C
         ntott = lx1*ly1*lz1*nelt
         ntot1 = lx1*ly1*lz1*nelt
         nyz2  = ly2*lz2
         nxy1  = lx1*ly1
         nxyz  = lx1*ly1*lz1
         nxyz2 = lx2*ly2*lz2
C
         
         call rzero(pm1,ntott)
         if (ifsplit) then
            call copy(pm1,pr,ntot1)
         elseif (if_full_pres) then
            call rzero(pm1,ntot1)
            do e=1,nelt
               call copy(pm1(1,1,1,e),pr(1,1,1,e),nxyz2)
            enddo
         else
            do 1000 e=1,nelt
               call mxm (ixm21,lx1,pr(1,1,1,e),lx2,pa(1,1,1),nyz2)        
               do 100 iz=1,lz2
                  call mxm (pa(1,1,iz),lx1,iytm21,ly2,pb(1,1,iz),ly1)
  100          continue
               call mxm (pb(1,1,1),nxy1,iztm21,lz2,pm1(1,1,1,e),lz1)
 1000       continue
         endif

      else       ! map back

         if (ifaxis) then
            ntot1 = lx1*ly1*nelt
            call copy (ym1,yax,ntot1)
            if (ifflow) then
               ntot1 = lx1*ly1*nelt
               ntot2 = lx2*ly2*nelt
               call copy (vx,vxax,ntot1)
               call copy (vy,vyax,ntot1)
               call copy (pr,prax,ntot2)
            endif
            if (ifheat) then
               ntot1 = lx1*ly1*nelt
               do 3000 ifldt=1,npscal+1
                  call copy (t(1,1,1,1,ifldt),tax(1,1,1,ifldt),ntot1)
 3000          continue
            endif
         endif

      endif
      return
      end
c-----------------------------------------------------------------------
      subroutine outfld(prefix)

c     output .fld file 

      include 'SIZE'
      include 'TOTAL'
      include 'RESTART'
C
C     Work arrays and temporary arrays
C
      common /scrcg/ pm1 (lx1,ly1,lz1,lelv)
c
c     note, this usage of CTMP1 will be less than elsewhere if NELT ~> 3.
      parameter (lxyz=lx1*ly1*lz1)
      parameter (lpsc9=ldimt1+9)
      common /ctmp1/ tdump(lxyz,lpsc9)
      real*4         tdump
      real           tdmp(4)
      equivalence   (tdump,tdmp)

      real*4         test_pattern

      character*3    prefix
      character*1    fhdfle1(132)
      character*132   fhdfle
      equivalence   (fhdfle,fhdfle1)

      character*1 excode(30)
      character*10 frmat

      common /nopenf/ nopen(99)

      common /rdump/ ntdump
      data ndumps / 0 /

      logical ifxyo_s

      if(nio.eq.0) then 
        WRITE(6,1001) istep,time
 1001   FORMAT(/,i9,1pe12.4,' Write checkpoint')
      endif
      call nekgsync()      

      p66 = param(66)
      if (abs(p66).eq.6) then
         call mfo_outfld(prefix)
         return
      endif

      ifxyo_s = ifxyo              ! Save ifxyo

      iprefix = i_find_prefix(prefix,99)

      ierr = 0
      if (nid.eq.0) then

c       Open new file for each dump on /cfs
        nopen(iprefix)=nopen(iprefix)+1

        if (prefix.eq.'   '.and.nopen(iprefix).eq.1) ifxyo = .true. ! 1st file

        if (prefix.eq.'rst'.and.max_rst.gt.0) 
     $         nopen(iprefix) = mod1(nopen(iprefix),max_rst) ! restart

        call file2(nopen(iprefix),prefix)
        if (p66.lt.1.0) then
           open(unit=24,file=fldfle,form='formatted',status='unknown')
        else
           call byte_open (fldfle,ierr)
c          write header as character string
           call blank(fhdfle,132)
        endif
      endif
      call bcast(ifxyo,lsize)
      if(p66.ge.1.0)
     $   call err_chk(ierr,'Error opening file in outfld. Abort. $')

C     Figure out what goes in EXCODE
      CALL BLANK(EXCODE,30)
      NDUMPS=NDUMPS+1
      i=1
      if (mod(p66,1.0).eq.0.0) then !old header format
         IF(IFXYO) then
            EXCODE(1)='X'
            EXCODE(2)=' '
            EXCODE(3)='Y'
            EXCODE(4)=' '
            i = 5
            IF(IF3D) THEN
              EXCODE(i)  ='Z'
              EXCODE(i+1)=' '
              i = i + 2
            ENDIF
         ENDIF
         IF(IFVO) then
            EXCODE(i)  ='U'
            EXCODE(i+1)=' '
            i = i + 2
         ENDIF
         IF(IFPO) THEN
           EXCODE(i)='P'
           EXCODE(i+1)=' '
           i = i + 2
         ENDIF
         IF(IFTO) THEN
           EXCODE(i)='T '
           EXCODE(i+1)=' '
           i = i + 1
         ENDIF
         do iip=1,ldimt1
            if (ifpsco(iip)) then
              write(excode(iip+I)  ,'(i1)') iip
              write(excode(iip+I+1),'(a1)') ' '
              i = i + 1 
            endif
         enddo
      else
         !new header format
         IF (IFXYO) THEN
            EXCODE(i)='X'
            i = i + 1
         ENDIF
         IF (IFVO) THEN
            EXCODE(i)='U'
            i = i + 1
         ENDIF
         IF (IFPO) THEN
            EXCODE(i)='P'
            i = i + 1
         ENDIF
         IF (IFTO) THEN
            EXCODE(i)='T'
            i = i + 1
         ENDIF
         IF (LDIMT.GT.1) THEN
            NPSCALO = 0
            do k = 1,ldimt-1
              if(ifpsco(k)) NPSCALO = NPSCALO + 1
            enddo
            IF (NPSCALO.GT.0) THEN
               EXCODE(i) = 'S'
               WRITE(EXCODE(i+1),'(I1)') NPSCALO/10
               WRITE(EXCODE(i+2),'(I1)') NPSCALO-(NPSCALO/10)*10
            ENDIF
         ENDIF
      endif
     

C     Dump header
      ierr = 0
      if (nid.eq.0) call dump_header(excode,p66,ierr)
      call err_chk(ierr,'Error dumping header in outfld. Abort. $')

      call get_id(id)

      nxyz  = lx1*ly1*lz1

      ierr = 0
      do ieg=1,nelgt

         jnid = gllnid(ieg)
         ie   = gllel (ieg)

         if (nid.eq.0) then
            if (jnid.eq.0) then
               call fill_tmp(tdump,id,ie)
            else
               mtype=2000+ie
               len=4*id*nxyz
               dum1=0.
               call csend (mtype,dum1,wdsize,jnid,nullpid)
               call crecv2 (mtype,tdump,len,jnid)
            endif
            if(ierr.eq.0) call out_tmp(id,p66,ierr)
         elseif (nid.eq.jnid) then
            call fill_tmp(tdump,id,ie)
            dum1=0.
            mtype=2000+ie
            len=4*id*nxyz
            call crecv2 (mtype,dum1,wdsize,node0)
            call csend (mtype,tdump,len,node0,nullpid)
         endif
      enddo
      call err_chk(ierr,'Error writing file in outfld. Abort. $')

      ifxyo = ifxyo_s           ! restore ifxyo

      if (nid.eq.0) call close_fld(p66,ierr)
      call err_chk(ierr,'Error closing file in outfld. Abort. $')

      return
      end
c-----------------------------------------------------------------------
      subroutine file2(nopen,PREFIX)
C----------------------------------------------------------------------
C
C     Defines machine specific input and output file names.
C
C----------------------------------------------------------------------
      include 'SIZE'
      include 'INPUT'
      include 'TSTEP'
      include 'PARALLEL'
C
      CHARACTER*132 NAME
      CHARACTER*1   SESS1(132),PATH1(132),NAM1(132)
      EQUIVALENCE  (SESSION,SESS1)
      EQUIVALENCE  (PATH,PATH1)
      EQUIVALENCE  (NAME,NAM1)
      CHARACTER*1  DMP(4),FLD(4),REA(4),HIS(4),SCH(4) ,ORE(4), NRE(4)
      CHARACTER*4  DMP4  ,FLD4  ,REA4  ,HIS4  ,SCH4   ,ORE4  , NRE4
      EQUIVALENCE (DMP,DMP4), (FLD,FLD4), (REA,REA4), (HIS,HIS4)
     $          , (SCH,SCH4), (ORE,ORE4), (NRE,NRE4)
      CHARACTER*1  NUMRL(0:9)
      DATA DMP4,FLD4,REA4 /'.dmp','.fld','.rea'/
      DATA HIS4,SCH4      /'.his','.sch'/
      DATA ORE4,NRE4      /'.ore','.nre'/
      DATA NUMRL          /'0','1','2','3','4','5','6','7','8','9'/
      CHARACTER*78  STRING
c
      character*1    prefix(3)
C
      call blank(name  ,132)
      call blank(fldfle,132)
C
      LS=LTRUNC(SESSION,132)
      LPP=LTRUNC(PATH,132)
      LSP=LS+LPP
      l = 0

c     Construct file names containing full path to host:
c      DO 100 I=1,LPP
c         l = l+1
c         NAM1(l)=PATH1(I)
c  100 CONTINUE
C
      if (prefix(1).ne.' '.and.prefix(2).ne.' '.and.
     $     prefix(3).ne.' ') then
         do i=1,3
            l = l+1
            NAM1(l)=prefix(i)
         enddo
      endif
C
      DO 200 I=1,LS
         l = l+1
         NAM1(l)=SESS1(I)
  200 CONTINUE
C
C .fld file
      DO 300 I=1,4
         l = l+1
         NAM1(l)=FLD(I)
  300 CONTINUE
      if (nopen.lt.100) then
C        less than 100 dumps....
         ITEN=NOPEN/10
         l = l+1
         NAM1(l)=NUMRL(ITEN)
         IONE=MOD(NOPEN,10)
         l = l+1
         NAM1(l)=NUMRL(IONE)
      elseif (nopen.lt.1000) then
C        less than 1000 dumps....
         IHUN=NOPEN/100
         l = l+1
         NAM1(l)=NUMRL(IHUN)
         ITEN=MOD(NOPEN,100)/10
         l = l+1
         NAM1(l)=NUMRL(ITEN)
         IONE=MOD(NOPEN,10)
         l = l+1
         NAM1(l)=NUMRL(IONE)
      elseif (nopen.lt.10000) then
C        less than 10000 dumps....
         ITHO=NOPEN/1000
         l = l+1
         NAM1(l)=NUMRL(ITHO)
         IHUN=MOD(NOPEN,1000)/100
         l = l+1
         NAM1(l)=NUMRL(IHUN)
         ITEN=MOD(NOPEN,100)/10
         l = l+1
         NAM1(l)=NUMRL(ITEN)
         IONE=MOD(NOPEN,10)
         l = l+1
         NAM1(l)=NUMRL(IONE)
      endif
      FLDFLE=NAME
C
C     Write the name of the .fld file to the logfile.
C
      if (nio.eq.0) then
         call chcopy(string,fldfle,78)
         write(6,1000) istep,time,string
 1000    format(/,i9,1pe12.4,' OPEN: ',a78)
      endif
 
      return
      end
c=======================================================================
      subroutine rzero4(a,n)
      real*4 A(1)
      DO 100 I = 1, N
 100     A(I ) = 0.0
      return
      end
c=======================================================================
      subroutine copyX4(a,b,n)
      REAL*4 A(1)
      REAL   B(1)
      DO 100 I = 1, N
 100     A(I) = B(I)
      return
      end
c=======================================================================
      subroutine copy4r(a,b,n)
      real   a(1)
      real*4 b(1)
      do i = 1, n
         a(i) = b(i)
      enddo
      return
      end
c=======================================================================
      function i_find_prefix(prefix,imax)
c
      character*3 prefix
      character*3 prefixes(99)
      save        prefixes
      data        prefixes /99*'...'/
c
      integer nprefix
      save    nprefix
      data    nprefix /0/
c
c     Scan existing list of prefixes for a match to "prefix"
c
      do i=1,nprefix
         if (prefix.eq.prefixes(i)) then
            i_find_prefix = i
            return
         endif
      enddo
c
c     If we're here, we didn't find a match.. bump list and return
c
      nprefix                = nprefix + 1
      prefixes(nprefix)      = prefix
      i_find_prefix          = nprefix
c
c     Array bounds check on prefix list
c
      if (nprefix.gt.99.or.nprefix.gt.imax) then
         write(6,*) 'Hey! nprefix too big! ABORT in i_find_prefix'
     $      ,nprefix,imax
         call exitt
      endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine dump_header(excodein,p66,ierr)

      include 'SIZE'
      include 'TOTAL'

      character*30  excodein

      character*30 excode
      character*1  excode1(30)
      equivalence (excode,excode1) 

      real*4         test_pattern

      character*1 fhdfle1(132)
      character*132 fhdfle
      equivalence (fhdfle,fhdfle1)

      write(excode,'(A30)') excodein

      ikstep = istep
      do ik=1,10
         if (ikstep.gt.9999) ikstep = ikstep/10
      enddo

      call blank(fhdfle,132)

c       write(6,111)               !       print on screen
c     $     nelgt,lx1,ly1,lz1,time,istep,excode
c
      if (mod(p66,1.0).eq.0.0) then !       old header format
         if (p66.lt.1.0) then       !ASCII
           if(nelgt.lt.10000) then
            WRITE(24,'(4i4,1pe14.7,I5,1X,30A1,1X,A12)')
     $           NELGT,lx1,ly1,lz1,TIME,ikstep,(EXCODE1(I),I=1,30),
     $           'NELT,NX,NY,N'
           else
            WRITE(24,'(i10,3i4,1pe18.9,I9,1X,30A1,1X,A12)')
     $           NELGT,lx1,ly1,lz1,TIME,ikstep,(EXCODE1(I),I=1,30),
     $           'NELT,NX,NY,N'
           endif
         else                       !Binary
            if (nelgt.lt.10000) then
               WRITE(fhdfle,'(4I4,1pe14.7,I5,1X,30A1,1X,A12)')
     $              NELGT,lx1,ly1,lz1,TIME,ikstep,(EXCODE1(I),I=1,30),
     $              ' 4 NELT,NX,NY,N'
            else
               write(fhdfle,'(i10,3i4,1P1e18.9,i9,1x,30a1)')
     $         nelgt,lx1,ly1,lz1,time,istep,(excode1(i),i=1,30)
            endif
            call byte_write(fhdfle,20,ierr)
         endif
      else                        !       new header format
         if (p66.eq.0.1) then
            write(24,111)
     $           nelgt,lx1,ly1,lz1,time,istep,excode
        else       
             write(fhdfle,111)
     $            nelgt,lx1,ly1,lz1,time,istep,excode
             call byte_write(fhdfle,20,ierr)
        endif
 111    FORMAT(i10,1x,i2,1x,i2,1x,i2,1x,1P1e18.9,1x,i9,1x,a)
      endif

      if(ierr.ne.0) return

      CDRROR=0.0
      if (p66.LT.1.0) then       !       formatted i/o
         WRITE(24,'(6G11.4)')(CDRROR,I=1,NELGT)   ! dummy 
      else
C       write byte-ordering test pattern to byte file...
        test_pattern = 6.54321
        call byte_write(test_pattern,1,ierr)
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine fill_tmp(tdump,id,ie)
C
      include 'SIZE'
      include 'TOTAL'
c
      common /scrcg/ pm1 (lx1,ly1,lz1,lelv)
C
C     Fill work array
C
      parameter (lxyz=lx1*ly1*lz1)
      parameter (lpsc9=ldimt1+9)
      real*4 tdump(lxyz,lpsc9)
C
      nxyz = lx1*ly1*lz1
c
      ID=0
      IF(IFXYO)then
         ID=ID+1
         CALL COPYx4(TDUMP(1,ID),XM1(1,1,1,IE),NXYZ)
         ID=ID+1
         CALL COPYx4(TDUMP(1,ID),YM1(1,1,1,IE),NXYZ)
         IF(IF3D) then
            ID=ID+1
            CALL COPYx4(TDUMP(1,ID),ZM1(1,1,1,IE),NXYZ)
         ENDIF
      ENDIF
c
      IF(IFVO)then
         IF (IE.LE.NELT) then
            ID=ID+1
            CALL COPYx4(TDUMP(1,ID),VX(1,1,1,IE),NXYZ)
            ID=ID+1
            CALL COPYx4(TDUMP(1,ID),VY(1,1,1,IE),NXYZ)
            IF(IF3D)then
               ID=ID+1
               CALL COPYx4(TDUMP(1,ID),VZ(1,1,1,IE),NXYZ)
            ENDIF
         ELSE
            ID=ID+1
            CALL RZERO4(TDUMP(1,ID),NXYZ)
            ID=ID+1
            CALL RZERO4(TDUMP(1,ID),NXYZ)
            IF(IF3D)then
               ID=ID+1
               CALL RZERO4(TDUMP(1,ID),NXYZ)
            ENDIF
         ENDIF
      ENDIF
      IF(IFPO)then
         IF (IE.LE.NELT) then
            ID=ID+1
            CALL COPYx4(TDUMP(1,ID),PM1(1,1,1,IE),NXYZ)
         ELSE
            ID=ID+1
            CALL RZERO4(TDUMP(1,ID),NXYZ)
         ENDIF
      ENDIF
      IF(IFTO)then
         ID=ID+1
         CALL COPYx4(TDUMP(1,ID),T(1,1,1,IE,1),NXYZ)
      ENDIF
C     PASSIVE SCALARS
      do iip=1,ldimt1
         if (ifpsco(iip)) then
            id=id+1
            call copyX4(tdump(1,id),t(1,1,1,ie,iip+1),nxyz)
        endif
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine get_id(id) !  Count amount of data to be shipped

      include 'SIZE'
      include 'TOTAL'

      id=0

      if (ifxyo) id=id+ldim
      if (ifvo)  id=id+ldim
      if (ifpo)  id=id+1
      if (ifto)  id=id+1

      do iip=1,ldimt1
         if (ifpsco(iip)) id=id+1     !     Passive scalars
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine close_fld(p66,ierr)

      include 'SIZE'
      include 'TOTAL'

      if (nid.eq.0) then
         if (p66.lt.1) then
            close(unit=24)
         else
            call byte_close(ierr)
         endif
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine out_tmp(id,p66,ierr)

      include 'SIZE'
      include 'TOTAL'

      parameter (lxyz=lx1*ly1*lz1)
      parameter (lpsc9=ldimt1+9)

      common /ctmp1/ tdump(lxyz,lpsc9)
      real*4         tdump

      character*11 frmat

      nxyz = lx1*ly1*lz1

      call blank(frmat,11)
      if (id.le.9) then
         WRITE(FRMAT,1801) ID
 1801    FORMAT('(1p',I1,'e14.6)')
      else
         WRITE(FRMAT,1802) ID
 1802    FORMAT('(1p',I2,'e14.6)')
      endif

      if (p66.lt.1.0) then
C       formatted i/o
        WRITE(24,FRMAT)
     $      ((TDUMP(I,II),II=1,ID),I=1,NXYZ)
      else
C        C binary i/o
         do ii=1,id
            call byte_write(tdump(1,ii),nxyz,ierr)
            if(ierr.ne.0) goto 101
         enddo
      endif
 101  continue

      return
      end
c-----------------------------------------------------------------------
      subroutine mfo_outfld(prefix)  ! muti-file output

      include 'SIZE'
      include 'TOTAL'
      include 'RESTART'
      common /scrcg/ pm1 (lx1,ly1,lz1,lelv)  ! mapped pressure

      integer*8 offs0,offs,nbyte,stride,strideB,nxyzo8
      character*3 prefix
      logical ifxyo_s
 
      common /SCRUZ/  ur1(lxo*lxo*lxo*lelt)
     &              , ur2(lxo*lxo*lxo*lelt)
     &              , ur3(lxo*lxo*lxo*lelt)

      tiostart=dnekclock_sync()

      call io_init

      ifxyo_s = ifxyo 
      ifxyo_  = ifxyo
      nout = nelt
      nxo  = lx1
      nyo  = ly1
      nzo  = lz1
      if (ifreguo) then ! dump on regular (uniform) mesh
         if (nrg.gt.lxo) then
            if (nid.eq.0) write(6,*) 
     &         'WARNING: nrg too large, reset to lxo!'
            nrg = lxo
         endif
         nxo  = nrg
         nyo  = nrg
         nzo  = 1
         if(if3d) nzo = nrg
      endif
      offs0 = iHeaderSize + 4 + isize*nelgt

      ierr=0
      if (nid.eq.pid0) then
         call mfo_open_files(prefix,ierr)         ! open files on i/o nodes
      endif
      call err_chk(ierr,'Error opening file in mfo_open_files. $')
      call bcast(ifxyo_,lsize)
      ifxyo = ifxyo_
      call mfo_write_hdr                     ! create element mapping +

c     call exitti('this is wdsizo A:$',wdsizo)
                                             ! write hdr
      nxyzo8  = nxo*nyo*nzo
      strideB = nelB * nxyzo8*wdsizo
      stride  = nelgt* nxyzo8*wdsizo

      ioflds = 0
      ! dump all fields based on the t-mesh to avoid different
      ! topologies in the post-processor
      if (ifxyo) then
         offs = offs0 + ldim*strideB
         call byte_set_view(offs,ifh_mbyte)
         if (ifreguo) then
            call map2reg(ur1,nrg,xm1,nout)
            call map2reg(ur2,nrg,ym1,nout)
            if (if3d) call map2reg(ur3,nrg,zm1,nout)
            call mfo_outv(ur1,ur2,ur3,nout,nxo,nyo,nzo)
         else
            call mfo_outv(xm1,ym1,zm1,nout,nxo,nyo,nzo)
         endif
         ioflds = ioflds + ldim
      endif
      if (ifvo ) then
         offs = offs0 + ioflds*stride + ldim*strideB
         call byte_set_view(offs,ifh_mbyte)
         if (ifreguo) then
             call map2reg(ur1,nrg,vx,nout)
             call map2reg(ur2,nrg,vy,nout)
             if (if3d) call map2reg(ur3,nrg,vz,nout)
             call mfo_outv(ur1,ur2,ur3,nout,nxo,nyo,nzo) 
         else
            call mfo_outv(vx,vy,vz,nout,nxo,nyo,nzo)  ! B-field handled thru outpost
         endif
         ioflds = ioflds + ldim
      endif
      if (ifpo ) then
         offs = offs0 + ioflds*stride + strideB
         call byte_set_view(offs,ifh_mbyte)
         if (ifreguo) then
            call map2reg(ur1,nrg,pm1,nout)
            call mfo_outs(ur1,nout,nxo,nyo,nzo)
         else
            call mfo_outs(pm1,nout,nxo,nyo,nzo)
         endif
         ioflds = ioflds + 1
      endif
      if (ifto ) then
         offs = offs0 + ioflds*stride + strideB
         call byte_set_view(offs,ifh_mbyte)
         if (ifreguo) then
            call map2reg(ur1,nrg,t,nout)
            call mfo_outs(ur1,nout,nxo,nyo,nzo)
         else
            call mfo_outs(t,nout,nxo,nyo,nzo)
         endif
         ioflds = ioflds + 1
      endif
      do k=1,ldimt-1
         if(ifpsco(k)) then
           offs = offs0 + ioflds*stride + strideB
           call byte_set_view(offs,ifh_mbyte)
           if (ifreguo) then
              call map2reg(ur1,nrg,t(1,1,1,1,k+1),nout)
              call mfo_outs(ur1,nout,nxo,nyo,nzo)
           else
              call mfo_outs(t(1,1,1,1,k+1),nout,nxo,nyo,nzo)
           endif
           ioflds = ioflds + 1
         endif
      enddo
      dnbyte = 1.*ioflds*nout*wdsizo*nxo*nyo*nzo

      if (if3d) then
         offs0   = offs0 + ioflds*stride
         strideB = nelB *2*4   ! min/max single precision
         stride  = nelgt*2*4
         ioflds  = 0
         ! add meta data to the end of the file
         if (ifxyo) then
            offs = offs0 + ldim*strideB
            call byte_set_view(offs,ifh_mbyte)
            call mfo_mdatav(xm1,ym1,zm1,nout)
            ioflds = ioflds + ldim
         endif
         if (ifvo ) then
            offs = offs0 + ioflds*stride + ldim*strideB
            call byte_set_view(offs,ifh_mbyte)
            call mfo_mdatav(vx,vy,vz,nout)
            ioflds = ioflds + ldim
         endif
         if (ifpo ) then
            offs = offs0 + ioflds*stride + strideB
            call byte_set_view(offs,ifh_mbyte)
            call mfo_mdatas(pm1,nout)
            ioflds = ioflds + 1
         endif
         if (ifto ) then
            offs = offs0 + ioflds*stride + strideB
            call byte_set_view(offs,ifh_mbyte)
            call mfo_mdatas(t,nout)
            ioflds = ioflds + 1
         endif
         do k=1,ldimt-1
            offs = offs0 + ioflds*stride + strideB
            call byte_set_view(offs,ifh_mbyte)
            if(ifpsco(k)) call mfo_mdatas(t(1,1,1,1,k+1),nout)
            ioflds = ioflds + 1
         enddo
         dnbyte = dnbyte + 2.*ioflds*nout*wdsizo
      endif

      ierr = 0
      if (nid.eq.pid0) then 
         if(ifmpiio) then
           call byte_close_mpi(ifh_mbyte,ierr)
         else
           call byte_close(ierr)
         endif
      endif
      call err_chk(ierr,'Error closing file in mfo_outfld. Abort. $')

      tio = dnekclock_sync()-tiostart
      if (tio.le.0) tio=1.

      dnbyte = glsum(dnbyte,1)
      dnbyte = dnbyte + iHeaderSize + 4. + isize*nelgt
      dnbyte = dnbyte/1024/1024
      if(nio.eq.0) write(6,7) istep,time,dnbyte,dnbyte/tio,
     &             nfileo
    7 format(/,i9,1pe12.4,' done :: Write checkpoint',/,
     &       30X,'file size = ',3pG12.2,'MB',/,
     &       30X,'avg data-throughput = ',0pf7.1,'MB/s',/,
     &       30X,'io-nodes = ',i5,/)

      ifxyo = ifxyo_s ! restore old value

      return
      end
c-----------------------------------------------------------------------
      subroutine io_init ! determine which nodes will output
      character*132 hname

      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'
      include 'RESTART'

      ifdiro = .false.

      ifmpiio = .false.
      if(abs(param(65)).eq.1 .and. abs(param(66)).eq.6) ifmpiio=.true.
#ifdef NOMPIIO
      ifmpiio = .false.
#endif

      wdsizo = 4
      if (param(63).gt.0) wdsizo = 8 ! 64-bit .fld file
      nrg = lxo

      if(ifmpiio) then
        nfileo  = np
        nproc_o = 1
        fid0    = 0
        pid0    = nid
        pid1    = 0
      else
        if(param(65).lt.0) ifdiro = .true. !  p65 < 0 --> multi subdirectories
        nfileo  = abs(param(65))
        if(nfileo.eq.0) nfileo = 1
        if(np.lt.nfileo) nfileo=np   
        nproc_o = np / nfileo              !  # processors pointing to pid0
        fid0    = nid/nproc_o              !  file id
        pid0    = nproc_o*fid0             !  my parent i/o node
        pid1    = min(np-1,pid0+nproc_o-1) !  range of sending procs
      endif

      ! how many elements are present up to rank nid
      nn = nelt
      nelB = igl_running_sum(nn)
      nelB = nelB - nelt
     
      pid00 = glmin(pid0,1)

      return
      end
c-----------------------------------------------------------------------
      subroutine mfo_open_files(prefix,ierr) ! open files

      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'
      include 'RESTART'

      character*1 prefix(3)
      character*3 prefx

      character*132  fname
      character*1    fnam1(132)
      equivalence   (fnam1,fname)

      character*6  six,str
      save         six
      data         six / "??????" /


      character*1 slash,dot
      save        slash,dot
      data        slash,dot  / '/' , '.' /

      integer nopen(99,2)
      save    nopen
      data    nopen  / 198*0 /

      call blank(fname,132)      !  zero out for byte_open()

      iprefix        = i_find_prefix(prefix,99)
      if (ifreguo) then
         nopen(iprefix,2) = nopen(iprefix,2)+1
         nfld             = nopen(iprefix,2)
      else
         nopen(iprefix,1) = nopen(iprefix,1)+1
         nfld             = nopen(iprefix,1)
      endif

      call chcopy(prefx,prefix,3)        ! check for full-restart request
      if (prefx.eq.'rst'.and.max_rst.gt.0) nfld = mod1(nfld,max_rst)

      call restart_nfld( nfld, prefix ) ! Check for Restart option.
      if (prefx.eq.'   '.and.nfld.eq.1) ifxyo_ = .true. ! 1st file

      if(ifmpiio) then
        rfileo = 1
      else
        rfileo = nfileo
      endif
      ndigit = log10(rfileo) + 1

      lenp = ltrunc(path,132)
      call chcopy(fnam1(1),path,lenp)    
      k = 1 + lenp 
 
      if (ifdiro) then                                  !  Add directory
         call chcopy(fnam1(k),'A',1)
         k = k + 1
         call chcopy(fnam1(k),six,ndigit)  ! put ???? in string
         k = k + ndigit
         call chcopy(fnam1(k),slash,1)
         k = k + 1
      endif

      if (prefix(1).ne.' '.and.prefix(2).ne.' '.and.    !  Add prefix
     $    prefix(3).ne.' ') then
         call chcopy(fnam1(k),prefix,3)
         k = k + 3
      endif

      len=ltrunc(session,132)                           !  Add SESSION
      call chcopy(fnam1(k),session,len)
      k = k+len
     
      if (ifreguo) then
         len=4
         call chcopy(fnam1(k),'_reg',len)
         k = k+len
      endif

      call chcopy(fnam1(k),six,ndigit)                  !  Add file-id holder
      k = k + ndigit

      call chcopy(fnam1(k  ),dot,1)                     !  Add .f appendix
      call chcopy(fnam1(k+1),'f',1)
      k = k + 2

      write(str,4) nfld                                 !  Add nfld number
    4 format(i5.5)
      call chcopy(fnam1(k),str,5)
      k = k + 5

      call addfid(fname,fid0)

      if(ifmpiio) then
        if(nio.eq.0)    write(6,*) '      FILE:',fname 
        call byte_open_mpi(fname,ifh_mbyte,.false.,ierr) 
      else
        if(nid.eq.pid0) write(6,*) '      FILE:',fname 
        call byte_open(fname,ierr)
      endif
 
      return
      end
c-----------------------------------------------------------------------

      subroutine restart_nfld( nfld, prefix ) 
      include 'SIZE' ! For nio
      character*3 prefix
c
c     Check for Restart option and return proper nfld value.
c     Also, convenient spot to explain restart strategy.
c
c
c     The approach is as follows:
c
c         Prefix rs4 would indicate 4 files in the restart cycle.
c         
c         This would be normal usage for velocity only, with
c         checkpoints taking place in synch with standard io.
c
c         The resultant restart sequence might look like:
c
c         blah.fld09           Step 0
c         rs4blah.fld01             1
c         rs4blah.fld02             2
c
c         which implies that fld09 would be used as the i.c.
c         in the restart, rs4blah.fld01 would overwrite the
c         solution at Step 1, and rs4blah.fld02 would overwrite
c         Step 2.   Net result is that Steps 0-2 of the restart
c         session have solutions identical to those computed in
c         the prior run.   (It's important that both runs use
c         the same dt in this case.)
c
c
c         Another equally possible restart sequence would be:
c
c
c         blah.fld10           Step 0
c         rs4blah.fld03             1
c         rs4blah.fld04             2
c
c         Why the 3 & 4 ?   If one were to use only 1 & 2, there
c         is a risk that the system crashes while writing, say,
c         rs4blah.fld01, in which case the restart is compromised --
c         very frustrating at the end of a run that has been queued
c         for a week.  By providing a toggled sequence in pairs such as
c
c         (1,2),   (3,4),  (1,2), ...
c
c         ensures that one always has at least one complete restart
c         sequence.   In the example above, the following files would
c         be written, in order:
c
c         :
c         :
c         blah.fld09
c         rs4blah.fld01
c         rs4blah.fld02
c         blah.fld10
c         rs4blah.fld03
c         rs4blah.fld04
c         blah.fld11
c         rs4blah.fld01       (overwriting existing rs4blah.fld01)
c         rs4blah.fld02       (    "           "        "  .fld02)
c         blah.fld12
c         rs4blah.fld03       (   etc.  )
c         rs4blah.fld04
c         :
c         :
c
c
c         Other strategies are possible, according to taste.
c
c         Here is a data-intensive one:
c
c         MHD + double-precision restart, but single-precision std files
c
c         In this case, single-precision files are kept as the running
c         file sequence (i.e., for later post-processing) but dbl-prec.
c         is required for restart.  A total of 12 temporary restart files
c         must be saved:  (3 for velocity, 3 for B-field) x 2 for redundancy.
c
c         This is expressed, using hexadecimal notation (123456789abc...),
c         as prefix='rsc'.
c         
c         
      character*16 kst
      save         kst
      data         kst / '0123456789abcdef' /
      character*1  ks1(0:15),kin
      equivalence (ks1,kst)

c
c
      if (indx1(prefix,'rs',2).eq.1) then
         read(prefix,3) kin
    3    format(2x,a1)
         do kfld=1,15
            if (ks1(kfld).eq.kin) goto 10
         enddo
   10    if (kfld.eq.16) kfld=4 ! std. default
         nfln = mod1(nfld,kfld) ! Restart A (1,2) and B (3,4)
         if (nio.eq.0) write(6,*) nfln,nfld,kfld,' kfld'
         nfld = nfln
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine full_restart_save(iosave)

      integer iosave,save_size,nfld_save
      logical if_full_pres_tmp

      include 'SIZE'
      include 'INPUT'
      include 'TSTEP'

      if (PARAM(27).lt. 0) then
          nfld_save=abs(PARAM(27))  ! For full restart
      else 
          nfld_save=3
      endif
      save_size=8  ! For full restart

      dtmp = param(63)
      if_full_pres_tmp = if_full_pres     

      param(63) = 1 ! Enforce 64-bit output
      if_full_pres = .true. !Preserve mesh 2 pressure

      if (lastep.ne.1) call restart_save(iosave,nfld_save)

      param(63) = dtmp
      if_full_pres = if_full_pres_tmp 

      return
      end
c-----------------------------------------------------------------------
      subroutine restart_save(iosave,nfldi)

      integer iosave,nfldi


c     Save current fields for later restart.
c
c     Input arguments:
c
c       .iosave plays the usual triggering role, like iostep
c
c       .nfldi is the number of rs files to save before overwriting
c

      include 'SIZE'
      include 'TOTAL'
      include 'RESTART'

      character*3 prefix

      character*17 kst
      save         kst
      data         kst / '0123456789abcdefx' /
      character*1  ks1(0:16)
      equivalence (ks1,kst)

      logical if_full_pres_tmp

      iosav = iosave

      if (iosav.eq.0) iosav = iostep
      if (iosav.eq.0) return

      iotest = 0
c     if (iosav.eq.iostep) iotest = 1  ! currently spoiled because of 
c                                      ! incompatible format of .fld
c                                      ! and multi-file i/o;  the latter
c                                      ! is the only form used for restart

      nfld  = nfldi*2
      nfld2 = nfld/2
      mfld  = min(17,nfld)
      if (ifmhd) nfld2 = nfld/4

      i2 = iosav/2
      m1 = istep+iosav-iotest
      mt = mod(istep+iosav-iotest,iosav)
      prefix = '   '

      if (istep.gt.iosav/2  .and.
     $   mod(istep+iosav-iotest,iosav).lt.nfld2) then ! save
         write(prefix,'(A)') 'rs_'
c         write(prefix,3) ks1(mfld)
c    3    format('rs',a1)

         p66 = param(66)
         param(66) = 6
         if (ifmhd) call outpost2(bx,by,bz,pm,t,0,prefix)  ! first B
         call prepost (.true.,prefix)
         param(66) = p66

      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine outpost(v1,v2,v3,vp,vt,name3)

      include 'SIZE'
      include 'INPUT'

      real v1(1),v2(1),v3(1),vp(1),vt(1)
      character*3 name3


      itmp=0
      if (ifto) itmp=1
      call outpost2(v1,v2,v3,vp,vt,itmp,name3)

      return
      end
c-----------------------------------------------------------------------
      subroutine outpost2(v1,v2,v3,vp,vt,nfldt,name3)

      include 'SIZE'
      include 'SOLN'
      include 'INPUT'

      parameter(ltot1=lx1*ly1*lz1*lelt)
      parameter(ltot2=lx2*ly2*lz2*lelv)
      common /outtmp/  w1(ltot1),w2(ltot1),w3(ltot1),wp(ltot2)
     &                ,wt(ltot1,ldimt)
c
      real v1(1),v2(1),v3(1),vp(1),vt(ltot1,1)
      character*3 name3
      logical if_save(ldimt)
c
      ntot1  = lx1*ly1*lz1*nelt
      ntot1t = lx1*ly1*lz1*nelt
      ntot2  = lx2*ly2*lz2*nelt

      if(nfldt.gt.ldimt) then
        write(6,*) 'ABORT: outpost data too large (nfldt>ldimt)!'
        call exitt
      endif

c store solution
      call copy(w1,vx,ntot1)
      call copy(w2,vy,ntot1)
      call copy(w3,vz,ntot1)
      call copy(wp,pr,ntot2)
      do i = 1,nfldt
         call copy(wt(1,i),t(1,1,1,1,i),ntot1t)
      enddo

c swap with data to dump
      call copy(vx,v1,ntot1)
      call copy(vy,v2,ntot1)
      call copy(vz,v3,ntot1)
      call copy(pr,vp,ntot2)
      do i = 1,nfldt
         call copy(t(1,1,1,1,i),vt(1,i),ntot1t)
      enddo

c dump data
      if_save(1) = ifto
      ifto = .false.
      if(nfldt.gt.0) ifto = .true. 
      do i = 1,ldimt-1
         if_save(i+1) = ifpsco(i)
         ifpsco(i) = .false.   
         if(i+1.le.nfldt) ifpsco(i) = .true.
      enddo

      call prepost(.true.,name3)

      ifto = if_save(1)
      do i = 1,ldimt-1
         ifpsco(i) = if_save(i+1) 
      enddo

c restore solution data
      call copy(vx,w1,ntot1)
      call copy(vy,w2,ntot1)
      call copy(vz,w3,ntot1)
      call copy(pr,wp,ntot2)
      do i = 1,nfldt
         call copy(t(1,1,1,1,i),wt(1,i),ntot1t)
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine mfo_mdatav(u,v,w,nel)

      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'
      include 'RESTART'

      real u(lx1*ly1*lz1,1),v(lx1*ly1*lz1,1),w(lx1*ly1*lz1,1)

      real*4 buffer(1+6*lelt)

      integer e

      call nekgsync() ! clear outstanding message queues.

      nxyz = lx1*ly1*lz1
      n    = 2*ldim
      len  = 4 + 4*(n*lelt)   ! recv buffer size
      leo  = 4 + 4*(n*nelt) 
      ierr = 0

      ! Am I an I/O node?
      if (nid.eq.pid0) then
         j = 1
         do e=1,nel
            buffer(j+0) = vlmin(u(1,e),nxyz) 
            buffer(j+1) = vlmax(u(1,e),nxyz)
            buffer(j+2) = vlmin(v(1,e),nxyz) 
            buffer(j+3) = vlmax(v(1,e),nxyz)
            j = j + 4
            if(if3d) then
              buffer(j+0) = vlmin(w(1,e),nxyz) 
              buffer(j+1) = vlmax(w(1,e),nxyz)
              j = j + 2
            endif
         enddo

         ! write out my data
         nout = n*nel
         if(ierr.eq.0) then
           if(ifmpiio) then
             call byte_write_mpi(buffer,nout,-1,ifh_mbyte,ierr)
           else
             call byte_write(buffer,nout,ierr)
           endif
         endif

         ! write out the data of my childs
         idum  = 1
         do k=pid0+1,pid1
            mtype = k
            call csend(mtype,idum,4,k,0)           ! handshake
            call crecv(mtype,buffer,len)
            inelp = buffer(1)
            nout  = n*inelp
            if(ierr.eq.0) then 
              if(ifmpiio) then 
                call byte_write_mpi(buffer(2),nout,-1,ifh_mbyte,ierr)
              else
                call byte_write(buffer(2),nout,ierr)
              endif
            endif
         enddo
      else
         j = 1
         buffer(j) = nel
         j = j + 1
         do e=1,nel
            buffer(j+0) = vlmin(u(1,e),nxyz) 
            buffer(j+1) = vlmax(u(1,e),nxyz)
            buffer(j+2) = vlmin(v(1,e),nxyz) 
            buffer(j+3) = vlmax(v(1,e),nxyz)
            j = j + 4
            if(n.eq.6) then
              buffer(j+0) = vlmin(w(1,e),nxyz) 
              buffer(j+1) = vlmax(w(1,e),nxyz)
              j = j + 2
            endif
         enddo

         ! send my data to my pararent I/O node
         mtype = nid
         call crecv(mtype,idum,4)                ! hand-shake
         call csend(mtype,buffer,leo,pid0,0)     ! u4 :=: u8
      endif

      call err_chk(ierr,'Error writing data to .f00 in mfo_mdatav. $')

      return
      end
c-----------------------------------------------------------------------
      subroutine mfo_mdatas(u,nel)

      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'
      include 'RESTART'

      real u(lx1*ly1*lz1,1)

      real*4 buffer(1+2*lelt)

      integer e

      call nekgsync() ! clear outstanding message queues.

      nxyz = lx1*ly1*lz1
      n    = 2
      len  = 4 + 4*(n*lelt)    ! recv buffer size
      leo  = 4 + 4*(n*nelt)
      ierr = 0

      ! Am I an I/O node?
      if (nid.eq.pid0) then
         j = 1
         do e=1,nel
            buffer(j+0) = vlmin(u(1,e),nxyz) 
            buffer(j+1) = vlmax(u(1,e),nxyz)
            j = j + 2
         enddo

         ! write out my data
         nout = n*nel
         if(ierr.eq.0) then 
           if(ifmpiio) then
             call byte_write_mpi(buffer,nout,-1,ifh_mbyte,ierr)
           else
             call byte_write(buffer,nout,ierr)
           endif
         endif

         ! write out the data of my childs
         idum  = 1
         do k=pid0+1,pid1
            mtype = k
            call csend(mtype,idum,4,k,0)           ! handshake
            call crecv(mtype,buffer,len)
            inelp = buffer(1)
            nout  = n*inelp
            if(ierr.eq.0) then 
              if(ifmpiio) then
                call byte_write_mpi(buffer(2),nout,-1,ifh_mbyte,ierr)
              else
                call byte_write(buffer(2),nout,ierr)
              endif
            endif
         enddo
      else
         j = 1
         buffer(j) = nel
         j = j + 1
         do e=1,nel
            buffer(j+0) = vlmin(u(1,e),nxyz) 
            buffer(j+1) = vlmax(u(1,e),nxyz)
            j = j + 2
         enddo

         ! send my data to my pararent I/O node
         mtype = nid
         call crecv(mtype,idum,4)                ! hand-shake
         call csend(mtype,buffer,leo,pid0,0)     ! u4 :=: u8
      endif

      call err_chk(ierr,'Error writing data to .f00 in mfo_mdatas. $')

      return
      end
c-----------------------------------------------------------------------
      subroutine mfo_outs(u,nel,mx,my,mz)   ! output a scalar field

      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'
      include 'RESTART'

      real u(mx,my,mz,1)

      common /SCRNS/ u4(2+lxo*lxo*lxo*2*lelt)
      real*4         u4
      real*8         u8(1+lxo*lxo*lxo*1*lelt)
      equivalence    (u4,u8)

      integer e

      umax = glmax(u,nel*mx*my*mz)
      umin = glmin(u,nel*mx*my*mz)
      if(nid.eq.0) write(6,'(A,2g13.5)') ' min/max:', umin,umax

      call nekgsync() ! clear outstanding message queues.
      if(mx.gt.lxo .or. my.gt.lxo .or. mz.gt.lxo) then
        if(nid.eq.0) write(6,*) 'ABORT: lxo too small'
        call exitt
      endif

      nxyz = mx*my*mz
      len  = 8 + 8*(lelt*nxyz)  ! recv buffer size
      leo  = 8 + wdsizo*(nel*nxyz)
      ntot = nxyz*nel

      idum = 1
      ierr = 0

      if (nid.eq.pid0) then

         if (wdsizo.eq.4) then             ! 32-bit output
             call copyx4 (u4,u,ntot)
         else
             call copy   (u8,u,ntot)
         endif
         nout = wdsizo/4 * ntot
         if(ierr.eq.0) then 
           if(ifmpiio) then
             call byte_write_mpi(u4,nout,-1,ifh_mbyte,ierr)
           else
             call byte_write(u4,nout,ierr)          ! u4 :=: u8
           endif
         endif

         ! write out the data of my childs
         idum  = 1
         do k=pid0+1,pid1
            mtype = k
            call csend(mtype,idum,4,k,0)       ! handshake
            call crecv(mtype,u4,len)
            nout  = wdsizo/4 * nxyz * u8(1)
            if (wdsizo.eq.4.and.ierr.eq.0) then
               if(ifmpiio) then
                 call byte_write_mpi(u4(3),nout,-1,ifh_mbyte,ierr)
               else
                 call byte_write(u4(3),nout,ierr)
               endif
            elseif(ierr.eq.0) then
               if(ifmpiio) then
                 call byte_write_mpi(u8(2),nout,-1,ifh_mbyte,ierr)
               else
                 call byte_write(u8(2),nout,ierr)
               endif
            endif
         enddo

      else

         u8(1)= nel
         if (wdsizo.eq.4) then             ! 32-bit output
             call copyx4 (u4(3),u,ntot)
         else
             call copy   (u8(2),u,ntot)
         endif

         mtype = nid
         call crecv(mtype,idum,4)            ! hand-shake
         call csend(mtype,u4,leo,pid0,0)     ! u4 :=: u8

      endif

      call err_chk(ierr,'Error writing data to .f00 in mfo_outs. $')

      return
      end
c-----------------------------------------------------------------------

      subroutine mfo_outv(u,v,w,nel,mx,my,mz)   ! output a vector field

      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'
      include 'RESTART'

      real u(mx*my*mz,1),v(mx*my*mz,1),w(mx*my*mz,1)

      common /SCRNS/ u4(2+lxo*lxo*lxo*6*lelt)
      real*4         u4
      real*8         u8(1+lxo*lxo*lxo*3*lelt)
      equivalence    (u4,u8)

      integer e

      umax = glmax(u,nel*mx*my*mz)
      vmax = glmax(v,nel*mx*my*mz)
      wmax = glmax(w,nel*mx*my*mz)
      umin = glmin(u,nel*mx*my*mz)
      vmin = glmin(v,nel*mx*my*mz)
      wmin = glmin(w,nel*mx*my*mz)
      if(nid.eq.0) write(6,'(A,6g13.5)') ' min/max:', 
     $             umin,umax, vmin,vmax, wmin,wmax

      call nekgsync() ! clear outstanding message queues.
      if(mx.gt.lxo .or. my.gt.lxo .or. mz.gt.lxo) then
        if(nid.eq.0) write(6,*) 'ABORT: lxo too small'
        call exitt
      endif

      nxyz = mx*my*mz
      len  = 8 + 8*(lelt*nxyz*ldim)   ! recv buffer size (u4)
      leo  = 8 + wdsizo*(nel*nxyz*ldim)
      idum = 1
      ierr = 0

      if (nid.eq.pid0) then
         j = 0 
         if (wdsizo.eq.4) then             ! 32-bit output
             do iel = 1,nel
                call copyx4   (u4(j+1),u(1,iel),nxyz)
                j = j + nxyz
                call copyx4   (u4(j+1),v(1,iel),nxyz)
                j = j + nxyz
                if(if3d) then
                  call copyx4 (u4(j+1),w(1,iel),nxyz)
                  j = j + nxyz
                endif
             enddo
         else
             do iel = 1,nel
                call copy     (u8(j+1),u(1,iel),nxyz)
                j = j + nxyz
                call copy     (u8(j+1),v(1,iel),nxyz)
                j = j + nxyz
                if(if3d) then
                  call copy   (u8(j+1),w(1,iel),nxyz)
                  j = j + nxyz
                endif
             enddo
         endif
         nout = wdsizo/4 * ldim*nel * nxyz
         if(ierr.eq.0) then 
           if(ifmpiio) then
             call byte_write_mpi(u4,nout,-1,ifh_mbyte,ierr)
           else
             call byte_write(u4,nout,ierr)          ! u4 :=: u8
           endif
         endif

         ! write out the data of my childs
         do k=pid0+1,pid1
            mtype = k
            call csend(mtype,idum,4,k,0)           ! handshake
            call crecv(mtype,u4,len)
            nout  = wdsizo/4 * ldim*nxyz * u8(1)

            if (wdsizo.eq.4.and.ierr.eq.0) then
               if(ifmpiio) then
                 call byte_write_mpi(u4(3),nout,-1,ifh_mbyte,ierr)
               else
                 call byte_write(u4(3),nout,ierr)
               endif
            elseif(ierr.eq.0) then
               if(ifmpiio) then
                 call byte_write_mpi(u8(2),nout,-1,ifh_mbyte,ierr)
               else
                 call byte_write(u8(2),nout,ierr)
               endif
            endif
         enddo
      else

         u8(1) = nel
         if (wdsizo.eq.4) then             ! 32-bit output
             j = 2
             do iel = 1,nel
                call copyx4   (u4(j+1),u(1,iel),nxyz)
                j = j + nxyz
                call copyx4   (u4(j+1),v(1,iel),nxyz)
                j = j + nxyz
                if(if3d) then
                  call copyx4 (u4(j+1),w(1,iel),nxyz)
                  j = j + nxyz
                endif
             enddo
         else
             j = 1
             do iel = 1,nel
                call copy     (u8(j+1),u(1,iel),nxyz)
                j = j + nxyz
                call copy     (u8(j+1),v(1,iel),nxyz)
                j = j + nxyz
                if(if3d) then
                  call copy   (u8(j+1),w(1,iel),nxyz)
                  j = j + nxyz
                endif
             enddo
         endif

         mtype = nid
         call crecv(mtype,idum,4)            ! hand-shake
         call csend(mtype,u4,leo,pid0,0)     ! u4 :=: u8

      endif

      call err_chk(ierr,'Error writing data to .f00 in mfo_outv. $')
      return
      end
c-----------------------------------------------------------------------
      subroutine mfo_write_hdr          ! write hdr, byte key, els.

      include 'SIZE'
      include 'SOLN'
      include 'INPUT'
      include 'PARALLEL'
      include 'RESTART'
      include 'TSTEP'
      real*4 test_pattern
      common /ctmp0/ lglist(0:lelt)

      character*132 hdr
      integer*8 ioff
      logical if_press_mesh

      call nekgsync()
      idum = 1

      if(ifmpiio) then
        nfileoo = 1   ! all data into one file
        nelo = nelgt
      else
        nfileoo = nfileo
        if(nid.eq.pid0) then                ! how many elements to dump
          nelo = nelt
          do j = pid0+1,pid1
             mtype = j
             call csend(mtype,idum,4,j,0)   ! handshake
             call crecv(mtype,inelp,4)
             nelo = nelo + inelp
          enddo
        else
          mtype = nid
          call crecv(mtype,idum,4)          ! hand-shake
          call csend(mtype,nelt,4,pid0,0)   ! u4 :=: u8
        endif 
      endif

      ierr = 0
      if(nid.eq.pid0) then

      call blank(hdr,132)              ! write header
      call blank(rdcode1,10)
      i = 1
      IF (IFXYO) THEN
         rdcode1(i)='X'
         i = i + 1
      ENDIF
      IF (IFVO) THEN
         rdcode1(i)='U'
         i = i + 1
      ENDIF
      IF (IFPO) THEN
         rdcode1(i)='P'
         i = i + 1
      ENDIF
      IF (IFTO) THEN
         rdcode1(i)='T'
         i = i + 1
      ENDIF
      IF (LDIMT.GT.1) THEN
         NPSCALO = 0
         do k = 1,ldimt-1
           if(ifpsco(k)) NPSCALO = NPSCALO + 1
         enddo
         IF (NPSCALO.GT.0) THEN
            rdcode1(i) = 'S'
            WRITE(rdcode1(i+1),'(I1)') NPSCALO/10
            WRITE(rdcode1(i+2),'(I1)') NPSCALO-(NPSCALO/10)*10
         ENDIF
      ENDIF

c     check pressure format
      if_press_mesh = .false.
      if (.not.ifsplit.and.if_full_pres) if_press_mesh = .true.
 
      write(hdr,1) wdsizo,nxo,nyo,nzo,nelo,nelgt,time,istep,fid0,nfileoo
     $            ,(rdcode1(i),i=1,10),p0th,if_press_mesh
    1 format('#std',1x,i1,1x,i2,1x,i2,1x,i2,1x,i10,1x,i10,1x,e20.13,
     &       1x,i9,1x,i6,1x,i6,1x,10a,1pe15.7,1x,l1)

      test_pattern = 6.54321           ! write test pattern for byte swap

      if(ifmpiio) then
        ! only rank0 (pid00) will write hdr + test_pattern
        call byte_write_mpi(hdr,iHeaderSize/4,pid00,ifh_mbyte,ierr)
        call byte_write_mpi(test_pattern,1,pid00,ifh_mbyte,ierr)
      else
        call byte_write(hdr,iHeaderSize/4,ierr)
        call byte_write(test_pattern,1,ierr)
      endif

      endif

      call err_chk(ierr,'Error writing header in mfo_write_hdr. $')

      ! write global element numbering for this group
      if(nid.eq.pid0) then
        if(ifmpiio) then
          ioff = iHeaderSize + 4 + nelB*isize
          call byte_set_view (ioff,ifh_mbyte)
          call byte_write_mpi(lglel,nelt,-1,ifh_mbyte,ierr)
        else
          call byte_write(lglel,nelt,ierr)
        endif

        do j = pid0+1,pid1
           mtype = j
           call csend(mtype,idum,4,j,0)   ! handshake
           len = 4*(lelt+1)
           call crecv(mtype,lglist,len)
           if(ierr.eq.0) then
             if(ifmpiio) then
              call byte_write_mpi(lglist(1),lglist(0),-1,ifh_mbyte,ierr)
             else
              call byte_write(lglist(1),lglist(0),ierr)
             endif
           endif
        enddo
      else
        mtype = nid
        call crecv(mtype,idum,4)          ! hand-shake
        
        lglist(0) = nelt
        call icopy(lglist(1),lglel,nelt)

        len = 4*(nelt+1)
        call csend(mtype,lglist,len,pid0,0)  
      endif 

      call err_chk(ierr,'Error writing global nums in mfo_write_hdr$')
      return
      end
c-----------------------------------------------------------------------

       PROGRAM MXMDRIVER

       INTEGER N
       PARAMETER (N=4)
       real A(N,N),B(N,N),C(N,N)
       INTEGER I,J

       DO J=1,N
         DO I=1,N
           A(I,J) = 1.0*(I+J)
           B(I,J) = 1.0*(I-J)
         ENDDO
       ENDDO

       DO I=1,N
         DO J=1,N
           C(I,J) = 0.0
           DO K=1,N
             C(I,J) = C(I,J) + A(I,K)*B(K,J)
           ENDDO
         ENDDO
       ENDDO

       DO J=1,N
         DO I=1,N
            PRINT *,"C(",I,",",J,") = ",C(I,J)
         ENDDO
       ENDDO

       END 

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Race condition on outLen due to unprotected writes.
!Adding private (outLen) can avoid race condition. But it is wrong semantically.
!
!Data race pairs: we allow two pair to preserve the original code pattern.
!1. outLen@60 vs. outLen@60
!2. output[]@59 vs. output[]@59


program DRB019_plusplus_var_yes
    use omp_lib
    implicit none

    integer :: i, inLen, outLen, argCount, allocStatus, rdErr, ix
    character(len=80), dimension(:), allocatable :: args
    integer, dimension(:), allocatable :: input
    integer, dimension(:), allocatable :: output

    inLen = 1000
    outLen = 1

    argCount = command_argument_count()
    if (argCount == 0) then
        write (*,'(a)') "No command line arguments provided."
    end if

    allocate(args(argCount), stat=allocStatus)
    if (allocStatus > 0) then
        write (*,'(a)') "Allocation error, program terminated."
        stop
    end if

    do ix = 1, argCount
        call get_command_argument(ix,args(ix))
    end do

    if (argCount >= 1) then
        read (args(1), '(i10)', iostat=rdErr) inLen
        if (rdErr /= 0 ) then
            write (*,'(a)') "Error, invalid integer value."
        end if
    end if

    allocate (input(inLen))
    allocate (output(inLen))

    do i = 1, inLen
        input(i) = i
    end do

    !$omp parallel do
    do i = 1, inLen
        output(outLen) = input(i)
        outLen = outLen + 1
    end do
    !$omp end parallel do

    print 100, output(0)
    100 format ("output(0)=",i3)


    deallocate(input,output,args)
end program

      PROGRAM MXMDRIVER
      IMPLICIT NONE
      !$CVL $input
      integer BOUND
      !$CVL $output
      integer OUTVAL
      
      INTEGER N = BOUND
      real RES
      real A(N,N),B(N,N),C(N,N)
      INTEGER I,J
      !$CVL $assume(BOUND .EQ. 2);
      RES = 0.0
      DO J=1,N
        DO I=1,N
          A(I,J) = 1.0*(I*N+J)
          B(I,J) = 1.0*(I-J*N)
        ENDDO
      ENDDO
      CALL MXM(A, N, B, N, C, N)
      DO J=1,N
        DO I=1,N
          RES = RES + C(I,J)
        ENDDO
      ENDDO
      PRINT *, RES
      OUTVAL = RES
      END 

      subroutine mxm(A,N1,B,N2,C,N3)
c
      real a(n1,n2),b(n2,n3),c(n1,n3),s

c$OMP PARALLEL DEFAULT(PRIVATE) SHARED(A,B,C,N1,N2,N3)
c$OMP DO
         do j=1,n3
            do i=1,n1
               s = 0.0
               do k=1,n2
                  s = s + a(i,k)*b(k,j)
               enddo
               c(i,j) = s
            enddo
         enddo
c$OMP END DO
c$OMP END PARALLEL

      return
      end

c-----------------------------------------------------------------------
      subroutine icopy48(a,b,n)
      integer*8 a(1)
      integer*4 b(1)
      do 100 i = 1, n
 100     a(i) = b(i)
      return
      end
c-----------------------------------------------------------------------
      subroutine icopy84(a,b,n)
      integer*4 a(1)
      integer*8 b(1)
      do 100 i = 1, n
 100     a(i) = b(i)
      return
      end
c-----------------------------------------------------------------------
      SUBROUTINE BLANK(A,N)
      CHARACTER*1 A(1)
      CHARACTER*1 BLNK
      SAVE        BLNK
      DATA        BLNK /' '/
C
      DO 10 I=1,N
         A(I)=BLNK
   10 CONTINUE
      RETURN
      END
c-----------------------------------------------------------------------
      SUBROUTINE VSQ (A,N)
      DIMENSION  A(1)
C
      include 'OPCTR'
C
      DO 100 I = 1, N
 100     A(I) = A(I)**2
      RETURN
      END
c-----------------------------------------------------------------------
      SUBROUTINE VSQRT(A,N)
      DIMENSION  A(1)
C
      include 'OPCTR'
C
      DO 100 I = 1, N
 100     A(I) = SQRT(A(I))
      RETURN
      END
c-----------------------------------------------------------------------
      subroutine invers2(a,b,n)
      REAL A(1),B(1)
C
      include 'OPCTR'
C
      DO 100 I=1,N
         A(I)=1./B(I)
 100  CONTINUE
      return
      END
c-----------------------------------------------------------------------
      subroutine invcol1(a,n)
      REAL A(1)
C
      include 'OPCTR'
C
      DO 100 I=1,N
         A(I)=1./A(I)
 100  CONTINUE
      return
      END
c-----------------------------------------------------------------------
      subroutine invcol2(a,b,n)
C
      REAL A(1),B(1)
      include 'CTIMER'
      include 'OPCTR'

#ifdef TIMER2
      if (icalld.eq.0) then
         tinvc=0.0
         icalld=icalld+1
      endif
      etime1=dnekclock()
#endif

      DO 100 I=1,N
         A(I)=A(I)/B(I)
 100  CONTINUE

#ifdef TIMER2
      tinvc=tinvc+(dnekclock()-etime1)
#endif

      return
      END
c-----------------------------------------------------------------------
      subroutine invcol3(a,b,c,n)
      REAL A(1),B(1),C(1)
C
      include 'OPCTR'
      include 'CTIMER'

#ifdef TIMER2
      if (icalld.eq.0) tinv3=0.0
      icalld=icalld+1
      ninv3=icalld
      etime1=dnekclock()
#endif
C
      DO 100 I=1,N
         A(I)=B(I)/C(I)
 100  CONTINUE
#ifdef TIMER2
      tinv3=tinv3+(dnekclock()-etime1)
#endif
      return
      END
c-----------------------------------------------------------------------
      subroutine col4(a,b,c,d,n)
      REAL A(1),B(1),C(1),D(1)
C
      include 'OPCTR'
C
      DO 100 I=1,N
         A(I)=B(I)*C(I)*D(I)
  100 CONTINUE
      return
      END
c-----------------------------------------------------------------------
      subroutine Xaddcol3(a,b,c,n)
      REAL A(1),B(1),C(1)
C
      include 'OPCTR'
C
      DO 100 I=1,N
         A(I)=A(I)+B(I)*C(I)
  100 CONTINUE
      return
      END
c-----------------------------------------------------------------------
      subroutine addcol4(a,b,c,d,n)
      REAL A(1),B(1),C(1),D(1)
C
      include 'OPCTR'
C
      DO 100 I=1,N
         A(I)=A(I)+B(I)*C(I)*D(I)
  100 CONTINUE
      return
      END
c-----------------------------------------------------------------------
      subroutine ascol5 (a,b,c,d,e,n)
      REAL A(1),B(1),C(1),D(1),E(1)
C
      include 'OPCTR'
C
      DO 100 I=1,N
         A(I) = B(I)*C(I)-D(I)*E(I)
 100  CONTINUE
      return
      END
c-----------------------------------------------------------------------
      subroutine sub2(a,b,n)
      REAL A(1),B(1)
C
      include 'OPCTR'
C
      DO 100 I=1,N
         A(I)=A(I)-B(I)
 100  CONTINUE
      return
      END
c-----------------------------------------------------------------------
      subroutine sub3(a,b,c,n)
      REAL A(1),B(1),C(1)
C
      include 'OPCTR'
C
      DO 100 I=1,N
         A(I)=B(I)-C(I)
 100  CONTINUE
      return
      END
c-----------------------------------------------------------------------
      subroutine subcol3(a,b,c,n)
      REAL A(1),B(1),C(1)
C
      include 'OPCTR'
C
      DO 100 I=1,N
         A(I)=A(I)-B(I)*C(I)
  100 CONTINUE
      return
      END
c-----------------------------------------------------------------------
      subroutine subcol4(a,b,c,d,n)
      REAL A(1),B(1),C(1),D(1)
C
      include 'OPCTR'
C
      DO 100 I=1,N
         A(I)=A(I)-B(I)*C(I)*D(I)
  100 CONTINUE
      return
      END
c-----------------------------------------------------------------------
      subroutine rzero(a,n)
      DIMENSION  A(1)
      DO 100 I = 1, N
 100     A(I ) = 0.0
      return
      END
c-----------------------------------------------------------------------
      subroutine izero(a,n)
      INTEGER A(1)
C
      DO 100 I = 1, N
 100     A(I ) = 0
      return
      END
c-----------------------------------------------------------------------
      subroutine ione(a,n)
      INTEGER  A(1)
      DO 100 I = 1, N
 100     A(I ) = 1
      return
      END
c-----------------------------------------------------------------------
      subroutine rone(a,n)
      DIMENSION A(1)
      DO 100 I = 1, N
 100     A(I ) = 1.0
      return
      END
c-----------------------------------------------------------------------
      subroutine ltrue(a,n)
      LOGICAL A(1)
      DO 100 I = 1, N
 100     A(I ) = .TRUE.
      return
      END
c-----------------------------------------------------------------------
      subroutine cfill(a,b,n)
      DIMENSION  A(1)
C
      DO 100 I = 1, N
 100     A(I) = B
      return
      END
c-----------------------------------------------------------------------
      subroutine ifill(ia,ib,n)
      DIMENSION IA(1)
C
      DO 100 I = 1, N
 100     IA(I) = IB
      return
      END
c-----------------------------------------------------------------------
      subroutine copy(a,b,n)
      real a(1),b(1)

      do i=1,n
         a(i)=b(i)
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine copyi4(a,b,n)
      integer a(1)
      real    b(1)

      do i=1,n
         a(i)=b(i)
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine chcopy(a,b,n)
      CHARACTER*1 A(1), B(1)
C
      DO 100 I = 1, N
 100     A(I) = B(I)
      return
      END
C
      subroutine icopy(a,b,n)
      INTEGER A(1), B(1)
C
      DO 100 I = 1, N
 100     A(I) = B(I)
      return
      END
c-----------------------------------------------------------------------
      subroutine i8copy(a,b,n)
      INTEGER*8 A(1), B(1)
C
      DO 100 I = 1, N
 100     A(I) = B(I)
      return
      END
c-----------------------------------------------------------------------
      subroutine chsign(a,n)
      REAL A(1)
C
      DO 100 I=1,N
         A(I) = -A(I)
 100  CONTINUE
      return
      END
C
c-----------------------------------------------------------------------
      subroutine cmult(a,const,n)
      REAL A(1)
C
      include 'OPCTR'
C
      DO 100 I=1,N
         A(I)=A(I)*CONST
 100  CONTINUE
      return
      END
c-----------------------------------------------------------------------
      subroutine cadd(a,const,n)
      REAL A(1)
C
      include 'OPCTR'
C
      DO 100 I=1,N
         A(I)=A(I)+CONST
 100  CONTINUE
      return
      END
c-----------------------------------------------------------------------
      subroutine iadd(i1,iscal,n)
      DIMENSION I1(1)
C
      DO 10 I=1,N
         I1(I)=I1(I)+ISCAL
   10 CONTINUE
      return
      END
c-----------------------------------------------------------------------
      subroutine cadd2(a,b,const,n)
      REAL A(1),B(1)
C
      include 'OPCTR'
C
      DO 100 I=1,N
         A(I)=B(I)+CONST
 100  CONTINUE
      return
      END
c-----------------------------------------------------------------------
      real function vlmin(vec,n)
      REAL VEC(1)
      TMIN = 99.0E20
C
      DO 100 I=1,N
         TMIN = MIN(TMIN,VEC(I))
 100  CONTINUE
      VLMIN = TMIN
      return
      END
c-----------------------------------------------------------------------
      integer function ivlmin(vec,n)
      integer vec(1),tmin
      if (n.eq.0) then
         ivlmin=0
         return
      endif
      tmin = 8888888
      do i=1,n
         tmin = min(tmin,vec(i))
      enddo
      ivlmin = tmin
      return
      end
c-----------------------------------------------------------------------
      integer function ivlmax(vec,n)
      integer vec(1),tmax
      if (n.eq.0) then
         ivlmax=0
         return
      endif
      TMAX =-8888888
      do i=1,n
         TMAX = MAX(TMAX,VEC(I))
      enddo
      Ivlmax = tmax
      return
      end
c-----------------------------------------------------------------------
      real function vlmax(vec,n)
      REAL VEC(1)
      TMAX =-99.0E20
      do i=1,n
         TMAX = MAX(TMAX,VEC(I))
      enddo
      VLMAX = TMAX
      return
      END
c-----------------------------------------------------------------------
      real function vlamax(vec,n)
      REAL VEC(1)
      TAMAX = 0.0
C
      DO 100 I=1,N
         TAMAX = MAX(TAMAX,ABS(VEC(I)))
 100  CONTINUE
      VLAMAX = TAMAX
      return
      END
c-----------------------------------------------------------------------
      real function vlsum(vec,n)
      REAL VEC(1)
      include 'OPCTR'
C
      SUM = 0.
C
      DO 100 I=1,N
         SUM=SUM+VEC(I)
 100  CONTINUE
      VLSUM = SUM
      return
      END
c-----------------------------------------------------------------------
      subroutine vcross (u1,u2,u3,v1,v2,v3,w1,w2,w3,n)
C
C     Compute a Cartesian vector cross product.
C
      DIMENSION U1(1),U2(1),U3(1)
      DIMENSION V1(1),V2(1),V3(1)
      DIMENSION W1(1),W2(1),W3(1)
C
C
      DO 100 I=1,N
         U1(I) = V2(I)*W3(I) - V3(I)*W2(I)
         U2(I) = V3(I)*W1(I) - V1(I)*W3(I)
         U3(I) = V1(I)*W2(I) - V2(I)*W1(I)
  100 CONTINUE
      return
      END
c-----------------------------------------------------------------------
      subroutine vdot2 (dot,u1,u2,v1,v2,n)
C
C     Compute a Cartesian vector dot product. 2-d version
C
      DIMENSION DOT(1)
      DIMENSION U1(1),U2(1)
      DIMENSION V1(1),V2(1)
C
C
      DO 100 I=1,N
         DOT(I) = U1(I)*V1(I) + U2(I)*V2(I) 
  100 CONTINUE
      return
      END
c-----------------------------------------------------------------------
      subroutine vdot3 (dot,u1,u2,u3,v1,v2,v3,n)
C
C     Compute a Cartesian vector dot product. 3-d version
C
      DIMENSION DOT(1)
      DIMENSION U1(1),U2(1),U3(1)
      DIMENSION V1(1),V2(1),V3(1)
C
C
      DO 100 I=1,N
         DOT(I) = U1(I)*V1(I) + U2(I)*V2(I) + U3(I)*V3(I)
  100 CONTINUE
      return
      END
c-----------------------------------------------------------------------
      subroutine addtnsr(s,h1,h2,h3,nx,ny,nz)
C
C     Map and add to S a tensor product form of the three functions H1,H2,H3.
C     This is a single element routine used for deforming geometry.
C
      DIMENSION H1(1),H2(1),H3(1)
      DIMENSION S(NX,NY,NZ)
C
      DO 200 IZ=1,NZ
      DO 200 IY=1,NY
         HH = H2(IY)*H3(IZ)
         DO 100 IX=1,NX
            S(IX,IY,IZ)=S(IX,IY,IZ)+HH*H1(IX)
  100    CONTINUE
  200 CONTINUE
      return
      END
      function ltrunc(string,l)
      CHARACTER*1 STRING(L)
      CHARACTER*1   BLNK
      DATA BLNK/' '/
C
      DO 100 I=L,1,-1
         L1=I
         IF (STRING(I).NE.BLNK) GOTO 200
  100 CONTINUE
      L1=0
  200 CONTINUE
      LTRUNC=L1
      return
      END
c-----------------------------------------------------------------------
      function mod1(i,n)
C
C     Yields MOD(I,N) with the exception that if I=K*N, result is N.
C
      MOD1=0
      IF (I.EQ.0) THEN
         return
      ENDIF
      IF (N.EQ.0) THEN
         WRITE(6,*) 
     $  'WARNING:  Attempt to take MOD(I,0) in function mod1.'
         return
      ENDIF
      II = I+N-1
      MOD1 = MOD(II,N)+1
      return
      END
c-----------------------------------------------------------------------
      integer function log2(k)
      RK=(K)
      RLOG=LOG10(RK)
      RLOG2=LOG10(2.0)
      RLOG=RLOG/RLOG2+0.5
      LOG2=INT(RLOG)
      return
      END
c-----------------------------------------------------------------------
      subroutine iflip(i1,n)
      DIMENSION I1(1)
      N1=N+1
      N2=N/2
      DO 10 I=1,N2
         ILAST=N1-I
         ITMP=I1(ILAST)
         I1(ILAST)=I1(I)
         I1(I)=ITMP
   10 CONTINUE
      return
      END
c-----------------------------------------------------------------------
      subroutine iswap(b,ind,n,temp)
      INTEGER B(1),IND(1),TEMP(1)
C***
C***  SORT ASSOCIATED ELEMENTS BY PUTTING ITEM(JJ)
C***  INTO ITEM(I), WHERE JJ=IND(I).
C***
      DO 20 I=1,N
         JJ=IND(I)
         TEMP(I)=B(JJ)
   20 CONTINUE
      DO 30 I=1,N
   30 B(I)=TEMP(I)
      return
      END
c-----------------------------------------------------------------------
      subroutine col2(a,b,n)
      real a(1),b(1)
      include 'OPCTR'
      include 'CTIMER'

#ifdef TIMER2
      if (icalld.eq.0) then
          icalld=1
          tcol2=0
      endif
      etime1=dnekclock()
#endif

      do i=1,n
         a(i)=a(i)*b(i)
      enddo

#ifdef TIMER2
      tcol2=tcol2+(dnekclock()-etime1)
#endif

      return
      end
c-----------------------------------------------------------------------
      subroutine col2c(a,b,c,n)
      real a(1),b(1),c

      do i=1,n
         a(i)=a(i)*b(i)*c
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine col3(a,b,c,n)
      real a(1),b(1),c(1)
      include 'OPCTR'
      include 'CTIMER'

#ifdef TIMER2
      if (icalld.eq.0) then
          icalld=1
          tcol3=0
      endif
      etime1=dnekclock()
#endif

      do i=1,n
         a(i)=b(i)*c(i)
      enddo

#ifdef TIMER2
      tcol3=tcol3+(dnekclock()-etime1)
#endif

      return
      end
c-----------------------------------------------------------------------
      subroutine add2(a,b,n)
      real a(1),b(1)
      include 'OPCTR'
      include 'CTIMER'

#ifdef TIMER2
      if (icalld.eq.0) then
          icalld=1
          tadd2=0
      endif
      etime1=dnekclock()
#endif
      do i=1,n
         a(i)=a(i)+b(i)
      enddo

#ifdef TIMER2
      tadd2=tadd2+(dnekclock()-etime1)
#endif
      return
      end
c-----------------------------------------------------------------------
      subroutine add3(a,b,c,n)
      real a(1),b(1),c(1)
      include 'OPCTR'

      do i=1,n
         a(i)=b(i)+c(i)
      enddo
      return
      end
c-----------------------------------------------------------------------
      subroutine addcol3(a,b,c,n)
      real a(1),b(1),c(1)
      include 'OPCTR'
      include 'CTIMER'

#ifdef TIMER2
      if (icalld.eq.0) then
          icalld=1
          tadc3=0
      endif
      etime1=dnekclock()
#endif

      do i=1,n
         a(i)=a(i)+b(i)*c(i)
      enddo

#ifdef TIMER2
      tadc3=tadc3+(dnekclock()-etime1)
#endif

      return
      end
c-----------------------------------------------------------------------
      subroutine add2s1(a,b,c1,n)
      real a(1),b(1)
C
      include 'OPCTR'
C
      DO 100 I=1,N
        A(I)=C1*A(I)+B(I)
  100 CONTINUE
      return
      END
C
c-----------------------------------------------------------------------
      subroutine add2s2(a,b,c1,n)
      real a(1),b(1)
C
      include 'OPCTR'
      include 'CTIMER'
C
#ifdef TIMER2
      if (icalld.eq.0) then
          icalld=1
          ta2s2=0
      endif
      etime1=dnekclock()
#endif
C
      DO 100 I=1,N
        A(I)=A(I)+C1*B(I)
  100 CONTINUE

#ifdef TIMER2
      ta2s2=ta2s2+(dnekclock()-etime1)
#endif

      return
      END
C
c-----------------------------------------------------------------------
      subroutine add3s2(a,b,c,c1,c2,n)
      real a(1),b(1),c(1)
C
      include 'OPCTR'
C
      DO 100 I=1,N
        A(I)=C1*B(I)+C2*C(I)
  100 CONTINUE
      return
      END
C
c-----------------------------------------------------------------------
      subroutine add4(a,b,c,d,n)
      REAL A(1),B(1),C(1),D(1)
C
      include 'OPCTR'
C
      DO 100 I=1,N
         A(I)=B(I)+C(I)+D(I)
 100  CONTINUE
      return
      END
c-----------------------------------------------------------------------
      real function vlsc2(x,y,n)
      REAL X(1),Y(1)
      include 'SIZE'
      include 'OPCTR'
      include 'PARALLEL'
C
      s = 0.
      do i=1,n
         s = s + x(i)*y(i)
      enddo
      vlsc2=s
      return
      end
c-----------------------------------------------------------------------
      real function vlsc21(x,y,n)
      real x(1),y(1)
      include 'SIZE'
      include 'OPCTR'
      include 'PARALLEL'
C
      s = 0.
      do i=1,n
         s = s + x(i)*x(i)*y(i)
      enddo
      vlsc21=s
      return
      end

C----------------------------------------------------------------------------
C
C     Vector reduction routines which require communication 
C     on a parallel machine. These routines must be substituted with
C     appropriate routines which take into account the specific architecture.
C
C----------------------------------------------------------------------------


      function glsc3(a,b,mult,n)
C
C     Perform inner-product in double precision
C
      REAL A(1),B(1),MULT(1)
      REAL TMP,WORK(1)
C
      include 'OPCTR'
C
      TMP = 0.0
      DO 10 I=1,N
         TMP = TMP + A(I)*B(I)*MULT(I)
 10   CONTINUE
      CALL GOP(TMP,WORK,'+  ',1)
      GLSC3 = TMP
      return
      END
c-----------------------------------------------------------------------
      function glsc2(x,y,n)
C
C     Perform inner-product in double precision
C
      include 'OPCTR'
c
      real x(1), y(1)
      real tmp,work(1)
C
      tmp=0.0
      do 10 i=1,n
         tmp = tmp+ x(i)*y(i)
   10 continue
      CALL GOP(TMP,WORK,'+  ',1)
      GLSC2 = TMP
      return
      END
c-----------------------------------------------------------------------
      function glsc23(x,y,z,n)
c
C     Perform inner-product  x*x*y*z
c
      real x(1), y(1),z(1)
      real tmp,work(1)

      ds = 0.0
      do 10 i=1,n
         ds=ds+x(i)*x(i)*y(i)*z(i)
   10 continue
      tmp=ds
      call gop(tmp,work,'+  ',1)
      glsc23 = tmp
      return
      end
c-----------------------------------------------------------------------
      real function gl2norm(a,n)

      include 'SIZE'
      include 'MASS'

      real a(1)

      common /scrsf/ w1 (lx1,ly1,lz1,lelt)

      call col3 (w1,a,a,n)
      call col2 (w1,bm1,n)
      gl2norm = sqrt(glsum (w1,n)/volvm1)

      return
      end
c-----------------------------------------------------------------------
      real function gl2norm2(a,n)

      include 'SIZE'
      include 'MASS'

      real a(n)

      common /scrsf/ w1 (lx2*ly2*lz2*lelt)

      call col3 (w1,a,a,n)
      call col2 (w1,bm2,n)
      gl2norm2 = sqrt(glsum (w1,n)/volvm2)

      return
      end
c-----------------------------------------------------------------------
      function glsum (x,n)
      DIMENSION X(1)
      DIMENSION TMP(1),WORK(1)
      TSUM = 0.
      DO 100 I=1,N
         TSUM = TSUM+X(I)
 100  CONTINUE
      TMP(1)=TSUM
      CALL GOP(TMP,WORK,'+  ',1)
      GLSUM = TMP(1)
      return
      END
c-----------------------------------------------------------------------
      real function glamax(a,n)
      REAL A(1)
      DIMENSION TMP(1),WORK(1)
      TMAX = 0.0
      DO 100 I=1,N
         TMAX = MAX(TMAX,ABS(A(I)))
 100  CONTINUE
      TMP(1)=TMAX
      CALL GOP(TMP,WORK,'M  ',1)
      GLAMAX=ABS(TMP(1))
      return
      END
c-----------------------------------------------------------------------
      real function glamin(a,n)
      real a(1)
      dimension tmp(1),work(1)
      tmin = 9.e28
      do 100 i=1,n
         tmin = min(tmin,abs(a(i)))
 100  continue
      tmp(1)=tmin
      call gop(tmp,work,'m  ',1)
      glamin=abs(tmp(1))
      return
      end
c-----------------------------------------------------------------------
      function iglmin(a,n)
      integer a(1),tmin
      integer tmp(1),work(1)
      tmin=  999999999
      do i=1,n
         tmin=min(tmin,a(i))
      enddo
      tmp(1)=tmin
      call igop(tmp,work,'m  ',1)
      iglmin=tmp(1)
      return
      end
c-----------------------------------------------------------------------
      function iglmax(a,n)
      integer a(1),tmax
      integer tmp(1),work(1)
      tmax= -999999999
      do i=1,n
         tmax=max(tmax,a(i))
      enddo
      tmp(1)=tmax
      call igop(tmp,work,'M  ',1)
      iglmax=tmp(1)
      return
      end
c-----------------------------------------------------------------------
      function iglsum(a,n)
      integer a(1),tsum
      integer tmp(1),work(1)
      tsum= 0
      do i=1,n
         tsum=tsum+a(i)
      enddo
      tmp(1)=tsum
      call igop(tmp,work,'+  ',1)
      iglsum=tmp(1)
      return
      end
c-----------------------------------------------------------------------
      subroutine i8zero(a,n)
      integer*8 a(1)
      do i=1,n
         a(i)=0
      enddo
      return
      end
c-----------------------------------------------------------------------
      integer*8 function i8glsum(a,n)
      integer*8 a(1),tsum
      integer*8 tmp(1),work(1)
      tsum= 0
      do i=1,n
         tsum=tsum+a(i)
      enddo
      tmp(1)=tsum
      call i8gop(tmp,work,'+  ',1)
      i8glsum=tmp(1)
      return
      end
C-----------------------------------------------------------------------
      function glmax(a,n)
      REAL A(1)
      DIMENSION TMP(1),WORK(1)
      TMAX=-99.0e20
      DO 100 I=1,N
         TMAX=MAX(TMAX,A(I))
  100 CONTINUE
      TMP(1)=TMAX
      CALL GOP(TMP,WORK,'M  ',1)
      GLMAX=TMP(1)
      return
      END
c-----------------------------------------------------------------------
      function glmin(a,n)
      REAL A(1)
      DIMENSION TMP(1),WORK(1)
      TMIN=99.0e20
      DO 100 I=1,N
         TMIN=MIN(TMIN,A(I))
  100 CONTINUE
      TMP(1)=TMIN
      CALL GOP(TMP,WORK,'m  ',1)
      GLMIN = TMP(1)
      return
      END
c-----------------------------------------------------------------------
      subroutine gllog(la,lb)
C
C     If ANY LA=LB, then ALL LA=LB.
C
      LOGICAL LA,LB
      DIMENSION TMP(1),WORK(1)
C
      TMP(1)=1.0
      IF (LB) THEN
         IF (LA) TMP(1)=0.0
      ELSE
         IF (.NOT.LA) TMP(1)=0.0
      ENDIF
      CALL GOP(TMP,WORK,'*  ',1)
      IF (TMP(1).EQ.0.0) LA=LB
      return
      END
c-----------------------------------------------------------------------
      function fmdian(a,n,ifok)
C     find the Median of the (global) set A
      include 'SIZE'
      DIMENSION A(1)
      DIMENSION WORK1(5),WORK2(5)
      DIMENSION GUES(100)
      LOGICAL IFOK
C
      AMP  =1.5
      AFAC =1.5
      GMIN =GLMIN(A,N)
      GMAX =GLMAX(A,N)
      GMIN0=GLMIN(A,N)
      GMAX0=GLMAX(A,N)
      GUESS=(GMAX+GMIN)/2.0
      EPS  =(GMAX-GMIN)
      IF (EPS.EQ.0.0) THEN
         FMDIAN=GMAX
         return
      ENDIF
      WORK1(1)=N
      CALL GOP(WORK1,WORK2,'+  ',1)
      NTOT=WORK1(1)
      N2 = (NTOT+1)/2
      IF (.NOT.IFOK) THEN
        WRITE(6,8) NID,N,(A(I),I=1,N)
        WRITE(6,9) NID,NTOT,N2,N,GMIN,GMAX
    8   FORMAT(I5,'N,A:',I5,10(6F10.5,/)) 
    9   FORMAT(I5,'mnx:',3I6,2F10.5)
      ENDIF
C
C     This is the trial loop
C
      ITRY=-1
   10 CONTINUE
      ITRY=ITRY+1
      II=ITRY+1
      IF (II.LE.100) GUES(II)=GUESS
C     error check for infinite loop
      IF (ITRY.GT.2*NTOT) GOTO 9000
      CALL RZERO(WORK1,5)
      NLT=0
      NGT=0
      CLT=GMIN0
      CGT=GMAX0
      DO 100 I=1,N
         AA=A(I)
         IF (AA.NE.GUESS) THEN
            IF (AA.LT.GUESS) THEN
               NLT=NLT+1
C              CLT - closest value to GUESS Less Than GUESS
               IF (AA.GT.CLT) CLT=AA
            ENDIF
            IF (AA.GT.GUESS) THEN
               NGT=NGT+1
C              CGT - closest value to GUESS Greater Than GUESS
               IF (AA.LT.CGT) CGT=AA
            ENDIF
            DUM=1./(EPS+ABS(AA-GUESS))
            WORK1(1)=WORK1(1)+DUM
            WORK1(2)=WORK1(2)+DUM*AA
         ELSE
C           detected values equaling the guess.
            WORK1(5)=WORK1(5)+1.0
         ENDIF
  100 CONTINUE
C     Invoke vector reduction across processors:
      WORK2(1)=CLT
      CLT=GLMAX(WORK2,1)
      WORK2(1)=CGT
      CGT=GLMIN(WORK2,1)
      WORK1(3)=NLT
      WORK1(4)=NGT
      CALL GOP(WORK1,WORK2,'+  ',5)
      NLT=WORK1(3)
      NGT=WORK1(4)
      IF (.NOT.IFOK) THEN
         WRITE(6,101) NID,GUESS,CLT,CGT
         WRITE(6,102) NID,(WORK1(I),I=1,5)
  101    FORMAT(I5,'Glg:',3F12.5)
  102    FORMAT(I5,'WORK1:',5F12.5)
      ENDIF
C
C     Done?
C
      IF (NLT.GT.N2.OR.NGT.GT.N2) THEN
C        we're not done.....
         IF (NGT.GT.NLT) THEN
C           guess is too low
            GMIN=CGT
            G2=CGT+MAX(0.,WORK1(2)/WORK1(1)-GUESS)*AMP
            IF (G2.GT.GMAX) G2=0.5*(GUESS+GMAX)
            EPS=AFAC*ABS(G2-GUESS)
C           see that we move at least as far as the next closest value.
            GUESS=MAX(G2,CGT)
            GOTO 10
         ELSE IF (NLT.GT.NGT) THEN
C           guess is too high
            GMAX=CLT
            G2=CLT+MIN(0.,WORK1(2)/WORK1(1)-GUESS)*AMP
            IF (G2.LT.GMIN) G2=0.5*(GUESS+GMIN)
            EPS=AFAC*ABS(G2-GUESS)
C           see that we move at least as far as the next closest value.
            GUESS=MIN(G2,CLT)
            GOTO 10
         ENDIF
      ELSE
C
C        we're done....
         IF (WORK1(5).NE.0) THEN
C           the median is (usually) one of the values 
            FMDIAN=GUESS
            IF (WORK1(5).EQ.1.0) THEN
               IF (MOD(NTOT,2).EQ.0) THEN
                  IF (NGT.GT.NLT) THEN
                     FMDIAN=0.5*(GUESS+CGT)
                  ELSE
                     FMDIAN=0.5*(GUESS+CLT)
                  ENDIF
               ELSE
                  IF (NGT.EQ.NLT) THEN
                     FMDIAN=GUESS
                  ELSE IF(NGT.GT.NLT) THEN
                     FMDIAN=CGT
                  ELSE
                     FMDIAN=CLT
                  ENDIF
               ENDIF
            ENDIF
         ELSE
            IF (MOD(NTOT,2).EQ.0) THEN
               IF (NGT.EQ.NLT) THEN
                  FMDIAN=0.5*(CLT+CGT)
               ELSE IF(NGT.GT.NLT) THEN
                  FMDIAN=0.5*(GUESS+CGT)
               ELSE
                  FMDIAN=0.5*(GUESS+CLT)
               ENDIF
            ELSE
               IF (NGT.EQ.NLT) THEN
                  FMDIAN=GUESS
               ELSE IF(NGT.GT.NLT) THEN
                  FMDIAN=CGT
               ELSE
                  FMDIAN=CLT
               ENDIF
           ENDIF
         ENDIF
C
      ENDIF
       IF (.NOT.IFOK) WRITE(6,*) NID,'FMDIAN2',FMDIAN,(A(I),I=1,N)
      return
C
C     Error handling
C
 9000 CONTINUE
      WRITE(6,11) NTOT,GMIN0,GMAX0,GUESS
   11 FORMAT('ABORTING IN FMDIAN: N,AMIN,AMAX:',I6,3G14.6)
      DO 13 I1=1,N,5
        IN=I1+5 
        IN=MIN(IN,N)
        WRITE(6,12) NID,(A(I),I=I1,IN)
   12   FORMAT(I4,' FMA:',5G14.6)
   13 CONTINUE
      DO 15 I1=1,ITRY,5
        IN=I1+5
        IN=MIN(IN,ITRY)
        WRITE(6,14) NID,(GUES(I),I=I1,IN)
   14   FORMAT(I4,' FMG:',5G14.6)
   15 CONTINUE
      call exitt
      END

C========================================================================
C     Double precision matrix and vector routines
C========================================================================

c-----------------------------------------------------------------------
      subroutine dcadd(a,const,n)
      real*8 A(1),CONST
C
      DO 100 I=1,N
         A(I)=A(I)+CONST
 100  CONTINUE
      return
      END
c-----------------------------------------------------------------------
      subroutine dsub2(a,b,n)
      real*8 A(1), B(1)
C
      DO 100 I=1,N
         A(I)=A(I)-B(I)
 100  CONTINUE
      return
      END
C
c-----------------------------------------------------------------------
      subroutine dadd2(a,b,n)
      real*8 A(1), B(1)
C
      DO 100 I=1,N
         A(I)=A(I)+B(I)
 100  CONTINUE
      return
      END
c-----------------------------------------------------------------------
      subroutine chswapr(b,L,ind,n,temp)
      INTEGER IND(1)
      CHARACTER*6 B(1),TEMP(1)
C***
C***  SORT ASSOCIATED ELEMENTS BY PUTTING ITEM(JJ)
C***  INTO ITEM(I), WHERE JJ=IND(I).
C***
      DO 20 I=1,N
         JJ=IND(I)
         TEMP(I)=B(JJ)
   20 CONTINUE
      DO 30 I=1,N
   30 B(I)=TEMP(I)
      return
      END
c-----------------------------------------------------------------------
      subroutine drcopy(r,d,N)
      real*8    d(1)
      dimension r(1)
      do 10 i=1,n
         r(i)=d(i)
   10 continue
      return
      end
c-----------------------------------------------------------------------
      subroutine rrcopy(r,d,N)
      real*4 d(1)
      real*4 r(1)
      do 10 i=1,n
         r(i)=d(i)
   10 continue
      return
      end
c-----------------------------------------------------------------------
      subroutine sorts(xout,xin,work,n)
      real xout(1),xin(1),work(1)
      call copy(xout,xin,n)
      call sort(xout,work,n)
      return
      end
C
c-----------------------------------------------------------------------
      function ivlsum(a,n)
      INTEGER A(1)
      INTEGER TSUM
      if (n.eq.0) then
         ivlsum = 0
         return
      endif
      TSUM=A(1)
      DO 100 I=2,N
         TSUM=TSUM+A(I)
  100 CONTINUE
      IVLSUM=TSUM
      return
      END
c-----------------------------------------------------------------------
      subroutine icadd(a,c,n)
      INTEGER A(1),C
      DO 100 I = 1, N
 100     A(I) = A(I) + C
      return
      END
      subroutine isort(a,ind,n)
C
C     Use Heap Sort (p 231 Num. Rec., 1st Ed.)
C
      integer a(1),ind(1)
      integer aa
C
      dO 10 j=1,n
         ind(j)=j
   10 continue
C
      if (n.le.1) return
      L=n/2+1
      ir=n
  100 continue
         if (l.gt.1) then
            l=l-1
            aa  = a  (l)
            ii  = ind(l)
         else
                 aa =   a(ir)
                 ii = ind(ir)
              a(ir) =   a( 1)
            ind(ir) = ind( 1)
            ir=ir-1
            if (ir.eq.1) then
                 a(1) = aa
               ind(1) = ii
               return
            endif
         endif
         i=l
         j=l+l
  200    continue
         if (j.le.ir) then
            if (j.lt.ir) then
               if ( a(j).lt.a(j+1) ) j=j+1
            endif
            if (aa.lt.a(j)) then
                 a(i) = a(j)
               ind(i) = ind(j)
               i=j
               j=j+j
            else
               j=ir+1
            endif
         GOTO 200
         endif
           a(i) = aa
         ind(i) = ii
      GOTO 100
      end
      subroutine sort(a,ind,n)
C
C     Use Heap Sort (p 231 Num. Rec., 1st Ed.)
C
      real a(1),aa
      integer ind(1)
C
      dO 10 j=1,n
         ind(j)=j
   10 continue
C
      if (n.le.1) return
      L=n/2+1
      ir=n
  100 continue
         if (l.gt.1) then
            l=l-1
            aa  = a  (l)
            ii  = ind(l)
         else
                 aa =   a(ir)
                 ii = ind(ir)
              a(ir) =   a( 1)
            ind(ir) = ind( 1)
            ir=ir-1
            if (ir.eq.1) then
                 a(1) = aa
               ind(1) = ii
               return
            endif
         endif
         i=l
         j=l+l
  200    continue
         if (j.le.ir) then
            if (j.lt.ir) then
               if ( a(j).lt.a(j+1) ) j=j+1
            endif
            if (aa.lt.a(j)) then
                 a(i) = a(j)
               ind(i) = ind(j)
               i=j
               j=j+j
            else
               j=ir+1
            endif
         GOTO 200
         endif
           a(i) = aa
         ind(i) = ii
      GOTO 100
      end
c-----------------------------------------------------------------------
      subroutine iswap_ip(x,p,n)
      integer x(1),xstart
      integer p(1)
c
c     In-place permutation: x' = x(p)
c
      do k=1,n
         if (p(k).gt.0) then   ! not swapped
            xstart     = x(k)
            loop_start = k
            last       = k
            do j=k,n
               next    = p(last)
               if (next.lt.0) then
                  write(6,*) 'Hey! iswap_ip problem.',j,k,n,next
                  call exitt
               elseif (next.eq.loop_start) then
                  x(last) = xstart
                  p(last) = -p(last)
                  goto 10
               else
                  x(last) = x(next)
                  p(last) = -p(last)
                  last    = next
               endif
            enddo
   10       continue
         endif
      enddo
c
      do k=1,n
         p(k) = -p(k)
      enddo
      return
      end
c-----------------------------------------------------------------------
      subroutine iswapt_ip(x,p,n)
      integer x(1),t1,t2
      integer p(1)
c
c     In-place permutation: x'(p) = x
c

      do k=1,n
         if (p(k).gt.0) then   ! not swapped
            loop_start = k
            next       = p(loop_start)
            t1         = x(loop_start)
            do j=1,n
               if (next.lt.0) then
                  write(6,*) 'Hey! iswapt_ip problem.',j,k,n,next
                  call exitt
               elseif (next.eq.loop_start) then
                  x(next) = t1
                  p(next) = -p(next)
                  goto 10
               else
                  t2      =  x(next)
                  x(next) =  t1
                  t1      =  t2
                  nextp   =  p(next)
                  p(next) = -p(next)
                  next    =  nextp
               endif
            enddo
   10       continue
         endif
      enddo
c
      do k=1,n
         p(k) = -p(k)
      enddo
      return
      end
c-----------------------------------------------------------------------
      subroutine swap_ip(x,p,n)
      real    x(1),xstart
      integer p(1)
c
c     In-place permutation: x' = x(p)
c
      do k=1,n
         if (p(k).gt.0) then   ! not swapped
            xstart     = x(k)
            loop_start = k
            last       = k
            do j=k,n
               next    = p(last)
               if (next.lt.0) then
                  write(6,*) 'Hey! swap_ip problem.',j,k,n,next
                  call exitt
               elseif (next.eq.loop_start) then
                  x(last) = xstart
                  p(last) = -p(last)
                  goto 10
               else
                  x(last) = x(next)
                  p(last) = -p(last)
                  last    = next
               endif
            enddo
   10       continue
         endif
      enddo
c
      do k=1,n
         p(k) = -p(k)
      enddo
      return
      end
c-----------------------------------------------------------------------
      subroutine swapt_ip(x,p,n)
      real    x(1),t1,t2
      integer p(1)
c
c     In-place permutation: x'(p) = x
c

      do k=1,n
         if (p(k).gt.0) then   ! not swapped
            loop_start = k
            next       = p(loop_start)
            t1         = x(loop_start)
            do j=1,n
               if (next.lt.0) then
                  write(6,*) 'Hey! swapt_ip problem.',j,k,n,next
                  call exitt
               elseif (next.eq.loop_start) then
                  x(next) = t1
                  p(next) = -p(next)
                  goto 10
               else
                  t2      =  x(next)
                  x(next) =  t1
                  t1      =  t2
                  nextp   =  p(next)
                  p(next) = -p(next)
                  next    =  nextp
               endif
            enddo
   10       continue
         endif
      enddo
c
      do k=1,n
         p(k) = -p(k)
      enddo
      return
      end
c-----------------------------------------------------------------------
      subroutine glvadd(x,w,n)
      real x(1),w(1)
      call gop(x,w,'+  ',n)
      return
      end
c-----------------------------------------------------------------------
      subroutine add3s12(x,y,z,c1,c2,n)
      real x(1),y(1),z(1),c1,c2
      do i=1,n
         x(i) = c1*y(i)+c2*z(i)
      enddo
      return
      end
c-----------------------------------------------------------------------
      integer*8 function i8glmax(a,n)
      integer*8 a(1),tmax
      integer*8 tmp(1),work(1)
      tmax= -999999
      do i=1,n
         tmax=max(tmax,a(i))
      enddo
      tmp(1)=tmax
      call i8gop(tmp,work,'M  ',1)
      i8glmax=tmp(1)
      if (i8glmax .eq. -999999) i8glmax=0
      return
      end
c-----------------------------------------------------------------------
      subroutine admcol3(a,b,c,d,n)
      REAL A(1),B(1),C(1),D
C
      DO 100 I=1,N
         A(I)=A(I)+B(I)*C(I)*D
  100 CONTINUE
      return
      END
c-----------------------------------------------------------------------
      subroutine add2col2(a,b,c,n)
      real a(1),b(1),c(1)
c
      do i=1,n
         a(i) = a(i) + b(i)*c(i)
      enddo
      return
      end
c-----------------------------------------------------------------------
      subroutine add2sxy(x,a,y,b,n)
      real x(1),y(1)
c
      do i=1,n
         x(i) = a*x(i) + b*y(i)
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine col2s2(x,y,s,n)
      real x(n),y(n)
c
      do i=1,n
         x(i)=s*x(i)*y(i)
      enddo
c
      return
      end
cc-----------------------------------------------------------------------
      subroutine transpose(a,lda,b,ldb)
      real a(lda,1),b(ldb,1)
c
      do j=1,ldb
         do i=1,lda
            a(i,j) = b(j,i)
         enddo
      enddo
      return
      end
c-----------------------------------------------------------------------
      subroutine transpose1(a,n)
      real a(n,n)
c
      do j=1,n
      do i=j+1,n
         ta     = a(i,j)
         a(i,j) = a(j,i)
         a(j,i) = ta
      enddo
      enddo
      return
      end
c-----------------------------------------------------------------------
      real function difmax(a,b,n)
      real a(1),b(1)

      d=0
      do i=1,n
         diff = abs(a(i)-b(i))
         d    = max(d,diff)
      enddo
      difmax = glamax(d,1)

      return
      end
c-----------------------------------------------------------------------
ccc Nek-Nek routines
c-----------------------------------------------------------------------
      function glmin_ms(a,n)
      include 'SIZE'
      include 'PARALLEL'
      real a(1)

      call setnekcomm(iglobalcomm)
      glmin_ms = glmin(a,n)
      call setnekcomm(intracomm)

      return
      end
c-----------------------------------------------------------------------
      function glamin_ms(a,n)
      include 'SIZE'
      include 'PARALLEL'
      real a(1)

      call setnekcomm(iglobalcomm)
      glamin_ms = glamin(a,n)
      call setnekcomm(intracomm)

      return
      end
c-----------------------------------------------------------------------
      function glmax_ms(a,n)
      include 'SIZE'
      include 'PARALLEL'
      real a(1)

      call setnekcomm(iglobalcomm)
      glmax_ms = glmax(a,n)
      call setnekcomm(intracomm)

      return
      end
c------------------------------------------------------------------------
      function glamax_ms(a,n)
      include 'SIZE'
      include 'PARALLEL'
      real a(1)

      call setnekcomm(iglobalcomm)
      glamax_ms = glamax(a,n)
      call setnekcomm(intracomm)

      return
      end
c------------------------------------------------------------------------
      function glsum_ms(a,n)
      include 'SIZE'
      include 'PARALLEL'
      real a(1)

      call setnekcomm(iglobalcomm)
      glsum_ms = glsum(a,n)
      call setnekcomm(intracomm)

      return
      end
c-----------------------------------------------------------------------
      function iglsum_ms(a,n)
      include 'SIZE'
      include 'PARALLEL'
      integer a(1),n

      call setnekcomm(iglobalcomm)
      iglsum_ms = iglsum(a,n)
      call setnekcomm(intracomm)

      return
      end
c-----------------------------------------------------------------------
      function glsc3_ms(a,b,c,n)
      include 'SIZE'
      include 'PARALLEL'
      real a(1),b(1),c(1)

      call setnekcomm(iglobalcomm)
      glsc3_ms = glsc3(a,b,c,n)
      call setnekcomm(intracomm)

      return
      end
c-----------------------------------------------------------------------
      function glsc2_ms(a,b,n)
      include 'SIZE'
      include 'PARALLEL'
      real a(1),b(1)

      call setnekcomm(iglobalcomm)
      glsc2_ms = glsc2(a,b,n)
      call setnekcomm(intracomm)

      return
      end
c-----------------------------------------------------------------------
      function iglmax_ms(a,n)
      include 'SIZE'
      include 'PARALLEL'
      integer a(1)

      call setnekcomm(iglobalcomm)
      iglmax_ms = iglmax(a,n)
      call setnekcomm(intracomm)

      return
      end
c-----------------------------------------------------------------------
      function iglmin_ms(a,n)
      include 'SIZE'
      include 'PARALLEL'
      integer a(1)

      call setnekcomm(iglobalcomm)
      iglmin_ms = iglmin(a,n)
      call setnekcomm(intracomm)

      return
      end
c-----------------------------------------------------------------------

      SUBROUTINE ESOLVER (RES,H1,H2,H2INV,INTYPE)
C---------------------------------------------------------------------
C
C     Choose E-solver
C
C--------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'ESOLV'
      INCLUDE 'INPUT'
C
      REAL RES   (LX2,LY2,LZ2,LELV)
      REAL H1    (LX1,LY1,LZ1,LELV)
      REAL H2    (LX1,LY1,LZ1,LELV)
      REAL H2INV (LX1,LY1,LZ1,LELV)
      common /scruz/ wk1(lx2*ly2*lz2*lelv)
     $             , wk2(lx2*ly2*lz2*lelv)
     $             , wk3(lx2*ly2*lz2*lelv)

      include 'CTIMER'
      real kwave2

      if (icalld.eq.0) teslv=0.0

      call ortho(res) !Ensure that residual is orthogonal to null space

      icalld=icalld+1
      neslv=icalld
      etime1=dnekclock()

      if (.not. ifsplit) then
         if (param(42).eq.1) then
            CALL UZAWA (RES,H1,H2,H2INV,INTYPE,ICG)
         else
            call uzawa_gmres(res,h1,h2,h2inv,intype,icg)
         endif
      else
         WRITE(6,*) 'ERROR: E-solver does not exist PnPn'
         CALL EXITT
      ENDIF

      teslv=teslv+(dnekclock()-etime1)

      RETURN
      END
c-----------------------------------------------------------------------
      subroutine dmp_map(imap)
c
c     Dump map file and element center point
c
      include 'SIZE'
      include 'TOTAL'

      common /ivrtx/ vertex ((2**ldim)*lelt)
      common /scruz/ xbar(ldim,lelt),ibar(lelt)
      integer vertex
      integer imap(nelgt)

      integer e,eg

      nxb = (lx1+1)/2
      nyb = (ly1+1)/2
      nzb = (lz1+1)/2
      
      do e=1,nelt
         xbar(ldim,e) = zm1(nxb,nyb,nzb,e)
         xbar(1   ,e) = xm1(nxb,nyb,nzb,e)
         xbar(2   ,e) = ym1(nxb,nyb,nzb,e)
         eg           = lglel(e)
         ibar(e)      = imap(eg)
      enddo
      call p_outvec_ir(ibar,xbar,ldim,'mpxyz.dat')

      return
      end
c-----------------------------------------------------------------------
      subroutine p_outvec_ir(ia,a,lda,name9)
      integer ia(1)
      real    a(lda,1)
      character*9 name9

      include 'SIZE'
      include 'TOTAL'

      parameter (lbuf=50)
      common /scbuf/ buf(lbuf)
      integer ibuf(10),e,eg
      equivalence (buf,ibuf)

      if (nid.eq.0) then
         open(unit=49,file=name9)
         write(6,*) 'Opening ',name9,' in p_outveci. lda=',lda
      endif

      len = wdsize*(lda+1)
      dum = 0.

      do eg=1,nelgt

         mid   = gllnid(eg)
         e     = gllel (eg)
         mtype = 2000+e

         if (nid.eq.0) then
            if (mid.eq.0) then
               call icopy(buf(1),ia(e),1)
               call  copy(buf(2),a(1,e),lda)
            else
               call csend (mtype,dum,wdsize,mid,nullpid)
               call crecv2 (mtype,buf,len,mid)
            endif
            write(49,49) mid,ibuf(1),(buf(k+1),k=1,lda)
   49       format(2i12,1p3e16.7)
         elseif (nid.eq.mid) then
            call icopy(buf(1),ia(e),1)
            call  copy(buf(2),a(1,e),lda)
            call crecv2 (mtype,dum,wdsize,0)
            call csend (mtype,buf,len,node0,nullpid)
         endif
      enddo

      if (nid.eq.0) then
         close(49)
         write(6,*) 'Done writing to ',name9,' p_outveci.'
      endif

      call nekgsync()

      return
      end
c-----------------------------------------------------------------------

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!The safelen(2) clause safelen(2)@22:16 guarantees that the vector code is safe for vectors up to 2 (inclusive).
!In the loop, m can be 2 or more for the correct execution. If the value of m is less than 2,
!the behavior is undefined. Data Race Pair: b[i]@24:9 and b[i-m]@24:16.

program DRB137_simdsafelen_orig_no
    use omp_lib
    implicit none

    integer :: i, m, n
    real :: b(4)

    m = 1
    n = 4

    !$omp simd safelen(2)
    do i = m+1, n
        b(i) = b(i-m) - 1.0
    end do

    print*, b(3)
end program

c-----------------------------------------------------------------------
      subroutine cbcmesh
C
C     Generate boundary conditions (CBC arrays) for mesh solver
C
      include 'SIZE'
      include 'GEOM'
      include 'INPUT'
      include 'TSTEP'
C
      CHARACTER CBM*1,CBF*3,CBT*3,CB*3
C
      IFLD   = 0
      NFACE  = 2*ldim
      IFMELT = .FALSE.
      IF (IFTMSH(IFLD)) IFMELT=.TRUE.
C
      DO 100 IEL=1,NELT
      DO 100 IFC=1,NFACE
         CBM = CBC(IFC,IEL,0)
         CBF = CBC(IFC,IEL,1)
         CBT = CBC(IFC,IEL,2)
C
         IF (CBT(1:1).EQ.'M') THEN
             IFLD = 2
             CB   = CBT
             GOTO 200
         ENDIF
         IF (CBF(1:1).EQ.'M' .OR. CBF(1:1).EQ.'m') THEN
             IFLD = 1
             CB   = CBF
C             IF (CBF.EQ.'mv ' .AND. CBT.EQ.'E  ') THEN
C                 IFTMSH(0)=.TRUE.
C             ENDIF
             IF (CBF.EQ.'mv ' .AND. CBM.EQ.'+'  ) THEN
                CB = 'mvn'
                CBC(IFC,IEL,1) = CB
             ENDIF
             GOTO 200
         ENDIF
         IF (CBF(1:1).EQ.'V' .OR. CBF(1:1).EQ.'v' .OR.
     $       CBF(1:1).EQ.'W' ) THEN
             IFLD = 1
             CB   = 'FIX'
             IF (IFMELT .OR. CBM.EQ.'+') CB='SYM'
             GOTO 200
         ENDIF
         IF (CBT.EQ.'T  ' .OR. CBT.EQ.'t  ') THEN
             IFLD = 2
             CB   = 'FIX'
             IF (CBM.EQ.'+') CB='SYM'
             GOTO 200
         ENDIF
         IF (CBF.EQ.'P  ' .OR. CBF.EQ.'E  ') THEN
             IFLD = 1
             CB   = CBF
             IF (CBM.EQ.'-') CB='FIX'
             IF (CBM.EQ.'+') CB='SYM'
             GOTO 200
         ENDIF
         IF (CBT.EQ.'P  ' .OR. CBT.EQ.'E  ') THEN
             IFLD = 2
             CB   = CBT
             IF (CBM.EQ.'-') CB='FIX'
             IF (CBM.EQ.'+') CB='SYM'
             GOTO 200
         ENDIF
         IFLD = 1
         IF (CBF.EQ.'   ') IFLD = 2
         CB   = 'SYM'
         IF (CBM.EQ.'-') CB = 'FIX'
C
  200    CBC(IFC,IEL,0) = CB
         DO 250 I=1,5
  250    BC(I,IFC,IEL,0)=BC(I,IFC,IEL,IFLD)
  100 CONTINUE
C
      return
      end
c-----------------------------------------------------------------------
      subroutine admeshv
C
      include 'SIZE'
      include 'SOLN'
      include 'TSTEP'
C
      COMMON /SCRUZ/ FM1(LX1,LY1,LZ1,LELT)
     $             , FM2(LX1,LY1,LZ1,LELT)
     $             , FM3(LX1,LY1,LZ1,LELT)
     $             , PHI(LX1,LY1,LZ1,LELT)
C
      NTOT1=lx1*ly1*lz1*NELV
C
      CALL RZERO (FM1,NTOT1)
      CALL RZERO (FM2,NTOT1)
      CALL RZERO (FM3,NTOT1)
C
      CALL DIVWS (FM1,VX,PHI,NELV,1)
      CALL DIVWS (FM2,VY,PHI,NELV,2)
      CALL ADD2  (BFX,FM1,NTOT1)
      CALL ADD2  (BFY,FM2,NTOT1)
      IF (ldim.EQ.3) THEN
         CALL DIVWS (FM3,VZ,PHI,NELV,3)
         CALL ADD2  (BFZ,FM3,NTOT1)
      ENDIF
C
      return
      end
c-----------------------------------------------------------------------
      subroutine admesht
C
      include 'SIZE'
      include 'SOLN'
      include 'TSTEP'
C
      COMMON /SCRUZ/ FMT(LX1,LY1,LZ1,LELT)
     $             , PHI(LX1,LY1,LZ1,LELT)
C
      IFLD = 0
      NEL  = NELFLD(IFLD)
      NTOT1= lx1*ly1*lz1*NEL
C
      CALL RZERO   (FMT,NTOT1)
      CALL DIVWS   (FMT,T(1,1,1,1,IFIELD-1),PHI,NEL,1)
      CALL ADDCOL3 (BQ(1,1,1,1,IFIELD-1),FMT,VTRANS(1,1,1,1,IFIELD),
     &              NTOT1)
C
      return
      end
c-----------------------------------------------------------------------
      subroutine divws (fms,sfv,phi,nel,idir)
C
      include 'SIZE'
      include 'GEOM'
      include 'MASS'
      include 'MVGEOM'
      include 'WZ'
      include 'INPUT'
C
      COMMON /SCRSF/ PHR(LX1,LY1,LZ1,LELT)
     $             , PHS(LX1,LY1,LZ1,LELT)
     $             , PHT(LX1,LY1,LZ1,LELT)

      DIMENSION FMS(LX1,LY1,LZ1,1)
     $        , SFV(LX1,LY1,LZ1,1)
     $        , PHI(LX1,LY1,LZ1,1)
C
      NXYZ1 = lx1*ly1*lz1
      NTOT1 = NXYZ1*NEL
C
      CALL COL3    (PHI,SFV,WX,NTOT1)
      CALL URST    (PHI,PHR,PHS,PHT,NEL)
      CALL ADDCOL3 (FMS,RXM1,PHR,NTOT1)
      CALL ADDCOL3 (FMS,SXM1,PHS,NTOT1)
      IF (ldim.EQ.3) CALL ADDCOL3 (FMS,TXM1,PHT,NTOT1)
C
      CALL COL3    (PHI,SFV,WY,NTOT1)
      CALL URST    (PHI,PHR,PHS,PHT,NEL)
      CALL ADDCOL3 (FMS,RYM1,PHR,NTOT1)
      CALL ADDCOL3 (FMS,SYM1,PHS,NTOT1)
      IF (ldim.EQ.3) CALL ADDCOL3 (FMS,TYM1,PHT,NTOT1)
C      
      IF (ldim.EQ.3) THEN
         CALL COL3    (PHI,SFV,WZ,NTOT1)
         CALL URST    (PHI,PHR,PHS,PHT,NEL)
         CALL ADDCOL3 (FMS,RZM1,PHR,NTOT1)
         CALL ADDCOL3 (FMS,SZM1,PHS,NTOT1)
         CALL ADDCOL3 (FMS,TZM1,PHT,NTOT1)
      ENDIF
C
      CALL COL2    (FMS,BM1,NTOT1)
      CALL INVCOL2 (FMS,JACM1,NTOT1)
C
      IF (IFAXIS) CALL AXIFMS (FMS,SFV,PHI,NEL,IDIR)
C
      return
      end
c-----------------------------------------------------------------------
      subroutine axifms (fms,sfv,phi,nel,idir)
C
      include 'SIZE'
      include 'DXYZ'
      include 'GEOM'
      include 'INPUT'
      include 'MASS'
      include 'MVGEOM'
      include 'WZ'
      COMMON /SCRSF/ PHR(LX1,LY1,LZ1,LELT)
     $             , PHS(LX1,LY1,LZ1,LELT)
     $             , PHT(LX1,LY1,LZ1,LELT)
C
      DIMENSION FMS(LX1,LY1,LZ1,1)
     $        , PHI(LX1,LY1,LZ1,1)
     $        , SFV(LX1,LY1,LZ1,1)
     $        , WYS(LX1)
      EQUIVALENCE (WYS(1),PHT(1,1,1,1))
C
      NXYZ1 = lx1*ly1*lz1
      NTOT1 = NXYZ1*NEL
      CALL COL3 (PHI,SFV,WY,NTOT1)
C
      DO 100 IEL=1,NEL
      IF ( IFRZER(IEL) ) THEN
         IF (IDIR.EQ.1) THEN
            CALL MXM (WY(1,1,1,IEL),lx1,DATM1,ly1,WYS,1)
            DO 220 IX=1,lx1
            FMS(IX,1,1,IEL)= FMS(IX,1,1,IEL) + WXM1(IX)*WAM1(1)*
     $                       WYS(IX)*SFV(IX,1,1,IEL)*JACM1(IX,1,1,IEL)
  220       CONTINUE
         ENDIF
         DO 320 IX=1,lx1
         DO 320 IY=2,ly1
            FMS(IX,IY,1,IEL)=FMS(IX,IY,1,IEL) + PHI(IX,IY,1,IEL) *
     $                       BM1(IX,IY,1,IEL) / YM1(IX,IY,1,IEL)
  320    CONTINUE
      ELSE
         CALL ADDCOL4 (FMS(1,1,1,IEL),PHI(1,1,1,IEL),JACM1(1,1,1,IEL),
     $                 W2CM1,NXYZ1)
      ENDIF
  100 CONTINUE
C
      return
      end
c-----------------------------------------------------------------------
      subroutine updcoor
C-----------------------------------------------------------------------
C
C     Subroutine to update geometry for moving boundary problems
C
C-----------------------------------------------------------------------
      include 'SIZE'
      include 'TSTEP'
      include 'INPUT'
C
      IFIELD = 0
      NEL    = NELFLD(IFIELD)
C
C     Update collocation points coordinates
C
      CALL UPDXYZ (NEL)
C
C     Shift lagged mesh velocity
C
      if (.not.ifrich) call lagmshv (nel)
C
      return
      end
c-----------------------------------------------------------------------
      subroutine mvbdry (nel)

c     Evaluate mesh velocities at all moving boundaries

      include 'SIZE'
      include 'GEOM'
      include 'INPUT'
      include 'MVGEOM'
      include 'SOLN'
      include 'TSTEP'

      common /scrsf/ wvx(lx1*ly1*lz1,lelt)
     $             , wvy(lx1*ly1*lz1,lelt)
     $             , wvz(lx1*ly1*lz1,lelt)
      common /scrch/ wtx(lx1*ly1*lz1,lelt)
     $             , wty(lx1*ly1*lz1,lelt)
      common /scrmg/ wtz(lx1*ly1*lz1,lelt)
     $             , rnx(lx1*ly1*lz1,lelt)
     $             , rny(lx1*ly1*lz1,lelt)
     $             , rnz(lx1*ly1*lz1,lelt)
      common /scruz/ dsa(lx1*ly1*lz1,lelt)
     $             , qni(lx1*ly1*lz1,lelt)
     $             , smt(lx1*ly1*lz1,lelt)
     $             , ta (lx1*ly1*lz1,lelt)

      logical ifalgn,ifnorx,ifnory,ifnorz,ifdsmv,ifregw
      character cb*3
      integer e,f

      ifield = 0
      nxyz1  = lx1*ly1*lz1
      n      = lx1*ly1*lz1*nel
      nface  = 2*ldim
      call rzero3  (rnx,rny,rnz,n)

      do 100 e=1,nel
      do 100 f=1,nface
         cb = cbc(f,e,ifield)
         if (cb.eq.'ms ' .or. cb.eq.'MS ' .or. 
     $       cb.eq.'msi' .or. cb.eq.'MSI' .or. 
     $       cb.eq.'mm ' .or. cb.eq.'MM ' .or. 
     $       cb.eq.'mv ' .OR. cb.eq.'mvn' .or.
     $       cb.eq.'MLI') then
             call facexv (unx(1,1,f,e),uny(1,1,f,e),
     $                    unz(1,1,f,e),rnx(1,e),
     $                    rny(1,e),rnz(1,e),f,1)
         endif
  100 continue

      call opdssum (rnx,rny,rnz)
      call unitvec (rnx,rny,rnz,n)

      call rzero3 (wvx,wvy,wvz,n)
      call rzero3 (wtx,wty,wtz,n)
      do 1000 isweep=1,2

        ifregw = .false.
        ifdsmv = .false.
        call rzero  (dsa,n)
        call rzero  (ta,n)

        if (ifflow) then
          ifield = 1
          call rzero  (smt,n)
          do 210 e=1,nelv
          do 210 f=1,nface
           cb = cbc(f,e,ifield)
           if (cb.eq.'mv ' .or. cb.eq.'mvn'  .or.
     $         cb.eq.'mm ' .or. cb.eq.'MM '  .or.
     $         cb.eq.'msi' .or. cb.eq.'MSI'  .or.
     $         cb.eq.'ms ' .or. cb.eq.'MS ') then
              ifregw = .true.
              call facec3 (wvx(1,e),wvy(1,e),wvz(1,e),
     $                     vx (1,1,1,e),vy (1,1,1,e),vz (1,1,1,e),f)
              if (cb.ne.'mv ')
     $           call norcmp2(wvx(1,e),wvy(1,e),wvz(1,e),e,f)
           endif
c          if (cb.eq.'msi' .or. cb.eq.'MSI') then
c             ifdsmv = .true.
c             call facsmt (smt(1,e),f)
c          endif
  210     continue

          call dsavg(wvx)
          call dsavg(wvy)
          if (if3d) call dsavg(wvz)

          if (istep.eq.0) call opcopy(wx,wy,wz,wvx,wvy,wvz)
c         if (istep.eq.4) then
c            call opcopy(wx,wy,wz,wvx,wvy,wvz)
c            call outpost(vx,vy,vz,wtx,wtx,'   ')
c            call outpost(wx,wy,wz,wtx,wtx,'   ')
c            write(6,*) 'quit1',istep
c            stop
c         endif

          iregw = 0    ! Global handshake on logicals ifregw, ifdsmv
          if (ifregw) iregw = 1       ! pff  9/11/07
          iregw = iglmax(iregw,1)
          if (iregw.eq.1) ifregw = .true.

          idsmv = 0
          if (ifdsmv) idsmv = 1
          idsmv = iglmax(idsmv,1)
          if (idsmv.eq.1) ifdsmv = .true.

          ifdsmv = .false.
          ifregw = .true.

c         if (ifdsmv) then
c           call dssum (smt,lx1,ly1,lz1)
c           do 215 e=1,nelv
c           do 215 f=1,nface
c              cb = cbc(f,e,ifield)
c              if (cb.eq.'msi' .or. cb.eq.'MSI') then
c               call facec3 (wtx(1,e),wty(1,e),wtz(1,e),
c    $                       vx(1,1,1,e),vy(1,1,1,e),vz(1,1,1,e),f)
c               call facemv (wtx(1,e),wty(1,e),wtz(1,e),
c    $                       rnx(1,e),rny(1,e),rnz(1,e),
c    $                       smt(1,e),f) 
c              endif
c 215       continue
c           call opdssum(wtx,wty,wtz)
c         endif

        endif
C
        if (ifmelt .and. istep.gt.0) then
           ifield = 2
           call rzero (smt,n)
           call cqnet (qni,ta,nel)
           do 220 e=1,nelt
           do 220 f=1,nface
              cb   = cbc(f,e,ifield)
              if (cb.eq.'MLI') call facsmt (smt(1,e),f)
              if (cb.eq.'MLI' .or. cb.eq.'MCI') then
                 call facexs (area(1,1,f,e),ta,f,1)
                 call add2   (dsa(1,e),ta,nxyz1)
              endif
  220      continue
           call dssum (smt,lx1,ly1,lz1)
           call dssum (dsa,lx1,ly1,lz1)
           do 280 e=1,nelt
           do 280 f=1,nface
              cb = cbc(f,e,ifield)
              if (cb.eq.'MLI') then
                 rhola = -0.5 * bc(5,f,e,ifield)
                 call facemt (wtx(1,e),wty(1,e),wtz(1,e),
     $                        rnx(1,e),rny(1,e),rnz(1,e),
     $                        qni(1,e),dsa(1,e),smt(1,e),
     $                        rhola,f)
              endif
  280      continue
           call opdssum (wtx,wty,wtz)
        endif

        ifield = 0
        do 330 e=1,nel
        do 330 f=1,nface
         cb = cbc(f,e,ifield)
         if (cb.eq.'SYM') then
            call chknord (ifalgn,ifnorx,ifnory,ifnorz,f,e)
            if (ifregw) then
               if (ifnorx) call facev (wvx,e,f,0.0,lx1,ly1,lz1)
               if (ifnory) call facev (wvy,e,f,0.0,lx1,ly1,lz1)
               if (ifnorz) call facev (wvz,e,f,0.0,lx1,ly1,lz1)
               if (.not.ifalgn) call faczqn (wvx(1,e),wvy(1,e),
     $                                       wvz(1,e),f,e)
            endif
            if (ifdsmv .or. ifmelt) then
               if (ifnorx) call facev (wtx,e,f,0.0,lx1,ly1,lz1)
               if (ifnory) call facev (wty,e,f,0.0,lx1,ly1,lz1)
               if (ifnorz) call facev (wtz,e,f,0.0,lx1,ly1,lz1)
               if (.not.ifalgn) call faczqn (wtx(1,e),wty(1,e),
     $                                       wtz(1,e),f,e)
            endif
         endif
  330   continue

        do 350 e=1,nel
        do 350 f=1,nface
         cb = cbc(f,e,ifield)
         if (cb.eq.'FIX') then
            if (ifregw) then
               call facev (wvx,e,f,0.0,lx1,ly1,lz1)
               call facev (wvy,e,f,0.0,lx1,ly1,lz1)
               if (ldim.eq.3) call facev (wvz,e,f,0.0,lx1,ly1,lz1)
            endif
            if (ifdsmv .or. ifmelt) then
               call facev (wtx,e,f,0.0,lx1,ly1,lz1)
               call facev (wty,e,f,0.0,lx1,ly1,lz1)
               if (ldim.eq.3) call facev (wtz,e,f,0.0,lx1,ly1,lz1)
            endif
         endif
  350   continue 

        if (isweep.eq.1) then
         if (ifregw) then
            call dsop (wvx,'MXA',lx1,ly1,lz1)
            call dsop (wvy,'MXA',lx1,ly1,lz1)
            if (ldim.eq.3) call dsop (wvz,'MXA',lx1,ly1,lz1)
         endif
         if (ifdsmv .or. ifmelt) then
            call dsop (wtx,'MXA',lx1,ly1,lz1)
            call dsop (wty,'MXA',lx1,ly1,lz1)
            if (ldim.eq.3) call dsop (wtz,'MXA',lx1,ly1,lz1)
         endif
        else
         if (ifregw) then
            call dsop (wvx,'MNA',lx1,ly1,lz1)
            call dsop (wvy,'MNA',lx1,ly1,lz1)
            if (ldim.eq.3) call dsop (wvz,'MNA',lx1,ly1,lz1)
         endif
         if (ifdsmv .or. ifmelt) then
            call dsop (wtx,'MNA',lx1,ly1,lz1)
            call dsop (wty,'MNA',lx1,ly1,lz1)
            if (ldim.eq.3) call dsop (wtz,'MNA',lx1,ly1,lz1)
         endif
        endif

 1000 continue

      call rmask (wx,wy,wz,nel)
c     if (istep.eq.2) then
c        call outpost(wx,wy,wz,wtx,wtx,'   ')
c        write(6,*) 'quit2'
c        stop
c     endif

      if (ifregw) then
         call add2  (wx,wvx,n)
         call add2  (wy,wvy,n)
         if (ldim.eq.3) call add2  (wz,wvz,n)
      endif
      if (ifdsmv .or. ifmelt) then
         call add2  (wx,wtx,n)
         call add2  (wy,wty,n)
         if (ldim.eq.3) call add2  (wz,wtz,n)
      endif
 
c     if (istep.gt.4) then
c        call outpost(wx,wy,wz,wtx,wtx,'   ')
c        write(6,*) 'quit3'
c        stop
c     endif
 
      return
      end
c-----------------------------------------------------------------------
      subroutine norcmp2(wvx,wvy,wvz,e,f)
      include 'SIZE'
      include 'GEOM'
      include 'INPUT'


      real wvx(lx1,ly1,lz1),wvy(lx1,ly1,lz1),wvz(lx1,ly1,lz1)

      integer e,f

      common /scruz/ r1(lx1,ly1,lz1),r2(lx1,ly1,lz1),r3(lx1,ly1,lz1)

      call facind(i0,i1,j0,j1,k0,k1,lx1,ly1,lz1,f)

      l=0
      do k=k0,k1
      do j=j0,j1
      do i=i0,i1
         l=l+1
         scale=wvx(i,j,k)*unx(l,1,f,e)
     $        +wvy(i,j,k)*uny(l,1,f,e)
     $        +wvz(i,j,k)*unz(l,1,f,e)
         wvx(i,j,k) = scale*unx(l,1,f,e)
         wvy(i,j,k) = scale*uny(l,1,f,e)
         wvz(i,j,k) = scale*unz(l,1,f,e)
      enddo
      enddo
      enddo

c     wvxm = vlamax(wvx,lx1*ly1)
c     write(6,*) f,e,wvxm,' w-max'

      return
      end
c-----------------------------------------------------------------------
      subroutine norcmp (wt1,wt2,wt3,rnx,rny,rnz,ifc)
C
      include 'SIZE'
      COMMON /SCRUZ/ R1(LX1,LY1,LZ1),R2(LX1,LY1,LZ1),R3(LX1,LY1,LZ1)
C
      DIMENSION WT1(LX1,LY1,LZ1),WT2(LX1,LY1,LZ1),WT3(LX1,LY1,LZ1)
     $        , RNX(LX1,LY1,LZ1),RNY(LX1,LY1,LZ1),RNZ(LX1,LY1,LZ1)
C
      NXYZ1 = lx1*ly1*lz1
C
      CALL COPY (R1,WT1,NXYZ1)
      CALL COPY (R2,WT2,NXYZ1)
      IF (ldim.EQ.3) CALL COPY (R3,WT3,NXYZ1)
      CALL FACIND2 (JS1,JF1,JSKIP1,JS2,JF2,JSKIP2,IFC)
C
      IF (ldim.EQ.2) THEN
         DO 200 J2=JS2,JF2,JSKIP2
         DO 200 J1=JS1,JF1,JSKIP1
            WN          = R1(J1,J2,1)*RNX(J1,J2,1) + 
     $                    R2(J1,J2,1)*RNY(J1,J2,1)
            WT1(J1,J2,1) = WN *RNX(J1,J2,1)
            WT2(J1,J2,1) = WN *RNY(J1,J2,1)
  200    CONTINUE
      ELSE
         DO 300 J2=JS2,JF2,JSKIP2
         DO 300 J1=JS1,JF1,JSKIP1
            WN          = R1(J1,J2,1)*RNX(J1,J2,1) + 
     $                    R2(J1,J2,1)*RNY(J1,J2,1) +
     $                    R3(J1,J2,1)*RNZ(J1,J2,1)
            WT1(J1,J2,1) = WN *RNX(J1,J2,1)
            WT2(J1,J2,1) = WN *RNY(J1,J2,1)
            WT3(J1,J2,1) = WN *RNZ(J1,J2,1)
  300    CONTINUE
      ENDIF
C
      return
      end
c-----------------------------------------------------------------------
      subroutine facemv (wt1,wt2,wt3,rnx,rny,rnz,smt,ifc)
C
      include 'SIZE'
      COMMON /SCRUZ/ R1(LX1,LY1,LZ1),R2(LX1,LY1,LZ1),R3(LX1,LY1,LZ1)
C
      DIMENSION WT1(LX1,LY1,LZ1),WT2(LX1,LY1,LZ1),WT3(LX1,LY1,LZ1)
     $        , RNX(LX1,LY1,LZ1),RNY(LX1,LY1,LZ1),RNZ(LX1,LY1,LZ1)
     $        , SMT(LX1,LY1,LZ1)
C
      NXYZ1 = lx1*ly1*lz1
C
      CALL COPY (R1,WT1,NXYZ1)
      CALL COPY (R2,WT2,NXYZ1)
      IF (ldim.EQ.3) CALL COPY (R3,WT3,NXYZ1)
      CALL FACIND2 (JS1,JF1,JSKIP1,JS2,JF2,JSKIP2,IFC)
C
      IF (ldim.EQ.2) THEN
         DO 200 J2=JS2,JF2,JSKIP2
         DO 200 J1=JS1,JF1,JSKIP1
            WN          = ( R1(J1,J2,1)*RNX(J1,J2,1) + 
     $                      R2(J1,J2,1)*RNY(J1,J2,1) ) / SMT(J1,J2,1)
            WT1(J1,J2,1) = WN *RNX(J1,J2,1)
            WT2(J1,J2,1) = WN *RNY(J1,J2,1)
  200    CONTINUE
      ELSE
         DO 300 J2=JS2,JF2,JSKIP2
         DO 300 J1=JS1,JF1,JSKIP1
            WN          = ( R1(J1,J2,1)*RNX(J1,J2,1) + 
     $                      R2(J1,J2,1)*RNY(J1,J2,1) +
     $                      R3(J1,J2,1)*RNZ(J1,J2,1) ) / SMT(J1,J2,1)
            WT1(J1,J2,1) = WN *RNX(J1,J2,1)
            WT2(J1,J2,1) = WN *RNY(J1,J2,1)
            WT3(J1,J2,1) = WN *RNZ(J1,J2,1)
  300    CONTINUE
      ENDIF
C
      return
      end
c-----------------------------------------------------------------------
      subroutine faczqn (wt1,wt2,wt3,ifc,iel)
C
      include 'SIZE'
      include 'GEOM'
      include 'TOPOL'
      COMMON /SCRUZ/ R1(LX1,LY1,LZ1),R2(LX1,LY1,LZ1),R3(LX1,LY1,LZ1)
C
      DIMENSION WT1(LX1,LY1,LZ1),WT2(LX1,LY1,LZ1),WT3(LX1,LY1,LZ1)
C
      NXYZ1 = lx1*ly1*lz1
      CALL COPY (R1,WT1,NXYZ1)
      CALL COPY (R2,WT2,NXYZ1)
      IF (ldim.EQ.3) CALL COPY (R3,WT3,NXYZ1)
C
      CALL FACIND2 (JS1,JF1,JSKIP1,JS2,JF2,JSKIP2,IFC)
      I = 0
C
      IF (ldim.EQ.2) THEN
      DO 200 J2=JS2,JF2,JSKIP2
      DO 200 J1=JS1,JF1,JSKIP1
         I = I+1
         W1           = R1(J1,J2,1)*T1X(I,1,IFC,IEL) + 
     $                  R2(J1,J2,1)*T1Y(I,1,IFC,IEL)
         WT1(J1,J2,1) = W1 *T1X(I,1,IFC,IEL)
         WT2(J1,J2,1) = W1 *T1Y(I,1,IFC,IEL)
  200 CONTINUE
      ELSE
      DO 300 J2=JS2,JF2,JSKIP2
      DO 300 J1=JS1,JF1,JSKIP1
         I = I+1
         W1           = R1(J1,J2,1)*T1X(I,1,IFC,IEL) + 
     $                  R2(J1,J2,1)*T1Y(I,1,IFC,IEL) +
     $                  R3(J1,J2,1)*T1Z(I,1,IFC,IEL)
         WT1(J1,J2,1) = W1 *T1X(I,1,IFC,IEL)
         WT2(J1,J2,1) = W1 *T1Y(I,1,IFC,IEL)
         WT3(J1,J2,1) = W1 *T1Z(I,1,IFC,IEL)
  300 CONTINUE
      ENDIF
C
      return
      end
c-----------------------------------------------------------------------
      subroutine facsmt (smt,ifc)
C
      include 'SIZE'
      DIMENSION SMT(LX1,LY1,LZ1)
C
      CALL FACIND2 (JS1,JF1,JSKIP1,JS2,JF2,JSKIP2,IFC)
C
      DO 100 J2=JS2,JF2,JSKIP2
      DO 100 J1=JS1,JF1,JSKIP1
         SMT(J1,J2,1)=SMT(J1,J2,1) + 1.0
  100 CONTINUE
C
      return
      end
c-----------------------------------------------------------------------
      subroutine cqnet (qni,ta,nel)
C
      include 'SIZE'
      include 'INPUT'
      include 'SOLN'
      include 'TSTEP'
      COMMON /SCRVH/ H1(LX1,LY1,LZ1,LELT)
     $             , H2(LX1,LY1,LZ1,LELT)
C
      DIMENSION QNI(LX1,LY1,LZ1,1)
     $        , TA (LX1,LY1,LZ1,1)
C
      INTLOC = -1
      IMSHL  =  2
      NTOT1  = lx1*ly1*lz1*NEL
C
      CALL SETHLM (H1,H2,INTLOC)
      CALL AXHELM (TA,T(1,1,1,1,IFIELD-1),H1,H2,IMSHL,1)
      CALL SUB3   (QNI,TA,BQ(1,1,1,1,IFIELD-1),NTOT1)
      CALL DSSUM  (QNI,lx1,ly1,lz1)
C
      return
      end
c-----------------------------------------------------------------------
      subroutine facemt (w1,w2,w3,rnx,rny,rnz,qni,dsa,smt,rhola,ifc)
C
      include 'SIZE'
      include 'GEOM'
C
      DIMENSION  W1 (LX1,LY1,LZ1)
     $        ,  W2 (LX1,LY1,LZ1)
     $        ,  W3 (LX1,LY1,LZ1)
     $        ,  RNX(LX1,LY1,LZ1)
     $        ,  RNY(LX1,LY1,LZ1)
     $        ,  RNZ(LX1,LY1,LZ1)
     $        ,  QNI(LX1,LY1,LZ1)
     $        ,  DSA(LX1,LY1,LZ1)
     $        ,  SMT(LX1,LY1,LZ1)
C
      CALL FACIND2 (JS1,JF1,JSKIP1,JS2,JF2,JSKIP2,IFC)
C
      IF (ldim.EQ.2) THEN
      DO 200 J2=JS2,JF2,JSKIP2
      DO 200 J1=JS1,JF1,JSKIP1
         AA = QNI(J1,J2,1) / ( DSA(J1,J2,1)*SMT(J1,J2,1)*RHOLA )
         W1(J1,J2,1) = RNX(J1,J2,1) * AA
         W2(J1,J2,1) = RNY(J1,J2,1) * AA
  200 CONTINUE
      ELSE
      DO 300 J2=JS2,JF2,JSKIP2
      DO 300 J1=JS1,JF1,JSKIP1
         AA = QNI(J1,J2,1) / ( DSA(J1,J2,1)*SMT(J1,J2,1)*RHOLA )
         W1(J1,J2,1) = RNX(J1,J2,1) * AA
         W2(J1,J2,1) = RNY(J1,J2,1) * AA
         W3(J1,J2,1) = RNZ(J1,J2,1) * AA
  300 CONTINUE
      ENDIF
C
      return
      end
c-----------------------------------------------------------------------
      subroutine elasolv (nel)
C
C     Elastostatic solver for mesh deformation
C
      include 'SIZE'
      include 'GEOM'
      include 'INPUT'
      include 'MVGEOM'
      include 'SOLN'
      include 'TSTEP'
C
      COMMON /SCRNS/ DW1  (LX1,LY1,LZ1,LELT)
     $             , DW2  (LX1,LY1,LZ1,LELT)
     $             , DW3  (LX1,LY1,LZ1,LELT)
     $             , AW1  (LX1,LY1,LZ1,LELT)
     $             , AW2  (LX1,LY1,LZ1,LELT)
     $             , AW3  (LX1,LY1,LZ1,LELT)
      COMMON /SCRVH/ H1   (LX1,LY1,LZ1,LELT)
     $             , H2   (LX1,LY1,LZ1,LELT)
      common /scruz/ prt  (lx1,ly1,lz1,lelt)
      COMMON /FASTMD/ IFDFRM(LELT), IFFAST(LELT), IFH2, IFSOLV
      LOGICAL IFDFRM, IFFAST, IFH2, IFSOLV

      if (ifusermv) return  ! Compute wx,wy,wz in userchk.
c
      NTOT1  = lx1*ly1*lz1*NEL
      MAXIT  = 1000
      MATMOD = -1
      IFH2   = .FALSE.
      IFSOLV = .TRUE.
      IMSOLV = 0
      VNU    = 0.0
      VNU    = param(47)
      if (vnu.eq.0) VNU    = 0.4
      vnu    = max(0.00,vnu)
      vnu    = min(0.499,vnu)

C     Set up elastic material constants

      CE = 1./(1. + VNU)
      C2 = VNU * CE / (1. - 2.*VNU)
      C3 = 0.5 * CE
      CALL CFILL (H1,C2,NTOT1)
      CALL CFILL (H2,C3,NTOT1)

C     Solve for interior mesh velocities

      CALL MESHTOL (AW1,TOLMSH,NEL,IMSOLV)
      IF (IMSOLV.EQ.1) return

      CALL AXHMSF  (AW1,AW2,AW3,WX,WY,WZ,H1,H2,MATMOD)

c     if (istep.eq.2) then
c        call outpost(wx,wy,wz,h1,h2,'   ')
c        call outpost(aw1,aw2,aw3,h1,h2,'   ')
c        write(6,*) 'quit elas 1'
c        stop
c     endif

      CALL CHSIGN  (AW1,NTOT1)
      CALL CHSIGN  (AW2,NTOT1)
      IF (ldim.EQ.3) CALL CHSIGN (AW3,NTOT1)
      CALL HMHZSF  ('NOMG',DW1,DW2,DW3,AW1,AW2,AW3,H1,H2,
     $               W1MASK,W2MASK,W3MASK,WMULT,TOLMSH,
     $               MAXIT,MATMOD)
C
C     Update mesh velocities
C
      CALL ADD2 (WX,DW1,NTOT1)
      CALL ADD2 (WY,DW2,NTOT1)
      IF (ldim.EQ.3) CALL ADD2 (WZ,DW3,NTOT1)

      ifldt = ifield
      ifield=1
      if (ifheat) ifield=2
      call dsavg(wx)
      call dsavg(wy)
      call dsavg(wz)
      ifield = ifldt

c     if (istep.gt.1) then
c        ifldx = ifield
c        ifield = 1
c        call incomprn (wx,wy,wz,prt) ! project U onto div-free space
c        ifield = ifldx
c        return
c     endif

      return
      end
c-----------------------------------------------------------------------
      subroutine meshtol (ta,tolmsh,nel,imsolv)
C
      include 'SIZE'
      include 'EIGEN'
      include 'MVGEOM'
      include 'TSTEP'
      DIMENSION TA(LX1,LY1,LZ1,1)
C
      NTOT1 = lx1*ly1*lz1*NEL
      TOLAB = TOLREL
C
      DELTA  = 1.0E-9
      X      = 1.0 + DELTA
      Y      = 1.0
      DIFF   = ABS(X - Y)
      IF (DIFF .EQ. 0.0) EPS = 1.0E-05
      IF (DIFF .GT. 0.0) EPS = 1.0E-12
C
      CALL OPDOT  (TA,WX,WY,WZ,WX,WY,WZ,NTOT1)
C
      WDOT = GLMAX(TA,NTOT1)
      WMAX = SQRT(WDOT)
      IF (WMAX .LT. EPS) THEN
          IMSOLV = 1
          return
      ENDIF
C
      TOLMSH = TOLAB * WMAX * SQRT(EIGAA)
C
      return
      end
c-----------------------------------------------------------------------
      subroutine updxyz (nel)
C
      include 'SIZE'
      include 'TSTEP'
      include 'MVGEOM'
      include 'GEOM'
      include 'INPUT'
      COMMON /SCRSF/ UX(LX1,LY1,LZ1,LELT)
     $             , UY(LX1,LY1,LZ1,LELT)
     $             , UZ(LX1,LY1,LZ1,LELT)
      DIMENSION ABM(3)
C
      NTOT1 = lx1*ly1*lz1*NEL
C
      DO 10 I=1,NBD
   10 ABM(I) = DT*ABMSH(I)
C
      IF (ISTEP.EQ.0) THEN
         CALL COPY (UX,WX,NTOT1)
         CALL COPY (UY,WY,NTOT1)
         IF (ldim.EQ.3) CALL COPY (UZ,WZ,NTOT1)
      else
         if (ifrich) then
            call cmult2(ux,wx,dt,ntot1)
            call cmult2(uy,wy,dt,ntot1)
            if (ldim.eq.3) call cmult2(uz,wz,dt,ntot1)
         else
            CALL CMULT2 (UX,WX,ABM(1),NTOT1)
            CALL CMULT2 (UY,WY,ABM(1),NTOT1)
            IF (ldim.EQ.3) CALL CMULT2 (UZ,WZ,ABM(1),NTOT1)
            DO 100 ILAG=2,NBD
               CALL ADD2S2 (UX,WXLAG(1,1,1,1,ILAG-1),ABM(ILAG),NTOT1)
               CALL ADD2S2 (UY,WYLAG(1,1,1,1,ILAG-1),ABM(ILAG),NTOT1)
               IF (ldim.EQ.3)
     $         CALL ADD2S2 (UZ,WZLAG(1,1,1,1,ILAG-1),ABM(ILAG),NTOT1)
  100       CONTINUE
         endif
      ENDIF
C
      CALL ADD2 (XM1,UX,NTOT1)
      CALL ADD2 (YM1,UY,NTOT1)
      IF (ldim.EQ.3) CALL ADD2 (ZM1,UZ,NTOT1)
C
      return
      end
c-----------------------------------------------------------------------
      subroutine lagmshv (nel)
C-----------------------------------------------------------------------
C
C     Keep old mesh velocity
C
C-----------------------------------------------------------------------
      include 'SIZE'
      include 'INPUT'
      include 'MVGEOM'
      include 'TSTEP'
C
      NTOT1 = lx1*ly1*lz1*NEL
C
      DO 100 ILAG=NBDINP-1,2,-1
         CALL COPY (WXLAG(1,1,1,1,ILAG),WXLAG(1,1,1,1,ILAG-1),NTOT1)
         CALL COPY (WYLAG(1,1,1,1,ILAG),WYLAG(1,1,1,1,ILAG-1),NTOT1)
         IF (ldim.EQ.3)
     $   CALL COPY (WZLAG(1,1,1,1,ILAG),WZLAG(1,1,1,1,ILAG-1),NTOT1)
 100  CONTINUE
C
         CALL COPY (WXLAG(1,1,1,1,1),WX,NTOT1)
         CALL COPY (WYLAG(1,1,1,1,1),WY,NTOT1)
         IF (ldim.EQ.3)
     $   CALL COPY (WZLAG(1,1,1,1,1),WZ,NTOT1)
C
      return
      end
c-----------------------------------------------------------------------
      subroutine facec3 (a1,a2,a3,b1,b2,b3,ifc)
C
C     Copy the face (IFC) of B1,B2,B3 to A1,A2,A3.
C     IFACE is the input in the pre-processor ordering scheme.
C
      include 'SIZE'
      DIMENSION A1(LX1,LY1,LZ1)
     $        , A2(LX1,LY1,LZ1)
     $        , A3(LX1,LY1,LZ1)
     $        , B1(LX1,LY1,LZ1)
     $        , B2(LX1,LY1,LZ1)
     $        , B3(LX1,LY1,LZ1)
C
      CALL FACIND2 (JS1,JF1,JSKIP1,JS2,JF2,JSKIP2,IFC)
C
      DO 100 J2=JS2,JF2,JSKIP2
      DO 100 J1=JS1,JF1,JSKIP1
         A1(J1,J2,1)=B1(J1,J2,1)
         A2(J1,J2,1)=B2(J1,J2,1)
         A3(J1,J2,1)=B3(J1,J2,1)
  100 CONTINUE
      return
      end
c-----------------------------------------------------------------------
      subroutine ptbgeom
C-----------------------------------------------------------------------
C
C     Subroutine to impose perturbation to geometry before solution
C     for moving boundary problems
C
C-----------------------------------------------------------------------
      include 'SIZE'
      include 'GEOM'
      include 'MVGEOM'
      include 'SOLN'
      include 'TSTEP'
      include 'INPUT'
      COMMON /SCRUZ/ XM3 (LX3,LY3,LZ3,LELT)
     $ ,             YM3 (LX3,LY3,LZ3,LELT)
     $ ,             ZM3 (LX3,LY3,LZ3,LELT)
C
      IF (ISTEP .EQ. 0) return
      IFIELD = 0
      NEL    = NELFLD(IFIELD)
      NTOT1  = lx1*ly1*lz1*NEL
      IMESH  = 1
      IF ( IFTMSH(IFIELD) ) IMESH = 2
C
      CALL IBDGEOM (NEL)
      CALL ELASOLV (NEL)
      CALL UPDXYZ  (NEL)
      CALL GEOM1 (XM3,YM3,ZM3)
      CALL GEOM2
      CALL UPDMSYS (0)
      CALL VOLUME
      CALL SETINVM
      CALL LAGMASS
C
      CALL RZERO (WX,NTOT1)
      CALL RZERO (WY,NTOT1)
      IF (ldim.EQ.3) CALL RZERO (WZ,NTOT1)
C
      return
      end
c-----------------------------------------------------------------------
      subroutine ibdgeom (nel)
C
C     Routine to evaluate mesh velocities at all moving boundaries
C
      include 'SIZE'
      include 'GEOM'
      include 'INPUT'
      include 'PARALLEL'
      include 'MVGEOM'
      include 'TSTEP'
C
      CHARACTER CB*1
C
      NFACE  = 2*ldim
      NTOT1  = lx1*ly1*lz1*NEL
C
      CALL RZERO (WX,NTOT1)
      CALL RZERO (WY,NTOT1)
      CALL RZERO (WZ,NTOT1)
C
      DO 1000 ISWEEP=1,2
C
      IFLD = 0
      DO 110 IEL=1,NEL
      DO 110 IFC=1,NFACE
         ieg = lglel(iel)
         CB  = CBC(IFC,IEL,IFLD)
      IF (CB.EQ.'M' .OR. CB.EQ.'m') THEN
         CALL FACIND (KX1,KX2,KY1,KY2,KZ1,KZ2,lx1,ly1,lz1,IFC)
         DO 140 IZ=KZ1,KZ2
         DO 140 IY=KY1,KY2
         DO 140 IX=KX1,KX2
         CALL INIGEOM (WX(IX,IY,IZ,IEL),WY(IX,IY,IZ,IEL),
     $                 WZ(IX,IY,IZ,IEL),XM1(IX,IY,IZ,IEL),
     $                 YM1(IX,IY,IZ,IEL),ZM1(IX,IY,IZ,IEL),
     $                 IFC,IEG)
  140    CONTINUE
      ENDIF
  110 CONTINUE
C
      IF (ISWEEP.EQ.1) THEN
         CALL DSOP (WX,'MXA',lx1,ly1,lz1)
         CALL DSOP (WY,'MXA',lx1,ly1,lz1)
         IF (ldim.EQ.3) CALL DSOP (WZ,'MXA',lx1,ly1,lz1)
      ELSE
         CALL DSOP (WX,'MNA',lx1,ly1,lz1)
         CALL DSOP (WY,'MNA',lx1,ly1,lz1)
         IF (ldim.EQ.3) CALL DSOP (WZ,'MNA',lx1,ly1,lz1)
      ENDIF
C
 1000 CONTINUE
C
      return
      end
c-----------------------------------------------------------------------
      subroutine inigeom (ux,uy,uz,x,y,z,iside,iel)
C
      include 'SIZE'
      include 'TSTEP'
C
      UX  =  0.0
      UY  =  0.0
      UZ  =  0.0
C
      return
      end
c-----------------------------------------------------------------------
      subroutine quickmv
      include 'SIZE'
      include 'TOTAL'
      include 'ZPER'
c
      if (if3d) then
         call quickmv3d
      else
         call quickmv2d
      endif
      return
      end
c-----------------------------------------------------------------------
      subroutine quickmv2d
      include 'SIZE'
      include 'TOTAL'
      include 'ZPER'
c
      integer e,ex,ey,ez,eg
      common /surfa/ zsurf(lx1,lz1,lelx,lely)
     $             , wsurf(lx1,lz1,lelx,lely)
      real nxs,nys,nzs
c
      icount = 0
      do ex=1,nelx
      do ix=1,lx1
         zsurf(ix,1,ex,1) = -1.e20
         wsurf(ix,1,ex,1) = -1.e20
         ey=nely
         eg  = ex + nelx*(ey-1) 
         mid = gllnid(eg)
         e   = gllel (eg)
         if (mid.eq.nid) then
            zsurf(ix,1,ex,1) = ym1(ix,ly1,1,e)
            vxs              = vx (ix,ly1,1,e)
            vys              = vy (ix,ly1,1,e)
            nxs              = unx(ix,1,3,e)          ! Face 3 is on top in 2D
            nys              = uny(ix,1,3,e)
            gamma_s          = (vxs*nxs + vys*nys)/(nys) 
            wsurf(ix,1,ex,1) = gamma_s           ! vertical component of wsurf
         endif
         zsurf(ix,1,ex,1) = glmax(zsurf(ix,1,ex,1),1)
         wsurf(ix,1,ex,1) = glmax(wsurf(ix,1,ex,1),1)
         icount = icount+1

c        write(6,6) ex,e,ix,xm1(ix,ly1,1,e),ym1(ix,ly1,1,e)
c    $   ,vxs,vys,nxs,nys,gamma_s,wsurf(ix,1,ex,1),zsurf(ix,1,ex,1)
c   6        format(3i3,1p9e12.4,' srf')

      enddo
      enddo
      zmin = glmin(ym1,lx1*ly1*lz1*nelv)
c
      do ex=1,nelx
      do ix=1,lx1
         do ey=1,nely
            eg  = ex + nelx*(ey-1) 
            mid = gllnid(eg)
            e   = gllel (eg)
            if (mid.eq.nid) then
               do iy=1,ly1
                  wy (ix,iy,1,e) = wsurf(ix,1,ex,1)
     $               * (ym1(ix,iy,1,e)-zmin)/(zsurf(ix,1,ex,1)-zmin)
               enddo
            endif
         enddo
      enddo
      enddo
c
      n = lx1*ly1*lz1*nelv
      call rzero(wx,n)
      call dsavg(wy)

c     call opcopy(vx,vy,vz,wx,wy,wz)
c     call outpost(vx,vy,vz,pr,t,'   ')
c     call exitt

      return
      end
c-----------------------------------------------------------------------
      subroutine quickmv3d
      include 'SIZE'
      include 'TOTAL'
      include 'ZPER'
c
      integer e,ex,ey,ez,eg
      common /surfa/ zsurf(lx1,lz1,lelx,lely)
     $             , wsurf(lx1,lz1,lelx,lely)
      real nxs,nys,nzs
c
      icount = 0
      do ey=1,nely
      do ex=1,nelx
      do iy=1,ly1
      do ix=1,lx1
         zsurf(ix,iy,ex,ey) = -1.e20
         wsurf(ix,iy,ex,ey) = -1.e20
         ez  = nelz
         eg  = ex + nelx*(ey-1) + nelx*nely*(ez-1)
         mid = gllnid(eg)
         e   = gllel (eg)
         if (mid.eq.nid) then
            zsurf(ix,iy,ex,ey) = zm1(ix,iy,lz1,e)
            vxs                = vx (ix,iy,lz1,e)
            vys                = vy (ix,iy,lz1,e)
            vzs                = vz (ix,iy,lz1,e)
            nxs                = unx(ix,iy,6,e)     ! Face 6 is on top in 3D
            nys                = uny(ix,iy,6,e)
            nzs                = unz(ix,iy,6,e) 
            gamma_s            = (vxs*nxs+vys*nys+vzs*nzs)/(nzs)
            wsurf(ix,iy,ex,ey) = gamma_s  ! vertical component of wsurf
         endif
         zsurf(ix,iy,ex,ey) = glmax(zsurf(ix,iy,ex,ey),1)
         wsurf(ix,iy,ex,ey) = glmax(wsurf(ix,iy,ex,ey),1)
         icount = icount+1
      enddo
      enddo
      enddo
      enddo

      n = lx1*ly1*lz1*nelv
      zmin = glmin(zm1,n)
c
      do ey=1,nely
      do ex=1,nelx
      do iy=1,ly1
      do ix=1,lx1
         do ez=1,nelz
            eg  = ex + nelx*(ey-1) + nelx*nely*(ez-1)
            mid = gllnid(eg)
            e   = gllel (eg)
            if (mid.eq.nid) then
               do iz=1,lz1
                  wz (ix,iy,iz,e) = wsurf(ix,iy,ex,ey)
     $               * (zm1(ix,iy,iz,e)-zmin)/(zsurf(ix,iy,ex,ey)-zmin)
               enddo
            endif
         enddo
      enddo
      enddo
      enddo
      enddo
c
      n = lx1*ly1*lz1*nelv
      call rzero(wx,n)
      call rzero(wy,n)
      call dsavg(wz)
c
      return
      end
c-----------------------------------------------------------------------

      subroutine mxm(a,n1,b,n2,c,n3)
      real a(n1,n2),b(n2,n3),c(n1,n3)
      do j=1,n3
         do i=1,n1
           c(i,j) = 0.0
           do k = 1,n2
            c(i,j) = c(i,j) + a(i,k)*b(k,j)
           end do
         enddo
      enddo
      return
      end

program array_section
  integer :: A(-1:1,-2:2)
  integer :: i, j, m, n
  
  n = 2
  do j=-2,2,2
    do i=-1,1
   	  A(i,j) = i*j+i+1
    end do
  end do
  call subr(n, A(0:0, -2:2:4))
  m = A(0,-2) + A(0,2)
!$CVL $assert(m .EQ. 0);
end program array_section

subroutine subr(N, B) 
  integer :: N, i
  integer, dimension(N) :: B
  
  do i=1,N
    B(i) = 0
  end do 
end subroutine subr

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!*****************************************************************************
!
!  adi.F90: This file is part of the PolyBench/Fortran 1.0 test suite.
!
!  Contact: Louis-Noel Pouchet <pouchet@cse.ohio-state.edu>
!  Web address: http://polybench.sourceforge.net
!
!*****************************************************************************

!!No data race pairs.

! Include polybench common header.
#include "polybench/fpolybench.h"

! Include benchmark-specific header.
! Default data type is double, default size is 10x1024x1024.
#include "polybench/adi.h"

      program adi
      use omp_lib
      implicit none

      POLYBENCH_2D_ARRAY_DECL(x,DATA_TYPE,500, 500)
      POLYBENCH_2D_ARRAY_DECL(a,DATA_TYPE,500, 500)
      POLYBENCH_2D_ARRAY_DECL(b,DATA_TYPE,500, 500)
      polybench_declare_prevent_dce_vars
      polybench_declare_instruments

!     Allocation of Arrays
      POLYBENCH_ALLOC_2D_ARRAY(x, 500, 500)
      POLYBENCH_ALLOC_2D_ARRAY(a, 500, 500)
      POLYBENCH_ALLOC_2D_ARRAY(b, 500, 500)

!     Initialization
      call init_array(500, x, a, b)

!     Kernel Execution
      polybench_start_instruments

      call kernel_adi(10, 500, x, a, b)

      polybench_stop_instruments
      polybench_print_instruments

!     Prevent dead-code elimination. All live-out data must be printed
!     by the function call in argument.
      polybench_prevent_dce(print_array(500, x));

!     Deallocation of Arrays
      POLYBENCH_DEALLOC_ARRAY(x)
      POLYBENCH_DEALLOC_ARRAY(a)
      POLYBENCH_DEALLOC_ARRAY(b)

      contains
!       Array initialization.
        subroutine init_array(n, x, a, b)
        implicit none

        DATA_TYPE, dimension(n, n) :: a
        DATA_TYPE, dimension(n, n) :: x
        DATA_TYPE, dimension(n, n) :: b
        integer :: n
        integer :: c1, c2, c3, c4

        if (n >= 1) then
            !$omp parallel do private(c2,c3,c4)
            do c1 = 1, merge(merge(-((-(n-1) + 17) / 16),-((-(n-1) + 15) / 16),16<0),(n-1) / 16,(n-1) * 16 < 0)
                do c2 = 1, merge(merge(-((-(n-1) + 17) / 16),-((-(n-1) + 15) / 16),16<0),(n-1) / 16,(n-1) * 16 < 0)
                    do c3 = 16*c1, merge(16*c1+15,n-1,(16*c1+15)<(n-1))
                        !$omp simd
                        do c4 = 16*c2, merge(16*c2+15,n-1,(16*c2+15)<(n-1))
                            x(c3,c4)=(DBLE(c3)*DBLE(c4+1)+1.0D0)/DBLE(n)
                            a(c3,c4)=(DBLE(c3)*DBLE(c4+2)+2.0D0)/DBLE(n)
                            b(c3,c4)=(DBLE(c3)*DBLE(c4+3)+3.0D0)/DBLE(n)
                        end do
                    end do
                end do
            end do
            !$omp end parallel do
        end if
        end subroutine

!       DCE code. Must scan the entire live-out data.
!       Can be used also to check the correctness of the output.

        subroutine print_array(n, x)
        implicit none

        DATA_TYPE, dimension(n, n) :: x
        integer :: n
        integer :: i, j

        do i = 1, n
          do j = 1, n
            write(0, DATA_PRINTF_MODIFIER) x(i, j)
            if (mod((i * 500 + j), 20) == 0) then
              write(0, *)
            end if
          end do
        end do
        write(0, *)
        end subroutine

!        Main computational kernel. The whole function will be timed,
!        including the call and return.
        subroutine kernel_adi(tsteps, n, x, a, b)
        implicit none

        DATA_TYPE, dimension(n, n) :: a
        DATA_TYPE, dimension(n, n) :: x
        DATA_TYPE, dimension(n, n) :: b
        integer :: n, tsteps
        !integer :: i1, i2, t
        integer :: c0,c2,c8, c9, c15

        if (n >= 1 .and. tsteps >= 1) then
            do c0 = 1, tsteps
                if (n>=2) then
                    !$omp parallel do private(c15,c9,c8)
                    do c2 = 1, merge(merge(-((-(n-1) + 17) / 16),-((-(n-1) + 15) / 16),16<0),(n-1) / 16,(n-1) * 16 < 0)
                        do c8 = 1, merge(merge(-((-(n-1) + 17) / 16),-((-(n-1) + 15) / 16),16<0),(n-1) / 16,(n-1) * 16 < 0)
                            do c9 = merge(2,16*c8,1>16*c8), merge(16*c8+15,n-1,(16*c8+15)<(n-1))
                                !$omp simd
                                do c15 = 16*c2, merge(16*c2+15,n-1,16*c2+15<n-1)
                                    B(c15,c9) = B(c15,c9) - A(c15,c9) * A(c15,c9) / B(c15,c9 - 1)
                                end do
                            end do
                        end do

                        do c8 = 1, merge(merge(-((-(n-1) + 17) / 16),-((-(n-1) + 15) / 16),16<0),(n-1) / 16,(n-1) * 16 < 0)
                            do c9 = merge(2,16*c8,2>16*c8), merge(16*c8+15,n-1,(16*c8+15)<(n-1))
                                !$omp simd
                                do c15 = 16*c2, merge(16*c2+15,n-1,16*c2+15<n-1)
                                    x(c15,c9) = x(c15,c9) - x(c15,c9) * A(c15,c9) / B(c15,c9 - 1)
                                end do
                            end do
                        end do

                        do c8 = 1, merge(merge(-((-(n-3) + 17) / 16),-((-(n-3) + 15) / 16),16<0),(n-3) / 16,(n-3) * 16 < 0)
                            do c9 = 16*c8, merge(16*c8+15,n-3,16*c8+15<n-3)
                                !$omp simd
                                do c15=16*c2, merge(16*c2+15,n-1,16*c2+15 < n-1)
                                    X(c15,n - c9 - 2) = (X(c15,n - 2 - c9) - X(c15,n - 2 - c9 - 1) * A(c15,n - c9 - 3)) / B(c15,n - 3 - c9)
                                end do
                            end do
                        end do
                    end do
                end if

                !$omp parallel do private(c15)
                do c2 = 1, merge(merge(-((-(n-1) + 17) / 16),-((-(n-1) + 15) / 16),16<0),(n-1) / 16,(n-1) * 16 < 0)
                    !$omp simd
                    do c15=16*c2, merge(16*c2+15,n-1,16*c2+15<n-1)
                        x(c15,n-1) = x(c15,n-1)/b(c15,n-1)
                    end do
                end do
                !$omp end parallel do

                if (n >= 2) then
                    !$omp parallel do private(c15, c9, c8)
                    do c2 = 1, merge(merge(-((-(n-1) + 17) / 16),-((-(n-1) + 15) / 16),16<0),(n-1) / 16,(n-1) * 16 < 0)
                        do c8 = 1, merge(merge(-((-(n-1) + 17) / 16),-((-(n-1) + 15) / 16),16<0),(n-1) / 16,(n-1) * 16 < 0)
                            do c9 = merge(2,16*c8,2>16*c8), merge(16*c8+15,n-1,16*c8+15<n-1)
                                !$omp simd
                                do c15 = 16*c2, merge(16*c2+15,n-1,16*c2+15<n-1)
                                    B(c9,c15) = B(c9,c15) - A(c9,c15) * A(c9,c15) / B(c9 - 1,c15)
                                end do
                            end do
                        end do

                        do c8 = 1, merge(merge(-((-(n-1) + 17) / 16),-((-(n-1) + 15) / 16),16<0),(n-1) / 16,(n-1) * 16 < 0)
                            do c9 = merge(2,16*c8,2>16*c8), merge(16*c8+15,n-1,16*c8+15<n-1)
                                !$omp simd
                                do c15 = 16*c2, merge(16*c2+15,n-1,16*c2+15<n-1)
                                    X(c9,c15) = X(c9,c15) - X(c9 - 1,c15) * A(c9,c15) / B(c9 - 1,c15)
                                end do
                            end do
                        end do

                        do c8 = 1, merge(merge(-((-(n-3) + 17) / 16),-((-(n-3) + 15) / 16),16<0),(n-3) / 16,(n-3) * 16 < 0)
                            do c9 = 16*c8, merge(16*c8+15,n-3,16*c8+15<n-3)
                                !$omp simd
                                do c15=16*c2, merge(16*c2+15,n-1,16*c2+15 < n-1)
                                    X(n - 2 - c9,c15) = (X(n - 2 - c9,c15) - X(n - c9 - 3,c15) * A(n - 3 - c9,c15)) / B(n - 2 - c9,c15)
                                end do
                            end do
                        end do

                    end do
                    !$omp end parallel do
                end if

                !$omp parallel do private(c15)
                do c2 = 1, merge(merge(-((-(n-1) + 17) / 16),-((-(n-1) + 15) / 16),16<0),(n-1) / 16,(n-1) * 16 < 0)
                    !$omp simd
                    do c15 = 16*c2, merge(16*c2+15,n-1,16*c2+15<n-1)
                        X(n - 1,c15) = X(n - 1,c15) / B(n - 1,c15)
                    end do
                end do
                !$omp end parallel do
            end do
        end if


        end subroutine

      end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!The thread encountering the taskwait directive at line 22 only waits for its child task
!(line 14-21) to complete. It does not wait for its descendant tasks (line 16-19). Data Race pairs, sum@36:13 and sum@36:13.

program DRB117_taskwait_waitonlychild_orig_yes
    use omp_lib
    implicit none

    integer, dimension(:), allocatable :: a, psum
    integer :: sum, i

    allocate(a(4))
    allocate(psum(4))

    !$omp parallel num_threads(2)
        !$omp do schedule(dynamic, 1)
        do i = 1, 4
            a(i) = i
        end do
        !$omp end do

        !$omp single
            !$omp task
                !$omp task
                  psum(2) = a(3)+a(4)
                !$omp end task
               psum(1) = a(1)+a(2)
            !$omp end task
            !$omp taskwait
            sum = psum(2)+psum(1)
        !$omp end single
    !$omp end parallel

    print*,'sum =',sum

    deallocate(a,psum)
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!micro-bench equivalent to the restrict keyword in C-99 in F95. No data race pairs.

module DRB068
    use omp_lib
    implicit none
contains
    subroutine foo(n, a, b, c, d)
        integer, value :: n
        integer :: i
        integer, dimension(:), pointer, intent(out) :: a, b, c, d

        allocate (a(n))
        allocate (b(n))
        allocate (c(n))
        allocate (d(n))

        do i = 1, n
            b(i) = i
            c(i) = i
        end do

        !$omp parallel do
        do i = 1, n
            a(i) = b(i)+c(i)
        end do
        !$omp end parallel do

        if (a(500) /= 1000) then
            print*,a(500)
        end if

        nullify(a,b,c,d)
    end subroutine
end module

program DRB068_restrictpointer2_orig_no
    use omp_lib
    use DRB068
    implicit none

    integer :: n = 1000
    integer, dimension(:), pointer :: a=>null(), b=>null(), c=>null(), d=>null()

    allocate (a(n))
    allocate (b(n))
    allocate (c(n))
    allocate (d(n))

    call foo(n,a,b,c,d)

    if(associated(a))nullify(a)
    if(associated(b))nullify(b)
    if(associated(c))nullify(c)
    if(associated(d))nullify(d)

end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!The loop in this example cannot be parallelized.
!
!Data race pairs: we allow two pairs to preserve the original code pattern.
! 1. x@50 vs. x@51
! 2. x@51 vs. x@51

program DRB017_outputdep_var_yes
    use omp_lib
    implicit none

    integer len, i, x, argCount, allocStatus, rdErr, ix
    character(len=80), dimension(:), allocatable :: args
    integer, dimension (:), allocatable :: a

    len = 100
    x = 10

    argCount = command_argument_count()
    if (argCount == 0) then
        write (*,'(a)') "No command line arguments provided."
    end if

    allocate(args(argCount), stat=allocStatus)
    if (allocStatus > 0) then
        write (*,'(a)') "Allocation error, program terminated."
        stop
    end if

    do ix = 1, argCount
        call get_command_argument(ix,args(ix))
    end do

    if (argCount >= 1) then
        read (args(1), '(i10)', iostat=rdErr) len
        if (rdErr /= 0 ) then
            write (*,'(a)') "Error, invalid integer value."
        end if
    end if

    allocate (a(len))
    !$omp parallel do
    do i = 1, len
        a(i) = x
        x = i
    end do
    !$omp end parallel do

    print 100, x, a(0)
    100 format ("x=",i3,2x,"a(0)=",i3)

    deallocate(args,a)
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!omp for loop is allowed to use the linear clause, an OpenMP 4.5 addition. No data race pairs.

program DRB112_linear_orig_no
    use omp_lib
    implicit none

    integer len, i, j
    integer, parameter :: dp = kind(1.0d0)
    real(dp), dimension(:), allocatable :: a,b,c

    len = 100
    i = 0
    j = 0

    allocate (a(len))
    allocate (b(len))
    allocate (c(len))

    do i = 1, len
        a(i) = (real(i,dp))/2.0
        b(i) = (real(i,dp))/3.0
        c(i) = (real(i,dp))/7.0
    end do

    !$omp parallel do linear(j)
    do i = 1, len
        c(j) = c(j)+a(i)*b(i)
        j = j+1
    end do
    !$omp end parallel do

    !print*,'c(50) =',c(50)

    if(allocated(a))deallocate(a)
    if(allocated(b))deallocate(b)
end program

C> @file bc.f Boundary condition routines

C> \ingroup bcond
C> @{
C> Determining rind state for Dirichlet boundary conditions
      subroutine InviscidBC(wminus,wbc,nstate)
!-------------------------------------------------------------------------------
! JH091514 A fading copy of RFLU_ModAUSM.F90 from RocFlu
!-------------------------------------------------------------------------------

!#ifdef SPEC
!      USE ModSpecies, ONLY: t_spec_type
!#endif
      include 'SIZE'
      include 'INPUT' ! do we need this?
      include 'GEOM' ! for unx
      include 'CMTDATA' ! do we need this without outflsub?
!     include 'TSTEP' ! for ifield?
      include 'DG'

! ==============================================================================
! Arguments
! ==============================================================================
      integer nstate,nflux
      real wminus(lx1*lz1,2*ldim,nelt,nstate),
     >     wbc(lx1*lz1,2*ldim,nelt,nstate)

! ==============================================================================
! Locals
! ==============================================================================

      integer e,f,fdim,i,k,nxz,nface,ifield
      parameter (lfd=lxd*lzd)
! JH111815 legacy rocflu names.
!
! nx,ny,nz : outward facing unit normal components
! fs       : face speed. zero until we have moving grid
! jaco_c   : fdim-D GLL grid Jacobian
! nm       : jaco_c, fine grid
!
! State on the interior (-, "left") side of the face
! rl       : density
! ul,vl,wl : velocity
! tl       : temperature
! al       : sound speed
! pl       : pressure, then phi
! cpl      : rho*cp
! State on the exterior (+, "right") side of the face
! rr       : density
! ur,vr,wr : velocity
! tr       : temperature
! ar       : sound speed
! pr       : pressure
! cpr      : rho*cp

      COMMON /SCRNS/ nx(lfd), ny(lfd), nz(lfd), rl(lfd), ul(lfd),
     >               vl(lfd), wl(lfd), pl(lfd), tl(lfd), al(lfd),
     >               cpl(lfd),rr(lfd), ur(lfd), vr(lfd), wr(lfd),
     >               pr(lfd),tr(lfd), ar(lfd),cpr(lfd),phl(lfd),fs(lfd),
     >               jaco_f(lfd),flx(lfd,toteq),jaco_c(lx1*lz1)
      real nx, ny, nz, rl, ul, vl, wl, pl, tl, al, cpl, rr, ur, vr, wr,
     >                pr,tr, ar,cpr,phl,fs,jaco_f,flx,jaco_c

!     REAL vf(3)
      real nTol
      character*132 deathmessage
      common /nekcb/ cb
      character*3 cb

      nTol = 1.0E-14

      fdim=ldim-1
      nface = 2*ldim
      nxz   = lx1*lz1
      nxzd  = lxd*lzd
      ifield= 1 ! You need to figure out the best way of dealing with
                ! this variable

!     if (outflsub)then
!        call maxMachnumber
!     endif
      do e=1,nelt
      do f=1,nface

         cb=cbc(f,e,ifield)
         if (cb.ne.'E  '.and.cb.ne.'P  ') then ! cbc bndy

!-----------------------------------------------------------------------
! compute flux for weakly-enforced boundary condition
!-----------------------------------------------------------------------

            do j=1,nstate
               do i=1,nxz
                  if (abs(wbc(i,f,e,j)) .gt. ntol) then
                  write(6,*) nid,j,i,wbc(i,f,e,j),wminus(i,f,e,j),cb,
     > nstate
                  write(deathmessage,*)  'GS hit a bndy,f,e=',f,e,'$'
! Make sure you are not abusing this error handler
                  call exitti(deathmessage,f)
                  endif
               enddo
            enddo

! JH060215 added SYM bc. Just use it as a slip wall hopefully.
! JH021717 OK I just realized that this way doubles my userbc calls.
!          not sure if face loop and if-block for cb is a better way
!          to do it or not.
            if (cb.eq.'v  ' .or. cb .eq. 'V  ') then
              call inflow(nstate,f,e,wminus,wbc)
            elseif (cb.eq.'O  ') then
              call outflow(nstate,f,e,wminus,wbc)
            elseif (cb .eq. 'W  ' .or. cb .eq.'I  '.or.cb .eq.'SYM')then
              call wallbc_inviscid(nstate,f,e,wminus,wbc)
            endif 

         endif
      enddo
      enddo

C> @}
      return
      end

!-----------------------------------------------------------------------

C> \ingroup bcond
C> @{
C> Determining IGU contribution to boundary flux. 0 for artificial
C> viscosity, and strictly interior for physical viscosity.
      subroutine bcflux(flux,agradu,qminus)
! Need proper indexing and nekasgn & cmtasgn calls
      include 'SIZE'
      include 'INPUT'
      include 'DG'
!     include 'NEKUSE'
      include 'TSTEP' ! wait how do we know what ifield is?
      integer e,eq,f
      real flux  (lx1*lz1,2*ldim,nelt,toteq)
      real agradu(lx1*lz1,2*ldim,nelt,toteq)
!     real qminus(lx1*lz1,2*ldim,nelt,nqq) ! include CMTDATA?
      real qminus(*) ! 'scuse me. comin' through
      common /nekcb/ cb
      character*3 cb

      nfaces=2*ldim
      nxz=lx1*lz1
      ifield=1

      do e=1,nelt
         do f=1,nfaces
            if (cbc(f, e, ifield).ne.'E  '.and.
     >          cbc(f, e, ifield).ne.'P  ') then ! cbc bndy
               cb=cbc(f,e,ifield)
               if (cb .eq. 'I  ') then ! NEUMANN CONDITIONS GO HERE
!-------------------------------------------------------------
! JH112216 HARDCODING ADIABATIC WALL. DO SMARTER SOON
                  call rzero(flux(1,f,e,1),nxz)
                  do eq=2,ldim+1
                     call copy(flux(1,f,e,eq),agradu(1,f,e,eq),nxz)
                  enddo
! METHOD "B", ADIABATIC NO-SLIP
                  call rzero(flux(1,f,e,toteq),nxz)
! METHOD "A", ADIABATIC NO-SLIP augments with viscous work. triage below
! because, predictably, NOW I need to computate AgradU on surfaces and I don't
! have general code for that.
                  call a5adiabatic_wall(flux(1,1,1,toteq),f,e,agradu,
     >                                  qminus)
! JH112216 HARDCODING ADIABATIC WALL. DO SMARTER SOON
!-------------------------------------------------------------
!                 cbu=cb
!                 do eq=1,toteq
!                    call userflux(flux(1,f,e,eq)) ! replace this with userbc
!                 enddo
               else  ! if (cb .eq. 'SYM') then ! NEED PHYSICAL VISC TEST
! JH031617 But this code block basically guarantees that artificial viscosity
!          does not contribute to viscous fluxes at boundaries.
                  do eq=1,toteq
                     call rzero(flux(1,f,e,eq),nxz)
                  enddo
               endif
            endif
         enddo
      enddo

C> @}
      return
      end

      subroutine a5adiabatic_wall(eflx,f,e,dU,wstate)
      include 'SIZE'
      include 'INPUT'
      include 'GEOM' ! for UNX under ADIABATIC WALL METHOD "A"
      include 'CMTDATA'
      real eflx  (lx1*lz1,2*ldim,nelt) ! better be zero on entry
      real dU    (lx1*lz1,2*ldim,nelt,toteq)
      real wstate(lx1*lz1,2*ldim,nelt,nqq)
      common /scrns/ flxscr(lx1*lz1)
      real flxscr
      integer e,f

      nxz=lx1*lz1

      call rzero(eflx(1,f,e),nxz)
      call rzero(hface,nxz)

      call a51dUadia(flxscr,f,e,dU,wstate)
      call add2col2(eflx(1,f,e),flxsxcr,unx(1,1,f,e),nxz)
      call a52dUadia(flxscr,f,e,dU,wstate)
      call add2col2(eflx(1,f,e),flxsxcr,uny(1,1,f,e),nxz)
      if (if3d) then
         call a53dUadia(flxscr,f,e,dU,wstate)
         call add2col2(eflx(1,f,e),flxsxcr,unz(1,1,f,e),nxz)
      endif
      return
      end

      subroutine a51dUadia(flux,f,ie,dU,wstate)
! same as A51 for volume flux, but
! 1. uses surface storage of quantities in wstate <-qminus (intent(in))
! 2. SETS K=0. ADIABATIC WALLS HAVE VISCOUS HEATING, BUT DON'T CONDUCT
      include 'SIZE'
      include 'CMTDATA'
      real wstate(lx1*lz1,2*ldim,nelt,nqq)
      real dU    (lx1*lz1,2*ldim,nelt,toteq,3)
      real flux  (lx1*ly1*lz1)
      real K,E,kmcvmu,lambdamu
      integer f
      npt=lx1*lz1

      do i=1,npt
         dU1x=dU(i,f,ie,1,1)
         dU2x=dU(i,f,ie,2,1)
         dU3x=dU(i,f,ie,3,1)
         dU4x=dU(i,f,ie,4,1)
         dU5x=dU(i,f,ie,5,1)
         dU1y=dU(i,f,ie,1,2)
         dU2y=dU(i,f,ie,2,2)
         dU3y=dU(i,f,ie,3,2)
         dU4y=dU(i,f,ie,4,2)
         dU5y=dU(i,f,ie,5,2)
         dU1z=dU(i,f,ie,1,3)
         dU2z=dU(i,f,ie,2,3)
         dU3z=dU(i,f,ie,3,3)
         dU4z=dU(i,f,ie,4,3)
         dU5z=dU(i,f,ie,5,3)
         rho   =wstate(i,f,ie,irho)
         cv    =wstate(i,f,ie,icvf)/rho
         lambda=wstate(i,f,ie,ilamf)
         mu    =wstate(i,f,ie,imuf)
         K     =0.0 ! ADIABATIC HARDCODING
         u1    =wstate(i,f,ie,iux)
         u2    =wstate(i,f,ie,iuy)
         u3    =wstate(i,f,ie,iuz)
         E     =wstate(i,f,ie,iu5)/rho
         lambdamu=lambda+mu
         kmcvmu=K-cv*mu
         flux(i)=
     >(K*dU5x+cv*lambda*u1*dU4z-kmcvmu*u3*dU4x+cv*lambda*u1*dU3y
     1   -kmcvmu*u2*dU3x+cv*mu*u3*dU2z+cv*mu*u2*dU2y+(cv*lambda-
     2   K+2*cv*mu)*u1*dU2x-cv*lambdamu*u1*u3*dU1z-cv*lambdamu
     3   *u1*u2*dU1y+(K*u3**2-cv*mu*u3**2+K*u2**2-cv*mu*u2**2-cv*la
     4   mbda*u1**2+K*u1**2-2*cv*mu*u1**2-E*K)*dU1x)/(cv*rho)
      enddo
      return
      end

      subroutine a52dUadia(flux,f,ie,dU,wstate)
! same as A52 for volume flux, but
! 1. uses surface storage of quantities in wstate <-qminus (intent(in))
! 2. SETS K=0. ADIABATIC WALLS HAVE VISCOUS HEATING, BUT DON'T CONDUCT
      include 'SIZE'
      include 'CMTDATA'
      real wstate(lx1*lz1,2*ldim,nelt,nqq)
      real dU    (lx1*lz1,2*ldim,nelt,toteq,3)
      real flux  (lx1*ly1*lz1)
      real K,E,kmcvmu,lambdamu
      integer f
      npt=lx1*lz1

      do i=1,npt
         dU1x=dU(i,f,ie,1,1)
         dU2x=dU(i,f,ie,2,1)
         dU3x=dU(i,f,ie,3,1)
         dU4x=dU(i,f,ie,4,1)
         dU5x=dU(i,f,ie,5,1)
         dU1y=dU(i,f,ie,1,2)
         dU2y=dU(i,f,ie,2,2)
         dU3y=dU(i,f,ie,3,2)
         dU4y=dU(i,f,ie,4,2)
         dU5y=dU(i,f,ie,5,2)
         dU1z=dU(i,f,ie,1,3)
         dU2z=dU(i,f,ie,2,3)
         dU3z=dU(i,f,ie,3,3)
         dU4z=dU(i,f,ie,4,3)
         dU5z=dU(i,f,ie,5,3)
         rho   =wstate(i,f,ie,irho)
         cv    =wstate(i,f,ie,icvf)/rho
         lambda=wstate(i,f,ie,ilamf)
         mu    =wstate(i,f,ie,imuf)
         K     =0.0 ! ADIABATIC HARDCODING
         u1    =wstate(i,f,ie,iux)
         u2    =wstate(i,f,ie,iuy)
         u3    =wstate(i,f,ie,iuz)
         E     =wstate(i,f,ie,iu5)/rho
         lambdamu=lambda+mu
         kmcvmu=K-cv*mu
         flux(i)=
     >(K*dU5y+cv*lambda*u2*dU4z-kmcvmu*u3*dU4y+cv*mu*u3*dU3z+(cv
     1   *lambda-K+2*cv*mu)*u2*dU3y+cv*mu*u1*dU3x-kmcvmu*u1*dU2y+
     2   cv*lambda*u2*dU2x-cv*lambdamu*u2*u3*dU1z+(K*u3**2-cv*mu
     3   *u3**2-cv*lambda*u2**2+K*u2**2-2*cv*mu*u2**2+K*u1**2-cv*mu*
     4   u1**2-E*K)*dU1y-cv*lambdamu*u1*u2*dU1x)/(cv*rho)
      enddo
      return
      end

      subroutine a53dUadia(flux,f,ie,dU,wstate)
! same as A53 for volume flux, but
! 1. uses surface storage of quantities in wstate <-qminus (intent(in))
! 2. SETS K=0. ADIABATIC WALLS HAVE VISCOUS HEATING, BUT DON'T CONDUCT
      include 'SIZE'
      include 'CMTDATA'
      real wstate(lx1*lz1,2*ldim,nelt,nqq)
      real dU    (lx1*lz1,2*ldim,nelt,toteq,3)
      real flux  (lx1*ly1*lz1)
      real K,E,kmcvmu,lambdamu
      integer f
      npt=lx1*lz1

      do i=1,npt
         dU1x=dU(i,f,ie,1,1)
         dU2x=dU(i,f,ie,2,1)
         dU3x=dU(i,f,ie,3,1)
         dU4x=dU(i,f,ie,4,1)
         dU5x=dU(i,f,ie,5,1)
         dU1y=dU(i,f,ie,1,2)
         dU2y=dU(i,f,ie,2,2)
         dU3y=dU(i,f,ie,3,2)
         dU4y=dU(i,f,ie,4,2)
         dU5y=dU(i,f,ie,5,2)
         dU1z=dU(i,f,ie,1,3)
         dU2z=dU(i,f,ie,2,3)
         dU3z=dU(i,f,ie,3,3)
         dU4z=dU(i,f,ie,4,3)
         dU5z=dU(i,f,ie,5,3)
         rho   =wstate(i,f,ie,irho)
         cv    =wstate(i,f,ie,icvf)/rho
         lambda=wstate(i,f,ie,ilamf)
         mu    =wstate(i,f,ie,imuf)
         K     =0.0 ! ADIABATIC HARDCODING
         u1    =wstate(i,f,ie,iux)
         u2    =wstate(i,f,ie,iuy)
         u3    =wstate(i,f,ie,iuz)
         E     =wstate(i,f,ie,iu5)/rho
         lambdamu=lambda+mu
         kmcvmu=K-cv*mu
         flux(i)=
     >(K*(dU5z-E*dU1z)+cv*u3*(lambda*dU4z+2*mu*dU4z+lambda*dU3y+lambda
     1   *dU2x)-K*u3*dU4z+cv*mu*u2*(dU4y+dU3z)+cv*mu*u1*(dU4x+dU2z)-
     2   K*u2*dU3z-K*u1*dU2z-cv*(lambda+2*mu)*u3**2*dU1z+K*u3**2*dU1z+
     3   K*u2**2*dU1z-cv*mu*u2**2*dU1z+K*u1**2*dU1z-cv*mu*u1**2*dU1z-c
     4   _v*(lambda+mu)*u2*u3*dU1y-cv*(lambda+mu)*u1*u3*dU1x)/(cv*rho)
      enddo
      return
      end

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Concurrent access of var@26:13 has no atomicity violation. No data race present.

module DRB163
    integer :: var(16)
    integer :: i, j
end module

program DRB163_simdmissinglock1_orig_gpu_no
    use omp_lib
    use DRB163
    implicit none

    do i = 1, 16
        var(i) = 0
    end do

    !$omp target map(tofrom:var) device(0)
    !$omp teams distribute parallel do reduction(+:var)
    do i = 1, 20
        !$omp simd
        do j = 1, 16
            var(j) = var(j)+1
        end do
        !$omp end simd
    end do
    !$omp end teams distribute parallel do
    !$omp end target

    do i = 1, 16
        if (var(i) /= 20) then
            print*, var(i), i
        end if
    end do

end program

C> @file step.f time stepping and mesh spacing routines
      subroutine setdtcmt
!--------------------------------------------------------------
! JH072914 now summed instead of maximized for compressible flow
! JH082015 why was I doing that again?
!     someday compute new timestep based on CFL-condition. follow
!     setdtc in nek/subs1.f very carefully.
! JH091616 now with diffusion number for naively explicit visc
! JH091616 consider migrating to compute_cfl
! JH120116 Why aren't we including total again?
!--------------------------------------------------------------
      include 'SIZE'
      include 'GEOM'
      include 'MVGEOM'
      include 'MASS'
      include 'TSTEP'
      include 'INPUT'
      include 'SOLN'
      include 'CMTDATA'

!--------------------------------------------------------------
! YOU REALLY PROBABLY WANT YOUR OWN SCRATCH SPACE FOR THIS
      common /scrsf/ utmp(lx1,ly1,lz1,lelt) ! mind if I borrow this?
     $ ,             vtmp(lx1,ly1,lz1,lelt) ! as long as the mesh
     $ ,             wtmp(lx1,ly1,lz1,lelt) ! doesn't move
! YOU REALLY PROBABLY WANT YOUR OWN SCRATCH SPACE FOR THAT
!--------------------------------------------------------------
      common /udxmax/ umax
      real strof
      data strof /1.0e-8/

      dt=abs(param(12))

      NTOT   = lx1*ly1*lz1*NELV
      do i=1,ntot
         utmp(i,1,1,1) = abs(vx(i,1,1,1))+csound(i,1,1,1)
         vtmp(i,1,1,1) = abs(vy(i,1,1,1))+csound(i,1,1,1)
         wtmp(i,1,1,1) = abs(vz(i,1,1,1))+csound(i,1,1,1)
      enddo

! JH091118 DefaultParameters means we don't have direct control over
!          this variable anymore. If it's lower than its default value,
!          we trust it to set the time step
!     if (ctarg .gt.0.0) then
      if (ctarg .lt.0.5) then
         call compute_cfl (umax,utmp,vtmp,wtmp,1.0)
         dt_cfl=ctarg/umax
         call glsqinvcolmin(dt1,vdiff(1,1,1,1,imu ),gridh,ntot,ctarg)
         call glsqinvcolmin(dt2,vdiff(1,1,1,1,iknd),gridh,ntot,ctarg)
         call glsqinvcolmin(dt3,vdiff(1,1,1,1,inus),gridh,ntot,ctarg)
         dt=min(dt_cfl,dt1,dt2,dt3)
         if (dt .gt. 10.0) then
            if (nio.eq.0) write(6,*) 'dt huge. crashing ',istep,stage,
     >         dt
            call exitt
         endif
      else
         dt = abs(param(12))
      endif
      dt_ptcle = dt  
#ifdef LPM
      call lpm_set_dt(dt_ptcle) ! particle time step
      dt=min(dt,dt_ptcle)
#endif

      if (timeio .gt. 0.0) then ! adjust dt for timeio. 
         zetime1=time_cmt
         zetime2=time_cmt+dt
         it1=zetime1/timeio
         it2=zetime2/timeio
         ita=it1
         itb=ita+1
         if (abs(zetime1-itb*timeio).le.strof) it1=itb
         ita=it2
         itb=ita+1
         if (abs(zetime2-itb*timeio).le.strof) it2=itb
         if (it2.gt.it1) then
            ifoutfld=.true.
            dt=(it2*timeio)-time_cmt
         endif
      endif

      param(12)=-dt

      call compute_cfl (courno,utmp,vtmp,wtmp,dt) ! sanity?

! diffusion number based on viscosity.

!     call mindr(mdr,diffno2)
      call glinvcol2max(diffno1,vdiff(1,1,1,1,imu), gridh,ntot,dt)
      call glinvcol2max(diffno2,vdiff(1,1,1,1,iknd),gridh,ntot,dt)
      call glinvcol2max(diffno3,vdiff(1,1,1,1,inus),gridh,ntot,dt)
!     diffno=max(diffno1,diffno2,diffno3)
      time_cmt= time_cmt+dt
      time    = time_cmt
      if (nio.eq.0) WRITE(6,100)ISTEP,TIME_CMT,DT,COURNO,
     >   diffno1,diffno2,diffno3
 100  FORMAT('CMT ',I7,', t=',1pE14.7,', DT=',1pE14.7
     $,', C=',1pE12.5,', Dmu,knd,art=',3(1pE11.4))

      return
      end

      subroutine mindr(mdr,diffno)
c
c     Find minimum distance between grid points
c     and multiply it by viscosity to get diffusion number
c     Probably need to do this for energy equation too...
! JH091616 migrate to getdr 3d ASAP. Again, follow compute_cfl
      include 'SIZE'
      include 'TOTAL'
      include 'CMTDATA'

      real    mdr,dr1
      real    x0,x1,x2,x3,x4,y0,y1,y2,y3,y4
      integer e
c
      mdr=1.e5
      if(if3d) then
        write(6,*)'TODO:: mindr for 3D. getdr'
        call exitt
      else
        diffno=0.0
        do e=1,nelt
          do iy=2,ly1-1
          do ix=2,lx1-1
            dtmp=1.0e5
            x0 = xm1(ix  ,iy  ,1,e)
            x1 = xm1(ix  ,iy-1,1,e)
            x2 = xm1(ix+1,iy  ,1,e)
            x3 = xm1(ix  ,iy+1,1,e)
            x4 = xm1(ix-1,iy  ,1,e)
            y0 = ym1(ix  ,iy  ,1,e)
            y1 = ym1(ix  ,iy-1,1,e)
            y2 = ym1(ix+1,iy  ,1,e)
            y3 = ym1(ix  ,iy+1,1,e)
            y4 = ym1(ix-1,iy  ,1,e)
            dr1 = dist2(x0,y0,x1,y1)
            if(dr1.lt.mdr) mdr=dr1
            if(dr1.lt.dtmp) dtmp=dr1
            dr1 = dist2(x0,y0,x2,y2)
            if(dr1.lt.mdr) mdr=dr1
            if(dr1.lt.dtmp) dtmp=dr1
            dr1 = dist2(x0,y0,x3,y3)
            if(dr1.lt.mdr) mdr=dr1
            if(dr1.lt.dtmp) dtmp=dr1
            dr1 = dist2(x0,y0,x4,y4)
            if(dr1.lt.mdr) mdr=dr1
            if(dr1.lt.dtmp) dtmp=dr1
            diffno=max(diffno,dt*vdiff(ix,iy,1,e,imu)/dtmp/dtmp)
          enddo
          enddo
        enddo
      endif
      diffno=glmax(diffno,1)
      mdr = glmin(mdr,1)
      if(mdr.ge.1.e5) write(6,*) 'wrong mdr'

      return
      end

      real function dist2(x1,y1,x2,y2)
      real x1,y1,x2,y2,dx,dy
c
      dx = x1-x2
      dy = y1-y2
      dist2 = sqrt(dx*dx+dy*dy)
c
      return
      end

!-----------------------------------------------------------------------

      subroutine compute_grid_h(h,x,y,z)
! Richard Pasquetti SEM "grid spacing h." good parallelogram/piped stuff
      include 'SIZE'
      include 'INPUT'
      include 'GEOM'
      real a(3), b(3), c(3), d(3)
      real h(lx1,ly1,lz1,nelt) ! intent(out)
      real x(lx1,ly1,lz1,nelt) ! intent(in)
      real y(lx1,ly1,lz1,nelt) ! intent(in)
      real z(lx1,ly1,lz1,nelt) ! intent(in)
      integer e
      integer icalld
      data icalld /0/
      save icalld
      
      if (icalld .eq. 1) then
         return
      else
         icalld=1
      endif

      do e=1,nelt
         do iz=1,lz1
            if (if3d) then
               km1=iz-1
               kp1=iz+1
               izm=km1
               if (km1 .lt. 1) izm=iz
               izp=kp1
               if (kp1 .gt. lz1) izp=iz
            else
               izm=iz
               izp=iz
            endif
            do iy=1,ly1
               jm1=iy-1
               jp1=iy+1
               iym=jm1
               if (jm1 .lt. 1) iym=iy
               iyp=jp1
               if (jp1 .gt. ly1) iyp=iy
               do ix=1,lx1
                  im1=ix-1
                  ip1=ix+1
                  ixm=im1
                  if (im1 .lt. 1) ixm=ix
                  ixp=ip1
                  if (ip1 .gt. lx1) ixp=ix
                  x1 = x(ixm,iy ,iz ,e)
                  x2 = x(ixp,iy ,iz ,e)
                  x3 = x(ix ,iym,iz ,e)
                  x4 = x(ix ,iyp,iz ,e)
                  x5 = x(ix ,iy ,izm,e)
                  x6 = x(ix ,iy ,izp,e)
                  y1 = y(ixm,iy ,iz ,e)
                  y2 = y(ixp,iy ,iz ,e)
                  y3 = y(ix ,iym,iz ,e)
                  y4 = y(ix ,iyp,iz ,e)
                  y5 = y(ix ,iy ,izm,e)
                  y6 = y(ix ,iy ,izp,e)
                  z1 = z(ixm,iy ,iz ,e)
                  z2 = z(ixp,iy ,iz ,e)
                  z3 = z(ix ,iym,iz ,e)
                  z4 = z(ix ,iyp,iz ,e)
                  z5 = z(ix ,iy ,izm,e)
                  z6 = z(ix ,iy ,izp,e)
                  a(1)=x2-x1
                  a(2)=y2-y1
                  a(3)=z2-z1
                  b(1)=x4-x3
                  b(2)=y4-y3
                  b(3)=z4-z3
                  c(1)=x6-x5
                  c(2)=y6-y5
                  c(3)=z6-z5
                  if (if3d) then
                     fact=0.125 ! h doesn't reach into corners of neighboring elements
                     if (ixp.eq.ix.or.ixm.eq.ix) fact=2.0*fact
                     if (iym.eq.iy.or.iyp.eq.iy) fact=2.0*fact
                     if (izm.eq.iz.or.izp.eq.iz) fact=2.0*fact
                     call cross(d,a,b)
                     h(ix,iy,iz,e)=fact*dot(c,d,3)
                     h(ix,iy,iz,e)=abs(h(ix,iy,iz,e))**(1.0/3.0)
                  else
                     fact=0.25
                     if (ixp.eq.ix.or.ixm.eq.ix) fact=2.0*fact
                     if (iym.eq.iy.or.iyp.eq.iy) fact=2.0*fact
                     h(ix,iy,iz,e)=sqrt(fact*abs(a(1)*b(2)-a(2)*b(1)))
                  endif
               enddo
            enddo
         enddo
      enddo

      return
      end

!-----------------------------------------------------------------------

      subroutine glinvcol2max(col2m,a,b,n,s)
      real col2m
      real s
      real a(*),b(*)
      tmp=0.0
      do i=1,n
         tmp=max(tmp,abs(s*a(i)/b(i)/b(i)))
      enddo
      col2m=glamax(tmp,1)
      return
      end

!-----------------------------------------------------------------------

      subroutine glsqinvcolmin(col2m,a,b,n,s)
      real col2m
      real s
      real a(*),b(*)
      tmp=1.0e36
      do i=1,n
         if (a(i).gt.1.0e-36) tmp=min(tmp,abs(s*b(i)**2/a(i)))
      enddo
      col2m=glamin(tmp,1)
      return
      end

!-----------------------------------------------------------------------

      subroutine compute_mesh_h(h,x,y,z)
! Zingan's DGFEM formula: h=minimum distance between vertices divided by
!                         polynomial order
      include 'SIZE'
      include 'INPUT'
      real h(nelt)             ! intent(out)
      real x(lx1,ly1,lz1,nelt) ! intent(in)
      real y(lx1,ly1,lz1,nelt) ! intent(in)
      real z(lx1,ly1,lz1,nelt) ! intent(in)
      real xcrn(8),ycrn(8),zcrn(8)
      integer e
      integer icalld
      data icalld /0/
      save icalld
      
      if (icalld .eq. 1) then
         return
      else
         icalld=1
      endif

      ncrn=2**ldim
      rp=1.0/((lx1-1))

      do e=1,nelt
         call rzero(zcrn,8)
         k1=1
         k2=lz1
         j1=1
         j2=ly1
         i1=1
         i2=lx1
         xcrn(1) = x(i1,j1,k1,e)
         xcrn(2) = x(i2,j1,k1,e)
         xcrn(3) = x(i1,j2,k1,e)
         xcrn(4) = x(i2,j2,k1,e)
         ycrn(1) = y(i1,j1,k1,e)
         ycrn(2) = y(i2,j1,k1,e)
         ycrn(3) = y(i1,j2,k1,e)
         ycrn(4) = y(i2,j2,k1,e)
         if (if3d) then
            xcrn(5) = x(i1,j1,k2,e)
            xcrn(6) = x(i2,j1,k2,e)
            xcrn(7) = x(i1,j2,k2,e)
            xcrn(8) = x(i2,j2,k2,e)
            ycrn(5) = y(i1,j1,k2,e)
            ycrn(6) = y(i2,j1,k2,e)
            ycrn(7) = y(i1,j2,k2,e)
            ycrn(8) = y(i2,j2,k2,e)
            zcrn(1) = z(i1,j1,k1,e)
            zcrn(2) = z(i2,j1,k1,e)
            zcrn(3) = z(i1,j2,k1,e)
            zcrn(4) = z(i2,j2,k1,e)
            zcrn(5) = z(i1,j1,k2,e)
            zcrn(6) = z(i2,j1,k2,e)
            zcrn(7) = z(i1,j2,k2,e)
            zcrn(8) = z(i2,j2,k2,e)
         endif
         dist=1.0e36
         do ic1=1,ncrn
            do ic2=1,ncrn
               if (ic2 .ne. ic1) then
                  dtmp=(xcrn(ic2)-xcrn(ic1))**2+
     >                 (ycrn(ic2)-ycrn(ic1))**2+
     >                 (zcrn(ic2)-zcrn(ic1))**2
                  dist=min(dist,sqrt(dtmp))
               endif
            enddo
         enddo
         h(e)=dist*rp
      enddo

      return
      end

      subroutine genwz
C-----------------------------------------------------------------
C
C     GENERATE
C
C            - DERIVATIVE OPERATORS
C            - INTERPOLATION OPERATORS
C            - WEIGHTS
C            - COLLOCATION POINTS
C
C     ASSOCIATED WITH THE
C
C            - GAUSS-LOBATTO LEGENDRE MESH (SUFFIX M1/M2/M3)
C            - GAUSS LEGENDRE         MESH (SUFFIX M2)
C            - GAUSS-LOBATTO JACOBI   MESH (SUFFIX M1/M2/M3)
C
C-----------------------------------------------------------------
C
      INCLUDE 'SIZE'
      INCLUDE 'WZ'
      INCLUDE 'DXYZ'
      INCLUDE 'IXYZ'
      INCLUDE 'INPUT'

      REAL TMP(LY1,LY1),TMPT(LY1,LY1)
C
      IF (ldim.EQ.2) THEN
C
C***  Two-dimensional case  **********************
C
C
C     Gauss-Lobatto Legendre mesh (suffix M1)
C     Generate collocation points and weights
C
      CALL ZWGLL (ZGM1(1,1),WXM1,lx1)
      CALL ZWGLL (ZGM1(1,2),WYM1,ly1)
      ZGM1(lz1,3) = 0.
      WZM1(lz1)   = 1.
      DO 100 IY=1,ly1
      DO 100 IX=1,lx1
      W3M1(IX,IY,1)=WXM1(IX)*WYM1(IY)
  100 CONTINUE
C
C     Compute derivative matrices
C
      CALL DGLL (DXM1,DXTM1,ZGM1(1,1),lx1,lx1)
      CALL DGLL (DYM1,DYTM1,ZGM1(1,2),ly1,ly1)
      CALL RZERO (DZM1 ,lz1*lz1)
      CALL RZERO (DZTM1,lz1*lz1)
C
C     Gauss Legendre mesh (suffix M2)
C     Generate collocation points and weights
C
      IF(IFSPLIT)THEN
         CALL ZWGLL (ZGM2(1,1),WXM2,lx2)
         CALL ZWGLL (ZGM2(1,2),WYM2,ly2)
      ELSE
         CALL ZWGL  (ZGM2(1,1),WXM2,lx2)
         CALL ZWGL  (ZGM2(1,2),WYM2,ly2)
      ENDIF
      ZGM2(lz2,3) = 0.
      WZM2(lz2)   = 1.
      DO 200 IY=1,ly2
      DO 200 IX=1,lx2
      W3M2(IX,IY,1)=WXM2(IX)*WYM2(IY)
  200 CONTINUE
C
C     Gauss-Lobatto Legendre mesh (suffix M3).
C     Generate collocation points and weights.
C
      CALL ZWGLL (ZGM3(1,1),WXM3,lx3)
      CALL ZWGLL (ZGM3(1,2),WYM3,ly3)
      ZGM3(lz3,3) = 0.
      WZM3(lz3)   = 1.
      DO 300 IY=1,ly3
      DO 300 IX=1,lx3
      W3M3(IX,IY,1)=WXM3(IX)*WYM3(IY)
  300 CONTINUE
C
C     Compute derivative matrices
C
      CALL DGLL (DXM3,DXTM3,ZGM3(1,1),lx3,lx3)
      CALL DGLL (DYM3,DYTM3,ZGM3(1,2),ly3,ly3)
      CALL RZERO (DZM3 ,lz3*lz3)
      CALL RZERO (DZTM3,lz3*lz3)
C
C     Generate interpolation operators for the staggered mesh
C
      CALL IGLLM (IXM12,IXTM12,ZGM1(1,1),ZGM2(1,1),lx1,lx2,lx1,lx2)
      CALL IGLLM (IYM12,IYTM12,ZGM1(1,2),ZGM2(1,2),ly1,ly2,ly1,ly2)
      IZM12 (lz2,lz1) = 1.
      IZTM12(lz1,lz2) = 1.
C
C     NOTE: The splitting scheme has only one mesh!!!!!
C
      IF (IFSPLIT) THEN
         CALL IGLLM (IXM21,IXTM21,ZGM1(1,1),ZGM2(1,1),lx1,lx2,lx1,lx2)
         CALL IGLLM (IYM21,IYTM21,ZGM1(1,2),ZGM2(1,2),ly1,ly2,ly1,ly2)
      ELSE
         CALL IGLM  (IXM21,IXTM21,ZGM2(1,1),ZGM1(1,1),lx2,lx1,lx2,lx1)
         CALL IGLM  (IYM21,IYTM21,ZGM2(1,2),ZGM1(1,2),ly2,ly1,ly2,ly1)
      ENDIF
      IZM21 (lz1,lz2) = 1.
      IZTM21(lz2,lz1) = 1.
C
C     Compute derivative operators for the staggered mesh
C
      IF(IFSPLIT)THEN
         CALL COPY (DXM12, DXM1, lx1*lx2)
         CALL COPY (DXTM12,DXTM1,lx1*lx2)
         CALL COPY (DYM12, DYM1, ly1*ly2)
         CALL COPY (DYTM12,DYTM1,ly1*ly2)
         CALL COPY (DZM12, DZM1, lz1*lz2)
         CALL COPY (DZTM12,DZTM1,lz1*lz2)
      ELSE
         CALL DGLLGL (DXM12,DXTM12,ZGM1(1,1),ZGM2(1,1),IXM12,
     $                                       lx1,lx2,lx1,lx2)
         CALL DGLLGL (DYM12,DYTM12,ZGM1(1,2),ZGM2(1,2),IYM12,
     $                                       ly1,ly2,ly1,ly2)
         DZM12 (lz2,lz1) = 0.
         DZTM12(lz2,lz1) = 0.
      ENDIF
C
C     Compute interpolation operators for the geometry mesh M3.
C
      CALL IGLLM (IXM13,IXTM13,ZGM1(1,1),ZGM3(1,1),lx1,lx3,lx1,lx3)
      CALL IGLLM (IYM13,IYTM13,ZGM1(1,2),ZGM3(1,2),ly1,ly3,ly1,ly3)
      CALL IGLLM (IXM31,IXTM31,ZGM3(1,1),ZGM1(1,1),lx3,lx1,lx3,lx1)
      CALL IGLLM (IYM31,IYTM31,ZGM3(1,2),ZGM1(1,2),ly3,ly1,ly3,ly1)
      IZM13 (lz3,lz1) = 1.
      IZTM13(lz1,lz3) = 1.
      IZM31 (lz1,lz3) = 1.
      IZTM31(lz3,lz1) = 1.
C
C
      IF (IFAXIS) THEN
C
C     Special treatment for the axisymmetric case
C     Generate additional points, weights, derivative operators and
C     interpolation operators required for elements close to the axis.
C
C
C     Gauss-Lobatto Jacobi mesh (suffix M1).
C     Generate collocation points and weights (alpha=0, beta=1).
C
      ALPHA = 0.
      BETA  = 1.
      CALL ZWGLJ (ZAM1,WAM1,ly1,ALPHA,BETA)
      DO 400 IY=1,ly1
      DO 400 IX=1,lx1
         W2AM1(IX,IY)=WXM1(IX)*WAM1(IY)
         W2CM1(IX,IY)=WXM1(IX)*WYM1(IY)
  400 CONTINUE
C
C     Compute derivative matrices
C
      CALL COPY (DCM1,DYM1,ly1*ly1)
      CALL COPY (DCTM1,DYTM1,ly1*ly1)
      CALL DGLJ (DAM1,DATM1,ZAM1,ly1,ly1,ALPHA,BETA)
C
C     Gauss Jacobi mesh (suffix M2)
C     Generate collocation points and weights
C
      IF(IFSPLIT)THEN
         CALL ZWGLJ (ZAM2,WAM2,ly2,ALPHA,BETA)
      ELSE
         CALL ZWGJ  (ZAM2,WAM2,ly2,ALPHA,BETA)
      ENDIF
      DO 500 IY=1,ly2
      DO 500 IX=1,lx2
         W2CM2(IX,IY)=WXM2(IX)*WYM2(IY)
         W2AM2(IX,IY)=WXM2(IX)*WAM2(IY)
  500 CONTINUE
C
C     Gauss-Lobatto Jacobi mesh (suffix M3).
C     Generate collocation points and weights.
C
      CALL ZWGLJ (ZAM3,WAM3,ly3,ALPHA,BETA)
      DO 600 IY=1,ly3
      DO 600 IX=1,lx3
         W2CM3(IX,IY)=WXM3(IX)*WYM3(IY)
         W2AM3(IX,IY)=WXM3(IX)*WAM3(IY)
  600 CONTINUE
C
C     Compute derivative matrices
C
      CALL COPY (DCM3,DYM3,ly3*ly3)
      CALL COPY (DCTM3,DYTM3,ly3*ly3)
      CALL DGLJ (DAM3,DATM3,ZAM3,ly3,ly3,ALPHA,BETA)
C
C     Generate interpolation operators for the staggered mesh
C
      CALL COPY  (ICM12,IYM12,ly2*ly1)
      CALL COPY  (ICTM12,IYTM12,ly1*ly2)
      CALL IGLJM (IAM12,IATM12,ZAM1,ZAM2,ly1,ly2,ly1,ly2,ALPHA,BETA)
      CALL COPY  (ICM21,IYM21,ly1*ly2)
      CALL COPY  (ICTM21,IYTM21,ly2*ly1)
      IF (IFSPLIT) THEN
      CALL IGLJM (IAM21,IATM21,ZAM2,ZAM1,ly1,ly2,ly1,ly2,ALPHA,BETA)
      ELSE
      CALL IGJM  (IAM21,IATM21,ZAM2,ZAM1,ly2,ly1,ly2,ly1,ALPHA,BETA)
      ENDIF
C
C     Compute derivative operators for the staggered mesh
C
      CALL COPY  (DCM12,DYM12,ly2*ly1)
      CALL COPY  (DCTM12,DYTM12,ly1*ly2)
      IF(IFSPLIT)THEN
         CALL COPY (DAM12, DAM1, ly1*ly2)
         CALL COPY (DATM12,DATM1,ly1*ly2)
      ELSE
         CALL DGLJGJ (DAM12,DATM12,ZAM1,ZAM2,IAM12,
     $                             ly1,ly2,ly1,ly2,ALPHA,BETA)
      ENDIF
C
C     Compute interpolation operators for the geometry mesh M3.
C
      CALL COPY  (ICM13,IYM13,ly3*ly1)
      CALL COPY  (ICTM13,IYTM13,ly1*ly3)
      CALL IGLJM (IAM13,IATM13,ZAM1,ZAM3,ly1,ly3,ly1,ly3,ALPHA,BETA)
      CALL COPY  (ICM31,IYM31,ly1*ly3)
      CALL COPY  (ICTM31,IYTM31,ly3*ly1)
      CALL IGLJM (IAM31,IATM31,ZAM3,ZAM1,ly3,ly1,ly3,ly1,ALPHA,BETA)
C
C     Compute interpolation operators between Gauss-Lobatto Jacobi
C     and Gauss-Lobatto Legendre (to be used in PREPOST).
C
      CALL IGLJM(IAJL1,IATJL1,ZAM1,ZGM1(1,2),ly1,ly1,ly1,ly1,ALPHA,BETA)
      IF (IFSPLIT) THEN
      CALL IGLJM(IAJL2,IATJL2,ZAM2,ZGM2(1,2),ly2,ly2,ly2,ly2,ALPHA,BETA)
      ELSE
      CALL IGJM (IAJL2,IATJL2,ZAM2,ZGM2(1,2),ly2,ly2,ly2,ly2,ALPHA,BETA)
      ENDIF

      CALL INVMT(IAJL1 ,IALJ1 ,TMP ,ly1)
      CALL INVMT(IATJL1,IATLJ1,TMPT,ly1)
      CALL MXM (IATJL1,ly1,IATLJ1,ly1,TMPT,ly1)
      CALL MXM (IAJL1 ,ly1,IALJ1 ,ly1,TMP ,ly1)

C
C     Compute interpolation operators between Gauss-Lobatto Legendre
C     and Gauss-Lobatto Jacobi (to be used in subr. genxyz IN postpre).
C
c
c     This call is not right, and these arrays are not used. 3/27/02. pff
c     CALL IGLLM(IALJ3,IATLJ3,ZGM3(1,2),ZAM3,ly3,ly3,ly3,ly3,ALPHA,BETA)
      CALL IGLJM(IALJ3,IATLJ3,ZGM3(1,2),ZAM3,ly3,ly3,ly3,ly3,ALPHA,BETA)
C
      ENDIF
C
C
      ELSE
C
C***  Three-dimensional case ************************************
C
C
C     Gauss-Lobatto Legendre mesh (suffix M1)
C     Generate collocation points and weights
C
      CALL ZWGLL (ZGM1(1,1),WXM1,lx1)
      CALL ZWGLL (ZGM1(1,2),WYM1,ly1)
      CALL ZWGLL (ZGM1(1,3),WZM1,lz1)
      DO 700 IZ=1,lz1
      DO 700 IY=1,ly1
      DO 700 IX=1,lx1
      W3M1(IX,IY,IZ)=WXM1(IX)*WYM1(IY)*WZM1(IZ)
  700 CONTINUE
C
C     Compute derivative matrices
C
      CALL DGLL (DXM1,DXTM1,ZGM1(1,1),lx1,lx1)
      CALL DGLL (DYM1,DYTM1,ZGM1(1,2),ly1,ly1)
      CALL DGLL (DZM1,DZTM1,ZGM1(1,3),lz1,lz1)
C
C     Gauss Legendre mesh (suffix M2)
C     Generate collocation points and weights
C
      IF(IFSPLIT)THEN
         CALL ZWGLL (ZGM2(1,1),WXM2,lx2)
         CALL ZWGLL (ZGM2(1,2),WYM2,ly2)
         CALL ZWGLL (ZGM2(1,3),WZM2,lz2)
      ELSE
         CALL ZWGL  (ZGM2(1,1),WXM2,lx2)
         CALL ZWGL  (ZGM2(1,2),WYM2,ly2)
         CALL ZWGL  (ZGM2(1,3),WZM2,lz2)
      ENDIF
      DO 800 IZ=1,lz2
      DO 800 IY=1,ly2
      DO 800 IX=1,lx2
      W3M2(IX,IY,IZ)=WXM2(IX)*WYM2(IY)*WZM2(IZ)
  800 CONTINUE
C
C     Gauss-Loabtto Legendre mesh (suffix M3).
C     Generate collocation points and weights.
C
      CALL ZWGLL (ZGM3(1,1),WXM3,lx3)
      CALL ZWGLL (ZGM3(1,2),WYM3,ly3)
      CALL ZWGLL (ZGM3(1,3),WZM3,lz3)
      DO 900 IZ=1,lz3
      DO 900 IY=1,ly3
      DO 900 IX=1,lx3
      W3M3(IX,IY,IZ)=WXM3(IX)*WYM3(IY)*WZM3(IZ)
  900 CONTINUE
C
C     Compute derivative matrices
C
      CALL DGLL (DXM3,DXTM3,ZGM3(1,1),lx3,lx3)
      CALL DGLL (DYM3,DYTM3,ZGM3(1,2),ly3,ly3)
      CALL DGLL (DZM3,DZTM3,ZGM3(1,3),lz3,lz3)
C
C     Generate interpolation operators for the staggered mesh
C
      CALL IGLLM (IXM12,IXTM12,ZGM1(1,1),ZGM2(1,1),lx1,lx2,lx1,lx2)
      CALL IGLLM (IYM12,IYTM12,ZGM1(1,2),ZGM2(1,2),ly1,ly2,ly1,ly2)
      CALL IGLLM (IZM12,IZTM12,ZGM1(1,3),ZGM2(1,3),lz1,lz2,lz1,lz2)
C
C     NOTE: The splitting scheme has only one mesh!!!!!
C
      IF (IFSPLIT) THEN
         CALL IGLLM (IXM21,IXTM21,ZGM1(1,1),ZGM2(1,1),lx1,lx2,lx1,lx2)
         CALL IGLLM (IYM21,IYTM21,ZGM1(1,2),ZGM2(1,2),ly1,ly2,ly1,ly2)
         CALL IGLLM (IZM21,IZTM21,ZGM1(1,3),ZGM2(1,3),lz1,lz2,lz1,lz2)
      ELSE
         CALL IGLM  (IXM21,IXTM21,ZGM2(1,1),ZGM1(1,1),lx2,lx1,lx2,lx1)
         CALL IGLM  (IYM21,IYTM21,ZGM2(1,2),ZGM1(1,2),ly2,ly1,ly2,ly1)
         CALL IGLM  (IZM21,IZTM21,ZGM2(1,3),ZGM1(1,3),lz2,lz1,lz2,lz1)
      ENDIF
C
C     Compute derivative operators for the staggered mesh
C
      IF(IFSPLIT)THEN
         CALL COPY (DXM12, DXM1, lx1*lx2)
         CALL COPY (DXTM12,DXTM1,lx1*lx2)
         CALL COPY (DYM12, DYM1, ly1*ly2)
         CALL COPY (DYTM12,DYTM1,ly1*ly2)
         CALL COPY (DZM12, DZM1, lz1*lz2)
         CALL COPY (DZTM12,DZTM1,lz1*lz2)
      ELSE
         CALL DGLLGL (DXM12,DXTM12,ZGM1(1,1),ZGM2(1,1),IXM12,
     $                                       lx1,lx2,lx1,lx2)
         CALL DGLLGL (DYM12,DYTM12,ZGM1(1,2),ZGM2(1,2),IYM12,
     $                                       ly1,ly2,ly1,ly2)
         CALL DGLLGL (DZM12,DZTM12,ZGM1(1,3),ZGM2(1,3),IZM12,
     $                                       lz1,lz2,lz1,lz2)
      ENDIF
C
C     Compute interpolation operators for the geometry mesh M3.
C
      CALL IGLLM (IXM13,IXTM13,ZGM1(1,1),ZGM3(1,1),lx1,lx3,lx1,lx3)
      CALL IGLLM (IYM13,IYTM13,ZGM1(1,2),ZGM3(1,2),ly1,ly3,ly1,ly3)
      CALL IGLLM (IZM13,IZTM13,ZGM1(1,3),ZGM3(1,3),lz1,lz3,lz1,lz3)
      CALL IGLLM (IXM31,IXTM31,ZGM3(1,1),ZGM1(1,1),lx3,lx1,lx3,lx1)
      CALL IGLLM (IYM31,IYTM31,ZGM3(1,2),ZGM1(1,2),ly3,ly1,ly3,ly1)
      CALL IGLLM (IZM31,IZTM31,ZGM3(1,3),ZGM1(1,3),lz3,lz1,lz3,lz1)
C
      ENDIF
C
      RETURN
      END
      subroutine geom1 (xm3,ym3,zm3)
C-----------------------------------------------------------------------
C
C     Routine to generate all elemental geometric data for mesh 1.
C
C     Velocity formulation : global-to-local mapping based on mesh 3
C     Stress   formulation : global-to-local mapping based on mesh 1
C
C-----------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'INPUT'
      INCLUDE 'TSTEP'
C
C     Note : XM3,YM3,ZM3 should come from COMMON /SCRUZ/.
C
      DIMENSION XM3(LX3,LY3,LZ3,1)
     $        , YM3(LX3,LY3,LZ3,1)
     $        , ZM3(LX3,LY3,LZ3,1)
C
      IF (IFGMSH3 .AND. ISTEP.EQ.0) THEN
         CALL GLMAPM3 (XM3,YM3,ZM3)
      ELSE
         CALL GLMAPM1
      ENDIF
C
      CALL GEODAT1
C
      RETURN
      END
      subroutine glmapm3 (xm3,ym3,zm3)
C-------------------------------------------------------------------
C
C     Routine to generate mapping data based on mesh 3
C     (Gauss-Legendre Lobatto meshes).
C
C         XRM3,  YRM3,  ZRM3   -   dx/dr, dy/dr, dz/dr
C         XSM3,  YSM3,  ZSM3   -   dx/ds, dy/ds, dz/ds
C         XTM3,  YTM3,  ZTM3   -   dx/dt, dy/dt, dz/dt
C         RXM3,  RYM3,  RZM3   -   dr/dx, dr/dy, dr/dz
C         SXM3,  SYM3,  SZM3   -   ds/dx, ds/dy, ds/dz
C         TXM3,  TYM3,  TZM3   -   dt/dx, dt/dy, dt/dz
C         JACM3                -   Jacobian
C
C------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'TOTAL'
C
C     Note : work arrays for mesh 3 in scratch commons will be 
C            changed after exit of routine.
C
      COMMON /SCRNS/ XRM3 (LX3,LY3,LZ3,LELT)
     $ ,             XSM3 (LX3,LY3,LZ3,LELT)
     $ ,             XTM3 (LX3,LY3,LZ3,LELT)
     $ ,             YRM3 (LX3,LY3,LZ3,LELT)
     $ ,             YSM3 (LX3,LY3,LZ3,LELT)
     $ ,             YTM3 (LX3,LY3,LZ3,LELT)
     $ ,             ZRM3 (LX3,LY3,LZ3,LELT)
      COMMON /CTMP0/ ZSM3 (LX3,LY3,LZ3,LELT)
     $ ,             ZTM3 (LX3,LY3,LZ3,LELT)
      COMMON /CTMP1/ RXM3 (LX3,LY3,LZ3,LELT)
     $ ,             RYM3 (LX3,LY3,LZ3,LELT)
     $ ,             RZM3 (LX3,LY3,LZ3,LELT)
     $ ,             SXM3 (LX3,LY3,LZ3,LELT)
      COMMON /SCRMG/ SYM3 (LX3,LY3,LZ3,LELT)
     $ ,             SZM3 (LX3,LY3,LZ3,LELT)
     $ ,             TXM3 (LX3,LY3,LZ3,LELT)
     $ ,             TYM3 (LX3,LY3,LZ3,LELT)
      COMMON /SCREV/ TZM3 (LX3,LY3,LZ3,LELT)
     $ ,             JACM3(LX3,LY3,LZ3,LELT)
      REAL           JACM3
      DIMENSION XM3(LX3,LY3,LZ3,1)
     $        , YM3(LX3,LY3,LZ3,1)
     $        , ZM3(LX3,LY3,LZ3,1)
C
C
      NXY3  = lx3*ly3
      NYZ3  = ly3*lz3
      NXYZ3 = lx3*ly3*lz3
      NTOT3 = NXYZ3*NELT
      NXYZ1 = lx1*ly1*lz1
      NTOT1 = NXYZ1*NELT
C
C
C     Compute isoparametric partials.
C

      IF (ldim.EQ.2) THEN
C
C     Two-dimensional case
C
      DO 200 IEL=1,NELT
C
C     Use the appropriate derivative- and interpolation operator in
C     the y-direction (= radial direction if axisymmetric).
C
      IF (IFAXIS) THEN
         ly33   = ly3*ly3
         IF (IFRZER(IEL)) THEN
            CALL COPY (DYTM3,DATM3,ly33)
         ELSE
            CALL COPY (DYTM3,DCTM3,ly33)
         ENDIF
      ENDIF
C
      CALL MXM(DXM3,lx3,XM3(1,1,1,IEL),lx3,XRM3(1,1,1,IEL),ly3)
      CALL MXM(DXM3,lx3,YM3(1,1,1,IEL),lx3,YRM3(1,1,1,IEL),ly3)
      CALL MXM(XM3(1,1,1,IEL),lx3,DYTM3,ly3,XSM3(1,1,1,IEL),ly3)
      CALL MXM(YM3(1,1,1,IEL),lx3,DYTM3,ly3,YSM3(1,1,1,IEL),ly3)
C
 200  CONTINUE
C
      CALL RZERO   (JACM3,NTOT3)
      CALL ADDCOL3 (JACM3,XRM3,YSM3,NTOT3)
      CALL SUBCOL3 (JACM3,XSM3,YRM3,NTOT3)
C
      CALL COPY    (RXM3,YSM3,NTOT3)
      CALL COPY    (RYM3,XSM3,NTOT3)
      CALL CHSIGN  (RYM3,NTOT3)
      CALL COPY    (SXM3,YRM3,NTOT3)
      CALL CHSIGN  (SXM3,NTOT3)
      CALL COPY    (SYM3,XRM3,NTOT3)
C
      ELSE
C
C     Three-dimensional case
C
      DO 300 IEL=1,NELT
C
      CALL MXM(DXM3,lx3,XM3(1,1,1,IEL),lx3,XRM3(1,1,1,IEL),NYZ3)
      CALL MXM(DXM3,lx3,YM3(1,1,1,IEL),lx3,YRM3(1,1,1,IEL),NYZ3)
      CALL MXM(DXM3,lx3,ZM3(1,1,1,IEL),lx3,ZRM3(1,1,1,IEL),NYZ3)
C
      DO 310 IZ=1,lz3
      CALL MXM(XM3(1,1,IZ,IEL),lx3,DYTM3,ly3,XSM3(1,1,IZ,IEL),ly3)
      CALL MXM(YM3(1,1,IZ,IEL),lx3,DYTM3,ly3,YSM3(1,1,IZ,IEL),ly3)
      CALL MXM(ZM3(1,1,IZ,IEL),lx3,DYTM3,ly3,ZSM3(1,1,IZ,IEL),ly3)
 310  CONTINUE
C
      CALL MXM(XM3(1,1,1,IEL),NXY3,DZTM3,lz3,XTM3(1,1,1,IEL),lz3)
      CALL MXM(YM3(1,1,1,IEL),NXY3,DZTM3,lz3,YTM3(1,1,1,IEL),lz3)
      CALL MXM(ZM3(1,1,1,IEL),NXY3,DZTM3,lz3,ZTM3(1,1,1,IEL),lz3)
C
 300  CONTINUE
C
      CALL RZERO   (JACM3,NTOT3)
      CALL ADDCOL4 (JACM3,XRM3,YSM3,ZTM3,NTOT3)
      CALL ADDCOL4 (JACM3,XTM3,YRM3,ZSM3,NTOT3)
      CALL ADDCOL4 (JACM3,XSM3,YTM3,ZRM3,NTOT3)
      CALL SUBCOL4 (JACM3,XRM3,YTM3,ZSM3,NTOT3)
      CALL SUBCOL4 (JACM3,XSM3,YRM3,ZTM3,NTOT3)
      CALL SUBCOL4 (JACM3,XTM3,YSM3,ZRM3,NTOT3)
C
      CALL ASCOL5  (RXM3,YSM3,ZTM3,YTM3,ZSM3,NTOT3)
      CALL ASCOL5  (RYM3,XTM3,ZSM3,XSM3,ZTM3,NTOT3)
      CALL ASCOL5  (RZM3,XSM3,YTM3,XTM3,YSM3,NTOT3)
      CALL ASCOL5  (SXM3,YTM3,ZRM3,YRM3,ZTM3,NTOT3)
      CALL ASCOL5  (SYM3,XRM3,ZTM3,XTM3,ZRM3,NTOT3)
      CALL ASCOL5  (SZM3,XTM3,YRM3,XRM3,YTM3,NTOT3)
      CALL ASCOL5  (TXM3,YRM3,ZSM3,YSM3,ZRM3,NTOT3)
      CALL ASCOL5  (TYM3,XSM3,ZRM3,XRM3,ZSM3,NTOT3)
      CALL ASCOL5  (TZM3,XRM3,YSM3,XSM3,YRM3,NTOT3)
C
      ENDIF
C
C     Mapping from space P(n-2) to space P(n) (mesh M3 to mesh M1).
C
      IF (ldim.EQ.2) THEN
         CALL RZERO (RZM1,NTOT1)
         CALL RZERO (SZM1,NTOT1)
         CALL RONE  (TZM1,NTOT1)
      ENDIF
C
      kerr = 0
      DO 400 ie=1,NELT

c        write(6,*) 'chkj1'
c        call outxm3j(xm3,ym3,jacm3)

         CALL CHKJAC(JACM3(1,1,1,ie),NXYZ3,ie,xm3(1,1,1,ie),
     $ ym3(1,1,1,ie),zm3(1,1,1,ie),ldim,ierr)
         if (ierr.eq.1) kerr = kerr+1
         CALL MAP31 (RXM1(1,1,1,ie),RXM3(1,1,1,ie),ie)
         CALL MAP31 (RYM1(1,1,1,ie),RYM3(1,1,1,ie),ie)
         CALL MAP31 (SXM1(1,1,1,ie),SXM3(1,1,1,ie),ie)
         CALL MAP31 (SYM1(1,1,1,ie),SYM3(1,1,1,ie),ie)
         IF (ldim.EQ.3) THEN
            CALL MAP31 (RZM1(1,1,1,ie),RZM3(1,1,1,ie),ie)
            CALL MAP31 (SZM1(1,1,1,ie),SZM3(1,1,1,ie),ie)
            CALL MAP31 (TXM1(1,1,1,ie),TXM3(1,1,1,ie),ie)
            CALL MAP31 (TYM1(1,1,1,ie),TYM3(1,1,1,ie),ie)
            CALL MAP31 (TZM1(1,1,1,ie),TZM3(1,1,1,ie),ie)
         ENDIF
         CALL MAP31 (JACM1(1,1,1,ie),JACM3(1,1,1,ie),ie)
         CALL MAP31 (XM1(1,1,1,ie),XM3(1,1,1,ie),ie)
         CALL MAP31 (YM1(1,1,1,ie),YM3(1,1,1,ie),ie)
         CALL MAP31 (ZM1(1,1,1,ie),ZM3(1,1,1,ie),ie)
 400  CONTINUE
      kerr = iglsum(kerr,1)
      if (kerr.gt.0) then
         ifxyo = .true.
         ifvo  = .false.
         ifpo  = .false.
         ifto  = .false.
         param(66) = 4
         call outpost(vx,vy,vz,pr,t,'xyz')
         if (nid.eq.0) write(6,*) 'Jac error 3, setting p66=4, ifxyo=t'
         call exitt
      endif

      call invers2(jacmi,jacm1,ntot1)

      RETURN
      END
      subroutine glmapm1
C-----------------------------------------------------------------------
C
C     Routine to generate mapping data based on mesh 1
C     (Gauss-Legendre Lobatto meshes).
C
C         XRM1,  YRM1,  ZRM1   -   dx/dr, dy/dr, dz/dr
C         XSM1,  YSM1,  ZSM1   -   dx/ds, dy/ds, dz/ds
C         XTM1,  YTM1,  ZTM1   -   dx/dt, dy/dt, dz/dt
C         RXM1,  RYM1,  RZM1   -   dr/dx, dr/dy, dr/dz
C         SXM1,  SYM1,  SZM1   -   ds/dx, ds/dy, ds/dz
C         TXM1,  TYM1,  TZM1   -   dt/dx, dt/dy, dt/dz
C         JACM1                -   Jacobian
C
C-----------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'INPUT'
      INCLUDE 'SOLN'
C
C     Note: Subroutines GLMAPM1, GEODAT1, AREA2, SETWGTR and AREA3 
C           share the same array structure in Scratch Common /SCRNS/.
C
      COMMON /SCRNS/ XRM1(LX1,LY1,LZ1,LELT)
     $ ,             YRM1(LX1,LY1,LZ1,LELT)
     $ ,             XSM1(LX1,LY1,LZ1,LELT)
     $ ,             YSM1(LX1,LY1,LZ1,LELT)
     $ ,             XTM1(LX1,LY1,LZ1,LELT)
     $ ,             YTM1(LX1,LY1,LZ1,LELT)
     $ ,             ZRM1(LX1,LY1,LZ1,LELT)
      COMMON /CTMP1/ ZSM1(LX1,LY1,LZ1,LELT)
     $ ,             ZTM1(LX1,LY1,LZ1,LELT)
C
      NXY1  = lx1*ly1
      NYZ1  = ly1*lz1
      NXYZ1 = lx1*ly1*lz1
      NTOT1 = NXYZ1*NELT
C
      CALL XYZRST (XRM1,YRM1,ZRM1,XSM1,YSM1,ZSM1,XTM1,YTM1,ZTM1,
     $             IFAXIS)
C
      IF (ldim.EQ.2) THEN
         CALL RZERO   (JACM1,NTOT1)
         CALL ADDCOL3 (JACM1,XRM1,YSM1,NTOT1)
         CALL SUBCOL3 (JACM1,XSM1,YRM1,NTOT1)
         CALL COPY    (RXM1,YSM1,NTOT1)
         CALL COPY    (RYM1,XSM1,NTOT1)
         CALL CHSIGN  (RYM1,NTOT1)
         CALL COPY    (SXM1,YRM1,NTOT1)
         CALL CHSIGN  (SXM1,NTOT1)
         CALL COPY    (SYM1,XRM1,NTOT1)
         CALL RZERO   (RZM1,NTOT1)
         CALL RZERO   (SZM1,NTOT1)
         CALL RONE    (TZM1,NTOT1)
      ELSE
         CALL RZERO   (JACM1,NTOT1)
         CALL ADDCOL4 (JACM1,XRM1,YSM1,ZTM1,NTOT1)
         CALL ADDCOL4 (JACM1,XTM1,YRM1,ZSM1,NTOT1)
         CALL ADDCOL4 (JACM1,XSM1,YTM1,ZRM1,NTOT1)
         CALL SUBCOL4 (JACM1,XRM1,YTM1,ZSM1,NTOT1)
         CALL SUBCOL4 (JACM1,XSM1,YRM1,ZTM1,NTOT1)
         CALL SUBCOL4 (JACM1,XTM1,YSM1,ZRM1,NTOT1)
         CALL ASCOL5  (RXM1,YSM1,ZTM1,YTM1,ZSM1,NTOT1)
         CALL ASCOL5  (RYM1,XTM1,ZSM1,XSM1,ZTM1,NTOT1)
         CALL ASCOL5  (RZM1,XSM1,YTM1,XTM1,YSM1,NTOT1)
         CALL ASCOL5  (SXM1,YTM1,ZRM1,YRM1,ZTM1,NTOT1)
         CALL ASCOL5  (SYM1,XRM1,ZTM1,XTM1,ZRM1,NTOT1)
         CALL ASCOL5  (SZM1,XTM1,YRM1,XRM1,YTM1,NTOT1)
         CALL ASCOL5  (TXM1,YRM1,ZSM1,YSM1,ZRM1,NTOT1)
         CALL ASCOL5  (TYM1,XSM1,ZRM1,XRM1,ZSM1,NTOT1)
         CALL ASCOL5  (TZM1,XRM1,YSM1,XSM1,YRM1,NTOT1)
      ENDIF
C
      kerr = 0
      DO 500 ie=1,NELT
         CALL CHKJAC(JACM1(1,1,1,ie),NXYZ1,ie,xm1(1,1,1,ie),
     $ ym1(1,1,1,ie),zm1(1,1,1,ie),ldim,ierr)
         if (ierr.ne.0) kerr = kerr+1
  500 CONTINUE
      kerr = iglsum(kerr,1)
      if (kerr.gt.0) then
         ifxyo = .true.
         ifvo  = .false.
         ifpo  = .false.
         ifto  = .false.
         param(66) = 4
         call outpost(vx,vy,vz,pr,t,'xyz')
         if (nid.eq.0) write(6,*) 'Jac error 1, setting p66=4, ifxyo=t'
         call exitt
      endif

      call invers2(jacmi,jacm1,ntot1)

      RETURN
      END
      subroutine geodat1
C-----------------------------------------------------------------------
C
C     Routine to generate elemental geometric matrices on mesh 1
C     (Gauss-Legendre Lobatto mesh).
C
C-----------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'INPUT'
      INCLUDE 'MASS'
      INCLUDE 'TSTEP'
      INCLUDE 'WZ'
C
C     Note: Subroutines GLMAPM1, GEODAT1, AREA2, SETWGTR and AREA3 
C           share the same array structure in Scratch Common /SCRNS/.
C
      COMMON /SCRNS/ XRM1(LX1,LY1,LZ1,LELT)
     $ ,             YRM1(LX1,LY1,LZ1,LELT)
     $ ,             XSM1(LX1,LY1,LZ1,LELT)
     $ ,             YSM1(LX1,LY1,LZ1,LELT)
     $ ,             XTM1(LX1,LY1,LZ1,LELT)
     $ ,             YTM1(LX1,LY1,LZ1,LELT)
     $ ,             ZRM1(LX1,LY1,LZ1,LELT)
      COMMON /CTMP1/ ZSM1(LX1,LY1,LZ1,LELT)
     $ ,             ZTM1(LX1,LY1,LZ1,LELT)
     $ ,             WJ   (LX1,LY1,LZ1,LELT)
C
      NXYZ1 = lx1*ly1*lz1
      NTOT1 = NXYZ1*NELT
C
      IF (IFGMSH3 .AND. ISTEP.EQ.0)
     $   CALL XYZRST (XRM1,YRM1,ZRM1,XSM1,YSM1,ZSM1,XTM1,YTM1,ZTM1,
     $                IFAXIS)
C
      IF (.NOT.IFAXIS) THEN
         CALL INVERS2 (WJ,JACM1,NTOT1)
      ELSE
         DO 500 IEL=1,NELT
           IF (IFRZER(IEL)) THEN
              DO 510 J=1,ly1
              DO 510 I=1,lx1
                IF (J.GT.1) THEN
                   WJ(I,J,1,IEL) = YM1(I,J,1,IEL)/
     $                            (JACM1(I,J,1,IEL)*(1.+ZAM1(J)))
                ELSE
                   WJ(I,J,1,IEL) = YSM1(I,J,1,IEL)/JACM1(I,J,1,IEL)
                ENDIF
 510          CONTINUE
           ELSE
              CALL INVCOL3 (WJ(1,1,1,IEL),YM1(1,1,1,IEL),
     $                      JACM1(1,1,1,IEL),NXYZ1)
           ENDIF
 500     CONTINUE
      ENDIF
C
C     Compute geometric factors for integrated del-squared operator.
C
      IF (ldim.EQ.2) THEN
         CALL VDOT2 (G1M1,RXM1,RYM1,RXM1,RYM1,NTOT1)
         CALL VDOT2 (G2M1,SXM1,SYM1,SXM1,SYM1,NTOT1)
         CALL VDOT2 (G4M1,RXM1,RYM1,SXM1,SYM1,NTOT1)
         CALL COL2  (G1M1,WJ,NTOT1)
         CALL COL2  (G2M1,WJ,NTOT1)
         CALL COL2  (G4M1,WJ,NTOT1)
         CALL RZERO (G3M1,NTOT1)
         CALL RZERO (G5M1,NTOT1)
         CALL RZERO (G6M1,NTOT1)
      ELSE
         CALL VDOT3 (G1M1,RXM1,RYM1,RZM1,RXM1,RYM1,RZM1,NTOT1)
         CALL VDOT3 (G2M1,SXM1,SYM1,SZM1,SXM1,SYM1,SZM1,NTOT1)
         CALL VDOT3 (G3M1,TXM1,TYM1,TZM1,TXM1,TYM1,TZM1,NTOT1)
         CALL VDOT3 (G4M1,RXM1,RYM1,RZM1,SXM1,SYM1,SZM1,NTOT1)
         CALL VDOT3 (G5M1,RXM1,RYM1,RZM1,TXM1,TYM1,TZM1,NTOT1)
         CALL VDOT3 (G6M1,SXM1,SYM1,SZM1,TXM1,TYM1,TZM1,NTOT1)
         CALL COL2  (G1M1,WJ,NTOT1)
         CALL COL2  (G2M1,WJ,NTOT1)
         CALL COL2  (G3M1,WJ,NTOT1)
         CALL COL2  (G4M1,WJ,NTOT1)
         CALL COL2  (G5M1,WJ,NTOT1)
         CALL COL2  (G6M1,WJ,NTOT1)
      ENDIF
C
C     Multiply the geometric factors GiM1,i=1,5 with the
C     weights on mesh M1.
C
      DO 580 IEL=1,NELT
         IF (IFAXIS) CALL SETAXW1 ( IFRZER(IEL) )
            CALL COL2 (G1M1(1,1,1,IEL),W3M1,NXYZ1)
            CALL COL2 (G2M1(1,1,1,IEL),W3M1,NXYZ1)
            CALL COL2 (G4M1(1,1,1,IEL),W3M1,NXYZ1)
         IF (ldim.EQ.3) THEN
            CALL COL2 (G3M1(1,1,1,IEL),W3M1,NXYZ1)
            CALL COL2 (G5M1(1,1,1,IEL),W3M1,NXYZ1)
            CALL COL2 (G6M1(1,1,1,IEL),W3M1,NXYZ1)
         ENDIF
  580 CONTINUE
C
C     Compute the mass matrix on mesh M1.
C
      DO 700 IEL=1,NELT
         IF (IFAXIS) CALL SETAXW1 ( IFRZER(IEL) )
            CALL COL3 (BM1  (1,1,1,IEL),JACM1(1,1,1,IEL),W3M1,NXYZ1)
         IF (IFAXIS) THEN 
             CALL COL3(BAXM1(1,1,1,IEL),JACM1(1,1,1,IEL),W3M1,NXYZ1)
          IF (IFRZER(IEL)) THEN
            DO 600 J=1,ly1
            IF (J.GT.1) THEN
               DO 610 I=1,lx1
                  BM1(I,J,1,IEL) = BM1(I,J,1,IEL)*YM1(I,J,1,IEL)
     $                                           /(1.+ZAM1(J))
                  BAXM1(I,J,1,IEL)=BAXM1(I,J,1,IEL)/(1.+ZAM1(J))
 610           CONTINUE
            ELSE
               DO 620 I=1,lx1
                  BM1(I,J,1,IEL) = BM1(I,J,1,IEL)*YSM1(I,J,1,IEL)
                  BAXM1(I,J,1,IEL)=BAXM1(I,J,1,IEL)
 620           CONTINUE
            ENDIF
 600        CONTINUE
          ELSE
            CALL COL2 (BM1(1,1,1,IEL),YM1(1,1,1,IEL),NXYZ1)
          ENDIF
         ENDIF
C
 700  CONTINUE

      IF(IFAXIS) THEN
        DO IEL=1,NELT
          IF(IFRZER(IEL)) THEN
            DO J=1,ly1
            DO I=1,lx1
              IF(J.EQ.1) THEN
                 YINVM1(I,J,1,IEL)=1.0D0/YSM1(I,J,1,IEL)
              ELSE
                 YINVM1(I,J,1,IEL)=1.0D0/YM1 (I,J,1,IEL)
              ENDIF
            ENDDO 
            ENDDO 
          ELSE
            CALL INVERS2(YINVM1(1,1,1,IEL),YM1(1,1,1,IEL),NXYZ1)
          ENDIF
        ENDDO
      ELSE
        CALL CFILL(YINVM1,1.0D0,NXYZ1*NELT)
      ENDIF
C
C     Compute normals, tangents, and areas on elemental surfaces
C
      CALL SETAREA
C
      RETURN
      END
      subroutine geom2
C-------------------------------------------------------------------
C
C     Routine to generate all elemental geometric data for mesh 2
C     (Gauss-Legendre mesh).
C
C         RXM2,  RYM2,  RZM2   -   dr/dx, dr/dy, dr/dz
C         SXM2,  SYM2,  SZM2   -   ds/dx, ds/dy, ds/dz
C         TXM2,  TYM2,  TZM2   -   dt/dx, dt/dy, dt/dz
C         JACM2                -   Jacobian
C         BM2                  -   Mass matrix
C
C------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'TOTAL'
C
      NXYZ2 = lx2*ly2*lz2
      NTOT2 = NXYZ2*NELV
C
      IF (IFSPLIT) THEN
C
C        Mesh 1 and 2 are identical
C
         CALL COPY (RXM2,RXM1,NTOT2)
         CALL COPY (RYM2,RYM1,NTOT2)
         CALL COPY (RZM2,RZM1,NTOT2)
         CALL COPY (SXM2,SXM1,NTOT2)
         CALL COPY (SYM2,SYM1,NTOT2)
         CALL COPY (SZM2,SZM1,NTOT2)
         CALL COPY (TXM2,TXM1,NTOT2)
         CALL COPY (TYM2,TYM1,NTOT2)
         CALL COPY (TZM2,TZM1,NTOT2)
         CALL COPY (JACM2,JACM1,NTOT2)
         CALL COPY (BM2,BM1,NTOT2)

         CALL COPY (XM2,XM1,NTOT2)
         CALL COPY (YM2,YM1,NTOT2)
         CALL COPY (ZM2,ZM1,NTOT2)

      ELSE
C
C     Consistent approximation spaces (UZAWA)
C
         IF (ldim.EQ.2) THEN
            CALL RZERO (RZM2,NTOT2)
            CALL RZERO (SZM2,NTOT2)
            CALL RONE  (TZM2,NTOT2)
         ENDIF
C
         DO 1000 IEL=1,NELV
C
C        Mapping from mesh M1 to mesh M2
C
         CALL MAP12 (RXM2(1,1,1,IEL),RXM1(1,1,1,IEL),IEL)
         CALL MAP12 (RYM2(1,1,1,IEL),RYM1(1,1,1,IEL),IEL)
         CALL MAP12 (SXM2(1,1,1,IEL),SXM1(1,1,1,IEL),IEL)
         CALL MAP12 (SYM2(1,1,1,IEL),SYM1(1,1,1,IEL),IEL)
         IF (ldim.EQ.3) THEN
            CALL MAP12 (RZM2(1,1,1,IEL),RZM1(1,1,1,IEL),IEL)
            CALL MAP12 (SZM2(1,1,1,IEL),SZM1(1,1,1,IEL),IEL)
            CALL MAP12 (TXM2(1,1,1,IEL),TXM1(1,1,1,IEL),IEL)
            CALL MAP12 (TYM2(1,1,1,IEL),TYM1(1,1,1,IEL),IEL)
            CALL MAP12 (TZM2(1,1,1,IEL),TZM1(1,1,1,IEL),IEL)
         ENDIF
         CALL MAP12 (JACM2(1,1,1,IEL),JACM1(1,1,1,IEL),IEL)
C
         CALL MAP12 (XM2(1,1,1,IEL),XM1(1,1,1,IEL),IEL)
         CALL MAP12 (YM2(1,1,1,IEL),YM1(1,1,1,IEL),IEL)
         CALL MAP12 (ZM2(1,1,1,IEL),ZM1(1,1,1,IEL),IEL)
C
C        Compute the mass matrix on mesh M2.
C
         IF (IFAXIS) CALL SETAXW2 ( IFRZER(IEL) )
         CALL COL3 (BM2(1,1,1,IEL),W3M2,JACM2(1,1,1,IEL),NXYZ2)
C
         IF (IFAXIS.AND.IFRZER(IEL)) THEN
            DO 300 J=1,ly2
            DO 300 I=1,lx2
               BM2(I,J,1,IEL) = BM2(I,J,1,IEL)*YM2(I,J,1,IEL)
     $                                        /(1.+ZAM2(J))
 300        CONTINUE
         ELSEIF (IFAXIS.AND.(.NOT.IFRZER(IEL))) THEN
            CALL COL2 (BM2(1,1,1,IEL),YM2(1,1,1,IEL),NXYZ2)
         ENDIF
 1000    CONTINUE
C
      ENDIF
C
C     Compute inverse of mesh 2 mass matrix, pff 3/5/92
      CALL INVERS2(BM2INV,BM2,NTOT2)
C
      RETURN
      END
      subroutine xyzrst (xrm1,yrm1,zrm1,xsm1,ysm1,zsm1,
     $                   XTM1,YTM1,ZTM1,IFAXIS)
C-----------------------------------------------------------------------
C
C     Compute global-to-local derivatives on mesh 1.
C
C-----------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'DXYZ'
C
      DIMENSION XRM1(LX1,LY1,LZ1,1),YRM1(LX1,LY1,LZ1,1)
     $        , ZRM1(LX1,LY1,LZ1,1),XSM1(LX1,LY1,LZ1,1)
     $        , YSM1(LX1,LY1,LZ1,1),ZSM1(LX1,LY1,LZ1,1)
     $        , XTM1(LX1,LY1,LZ1,1),YTM1(LX1,LY1,LZ1,1)
     $        , ZTM1(LX1,LY1,LZ1,1)
      LOGICAL IFAXIS
C
      NXY1=lx1*ly1
      NYZ1=ly1*lz1
C
      DO 100 IEL=1,NELT
C
      IF (IFAXIS) CALL SETAXDY ( IFRZER(IEL) )
C
      CALL MXM (DXM1,lx1,XM1(1,1,1,IEL),lx1,XRM1(1,1,1,IEL),NYZ1)
      CALL MXM (DXM1,lx1,YM1(1,1,1,IEL),lx1,YRM1(1,1,1,IEL),NYZ1)
      CALL MXM (DXM1,lx1,ZM1(1,1,1,IEL),lx1,ZRM1(1,1,1,IEL),NYZ1)
C
      DO 10 IZ=1,lz1
      CALL MXM (XM1(1,1,IZ,IEL),lx1,DYTM1,ly1,XSM1(1,1,IZ,IEL),ly1)
      CALL MXM (YM1(1,1,IZ,IEL),lx1,DYTM1,ly1,YSM1(1,1,IZ,IEL),ly1)
      CALL MXM (ZM1(1,1,IZ,IEL),lx1,DYTM1,ly1,ZSM1(1,1,IZ,IEL),ly1)
   10 CONTINUE
C
      IF (ldim.EQ.3) THEN
         CALL MXM (XM1(1,1,1,IEL),NXY1,DZTM1,lz1,XTM1(1,1,1,IEL),lz1)
         CALL MXM (YM1(1,1,1,IEL),NXY1,DZTM1,lz1,YTM1(1,1,1,IEL),lz1)
         CALL MXM (ZM1(1,1,1,IEL),NXY1,DZTM1,lz1,ZTM1(1,1,1,IEL),lz1)
      ELSE
         CALL RZERO (XTM1(1,1,1,IEL),NXY1)
         CALL RZERO (YTM1(1,1,1,IEL),NXY1)
         CALL RONE  (ZTM1(1,1,1,IEL),NXY1)
      ENDIF
C
  100 CONTINUE
C
      RETURN
      END
      subroutine chkjac(jac,n,iel,X,Y,Z,ND,IERR)
c
      include 'SIZE'
      include 'PARALLEL'
C
C     Check the array JAC for a change in sign.
C
      REAL JAC(N),x(1),y(1),z(1)
c
      ierr = 1
      SIGN = JAC(1)
      DO 100 I=2,N
         IF (SIGN*JAC(I).LE.0.0) THEN
            ieg = lglel(iel)
            WRITE(6,101) nid,I,ieg
            write(6,*) jac(i-1),jac(i)
            if (ldim.eq.3) then
               write(6,7) nid,x(i-1),y(i-1),z(i-1)
               write(6,7) nid,x(i),y(i),z(i)
            else
               write(6,7) nid,x(i-1),y(i-1)
               write(6,7) nid,x(i),y(i)
            endif
    7       format(i5,' xyz:',1p3e14.5)
c           if (np.eq.1) call out_xyz_el(x,y,z,iel)
c           ierr=0
            return
         ENDIF
  100 CONTINUE
  101 FORMAT(//,i5,2x
     $ ,'ERROR:  Vanishing Jacobian near',i7,'th node of element'
     $ ,I10,'.')
c
c
      ierr = 0
      RETURN
      END
c-----------------------------------------------------------------------
      subroutine volume
C
C     Compute the volume based on mesh M1 and mesh M2
C

      include 'SIZE'
      include 'ESOLV'
      include 'INPUT'
      include 'MASS'
      include 'TSTEP'
      integer e
C
      volvm1=glsum(bm1,lx1*ly1*lz1*nelv)
      volvm2=glsum(bm2,lx2*ly2*lz2*nelv)
      voltm1=glsum(bm1,lx1*ly1*lz1*nelt)
      voltm2=glsum(bm2,lx2*ly2*lz2*nelt)
      mfield=1
      if (ifmvbd) mfield=0
      nfldt = nfield
      if (ifmhd) nfldt = nfield+1

      do ifld=mfield,nfldt
         if (iftmsh(ifld)) then
             volfld(ifld) = voltm1
         else
             volfld(ifld) = volvm1
         endif
      enddo

c      if (nio.eq.0) write(6,*) 'vol_t,vol_v:',voltm1,volvm1


      nxyz = lx1*ly1*lz1
      do e=1,nelt
         volel(e) = vlsum(bm1(1,1,1,e),nxyz)
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine setarea
C
C     Compute surface data: areas, normals and tangents
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'INPUT'
C
      NSRF  = 6*lx1*lz1*NELT
C
      CALL RZERO  (AREA,NSRF)
      CALL RZERO3 (UNX,UNY,UNZ,NSRF)
      CALL RZERO3 (T1X,T1Y,T1Z,NSRF)      
      CALL RZERO3 (T2X,T2Y,T2Z,NSRF)      
C
      IF (ldim.EQ.2) THEN
         CALL AREA2
      ELSE
         CALL AREA3
      ENDIF
C
      RETURN
      END
      subroutine area2
C--------------------------------------------------------------------
C
C     Compute areas, normals and tangents (2D and Axisymmetric geom.)
C
C--------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
C
C     Note: Subroutines GLMAPM1, GEODAT1, AREA2, SETWGTR and AREA3 
C           share the same array structure in Scratch Common /SCRNS/.
C
      COMMON /SCRNS/ XRM1(LX1,LY1,LZ1,LELT)
     $ ,             YRM1(LX1,LY1,LZ1,LELT)
     $ ,             XSM1(LX1,LY1,LZ1,LELT)
     $ ,             YSM1(LX1,LY1,LZ1,LELT)
      COMMON /CTMP0/ WGTR1(LX1,LELT)
     $ ,             WGTR2(LY1,LELT)
     $ ,             WGTR3(LX1,LELT)
     $ ,             WGTR4(LY1,LELT)
C
      CALL SETWGTR (WGTR1,WGTR2,WGTR3,WGTR4)
C
C     "R"
C
      DO 100 IEL=1,NELT
      DO 100 IY=1,ly1
         XS2  = XSM1(lx1,IY,1,IEL)
         YS2  = YSM1(lx1,IY,1,IEL)
         XS4  = XSM1(  1,IY,1,IEL)
         YS4  = YSM1(  1,IY,1,IEL)
         SS2  = SQRT( XS2**2 + YS2**2 )
         SS4  = SQRT( XS4**2 + YS4**2 )
         T1X (IY,1,2,IEL) =  XS2 / SS2
         T1Y (IY,1,2,IEL) =  YS2 / SS2
         T1X (IY,1,4,IEL) = -XS4 / SS4
         T1Y (IY,1,4,IEL) = -YS4 / SS4
         UNX (IY,1,2,IEL) =  T1Y(IY,1,2,IEL)
         UNY (IY,1,2,IEL) = -T1X(IY,1,2,IEL)
         UNX (IY,1,4,IEL) =  T1Y(IY,1,4,IEL)
         UNY (IY,1,4,IEL) = -T1X(IY,1,4,IEL)
         AREA(IY,1,2,IEL) =  SS2 * WGTR2(IY,IEL)
         AREA(IY,1,4,IEL) =  SS4 * WGTR4(IY,IEL)
  100 CONTINUE
C
C     "S"
C
      DO 200 IEL=1,NELT
      DO 200 IX=1,lx1
         XR1  = XRM1(IX,  1,1,IEL)
         YR1  = YRM1(IX,  1,1,IEL)
         XR3  = XRM1(IX,ly1,1,IEL)
         YR3  = YRM1(IX,ly1,1,IEL)
         RR1  = SQRT( XR1**2 + YR1**2 )
         RR3  = SQRT( XR3**2 + YR3**2 )
         T1X (IX,1,1,IEL) =  XR1 / RR1
         T1Y (IX,1,1,IEL) =  YR1 / RR1
         T1X (IX,1,3,IEL) = -XR3 / RR3
         T1Y (IX,1,3,IEL) = -YR3 / RR3
         UNX (IX,1,1,IEL) =  T1Y(IX,1,1,IEL)
         UNY (IX,1,1,IEL) = -T1X(IX,1,1,IEL)
         UNX (IX,1,3,IEL) =  T1Y(IX,1,3,IEL)
         UNY (IX,1,3,IEL) = -T1X(IX,1,3,IEL)
         AREA(IX,1,1,IEL) =  RR1 * WGTR1(IX,IEL)
         AREA(IX,1,3,IEL) =  RR3 * WGTR3(IX,IEL)
  200 CONTINUE
C
      RETURN
      END
      subroutine setwgtr (wgtr1,wgtr2,wgtr3,wgtr4)
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'INPUT'
      INCLUDE 'WZ'
C
C     Note: Subroutines GLMAPM1, GEODAT1, AREA2, SETWGTR and AREA3 
C           share the same array structure in Scratch Common /SCRNS/.
C
      COMMON /SCRNS/ XRM1(LX1,LY1,LZ1,LELT)
     $ ,             YRM1(LX1,LY1,LZ1,LELT)
     $ ,             XSM1(LX1,LY1,LZ1,LELT)
     $ ,             YSM1(LX1,LY1,LZ1,LELT)
C
      DIMENSION WGTR1(LX1,1)
     $ ,        WGTR2(LY1,1)
     $ ,        WGTR3(LX1,1)
     $ ,        WGTR4(LY1,1)
C
      IF (IFAXIS) THEN
         DO 100 IEL=1,NELT
            DO 120 IX=1,lx1
               WGTR1(IX,IEL) = YM1(IX,  1,1,IEL) * WXM1(IX)
               WGTR3(IX,IEL) = YM1(IX,ly1,1,IEL) * WXM1(IX)
  120       CONTINUE
            IF ( IFRZER(IEL) ) THEN
               IY = 1
               WGTR2(IY,IEL) = YSM1(lx1,IY,1,IEL) * WAM1(IY)
               WGTR4(IY,IEL) = YSM1(  1,IY,1,IEL) * WAM1(IY)
               DO 160 IY=2,ly1
                  DNR = 1. + ZAM1(IY)
                  WGTR2(IY,IEL) = YM1(lx1,IY,1,IEL) * WAM1(IY) / DNR
                  WGTR4(IY,IEL) = YM1(  1,IY,1,IEL) * WAM1(IY) / DNR
  160          CONTINUE
            ELSE
               DO 180 IY=1,ly1
                  WGTR2(IY,IEL) = YM1(lx1,IY,1,IEL) * WYM1(IY)
                  WGTR4(IY,IEL) = YM1(  1,IY,1,IEL) * WYM1(IY)
  180          CONTINUE
            ENDIF
  100    CONTINUE
      ELSE
         DO 200 IEL=1,NELT
            CALL COPY (WGTR1(1,IEL),WXM1,lx1)
            CALL COPY (WGTR2(1,IEL),WYM1,ly1)
            CALL COPY (WGTR3(1,IEL),WXM1,lx1)
            CALL COPY (WGTR4(1,IEL),WYM1,ly1)
  200    CONTINUE
      ENDIF
C
      RETURN
      END
      subroutine area3
C--------------------------------------------------------------------
C
C     Compute areas, normals and tangents (3D geom.)
C
C--------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'WZ'
      INCLUDE 'GEOM'
C
C     Note: Subroutines GLMAPM1, GEODAT1, AREA2, SETWGTR and AREA3 
C           share the same array structure in Scratch Common /SCRNS/.
C
      COMMON /SCRNS/ XRM1(LX1,LY1,LZ1,LELT)
     $ ,             YRM1(LX1,LY1,LZ1,LELT)
     $ ,             XSM1(LX1,LY1,LZ1,LELT)
     $ ,             YSM1(LX1,LY1,LZ1,LELT)
     $ ,             XTM1(LX1,LY1,LZ1,LELT)
     $ ,             YTM1(LX1,LY1,LZ1,LELT)
     $ ,             ZRM1(LX1,LY1,LZ1,LELT)
      COMMON /CTMP1/ ZSM1(LX1,LY1,LZ1,LELT)
     $ ,             ZTM1(LX1,LY1,LZ1,LELT)
     $ ,             A  (LX1,LY1,LZ1,LELT)
     $ ,             B  (LX1,LY1,LZ1,LELT)
      COMMON /CTMP0/ C  (LX1,LY1,LZ1,LELT)
     $ ,             DOT(LX1,LY1,LZ1,LELT)
C
      NXY1  = lx1*ly1
      NFACE = 2*ldim
      NTOT  = lx1*ly1*lz1*NELT
      NSRF  = 6*lx1*ly1*NELT
C
C        "R"
C
      CALL VCROSS(A,B,C,XSM1,YSM1,ZSM1,XTM1,YTM1,ZTM1,NTOT)
      CALL VDOT3 (DOT,A,B,C,A,B,C,NTOT)
C
      DO 100 IEL=1,NELT
      DO 100 IZ=1,lz1
      DO 100 IY=1,ly1
         WEIGHT = WYM1(IY)*WZM1(IZ)
         AREA(IY,IZ,2,IEL) = SQRT(DOT(lx1,IY,IZ,IEL))*WEIGHT
         AREA(IY,IZ,4,IEL) = SQRT(DOT(  1,IY,IZ,IEL))*WEIGHT
         UNX (IY,IZ,4,IEL) = -A(  1,IY,IZ,IEL)
         UNX (IY,IZ,2,IEL) =  A(lx1,IY,IZ,IEL)
         UNY (IY,IZ,4,IEL) = -B(  1,IY,IZ,IEL)
         UNY (IY,IZ,2,IEL) =  B(lx1,IY,IZ,IEL)
         UNZ (IY,IZ,4,IEL) = -C(  1,IY,IZ,IEL)
         UNZ (IY,IZ,2,IEL) =  C(lx1,IY,IZ,IEL)
  100 CONTINUE
C
C        "S"
C
      CALL VCROSS(A,B,C,XRM1,YRM1,ZRM1,XTM1,YTM1,ZTM1,NTOT)
      CALL VDOT3 (DOT,A,B,C,A,B,C,NTOT)
      DO 200 IEL=1,NELT
      DO 200 IZ=1,lz1
      DO 200 IX=1,lx1
         WEIGHT=WXM1(IX)*WZM1(IZ)
         AREA(IX,IZ,1,IEL) = SQRT(DOT(IX,  1,IZ,IEL))*WEIGHT
         AREA(IX,IZ,3,IEL) = SQRT(DOT(IX,ly1,IZ,IEL))*WEIGHT
         UNX (IX,IZ,1,IEL) =  A(IX,  1,IZ,IEL)
         UNX (IX,IZ,3,IEL) = -A(IX,ly1,IZ,IEL)
         UNY (IX,IZ,1,IEL) =  B(IX,  1,IZ,IEL)
         UNY (IX,IZ,3,IEL) = -B(IX,ly1,IZ,IEL)
         UNZ (IX,IZ,1,IEL) =  C(IX,  1,IZ,IEL)
         UNZ (IX,IZ,3,IEL) = -C(IX,ly1,IZ,IEL)
  200 CONTINUE
C
C        "T"
C
      CALL VCROSS(A,B,C,XRM1,YRM1,ZRM1,XSM1,YSM1,ZSM1,NTOT)
      CALL VDOT3 (DOT,A,B,C,A,B,C,NTOT)
      DO 300 IEL=1,NELT
      DO 300 IX=1,lx1
      DO 300 IY=1,ly1
         WEIGHT=WXM1(IX)*WYM1(IY)
         AREA(IX,IY,5,IEL) = SQRT(DOT(IX,IY,  1,IEL))*WEIGHT
         AREA(IX,IY,6,IEL) = SQRT(DOT(IX,IY,lz1,IEL))*WEIGHT
         UNX (IX,IY,5,IEL) = -A(IX,IY,  1,IEL)
         UNX (IX,IY,6,IEL) =  A(IX,IY,lz1,IEL)
         UNY (IX,IY,5,IEL) = -B(IX,IY,  1,IEL)
         UNY (IX,IY,6,IEL) =  B(IX,IY,lz1,IEL)
         UNZ (IX,IY,5,IEL) = -C(IX,IY,  1,IEL)
         UNZ (IX,IY,6,IEL) =  C(IX,IY,lz1,IEL)
  300 CONTINUE
C
      CALL UNITVEC (UNX,UNY,UNZ,NSRF)
C
C     COMPUTE UNIT TANGENT T1
C
      DO 600 IEL=1,NELT
      DO 600 IFC=1,NFACE
      IF (IFC.EQ.1 .OR. IFC.EQ.6) THEN
         CALL FACEXV (T1X(1,1,IFC,IEL),T1Y(1,1,IFC,IEL),
     $                T1Z(1,1,IFC,IEL),
     $                XRM1(1,1,1,IEL),YRM1(1,1,1,IEL),
     $                ZRM1(1,1,1,IEL),IFC,0)
      ELSEIF (IFC.EQ.2 .OR. IFC.EQ.5) THEN
         CALL FACEXV (T1X(1,1,IFC,IEL),T1Y(1,1,IFC,IEL),
     $                T1Z(1,1,IFC,IEL),
     $                XSM1(1,1,1,IEL),YSM1(1,1,1,IEL),
     $                ZSM1(1,1,1,IEL),IFC,0)
      ELSE
         CALL FACEXV (T1X(1,1,IFC,IEL),T1Y(1,1,IFC,IEL),
     $                T1Z(1,1,IFC,IEL),
     $                XTM1(1,1,1,IEL),YTM1(1,1,1,IEL),
     $                ZTM1(1,1,1,IEL),IFC,0)
      ENDIF
  600 CONTINUE
C
      CALL UNITVEC (T1X,T1Y,T1Z,NSRF)
C
C     COMPUTE UNIT TANGENT T2  ( T2 = Normal X T1 )
C
      DO 700 IEL=1,NELT
      DO 700 IFC=1,NFACE
         CALL VCROSS (T2X(1,1,IFC,IEL),T2Y(1,1,IFC,IEL),
     $                T2Z(1,1,IFC,IEL),
     $                UNX(1,1,IFC,IEL),UNY(1,1,IFC,IEL),
     $                UNZ(1,1,IFC,IEL),
     $                T1X(1,1,IFC,IEL),T1Y(1,1,IFC,IEL),
     $                T1Z(1,1,IFC,IEL),NXY1)
  700 CONTINUE
C
      RETURN
      END
      subroutine lagmass
C--------------------------------------------------------------------
C
C     Lag the mass matrix (matrices)
C
C--------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'MASS'
      INCLUDE 'TSTEP'
C
      NTOT1 = lx1*ly1*lz1*NELT
      DO 100 ILAG=NBDINP-1,2,-1
         CALL COPY (BM1LAG(1,1,1,1,ILAG),BM1LAG(1,1,1,1,ILAG-1),NTOT1)
 100  CONTINUE
      CALL COPY (BM1LAG(1,1,1,1,1),BM1,NTOT1)
C
      RETURN
      END
C
      subroutine setinvm
C--------------------------------------------------------------------
C
C     Invert the mass matrix.
C
C     1)  Copy BM1 to BINVM1
C     2)  Perform direct stiffness summation on BINVM1
C     3)  Compute BINVM1 = 1/BINVM1
C     4)  Two inverse mass matrices required because of difference
C         in DSSUM routine for IMESH=1 and IMESH=2.
C
C--------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'MASS'
      INCLUDE 'GEOM'
      INCLUDE 'INPUT'
      INCLUDE 'TSTEP'
      INCLUDE 'WZ'

      nxyz1  = lx1*ly1*lz1

      ifld = ifield

csk      IF (IFFLOW) THEN ! Velocity mass matrix
         IFIELD = 1
         NTOT   = NXYZ1*NELV
         CALL COPY    (BINVM1,BM1,NTOT)
         CALL DSSUM   (BINVM1,lx1,ly1,lz1)
         CALL INVCOL1 (BINVM1,NTOT)
csk      ENDIF


      IF (IFHEAT) THEN ! Temperature mass matrix
         IFIELD = 2
         NTOT   = NXYZ1*NELT
         CALL COPY    (BINTM1,BM1,NTOT)
         CALL DSSUM   (BINTM1,lx1,ly1,lz1)
         CALL INVCOL1 (BINTM1,NTOT)
      ENDIF

      ifield = ifld

      return
      end

c-----------------------------------------------------------------------

      subroutine maprs(y,x,xa,nrest,iel)
C
C     Map the elemental array X from Restart mesh to Y on mesh M1
C     Conforming elements, i.e. lx1=ly1=lz1.
C
C---------------------------------------------------------------
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'IXYZ'
      INCLUDE 'WZ'
      INCLUDE 'INPUT'
C
      REAL X(NREST,NREST,NREST)
      REAL Y(LX1,LY1,LZ1)
C
      REAL XA(lx1,NREST,NREST)
      COMMON /CTMP0/ XB(LX1,LY1,LZ1)
C
      REAL IXRES(LX1,LX1),IXTRES(LX1,LX1)
      REAL IYRES(LY1,LY1),IYTRES(LY1,LY1)
      REAL IZRES(LZ1,LZ1),IZTRES(LZ1,LZ1)
      REAL ZCRES(20),WCRES(20)
      REAL ZARES(20),WARES(20)
C
      NZREST = NREST
      IF(lz1.EQ.1) NZREST=1
      NYZRES = NREST*NZREST
      NXY1   = lx1 *ly1
C
      CALL ZWGLL   (ZCRES,WCRES,NREST)
      CALL IGLLM   (IXRES,IXTRES,ZCRES,ZGM1,NREST,lx1,NREST,lx1)
      IF (.NOT.IFAXIS) THEN
         CALL COPY (IYRES,IXRES,lx1*NREST)
         CALL COPY (IYTRES,IXTRES,lx1*NREST)
         CALL COPY (IZRES,IXRES,lx1*NREST)
         CALL COPY (IZTRES,IXTRES,lx1*NREST)
      ELSE
C
C     Use the appropriate derivative- and interpolation operator in
C     the y-direction (= radial direction if axisymmetric).
C
         IF (IFRZER(IEL)) THEN
           ALPHA = 0.
           BETA  = 1.
           CALL ZWGLJ   (ZARES,WARES,NREST,ALPHA,BETA)
           CALL IGLJM   (IYRES,IYTRES,ZARES,ZGM1,NREST,ly1,NREST,ly1,
     $                                                    ALPHA,BETA)
           ly1R   = ly1*NREST
         ELSE
           CALL COPY (IYRES,IXRES,lx1*NREST)
           CALL COPY (IYTRES,IXTRES,lx1*NREST)
         ENDIF
      ENDIF
C
      IF (ldim.EQ.2) THEN
         CALL MXM (IXRES,lx1,X,NREST,XA,NREST)
         CALL MXM (XA,lx1,IYTRES,NREST,Y,ly1)
      ELSE
         CALL MXM (IXRES,lx1,X,NREST,XA,NYZRES)
         DO 100 IZ=1,NZREST
            CALL MXM (XA(1,1,IZ),lx1,IYTRES,NREST,XB(1,1,IZ),ly1)
 100     CONTINUE
         CALL MXM (XB,NXY1,IZTRES,NZREST,Y,lz1)
      ENDIF
C
      RETURN
      END
C
      subroutine map31 (y,x,iel)
C---------------------------------------------------------------
C
C     Map the elemental array X from mesh M3 to mesh M1
C
C---------------------------------------------------------------
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'IXYZ'
      INCLUDE 'INPUT'
C
      REAL X(LX3,LY3,LZ3)
      REAL Y(LX1,LY1,LZ1)
C
      COMMON /CTMP0/ XA(LX1,LY3,LZ3), XB(LX1,LY1,LZ3)
C
      NYZ3 = ly3*lz3
      NXY1 = lx1*ly1
C
C     Use the appropriate derivative- and interpolation operator in
C     the y-direction (= radial direction if axisymmetric).
C
      IF (IFAXIS) THEN
         ly31   = ly1*ly3
         IF (IFRZER(IEL))      CALL COPY (IYTM31,IATM31,ly31)
         IF (.NOT.IFRZER(IEL)) CALL COPY (IYTM31,ICTM31,ly31)
      ENDIF
C
      IF (IF3D) THEN
         CALL MXM (IXM31,lx1,X,lx3,XA,NYZ3)
         DO 100 IZ=1,lz3
            CALL MXM (XA(1,1,IZ),lx1,IYTM31,ly3,XB(1,1,IZ),ly1)
 100     CONTINUE
         CALL MXM (XB,NXY1,IZTM31,lz3,Y,lz1)
      ELSE
         CALL MXM (IXM31,lx1,X,lx3,XA,NYZ3)
         CALL MXM (XA,lx1,IYTM31,ly3,Y,ly1)
      ENDIF
C
      RETURN
      END
C
      subroutine map13 (y,x,iel)
C---------------------------------------------------------------
C
C     Map the elemental array X from mesh M1 to mesh M3
C
C---------------------------------------------------------------
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'IXYZ'
      INCLUDE 'INPUT'
C
      REAL X(LX1,LY1,LZ1)
      REAL Y(LX3,LY3,LZ3)
C
      COMMON /CTMP0/ XA(LX3,LY1,LZ1),  XB(LX3,LY3,LZ1)
C
      NYZ1 = ly1*lz1
      NXY3 = lx3*ly3
C
C     Use the appropriate derivative- and interpolation operator in
C     the y-direction (= radial direction if axisymmetric).
C
      IF (IFAXIS) THEN
         ly13   = ly1*ly3
         IF (IFRZER(IEL))      CALL COPY (IYTM13,IATM13,ly13)
         IF (.NOT.IFRZER(IEL)) CALL COPY (IYTM13,ICTM13,ly13)
      ENDIF
C
      CALL MXM (IXM13,lx3,X,lx1,XA,NYZ1)
      DO 100 IZ=1,lz1
         CALL MXM (XA(1,1,IZ),lx3,IYTM13,ly1,XB(1,1,IZ),ly3)
 100  CONTINUE
      CALL MXM (XB,NXY3,IZTM13,lz1,Y,lz3)
C
      RETURN
      END
      subroutine map12 (y,x,iel)
C---------------------------------------------------------------
C
C     Map the elemental array X from mesh M1 to mesh M2
C
C---------------------------------------------------------------
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'IXYZ'
      INCLUDE 'INPUT'
C
      REAL X(LX1,LY1,LZ1)
      REAL Y(LX2,LY2,LZ2)
C
      COMMON /CTMP00/ XA(LX2,LY1,LZ1), XB(LX2,LY2,LZ1)
C
      NYZ1 = ly1*lz1
      NXY2 = lx2*ly2
C
C     Use the appropriate derivative- and interpolation operator in
C     the y-direction (= radial direction if axisymmetric).
C
      IF (IFAXIS) THEN
         ly12   = ly1*ly2
         IF (IFRZER(IEL))      CALL COPY (IYTM12,IATM12,ly12)
         IF (.NOT.IFRZER(IEL)) CALL COPY (IYTM12,ICTM12,ly12)
      ENDIF
C
      CALL MXM (IXM12,lx2,X,lx1,XA,NYZ1)
      DO 100 IZ=1,lz1
         CALL MXM (XA(1,1,IZ),lx2,IYTM12,ly1,XB(1,1,IZ),ly2)
 100  CONTINUE
      CALL MXM (XB,NXY2,IZTM12,lz1,Y,lz2)
C
      RETURN
      END
C
      subroutine map21t (y,x,iel)
C---------------------------------------------------------------
C
C     Map the elemental array X from mesh M2 to mesh M1 (Y)
C
C---------------------------------------------------------------
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'IXYZ'
      INCLUDE 'INPUT'
C
      REAL X(LX2,LY2,LZ2)
      REAL Y(LX1,LY1,LZ1)
C
      COMMON /CTMP0/ XA(LX1,LY2,LZ2), XB(LX1,LY1,LZ2)
C
      NYZ2 = ly2*lz2
      NXY1 = lx1*ly1
      NXYZ = lx1*ly1*lz1
C
C     Use the appropriate derivative- and interpolation operator in
C     the y-direction (= radial direction if axisymmetric).
C
      IF (IFSPLIT) THEN
         CALL COPY(Y,X,NXYZ)
         RETURN
      ENDIF
C
      IF (IF3D) THEN
         CALL MXM (IXM21,lx1,X,lx2,XA,NYZ2)
         DO 100 IZ=1,lz2
            CALL MXM (XA(1,1,IZ),lx1,IYTM21,ly2,XB(1,1,IZ),ly1)
 100     CONTINUE
         CALL MXM (XB,NXY1,IZTM21,lz2,Y,lz1)
      ELSE
         CALL MXM (IXM21,lx1,X,lx2,XA,NYZ2)
         CALL MXM (XA,lx1,IYTM21,ly2,Y,ly1)
      ENDIF
      RETURN
      END
      subroutine map21e (y,x,iel)
C---------------------------------------------------------------
C
C     Map the elemental array X from mesh M2 to mesh M1
C
C---------------------------------------------------------------
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'IXYZ'
      INCLUDE 'INPUT'
C
      REAL X(LX2,LY2,LZ2)
      REAL Y(LX1,LY1,LZ1)
C
      COMMON /CTMP0/ XA(LX1,LY2,LZ2), XB(LX1,LY1,LZ2)
C
      NYZ2 = ly2*lz2
      NXY1 = lx1*ly1
C
C     Use the appropriate derivative- and interpolation operator in
C     the y-direction (= radial direction if axisymmetric).
C
      IF (IFAXIS) THEN
         ly21   = ly1*ly2
         IF (IFRZER(IEL))      CALL COPY (IYM12,IAM12,ly21)
         IF (.NOT.IFRZER(IEL)) CALL COPY (IYM12,ICM12,ly21)
      ENDIF
C
      CALL MXM (IXTM12,lx1,X,lx2,XA,NYZ2)
      DO 100 IZ=1,lz2
         CALL MXM (XA(1,1,IZ),lx1,IYM12,ly2,XB(1,1,IZ),ly1)
 100  CONTINUE
      CALL MXM (XB,NXY1,IZM12,lz2,Y,lz1)
C
      RETURN
      END
c-----------------------------------------------------------------------
      subroutine out_xyz_el(x,y,z,e)
      include 'SIZE'
      integer e
      real x(1),y(1),z(1)
c
      call out_fld_el(x,e,'XQ')
      call out_fld_el(y,e,'YQ')
      call out_fld_el(z,e,'ZQ')
c
      return
      end
c-----------------------------------------------------------------------
      subroutine out_fld_el(x,e,c2)
      include 'SIZE'
      real x(lx1,ly1,lz1,lelt)
      integer e
      character*2 c2
c
      write(6,1) c2,e
      nx8 = min(lx1,8)
      do k=1,lz1
      do j=1,ly1
         write(6,1) c2,e,(x(i,j,k,e),i=1,nx8)
      enddo
      enddo
    1 format(a2,i6,1p8e11.3)
      return
      end
c-----------------------------------------------------------------------
      subroutine outxm3j(xm3,ym3,jm3)
      include 'SIZE'
      include 'TOTAL'

      real xm3(lx1,ly1,lz1,lelv)
      real ym3(lx1,ly1,lz1,lelv)
      real jm3(lx1,ly1,lz1,lelv)

      integer e

      do e=1,nelt
         write(6,*) e,nelfld(e),iftmsh(e),' iftmsh'
         call outmat(xm3(1,1,1,e),lx3,ly3,' xm3  ',e)
         call outmat(ym3(1,1,1,e),lx3,ly3,' ym3  ',e)
         call outmat(jm3(1,1,1,e),lx3,ly3,' jm3  ',e)
      enddo

      return
      end
c-----------------------------------------------------------------------
      SUBROUTINE INVMT(A,B,AA,N)
C
      REAL A(N,N),AA(N,N),B(N,N)
      INTEGER INDX(100)
C
      NN = N*N
      DO 12 I=1,N
       DO 11 J=1,N
        B(I,J) = 0.0
 11    CONTINUE
       B(I,I) = 1.0
 12   CONTINUE
C
      CALL COPY  (AA,A,NN)
      CALL LUDCMP(AA,N,N,INDX,D)
      DO 13 J=1,N
       CALL LUBKSB(AA,N,N,INDX,B(1,J))
 13   CONTINUE
C
      RETURN
      END

      SUBROUTINE LUBKSB(A,N,NP,INDX,B)
      REAL A(NP,NP),B(N)
      INTEGER INDX(N)
      II=0
      DO 12 I=1,N
        LL=INDX(I)
        SUM=B(LL)
        B(LL)=B(I)
        IF (II.NE.0)THEN
          DO 11 J=II,I-1
            SUM=SUM-A(I,J)*B(J)
11        CONTINUE
        ELSE IF (SUM.NE.0.0) THEN
          II=I
        ENDIF
        B(I)=SUM
12    CONTINUE
      DO 14 I=N,1,-1
        SUM=B(I)
        IF(I.LT.N)THEN
          DO 13 J=I+1,N
            SUM=SUM-A(I,J)*B(J)
13        CONTINUE
        ENDIF
        B(I)=SUM/A(I,I)
14    CONTINUE
      RETURN
      END
      SUBROUTINE LUDCMP(A,N,NP,INDX,D)
      PARAMETER (NMAX=100,TINY=1.0E-20)
      REAL A(NP,NP),VV(NMAX)
      INTEGER INDX(N)
      D=1.0
      DO 12 I=1,N
        AAMAX=0.0
        DO 11 J=1,N
          IF (ABS(A(I,J)).GT.AAMAX) AAMAX=ABS(A(I,J))
11      CONTINUE
        IF (AAMAX.EQ.0.0) THEN
           write(6,*) 'Singular matrix.'
           call exitt
        ENDIF
        VV(I)=1.0/AAMAX
12    CONTINUE
      DO 19 J=1,N
        IF (J.GT.1) THEN
          DO 14 I=1,J-1
            SUM=A(I,J)
            IF (I.GT.1)THEN
              DO 13 K=1,I-1
                SUM=SUM-A(I,K)*A(K,J)
13            CONTINUE
              A(I,J)=SUM
            ENDIF
14        CONTINUE
        ENDIF
        AAMAX=0.0
        DO 16 I=J,N
          SUM=A(I,J)
          IF (J.GT.1)THEN
            DO 15 K=1,J-1
              SUM=SUM-A(I,K)*A(K,J)
15          CONTINUE
            A(I,J)=SUM
          ENDIF
          DUM=VV(I)*ABS(SUM)
          IF (DUM.GE.AAMAX) THEN
            IMAX=I
            AAMAX=DUM
          ENDIF
16      CONTINUE
        IF (J.NE.IMAX)THEN
          DO 17 K=1,N
            DUM=A(IMAX,K)
            A(IMAX,K)=A(J,K)
            A(J,K)=DUM
17        CONTINUE
          D=-D
          VV(IMAX)=VV(J)
        ENDIF
        INDX(J)=IMAX
        IF(J.NE.N)THEN
          IF(A(J,J).EQ.0.)A(J,J)=TINY
          DUM=1.0/A(J,J)
          DO 18 I=J+1,N
            A(I,J)=A(I,J)*DUM
18        CONTINUE
        ENDIF
19    CONTINUE
      IF(A(N,N).EQ.0.0)A(N,N)=TINY
      RETURN
      END
c-----------------------------------------------------------------------
      subroutine set_unr
      include 'SIZE'
      include 'INPUT'
      include 'GEOM'
      include 'TOPOL'

      integer e,f,pf

      nface = 2*ldim
      call dsset(lx1,ly1,lz1)

      do e=1,nelt
      do f=1,nface

         pf     = eface1(f)
         js1    = skpdat(1,pf)
         jf1    = skpdat(2,pf)
         jskip1 = skpdat(3,pf)
         js2    = skpdat(4,pf)
         jf2    = skpdat(5,pf)
         jskip2 = skpdat(6,pf)

         i = 0
         if (if3d) then
            do j2=js2,jf2,jskip2
            do j1=js1,jf1,jskip1
               i = i+1
               a = area(i,1,f,e)/jacm1(j1,j2,1,e)
               unr(i,f,e) = a * ( rxm1(j1,j2,1,e)*unx(i,1,f,e)
     $                          + rym1(j1,j2,1,e)*uny(i,1,f,e)
     $                          + rzm1(j1,j2,1,e)*unz(i,1,f,e) )
               uns(i,f,e) = a * ( sxm1(j1,j2,1,e)*unx(i,1,f,e)
     $                          + sym1(j1,j2,1,e)*uny(i,1,f,e)
     $                          + szm1(j1,j2,1,e)*unz(i,1,f,e) )
               unt(i,f,e) = a * ( txm1(j1,j2,1,e)*unx(i,1,f,e)
     $                          + tym1(j1,j2,1,e)*uny(i,1,f,e)
     $                          + tzm1(j1,j2,1,e)*unz(i,1,f,e) )
            enddo
            enddo
         else
            do j2=js2,jf2,jskip2
            do j1=js1,jf1,jskip1
               i = i+1
               a = area(i,1,f,e)/jacm1(j1,j2,1,e)
               unr(i,f,e) = a * ( rxm1(j1,j2,1,e)*unx(i,1,f,e)
     $                          + rym1(j1,j2,1,e)*uny(i,1,f,e) )
               uns(i,f,e) = a * ( sxm1(j1,j2,1,e)*unx(i,1,f,e)
     $                          + sym1(j1,j2,1,e)*uny(i,1,f,e) )
               unt(i,f,e) = 0.
            enddo
            enddo
         endif
      enddo
      enddo

      return
      end
c-----------------------------------------------------------------------

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Two-dimension array computation with a vetorization directive
!collapse(2) makes simd associate with 2 loops.
!Loop iteration variables should be predetermined as lastprivate. No data race pairs.

program DRB098_simd2_orig_no
    use omp_lib
    implicit none

    integer, parameter :: dp = kind(1.0d0)
    real(dp), dimension(:,:), allocatable :: a,b,c
    integer :: len, i, j

    len = 100
    allocate (a(len,len))
    allocate (b(len,len))
    allocate (c(len,len))

    do i = 1, len
        do j = 1, len
            a(i,j) = real(i,dp)/2.0
            b(i,j) = real(i,dp)/3.0
            c(i,j) = real(i,dp)/7.0
        end do
    end do

    !$omp simd collapse(2)
    do i = 1, len
        do j = 1, len
            c(i,j)=a(i,j)*b(i,j)
        end do
    end do
    !$omp end simd

    print*,'c(50,50) =',c(50,50)

    deallocate(a,b,c)
end program

! @expect verified
! @flag --unroll=10

recursive function fib(n)
  implicit none
  integer, intent(in) :: n
  integer :: fib
  if (n <= 0) then
    fib = 0
  else if (n == 1) then
    fib = 1
  else 
    fib = fib(n - 1) + fib(n - 2)
  end if
end function

program main
  implicit none
  integer :: fib
  !print *, fib(5) == 5
  !print *, fib(6) == 8 
  integer :: z
  !z = fib(2)
  !!CVL $ssert(z > 18)
  !$CVL $assert(fib(5) == 5)
  !$CVL $assert(fib(6) /= 8)
end program main

!
!  Copyright (c) 2010-2015 Centre National de la Recherche Scientifique.
!  written by Nathanael Schaeffer (CNRS, ISTerre, Grenoble, France).
!  
!  nathanael.schaeffer@ujf-grenoble.fr
!  
!  This software is governed by the CeCILL license under French law and
!  abiding by the rules of distribution of free software. You can use,
!  modify and/or redistribute the software under the terms of the CeCILL
!  license as circulated by CEA, CNRS and INRIA at the following URL
!  "http://www.cecill.info".
!  
!  The fact that you are presently reading this means that you have had
!  knowledge of the CeCILL license and that you accept its terms.
!  




      INTEGER SHT_NATIVE_LAYOUT
      PARAMETER (SHT_NATIVE_LAYOUT=0)
      INTEGER SHT_THETA_CONTIGUOUS
      PARAMETER (SHT_THETA_CONTIGUOUS=256)
      INTEGER SHT_PHI_CONTIGUOUS
      PARAMETER (SHT_PHI_CONTIGUOUS=512)

      INTEGER SHT_NO_CS_PHASE
      PARAMETER (SHT_NO_CS_PHASE=1024)
      INTEGER SHT_REAL_NORM
      PARAMETER (SHT_REAL_NORM=2048)

      INTEGER SHT_ORTHONORMAL
      PARAMETER (SHT_ORTHONORMAL=0)
      INTEGER SHT_FOURPI
      PARAMETER (SHT_FOURPI=1)
      INTEGER SHT_SCHMIDT
      PARAMETER (SHT_SCHMIDT=2)

      INTEGER SHT_GAUSS
      PARAMETER (SHT_GAUSS=0)
      INTEGER SHT_AUTO
      PARAMETER (SHT_AUTO=1)
      INTEGER SHT_REG_FAST
      PARAMETER (SHT_REG_FAST=2)
      INTEGER SHT_REG_DCT
      PARAMETER (SHT_REG_DCT=3)
      INTEGER SHT_QUICK_INIT
      PARAMETER (SHT_QUICK_INIT=4)
      INTEGER SHT_REG_POLES
      PARAMETER (SHT_REG_POLES=5)
      INTEGER SHT_GAUSS_FLY
      PARAMETER (SHT_GAUSS_FLY=6)

      INTEGER SHT_SOUTH_POLE_FIRST
      PARAMETER (SHT_SOUTH_POLE_FIRST=8192)
      INTEGER SHT_SCALAR_ONLY
      PARAMETER (SHT_SCALAR_ONLY=4096)
      INTEGER SHT_LOAD_SAVE_CFG
      PARAMETER (SHT_LOAD_SAVE_CFG=16384)

c-----------------------------------------------------------------------
      subroutine lb_setqvol(flocal,qvol,in,m,isInactive)
c
c     Compute user specified volumetric source term vector using
c     flocal(real inout(m),m) for all 'active' (isInactive==0) 
c     fluid points
c
      include 'SIZE'
c
      real qvol(lx1,ly1,lz1,lelv,*),in(lx1,ly1,lz1,lelt,*)
      integer isInactive(lx1,ly1,lz1,*)

      integer lb_imap(lx1*ly1*lz1*lelv)
      common /lbr/ buf(ldimt,lx1*ly1*lz1*lelv)
      real buf

      external flocal

      lqvol = lx1*ly1*lz1*lelv
      lin   = lx1*ly1*lz1*lelt
      ntot  = lx1*ly1*lz1*nelv

      ! pack input data
      n = 0
      do i = 1,ntot
        if(isInactive(i,1,1,1).eq.0) then
          n = n + 1              
          lb_imap(n) = i
          do j = 1,m
             k = (j-1)*lin + i
             buf(j,n) = in(k,1,1,1,1)
          enddo 
        endif     
      enddo

      ! distribute input data ->compute output data ->transfer back
      nmax = lin 
      call lb_process_items(n,buf,flocal,m,nmax)

      ! unpack output data 
      do i = 1,n
         do k = 1,m
            j = (k-1)*lqvol + lb_imap(i)
            qvol(j,1,1,1,1) = buf(k,i) 
         enddo  
      enddo  

      return
      end
c-----------------------------------------------------------------------
      subroutine lb_process_items(nin,rdata,flocal,m,nmax)
c
      include 'SIZE'
      common /nekmpi/ nidd,npp,nekcomm,nekgroup,nekreal

      real rdata(1)
      external flocal    

      integer*8 i8gl_running_sum, i8rsum
      integer*8 n8, np8, nb8

      common /scrns/ vi(2,lx1*ly1*lz1*lelt)
      integer vi

      integer icalld,cr_lb
      data icalld /0/
      save icalld,cr_lb

      parameter(kid = 1) ! column to store local id 
      parameter(kp  = 2) ! column to store rank tag

      real tcomm
      data tcomm /0.0/
      save tcomm

      n  = nin
      n0 = n

      if(icalld.eq.0) then
        call fgslib_crystal_setup(cr_lb,nekcomm,npp)
        icalld = 1
      endif

      ! partition into chunks 
      ! note: simple approach but not of approx. equal size
      n8  = n
      np8 = npp
      ng8 = i8glsum(n8,1)
      nb8 = ng8/np8
      do i = 0,mod(ng8,np8)-1
         if(nid.eq.i) nb8 = nb8 + 1
      enddo
      i8rsum = i8gl_running_sum(n8) - n8 
      do i=1,n
         vi(kid,i) = i
         ig = i8rsum + i
         vi(kp ,i) = (ig-1)/nb8
      enddo

      if (loglevel.gt.2) then
        n0_max = iglmax(n0,1)
        n0_min = iglmin(n0,1)
      endif

      etime = dnekclock_sync()
      call fgslib_crystal_tuple_transfer
     &     (cr_lb,n,nmax,vi,2,vl,0,rdata,m,kp)
      tcomm = tcomm + dnekclock_sync() - etime

      if (loglevel.gt.2) then
        n_max = iglmax(n,1)
        n_min = iglmin(n,1)
      endif

      do j = 1,n
         jj = (j-1)*m + 1
         call flocal(rdata(jj),m)
      enddo

      etime = dnekclock_sync()
      call fgslib_crystal_tuple_transfer
     &     (cr_lb,n,nmax,vi,2,vl,0,rdata,m,kp)
      tcomm = tcomm + dnekclock_sync() - etime

      if (n.gt.nmax) call exitti('lb_process_items nmax too small$',n)
      if (n.ne.n0)   call exitti('lb_process_items unexpected n$',n)

      key = kid ! restore based on local id
      call fgslib_crystal_tuple_sort
     &     (cr_lb,n,vi,2,vl,0,rdata,m,key,1)

      if (loglevel.gt.2 .and. nid.eq.0) then
         write(6,*) 'lb before nmax/nmin:', n0_max, n0_min
         write(6,*) 'lb after  nmax/nmin:', n_max , n_min
         write(6,*) 'lb tcomm           :', tcomm
      endif

      return
      end

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!omp_get_thread_num() is used to ensure serial semantics. No data race pairs.

program DRB051_getthreadnum_orig_no
    use omp_lib
    implicit none

    integer :: numThreads

    !$omp parallel
    if (omp_get_thread_num() == 0) then
        numThreads = omp_get_num_threads()
    end if
    !$omp end parallel

    print 100, numThreads
    100 format ('numThreads =',i3)
end program

subroutine Eos_getData_loop1(vecLen, eosData, solnData, i,j,k,n, pres_map,dens_map,gamc_map,&
                    game_map,temp_map,entr_map,eint_map,ener_map, velx_map, vely_map, velz_map, &
                    sumy_map, ye_map, pres,dens,gamc,temp,abar,zbar,eint,ekin,entr)

implicit none

#include "Eos.h"
#include "Eos_map.h"
#include "constants.h"
#include "Flash.h"

        integer :: vecLen
        real, dimension(EOS_NUM*vecLen) :: eosData
        real, dimension(:,:,:,:) :: solnData
        integer :: i,j,k
        integer :: n
        integer :: pres,dens,gamc,temp,abar,zbar,eint,ekin,entr
        integer :: pres_map,dens_map,gamc_map,game_map,temp_map,entr_map
        integer :: eint_map,ener_map, velx_map, vely_map, velz_map, sumy_map, ye_map

        real :: kineticEnergy, internalEnergy
        
        real :: eos_eintSwitch, eos_smalle
                
           if (velx_map > 0 .AND. vely_map > 0 .AND. velz_map > 0) then
              kineticEnergy  = 0.5*(solnData(velx_map,i,j,k)**2 + &
                                    solnData(vely_map,i,j,k)**2 + &
                                    solnData(velz_map,i,j,k)**2)
           else
              kineticEnergy = 0.0
           end if
           
           n=n+1
           eosData(ekin+n) = kineticEnergy
           !! kineticEnergy holds velocity vector information -- 1/2 * Vmag**2
           !! internalEnergy holds eint (directly)  or energyTotal - ekinetic (calculated),
           !!          depending upon eintSwitch
           if(eint_map /= NONEXISTENT) then
              internalEnergy  = solnData(eint_map,i,j,k)
              if(ener_map /= NONEXISTENT) then
                 if ( solnData(ener_map,i,j,k) - kineticEnergy > max(eos_smalle, eos_eintSwitch*kineticEnergy)) then
                    internalEnergy = solnData(ener_map,i,j,k) - kineticEnergy
                 end if
              end if
           else if(game_map /= NONEXISTENT) then ! This case should be usable for R(elativistic)HD - KW
              internalEnergy  = solnData(pres_map,i,j,k) / solnData(dens_map,i,j,k) / (solnData(game_map,i,j,k) - 1.0)
              if(ener_map /= NONEXISTENT) then
                 if ( solnData(ener_map,i,j,k) - kineticEnergy > max(eos_smalle, eos_eintSwitch*kineticEnergy)) then
                    internalEnergy = solnData(ener_map,i,j,k) - kineticEnergy
                 end if
              end if
           else if(ener_map /= NONEXISTENT) then
              internalEnergy = solnData(ener_map,i,j,k)-kineticEnergy
           else
              internalEnergy = eos_smalle
           endif
           
           internalEnergy = max(internalEnergy, eos_smalle)
           eosData(eint+n) = internalEnergy
           
           eosData(pres+n) = solnData(pres_map,i,j,k)
           eosData(dens+n) = solnData(dens_map,i,j,k)
           eosData(temp+n) = solnData(temp_map,i,j,k)
           eosData(gamc+n) = solnData(gamc_map,i,j,k)
           if((ye_map /= NONEXISTENT).and.(sumy_map /= NONEXISTENT)) then
              !! cal says abar=1/sumy
              !! cal says zbar=ye / sumy and he claims sumy are never zero
              eosData(abar+n) =  1.0 /  solnData(sumy_map,i,j,k)
              eosData(zbar+n) = solnData(ye_map,i,j,k) /  solnData(sumy_map,i,j,k)
           endif
           if(entr_map /= NONEXISTENT) eosData(entr+n) = solnData(entr_map,i,j,k)
           
end subroutine Eos_getData_loop1

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!This is a program based on a test contributed by Yizi Gu@Rice Univ.
! * Missing the ordered clause
! * Data race pair: x@21:9 vs. x@21:13


program DRB109_orderedmissing_orig_yes
    use omp_lib
    implicit none

    integer x,i

    !$omp parallel do ordered
    do i = 1, 100
        x = x+1
    end do
    !$omp end parallel do

    print*,'x =',x

end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!A variable is declared inside a function called within a parallel region.
!The variable should be private if it does not use static storage. No data race pairs.

module DRB083
    use omp_lib
    implicit none
    contains
    subroutine foo()
      integer :: q
      q = 0
      q = q+1
    end subroutine foo
end module DRB083

program DRB083_declared_in_func_orig_no
    use omp_lib
    use DRB083
    implicit none

    !$omp parallel
    call foo()
    !$omp end parallel
end program

c-----------------------------------------------------------------------
      subroutine read_re2_data(ifbswap, ifxyz, ifcur, ifbc)  ! .re2 reader

      include 'SIZE'
      include 'TOTAL'
      include 'RESTART'
      include 'CTIMER'

      logical ifbswap
      logical ifxyz, ifcur, ifbc
      integer idummy(100)

      common /nekmpi/ nidd,npp,nekcomm,nekgroup,nekreal
 
 
      etime0 = dnekclock_sync()

                  ibc = 2
      if (ifflow) ibc = 1

                  nfldt = 1
      if (ifheat) nfldt = 2+npscal
      if (ifmhd ) nfldt = 2+npscal+1

      ! first field to read
      if (param(33).gt.0) ibc = int(param(33))

      ! number of fields to read
      if (param(32).gt.0) nfldt = ibc + int(param(32)) - 1

      call blank(cbc,3*size(cbc))
      call rzero(bc ,size(bc))

#ifndef NOMPIIO
      call fgslib_crystal_setup(cr_re2,nekcomm,np)

      call byte_open_mpi(re2fle,fh_re2,.true.,ierr)
      call err_chk(ierr,' Cannot open .re2 file!$')

      call readp_re2_mesh (ifbswap,ifxyz)
      call readp_re2_curve(ifbswap,ifcur)
      do ifield = ibc,nfldt
        call readp_re2_bc(cbc(1,1,ifield),bc(1,1,1,ifield),
     &    ifbswap,ifbc)
      enddo

      call fgslib_crystal_free(cr_re2)
      call byte_close_mpi(fh_re2,ierr)
#else
      call byte_open(re2fle,ierr)
      call byte_read(idummy,21,ierr) ! skip hdr+endian code 

      call bin_rd1_mesh (ifbswap)
      call bin_rd1_curve(ifbswap)
      do ifield = ibc,nfldt
         call bin_rd1_bc (cbc(1,1,ifield),bc(1,1,1,ifield),ifbswap)
      enddo

      call byte_close(ierr)
#endif

      etime_t = dnekclock_sync() - etime0
      if(nio.eq.0) write(6,'(A,1(1g9.2),A,/)')
     &                   ' done :: read .re2 file   ',
     &                   etime_t, ' sec'

      return
      end
c-----------------------------------------------------------------------
      subroutine readp_re2_mesh(ifbswap,ifread) ! version 2 of .re2 reader

      include 'SIZE'
      include 'TOTAL'

      logical ifbswap
      logical ifread

      parameter(nrmax = lelt)             ! maximum number of records
      parameter(lrs   = 1+ldim*(2**ldim)) ! record size: group x(:,c) ...
      parameter(li    = 2*lrs+2)

      integer         bufr(li-2,nrmax)
      common /scrns/  bufr

      integer         vi  (li  ,nrmax)
      common /ctmp1/  vi

      integer*8       lre2off_b,dtmp8
      integer*8       nrg

      nrg       = nelgt
      nr        = nelt
      irankoff  = igl_running_sum(nr) - nr
      dtmp8     = irankoff
      re2off_b  = 84 ! set initial offset (hdr + endian)
      lre2off_b = re2off_b + dtmp8*lrs*wdsizi
      lrs4      = lrs*wdsizi/4

      ! read coordinates from file
      nwds4r = nr*lrs4
      call byte_set_view(lre2off_b,fh_re2)
      call byte_read_mpi(bufr,nwds4r,-1,fh_re2,ierr)
      re2off_b = re2off_b + nrg*4*lrs4
      if (ierr.gt.0) goto 100

      if (.not.ifread) return

      if (nio.eq.0) write(6,*) 'reading mesh '

      ! pack buffer
      do i = 1,nr
         jj      = (i-1)*lrs4 + 1
         ielg    = irankoff + i ! elements are stored in global order
         vi(1,i) = gllnid(ielg)
         vi(2,i) = ielg
         call icopy(vi(3,i),bufr(jj,1),lrs4)
      enddo

      ! crystal route nr real items of size lrs to rank vi(key,1:nr)
      n   = nr
      key = 1 
      call fgslib_crystal_tuple_transfer(cr_re2,n,nrmax,vi,li,
     &   vl,0,vr,0,key)

      ! unpack buffer
      ierr = 0
      if (n.gt.nrmax) then
         ierr = 1
         goto 100
      endif

      do i = 1,n
         iel = gllel(vi(2,i)) 
         call icopy     (bufr,vi(3,i),lrs4)
         call buf_to_xyz(bufr,iel,ifbswap,ierr)
      enddo

 100  call err_chk(ierr,'Error reading .re2 mesh$')

      return
      end
c-----------------------------------------------------------------------
      subroutine readp_re2_curve(ifbswap,ifread)

      include 'SIZE'
      include 'TOTAL'

      logical ifbswap
      logical ifread

      common /nekmpi/ nidd,npp,nekcomm,nekgroup,nekreal

      parameter(nrmax = 12*lelt) ! maximum number of records
      parameter(lrs   = 2+1+5)   ! record size: eg iside curve(5) ccurve
      parameter(li    = 2*lrs+1)

      integer         bufr(li-1,nrmax)
      common /scrns/  bufr

      integer         vi  (li  ,nrmax)
      common /ctmp1/  vi

      integer*8       lre2off_b,dtmp8
      integer*8       nrg
      integer*4       nrg4(2)
      

      ! read total number of records
      nwds4r    = 1*wdsizi/4
      lre2off_b = re2off_b
      call byte_set_view(lre2off_b,fh_re2)
      call byte_read_mpi(nrg4,nwds4r,-1,fh_re2,ierr)
      if(ierr.gt.0) goto 100

      if(wdsizi.eq.8) then
         if(ifbswap) call byte_reverse8(nrg4,nwds4r,ierr)
         call copy(dnrg,nrg4,1)
         nrg = dnrg
      else
         if(ifbswap) call byte_reverse (nrg4,nwds4r,ierr)
         nrg = nrg4(1)
      endif
      re2off_b = re2off_b + 4*nwds4r

      if(nrg.eq.0) return

      ! read data from file
      dtmp8 = np
      nr = nrg/dtmp8
      do i = 0,mod(nrg,dtmp8)-1
         if(i.eq.nid) nr = nr + 1
      enddo
      irankoff  = igl_running_sum(nr) - nr
      dtmp8     = irankoff
      lre2off_b = re2off_b + dtmp8*lrs*wdsizi
      lrs4      = lrs*wdsizi/4

      re2off_b = re2off_b + nrg*4*lrs4

      if (.not.ifread) return
      if(nio.eq.0) write(6,*) 'reading curved sides '

      nwds4r = nr*lrs4
      call byte_set_view(lre2off_b,fh_re2)
      call byte_read_mpi(bufr,nwds4r,-1,fh_re2,ierr)
      if(ierr.gt.0) goto 100

      ! pack buffer
      do i = 1,nr
         jj = (i-1)*lrs4 + 1

         if(ifbswap) then 
           lrs4s = lrs4 - wdsizi/4 ! words to swap (last is char)
           if(wdsizi.eq.8) call byte_reverse8(bufr(jj,1),lrs4s,ierr)
           if(wdsizi.eq.4) call byte_reverse (bufr(jj,1),lrs4s,ierr)
         endif

         ielg = bufr(jj,1)
         if(wdsizi.eq.8) call copyi4(ielg,bufr(jj,1),1)

         if(ielg.le.0 .or. ielg.gt.nelgt) goto 100
         vi(1,i) = gllnid(ielg)

         call icopy (vi(2,i),bufr(jj,1),lrs4)
      enddo

      ! crystal route nr real items of size lrs to rank vi(key,1:nr)
      n    = nr
      key  = 1
      call fgslib_crystal_tuple_transfer(cr_re2,n,nrmax,vi,li,vl,0,vr,0,
     &                                   key)

      ! unpack buffer
      if(n.gt.nrmax) goto 100
      do i = 1,n
         call icopy       (bufr,vi(2,i),lrs4)
         call buf_to_curve(bufr)
      enddo

      return

 100  ierr = 1
      call err_chk(ierr,'Error reading .re2 curved data$')

      end
c-----------------------------------------------------------------------
      subroutine readp_re2_bc(cbl,bl,ifbswap,ifread)

      include 'SIZE'
      include 'TOTAL'

      character*3  cbl(  6,lelt)
      real         bl (5,6,lelt)
      logical      ifbswap
      logical      ifread

      parameter(nrmax = 6*lelt) ! maximum number of records
      parameter(lrs   = 2+1+5)  ! record size: eg iside bl(5) cbl
      parameter(li    = 2*lrs+1)

      integer         bufr(li-1,nrmax)
      common /scrns/  bufr

      integer         vi  (li  ,nrmax)
      common /ctmp1/  vi

      integer*8       lre2off_b,dtmp8
      integer*8       nrg
      integer*4       nrg4(2)

      ! read total number of records
      nwds4r    = 1*wdsizi/4
      lre2off_b = re2off_b
      call byte_set_view(lre2off_b,fh_re2)
      call byte_read_mpi(nrg4,nwds4r,-1,fh_re2,ierr)
      if(ierr.gt.0) goto 100

      if(wdsizi.eq.8) then
         if(ifbswap) call byte_reverse8(nrg4,nwds4r,ierr)
         call copy(dnrg,nrg4,1)
         nrg = dnrg
      else
         if(ifbswap) call byte_reverse (nrg4,nwds4r,ierr)
         nrg = nrg4(1)
      endif
      re2off_b = re2off_b + 4*nwds4r

      if(nrg.eq.0) return

      ! read data from file
      dtmp8 = np
      nr = nrg/dtmp8
      do i = 0,mod(nrg,dtmp8)-1
         if(i.eq.nid) nr = nr + 1
      enddo
      irankoff  = igl_running_sum(nr) - nr
      dtmp8     = irankoff
      lre2off_b = re2off_b + dtmp8*lrs*wdsizi
      lrs4      = lrs*wdsizi/4

      re2off_b = re2off_b + nrg*4*lrs4

      if (.not.ifread) return
      if(nio.eq.0) write(6,*) 'reading bc for ifld',ifield

      nwds4r = nr*lrs4
      call byte_set_view(lre2off_b,fh_re2)
      call byte_read_mpi(bufr,nwds4r,-1,fh_re2,ierr)
      if(ierr.gt.0) goto 100

      ! pack buffer
      do i = 1,nr
         jj = (i-1)*lrs4 + 1

         if(ifbswap) then 
           lrs4s = lrs4 - wdsizi/4 ! words to swap (last is char)
           if(wdsizi.eq.8) call byte_reverse8(bufr(jj,1),lrs4s,ierr)
           if(wdsizi.eq.4) call byte_reverse (bufr(jj,1),lrs4s,ierr)
         endif

         ielg = bufr(jj,1)
         if(wdsizi.eq.8) call copyi4(ielg,bufr(jj,1),1)

         if(ielg.le.0 .or. ielg.gt.nelgt) goto 100
         vi(1,i) = gllnid(ielg)

         call icopy (vi(2,i),bufr(jj,1),lrs4)
      enddo

      ! crystal route nr real items of size lrs to rank vi(key,1:nr)
      n    = nr
      key  = 1

      call fgslib_crystal_tuple_transfer(cr_re2,n,nrmax,vi,li,vl,0,vr,0,
     &                                   key)

      ! fill up with default
      do iel=1,nelt
      do k=1,6
         cbl(k,iel) = 'E  '
      enddo
      enddo

      ! unpack buffer
      if(n.gt.nrmax) goto 100
      do i = 1,n
         call icopy    (bufr,vi(2,i),lrs4)
         call buf_to_bc(cbl,bl,bufr)
      enddo

      return

 100  ierr = 1
      call err_chk(ierr,'Error reading .re2 boundary data$')

      end
c-----------------------------------------------------------------------
      subroutine buf_to_xyz(buf,e,ifbswap,ierr)! version 1 of binary reader

      include 'SIZE'
      include 'TOTAL'
      logical ifbswap

c      integer e,eg,buf(0:49)
      integer e,eg,buf(0:49)

      nwds = (1 + ldim*(2**ldim))*(wdsizi/4) ! group + 2x4 for 2d, 3x8 for 3d

      if     (ifbswap.and.ierr.eq.0.and.wdsizi.eq.8) then
          call byte_reverse8(buf,nwds,ierr)
      elseif (ifbswap.and.ierr.eq.0.and.wdsizi.eq.4) then
          call byte_reverse (buf,nwds,ierr)
      endif
      if(ierr.ne.0) return

      if(wdsizi.eq.8) then
         call copyi4(igroup(e),buf(0),1) !0-1
         if (ldim.eq.3) then
            call copy  (xc(1,e),buf( 2),8) !2 --17
            call copy  (yc(1,e),buf(18),8) !18--33
            call copy  (zc(1,e),buf(34),8) !34--49
         else
            call copy  (xc(1,e),buf( 2),4) !2 --9
            call copy  (yc(1,e),buf(10),4) !10--17
          endif
      else
         igroup(e) = buf(0)
         if (if3d) then
            call copy4r(xc(1,e),buf( 1),8)
            call copy4r(yc(1,e),buf( 9),8)
            call copy4r(zc(1,e),buf(17),8)
         else
            call copy4r(xc(1,e),buf( 1),4)
            call copy4r(yc(1,e),buf( 5),4)
         endif
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine buf_to_curve(buf)    ! version 1 of binary reader

      include 'SIZE'
      include 'TOTAL'

      integer e,eg,f,buf(30)

      if(wdsizi.eq.8) then
        call copyi4(eg,buf(1),1) !1-2
        e  = gllel(eg)

        call copyi4(f,buf(3),1) !3-4

        call copy  ( curve(1,f,e),buf(5) ,5) !5--14
        call chcopy(ccurve(  f,e),buf(15),1)!15
      else
        eg = buf(1)
        e  = gllel(eg)
        f  = buf(2)

        call copy4r( curve(1,f,e),buf(3),5)
        call chcopy(ccurve(f,e)  ,buf(8),1)
      endif

c     write(6,1) eg,e,f,(curve(k,f,e),k=1,5),ccurve(f,e)
c   1 format(2i7,i3,5f10.3,1x,a1,'ccurve')

      return
      end
c-----------------------------------------------------------------------
      subroutine buf_to_bc(cbl,bl,buf)    ! version 1 of binary reader

      include 'SIZE'
      include 'TOTAL'

      character*3 cbl(6,lelt)
      real         bl(5,6,lelt)

      integer e,eg,f,buf(30)

      if(wdsizi.eq.8) then
        call copyi4(eg,buf(1),1) !1-2
        e  = gllel(eg)

        call copyi4(f,buf(3),1) !3-4

        call copy  (bl(1,f,e),buf(5),5) !5--14
        call chcopy(cbl( f,e),buf(15),3)!15-16

        if(nelt.ge.1000000.and.cbl(f,e).eq.'P  ')
     $   call copyi4(bl(1,f,e),buf(5),1) !Integer assign connecting P element

      else
        eg = buf(1)
        e  = gllel(eg)
        f  = buf(2)

        call copy4r ( bl(1,f,e),buf(3),5)
        call chcopy (cbl(  f,e),buf(8),3)

        if (nelgt.ge.1000000.and.cbl(f,e).eq.'P  ')
     $     bl(1,f,e) = buf(3) ! Integer assign of connecting periodic element
      endif

c      write(6,1) eg,e,f,cbl(f,e),' CBC',nid
c  1   format(2i8,i4,2x,a3,a4,i8)

      return
      end
c-----------------------------------------------------------------------
      subroutine bin_rd1_mesh(ifbswap)    ! version 1 of binary reader

      include 'SIZE'
      include 'TOTAL'
      logical ifbswap

      integer e,eg,buf(55)

      if (nio.eq.0) write(6,*)    '  reading mesh '

      nwds = (1 + ldim*(2**ldim))*(wdsizi/4) ! group + 2x4 for 2d, 3x8 for 3d
      len  = 4*nwds                          ! 4 bytes / wd

      if (nwds.gt.55.or.isize.gt.4) then
         write(6,*) nid,' Error in bin_rd1_mesh: buf size',nwds,isize
         call exitt
      endif

      call nekgsync()

      niop = 10
      do k=1,8
         if (nelgt/niop .lt. 100) goto 10
         niop = niop*10
      enddo
   10 continue

      ierr  = 0
      ierr2 = 0
      len1  = 4
      do eg=1,nelgt             ! sync NOT needed here

         mid = gllnid(eg)
         e   = gllel (eg)
#ifdef DEBUG
         if (nio.eq.0.and.mod(eg,niop).eq.0) write(6,*) eg,' mesh read'
#endif
         if (mid.ne.nid.and.nid.eq.0) then              ! read & send

            if(ierr.eq.0) then
              call byte_read  (buf,nwds,ierr)
              call csend(e,ierr,len1,mid,0)
              if(ierr.eq.0) call csend(e,buf,len,mid,0)
            else
              call csend(e,ierr,len1,mid,0)
            endif

         elseif (mid.eq.nid.and.nid.ne.0) then          ! recv & process

            call crecv      (e,ierr,len1)
            if(ierr.eq.0) then
              call crecv      (e,buf,len)
              call buf_to_xyz (buf,e,ifbswap,ierr2)
            endif
 
         elseif (mid.eq.nid.and.nid.eq.0) then          ! read & process

            if(ierr.eq.0) then
              call byte_read  (buf,nwds,ierr)
              call buf_to_xyz (buf,e,ifbswap,ierr2)
            endif
         endif

      enddo
      ierr = ierr + ierr2
      call err_chk(ierr,'Error reading .re2 mesh. Abort. $')

      return
      end
c-----------------------------------------------------------------------
      subroutine bin_rd1_curve (ifbswap) ! v. 1 of curve side reader

      include 'SIZE'
      include 'TOTAL'
      logical ifbswap

      integer e,eg,buf(55)
      real rcurve

      nwds = (2 + 1 + 5)*(wdsizi/4) !eg+iside+ccurve+curve(6,:,:) !only 5 in rea
      len  = 4*nwds      ! 4 bytes / wd

      if (nwds.gt.55.or.isize.gt.4) then
         write(6,*)nid,' Error in bin_rd1_curve: buf size',nwds,isize
         call exitt
      endif

      call nekgsync()

      ierr = 0
      len1 = 4
      if (nid.eq.0) then  ! read & send/process

         if(wdsizi.eq.8) then
           call byte_read(rcurve,2,ierr)
           if (ifbswap) call byte_reverse8(rcurve,2,ierr)
           ncurve = rcurve
         else
           call byte_read(ncurve,1,ierr)
           if (ifbswap) call byte_reverse(ncurve,1,ierr)
         endif

         if(ncurve.ne.0) write(6,*) '  reading curved sides '
         do k=1,ncurve
           if(ierr.eq.0) then
              call byte_read(buf,nwds,ierr)
              if(wdsizi.eq.8) then
                if(ifbswap) call byte_reverse8(buf,nwds-2,ierr)
                call copyi4(eg,buf(1),1)  !1,2
              else
                if (ifbswap) call byte_reverse(buf,nwds-1,ierr) ! last is char
                eg  = buf(1)
              endif

              mid = gllnid(eg)
              if (mid.eq.0.and.ierr.eq.0) then
                 call buf_to_curve(buf)
              else
                 if(ierr.eq.0) then
                   call csend(mid,buf,len,mid,0)
                 else
                   goto 98
                 endif
              endif
           else
              goto 98
           endif
         enddo
  98     call buf_close_out  ! notify all procs: no more data

      else               ! wait for data from node 0

         ncurve_mx = 12*nelt
         do k=1,ncurve_mx+1   ! +1 to make certain we receive the close-out

            call crecv(nid,buf,len)
            if(wdsizi.eq.8) then 
               call copyi4(ichk,buf(1),1)
               if(ichk.eq.0) goto 99
               call buf_to_curve(buf)
            elseif (buf(1).eq.0) then
               goto 99
            else
               call buf_to_curve(buf)
            endif
            
         enddo
   99    call buf_close_out

      endif
      call err_chk(ierr,'Error reading .re2 curved data. Abort.$')


      return
      end
c-----------------------------------------------------------------------
      subroutine bin_rd1_bc (cbl,bl,ifbswap) ! v. 1 of bc reader

      include 'SIZE'
      include 'TOTAL'
      logical ifbswap

      character*3 cbl(6,lelt)
      real         bl(5,6,lelt)

      integer e,eg,buf(55)
      real rbc_max

      nwds = (2 + 1 + 5)*(wdsizi/4)   ! eg + iside + cbc + bc(5,:,:)
      len  = 4*nwds      ! 4 bytes / wd

      if (nwds.gt.55.or.isize.gt.4) then
         write(6,*) nid,' Error in bin_rd1_bc: buf size',nwds,isize
         call exitt
      endif

      do e=1,nelt   ! fill up cbc w/ default
      do k=1,6
         cbl(k,e) = 'E  '
      enddo
      enddo

      call nekgsync()
      ierr=0
      len1=4
      if (nid.eq.0) then  ! read & send/process
  
         if(wdsizi.eq.8) then
           call byte_read(rbc_max,2,ierr)
           if (ifbswap) call byte_reverse8(rbc_max,2,ierr) ! last is char
           nbc_max = rbc_max
         else
           call byte_read(nbc_max,1,ierr)
           if (ifbswap) call byte_reverse(nbc_max,1,ierr) ! last is char
         endif

         if(nbc_max.ne.0) write(6,*) '  reading bc for ifld',ifield
         do k=1,nbc_max
c           write(6,*) k,' dobc1 ',nbc_max
            if(ierr.eq.0) then
               call byte_read(buf,nwds,ierr)
               if(wdsizi.eq.8) then
                 if (ifbswap) call byte_reverse8(buf,nwds-2,ierr)
                 call copyi4(eg,buf(1),1) !1&2 of buf
               else
                 if (ifbswap) call byte_reverse(buf,nwds-1,ierr) ! last is char
                 eg  = buf(1)
               endif
               mid = gllnid(eg)
c              write(6,*) k,' dobc3 ',eg,mid

               if (mid.eq.0.and.ierr.eq.0) then
                   call buf_to_bc(cbl,bl,buf)
               else
c                  write(6,*) mid,' sendbc1 ',eg
                   if(ierr.eq.0) then
                     call csend(mid,buf,len,mid,0)
                   else
                     goto 98
                   endif
c                  write(6,*) mid,' sendbc2 ',eg
               endif
c              write(6,*) k,' dobc2 ',nbc_max,eg
            else
               goto 98
            endif
         enddo
c        write(6,*) mid,' bclose ',eg,nbc_max
  98     call buf_close_outv ! notify all procs: no more data

      else               ! wait for data from node 0

         nbc_max = 2*ldim*nelt
         do k=1,nbc_max+1  ! Need one extra !

c           write(6,*) nid,' recvbc1',k
            call crecv(nid,buf,len)
c           write(6,*) nid,' recvbc2',k,buf(1)

            if(wdsizi.eq.8) then 
               call copyi4(ichk,buf(1),1)
               if(ichk.eq.0) goto 99
               call buf_to_bc(cbl,bl,buf)
            elseif (buf(1).eq.0) then
                goto 99
            else
                call buf_to_bc(cbl,bl,buf)
            endif
            
         enddo
   99    call buf_close_outv

      endif

      call err_chk(ierr,'Error reading boundary data for re2. Abort.$')

      return
      end
c-----------------------------------------------------------------------
      subroutine buf_close_outv  ! this is the stupid O(P) formulation

      include 'SIZE'
      include 'PARALLEL'
      integer*4 zero
      real      rzero

      len   = wdsizi
      rzero = 0
      zero  = 0
c     write(6,*) nid,' bufclose'
      if (nid.eq.0) then
         do mid=1,np-1
            if(wdsizi.eq.8)call csend(mid,rzero,len,mid,0)
            if(wdsizi.eq.4)call csend(mid, zero,len,mid,0)
c           write(6,*) mid,' sendclose'
         enddo
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine buf_close_out  ! this is the stupid O(P) formulation

      include 'SIZE'
      include 'PARALLEL'
      integer*4 zero
      real      rzero

c     len  = 4
      len   = wdsizi
      zero = 0
      rzero = 0
      if (nid.eq.0) then
         do mid=1,np-1
            if(wdsizi.eq.8)call csend(mid,rzero,len,mid,0)
            if(wdsizi.eq.4)call csend(mid, zero,len,mid,0)
         enddo
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine read_re2_hdr(ifbswap, ifverbose) ! open file & chk for byteswap

      include 'SIZE'
      include 'TOTAL'

      logical ifbswap, ifverbose
      logical if_byte_swap_test

      integer fnami (33)
      character*132 fname
      equivalence (fname,fnami)

      character*132 hdr
      character*5 version
      real*4      test

      logical iffound

      ierr=0

      if (nid.eq.0) then
         if (ifverbose) write(6,'(A,A)') ' Reading ', re2fle
         call izero(fnami,33)
         m = indx2(re2fle,132,' ',1)-1
         call chcopy(fname,re2fle,m)

         inquire(file=fname, exist=iffound)
         if(.not.iffound) ierr = 1
      endif
      call err_chk(ierr,' Cannot find re2 file!$')

      if (nid.eq.0) then
         call byte_open(fname,ierr)
         if(ierr.ne.0) goto 100
         call byte_read(hdr,20,ierr)
         if(ierr.ne.0) goto 100

         read (hdr,1) version,nelgt,ldimr,nelgv
    1    format(a5,i9,i3,i9)
 
         wdsizi = 4
         if(version.eq.'#v002') wdsizi = 8
         if(version.eq.'#v003') then
           wdsizi = 8
           param(32) = 1
         endif

         call byte_read(test,1,ierr)
         if(ierr.ne.0) goto 100
         ifbswap = if_byte_swap_test(test,ierr)
         if(ierr.ne.0) goto 100
        
         call byte_close(ierr)
      endif
 
 100  call err_chk(ierr,'Error reading re2 header$')

      call bcast(wdsizi, ISIZE)
      call bcast(ifbswap,LSIZE)
      call bcast(nelgv  ,ISIZE)
      call bcast(nelgt  ,ISIZE)
      call bcast(ldimr  ,ISIZE)
      call bcast(param(32),WDSIZE)

      if(wdsize.eq.4.and.wdsizi.eq.8) 
     $   call exitti('wdsize=4 & wdsizi(re2)=8 not compatible$',wdsizi)

      return
      end

c-----------------------------------------------------------------------
      subroutine calcz(d,e,n,dmax,dmin,z,ierr)
c
c     Num. Rec. 2nd Ed., p.473
c
c     Note:  d(1:n) is the diagonal of the sym. tridiagonal matrix
c            e(1:n) is the upper diagonal of the tridiagonal matrix,
c                   WITH e(n) ARBITRARY (a slight shift from Num.Rec.)
c
c            z(n:n) is the packed array of eigenvectors
c
      real  d(n),e(n),z(n,n)
      real  smalln,small
c
      call ident(z,n)
      one = 1.
c
c     Find smallest number  (pff mod to Num. Rec. 2nd Ed., p.473)
c
      small = 0.5
      do i = 1,100
         smalln = small * small
         if (smalln .eq.0) then
            do j=1,1000
               smalln = 0.5*small
               if (smalln .eq.0) goto 10
               small = smalln
            enddo
         endif
         small = smalln
      enddo
   10 continue
      small = 10.*small
      small = max(small,1e-99)
      
c     write(6,*) 'this is small:',small
c
      do 15 l=1,n
         iter = 0
c
    1    do 12 m=l,n-1
            dd = abs( d(m) ) + abs( d(m+1) )
            de = e(m) + dd
            df = abs(dd - de)
c           write(6,112) iter,m,'de:',dd,de,df,small
            if ( df .le. small ) goto 2
   12    continue
  112    format(i3,i9,1x,a3,1p4e16.8)
         m = n
c
    2    if ( m .ne. l ) then
            if ( iter .eq. 600 ) then
               write (6,*) 'too many iterations in calc'
c              n10 = min(n,10)
c              do i=1,n
c                 write(6,9) d(i),(z(i,j),j=1,n10)
c              enddo
c   9          format(1pe12.4,' e:',1p10e12.4)
c              call exitt
               ierr=1
               return
            endif
c
            iter = iter + 1
            g = ( d(l+1) - d(l) ) / ( 2.0 * e(l) )
            r = pythag(g,one)
            g = d(m) - d(l) + e(l)/(g+sign(r,g))
            s = 1.0
            c = 1.0
            p = 0.0
c
            do 14 i = m-1,l,-1
               f = s * e(i)
               b = c * e(i)
               r = pythag(f,g)
               e(i+1) = r
               if ( abs(r) .le. small ) then
                  d(i+1) = d(i+1) - p
                  e(m)   = 0.
                  goto 1
               endif
               s = f/r
               c = g/r
               g = d(i+1) - p
               r = ( d(i)-g )*s + 2.*c*b
               p = s*r
               d(i+1) = g + p
               g = c*r - b
c      ...     find eigenvectors ... (new, 11/19/94, pff, p.363. Num.Rec.I.)
               do 13 k=1,n
                  f = z(k,i+1)
                  z(k,i+1) = s*z(k,i)+c*f
                  z(k,i  ) = c*z(k,i)-s*f
   13          continue
c      ...     end of eigenvector section ... 
   14       continue
c
            d(l) = d(l) - p
            e(l) = g
            e(m) = 0.0
            goto 1
         endif
c
   15 continue
c
c     write (8,8) (d(j),j=1,n)
c   8 format('eig:',8f10.4)
c
      dmin = d(1)
      dmax = d(1)
      do 40 i = 1 , n
        dmin = min( d(i) , dmin )
        dmax = max( d(i) , dmax )
   40 continue
c
c     Output eigenvectors
c
c     n10 = min(n,10)
c     do i=1,n
c        write(6,9) d(i),(z(i,j),j=1,n10)
c     enddo
c   9 format(1pe12.4,' e:',1p10e12.4)
c
      ierr=0
      return
      end
c-----------------------------------------------------------------------
      function pythag(a,b)
c
c     Compute sqrt(a*a + b*b) w/o under- or over-flow.
c
      absa=abs(a) 
      absb=abs(b) 
      if (absa.gt.absb) then
         pythag = absa*sqrt(1. + (absb/absa)**2 )
      else
         if (absb.eq.0.) then
            pythag = 0.
         else
            pythag = absb*sqrt(1. + (absa/absb)**2 )
         endif
      endif
      return
      end
c-----------------------------------------------------------------------
      subroutine ident(a,n)
      real  a(n,n)
      call rzero(a,n*n)
      do i=1,n
         a(i,i) = 1.0
      enddo
      return
      end
c-----------------------------------------------------------------------

c-----------------------------------------------------------------------
      subroutine cdscal (igeom)
C
C     Solve the convection-diffusion equation for passive scalar IPSCAL
C
      include 'SIZE'
      include 'INPUT'
      include 'GEOM'
      include 'MVGEOM'
      include 'SOLN'
      include 'MASS'
      include 'TSTEP'
      COMMON  /CPRINT/ IFPRINT
      LOGICAL          IFPRINT
      LOGICAL          IFCONV

      COMMON /SCRNS/ TA(LX1,LY1,LZ1,LELT)
     $              ,TB(LX1,LY1,LZ1,LELT)
      COMMON /SCRVH/ H1(LX1,LY1,LZ1,LELT)
     $              ,H2(LX1,LY1,LZ1,LELT)

      include 'ORTHOT'

      if (ifdgfld(ifield)) then
         call cdscal_dg(igeom)
         return
      endif


      ifld1 = ifield-1
      napproxt(1,ifld1) = laxtt

      nel    = nelfld(ifield)
      n   = lx1*ly1*lz1*nel

      if (igeom.eq.1) then   ! geometry at t^{n-1}

         call makeq
         call lagscal

      else                   ! geometry at t^n

         IF (IFPRINT) THEN
            IF (IFIELD.EQ.2.AND.NID.EQ.0)
     $          WRITE (6,*) ' Temperature/Passive scalar solution'
         ENDIF

         if1=ifield-1
         write(name4t,1) if1-1
    1    format('PS',i2)
         if(ifield.eq.2) write(name4t,'(A4)') 'TEMP'

C
C        New geometry
C
         isd = 1
         if (ifaxis.and.ifaziv.and.ifield.eq.2) isd = 2
c        if (ifaxis.and.ifmhd) isd = 2 !This is a problem if T is to be T!

         do 1000 iter=1,nmxnl ! iterate for nonlin. prob. (e.g. radiation b.c.)

         intype = 0
         if (iftran) intype = -1
         call sethlm  (h1,h2,intype)
         call bcneusc (ta,-1)
         call add2    (h2,ta,n)
         call bcdirsc (t(1,1,1,1,ifield-1))
         call axhelm  (ta,t(1,1,1,1,ifield-1),h1,h2,imesh,ISD)
         call sub3    (tb,bq(1,1,1,1,ifield-1),ta,n)
         call bcneusc (ta,1)
         call add2    (tb,ta,n)

         if(iftmsh(ifield)) then
           call hsolve  (name4t,TA,TB,H1,H2 
     $                   ,tmask(1,1,1,1,ifield-1)
     $                   ,tmult(1,1,1,1,ifield-1)
     $                   ,imesh,tolht(ifield),nmxt(ifield-1),1
     $                   ,approxt(1,0,ifld1),napproxt(1,ifld1),bintm1)
         else
           call hsolve  (name4t,TA,TB,H1,H2 
     $                   ,tmask(1,1,1,1,ifield-1)
     $                   ,tmult(1,1,1,1,ifield-1)
     $                   ,imesh,tolht(ifield),nmxt(ifield-1),1
     $                   ,approxt(1,0,ifld1),napproxt(1,ifld1),binvm1)
         endif 

         call add2    (t(1,1,1,1,ifield-1),ta,n)

         call cvgnlps (ifconv) ! Check convergence for nonlinear problem 
         if (ifconv) goto 2000

C        Radiation case, smooth convergence, avoid flip-flop (ER).
         call cmult (ta,0.5,n)
         call sub2  (t(1,1,1,1,ifield-1),ta,n)

 1000    continue
 2000    continue

      endif

      return
      end

c-----------------------------------------------------------------------
      subroutine makeuq

c     Fill up user defined forcing function and collocate will the
c     mass matrix on the Gauss-Lobatto mesh.

      include 'SIZE'
      include 'INPUT'
      include 'MASS'
      include 'SOLN'
      include 'TSTEP'

      n = lx1*ly1*lz1*nelfld(ifield)

      if (.not.ifcvfld(ifield)) time = time-dt ! Set time to t^n-1 for user function

      if (nio.eq.0.and.loglevel.gt.2) 
     $   write(6,*) 'makeuq', ifield, time
      call setqvol(bq(1,1,1,1,ifield-1))
      call col2   (bq(1,1,1,1,ifield-1) ,bm1,n)

      if (.not.ifcvfld(ifield)) time = time+dt ! Restore time

      return
      end
c-----------------------------------------------------------------------
      subroutine setqvol(bql)

c     Set user specified volumetric forcing function (e.g. heat source).

      include 'SIZE'
      include 'INPUT'
      include 'SOLN'
      include 'TSTEP'
      include 'CTIMER'

      real bql(lx1*ly1*lz1,lelt)

#ifdef TIMER
      etime1=dnekclock()
#endif

      nel   = nelfld(ifield)
      nxyz1 = lx1*ly1*lz1
      n     = nxyz1*nel

      do iel=1,nel

         call nekuq (bql,iel) ! ONLY SUPPORT USERQ - pff, 3/08/16

c        igrp = igroup(iel)
c        if (matype(igrp,ifield).eq.1) then ! constant source within a group
c           cqvol = cpgrp(igrp,ifield,3)
c           call cfill (bql(1,iel),cqvol,nxyz1)
c        else  !  pff 2/6/96 ............ default is to look at userq
c           call nekuq (bql,iel)
c        endif

      enddo
c
c 101 FORMAT(' Wrong material type (',I3,') for group',I3,', field',I2
c    $    ,/,' Aborting in SETQVOL.')
C  

#ifdef TIMER
      tusfq=tusfq+(dnekclock()-etime1)
#endif
 
      return
      end
C
      subroutine nekuq (bql,iel)
C------------------------------------------------------------------
C
C     Generate user-specified volumetric source term (temp./p.s.)
C
C------------------------------------------------------------------
      include 'SIZE'
      include 'SOLN'
      include 'MASS'
      include 'PARALLEL'
      include 'TSTEP'
      include 'NEKUSE'
      include 'INPUT'
c
      real bql(lx1,ly1,lz1,lelt)
c
      ielg = lglel(iel)
      do 10 k=1,lz1
      do 10 j=1,ly1
      do 10 i=1,lx1
         if (optlevel.le.2) call nekasgn (i,j,k,iel)
         qvol = 0.0
         call userq   (i,j,k,ielg)
         bql(i,j,k,iel) = qvol
 10   continue

      return
      end
c-----------------------------------------------------------------------
      subroutine convab
C---------------------------------------------------------------
C
C     Eulerian scheme, add convection term to forcing function 
C     at current time step.
C
C---------------------------------------------------------------
      include 'SIZE'
      include 'SOLN'
      include 'MASS'
      include 'TSTEP'

      common /scruz/ ta (lx1*ly1*lz1*lelt)

      nel = nelfld(ifield)
      n   = lx1*ly1*lz1*nel

      call convop  (ta,t(1,1,1,1,ifield-1))
      do i=1,n
        bq(i,1,1,1,ifield-1) = bq (i,1,1,1,ifield-1)
     $                       - bm1(i,1,1,1)*ta(i)*vtrans(i,1,1,1,ifield)
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine makeabq
C
C     Sum up contributions to 3rd order Adams-Bashforth scheme.
C
      include 'SIZE'
      include 'SOLN'
      include 'TSTEP'

      ab0   = ab(1)
      ab1   = ab(2)
      ab2   = ab(3)
      nel   = nelfld(ifield)
      n     = lx1*ly1*lz1*nel

      do i=1,n
         ta=ab1*vgradt1(i,1,1,1,ifield-1)+ab2*vgradt2(i,1,1,1,ifield-1)
         vgradt2(i,1,1,1,ifield-1)=vgradt1(i,1,1,1,ifield-1)
         vgradt1(i,1,1,1,ifield-1)=bq     (i,1,1,1,ifield-1)
         bq     (i,1,1,1,ifield-1)=bq     (i,1,1,1,ifield-1)*ab0+ta
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine makebdq
C-----------------------------------------------------------------------
C
C     Add contributions to F from lagged BD terms.
C
C-----------------------------------------------------------------------
      include 'SIZE'
      include 'TOTAL'

      parameter (lt=lx1*ly1*lz1*lelt)
      common /scrns/ tb(lt),h2(lt)

      nel   = nelfld(ifield)
      n     = lx1*ly1*lz1*nel
   
      const = 1./dt
      do i=1,n
         h2(i)=const*vtrans(i,1,1,1,ifield)
         tb(i)=bd(2)*bm1(i,1,1,1)*t(i,1,1,1,ifield-1)
      enddo

      do ilag=2,nbd
         if (ifgeom) then
            do i=1,n
               ta=bm1lag(i,1,1,1,ilag-1)*tlag(i,1,1,1,ilag-1,ifield-1)
               tb(i)=tb(i)+ta*bd(ilag+1)
            enddo
         else
            do i=1,n
               ta=bm1(i,1,1,1)*tlag(i,1,1,1,ilag-1,ifield-1)
               tb(i)=tb(i)+ta*bd(ilag+1)
            enddo
         endif
      enddo

      call addcol3 (bq(1,1,1,1,ifield-1),tb,h2,n)

      return
      end
c-----------------------------------------------------------------------
      subroutine lagscal   !  Keep old passive scalar field(s) 

      include 'SIZE'
      include 'TOTAL'

      n = lx1*ly1*lz1*nelfld(ifield)

      do ilag=nbdinp-1,2,-1
         call copy (tlag(1,1,1,1,ilag  ,ifield-1),
     $              tlag(1,1,1,1,ilag-1,ifield-1),n)
      enddo

      call copy (tlag(1,1,1,1,1,ifield-1),t(1,1,1,1,ifield-1),n)

      return
      end
c-----------------------------------------------------------------------
      subroutine outfldrq (x,txt10,ichk)
      include 'SIZE'
      include 'TSTEP'
      real x(lx1,ly1,lz1,lelt)
      character*10 txt10
c
      integer idum,e
      save idum
      data idum /-3/

      if (idum.lt.0) return
c
C
      mtot = lx1*ly1*lz1*nelv
      if (lx1.gt.8.or.nelv.gt.16) return
      xmin = glmin(x,mtot)
      xmax = glmax(x,mtot)
c
      nell = nelt
      rnel = nell
      snel = sqrt(rnel)+.1
      ne   = snel
      ne1  = nell-ne+1
      k = 1
      do ie=1,1
         ne = 0
         write(6,116) txt10,k,ie,xmin,xmax,istep,time
         do l=0,1
            write(6,117) 
            do j=ly1,1,-1
              if (lx1.eq.2) write(6,102) ((x(i,j,k,e+l),i=1,lx1),e=1,1)
              if (lx1.eq.3) write(6,103) ((x(i,j,k,e+l),i=1,lx1),e=1,1)
              if (lx1.eq.4) write(6,104) ((x(i,j,k,e+l),i=1,lx1),e=1,1)
              if (lx1.eq.5) write(6,105) ((x(i,j,k,e+l),i=1,lx1),e=1,1)
              if (lx1.eq.6) write(6,106) ((x(i,j,k,e+l),i=1,lx1),e=1,1)
              if (lx1.eq.7) write(6,107) ((x(i,j,k,e+l),i=1,lx1),e=1,1)
              if (lx1.eq.8) write(6,118) ((x(i,j,k,e+l),i=1,lx1),e=1,1)
            enddo
         enddo
      enddo
C
  102 FORMAT(4(2f9.5,2x))
  103 FORMAT(4(3f9.5,2x))
  104 FORMAT(4(4f7.3,2x))
  105 FORMAT(5f9.5,10x,5f9.5)
  106 FORMAT(6f9.5,5x,6f9.5)
  107 FORMAT(7f8.4,5x,7f8.4)
  108 FORMAT(8f8.4,4x,8f8.4)
  118 FORMAT(8f12.9)
c
  116 FORMAT(  /,5X,'     ^              ',/,
     $    5X,'   Y |              ',/,
     $    5X,'     |              ',A10,/,
     $    5X,'     +---->         ','Plane = ',I2,'/',I2,2x,2e12.4,/,
     $    5X,'       X            ','Step  =',I9,f15.5)
  117 FORMAT(' ')
c
      if (ichk.eq.1.and.idum.gt.0) call checkit(idum)
      return
      end
c-----------------------------------------------------------------------
      subroutine cdscal_expl (igeom)
C
C     explicit convection-diffusion equation for passive scalar
C
      include 'SIZE'
      include 'INPUT'
      include 'GEOM'
      include 'MVGEOM'
      include 'SOLN'
      include 'MASS'
      include 'TSTEP'
      common  /cprint/ ifprint
      logical          ifprint
      logical          ifconv

      common /scrns/ ta(lx1,ly1,lz1,lelt)
     $              ,tb(lx1,ly1,lz1,lelt)
      common /scrvh/ h1(lx1,ly1,lz1,lelt)
     $              ,h2(lx1,ly1,lz1,lelt)


c     QUESTIONABLE support for Robin BC's at this point! (5/15/08)

      nel    = nelfld(ifield)
      n   = lx1*ly1*lz1*nel

      if (igeom.eq.1) then   ! geometry at t^{n-1}

         call makeq
         call lagscal

      else                   ! geometry at t^n

         if (nio.eq.0) write (6,*) istep,ifield,' explicit step'


C        New geometry

         isd = 1
         if (ifaxis.and.ifmhd) isd = 2 !This is a problem if T is to be T!

         intype = 0
         if (iftran) intype = -1
         call sethlm  (h1,h2,intype)

         call bcneusc (ta,-1)       ! Modify diagonal for Robin condition
         call add2    (h2,ta ,n)
         call col2    (h2,BM1,n)

         call bcneusc (tb,1)        ! Modify rhs for flux bc
         call add2    (bq(1,1,1,1,ifield-1),tb,n)

         call dssum   (bq(1,1,1,1,ifield-1),lx1,ly1,lz1)
         call dssum   (h2,lx1,ly1,lz1)

         call invcol3 (t(1,1,1,1,ifield-1),bq(1,1,1,1,ifield-1),h2,n)

         call bcdirsc (t(1,1,1,1,ifield-1)) ! --> no mask needed

      endif                   ! geometry at t^n

      return
      end
c-----------------------------------------------------------------------
      subroutine diffab  ! explicit treatment of diffusion operator
c
c     Eulerian scheme, add diffusion term to forcing function 
c     at current time step.
c

      include 'SIZE'
      include 'SOLN'
      include 'MASS'
      include 'TSTEP'
      include 'INPUT'

      common /scruz/ ta(lx1,ly1,lz1,lelt)
     $              ,h2(lx1,ly1,lz1,lelt)

      nel = nelfld(ifield)
      n   = lx1*ly1*lz1*nel

      intype = 0
      if (iftran) intype = -1

      isd = 1
      if (ifaxis.and.ifmhd) isd = 2 !This is a problem if T is to be T!

      imesh = 1
c      if (iftmsh(ifield)) imesh=2

      call rzero   (h2,n)
      call axhelm  (ta,t(1,1,1,1,ifield-1),vdiff(1,1,1,1,ifield)
     $             ,h2,imesh,isd)
      call sub2    (bq(1,1,1,1,ifield-1),ta,n)

      return
      end
c-----------------------------------------------------------------------
      subroutine set_eta_alpha2

c     Set up required dg terms, e.g., alpha, eta, etc.
c     Face weight: .5 interior, 1. boundary

      include 'SIZE'
      include 'TOTAL'
      common /mysedg/ eta


      integer e,f,pf

      nface = 2*ldim
      call dsset(lx1,ly1,lz1)

      eta =  5         !   Semi-optimized value, single domain

      do e=1,nelfld(ifield)
      do f=1,nface

         pf     = eface1(f)
         js1    = skpdat(1,pf)
         jf1    = skpdat(2,pf)
         jskip1 = skpdat(3,pf)
         js2    = skpdat(4,pf)
         jf2    = skpdat(5,pf)
         jskip2 = skpdat(6,pf)

         i = 0
         do j2=js2,jf2,jskip2
         do j1=js1,jf1,jskip1
            i = i+1
            a = area(i,1,f,e)  ! Check Fydkowski notes 
            a = a*a*fw(f,e)    ! For ds_avg used below, plus quad weight
            etalph(i,f,e) = eta*(a/bm1(j1,j2,1,e))
c           write(6,*) i,j1,j2,e,f,a,etalph(i,f,e)
         enddo
         enddo
      enddo
      enddo

      call fgslib_gs_op (dg_hndlx,etalph,1,1,0)  ! 1 ==> +

      return
      end
c-----------------------------------------------------------------------
      subroutine fwght(msk1,mult)
      include 'SIZE'
      include 'TOTAL'
      parameter (lx=lx1*ly1*lz1)
      real msk1(lx1,ly1,lz1),mult(lx1,ly1,lz1,1)
      integer e,f

      parameter(lf=lx1*lz1*2*ldim*lelt)
      common /scrdg/uf(lx1*lz1,2*ldim,lelt)



      do i=1,lf
         uf(i,1,1)=1.
      enddo
      call fgslib_gs_op (dg_hndlx,uf,1,1,0)  ! 1 ==> +

      nface = 2*ldim
      do e=1,nelt
      do f=1,nface
         fw(f,e) = 1                        ! Boundary
         if (uf(1,f,e).gt.1.1) fw(f,e)=0.5  ! Interior
      enddo
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine dg_setup
      include 'SIZE'
      include 'TOTAL'

      common /ivrtx/ vertex ((2**ldim)*lelt)
      common /ctmp1/ qs(lx1*ly1*lz1*lelt)
      integer vertex

      logical ifany
      save    ifany
      data    ifany /.false./

      do ifield=1,ldimt1
         if (ifdgfld(ifield)) ifany=.true.
      enddo

      if (ifany) then

        call setup_dg_gs(dg_hndlx,lx1,ly1,lz1,nelt,nelgt,vertex)
        call dg_set_fc_ptr

        param(59)=1
        call geom_reset(1)
        call set_unr
      endif


      n = lx1*ly1*lz1*nelt
      call invers2(binvdg,bm1,n)

      call set_dg_wgts

      return
      end
c-----------------------------------------------------------------------
      subroutine dg_setup2(mask)
      include 'SIZE'
      include 'TOTAL'

      real mask(1)
      common /ctmp0/ qs(lx1*ly1*lz1*lelt)

      integer ifld_last
      save    ifld_last
      data    ifld_last /0/

      if (ifield.eq.ifld_last) return
      ifld_last = ifield

      call fwght  (qs,mask)  ! qs is work array
      call set_eta_alpha2     ! Set eta/h

      return
      end
c-----------------------------------------------------------------------
      subroutine cdscal_dg (igeom)
C
C     Solve the convection-diffusion equation for passive scalar IPSCAL
C
      include 'SIZE'
      include 'TOTAL'
      common  /cprint/ ifprint
      logical          ifprint,ifconv

      parameter (lt=lx1*ly1*lz1*lelt)
      common /scrns/ ta(lt),tb(lt)
      common /scrvh/ h1(lt),h2(lt)

      include 'ORTHOT'  ! This must be fixed

      call dg_setup2(tmask(1,1,1,1,ifield-1))

      nel = nelfld(ifield)
      n   = lx1*ly1*lz1*nel

      if (igeom.eq.1) then   ! old geometry at t^{n-1}

         call makeq
         call lagscal

      else                   ! new geometry at t^n

         if (ifprint.and.nio.eq.0) 
     $      write (6,*) ' Temperature/Passive scalar solution',ifield

         if1=ifield-1
         write(name4t,1) if1-1
    1    format('PS',i2)
         if (ifield.eq.2) write(name4t,'(A4)') 'TEMP'
 
         isd = 1
         if (ifaxis.and.ifaziv.and.ifield.eq.2) isd = 2
c        if (ifaxis.and.ifmhd) isd = 2 !This is a problem if T is to be T!

         intype = 0
         if (iftran) intype = -1
         call sethlm  (h1,h2,intype)

c        call bcneusc (ta,-1)     !! Not Yet supported for DG
c        call add2    (h2,ta,n)   !! Not Yet supported for DG

         call rzero             (tb,n)
         call bcdirsc           (   t (1,1,1,1,ifield-1))
         call conv_bdry_dg_weak (tb,t (1,1,1,1,ifield-1))
         call hxdg_surfa        (tb,t (1,1,1,1,ifield-1),h1,h2)
         call add2              (tb,bq(1,1,1,1,ifield-1),n)

         call hmholtz_dg(name4t,t(1,1,1,1,ifield-1),tb,h1,h2 
     $                   ,tmask(1,1,1,1,ifield-1)
     $                   ,tolht(ifield),nmxt(ifield-1))

      endif  ! End of IGEOM branch.

      return
      end
c-----------------------------------------------------------------------

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Classic i-k-j matrix multiplication. No data race pairs.


program DRB060_matrixmultiply_orig_no
    use omp_lib
    implicit none

    integer :: N,M,K, len, i, j, l
    real, dimension(:,:), allocatable :: a, b, c

    len = 100
    N=len
    M=len
    K=len

    allocate (a(N,M))
    allocate (b(M,K))
    allocate (c(K,N))

    !$omp parallel do private(j, l)
    do i = 1, N
        do l = 1, K
            do j = 1, M
                c(i,j) = c(i,j)+a(i,l)*b(l,j)
            end do
        end do
    end do
    !$omp end parallel do

    deallocate(a,b,c)
end program

      subroutine load_fld(string)

      include 'SIZE'
      include 'INPUT'
      include 'RESTART'

      character string*(*)

      l = ltrunc(string,len(string))
      if(l.gt.132) call exitti('invalid string length$',l)

      call blank  (initc(1),132)
      call chcopy (initc(1),string,l)
      call setics

      return
      end
c-----------------------------------------------------------------------
      subroutine lambda2(l2)
c
c     Generate Lambda-2 vortex of Jeong & Hussein, JFM '95
c
      include 'SIZE'
      include 'TOTAL'

      real l2(lx1,ly1,lz1,1)

      parameter (lxyz=lx1*ly1*lz1)

      real gije(lxyz,ldim,ldim)
      real vv(ldim,ldim),ss(ldim,ldim),oo(ldim,ldim),w(ldim,ldim)
      real lam(ldim)

      nxyz = lx1*ly1*lz1
      n    = nxyz*nelv

      do ie=1,nelv
         ! Compute velocity gradient tensor
         call comp_gije(gije,vx(1,1,1,ie),vy(1,1,1,ie),vz(1,1,1,ie),ie)

         do l=1,nxyz
            ! decompose into symm. and antisymm. part
            do j=1,ldim
            do i=1,ldim
               ss(i,j) = 0.5*(gije(l,i,j)+gije(l,j,i))
               oo(i,j) = 0.5*(gije(l,i,j)-gije(l,j,i))
            enddo
            enddo
         
            call rzero(vv,ldim*ldim)
            do j=1,ldim
            do i=1,ldim
            do k=1,ldim
               vv(i,j) = vv(i,j) + ss(i,k)*ss(k,j) + oo(i,k)*oo(k,j)
            enddo
            enddo
            enddo

c           Solve eigenvalue problemand sort 
c           eigenvalues in ascending order.
            call find_lam3(lam,vv,w,ldim,ierr)

            l2(l,1,1,ie) = lam(2)
         enddo
      enddo

      ! smooth field
      ifld   = ifield
      ifield = 1
      wght   = 0.5 
      ncut   = 1
      call filter_s0(l2,wght,ncut,'vortx') 
      ifield = ifld

      return
      end
c-----------------------------------------------------------------------
      subroutine find_lam3(lam,aa,w,ldim,ierr)
      real aa(ldim,ldim),lam(ldim),w(ldim,ldim),lam2
c
c     Use cubic eqn. to compute roots
c
      common /ecmnr/ a,b,c,d,e,f,f2,ef,df,r0,r1
      common /ecmni/ nr
      common /ecmnl/ iffout,ifdefl
      logical        iffout,ifdefl
c
c
      iffout = .false.
      ierr = 0
c
c     2D case....
c
c
      if (ldim.eq.2) then
         a = aa(1,1)
         b = aa(1,2)
         c = aa(2,1)
         d = aa(2,2)
         aq = 1.
         bq = -(a+d)
         cq = a*d-c*b
c
         call quadratic(x1,x2,aq,bq,cq,ierr)
c 
         lam(1) = min(x1,x2)
         lam(2) = max(x1,x2)
c
         return
      endif
c
c     Else ...  3D case....
c                                    a d e
c     Get symmetric 3x3 matrix       d b f
c                                    e f c
c
      a = aa(1,1)
      b = aa(2,2)
      c = aa(3,3)
      d = 0.5*(aa(1,2)+aa(2,1))
      e = 0.5*(aa(1,3)+aa(3,1))
      f = 0.5*(aa(2,3)+aa(3,2))
      ef = e*f
      df = d*f
      f2 = f*f
c
c
c     Use cubic eqn. to compute roots
c
c     ax = a-x
c     bx = b-x
c     cx = c-x
c     y = ax*(bx*cx-f2) - d*(d*cx-ef) + e*(df-e*bx)
c
      a1 = -(a+b+c)
      a2 =  (a*b+b*c+a*c) - (d*d+e*e+f*f)
      a3 =  a*f*f + b*e*e + c*d*d - a*b*c - 2*d*e*f
c
      call cubic  (lam,a1,a2,a3,ierr)
      call sort   (lam,w,3)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine quadratic(x1,x2,a,b,c,ierr)
c
c     Stable routine for computation of real roots of quadratic
c
      ierr = 0
      x1 = 0.
      x2 = 0.
c
      if (a.eq.0.) then
         if (b.eq.0) then
            if (c.ne.0) then
c              write(6,10) x1,x2,a,b,c
               ierr = 1
            endif
            return
         endif
         ierr = 2
         x1 = -c/b
c        write(6,11) x1,a,b,c
         return
      endif
c
      d = b*b - 4.*a*c
      if (d.lt.0) then
         ierr = 1
c        write(6,12) a,b,c,d
         return
      endif
      if (d.gt.0) d = sqrt(d)
c
      if (b.gt.0) then
         x1 = -2.*c / ( d+b )
         x2 = -( d+b ) / (2.*a)
      else
         x1 =  ( d-b ) / (2.*a)
         x2 = -2.*c / ( d-b )
      endif
c
   10 format('ERROR: Both a & b zero in routine quadratic NO ROOTS.'
     $      ,1p5e12.4)
   11 format('ERROR: a = 0 in routine quadratic, only one root.'
     $      ,1p5e12.4)
   12 format('ERROR: negative discriminate in routine quadratic.'
     $      ,1p5e12.4)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine cubic(xo,ai1,ai2,ai3,ierr)
      real xo(3),ai1,ai2,ai3
      complex*16 x(3),a1,a2,a3,q,r,d,arg,t1,t2,t3,theta,sq,a13
c
c     Compute real solutions to cubic root eqn. (Num. Rec. v. 1, p. 146)
c     pff/Sang-Wook Lee  Jan 19 , 2004
c
c     Assumption is that all x's are *real*
c
      real*8 twopi
      save   twopi
      data   twopi /6.283185307179586476925286766/
c
      ierr = 0
c
      zero = 0.
      a1   = cmplx(ai1,zero)
      a2   = cmplx(ai2,zero)
      a3   = cmplx(ai3,zero)
c
      q = (a1*a1 - 3*a2)/9.
      if (q.eq.0) goto 999
c
      r = (2*a1*a1*a1 - 9*a1*a2 + 27*a3)/54.
c
      d = q*q*q - r*r
c
c     if (d.lt.0) goto 999
c
      arg   = q*q*q
      arg   = sqrt(arg)
      arg   = r/arg
c
      if (abs(arg).gt.1) goto 999
      theta = acos(abs(arg))
c
      t1    = theta / 3.
      t2    = (theta + twopi) / 3.
      t3    = (theta + 2.*twopi) / 3.
c
      sq  = -2.*sqrt(q)
      a13 = a1/3.
      x(1) = sq*cos(t1) - a13
      x(2) = sq*cos(t2) - a13
      x(3) = sq*cos(t3) - a13
c
      xo(1) = real(x(1))
      xo(2) = real(x(2))
      xo(3) = real(x(3))
c
      return
c
  999 continue   ! failed
      ierr = 1
      call rzero(x,3)

      return
      end
c-----------------------------------------------------------------------
      subroutine comp_gije(gije,u,v,w,e)
c
c                                         du_i
c     Compute the gradient tensor G_ij := ----  ,  for element e
c                                         du_j
c
      include 'SIZE'
      include 'TOTAL'

      real gije(lx1*ly1*lz1,ldim,ldim)
      real u   (lx1*ly1*lz1)
      real v   (lx1*ly1*lz1)
      real w   (lx1*ly1*lz1)

      real ur  (lx1*ly1*lz1)
      real us  (lx1*ly1*lz1)
      real ut  (lx1*ly1*lz1)

      integer e

      n    = lx1-1      ! Polynomial degree
      nxyz = lx1*ly1*lz1

      if (if3d) then     ! 3D CASE

        do k=1,3
          if (k.eq.1) call local_grad3(ur,us,ut,u,n,1,dxm1,dxtm1)
          if (k.eq.2) call local_grad3(ur,us,ut,v,n,1,dxm1,dxtm1)
          if (k.eq.3) call local_grad3(ur,us,ut,w,n,1,dxm1,dxtm1)

          do i=1,nxyz
            dj = jacmi(i,e)

            ! d/dx
            gije(i,k,1) = dj*( 
     $      ur(i)*rxm1(i,1,1,e)+us(i)*sxm1(i,1,1,e)+ut(i)*txm1(i,1,1,e))
            ! d/dy
            gije(i,k,2) = dj*( 
     $      ur(i)*rym1(i,1,1,e)+us(i)*sym1(i,1,1,e)+ut(i)*tym1(i,1,1,e))
            ! d/dz
            gije(i,k,3) = dj*(
     $      ur(i)*rzm1(i,1,1,e)+us(i)*szm1(i,1,1,e)+ut(i)*tzm1(i,1,1,e))

          enddo
        enddo

      elseif (ifaxis) then   ! AXISYMMETRIC CASE
            if(nid.eq.0) write(6,*) 
     &        'ABORT: comp_gije no axialsymmetric support for now'
            call exitt
      else              ! 2D CASE

        do k=1,2
          if (k.eq.1) call local_grad2(ur,us,u,n,1,dxm1,dxtm1)
          if (k.eq.2) call local_grad2(ur,us,v,n,1,dxm1,dxtm1)
          do i=1,nxyz
             dj = jacmi(i,e)
             ! d/dx
             gije(i,k,1)=dj*(ur(i)*rxm1(i,1,1,e)+us(i)*sxm1(i,1,1,e))
             ! d/dy 
             gije(i,k,2)=dj*(ur(i)*rym1(i,1,1,e)+us(i)*sym1(i,1,1,e))
          enddo
        enddo
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine filter_s1(scalar,tf,nx,nel) ! filter scalar field 

      include 'SIZE'

      parameter(lxyz=lx1*ly1*lz1) 
      real scalar(lxyz,1)
      real fh(nx*nx),fht(nx*nx),tf(nx)

      real w1(lxyz,lelt)

c     Build 1D-filter based on the transfer function (tf)
      call build_1d_filt(fh,fht,tf,nx,nio)

c     Filter scalar
      call copy(w1,scalar,lxyz*nel)
      do ie=1,nel
         call tens3d1(scalar(1,ie),w1(1,ie),fh,fht,lx1,lx1)  ! fh x fh x fh x scalar
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine filter_s0(scalar,wght,ncut,name5) ! filter scalar field 

      include 'SIZE'
      include 'TOTAL'

      real scalar(1)
      character*5 name5

      parameter (l1=lx1*lx1)
      real intdv(l1),intuv(l1),intdp(l1),intup(l1),intv(l1),intp(l1)
      save intdv    ,intuv    ,intdp    ,intup    ,intv    ,intp

      common /ctmp0/ intt
      common /screv/ wk1,wk2
      common /scrvh/ zgmv,wgtv,zgmp,wgtp,tmax(100)

      real intt (lx1,lx1)
      real wk1  (lx1,lx1,lx1,lelt)
      real wk2  (lx1,lx1,lx1)
      real zgmv (lx1),wgtv(lx1),zgmp(lx1),wgtp(lx1)


      integer icall
      save    icall
      data    icall /0/

      logical ifdmpflt

      imax = nid
      imax = iglmax(imax,1)
      jmax = iglmax(imax,1)

c    if (icall.eq.0) call build_new_filter(intv,zgm1,lx1,ncut,wght,nio)
      call build_new_filter(intv,zgm1,lx1,ncut,wght,nio)

      icall = 1

      call filterq(scalar,intv,lx1,lz1,wk1,wk2,intt,if3d,fmax)
      fmax = glmax(fmax,1)

      if (nio.eq.0) write(6,1) istep,fmax,name5
    1 format(i8,' sfilt:',1pe12.4,a10)

      return
      end
c-----------------------------------------------------------------------
      subroutine tens3d1(v,u,f,ft,nv,nu)  ! v = F x F x F x u

c     Note: this routine assumes that lx1=ly1=lz1
c
      include 'SIZE'
      include 'INPUT'

      parameter (lw=4*lx1*lx1*lz1)
      common /ctensor/ w1(lw),w2(lw)

      real v(nv,nv,nv),u(nu,nu,nu)
      real f(1),ft(1)

      if (nu*nu*nv.gt.lw) then
         write(6,*) nid,nu,nv,lw,' ERROR in tens3d1. Increase lw.'
         call exitt
      endif

      if (if3d) then
         nuv = nu*nv
         nvv = nv*nv
         call mxm(f,nv,u,nu,w1,nu*nu)
         k=1
         l=1
         do iz=1,nu
            call mxm(w1(k),nv,ft,nu,w2(l),nv)
            k=k+nuv
            l=l+nvv
         enddo
         call mxm(w2,nvv,ft,nu,v,nv)
      else
         call mxm(f ,nv,u,nu,w1,nu)
         call mxm(w1,nv,ft,nu,v,nv)
      endif
      return
      end
c-----------------------------------------------------------------------
      subroutine build_1d_filt(fh,fht,trnsfr,nx,nio)
c
c     This routing builds a 1D filter with transfer function diag()
c
c     Here, nx = number of points
c
      real fh(nx,nx),fht(nx,nx),trnsfr(nx)
c
      parameter (lm=40)
      parameter (lm2=lm*lm)
      common /cfiltr/ phi(lm2),pht(lm2),diag(lm2),rmult(lm),Lj(lm)
     $              , zpts(lm)
      real Lj

      common /cfilti/ indr(lm),indc(lm),ipiv(lm)
c
      if (nx.gt.lm) then
         write(6,*) 'ABORT in set_filt:',nx,lm
         call exitt
      endif

      call zwgll(zpts,rmult,nx)

      kj = 0
      n  = nx-1
      do j=1,nx
         z = zpts(j)
         call legendre_poly(Lj,z,n)
         kj = kj+1
         pht(kj) = Lj(1)
         kj = kj+1
         pht(kj) = Lj(2)
         do k=3,nx
            kj = kj+1
            pht(kj) = Lj(k)-Lj(k-2)
         enddo
      enddo
      call transpose (phi,nx,pht,nx)
      call copy      (pht,phi,nx*nx)
      call gaujordf  (pht,nx,nx,indr,indc,ipiv,ierr,rmult)

      call rzero(diag,nx*nx)
      k=1 
      do i=1,nx
         diag(k) = trnsfr(i)
         k = k+(nx+1)
      enddo

      call mxm  (diag,nx,pht,nx,fh,nx)      !          -1
      call mxm  (phi ,nx,fh,nx,pht,nx)      !     V D V

      call copy      (fh,pht,nx*nx)
      call transpose (fht,nx,fh,nx)

      do k=1,nx*nx
         pht(k) = 1.-diag(k)
      enddo
      np1 = nx+1
      if (nio.eq.0) then
         write(6,6) 'flt amp',(pht (k),k=1,nx*nx,np1)
         write(6,6) 'flt trn',(diag(k),k=1,nx*nx,np1)
   6     format(a8,16f7.4,6(/,8x,16f7.4))
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine mag_tensor_e(mag,aije)
c
c     Compute magnitude of tensor A_e for element e
c
c     mag(A_e) = sqrt( 0.5 (A:A) )
c
      include 'SIZE'
      REAL mag (lx1*ly1*lz1)
      REAL aije(lx1*ly1*lz1,ldim,ldim)

      nxyz = lx1*ly1*lz1

      call rzero(mag,nxyz)
 
      do 100 j=1,ldim
      do 100 i=1,ldim
      do 100 l=1,nxyz 
         mag(l) = mag(l) + 0.5*aije(l,i,j)*aije(l,i,j)
 100  continue

      call vsqrt(mag,nxyz)

      return
      end
c-----------------------------------------------------------------------
      subroutine comp_sije(gije)
c
c     Compute symmetric part of a tensor G_ij for element e
c
      include 'SIZE'
      include 'TOTAL'

      real gije(lx1*ly1*lz1,ldim,ldim)

      nxyz = lx1*ly1*lz1

      k = 1

      do j=1,ldim
      do i=k,ldim
         do l=1,nxyz
            gije(l,i,j) = 0.5*(gije(l,i,j)+gije(l,j,i))
            gije(l,j,i) = gije(l,i,j)
         enddo
      enddo
         k = k + 1
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine map2reg(ur,n,u,nel)
c
c     Map scalar field u() to regular n x n x n array ur 
c
      include 'SIZE'
      real ur(1),u(lx1*ly1*lz1,1)

      integer e

      ldr = n**ldim

      k=1
      do e=1,nel
         if (ldim.eq.2) call map2reg_2di_e(ur(k),n,u(1,e),lx1) 
         if (ldim.eq.3) call map2reg_3di_e(ur(k),n,u(1,e),lx1) 
         k = k + ldr
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine map2reg_2di_e(uf,n,uc,m) ! Fine, uniform pt

      real uf(n,n),uc(m,m)

      parameter (l=50)
      common /cmap2d/ j(l*l),jt(l*l),w(l*l),z(l)

      integer mo,no
      save    mo,no
      data    mo,no / 0,0 /

      if (m.gt.l) call exitti('map2reg_2di_e memory 1$',m)
      if (n.gt.l) call exitti('map2reg_2di_e memory 2$',n)

      if (m.ne.mo .or. n.ne.no ) then

          call zwgll (z,w,m)
          call zuni  (w,n)

          call gen_int_gz(j,jt,w,n,z,m)

      endif

      call mxm(j,n,uc,m,w ,m)
      call mxm(w,n,jt,m,uf,n)

      return
      end
c-----------------------------------------------------------------------
      subroutine map2reg_3di_e(uf,n,uc,m) ! Fine, uniform pt

      real uf(n,n,n),uc(m,m,m)

      parameter (l=16)
      common /cmap3d/ j(l*l),jt(l*l),v(l*l*l),w(l*l*l),z(l)

      integer mo,no
      save    mo,no
      data    mo,no / 0,0 /

      if (m.gt.l) call exitti('map2reg_3di_e memory 1$',m)
      if (n.gt.l) call exitti('map2reg_3di_e memory 2$',n)

      if (m.ne.mo .or. n.ne.no ) then

          call zwgll (z,w,m)
          call zuni  (w,n)

          call gen_int_gz(j,jt,w,n,z,m)

      endif

      mm = m*m
      mn = m*n
      nn = n*n

      call mxm(j,n,uc,m,v ,mm)
      iv=1
      iw=1
      do k=1,m
         call mxm(v(iv),n,jt,m,w(iw),n)
         iv = iv+mn
         iw = iw+nn
      enddo
      call mxm(w,nn,jt,m,uf,n)

      return
      end
c-----------------------------------------------------------------------
      subroutine gen_int_gz(j,jt,g,n,z,m)

c     Generate interpolater from m z points to n g points

c        j   = interpolation matrix, mapping from z to g
c        jt  = transpose of interpolation matrix
c        m   = number of points on z grid
c        n   = number of points on g grid

      real j(n,m),jt(m,n),g(n),z(m)

      mpoly  = m-1
      do i=1,n
         call fd_weights_full(g(i),z,mpoly,0,jt(1,i))
      enddo

      call transpose(j,n,jt,m)

      return
      end
c-----------------------------------------------------------------------
      subroutine zuni(z,np)
c
c     Generate equaly spaced np points on the interval [-1:1]
c
      real z(1)

      dz = 2./(np-1)
      z(1) = -1.
      do i = 2,np-1
         z(i) = z(i-1) + dz
      enddo
      z(np) = 1.

      return
      end
c-----------------------------------------------------------------------
      subroutine gen_re2(imid)  ! Generate and output essential parts of .rea
                                ! And re2
                                ! Clobbers ccurve()
                                ! byte read is float size..
                                ! 4 wdsize
      include 'SIZE'
      include 'TOTAL'

      character*80 hdr
      real*4 test
      data   test  / 6.54321 /
      integer ierr


c     imid = 0  ! No midside node defs
c     imid = 1  ! Midside defs where current curve sides don't exist
c     imid = 2  ! All nontrivial midside node defs

      ierr = 0
      if (nid.eq.0) then
         call byte_open('newre2.re2' // char(0), ierr)
         call blank(hdr,80)
         if(wdsize.eq.8) then 
            write(hdr,112) nelgt,ldim,nelgv 
         else
            write(hdr,111) nelgt,ldim,nelgv
         endif
  111    format('#v001',i9,i3,i9,' hdr')
  112    format('#v002',i9,i3,i9,' hdr')
         if(ierr.eq.0) call byte_write(hdr,20,ierr)  
         if(ierr.eq.0) call byte_write(test,1,ierr) !write endian discriminator
      endif
      call err_chk(ierr,'Error opening  in gen_re2$') 

      call gen_re2_xyz
      call gen_re2_curve(imid)  ! Clobbers ccurve()

      do ifld=1,nfield
         call gen_re2_bc   (ifld)
      enddo

      if (nid.eq.0) call byte_close(ierr)
      call err_chk(ierr,'Error closing in gen_re2$') 

      return
      end
c-----------------------------------------------------------------------
      subroutine gen_re2_xyz
      include 'SIZE'
      include 'TOTAL'

      parameter (lv=2**ldim,lblock=1000)
      common /scrns/ xyz(lv,ldim,lblock),wk(lv*ldim*lblock)
      common /scruz/ igr(lblock)

      integer e,eb,eg,ierr,wdsiz2

      integer isym2pre(8)   ! Symmetric-to-prenek vertex ordering
      save    isym2pre
      data    isym2pre / 1 , 2 , 4 , 3 , 5 , 6 , 8 , 7 /

      real*4 buf (50)  ! nwds * 2 for double precision
      real   buf2(25)  ! double precsn
      equivalence (buf,buf2)


      nxs = lx1-1
      nys = ly1-1
      nzs = lz1-1
 
      wdsiz2=4
      if(wdsize.eq.8) wdsiz2=8
      nblock = lv*ldim*lblock   !memory size of data blocks

      ierr=0

      do eb=1,nelgt,lblock
         nemax = min(eb+lblock-1,nelgt)
         call rzero(xyz,nblock)
         call izero(igr,lblock)
         kb = 0
         do eg=eb,nemax
            mid = gllnid(eg)
            e   = gllel (eg)
            kb  = kb+1
            l   = 0
            if (mid.eq.nid.and.if3d) then ! fill owning processor
               igr(kb) = igroup(e)
               do k=0,1
               do j=0,1
               do i=0,1
                  l=l+1
                  li=isym2pre(l)
                  xyz(li,1,kb) = xm1(1+i*nxs,1+j*nys,1+k*nzs,e)
                  xyz(li,2,kb) = ym1(1+i*nxs,1+j*nys,1+k*nzs,e)
                  xyz(li,3,kb) = zm1(1+i*nxs,1+j*nys,1+k*nzs,e)
               enddo
               enddo
               enddo
            elseif (mid.eq.nid) then    ! 2D
               igr(kb) = igroup(e)
               do j=0,1
               do i=0,1
                  l =l+1
                  li=isym2pre(l)
                  xyz(li,1,kb) = xm1(1+i*nxs,1+j*nys,1,e)
                  xyz(li,2,kb) = ym1(1+i*nxs,1+j*nys,1,e)
               enddo
               enddo
            endif
         enddo
         call  gop(xyz,wk,'+  ',nblock)  ! Sum across all processors
         call igop(igr,wk,'+  ',lblock)  ! Sum across all processors

         if (nid.eq.0.and.ierr.eq.0) then
            kb = 0
            do eg=eb,nemax
               kb  = kb+1

               if(wdsiz2.eq.8) then
                  call rgrp=igr(kb)
                  call byte_write(rgrp,2,ierr)
                 
                  if(if3d) then
                    buf2(1) = xyz(1,1,kb)
                    buf2(2) = xyz(2,1,kb)
                    buf2(3) = xyz(3,1,kb)
                    buf2(4) = xyz(4,1,kb)

                    buf2(5) = xyz(5,1,kb)
                    buf2(6) = xyz(6,1,kb)
                    buf2(7) = xyz(7,1,kb)
                    buf2(8) = xyz(8,1,kb)

                    buf2(9) = xyz(1,2,kb)
                    buf2(10)= xyz(2,2,kb)
                    buf2(11)= xyz(3,2,kb)
                    buf2(12)= xyz(4,2,kb)
                  
                    buf2(13)= xyz(5,2,kb)
                    buf2(14)= xyz(6,2,kb)
                    buf2(15)= xyz(7,2,kb)
                    buf2(16)= xyz(8,2,kb)

                    buf2(17)= xyz(1,3,kb)
                    buf2(18)= xyz(2,3,kb)
                    buf2(19)= xyz(3,3,kb)
                    buf2(20)= xyz(4,3,kb)

                    buf2(21)= xyz(5,3,kb)
                    buf2(22)= xyz(6,3,kb)
                    buf2(23)= xyz(7,3,kb)
                    buf2(24)= xyz(8,3,kb)

                    if(ierr.eq.0) call byte_write(buf,48,ierr)
                  else
                    buf2(1) = xyz(1,1,kb)
                    buf2(2) = xyz(2,1,kb)
                    buf2(3) = xyz(3,1,kb)
                    buf2(4) = xyz(4,1,kb)

                    buf2(5) = xyz(1,2,kb)
                    buf2(6) = xyz(2,2,kb)
                    buf2(7) = xyz(3,2,kb)
                    buf2(8) = xyz(4,2,kb)
    
                    if(ierr.eq.0) call byte_write(buf,16,ierr)
                  endif
               else  !!!! 4byte precision !!!!
                  call byte_write(igr(kb),1,ierr)
                  if (if3d) then 

                    buf(1)  = xyz(1,1,kb)
                    buf(2)  = xyz(2,1,kb)
                    buf(3)  = xyz(3,1,kb)
                    buf(4)  = xyz(4,1,kb)

                    buf(5)  = xyz(5,1,kb)
                    buf(6)  = xyz(6,1,kb)
                    buf(7)  = xyz(7,1,kb)
                    buf(8)  = xyz(8,1,kb)

                    buf(9)  = xyz(1,2,kb)
                    buf(10) = xyz(2,2,kb)
                    buf(11) = xyz(3,2,kb)
                    buf(12) = xyz(4,2,kb)
                  
                    buf(13) = xyz(5,2,kb)
                    buf(14) = xyz(6,2,kb)
                    buf(15) = xyz(7,2,kb)
                    buf(16) = xyz(8,2,kb)

                    buf(17) = xyz(1,3,kb)
                    buf(18) = xyz(2,3,kb)
                    buf(19) = xyz(3,3,kb)
                    buf(20) = xyz(4,3,kb)

                    buf(21) = xyz(5,3,kb)
                    buf(22) = xyz(6,3,kb)
                    buf(23) = xyz(7,3,kb)
                    buf(24) = xyz(8,3,kb)

                    if(ierr.eq.0) call byte_write(buf,24,ierr)

                  else ! 2D
                    buf(1)  = xyz(1,1,kb)
                    buf(2)  = xyz(2,1,kb)
                    buf(3)  = xyz(3,1,kb)
                    buf(4)  = xyz(4,1,kb)

                    buf(5)  = xyz(1,2,kb)
                    buf(6)  = xyz(2,2,kb)
                    buf(7)  = xyz(3,2,kb)
                    buf(8)  = xyz(4,2,kb)

                    if(ierr.eq.0) call byte_write(buf,8,ierr)
                  endif
               endif
              
            enddo
         endif
      enddo
      call err_chk(ierr,'Error writing to newre2.re2 in gen_re2_xyz$')

      return
      end
c-----------------------------------------------------------------------
      subroutine gen_re2_curve(imid)

c     This routine is complex because we must first count number of 
c     nontrivial curved sides.

c     A two pass strategy is used:  first count, then write

      include 'SIZE'
      include 'TOTAL'

      integer e,eb,eg,wdsiz2
      character*1 cc(4)

      real*4 buf (16)  ! nwds * 2 for double precision
      real   buf2( 8)  ! double precsn
      equivalence (buf,buf2)

      parameter (lblock=500)
      common /scrns/ vcurve(5,12,lblock),wk(5*12*lblock)
      common /scruz/ icurve(12,lblock)

      wdsiz2=4
      if(wdsize.eq.8) wdsiz2=8

      if (imid.gt.0) then

c        imid = 0  ! No midside node defs
c        imid = 1  ! Midside defs where current curve sides don't exist
c        imid = 2  ! All nontrivial midside node defs

         if (imid.eq.2) call blank(ccurve,12*lelt)

         do e=1,nelt
            call gen_rea_midside_e(e)
         enddo

      endif
      nedge = 4 + 8*(ldim-2)

      ncurvn = 0
      do e=1,nelt
      do i=1,nedge
         if (ccurve(i,e).ne.' ') ncurvn = ncurvn+1
      enddo
      enddo
      ncurvn = iglsum(ncurvn,1)
 
      ierr=0

      if(nid.eq.0.and.wdsiz2.eq.8) then
         rcurvn = ncurvn
         call byte_write(rcurvn,2,ierr)
      elseif(nid.eq.0) then
         call byte_write(ncurvn,1,ierr)
      endif

      do eb=1,nelgt,lblock

         nemax = min(eb+lblock-1,nelgt)
         call izero(icurve,12*lblock)
         call rzero(vcurve,60*lblock)

         kb = 0
         do eg=eb,nemax
            mid = gllnid(eg)
            e   = gllel (eg)
            kb  = kb+1
            if (mid.eq.nid) then ! fill owning processor
               do i=1,nedge
                  icurve(i,kb) = 0
                  if (ccurve(i,e).eq.'C') icurve(i,kb) = 1
                  if (ccurve(i,e).eq.'s') icurve(i,kb) = 2
                  if (ccurve(i,e).eq.'m') icurve(i,kb) = 3
                  call copy(vcurve(1,i,kb),curve(1,i,e),5)
               enddo
            endif
         enddo
         call igop(icurve,wk,'+  ',12*lblock)  ! Sum across all processors
         call  gop(vcurve,wk,'+  ',60*lblock)  ! Sum across all processors

         if (nid.eq.0) then
            kb = 0
            do eg=eb,nemax
               kb  = kb+1

               do i=1,nedge
                  ii = icurve(i,kb)   ! equivalenced to s4
                  if (ii.ne.0) then
                     if (ii.eq.1) cc(1)='C'
                     if (ii.eq.2) cc(1)='s'
                     if (ii.eq.3) cc(1)='m'

                     if(wdsiz2.eq.8) then

                        buf2(1) = eg
                        buf2(2) = i
                        call copy  (buf2(3),vcurve(1,i,kb),5)!real*8 write
                        call blank(buf2(8),8)
                        call chcopy(buf2(8),cc,4)
                        iz = 16
                     else
                        call icopy(buf(1),eg,1) 
                        call icopy(buf(2), i,1) 
                        call copyX4(buf(3),vcurve(1,i,kb),5) !real*4 write
                        call blank(buf(8),4)
                        call chcopy(buf(8),cc,4)
                        iz = 8
                     endif

                     if(ierr.eq.0) call byte_write(buf,iz,ierr)
                  endif
               enddo
            enddo
         endif

      enddo
      call err_chk(ierr,'Error writing to newre2.re2 in gen_re2_curve$')

      return
      end
c-----------------------------------------------------------------------
      subroutine gen_re2_bc (ifld)

      include 'SIZE'
      include 'TOTAL'

      integer e,eb,eg,wdsiz2

      parameter (lblock=500)
      common /scrns/ vbc(5,6,lblock),wk(5*6*lblock)
      common /scruz/ ibc(6,lblock)

      character*1 s4(4)
      character*3 s3
      integer     i4
      equivalence(i4,s4)
      equivalence(s3,s4)

      character*1 chtemp
      save        chtemp
      data        chtemp /' '/   ! For mesh bcs

      real*4 buf (16)  ! nwds * 2 for double precision
      real   buf2( 8)  ! double precsn
      equivalence (buf,buf2)


      nface = 2*ldim
      ierr = 0
      nbc  = 0
      rbc  = 0

      wdsiz2=4
      if(wdsize.eq.8) wdsiz2=8

      nlg = nelg(ifld)

      if (ifld.eq.1.and..not.ifflow) then ! NO B.C.'s for this field
         if(nid.eq.0.and.wdsiz2.eq.4) call byte_write(nbc,1,ierr)
         if(nid.eq.0.and.wdsiz2.eq.8) call byte_write(rbc,2,ierr)
         call err_chk(ierr,'Error writing to newre2.re2 in gen_re2_bc$')
         return
      endif

      do ii = 1,nelt
         do jj = 1,nface
            if(cbc(jj,ii,ifld).ne.'E  ')nbc=nbc+1
         enddo
      enddo
      call igop(nbc,wk,'+  ', 1       )  ! Sum across all processors
      if(nid.eq.0.and.wdsiz2.eq.8) then
         rbc = nbc
         call byte_write(rbc,2,ierr)
      elseif(nid.eq.0) then
         call byte_write(nbc,1,ierr)
      endif

      do eb=1,nlg,lblock
         nemax = min(eb+lblock-1,nlg)
         call izero(ibc, 6*lblock)
         call rzero(vbc,30*lblock)
         kb = 0
         do eg=eb,nemax
            mid = gllnid(eg)
            e   = gllel (eg)
            kb  = kb+1
            if (mid.eq.nid) then ! fill owning processor
               do i=1,nface
                  i4 = 0
                  call chcopy(s4,cbc(i,e,ifld),3)
                  ibc(i,kb) = i4
                  call copy(vbc(1,i,kb),bc(1,i,e,ifld),5)
               enddo
            endif
         enddo
         call igop(ibc,wk,'+  ', 6*lblock)  ! Sum across all processors
         call  gop(vbc,wk,'+  ',30*lblock)  ! Sum across all processors

         if (nid.eq.0) then
            kb = 0
            do eg=eb,nemax
               kb  = kb+1

               do i=1,nface
                  i4 = ibc(i,kb)   ! equivalenced to s4
                  if (s3.ne.'E  ') then

                     if(wdsiz2.eq.8) then
                        buf2(1)=eg
                        buf2(2)=i
                        call copy    (buf2(3),vbc(1,i,eg),5)
                        call blank   (buf2(8),8)
                        call chcopy  (buf2(8),s3,3)
                       if(nlg.ge.1000000) then
                            call icopy(i_vbc,vbc(1,i,eg),1)
                            buf2(3)=i_vbc
                        endif
                        iz=16
                     else
                        call icopy   (buf(1),eg,1)
                        call icopy   (buf(2),i,1)
                        call copyX4  (buf(3),vbc(1,i,eg),5)
                        call blank   (buf(8),4)
                      if(nlg.ge.1000000)call icopy(buf(3),vbc(1,i,eg),1)
                        call chcopy  (buf(8),s3,3)
                        iz=8
                     endif

                     if(ierr.eq.0) call byte_write (buf,iz,ierr)
                     
                  endif
               enddo
            enddo
         endif
      enddo
      call err_chk(ierr,'Error writing to newre2.re2 in gen_re2_bc$')

      return
      end
c-----------------------------------------------------------------------
      subroutine gen_rea(imid)  ! Generate and output essential parts of .rea
                                ! Clobbers ccurve()
      include 'SIZE'
      include 'TOTAL'

c     imid = 0  ! No midside node defs
c     imid = 1  ! Midside defs where current curve sides don't exist
c     imid = 2  ! All nontrivial midside node defs

      if (nid.eq.0) open(unit=10,file='newrea.out',status='unknown') ! clobbers existing file

      call gen_rea_xyz

      call gen_rea_curve(imid)  ! Clobbers ccurve()

      if (nid.eq.0) write(10,*)' ***** BOUNDARY CONDITIONS *****'
      do ifld=1,nfield
         call gen_rea_bc   (ifld)
      enddo

      if (nid.eq.0) close(10)

      return
      end
c-----------------------------------------------------------------------
      subroutine gen_rea_xyz
      include 'SIZE'
      include 'TOTAL'

      parameter (lv=2**ldim,lblock=1000)
      common /scrns/ xyz(lv,ldim,lblock),wk(lv*ldim*lblock)
      common /scruz/ igr(lblock)

      integer e,eb,eg
      character*1 letapt

      integer isym2pre(8)   ! Symmetric-to-prenek vertex ordering
      save    isym2pre
      data    isym2pre / 1 , 2 , 4 , 3 , 5 , 6 , 8 , 7 /

      letapt = 'a'
      numapt = 1

      nxs = lx1-1
      nys = ly1-1
      nzs = lz1-1
      nblock = lv*ldim*lblock

      if (nid.eq.0) 
     $  write(10,'(i12,i3,i12,'' NEL,ldim,NELV'')') nelgt,ldim,nelgv

      do eb=1,nelgt,lblock
         nemax = min(eb+lblock-1,nelgt)
         call rzero(xyz,nblock)
         call izero(igr,lblock)
         kb = 0
         do eg=eb,nemax
            mid = gllnid(eg)
            e   = gllel (eg)
            kb  = kb+1
            l   = 0
            if (mid.eq.nid.and.if3d) then ! fill owning processor
               igr(kb) = igroup(e)
               do k=0,1
               do j=0,1
               do i=0,1
                  l=l+1
                  li=isym2pre(l)
                  xyz(li,1,kb) = xm1(1+i*nxs,1+j*nys,1+k*nzs,e)
                  xyz(li,2,kb) = ym1(1+i*nxs,1+j*nys,1+k*nzs,e)
                  xyz(li,3,kb) = zm1(1+i*nxs,1+j*nys,1+k*nzs,e)
               enddo
               enddo
               enddo
            elseif (mid.eq.nid) then    ! 2D
               igr(kb) = igroup(e)
               do j=0,1
               do i=0,1
                  l =l+1
                  li=isym2pre(l)
                  xyz(li,1,kb) = xm1(1+i*nxs,1+j*nys,1,e)
                  xyz(li,2,kb) = ym1(1+i*nxs,1+j*nys,1,e)
               enddo
               enddo
            endif
         enddo
         call  gop(xyz,wk,'+  ',nblock)  ! Sum across all processors
         call igop(igr,wk,'+  ',lblock)  ! Sum across all processors

         if (nid.eq.0) then
            kb = 0
            do eg=eb,nemax
               kb  = kb+1

               write(10,'(a15,i12,a2,i5,a1,a10,i6)')
     $   '      ELEMENT  ',eg,' [',numapt,letapt,']    GROUP',igr(kb)

               if (if3d) then 

                  write(10,'(4g15.7)')(xyz(ic,1,kb),ic=1,4)
                  write(10,'(4g15.7)')(xyz(ic,2,kb),ic=1,4)
                  write(10,'(4g15.7)')(xyz(ic,3,kb),ic=1,4)

                  write(10,'(4g15.7)')(xyz(ic,1,kb),ic=5,8)
                  write(10,'(4g15.7)')(xyz(ic,2,kb),ic=5,8)
                  write(10,'(4g15.7)')(xyz(ic,3,kb),ic=5,8)

               else ! 2D

                  write(10,'(4g15.7)')(xyz(ic,1,kb),ic=1,4)
                  write(10,'(4g15.7)')(xyz(ic,2,kb),ic=1,4)

               endif

            enddo
         endif
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine gen_rea_curve(imid)

c     This routine is complex because we must first count number of 
c     nontrivial curved sides.

c     A two pass strategy is used:  first count, then write

      include 'SIZE'
      include 'TOTAL'

      integer e,eb,eg
      character*1 cc

      parameter (lblock=500)
      common /scrns/ vcurve(5,12,lblock),wk(5*12*lblock)
      common /scruz/ icurve(12,lblock)

      if (imid.gt.0) then

c        imid = 0  ! No midside node defs
c        imid = 1  ! Midside defs where current curve sides don't exist
c        imid = 2  ! All nontrivial midside node defs

         if (imid.eq.2) call blank(ccurve,12*lelt)

         do e=1,nelt
            call gen_rea_midside_e(e)
         enddo

      endif

      nedge = 4 + 8*(ldim-2)

      ncurvn = 0
      do e=1,nelt
      do i=1,nedge
         if (ccurve(i,e).ne.' ') ncurvn = ncurvn+1
      enddo
      enddo
      ncurvn = iglsum(ncurvn,1)

      if (nid.eq.0) then
         WRITE(10,*)' ***** CURVED SIDE DATA *****'
         WRITE(10,'(I10,A20,A33)') ncurvn,' Curved sides follow',
     $   ' IEDGE,IEL,CURVE(I),I=1,5, CCURVE'
      endif

      do eb=1,nelgt,lblock

         nemax = min(eb+lblock-1,nelgt)
         call izero(icurve,12*lblock)
         call rzero(vcurve,60*lblock)

         kb = 0
         do eg=eb,nemax
            mid = gllnid(eg)
            e   = gllel (eg)
            kb  = kb+1
            if (mid.eq.nid) then ! fill owning processor
               do i=1,nedge
                  icurve(i,kb) = 0
                  if (ccurve(i,e).eq.'C') icurve(i,kb) = 1
                  if (ccurve(i,e).eq.'s') icurve(i,kb) = 2
                  if (ccurve(i,e).eq.'m') icurve(i,kb) = 3
                  call copy(vcurve(1,i,kb),curve(1,i,e),5)
               enddo
            endif
         enddo
         call igop(icurve,wk,'+  ',12*lblock)  ! Sum across all processors
         call  gop(vcurve,wk,'+  ',60*lblock)  ! Sum across all processors

         if (nid.eq.0) then
            kb = 0
            do eg=eb,nemax
               kb  = kb+1

               do i=1,nedge
                  ii = icurve(i,kb)   ! equivalenced to s4
                  if (ii.ne.0) then
                     if (ii.eq.1) cc='C'
                     if (ii.eq.2) cc='s'
                     if (ii.eq.3) cc='m'
                     if (nelgt.lt.1000) then
                        write(10,'(i3,i3,5g14.6,1x,a1)') i,eg,
     $                  (vcurve(k,i,kb),k=1,5),cc
                     elseif (nelgt.lt.1000000) then
                        write(10,'(i2,i6,5g14.6,1x,a1)') i,eg,
     $                  (vcurve(k,i,kb),k=1,5),cc
                     else
                        write(10,'(i2,i12,5g14.6,1x,a1)') i,eg,
     $                  (vcurve(k,i,kb),k=1,5),cc
                     endif
                  endif
               enddo
            enddo
         endif

      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine gen_rea_bc (ifld)

      include 'SIZE'
      include 'TOTAL'

      integer e,eb,eg

      parameter (lblock=500)
      common /scrns/ vbc(5,6,lblock),wk(5*6*lblock)
      common /scruz/ ibc(6,lblock)

      character*1 s4(4)
      character*3 s3
      integer     i4
      equivalence(i4,s4)
      equivalence(s3,s4)

      character*1 chtemp
      save        chtemp
      data        chtemp /' '/   ! For mesh bcs

      nface = 2*ldim

      nlg = nelg(ifld)

      if (ifld.eq.1.and..not.ifflow) then ! NO B.C.'s for this field
         if (nid.eq.0) write(10,*)
     $      ' ***** NO FLUID   BOUNDARY CONDITIONS *****'
         return
      elseif (ifld.eq.1.and.nid.eq.0) then ! NO B.C.'s for this field
         write(10,*) ' *****    FLUID   BOUNDARY CONDITIONS *****'
      elseif (ifld.ge.2.and.nid.eq.0) then ! NO B.C.'s for this field
         write(10,*) ' *****    THERMAL BOUNDARY CONDITIONS *****'
      endif

      do eb=1,nlg,lblock
         nemax = min(eb+lblock-1,nlg)
         call izero(ibc, 6*lblock)
         call rzero(vbc,30*lblock)
         kb = 0
         do eg=eb,nemax
            mid = gllnid(eg)
            e   = gllel (eg)
            kb  = kb+1
            if (mid.eq.nid) then ! fill owning processor
               do i=1,nface
                  i4 = 0
                  call chcopy(s4,cbc(i,e,ifld),3)
                  ibc(i,kb) = i4
                  call copy(vbc(1,i,kb),bc(1,i,e,ifld),5)
               enddo
            endif
         enddo
         call igop(ibc,wk,'+  ', 6*lblock)  ! Sum across all processors
         call  gop(vbc,wk,'+  ',30*lblock)  ! Sum across all processors

         if (nid.eq.0) then
            kb = 0
            do eg=eb,nemax
               kb  = kb+1

               do i=1,nface
                  i4 = ibc(i,kb)   ! equivalenced to s4

c                 chtemp='   '
c                 if (ifld.eq.1 .or. (ifld.eq.2 .and. .not. ifflow))
c    $               chtemp = cbc(i,kb,0)

                  if (nlg.lt.1000) then
                     write(10,'(a1,a3,2i3,5g14.6)')
     $               chtemp,s3,eg,i,(vbc(ii,i,kb),ii=1,5)
                  elseif (nlg.lt.100000) then
                     write(10,'(a1,a3,i5,i1,5g14.6)')
     $               chtemp,s3,eg,i,(vbc(ii,i,kb),ii=1,5)
                  elseif (nlg.lt.1000000) then
                     write(10,'(a1,a3,i6,5g14.6)')
     $               chtemp,s3,eg,(vbc(ii,i,kb),ii=1,5)
                  else
                     write(10,'(a1,a3,i12,5g18.11)')
     $               chtemp,s3,eg,(vbc(ii,i,kb),ii=1,5)
                  endif
               enddo
            enddo
         endif
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine gen_rea_midside_e(e)

      include 'SIZE'
      include 'TOTAL'

      common /scrns/ x3(27),y3(27),z3(27),xyz(3,3)
      character*1 ccrve(12)
      integer e,edge

      integer e3(3,12)
      save    e3
      data    e3 /  1, 2, 3,    3, 6, 9,    9, 8, 7,    7, 4, 1
     $           , 19,20,21,   21,24,27,   27,26,25,   25,22,19
     $           ,  1,10,19,    3,12,21,    9,18,27,    7,16,25 /

      real len

      call chcopy(ccrve,ccurve(1,e),12)

      call map2reg(x3,3,xm1(1,1,1,e),1)  ! Map to 3x3x3 array
      call map2reg(y3,3,ym1(1,1,1,e),1)
      if (if3d) call map2reg(z3,3,zm1(1,1,1,e),1)

c     Take care of spherical curved face defn
      if (ccurve(5,e).eq.'s') then
         call chcopy(ccrve(1),'ssss',4) ! face 5
         call chcopy(ccrve(5),' ',1)    ! face 5
      endif
      if (ccurve(6,e).eq.'s') then
         call chcopy(ccrve(5),'ssss',4) ! face 6
      endif

      tol   = 1.e-4
      tol2  = tol**2
      nedge = 4 + 8*(ldim-2)

      do i=1,nedge
         if (ccrve(i).eq.' ') then
            do j=1,3
               xyz(1,j)=x3(e3(j,i))
               xyz(2,j)=y3(e3(j,i))
               xyz(3,j)=z3(e3(j,i))
            enddo
            len = 0.
            h   = 0.
            do j=1,ldim
               xmid = .5*(xyz(j,1)+xyz(j,3))
               h    = h   + (xyz(j,2)-xmid)**2
               len  = len + (xyz(j,3)-xyz(j,1))**2
            enddo
            if (h.gt.tol2*len) ccurve(i,e) = 'm'
            if (h.gt.tol2*len) call copy(curve(1,i,e),xyz(1,2),ldim)
         endif
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine hpts
c
c     evaluate velocity, temperature, pressure and ps-scalars 
c     for list of points and dump results
c     note: read/write on rank0 only 
c
c     ASSUMING LHIS IS MAX NUMBER OF POINTS TO READ IN ON ONE PROCESSOR

      include 'SIZE'
      include 'TOTAL'

      parameter(nfldm=ldim+ldimt+1)

      real pts, fieldout, dist, rst
      common /c_hptsr/ pts      (ldim,lhis)
     $               , fieldout (nfldm,lhis)
     $               , dist     (lhis)
     $               , rst      (lhis*ldim)

      common /nekmpi/ nidd,npp,nekcomm,nekgroup,nekreal

      integer rcode, elid, proc
      common /c_hptsi/ rcode(lhis),elid(lhis),proc(lhis)

      common /scrcg/  pm1 (lx1,ly1,lz1,lelv) ! mapped pressure
      common /outtmp/ wrk (lx1*ly1*lz1*lelt,nfldm)


      logical iffind

      integer icalld,npoints,npts
      save    icalld,npoints,npts
      data    icalld  /0/
      data    npoints /0/

      save    inth_hpts

      nxyz  = lx1*ly1*lz1
      ntot  = nxyz*nelt 
      nbuff = lhis      ! point to be read in on 1 proc.

      toldist = 5e-6

      if(nio.eq.0) write(6,*) 'dump history points'

      if(icalld.eq.0) then
        npts  = lhis      ! number of points per proc
        call hpts_in(pts,npts,npoints)

        tol     = 5e-13
        n       = lx1*ly1*lz1*lelt
        npt_max = 128
        nxf     = 2*lx1 ! fine mesh for bb-test
        nyf     = 2*ly1
        nzf     = 2*lz1
        bb_t    = 0.01 ! relative size to expand bounding boxes by
        call fgslib_findpts_setup(inth_hpts,nekcomm,np,ldim,
     &                            xm1,ym1,zm1,lx1,ly1,lz1,
     &                            nelt,nxf,nyf,nzf,bb_t,n,n,
     &                            npt_max,tol)
      endif


      call prepost_map(0)  ! maps axisymm and pressure

      ! pack working array
      nflds = 0
      if(ifvo) then
        call copy(wrk(1,1),vx,ntot)
        call copy(wrk(1,2),vy,ntot)
        if(if3d) call copy(wrk(1,3),vz,ntot)
        nflds = ldim
      endif
      if(ifpo) then
        nflds = nflds + 1
        call copy(wrk(1,nflds),pm1,ntot)
      endif
      if(ifto) then
        nflds = nflds + 1
        call copy(wrk(1,nflds),t,ntot)
      endif
      do i = 1,ldimt
         if(ifpsco(i)) then
           nflds = nflds + 1
           call copy(wrk(1,nflds),T(1,1,1,1,i+1),ntot)
         endif
      enddo
      
      ! interpolate
      if(icalld.eq.0) then
        call fgslib_findpts(inth_hpts,rcode,1,
     &                      proc,1,
     &                      elid,1,
     &                      rst,ldim,
     &                      dist,1,
     &                      pts(1,1),ldim,
     &                      pts(2,1),ldim,
     &                      pts(3,1),ldim,npts)
     
        nfail = 0 
        do i=1,npts
           ! check return code 
           if(rcode(i).eq.1) then
             if(sqrt(dist(i)).gt.toldist) then
               nfail = nfail + 1
               IF (NFAIL.LE.5) WRITE(6,'(a,1p4e15.7)') 
     &     ' WARNING: point on boundary or outside the mesh xy[z]d^2:'
     &     ,(pts(k,i),k=1,ldim),dist(i)
             endif   
           elseif(rcode(i).eq.2) then
             nfail = nfail + 1
             if (nfail.le.5) write(6,'(a,1p3e15.7)') 
     &        ' WARNING: point not within mesh xy[z]: !',
     &        (pts(k,i),k=1,ldim)
           endif
        enddo
        icalld = 1
      endif


      ! evaluate input field at given points
      do ifld = 1,nflds
         call fgslib_findpts_eval(inth_hpts,fieldout(ifld,1),nfldm,
     &                            rcode,1,
     &                            proc,1,
     &                            elid,1,
     &                            rst,ldim,npts,
     &                            wrk(1,ifld))
      enddo
      ! write interpolation results to hpts.out
      call hpts_out(fieldout,nflds,nfldm,npoints,nbuff)

      call prepost_map(1)  ! maps back axisymm arrays

      return
      end
c-----------------------------------------------------------------------
      subroutine buffer_in(buffer,npp,npoints,nbuf)
        
      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'

      real    buffer(ldim,nbuf)  

      ierr = 0
      if(nid.eq.0) then
        write(6,*) 'reading history points'
        open(50,file=hisfle,status='old',err=100)
        read(50,*,err=100) npoints
        goto 101
 100    ierr = 1
 101    continue
      endif
      ierr=iglsum(ierr,1)
      if(ierr.gt.0) then
        if(nio.eq.0) 
     &   write(6,*) 'Cannot open history file in subroutine hpts()'
        call exitt
      endif
      
      call bcast(npoints,isize)
      if(npoints.gt.(lhis-1)*np) then
        if(nid.eq.0) write(6,*) 'ABORT: Increase lhis in SIZE!'
        call exitt
      endif
      if(nid.eq.0) write(6,*) 'found ', npoints, ' points'


      npass =  npoints/nbuf +1  !number of passes to cover all pts
      n0    =  mod(npoints,nbuf)!remainder 
      if(n0.eq.0) then
         npass = npass-1
         n0    = nbuf
      endif

      len = wdsize*ldim*nbuf
      if (nid.gt.0.and.nid.lt.npass) msg_id=irecv(nid,buffer,len)
      call nekgsync
      
      npp=0  
      if(nid.eq.0) then
        i1 = nbuf
        do ipass = 1,npass
           if(ipass.eq.npass) i1 = n0
           do i = 1,i1
              read(50,*) (buffer(j,i),j=1,ldim) 
           enddo
           if(ipass.lt.npass)call csend(ipass,buffer,len,ipass,0)
        enddo
        npp = n0
      elseif (nid.lt.npass)  then !processors receiving data
        call msgwait(msg_id)
        npp=nbuf
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine hpts_in(pts,npts,npoints) 
c                        npts=local count; npoints=total count

      include 'SIZE'
      include 'PARALLEL'

      parameter (lt2=2*lx1*ly1*lz1*lelt)
      common /scrns/ xyz(ldim,lt2)
      common /scruz/ mid(lt2)  ! Target proc id
      real    pts(ldim,npts)

      if (lt2.gt.npts) then

         call buffer_in(xyz,npp,npoints,lt2)
         if(npoints.gt.np*npts) then
           if(nid.eq.0)write(6,*)'ABORT in hpts(): npoints > NP*lhis!!' 
           if(nid.eq.0)write(6,*)'Change SIZE: ',np,npts,npoints
           call exitt
         endif

         npmax = (npoints/npts)
         if(mod(npoints,npts).eq.0) npmax=npmax+1

         if(nid.gt.0.and.npp.gt.0) then
          npts_b = lt2*(nid-1)               ! # pts  offset(w/o 0)
          nprc_b = npts_b/npts               ! # proc offset(w/o 0)

          istart = mod(npts_b,npts)          ! istart-->npts pts left
          ip     = nprc_b + 1                ! PID offset
          icount = istart                    ! point offset
         elseif(nid.eq.0) then
          npts0   = mod1(npoints,lt2)        ! Node 0 pts
          npts_b  = npoints - npts0          ! # pts before Node 0
          nprc_b  = npts_b/npts

          istart  = mod(npts_b,npts)
          ip      = nprc_b + 1
          icount  = istart
         endif

         do i =1,npp
            icount = icount + 1
            if(ip.gt.npmax) ip = 0
            mid(i) = ip
            if (icount.eq.npts) then
               ip     = ip+1
               icount = 0
            endif
         enddo

         call fgslib_crystal_tuple_transfer 
     &      (cr_h,npp,lt2,mid,1,pts,0,xyz,ldim,1)

         call copy(pts,xyz,ldim*npp)
      else
         call buffer_in(pts,npp,npoints,npts)
      endif
      npts = npp


      return
      end
c-----------------------------------------------------------------------
      subroutine hpts_out(fieldout,nflds,nfldm,npoints,nbuff)

      include 'SIZE'
      include 'TOTAL'

      real buf(nfldm,nbuff),fieldout(nfldm,nbuff)

      len = wdsize*nfldm*nbuff


      npass = npoints/nbuff + 1
      il = mod(npoints,nbuff)
      if(il.eq.0) then
         il = nbuff
         npass = npass-1
      endif

      do ipass = 1,npass

        call nekgsync

        if(ipass.lt.npass) then
          if(nid.eq.0) then
            call crecv(ipass,buf,len)
            do ip = 1,nbuff
              write(50,'(1p20E15.7)') time,
     &         (buf(i,ip), i=1,nflds)
            enddo
          elseif(nid.eq.ipass) then
            call csend(ipass,fieldout,len,0,nid)
          endif

        else  !ipass.eq.npass

          if(nid.eq.0) then
            do ip = 1,il
              write(50,'(1p20E15.7)') time,
     &         (fieldout(i,ip), i=1,nflds)
            enddo
          endif

        endif
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine gen_rea_full(imid)  ! Generate and output essential parts of .rea
                                ! Clobbers ccurve()
      include 'SIZE'
      include 'TOTAL'

c     imid = 0  ! No midside node defs
c     imid = 1  ! Midside defs where current curve sides don't exist
c     imid = 2  ! All nontrivial midside node defs

      if (nid.eq.0) open(unit=10,file='newrea.rea',status='unknown') ! clobbers existing file

      call gen_rea_top

      call gen_rea_xyz

      call gen_rea_curve(imid)  ! Clobbers ccurve()

      if (nid.eq.0) write(10,*)' ***** BOUNDARY CONDITIONS *****'
      do ifld=1,nfield
         call gen_rea_bc   (ifld)
      enddo

      call gen_rea_bottom

      if (nid.eq.0) close(10)

      return
      end
c-----------------------------------------------------------------------
      subroutine gen_rea_top
      
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'PARALLEL'
      INCLUDE 'CTIMER'

      logical ifbswap,ifre2,parfound
      character*132 string
      character*72 string2
      integer idum(3*numsts+3)
      integer paramval

      ierr = 0
      call flush_io

      if(nid.eq.0) then
        write(6,'(A,A)') ' Reading ', reafle
        open (unit=9,file=reafle,status='old', iostat=ierr)
      endif

      call bcast(ierr,isize)
      if (ierr .gt. 0) call exitti('Cannot open .rea file!$',1)


      IF(NID.EQ.0) THEN
        READ(9,'(a)') string2
        write(10,'(a)') string2
        READ(9,'(a)') string2
        write(10,*) string2
        READ(9,'(a)') string2
        write(10,*) string2
        READ(9,'(a)') string2
        write(10,*) string2

        READ(string2,*) paramval

c       WRITE PARAMETERS
        DO 20 I=1,paramval
          READ(9,'(a)') string2
          write(10,*) string2
   20   CONTINUE

c       LINES OF PASSIVE SCALARS
        read(9,'(a)') string2
        write(10,*) string2

        read(string2,*) paramval
        if (paramval.gt.0) then
         do I=1,paramval
          READ(9,'(a)') string2
          write(10,*) string2
         enddo
        endif

c       LINES OF LOGICAL SWITCHES
        read(9,'(a)') string2
        write(10,*) string2

        read(string2,*) paramval
        if (paramval.gt.0) then
         do I=1,paramval
          READ(9,'(a)') string2
          write(10,*) string2
         enddo
        endif

c         LAST TWO LINES BEFORE ELEMENT DATA BEGINS
         do I=1,2
          READ(9,'(a)') string2
          write(10,*) string2
         enddo


       ENDIF


      return
      end
c-----------------------------------------------------------------------
      subroutine gen_rea_bottom
      
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'PARALLEL'
      INCLUDE 'CTIMER'

      logical ifbswap,ifre2,parfound
      character*132 string
      character*72 string2
      integer idum(3*numsts+3)
      integer paramval,i,j
      integer n1,n2,n3

c     IGNORE ELEMENT DATA
c     IGNORE XY DATA

      IF(NID.EQ.0) THEN
        READ(9,'(a)') string2
        READ(string2,*) n1,n2,n3
        if (n1.lt.0) goto 1001
      do i=1,nelgt
        READ(9,'(a)') string2
        do j=1,2+(ldim-2)*4
           READ(9,'(a)') string2
        enddo
      enddo
c     CURVE SIDE DATA
      READ(9,'(a)') string2
      READ(9,*) paramval
      if (paramval.gt.0) then
       do I=1,paramval
        READ(9,'(a)') string2
       enddo
      endif
c     BOUNDARY CONDITIONS
      READ(9,'(a)') string2
c     FLUID
      READ(9,'(a)') string2
      if (ifflow) then
       do i=1,nelgv*2*ldim
        READ(9,'(a)') string2
       enddo
      endif
c      Thermal
      READ(9,'(a)') string2
      if (ifheat) then
       do i=1,nelgt*2*ldim
        READ(9,'(a)') string2
       enddo
      else
       write(10,*) string2
      endif

 1001 continue 

c     PRESOLVE
        READ(9,'(a)') string2
        write(10,*) string2
c     INITIAL CONDITIONS
        READ(9,'(a)') string2
        write(10,*) string2
        read(string2,*) paramval
        if (paramval.gt.0) then
        do I=1,paramval
          READ(9,'(a)') string2
          write(10,*) string2
        enddo
        endif
c       DRIVE FORCE
        READ(9,'(a)') string2
        write(10,*) string2
        READ(9,'(a)') string2
        write(10,*) string2
        read(string2,*) paramval

        if (paramval.gt.0) then
        do I=1,paramval
          READ(9,'(a)') string2
          write(10,*) string2
        enddo
        endif

c       VARIABLE PROPERTY DATA
        read(9,'(a)') string2
        write(10,*) string2
        read(9,'(a)') string2
        write(10,*) string2
        read(string2,*) paramval
        if (paramval.gt.0) then
         do I=1,paramval
          READ(9,'(a)') string2
          write(10,*) string2
         enddo
        endif

c       HISTORY AND INTEGRAL DATA
        read(9,'(a)') string2
        write(10,*) string2
        read(9,'(a)') string2
        write(10,*) string2

        read(string2,*) paramval
        if (paramval.gt.0) then
         do I=1,paramval
          READ(9,'(a)') string2
          write(10,*) string2
         enddo
        endif

c      OUPUT FIELD SPECIFICATION
        read(9,'(a)') string2
        write(10,*) string2

        read(9,'(a)') string2
        write(10,*) string2
        read(string2,*) paramval
        if (paramval.gt.0) then
         do I=1,paramval
          READ(9,'(a)') string2
          write(10,*) string2
         enddo
        endif

c         LAST FOUR LINES
         do I=1,5
          READ(9,'(a)') string2
          write(10,*) string2
         enddo


       ENDIF

      if (nid.eq.0) close(9)

      return
      end
c-----------------------------------------------------------------------

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Two-dimensional array computation using loops: missing private(j).
!References to j in the loop cause data races.
!Data race pairs (we allow multiple ones to preserve the pattern):
!  Write_set = {j@28, j@28:implicit step function +1}
!  Read_set = {j@29:17, j@29:26, j@28:12, j28@:22 (implicit step by +1)}
!  Any pair from Write_set vs. Write_set  and Write_set vs. Read_set is a data race pair.


program DRB073_doall2_orig_yes
    use omp_lib
    implicit none

    integer :: i, j, len
    integer, dimension(:,:), allocatable :: a
    len = 100

    allocate (a(len,len))

    !$omp parallel do
    do i = 1, 100
        do j = 1, 100
            a(i,j) = a(i,j)+1
        end do
    end do
    !$omp end parallel do


    deallocate(a)
end program

C> @file wall_bc.f Dirichlet states for wall boundary conditions
! FUN FACT: Did you know that bdry.f has a subroutine called
!           BCNEUSC
      subroutine wallbc2(nstate,f,e,facew,wbc)
! DIRICHLET WALL CONDITIONS BECAUSE I DONT KNOW HOW TO INDEX
! UNX in userbc with volume indices instead of face indices
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'TSTEP'
      include 'SOLN'
      include 'NEKUSE'
      include 'PARALLEL'
      include 'CMTBCDATA'
      include 'CMTDATA'

      integer nstate,f,e
      real    facew(lx1*lz1,2*ldim,nelt,nstate)
      real    wbc(lx1*lz1,2*ldim,nelt,nstate) 
      common /nekcb/ cb
      character*3 cb

      tol=1.0e-10
! JH112116
! rind state for inviscid fluxes is different from viscous fluxes? not
! sure what the right thing to do is.
! JH031617 Collis (CTR 2002-ish), Hartmann & Houston (2006-8) probably BR
!          and Dolejsi and Feistatuer (2015) (check that)
!          all say YES, inviscid rind and viscous rind are different.
      call facind(i0,i1,j0,j1,k0,k1,lx1,ly1,lz1,f)    
      ieg=lglel(e)
      l=0
      do iz=k0,k1
      do iy=j0,j1
      do ix=i0,i1
         call nekasgn(ix,iy,iz,e)
         call cmtasgn(ix,iy,iz,e)
         call userbc (ix,iy,iz,f,ieg)
         l=l+1

! bring this outside of the face point loop you moron
         if (abs(vdiff(ix,iy,iz,e,ilam)) .gt. tol) then ! physical not artvisc

            wbc(l,f,e,iux)=ux
            wbc(l,f,e,iuy)=uy
            wbc(l,f,e,iuz)=uz
!-----------------------------------------------------------------
! JH112116 I need to check wbc(:,ipr) to make sure it is unchanced
!          from inviscid computation (assuming that's the right
!          answer for general viscous BC).
!-----------------------------------------------------------------
            wbc(l,f,e,iph) =phi
            wbc(l,f,e,ithm)=temp
            wbc(l,f,e,iu1) =facew(l,f,e,iu1)
            wbc(l,f,e,iu2) =wbc(l,f,e,iu1)*ux
            wbc(l,f,e,iu3) =wbc(l,f,e,iu1)*uy
            wbc(l,f,e,iu4) =wbc(l,f,e,iu1)*uz
            if (cb .eq. 'W  ') then ! consider taking properties from userbc too
!           wbc(l,f,e,iu5)=wbc(l,f,e,iu1)*facew(l,f,e,icvf)
               wbc(l,f,e,iu5)=phi*facew(l,f,e,icvf)*temp+
     >         0.5/wbc(l,f,e,iu1)*(wbc(l,f,e,iu2)**2+wbc(l,f,e,iu3)**2+
     >                          wbc(l,f,e,iu4)**2)
            else ! BETTA JUST BE 'I  '
!-------------------------------------------------------------
! JH111516 HARDCODING ADIABATIC WALL. DO SMARTER SOON
!          METHOD "B"
!           wbc(l,f,e,iu5)=facew(l,f,e,iu5)-0.5/facew(l,f,e,iu1)*
!    >     (facew(l,f,e,iu2)**2+facew(l,f,e,iu3)**2+facew(l,f,e,iu4)**2)
!          METHOD "A"
               wbc(l,f,e,iu5)=facew(l,f,e,iu5)
            endif
! JH111516 INVISCID HARDCODING ADIABATIC WALL. DO SMARTER SOON
!-------------------------------------------------------------
         else ! artvisc only

! JH031617 For now, artificial viscosity does not directly contribute to
!          boundary fluxes at all. This means dU=0 for IGTU and gradU is
!          strictly interior for IGU
            do m=1,nqq ! TEST FOR vDIFF OUTSIDE WHAT THE EHLLO IS WRONG WITH YOU
               wbc(l,f,e,m)=facew(l,f,e,m)
            enddo

         endif ! physical viscosity or artvisc
      enddo
      enddo
      enddo

      return
      end

      subroutine wallbc_inviscid(nstate,f,e,facew,wbc)
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      include 'CMTBCDATA'

      integer nstate,f,e
      real    facew(lx1*lz1,2*ldim,nelt,nstate)
      real    wbc(lx1*lz1,2*ldim,nelt,nstate) 

! JH102016
! rind state for inviscid fluxes is different from viscous fluxes
      call reflect_rind(nstate,f,e,facew,wbc)

      return
      end

      subroutine reflect_rind(nvar,f,e,facew,wbc)
      include 'SIZE'
      include 'CMTBCDATA'
      include 'CMTDATA'
      include 'GEOM'
      include 'INPUT'
      include 'PARALLEL'
      include 'DG'
      include 'MASS'
      include 'TSTEP'
      integer  f,e
! JH091614 facew now has intent(inout)...
! JH031315 not anymore. nobody changes qminus here. that's dumb
      real facew(lx1*lz1,2*ldim,nelt,nvar)
      real wbc(lx1*lz1,2*ldim,nelt,nvar)
      integer i, nxz, fdim
      real nx,ny,nz,rl,ul,vl,wl,pl,fs
      parameter (lfd1=lxd*lzd,lfc1=lx1*lz1)

      nxz=lx1*lz1
      nxzd=lxd*lzd
      fdim=ldim-1
      ieg=lglel(e)
      ifield=1

! I know this says slipwall, but to the inviscid terms all walls are
! slip. or something.
      call facind(i0,i1,j0,j1,k0,k1,lx1,ly1,lz1,f)    
      do l=1,nxz
         nx = unx(l,1,f,e)
         ny = uny(l,1,f,e)
         nz = unz(l,1,f,e)
         rl = facew(l,f,e,irho)
         rr = rl
         ul = facew(l,f,e,iux)
         vl = facew(l,f,e,iuy)
         wl = facew(l,f,e,iuz)
         fs = 0.0 ! no moving grid for awhile, and it will not look anything
                  ! like RocFlu

! JH111516 Mirror a la' Dolejsi & Feistauer (2015) section 8.3.1.2
! JH021717 This is for inviscid fluxes, which are produced by the Riemann
!          solver. Presently, this is AUSM, which acts on primitive variables
!          as-coded. Still, it always makes sense to form UBC, so we do so
!          here even though it is different for viscous BC
         udotn = ul*nx+vl*ny+wl*nz
         ur = ul-2.0*udotn*nx
         vr = vl-2.0*udotn*ny
         wr = wl-2.0*udotn*nz
         wbc(l,f,e,irho)= rr
         wbc(l,f,e,iux) = ur
         wbc(l,f,e,iuy) = vr
         wbc(l,f,e,iuz) = wr
         wbc(l,f,e,ipr) = facew(l,f,e,ipr)
         wbc(l,f,e,ithm)= facew(l,f,e,ithm)
         wbc(l,f,e,isnd)= facew(l,f,e,isnd)
         wbc(l,f,e,iph) = facew(l,f,e,iph)
         wbc(l,f,e,icvf)= facew(l,f,e,icvf)
         wbc(l,f,e,icpf)= facew(l,f,e,icpf)
         wbc(l,f,e,iu1)= facew(l,f,e,iu1)
         wbc(l,f,e,iu2)= rr*ur
         wbc(l,f,e,iu3)= rr*vr
         wbc(l,f,e,iu4)= rr*wr
         wbc(l,f,e,iu5)= facew(l,f,e,iu5)
      enddo

      return
      end

!--------------------------------------------------------------------
! NOT LONG FOR THIS WORLD

      subroutine slipwall_rflu(nvar,f,e,facew,wbc,fluxw)
      include 'SIZE'
      include 'CMTBCDATA'
      include 'CMTDATA'
      include 'GEOM'
      include 'NEKUSE'
      include 'INPUT'
      include 'PARALLEL'
      include 'DG'
      include 'MASS'
      include 'TSTEP'
      integer  f,e
! JH091614 facew now has intent(inout)...
! JH031315 not anymore. nobody changes qminus here. that's dumb
      real facew(lx1*lz1,2*ldim,nelt,nvar)
      real wbc(lx1*lz1,2*ldim,nelt,nvar)
      real fluxw(lx1*lz1,2*ldim,nelt,*)
      integer i, nxz, fdim
      real nx,ny,nz,rl,ul,vl,wl,pl,fs
      parameter (lfd1=lxd*lzd,lfc1=lx1*lz1)
      common /SCRNS/ nxf(lfd1),nyf(lfd1),nzf(lfd1),fs2(lfd1),
     >               ufacel(lfd1,5),plc(lfc1),ufacer(lfd1,5),prc(lfd1),
     >               flx(lfd1,5),plf(lfd1),jaco_c(lfc1),
     >               jaco_f(lfd1),dumminus(lfd1,5)
      real nxf,nyf,nzf,ufacel,ufacer,plc,prc,plf,jaco_c,jaco_f,dumminus

      nxz=lx1*lz1
      nxzd=lxd*lzd
      fdim=ldim-1
      ieg=lglel(e)
      ifield=1

! I know this says slipwall, but to the inviscid terms all walls are
! slip. or something.
      call facind(i0,i1,j0,j1,k0,k1,lx1,ly1,lz1,f)    
      l=0
      do iz=k0,k1
      do iy=j0,j1
      do ix=i0,i1
         call nekasgn(ix,iy,iz,e)
         call userbc (ix,iy,iz,f,ieg) ! get molarmass, phi
c                                     ! ux,uy,uz someday
         l=l+1
         nx = unx(l,1,f,e)
         ny = uny(l,1,f,e)
         nz = unz(l,1,f,e)
         rl = facew(l,f,e,irho)
         ul = facew(l,f,e,iux)
         vl = facew(l,f,e,iuy)
         wl = facew(l,f,e,iuz)
         plc(l)= facew(l,f,e,ipr)
         fs = 0.0 ! no moving grid for awhile, and it will not look anything
                  ! like RocFlu
         call RFLU_SetRindStateSlipWallPerf(cp,molarmass,nx,ny,nz,
     >                                      rl,ul,vl,wl,fs,plc(l))
         wbc(l,f,e,irho)=rl

!-----------------------------------------------------------------
! JH111516 INVISCID HARDCODING SLIP WALL. DO THIS SMARTER SOON
! JH111516 Mirror a la' Dolejsi & Feistauer (2015) section 8.3.1.2
!-----------------------------------------------------------------
         udotn=ul*nx+vl*ny+wl*nz
         ur=ul-2.0*udotn*nx
         vr=vl-2.0*udotn*ny
         wr=wl-2.0*udotn*nz
         wbc(l,f,e,iux)=ur
         wbc(l,f,e,iuy)=vr
         wbc(l,f,e,iuz)=wr
! JH111516 SHOULD BE SET TO WALL SPEED i.e. 0 FOR NO-SLIP WALLS!!!
!-----------------------------------------------------------------
         wbc(l,f,e,ipr)=plc(l)! from RFLU_SetRindStateSlipWallPerf
         wbc(l,f,e,iph)=phi
         wbc(l,f,e,iu1)=facew(l,f,e,iu1)
         wbc(l,f,e,iu2)=wbc(l,f,e,iu1)*ur
         wbc(l,f,e,iu3)=wbc(l,f,e,iu1)*vr
         wbc(l,f,e,iu4)=wbc(l,f,e,iu1)*wr
!-------------------------------------------------------------
! JH111516 INVISCID HARDCODING ADIABATIC WALL. DO SMARTER SOON
         wbc(l,f,e,iu5)=facew(l,f,e,iu5)
! JH111516 INVISCID HARDCODING ADIABATIC WALL. DO SMARTER SOON
!-------------------------------------------------------------
! need a different place to set dirichlet BC for viscous fluxes
!           wbc(l,f,e,iux)=ux ! better b
!           wbc(l,f,e,iuy)=uy
!           wbc(l,f,e,iuz)=uz
!        if (cbc(f,e,ifield) .eq. 'W  ') wbc(l,f,e,ithm)=temp
         plc(l)=plc(l)*phi
      enddo
      enddo
      enddo

! Inviscid flux at walls is due to pressure only. should probably just
! hardcode that instead of calling CentralInviscid so trivially
      if (lxd.gt.lx1) then
         call map_faced(nxf,unx(1,1,f,e),lx1,lxd,fdim,0)
         call map_faced(nyf,uny(1,1,f,e),lx1,lxd,fdim,0)
         call map_faced(nzf,unz(1,1,f,e),lx1,lxd,fdim,0)
         call map_faced(plf,plc,lx1,lxd,fdim,0)

         call invcol3(jaco_c,area(1,1,f,e),wghtc,nxz)
         call map_faced(jaco_f,jaco_c,lx1,lxd,fdim,0)
         call col2(jaco_f,wghtf,nxzd)
      else
         call copy(nxf,unx(1,1,f,e),nxz)
         call copy(nyf,uny(1,1,f,e),nxz)
         call copy(nzf,unz(1,1,f,e),nxz)
         call copy(plf,plc,nxz)

         call copy(jaco_f,area(1,1,f,e),nxz)
      endif
      call rzero(dumminus,toteq*nxzd)
      call map_faced(dumminus(1,1),facew(1,f,e,iu1),lx1,lxd,fdim,0)
      call rzero(fs2,nxzd)
! START BY GETTING RID OF THESE TRIVIAL CENTRAL CALLS AND CENTRAL ALTOGETHER
      call CentralInviscid_FluxFunction(nxzd,nxf,nyf,nzf,fs2,dumminus,
     >                                    plf,dumminus,plf,flx)

      do ieq=1,toteq-1
         call col2(flx(1,ieq),jaco_f,nxzd)
      enddo

      if (lxd.gt.lx1) then
         do j=1,toteq-1
            call map_faced(fluxw(1,f,e,j),flx(1,j),lx1,lxd,fdim,1)
         enddo
         if(cbc(f,e,ifield).ne.'I  ') call map_faced(fluxw(1,f,e,toteq),
     >                              flx(1,toteq),lx1,lxd,fdim,1)
      else
         do j=1,toteq-1
            call copy(fluxw(1,f,e,j),flx(1,j),nxz)
         enddo
         if (cbc(f,e,ifield).ne.'I  ') call copy(fluxw(1,f,e,toteq),
     >                              flx(1,toteq),nxz)
      endif

      return
      end

!-----------------------------------------------------------------------
! ******************************************************************************
!
! Purpose: Set rind state for slip-wall boundaries and perfect gas.
!
! Description: Torn bleeding from RocFlu. I think "rind" means the same thing as
!              "ghost," but I gotta admit that it's a better way of putting it.
!              Not sure if low-order reconstruction lurks here.
! Input:
!   cpGas       Specific heat at constant pressure
!   mmGas       Molecular mass
!   nx,ny,nz    Components of unit normal vector
!   rl          Density
!   ul         x-velocity component
!   vl         y-velocity component
!   wl         z-velocity component
!   fs          Grid speed
!   pl          Pressure
!
! Output: 
!   pl          Pressure
!
! Notes: 
!   1. Valid only for thermally and calorically perfect gas.
!
! ******************************************************************************

      SUBROUTINE RFLU_SetRindStateSlipWallPerf(cpGas,mmGas,nx,ny,nz,rl,
     >                                         ul,vl,wl,fs,pl)

! ******************************************************************************
!   Declarations and definitions
! ******************************************************************************

      real MixtPerf_R_M, MixtPerf_G_CpR, MixtPerf_C_DGP
      external MixtPerf_R_M, MixtPerf_G_CpR, MixtPerf_C_DGP

! ==============================================================================  
!   Arguments 
! ==============================================================================  

      REAL cpGas,fs,mmGas,nx,ny,nz,rl,ul,vl,wl
      REAL pl

! ==============================================================================  
!   Locals 
! ==============================================================================  

      REAL al,gGas,irl,ql,rGas,term
          
! ******************************************************************************
!   Compute wall pressure
! ******************************************************************************

      rGas = MixtPerf_R_M(mmGas)
      gGas = MixtPerf_G_CpR(cpGas,rGas)
 
      irl = 1.0/rl
      ql  = ul*nx + vl*ny + wl*nz - fs
 
      al  = MixtPerf_C_DGP(rl,gGas,pl)

      IF ( ql .lt. 0.0 ) THEN
         term = 1.0 + 0.5*(gGas-1.0)*ql/al
         pl   = pl*term**(2.0*gGas/(gGas-1.0))
      ELSE
         term = (gGas+1.0)/4.0
         pl   = pl + term*rl*ql*(ql + SQRT(al*al+term*term*ql*ql)/term)
      END IF ! ql
 
! ******************************************************************************
!   End
! ******************************************************************************

      end
! NOT LONG FOR THIS WORLD
!--------------------------------------------------------------------

program shortcircuiteval
  implicit none
  real :: res, arr(4)
  integer :: n, i
  n = 4
  do i=1,n
    arr(i) = i
  end do
  i = 6
  call shortcircuit(arr, n, i, res);
end program shortcircuiteval
       
subroutine shortcircuit(arr, arr_size, idx, relu)
  real :: arr(:)
  integer :: idx, arr_size
  real :: relu
  if(idx .le. arr_size .and. arr(idx) .ge. 0) then
    relu = arr(idx)
  else
    relu = 0
  end if
end subroutine shortcircuit

      SUBROUTINE EPREC2(Z2,R2)
C----------------------------------------------------------------
C
C     Precondition the explicit pressure operator (E) with
C     a Neumann type (H1) Laplace operator: JT*A*J.
C     Invert A by conjugate gradient iteration or multigrid.
C
C     NOTE: SCRNS is used.
C
C----------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'GEOM'
      INCLUDE 'SOLN'
      INCLUDE 'MASS'
      INCLUDE 'PARALLEL'
      INCLUDE 'TSTEP'
      REAL           Z2   (LX2,LY2,LZ2,LELV)
      REAL           R2   (LX2,LY2,LZ2,LELV)
      COMMON /SCRNS/ MASK (LX1,LY1,LZ1,LELV)
     $              ,R1   (LX1,LY1,LZ1,LELV)
     $              ,X1   (LX1,LY1,LZ1,LELV)
     $              ,W2   (LX2,LY2,LZ2,LELV)
     $              ,H1   (LX1,LY1,LZ1,LELV)
     $              ,H2   (LX1,LY1,LZ1,LELV)
      REAL    MASK
c
      integer icalld
      save    icalld
      data    icalld/0/
      icalld=icalld+1
c
      ntot2  = lx2*ly2*lz2*nelv
      call rzero(z2,ntot2)
c
c
c
c
c  Both local and global solver...
       call dd_solver (z2,r2)
c
c
c
c  Local solver only
c      call local_solves_fdm (z2,r2)
c
c
c
      return
      end
c-----------------------------------------------------------------------
      subroutine dd_solver(u,v)
c
      include 'SIZE'
      include 'DOMAIN'
      include 'INPUT'
      include 'PARALLEL'
      include 'SOLN'
      include 'CTIMER'
c
      real u(1),v(1)
      common /scrprc/ uc(lx1*ly1*lz1*lelt)
c
      if (icalld.eq.0) then
         tddsl=0.0
         tcrsl=0.0
         nddsl=0
         ncrsl=0
      endif
      icalld = icalld + 1
      nddsl  = nddsl  + 1
      ncrsl  = ncrsl  + 1

      ntot  = lx2*ly2*lz2*nelv
      call rzero(u,ntot)

      etime1=dnekclock()
      call local_solves_fdm    (u,v)
      tddsl=tddsl+dnekclock()-etime1

      etime1=dnekclock()
      call crs_solve_l2 (uc,v)
      tcrsl=tcrsl+dnekclock()-etime1

      alpha = 10.
c     if (param(89).ne.0.) alpha = abs(param(89))
      call add2s2(u,uc,alpha,ntot)

      return
      end
c-----------------------------------------------------------------------
      subroutine rar2_out(x,name13)
      include 'SIZE'
c
      real x(lx2,ly2,lz2,lelt)
      character*13 name13
c
      if (nelv.gt.20) return
      write(6,*) 
      write(6,1) name13
    1 format(a13)
      if (nelv.gt.2) then
         write(6,*) 
         do j=ly2,1,-1
            write(6,6) (x(k,j,1,3),k=1,lx2),(x(k,j,1,4),k=1,lx2)
         enddo
         write(6,*)
         write(6,*)
      endif
c
      do j=ly2,1,-1
         write(6,6) (x(k,j,1,1),k=1,lx2),(x(k,j,1,2),k=1,lx2)
      enddo
      write(6,*)
    6 format(3f8.4,5x,3f8.4)
      return
      end
c-----------------------------------------------------------------------
      subroutine rarr_out2(x,name13)
      include 'SIZE'
      include 'INPUT'
c
      real x(lx2,ly2,lz2,lelt)
      character*13 name13
c
      if (nelv.gt.20) return
      write(6,*) 
      write(6,1) name13
    1 format('rarr2',3x,a13)
c
c     3 D
c
      if (if3d) then
         do iz=1,lz1
            write(6,*) 
            do j=ly1,1,-1
               write(6,3) (x(k,j,iz,1),k=1,lx2),(x(k,j,iz,2),k=1,lx2)
            enddo
         enddo
         write(6,*)
         write(6,*)
         return
      endif
c
c     2 D
c
      if (nelv.gt.2) then
         write(6,*) 
         do j=ly2,1,-1
            write(6,6) (x(k,j,1,3),k=1,lx2),(x(k,j,1,4),k=1,lx2)
         enddo
         write(6,*)
         write(6,*)
      endif
c
      do j=ly2,1,-1
         write(6,6) (x(k,j,1,1),k=1,lx2),(x(k,j,1,2),k=1,lx2)
      enddo
      write(6,*)
    3 format(4f6.2,5x,4f6.2)
    6 format(4f8.5,5x,4f8.5)
      return
      end
c-----------------------------------------------------------------------

      PROGRAM SPECLIB
      INTEGER NP = 3, I, J
      REAL TMP
      DIMENSION Z(3), W(3)
      
      DO I=1,NP
          Z(I) = I*2.0
          W(I) = 1.0
      END DO
      DO I=1, 2*NP, 2
          TMP = 2.0*I*ATAN(1)/NP
!$CVL $ASSUME(COS(TMP) + COS(4*ATAN(1) - TMP) == 0.0);
      END DO
!$CVL $ASSUME(2.0*COS(ATAN(1))*COS(ATAN(1)) == 1.0);
!$CVL $ASSUME(4.0*COS(10.0/3.0*ATAN(1))*COS(10.0/3.0*ATAN(1)) == 3.0)
      CALL ZWGL(Z,W,NP)
      END PROGRAM SPECLIB

c-----------------------------------------------------------------------
      subroutine setupcomm(comm,newcomm,newcommg,path_in,session_in)
      include 'mpif.h'
      include 'SIZE'
      include 'PARALLEL' 
      include 'TSTEP' 
      include 'INPUT'

      integer comm, newcomm, newcommg
      character session_in*(*), path_in*(*)
      logical flag
    
      common /nekmpi/ mid,mp,nekcomm,nekgroup,nekreal
 
      integer nid_global_root(0:nsessmax-1)
      character*132 session_mult(0:nsessmax-1), path_mult(0:nsessmax-1)

      logical ifhigh
      logical mpi_is_initialized

      integer*8 ntags

      call mpi_initialized(mpi_is_initialized, ierr)
      if (.not.mpi_is_initialized) call mpi_init(ierr)

      call mpi_comm_dup(comm,newcommg,ierr)
      newcomm = newcommg
      nekcomm = newcommg 

      call mpi_comm_size(nekcomm,np_global,ierr)
      call mpi_comm_rank(nekcomm,nid_global,ierr)

      ! check upper tag size limit
      call mpi_comm_get_attr(MPI_COMM_WORLD,MPI_TAG_UB,ntags,flag,ierr)
      if (ntags .lt. np_global) then
         if(nid_global.eq.0) write(6,*) 'ABORT: MPI_TAG_UB too small!'
         call exitt
      endif

      ! set defaults
      nid         = nid_global
      ifneknek    = .false.
      ifneknekc   = .false. ! session are uncoupled
      nsessions   = 1

      ierr = 0
      nlin = 0
      if (nid .eq. 0) then
         l = ltrunc(session_in,len(session_in))
         if (l .gt. 0) then
            call blank(session_mult(0),132)
            call chcopy(session_mult(0), session_in, l)
            l = ltrunc(path_in,len(path_in))
            call blank(path_mult(0)   ,132)
            call chcopy(path_mult(0), path_in, l)
         else
           !write(6,*) 'Reading session file ...'
           open (unit=8,file='SESSION.NAME',status='old',err=24)
 21        read (8,*,END=22)
           nlin = nlin + 1 
           goto 21
 22        rewind(8)
           if (nlin.gt.2) read(8,*,err=24) nsessions
           if (nsessions.gt.1) read(8,*,err=24) ifneknekc
           do n=0,nsessions-1
              call blank(session_mult(n),132)
              call blank(path_mult(n)   ,132)
              read(8,11,err=24) session_mult(n)
              read(8,11,err=24) path_mult(n)
              if (nsessions.gt.1) read(8,*,err=24)  npsess(n)
           enddo
 11        format(a132)
           close(8)
         endif
         if (nsessions.gt.1) 
     $     write(6,*) 'Number of sessions:',nsessions
         goto 23
 24      ierr = 1
      endif
 23   continue
      call err_chk(ierr,' Error while reading SESSION.NAME!$')

      call bcast(nsessions,ISIZE)
      if (nsessions .gt. nsessmax) 
     &   call exitti('nsessmax in SIZE too low!$',nsessmax)
      if (nsessions .gt. 1) ifneknek = .true.

      call bcast(ifneknekc,LSIZE)
      do n = 0,nsessions-1
         call bcast(npsess(n),ISIZE)
         call bcast(session_mult(n),132*CSIZE)
         call bcast(path_mult(n),132*CSIZE)
      enddo

      ! single session run
      if (.not.ifneknek) then
         ifneknekc = .false.
         session   = session_mult(0)
         path      = path_mult(0)
         amgfile  = session
         return
      endif
 
c     Check if specified number of ranks in each session is consistent 
c     with the total number of ranks
      npall=0
      do n=0,nsessions-1
         npall=npall+npsess(n)
      enddo
      if (npall.ne.np_global) 
     &   call exitti('Number of ranks does not match!$',npall)

c     Assign key for splitting into multiple groups
      nid_global_root_next=0
      do n=0,nsessions-1
         nid_global_root(n)=nid_global_root_next
         nid_global_root_next=nid_global_root(n)+npsess(n)
         if (nid_global.ge.nid_global_root(n).and.
     &       nid_global.lt.nid_global_root_next) idsess = n
      enddo
      call mpi_comm_split(comm,idsess,nid,newcomm,ierr)
 
      session = session_mult(idsess)
      path    = path_mult   (idsess)

      if (ifneknekc) then
         if (nsessions.gt.2) call exitti(
     &     'More than 2 coupled sessions are currently not supported!$',
     $     nsessions)
      endif 

      amgfile  = session

      return
      end
c---------------------------------------------------------------------
      subroutine iniproc()
      include 'SIZE'
      include 'PARALLEL'
      include 'INPUT'
      include 'mpif.h'

      common /nekmpi/ nid_,np_,nekcomm,nekgroup,nekreal

      logical flag
      integer*8 isize_mpi, lb

      nid  = mynode()
      nid_ = nid
      np   = numnodes()
      np_  = np

      nio = -1             ! Default io flag 
      if (nid.eq.0) nio=0  ! Only node 0 writes

      if (nid.eq.nio) then
         if (ifneknek) then
           call set_stdout(' ',idsess) 
         else
           call set_stdout(' ',-1) 
         endif
      endif

      if (wdsize .eq. 4)
     $   call exitti('Single precision mode not supported!',wdsize)

      call MPI_Type_Get_Extent(MPI_DOUBLE_PRECISION,lb,isize_mpi,ierr)
      if (isize_mpi .ne. wdsize) then
         call exitti('MPI real size does not match$',isize_mpi)
      endif

      call MPI_Type_Get_Extent(MPI_INTEGER,lb,isize_mpi,ierr)
       if (isize_mpi .ne. isize) then
         call exitti('MPI integer size does not match$',isize_mpi)
      endif

      call MPI_Type_Get_Extent(MPI_INTEGER8,lb,isize_mpi,ierr)
       if (isize_mpi .ne. isize8) then
         call exitti('MPI integer8 size does not match$',isize_mpi)
      endif

      PID = 0
      NULLPID=0
      NODE0=0
      NODE= NID+1

C     Test timer accuracy
      edif = 0.0
      do i = 1,10
         e1 = dnekclock()
         e2 = dnekclock()
         edif = edif + e2-e1
      enddo
      edif = edif/10.

      call fgslib_crystal_setup(cr_h,nekcomm,np)  ! set cr handle to new instance
      return
      end
c-----------------------------------------------------------------------
      subroutine gop( x, w, op, n)

c     Global vector commutative operation

      include 'CTIMER'

      include 'mpif.h'
      common /nekmpi/ nid,np,nekcomm,nekgroup,nekreal

      real x(n), w(n)
      character*3 op

      if (ifsync) call nekgsync()

#ifdef TIMER
      if (icalld.eq.0) then
        tgop =0.0d0
        ngop =0
        icalld=1
      endif
      ngop = ngop + 1
      etime1=dnekclock()
#endif
c
      if (op.eq.'+  ') then
      call mpi_allreduce(x,w,n,MPI_DOUBLE_PRECISION,mpi_sum,nekcomm,ie)
      elseif (op.EQ.'M  ') then
      call mpi_allreduce(x,w,n,MPI_DOUBLE_PRECISION,mpi_max,nekcomm,ie)
      elseif (op.EQ.'m  ') then
      call mpi_allreduce(x,w,n,MPI_DOUBLE_PRECISION,mpi_min,nekcomm,ie)
      elseif (op.EQ.'*  ') then
      call mpi_allreduce(x,w,n,MPI_DOUBLE_PRECISION,mpi_prod,nekcomm,ie)
      else
      write(6,*) nid,' OP ',op,' not supported.  ABORT in GOP.'
      call exitt
      endif

      call copy(x,w,n)

#ifdef TIMER
      tgop =tgop +(dnekclock()-etime1)
#endif

      return
      end
c-----------------------------------------------------------------------
      subroutine igop( x, w, op, n)
c
c     Global vector commutative operation
c
      include 'mpif.h'
      common /nekmpi/ nid,np,nekcomm,nekgroup,nekreal

      integer x(n), w(n)
      character*3 op

      if     (op.eq.'+  ') then
        call mpi_allreduce (x,w,n,mpi_integer,mpi_sum ,nekcomm,ierr)
      elseif (op.EQ.'M  ') then
        call mpi_allreduce (x,w,n,mpi_integer,mpi_max ,nekcomm,ierr)
      elseif (op.EQ.'m  ') then
        call mpi_allreduce (x,w,n,mpi_integer,mpi_min ,nekcomm,ierr)
      elseif (op.EQ.'*  ') then
        call mpi_allreduce (x,w,n,mpi_integer,mpi_prod,nekcomm,ierr)
      else
        write(6,*) nid,' OP ',op,' not supported.  ABORT in igop.'
        call exitt
      endif

      call icopy(x,w,n)

      return
      end
c-----------------------------------------------------------------------
      subroutine i8gop( x, w, op, n)
c
c     Global vector commutative operation
c
      include 'mpif.h'
      common /nekmpi/ nid,np,nekcomm,nekgroup,nekreal

      integer*8 x(n), w(n)
      character*3 op

      if     (op.eq.'+  ') then
        call mpi_allreduce (x,w,n,mpi_integer8,mpi_sum ,nekcomm,ierr)
      elseif (op.EQ.'M  ') then
        call mpi_allreduce (x,w,n,mpi_integer8,mpi_max ,nekcomm,ierr)
      elseif (op.EQ.'m  ') then
        call mpi_allreduce (x,w,n,mpi_integer8,mpi_min ,nekcomm,ierr)
      elseif (op.EQ.'*  ') then
        call mpi_allreduce (x,w,n,mpi_integer8,mpi_prod,nekcomm,ierr)
      else
        write(6,*) nid,' OP ',op,' not supported.  ABORT in igop.'
        call exitt
      endif

      call i8copy(x,w,n)

      return
      end
c-----------------------------------------------------------------------
      subroutine csend(mtype,buf,len,jnid,jpid)
      include 'mpif.h'
      common /nekmpi/ nid,np,nekcomm,nekgroup,nekreal
      real*4 buf(1)

      call mpi_send (buf,len,mpi_byte,jnid,mtype,nekcomm,ierr)

      return
      end
c-----------------------------------------------------------------------
      subroutine crecv(mtype,buf,lenm)
      include 'mpif.h'
      common /nekmpi/ nid,np,nekcomm,nekgroup,nekreal
      integer status(mpi_status_size)
C
      real*4 buf(1)
      len = lenm
      jnid = mpi_any_source

      call mpi_recv (buf,len,mpi_byte
     $              ,jnid,mtype,nekcomm,status,ierr)
c
      if (len.gt.lenm) then 
          write(6,*) nid,'long message in mpi_crecv:',len,lenm
          call exitt
      endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine crecv2(mtype,buf,lenm,jnid)
      include 'mpif.h'
      common /nekmpi/ nid,np,nekcomm,nekgroup,nekreal
      integer status(mpi_status_size)
C
      real*4 buf(1)
      len = lenm

      call mpi_recv (buf,len,mpi_byte
     $              ,jnid,mtype,nekcomm,status,ierr)
c
      if (len.gt.lenm) then 
          write(6,*) nid,'long message in mpi_crecv:',len,lenm
          call exitt
      endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine crecv3(mtype,buf,len,lenm)
      include 'mpif.h'
      common /nekmpi/ nid,np,nekcomm,nekgroup,nekreal
      integer status(mpi_status_size)
C
      real*4 buf(1)
      len = lenm
      jnid = mpi_any_source

      call mpi_recv (buf,len,mpi_byte
     $            ,jnid,mtype,nekcomm,status,ierr)
      call mpi_get_count (status,mpi_byte,len,ierr)
c
      if (len.gt.lenm) then 
          write(6,*) nid,'long message in mpi_crecv:',len,lenm
          call exitt
      endif
c
      return
      end
c-----------------------------------------------------------------------
      integer function numnodes()
      include 'mpif.h'
      common /nekmpi/ nid,np,nekcomm,nekgroup,nekreal

      call mpi_comm_size (nekcomm, numnodes , ierr)

      return
      end
c-----------------------------------------------------------------------
      integer function mynode()
      include 'mpif.h'
      common /nekmpi/ nid,np,nekcomm,nekgroup,nekreal
      integer myid

      call mpi_comm_rank (nekcomm, myid, ierr)
      mynode = myid

      return
      end
c-----------------------------------------------------------------------
      real*8 function dnekclock()
      include 'mpif.h'
c
      dnekclock=mpi_wtime()
c
      return
      end
c-----------------------------------------------------------------------
      real*8 function dnekclock_sync()
      include 'mpif.h'
c
      call nekgsync()
      dnekclock_sync=mpi_wtime()
c
      return
      end
c-----------------------------------------------------------------------
      subroutine lbcast(ifif)
C
C     Broadcast logical variable to all processors.
C
      include 'SIZE'
      include 'PARALLEL'
      include 'mpif.h'

      logical ifif

      if (np.eq.1) return

      item=0
      if (ifif) item=1
      call bcast(item,isize)
      ifif=.false.
      if (item.eq.1) ifif=.true.

      return
      end
c-----------------------------------------------------------------------
      subroutine bcast(buf,len)
      include 'mpif.h'
      common /nekmpi/ nid,np,nekcomm,nekgroup,nekreal
      real*4 buf(1)

      call mpi_bcast (buf,len,mpi_byte,0,nekcomm,ierr)

      return
      end
c-----------------------------------------------------------------------
      subroutine create_comm(inewcomm)
      include 'mpif.h'
      common /nekmpi/ nid,np,nekcomm,nekgroup,nekreal

c      call mpi_comm_group (mpi_comm_world,itmp,ierr)
c      call mpi_comm_create (mpi_comm_world,itmp,icomm,ierr)
c      call mpi_group_free (itmp,ierr)

      call mpi_comm_dup(nekcomm,inewcomm,ierr)

      return
      end
c-----------------------------------------------------------------------
      function isend(msgtag,x,len,jnid,jpid)
c
c     Note: len in bytes
c
      integer x(1)
C
      include 'mpif.h'
      common /nekmpi/ nid,np,nekcomm,nekgroup,nekreal
C
      call mpi_isend (x,len,mpi_byte,jnid,msgtag
     $       ,nekcomm,imsg,ierr)
      isend = imsg
c     write(6,*) nid,' isend:',imsg,msgtag,len,jnid,(x(k),k=1,len/4)
c
      return
      end
c-----------------------------------------------------------------------
      function irecv(msgtag,x,len)
c
c     Note: len in bytes
c
      integer x(1)
C
      include 'mpif.h'
      common /nekmpi/ nid,np,nekcomm,nekgroup,nekreal
C
      call mpi_irecv (x,len,mpi_byte,mpi_any_source,msgtag
     $       ,nekcomm,imsg,ierr)
      irecv = imsg
c     write(6,*) nid,' irecv:',imsg,msgtag,len
c
c
      return
      end
c-----------------------------------------------------------------------
      subroutine msgwait(imsg)
c
      include 'mpif.h'
      common /nekmpi/ nid,np,nekcomm,nekgroup,nekreal
      integer status(mpi_status_size)
c
c     write(6,*) nid,' msgwait:',imsg
c
      call mpi_wait (imsg,status,ierr)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine nekgsync()

      include 'mpif.h'
      common /nekmpi/ nid,np,nekcomm,nekgroup,nekreal

      call mpi_barrier(nekcomm,ierr)

      return
      end
c-----------------------------------------------------------------------
      subroutine exittr(stringi,rdata,idata)
      character*1 stringi(132)
      character*1 stringo(132)
      character*25 s25
      include 'SIZE'
      include 'TOTAL'
      include 'CTIMER'

      call blank(stringo,132)
      call chcopy(stringo,stringi,132)
      len = indx1(stringo,'$',1)
      write(s25,25) rdata,idata
   25 format(1x,1p1e14.6,i10)
      call chcopy(stringo(len),s25,25)

      if (nid.eq.0) write(6,1) (stringo(k),k=1,len+24)
    1 format('EXIT: ',132a1)

      call exitt

      return
      end
c-----------------------------------------------------------------------
      subroutine exitti(stringi,idata)
      character*1 stringi(132)
      character*1 stringo(132)
      character*11 s11
      include 'SIZE'
      include 'TOTAL'
      include 'CTIMER'

      call blank(stringo,132)
      call chcopy(stringo,stringi,132)
      len = indx1(stringo,'$',1)
      write(s11,11) idata
   11 format(1x,i10)
      call chcopy(stringo(len),s11,11)

      if (nid.eq.0) write(6,1) (stringo(k),k=1,len+10)
    1 format('EXIT: ',132a1)

      call exitt

      return
      end
c-----------------------------------------------------------------------
      subroutine err_chk(ierr,string)
      character*1 string(132)
      character*1 ostring(132)
      character*10 s10
      include 'SIZE'
c     include 'TOTAL'
c     include 'CTIMER'

      ierr = iglsum(ierr,1)
      if(ierr.eq.0) return 

      len = indx1(string,'$',1)
      call blank(ostring,132)
      write(s10,11) ierr
   11 format(1x,' ierr=',i3)

      call chcopy(ostring,string,len-1)
      call chcopy(ostring(len),s10,10)

      if (nid.eq.0) write(6,1) (ostring(k),k=1,len+10)
    1 format('ERROR: ',132a1)

      call exitt

      return
      end
c
c-----------------------------------------------------------------------
      subroutine exitt0

      include 'SIZE'
      include 'TOTAL'

      if (nid.eq.0) then
         write(6,*) ' '
         write(6,'(A)') 'run successful: dying ...'
         write(6,*) ' '
      endif

c      if (nid.eq.0) call close_files
      call print_runtime_info
      call nek_die(0) 

      return
      end
c-----------------------------------------------------------------------
      subroutine exitt

      include 'SIZE'
      include 'TOTAL'

      if (nid.eq.0) then
         write(6,*) ' '
         write(6,'(A)') 'an error occured: dying ...'
         write(6,*) ' '
      endif

c      call print_stack()
c      if (nid.eq.0) call close_files
c      call print_runtime_info
      call nek_die(1) 
 
      return
      end
c-----------------------------------------------------------------------
      subroutine print_runtime_info
      include 'SIZE'
      include 'TOTAL'
      include 'CTIMER'
      include 'mpif.h'

#ifdef PAPI
      gflops = glsum(dnekgflops(),1)
#endif

      tstop  = dnekclock_sync()
      ttotal = tstop-etimes
      tsol   = max(ttime - tprep,0.0)
      nxyz   = lx1*ly1*lz1

      dtmp4 = glsum(getmaxrss(),1)/1e9

      if (nid.eq.0) then 
         dtmp1 = 0
         dtmp2 = 0
         if(istep.gt.0) then
           dgp   = nvtot
           dgp   = max(dgp,1.)*max(istep,1)
           dtmp0 = np*(ttime-tprep)
           dtmp1 = 0
           if (dtmp0.gt.0) dtmp1 = dgp/dtmp0 
           dtmp2 = (ttime-tprep)/max(istep,1)
         endif 
         write(6,*) ' '
         write(6,'(5(A,1p1e13.5,A,/))') 
     &       'total elapsed time             : ',ttotal, ' sec'
     &      ,'total solver time w/o IO       : ',tsol,   ' sec'
     &      ,'time/timestep                  : ',dtmp2 , ' sec'
     &      ,'avg throughput per timestep    : ',dtmp1 , ' gridpts/CPUs'
     &      ,'total max memory usage         : ',dtmp4 , ' GB'
#ifdef PAPI
         write(6,'(1(A,1p1e13.5,/))') 
     &      ,'total Gflops/s                 : ',gflops
#endif
      endif 
      call flush_io

      return
      end
c-----------------------------------------------------------------------
      subroutine nek_die(ierr)
      include 'SIZE'
      include 'mpif.h'

      call mpi_finalize (ierr_)
      call cexit(ierr)
 
      return
      end
c-----------------------------------------------------------------------
      subroutine fgslib_userExitHandler(istatus)

      call exitt

      return
      end
c-----------------------------------------------------------------------
      subroutine printHeader

      include 'SIZE'
      include 'PARALLEL'

      include 'HEADER'
      write(6,*) 'Number of MPI ranks :', np
c      WRITE(6,*) 'REAL     wdsize     :',WDSIZE
c      WRITE(6,*) 'INTEGER  wdsize     :',ISIZE
c      WRITE(6,*) 'INTEGER8 wdsize     :',ISIZE8
      WRITE(6,*) ' '

      return
      end
c-----------------------------------------------------------------------
      function igl_running_sum(in)
c
      include 'mpif.h'
      common /nekmpi/ nid,np,nekcomm,nekgroup,nekreal
      integer status(mpi_status_size)
      integer x,w,r

      x = in  ! running sum
      w = in  ! working buff
      r = 0   ! recv buff

      call mpi_scan(x,r,1,mpi_integer,mpi_sum,nekcomm,ierr)
      igl_running_sum = r

      return
      end
c-----------------------------------------------------------------------
      subroutine platform_timer(ivb) ! mxm, ping-pong, and all_reduce timer

      include 'SIZE'
      include 'TOTAL'


      call mxm_test_all(nid,ivb)  ! measure mxm times
c     call exitti('done mxm_test_all$',ivb)

      call comm_test(ivb)         ! measure message-passing and all-reduce times

      return
      end
c-----------------------------------------------------------------------
      subroutine comm_test(ivb) ! measure message-passing and all-reduce times
                                ! ivb = 0 --> minimal verbosity
                                ! ivb = 1 --> fully verbose
                                ! ivb = 2 --> smaller sample set(shorter)

      include 'SIZE'
      include 'PARALLEL'

      call gop_test(ivb)   ! added, Jan. 8, 2008

      log_np=log2(np)
      np2 = 2**log_np
      if (np2.eq.np) call gp2_test(ivb)   ! added, Jan. 8, 2008

      io = 6
      n512 = min(512,np-1)

      do nodeb=1,n512
         call pingpongo(alphas,betas,0,nodeb,.0005,io,ivb)
         if (nid.eq.0) write(6,2) nodeb,np,alphas,betas
    2    format(2i10,1p2e15.7,' alpha betao')
      enddo

      do kk=0,2
      do nodeb=1,n512
         call pingpong (alphas,betas,0,nodeb,.0005,io,ivb,kk)
         if (nid.eq.0) write(6,1) nodeb,np,alphas,betas,kk
    1    format(2i10,1p2e15.7,' alpha beta',i1)
      enddo
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine pingpong(alphas,betas,nodea,nodeb,dt,io,ivb,kk)

      include 'SIZE'
      common /nekmpi/ mid,np,nekcomm,nekgroup,nekreal

      parameter  (lt=lx1*ly1*lz1*lelt)
      parameter (mwd = 3*lt/2)
      common /scrns/ x(mwd),y(mwd),x1(mwd),y1(mwd)

      include 'mpif.h'
      integer status(mpi_status_size)

      character*10 fname

      if (nid.eq.nodea) then
         write(fname,3) np,nodeb
    3    format('t',i4.4,'.',i4.4)
         if (io.ne.6) open (unit=io,file=fname)
      endif

      call nekgsync
      call get_msg_vol(msg_vol,dt,nodea,nodeb) ! Est. msg vol for dt s

      nwds = 0
      if (nid.eq.nodea.and.ivb.gt.0) write(io,*)

      betas = 0  ! Reported inverse bandwidth
      count = 0

      do itest = 1,500

         nloop = msg_vol/(nwds+2)
         nloop = min(nloop,1000)
         nloop = max(nloop,1)

         len   = 8*nwds
     
         if (kk.eq.0)
     $      call ping_loop (t1,t0,len,nloop,nodea,nodeb,nid,x,y,x1,y1)
         if (kk.eq.1)
     $      call ping_loop1(t1,t0,len,nloop,nodea,nodeb,nid,x,y)
         if (kk.eq.2)
     $      call ping_loop2(t1,t0,len,nloop,nodea,nodeb,nid,x,y)

         if (nid.eq.nodea) then
            tmsg = (t1-t0)/(2*nloop)   ! 2*nloop--> Double Buffer
            tmsg = tmsg / 2.           ! one-way cost = 1/2 round-trip
            tpwd = tmsg                ! time-per-word
            if (nwds.gt.0) tpwd = tmsg/nwds
            if (ivb.gt.0) write(io,1) nodeb,np,nloop,nwds,tmsg,tpwd,kk
    1       format(3i6,i12,1p2e16.8,' pgn',i1)

            if (nwds.eq.1) then
               alphas = tmsg
            elseif (nwds.gt.10000) then   ! "average" beta
               betas = (betas*count + tpwd)/(count+1)
               count = count + 1
            endif
         endif

         if (ivb.eq.2) then
            nwds = (nwds+1)*1.25
         else
            nwds = (nwds+1)*1.016
         endif
         if (nwds.gt.mwd) then
c        if (nwds.gt.1024) then
            if (nid.eq.nodea.and.io.ne.6) close(unit=io)
            call nekgsync
            return
         endif

      enddo

      if (nid.eq.nodea.and.io.ne.6) close(unit=io)
      call nekgsync

      return
      end
c-----------------------------------------------------------------------
      subroutine pingpongo(alphas,betas,nodea,nodeb,dt,io,ivb)

      include 'SIZE'
      common /nekmpi/ mid,np,nekcomm,nekgroup,nekreal

      parameter  (lt=lx1*ly1*lz1*lelt)
      parameter (mwd = 3*lt)
      common /scrns/ x(mwd),y(mwd)

      include 'mpif.h'
      integer status(mpi_status_size)

      character*10 fname

      if (nid.eq.nodea) then
         write(fname,3) np,nodeb
    3    format('t',i4.4,'.',i4.4)
         if (io.ne.6) open (unit=io,file=fname)
      endif

      call nekgsync
      call get_msg_vol(msg_vol,dt,nodea,nodeb) ! Est. msg vol for dt s

      nwds = 0
      if (nid.eq.nodea.and.ivb.gt.0) write(io,*)

      betas = 0  ! Reported inverse bandwidth
      count = 0

      do itest = 1,500
         call nekgsync
         nloop = msg_vol/(nwds+2)
         nloop = min(nloop,1000)
         nloop = max(nloop,1)

         len   = 8*nwds
         jnid = mpi_any_source

         if (nid.eq.nodea) then

            msg  = irecv(itest,y,1)
            call csend(itest,x,1,nodeb,0)   ! Initiate send, to synch.
            call msgwait(msg)

            t0 = mpi_wtime ()
            do i=1,nloop
               call mpi_irecv(y,len,mpi_byte,mpi_any_source,i
     $                        ,nekcomm,msg,ierr)
               call mpi_send (x,len,mpi_byte,nodeb,i,nekcomm,ierr)
               call mpi_wait (msg,status,ierr)
            enddo
            t1 = mpi_wtime ()
            tmsg = (t1-t0)/nloop
            tmsg = tmsg / 2.       ! Round-trip message time = twice one-way
            tpwd = tmsg
            if (nwds.gt.0) tpwd = tmsg/nwds
            if (ivb.gt.0) write(io,1) nodeb,np,nloop,nwds,tmsg,tpwd
    1       format(3i6,i12,1p2e16.8,' pgo')

            if (nwds.eq.1) then
               alphas = tmsg
            elseif (nwds.gt.10000) then
               betas = (betas*count + tpwd)/(count+1)
               count = count + 1
            endif

         elseif (nid.eq.nodeb) then

            call crecv(itest,y,1)           ! Initiate send, to synch.
            call csend(itest,x,1,nodea,0)

            t0 = dnekclock()
            do i=1,nloop
               call mpi_recv (y,len,mpi_byte
     $               ,jnid,i,nekcomm,status,ierr)
               call mpi_send (x,len,mpi_byte,nodea,i,nekcomm,ierr)
            enddo
            t1 = dnekclock()
            tmsg = (t1-t0)/nloop

         endif

         nwds = (nwds+1)*1.016
         if (nwds.gt.mwd) then
            if (nid.eq.nodea.and.io.ne.6) close(unit=io)
            call nekgsync
            return
         endif

      enddo

      if (nid.eq.nodea.and.io.ne.6) close(unit=io)
      call nekgsync

      return
      end
c-----------------------------------------------------------------------
      subroutine get_msg_vol(msg_vol,dt,nodea,nodeb)
      include 'SIZE'
      common /nekmpi/ mid,np,nekcomm,nekgroup,nekreal
      parameter (lt=lx1*ly1*lz1*lelt)
      common /scrns/ x(3*lt),y(3*lt)
!
!     Est. msg vol for dt s
!
      msg_vol = 1000

      nwds  = min(1000,lt)
      nloop = 50
 
      tmsg = 0.
      call gop(tmsg,t1,'+  ',1)

      len = 8*nwds
      if (nid.eq.nodea) then

         msg  = irecv(1,y,1)
         call csend(1,x,1,nodeb,0)   ! Initiate send, to synch.
         call msgwait(msg)

         t0 = dnekclock()
         do i=1,nloop
            msg  = irecv(i,y,len)
            call csend(i,x,len,nodeb,0)
            call msgwait(msg)
         enddo
         t1   = dnekclock()
         tmsg = (t1-t0)/nloop
         tpwd = tmsg/nwds

      elseif (nid.eq.nodeb) then

         call crecv(1,y,1)           ! Initiate send, to synch.
         call csend(1,x,1,nodea,0)

         t0 = dnekclock()
         do i=1,nloop
            call crecv(i,y,len)
            call csend(i,x,len,nodea,0)
         enddo
         t1   = dnekclock()
         tmsg = (t1-t0)/nloop
         tmsg = 0.

      endif

      call gop(tmsg,t1,'+  ',1)
      msg_vol = nwds*(dt/tmsg)
c     if (nid.eq.nodea) write(6,*) nid,msg_vol,nwds,dt,tmsg,' msgvol'

      return
      end
c-----------------------------------------------------------------------
      subroutine gop_test(ivb)
      include 'SIZE'
      common /nekmpi/ mid,np,nekcomm,nekgroup,nekreal
      include 'mpif.h'
      integer status(mpi_status_size)

      parameter  (lt=lx1*ly1*lz1*lelt)
      parameter (mwd = 3*lt)
      common /scrns/ x(mwd),y(mwd)
      common /scruz/ times(2,500)
      common /scrcg/ nwd(500)

      nwds  = 1
      mtest = 0
      do itest = 1,500
         nwds = (nwds+1)*1.016
         if (nwds.gt.mwd) goto 100
         mtest = mtest+1
         nwd(mtest) = nwds
      enddo
  100 continue

      nwds = 1
      do itest = mtest,1,-1

         tiny = 1.e-27
         call cfill(x,tiny,mwd)
         nwds = nwd(itest)
         call nekgsync

         t0 = mpi_wtime ()
         call gop(x,y,'+  ',nwds)
         call gop(x,y,'+  ',nwds)
         call gop(x,y,'+  ',nwds)
         call gop(x,y,'+  ',nwds)
         call gop(x,y,'+  ',nwds)
         call gop(x,y,'+  ',nwds)
         t1 = mpi_wtime ()

         tmsg = (t1-t0)/6 ! six calls
         tpwd = tmsg
         if (nwds.gt.0) tpwd = tmsg/nwds
         times(1,itest) = tmsg
         times(2,itest) = tpwd

      enddo
  101 continue


      if (nid.eq.0) then
         nwds = 1
         do itest=1,500
            if (ivb.gt.0.or.itest.eq.1) 
     $         write(6,1) np,nwds,(times(k,itest),k=1,2)
    1       format(i12,i12,1p2e16.8,' gop')
            nwds = (nwds+1)*1.016
            if (nwds.gt.mwd) goto 102
         enddo
  102    continue
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine gp2_test(ivb)

      include 'SIZE'
      include 'mpif.h'

      common /nekmpi/ mid,np,nekcomm,nekgroup,nekreal
      integer status(mpi_status_size)

      parameter  (lt=lx1*ly1*lz1*lelt)
      parameter (mwd = 3*lt)
      common /scrns/ x(mwd),y(mwd)
      common /scruz/ times(2,500)

      call rzero(x,mwd)

      nwds = 1
      do itest = 1,500
         call gp2(x,y,'+  ',1,nid,np)

         t0 = mpi_wtime ()
         call gp2(x,y,'+  ',nwds,nid,np)
         call gp2(x,y,'+  ',nwds,nid,np)
         call gp2(x,y,'+  ',nwds,nid,np)
         call gp2(x,y,'+  ',nwds,nid,np)
         t1 = mpi_wtime ()

         tmsg = (t1-t0)/4 ! four calls
         tpwd = tmsg
         if (nwds.gt.0) tpwd = tmsg/nwds
         times(1,itest) = tmsg
         times(2,itest) = tpwd

         nwds = (nwds+1)*1.016
         if (nwds.gt.mwd) goto 101
      enddo
  101 continue


      if (nid.eq.0) then
         nwds = 1
         do itest=1,500
            if (ivb.gt.0.or.itest.eq.1) 
     $         write(6,1) np,nwds,(times(k,itest),k=1,2)
    1       format(i12,i12,1p2e16.8,' gp2')
            nwds = (nwds+1)*1.016
            if (nwds.gt.mwd) goto 102
         enddo
  102    continue
      endif

      return
      end
c-----------------------------------------------------------------------
      integer function xor(m,n)
c
c  If NOT running on a parallel processor, it is sufficient to
c  have this routine return a value of XOR=1.
c
c  Pick one of the following:
c
c  UNIX 4.2, f77:
       XOR = OR(M,N)-AND(M,N)
c
c  Intel FTN286:
c     XOR = M.NEQV.N
c
c  Ryan-McFarland Fortran
C      XOR = IEOR(M,N)
c
c     XOR = 0
c     IF(M.EQ.1 .OR.  N.EQ.1) XOR=1
c     IF(M.EQ.0 .AND. N.EQ.0) XOR=0
c     IF(M.EQ.1 .AND. N.EQ.1) XOR=0
c     IF(M.GT.1 .OR.N.GT.1 .OR.M.LT.0.OR.N.LT.0) THEN
c        PRINT*,'ERROR IN XOR'
c        STOP
c     ENDIF
C
      return
      end
c-----------------------------------------------------------------------
      subroutine gp2( x, w, op, n, nid, np)
c
c     Global vector commutative operation using spanning tree.
c
c     Std. fan-in/fan-out

      real x(n), w(n)
      character*3 op

      integer bit, bytes, cnt, diff, spsize, i, 
     *   parent, troot, xor, root, lnp, log2
      logical ifgot

      integer type
      save    type
      data    type  /998/

      type  = type+100
      if (type.gt.9992) type=type-998
      typer = type-1
      bytes = 8*n

      root    = 0
      troot   = max0((nid/np)*np, root)
      diff    = xor(nid,troot)
      nullpid = 0

c     Accumulate contributions from children, if any
      level2=1
    5 continue
         level=level2
         level2=level+level
         if (mod(nid,level2).ne.0) goto 20
            call crecv(type,w,bytes)
            if (op.eq.'+  ') then
               do i=1,n
                  x(i) = x(i) + w(i)
               enddo
            elseif (op.eq.'*  ') then
               do i=1,n
                  x(i) = x(i) * w(i)
               enddo
            elseif (op.eq.'M  ') then
               do i=1,n
                  x(i) = max(x(i),w(i))
               enddo
            elseif (op.eq.'m  ') then
               do i=1,n
                  x(i) = min(x(i),w(i))
               enddo
            endif
         if (level2.lt.np) goto 5

c     Pass result back to parent
   20 parent = nid-level
      if (nid .ne. 0) call csend(type,x,bytes,parent,nullpid)

c     Await final answer from node 0 via log_2 fan out
      level=np/2
      ifgot=.false.
      if (nid.eq.root) ifgot=.true.

      lnp = log2(np)
      do i=1,lnp
        if (ifgot) then
           jnid=nid+level
           call csend(typer,x,bytes,jnid,nullpid)
        elseif (mod(nid,level).eq.0) then
           call crecv(typer,x,bytes)
           ifgot=.true.
        endif
        level=level/2
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine ping_loop1(t1,t0,len,nloop,nodea,nodeb,nid,x,y)

      common /nekmpi/ mid,np,nekcomm,nekgroup,nekreal

      real x(1),y(1)

      include 'mpif.h'
      integer status(mpi_status_size)

      i=0
      if (nid.eq.nodea) then
         call nekgsync
         call mpi_irecv(y,len,mpi_byte,nodeb,i,nekcomm,msg,ierr)    ! 1b
         call mpi_send (x,len,mpi_byte,nodeb,i,nekcomm,ierr)        ! 1a
c        call mpi_rsend(x,len,mpi_byte,nodeb,i,nekcomm,ierr)        ! 1a
         call msgwait(msg)                                          ! 1b

         t0 = mpi_wtime ()
         do i=1,nloop
            call mpi_irecv(y,len,mpi_byte,nodeb,i,nekcomm,msg,ierr) ! 2b
            call mpi_send (x,len,mpi_byte,nodeb,i,nekcomm,ierr)     ! 2a
c           call mpi_rsend(x,len,mpi_byte,nodeb,i,nekcomm,ierr)     ! 2a
            call mpi_wait (msg,status,ierr)                         ! 2b
         enddo
         t1 = mpi_wtime ()

      elseif (nid.eq.nodeb) then

         call mpi_irecv(y,len,mpi_byte,nodea,i,nekcomm,msg,ierr)    ! 1a
         call nekgsync
         call mpi_wait (msg,status,ierr)                            ! 1a

         j=i
         do i=1,nloop
            call mpi_irecv(y,len,mpi_byte,nodea,i,nekcomm,msg,ierr) ! 2a
c           call mpi_rsend(x,len,mpi_byte,nodea,j,nekcomm,ierr)     ! 1b
            call mpi_send (x,len,mpi_byte,nodea,j,nekcomm,ierr)     ! 1b
            call mpi_wait (msg,status,ierr)                         ! 2a
            j=i
         enddo
c        call mpi_rsend(x,len,mpi_byte,nodea,j,nekcomm,ierr)        ! nb
         call mpi_send (x,len,mpi_byte,nodea,j,nekcomm,ierr)        ! nb

      else
         call nekgsync
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine ping_loop2(t1,t0,len,nloop,nodea,nodeb,nid,x,y)

      common /nekmpi/ mid,np,nekcomm,nekgroup,nekreal

      real x(1),y(1)

      include 'mpif.h'
      integer status(mpi_status_size)

      i=0
      if (nid.eq.nodea) then
         call nekgsync
         call mpi_irecv(y,len,mpi_byte,nodeb,i,nekcomm,msg,ierr)    ! 1b
         call mpi_send (x,len,mpi_byte,nodeb,i,nekcomm,ierr)        ! 1a
         call msgwait(msg)                                          ! 1b

         t0 = mpi_wtime ()
         do i=1,nloop
            call mpi_send (x,len,mpi_byte,nodeb,i,nekcomm,ierr)     ! 2a
            call mpi_irecv(y,len,mpi_byte,nodeb,i,nekcomm,msg,ierr) ! 2b
            call mpi_wait (msg,status,ierr)                         ! 2b
         enddo
         t1 = mpi_wtime ()

      elseif (nid.eq.nodeb) then

         call mpi_irecv(y,len,mpi_byte,nodea,i,nekcomm,msg,ierr)    ! 1a
         call nekgsync
         call mpi_wait (msg,status,ierr)                            ! 1a

         j=i
         do i=1,nloop
            call mpi_send (x,len,mpi_byte,nodea,j,nekcomm,ierr)     ! 1b
            call mpi_irecv(y,len,mpi_byte,nodea,i,nekcomm,msg,ierr) ! 2a
            call mpi_wait (msg,status,ierr)                         ! 2a
            j=i
         enddo
         call mpi_send (x,len,mpi_byte,nodea,j,nekcomm,ierr)        ! nb

      else
         call nekgsync
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine ping_loop(t1,t0,len,nloop,nodea,nodeb,nid,x1,y1,x2,y2)
c     Double Buffer : does 2*nloop timings

      common /nekmpi/ mid,np,nekcomm,nekgroup,nekreal

      real x1(1),y1(1),x2(1),y2(1)

      include 'mpif.h'
      integer status(mpi_status_size)

      itag=1
      if (nid.eq.nodea) then
         call mpi_irecv(y1,len,mpi_byte,nodeb,itag,nekcomm,msg1,ierr)   ! 1b 
         call nekgsync


         t0 = mpi_wtime ()
         do i=1,nloop
            call mpi_send (x1,len,mpi_byte,nodeb,itag,nekcomm,ierr)     ! 1a 
            call mpi_irecv(y2,len,mpi_byte,nodeb,itag,nekcomm,msg2,ierr)! 2b 
            call mpi_wait (msg1,status,ierr)                            ! 1b
            call mpi_send (x2,len,mpi_byte,nodeb,itag,nekcomm,ierr)     ! 2a 
            call mpi_irecv(y1,len,mpi_byte,nodeb,itag,nekcomm,msg1,ierr)! 3b 
            call mpi_wait (msg2,status,ierr)                            ! 2b
         enddo
         t1 = mpi_wtime ()
         call mpi_send (x1,len,mpi_byte,nodeb,itag,nekcomm,ierr)        ! nb
         call mpi_wait (msg1,status,ierr)                              ! nb

      elseif (nid.eq.nodeb) then

         call mpi_irecv(y1,len,mpi_byte,nodea,itag,nekcomm,msg1,ierr)   ! nb 
         call nekgsync


         do i=1,nloop
            call mpi_wait (msg1,status,ierr)                            ! 1a
            call mpi_send (x1,len,mpi_byte,nodea,itag,nekcomm,ierr)     ! 1b
            call mpi_irecv(y2,len,mpi_byte,nodea,itag,nekcomm,msg2,ierr)! 2a
            call mpi_wait (msg2,status,ierr)                            ! 2a 
            call mpi_send (x2,len,mpi_byte,nodea,itag,nekcomm,ierr)     ! 2b
            call mpi_irecv(y1,len,mpi_byte,nodea,itag,nekcomm,msg1,ierr)! 3a
         enddo
         call mpi_wait (msg1,status,ierr)                            ! 2a 
         call mpi_send (x1,len,mpi_byte,nodea,itag,nekcomm,ierr)        ! nb

      else
         call nekgsync
      endif

      return
      end
c-----------------------------------------------------------------------
      integer*8 function i8gl_running_sum(in)
c
      include 'mpif.h'

      integer*8 in

      common /nekmpi/ nid,np,nekcomm,nekgroup,nekreal
      integer status(mpi_status_size)
      integer*8 x,r

      x = in  ! running sum
      r = 0   ! recv buff

      call mpi_scan(x,r,1,mpi_integer8,mpi_sum,nekcomm,ierr)
      i8gl_running_sum = r

      return
      end
c-----------------------------------------------------------------------
      subroutine close_files
      logical ifopen

      do ii=1,99
         if(ii.ne.5.and.ii.ne.6) then
           inquire(unit=ii,opened=ifopen)
           if(ifopen) close(ii)
         endif
      enddo

      return
      end
c----------------------------------------------------------------------
      subroutine neknekgsync()

      include 'SIZE'
      include 'PARALLEL'

      call mpi_barrier(iglobalcomm,ierr)

      return
      end
c------------------------------------------------------------------------
      subroutine setnekcomm(comm_in)

      include 'SIZE'

      integer comm_in
      common /nekmpi/ mid,mp,nekcomm,nekgroup,nekreal

      nekcomm = comm_in
      call mpi_comm_size(nekcomm,mp,ierr)
      np = mp

      return
      end

c-----------------------------------------------------------------------
      subroutine char_conv(p0,u,ulag,bm,bmlag,msk,c,cs,gsl)
c
c
c     Convect over last NBD steps using characteristics scheme
c
c     NOTE:  Here, we assume that ulag is stored by time-slice first,
c            then by field number (this is opposite to prior Nek5000)
c
c
      include 'SIZE'
      include 'TOTAL'
      real    p0(1),u(1),ulag(1),bm(1),bmlag(1),msk(1),c(1),cs(0:1)
      integer gsl

      common /scrns/ ct  (lxd*lyd*lzd*lelv*ldim)

      common /scrvh/ bmsk(lx1*ly1*lz1*lelv)
     $             , bdwt(lx1*ly1*lz1*lelv)
     $             , bmst(lx1*ly1*lz1*lelv)
     $             , u1  (lx1*ly1*lz1*lelv)

      common /scrmg/ r1  (lx1*ly1*lz1*lelv)
     $             , r2  (lx1*ly1*lz1*lelv)
     $             , r3  (lx1*ly1*lz1*lelv)
     $             , r4  (lx1*ly1*lz1*lelv)
      
      nelc = nelv            ! number of elements in convecting field
      if (ifield.eq.ifldmhd) nelc = nelfld(ifield)

      nc  = cs(0)            ! number of stored convecting fields

      ln  = lx1*ly1*lz1*lelt
      n   = lx1*ly1*lz1*nelfld(ifield)
      m   = lxd*lyd*lzd*nelc*ldim

c      if(nid.eq.0) write(*,*) 'going into char_conv1 '
      call char_conv1 (p0,u,bmnv,n,ulag,ln,gsl,c,m,cs(1),nc,ct
     $  ,u1,r1,r2,r3,r4,bmsk,bdivw,bdwt,bmass,bmst,bm,bmlag)

      return
      end
c-----------------------------------------------------------------------
      subroutine char_conv1 (p0,u,bmnv,n,ulag,ln,gsl,c,m,cs,nc,ct
     $  ,u1,r1,r2,r3,r4,bmsk,bdivw,bdwt,bmass,bmst,bm,bmlag)

      include 'SIZE'
      include 'INPUT'
      include 'TSTEP'

      real p0(n),u(n),bmnv(n,1),ulag(ln,1),c(m,0:nc),cs(0:nc),bdivw(n,1)
     $          ,bm(n), bmlag(ln,1)

      real ct(m),u1(n),r1(n),r2(n),r3(n),r4(n),bmsk(n),bdwt(n) ! work arrays

      integer gsl


!     Convect over last NBD steps using characteristics scheme

!              n-q                                      n-1
!     Given u(t    , X ),  q = 1,2,...,nbd, compute  phi     ( := p0 )

!        n-1       nbd   ~n-q
!     phi     :=  sum    u
!                  q=1

!          ~n-q             ~n-q
!     each u     satisfies  u    := v  such that


!     dv
!     -- + C.grad v = 0  t \in [t^n-q,t^n],   v(t^n-q,X) = u(t^n-q,X)
!     dt

!     n = lx1*ly1*lz1*nelv
!     m = lxd*lyd*lzd*nelv

      tau = time-vlsum(dtlag,nbd)              ! initialize time for u^n-k
      call int_vel (ct  ,tau,c    ,m,nc,cs,nid) ! ct(t) = sum w_k c(.,k)
      call int_vel (bmsk,tau,bmnv ,n,nc,cs,nid) ! B^-1(t^n-1)
      call int_vel (bmst,tau,bmass,n,nc,cs,nid) ! B(t^n-1)
      call int_vel (bdwt,tau,bdivw,n,nc,cs,nid) ! BdivW(t^n-1)

      call rzero(p0,n)

      do ilag = nbd,1,-1

         um = 0
         if (ilag.eq.1) then
            do i=1,n
               p0(i) = p0(i)+bd(ilag+1)*u(i)*bm(i)
               um=max(um,u(i))
            enddo
         else
           if(ifmvbd) then
            do i=1,n
               p0(i) = p0(i)+bd(ilag+1)*ulag(i,ilag-1)*bmlag(i,ilag-1)
               um=max(um,ulag(i,ilag-1))
            enddo
           else
            do i=1,n
               p0(i) = p0(i)+bd(ilag+1)*ulag(i,ilag-1)*bm(i)
               um=max(um,ulag(i,ilag-1))
            enddo
           endif
         endif

         dtau = dtlag(ilag)/ntaubd
         do itau = 1,ntaubd ! ntaubd=number of RK4 substeps (typ. 1 or 2)

            tau1 = tau + dtau

            c1 = 1.
            c2 = -dtau/2.
            c3 = -dtau
            th = tau+dtau/2.

            call invcol3 (u1,p0,bmst,n)
            call conv_rhs(r1,u1,ct,bmsk,bmst,bdwt,gsl)          ! STAGE 1
            call col2    (r1,bmst,n)     !             ! r1 = B(n-1)* r1

            call add3s12 (u1,p0,r1,c1,c2,n)
            call int_vel (bmst,th,bmass,n,nc,cs,nid)   ! B(n-1/2)
            call invcol2 (u1,bmst,n)                   ! u2=B(n-1/2)

            call int_vel (ct  ,th,c    ,m,nc,cs,nid)   ! STAGE 2
            call int_vel (bmsk,th,bmnv ,n,nc,cs,nid)   ! B^-1(n-1/2)
            call int_vel (bdwt,th,bdivw,n,nc,cs,nid)   ! BdivW(n-1/2)
            call conv_rhs(r2,u1,ct,bmsk,bmst,bdwt,gsl)
            call col2    (r2,bmst,n)     !  du = B          * du

            call add3s12 (u1,p0,r2,c1,c2,n)           ! STAGE 3
            call invcol2 (u1,bmst,n)
            call conv_rhs(r3,u1,ct,bmsk,bmst,bdwt,gsl)          ! B(n-1/2) (still)
            call col2    (r3,bmst,n)     !  du = B          * du

            call add3s12 (u1,p0,r3,c1,c3,n)
            call int_vel (bmst,tau1,bmass,n,nc,cs,nid) ! B^-1(n)
            call invcol2 (u1,bmst,n)                   ! u2=B(n-1/2)

            call int_vel (ct  ,tau1,c    ,m,nc,cs,nid) ! STAGE 4
            call int_vel (bmsk,tau1,bmnv ,n,nc,cs,nid) ! B^-1(n)
            call int_vel (bdwt,tau1,bdivw,n,nc,cs,nid) ! BdivW(n)
            call conv_rhs(r4,u1,ct,bmsk,bmst,bdwt,gsl)
            call col2    (r4,bmst,n)     !  du = B          * du

            c1 = -dtau/6.
            c2 = -dtau/3.
            do i=1,n
               p0(i) = p0(i)+c1*(r1(i)+r4(i))+c2*(r2(i)+r3(i))
            enddo
            tau = tau1
         enddo
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine int_vel(c_t,t0,c,n,nc,ct,nid)

c     Interpolate convecting velocity field c(t_1,...,t_nconv) to
c     time t0 and return result in c_t.

c     Ouput:   c_t = sum wt_k * ct_i(k) 

c     Here, t0 is the time of interest

      real c_t(n),c(n,0:nc),ct(0:nc)

      parameter (lwtmax=10)
      real wt(0:lwtmax)

      if (nc.gt.lwtmax) then
         write(6,*) nid,'ERROR int_vel: lwtmax too small',lwtmax,nc
         call exitt
      endif

      no = nc-1
      call fd_weights_full(t0,ct(0),no,0,wt)  ! interpolation weights

      call rzero(c_t,n)
      do j=1,n
      do i=0,no
         c_t(j) = c_t(j) + wt(i)*c(j,i)
      enddo
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine conv_rhs (du,u,c,bmsk,bmst,bdwt,gsl)
c
      include 'SIZE'
      include 'TOTAL'
c
c     apply convecting field c(1,ldim) to scalar field u(1)
c
      real du(1),u(1),c(1),bmsk(1),bdwt(1)
      integer gsl
c
      logical ifconv
c
c     ifconv = .false.
      ifconv = .true.
c
      n = lx1*ly1*lz1*nelv

      if (ifdgfld(ifield)) then

       if (param(99).eq.1) call conv_rhs_dg         (du,u,c)
       if (param(99).eq.0) call conv_rhs_dg_aliased (du,u,c)

      elseif (ifconv) then

         if (ifcons) then
           if (if3d     ) call convop_cons_3d (du,u,c,lx1,lxd,nelv)
           if (.not.if3d) call convop_cons_2d (du,u,c,lx1,lxd,nelv)
         else
           if (if3d     ) call convop_fst_3d  (du,u,c,lx1,lxd,nelv)
           if (.not.if3d) call convop_fst_2d  (du,u,c,lx1,lxd,nelv)
         endif

         call subcol3(du,bdwt,u,n)
         call fgslib_gs_op (gsl,du,1,1,0)  !  +

         call col2 (du,bmsk,n)     !  du = Binv * msk * du

      else
         call rzero   (du,n)
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine convop_fst_3d(du,u,c,mx,md,nel)
c
      include 'SIZE'
c
c     apply convecting field c to scalar field u
c
      real du(mx*mx*mx,nel)
      real  u(mx*mx*mx,nel)
      real  c(md*md*md,nel,3)
      parameter (ldd=lxd*lyd*lzd)
      common /ctmp1/ ur(ldd),us(ldd),ut(ldd),ud(ldd)
c
      logical if3d,ifd
      integer e
c
      if3d = .true.
      ifd  = .false.
      if (md.ne.mx) ifd=.true.
      ifd=.true.
c
      nrstd = md**3
      call lim_chk(nrstd,ldd,'urus ','ldd  ','convop_fst')
c
      do e=1,nel
         call grad_rstd(ur,us,ut,u(1,e),mx,md,if3d,ud)
         if (ifd) then    ! dealiased
            do i=1,nrstd
c              C has the mass matrix factored in per (4.8.5), p. 227, DFM.
               ud(i) = c(i,e,1)*ur(i)+c(i,e,2)*us(i)+c(i,e,3)*ut(i)
            enddo
            call intp_rstd(du(1,e),ud,mx,md,if3d,1) ! 1 --> transpose
         else
            do i=1,nrstd
c              C has the mass matrix factored in per (4.8.5), p. 227, DFM.
               du(i,e) = c(i,e,1)*ur(i)+c(i,e,2)*us(i)+c(i,e,3)*ut(i)
            enddo
         endif
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine convop_fst_2d(du,u,c,mx,md,nel)
c
      include 'SIZE'
c
c     apply convecting field c to scalar field u
c
      real du(mx*mx,nel)
      real  u(mx*mx,nel)
      real  c(md*md,nel,2)
      parameter (ldd=lxd*lyd*lzd)
      common /ctmp1/ ur(ldd),us(ldd),ut(ldd),ud(ldd)
c
      logical if3d,ifd
      integer e
c
      if3d = .false.
      ifd  = .false.
      if (md.ne.mx) ifd=.true.
      ifd=.true.
c
      nrstd = md**2
      call lim_chk(nrstd,ldd,'urus ','ldd  ','convop_fst')
c
      do e=1,nel
         call grad_rstd(ur,us,ut,u(1,e),mx,md,if3d,ud)
         if (ifd) then    ! dealiased
            do i=1,nrstd
c              C has the mass matrix factored in per (4.8.5), p. 227, DFM.
               ud(i) = c(i,e,1)*ur(i)+c(i,e,2)*us(i)
            enddo
            call intp_rstd(du(1,e),ud,mx,md,if3d,1) ! 1 --> transpose
         else
            do i=1,nrstd
c              C has the mass matrix factored in per (4.8.5), p. 227, DFM.
               du(i,e) = c(i,e,1)*ur(i)+c(i,e,2)*us(i)
            enddo
         endif
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine grad_rstd(ur,us,ut,u,mx,md,if3d,ju) ! GLL->GL grad

      include 'SIZE'
      include 'DXYZ'

      real    ur(1),us(1),ut(1),u(1),ju(1)
      logical if3d

      parameter (ldg=lxd**3,lwkd=4*lxd*lxd)
      common /dgrad/ d(ldg),dt(ldg),dg(ldg),dgt(ldg),jgl(ldg),jgt(ldg)
     $             , wkd(lwkd)
      real jgl,jgt

      call intp_rstd(ju,u,mx,md,if3d,0) ! 0 = forward

      m0 = md-1
      call get_dgl_ptr (ip,md,md)
      if (if3d) then
         call local_grad3(ur,us,ut,ju,m0,1,dg(ip),dgt(ip))
      else
         call local_grad2(ur,us   ,ju,m0,1,dg(ip),dgt(ip))
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine intp_rstd(ju,u,mx,md,if3d,idir) ! GLL->GL interpolation

c     GLL interpolation from mx to md.

c     If idir ^= 0, then apply transpose operator  (md to mx)

      include 'SIZE'

      real    ju(1),u(1)
      logical if3d

      parameter (ldg=lxd**3,lwkd=4*lxd*lxd)
      common /dgrad/ d(ldg),dt(ldg),dg(ldg),dgt(ldg),jgl(ldg),jgt(ldg)
     $             , wkd(lwkd)
      real jgl,jgt

      parameter (ld=2*lxd)
      common /ctmp0/ w(ld**ldim,2)

      call lim_chk(md,ld,'md   ','ld   ','grad_rstd ')
      call lim_chk(mx,ld,'mx   ','ld   ','grad_rstd ')

      ldw = 2*(ld**ldim)

      call get_int_ptr (i,mx,md)
c
      if (idir.eq.0) then
         call specmpn(ju,md,u,mx,jgl(i),jgt(i),if3d,w,ldw)
      else
         call specmpn(ju,mx,u,md,jgt(i),jgl(i),if3d,w,ldw)
      endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine gen_int(jgl,jgt,mp,np,w)
c
c     Generate interpolation from np GLL points to mp GL points
c
c        jgl  = interpolation matrix, mapping from velocity nodes to pressure
c        jgt  = transpose of interpolation matrix
c        w    = work array of size (np+mp)
c
c        np   = number of points on GLL grid
c        mp   = number of points on GL  grid
c
c
      real jgl(mp,np),jgt(np*mp),w(1)
c
      iz = 1
      id = iz + np
c
      call zwgll (w(iz),jgt,np)
      call zwgl  (w(id),jgt,mp)
c
      n  = np-1
      do i=1,mp
         call fd_weights_full(w(id+i-1),w(iz),n,0,jgt)
         do j=1,np
            jgl(i,j) = jgt(j)                  !  Interpolation matrix
         enddo
      enddo
c
      call transpose(jgt,np,jgl,mp)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine gen_dgl(dgl,dgt,mp,np,w)
c
c     Generate derivative from np GL points onto mp GL points
c
c        dgl  = interpolation matrix, mapping from velocity nodes to pressure
c        dgt  = transpose of interpolation matrix
c        w    = work array of size (3*np+mp)
c
c        np   = number of points on GLL grid
c        mp   = number of points on GL  grid
c
c
c
      real dgl(mp,np),dgt(np*mp),w(1)
c
c
      iz = 1
      id = iz + np
c
      call zwgl  (w(iz),dgt,np)  ! GL points
      call zwgl  (w(id),dgt,mp)  ! GL points
c
      ndgt = 2*np
      ldgt = mp*np
      call lim_chk(ndgt,ldgt,'ldgt ','dgt  ','gen_dgl   ')
c
      n  = np-1
      do i=1,mp
         call fd_weights_full(w(id+i-1),w(iz),n,1,dgt) ! 1=1st deriv.
         do j=1,np
            dgl(i,j) = dgt(np+j)                       ! Derivative matrix
         enddo
      enddo
c
      call transpose(dgt,np,dgl,mp)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine lim_chk(n,m,avar5,lvar5,sub_name10)
      include 'SIZE'            ! need nid
      character*5  avar5,lvar5
      character*10 sub_name10

      if (n.gt.m) then
         write(6,1) nid,n,m,avar5,lvar5,sub_name10
    1    format(i8,' ERROR: :',2i12,2(1x,a5),1x,a10)
         call exitti('lim_chk problem. $',n)
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine get_int_ptr (ip,mx,md) ! GLL-->GL pointer

c     Get pointer to jgl() for interpolation pair (mx,md)

      include 'SIZE'

      parameter (ldg=lxd**3,lwkd=4*lxd*lxd)
      common /dgrad/ d(ldg),dt(ldg),dg(ldg),dgt(ldg),jgl(ldg),jgt(ldg)
     $             , wkd(lwkd)
      real jgl,jgt
c
      parameter (ld=2*lxd)
      common /igrad/ pd    (0:ld*ld)
     $             , pdg   (0:ld*ld)
     $             , pjgl  (0:ld*ld)
      integer pd , pdg , pjgl
c
      ij = md + ld*(mx-1)
      ip = pjgl(ij)
c
      if (ip.eq.0) then
c
         nstore   = pjgl(0)
         pjgl(ij) = nstore+1
         nstore   = nstore + md*mx
         pjgl(0)  = nstore
         ip       = pjgl(ij)
c
         nwrkd = mx + md
         call lim_chk(nstore,ldg ,'jgl  ','ldg  ','get_int_pt')
         call lim_chk(nwrkd ,lwkd,'wkd  ','lwkd ','get_int_pt')
c
         call gen_int(jgl(ip),jgt(ip),md,mx,wkd)
      endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine get_dgl_ptr (ip,mx,md)
c
c     Get pointer to GL-GL interpolation dgl() for pair (mx,md)
c
      include 'SIZE'
c
      parameter (ldg=lxd**3,lwkd=4*lxd*lxd)
      common /dgrad/ d(ldg),dt(ldg),dg(ldg),dgt(ldg),jgl(ldg),jgt(ldg)
     $             , wkd(lwkd)
      real jgl,jgt
c
      parameter (ld=2*lxd)
      common /jgrad/ pd    (0:ld*ld)
     $             , pdg   (0:ld*ld)
     $             , pjgl  (0:ld*ld)
      integer pd , pdg , pjgl
c
      ij = md + ld*(mx-1)
      ip = pdg (ij)

      if (ip.eq.0) then

         nstore   = pdg (0)
         pdg (ij) = nstore+1
         nstore   = nstore + md*mx
         pdg (0)  = nstore
         ip       = pdg (ij)
c
         nwrkd = mx + md
         call lim_chk(nstore,ldg ,'dg   ','ldg  ','get_dgl_pt')
         call lim_chk(nwrkd ,lwkd,'wkd  ','lwkd ','get_dgl_pt')
c
         call gen_dgl(dg (ip),dgt(ip),md,mx,wkd)
      endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine set_conv_char(ct,c,ux,uy,uz,nelc,tau,ifnew)
      include 'SIZE'
      include 'TSTEP'

      real ct(0:1)               ! time stamps for saved field (0=#flds)
      real c(1)                  ! saved vel. fields, dealiased etc.
      real ux(1),uy(1),uz(1)     ! input vel. field
      integer nelc               ! number of elements in conv. field
      logical ifnew              ! =true if shifting stack of fields

      numr      = lxd*lyd*lzd*lelv*ldim*(lorder+1)
      denr      = lxd*lyd*lzd*nelv*ldim
      nconv_max = numr/denr
      if (nconv_max.lt.nbdinp+1) 
     $   call exitti(
     $     'ABORT: not enough memory for characteristics scheme!$',
     $     nconv_max)

      nc = ct(0)

      m  = lxd*lyd*lzd*nelc*ldim

      call set_ct_cvx
     $    (ct,c,m,ux,uy,uz,tau,nc,nconv_max,nelc,ifnew)

      nc = min (nc,nbdinp)
      ct(0) = nc  ! store current count

      return
      end
c-----------------------------------------------------------------------
      subroutine set_ct_cvx(ct,c,m,u,v,w,tau,nc,mc,nelc,ifnew)
      include 'SIZE'
      include 'INPUT'  ! ifcons

      real ct(0:1),c(m,1)
      real u(1),v(1),w(1)
      logical ifnew

      if (ifnew) then

c        Shift existing convecting fields
c        Note:  "1" entry is most recent

         nc = nc+1
         nc = min(nc,mc)
         ct(0) = nc

         do i=nc,2,-1
            call copy(c(1,i),c(1,i-1),m)
            ct(i) = ct(i-1)
         enddo
      endif

c     Save time and map the current velocity to rst coordinates.

      ix = 1
      iy = ix + lxd*lyd*lzd*nelc
      iz = iy + lxd*lyd*lzd*nelc

      if (ifcons) then
         call set_convect_cons(c(ix,1),c(iy,1),c(iz,1),u,v,w)
      else
         call set_convect_new (c(ix,1),c(iy,1),c(iz,1),u,v,w)
      endif

      ct(1) = tau

      return
      end
c-----------------------------------------------------------------------
      subroutine grad_rst(ur,us,ut,u,md,if3d) ! Gauss-->Gauss grad

      include 'SIZE'
      include 'DXYZ'

      real    ur(1),us(1),ut(1),u(1)
      logical if3d

      parameter (ldg=lxd**3,lwkd=4*lxd*lxd)
      common /dgrad/ d(ldg),dt(ldg),dg(ldg),dgt(ldg),jgl(ldg),jgt(ldg)
     $             , wkd(lwkd)
      real jgl,jgt

      m0 = md-1
      call get_dgl_ptr (ip,md,md)
      if (if3d) then
         call local_grad3(ur,us,ut,u,m0,1,dg(ip),dgt(ip))
      else
         call local_grad2(ur,us   ,u,m0,1,dg(ip),dgt(ip))
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine convect_new(bdu,u,ifuf,cx,cy,cz,ifcf)

C     Compute dealiased form:  J^T Bf *JC .grad Ju w/ correct Jacobians
C
      include 'SIZE'
      include 'TOTAL'

      real bdu(1),u(1),cx(1),cy(1),cz(1)
      logical ifuf,ifcf            ! u and/or c already on fine mesh?

      parameter (lxy=lx1*ly1*lz1,ltd=lxd*lyd*lzd)
      common /scrcv/ fx(ltd),fy(ltd),fz(ltd)
     $             , ur(ltd),us(ltd),ut(ltd)
     $             , tr(ltd,3),uf(ltd)

      integer e

      call set_dealias_rx

      nxyz1 = lx1*ly1*lz1
      nxyzd = lxd*lyd*lzd

      nxyzu = nxyz1
      if (ifuf) nxyzu = nxyzd

      nxyzc = nxyz1
      if (ifcf) nxyzc = nxyzd

      iu = 1    ! pointer to scalar field u
      ic = 1    ! pointer to vector field C
      ib = 1    ! pointer to scalar field Bdu


      do e=1,nelv

         if (ifcf) then

            call copy(tr(1,1),cx(ic),nxyzd)  ! already in rst form
            call copy(tr(1,2),cy(ic),nxyzd)
            if (if3d) call copy(tr(1,3),cz(ic),nxyzd)

         else  ! map coarse velocity to fine mesh (C-->F)

           call intp_rstd(fx,cx(ic),lx1,lxd,if3d,0) ! 0 --> forward
           call intp_rstd(fy,cy(ic),lx1,lxd,if3d,0) ! 0 --> forward
           if (if3d) call intp_rstd(fz,cz(ic),lx1,lxd,if3d,0) ! 0 --> forward

           if (if3d) then  ! Convert convector F to r-s-t coordinates

             do i=1,nxyzd
               tr(i,1)=rx(i,1,e)*fx(i)+rx(i,2,e)*fy(i)+rx(i,3,e)*fz(i)
               tr(i,2)=rx(i,4,e)*fx(i)+rx(i,5,e)*fy(i)+rx(i,6,e)*fz(i)
               tr(i,3)=rx(i,7,e)*fx(i)+rx(i,8,e)*fy(i)+rx(i,9,e)*fz(i)
             enddo

           else

             do i=1,nxyzd
               tr(i,1)=rx(i,1,e)*fx(i)+rx(i,2,e)*fy(i)
               tr(i,2)=rx(i,3,e)*fx(i)+rx(i,4,e)*fy(i)
             enddo

           endif

         endif

         if (ifuf) then
            call grad_rst(ur,us,ut,u(iu),lxd,if3d)
         else
            call intp_rstd(uf,u(iu),lx1,lxd,if3d,0) ! 0 --> forward
            call grad_rst(ur,us,ut,uf,lxd,if3d)
         endif

         if (if3d) then
            do i=1,nxyzd ! mass matrix included, per DFM (4.8.5)
               uf(i) = tr(i,1)*ur(i)+tr(i,2)*us(i)+tr(i,3)*ut(i)
            enddo
         else
            do i=1,nxyzd ! mass matrix included, per DFM (4.8.5)
               uf(i) = tr(i,1)*ur(i)+tr(i,2)*us(i)
            enddo
         endif
         call intp_rstd(bdu(ib),uf,lx1,lxd,if3d,1) ! Project back to coarse

         ic = ic + nxyzc
         iu = iu + nxyzu
         ib = ib + nxyz1

      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine convect_cons(bdu,u,ifuf,cx,cy,cz,ifcf)

c     Compute dealiased form:  J^T Bf *div. JC Ju w/ correct Jacobians

c     conservative form


      include 'SIZE'
      include 'TOTAL'

      real bdu(1),u(1),cx(1),cy(1),cz(1)

      logical ifuf,ifcf            ! u and/or c already on fine mesh?

      parameter (lxy=lx1*ly1*lz1,ltd=lxd*lyd*lzd)
      common /scrcv/ uf(ltd),cf(ltd),cu(ltd)
     $             , cr(ltd),cs(ltd),ct(ltd)


      integer e

      call set_dealias_rx

      nxyz1 = lx1*ly1*lz1
      nxyzd = lxd*lyd*lzd

      nxyzu = nxyz1
      if (ifuf) nxyzu = nxyzd

      nxyzc = nxyz1
      if (ifcf) nxyzc = nxyzd

      iu = 1    ! pointer to scalar field u
      ic = 1    ! pointer to vector field C
      ib = 1    ! pointer to scalar field Bdu

      do e=1,nelv

        call intp_rstd(uf,u(iu),lx1,lxd,if3d,0) ! 0 --> forward

        call rzero(cu,nxyzd)
        do i=1,ldim

         if (ifcf) then  ! C is already on fine mesh

           call exitt  ! exit for now

         else  ! map coarse velocity to fine mesh (C-->F)

           if (i.eq.1) call intp_rstd(cf,cx(ic),lx1,lxd,if3d,0) ! 0 --> forward
           if (i.eq.2) call intp_rstd(cf,cy(ic),lx1,lxd,if3d,0) ! 0 --> forward
           if (i.eq.3) call intp_rstd(cf,cz(ic),lx1,lxd,if3d,0) ! 0 --> forward

           call col2(cf,uf,nxyzd)   !  collocate C and u on fine mesh

           call grad_rst(cr,cs,ct,cf,lxd,if3d)  ! d/dr (C_i*u)

           if (if3d) then

             do j=1,nxyzd
               cu(j)=cu(j)
     $              +cr(j)*rx(j,i,e)+cs(j)*rx(j,i+3,e)+ct(j)*rx(j,i+6,e)
             enddo

           else  ! 2D

             do j=1,nxyzd
               cu(j)=cu(j)
     $              +cr(j)*rx(j,i,e)+cs(j)*rx(j,i+2,e)
             enddo

           endif
         endif
        enddo

        call intp_rstd(bdu(ib),cu,lx1,lxd,if3d,1) ! Project back to coarse

        ic = ic + nxyzc
        iu = iu + nxyzu
        ib = ib + nxyz1

      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine set_convect_cons(cx,cy,cz,ux,uy,uz)

c     Put vx,vy,vz on fine mesh (for conservation form)


      include 'SIZE'
      include 'TOTAL'

      parameter (lxy=lx1*ly1*lz1,ltd=lxd*lyd*lzd)

      real cx(ltd,1),cy(ltd,1),cz(ltd,1)
      real ux(lxy,1),uy(lxy,1),uz(lxy,1)

      integer e

      call set_dealias_rx

      do e=1,nelv    ! Map coarse velocity to fine mesh (C-->F)

         call intp_rstd(cx(1,e),ux(1,e),lx1,lxd,if3d,0) ! 0 --> forward
         call intp_rstd(cy(1,e),uy(1,e),lx1,lxd,if3d,0) ! 0 --> forward
         if (if3d) call intp_rstd(cz(1,e),uz(1,e),lx1,lxd,if3d,0) ! 0 --> forward

      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine set_convect_new(cr,cs,ct,ux,uy,uz)
C
C     Put vxd,vyd,vzd into rst form on fine mesh
C
C     For rst form, see eq. (4.8.5) in Deville, Fischer, Mund (2002).
C
      include 'SIZE'
      include 'TOTAL'

      parameter (lxy=lx1*ly1*lz1,ltd=lxd*lyd*lzd)

      real cr(ltd,1),cs(ltd,1),ct(ltd,1)
      real ux(lxy,1),uy(lxy,1),uz(lxy,1)

      common /scrcv/ fx(ltd),fy(ltd),fz(ltd)
     $             , ur(ltd),us(ltd),ut(ltd)
     $             , tr(ltd,3),uf(ltd)

      integer e

      call set_dealias_rx

      nxyz1 = lx1*ly1*lz1
      nxyzd = lxd*lyd*lzd

      ic = 1    ! pointer to vector field C

      do e=1,nelv 

c        Map coarse velocity to fine mesh (C-->F)

         call intp_rstd(fx,ux(1,e),lx1,lxd,if3d,0) ! 0 --> forward
         call intp_rstd(fy,uy(1,e),lx1,lxd,if3d,0) ! 0 --> forward
         if (if3d) call intp_rstd(fz,uz(1,e),lx1,lxd,if3d,0) ! 0 --> forward

c        Convert convector F to r-s-t coordinates

         if (if3d) then

           do i=1,nxyzd
              cr(i,e)=rx(i,1,e)*fx(i)+rx(i,2,e)*fy(i)+rx(i,3,e)*fz(i)
              cs(i,e)=rx(i,4,e)*fx(i)+rx(i,5,e)*fy(i)+rx(i,6,e)*fz(i)
              ct(i,e)=rx(i,7,e)*fx(i)+rx(i,8,e)*fy(i)+rx(i,9,e)*fz(i)
           enddo

         else

           do i=1,nxyzd
              cr(i,e)=rx(i,1,e)*fx(i)+rx(i,2,e)*fy(i)
              cs(i,e)=rx(i,3,e)*fx(i)+rx(i,4,e)*fy(i)
           enddo

         endif
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine advchar
c
c     Compute convective contribution using 
c     operator-integrator-factor method (characteristics).
c
      include 'SIZE'
      include 'MASS'
      include 'INPUT'
      include 'SOLN'
      include 'TSTEP'
      include 'PARALLEL'

      include 'CTIMER'

      common /cchar/ ct_vx(0:lorder) ! time for each slice in c_vx()

      common /scruz/ phx  (lx1*ly1*lz1*lelt)
     $ ,             phy  (lx1*ly1*lz1*lelt)
     $ ,             phz  (lx1*ly1*lz1*lelt)
     $ ,             hmsk (lx1*ly1*lz1*lelt)

      if (icalld.eq.0) tadvc=0.0
      icalld=icalld+1
      nadvc=icalld
      etime1=dnekclock()

      dti = 1./dt
      n   = lx1*ly1*lz1*nelv

      call char_conv(phx,vx,vxlag,bm1,bm1lag,hmsk,c_vx,ct_vx,gsh_fld(1))
      call char_conv(phy,vy,vylag,bm1,bm1lag,hmsk,c_vx,ct_vx,gsh_fld(1))
      if (if3d) call char_conv
     $              (phz,vz,vzlag,bm1,bm1lag,hmsk,c_vx,ct_vx,gsh_fld(1))

      call cfill(hmsk,dti,n)
      if(.not. iflomach) call col2(hmsk,vtrans,n) 

      if (if3d) then

        do i=1,n
           h2i = hmsk(i)
           bfx(i,1,1,1) = bfx(i,1,1,1)+phx(i)*h2i
           bfy(i,1,1,1) = bfy(i,1,1,1)+phy(i)*h2i
           bfz(i,1,1,1) = bfz(i,1,1,1)+phz(i)*h2i
        enddo

      else
        
        do i=1,n
           h2i = hmsk(i)
           bfx(i,1,1,1) = bfx(i,1,1,1)+phx(i)*h2i
           bfy(i,1,1,1) = bfy(i,1,1,1)+phy(i)*h2i
        enddo

      endif

      tadvc=tadvc+(dnekclock()-etime1)

      return
      end
c-----------------------------------------------------------------------
      subroutine convch

c     Compute convective contribution using 
c     operator-integrator-factor method (characteristics).

      include 'SIZE'
      include 'MASS'
      include 'INPUT'
      include 'SOLN'
      include 'TSTEP'
      include 'PARALLEL'
      include 'CTIMER'

      common /cchar/ ct_vx(0:lorder) ! time for each slice in c_vx()

      common /scruz/ phi  (lx1*ly1*lz1*lelt)
     $ ,             hmsk (lx1*ly1*lz1*lelt)

      if (icalld.eq.0) tadvc=0.0
      icalld=icalld+1
      nadvc=icalld
      etime1=dnekclock()

      n   = lx1*ly1*lz1*nelv
      dti = 1./dt

      if(nid.eq.0 .and. loglevel.gt.2) write(6,*) 'convch', ifield
      call char_conv(phi,t(1,1,1,1,ifield-1),tlag(1,1,1,1,1,ifield-1)
     $        ,bm1,bm1lag,hmsk,c_vx,ct_vx,gsh_fld(1))

      do i=1,n
         bq(i,1,1,1,ifield-1) = bq(i,1,1,1,ifield-1)
     $          + phi(i)*vtrans(i,1,1,1,ifield)*dti
      enddo

      tadvc=tadvc+(dnekclock()-etime1)

      return
      end
c-----------------------------------------------------------------------
      subroutine convop_cons_3d(du,u,c,mx,md,nel) ! Conservation form

c     Apply convecting field c to scalar field u, conservation form d/dxj cj phi

c     Assumes that current convecting field is on dealias mesh, in c()

      include 'SIZE'
      include 'DEALIAS'
      include 'GEOM'

      real du(mx*mx*mx,nel)
      real  u(mx*mx*mx,nel)
      real  c(md*md*md,nel,3)
      parameter (ldd=lxd*lyd*lzd)
      common /ctmp1/ ur(ldd),us(ldd),ut(ldd),ju(ldd),ud(ldd),tu(ldd)
      real ju

      logical if3d,ifd
      integer e

      if3d = .true.
      ifd  = .false.
      if (md.ne.mx) ifd=.true.
      ifd=.true.

      nrstd = md**3
      call lim_chk(nrstd,ldd,'urus ','ldd  ','convp_cons')

      do e=1,nel

         call intp_rstd (ju,u(1,e),mx,md,if3d,0) ! 0 = forward; on Gauss points!
         call rzero     (ud,nrstd)

         do j=1,ldim
            do i=1,nrstd
               tu(i)=c(i,e,j)*ju(i)   ! C_j*T
            enddo
            call grad_rst(ur,us,ut,tu,md,if3d)  ! Already on fine (Gauss) mesh

            j0 = j+0
            j3 = j+3
            j6 = j+6
            do i=1,nrstd   ! rx has mass matrix and Jacobian on fine mesh
               ud(i)=ud(i)
     $              +rx(i,j0,e)*ur(i)+rx(i,j3,e)*us(i)+rx(i,j6,e)*ut(i)
            enddo
         enddo

         call intp_rstd(du(1,e),ud,mx,md,if3d,1) ! 1 --> transpose

      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine convop_cons_2d(du,u,c,mx,md,nel) ! Conservation form

c     Apply convecting field c to scalar field u, conservation form d/dxj cj phi

c     Assumes that current convecting field is on dealias mesh, in c()

      include 'SIZE'
      include 'GEOM'
      include 'TSTEP'


      real du(mx*mx,nel)
      real  u(mx*mx,nel)
      real  c(md*md,nel,2)
      parameter (ldd=lxd*lyd*lzd)
      common /ctmp1/ ur(ldd),us(ldd),ut(ldd),ju(ldd),ud(ldd),tu(ldd)
      real ju

      logical if3d,ifd
      integer e

      if3d = .false.
      ifd  = .false.
      if (md.ne.mx) ifd=.true.

      nrstd = md**2
      call lim_chk(nrstd,ldd,'urus ','ldd  ','convp_cons')

      if (nio.eq.0.and.istep.lt.3) write(6,*) 'convp_cons',istep

      do e=1,nel

         call intp_rstd (ju,u(1,e),mx,md,if3d,0) ! 0 = forward; on Gauss points!
         call rzero     (ud,nrstd)

c        call outmat(c(1,e,1),md,md,'fine u',e)
c        call outmat(c(1,e,2),md,md,'fine v',e)
c        call outmat(ju      ,md,md,'fine T',e)

         do j=1,ldim
            do i=1,nrstd
               tu(i)=c(i,e,j)*ju(i)   ! C_j*T
            enddo
            call grad_rst(ur,us,ut,tu,md,if3d)  ! Already on fine (Gauss) mesh

            j0 = j+0
            j2 = j+2
            do i=1,nrstd   ! rx has mass matrix and Jacobian on fine mesh
               ud(i)=ud(i)+rx(i,j0,e)*ur(i)+rx(i,j2,e)*us(i)
            enddo
         enddo

         call intp_rstd(du(1,e),ud,mx,md,if3d,1) ! 1 --> transpose

      enddo

c     call exitti('convop_cons_2d$',istep)

      return
      end
c-----------------------------------------------------------------------
      subroutine iface_vert_int8(fa,va,jz0,jz1,nel)
      include 'SIZE'
      integer*8 fa(lx1*lz1,2*ldim,nel),va(0:lx1+1,0:ly1+1,jz0:jz1,nel)
      integer e,f

      n = lx1*lz1*2*ldim*nel
      call i8zero(fa,n)

      mx1 = lx1+2
      my1 = ly1+2
      mz1 = lz1+2
      if (ldim.eq.2) mz1=1

      nface = 2*ldim
      do e=1,nel
      do f=1,nface
         call facind (kx1,kx2,ky1,ky2,kz1,kz2,lx1,ly1,lz1,f)

         if     (f.eq.1) then ! EB notation
            ky1=ky1-1
            ky2=ky1
         elseif (f.eq.2) then
            kx1=kx1+1
            kx2=kx1
         elseif (f.eq.3) then
            ky1=ky1+1
            ky2=ky1
         elseif (f.eq.4) then
            kx1=kx1-1
            kx2=kx1
         elseif (f.eq.5) then
            kz1=kz1-1
            kz2=kz1
         elseif (f.eq.6) then
            kz1=kz1+1
            kz2=kz1
         endif

         i = 0
         do iz=kz1,kz2
         do iy=ky1,ky2
         do ix=kx1,kx2
            i = i+1
            fa(i,f,e)=va(ix,iy,iz,e)
c           write(6,*) 'fa:',fa(i,f,e),i,f,e
         enddo
         enddo
         enddo
      enddo
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine set_binv(bmnv,hmsk,n) ! Store binvm1*(hyperbolic mask)

      include 'SIZE'
      include 'PARALLEL'
      include 'MASS'

      real bmnv(n,lorder),hmsk(n)

      do i=lorder,2,-1
         call copy(bmnv(1,i),bmnv(1,i-1),n)
      enddo

      call copy (bmnv,bm1,n)  ! Fill bmnv(1,1)

      call fgslib_gs_op(gsh_fld(1),bmnv,1,1,0)  ! 1 ==> +; gsh_fld(1) is velocity

      do i=1,n
         bmnv(i,1)=hmsk(i)/bmnv(i,1)
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine set_bdivw(bdivw,hmsk,n) ! Store binvm1*(hyperbolic mask)

      include 'SIZE'
      include 'PARALLEL'
      include 'MASS'
      include 'INPUT'
      include 'MVGEOM'
      common /scruz/ cx  (lx1*ly1*lz1*lelt)
     $ ,             cy  (lx1*ly1*lz1*lelt)
     $ ,             cz  (lx1*ly1*lz1*lelt)

      real bdivw(n,lorder),hmsk(n)

      do i=lorder,2,-1
         call copy(bdivw(1,i),bdivw(1,i-1),n)
      enddo

      call gradm1 (bdivw,cy    ,cz   , wx   )
      call gradm1 (cx   ,cy    ,cz   , wy   )
      call add2   (bdivw,cy    ,       n    )
      if (if3d) then
         call gradm1 (cx   ,cy    ,cz   , wz   )
         call add2   (bdivw,cz    ,       n    )
      endif
      call col2(bdivw,bm1,n)

      return
      end
c-----------------------------------------------------------------------
      subroutine set_bmass(bmass,hmsk,n) ! Store bmass*(hyperbolic mask)

      include 'SIZE'
      include 'PARALLEL'
      include 'MASS'

      real bmass(n,lorder),hmsk(n)

      do i=lorder,2,-1
         call copy(bmass(1,i),bmass(1,i-1),n)
      enddo

      call copy (bmass,bm1,n)  ! Fill bmass(1,1)

      return
      end
c-----------------------------------------------------------------------
      subroutine setup_dg_gs(dgh,nx,ny,nz,nel,melg,vertex)

c     Global-to-local mapping for gs

      include 'SIZE'
      include 'TOTAL'

      integer   dgh,vertex(1)

      parameter(lf=lx1*lz1*2*ldim*lelt)
      common /c_is1/ glo_num_face(lf)
     $             , glo_num_vol((lx1+2)*(ly1+2)*(lz1+2)*lelt)
      integer*8 glo_num_face,glo_num_vol,ngv

      common /nekmpi/ mid,mp,nekcomm,nekgroup,nekreal

      mx = nx+2
      call set_vert(glo_num_vol,ngv,mx,nel,vertex,.false.)

      mz0 = 1
      mz1 = 1
      if (if3d) mz0 = 0
      if (if3d) mz1 = lz1+1
      call iface_vert_int8 (glo_num_face,glo_num_vol,mz0,mz1,nelt) 

      nf = lx1*lz1*2*ldim*nelt !total number of points on faces
      call fgslib_gs_setup(dgh,glo_num_face,nf,nekcomm,np)

      return
      end
c-----------------------------------------------------------------------
      subroutine dg_set_fc_ptr

c     Set up pointer to restrict u to faces ! NOTE: compact

      include 'SIZE'
      include 'TOTAL'

      integer e,f,ef

      call dsset(lx1,ly1,lz1) ! set skpdat

      nxyz  = lx1*ly1*lz1
      nxz   = lx1*lz1
      nface = 2*ldim
      nxzf  = lx1*lz1*nface ! red'd mod to area, unx, etc.

      k = 0

      do e=1,nelv
      do ef=1,nface  ! EB notation

         f      = eface1(ef)
         js1    = skpdat(1,f)
         jf1    = skpdat(2,f)
         jskip1 = skpdat(3,f)
         js2    = skpdat(4,f)
         jf2    = skpdat(5,f)
         jskip2 = skpdat(6,f)

         i = 0
         do j2=js2,jf2,jskip2
         do j1=js1,jf1,jskip1

            i = i+1
            k = i+nxz*(ef-1)+nxzf*(e-1)           ! face   numbering
            dg_face(k) = j1+lx1*(j2-1)+nxyz*(e-1) ! global numbering

         enddo
         enddo

      enddo
      enddo
      ndg_facex = nxzf*nelv

      return
      end
c-----------------------------------------------------------------------
      subroutine full2face(faceary, vol_ary)

      include 'SIZE'
      include 'TOTAL'

      real     faceary(lx1*lz1,2*ldim,lelt)
      real     vol_ary(lx1,ly1,lz1,lelt)
      integer  i,j

      do j=1,ndg_facex
         i=dg_face(j)
         faceary(j,1,1) = vol_ary(i,1,1,1)
      enddo


      return
      end
c-----------------------------------------------------------------------
      subroutine face2full(vol_ary, faceary)

      include 'SIZE'
      include 'TOTAL'

      real     faceary(lx1*lz1,2*ldim,lelt)
      real     vol_ary(lx1,ly1,lz1,lelt)
      integer  i,j

      n=lx1*ly1*lz1*nelfld(ifield)
      call rzero(vol_ary,n)

      do j=1,ndg_facex
         i=dg_face(j)
         vol_ary(i,1,1,1) = vol_ary(i,1,1,1)+faceary(j,1,1)
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine add_face2full(vol_ary, faceary)

      include 'SIZE'
      include 'TOTAL'

      real     faceary(lx1*lz1,2*ldim,lelt)
      real     vol_ary(lx1,ly1,lz1,lelt)
      integer  i,j

      do j=1,ndg_facex
         i=dg_face(j)
         vol_ary(i,1,1,1) = vol_ary(i,1,1,1)+faceary(j,1,1)
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine conv_rhs_dg_aliased (du,u,c)
c
      include 'SIZE'
      include 'TOTAL'

c     Apply convecting field c(1,ldim) to scalar field u(1).

      real du(1),u(1),c(1)

      parameter(lf=lx1*lz1*2*ldim*lelt)
      common /scrdg/ uf(lf),uxf(lf),uyf(lf),uzf(lf),upwind_wgt(lf)

      integer e,f

      n  = lx1*ly1*lz1*nelv
      nf = lx1*lz1*2*ldim*nelt


      if (ifcons) then
        if (if3d     ) call convop_cons_3d (du,u,c,lx1,lxd,nelv)
        if (.not.if3d) call convop_cons_2d (du,u,c,lx1,lxd,nelv)
      else
        if (if3d     ) call convop_fst_3d  (du,u,c,lx1,lxd,nelv)
        if (.not.if3d) call convop_fst_2d  (du,u,c,lx1,lxd,nelv)
      endif

      call full2face(uf ,u )
      call full2face(uxf,vx)
      call full2face(uyf,vy)
      call full2face(uzf,vz)
      if (.not.if3d) call rzero(uzf,nf)

      beta_u = 0.00 ! 1=full upwind; 0=central flux
      beta_u = 0.25 ! 1=full upwind; 0=central flux
      beta_u = 1.00 ! 1=full upwind; 0=central flux
      beta_u = param(98)
      if (istep.le.5.and.nio.eq.0) write(6,*) beta_u,' dg upwind'

      nface = 2*ldim
      nxz   = lx1*lz1
      k     = 0
      do e=1,nelt
      do f=1,nface
      do i=1,nxz

         k=k+1

         beta   = ( unx (i,1,f,e)*uxf(k)
     $            + uny (i,1,f,e)*uyf(k)
     $            + unz (i,1,f,e)*uzf(k))

         uf(k)  = -beta*area(i,1,f,e)*uf(k)

         upwind_wgt(k) = 1.0
         if (beta.gt.0) upwind_wgt(k) = 0.0
         upwind_wgt(k) = 0.5*(1-beta_u) + upwind_wgt(k)*beta_u
         if (beta.eq.0) upwind_wgt(k) = 0.5

      enddo
      enddo
      enddo
      
      call fgslib_gs_op(dg_hndlx,uf,1,1,0)  ! 1 ==> +
      call col2 (uf,upwind_wgt,nf)  ! Inefficient, but ok for now.
                                    ! Should be combined with
      call add_face2full( du , uf)  ! <--- this stmt.

      call fbinvert     ( du )      ! Right now works only for undeformed

      return
      end
c-----------------------------------------------------------------------
      subroutine map_faced(ju,u,mx,md,fdim,idir) ! GLL->GL interpolation

c     GLL interpolation from mx to md for a face array of size (nx,nz)

c     If idir ^= 0, then apply transpose operator  (md to mx)

      include 'SIZE'

      real    ju(1),u(1)
      integer fdim

      parameter (ldg=lxd**3,lwkd=4*lxd*lxd)
      common /dgrad/ d(ldg),dt(ldg),dg(ldg),dgt(ldg),jgl(ldg),jgt(ldg)
     $             , wkd(lwkd)
      real jgl,jgt

      parameter (ld=2*lxd)
      common /ctmp0/ w(ld**ldim,2)

      call lim_chk(md,ld,'md   ','ld   ','map_faced ')
      call lim_chk(mx,ld,'mx   ','ld   ','map_faced ')

c     call copy(ju,u,mx)
c     return

      call get_int_ptr (i,mx,md)

      if (idir.eq.0) then
         if (fdim.eq.2) then
            call mxm(jgl(i),md,u,mx,wkd,mx)
            call mxm(wkd,md,jgt(i),mx,ju,md)
         else
            call mxm(jgl(i),md,u,mx,ju,1)
         endif
      else
         if (fdim.eq.2) then
            call mxm(jgt(i),mx,u,md,wkd,md)
            call mxm(wkd,mx,jgl(i),md,ju,mx)
         else
            call mxm(jgt(i),mx,u,md,ju,1)
         endif
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine fbinvert(rhs) ! Still in development.  10/10/15, pff.

      include 'SIZE'
      include 'TOTAL'

      real     rhs(lx1,ly1,lz1,lelt)

      common /cfbinv/ qn(lx1),alpha_n,beta_n
     $               ,s1(ly1,lz1),bnv(lx1)
     $               ,tmp(lx1*ly1*lz1*lelt)
      integer icalld
      save    icalld
      data    icalld /0/

      integer e

      n = lx1*ly1*lz1*nelfld(ifield)

      do i=1,n                            ! FOR NOW, USE DIAGONAL MASS
         rhs(i,1,1,1)=rhs(i,1,1,1)/bm1(i,1,1,1)   ! MATRIX.   pff, 10/10/15
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine grad_rstd_ta(du,ur,us,ut,md,if3d) ! GL->GL gradt

      include 'SIZE'
      include 'DXYZ'

      real    ur(1),us(1),ut(1),u(1)

      logical if3d

      parameter (ldg=lxd**3,lwkd=4*lxd*lxd)
      common /dgrad/ d(ldg),dt(ldg),dg(ldg),dgt(ldg),jgl(ldg),jgt(ldg)
     $             , wkd(lwkd)
      real jgl,jgt

      call get_dgl_ptr (ip,md,md)
      call gradrta     (du,ur,us,ut,dgt(ip),dg(ip),dg(ip),md,md,md,if3d)

      return
      end
c-----------------------------------------------------------------------
      subroutine set_dg_wgts

      include 'SIZE'
      include 'TOTAL'

      integer icalld
      save    icalld
      data    icalld /0/

      common /finewts/ zptf(lxd),wgtf(lxd),wghtf(lxd*lzd),wghtc(lx1*lz1)

      if (icalld.eq.0) then    !  Set fine-scale surface weights

         icalld = 1

         call zwgl(zptf,wgtf,lxd)
         if (if3d) then
            k=0
            do j=1,ly1
            do i=1,lx1
               k=k+1
               wghtc(k)=wxm1(i)*wzm1(j)
            enddo
            enddo
            k=0
            do j=1,lyd
            do i=1,lxd
               k=k+1
               wghtf(k)=wgtf(i)*wgtf(j)
            enddo
            enddo
         else
            call copy(wghtc,wxm1,lx1)
            call copy(wghtf,wgtf,lxd)
         endif
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine conv_rhs_dg (du,u,c)
c
      include 'SIZE'
      include 'TOTAL'

c     Apply convecting field c(1,ldim) to scalar field u(1).

      parameter(ldd=lxd*lyd*lzd)
      real du(1),u(1),c(ldd*lelv,3)

      parameter(lf=lx1*lz1*2*ldim*lelt)
      common /scrdg/ uf(lf),uxf(lf),uyf(lf),uzf(lf),upwind_wgt(lf)
     $             , beta_c(lx1*lz1),jaco_c(lx1*lz1)
     $             , beta_f(lxd*lzd),jaco_f(lxd*lzd)
     $             , ufine (lxd*lzd)
      real jaco_c,jaco_f
      common /finewts/ zptf(lxd),wgtf(lxd),wghtf(lxd*lzd),wghtc(lx1*lz1)

      integer e,f,fdim


      n  = lx1*ly1*lz1*lelv
      nf = lx1*lz1*2*ldim*lelt

      call conv_rhs_dg_weak (du,u,c(1,1),c(1,2),c(1,3))

      call full2face(uf ,u )
      call full2face(uxf,vx)
      call full2face(uyf,vy)
      call full2face(uzf,vz)
      if (.not.if3d) call rzero(uzf,nf)

      beta_u = 0.00 ! 1=full upwind; 0=central flux
      beta_u = 0.25 ! 1=full upwind; 0=central flux
      beta_u = 1.00 ! 1=full upwind; 0=central flux
      beta_u = param(98)
      if (istep.le.5.and.nio.eq.0) write(6,*) beta_u,' dg upwind'

      nface = 2*ldim
      nxz   = lx1*lz1
      nxzd  = lxd*lzd
      k     = 0
      do e=1,nelt         ! This formula for upwind weights appears to
      do f=1,nface        ! assume that U is continuous, or at least of

        kface = k+1
        do i=1,nxz        ! the same sign on either side of the interface.

         k=k+1

         beta   = ( unx (i,1,f,e)*uxf(k)
     $            + uny (i,1,f,e)*uyf(k)
     $            + unz (i,1,f,e)*uzf(k))

         upwind_wgt(k) = 1.0
         if (beta.gt.0) upwind_wgt(k) = 0.0
         upwind_wgt(k) = 0.5*(1-beta_u) + upwind_wgt(k)*beta_u

         beta_c(i)   = -beta
         jaco_c(i)   = area(i,1,f,e)/wghtc(i)

        enddo

        fdim = ldim-1 ! Dimension of face
        call map_faced(beta_f,beta_c  ,lx1,lxd,fdim,0) ! Dealiased quadrature,
        call map_faced(jaco_f,jaco_c  ,lx1,lxd,fdim,0) ! 0 --> coarse to fine,
        call map_faced(ufine,uf(kface),lx1,lxd,fdim,0) !   ufine = J uf

        do i=1,nxzd
           ufine(i)=wghtf(i)*jaco_f(i)*beta_f(i)*ufine(i)
        enddo
        call map_faced(uf(kface),ufine,lx1,lxd,fdim,1)  ! 1 --> uf = J^T ufine

      enddo
      enddo

      call fgslib_gs_op(dg_hndlx,uf,1,1,0)  ! 1 ==> +

      call col2 (uf,upwind_wgt,nf)  ! Inefficient, but ok for now.
                                    ! Should be combined with
      call add_face2full( du , uf)  ! <--- this stmt.

      call fbinvert     ( du )      ! Right now works only for undeformed

      return
      end
c-----------------------------------------------------------------------
      subroutine convect_dg(du,u,ifuf,cr,cs,ct,ifcf)
      include 'SIZE'
      include 'TOTAL'
      real du(1),u(1),cr(1),cs(1),ct(1)
      logical ifuf,ifcf

      call conv_rhs_dg_weak (du,u,cr,cs,ct)

      return
      end
c-----------------------------------------------------------------------
      subroutine convop_weak(du,u,cr,cs,ct,mx,md,nel) ! Weak Conservation form

c     Apply convecting field c to scalar field u, conservation form d/dxj cj phi

c     Assumes that current convecting field is on dealias mesh, in c()

      include 'SIZE'
      include 'TOTAL'

      parameter (lxx=lx1*ly1*lz1,ldd=lxd*lyd*lzd)
      real du(lxx,nel)
      real  u(lxx,nel)
      real  cr(ldd,nel),cs(ldd,nel),ct(ldd,nel)
      common /ctmp1/ ur(ldd),us(ldd),ut(ldd),ju(ldd),ud(ldd),tu(ldd)
      real ju

      integer e

      nxyz  = lx1*ly1*lz1
      nrstd = md**ldim

      call lim_chk(nrstd,ldd,'urus5','ldd  ','convp_cons')

      do e=1,nel

         call intp_rstd (ju,u(1,e),mx,md,if3d,0) ! 0 = forward; on Gauss points!
         if (ldim.eq.3) then
          do i=1,ldd
            ur(i)=ju(i)*cr(i,e) ! Already in r-s-t coordinates
            us(i)=ju(i)*cs(i,e)
            ut(i)=ju(i)*ct(i,e)
            ud(i)=0
          enddo
         else
          do i=1,ldd
            ur(i)=ju(i)*cr(i,e) ! Already in r-s-t coordinates
            us(i)=ju(i)*cs(i,e)
            ud(i)=0
          enddo
         endif
         call grad_rstd_ta (ud,ur,us,ut,lxd,if3d) ! GL->GL gradt
         call intp_rstd    (du(1,e),ud,mx,md,if3d,1) ! 1 = backward; on Gauss points!
         do i=1,nxyz
            du(i,e) = -du(i,e)*binvdg(i,e)
         enddo

      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine conv_bdry_dg_weak (du,u) ! THIS SHOULD HAVE: ,cr,cs,ct)
c
c     Implement  Cu = Div (cu) in weak form using DG
c
      include 'SIZE'
      include 'TOTAL'

c     Apply convecting field c(1,ldim) to scalar field u(1).

      real du(1),u(1)

      parameter(lf=lx1*lz1*2*ldim*lelt)
      common /scrdg/uf(lf),uxf(lf),uyf(lf),uzf(lf),upwind_wgt(lf),us(lf)
     $             ,beta_c(lx1*lz1),jaco_c(lx1*lz1)
     $             ,beta_f(lxd*lzd),jaco_f(lxd*lzd)
     $             ,ufine (lxd*lzd)
      real jaco_c,jaco_f

      common /finewts/ zptf(lxd),wgtf(lxd),wghtf(lxd*lzd),wghtc(lx1*lz1)

      integer e,f,fdim

      n  = lx1*ly1*lz1*nelv
      nf = lx1*lz1*2*ldim*nelt

      call full2face(uf ,u )
      call full2face(uxf,vx)
      call full2face(uyf,vy)
      call full2face(uzf,vz)
      if (.not.if3d) call rzero(uzf,nf)

      beta_u = 1.00 ! 1=full upwind; 0=central flux

      nface = 2*ldim
      nxz   = lx1*lz1
      nxzd  = lxd*lzd
      k     = 0
      do e=1,nelt         ! This formula for upwind weights appears to
      do f=1,nface        ! assume that U is continuous, or at least of

       kface = k+1
       if (fw(f,e).gt.0.6) then

        do i=1,nxz        ! the same sign on either side of the interface.

         k=k+1

         beta   = ( unx (i,1,f,e)*uxf(k)
     $            + uny (i,1,f,e)*uyf(k)
     $            + unz (i,1,f,e)*uzf(k))

         upwind_wgt(k) = 0.0
         if (beta.lt.0) upwind_wgt(k) = 1.0

         beta_c(i)   = beta
         jaco_c(i)   = area(i,1,f,e)/wghtc(i)

        enddo

        fdim = ldim-1 ! Dimension of face
        call map_faced(beta_f,beta_c  ,lx1,lxd,fdim,0) ! Dealiased quadrature,
        call map_faced(jaco_f,jaco_c  ,lx1,lxd,fdim,0) ! 0 --> coarse to fine,
        call map_faced(ufine,uf(kface),lx1,lxd,fdim,0) !   ufine = J uf

        do i=1,nxzd
           ufine(i)=wghtf(i)*jaco_f(i)*beta_f(i)*ufine(i)
        enddo
        call map_faced(uf(kface),ufine,lx1,lxd,fdim,1)  ! 1 --> uf = J^T ufine

       else
        do i=1,nxz
         k=k+1
         upwind_wgt(k) = 0.0
        enddo
       endif

      enddo
      enddo

      do j=1,ndg_facex
         i=dg_face(j)
         du(i) =  du(i) - ( upwind_wgt(j)*uf(j) )
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine conv_rhs_dg_weak (du,u,cr,cs,ct)
c
c     Implement  Cu = Div (cu) in weak form using DG
c
      include 'SIZE'
      include 'TOTAL'

c     Apply convecting field c(1,ldim) to scalar field u(1).

      real du(1),u(1),cr(1),cs(1),ct(1)

      parameter(lf=lx1*lz1*2*ldim*lelt)
      common /scrdg/uf(lf),uxf(lf),uyf(lf),uzf(lf),upwind_wgt(lf),us(lf)
     $             ,beta_c(lx1*lz1),jaco_c(lx1*lz1)
     $             ,beta_f(lxd*lzd),jaco_f(lxd*lzd)
     $             ,ufine (lxd*lzd)
      real jaco_c,jaco_f

      common /finewts/ zptf(lxd),wgtf(lxd),wghtf(lxd*lzd),wghtc(lx1*lz1)

      integer e,f,fdim

      n  = lx1*ly1*lz1*lelv
      nf = lx1*lz1*2*ldim*lelt


      call convop_weak (du,u,cr,cs,ct,lx1,lxd,nelv)  ! Volumetric term

      call full2face(uf ,u )
      call full2face(uxf,vx)
      call full2face(uyf,vy)
      call full2face(uzf,vz)
      if (.not.if3d) call rzero(uzf,nf)

      beta_u = 0.25 ! 1=full upwind; 0=central flux
      beta_u = 0.00 ! 1=full upwind; 0=central flux
      beta_u = 1.00 ! 1=full upwind; 0=central flux
      if (istep.le.5.and.nio.eq.0) write(6,*) beta_u,' dg upwind'

      nface = 2*ldim
      nxz   = lx1*lz1
      nxzd  = lxd*lzd
      k     = 0
      do e=1,nelt         ! This formula for upwind weights appears to
      do f=1,nface        ! assume that U is continuous, or at least of

        kface = k+1
        do i=1,nxz        ! the same sign on either side of the interface.
            k=k+1
            beta   = ( unx (i,1,f,e)*uxf(k)
     $               + uny (i,1,f,e)*uyf(k)
     $               + unz (i,1,f,e)*uzf(k) )

            upwind_wgt(k) = 0.0
            if (beta.gt.0) upwind_wgt(k) = 1.0
            upwind_wgt(k) = 0.5*(1-beta_u) + beta_u*(1-upwind_wgt(k))

            if (fw(f,e).gt.0.6 .and. beta.lt.0) upwind_wgt(k)=1.
            if (fw(f,e).gt.0.6 .and. beta.gt.0) upwind_wgt(k)=0.

            beta_c(i)   = beta
            jaco_c(i)   = area(i,1,f,e)/wghtc(i)
        enddo

        fdim = ldim-1 ! Dimension of face
        call map_faced(beta_f,beta_c  ,lx1,lxd,fdim,0) ! Dealiased quadrature,
        call map_faced(jaco_f,jaco_c  ,lx1,lxd,fdim,0) ! 0 --> coarse to fine,
        call map_faced(ufine,uf(kface),lx1,lxd,fdim,0) !   ufine = J uf

        do i=1,nxzd
           ufine(i)=wghtf(i)*jaco_f(i)*beta_f(i)*ufine(i)
        enddo
        call map_faced(uf(kface),ufine,lx1,lxd,fdim,1)  ! 1 --> uf = J^T ufine
        call copy     (us(kface),uf(kface),lx1*lz1)     ! Save uf for later recombination

      enddo
      enddo

      call fgslib_gs_op(dg_hndlx,uf,1,1,0)  ! 1 ==> +  :   uf <-- uf^- + uf^+

      do j=1,ndg_facex
         i=dg_face(j)
         du(i) = du(i) + ( us(j)-upwind_wgt(j)*uf(j) )*binvdg(i,1)
      enddo

      return
      end
c-----------------------------------------------------------------------

c-----------------------------------------------------------------------
      subroutine plan4 (igeom)

C     Splitting scheme A.G. Tomboulides et al.
c     Journal of Sci.Comp.,Vol. 12, No. 2, 1998
c
C     NOTE: QTL denotes the so called thermal
c           divergence and has to be provided
c           by userqtl.
c
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'GEOM'
      INCLUDE 'MASS'
      INCLUDE 'SOLN'
      INCLUDE 'MVGEOM'
      INCLUDE 'TSTEP'
      INCLUDE 'ORTHOP'
      INCLUDE 'CTIMER'
C
      COMMON /SCRNS/ RES1  (LX1,LY1,LZ1,LELV)
     $ ,             RES2  (LX1,LY1,LZ1,LELV)
     $ ,             RES3  (LX1,LY1,LZ1,LELV)
     $ ,             DV1   (LX1,LY1,LZ1,LELV)
     $ ,             DV2   (LX1,LY1,LZ1,LELV)
     $ ,             DV3   (LX1,LY1,LZ1,LELV)
     $ ,             RESPR (LX2,LY2,LZ2,LELV)
      common /scrvh/ h1    (lx1,ly1,lz1,lelv)
     $ ,             h2    (lx1,ly1,lz1,lelv)
 
      REAL           DPR   (LX2,LY2,LZ2,LELV)
      EQUIVALENCE   (DPR,DV1)
      LOGICAL        IFSTSP

      REAL DVC (LX1,LY1,LZ1,LELV), DFC(LX1,LY1,LZ1,LELV)
      REAL DIV1, DIV2, DIF1, DIF2, QTL1, QTL2
c
      INTYPE = -1
      NTOT1  = lx1*ly1*lz1*NELV

      if (igeom.eq.1) then

         ! compute explicit contributions bfx,bfy,bfz 
         call makef 

         call sumab(vx_e,vx,vxlag,ntot1,ab,nab)
         call sumab(vy_e,vy,vylag,ntot1,ab,nab)
         if (if3d) call sumab(vz_e,vz,vzlag,ntot1,ab,nab)

      else

         if(iflomach) call opcolv(bfx,bfy,bfz,vtrans)

         ! add user defined divergence to qtl 
         call add2 (qtl,usrdiv,ntot1)

         if (igeom.eq.2) call lagvel

         ! mask Dirichlet boundaries
         call bcdirvc  (vx,vy,vz,v1mask,v2mask,v3mask) 

         ! compute pressure
         call copy(prlag,pr,ntot1)
         if (icalld.eq.0) tpres=0.0
         icalld=icalld+1
         npres=icalld
         etime1=dnekclock()

         call crespsp  (respr)
         call invers2  (h1,vtrans,ntot1)
         call rzero    (h2,ntot1)
         call ctolspl  (tolspl,respr)
         napproxp(1) = laxtp
         call hsolve   ('PRES',dpr,respr,h1,h2 
     $                        ,pmask,vmult
     $                        ,imesh,tolspl,nmxp,1
     $                        ,approxp,napproxp,binvm1)
         call add2    (pr,dpr,ntot1)
         call ortho   (pr)

         tpres=tpres+(dnekclock()-etime1)

         ! compute velocity
         if(ifstrs .and. .not.ifaxis) then
            call bcneutr
            call cresvsp_weak(res1,res2,res3,h1,h2)
         else
            call cresvsp     (res1,res2,res3,h1,h2)
         endif
         call ophinv       (dv1,dv2,dv3,res1,res2,res3,h1,h2,tolhv,nmxv)
         call opadd2       (vx,vy,vz,dv1,dv2,dv3)

      endif

      return
      END

c-----------------------------------------------------------------------
      subroutine crespsp (respr)

C     Compute startresidual/right-hand-side in the pressure

      INCLUDE 'SIZE'
      INCLUDE 'TOTAL'

      REAL           RESPR (LX1*LY1*LZ1,LELV)
c
      COMMON /SCRNS/ TA1   (LX1*LY1*LZ1,LELV)
     $ ,             TA2   (LX1*LY1*LZ1,LELV)
     $ ,             TA3   (LX1*LY1*LZ1,LELV)
     $ ,             WA1   (LX1*LY1*LZ1*LELV)
     $ ,             WA2   (LX1*LY1*LZ1*LELV)
     $ ,             WA3   (LX1*LY1*LZ1*LELV)
      COMMON /SCRMG/ W1    (LX1*LY1*LZ1,LELV)
     $ ,             W2    (LX1*LY1*LZ1,LELV)
     $ ,             W3    (LX1*LY1*LZ1,LELV)

      common /scruz/         sij (lx1*ly1*lz1,6,lelv)
      parameter (lr=lx1*ly1*lz1)
      common /scrvz/         ur(lr),us(lr),ut(lr)
     $                     , vr(lr),vs(lr),vt(lr)
     $                     , wr(lr),ws(lr),wt(lr)

      CHARACTER CB*3
      
      NXYZ1  = lx1*ly1*lz1
      NTOT1  = NXYZ1*NELV
      NFACES = 2*ldim

c     -mu*curl(curl(v))
      call op_curl (ta1,ta2,ta3,vx_e,vy_e,vz_e,
     &              .true.,w1,w2)
      if(IFAXIS) then  
         CALL COL2 (TA2, OMASK,NTOT1)
         CALL COL2 (TA3, OMASK,NTOT1)
      endif
      call op_curl  (wa1,wa2,wa3,ta1,ta2,ta3,.true.,w1,w2)
      if(IFAXIS) then  
         CALL COL2  (WA2, OMASK,NTOT1)
         CALL COL2  (WA3, OMASK,NTOT1)
      endif
      call opcolv   (wa1,wa2,wa3,bm1)
c
      call opgrad   (ta1,ta2,ta3,QTL)
      if(IFAXIS) then  
         CALL COL2  (ta2, OMASK,ntot1)
         CALL COL2  (ta3, OMASK,ntot1)
      endif
      scale = -4./3. 
      call opadd2cm (wa1,wa2,wa3,ta1,ta2,ta3,scale)

c compute stress tensor for ifstrs formulation - variable viscosity Pn-Pn
      if (ifstrs .and. ifvvisp) then
         call opgrad   (ta1,ta2,ta3,vdiff)
         call invcol2  (ta1,vdiff,ntot1)
         call invcol2  (ta2,vdiff,ntot1)
         call invcol2  (ta3,vdiff,ntot1)

         nij = 3
         if (if3d.or.ifaxis) nij=6

         call comp_sij   (sij,nij,vx_e,vy_e,vz_e,
     &                    ur,us,ut,vr,vs,vt,wr,ws,wt)
         call col_mu_sij (w1,w2,w3,ta1,ta2,ta3,sij,nij)

         call opcolv   (ta1,ta2,ta3,QTL)
         scale2 = -2./3. 
         call opadd2cm (w1,w2,w3,ta1,ta2,ta3,scale2)
         call opsub2   (wa1,wa2,wa3,w1,w2,w3)

      endif

      call invcol3  (w1,vdiff,vtrans,ntot1)
      call opcolv   (wa1,wa2,wa3,w1)

c     add old pressure term because we solve for delta p 
      call invers2 (ta1,vtrans,ntot1)
      call rzero   (ta2,ntot1)

      call bcdirpr (pr)

      call axhelm  (respr,pr,ta1,ta2,imesh,1)
      call chsign  (respr,ntot1)

c     add explicit (NONLINEAR) terms 
      n = lx1*ly1*lz1*nelv
      do i=1,n
         ta1(i,1) = bfx(i,1,1,1)/vtrans(i,1,1,1,1)-wa1(i)
         ta2(i,1) = bfy(i,1,1,1)/vtrans(i,1,1,1,1)-wa2(i)
         ta3(i,1) = bfz(i,1,1,1)/vtrans(i,1,1,1,1)-wa3(i)
      enddo
      call opdssum (ta1,ta2,ta3)
      do i=1,n
         ta1(i,1) = ta1(i,1)*binvm1(i,1,1,1)
         ta2(i,1) = ta2(i,1)*binvm1(i,1,1,1)
         ta3(i,1) = ta3(i,1)*binvm1(i,1,1,1)
      enddo

      if (if3d) then
         call cdtp    (wa1,ta1,rxm1,sxm1,txm1,1)
         call cdtp    (wa2,ta2,rym1,sym1,tym1,1)
         call cdtp    (wa3,ta3,rzm1,szm1,tzm1,1)
         do i=1,n
            respr(i,1) = respr(i,1)+wa1(i)+wa2(i)+wa3(i)
         enddo
      else
         call cdtp    (wa1,ta1,rxm1,sxm1,txm1,1)
         call cdtp    (wa2,ta2,rym1,sym1,tym1,1)

         do i=1,n
            respr(i,1) = respr(i,1)+wa1(i)+wa2(i)
         enddo
      endif

C     add thermal divergence
      dtbd = BD(1)/DT
      call admcol3(respr,QTL,bm1,dtbd,ntot1)
 
C     surface terms
      DO 100 IEL=1,NELV
         DO 300 IFC=1,NFACES
            CALL RZERO  (W1(1,IEL),NXYZ1)
            CALL RZERO  (W2(1,IEL),NXYZ1)
            IF (ldim.EQ.3)
     $      CALL RZERO  (W3(1,IEL),NXYZ1)
            CB = CBC(IFC,IEL,IFIELD)
            IF (CB(1:1).EQ.'V'.OR.CB(1:1).EQ.'v'.or.
     $         cb.eq.'MV '.or.cb.eq.'mv '.or.cb.eq.'shl') then
               CALL FACCL3
     $         (W1(1,IEL),VX(1,1,1,IEL),UNX(1,1,IFC,IEL),IFC)
               CALL FACCL3
     $         (W2(1,IEL),VY(1,1,1,IEL),UNY(1,1,IFC,IEL),IFC)
               IF (ldim.EQ.3)
     $          CALL FACCL3
     $         (W3(1,IEL),VZ(1,1,1,IEL),UNZ(1,1,IFC,IEL),IFC)
            ELSE IF (CB(1:3).EQ.'SYM') THEN
               CALL FACCL3
     $         (W1(1,IEL),TA1(1,IEL),UNX(1,1,IFC,IEL),IFC)
               CALL FACCL3
     $         (W2(1,IEL),TA2(1,IEL),UNY(1,1,IFC,IEL),IFC)
               IF (ldim.EQ.3)
     $          CALL FACCL3
     $         (W3(1,IEL),TA3(1,IEL),UNZ(1,1,IFC,IEL),IFC)
            ENDIF
            CALL ADD2   (W1(1,IEL),W2(1,IEL),NXYZ1)
            IF (ldim.EQ.3)
     $      CALL ADD2   (W1(1,IEL),W3(1,IEL),NXYZ1)
            CALL FACCL2 (W1(1,IEL),AREA(1,1,IFC,IEL),IFC)
            IF (CB(1:1).EQ.'V'.OR.CB(1:1).EQ.'v'.or.
     $         cb.eq.'MV '.or.cb.eq.'mv ') then
              CALL CMULT(W1(1,IEL),dtbd,NXYZ1)
            endif
            CALL SUB2 (RESPR(1,IEL),W1(1,IEL),NXYZ1)
  300    CONTINUE
  100 CONTINUE

C     Assure that the residual is orthogonal to (1,1,...,1)T 
C     (only if all Dirichlet b.c.)
      CALL ORTHO (RESPR)

      return
      END
c----------------------------------------------------------------------
      subroutine cresvsp (resv1,resv2,resv3,h1,h2)

C     Compute the residual for the velocity

      INCLUDE 'SIZE'
      INCLUDE 'TOTAL'

      real resv1(lx1,ly1,lz1,lelv)
     $   , resv2(lx1,ly1,lz1,lelv)
     $   , resv3(lx1,ly1,lz1,lelv)
     $   , h1   (lx1,ly1,lz1,lelv)
     $   , h2   (lx1,ly1,lz1,lelv)

      COMMON /SCRUZ/ TA1   (LX1,LY1,LZ1,LELV)
     $ ,             TA2   (LX1,LY1,LZ1,LELV)
     $ ,             TA3   (LX1,LY1,LZ1,LELV)
     $ ,             TA4   (LX1,LY1,LZ1,LELV)

      NTOT = lx1*ly1*lz1*NELV
      INTYPE = -1

      CALL SETHLM  (H1,H2,INTYPE)

      CALL OPHX    (RESV1,RESV2,RESV3,VX,VY,VZ,H1,H2)
      CALL OPCHSGN (RESV1,RESV2,RESV3)

      scale = -1./3.
      if (ifstrs) scale =  2./3.

      call col3    (ta4,vdiff,qtl,ntot)
      call add2s1  (ta4,pr,scale,ntot)
      call opgrad  (ta1,ta2,ta3,TA4)
      if(IFAXIS) then
         CALL COL2 (TA2, OMASK,NTOT)
         CALL COL2 (TA3, OMASK,NTOT)
      endif
c
      call opsub2  (resv1,resv2,resv3,ta1,ta2,ta3)
      call opadd2  (resv1,resv2,resv3,bfx,bfy,bfz)

      return
      end

c----------------------------------------------------------------------
      subroutine cresvsp_weak (resv1,resv2,resv3,h1,h2)

C     Compute the residual for the velocity

      INCLUDE 'SIZE'
      INCLUDE 'TOTAL'

      real resv1(lx1,ly1,lz1,lelv)
     $   , resv2(lx1,ly1,lz1,lelv)
     $   , resv3(lx1,ly1,lz1,lelv)
     $   , h1   (lx1,ly1,lz1,lelv)
     $   , h2   (lx1,ly1,lz1,lelv)

      COMMON /SCRUZ/ TA1   (LX1,LY1,LZ1,LELV)
     $ ,             TA2   (LX1,LY1,LZ1,LELV)
     $ ,             TA3   (LX1,LY1,LZ1,LELV)
     $ ,             TA4   (LX1,LY1,LZ1,LELV)
      COMMON /SCRMG/ wa1   (LX1*LY1*LZ1,LELV)
     $ ,             wa2   (LX1*LY1*LZ1,LELV)
     $ ,             wa3   (LX1*LY1*LZ1,LELV)

      NTOT = lx1*ly1*lz1*NELV
      INTYPE = -1

      CALL OPRZERO (RESV1,RESV2,RESV3)
      CALL OPRZERO (wa1  ,wa2  ,wa3  )
      CALL OPRZERO (ta1  ,ta2  ,ta3  )

      CALL SETHLM  (H1,H2,INTYPE)

      CALL OPHX    (RESV1,RESV2,RESV3,VX,VY,VZ,H1,H2)
      CALL OPCHSGN (RESV1,RESV2,RESV3)

      scale = -1./3.
      if (ifstrs) scale =  2./3.

      call col3    (ta4,vdiff,qtl,ntot)
      call cmult   (ta4,scale,ntot)
      call opgrad  (ta1,ta2,ta3,TA4)

      call cdtp    (wa1,pr ,rxm1,sxm1,txm1,1)
      call cdtp    (wa2,pr ,rym1,sym1,tym1,1)
      if(if3d) call cdtp    (wa3,pr ,rzm1,szm1,tzm1,1)

      call sub2    (ta1,wa1,ntot)
      call sub2    (ta2,wa2,ntot)
      if(if3d) call sub2    (ta3,wa3,ntot)

      if(IFAXIS) then
         CALL COL2 (TA2, OMASK,NTOT)
         CALL COL2 (TA3, OMASK,NTOT)
      endif
c
      call opsub2  (resv1,resv2,resv3,ta1,ta2,ta3)
      call opadd2  (resv1,resv2,resv3,bfx,bfy,bfz)

      return
      end

c-----------------------------------------------------------------------
      subroutine op_curl(w1,w2,w3,u1,u2,u3,ifavg,work1,work2)
c
      include 'SIZE'
      include 'TOTAL'
c
      real duax(lx1), ta(lx1,ly1,lz1,lelv)

      logical ifavg
c
      real w1(1),w2(1),w3(1),work1(1),work2(1),u1(1),u2(1),u3(1)
c
      ntot  = lx1*ly1*lz1*nelv
      nxyz  = lx1*ly1*lz1
c     work1=dw/dy ; work2=dv/dz
        call dudxyz(work1,u3,rym1,sym1,tym1,jacm1,1,2)
        if (if3d) then
           call dudxyz(work2,u2,rzm1,szm1,tzm1,jacm1,1,3)
           call sub3(w1,work1,work2,ntot)
        else
           call copy(w1,work1,ntot)

           if(ifaxis) then
              call copy (ta,u3,ntot)
              do iel = 1,nelv
                if(IFRZER(iel)) then
                  call rzero (ta(1,1,1,iel),lx1)
                  call MXM   (ta(1,1,1,iel),lx1,DATM1,ly1,duax,1)
                  call copy  (ta(1,1,1,iel),duax,lx1)
                endif
                call col2    (ta(1,1,1,iel),yinvm1(1,1,1,iel),nxyz)
              enddo
              call add2      (w1,ta,ntot)
           endif

        endif
c     work1=du/dz ; work2=dw/dx
        if (if3d) then
           call dudxyz(work1,u1,rzm1,szm1,tzm1,jacm1,1,3)
           call dudxyz(work2,u3,rxm1,sxm1,txm1,jacm1,1,1)
           call sub3(w2,work1,work2,ntot)
        else
           call rzero (work1,ntot)
           call dudxyz(work2,u3,rxm1,sxm1,txm1,jacm1,1,1)
           call sub3(w2,work1,work2,ntot)
        endif
c     work1=dv/dx ; work2=du/dy
        call dudxyz(work1,u2,rxm1,sxm1,txm1,jacm1,1,1)
        call dudxyz(work2,u1,rym1,sym1,tym1,jacm1,1,2)
        call sub3(w3,work1,work2,ntot)
c
c    Avg at bndry
c
c     if (ifavg) then
      if (ifavg .and. .not. ifcyclic) then

         ifielt = ifield
         ifield = 1
       
         call opcolv  (w1,w2,w3,bm1)
         call opdssum (w1,w2,w3)
         call opcolv  (w1,w2,w3,binvm1)

         ifield = ifielt

      endif
c
      return
      end

c-----------------------------------------------------------------------
      subroutine opadd2cm (a1,a2,a3,b1,b2,b3,c)
      INCLUDE 'SIZE'
      REAL A1(1),A2(1),A3(1),B1(1),B2(1),B3(1),C
      NTOT1=lx1*ly1*lz1*NELV
      if (ldim.eq.3) then
         do i=1,ntot1
            a1(i) = a1(i) + b1(i)*c
            a2(i) = a2(i) + b2(i)*c
            a3(i) = a3(i) + b3(i)*c
         enddo
      else
         do i=1,ntot1
            a1(i) = a1(i) + b1(i)*c
            a2(i) = a2(i) + b2(i)*c
         enddo
      endif
      return
      END

c-----------------------------------------------------------------------
      subroutine split_vis

c     Split viscosity into a constant implicit (VDIFF) and variable 
c     explicit (VDIFF_E) part.

      include 'SIZE'
      include 'TOTAL'

      n = lx1*ly1*lz1*nelv

      dnu_star = -nu_star
      call cadd2 (vdiff_e,vdiff,dnu_star,n)   ! set explicit part

      call cfill (vdiff,nu_star,n)            ! set implicit part

      return
      end
c-----------------------------------------------------------------------
      subroutine redo_split_vis     !     Redo split viscosity

      include 'SIZE'
      include 'TOTAL'

      n = lx1*ly1*lz1*nelv
      call add2(vdiff,vdiff_e,n) ! sum up explicit and implicit part

      return
      end
c-----------------------------------------------------------------------
      subroutine col_mu_sij(w1,w2,w3,ta1,ta2,ta3,sij,nij)

      include 'SIZE'
      include 'TOTAL'

      parameter (lr=lx1*ly1*lz1)
      real w1 (lr,1),w2 (lr,1),w3 (lr,1)
      real ta1(lr,1),ta2(lr,1),ta3(lr,1)
      real sij(lr,nij,1)
      integer e

      nxyz1 = lx1*ly1*lz1

      if (if3d.or.ifaxis) then
        do e=1,nelv
          call vdot3 (w1(1,e),ta1(1,e),ta2(1,e),ta3(1,e)
     $               ,sij(1,1,e),sij(1,4,e),sij(1,6,e),nxyz1)
          call vdot3 (w2(1,e),ta1(1,e),ta2(1,e),ta3(1,e)
     $                  ,sij(1,4,e),sij(1,2,e),sij(1,5,e),nxyz1)
          call vdot3 (w3(1,e),ta1(1,e),ta2(1,e),ta3(1,e)
     $                  ,sij(1,6,e),sij(1,5,e),sij(1,3,e),nxyz1)
        enddo

      else

        do e=1,nelv
          call vdot2 (w1(1,e),ta1(1,e),ta2(1,e)
     $               ,sij(1,1,e),sij(1,3,e),nxyz1)
          call vdot2 (w2,ta1(1,e),ta2(1,e)
     $               ,sij(1,3,e),sij(1,2,e),nxyz1)
          call rzero (w3(1,e),nxyz1)
        enddo

      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine sumab(v,vv,vvlag,ntot,ab_,nab_)
c
c     sum up AB/BDF contributions 
c
      include 'SIZE'

      real vvlag(lx1*ly1*lz1*lelv,*)
      real ab_(*)

      ab0 = ab_(1)
      ab1 = ab_(2)
      ab2 = ab_(3)

      call add3s2(v,vv,vvlag(1,1),ab0,ab1,ntot)
      if(nab_.eq.3) call add2s2(v,vvlag(1,2),ab2,ntot)

      return
      end
c-----------------------------------------------------------------------
      subroutine userqtl_scig
c
c     Compute the thermal divergence QTL for an ideal single component gas 
c     QTL := div(v) = -1/rho * Drho/Dt
c
      include 'SIZE'
      include 'TOTAL'
      include 'CVODE'

      common /scrns/ w1(lx1,ly1,lz1,lelt)
     $              ,w2(lx1,ly1,lz1,lelt)
     $              ,w3(lx1,ly1,lz1,lelt)
     $              ,tx(lx1,ly1,lz1,lelt)
     $              ,ty(lx1,ly1,lz1,lelt)
     $              ,tz(lx1,ly1,lz1,lelt)

      nxyz = lx1*ly1*lz1
      ntot = nxyz*nelv

      ifld_save = ifield

c - - Assemble RHS of T-eqn
      ifield=2

      call makeuq
      call copy(qtl,bq,ntot)

      ifield=1     !set right gs handle (QTL is only defined on the velocity mesh)
      call opgrad  (tx,ty,tz,t)
      call opdssum (tx,ty,tz)
      call opcolv  (tx,ty,tz,binvm1)
      call opcolv  (tx,ty,tz,vdiff(1,1,1,1,2))
      call opdiv   (w2,tx,ty,tz)

      call add2    (qtl,w2,ntot)
      call dssum   (qtl,lx1,ly1,lz1)
      call col2    (qtl,binvm1,ntot)

      ! QTL = T_RHS/(rho*cp**T)
      call col3    (w2,vtrans(1,1,1,1,2),t,ntot)
      call invcol2 (qtl,w2,ntot)

      dp0thdt = 0.0
      if (ifdp0dt) then
         dd = (1.0 - gamma0)/gamma0
         call rone(w1,ntot)
         call cmult(w1,dd,ntot)

         call invcol3(w2,vtrans(1,1,1,1,2),vtrans,ntot)
         call invcol2(w1,w2,ntot)

         call cadd(w1,1.0,ntot)
         call copy(w2,w1,ntot)
         call col2(w1,bm1,ntot)
  
         p0alph1 = 1. / glsum(w1,ntot)
  
         call copy   (w1,qtl,ntot)
         call col2   (w1,bm1,ntot)

         termQ = glsum(w1,ntot)
         if (ifcvfun) then
            termV = glcflux(vx,vy,vz)
            prhs  = p0alph1*(termQ - termV)
            pcoef =(cv_bd(1) - cv_dtNek*prhs)
            call add3s2(Saqpq,p0thn,p0thlag(1),cv_bd(2),cv_bd(3),1)
            if(nbd.eq.3) call add2s2(Saqpq,p0thlag(2),cv_bd(4),1)
            p0th  = Saqpq / pcoef
         else
            termV = glcflux(vx_e,vy_e,vz_e)
            prhs  = p0alph1*(termQ - termV)
            pcoef =(bd(1) - dt*prhs)
            call add3s2(Saqpq,p0thn,p0thlag(1),bd(2),bd(3),1)
            if(nbd.eq.3) call add2s2(Saqpq,p0thlag(2),bd(4),1)
            p0th  = Saqpq / pcoef
            p0thlag(2) = p0thlag(1)
            p0thlag(1) = p0thn
            p0thn      = p0th
         endif

         dp0thdt= prhs*p0th

         dd =-prhs
         call cmult(w2,dd,ntot)
         call add2 (qtl,w2,ntot)
      endif

      ifield = ifld_save

      return
      end
c-----------------------------------------------------------------------
      subroutine qthermal
c
c     generic qtl wrapper
c
      INCLUDE 'SIZE'
      INCLUDE 'TOTAL'

      ntot = lx1*ly1*lz1*nelv

      call rzero(qtl,ntot)
      call userqtl()

      return
      end
c-----------------------------------------------------------------------
      subroutine printdiverr
c
      INCLUDE 'SIZE'
      INCLUDE 'TOTAL'

      COMMON /SCRNS/ DVC  (LX1,LY1,LZ1,LELV),
     $               DV1  (LX1,LY1,LZ1,LELV),
     $               DV2  (LX1,LY1,LZ1,LELV),
     $               DFC  (LX1,LY1,LZ1,LELV)
 
      ntot1 = lx1*ly1*lz1*nelv

      !Calculate Divergence norms of new VX,VY,VZ
      CALL OPDIV   (DVC,VX,VY,VZ)
      CALL DSSUM   (DVC,lx1,ly1,lz1)
      CALL COL2    (DVC,BINVM1,NTOT1)

      CALL COL3    (DV1,DVC,BM1,NTOT1)
      DIV1 = GLSUM (DV1,NTOT1)/VOLVM1

      CALL COL3    (DV2,DVC,DVC,NTOT1)
      CALL COL2    (DV2,BM1   ,NTOT1)
      DIV2 = GLSUM (DV2,NTOT1)/VOLVM1
      DIV2 = SQRT  (DIV2)

      !Calculate Divergence difference norms
      CALL SUB3    (DFC,DVC,QTL,NTOT1)
      CALL COL3    (DV1,DFC,BM1,NTOT1)
      DIF1 = GLSUM (DV1,NTOT1)/VOLVM1

      CALL COL3    (DV2,DFC,DFC,NTOT1)
      CALL COL2    (DV2,BM1   ,NTOT1)
      DIF2 = GLSUM (DV2,NTOT1)/VOLVM1
      DIF2 = SQRT  (DIF2)

      CALL COL3    (DV1,QTL,BM1,NTOT1)
      QTL1 = GLSUM (DV1,NTOT1)/VOLVM1

      CALL COL3    (DV2,QTL,QTL,NTOT1)
      CALL COL2    (DV2,BM1   ,NTOT1)
      QTL2 = GLSUM (DV2,NTOT1)/VOLVM1
      QTL2 = SQRT  (QTL2)

      IF (NIO.EQ.0) THEN
         WRITE(6,'(13X,A,1p2e13.4)')
     &         'L1/L2 DIV(V)        ',DIV1,DIV2
         WRITE(6,'(13X,A,1p2e13.4)') 
     &         'L1/L2 QTL           ',QTL1,QTL2
         WRITE(6,'(13X,A,1p2e13.4)')
     &         'L1/L2 DIV(V)-QTL    ',DIF1,DIF2
         IF (DIF2.GT.0.1) WRITE(6,'(13X,A)') 
     &         'WARNING: DIV(V)-QTL too large!'
      ENDIF

      return
      end
c-----------------------------------------------------------------------
      SUBROUTINE BCDIRPR(S)
C
C     Apply Dirichlet boundary conditions to surface of Pressure.
C     Use IFIELD=1.
C
      INCLUDE 'SIZE'
      INCLUDE 'TSTEP'
      INCLUDE 'INPUT'
      INCLUDE 'SOLN'
      INCLUDE 'TOPOL'
      INCLUDE 'CTIMER'
C
      DIMENSION S(LX1,LY1,LZ1,LELT)
      COMMON /SCRSF/ TMP(LX1,LY1,LZ1,LELT)
     $             , TMA(LX1,LY1,LZ1,LELT)
     $             , SMU(LX1,LY1,LZ1,LELT)
      common  /nekcb/ cb
      CHARACTER CB*3

      if (icalld.eq.0) then
         tusbc=0.0
         nusbc=0
         icalld=icalld+1
      endif
      nusbc=nusbc+1
      etime1=dnekclock()
C
      IFLD   = 1
      NFACES = 2*ldim
      NXYZ   = lx1*ly1*lz1
      NEL    = NELFLD(IFIELD)
      NTOT   = NXYZ*NEL
      NFLDT  = NFIELD - 1
C
      CALL RZERO(TMP,NTOT)
C
C     pressure boundary condition
C
      DO 2100 ISWEEP=1,2
C
         DO 2010 IE=1,NEL
         DO 2010 IFACE=1,NFACES
            CB=CBC(IFACE,IE,IFIELD)
            BC1=BC(1,IFACE,IE,IFIELD)
            IF (cb.EQ.'O  ' .or. cb.eq.'ON ' .or.
     $          cb.eq.'o  ' .or. cb.eq.'on ') 
     $          CALL FACEIS (CB,TMP(1,1,1,IE),IE,IFACE,lx1,ly1,lz1)
 2010    CONTINUE
C
C        Take care of Neumann-Dirichlet shared edges...
C
         IF (ISWEEP.EQ.1) CALL DSOP(TMP,'MXA',lx1,ly1,lz1)
         IF (ISWEEP.EQ.2) CALL DSOP(TMP,'MNA',lx1,ly1,lz1)
 2100 CONTINUE
C
C     Copy temporary array to temperature array.
C
      CALL COL2(S,PMASK,NTOT)
      CALL ADD2(S,TMP,NTOT)

      tusbc=tusbc+(dnekclock()-etime1)

      RETURN
      END
C
c-----------------------------------------------------------------------

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!This benchmark is extracted from flush_nolist.1c of OpenMP
!Application Programming Interface Examples Version 4.5.0 .
!
!We privatize variable i to fix data races in the original example.
!Once i is privatized, flush is no longer needed. No data race pairs.

module DRB076
    use omp_lib
    implicit none
contains
    subroutine f1(q)
        integer :: q
        q = 1
    end subroutine
end module

program DRB076_flush_orig_no
    use omp_lib
    use DRB076
    implicit none

    integer :: i, sum
    i = 0
    sum = 0

    !$omp parallel reduction(+:sum) num_threads(10) private(i)
    call f1(i)
    sum = sum + i
    !$omp end parallel

    if (sum /= 10) then
        print*,'sum =',sum
    end if
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!tasks with depend clauses to ensure execution order, no data races.

program DRB079_taskdep3_orig_no
    use omp_lib
    implicit none

    integer :: i, j, k
    i = 0

    !$omp parallel
        !$omp single
            !$omp task depend (out:i)
                call sleep(3)
                i = 1
            !$omp end task
            !$omp task depend (in:i)
                j = i
            !$omp end task
            !$omp task depend (in:i)
                k = i
            !$omp end task
        !$omp end single
    !$omp end parallel

    print 100, j, k
    100 format ('j =',i3,2x,'k =',i3)

    if (j /= 1 .and. k /= 1) then
        print*, 'Race Condition'
    end if

end program

      Program Driver
      
        implicit none
      
        #include "Eos.h"
        #include "Eos_map.h"
        #include "constants.h"
        #include "Flash.h"
      
        integer range(LOW:HIGH,MDIM)
        integer vecLen, n
        real solnData(EOS_NUM,NZB,NYB,NXB)
        real eosData(EOS_NUM*NZB*NYB*NXB)
        
        range(LOW, IAXIS) = GRID_ILO
        range(LOW, JAXIS) = GRID_JLO
        range(LOW, KAXIS) = GRID_KLO
        range(HIGH, IAXIS) = GRID_IHI
        range(HIGH, JAXIS) = GRID_JHI
        range(HIGH, KAXIS) = GRID_KHI
      
        n = 1
      
        do l = 1, EOS_NUM
          do k = GRID_KLO,GRID_KHI
            do j = GRID_JLO,GRID_JHI
              do i = GRID_ILO,GRID_IHI
                solnData(l,k,j,i) = 1.0
                eosData(n) = 0.0
                n = n+1
              end do
            end do
          end do
        end do
      
!        call Eos_getData(range,vecLen,solnData,1,eosData)
        
      End Program Driver
      

      PROGRAM DRIVERGAUSS
      DIMENSION A(2,2),IR(2),IC(2)
      N = 2
      LDIM = 2
      
      DO I=1,N
        DO J=1,N
          A(J,I) = I*10+J
        END DO
      END DO
      CALL LU(A,LDIM,N,IR,IC)
      
      END PROGRAM DRIVERGAUSS

      subroutine mxm(a,n1,b,n2,c,n3)
c
c     Compute matrix-matrix product C = A*B
c     for contiguously packed matrices A,B, and C.
c
      real a(n1,n2),b(n2,n3),c(n1,n3)
c
      include 'SIZE'
      include 'CTIMER'
      include 'OPCTR'
      include 'TOTAL'
c
      integer*8 tt
      parameter(tt = 32) 

#ifdef TIMER2
      if (isclld.eq.0) then
          isclld=1
          nrout=nrout+1
          myrout=nrout
          rname(myrout) = 'mxm   '
      endif
      isbcnt = n1*n3*(2*n2-1)
      dct(myrout) = dct(myrout) + (isbcnt)
      ncall(myrout) = ncall(myrout) + 1
      dcount = dcount + (isbcnt)
      etime1 = dnekclock()
#endif


#ifdef BGQ
      if (n2 .eq. 8 .and. mod(n1,4) .eq. 0 
     $  .and. MOD(LOC(a),tt).eq.0 
     $  .and. MOD(LOC(b),tt).eq.0 
     $  .and. MOD(LOC(c),tt).eq.0 
     $   ) then
        call mxm_bgq_8(a, n1, b, n2, c, n3)  
        goto 111
      endif
      if (n2 .eq. 16 .and. mod(n1,4) .eq. 0 
     $  .and. MOD(LOC(a),tt).eq.0
     $  .and. MOD(LOC(b),tt).eq.0
     $  .and. MOD(LOC(c),tt).eq.0
     $    ) then
        call mxm_bgq_16(a, n1, b, n2, c, n3)  
        goto 111
      endif
      if (n2 .eq. 10 .and. mod(n1,4) .eq. 0 .and. mod(n3,2) .eq. 0 
     &   .and. MOD(LOC(a),tt).eq.0 
     &   .and. MOD(LOC(b),tt).eq.0  
     &   .and. MOD(LOC(c),tt).eq.0  
     &     ) then
        call mxm_bgq_10(a, n1, b, n2, c, n3)  
        goto 111
      endif
      if (n2 .eq. 6 .and. mod(n1,4) .eq. 0 .and. mod(n3,2) .eq. 0 
     &   .and. MOD(LOC(a),tt).eq.0 
     &   .and. MOD(LOC(b),tt).eq.0  
     &   .and. MOD(LOC(c),tt).eq.0  
     &  ) then
        call mxm_bgq_6(a, n1, b, n2, c, n3)  
        goto 111
      endif
#endif

#ifdef XSMM
      if ((n1*n2*n3)**(1./3) .gt. 6) then
         call libxsmm_dgemm('N','N',n1,n3,n2,1.0,a,n1,b,n2,0.0,c,n1)
         goto 111
      else
         goto 101
      endif
#endif

#ifdef BLAS_MXM
      call dgemm('N','N',n1,n3,n2,1.0,a,n1,b,n2,0.0,c,n1)
      goto 111
#endif

 101  call mxmf2(a,n1,b,n2,c,n3)

 111  continue
#ifdef TIMER2
      tmxmf = tmxmf + dnekclock() - etime1  
#endif
      return
      end
c-----------------------------------------------------------------------
      subroutine fgslib_mxm(a,n1,b,n2,c,n3)
      real a(n1,n2),b(n2,n3),c(n1,n3)

      call mxmf2(a,n1,b,n2,c,n3)

      return
      end

      program test
      implicit none
      logical havetobreak
      integer i,j,jj,k,n

      n=10

      i=1
      do 13 k=1,n
        if(k .gt. 3) go to 14
        i=i+1
   13 continue
   14 continue

      j=1
      havetobreak = .false.
      do k=1,n
        if(k .gt. 3) then
          havetobreak = .true.
        end if
        if(.not. havetobreak) then
          j=j+1
        end if
      end do

      jj=1
      do k=1,n
        if(k .gt. 3) then
          exit
        end if
        jj=jj+1
      end do
      !$ civl $assert(i==4);
      !$ civl $assert(j==4);
      !$ civl $assert(jj==4);
      write(*,*) i, j, jj
      end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!The var@22:13 is atomic update. Hence, there is no data race.


program DRB146_atomicupdate_orig_gpu_no
    use omp_lib
    implicit none

    integer :: var, i
    var = 0

    !$omp target map(tofrom:var) device(0)
        !$omp teams distribute
        do i = 1, 100
            !$omp atomic update
            var = var+1
            !$omp end atomic
        end do
        !$omp end teams distribute
    !$omp end target

  print*,var
end program

      subroutine printalot(e,f,lu,pileoffaces)
      include 'SIZE'
      include 'DG'
      include 'CMTDATA'
      include 'GEOM'
      parameter (ldd=lxd*lyd*lzd)
      common /ctmp1/ xface(lx1*lz1,2*ldim),yface(lx1*lz1,2*ldim),
     >               supapad(6*ldd-4*ldim*lx1*lz1)
      real   pileoffaces(lx1*lz1,2*ldim,nelt,toteq)!,ldim)
      integer   e,f,lu
      real ghere, betahere,pi,kond,h
      pi=4.0*atan(1.0)
      ghere=1.4
      betahere=5.0

      call full2face_cmt(1,lx1,ly1,lz1,iface_flux(1,e),xface,
     >                   xm1(1,1,1,e))
      call full2face_cmt(1,lx1,ly1,lz1,iface_flux(1,e),yface,
     >                   ym1(1,1,1,e))
      nxz=lx1*lz1
      write(lu,*) '# e=',e
      do i=1,nxz
!        x=xface(i,f)-5.0
!        y=yface(i,f)
!        r2=x**2+y**2
!        zeu=-betahere*y*0.5/pi*exp(1.0-r2)
!        zev= betahere*x*0.5/pi*exp(1.0-r2)
!        tau11=2.0*muref*betahere*x*y/pi*exp(1.0-r2)
!        tau12=betahere/pi*(y**2-x**2)*exp(1.0-r2)*muref
!        tau22=-tau11
!        zework1=zeu*tau11+zev*tau12
!        zework2=zeu*tau12+zev*tau22
!        kond=cpgref*muref/prlam
!        tx=0.25*betahere**2/pi/pi*(ghere-1.0)/ghere*exp(2.*(1.0-r2))*x
!        ty=0.25*betahere**2/pi/pi*(ghere-1.0)/ghere*exp(2.*(1.0-r2))*y
!        fluxx=zework1-kond*tx
!        fluxy=zework2-kond*ty
         y=yface(i,f)
         u2=1.0
         h=1.0
         tau12=u2*muref/h
!        write(lu,'(5e17.5)') xface(i,f),yface(i,f),-tau12,
!    >                        pileoffaces(i,f,e,3,1),
!    >                        pileoffaces(i,f,e,3,2)
!    >                        pileoffaces(i,f,e,3,1),-tau11,
!        write(lu,'(4e17.5)') xface(i,f),yface(i,f),
!    >                        pileoffaces(i,f,e,3,1),
!    >                        pileoffaces(i,f,e,3,2)
         write(lu,*) xface(i,f),yface(i,f), pileoffaces(i,f,e,1)
      enddo

      return
      end
c-----------------------------------------------------------------------
! A bunch of diagostic routines
c-----------------------------------------------------------------------
      subroutine matout_rowsum(ab,na,nb)
      integer   na,nb
      real   ab(na,nb)
      character*100 zefmt
      write(zefmt,'(a1,i2,a6)') '(',nb,'e15.7)'
      do i=1,na
         write(6,zefmt) (ab(i,j),j=1,nb)
!        write(6,*) i,'rowsum=',sum(ab(i,1:nb))
      enddo
      return
      end
c----------------------------------------------------------------------
      subroutine out_fld_nek
      include 'SIZE'
      include 'SOLN'
      COMMON /solnconsvar/ U(LX1,LY1,LZ1,TOTEQ,lelt) 
      COMMON /SCRNS/      OTVAR(LX1,LY1,LZ1,lelt,7)
      real                OTVAR
      real               phig(lx1,ly1,lz1,lelt)
      common /otherpvar/ phig
      integer e,f

      n = lx1*ly1*lz1
      do e=1,nelt
         call copy(otvar(1,1,1,e,4),u(1,1,1,1,e),n)
         call copy(otvar(1,1,1,e,5),u(1,1,1,2,e),n)
         call copy(otvar(1,1,1,e,6),u(1,1,1,3,e),n)
         call copy(otvar(1,1,1,e,7),u(1,1,1,4,e),n)
         call copy(otvar(1,1,1,e,1),u(1,1,1,5,e),n)
      enddo

c     call copy(otvar(1,1,1,1,2),tlag(1,1,1,1,1,2),n*nelt) ! s_{n-1}
c     call copy(otvar(1,1,1,1,3),tlag(1,1,1,1,2,1),n*nelt) ! s_n
      call copy(otvar(1,1,1,1,2),phig(1,1,1,1),n*nelt) ! s_{n-1}
      call copy(otvar(1,1,1,1,3),pr(1,1,1,1),n*nelt) ! s_n

c     ifxyo=.true.
      if (lx2.ne.lx1) call exitti('Set LX1=LX2 for I/O$',lx2)

      itmp = 3
      call outpost2(otvar(1,1,1,1,5),otvar(1,1,1,1,6),otvar(1,1,1,1,7)
     $             ,otvar(1,1,1,1,4),otvar(1,1,1,1,1),itmp,'SLN')
      return
      end

c----------------------------------------------------------------------

      subroutine dumpresidue(wfnav,inmbr)
      include 'SIZE'
      include 'INPUT'
      include 'GEOM'
      include 'MASS'
      include 'CMTDATA'

      character*32  wfnav
      character*32  citer,citer2
      integer e,i1,is,il,i,inmbr,length,eq,is2,il2
      real    rhseqs(toteq)

c     write(6,*)wfnav,inmbr
      i1 =index(wfnav,' ')-1
      write(citer,*)inmbr
      write(citer2,*)nid
      length = len(wfnav)
      do i=1,length
         if(citer(i:i).ne.' ')then
         is=i
c        exit ! Not valid w/ pgf77
         endif
      enddo
      do i=length,1,-1 
         if(citer(i:i).ne.' ')then
         il=i
c        exit ! Not valid w/ pgf77
         endif
      enddo
!     get the string that contains character nid
      do i=1,length
         if(citer2(i:i).ne.' ')then
         is2=i
c        exit ! Not valid w/ pgf77
         endif
      enddo
      do i=length,1,-1 
         if(citer2(i:i).ne.' ')then
         il2=i
c        exit ! Not valid w/ pgf77
         endif
      enddo
      nxyz1 = lx1*ly1*lz1
      nxy1  = lx1*ly1
      open(unit=11,file=wfnav(1:i1)//'.'//'it='//citer(is:il)//
     $                     '.'//'p='//citer2(is2:il2))
      write(11,*)'Title="',wfnav(1:i1),'"'
c      write(6,*)wfnav(1:i1),'.',citer(is:il)
      do i=1,length
        wfnav(i:i)=' '
      enddo
      do i=1,length
        citer(i:i)=' '
      enddo
      if(if3d)then
        write(11,*)'Variables=x,y,z,e1,e2,e3,e4,e5'
        do e = 1,nelt
          write(11,*)'zone T="',e,'",i=',lx1,',j=',ly1,',k=',lz1
          do i=1,nxyz1
             do eq=1,toteq
                rhseqs(eq) = res1(i,1,1,e,eq)/bm1(i,1,1,e)
             enddo
          write(11,101)xm1(i,1,1,e),ym1(i,1,1,e),zm1(i,1,1,e)
     $         ,rhseqs(1),rhseqs(2),rhseqs(3),rhseqs(4)
     $         ,rhseqs(5)
          enddo
        enddo
      else
        write(11,*)'Variables=x,y,e1,e2,e3,e4,e5'
        do e = 1,nelt
          write(11,*)'zone T="',e,'",i=',lx1,',j=',ly1
          do i=1,nxy1
             do eq=1,toteq
                rhseqs(eq) = res1(i,1,1,e,eq)/bm1(i,1,1,e)
             enddo
          write(11,102)xm1(i,1,1,e),ym1(i,1,1,e)
     $         ,rhseqs(1),rhseqs(2),rhseqs(3),rhseqs(4)
     $         ,rhseqs(5)
          enddo
        enddo
      endif
      close(11)
101   format(8(3x,e12.5))
102   format(7(3x,e14.7))
      return
      end
c----------------------------------------------------------------------
      subroutine mass_balance(if3d)
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'MASS'
      INCLUDE 'TSTEP'
      COMMON /solnconsvar/ U(LX1,LY1,LZ1,TOTEQ,lelt) 
      logical if3d
      integer e
      real msum,total_mass
c     First get the mass in the local domain. Then use
c     Global sum to get the total mass
c     mass = \rho_g \phi_g * Wts(i,j,k)
c     Note -  this is only for single processor runs
c          need to add glsum to make it parallel
      if (if3d)then
         msum = 0.0
         do e=1,nelt
            il = 0
            do k=1,lz1
               do j=1,ly1
                  do i=1,lx1
                     il = il +1
                     msum = msum + (u(i,j,k,1,e)*bm1(i,j,k,e))
                  enddo
               enddo
            enddo
         enddo
      else
         msum = 0.0
         do e=1,nelt
            il = 0
            do j=1,ly1
            do i=1,lx1
               il = il +1
               msum = msum + (u(i,j,1,1,e)*bm1(i,j,1,e))
            enddo
            enddo
         enddo
      endif
      total_mass = glsum(msum,1) 
      if(nio.eq.0)
c    $   write(6,*)'Total mass in the domain ',total_mass
     $   write(144,*)'Time ',time,'Mass ',total_mass
      return
      end
c-----------------------------------------------------------------------
! That was a bunch of diagostic routines
c-----------------------------------------------------------------------
      subroutine torque_calc_cmt(scale,x0,ifdout,iftout)
c
c     Compute torque about point x0
c
c     Scale is a user-supplied multiplier so that results may be
c     scaled to any convenient non-dimensionalization.
c
c
      INCLUDE 'SIZE'  
      INCLUDE 'TOTAL' 

      common /cvflow_r/ flow_rate,base_flow,domain_length,xsec
     $                , scale_vf(3)

c
      real x0(3),w1(0:maxobj)
      logical ifdout,iftout
c
      common /scrns/         sij (lx1*ly1*lz1*6*lelt)
      common /scrcg/         pm1 (lx1,ly1,lz1,lelt)
      common /scrsf/         xm0(lx1,ly1,lz1,lelt)
     $,                      ym0(lx1,ly1,lz1,lelt)
     $,                      zm0(lx1,ly1,lz1,lelt)
c
      parameter (lr=lx1*ly1*lz1)
      common /scruz/         ur(lr),us(lr),ut(lr)
     $                     , vr(lr),vs(lr),vt(lr)
     $                     , wr(lr),ws(lr),wt(lr)
c
      common /ICPVARS/ pvars(lx1,ly1,lz1,7)
      real             pvars
c
      n = lx1*ly1*lz1*nelv
      ntot1 = lx1*ly1*lz1
c
c     call mappr(pm1,pr,xm0,ym0) ! map pressure onto Mesh 1
c     IN CMT-Nek Pressure is defined on the velocity grid
      do ie=1,nelv 
         call copy(pm1(1,1,1,ie),pr(1,1,1,ie),ntot1)
      enddo
c
c    Add mean_pressure_gradient.X to p:

c    In CMT-Nek we do not fix the volume flow rate
c     if (param(55).ne.0) then
c        dpdx_mean = -scale_vf(1)
c        dpdy_mean = -scale_vf(2)
c        dpdz_mean = -scale_vf(3)
c     endif

c     call add2s2(pm1,xm1,dpdx_mean,n)  ! Doesn't work if object is cut by 
c     call add2s2(pm1,ym1,dpdy_mean,n)  ! periodicboundary.  In this case,
c     call add2s2(pm1,zm1,dpdz_mean,n)  ! set ._mean=0 and compensate in
c
c    Compute sij
c
      nij = 3
      if (if3d.or.ifaxis) nij=6
c     we store primivtive variables only on dealiased grid. We will modify
c     comp_sij such that primvars are stored on the grid element
c     by element in a scratch array. 
      call comp_sij_cmt(sij,nij,ur,us,ut,vr,vs,vt,wr,ws,wt)
c
c
c     Fill up viscous array w/ default
      param(2) = 0.0
c
      if (istep.lt.1) call cfill(vdiff,param(2),n)
c
      call cadd2(xm0,xm1,-x0(1),n)
      call cadd2(ym0,ym1,-x0(2),n)
      call cadd2(zm0,zm1,-x0(3),n)
c
      x1min=glmin(xm0(1,1,1,1),n)
      x2min=glmin(ym0(1,1,1,1),n)
      x3min=glmin(zm0(1,1,1,1),n)
c
      x1max=glmax(xm0(1,1,1,1),n)
      x2max=glmax(ym0(1,1,1,1),n)
      x3max=glmax(zm0(1,1,1,1),n)
c
      do i=0,maxobj
         dragpx(i) = 0   ! BIG CODE  :}
         dragvx(i) = 0
         dragx (i) = 0
         dragpy(i) = 0
         dragvy(i) = 0
         dragy (i) = 0
         dragpz(i) = 0
         dragvz(i) = 0
         dragz (i) = 0
         torqpx(i) = 0
         torqvx(i) = 0
         torqx (i) = 0
         torqpy(i) = 0
         torqvy(i) = 0
         torqy (i) = 0
         torqpz(i) = 0
         torqvz(i) = 0
         torqz (i) = 0
      enddo
c
c
      nobj = 0
      do ii=1,nhis
        if (hcode(10,ii).EQ.'I') then
          iobj   = lochis(1,ii)
          memtot = nmember(iobj)
          nobj   = max(iobj,nobj)
c
          if (hcode(1,ii).ne.' ' .or. hcode(2,ii).ne.' ' .or.
     $      hcode(3,ii).ne.' ' ) then
            ifield = 1
c
c           Compute drag for this object
c
            do mem=1,memtot
               ieg   = object(iobj,mem,1)
               ifc   = object(iobj,mem,2)
               if (gllnid(ieg).eq.nid) then ! this processor has a contribution
                  ie = gllel(ieg)
                  call drgtrq(dgtq,xm0,ym0,zm0,sij,pm1,vdiff,ifc,ie)
c
                  call cmult(dgtq,scale,12)
c
                  dragpx(iobj) = dragpx(iobj) + dgtq(1,1)  ! pressure 
                  dragpy(iobj) = dragpy(iobj) + dgtq(2,1)
                  dragpz(iobj) = dragpz(iobj) + dgtq(3,1)
c
                  dragvx(iobj) = dragvx(iobj) + dgtq(1,2)  ! viscous
                  dragvy(iobj) = dragvy(iobj) + dgtq(2,2)
                  dragvz(iobj) = dragvz(iobj) + dgtq(3,2)
c
                  torqpx(iobj) = torqpx(iobj) + dgtq(1,3)  ! pressure 
                  torqpy(iobj) = torqpy(iobj) + dgtq(2,3)
                  torqpz(iobj) = torqpz(iobj) + dgtq(3,3)
c
                  torqvx(iobj) = torqvx(iobj) + dgtq(1,4)  ! viscous
                  torqvy(iobj) = torqvy(iobj) + dgtq(2,4)
                  torqvz(iobj) = torqvz(iobj) + dgtq(3,4)
c
               endif
            enddo
          endif
        endif
      enddo
c
c     Sum contributions from all processors
c
      call gop(dragpx,w1,'+  ',maxobj+1)
      call gop(dragpy,w1,'+  ',maxobj+1)
      call gop(dragpz,w1,'+  ',maxobj+1)
      call gop(dragvx,w1,'+  ',maxobj+1)
      call gop(dragvy,w1,'+  ',maxobj+1)
      call gop(dragvz,w1,'+  ',maxobj+1)
c
      call gop(torqpx,w1,'+  ',maxobj+1)
      call gop(torqpy,w1,'+  ',maxobj+1)
      call gop(torqpz,w1,'+  ',maxobj+1)
      call gop(torqvx,w1,'+  ',maxobj+1)
      call gop(torqvy,w1,'+  ',maxobj+1)
      call gop(torqvz,w1,'+  ',maxobj+1)
c
      nobj = iglmax(nobj,1)
c
      do i=1,nobj
         dragx(i) = dragpx(i) + dragvx(i)
         dragy(i) = dragpy(i) + dragvy(i)
         dragz(i) = dragpz(i) + dragvz(i)
c
         torqx(i) = torqpx(i) + torqvx(i)
         torqy(i) = torqpy(i) + torqvy(i)
         torqz(i) = torqpz(i) + torqvz(i)
c
         dragpx(0) = dragpx (0) + dragpx (i)
         dragvx(0) = dragvx (0) + dragvx (i)
         dragx (0) = dragx  (0) + dragx  (i)
c
         dragpy(0) = dragpy (0) + dragpy (i)
         dragvy(0) = dragvy (0) + dragvy (i)
         dragy (0) = dragy  (0) + dragy  (i)
c
         dragpz(0) = dragpz (0) + dragpz (i)
         dragvz(0) = dragvz (0) + dragvz (i)
         dragz (0) = dragz  (0) + dragz  (i)
c
         torqpx(0) = torqpx (0) + torqpx (i)
         torqvx(0) = torqvx (0) + torqvx (i)
         torqx (0) = torqx  (0) + torqx  (i)
c
         torqpy(0) = torqpy (0) + torqpy (i)
         torqvy(0) = torqvy (0) + torqvy (i)
         torqy (0) = torqy  (0) + torqy  (i)
c
         torqpz(0) = torqpz (0) + torqpz (i)
         torqvz(0) = torqvz (0) + torqvz (i)
         torqz (0) = torqz  (0) + torqz  (i)
c
      enddo
c
      i0 = 0
      if (nobj.le.1) i0 = 1  ! one output for single-object case
c
      do i=i0,nobj
        if (nio.eq.0) then
          if (if3d.or.ifaxis) then
           if (ifdout) then
            write(6,6) istep,time,dragx(i),dragpx(i),dragvx(i),i,'dragx'
            write(6,6) istep,time,dragy(i),dragpy(i),dragvy(i),i,'dragy'
            write(6,6) istep,time,dragz(i),dragpz(i),dragvz(i),i,'dragz'
           endif
           if (iftout) then
            write(6,6) istep,time,torqx(i),torqpx(i),torqvx(i),i,'torqx'
            write(6,6) istep,time,torqy(i),torqpy(i),torqvy(i),i,'torqy'
            write(6,6) istep,time,torqz(i),torqpz(i),torqvz(i),i,'torqz'
           endif
          else
           if (ifdout) then
            write(6,6) istep,time,dragx(i),dragpx(i),dragvx(i),i,'dragx'
            write(6,6) istep,time,dragy(i),dragpy(i),dragvy(i),i,'dragy'
           endif
           if (iftout) then
            write(6,6) istep,time,torqz(i),torqpz(i),torqvz(i),i,'torqz'
           endif
          endif
        endif
    6   format(i8,1p4e19.11,2x,i5,a5)
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine comp_sij_cmt(sij,nij,ur,us,ut,vr,vs,vt,wr,ws,wt)
c                                       du_i       du_j
c     Compute the stress tensor S_ij := ----   +   ----
c                                       du_j       du_i
c
      include 'SIZE'
      include 'TOTAL'
c
      integer e
c
      real sij(lx1*ly1*lz1,nij,lelt)
      real ur (1) , us (1) , ut (1)
     $   , vr (1) , vs (1) , vt (1)
     $   , wr (1) , ws (1) , wt (1)

      real j ! Inverse Jacobian

      common /ICPVARS/ pvars(lx1,ly1,lz1,7)
      real             pvars

      n    = lx1-1      ! Polynomial degree
      nxyz = lx1*ly1*lz1

      if (if3d) then     ! 3D CASE
       do e=1,nelv
          call copy(pvars(1,1,1,1),vx(1,1,1,e),nxyz)
          call copy(pvars(1,1,1,2),vy(1,1,1,e),nxyz)
          call copy(pvars(1,1,1,3),vz(1,1,1,e),nxyz)
        call local_grad3(ur,us,ut,pvars,N,1,dxm1,dxtm1)
        call local_grad3(vr,vs,vt,pvars,N,2,dxm1,dxtm1)
        call local_grad3(wr,ws,wt,pvars,N,3,dxm1,dxtm1)

        do i=1,nxyz

         j = jacmi(i,e)

         sij(i,1,e) = j*  ! du/dx + du/dx
     $   2*(ur(i)*rxm1(i,1,1,e)+us(i)*sxm1(i,1,1,e)+ut(i)*txm1(i,1,1,e))

         sij(i,2,e) = j*  ! dv/dy + dv/dy
     $   2*(vr(i)*rym1(i,1,1,e)+vs(i)*sym1(i,1,1,e)+vt(i)*tym1(i,1,1,e))

         sij(i,3,e) = j*  ! dw/dz + dw/dz
     $   2*(wr(i)*rzm1(i,1,1,e)+ws(i)*szm1(i,1,1,e)+wt(i)*tzm1(i,1,1,e))

         sij(i,4,e) = j*  ! du/dy + dv/dx
     $   (ur(i)*rym1(i,1,1,e)+us(i)*sym1(i,1,1,e)+ut(i)*tym1(i,1,1,e) +
     $    vr(i)*rxm1(i,1,1,e)+vs(i)*sxm1(i,1,1,e)+vt(i)*txm1(i,1,1,e) )

         sij(i,5,e) = j*  ! dv/dz + dw/dy
     $   (wr(i)*rym1(i,1,1,e)+ws(i)*sym1(i,1,1,e)+wt(i)*tym1(i,1,1,e) +
     $    vr(i)*rzm1(i,1,1,e)+vs(i)*szm1(i,1,1,e)+vt(i)*tzm1(i,1,1,e) )

         sij(i,6,e) = j*  ! du/dz + dw/dx
     $   (ur(i)*rzm1(i,1,1,e)+us(i)*szm1(i,1,1,e)+ut(i)*tzm1(i,1,1,e) +
     $    wr(i)*rxm1(i,1,1,e)+ws(i)*sxm1(i,1,1,e)+wt(i)*txm1(i,1,1,e) )

        enddo
       enddo

      elseif (ifaxis) then  ! AXISYMMETRIC CASE  

c
c        Notation:                       ( 2  x  Acheson, p. 353)
c                     Cylindrical
c            Nek5k    Coordinates
c
c              x          z
c              y          r
c              z          theta
c

         do e=1,nelv
            call copy(pvars(1,1,1,1),vx(1,1,1,e),nxyz)
            call copy(pvars(1,1,1,2),vy(1,1,1,e),nxyz)
            call copy(pvars(1,1,1,3),vz(1,1,1,e),nxyz)
            call setaxdy ( ifrzer(e) )  ! change dytm1 if on-axis
            call local_grad2(ur,us,pvars,N,1,dxm1,dytm1)
            call local_grad2(vr,vs,pvars,N,2,dxm1,dytm1)
            call local_grad2(wr,ws,pvars,N,3,dxm1,dytm1)

            do i=1,nxyz
               j = jacmi(i,e)
               r = ym1(i,1,1,e)                              ! Cyl. Coord:

               sij(i,1,e) = j*  ! du/dx + du/dx              ! e_zz
     $           2*(ur(i)*rxm1(i,1,1,e)+us(i)*sxm1(i,1,1,e))

               sij(i,2,e) = j*  ! dv/dy + dv/dy              ! e_rr
     $           2*(vr(i)*rym1(i,1,1,e)+vs(i)*sym1(i,1,1,e))

               if (r.gt.0) then                              ! e_@@
                  sij(i,3,e) = pvars(i,1,1,1)/r  ! v / r 
               else
                  sij(i,3,e) = j*  ! L'Hopital's rule: e_@@ = dv/dr
     $            2*(vr(i)*rym1(i,1,1,e)+vs(i)*sym1(i,1,1,e))
               endif

               sij(i,4,e) = j*  ! du/dy + dv/dx             ! e_zr
     $            ( ur(i)*rym1(i,1,1,e)+us(i)*sym1(i,1,1,e) +
     $              vr(i)*rxm1(i,1,1,e)+vs(i)*sxm1(i,1,1,e) )

               if (yyyr.gt.0) then                             ! e_r@
                  sij(i,5,e) = j*  ! dw/dy 
     $              ( wr(i)*rym1(i,1,1,e)+ws(i)*sym1(i,1,1,e) )
     $              - pvars(i,1,1,3) / r
               else
                  sij(i,5,e) = 0
               endif

               sij(i,6,e) = j*  ! dw/dx                     ! e_@z
     $            ( wr(i)*rxm1(i,1,1,e)+ws(i)*sxm1(i,1,1,e) )

            enddo
         enddo

      else              ! 2D CASE

         do e=1,nelv
            call copy(pvars(1,1,1,1),vx(1,1,1,e),nxyz)
            call copy(pvars(1,1,1,2),vy(1,1,1,e),nxyz)
            call local_grad2(ur,us,pvars,N,1,dxm1,dxtm1)
            call local_grad2(vr,vs,pvars,N,2,dxm1,dxtm1)

            do i=1,nxyz
               j = jacmi(i,e)

               sij(i,1,e) = j*  ! du/dx + du/dx
     $           2*(ur(i)*rxm1(i,1,1,e)+us(i)*sxm1(i,1,1,e))

               sij(i,2,e) = j*  ! dv/dy + dv/dy
     $           2*(vr(i)*rym1(i,1,1,e)+vs(i)*sym1(i,1,1,e))

               sij(i,3,e) = j*  ! du/dy + dv/dx
     $           (ur(i)*rym1(i,1,1,e)+us(i)*sym1(i,1,1,e) +
     $            vr(i)*rxm1(i,1,1,e)+vs(i)*sxm1(i,1,1,e) )

            enddo
         enddo
      endif
      return
      end
c-----------------------------------------------------------------------

      SUBROUTINE SSTEST (ISSS)
C------------------------------------------------------------------------
C
C     Test if Steady State Solver should be activated.
C
C------------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'TSTEP'
      ISSS = 0
      IADV = 0
      DO 100 IFIELD=1,NFIELD
         IF (IFADVC(IFIELD)) IADV = 1
 100  CONTINUE
      IF (.NOT.IFTRAN.AND.(IADV.EQ.1)) ISSS = 1
      IF (ISSS.EQ.1.AND.NFIELD.GT.4.AND.NID.EQ.0) THEN
         WRITE (6,*) ' '
         WRITE (6,*) 'Trying to activate the steady state solver'
         WRITE (6,*) 'using NFIELD =',NFIELD
         WRITE (6,*) 'Maximum number of fields is 4'
         call exitt
      ENDIF
      RETURN
      END
C
      SUBROUTINE SSINIT (KMAX)
C-----------------------------------------------------------
C
C     Initialize steady state solver
C
C-----------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'EIGEN'
      INCLUDE 'TSTEP'
      INCLUDE 'STEADY'
C
      IFTRAN    = .TRUE.
      IFCHAR    = .TRUE.
      CTARG     = 3.
      IF (lx1.GE.10) THEN
         CTARG = 5.
      ENDIF
      CALL SETPROP
      TAUMIN = 1.E20
      MFIELD = 1
      IF (.NOT.IFFLOW) MFIELD=2
      DO 10 IFIELD=MFIELD,NFIELD
         DIFFUS = AVDIFF(IFIELD)/AVTRAN(IFIELD)
         TAUSS(IFIELD)  = 1./(EIGAA*DIFFUS)
         TXNEXT(IFIELD) = TAUSS(IFIELD)
         IF (TAUSS(IFIELD).LT.TAUMIN) TAUMIN = TAUSS(IFIELD)
 10   CONTINUE
C
      NBDINP    = 1.
      TIME      = 0.
      DT        = 0.
      DTINIT    = TAUMIN/5.
      NSTEPS    = 10000
      IOSTEP    = 10000
C
                   IFMODP = .TRUE.
                   IFSKIP = .TRUE.
                   NSSKIP = 1
C
                   PRELAX = 1.E-1
      IF (IFSPLIT) PRELAX = 1.E-4
C
                   IFSSVT = .FALSE.
                   IFEXVT = .FALSE.
C
                   KMAX   = 5
C
      CALL SETCHAR
C
C
      RETURN
      END
C
      SUBROUTINE CHKEXT (IFACCX,Z,S)
C------------------------------------------------------------------
C
C     Accept extrapolation?
C
C------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'TSTEP'
      INCLUDE 'INPUT'
      INCLUDE 'STEADY'
      LOGICAL IFACCX
      real*8 Z(1),S(1)
      REAL H1NRM1 (LDIMT1), H1NRM2(LDIMT1)
C
      CALL RZERO (H1NRM1,NFIELD)
      IF (IFFLOW) THEN
         IFIELD = 1
         CALL UNORM
         H1NRM1(IFIELD) = VNRMH1
      ENDIF
      DO 10 IFIELD=2,NFIELD
         CALL UNORM
         H1NRM1(IFIELD) = TNRMH1(IFIELD-1)
 10   CONTINUE
C
      CALL MKVEC (Z)
      CALL MKARR (S)
C
      CALL RZERO (H1NRM2,NFIELD)
      IF (IFFLOW) THEN
         IFIELD = 1
         CALL UNORM
         H1NRM2(IFIELD) = VNRMH1
      ENDIF
      DO 20 IFIELD=2,NFIELD
         CALL UNORM
         H1NRM2(IFIELD) = TNRMH1(IFIELD-1)
 20   CONTINUE
C
      XLIM   = .2
      IFACCX = .TRUE.
      RDMAX  = 0.
      RDLIM  = .5*TOLREL+1.E-4
      IF (IFFLOW) THEN
         IFIELD = 1
         RDIFF = ABS((H1NRM2(IFIELD)-H1NRM1(IFIELD))/H1NRM1(IFIELD))
         IF (RDIFF.GT.RDMAX) RDMAX = RDIFF
         IF (NIO.EQ.0) WRITE (6,*) ' ifield, rdiff ',ifield,rdiff
         IF (RDIFF.GT.XLIM) IFACCX = .FALSE.
      ENDIF
      DO 100 IFIELD=2,NFIELD
         RDIFF = ABS((H1NRM2(IFIELD)-H1NRM1(IFIELD))/H1NRM1(IFIELD))
         IF (RDIFF.GT.RDMAX) RDMAX = RDIFF
         IF (NIO.EQ.0) WRITE (6,*) ' ifield, rdiff ',ifield,rdiff
         IF (RDIFF.GT.XLIM) IFACCX = .FALSE.
 100  CONTINUE
C
      IF (.NOT.IFACCX) THEN
          IF (NIO.EQ.0) THEN
             WRITE (6,*) ' '
             write (6,*) 'Extrapolation attempt rejected'
             write (6,*) ' '
          ENDIF
          CALL MKARR (Z)
      ELSE
          IF (NIO.EQ.0) THEN
             write (6,*)  ' '
             write (6,*) 'Extrapolation accepted'
             write (6,*) ' '
          ENDIF
          IF (RDMAX.LT.RDLIM) IFSSVT = .TRUE.
          CALL FILLLAG
      ENDIF
C
      RETURN
      END
C
      SUBROUTINE FILLLAG
      INCLUDE 'SIZE'
      INCLUDE 'SOLN'
      INCLUDE 'INPUT'
      INCLUDE 'TSTEP'
      NBDINP = 3
      IF (IFFLOW) THEN
         CALL LAGVEL
         CALL LAGVEL
      ENDIF
      IF (IFHEAT) THEN
         DO 100 IFIELD=2,NFIELD
            CALL LAGSCAL
            CALL LAGSCAL
 100     CONTINUE
      ENDIF
      RETURN
      END
C
      SUBROUTINE GONSTEP (N,ITEST)
C----------------------------------------------------------------
C
C     Do N steps; return if steady state
C
C----------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'STEADY'
      EXTERNAL GOSTEP
C
      DO 1000 JSTEP=1,N
         IF (ITEST.EQ.0.AND.IFSSVT) GOTO 1001
         IF (ITEST.EQ.1.AND.(IFSSVT.OR.IFEXVT)) GOTO 1001
         CALL GOSTEP
 1000 CONTINUE
 1001 CONTINUE
C
      RETURN
      END
C
      SUBROUTINE GO1STEP (X,Y,NVEC)
C----------------------------------------------------------------
C
C     Advance one (or more) time step(s)
C
C----------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'TOTAL'
      real*8 X(1), Y(1)
C
      CALL MKARR (X)
      IF (.NOT.IFSKIP) NJSTEP=1
      IF (     IFSKIP) NJSTEP=NSSKIP
C
      DO 9000 JSTEP=1,NJSTEP
C
      ISTEP = ISTEP+1
      CALL SETTIME
      CALL SETPROP
      IF (IFMODP) CALL MODPROP 
      CALL SETSOLV
      CALL COMMENT
      DO 100 IGEOM=1,2
         IF (IFGEOM) THEN
            CALL GENGEOM (IGEOM)
            CALL GENEIG  (IGEOM)
         ENDIF
         IF (IFFLOW) CALL FLUID (IGEOM)
         IF (IFHEAT) CALL HEAT  (IGEOM)
         IF (IFMVBD) CALL MESHV (IGEOM)
 100  CONTINUE
      CALL PREPOST(.false.)
      CALL USERCHK
C
 9000 CONTINUE
C
      IF (ISTEP.GT.1) CALL CHKSSVT
      CALL MKVEC (Y)
C
      RETURN
      END
C
      SUBROUTINE GOSTEP 
C----------------------------------------------------------------
C
C     Advance one (or more) time step(s)
C
C----------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'TOTAL'
C
      IF (.NOT.IFSKIP) NJSTEP=1
      IF (     IFSKIP) NJSTEP=NSSKIP
C
      DO 9000 JSTEP=1,NJSTEP
C
      ISTEP = ISTEP+1
      CALL SETTIME
      CALL SETPROP
      IF (IFMODP) CALL MODPROP 
      CALL SETSOLV
      CALL COMMENT
      DO 100 IGEOM=1,2
         IF (IFGEOM) THEN
            CALL GENGEOM (IGEOM)
            CALL GENEIG  (IGEOM)
         ENDIF
         IF (IFFLOW) CALL FLUID (IGEOM)
         IF (IFHEAT) CALL HEAT  (IGEOM)
         IF (IFMVBD) CALL MESHV (IGEOM)
 100  CONTINUE
      CALL PREPOST(.false.)
      CALL USERCHK
C
 9000 CONTINUE
C
      IF (ISTEP.GT.1) CALL CHKSSVT
C
      RETURN
      END
C
      SUBROUTINE MODPROP
C------------------------------------------------------------------
C
C     Modify the properties
C
C------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'SOLN'
      INCLUDE 'TSTEP'
      INCLUDE 'STEADY'
      INCLUDE 'INPUT'
C
      MFIELD=1
      IF (.NOT.IFFLOW) MFIELD=2
      DO 100 IFIELD=MFIELD,NFIELD
         NTOT  = lx1*ly1*lz1*NELFLD(IFIELD)
         TAU   = .02*TAUSS(IFIELD)
         DECAY = 1.+99.*EXP(-TIME/TAU)
         CALL CMULT (VDIFF(1,1,1,1,IFIELD),DECAY,NTOT)
c         if (nid.eq.0)
c     $   write (6,*) '.......... diff = ',IFIELD,vdiff(1,1,1,1,IFIELD)
 100  CONTINUE
C
      RETURN
      END
C
      SUBROUTINE MKVEC (X)
C-------------------------------------------------------------
C
C     Fill up the vector X with VX, VY, ....
C
C-------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'SOLN'
      INCLUDE 'INPUT'
      INCLUDE 'TSTEP'
      real*8 X(1)
C
      NTOTV = lx1*ly1*lz1*NELV
C
      IF (IFFLOW) THEN
         DO 100 I=1,NTOTV
            X(I) = VX(I,1,1,1)
 100     CONTINUE
         DO 200 I=1,NTOTV
            X(I+NTOTV) = VY(I,1,1,1)
 200     CONTINUE
         IF (ldim.EQ.3) THEN
            IOFF = 2*NTOTV
            DO 300 I=1,NTOTV
               X(I+IOFF) = VZ(I,1,1,1)
 300        CONTINUE
         ENDIF
      ENDIF
C
      IF (IFHEAT) THEN
         IOFF = ldim*NTOTV
         DO 401 IFIELD=2,NFIELD
            NTOT = lx1*ly1*lz1*NELFLD(IFIELD)
            DO 400 I=1,NTOT
               X(I+IOFF) = T(I,1,1,1,IFIELD-1)
 400        CONTINUE
            IOFF = IOFF+NTOT
 401     CONTINUE
      ENDIF
C
      RETURN
      END
C
      SUBROUTINE MKARR (X)
C------------------------------------------------------------------
C
C     Split the vector X into VX, VY, .....
C
C------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'SOLN'
      INCLUDE 'TSTEP'
      INCLUDE 'INPUT'
      real*8 X(1)
C
      NTOTV = lx1*ly1*lz1*NELV
C
      IF (IFFLOW) THEN
         DO 10 I=1,NTOTV
            VX(I,1,1,1) = X(I)
 10      CONTINUE
         DO 20 I=1,NTOTV
            VY(I,1,1,1) = X(I+NTOTV)
 20      CONTINUE
         IF (ldim.EQ.3) THEN
            IOFF = 2*NTOTV
            DO 30 I=1,NTOTV
               VZ(I,1,1,1) = X(I+IOFF)
 30         CONTINUE
         ENDIF
      ENDIF
C
      IF (IFHEAT) THEN
         IOFF = ldim*NTOTV
         DO 41 IFIELD=2,NFIELD
            NTOT = lx1*ly1*lz1*NELFLD(IFIELD)
            DO 40 I=1,NTOT
               T(I,1,1,1,IFIELD-1) = X(I+IOFF)
 40         CONTINUE
            IOFF = IOFF+NTOT
 41      CONTINUE
      ENDIF
C
      RETURN
      END
C
      SUBROUTINE SSPARAM (KMAX,L)
C------------------------------------------------------------------------------
C
C     Set steady state parameters
C
C------------------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'TSTEP'
      INCLUDE 'INPUT'
      INCLUDE 'STEADY'
C
      IF (L.EQ.0) THEN
         CALL SSINIT (KMAX)
      ELSEIF (L.EQ.1) THEN
         ISTEP  = 0
C
         PRELAX = 1.E-2
         IF (IFSPLIT) PRELAX = 1.E-5
C
         CTARG  = 1.
         IF (IFSPLIT) CTARG  = 1.
         IF (lx1.GE.10) THEN
             CTARG  = 2.
             IF (IFSPLIT) CTARG = 2.
         ENDIF
C
         KMAX   = 5
         NBDINP = 3
         NSSKIP = 2
         IFSKIP = .TRUE.
         IFMODP = .FALSE.
C
      ELSEIF (L.EQ.2) THEN
C
         PRELAX = 1.E-3
         IF (IFSPLIT) PRELAX = 1.E-5
C
         CTARG = 1.
         IF (IFSPLIT) CTARG = 1.
         IF (lx1.GE.10) THEN
            CTARG = 2.
            IF (IFSPLIT) CTARG = 2.
         ENDIF
C
         KMAX   = 5
         NBDINP = 3
         NSSKIP = 2
         IFSKIP = .TRUE.
         IFMODP = .FALSE.
C
      ELSE
      ENDIF
      CALL SETCHAR
      RETURN
      END
C
      SUBROUTINE CHKSSVT
C-----------------------------------------------------------------------
C
C     Check for global steady state (velocity and temp/passive scalar)
C
C-----------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'TSTEP'
      INCLUDE 'STEADY'
C
      IF (IFFLOW) THEN
         IMESH  = 1
         IFIELD = 1
         CALL CHKSSV
      ENDIF
C
      IMESH = 2
      DO 100 IFIELD=2,NFIELD
         CALL CHKSST
 100  CONTINUE
C
      IFSSVT = .TRUE.
      IFEXVT = .TRUE.
      MFIELD = 1
      IF (.NOT.IFFLOW) MFIELD=2
      DO 200 IFIELD=MFIELD,NFIELD
         IF(.NOT.IFSTST(IFIELD)) IFSSVT = .FALSE.
         IF(.NOT.IFEXTR(IFIELD)) IFEXVT = .FALSE.
 200  CONTINUE
      RETURN
      END
C
      SUBROUTINE CHKSSV
C--------------------------------------------------------------------
C
C     Check steady state for velocity
C 
C--------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'SOLN'
      INCLUDE 'MASS'
      INCLUDE 'INPUT'
      INCLUDE 'EIGEN'
      INCLUDE 'TSTEP'
      INCLUDE 'STEADY'
      COMMON /CTOLPR/ DIVEX
      COMMON /CPRINT/ IFPRINT
      LOGICAL         IFPRINT
C
      COMMON /SCRSS2/ DV1 (LX1,LY1,LZ1,LELV)
     $ ,              DV2 (LX1,LY1,LZ1,LELV)
     $ ,              DV3 (LX1,LY1,LZ1,LELV)
      COMMON /SCRUZ/  W1  (LX1,LY1,LZ1,LELV)
     $ ,              W2  (LX1,LY1,LZ1,LELV)
     $ ,              W3  (LX1,LY1,LZ1,LELV)
     $ ,              BDIVV(LX2,LY2,LZ2,LELV)
      COMMON /SCRMG/  T1  (LX1,LY1,LZ1,LELV)
     $ ,              T2  (LX1,LY1,LZ1,LELV)
     $ ,              T3  (LX1,LY1,LZ1,LELV)
     $ ,              DIVV(LX2,LY2,LZ2,LELV)
      COMMON /SCRVH/  H1  (LX1,LY1,LZ1,LELV)
     $ ,              H2  (LX1,LY1,LZ1,LELV)
C
      CALL OPSUB3 (DV1,DV2,DV3,VX,VY,VZ,VXLAG,VYLAG,VZLAG)
      CALL NORMVC (DVNNH1,DVNNSM,DVNNL2,DVNNL8,DV1,DV2,DV3)
      INTYPE = -1
      CALL SETHLM (H1,H2,INTYPE)
      CALL OPHX   (W1,W2,W3,DV1,DV2,DV3,H1,H2)
      CALL OPDSSUM(W1,W2,W3)
      CALL OPMASK (W1,W2,W3)
      CALL OPCOLV3(T1,T2,T3,W1,W2,W3,BINVM1)
      CALL OPHX   (W1,W2,W3,T1,T2,T3,H1,H2)
      CALL OPCOL2 (W1,W2,W3,DV1,DV2,DV3)
      NTOT1  = lx1*ly1*lz1*NELV
      USNRM1 = GLSUM(W1,NTOT1)
      USNRM2 = GLSUM(W2,NTOT1)
      USNRM3 = 0.
      IF (ldim.EQ.3) USNRM3 = GLSUM(W3,NTOT1)
      USNORM = SQRT( (USNRM1+USNRM2+USNRM3)/VOLVM1 )
C
      NTOT2 = lx2*ly2*lz2*NELV
      CALL OPDIV (BDIVV,VX,VY,VZ)
      CALL COL3 (DIVV,BDIVV,BM2INV,NTOT2)
      DNORM = SQRT(GLSC2(DIVV,BDIVV,NTOT2)/VOLVM2)
C
      TOLOLD = TOLPS
      CALL SETTOLV
      TOLHV3 = TOLHV*(ldim)
      IF (IFSTRS) TOLHV3 = TOLHV
      IF (NIO.EQ.0 .AND. IFPRINT) THEN
         WRITE (6,*) 'USNORM, TOLHV',USNORM,TOLHV3
         WRITE (6,*) 'DNORM, TOLPS',DNORM,TOLPS
      ENDIF
      IF (DNORM.GT.(1.1*DIVEX).AND.DIVEX.GT.0.
     $                        .AND.TOLPDF.EQ.0.) TOLPDF = 5.*DNORM
      USREL = USNORM/TOLHV3
      DREL  = DNORM/TOLPS
C
      IF (TOLREL.GT.0.) THEN
         EXFAC = .3/TOLREL
      ELSE
         WRITE (6,*) 'WARNING: TOLREL=0. Please modify *.rea'
         call exitt
      ENDIF
      IFEXTR(IFIELD) = .FALSE.
c      IF ((USREL.LT.EXFAC).OR.(TIME.GT.TXNEXT(IFIELD))) 
c     $                                       IFEXTR(IFIELD) = .TRUE.
      IF (USREL.LT.EXFAC)                    IFEXTR(IFIELD) = .TRUE.
      if (nio.eq.0 .and. ifprint)
     $WRITE (6,*) 'Tau, Txnext ',IFIELD,tauss(ifield),txnext(ifield)
C
      IFSTST(IFIELD) = .FALSE.
      USLIM = 2.*TOLHV3
      DLIM  = 2.*TOLPS
      IF (USNORM.LT.USLIM.AND.DNORM.LT.DLIM .AND. .NOT.IFSPLIT) 
     $                                       IFSTST(IFIELD) = .TRUE.
      IF (USNORM.LT.USLIM .AND. IFSPLIT) 
     $                                       IFSTST(IFIELD) = .TRUE.
C
      RETURN
      END
C
      SUBROUTINE CHKSST 
C----------------------------------------------------------------------
C
C     Check for steady state for temperature/passive scalar
C
C----------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'SOLN'
      INCLUDE 'MASS'
      INCLUDE 'TSTEP'
      INCLUDE 'STEADY'
      COMMON /SCRUZ/  DELTAT (LX1,LY1,LZ1,LELT)
     $ ,              WA     (LX1,LY1,LZ1,LELT)
     $ ,              WB     (LX1,LY1,LZ1,LELT)
      COMMON /SCRVH/  H1     (LX1,LY1,LZ1,LELT)
     $ ,              H2     (LX1,LY1,LZ1,LELT)
      COMMON /CPRINT/ IFPRINT
      LOGICAL         IFPRINT
C
      NTOT = lx1*ly1*lz1*NELT
      CALL SUB3 (DELTAT(1,1,1,1),T(1,1,1,1,IFIELD-1),
     $                           TLAG(1,1,1,1,1,IFIELD-1),NTOT)
      CALL NORMSC (DVNNH1,DVNNSM,DVNNL2,DVNNL8,DELTAT,IMESH)
      INTYPE = -1
      ISD    = 1
      CALL SETHLM (H1,H2,INTYPE)
      CALL AXHELM (WA,DELTAT,H1,H2,IMESH,ISD)
      CALL DSSUM  (WA,lx1,ly1,lz1)
      CALL COL2   (WA,TMASK(1,1,1,1,IFIELD-1),NTOT)
      CALL COL3   (WB,WA,BINTM1,NTOT)
      CALL AXHELM (WA,WB,H1,H2,IMESH,ISD)
      CALL COL2   (WA,DELTAT,NTOT)
      USNORM = SQRT(GLSUM(WA,NTOT)/VOLTM1)
C
      CALL SETTOLT
      IF (NIO.EQ.0 .AND. IFPRINT) 
     $WRITE (6,*) 'USNORM, TOLHT',USNORM,TOLHT(IFIELD)
      USREL = USNORM/TOLHT(IFIELD)
C
      IF (TOLREL.GT.0.) THEN
         EXFAC = .3/TOLREL
      ELSE
         WRITE (6,*) 'WARNING: TOLREL=0. Please modify *.rea'
         call exitt
      ENDIF
      IFEXTR(IFIELD) = .FALSE.
c      IF ((USREL.LT.EXFAC).OR.(TIME.GT.TXNEXT(IFIELD))) 
c     $                     IFEXTR(IFIELD) = .TRUE.
      IF (USREL.LT.EXFAC)  IFEXTR(IFIELD) = .TRUE.
      IF(NIO.EQ.0 .AND. IFPRINT) 
     $WRITE (6,*) 'Tau, Txnext ',IFIELD,tauss(ifield),txnext(ifield)
C
      IFSTST(IFIELD) = .FALSE.
      USLIM = 2.*TOLHT(IFIELD)
      IF (USNORM.LT.USLIM) IFSTST(IFIELD) = .TRUE.
C
      RETURN
      END
C
      SUBROUTINE SSNORMD (DV1,DV2,DV3)
      INCLUDE 'SIZE'
      INCLUDE 'MASS'
      INCLUDE 'TSTEP'
      INCLUDE 'STEADY'
      REAL DV1(1),DV2(1),DV3(1)
      CALL NORMVC (DVDFH1,DVDFSM,DVDFL2,DVDFL8,DV1,DV2,DV3)
      RETURN
      END
C
      SUBROUTINE SSNORMP (DV1,DV2,DV3)
      INCLUDE 'SIZE'
      INCLUDE 'TSTEP'
      INCLUDE 'STEADY'
      REAL DV1(1),DV2(1),DV3(1)
      CALL NORMVC (DVPRH1,DVPRSM,DVPRL2,DVPRL8,DV1,DV2,DV3)
      RETURN
      END
C
      SUBROUTINE SETTOLV
C-------------------------------------------------------------------
C
C     Set tolerances for velocity solver
C
C-------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'EIGEN'
      INCLUDE 'MASS'
      INCLUDE 'TSTEP'
      INCLUDE 'SOLN'
      REAL LENGTH
C
      NTOT   = lx1*ly1*lz1*NELFLD(IFIELD)
      AVVISC = GLMIN(VDIFF(1,1,1,1,IFIELD),NTOT)
      AVDENS = GLMAX(VTRANS(1,1,1,1,IFIELD),NTOT)
C
      IF (IFTRAN) THEN
         IF (ISTEP.EQ.1)  VNORM = VNRML8
         IF (ISTEP.GT.1)  VNORM = VNRMSM
         IF (VNORM.EQ.0.) VNORM = TOLABS
         FACTOR = 1.+(AVDENS/(EIGAA*AVVISC*DT))
      ELSE
         VNORM = VNRML8
         IF (VNORM.EQ.0.) VNORM = TOLABS
         FACTOR = 1.
      ENDIF
C
      TOLPS  = TOLREL*VNORM * SQRT(EIGAS)/(4.*FACTOR) 
      TOLHV  = TOLREL*VNORM * SQRT(EIGAA)*AVVISC/2.
      TOLHV  = TOLHV/3.
      IF (.NOT.IFTRAN .AND. .NOT.IFNAV) TOLHV = TOLHV/10.
      TOLHR  = TOLHV
      TOLHS  = TOLHV
C
C     Non-zero default pressure tolerance
C     NOTE: This tolerance may change due to precision problems.
C           See subroutine CHKSSV
C
      IF (TOLPDF.NE.0.) TOLPS = TOLPDF
C
      RETURN
      END
C
      SUBROUTINE SETTOLT
C-------------------------------------------------------------------
C
C     Set tolerances for temerature/passive scalar solver
C
C-------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'EIGEN'
      INCLUDE 'MASS'
      INCLUDE 'TSTEP'
      INCLUDE 'SOLN'
      REAL LENGTH
C
      NTOT   = lx1*ly1*lz1*NELFLD(IFIELD)
      AVCOND = GLMIN (VDIFF(1,1,1,1,IFIELD),NTOT)
C
      IF (IFTRAN) THEN
         IF (ISTEP.EQ.1)  TNORM = TNRML8(IFIELD-1)
         IF (ISTEP.GT.1)  TNORM = TNRMSM(IFIELD-1)
         IF (TNORM.EQ.0.) TNORM = TOLABS
      ELSE
         TNORM = TNRML8(IFIELD-1)
         IF (TNORM.EQ.0.) TNORM = TOLABS
      ENDIF
C
      TOLHT(IFIELD) = TOLREL*TNORM * SQRT(EIGAA)*AVCOND
C
      RETURN
      END
C
      SUBROUTINE CHKTOLP (TOLMIN)
      INCLUDE 'SIZE'
      INCLUDE 'SOLN'
      INCLUDE 'MASS'
      INCLUDE 'TSTEP'
      COMMON /SCRMG/ DIVFLD (LX2,LY2,LZ2,LELV)
     $ ,             WORK   (LX2,LY2,LZ2,LELV)
      NTOT2 = lx2*ly2*lz2*NELV
      CALL OPDIV   (DIVFLD,VX,VY,VZ)
      CALL COL3    (WORK,DIVFLD,BM2INV,NTOT2)
      CALL COL2    (WORK,DIVFLD,NTOT2)
      DIVV  = SQRT(GLSUM(WORK,NTOT2)/VOLVM2)
C
      IFIELD = 1
      CALL SETTOLV
      TOLMIN = DIVV/100.
      IF (TOLMIN.LT.TOLPS) TOLMIN = TOLPS
      RETURN
      END
C
      SUBROUTINE SETCHAR
C-----------------------------------------------------------------------
C
C     If characteristics, need number of sub-timesteps (DT/DS).
C     Current sub-timeintegration scheme: RK4.
C     If not characteristics, i.e. standard semi-implicit scheme,
C     check user-defined Courant number.
C
C----------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'TSTEP'

      REAL MAX_CFL_RK4
      DATA MAX_CFL_RK4 /2.0/ ! stability limit for RK4 including safety factor
C
      IF (IFCHAR) THEN
         ICT    = MAX(INT(CTARG/MAX_CFL_RK4),1)
         NTAUBD = ICT
         DCT    = CTARG - ICT*MAX_CFL_RK4
         IF (DCT.GT.0.1) NTAUBD = NTAUBD+1
         IF (NIO.EQ.0) write(6,*) 'RK4 substeps:', ntaubd 
      ELSE
         NTAUBD = 0
         IF (CTARG.GT.0.5) THEN
            IF (NIO.EQ.0)
     $      WRITE (6,*) 'Reset the target Courant number to .5'
            CTARG = 0.5
         ENDIF
      ENDIF
C
      RETURN
      END
C
      SUBROUTINE PROJECT
C--------------------------------------------------------------------
C
C     Project current solution onto the closest incompressible field
C
C--------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'TOTAL'
      COMMON /SCRNS/ W1    (LX1,LY1,LZ1,LELV)
     $ ,             W2    (LX1,LY1,LZ1,LELV)
     $ ,             W3    (LX1,LY1,LZ1,LELV)
     $ ,             DV1   (LX1,LY1,LZ1,LELV)
     $ ,             DV2   (LX1,LY1,LZ1,LELV)
     $ ,             DV3   (LX1,LY1,LZ1,LELV)
     $ ,             RESPR (LX2,LY2,LZ2,LELV)
      COMMON /SCRVH/ H1    (LX1,LY1,LZ1,LELV)
     $ ,             H2    (LX1,LY1,LZ1,LELV)
C
      IF (NIO.EQ.0) WRITE(6,5)
    5 FORMAT(/,'  Project',/)
C
      NTOT1  = lx1*ly1*lz1*NELV
      NTOT2  = lx2*ly2*lz2*NELV
      INTYPE = 1
      CALL RZERO   (H1,NTOT1)
      CALL RONE    (H2,NTOT1)
      CALL OPDIV   (RESPR,VX,VY,VZ)
      CALL CHSIGN  (RESPR,NTOT2)
      CALL ORTHO   (RESPR)
      CALL UZAWA   (RESPR,H1,H2,INTYPE,ICG)
      CALL OPGRADT (W1,W2,W3,RESPR)
      CALL OPBINV  (DV1,DV2,DV3,W1,W2,W3,H2)
      CALL OPADD2  (VX,VY,VZ,DV1,DV2,DV3)
      RETURN
      END

c---------------------------------------------------------------------
      subroutine filter_cmtvar(continuous)
      include 'SIZE'
      include 'INPUT'
      include 'WZ'
      include 'DEALIAS'
      include 'CMTDATA'

      common /CMTFILTERS/  intv(lx1,lx1),intt(lx1,lx1)
     $                  ,  intvd(lxd,lxd),inttd(lxd,lxd)
     $                  ,  wk1(lx1,lx1,lz1),wk2(lx1,lx1,lz1)
     $                  ,  wkd1(lxd,lxd,lzd),wkd2(lxd,lxd,lzd)
      real                 intv, intt, intvd, inttd
!     real ::  intv(lx1,lx1),intt(lx1,lx1)

      real zgmd(lxd),wxmd(lxd)
      logical continuous
c     declare ncut and wght are declared in input
c     ncut is param(101) 
      integer icalld
      save    icalld
      data    icalld /0/


c     write(6,*)'Enter filter subroutine'
      if (icalld.eq.0) then
         icalld = 1
         if (continuous) then ! use existing nek5000 code in a
                              ! manner similar to nek5000
            if(nio.eq.0)  
     $         write(6,*)'Build new filter with bubble functions'
            call userfilt_bubble(intv,zgm1,lx1,nio)
c           call build_new_filter(intv,zgm1,lx1,ncut,wght,nio)
c           if (lx1.eq.lxd)then
c              nxyz = lxd*lyd*lzd
c              if(nio.eq.0) write(6,*)'Copy newly built filter built'
c              call copy(intvd,intv,nxyz)
c           else
c              if(nio.eq.0)write(6,*)'build new filter with',ncutd,wghtd
c              call zwgll(zgmd,wxmd,lxd)
c              call build_new_filter(intvd,zgmd,lxd,ncutd,wghtd,nio)
c           endif
c           do i=1,lx1*lx1
c              if(nio.eq.0) write(669,*)'filter',intv(i,1)
c           enddo
         else ! dg filter using Legendre basis instead of Lk-Lkm2
            if(nio.eq.0)  
     $         write(6,*)'Build new filter with Legendre basis'
            call userfilt(intv,zgm1,lx1,nio)
         endif
      endif

      call filtercv(intv,lx1,lz1,wk1,wk2,intt,if3d,u1max)

      return
      end
c---------------------------------------------------------------------

      subroutine filtercv(f,nx,nz,w1,w2,ft,if3d,dmax)
c     taken from filterq in navier5.f
      include 'SIZE'
      include 'TSTEP'
    
      COMMON /solnconsvar/ U(LX1,LY1,LZ1,TOTEQ,lelt) 
      logical if3d
c
      real w1(1),w2(1)
c
      real f(nx,nx),ft(nx,nx)
      integer e,eq

      call transpose(ft,nx,f,nx)
c
      nxyz=nx*nx*nz
      dmax = 0.


c     nel = nelfld(ifield)


      if (if3d) then
         do e=1,nelv
            do eq=1,toteq
c              Filter
               call copy(w2,u(1,1,1,eq,e),nxyz)
               call mxm(f,nx,w2,nx,w1,nx*nx)
               i=1
               j=1
               do k=1,nx
                  call mxm(w1(i),nx,ft,nx,w2(j),nx)
                  i = i+nx*nx
                  j = j+nx*nx
               enddo
               call mxm (w2,nx*nx,ft,nx,w1,nx)
               call sub3(w2,u(1,1,1,eq,e),w1,nxyz)
               call copy(u(1,1,1,eq,e),w1,nxyz)
               smax = vlamax(w2,nxyz)
               dmax = max(dmax,abs(smax))
            enddo
         enddo
c
      else
         do e=1,nelv
            do eq=1,toteq
c              Filter
               call copy(w1,u(1,1,1,eq,e),nxyz)
               call mxm(f,nx,w1,nx,w2,nx)
               call mxm(w2,nx,ft,nx,w1,nx)
c
               call sub3(w2,u(1,1,1,eq,e),w1,nxyz)
               call copy(u(1,1,1,eq,e),w1,nxyz)
               smax = vlamax(w2,nxyz)
               dmax = max(dmax,abs(smax))
            enddo
         enddo
      endif
c
      return
      end

!---------------------------------------------------------------------

      subroutine userfilt_bubble(intv,zpts,nx,nio)

!     This routing builds a 1D filter with a transfer function that
!     will be specified from the .usr file. Variables are projected on
!     to the space defined by bubble functions. 

      real intv(nx,nx),zpts(nx)
c
      parameter (lm=84)
      parameter (lm2=lm*lm)
      real      phi(lm2),pht(lm2),diag(lm2),rmult(lm),Lj(lm)
      integer   indr(lm),indc(lm),ipiv(lm)
c
      if (nx.gt.lm) then
        if(nio.eq.0) write(6,*) 'ABORT in build_new_filter:',nx,lm
         call exitt
      endif
c
      kj = 0
      n  = nx-1
      do j=1,nx
         z = zpts(j)
         call legendre_poly(Lj,z,n)
         kj = kj+1
         pht(kj) = Lj(1)
         kj = kj+1
         pht(kj) = Lj(2)
         do k=3,nx
            kj = kj+1
            pht(kj) = Lj(k)-Lj(k-2)
         enddo
      enddo
      call transpose (phi,nx,pht,nx)
      call copy      (pht,phi,nx*nx)
      call gaujordf  (pht,nx,nx,indr,indc,ipiv,ierr,rmult)
c
c     Set up transfer function

      call cmt_usrflt(rmult)
      call ident   (diag,nx)

      do k=1,nx
         amp=rmult(k)
         if (amp .ne. 1.0) then
            kk = k+nx*(k-1)
            diag(kk) = amp
         endif
      enddo

      call mxm  (diag,nx,pht,nx,intv,nx)      !          -1
      call mxm  (phi ,nx,intv,nx,pht,nx)      !     V D V
      call copy (intv,pht,nx*nx)

      do k=1,nx*nx
         pht(k) = 1.-diag(k)
      enddo
      np1 = nx+1
      if (nio.eq.0) then
         write(6,6) 'filt amp',(pht (k),k=1,nx*nx,np1)
         write(6,6) 'filt trn',(diag(k),k=1,nx*nx,np1)
   6     format(a8,16f7.4,6(/,8x,16f7.4))
      endif

      return
      end
!---------------------------------------------------------------------

      subroutine userfilt(intv,zpts,nx,nio)

!     This routing builds a 1D filter with a transfer function that
!     will be specified from the .usr file. DG ONLY as a Legendre basis
!     means endpoints are affected!

      real intv(nx,nx),zpts(nx)
c
      parameter (lm=84)
      parameter (lm2=lm*lm)
      real      phi(lm2),pht(lm2),diag(lm2),rmult(lm),Lj(lm)
      integer   indr(lm),indc(lm),ipiv(lm)
c
      if (nx.gt.lm) then
        if(nio.eq.0) write(6,*) 'ABORT in build_new_filter:',nx,lm
         call exitt
      endif
c
      kj = 0
      n  = nx-1
      do j=1,nx
         z = zpts(j)
         call legendre_poly(Lj,z,n)
         do k=1,nx
            kj = kj+1
            pht(kj) = Lj(k)
         enddo
      enddo
      call transpose (phi,nx,pht,nx)
      call copy      (pht,phi,nx*nx)
      call gaujordf  (pht,nx,nx,indr,indc,ipiv,ierr,rmult)
c
c     Set up transfer function

      call cmt_usrflt(rmult)
      call ident   (diag,nx)

      do k=1,nx
         amp=rmult(k)
         if (amp .ne. 1.0) then
            kk = k+nx*(k-1)
            diag(kk) = amp
         endif
      enddo

      call mxm  (diag,nx,pht,nx,intv,nx)      !          -1
      call mxm  (phi ,nx,intv,nx,pht,nx)      !     V D V
      call copy (intv,pht,nx*nx)

      do k=1,nx*nx
         pht(k) = 1.-diag(k)
      enddo
      np1 = nx+1
      if (nio.eq.0) then
         write(6,6) 'filt amp',(pht (k),k=1,nx*nx,np1)
         write(6,6) 'filt trn',(diag(k),k=1,nx*nx,np1)
   6     format(a8,16f7.4,6(/,8x,16f7.4))
      endif

      return
      end

#define INTP_HMAX 20

c-----------------------------------------------------------------------
      subroutine interp_setup(ih,tolin,nmsh,nelm)
c
c input:
c tolin ... tolerance newton solve (use 0 for default)
c nmsh  ... polynomial order for mesh (use 0 to fallback to lx1-1)
c nelm  ... number of local mesh elements (typically nelt) 
c 
c output:
c ih    ... handle
c

      include 'SIZE'
      include 'INPUT'
      include 'GEOM'

      common /nekmpi/ nidd,npp,nekcomm,nekgroup,nekreal

      common /intp_h/ ih_intp(2,INTP_HMAX)
      common /intp/   tol

      data ihcounter /0/
      save ihcounter

      real xmi, ymi, zmi
      common /CBXMI/ xmi(lx1*ly1*lz1*lelt),
     $               ymi(lx1*ly1*lz1*lelt),
     $               zmi(lx1*ly1*lz1*lelt)
 
      real w(2*lx1**3)

      tol = max(5e-13,tolin)
      npt_max = 128
      bb_t    = 0.01

      if (nio.eq.0) 
     $   write(6,*) 'call intp_setup ','tol=', tol

      if (nmsh.ge.1 .and. nmsh.lt.lx1-1) then
         if (nio.eq.0) write(6,*) 'Nmsh for findpts:',nmsh
         nxi = nmsh+1
         nyi = nxi
         nzi = 1
         if (if3d) nzi = nxi
         do ie = 1,nelm
           call map_m_to_n(xmi((ie-1)*nxi*nyi*nzi + 1),nxi,xm1(1,1,1,ie)
     $                     ,lx1,if3d,w,size(w))
           call map_m_to_n(ymi((ie-1)*nxi*nyi*nzi + 1),nyi,ym1(1,1,1,ie)
     $                     ,ly1,if3d,w,size(w))
           if (if3d) 
     $     call map_m_to_n(zmi((ie-1)*nxi*nyi*nzi + 1),nzi,zm1(1,1,1,ie)
     $                     ,lz1,if3d,w,size(w))
         enddo

         n = nelm*nxi*nyi*nzi 
         call fgslib_findpts_setup(ih_intp1,nekcomm,npp,ldim,
     &                             xm1,ym1,zm1,nx1,ny1,nz1,
     &                             nelm,nx1,ny1,nz1,bb_t,nelm+2,nelm+2,
     &                             npt_max,tol)

         call fgslib_findpts_setup(ih_intp2,nekcomm,npp,ldim,
     $                             xmi,ymi,zmi,nxi,nyi,nzi,
     $                             nelm,2*nxi,2*nyi,2*nzi,bb_t,n,n,
     $                             npt_max,tol)
      else
         n = nelm*nx1*ny1*nz1
         call fgslib_findpts_setup(ih_intp1,nekcomm,npp,ldim,
     &                             xm1,ym1,zm1,nx1,ny1,nz1,
     &                             nelm,2*nx1,2*ny1,2*nz1,bb_t,n,n,
     &                             npt_max,tol)
         ih_intp2 = ih_intp1
      endif

      ihcounter = ihcounter + 1 
      ih = ihcounter
      if (ih .gt. INTP_HMAX)
     $   call exitti('Maximum number of handles exceeded!$',INTP_HMAX)
      ih_intp(1,ih) = ih_intp1
      ih_intp(2,ih) = ih_intp2

      return
      end
c-----------------------------------------------------------------------
      subroutine interp_nfld(out,fld,nfld,xp,yp,zp,n,iwk,rwk,nmax,
     $                       iflp,ih)
c
c output:
c out       ... interpolation value(s) dim (n,nfld)
c
c input:
c fld       ... source field(s)
c nfld      ... number of fields
c xp,yp,zp  ... interpolation points
c n         ... number of points dim(xp,yp,zp)
c iwk       ... integer working array dim(nmax,3)
c rwk       ... real working array dim(nmax,ldim+1)
c nmax      ... leading dimension of iwk and rwk
c iflp      ... locate interpolation points (proc,el,r,s,t)
c ih        ... handle
c
      include 'SIZE'

      common /intp/   tol
      common /intp_h/ ih_intp(2,INTP_HMAX)

      real    fld(*),out(*)
      real    xp(*),yp(*),zp(*)

      logical iflp

      real    rwk(nmax,*)
      integer iwk(nmax,*) 

      integer nn(2)
      logical ifot

      if (ih.lt.1 .or. ih.gt.INTP_HMAX) 
     $   call exitti('invalid intp handle!$',ih)

      ih_intp1 = ih_intp(1,ih)
      ih_intp2 = ih_intp(2,ih)

      ifot = .false. ! transpose output field

      if (nio.eq.0 .and. loglevel.gt.2) 
     $   write(6,*) 'call intp_nfld', ih, ih_intp1, ih_intp2

      if (n.gt.nmax) then
         write(6,*)
     &    'ABORT: n>nmax in intp_nfld', n, nmax
         call exitt
      endif

      ! locate points (iel,iproc,r,s,t)
      nfail = 0
      if(iflp) then
        if(nio.eq.0 .and. loglevel.gt.2) write(6,*) 'call findpts'
        call fgslib_findpts(ih_intp2,
     &                      iwk(1,1),1,
     &                      iwk(1,3),1,
     &                      iwk(1,2),1,
     &                      rwk(1,2),ldim,
     &                      rwk(1,1),1,
     &                      xp,1,
     &                      yp,1,
     &                      zp,1,n)
        do in=1,n
           ! check return code
           if(iwk(in,1).eq.1) then
             if(rwk(in,1).gt.10*tol) then
               nfail = nfail + 1
               if (nfail.le.5) write(6,'(a,1p4e15.7)')
     &     ' WARNING: point on boundary or outside the mesh xy[z]d^2: ',
     &     xp(in),yp(in),zp(in),rwk(in,1)
             endif
           elseif(iwk(in,1).eq.2) then
             nfail = nfail + 1
             if (nfail.le.5) write(6,'(a,1p3e15.7)')
     &        ' WARNING: point not within mesh xy[z]: !',
     &        xp(in),yp(in),zp(in)
           endif
        enddo
      endif

      ! evaluate inut field at given points
      ltot = lelt*lx1*ly1*lz1
      do ifld = 1,nfld
         iin    = (ifld-1)*ltot + 1
         iout   = (ifld-1)*n + 1
         is_out = 1
         if(ifot) then ! transpose output
           iout   = ifld
           is_out = nfld
         endif
         call fgslib_findpts_eval(ih_intp1,out(iout),is_out,
     &                            iwk(1,1),1,
     &                            iwk(1,3),1,
     &                            iwk(1,2),1,
     &                            rwk(1,2),ldim,n,
     &                            fld(iin))
      enddo

      nn(1) = iglsum(n,1)
      nn(2) = iglsum(nfail,1)
      if(nio.eq.0) then
        if(nn(2).gt.0 .or. loglevel.gt.2) write(6,1) nn(1),nn(2)
  1     format('   total number of points = ',i12,/,'   failed = '
     &         ,i12,/,' done :: intp_nfld')
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine interp_free(ih)

      common /intp_h/ ih_intp(2,INTP_HMAX)

      ih_intp1 = ih_intp(1,ih)
      ih_intp2 = ih_intp(2,ih)

      call fgslib_findpts_free(ih_intp1)
      call fgslib_findpts_free(ih_intp2)

      return
      end
c-----------------------------------------------------------------------
      subroutine intp_setup(tolin)

      call exitti('intp_setup is deprecated, see release notes!!$',1)

      return
      end
c-----------------------------------------------------------------------
      subroutine intp_do(fldout,fldin,nfld,xp,yp,zp,n,iwk,rwk,nmax,iflp)

      call exitti('intp_do is deprecated, see release notes!!$',1)

      return
      end
c-----------------------------------------------------------------------
      subroutine intp_free()

      call exitti('intp_free is deprecated, see release notes!!$',1)

      return
      end

#!/bin/bash
# script to test many sht cases

id=`hg id`
log="test_suite.log"

function test1 {
    run="./time_SHT $1 -vector"
    echo $run
    echo "---" >> $log
    echo "*** $run *** " >> $log
    $run > tmp.out
    cat tmp.out | grep ERROR
    cat tmp.out | grep -i nan
    cat tmp.out >> $log
}

echo "beginning test suite for $id" > $log

# first, do a huge transform :
test1 "2047 -mres=15 -quickinit -iter=1"

# even bigger :
test1 "7975 -mres=145 -quickinit -iter=1"

# without threads
test1 "2047 -mres=15 -quickinit -iter=1 -nth=1"

for switch in "" "-oop" "-transpose" "-schmidt" "-4pi"
do
  for mode in "-quickinit" "-gauss" "-reg" "-fly" "-gauss -nth=1"
  do
    for lmax in 1 2 3 4 11 12 13 14 31 32 33 34 121 122 123 124
    do
      for mmax in 0 1 $lmax
      do
         test1 "$lmax -mmax=$mmax $mode $switch -iter=1"
      done
    done
    for nlat in 32 34 36 38 40 42 44 46
    do
         test1 "19 -mmax=10 -nlat=$nlat $mode $switch -iter=10"
    done
  done
done

#!/bin/sh
## time_benchmark.sh for  in /Users/pouchet
##
## Made by Louis-Noel Pouchet
## Contact: <pouchet@cse.ohio-state.edu>
##
## Started on  Sat Oct 29 00:03:48 2011 Louis-Noel Pouchet
## Last update Sat Oct 29 01:16:34 2011 Louis-Noel Pouchet
##

## Maximal variance accepted between the 3 median runs for performance results.
## Here 5%
VARIANCE_ACCEPTED=5;

if [ $# -ne 1 ]; then
    echo "Usage: ./time_benchmarh.sh <binary_name>";
    echo "Example: ./time_benchmarh.sh \"./a.out\"";
    echo "Note: the file must be a Polybench program compiled with -DPOLYBENCH_TIME";
    exit 1;
fi;


compute_mean_exec_time()
{
    file="$1";
    benchcomputed="$2";
    cat "$file" | grep "[0-9]\+" | sort -n | head -n 4 | tail -n 3 > avg.out;
    expr="(0";
    while read n; do
	expr="$expr+$n";
    done < avg.out;
    time=`echo "scale=8;$expr)/3" | bc`;
    tmp=`echo "$time" | cut -d '.' -f 1`;
    if [ -z "$tmp" ]; then
	time="0$time";
    fi;
    val1=`cat avg.out | head -n 1`;
    val2=`cat avg.out | head -n 2 | tail -n 1`;
    val3=`cat avg.out | head -n 3 | tail -n 1`;
    val11=`echo "a=$val1 - $time;if(0>a)a*=-1;a" | bc 2>&1`;
    test_err=`echo "$val11" | grep error`;
    if ! [ -z "$test_err" ]; then
	echo "[ERROR] Program output does not match expected single-line with time.";
	echo "[ERROR] The program must be a PolyBench, compiled with -DPOLYBENCH_TIME";
	exit 1;
    fi;
    val12=`echo "a=$val2 - $time;if(0>a)a*=-1;a" | bc`;
    val13=`echo "a=$val3 - $time;if(0>a)a*=-1;a" | bc`;
    myvar=`echo "$val11 $val12 $val13" | awk '{ if ($1 > $2) { if ($1 > $3) print $1; else print $3; } else { if ($2 > $3) print $2; else print $3; } }'`;
    variance=`echo "scale=5;($myvar/$time)*100" | bc`;
    tmp=`echo "$variance" | cut -d '.' -f 1`;
    if [ -z "$tmp" ]; then
	variance="0$variance";
    fi;
    compvar=`echo "$variance $VARIANCE_ACCEPTED" | awk '{ if ($1 < $2) print "ok"; else print "error"; }'`;
    if [ "$compvar" = "error" ]; then
	$ECHO_CMD "\033[31m[WARNING]\033[0m Variance is above thresold, unsafe performance measurement";
	$ECHO_CMD "        => max deviation=$variance%, tolerance=$VARIANCE_ACCEPTED%";
	WARNING_VARIANCE="$WARNING_VARIANCE\n$benchcomputed: max deviation=$variance%, tolerance=$VARIANCE_ACCEPTED%";
    else
	echo "[INFO] Maximal deviation from arithmetic mean of 3 average runs: $variance%";
    fi;
    PROCESSED_TIME="$time";
    rm -f avg.out;
}

echo "[INFO] Running 5 times $1..."
echo "[INFO] Maximal variance authorized on 3 average runs: $VARIANCE_ACCEPTED%)...";

$1 > ____tempfile.data.polybench;
$1 >> ____tempfile.data.polybench;
$1 >> ____tempfile.data.polybench;
$1 >> ____tempfile.data.polybench;
$1 >> ____tempfile.data.polybench;

compute_mean_exec_time "____tempfile.data.polybench" "$1";
echo "[INFO] Normalized time: $PROCESSED_TIME";
rm -f ____tempfile.data.polybench;

#!/usr/bin/env bash

# Copyright (c) 2017, Lawrence Livermore National Security, LLC.
# Produced at the Lawrence Livermore National Laboratory
# Written by Chunhua Liao, Pei-Hung Lin, Joshua Asplund,
# Markus Schordan, and Ian Karlin
# (email: liao6@llnl.gov, lin32@llnl.gov, asplund1@llnl.gov,
# schordan1@llnl.gov, karlin1@llnl.gov)
# LLNL-CODE-732144
# All rights reserved.
#
# This file is part of DataRaceBench. For details, see
# https://github.com/LLNL/dataracebench. Please also see the LICENSE file
# for our additional BSD notice
# 
# Redistribution of Backstroke and use in source and binary forms, with
# or without modification, are permitted provided that the following
# conditions are met:
#
# * Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the disclaimer below.
#
# * Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the disclaimer (as noted below)
#   in the documentation and/or other materials provided with the
#   distribution.
#
# * Neither the name of the LLNS/LLNL nor the names of its contributors
#   may be used to endorse or promote products derived from this
#   software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
# CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
# INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL LAWRENCE LIVERMORE NATIONAL
# SECURITY, LLC, THE U.S. DEPARTMENT OF ENERGY OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
# OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
# IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
# THE POSSIBILITY OF SUCH DAMAGE.

CSV_HEADER="tool,id,filename,haverace,threads,dataset,races,elapsed-time(seconds),used-mem(KBs),compile-return,runtime-return"
TESTS=($(grep -l main micro-benchmarks/*.c micro-benchmarks/*.cpp))
FORTRANTESTS=($(find micro-benchmarks-fortran -iregex ".*\.F[0-9]*" -o -iregex ".*\.for"))
OUTPUT_DIR="results"
LOG_DIR="$OUTPUT_DIR/log"
EXEC_DIR="$OUTPUT_DIR/exec"
LOGFILE="$LOG_DIR/dataracecheck.log"
LANGUAGE="default"


MEMCHECK=${MEMCHECK:-"/usr/bin/time"}
TIMEOUTCMD=${TIMEOUTCMD:-"timeout"}
VALGRIND=${VALGRIND:-"valgrind"}
VALGRIND_COMPILE_C_FLAGS="-g -std=c99 -fopenmp"
VALGRIND_COMPILE_CPP_FLAGS="-g -fopenmp"

CLANG=${CLANG:-"clang"}
TSAN_COMPILE_FLAGS="-fopenmp -fsanitize=thread -g"

ARCHER=${ARCHER:-"clang-archer"}
ARCHER_COMPILE_FLAGS="-larcher"

INSPECTOR=${INSPECTOR:-"inspxe-cl"}
ICC_COMPILE_FLAGS="-O0 -fopenmp -std=c99 -qopenmp-offload=host"
ICPC_COMPILE_FLAGS="-O0 -fopenmp -qopenmp-offload=host"

ROMP_CPP_COMPILE_FLAGS="-g -std=c++11 -fopenmp -lomp"
ROMP_C_COMPILE_FLAGS="-g -fopenmp -lomp"

FORTRAN_LINK_FLAGS="-ffree-line-length-none -fopenmp -c -fsanitize=thread"
FORTRAN_COMPILE_FLAGS="-fopenmp -fsanitize=thread -lgfortran"
IFORT_FORTRAN_FLAGS="-free -qopenmp -qopenmp-offload=host -Tf"
POLYFLAG="micro-benchmarks/utilities/polybench.c -I micro-benchmarks -I micro-benchmarks/utilities -DPOLYBENCH_NO_FLUSH_CACHE -DPOLYBENCH_TIME -D_POSIX_C_SOURCE=200112L"
FPOLYFLAG="-Imicro-benchmarks-fortran micro-benchmarks-fortran/utilities/fpolybench.o"
VARLEN_PATTERN='[[:alnum:]]+-var-[[:alnum:]]+\.c'
RACES_PATTERN='[[:alnum:]]+-[[:alnum:]]+-yes\.c'
CPP_PATTERN='[[:alnum:]]+\.cpp'
F_PATTERN='[[:alnum:]]+\.f95'
F_VARLEN_PATTERN='[[:alnum:]]+-var-[[:alnum:]]+\.f95'
F_RACES_PATTERN='[[:alnum:]]+-[[:alnum:]]+-yes\.f95'

usage () {
  echo
  echo "Usage: $0 [--help] [OPTIONS]"
  echo "  --help    : Show usage and options"
  echo
  echo "OPTIONS:"
  echo "  -x tool       : Add the specified tool to test set."
  echo "                  Value can be one of: gnu, clang, intel, helgrind, tsan-clang, tsan-gcc, archer, inspector, inspector-max-resources, romp."
  echo "  -n iterations : Run each setting the specified number of iterations."
  echo "  -t threads    : Add the specified number of threads as a testcase."
  echo "  -d size       : Add a specific dataset size to the varlen test suite."
  echo "  -s minutes    : Add a specific timeout minutes."
  echo "  -l language   : Add a specific language test"
  echo "  -c customized : Add a customized test list"
  echo
}

valid_tool_name () {
  case "$1" in
    gnu) return 0 ;;
    clang) return 0 ;;
    intel) return 0 ;;
    helgrind) return 0 ;;
    archer) return 0 ;;
    tsan-clang) return 0 ;;
    tsan-gcc) return 0 ;;
    inspector) return 0 ;;
    inspector-max-resources) return 0 ;;
    romp) return 0;;   
    *) return 1 ;;
  esac
}

valid_language_name () {
  case "$1" in
    c/c++) return 0 ;;
    C/C++) return 0 ;;
    c) return 0 ;;
    C) return 0 ;;
    c++) return 0 ;;
    C++) return 0 ;;
    fortran) return 0 ;;
    Fortran) return 0 ;;
    FORTRAN) return 0 ;;
    *) return 1 ;;
  esac
}

check_return_code () {
  case "$1" in
    11) echo "Seg Fault"; testreturn=11 ;;
    124) echo "Executime timeout";testreturn=124  ;;
    139) echo "Seg Fault"; testreturn=11 ;;
    *) testreturn=0  ;;
  esac
}

if [[ "$1" == "--help" ]]; then
  usage && exit 0;
fi

mkdir -p "$OUTPUT_DIR"
mkdir -p "$LOG_DIR"
mkdir -p "$EXEC_DIR"

TOOLS=()
DATASET_SIZES=()
THREADLIST=()
ITERATIONS=0
TIMEOUTMIN="5"
# Parse options
while getopts "n:t:x:d:s:l:c:" opt; do
  case $opt in
    x)  if valid_tool_name "${OPTARG}"; then TOOLS+=(${OPTARG});
        else echo "Invalid tool name ${OPTARG}" && usage && exit 1
        fi ;;
    n)  if [[ ${OPTARG} -gt 0 ]]; then ITERATIONS=${OPTARG};
        else echo "Number of iterations must be greater than 0"
        fi ;;
    t)  if [[ ${OPTARG} -gt 1 ]]; then THREADLIST+=(${OPTARG})
        else echo "Number of threads must be greater than 1" && usage && exit 1;
        fi ;;
    d)  if [[ ${OPTARG} -gt 1 ]]; then DATASET_SIZES+=(${OPTARG})
        else echo "Dataset size must be greater than 1" && usage && exit 1;
        fi ;;
    s)  if [[ ${OPTARG} -gt 0 ]]; then TIMEOUTMIN=(${OPTARG})
        else echo "timeout must be greater than 0" && usage && exit 1;
        fi ;;
    l)  if valid_language_name "${OPTARG}"; then LANGUAGE=${OPTARG};
        else echo "Invalid language name ${OPTARG}" && help && exit 1;
        fi ;;
    c)  if [[ ${OPTARG} -eq 1 ]]; then
            if [[ "$LANGUAGE" == "c" || "$LANGUAGE" == "C" || "$LANGUAGE" == "c++" || "$LANGUAGE" == "C++" ]]; then
                TEST=($(cat list.def));
                for tests in "${TEST[@]}"; do
                         CTEST+=("micro-benchmarks/$tests")
                 done
                 TESTS=("${CTEST[@]}")
            else
                 TEST=($(cat list.def));
                 for tests in "${TEST[@]}"; do
                         CTEST+=("micro-benchmarks-fortran/$tests")
                 done

                 FORTRANTESTS=("${CTEST[@]}")
            fi
        fi;;
  esac
done

# Set default values
if [[ ! ${#TOOLS[@]} -gt 0 ]]; then
  echo "Default tool set will be used: gnu, clang, intel helgrind, tsan-clang, tsan-gcc, archer, inspector-max-resources."
  TOOLS=( 'gnu' 'clang' 'intel' 'helgrind' 'tsan-clang' 'tsan-gcc' 'archer' 'inspector-max-resources' )
else
  echo "Tools: ${TOOLS[*]}";
fi

if [[ ! ${#DATASET_SIZES[@]} -gt 0 ]]; then
  echo "Default dataset sizes will be used: 32, 64, 128, 256, 512, 1024."
  DATASET_SIZES=('32' '64' '128' '256' '512' '1024')
else
  echo "Dataset sizes: ${DATASET_SIZES[*]}";
fi

if [[ ! ${#THREADLIST[@]} -gt 0 ]]; then
  echo "Default thread counts will be used: 3, 36, 45, 72, 90, 180, 256."
  THREADLIST=('3' '36' '45' '72' '90' '180' '256')
else
  echo "Thread counts: ${THREADLIST[*]}";
fi

if [[ ! $ITERATIONS -gt 0 ]]; then
  echo "Default number of iterations will be used: 3"
  ITERATIONS=3
else
  echo "Iterations: ${ITERATIONS}";
fi

if [[ ! $TIMEOUTMIN -gt 0 ]]; then
  echo "Default timeout will be 5 minutes"
  TIMEOUTMIN=5
else
  echo "Timeout minutes: ${TIMEOUTMIN}";
fi

if [[ -e "$LOGFILE" ]]; then rm "$LOGFILE"; fi

# Increase stack size - Fixes crashes in some analyses
ULIMITS=$(ulimit -s)
ulimit -s unlimited

TOOL_INDEX=0
TEST_INDEX=0
THREAD_INDEX=0
SIZE_INDEX=0
ITER=1

cleanup () {
  ulimit -s "$ULIMITS"
  if [[ -e $exname ]]; then rm "$exname"; fi
  echo "EXITING"
  echo "--------------------------" >> "$LOGFILE"
  echo "Unfinished tests:" >> "$LOGFILE"
  for tool in "${TOOLS[@]:$TOOL_INDEX}"; do
    if [[ $TEST_INDEX -eq 0 && $THREAD_INDEX -eq 0 && $SIZE_INDEX -eq 0 && $ITER -eq 1 ]]; then
      echo "$tool,all,all,all,$ITERATIONS" >> "$LOGFILE"
    else
      for test in "${TESTS[@]:$TEST_INDEX}"; do
        if [[ $THREAD_INDEX -eq 0 && $SIZE_INDEX -eq 0 && $ITER -eq 1 ]]; then
          echo "$tool,\"$test\",all,all,$ITERATIONS" >> "$LOGFILE"
        else
          for thread in "${THREADLIST[@]:$THREAD_INDEX}"; do
            if [[ $SIZE_INDEX -eq 0 && $ITER -eq 1 ]]; then
              echo "$tool,\"$test\",$thread,all,$ITERATIONS" >> "$LOGFILE"
            else
              for size in "${SIZES[@]:$SIZE_INDEX}"; do
                if [[ $ITER -eq 1 ]]; then echo "$tool,\"$test\",$thread,${size:-"N/A"},$ITERATIONS" >> "$LOGFILE"
                else echo "$tool,\"$test\",$thread,all,$((ITERATIONS - ITER + 1))" >> "$LOGFILE"; ITER=1; fi
              done
              SIZE_INDEX=0
            fi
          done
          THREAD_INDEX=0
        fi
      done
      TEST_INDEX=0
    fi
  done
  exit 1
}

trap cleanup SIGINT SIGTERM

if [[ "$LANGUAGE" == "c" || "$LANGUAGE" == "C" || "$LANGUAGE" == "c++" || "$LANGUAGE" == "C++" ]]; then

for tool in "${TOOLS[@]}"; do

  MEMLOG="$LOG_DIR/$tool.memlog"
  file="$OUTPUT_DIR/$tool.csv"
  echo "Saving to: $file and $MEMLOG"
  [ -e "$file" ] && rm "$file"
  echo "$CSV_HEADER" >> "$file"

  runtime_flags=''
  case "$tool" in
    'inspector-max-resources')
      runtime_flags+=" -collect ti3 -knob scope=extreme -knob stack-depth=16 -knob use-maximum-resources=true"
      tool='inspector'
      ;;
    'inspector')
      runtime_flags+=" -collect ti2"
      ;;
  esac

  TEST_INDEX=0
  for test in "${TESTS[@]}"; do
	  echo "test is $test"
    additional_compile_flags=''
    if [[ "$test" =~ $RACES_PATTERN ]]; then haverace=true; else haverace=false; fi
    if [[ "$test" =~ $VARLEN_PATTERN ]]; then SIZES=("${DATASET_SIZES[@]}"); else SIZES=(''); fi
    testname=$(basename $test)
    id=${testname#DRB}
    id=${id%%-*}
    echo "$test has $testname and ID=$id"

    # Compile
    exname="$EXEC_DIR/$(basename "$test").$tool.out"
    rompexec="$exname.inst"
    logname="$(basename "$test").$tool.log"
    if [[ -e "$LOG_DIR/$logname" ]]; then rm "$LOG_DIR/$logname"; fi
    if grep -q 'PolyBench' "$test"; then additional_compile_flags+=" $POLYFLAG"; fi

    if [[ "$test" =~ $CPP_PATTERN ]]; then
      echo "testing C++ code:$test"
      case "$tool" in 
        gnu)        g++ -g -fopenmp $additional_compile_flags $test -o $exname -lm ;;
        clang)      clang++ -fopenmp -g $additional_compile_flags $test -o $exname -lm ;;
        intel)      icpc $ICPC_COMPILE_FLAGS $additional_compile_flags $test -o $exname -lm ;;
        helgrind)   g++ $VALGRIND_COMPILE_CPP_FLAGS $additional_compile_flags $test -o $exname -lm ;;
        archer)     clang-archer++ $ARCHER_COMPILE_FLAGS $additional_compile_flags $test -o $exname -lm ;;
        tsan-clang) clang++ $TSAN_COMPILE_FLAGS $additional_compile_flags $test -o $exname -lm ;;
        tsan-gcc)   g++ $TSAN_COMPILE_FLAGS $additional_compile_flags $test -o $exname -lm ;;
        inspector)  icpc $ICPC_COMPILE_FLAGS $additional_compile_flags $test -o $exname -lm ;;
        romp)       g++ $ROMP_CPP_COMPILE_FLAGS $additional_compile_flags $test -o $exname -lm;
                    echo $exname
                    InstrumentMain --program=$exname;
      esac
    else
      case "$tool" in 
        gnu)        gcc -g -std=c99 -fopenmp $additional_compile_flags $test -o $exname -lm ;;
        clang)      clang -fopenmp -g $additional_compile_flags $test -o $exname -lm ;;
        intel)      icc $ICC_COMPILE_FLAGS $additional_compile_flags $test -o $exname -lm ;;
        helgrind)   gcc $VALGRIND_COMPILE_C_FLAGS $additional_compile_flags $test -o $exname -lm ;;
        archer)     clang-archer $ARCHER_COMPILE_FLAGS $additional_compile_flags $test -o $exname -lm ;;
        tsan-clang) clang $TSAN_COMPILE_FLAGS $additional_compile_flags $test -o $exname -lm ;;
        tsan-gcc)   gcc $TSAN_COMPILE_FLAGS $additional_compile_flags $test -o $exname -lm ;;
        inspector)  icc $ICC_COMPILE_FLAGS $additional_compile_flags $test -o $exname -lm ;;
        romp)       gcc $ROMP_C_COMPILE_FLAGS $additional_compile_flags $test -o $exname -lm;
                    echo $exname
                    InstrumentMain --program=$exname;
      esac
    fi
    compilereturn=$?; 
    echo "compile return code: $compilereturn";

    THREAD_INDEX=0
    for thread in "${THREADLIST[@]}"; do
      echo "Testing $test: with $thread threads"
      export OMP_NUM_THREADS=$thread 
      SIZE_INDEX=0
      for size in "${SIZES[@]}"; do
        # Sanity check
        if [[ ! -e "$exname" ]]; then
          echo "$tool,$id,\"$testname\",$haverace,$thread,${size:-"N/A"},,,,$compilereturn," >> "$file";
          echo "Executable for $testname with $thread threads and input size $size is not available" >> "$LOGFILE";
        elif { "./$exname $size"; } 2>&1 | grep -Eq 'Segmentation fault'; then
            echo "$tool,$id,\"$testname\",$haverace,$thread,${size:-"N/A"},,,,$compilereturn," >> "$file";
            echo "Seg fault found in $testname with $thread threads and input size $size" >> "$LOGFILE";
        else
          ITER_INDEX=1
          for ITER in $(seq 1 "$ITERATIONS"); do
            echo -e "*****     Log $ITER_INDEX for $testname with $thread threads and input size $size     *****" >> "$LOG_DIR/$logname"
            start=$(date +%s%6N)
            case "$tool" in
              gnu)
                #races=$($TIMEOUTCMD $TIMEOUTMIN"m" $MEMCHECK -f "%M" -o "$MEMLOG" "./$exname" $size 2>&1 | tee -a "$LOG_DIR/$logname" | grep -ce 'Possible data race') ;;
		;&
              clang)
                #races=$($MEMCHECK -f "%M" -o "$MEMLOG" "./$exname" $size 2>&1 | tee -a "$LOG_DIR/$logname" | grep -ce 'Possible data race') ;;
		;&
              intel)
                #races=$($MEMCHECK -f "%M" -o "$MEMLOG" "./$exname" $size 2>&1 | tee -a "$LOG_DIR/$logname" | grep -ce 'Possible data race') ;;
		$TIMEOUTCMD $TIMEOUTMIN"m" $MEMCHECK -f "%M" -o "$MEMLOG" "./$exname" $size &> tmp.log;
		check_return_code $?;
                echo "testname return $testreturn";
                races="",
                cat tmp.log >> "$LOG_DIR/$logname" || >tmp.log ;;
              helgrind)
#                races=$($MEMCHECK -f "%M" -o "$MEMLOG" $VALGRIND  --tool=helgrind "./$exname" $size 2>&1 | tee -a "$LOG_DIR/$logname" | grep -ce 'Possible data race') ;;
                $TIMEOUTCMD $TIMEOUTMIN"m" $MEMCHECK -f "%M" -o "$MEMLOG" $VALGRIND  --tool=helgrind "./$exname" $size &> tmp.log;
                check_return_code $?;
		echo "testname return $testreturn"
                races=$(grep -ce 'Possible data race' tmp.log) 
                cat tmp.log >> "$LOG_DIR/$logname" || >tmp.log ;;
              archer)
                $TIMEOUTCMD $TIMEOUTMIN"m" $MEMCHECK -f "%M" -o "$MEMLOG" "./$exname" $size &> tmp.log;
                check_return_code $?;
		echo "testname return $testreturn"
                races=$(grep -ce 'WARNING: ThreadSanitizer: data race' tmp.log) 
                cat tmp.log >> "$LOG_DIR/$logname" || >tmp.log ;;
              tsan-clang)
#                races=$($MEMCHECK -f "%M" -o "$MEMLOG" "./$exname" $size 2>&1 | tee -a "$LOG_DIR/$logname" | grep -ce 'WARNING: ThreadSanitizer: data race') ;;
                $TIMEOUTCMD $TIMEOUTMIN"m" $MEMCHECK -f "%M" -o "$MEMLOG" env TSAN_OPTIONS="ignore_noninstrumented_modules=1" "./$exname" $size &> tmp.log;
                check_return_code $?;
		echo "testname return $testreturn"
                races=$(grep -ce 'WARNING: ThreadSanitizer: data race' tmp.log) 
                cat tmp.log >> "$LOG_DIR/$logname" || >tmp.log ;;
              tsan-gcc)
#                races=$($MEMCHECK -f "%M" -o "$MEMLOG" "./$exname" $size 2>&1 | tee -a "$LOG_DIR/$logname" | grep -ce 'WARNING: ThreadSanitizer: data race') ;;
                $TIMEOUTCMD $TIMEOUTMIN"m" $MEMCHECK -f "%M" -o "$MEMLOG" "./$exname" $size &> tmp.log;
                check_return_code $?;
		echo "testname return $testreturn"
                races=$(grep -ce 'WARNING: ThreadSanitizer: data race' tmp.log) 
                cat tmp.log >> "$LOG_DIR/$logname" || >tmp.log ;;
              inspector)
#                races=$($MEMCHECK -f "%M" -o "$MEMLOG" $INSPECTOR $runtime_flags -- "./$exname" $size  2>&1 | tee -a "$LOG_DIR/$logname" | grep 'Data race' | sed -E 's/[[:space:]]*([[:digit:]]+).*/\1/') ;;
		$TIMEOUTCMD $TIMEOUTMIN"m" $MEMCHECK -f "%M" -o "$MEMLOG" $INSPECTOR $runtime_flags -- "./$exname" $size &> tmp.log;
		check_return_code $?;
                echo "testname return $testreturn";
                races=$(grep 'Data race' tmp.log | sed -E 's/[[:space:]]*([[:digit:]]+).*/\1/');
                cat tmp.log >> "$LOG_DIR/$logname" || >tmp.log ;;
              romp)
                $TIMEOUTCMD $TIMEOUTMIN"m" $MEMCHECK -f "%M" -o "$MEMLOG" "./$rompexec" $size &> tmp.log;
                check_return_code $?;
		echo "testname return $testreturn"
                races=$(grep -ce 'data race found:' tmp.log) 
                cat tmp.log >> "$LOG_DIR/$logname" || >tmp.log ;;
                #races=$("./$exname" $size 2>&1 | tee -a "$LOG_DIR/$logname" | grep -ce 'race found!') ;;
            esac
            end=$(date +%s%6N)
            elapsedtime=$(echo "scale=3; ($end-$start)/1000000"|bc)
            mem=$(cat $MEMLOG)
            echo "$tool,$id,\"$testname\",$haverace,$thread,${size:-"N/A"},${races:-0},$elapsedtime,$mem,$compilereturn,$testreturn" >> "$file"
            ITER_INDEX=$((ITER_INDEX+1))
          done
        fi
        SIZE_INDEX=$((SIZE_INDEX+1))
      done
      THREAD_INDEX=$((THREAD_INDEX+1))
    done
    TEST_INDEX=$((TEST_INDEX+1))
    #if [[ -e $exname ]]; then rm "$exname"; fi
  done
  TOOL_INDEX=$((TOOL_INDEX+1))
done

elif [[ "$LANGUAGE" == "fortran" || "$LANGUAGE" == "FORTRAN" ]]; then

for tool in "${TOOLS[@]}"; do

  MEMLOG="$LOG_DIR/$tool.memlog"
  file="$OUTPUT_DIR/$tool.csv"
  echo "Saving to: $file and $MEMLOG"
  [ -e "$file" ] && rm "$file"
  echo "$CSV_HEADER" >> "$file"

  runtime_flags=''
  case "$tool" in
    'inspector-max-resources')
      runtime_flags+=" -collect ti3 -knob scope=extreme -knob stack-depth=16 -knob use-maximum-resources=true"
      tool='inspector'
      ;;
    'inspector')
      runtime_flags+=" -collect ti2"
      ;;
  esac

  TEST_INDEX=0
  for test in "${FORTRANTESTS[@]}"; do
    additional_compile_flags=''
    if [[ "$test" =~ $F_RACES_PATTERN ]]; then haverace=true; else haverace=false; fi
    if [[ "$test" =~ $F_VARLEN_PATTERN ]]; then SIZES=("${DATASET_SIZES[@]}"); else SIZES=(''); fi
    testname=$(basename $test)
    id=${testname#DRB}
    id=${id%%-*}
    echo "$test has $testname and ID=$id"

    # Compile
    linkname="$EXEC_DIR/$testname.o"
    exname="$EXEC_DIR/$(basename "$test").$tool.out"
    rompexec="$exname.inst"
    logname="$(basename "$test").$tool.log"
    linklib=" "
    if [[ -e "$LOG_DIR/$logname" ]]; then rm "$LOG_DIR/$logname"; fi
    if grep -q 'PolyBench' "$test"; then additional_compile_flags+=" $FPOLYFLAG";gcc -c micro-benchmarks-fortran/utilities/fpolybench.c -o micro-benchmarks-fortran/utilities/fpolybench.o ; linklib+="micro-benchmarks-fortran/utilities/fpolybench.o"; fi

      echo "testing Fortran code:$test"
      case "$tool" in 
        gnu)        gfortran -fopenmp -lomp $additional_compile_flags $test -o $exname -lm ;;
        intel)      ifort $IFORT_FORTRAN_FLAGS  $test -o $exname -lm ;;
        tsan-clang) gfortran $FORTRAN_LINK_FLAGS $additional_compile_flags $test -o $linkname;
		    clang $FORTRAN_COMPILE_FLAGS $linkname $linklib -o $exname -lm;;
        tsan-gcc)   gfortran -fopenmp -fsanitize=thread $additional_compile_flags  $test -o $exname -lm  ;;
        archer)     gfortran $FORTRAN_LINK_FLAGS $additional_compile_flags $test -o $linkname;
	            clang-archer $FORTRAN_COMPILE_FLAGS $linkname $linklib -o $exname $ARCHER_COMPILE_FLAGS -lm;;
        inspector)  ifort $IFORT_FORTRAN_FLAGS  $test -o $exname -lm ;;
        romp)       gfortran -fopenmp -lomp -ffree-line-length-none $additional_compile_flags $test -o $exname -lm;
                    echo $exname
                    InstrumentMain --program=$exname;;
      esac
    compilereturn=$?; 
    echo "compile return code: $compilereturn";

    THREAD_INDEX=0
    for thread in "${THREADLIST[@]}"; do
      echo "Testing $test: with $thread threads"
      export OMP_NUM_THREADS=$thread 
      SIZE_INDEX=0
      for size in "${SIZES[@]}"; do
        # Sanity check
        if [[ ! -e "$exname" ]]; then
          echo "$tool,$id,\"$testname\",$haverace,$thread,${size:-"N/A"},,,,$compilereturn," >> "$file";
          echo "Executable for $testname with $thread threads and input size $size is not available" >> "$LOGFILE";
        elif { "./$exname $size"; } 2>&1 | grep -Eq 'Segmentation fault'; then
            echo "$tool,$id,\"$testname\",$haverace,$thread,${size:-"N/A"},,,,$compilereturn," >> "$file";
            echo "Seg fault found in $testname with $thread threads and input size $size" >> "$LOGFILE";
        else
          ITER_INDEX=1
          for ITER in $(seq 1 "$ITERATIONS"); do
            echo -e "*****     Log $ITER_INDEX for $testname with $thread threads and input size $size     *****" >> "$LOG_DIR/$logname"
            start=$(date +%s%6N)
            case "$tool" in
              gnu)
                #races=$($TIMEOUTCMD $TIMEOUTMIN"m" $MEMCHECK -f "%M" -o "$MEMLOG" "./$exname" $size 2>&1 | tee -a "$LOG_DIR/$logname" | grep -ce 'Possible data race') ;;
		;&
              clang)
                #races=$($MEMCHECK -f "%M" -o "$MEMLOG" "./$exname" $size 2>&1 | tee -a "$LOG_DIR/$logname" | grep -ce 'Possible data race') ;;
		;&
              intel)
                #races=$($MEMCHECK -f "%M" -o "$MEMLOG" "./$exname" $size 2>&1 | tee -a "$LOG_DIR/$logname" | grep -ce 'Possible data race') ;;
		$TIMEOUTCMD $TIMEOUTMIN"m" $MEMCHECK -f "%M" -o "$MEMLOG" "./$exname" $size &> tmp.log;
		check_return_code $?;
                echo "testname return $testreturn";
                races="",
                cat tmp.log >> "$LOG_DIR/$logname" || >tmp.log ;;
              helgrind)
#                races=$($MEMCHECK -f "%M" -o "$MEMLOG" $VALGRIND  --tool=helgrind "./$exname" $size 2>&1 | tee -a "$LOG_DIR/$logname" | grep -ce 'Possible data race') ;;
                $TIMEOUTCMD $TIMEOUTMIN"m" $MEMCHECK -f "%M" -o "$MEMLOG" $VALGRIND  --tool=helgrind "./$exname" $size &> tmp.log;
                check_return_code $?;
		echo "testname return $testreturn"
                races=$(grep -ce 'Possible data race' tmp.log) 
                cat tmp.log >> "$LOG_DIR/$logname" || >tmp.log ;;
              archer)
                $TIMEOUTCMD $TIMEOUTMIN"m" $MEMCHECK -f "%M" -o "$MEMLOG" "./$exname" $size &> tmp.log;
                check_return_code $?;
		echo "testname return $testreturn"
                races=$(grep -ce 'WARNING: ThreadSanitizer: data race' tmp.log) 
                cat tmp.log >> "$LOG_DIR/$logname" || >tmp.log ;;
              tsan-clang)
#                races=$($MEMCHECK -f "%M" -o "$MEMLOG" "./$exname" $size 2>&1 | tee -a "$LOG_DIR/$logname" | grep -ce 'WARNING: ThreadSanitizer: data race') ;;
                $TIMEOUTCMD $TIMEOUTMIN"m" $MEMCHECK -f "%M" -o "$MEMLOG" env TSAN_OPTIONS="ignore_noninstrumented_modules=1" "./$exname" $size &> tmp.log;
                check_return_code $?;
		echo "testname return $testreturn"
                races=$(grep -ce 'WARNING: ThreadSanitizer: data race' tmp.log) 
                cat tmp.log >> "$LOG_DIR/$logname" || >tmp.log ;;
              tsan-gcc)
#                races=$($MEMCHECK -f "%M" -o "$MEMLOG" "./$exname" $size 2>&1 | tee -a "$LOG_DIR/$logname" | grep -ce 'WARNING: ThreadSanitizer: data race') ;;
                $TIMEOUTCMD $TIMEOUTMIN"m" $MEMCHECK -f "%M" -o "$MEMLOG" "./$exname" $size &> tmp.log;
                check_return_code $?;
		echo "testname return $testreturn"
                races=$(grep -ce 'WARNING: ThreadSanitizer: data race' tmp.log) 
                cat tmp.log >> "$LOG_DIR/$logname" || >tmp.log ;;
              inspector)
#                races=$($MEMCHECK -f "%M" -o "$MEMLOG" $INSPECTOR $runtime_flags -- "./$exname" $size  2>&1 | tee -a "$LOG_DIR/$logname" | grep 'Data race' | sed -E 's/[[:space:]]*([[:digit:]]+).*/\1/') ;;
		$TIMEOUTCMD $TIMEOUTMIN"m" $MEMCHECK -f "%M" -o "$MEMLOG" $INSPECTOR $runtime_flags -- "./$exname" $size &> tmp.log;
		check_return_code $?;
                echo "testname return $testreturn";
                races=$(grep 'Data race' tmp.log | sed -E 's/[[:space:]]*([[:digit:]]+).*/\1/');
                cat tmp.log >> "$LOG_DIR/$logname" || >tmp.log ;;
              romp)
                $TIMEOUTCMD $TIMEOUTMIN"m" $MEMCHECK -f "%M" -o "$MEMLOG" "./$rompexec" $size &> tmp.log;
                check_return_code $?;
		echo "testname return $testreturn"
                races=$(grep -ce 'data race found:' tmp.log) 
                cat tmp.log >> "$LOG_DIR/$logname" || >tmp.log ;;
                #races=$("./$exname" $size 2>&1 | tee -a "$LOG_DIR/$logname" | grep -ce 'race found!') ;;
            esac
            end=$(date +%s%6N)
            elapsedtime=$(echo "scale=3; ($end-$start)/1000000"|bc)
            mem=$(cat $MEMLOG)
            echo "$tool,$id,\"$testname\",$haverace,$thread,${size:-"N/A"},${races:-0},$elapsedtime,$mem,$compilereturn,$testreturn" >> "$file"
            ITER_INDEX=$((ITER_INDEX+1))
          done
        fi
        SIZE_INDEX=$((SIZE_INDEX+1))
      done
      THREAD_INDEX=$((THREAD_INDEX+1))
    done
    TEST_INDEX=$((TEST_INDEX+1))
    #if [[ -e $exname ]]; then rm "$exname"; fi
  done
  TOOL_INDEX=$((TOOL_INDEX+1))
done
fi
for tool in "${TOOLS[@]}"; do
	python3 scripts/metric.py $OUTPUT_DIR/$tool.csv
done
[ ! -f *.mod ] || rm *.mod
[ ! -d r*ti3 ] || rm -rf r*ti3
[ ! -f micro-benchmarks-fortran/utilities/fpolybench.o ] || rm micro-benchmarks-fortran/utilities/fpolybench.o
[ ! -f micro-benchmarks/utilities/polybench.o ] || rm micro-benchmarks/utilities/polybench.o
ulimit -s "$ULIMITS"

#!/bin/sh
## create_pped_version.sh for  in /Users/pouchet
##
## Made by Louis-Noel Pouchet
## Contact: <pouchet@cse.ohio-state.edu>
##
## Started on  Mon Oct 31 16:20:01 2011 Louis-Noel Pouchet
## Last update Mon Oct 31 20:42:35 2011 Louis-Noel Pouchet
##

if [ $# -lt 1 ]; then
    echo "Usage: create_pped_version.sh <file.F90> [gcc -E flags]";
    exit 1;
fi;
args="$2";
file="$1";
head -n 8 $file | sed 's/F90/f90/' > .__poly_top.f;
tail -n +9 $file > .__poly_bottom.F;
filename=`echo "$file" | sed -e "s/\(.*\).F90/\1/1"`;
filenameorig=`basename $file`;
benchdir=`dirname "$file"`;
gcc -E .__poly_bottom.F -I$benchdir $args 2>/dev/null > .__tmp_poly.f
#echo "gcc -E .__poly_bottom.f -I$benchdir -Iutilities $args 2>/tmp/moh > .__tmp_poly.f"
sed -e "/^[ ]*$/d" .__tmp_poly.f | sed -e '/^#/d' | sed -e "s~.__poly_bottom.f~$filenameorig~g" > .__poly_bottom.f;
cat .__poly_top.f > $filename.preproc.f90;
#echo "#include <polybench.h>\n" >> $filename.preproc.c;
cat .__poly_bottom.f >> $filename.preproc.f90;
rm -f .__tmp_poly.f .__poly_bottom.f .__poly_top.f .__poly_bottom.F ;

#!/bin/sh
## create_cpped_version.sh for  in /Users/pouchet
##
## Made by Louis-Noel Pouchet
## Contact: <pouchet@cse.ohio-state.edu>
## License: /LICENSE.OSU.txt
##
## Started on  Mon Oct 31 16:20:01 2011 Louis-Noel Pouchet
## Last update Mon Oct 31 20:42:35 2011 Louis-Noel Pouchet
##

if [ $# -lt 1 ]; then
    echo "Usage: create_cpped_version.sh <file.c> [gcc -E flags]";
    exit 1;
fi;
args="$2";
file="$1";
head -n 12 $file > .__poly_top.c;
tail -n +12 $file > .__poly_bottom.c;
filename=`echo "$file" | sed -e "s/\(.*\).c/\1/1"`;
filenameorig=`basename $file`;
benchdir=`dirname "$file"`;
gcc -E .__poly_bottom.c -I $benchdir $args 2>/dev/null > .__tmp_poly.c
sed -e "/^[ ]*;[ ]*$/d" .__tmp_poly.c | sed -e "s~.__poly_bottom.c~$filenameorig~g" > .__poly_bottom.c;
cat .__poly_top.c > $filename.preproc.c;
echo "#include <polybench.h>\n" >> $filename.preproc.c;
cat .__poly_bottom.c >> $filename.preproc.c;
rm -f .__tmp_poly.c .__poly_bottom.c .__poly_top.c;
